/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/log/common/log","vs/base/common/uri","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/errors","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/base/common/network","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncProfilesStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/userDataSync/electron-sandbox/userDataSyncProfilesStorageService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],oe=function(Z){for(var e=[],D=0,i=Z.length;D<i;D++)e[D]=se[Z[D]];return e};define(se[52],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function D(k){return k?k.replace(/\$\((.*?)\)/g,(T,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=D;class i{constructor(T,I,P){this.id=T,this.definition=I,this.description=P,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);var R;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function I(b){if(b instanceof i)return["codicon","codicon-"+b.id];const E=T.exec(b.id);if(!E)return I(i.error);const[,p,v]=E,f=["codicon","codicon-"+p];return v&&f.push("codicon-modifier-"+v.substring(1)),f}k.asClassNameArray=I;function P(b){return I(b).join(" ")}k.asClassName=P;function w(b){return"."+I(b).join(".")}k.asCSSSelector=w})(R=e.CSSIcon||(e.CSSIcon={}))}),define(se[63],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function D(T){return(I,P,w)=>{let b=null,E=null;if(typeof w.value=="function"?(b="value",E=w.value):typeof w.get=="function"&&(b="get",E=w.get),!E)throw new Error("not supported");w[b]=T(E,P)}}function i(T,I,P){let w=null,b=null;if(typeof P.value=="function"?(w="value",b=P.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(w="get",b=P.get),!b)throw new Error("not supported");const E=`$memoize$${I}`;P[w]=function(...p){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,p)}),this[E]}}e.memoize=i;function R(T,I,P){return D((w,b)=>{const E=`$debounce$${b}`,p=`$debounce$result$${b}`;return function(...v){this[p]||(this[p]=P?P():void 0),clearTimeout(this[E]),I&&(this[p]=I(this[p],...v),v=[this[p]]),this[E]=setTimeout(()=>{w.apply(this,v),this[p]=P?P():void 0},T)}})}e.debounce=R;function k(T,I,P){return D((w,b)=>{const E=`$throttle$timer$${b}`,p=`$throttle$result$${b}`,v=`$throttle$lastRun$${b}`,f=`$throttle$pending$${b}`;return function(...m){if(this[p]||(this[p]=P?P():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),I&&(this[p]=I(this[p],...m)),this[f])return;const y=this[v]+T;y<=Date.now()?(this[v]=Date.now(),w.apply(this,[this[p]]),this[p]=P?P():void 0):(this[f]=!0,this[E]=setTimeout(()=>{this[f]=!1,this[v]=Date.now(),w.apply(this,[this[p]]),this[p]=P?P():void 0},y-Date.now()))}})}e.throttle=k}),define(se[11],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?c.isErrorNoTelemetry(n)?new c(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(o=>{o(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=D,e.errorHandler=new D;function i(d){e.errorHandler.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=i;function R(d){P(d)||e.errorHandler.onUnexpectedError(d)}e.onUnexpectedError=R;function k(d){P(d)||e.errorHandler.onUnexpectedExternalError(d)}e.onUnexpectedExternalError=k;function T(d){if(d instanceof Error){const{name:n,message:o}=d,t=d.stacktrace||d.stack;return{$isError:!0,name:n,message:o,stack:t,noTelemetry:c.isErrorNoTelemetry(d)}}return d}e.transformErrorForSerialization=T;const I="Canceled";function P(d){return d instanceof w?!0:d instanceof Error&&d.name===I&&d.message===I}e.isCancellationError=P;class w extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=w;function b(){const d=new Error(I);return d.name=d.message,d}e.canceled=b;function E(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.illegalArgument=E;function p(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.illegalState=p;function v(d){return d?new Error(`readonly property '${d} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function f(d){const n=new Error(`${d} has been disposed`);return n.name="DISPOSED",n}e.disposed=f;function m(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.getErrorMessage=m;class y extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=y;class u extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=u;class S extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=S;class c extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof c)return n;const o=new c;return o.message=n.message,o.stack=n.stack,o}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class h extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(se[19],oe([0,1,11]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function i(X,te=0){return X[X.length-(1+te)]}e.tail=i;function R(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.tail2=R;function k(X,te,re=(le,ue)=>le===ue){if(X===te)return!0;if(!X||!te||X.length!==te.length)return!1;for(let le=0,ue=X.length;le<ue;le++)if(!re(X[le],te[le]))return!1;return!0}e.equals=k;function T(X,te){const re=X.length-1;te<re&&(X[te]=X[re]),X.pop()}e.removeFastWithoutKeepingOrder=T;function I(X,te,re){return P(X.length,le=>re(X[le],te))}e.binarySearch=I;function P(X,te){let re=0,le=X-1;for(;re<=le;){const ue=(re+le)/2|0,Se=te(ue);if(Se<0)re=ue+1;else if(Se>0)le=ue-1;else return ue}return-(re+1)}e.binarySearch2=P;function w(X,te){let re=0,le=X.length;if(le===0)return 0;for(;re<le;){const ue=Math.floor((re+le)/2);te(X[ue])?le=ue:re=ue+1}return re}e.findFirstInSorted=w;function b(X,te,re){if(X=X|0,X>=te.length)throw new TypeError("invalid index");const le=te[Math.floor(te.length*Math.random())],ue=[],Se=[],we=[];for(const Ee of te){const Ce=re(Ee,le);Ce<0?ue.push(Ee):Ce>0?Se.push(Ee):we.push(Ee)}return X<ue.length?b(X,ue,re):X<ue.length+we.length?we[0]:b(X-(ue.length+we.length),Se,re)}e.quickSelect=b;function E(X,te){const re=[];let le;for(const ue of X.slice(0).sort(te))!le||te(le[0],ue)!==0?(le=[ue],re.push(le)):le.push(ue);return re}e.groupBy=E;function p(X,te,re){const le=[];function ue(Ee,Ce,Ae){if(Ce===0&&Ae.length===0)return;const Ne=le[le.length-1];Ne&&Ne.start+Ne.deleteCount===Ee?(Ne.deleteCount+=Ce,Ne.toInsert.push(...Ae)):le.push({start:Ee,deleteCount:Ce,toInsert:Ae})}let Se=0,we=0;for(;;){if(Se===X.length){ue(Se,0,te.slice(we));break}if(we===te.length){ue(Se,X.length-Se,[]);break}const Ee=X[Se],Ce=te[we],Ae=re(Ee,Ce);Ae===0?(Se+=1,we+=1):Ae<0?(ue(Se,1,[]),Se+=1):Ae>0&&(ue(Se,0,[Ce]),we+=1)}return le}e.sortedDiff=p;function v(X,te,re){const le=p(X,te,re),ue=[],Se=[];for(const we of le)ue.push(...X.slice(we.start,we.start+we.deleteCount)),Se.push(...we.toInsert);return{removed:ue,added:Se}}e.delta=v;function f(X,te,re){if(re===0)return[];const le=X.slice(0,re).sort(te);return y(X,te,le,re,X.length),le}e.top=f;function m(X,te,re,le,ue){return re===0?Promise.resolve([]):new Promise((Se,we)=>{(async()=>{const Ee=X.length,Ce=X.slice(0,re).sort(te);for(let Ae=re,Ne=Math.min(re+le,Ee);Ae<Ee;Ae=Ne,Ne=Math.min(Ne+le,Ee)){if(Ae>re&&await new Promise(Ge=>setTimeout(Ge)),ue&&ue.isCancellationRequested)throw new D.CancellationError;y(X,te,Ce,Ae,Ne)}return Ce})().then(Se,we)})}e.topAsync=m;function y(X,te,re,le,ue){for(const Se=re.length;le<ue;le++){const we=X[le];if(te(we,re[Se-1])<0){re.pop();const Ee=w(re,Ce=>te(we,Ce)<0);re.splice(Ee,0,we)}}}function u(X){return X.filter(te=>!!te)}e.coalesce=u;function S(X){let te=0;for(let re=0;re<X.length;re++)X[re]&&(X[te]=X[re],te+=1);X.length=te}e.coalesceInPlace=S;function c(X,te,re){X.splice(re,0,X.splice(te,1)[0])}e.move=c;function h(X){return!Array.isArray(X)||X.length===0}e.isFalsyOrEmpty=h;function d(X){return Array.isArray(X)&&X.length>0}e.isNonEmptyArray=d;function n(X,te=re=>re){const re=new Set;return X.filter(le=>{const ue=te(le);return re.has(ue)?!1:(re.add(ue),!0)})}e.distinct=n;function o(X){const te=new Set;return re=>{const le=X(re);return te.has(le)?!1:(te.add(le),!0)}}e.uniqueFilter=o;function t(X,te){const re=r(X,te);if(re!==-1)return X[re]}e.findLast=t;function r(X,te){for(let re=X.length-1;re>=0;re--){const le=X[re];if(te(le))return re}return-1}e.lastIndex=r;function s(X,te){return X.length>0?X[0]:te}e.firstOrDefault=s;function l(X,te){return X.length>0?X[X.length-1]:te}e.lastOrDefault=l;function a(X,te,re=(le,ue)=>le===ue){let le=0;for(let ue=0,Se=Math.min(X.length,te.length);ue<Se&&re(X[ue],te[ue]);ue++)le++;return le}e.commonPrefixLength=a;function g(X){return[].concat(...X)}e.flatten=g;function C(X,te){let re=typeof te=="number"?X:0;typeof te=="number"?re=X:(re=0,te=X);const le=[];if(re<=te)for(let ue=re;ue<te;ue++)le.push(ue);else for(let ue=re;ue>te;ue--)le.push(ue);return le}e.range=C;function A(X,te,re){return X.reduce((le,ue)=>(le[te(ue)]=re?re(ue):ue,le),Object.create(null))}e.index=A;function V(X,te){return X.push(te),()=>_(X,te)}e.insert=V;function _(X,te){const re=X.indexOf(te);if(re>-1)return X.splice(re,1),te}e.remove=_;function F(X,te,re){const le=X.slice(0,te),ue=X.slice(te);return le.concat(re,ue)}e.arrayInsert=F;function N(X,te){let re;if(typeof te=="number"){let le=te;re=()=>{const ue=Math.sin(le++)*179426549;return ue-Math.floor(ue)}}else re=Math.random;for(let le=X.length-1;le>0;le-=1){const ue=Math.floor(re()*(le+1)),Se=X[le];X[le]=X[ue],X[ue]=Se}}e.shuffle=N;function L(X,te){const re=X.indexOf(te);re>-1&&(X.splice(re,1),X.unshift(te))}e.pushToStart=L;function U(X,te){const re=X.indexOf(te);re>-1&&(X.splice(re,1),X.push(te))}e.pushToEnd=U;function $(X,te){for(const re of te)X.push(re)}e.pushMany=$;function H(X,te){return Array.isArray(X)?X.map(te):te(X)}e.mapArrayOrNot=H;function q(X){return Array.isArray(X)?X:[X]}e.asArray=q;function x(X){return X[Math.floor(Math.random()*X.length)]}e.getRandomElement=x;function W(X,te){for(const re of X){const le=te(re);if(le!==void 0)return le}}e.mapFind=W;function j(X,te,re){const le=ee(X,te),ue=X.length,Se=re.length;X.length=ue+Se;for(let we=ue-1;we>=le;we--)X[we+Se]=X[we];for(let we=0;we<Se;we++)X[we+le]=re[we]}e.insertInto=j;function K(X,te,re,le){const ue=ee(X,te),Se=X.splice(ue,re);return j(X,ue,le),Se}e.splice=K;function ee(X,te){return te<0?Math.max(te+X.length,0):Math.min(te,X.length)}var ce;(function(X){function te(ue){return ue<0}X.isLessThan=te;function re(ue){return ue>0}X.isGreaterThan=re;function le(ue){return ue===0}X.isNeitherLessOrGreaterThan=le,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function J(X,te){return(re,le)=>te(X(re),X(le))}e.compareBy=J;function Q(...X){return(te,re)=>{for(const le of X){const ue=le(te,re);if(!ce.isNeitherLessOrGreaterThan(ue))return ue}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=Q;const M=(X,te)=>X-te;e.numberComparator=M;function O(X,te){if(X.length===0)return;let re=X[0];for(let le=1;le<X.length;le++){const ue=X[le];te(ue,re)>0&&(re=ue)}return re}e.findMaxBy=O;function B(X,te){if(X.length===0)return;let re=X[0];for(let le=1;le<X.length;le++){const ue=X[le];te(ue,re)>=0&&(re=ue)}return re}e.findLastMaxBy=B;function z(X,te){return O(X,(re,le)=>-te(re,le))}e.findMinBy=z;class Y{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let re=this.firstIdx;for(;re<this.items.length&&te(this.items[re]);)re++;const le=re===this.firstIdx?null:this.items.slice(this.firstIdx,re);return this.firstIdx=re,le}takeFromEndWhile(te){let re=this.lastIdx;for(;re>=0&&te(this.items[re]);)re--;const le=re===this.lastIdx?null:this.items.slice(re+1,this.lastIdx+1);return this.lastIdx=re,le}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}removeLast(){const te=this.items[this.lastIdx];return this.lastIdx--,te}takeCount(te){const re=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,re}}e.ArrayQueue=Y;class ne{constructor(te){this.iterate=te}forEach(te){this.iterate(re=>(te(re),!0))}toArray(){const te=[];return this.iterate(re=>(te.push(re),!0)),te}filter(te){return new ne(re=>this.iterate(le=>te(le)?re(le):!0))}map(te){return new ne(re=>this.iterate(le=>re(te(le))))}some(te){let re=!1;return this.iterate(le=>(re=te(le),!re)),re}findFirst(te){let re;return this.iterate(le=>te(le)?(re=le,!1):!0),re}findLast(te){let re;return this.iterate(le=>(te(le)&&(re=le),!0)),re}findLastMaxBy(te){let re,le=!0;return this.iterate(ue=>((le||ce.isGreaterThan(te(ue,re)))&&(le=!1,re=ue),!0)),re}}e.CallbackIterable=ne,ne.empty=new ne(X=>{})}),define(se[127],oe([0,1,11]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function i(P,w){if(!P)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=i;function R(P,w="Unreachable"){throw new Error(w)}e.assertNever=R;function k(P){if(!P)throw new D.BugIndicatingError("Assertion Failed")}e.assert=k;function T(P){if(!P()){debugger;P(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function I(P,w){let b=0;for(;b<P.length-1;){const E=P[b],p=P[b+1];if(!w(E,p))return!1;b++}return!0}e.checkAdjacentItems=I}),define(se[80],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(i){const R=this;let k=!1,T;return function(){return k||(k=!0,T=i.apply(R,arguments)),T}}e.once=D}),define(se[64],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(i){function R(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}i.is=R;const k=Object.freeze([]);function T(){return k}i.empty=T;function*I(h){yield h}i.single=I;function P(h){return R(h)?h:I(h)}i.wrap=P;function w(h){return h||k}i.from=w;function b(h){return!h||h[Symbol.iterator]().next().done===!0}i.isEmpty=b;function E(h){return h[Symbol.iterator]().next().value}i.first=E;function p(h,d){for(const n of h)if(d(n))return!0;return!1}i.some=p;function v(h,d){for(const n of h)if(d(n))return n}i.find=v;function*f(h,d){for(const n of h)d(n)&&(yield n)}i.filter=f;function*m(h,d){let n=0;for(const o of h)yield d(o,n++)}i.map=m;function*y(...h){for(const d of h)for(const n of d)yield n}i.concat=y;function u(h,d,n){let o=n;for(const t of h)o=d(o,t);return o}i.reduce=u;function*S(h,d,n=h.length){for(d<0&&(d+=h.length),n<0?n+=h.length:n>h.length&&(n=h.length);d<n;d++)yield h[d]}i.slice=S;function c(h,d=Number.POSITIVE_INFINITY){const n=[];if(d===0)return[n,h];const o=h[Symbol.iterator]();for(let t=0;t<d;t++){const r=o.next();if(r.done)return[n,i.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return o}}]}i.consume=c})(D=e.Iterable||(e.Iterable={}))}),define(se[35],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var i;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(n){n.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function T(n,o=!1){let t=0;const r=n.length;let s="",l=0,a=16,g=0;function C(U){let $=0,H=0;for(;$<U;){const q=n.charCodeAt(t);if(q>=48&&q<=57)H=H*16+q-48;else if(q>=65&&q<=70)H=H*16+q-65+10;else if(q>=97&&q<=102)H=H*16+q-97+10;else break;t++,$++}return $<U&&(H=-1),H}function A(U){t=U,s="",l=0,a=16,g=0}function V(){const U=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&w(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&w(n.charCodeAt(t)))for(t++;t<n.length&&w(n.charCodeAt(t));)t++;else return g=3,n.substring(U,t);let $=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&w(n.charCodeAt(t))){for(t++;t<n.length&&w(n.charCodeAt(t));)t++;$=t}else g=3;return n.substring(U,$)}function _(){let U="",$=t;for(;;){if(t>=r){U+=n.substring($,t),g=2;break}const H=n.charCodeAt(t);if(H===34){U+=n.substring($,t),t++;break}if(H===92){if(U+=n.substring($,t),t++,t>=r){g=2;break}switch(n.charCodeAt(t++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const x=C(4);x>=0?U+=String.fromCharCode(x):g=4;break}default:g=5}$=t;continue}if(H>=0&&H<=31)if(P(H)){U+=n.substring($,t),g=2;break}else g=6;t++}return U}function F(){if(s="",g=0,l=t,t>=r)return l=r,a=17;let U=n.charCodeAt(t);if(I(U)){do t++,s+=String.fromCharCode(U),U=n.charCodeAt(t);while(I(U));return a=15}if(P(U))return t++,s+=String.fromCharCode(U),U===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),a=14;switch(U){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,s=_(),a=10;case 47:{const $=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<r&&!P(n.charCodeAt(t));)t++;return s=n.substring($,t),a=12}if(n.charCodeAt(t+1)===42){t+=2;const H=r-1;let q=!1;for(;t<H;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,q=!0;break}t++}return q||(t++,g=1),s=n.substring($,t),a=13}return s+=String.fromCharCode(U),t++,a=16}case 45:if(s+=String.fromCharCode(U),t++,t===r||!w(n.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=V(),a=11;default:for(;t<r&&N(U);)t++,U=n.charCodeAt(t);if(l!==t){switch(s=n.substring(l,t),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode(U),t++,a=16}}function N(U){if(I(U)||P(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let U;do U=F();while(U>=12&&U<=15);return U}return{setPosition:A,getPosition:()=>t,scan:o?L:F,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>t-l,getTokenError:()=>g}}e.createScanner=T;function I(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function P(n){return n===10||n===13||n===8232||n===8233}function w(n){return n>=48&&n<=57}var b;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(b||(b={}));function E(n,o){const t=[],r=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function g(C,A,V,_){l.value=C,l.offset=A,l.length=V,l.type=_,l.colonOffset=void 0,s=l}try{c(n,{onObjectBegin:(C,A)=>{if(o<=C)throw r;s=void 0,a=o>C,t.push("")},onObjectProperty:(C,A,V)=>{if(o<A||(g(C,A,V,"property"),t[t.length-1]=C,o<=A+V))throw r},onObjectEnd:(C,A)=>{if(o<=C)throw r;s=void 0,t.pop()},onArrayBegin:(C,A)=>{if(o<=C)throw r;s=void 0,t.push(0)},onArrayEnd:(C,A)=>{if(o<=C)throw r;s=void 0,t.pop()},onLiteralValue:(C,A,V)=>{if(o<A||(g(C,A,V,d(C)),o<=A+V))throw r},onSeparator:(C,A,V)=>{if(o<=A)throw r;if(C===":"&&s&&s.type==="property")s.colonOffset=A,a=!1,s=void 0;else if(C===","){const _=t[t.length-1];typeof _=="number"?t[t.length-1]=_+1:(a=!0,t[t.length-1]=""),s=void 0}}})}catch(C){if(C!==r)throw C}return{path:t,previousNode:s,isAtPropertyKey:a,matches:C=>{let A=0;for(let V=0;A<C.length&&V<t.length;V++)if(C[A]===t[V]||C[A]==="*")A++;else if(C[A]!=="**")return!1;return A===C.length}}}e.getLocation=E;function p(n,o=[],t=k.DEFAULT){let r=null,s=[];const l=[];function a(C){Array.isArray(s)?s.push(C):r!==null&&(s[r]=C)}return c(n,{onObjectBegin:()=>{const C={};a(C),l.push(s),s=C,r=null},onObjectProperty:C=>{r=C},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const C=[];a(C),l.push(s),s=C,r=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:a,onError:(C,A,V)=>{o.push({error:C,offset:A,length:V})}},t),s[0]}e.parse=p;function v(n,o=[],t=k.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(C){r.type==="property"&&(r.length=C-r.offset,r=r.parent)}function l(C){return r.children.push(C),C}c(n,{onObjectBegin:C=>{r=l({type:"object",offset:C,length:-1,parent:r,children:[]})},onObjectProperty:(C,A,V)=>{r=l({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:C,offset:A,length:V,parent:r})},onObjectEnd:(C,A)=>{r.length=C+A-r.offset,r=r.parent,s(C+A)},onArrayBegin:(C,A)=>{r=l({type:"array",offset:C,length:-1,parent:r,children:[]})},onArrayEnd:(C,A)=>{r.length=C+A-r.offset,r=r.parent,s(C+A)},onLiteralValue:(C,A,V)=>{l({type:d(C),offset:A,length:V,parent:r,value:C}),s(A+V)},onSeparator:(C,A,V)=>{r.type==="property"&&(C===":"?r.colonOffset=A:C===","&&s(A))},onError:(C,A,V)=>{o.push({error:C,offset:A,length:V})}},t);const g=r.children[0];return g&&delete g.parent,g}e.parseTree=v;function f(n,o){if(!n)return;let t=n;for(const r of o)if(typeof r=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const l of t.children)if(Array.isArray(l.children)&&l.children[0].value===r){t=l.children[1],s=!0;break}if(!s)return}else{const s=r;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=f;function m(n){if(!n.parent||!n.parent.children)return[];const o=m(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;o.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&o.push(t)}return o}e.getNodePath=m;function y(n){switch(n.type){case"array":return n.children.map(y);case"object":{const o=Object.create(null);for(const t of n.children){const r=t.children[1];r&&(o[t.children[0].value]=y(r))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=y;function u(n,o,t=!1){return o>=n.offset&&o<n.offset+n.length||t&&o===n.offset+n.length}e.contains=u;function S(n,o,t=!1){if(u(n,o,t)){const r=n.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=o;s++){const l=S(r[s],o,t);if(l)return l}return n}}e.findNodeAtOffset=S;function c(n,o,t=k.DEFAULT){const r=T(n,!1);function s(J){return J?()=>J(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(J){return J?Q=>J(Q,r.getTokenOffset(),r.getTokenLength()):()=>!0}const a=s(o.onObjectBegin),g=l(o.onObjectProperty),C=s(o.onObjectEnd),A=s(o.onArrayBegin),V=s(o.onArrayEnd),_=l(o.onLiteralValue),F=l(o.onSeparator),N=s(o.onComment),L=l(o.onError),U=t&&t.disallowComments,$=t&&t.allowTrailingComma;function H(){for(;;){const J=r.scan();switch(r.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:U||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(J){case 12:case 13:U?q(10):N();break;case 16:q(1);break;case 15:case 14:break;default:return J}}}function q(J,Q=[],M=[]){if(L(J),Q.length+M.length>0){let O=r.getToken();for(;O!==17;){if(Q.indexOf(O)!==-1){H();break}else if(M.indexOf(O)!==-1)break;O=H()}}}function x(J){const Q=r.getTokenValue();return J?_(Q):g(Q),H(),!0}function W(){switch(r.getToken()){case 11:{let J=0;try{J=JSON.parse(r.getTokenValue()),typeof J!="number"&&(q(2),J=0)}catch{q(2)}_(J);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return H(),!0}function j(){return r.getToken()!==10?(q(3,[],[2,5]),!1):(x(!1),r.getToken()===6?(F(":"),H(),ce()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function K(){a(),H();let J=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(J||q(4,[],[]),F(","),H(),r.getToken()===2&&$)break}else J&&q(6,[],[]);j()||q(4,[],[2,5]),J=!0}return C(),r.getToken()!==2?q(7,[2],[]):H(),!0}function ee(){A(),H();let J=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(J||q(4,[],[]),F(","),H(),r.getToken()===4&&$)break}else J&&q(6,[],[]);ce()||q(4,[],[4,5]),J=!0}return V(),r.getToken()!==4?q(8,[4],[]):H(),!0}function ce(){switch(r.getToken()){case 3:return ee();case 1:return K();case 10:return x(!0);default:return W()}}return H(),r.getToken()===17?t.allowEmptyContent?!0:(q(4,[],[]),!1):ce()?(r.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=c;function h(n,o){const t=T(n),r=[];let s,l=0,a;do switch(a=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:l!==a&&r.push(n.substring(l,a)),o!==void 0&&r.push(t.getTokenValue().replace(/[^\r\n]/g,o)),l=t.getPosition();break}while(s!==17);return r.join("")}e.stripComments=h;function d(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=d}),define(se[42],oe([0,1,35]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(w,b,E){let p,v,f,m,y;if(b){for(m=b.offset,y=m+b.length,f=m;f>0&&!P(w,f-1);)f--;let a=y;for(;a<w.length&&!P(w,a);)a++;v=w.substring(f,a),p=T(v,E)}else v=w,p=0,f=0,m=0,y=w.length;const u=I(E,w);let S=!1,c=0,h;E.insertSpaces?h=k(" ",E.tabSize||4):h="	";const d=(0,D.createScanner)(v,!1);let n=!1;function o(){return u+k(h,p+c)}function t(){let a=d.scan();for(S=!1;a===15||a===14;)S=S||a===14,a=d.scan();return n=a===16||d.getTokenError()!==0,a}const r=[];function s(a,g,C){!n&&g<y&&C>m&&w.substring(g,C)!==a&&r.push({offset:g,length:C-g,content:a})}let l=t();if(l!==17){const a=d.getTokenOffset()+f,g=k(h,p);s(g,f,a)}for(;l!==17;){let a=d.getTokenOffset()+d.getTokenLength()+f,g=t(),C="";for(;!S&&(g===12||g===13);){const V=d.getTokenOffset()+f;s(" ",a,V),a=d.getTokenOffset()+d.getTokenLength()+f,C=g===12?o():"",g=t()}if(g===2)l!==1&&(c--,C=o());else if(g===4)l!==3&&(c--,C=o());else{switch(l){case 3:case 1:c++,C=o();break;case 5:case 12:C=o();break;case 13:S?C=o():C=" ";break;case 6:C=" ";break;case 10:if(g===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?C=" ":g!==5&&g!==17&&(n=!0);break;case 16:n=!0;break}S&&(g===12||g===13)&&(C=o())}const A=d.getTokenOffset()+f;s(C,a,A),l=g}return r}e.format=i;function R(w,b){const E=JSON.stringify(w,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?E.replace(/\r\n|\r|\n/g,b.eol):E}e.toFormattedString=R;function k(w,b){let E="";for(let p=0;p<b;p++)E+=w;return E}function T(w,b){let E=0,p=0;const v=b.tabSize||4;for(;E<w.length;){const f=w.charAt(E);if(f===" ")p++;else if(f==="	")p+=v;else break;E++}return Math.floor(p/v)}function I(w,b){for(let E=0;E<b.length;E++){const p=b.charAt(E);if(p==="\r")return E+1<b.length&&b.charAt(E+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=I;function P(w,b){return`\r
`.indexOf(w.charAt(b))!==-1}e.isEOL=P}),define(se[81],oe([0,1,35,42]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(w,b,E){return k(w,b,void 0,E)}e.removeProperty=R;function k(w,b,E,p,v){const f=b.slice(),m=[],y=(0,D.parseTree)(w,m);let u,S;for(;f.length>0&&(S=f.pop(),u=(0,D.findNodeAtLocation)(y,f),u===void 0&&E!==void 0);)typeof S=="string"?E={[S]:E}:E=[E];if(u)if(u.type==="object"&&typeof S=="string"&&Array.isArray(u.children)){const c=(0,D.findNodeAtLocation)(u,[S]);if(c!==void 0)if(E===void 0){if(!c.parent)throw new Error("Malformed AST");const h=u.children.indexOf(c.parent);let d,n=c.parent.offset+c.parent.length;if(h>0){const o=u.children[h-1];d=o.offset+o.length}else d=u.offset+1,u.children.length>1&&(n=u.children[1].offset);return T(w,{offset:d,length:n-d,content:""},p)}else return T(w,{offset:c.offset,length:c.length,content:JSON.stringify(E)},p);else{if(E===void 0)return[];const h=`${JSON.stringify(S)}: ${JSON.stringify(E)}`,d=v?v(u.children.map(o=>o.children[0].value)):u.children.length;let n;if(d>0){const o=u.children[d-1];n={offset:o.offset+o.length,length:0,content:","+h}}else u.children.length===0?n={offset:u.offset+1,length:0,content:h}:n={offset:u.offset+1,length:0,content:h+","};return T(w,n,p)}}else if(u.type==="array"&&typeof S=="number"&&Array.isArray(u.children))if(E!==void 0){const c=`${JSON.stringify(E)}`;let h;if(u.children.length===0||S===0)h={offset:u.offset+1,length:0,content:u.children.length===0?c:c+","};else{const d=S===-1||S>u.children.length?u.children.length:S,n=u.children[d-1];h={offset:n.offset+n.length,length:0,content:","+c}}return T(w,h,p)}else{const c=S,h=u.children[c];let d;if(u.children.length===1)d={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===c){const n=u.children[c-1],o=n.offset+n.length,t=u.offset+u.length;d={offset:o,length:t-2-o,content:""}}else d={offset:h.offset,length:u.children[c+1].offset-h.offset,content:""};return T(w,d,p)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${u.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return T(w,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(E)},p)}}e.setProperty=k;function T(w,b,E){let p=I(w,b),v=b.offset,f=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;v>0&&!(0,i.isEOL)(p,v-1);)v--;for(;f<p.length&&!(0,i.isEOL)(p,f);)f++}const m=(0,i.format)(p,{offset:v,length:f-v},E);for(let u=m.length-1;u>=0;u--){const S=m[u];p=I(p,S),v=Math.min(v,S.offset),f=Math.max(f,S.offset+S.length),f+=S.content.length-S.length}const y=w.length-(p.length-f)-v;return[{offset:v,length:y,content:p.substring(v,f)}]}e.withFormatting=T;function I(w,b){return w.substring(0,b.offset)+b.content+w.substring(b.offset+b.length)}e.applyEdit=I;function P(w,b){const E=b.slice(0).sort((v,f)=>{const m=v.offset-f.offset;return m===0?v.length-f.length:m});let p=w.length;for(let v=E.length-1;v>=0;v--){const f=E[v];if(f.offset+f.length<=p)w=I(w,f);else throw new Error("Overlapping edit");p=f.offset}return w}e.applyEdits=P}),define(se[128],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new D(()=>R(this.getValue()))}}e.Lazy=D}),define(se[2],oe([0,1,80,64]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let k=null;function T(l){k=l}if(e.setDisposableTracker=T,R){const l="__is_disposable_tracked__";T(new class{trackDisposable(a){const g=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[l]||console.log(g)},3e3)}setParent(a,g){if(a&&a!==S.None)try{a[l]=!0}catch{}}markAsDisposed(a){if(a&&a!==S.None)try{a[l]=!0}catch{}}markAsSingleton(a){}})}function I(l){return k?.trackDisposable(l),l}function P(l){k?.markAsDisposed(l)}function w(l,a){k?.setParent(l,a)}function b(l,a){if(!!k)for(const g of l)k.setParent(g,a)}function E(l){return k?.markAsSingleton(l),l}e.markAsSingleton=E;function p(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=p;function v(l){if(i.Iterable.is(l)){const a=[];for(const g of l)if(g)try{g.dispose()}catch(C){a.push(C)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=v;function f(l){for(const a of l)p(a)&&a.dispose();return[]}e.disposeIfDisposable=f;function m(...l){const a=y(()=>v(l));return b(l,a),a}e.combinedDisposable=m;function y(l){const a=I({dispose:(0,D.once)(()=>{P(a),l()})});return a}e.toDisposable=y;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{v(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return w(a,this),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new u,I(this),w(this._store,this)}dispose(){P(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=S,S.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&w(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,P(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&w(a,null),a}}e.MutableDisposable=c;class h{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class d{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(a){let g=a;return this.unset=()=>g=void 0,this.isset=()=>g!==void 0,this.dispose=()=>{g&&(g(),g=void 0,P(this))},this}}e.SafeDisposable=d;class n{constructor(){this.references=new Map}acquire(a,...g){let C=this.references.get(a);C||(C={counter:0,object:this.createReferencedObject(a,...g)},this.references.set(a,C));const{object:A}=C,V=(0,D.once)(()=>{--C.counter===0&&(this.destroyReferencedObject(a,C.object),this.references.delete(a))});return C.counter++,{object:A,dispose:V}}}e.ReferenceCollection=n;class o{constructor(a){this.referenceCollection=a}async acquire(a,...g){const C=this.referenceCollection.acquire(a,...g);try{return{object:await C.object,dispose:()=>C.dispose()}}catch(A){throw C.dispose(),A}}}e.AsyncReferenceCollection=o;class t{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=t;function r(l){const a=new u;try{l(a)}finally{a.dispose()}}e.disposeOnReturn=r;class s{constructor(){this._store=new Map,this._isDisposed=!1,I(this)}dispose(){P(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{v(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,g,C=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),C||this._store.get(a)?.dispose(),this._store.set(a,g)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=s}),define(se[82],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(k){this.element=k,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class i{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let k=this._first;for(;k!==D.Undefined;){const T=k.next;k.prev=D.Undefined,k.next=D.Undefined,k=T}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,T){const I=new D(k);if(this._first===D.Undefined)this._first=I,this._last=I;else if(T){const w=this._last;this._last=I,I.prev=w,w.next=I}else{const w=this._first;this._first=I,I.next=w,w.prev=I}this._size+=1;let P=!1;return()=>{P||(P=!0,this._remove(I))}}shift(){if(this._first!==D.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==D.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==D.Undefined&&k.next!==D.Undefined){const T=k.prev;T.next=k.next,k.next.prev=T}else k.prev===D.Undefined&&k.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):k.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):k.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==D.Undefined;)yield k.element,k=k.next}}e.LinkedList=i}),define(se[37],oe([0,1]),function(Z,e){"use strict";var D,i,R;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function k(f,m,y){let u=f.get(m);return u===void 0&&(u=y,f.set(m,u)),u}e.getOrSet=k;function T(f){const m=[];return f.forEach((y,u)=>{m.push(`${u} => ${y}`)}),`Map(${f.size}) {${m.join(", ")}}`}e.mapToString=T;function I(f){const m=[];return f.forEach(y=>{m.push(y)}),`Set(${f.size}) {${m.join(", ")}}`}e.setToString=I;class P{constructor(m,y){this.uri=m,this.value=y}}class w{constructor(m,y){this[D]="ResourceMap",m instanceof w?(this.map=new Map(m.map),this.toKey=y??w.defaultToKey):(this.map=new Map,this.toKey=m??w.defaultToKey)}set(m,y){return this.map.set(this.toKey(m),new P(m,y)),this}get(m){return this.map.get(this.toKey(m))?.value}has(m){return this.map.has(this.toKey(m))}get size(){return this.map.size}clear(){this.map.clear()}delete(m){return this.map.delete(this.toKey(m))}forEach(m,y){typeof y<"u"&&(m=m.bind(y));for(const[u,S]of this.map)m(S.value,S.uri,this)}*values(){for(const m of this.map.values())yield m.value}*keys(){for(const m of this.map.values())yield m.uri}*entries(){for(const m of this.map.values())yield[m.uri,m.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,m]of this.map)yield[m.uri,m.value]}}e.ResourceMap=w,w.defaultToKey=f=>f.toString();class b{constructor(m,y){this[i]="ResourceSet",!m||typeof m=="function"?this._map=new w(m):(this._map=new w(y),m.forEach(this.add,this))}get size(){return this._map.size}add(m){return this._map.set(m,m),this}clear(){this._map.clear()}delete(m){return this._map.delete(m)}forEach(m,y){this._map.forEach((u,S)=>m.call(y,S,S,this))}has(m){return this._map.has(m)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var E;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class p{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(m){return this._map.has(m)}get(m,y=0){const u=this._map.get(m);if(!!u)return y!==0&&this.touch(u,y),u.value}set(m,y,u=0){let S=this._map.get(m);if(S)S.value=y,u!==0&&this.touch(S,u);else{switch(S={key:m,value:y,next:void 0,previous:void 0},u){case 0:this.addItemLast(S);break;case 1:this.addItemFirst(S);break;case 2:this.addItemLast(S);break;default:this.addItemLast(S);break}this._map.set(m,S),this._size++}return this}delete(m){return!!this.remove(m)}remove(m){const y=this._map.get(m);if(!!y)return this._map.delete(m),this.removeItem(y),this._size--,y.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const m=this._head;return this._map.delete(m.key),this.removeItem(m),this._size--,m.value}forEach(m,y){const u=this._state;let S=this._head;for(;S;){if(y?m.bind(y)(S.value,S.key,this):m(S.value,S.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");S=S.next}}keys(){const m=this,y=this._state;let u=this._head;const S={[Symbol.iterator](){return S},next(){if(m._state!==y)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.key,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return S}values(){const m=this,y=this._state;let u=this._head;const S={[Symbol.iterator](){return S},next(){if(m._state!==y)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.value,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return S}entries(){const m=this,y=this._state;let u=this._head;const S={[Symbol.iterator](){return S},next(){if(m._state!==y)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:[u.key,u.value],done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return S}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(m){if(m>=this.size)return;if(m===0){this.clear();return}let y=this._head,u=this.size;for(;y&&u>m;)this._map.delete(y.key),y=y.next,u--;this._head=y,this._size=u,y&&(y.previous=void 0),this._state++}addItemFirst(m){if(!this._head&&!this._tail)this._tail=m;else if(this._head)m.next=this._head,this._head.previous=m;else throw new Error("Invalid list");this._head=m,this._state++}addItemLast(m){if(!this._head&&!this._tail)this._head=m;else if(this._tail)m.previous=this._tail,this._tail.next=m;else throw new Error("Invalid list");this._tail=m,this._state++}removeItem(m){if(m===this._head&&m===this._tail)this._head=void 0,this._tail=void 0;else if(m===this._head){if(!m.next)throw new Error("Invalid list");m.next.previous=void 0,this._head=m.next}else if(m===this._tail){if(!m.previous)throw new Error("Invalid list");m.previous.next=void 0,this._tail=m.previous}else{const y=m.next,u=m.previous;if(!y||!u)throw new Error("Invalid list");y.previous=u,u.next=y}m.next=void 0,m.previous=void 0,this._state++}touch(m,y){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(y!==1&&y!==2)){if(y===1){if(m===this._head)return;const u=m.next,S=m.previous;m===this._tail?(S.next=void 0,this._tail=S):(u.previous=S,S.next=u),m.previous=void 0,m.next=this._head,this._head.previous=m,this._head=m,this._state++}else if(y===2){if(m===this._tail)return;const u=m.next,S=m.previous;m===this._head?(u.previous=void 0,this._head=u):(u.previous=S,S.next=u),m.next=void 0,m.previous=this._tail,this._tail.next=m,this._tail=m,this._state++}}}toJSON(){const m=[];return this.forEach((y,u)=>{m.push([u,y])}),m}fromJSON(m){this.clear();for(const[y,u]of m)this.set(y,u)}}e.LinkedMap=p;class v extends p{constructor(m,y=1){super(),this._limit=m,this._ratio=Math.min(Math.max(0,y),1)}get limit(){return this._limit}set limit(m){this._limit=m,this.checkTrim()}get ratio(){return this._ratio}set ratio(m){this._ratio=Math.min(Math.max(0,m),1),this.checkTrim()}get(m,y=2){return super.get(m,y)}peek(m){return super.get(m,0)}set(m,y){return super.set(m,y,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=v}),define(se[83],oe([0,1,37]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new D.LRUCache(1e4);function R(w){return P(w,"NFC",i)}e.normalizeNFC=R;const k=new D.LRUCache(1e4);function T(w){return P(w,"NFD",k)}e.normalizeNFD=T;const I=/[^\u0000-\u0080]/;function P(w,b,E){if(!w)return w;const p=E.get(w);if(p)return p;let v;return I.test(w)?v=w.normalize(b):v=w,E.set(w,v),v}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(b){return T(b).replace(w,"")}}()}),function(){function Z(R){const k=[];typeof R=="number"&&k.push("code/timeOrigin",R);function T(P){k.push(P,Date.now())}function I(){const P=[];for(let w=0;w<k.length;w+=2)P.push({name:k[w],startTime:k[w+1]});return P}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const T of performance.getEntriesByType("mark"))k.push({name:T.name,startTime:Math.round(R+T.startTime)});return k}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=D(i))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var i in D)(typeof exports=="object"?exports:Z)[i]=D[i]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function D(i){if(e[i])return e[i].exports;var R=e[i]={i,l:!1,exports:{}};return Z[i].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=Z,D.c=e,D.d=function(i,R,k){D.o(i,R)||Object.defineProperty(i,R,{enumerable:!0,get:k})},D.r=function(i){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},D.t=function(i,R){if(1&R&&(i=D(i)),8&R||4&R&&typeof i=="object"&&i&&i.__esModule)return i;var k=Object.create(null);if(D.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:i}),2&R&&typeof i!="string")for(var T in i)D.d(k,T,function(I){return i[I]}.bind(null,T));return k},D.n=function(i){var R=i&&i.__esModule?function(){return i.default}:function(){return i};return D.d(R,"a",R),R},D.o=function(i,R){return Object.prototype.hasOwnProperty.call(i,R)},D.p="",D(D.s=0)}([function(Z,e,D){(function(i){var R;e=Z.exports=M,R=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],P=e.src=[],w=0,b=w++;P[b]="0|[1-9]\\d*";var E=w++;P[E]="[0-9]+";var p=w++;P[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=w++;P[v]="("+P[b]+")\\.("+P[b]+")\\.("+P[b]+")";var f=w++;P[f]="("+P[E]+")\\.("+P[E]+")\\.("+P[E]+")";var m=w++;P[m]="(?:"+P[b]+"|"+P[p]+")";var y=w++;P[y]="(?:"+P[E]+"|"+P[p]+")";var u=w++;P[u]="(?:-("+P[m]+"(?:\\."+P[m]+")*))";var S=w++;P[S]="(?:-?("+P[y]+"(?:\\."+P[y]+")*))";var c=w++;P[c]="[0-9A-Za-z-]+";var h=w++;P[h]="(?:\\+("+P[c]+"(?:\\."+P[c]+")*))";var d=w++,n="v?"+P[v]+P[u]+"?"+P[h]+"?";P[d]="^"+n+"$";var o="[v=\\s]*"+P[f]+P[S]+"?"+P[h]+"?",t=w++;P[t]="^"+o+"$";var r=w++;P[r]="((?:<|>)?=?)";var s=w++;P[s]=P[E]+"|x|X|\\*";var l=w++;P[l]=P[b]+"|x|X|\\*";var a=w++;P[a]="[v=\\s]*("+P[l]+")(?:\\.("+P[l]+")(?:\\.("+P[l]+")(?:"+P[u]+")?"+P[h]+"?)?)?";var g=w++;P[g]="[v=\\s]*("+P[s]+")(?:\\.("+P[s]+")(?:\\.("+P[s]+")(?:"+P[S]+")?"+P[h]+"?)?)?";var C=w++;P[C]="^"+P[r]+"\\s*"+P[a]+"$";var A=w++;P[A]="^"+P[r]+"\\s*"+P[g]+"$";var V=w++;P[V]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=w++;P[_]="(?:~>?)";var F=w++;P[F]="(\\s*)"+P[_]+"\\s+",I[F]=new RegExp(P[F],"g");var N=w++;P[N]="^"+P[_]+P[a]+"$";var L=w++;P[L]="^"+P[_]+P[g]+"$";var U=w++;P[U]="(?:\\^)";var $=w++;P[$]="(\\s*)"+P[U]+"\\s+",I[$]=new RegExp(P[$],"g");var H=w++;P[H]="^"+P[U]+P[a]+"$";var q=w++;P[q]="^"+P[U]+P[g]+"$";var x=w++;P[x]="^"+P[r]+"\\s*("+o+")$|^$";var W=w++;P[W]="^"+P[r]+"\\s*("+n+")$|^$";var j=w++;P[j]="(\\s*)"+P[r]+"\\s*("+o+"|"+P[a]+")",I[j]=new RegExp(P[j],"g");var K=w++;P[K]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var ee=w++;P[ee]="^\\s*("+P[g]+")\\s+-\\s+("+P[g]+")\\s*$";var ce=w++;P[ce]="(<|>)?=?\\s*\\*";for(var J=0;J<35;J++)R(J,P[J]),I[J]||(I[J]=new RegExp(P[J]));function Q(ae,fe){if(ae instanceof M)return ae;if(typeof ae!="string"||ae.length>k||!(fe?I[t]:I[d]).test(ae))return null;try{return new M(ae,fe)}catch{return null}}function M(ae,fe){if(ae instanceof M){if(ae.loose===fe)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof M))return new M(ae,fe);R("SemVer",ae,fe),this.loose=fe;var ge=ae.trim().match(fe?I[t]:I[d]);if(!ge)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ie=+be;if(Ie>=0&&Ie<T)return Ie}return be}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=Q,e.valid=function(ae,fe){var ge=Q(ae,fe);return ge?ge.version:null},e.clean=function(ae,fe){var ge=Q(ae.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function(ae){return R("SemVer.compare",this.version,this.loose,ae),ae instanceof M||(ae=new M(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},M.prototype.compareMain=function(ae){return ae instanceof M||(ae=new M(ae,this.loose)),B(this.major,ae.major)||B(this.minor,ae.minor)||B(this.patch,ae.patch)},M.prototype.comparePre=function(ae){if(ae instanceof M||(ae=new M(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],be=ae.prerelease[fe];if(R("prerelease compare",fe,ge,be),ge===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(ge===void 0)return-1;if(ge!==be)return B(ge,be)}while(++fe)},M.prototype.inc=function(ae,fe){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,fe,ge,be){typeof ge=="string"&&(be=ge,ge=void 0);try{return new M(ae,ge).inc(fe,be).version}catch{return null}},e.diff=function(ae,fe){if(X(ae,fe))return null;var ge=Q(ae),be=Q(fe);if(ge.prerelease.length||be.prerelease.length){for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return Ie},e.compareIdentifiers=B;var O=/^[0-9]+$/;function B(ae,fe){var ge=O.test(ae),be=O.test(fe);return ge&&be&&(ae=+ae,fe=+fe),ge&&!be?-1:be&&!ge?1:ae<fe?-1:ae>fe?1:0}function z(ae,fe,ge){return new M(ae,ge).compare(new M(fe,ge))}function Y(ae,fe,ge){return z(ae,fe,ge)>0}function ne(ae,fe,ge){return z(ae,fe,ge)<0}function X(ae,fe,ge){return z(ae,fe,ge)===0}function te(ae,fe,ge){return z(ae,fe,ge)!==0}function re(ae,fe,ge){return z(ae,fe,ge)>=0}function le(ae,fe,ge){return z(ae,fe,ge)<=0}function ue(ae,fe,ge,be){var Ie;switch(fe){case"===":typeof ae=="object"&&(ae=ae.version),typeof ge=="object"&&(ge=ge.version),Ie=ae===ge;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof ge=="object"&&(ge=ge.version),Ie=ae!==ge;break;case"":case"=":case"==":Ie=X(ae,ge,be);break;case"!=":Ie=te(ae,ge,be);break;case">":Ie=Y(ae,ge,be);break;case">=":Ie=re(ae,ge,be);break;case"<":Ie=ne(ae,ge,be);break;case"<=":Ie=le(ae,ge,be);break;default:throw new TypeError("Invalid operator: "+fe)}return Ie}function Se(ae,fe){if(ae instanceof Se){if(ae.loose===fe)return ae;ae=ae.value}if(!(this instanceof Se))return new Se(ae,fe);R("comparator",ae,fe),this.loose=fe,this.parse(ae),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ae,fe){return B(fe,ae)},e.major=function(ae,fe){return new M(ae,fe).major},e.minor=function(ae,fe){return new M(ae,fe).minor},e.patch=function(ae,fe){return new M(ae,fe).patch},e.compare=z,e.compareLoose=function(ae,fe){return z(ae,fe,!0)},e.rcompare=function(ae,fe,ge){return z(fe,ae,ge)},e.sort=function(ae,fe){return ae.sort(function(ge,be){return e.compare(ge,be,fe)})},e.rsort=function(ae,fe){return ae.sort(function(ge,be){return e.rcompare(ge,be,fe)})},e.gt=Y,e.lt=ne,e.eq=X,e.neq=te,e.gte=re,e.lte=le,e.cmp=ue,e.Comparator=Se;var we={};function Ee(ae,fe){if(ae instanceof Ee)return ae.loose===fe?ae:new Ee(ae.raw,fe);if(ae instanceof Se)return new Ee(ae.value,fe);if(!(this instanceof Ee))return new Ee(ae,fe);if(this.loose=fe,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Ce(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Ae(ae,fe,ge,be,Ie,Le,Re,Fe,_e,Me,ze,ke,Oe){return((fe=Ce(ge)?"":Ce(be)?">="+ge+".0.0":Ce(Ie)?">="+ge+"."+be+".0":">="+fe)+" "+(Fe=Ce(_e)?"":Ce(Me)?"<"+(+_e+1)+".0.0":Ce(ze)?"<"+_e+"."+(+Me+1)+".0":ke?"<="+_e+"."+Me+"."+ze+"-"+ke:"<="+Fe)).trim()}function Ne(ae,fe){for(var ge=0;ge<ae.length;ge++)if(!ae[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ae.length;ge++)if(R(ae[ge].semver),ae[ge].semver!==we&&ae[ge].semver.prerelease.length>0){var be=ae[ge].semver;if(be.major===fe.major&&be.minor===fe.minor&&be.patch===fe.patch)return!0}return!1}return!0}function Ge(ae,fe,ge){try{fe=new Ee(fe,ge)}catch{return!1}return fe.test(ae)}function We(ae,fe,ge,be){var Ie,Le,Re,Fe,_e;switch(ae=new M(ae,be),fe=new Ee(fe,be),ge){case">":Ie=Y,Le=le,Re=ne,Fe=">",_e=">=";break;case"<":Ie=ne,Le=re,Re=Y,Fe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ge(ae,fe,be))return!1;for(var Me=0;Me<fe.set.length;++Me){var ze=fe.set[Me],ke=null,Oe=null;if(ze.forEach(function(ie){ie.semver===we&&(ie=new Se(">=0.0.0")),ke=ke||ie,Oe=Oe||ie,Ie(ie.semver,ke.semver,be)?ke=ie:Re(ie.semver,Oe.semver,be)&&(Oe=ie)}),ke.operator===Fe||ke.operator===_e||(!Oe.operator||Oe.operator===Fe)&&Le(ae,Oe.semver)||Oe.operator===_e&&Re(ae,Oe.semver))return!1}return!0}Se.prototype.parse=function(ae){var fe=this.loose?I[x]:I[W],ge=ae.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ae);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new M(ge[2],this.loose):this.semver=we},Se.prototype.toString=function(){return this.value},Se.prototype.test=function(ae){return R("Comparator.test",ae,this.loose),this.semver===we||(typeof ae=="string"&&(ae=new M(ae,this.loose)),ue(ae,this.operator,this.semver,this.loose))},Se.prototype.intersects=function(ae,fe){if(!(ae instanceof Se))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Ee(ae.value,fe),Ge(this.value,ge,fe);if(ae.operator==="")return ge=new Ee(this.value,fe),Ge(ae.semver,ge,fe);var be=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Le=this.semver.version===ae.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Fe=ue(this.semver,"<",ae.semver,fe)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),_e=ue(this.semver,">",ae.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return be||Ie||Le&&Re||Fe||_e},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ae){var fe=this.loose;ae=ae.trim(),R("range",ae,fe);var ge=fe?I[ee]:I[K];ae=ae.replace(ge,Ae),R("hyphen replace",ae),ae=ae.replace(I[j],"$1$2$3"),R("comparator trim",ae,I[j]),ae=(ae=(ae=ae.replace(I[F],"$1~")).replace(I[$],"$1^")).split(/\s+/).join(" ");var be=fe?I[x]:I[W],Ie=ae.split(" ").map(function(Le){return function(Re,Fe){return R("comp",Re),Re=function(_e,Me){return _e.trim().split(/\s+/).map(function(ze){return function(ke,Oe){R("caret",ke,Oe);var ie=Oe?I[q]:I[H];return ke.replace(ie,function(he,de,me,pe,Pe){var De;return R("caret",ke,he,de,me,pe,Pe),Ce(de)?De="":Ce(me)?De=">="+de+".0.0 <"+(+de+1)+".0.0":Ce(pe)?De=de==="0"?">="+de+"."+me+".0 <"+de+"."+(+me+1)+".0":">="+de+"."+me+".0 <"+(+de+1)+".0.0":Pe?(R("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),De=de==="0"?me==="0"?">="+de+"."+me+"."+pe+Pe+" <"+de+"."+me+"."+(+pe+1):">="+de+"."+me+"."+pe+Pe+" <"+de+"."+(+me+1)+".0":">="+de+"."+me+"."+pe+Pe+" <"+(+de+1)+".0.0"):(R("no pr"),De=de==="0"?me==="0"?">="+de+"."+me+"."+pe+" <"+de+"."+me+"."+(+pe+1):">="+de+"."+me+"."+pe+" <"+de+"."+(+me+1)+".0":">="+de+"."+me+"."+pe+" <"+(+de+1)+".0.0"),R("caret return",De),De})}(ze,Me)}).join(" ")}(Re,Fe),R("caret",Re),Re=function(_e,Me){return _e.trim().split(/\s+/).map(function(ze){return function(ke,Oe){var ie=Oe?I[L]:I[N];return ke.replace(ie,function(he,de,me,pe,Pe){var De;return R("tilde",ke,he,de,me,pe,Pe),Ce(de)?De="":Ce(me)?De=">="+de+".0.0 <"+(+de+1)+".0.0":Ce(pe)?De=">="+de+"."+me+".0 <"+de+"."+(+me+1)+".0":Pe?(R("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),De=">="+de+"."+me+"."+pe+Pe+" <"+de+"."+(+me+1)+".0"):De=">="+de+"."+me+"."+pe+" <"+de+"."+(+me+1)+".0",R("tilde return",De),De})}(ze,Me)}).join(" ")}(Re,Fe),R("tildes",Re),Re=function(_e,Me){return R("replaceXRanges",_e,Me),_e.split(/\s+/).map(function(ze){return function(ke,Oe){ke=ke.trim();var ie=Oe?I[A]:I[C];return ke.replace(ie,function(he,de,me,pe,Pe,De){R("xRange",ke,he,de,me,pe,Pe,De);var Be=Ce(me),$e=Be||Ce(pe),Te=$e||Ce(Pe);return de==="="&&Te&&(de=""),Be?he=de===">"||de==="<"?"<0.0.0":"*":de&&Te?($e&&(pe=0),Te&&(Pe=0),de===">"?(de=">=",$e?(me=+me+1,pe=0,Pe=0):Te&&(pe=+pe+1,Pe=0)):de==="<="&&(de="<",$e?me=+me+1:pe=+pe+1),he=de+me+"."+pe+"."+Pe):$e?he=">="+me+".0.0 <"+(+me+1)+".0.0":Te&&(he=">="+me+"."+pe+".0 <"+me+"."+(+pe+1)+".0"),R("xRange return",he),he})}(ze,Me)}).join(" ")}(Re,Fe),R("xrange",Re),Re=function(_e,Me){return R("replaceStars",_e,Me),_e.trim().replace(I[ce],"")}(Re,Fe),R("stars",Re),Re}(Le,fe)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Le){return!!Le.match(be)})),Ie=Ie.map(function(Le){return new Se(Le,fe)})},Ee.prototype.intersects=function(ae,fe){if(!(ae instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(be){return ae.set.some(function(Ie){return Ie.every(function(Le){return be.intersects(Le,fe)})})})})},e.toComparators=function(ae,fe){return new Ee(ae,fe).set.map(function(ge){return ge.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new M(ae,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Ne(this.set[fe],ae))return!0;return!1},e.satisfies=Ge,e.maxSatisfying=function(ae,fe,ge){var be=null,Ie=null;try{var Le=new Ee(fe,ge)}catch{return null}return ae.forEach(function(Re){Le.test(Re)&&(be&&Ie.compare(Re)!==-1||(Ie=new M(be=Re,ge)))}),be},e.minSatisfying=function(ae,fe,ge){var be=null,Ie=null;try{var Le=new Ee(fe,ge)}catch{return null}return ae.forEach(function(Re){Le.test(Re)&&(be&&Ie.compare(Re)!==1||(Ie=new M(be=Re,ge)))}),be},e.validRange=function(ae,fe){try{return new Ee(ae,fe).range||"*"}catch{return null}},e.ltr=function(ae,fe,ge){return We(ae,fe,"<",ge)},e.gtr=function(ae,fe,ge){return We(ae,fe,">",ge)},e.outside=We,e.prerelease=function(ae,fe){var ge=Q(ae,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ae,fe,ge){return ae=new Ee(ae,ge),fe=new Ee(fe,ge),ae.intersects(fe)},e.coerce=function(ae){if(ae instanceof M)return ae;if(typeof ae!="string")return null;var fe=ae.match(I[V]);return fe==null?null:Q((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,D(1))},function(Z,e){var D,i,R=Z.exports={};function k(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function I(y){if(D===setTimeout)return setTimeout(y,0);if((D===k||!D)&&setTimeout)return D=setTimeout,setTimeout(y,0);try{return D(y,0)}catch{try{return D.call(null,y,0)}catch{return D.call(this,y,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:k}catch{D=k}try{i=typeof clearTimeout=="function"?clearTimeout:T}catch{i=T}})();var P,w=[],b=!1,E=-1;function p(){b&&P&&(b=!1,P.length?w=P.concat(w):E=-1,w.length&&v())}function v(){if(!b){var y=I(p);b=!0;for(var u=w.length;u;){for(P=w,w=[];++E<u;)P&&P[E].run();E=-1,u=w.length}P=null,b=!1,function(S){if(i===clearTimeout)return clearTimeout(S);if((i===T||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(S);try{i(S)}catch{try{return i.call(null,S)}catch{return i.call(this,S)}}}(y)}}function f(y,u){this.fun=y,this.array=u}function m(){}R.nextTick=function(y){var u=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)u[S-1]=arguments[S];w.push(new f(y,u)),w.length!==1||b||I(v)},f.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=m,R.addListener=m,R.once=m,R.off=m,R.removeListener=m,R.removeAllListeners=m,R.emit=m,R.prependListener=m,R.prependOnceListener=m,R.listeners=function(y){return[]},R.binding=function(y){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(y){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(se[129],oe([0,1]),function(Z,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(I,P,w){this.level=I,this.key=P,this.value=w,this.forward=[]}}const R=void 0;class k{constructor(I,P=2**16){this.comparator=I,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(P)|0),this._header=new i(this._maxLevel,R,R)}get size(){return this._size}clear(){this._header=new i(this._maxLevel,R,R)}has(I){return Boolean(k._search(this,I,this.comparator))}get(I){return k._search(this,I,this.comparator)?.value}set(I,P){return k._insert(this,I,P,this.comparator)&&(this._size+=1),this}delete(I){const P=k._delete(this,I,this.comparator);return P&&(this._size-=1),P}forEach(I,P){let w=this._header.forward[0];for(;w;)I.call(P,w.value,w.key,this),w=w.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",P=this._header.forward[0];for(;P;)I+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return I}static _search(I,P,w){let b=I._header;for(let E=I._level-1;E>=0;E--)for(;b.forward[E]&&w(b.forward[E].key,P)<0;)b=b.forward[E];if(b=b.forward[0],b&&w(b.key,P)===0)return b}static _insert(I,P,w,b){const E=[];let p=I._header;for(let v=I._level-1;v>=0;v--){for(;p.forward[v]&&b(p.forward[v].key,P)<0;)p=p.forward[v];E[v]=p}if(p=p.forward[0],p&&b(p.key,P)===0)return p.value=w,!1;{const v=k._randomLevel(I);if(v>I._level){for(let f=I._level;f<v;f++)E[f]=I._header;I._level=v}p=new i(v,P,w);for(let f=0;f<v;f++)p.forward[f]=E[f].forward[f],E[f].forward[f]=p;return!0}}static _randomLevel(I,P=.5){let w=1;for(;Math.random()<P&&w<I._maxLevel;)w+=1;return w}static _delete(I,P,w){const b=[];let E=I._header;for(let p=I._level-1;p>=0;p--){for(;E.forward[p]&&w(E.forward[p].key,P)<0;)E=E.forward[p];b[p]=E}if(E=E.forward[0],!E||w(E.key,P)!==0)return!1;for(let p=0;p<I._level&&b[p].forward[p]===E;p++)b[p].forward[p]=E.forward[p];for(;I._level>0&&I._header.forward[I._level-1]===R;)I._level-=1;return!0}}e.SkipList=k}),define(se[43],oe([0,1,11,2]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(h){const d=h;return d?typeof d.read=="function":!1}e.isReadable=R;function k(h){const d=h;return d?[d.on,d.pause,d.resume,d.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=k;function T(h){const d=h;return d?k(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=T;function I(h,d){return new P(h,d)}e.newWriteableStream=I;class P{constructor(d,n){this.reducer=d,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d<"u"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(n=>n(d))}emitError(d){this.listeners.error.length===0?(0,D.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(n=>n(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,n){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(d,n){if(this.state.destroyed)return;let o;switch(d){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const t=o.indexOf(n);t>=0&&o.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(h,d){const n=[];let o;for(;(o=h.read())!==null;)n.push(o);return d(n)}e.consumeReadable=w;function b(h,d,n){const o=[];let t;for(;(t=h.read())!==null&&o.length<n;)o.push(t);return t===null&&o.length>0?d(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const r=t;return t=void 0,r}return h.read()}}}e.peekReadable=b;function E(h,d){return new Promise((n,o)=>{const t=[];p(h,{onData:r=>{d&&t.push(r)},onError:r=>{d?o(r):n(void 0)},onEnd:()=>{n(d?d(t):void 0)}})})}e.consumeStream=E;function p(h,d){let n=!1;return h.on("error",o=>{n||d.onError(o)}),h.on("end",()=>{n||d.onEnd()}),h.on("data",o=>{n||d.onData(o)}),(0,i.toDisposable)(()=>n=!0)}e.listenStream=p;function v(h,d){return new Promise((n,o)=>{const t=new i.DisposableStore,r=[],s=g=>{if(r.push(g),r.length>d)return t.dispose(),h.pause(),n({stream:h,buffer:r,ended:!1})},l=g=>o(g),a=()=>n({stream:h,buffer:r,ended:!0});t.add((0,i.toDisposable)(()=>h.removeListener("error",l))),h.on("error",l),t.add((0,i.toDisposable)(()=>h.removeListener("end",a))),h.on("end",a),t.add((0,i.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=v;function f(h,d){const n=I(d);return n.end(h),n}e.toStream=f;function m(){const h=I(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=m;function y(h){let d=!1;return{read:()=>d?null:(d=!0,h)}}e.toReadable=y;function u(h,d,n){const o=I(n);return p(h,{onData:t=>o.write(d.data(t)),onError:t=>o.error(d.error?d.error(t):t),onEnd:()=>o.end()}),o}e.transform=u;function S(h,d,n){let o=!1;return{read:()=>{const t=d.read();return o?t:(o=!0,t!==null?n([h,t]):h)}}}e.prefixedReadable=S;function c(h,d,n){let o=!1;const t=I(n);return p(d,{onData:r=>o?t.write(r):(o=!0,t.write(n([h,r]))),onError:r=>t.error(r),onEnd:()=>{o||(o=!0,t.write(h)),t.end()}}),t}e.prefixedStream=c}),define(se[17],oe([0,1,43]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer<"u";let R,k;class T{static alloc(g){return i?new T(Buffer.allocUnsafe(g)):new T(new Uint8Array(g))}static wrap(g){return i&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new T(g)}static fromString(g,C){return!(C?.dontUseNodeBuffer||!1)&&i?new T(Buffer.from(g)):(R||(R=new TextEncoder),new T(R.encode(g)))}static fromByteArray(g){const C=T.alloc(g.length);for(let A=0,V=g.length;A<V;A++)C.buffer[A]=g[A];return C}static concat(g,C){if(typeof C>"u"){C=0;for(let _=0,F=g.length;_<F;_++)C+=g[_].byteLength}const A=T.alloc(C);let V=0;for(let _=0,F=g.length;_<F;_++){const N=g[_];A.set(N,V),V+=N.byteLength}return A}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=T.alloc(this.byteLength);return g.set(this),g}toString(){return i?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(g,C){return new T(this.buffer.subarray(g,C))}set(g,C){if(g instanceof T)this.buffer.set(g.buffer,C);else if(g instanceof Uint8Array)this.buffer.set(g,C);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),C);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return w(this.buffer,g)}writeUInt32BE(g,C){b(this.buffer,g,C)}readUInt32LE(g){return E(this.buffer,g)}writeUInt32LE(g,C){p(this.buffer,g,C)}readUInt8(g){return v(this.buffer,g)}writeUInt8(g,C){f(this.buffer,g,C)}}e.VSBuffer=T;function I(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0}e.readUInt16LE=I;function P(a,g,C){a[C+0]=g&255,g=g>>>8,a[C+1]=g&255}e.writeUInt16LE=P;function w(a,g){return a[g]*2**24+a[g+1]*2**16+a[g+2]*2**8+a[g+3]}e.readUInt32BE=w;function b(a,g,C){a[C+3]=g,g=g>>>8,a[C+2]=g,g=g>>>8,a[C+1]=g,g=g>>>8,a[C]=g}e.writeUInt32BE=b;function E(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0|a[g+2]<<16>>>0|a[g+3]<<24>>>0}e.readUInt32LE=E;function p(a,g,C){a[C+0]=g&255,g=g>>>8,a[C+1]=g&255,g=g>>>8,a[C+2]=g&255,g=g>>>8,a[C+3]=g&255}e.writeUInt32LE=p;function v(a,g){return a[g]}e.readUInt8=v;function f(a,g,C){a[C]=g}e.writeUInt8=f;function m(a){return D.consumeReadable(a,g=>T.concat(g))}e.readableToBuffer=m;function y(a){return D.toReadable(a)}e.bufferToReadable=y;function u(a){return D.consumeStream(a,g=>T.concat(g))}e.streamToBuffer=u;async function S(a){return a.ended?T.concat(a.buffer):T.concat([...a.buffer,await u(a.stream)])}e.bufferedStreamToBuffer=S;function c(a){return D.toStream(a,g=>T.concat(g))}e.bufferToStream=c;function h(a){return D.transform(a,{data:g=>typeof g=="string"?T.fromString(g):T.wrap(g)},g=>T.concat(g))}e.streamToBufferReadableStream=h;function d(a){return D.newWriteableStream(g=>T.concat(g),a)}e.newWriteableBufferStream=d;function n(a,g){return D.prefixedReadable(a,g,C=>T.concat(C))}e.prefixedBufferReadable=n;function o(a,g){return D.prefixedStream(a,g,C=>T.concat(C))}e.prefixedBufferStream=o;function t(a){let g=0,C=0,A=0;const V=new Uint8Array(Math.floor(a.length/4*3)),_=N=>{switch(C){case 3:V[A++]=g|N,C=0;break;case 2:V[A++]=g|N>>>2,g=N<<6,C=3;break;case 1:V[A++]=g|N>>>4,g=N<<4,C=2;break;default:g=N<<2,C=1}};for(let N=0;N<a.length;N++){const L=a.charCodeAt(N);if(L>=65&&L<=90)_(L-65);else if(L>=97&&L<=122)_(L-97+26);else if(L>=48&&L<=57)_(L-48+52);else if(L===43||L===45)_(62);else if(L===47||L===95)_(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${a[N]}`)}}const F=A;for(;C>0;)_(0);return T.wrap(V).slice(0,F)}e.decodeBase64=t;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:a},g=!0,C=!1){const A=C?s:r;let V="";const _=a.byteLength%3;let F=0;for(;F<a.byteLength-_;F+=3){const N=a[F+0],L=a[F+1],U=a[F+2];V+=A[N>>>2],V+=A[(N<<4|L>>>4)&63],V+=A[(L<<2|U>>>6)&63],V+=A[U&63]}if(_===1){const N=a[F+0];V+=A[N>>>2],V+=A[N<<4&63],g&&(V+="==")}else if(_===2){const N=a[F+0],L=a[F+1];V+=A[N>>>2],V+=A[(N<<4|L>>>4)&63],V+=A[L<<2&63],g&&(V+="=")}return V}e.encodeBase64=l}),define(se[15],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(o){return typeof o=="string"}e.isString=D;function i(o){return Array.isArray(o)&&o.every(t=>D(t))}e.isStringArray=i;function R(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=R;function k(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}e.isTypedArray=k;function T(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=T;function I(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=I;function P(o){return o===!0||o===!1}e.isBoolean=P;function w(o){return typeof o>"u"}e.isUndefined=w;function b(o){return!E(o)}e.isDefined=b;function E(o){return w(o)||o===null}e.isUndefinedOrNull=E;function p(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=p;function v(o){if(E(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=v;function f(...o){const t=[];for(let r=0;r<o.length;r++){const s=o[r];if(E(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(s)}return t}e.assertAllDefined=f;const m=Object.prototype.hasOwnProperty;function y(o){if(!R(o))return!1;for(const t in o)if(m.call(o,t))return!1;return!0}e.isEmptyObject=y;function u(o){return typeof o=="function"}e.isFunction=u;function S(...o){return o.length>0&&o.every(u)}e.areFunctions=S;function c(o,t){const r=Math.min(o.length,t.length);for(let s=0;s<r;s++)h(o[s],t[s])}e.validateConstraints=c;function h(o,t){if(D(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(o instanceof t)return}catch{}if(!E(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function d(o){return o===null?void 0:o}e.withNullAsUndefined=d;function n(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=n}),define(se[32],oe([0,1,15]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const S=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([c,h])=>{S[c]=h&&typeof h=="object"?i(h):h}),S}e.deepClone=i;function R(u){if(!u||typeof u!="object")return u;const S=[u];for(;S.length>0;){const c=S.shift();Object.freeze(c);for(const h in c)if(k.call(c,h)){const d=c[h];typeof d=="object"&&!Object.isFrozen(d)&&!(0,D.isTypedArray)(d)&&S.push(d)}}return u}e.deepFreeze=R;const k=Object.prototype.hasOwnProperty;function T(u,S){return I(u,S,new Set)}e.cloneAndChange=T;function I(u,S,c){if((0,D.isUndefinedOrNull)(u))return u;const h=S(u);if(typeof h<"u")return h;if(Array.isArray(u)){const d=[];for(const n of u)d.push(I(n,S,c));return d}if((0,D.isObject)(u)){if(c.has(u))throw new Error("Cannot clone recursive data-structure");c.add(u);const d={};for(const n in u)k.call(u,n)&&(d[n]=I(u[n],S,c));return c.delete(u),d}return u}function P(u,S,c=!0){return(0,D.isObject)(u)?((0,D.isObject)(S)&&Object.keys(S).forEach(h=>{h in u?c&&((0,D.isObject)(u[h])&&(0,D.isObject)(S[h])?P(u[h],S[h],c):u[h]=S[h]):u[h]=S[h]}),u):S}e.mixin=P;function w(u,S){if(u===S)return!0;if(u==null||S===null||S===void 0||typeof u!=typeof S||typeof u!="object"||Array.isArray(u)!==Array.isArray(S))return!1;let c,h;if(Array.isArray(u)){if(u.length!==S.length)return!1;for(c=0;c<u.length;c++)if(!w(u[c],S[c]))return!1}else{const d=[];for(h in u)d.push(h);d.sort();const n=[];for(h in S)n.push(h);if(n.sort(),!w(d,n))return!1;for(c=0;c<d.length;c++)if(!w(u[d[c]],S[d[c]]))return!1}return!0}e.equals=w;function b(u){const S=new Set;return JSON.stringify(u,(c,h)=>{if((0,D.isObject)(h)||Array.isArray(h)){if(S.has(h))return"[Circular]";S.add(h)}return h})}e.safeStringify=b;function E(u,S){const c=Object.create(null);return!u||!S||Object.keys(S).forEach(d=>{const n=u[d],o=S[d];w(n,o)||(c[d]=o)}),c}e.distinct=E;function p(u,S){const c=S.toLowerCase(),h=Object.keys(u).find(d=>d.toLowerCase()===c);return h?u[h]:u[S]}e.getCaseInsensitive=p;function v(u,S){const c=Object.create(null);for(const[h,d]of Object.entries(u))S(h,d)&&(c[h]=d);return c}e.filter=v;function f(u){let S=[],c=Object.getPrototypeOf(u);for(;Object.prototype!==c;)S=S.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return S}e.getAllPropertyNames=f;function m(u){const S=[];for(const c of f(u))typeof u[c]=="function"&&S.push(c);return S}e.getAllMethodNames=m;function y(u,S){const c=d=>function(){const n=Array.prototype.slice.call(arguments,0);return S(d,n)},h={};for(const d of u)h[d]=c(d);return h}e.createProxyObject=y}),define(se[30],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(R){return D.test(R)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(I){for(let P=0;P<I.length;P++)I[P]=Math.floor(Math.random()*256);return I};const k=new Uint8Array(16),T=[];for(let I=0;I<256;I++)T.push(I.toString(16).padStart(2,"0"));return function(){R(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let P=0,w="";return w+=T[k[P++]],w+=T[k[P++]],w+=T[k[P++]],w+=T[k[P++]],w+="-",w+=T[k[P++]],w+=T[k[P++]],w+="-",w+=T[k[P++]],w+=T[k[P++]],w+="-",w+=T[k[P++]],w+=T[k[P++]],w+="-",w+=T[k[P++]],w+=T[k[P++]],w+=T[k[P++]],w+=T[k[P++]],w+=T[k[P++]],w+=T[k[P++]],w}}()}),define(se[130],oe([0,1,34]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(T){const I=T.replace(/\-/g,":").toLowerCase();return!i.has(I)}function k(){const T=(0,D.networkInterfaces)();for(const I in T){const P=T[I];if(P){for(const{mac:w}of P)if(R(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(se[131],oe([0,1,84]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(I,P,w,b=1){let E=!1;return new Promise(p=>{const v=setTimeout(()=>{if(!E)return E=!0,p(0)},w);R(I,P,b,f=>{if(!E)return E=!0,clearTimeout(v),p(f)})})}e.findFreePort=i;function R(I,P,w,b){if(P===0)return b(0);const E=new D.Socket;E.once("connect",()=>(T(E),R(I+w,P-1,w,b))),E.once("data",()=>{}),E.once("error",p=>(T(E),p.code!=="ECONNREFUSED"?R(I+w,P-1,w,b):b(I))),E.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(I,P,w,b="127.0.0.1"){let E=!1,p,v=1;const f=D.createServer({pauseOnConnect:!0});function m(y,u){E||(E=!0,f.removeAllListeners(),f.close(),p&&clearTimeout(p),u(y))}return new Promise(y=>{p=setTimeout(()=>{m(0,y)},w),f.on("listening",()=>{m(I,y)}),f.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&v<P?(I++,v++,f.listen(I,b)):m(0,y)}),f.on("close",()=>{m(0,y)}),f.listen(I,b)})}e.findFreePortFaster=k;function T(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(P){console.error(P)}}}),define(se[132],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function i(k){return k instanceof R?!0:k instanceof Error&&k.name===D&&k.message===D}e.isOfflineError=i;class R extends Error{constructor(){super(D),this.name=this.message}}e.OfflineError=R}),define(se[133],oe([0,1,17,11,132]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function k(P,w){if(!navigator.onLine)throw new R.OfflineError;P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((E,p)=>{b.open(P.type||"GET",P.url||"",!0,P.user,P.password),T(b,P),b.responseType="arraybuffer",b.onerror=v=>p(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=v=>{E({res:{statusCode:b.status,headers:I(b)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=v=>p(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(b.timeout=P.timeout),b.send(P.data),w.onCancellationRequested(()=>{b.abort(),p((0,i.canceled)())})})}e.request=k;function T(P,w){if(w.headers){e:for(const b in w.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(b,w.headers[b])}}}function I(P){const w=Object.create(null);for(const b of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const E=b.indexOf(":");w[b.substr(0,E).trim().toLowerCase()]=b.substr(E+1).trim()}return w}}),define(se[134],oe([9,10]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(se[65],oe([0,1,134]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,R=i*60,k=R*24,T=k*7,I=k*30,P=k*365;function w(E,p,v){typeof E!="number"&&(E=E.getTime());const f=Math.round((new Date().getTime()-E)/1e3);if(f<-30)return(0,D.localize)(0,null,w(new Date().getTime()+f*1e3,!1));if(f<30)return(0,D.localize)(1,null);let m;return f<i?(m=f,p?m===1?v?(0,D.localize)(2,null,m):(0,D.localize)(3,null,m):v?(0,D.localize)(4,null,m):(0,D.localize)(5,null,m):m===1?v?(0,D.localize)(6,null,m):(0,D.localize)(7,null,m):v?(0,D.localize)(8,null,m):(0,D.localize)(9,null,m)):f<R?(m=Math.floor(f/i),p?m===1?v?(0,D.localize)(10,null,m):(0,D.localize)(11,null,m):v?(0,D.localize)(12,null,m):(0,D.localize)(13,null,m):m===1?v?(0,D.localize)(14,null,m):(0,D.localize)(15,null,m):v?(0,D.localize)(16,null,m):(0,D.localize)(17,null,m)):f<k?(m=Math.floor(f/R),p?m===1?v?(0,D.localize)(18,null,m):(0,D.localize)(19,null,m):v?(0,D.localize)(20,null,m):(0,D.localize)(21,null,m):m===1?v?(0,D.localize)(22,null,m):(0,D.localize)(23,null,m):v?(0,D.localize)(24,null,m):(0,D.localize)(25,null,m)):f<T?(m=Math.floor(f/k),p?m===1?(0,D.localize)(26,null,m):(0,D.localize)(27,null,m):m===1?(0,D.localize)(28,null,m):(0,D.localize)(29,null,m)):f<I?(m=Math.floor(f/T),p?m===1?v?(0,D.localize)(30,null,m):(0,D.localize)(31,null,m):v?(0,D.localize)(32,null,m):(0,D.localize)(33,null,m):m===1?v?(0,D.localize)(34,null,m):(0,D.localize)(35,null,m):v?(0,D.localize)(36,null,m):(0,D.localize)(37,null,m)):f<P?(m=Math.floor(f/I),p?m===1?v?(0,D.localize)(38,null,m):(0,D.localize)(39,null,m):v?(0,D.localize)(40,null,m):(0,D.localize)(41,null,m):m===1?v?(0,D.localize)(42,null,m):(0,D.localize)(43,null,m):v?(0,D.localize)(44,null,m):(0,D.localize)(45,null,m)):(m=Math.floor(f/P),p?m===1?v?(0,D.localize)(46,null,m):(0,D.localize)(47,null,m):v?(0,D.localize)(48,null,m):(0,D.localize)(49,null,m):m===1?v?(0,D.localize)(50,null,m):(0,D.localize)(51,null,m):v?(0,D.localize)(52,null,m):(0,D.localize)(53,null,m))}e.fromNow=w;function b(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(se[135],oe([9,10]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(se[38],oe([0,1,19,15,135]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function k(E,p){return p&&(E.stack||E.stacktrace)?R.localize(0,null,I(E),T(E.stack)||T(E.stacktrace)):I(E)}function T(E){return Array.isArray(E)?E.join(`
`):E}function I(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?R.localize(1,null,E.message):E.message||R.localize(2,null)}function P(E=null,p=!1){if(!E)return R.localize(3,null);if(Array.isArray(E)){const v=D.coalesce(E),f=P(v[0],p);return v.length>1?R.localize(4,null,f,v.length):f}if(i.isString(E))return E;if(E.detail){const v=E.detail;if(v.error)return k(v.error,p);if(v.exception)return k(v.exception,p)}return E.stack?k(E,p):E.message?E.message:R.localize(5,null)}e.toErrorMessage=P;function w(E){const p=E;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=w;function b(E,p){let v;return typeof E=="string"?v=new Error(E):v=E,v.actions=p,v}e.createErrorWithActions=b}),define(se[136],oe([9,10]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(se[137],oe([0,1,136]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function i(R){switch(R){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=i}),define(se[138],oe([9,10]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(se[5],oe([0,1,138]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let i=!1,R=!1,k=!1,T=!1,I=!1,P=!1,w=!1,b=!1,E=!1,p=!1,v,f=e.LANGUAGE_DEFAULT,m,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const S=typeof u?.versions?.electron=="string",c=S&&u?.type==="renderer";if(typeof navigator=="object"&&!c)y=navigator.userAgent,i=y.indexOf("Windows")>=0,R=y.indexOf("Macintosh")>=0,b=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=y.indexOf("Linux")>=0,p=y?.indexOf("Mobi")>=0,P=!0,v=D.getConfiguredDefaultLocale(D.localize(0,null))||e.LANGUAGE_DEFAULT,f=v;else if(typeof u=="object"){i=u.platform==="win32",R=u.platform==="darwin",k=u.platform==="linux",T=k&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,w=S,E=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const a=u.env.VSCODE_NLS_CONFIG;if(a)try{const g=JSON.parse(a),C=g.availableLanguages["*"];v=g.locale,f=C||e.LANGUAGE_DEFAULT,m=g._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var h;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function d(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=d;let n=0;R?n=1:i?n=3:k&&(n=2),e.isWindows=i,e.isMacintosh=R,e.isLinux=k,e.isLinuxSnap=T,e.isNative=I,e.isElectron=w,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=p,e.isCI=E,e.platform=n,e.userAgent=y,e.language=f;var o;(function(a){function g(){return e.language}a.value=g;function C(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=C;function A(){return e.language==="en"}a.isDefault=A})(o=e.Language||(e.Language={})),e.locale=v,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let A=0,V=a.length;A<V;A++){const _=a[A];if(_.id===C.data.vscodeScheduleAsyncWork){a.splice(A,1),_.callback();return}}});let g=0;return C=>{const A=++g;a.push({id:A,callback:C}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return a=>setTimeout(a)})();var t;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||b?2:i?1:3;let r=!0,s=!1;function l(){if(!s){s=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,r=new Uint16Array(a.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(se[36],oe([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const R=D.globals.vscode.process;i={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(se[12],oe([0,1,36]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,R=97,k=90,T=122,I=46,P=47,w=92,b=58,E=63;class p extends Error{constructor(h,d,n){let o;typeof d=="string"&&d.indexOf("not ")===0?(o="must not be",d=d.replace(/^not /,"")):o="must be";const t=h.indexOf(".")!==-1?"property":"argument";let r=`The "${h}" ${t} ${o} of type ${d}`;r+=`. Received type ${typeof n}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function v(c,h){if(typeof c!="string")throw new p(h,"string",c)}function f(c){return c===P||c===w}function m(c){return c===P}function y(c){return c>=i&&c<=k||c>=R&&c<=T}function u(c,h,d,n){let o="",t=0,r=-1,s=0,l=0;for(let a=0;a<=c.length;++a){if(a<c.length)l=c.charCodeAt(a);else{if(n(l))break;l=P}if(n(l)){if(!(r===a-1||s===1))if(s===2){if(o.length<2||t!==2||o.charCodeAt(o.length-1)!==I||o.charCodeAt(o.length-2)!==I){if(o.length>2){const g=o.lastIndexOf(d);g===-1?(o="",t=0):(o=o.slice(0,g),t=o.length-1-o.lastIndexOf(d)),r=a,s=0;continue}else if(o.length!==0){o="",t=0,r=a,s=0;continue}}h&&(o+=o.length>0?`${d}..`:"..",t=2)}else o.length>0?o+=`${d}${c.slice(r+1,a)}`:o=c.slice(r+1,a),t=a-r-1;r=a,s=0}else l===I&&s!==-1?++s:s=-1}return o}function S(c,h){if(h===null||typeof h!="object")throw new p("pathObject","Object",h);const d=h.dir||h.root,n=h.base||`${h.name||""}${h.ext||""}`;return d?d===h.root?`${d}${n}`:`${d}${c}${n}`:n}e.win32={resolve(...c){let h="",d="",n=!1;for(let o=c.length-1;o>=-1;o--){let t;if(o>=0){if(t=c[o],v(t,"path"),t.length===0)continue}else h.length===0?t=D.cwd():(t=D.env[`=${h}`]||D.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==h.toLowerCase()&&t.charCodeAt(2)===w)&&(t=`${h}\\`));const r=t.length;let s=0,l="",a=!1;const g=t.charCodeAt(0);if(r===1)f(g)&&(s=1,a=!0);else if(f(g))if(a=!0,f(t.charCodeAt(1))){let C=2,A=C;for(;C<r&&!f(t.charCodeAt(C));)C++;if(C<r&&C!==A){const V=t.slice(A,C);for(A=C;C<r&&f(t.charCodeAt(C));)C++;if(C<r&&C!==A){for(A=C;C<r&&!f(t.charCodeAt(C));)C++;(C===r||C!==A)&&(l=`\\\\${V}\\${t.slice(A,C)}`,s=C)}}}else s=1;else y(g)&&t.charCodeAt(1)===b&&(l=t.slice(0,2),s=2,r>2&&f(t.charCodeAt(2))&&(a=!0,s=3));if(l.length>0)if(h.length>0){if(l.toLowerCase()!==h.toLowerCase())continue}else h=l;if(n){if(h.length>0)break}else if(d=`${t.slice(s)}\\${d}`,n=a,a&&h.length>0)break}return d=u(d,!n,"\\",f),n?`${h}\\${d}`:`${h}${d}`||"."},normalize(c){v(c,"path");const h=c.length;if(h===0)return".";let d=0,n,o=!1;const t=c.charCodeAt(0);if(h===1)return m(t)?"\\":c;if(f(t))if(o=!0,f(c.charCodeAt(1))){let s=2,l=s;for(;s<h&&!f(c.charCodeAt(s));)s++;if(s<h&&s!==l){const a=c.slice(l,s);for(l=s;s<h&&f(c.charCodeAt(s));)s++;if(s<h&&s!==l){for(l=s;s<h&&!f(c.charCodeAt(s));)s++;if(s===h)return`\\\\${a}\\${c.slice(l)}\\`;s!==l&&(n=`\\\\${a}\\${c.slice(l,s)}`,d=s)}}}else d=1;else y(t)&&c.charCodeAt(1)===b&&(n=c.slice(0,2),d=2,h>2&&f(c.charCodeAt(2))&&(o=!0,d=3));let r=d<h?u(c.slice(d),!o,"\\",f):"";return r.length===0&&!o&&(r="."),r.length>0&&f(c.charCodeAt(h-1))&&(r+="\\"),n===void 0?o?`\\${r}`:r:o?`${n}\\${r}`:`${n}${r}`},isAbsolute(c){v(c,"path");const h=c.length;if(h===0)return!1;const d=c.charCodeAt(0);return f(d)||h>2&&y(d)&&c.charCodeAt(1)===b&&f(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let h,d;for(let t=0;t<c.length;++t){const r=c[t];v(r,"path"),r.length>0&&(h===void 0?h=d=r:h+=`\\${r}`)}if(h===void 0)return".";let n=!0,o=0;if(typeof d=="string"&&f(d.charCodeAt(0))){++o;const t=d.length;t>1&&f(d.charCodeAt(1))&&(++o,t>2&&(f(d.charCodeAt(2))?++o:n=!1))}if(n){for(;o<h.length&&f(h.charCodeAt(o));)o++;o>=2&&(h=`\\${h.slice(o)}`)}return e.win32.normalize(h)},relative(c,h){if(v(c,"from"),v(h,"to"),c===h)return"";const d=e.win32.resolve(c),n=e.win32.resolve(h);if(d===n||(c=d.toLowerCase(),h=n.toLowerCase(),c===h))return"";let o=0;for(;o<c.length&&c.charCodeAt(o)===w;)o++;let t=c.length;for(;t-1>o&&c.charCodeAt(t-1)===w;)t--;const r=t-o;let s=0;for(;s<h.length&&h.charCodeAt(s)===w;)s++;let l=h.length;for(;l-1>s&&h.charCodeAt(l-1)===w;)l--;const a=l-s,g=r<a?r:a;let C=-1,A=0;for(;A<g;A++){const _=c.charCodeAt(o+A);if(_!==h.charCodeAt(s+A))break;_===w&&(C=A)}if(A!==g){if(C===-1)return n}else{if(a>g){if(h.charCodeAt(s+A)===w)return n.slice(s+A+1);if(A===2)return n.slice(s+A)}r>g&&(c.charCodeAt(o+A)===w?C=A:A===2&&(C=3)),C===-1&&(C=0)}let V="";for(A=o+C+1;A<=t;++A)(A===t||c.charCodeAt(A)===w)&&(V+=V.length===0?"..":"\\..");return s+=C,V.length>0?`${V}${n.slice(s,l)}`:(n.charCodeAt(s)===w&&++s,n.slice(s,l))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const h=e.win32.resolve(c);if(h.length<=2)return c;if(h.charCodeAt(0)===w){if(h.charCodeAt(1)===w){const d=h.charCodeAt(2);if(d!==E&&d!==I)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(y(h.charCodeAt(0))&&h.charCodeAt(1)===b&&h.charCodeAt(2)===w)return`\\\\?\\${h}`;return c},dirname(c){v(c,"path");const h=c.length;if(h===0)return".";let d=-1,n=0;const o=c.charCodeAt(0);if(h===1)return f(o)?c:".";if(f(o)){if(d=n=1,f(c.charCodeAt(1))){let s=2,l=s;for(;s<h&&!f(c.charCodeAt(s));)s++;if(s<h&&s!==l){for(l=s;s<h&&f(c.charCodeAt(s));)s++;if(s<h&&s!==l){for(l=s;s<h&&!f(c.charCodeAt(s));)s++;if(s===h)return c;s!==l&&(d=n=s+1)}}}}else y(o)&&c.charCodeAt(1)===b&&(d=h>2&&f(c.charCodeAt(2))?3:2,n=d);let t=-1,r=!0;for(let s=h-1;s>=n;--s)if(f(c.charCodeAt(s))){if(!r){t=s;break}}else r=!1;if(t===-1){if(d===-1)return".";t=d}return c.slice(0,t)},basename(c,h){h!==void 0&&v(h,"ext"),v(c,"path");let d=0,n=-1,o=!0,t;if(c.length>=2&&y(c.charCodeAt(0))&&c.charCodeAt(1)===b&&(d=2),h!==void 0&&h.length>0&&h.length<=c.length){if(h===c)return"";let r=h.length-1,s=-1;for(t=c.length-1;t>=d;--t){const l=c.charCodeAt(t);if(f(l)){if(!o){d=t+1;break}}else s===-1&&(o=!1,s=t+1),r>=0&&(l===h.charCodeAt(r)?--r===-1&&(n=t):(r=-1,n=s))}return d===n?n=s:n===-1&&(n=c.length),c.slice(d,n)}for(t=c.length-1;t>=d;--t)if(f(c.charCodeAt(t))){if(!o){d=t+1;break}}else n===-1&&(o=!1,n=t+1);return n===-1?"":c.slice(d,n)},extname(c){v(c,"path");let h=0,d=-1,n=0,o=-1,t=!0,r=0;c.length>=2&&c.charCodeAt(1)===b&&y(c.charCodeAt(0))&&(h=n=2);for(let s=c.length-1;s>=h;--s){const l=c.charCodeAt(s);if(f(l)){if(!t){n=s+1;break}continue}o===-1&&(t=!1,o=s+1),l===I?d===-1?d=s:r!==1&&(r=1):d!==-1&&(r=-1)}return d===-1||o===-1||r===0||r===1&&d===o-1&&d===n+1?"":c.slice(d,o)},format:S.bind(null,"\\"),parse(c){v(c,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return h;const d=c.length;let n=0,o=c.charCodeAt(0);if(d===1)return f(o)?(h.root=h.dir=c,h):(h.base=h.name=c,h);if(f(o)){if(n=1,f(c.charCodeAt(1))){let C=2,A=C;for(;C<d&&!f(c.charCodeAt(C));)C++;if(C<d&&C!==A){for(A=C;C<d&&f(c.charCodeAt(C));)C++;if(C<d&&C!==A){for(A=C;C<d&&!f(c.charCodeAt(C));)C++;C===d?n=C:C!==A&&(n=C+1)}}}}else if(y(o)&&c.charCodeAt(1)===b){if(d<=2)return h.root=h.dir=c,h;if(n=2,f(c.charCodeAt(2))){if(d===3)return h.root=h.dir=c,h;n=3}}n>0&&(h.root=c.slice(0,n));let t=-1,r=n,s=-1,l=!0,a=c.length-1,g=0;for(;a>=n;--a){if(o=c.charCodeAt(a),f(o)){if(!l){r=a+1;break}continue}s===-1&&(l=!1,s=a+1),o===I?t===-1?t=a:g!==1&&(g=1):t!==-1&&(g=-1)}return s!==-1&&(t===-1||g===0||g===1&&t===s-1&&t===r+1?h.base=h.name=c.slice(r,s):(h.name=c.slice(r,t),h.base=c.slice(r,s),h.ext=c.slice(t,s))),r>0&&r!==n?h.dir=c.slice(0,r-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let h="",d=!1;for(let n=c.length-1;n>=-1&&!d;n--){const o=n>=0?c[n]:D.cwd();v(o,"path"),o.length!==0&&(h=`${o}/${h}`,d=o.charCodeAt(0)===P)}return h=u(h,!d,"/",m),d?`/${h}`:h.length>0?h:"."},normalize(c){if(v(c,"path"),c.length===0)return".";const h=c.charCodeAt(0)===P,d=c.charCodeAt(c.length-1)===P;return c=u(c,!h,"/",m),c.length===0?h?"/":d?"./":".":(d&&(c+="/"),h?`/${c}`:c)},isAbsolute(c){return v(c,"path"),c.length>0&&c.charCodeAt(0)===P},join(...c){if(c.length===0)return".";let h;for(let d=0;d<c.length;++d){const n=c[d];v(n,"path"),n.length>0&&(h===void 0?h=n:h+=`/${n}`)}return h===void 0?".":e.posix.normalize(h)},relative(c,h){if(v(c,"from"),v(h,"to"),c===h||(c=e.posix.resolve(c),h=e.posix.resolve(h),c===h))return"";const d=1,n=c.length,o=n-d,t=1,r=h.length-t,s=o<r?o:r;let l=-1,a=0;for(;a<s;a++){const C=c.charCodeAt(d+a);if(C!==h.charCodeAt(t+a))break;C===P&&(l=a)}if(a===s)if(r>s){if(h.charCodeAt(t+a)===P)return h.slice(t+a+1);if(a===0)return h.slice(t+a)}else o>s&&(c.charCodeAt(d+a)===P?l=a:a===0&&(l=0));let g="";for(a=d+l+1;a<=n;++a)(a===n||c.charCodeAt(a)===P)&&(g+=g.length===0?"..":"/..");return`${g}${h.slice(t+l)}`},toNamespacedPath(c){return c},dirname(c){if(v(c,"path"),c.length===0)return".";const h=c.charCodeAt(0)===P;let d=-1,n=!0;for(let o=c.length-1;o>=1;--o)if(c.charCodeAt(o)===P){if(!n){d=o;break}}else n=!1;return d===-1?h?"/":".":h&&d===1?"//":c.slice(0,d)},basename(c,h){h!==void 0&&v(h,"ext"),v(c,"path");let d=0,n=-1,o=!0,t;if(h!==void 0&&h.length>0&&h.length<=c.length){if(h===c)return"";let r=h.length-1,s=-1;for(t=c.length-1;t>=0;--t){const l=c.charCodeAt(t);if(l===P){if(!o){d=t+1;break}}else s===-1&&(o=!1,s=t+1),r>=0&&(l===h.charCodeAt(r)?--r===-1&&(n=t):(r=-1,n=s))}return d===n?n=s:n===-1&&(n=c.length),c.slice(d,n)}for(t=c.length-1;t>=0;--t)if(c.charCodeAt(t)===P){if(!o){d=t+1;break}}else n===-1&&(o=!1,n=t+1);return n===-1?"":c.slice(d,n)},extname(c){v(c,"path");let h=-1,d=0,n=-1,o=!0,t=0;for(let r=c.length-1;r>=0;--r){const s=c.charCodeAt(r);if(s===P){if(!o){d=r+1;break}continue}n===-1&&(o=!1,n=r+1),s===I?h===-1?h=r:t!==1&&(t=1):h!==-1&&(t=-1)}return h===-1||n===-1||t===0||t===1&&h===n-1&&h===d+1?"":c.slice(h,n)},format:S.bind(null,"/"),parse(c){v(c,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return h;const d=c.charCodeAt(0)===P;let n;d?(h.root="/",n=1):n=0;let o=-1,t=0,r=-1,s=!0,l=c.length-1,a=0;for(;l>=n;--l){const g=c.charCodeAt(l);if(g===P){if(!s){t=l+1;break}continue}r===-1&&(s=!1,r=l+1),g===I?o===-1?o=l:a!==1&&(a=1):o!==-1&&(a=-1)}if(r!==-1){const g=t===0&&d?1:t;o===-1||a===0||a===1&&o===r-1&&o===t+1?h.base=h.name=c.slice(g,r):(h.name=c.slice(g,o),h.base=c.slice(g,r),h.ext=c.slice(o,r))}return t>0?h.dir=c.slice(0,t-1):d&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(se[139],oe([0,1,12]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(b){const E=(0,D.extname)(b),p=i[E.toLowerCase()];return p!==void 0?p:T(b)}e.getMediaOrTextMime=k;function T(b){const E=(0,D.extname)(b);return R[E.toLowerCase()]}e.getMediaMime=T;function I(b){for(const E in R)if(R[E]===b)return E}e.getExtensionForMimeType=I;const P=/^(.+)\/(.+?)(;.+)?$/;function w(b,E){const p=P.exec(b);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:E?void 0:b}e.normalizeMimeType=w}),define(se[85],oe([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(i=e.Source||(e.Source={}));var R;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(I,...P){const w=P.reduce((p,v)=>(p[v]=!0,p),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(p=>!w[p]).forEach(p=>{for(let v=0;v<b.length;v++)if(p.search(b[v])!==-1){delete I[p];break}})}e.sanitizeProcessEnvironment=k;function T(I){!I||(delete I.DEBUG,D.isMacintosh&&delete I.DYLD_LIBRARY_PATH,D.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(se[140],oe([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=D.globals.performance&&typeof D.globals.performance.now=="function";class R{static create(T=!0){return new R(T)}constructor(T){this._highResolution=i&&T,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(se[3],oe([0,1,11,80,2,82,140]),function(Z,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,P=!1;var w;(function(l){l.None=()=>R.Disposable.None;function a(z){if(P){const{onDidAddListener:Y}=z,ne=f.create();let X=0;z.onDidAddListener=()=>{++X===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ne.print()),Y?.()}}}function g(z,Y){return H(z,()=>{},0,void 0,void 0,Y)}l.defer=g;function C(z,Y=0,ne){return l.debounce(z,(X,te)=>X?(X.push(te),X):[te],Y,void 0,void 0,ne)}l.accumulate=C;function A(z){return(Y,ne=null,X)=>{let te=!1,re;return re=z(le=>{if(!te)return re?re.dispose():te=!0,Y.call(ne,le)},null,X),te&&re.dispose(),re}}l.once=A;function V(z,Y,ne){return $((X,te=null,re)=>z(le=>X.call(te,Y(le)),null,re),ne)}l.map=V;function _(z,Y,ne){return $((X,te=null,re)=>z(le=>{Y(le),X.call(te,le)},null,re),ne)}l.forEach=_;function F(z,Y,ne){return $((X,te=null,re)=>z(le=>Y(le)&&X.call(te,le),null,re),ne)}l.filter=F;function N(z){return z}l.signal=N;function L(...z){return(Y,ne=null,X)=>(0,R.combinedDisposable)(...z.map(te=>te(re=>Y.call(ne,re),null,X)))}l.any=L;function U(z,Y,ne,X){let te=ne;return V(z,re=>(te=Y(te,re),te),X)}l.reduce=U;function $(z,Y){let ne;const X={onWillAddFirstListener(){ne=z(te.fire,te)},onDidRemoveLastListener(){ne?.dispose()}};Y||a(X);const te=new y(X);return Y?.add(te),te.event}function H(z,Y,ne=100,X=!1,te,re){let le,ue,Se,we=0;const Ee={leakWarningThreshold:te,onWillAddFirstListener(){le=z(Ae=>{we++,ue=Y(ue,Ae),X&&!Se&&(Ce.fire(ue),ue=void 0),clearTimeout(Se),Se=setTimeout(()=>{const Ne=ue;ue=void 0,Se=void 0,(!X||we>1)&&Ce.fire(Ne),we=0},ne)})},onDidRemoveLastListener(){le.dispose()}};re||a(Ee);const Ce=new y(Ee);return re?.add(Ce),Ce.event}l.debounce=H;function q(z,Y=(X,te)=>X===te,ne){let X=!0,te;return F(z,re=>{const le=X||!Y(re,te);return X=!1,te=re,le},ne)}l.latch=q;function x(z,Y,ne){return[l.filter(z,Y,ne),l.filter(z,X=>!Y(X),ne)]}l.split=x;function W(z,Y=!1,ne=[]){let X=ne.slice(),te=z(ue=>{X?X.push(ue):le.fire(ue)});const re=()=>{X?.forEach(ue=>le.fire(ue)),X=null},le=new y({onWillAddFirstListener(){te||(te=z(ue=>le.fire(ue)))},onDidAddFirstListener(){X&&(Y?setTimeout(re):re())},onDidRemoveLastListener(){te&&te.dispose(),te=null}});return le.event}l.buffer=W;class j{constructor(Y){this.event=Y,this.disposables=new R.DisposableStore}map(Y){return new j(V(this.event,Y,this.disposables))}forEach(Y){return new j(_(this.event,Y,this.disposables))}filter(Y){return new j(F(this.event,Y,this.disposables))}reduce(Y,ne){return new j(U(this.event,Y,ne,this.disposables))}latch(){return new j(q(this.event,void 0,this.disposables))}debounce(Y,ne=100,X=!1,te){return new j(H(this.event,Y,ne,X,te,this.disposables))}on(Y,ne,X){return this.event(Y,ne,X)}once(Y,ne,X){return A(this.event)(Y,ne,X)}dispose(){this.disposables.dispose()}}function K(z){return new j(z)}l.chain=K;function ee(z,Y,ne=X=>X){const X=(...ue)=>le.fire(ne(...ue)),te=()=>z.on(Y,X),re=()=>z.removeListener(Y,X),le=new y({onWillAddFirstListener:te,onDidRemoveLastListener:re});return le.event}l.fromNodeEventEmitter=ee;function ce(z,Y,ne=X=>X){const X=(...ue)=>le.fire(ne(...ue)),te=()=>z.addEventListener(Y,X),re=()=>z.removeEventListener(Y,X),le=new y({onWillAddFirstListener:te,onDidRemoveLastListener:re});return le.event}l.fromDOMEventEmitter=ce;function J(z){return new Promise(Y=>A(z)(Y))}l.toPromise=J;function Q(z,Y){return Y(void 0),z(ne=>Y(ne))}l.runAndSubscribe=Q;function M(z,Y){let ne=null;function X(re){ne?.dispose(),ne=new R.DisposableStore,Y(re,ne)}X(void 0);const te=z(re=>X(re));return(0,R.toDisposable)(()=>{te.dispose(),ne?.dispose()})}l.runAndSubscribeWithStore=M;class O{constructor(Y,ne){this.obs=Y,this._counter=0,this._hasChanged=!1;const X={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};ne||a(X),this.emitter=new y(X),ne&&ne.add(this.emitter)}beginUpdate(Y){this._counter++}handleChange(Y,ne){this._hasChanged=!0}endUpdate(Y){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function B(z,Y){return new O(z,Y).emitter.event}l.fromObservable=B})(w=e.Event||(e.Event={}));class b{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${b._idPool++}`,b.all.add(this)}start(a){this._stopWatch=new T.StopWatch(!0),this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=b,b.all=new Set,b._idPool=0;let E=-1;function p(l){const a=E;return E=l,{dispose(){E=a}}}e.setGlobalLeakWarningThreshold=p;class v{constructor(a,g=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=g,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(a,g){const C=this.threshold;if(C<=0||g<C)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=C*.5;let V,_=0;for(const[F,N]of this._stacks)(!V||_<N)&&(V=F,_=N);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${_}):`),console.warn(V)}return()=>{const V=this._stacks.get(a.value)||0;this._stacks.set(a.value,V-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m{constructor(a,g,C){this.callback=a,this.callbackThis=g,this.stack=C,this.subscription=new R.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class y{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=E>0||this._options?.leakWarningThreshold?new v(this._options?.leakWarningThreshold??E):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const g of a)g.subscription.isset()&&(g.subscription.unset(),g.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,g,C)=>{if(this._listeners||(this._listeners=new k.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),R.Disposable.None;const A=this._listeners.isEmpty();A&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let V,_;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(_=f.create(),V=this._leakageMon.check(_,this._listeners.size+1)),I&&(_=_??f.create());const F=new m(a,g,_),N=this._listeners.push(F);A&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,a,g);const L=F.subscription.set(()=>{V?.(),this._disposed||(N(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return C instanceof R.DisposableStore?C.add(L):Array.isArray(C)&&C.push(L),L}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S);for(const g of this._listeners)this._deliveryQueue.push(this,g,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=y;class u{constructor(){this._queue=new k.LinkedList}get size(){return this._queue.size}push(a,g,C){this._queue.push(new c(a,g,C))}clear(a){const g=new k.LinkedList;for(const C of this._queue)C.emitter!==a&&g.push(C);this._queue=g}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(g){(0,D.onUnexpectedError)(g)}}}}e.EventDeliveryQueue=u;class S extends u{clear(a){this._queue.clear()}}class c{constructor(a,g,C){this.emitter=a,this.listener=g,this.event=C}}class h extends y{async fireAsync(a,g,C){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const A of this._listeners)this._asyncDeliveryQueue.push([A,a]);for(;this._asyncDeliveryQueue.size>0&&!g.isCancellationRequested;){const[A,V]=this._asyncDeliveryQueue.shift(),_=[],F={...V,token:g,waitUntil:N=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");C&&(N=C(N,A.callback)),_.push(N)}};try{A.invoke(F)}catch(N){(0,D.onUnexpectedError)(N);continue}Object.freeze(_),await Promise.allSettled(_).then(N=>{for(const L of N)L.status==="rejected"&&(0,D.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=h;class d extends y{constructor(a){super(a),this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=d;class n extends d{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=n;class o extends y{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){!this.hasListeners()||(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(g=>super.fire(g)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const g={event:a,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const C=()=>{this.hasListeners&&this.unhook(g);const A=this.events.indexOf(g);this.events.splice(A,1)};return(0,R.toDisposable)((0,i.once)(C))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(g=>this.emitter.fire(g))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class r{constructor(){this.buffers=[]}wrapEvent(a){return(g,C,A)=>a(V=>{const _=this.buffers[this.buffers.length-1];_?_.push(()=>g.call(C,V)):g.call(C,V)},void 0,A)}bufferEvents(a){const g=[];this.buffers.push(g);const C=a();return this.buffers.pop(),g.forEach(A=>A()),C}}e.EventBufferer=r;class s{constructor(){this.listening=!1,this.inputEvent=w.None,this.inputEventListener=R.Disposable.None,this.emitter=new y({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(se[22],oe([0,1,3]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(I,P){const w=setTimeout(I.bind(P),0);return{dispose(){clearTimeout(w)}}});var R;(function(I){function P(w){return w===I.None||w===I.Cancelled||w instanceof k?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}I.isCancellationToken=P,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(R=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(P){this._token=void 0,this._parentListener=void 0,this._parentListener=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=R.Cancelled}dispose(P=!1){P&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=T}),define(se[141],oe([0,1,22]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new D.CancellationTokenSource,P=this.task(I.token);return this.result={promise:P,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=i;class R{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const P=JSON.stringify(I);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=R;class k{get cachedValues(){return this._map}constructor(I){this.fn=I,this._map=new Map}get(I){if(this._map.has(I))return this._map.get(I);const P=this.fn(I);return this._map.set(I,P),P}}e.CachedFunction=k}),define(se[86],oe([0,1,3,2]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const R=T=>({onDidChange:D.Event.None,value:T});e.staticObservableValue=R;class k extends i.Disposable{get value(){return this._value}set value(I){I!==this._value&&(this._value=I,this.changeEmitter.fire(I))}constructor(I){super(),this._value=I,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=k}),define(se[27],oe([0,1,141,128]),function(Z,e,D,i){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function k(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=k;const T=/{(\d+)}/g;function I(ie,...he){return he.length===0?ie:ie.replace(T,function(de,me){const pe=parseInt(me,10);return isNaN(pe)||pe<0||pe>=he.length?de:he[pe]})}e.format=I;const P=/{([^}]+)}/g;function w(ie,he){return ie.replace(P,(de,me)=>he[me]??de)}e.format2=w;function b(ie){return ie.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=b;function E(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function p(ie,he){let de=0;const me=he.charCodeAt(0);for(let pe=ie.length-1;pe>=0;pe--)ie.charCodeAt(pe)===me&&de++;return de}e.count=p;function v(ie,he,de="\u2026"){return ie.length<=he?ie:`${ie.substr(0,he)}${de}`}e.truncate=v;function f(ie,he=" "){const de=m(ie,he);return y(de,he)}e.trim=f;function m(ie,he){if(!ie||!he)return ie;const de=he.length;if(de===0||ie.length===0)return ie;let me=0;for(;ie.indexOf(he,me)===me;)me=me+de;return ie.substring(me)}e.ltrim=m;function y(ie,he){if(!ie||!he)return ie;const de=he.length,me=ie.length;if(de===0||me===0)return ie;let pe=me,Pe=-1;for(;Pe=ie.lastIndexOf(he,pe-1),!(Pe===-1||Pe+de!==pe);){if(Pe===0)return"";pe=Pe}return ie.substring(0,pe)}e.rtrim=y;function u(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function S(ie){return ie.replace(/\*/g,"")}e.stripWildcards=S;function c(ie,he,de={}){if(!ie)throw new Error("Cannot create regex from empty string");he||(ie=E(ie)),de.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let me="";return de.global&&(me+="g"),de.matchCase||(me+="i"),de.multiline&&(me+="m"),de.unicode&&(me+="u"),new RegExp(ie,me)}e.createRegExp=c;function h(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function d(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=d;function n(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=n;function o(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=o;function t(ie){for(let he=0,de=ie.length;he<de;he++){const me=ie.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function r(ie,he=0,de=ie.length){for(let me=he;me<de;me++){const pe=ie.charCodeAt(me);if(pe!==32&&pe!==9)return ie.substring(he,me)}return ie.substring(he,de)}e.getLeadingWhitespace=r;function s(ie,he=ie.length-1){for(let de=he;de>=0;de--){const me=ie.charCodeAt(de);if(me!==32&&me!==9)return de}return-1}e.lastNonWhitespaceIndex=s;function l(ie,he,de){const me=[];let pe=0;for(const Pe of ie.matchAll(he)){if(me.push(ie.slice(pe,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");pe=Pe.index+Pe[0].length,me.push(de(Pe[0],...Pe.slice(1),Pe.index,ie,Pe.groups))}return me.push(ie.slice(pe)),Promise.all(me).then(Pe=>Pe.join(""))}e.replaceAsync=l;function a(ie,he){return ie<he?-1:ie>he?1:0}e.compare=a;function g(ie,he,de=0,me=ie.length,pe=0,Pe=he.length){for(;de<me&&pe<Pe;de++,pe++){const $e=ie.charCodeAt(de),Te=he.charCodeAt(pe);if($e<Te)return-1;if($e>Te)return 1}const De=me-de,Be=Pe-pe;return De<Be?-1:De>Be?1:0}e.compareSubstring=g;function C(ie,he){return A(ie,he,0,ie.length,0,he.length)}e.compareIgnoreCase=C;function A(ie,he,de=0,me=ie.length,pe=0,Pe=he.length){for(;de<me&&pe<Pe;de++,pe++){let $e=ie.charCodeAt(de),Te=he.charCodeAt(pe);if($e===Te)continue;if($e>=128||Te>=128)return g(ie.toLowerCase(),he.toLowerCase(),de,me,pe,Pe);_($e)&&($e-=32),_(Te)&&(Te-=32);const je=$e-Te;if(je!==0)return je}const De=me-de,Be=Pe-pe;return De<Be?-1:De>Be?1:0}e.compareSubstringIgnoreCase=A;function V(ie){return ie>=48&&ie<=57}e.isAsciiDigit=V;function _(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=_;function F(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=F;function N(ie,he){return ie.length===he.length&&A(ie,he)===0}e.equalsIgnoreCase=N;function L(ie,he){const de=he.length;return he.length>ie.length?!1:A(ie,he,0,de)===0}e.startsWithIgnoreCase=L;function U(ie,he){const de=Math.min(ie.length,he.length);let me;for(me=0;me<de;me++)if(ie.charCodeAt(me)!==he.charCodeAt(me))return me;return de}e.commonPrefixLength=U;function $(ie,he){const de=Math.min(ie.length,he.length);let me;const pe=ie.length-1,Pe=he.length-1;for(me=0;me<de;me++)if(ie.charCodeAt(pe-me)!==he.charCodeAt(Pe-me))return me;return de}e.commonSuffixLength=$;function H(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=H;function q(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=q;function x(ie,he){return(ie-55296<<10)+(he-56320)+65536}e.computeCodePoint=x;function W(ie,he,de){const me=ie.charCodeAt(de);if(H(me)&&de+1<he){const pe=ie.charCodeAt(de+1);if(q(pe))return x(me,pe)}return me}e.getNextCodePoint=W;function j(ie,he){const de=ie.charCodeAt(he-1);if(q(de)&&he>1){const me=ie.charCodeAt(he-2);if(H(me))return x(me,de)}return de}class K{get offset(){return this._offset}constructor(he,de=0){this._str=he,this._len=he.length,this._offset=de}setOffset(he){this._offset=he}prevCodePoint(){const he=j(this._str,this._offset);return this._offset-=he>=65536?2:1,he}nextCodePoint(){const he=W(this._str,this._len,this._offset);return this._offset+=he>=65536?2:1,he}eol(){return this._offset>=this._len}}e.CodePointIterator=K;class ee{get offset(){return this._iterator.offset}constructor(he,de=0){this._iterator=new K(he,de)}nextGraphemeLength(){const he=Le.getInstance(),de=this._iterator,me=de.offset;let pe=he.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const Pe=de.offset,De=he.getGraphemeBreakType(de.nextCodePoint());if(be(pe,De)){de.setOffset(Pe);break}pe=De}return de.offset-me}prevGraphemeLength(){const he=Le.getInstance(),de=this._iterator,me=de.offset;let pe=he.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const Pe=de.offset,De=he.getGraphemeBreakType(de.prevCodePoint());if(be(De,pe)){de.setOffset(Pe);break}pe=De}return me-de.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ee;function ce(ie,he){return new ee(ie,he).nextGraphemeLength()}e.nextCharLength=ce;function J(ie,he){return new ee(ie,he).prevGraphemeLength()}e.prevCharLength=J;function Q(ie,he){he>0&&q(ie.charCodeAt(he))&&he--;const de=he+ce(ie,he);return[de-J(ie,de),de]}e.getCharContainingOffset=Q;function M(ie){const he=new ee(ie);let de=0;for(;!he.eol();)de++,he.nextGraphemeLength();return de}e.charCount=M;let O;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function z(ie){return O||(O=B()),O.test(ie)}e.containsRTL=z;const Y=/^[\t\n\r\x20-\x7E]*$/;function ne(ie){return Y.test(ie)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=X;function te(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=te;function re(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=re;function le(ie,he){if(ie.length<he)return ie;const de=/\b/g;let me=0;for(;de.test(ie)&&!(ie.length-de.lastIndex<he);)me=de.lastIndex,de.lastIndex+=1;return ie.substring(me).replace(/^\s/,"")}e.lcut=le;const ue=/\x1B\x5B[12]?K/g,Se=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function Ee(ie){return ie&&(ie=ie.replace(ue,""),ie=ie.replace(Se,""),ie=ie.replace(we,"")),ie}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Ae(ie){return Ce(ie)?ie.substr(1):ie}e.stripUTF8BOM=Ae;function Ne(ie,he){if(!ie||!he||ie.length<he.length)return!1;const de=he.length,me=ie.toLowerCase();let pe=0,Pe=-1;for(;pe<de;){const De=me.indexOf(he[pe],Pe+1);if(De<0)return!1;Pe=De,pe++}return!0}e.fuzzyContains=Ne;function Ge(ie,he=!1){return ie?(he&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=Ge;function We(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=We;function ae(ie,he=1){if(he===0)return"";let de=-1;do de=ie.indexOf(`
`,de+1),he--;while(he>0&&de>=0);return de===-1?ie:(ie[de-1]==="\r"&&de--,ie.substr(0,de))}e.getNLines=ae;function fe(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.singleLetterHash=fe;function ge(ie){return Le.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=ge;function be(ie,he){return ie===0?he!==5&&he!==7:ie===2&&he===3?!1:ie===4||ie===2||ie===3||he===4||he===2||he===3?!0:!(ie===8&&(he===8||he===9||he===11||he===12)||(ie===11||ie===9)&&(he===9||he===10)||(ie===12||ie===10)&&he===10||he===5||he===13||he===7||ie===1||ie===13&&he===14||ie===6&&he===6)}var Ie;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Le{static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}constructor(){this._data=Re()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const de=this._data,me=de.length/3;let pe=1;for(;pe<=me;)if(he<de[3*pe])pe=2*pe;else if(he>de[3*pe+1])pe=2*pe+1;else return de[3*pe+2];return 0}}Le._INSTANCE=null;function Re(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(ie,he){if(ie===0)return 0;const de=_e(ie,he);if(de!==void 0)return de;const me=new K(he,ie);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Fe;function _e(ie,he){const de=new K(he,ie);let me=de.prevCodePoint();for(;Me(me)||me===65039||me===8419;){if(de.offset===0)return;me=de.prevCodePoint()}if(!re(me))return;let pe=de.offset;return pe>0&&de.prevCodePoint()===8205&&(pe=de.offset),pe}function Me(ie){return 127995<=ie&&ie<=127999}var ze;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(he){return ke.cache.get(Array.from(he))}static getLocales(){return ke._locales.getValue()}constructor(he){this.confusableDictionary=he}isAmbiguous(he){return this.confusableDictionary.has(he)}getPrimaryConfusable(he){return this.confusableDictionary.get(he)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ke,R=ke,ke.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.cache=new D.LRUCachedFunction(ie=>{function he(Te){const je=new Map;for(let Ve=0;Ve<Te.length;Ve+=2)je.set(Te[Ve],Te[Ve+1]);return je}function de(Te,je){const Ve=new Map(Te);for(const[et,ot]of je)Ve.set(et,ot);return Ve}function me(Te,je){if(!Te)return je;const Ve=new Map;for(const[et,ot]of Te)je.has(et)&&Ve.set(et,ot);return Ve}const pe=R.ambiguousCharacterData.getValue();let Pe=ie.filter(Te=>!Te.startsWith("_")&&Te in pe);Pe.length===0&&(Pe=["_default"]);let De;for(const Te of Pe){const je=he(pe[Te]);De=me(De,je)}const Be=he(pe._common),$e=de(Be,De);return new ke($e)}),ke._locales=new i.Lazy(()=>Object.keys(ke.ambiguousCharacterData.getValue()).filter(ie=>!ie.startsWith("_")));class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(he){return Oe.getData().has(he)}static get codePoints(){return Oe.getData()}}e.InvisibleCharacters=Oe,Oe._data=void 0}),define(se[48],oe([0,1,12,5,27,15]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(s){return s===47||s===92}e.isPathSeparator=T;function I(s){return s.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=I;function P(s){return s.indexOf("/")===-1&&(s=I(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=P;function w(s,l=D.posix.sep){if(!s)return"";const a=s.length,g=s.charCodeAt(0);if(T(g)){if(T(s.charCodeAt(1))&&!T(s.charCodeAt(2))){let A=3;const V=A;for(;A<a&&!T(s.charCodeAt(A));A++);if(V!==A&&!T(s.charCodeAt(A+1))){for(A+=1;A<a;A++)if(T(s.charCodeAt(A)))return s.slice(0,A+1).replace(/[\\/]/g,l)}}return l}else if(u(g)&&s.charCodeAt(1)===58)return T(s.charCodeAt(2))?s.slice(0,2)+l:s.slice(0,2);let C=s.indexOf("://");if(C!==-1){for(C+=3;C<a;C++)if(T(s.charCodeAt(C)))return s.slice(0,C+1)}return""}e.getRoot=w;function b(s){if(!i.isWindows||!s||s.length<5)return!1;let l=s.charCodeAt(0);if(l!==92||(l=s.charCodeAt(1),l!==92))return!1;let a=2;const g=a;for(;a<s.length&&(l=s.charCodeAt(a),l!==92);a++);return!(g===a||(l=s.charCodeAt(a+1),isNaN(l)||l===92))}e.isUNC=b;const E=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,l=i.isWindows){const a=l?E:p;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||l&&v.test(s)||s==="."||s===".."||l&&s[s.length-1]==="."||l&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function m(s,l,a){const g=s===l;return!a||g?g:!s||!l?!1:(0,R.equalsIgnoreCase)(s,l)}e.isEqual=m;function y(s,l,a,g=D.sep){if(s===l)return!0;if(!s||!l||l.length>s.length)return!1;if(a){if(!(0,R.startsWithIgnoreCase)(s,l))return!1;if(l.length===s.length)return!0;let A=l.length;return l.charAt(l.length-1)===g&&A--,s.charAt(A)===g}return l.charAt(l.length-1)!==g&&(l+=g),s.indexOf(l)===0}e.isEqualOrParent=y;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function S(s,l){return i.isWindows&&s.endsWith(":")&&(s+=D.sep),(0,D.isAbsolute)(s)||(s=(0,D.join)(l,s)),s=(0,D.normalize)(s),i.isWindows?(s=(0,R.rtrim)(s,D.sep),s.endsWith(":")&&(s+=D.sep)):(s=(0,R.rtrim)(s,D.sep),s||(s=D.sep)),s}e.sanitizeFilePath=S;function c(s){const l=(0,D.normalize)(s);return i.isWindows?s.length>3?!1:h(l)&&(s.length===2||l.charCodeAt(2)===92):l===D.posix.sep}e.isRootOrDriveLetter=c;function h(s,l=i.isWindows){return l?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function d(s){return h(s)?s[0]:void 0}e.getDriveLetter=d;function n(s,l,a){return l.length>s.length?-1:s===l?0:(a&&(s=s.toLowerCase(),l=l.toLowerCase()),s.indexOf(l))}e.indexOfPath=n;function o(s){const l=s.split(":");let a,g,C;for(const A of l){const V=Number(A);(0,k.isNumber)(V)?g===void 0?g=V:C===void 0&&(C=V):a=a?[a,A].join(":"):A}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:g!==void 0?g:void 0,column:C!==void 0?C:g!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(s,l,a=8){let g="";for(let A=0;A<a;A++)g+=t.charAt(Math.floor(Math.random()*t.length));let C;return l?C=`${l}-${g}`:C=g,s?(0,D.join)(s,C):C}e.randomPath=r}),define(se[66],oe([0,1,27]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(u){return R(u,0)}e.hash=i;function R(u,S){switch(typeof u){case"object":return u===null?k(349,S):Array.isArray(u)?P(u,S):w(u,S);case"string":return I(u,S);case"boolean":return T(u,S);case"number":return k(u,S);case"undefined":return k(937,S);default:return k(617,S)}}e.doHash=R;function k(u,S){return(S<<5)-S+u|0}e.numberHash=k;function T(u,S){return k(u?433:863,S)}function I(u,S){S=k(149417,S);for(let c=0,h=u.length;c<h;c++)S=k(u.charCodeAt(c),S);return S}e.stringHash=I;function P(u,S){return S=k(104579,S),u.reduce((c,h)=>R(h,c),S)}function w(u,S){return S=k(181387,S),Object.keys(u).sort().reduce((c,h)=>(c=I(h,c),R(u[h],c)),S)}class b{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=R(S,this._value),this._value}}e.Hasher=b;var E;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function p(u,S,c=32){const h=c-S,d=~((1<<h)-1);return(u<<S|(d&u)>>>h)>>>0}function v(u,S=0,c=u.byteLength,h=0){for(let d=0;d<c;d++)u[S+d]=h}function f(u,S,c="0"){for(;u.length<S;)u=c+u;return u}function m(u,S=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(c=>c.toString(16).padStart(2,"0")).join(""):f((u>>>0).toString(16),S/4)}e.toHexString=m;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const c=S.length;if(c===0)return;const h=this._buff;let d=this._buffLen,n=this._leftoverHighSurrogate,o,t;for(n!==0?(o=n,t=-1,n=0):(o=S.charCodeAt(0),t=0);;){let r=o;if(D.isHighSurrogate(o))if(t+1<c){const s=S.charCodeAt(t+1);D.isLowSurrogate(s)?(t++,r=D.computeCodePoint(o,s)):r=65533}else{n=o;break}else D.isLowSurrogate(o)&&(r=65533);if(d=this._push(h,d,r),t++,t<c)o=S.charCodeAt(t);else break}this._buffLen=d,this._leftoverHighSurrogate=n}_push(S,c,h){return h<128?S[c++]=h:h<2048?(S[c++]=192|(h&1984)>>>6,S[c++]=128|(h&63)>>>0):h<65536?(S[c++]=224|(h&61440)>>>12,S[c++]=128|(h&4032)>>>6,S[c++]=128|(h&63)>>>0):(S[c++]=240|(h&1835008)>>>18,S[c++]=128|(h&258048)>>>12,S[c++]=128|(h&4032)>>>6,S[c++]=128|(h&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=y._bigBlock32,c=this._buffDV;for(let a=0;a<64;a+=4)S.setUint32(a,c.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)S.setUint32(a,p(S.getUint32(a-12,!1)^S.getUint32(a-32,!1)^S.getUint32(a-56,!1)^S.getUint32(a-64,!1),1),!1);let h=this._h0,d=this._h1,n=this._h2,o=this._h3,t=this._h4,r,s,l;for(let a=0;a<80;a++)a<20?(r=d&n|~d&o,s=1518500249):a<40?(r=d^n^o,s=1859775393):a<60?(r=d&n|d&o|n&o,s=2400959708):(r=d^n^o,s=3395469782),l=p(h,5)+r+t+s+S.getUint32(a*4,!1)&4294967295,t=o,o=n,n=p(d,30),d=h,h=l;this._h0=this._h0+h&4294967295,this._h1=this._h1+d&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(se[87],oe([0,1,27]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(i||(i={})),function(R){const k="error",T="warning",I="warn",P="info",w="ignore";function b(p){return p?D.equalsIgnoreCase(k,p)?R.Error:D.equalsIgnoreCase(T,p)||D.equalsIgnoreCase(I,p)?R.Warning:D.equalsIgnoreCase(P,p)?R.Info:R.Ignore:R.Ignore}R.fromValue=b;function E(p){switch(p){case R.Error:return k;case R.Warning:return T;case R.Info:return P;default:return w}}R.toString=E}(i||(i={})),e.default=i}),define(se[49],oe([0,1,19,27]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class R{constructor(){this._value="",this._pos=0}reset(v){return this._value=v,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(v){const f=v.charCodeAt(0),m=this._value.charCodeAt(this._pos);return f-m}value(){return this._value[this._pos]}}e.StringIterator=R;class k{constructor(v=!0){this._caseSensitive=v}reset(v){return this._value=v,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let v=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(v)this._from++;else break;else v=!1;return this}cmp(v){return this._caseSensitive?(0,i.compareSubstring)(v,this._value,0,v.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(v,this._value,0,v.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class T{constructor(v=!0,f=!0){this._splitOnBackslash=v,this._caseSensitive=f}reset(v){this._from=0,this._to=0,this._value=v,this._valueLen=v.length;for(let f=v.length-1;f>=0;f--,this._valueLen--){const m=this._value.charCodeAt(f);if(!(m===47||this._splitOnBackslash&&m===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let v=!0;for(;this._to<this._valueLen;this._to++){const f=this._value.charCodeAt(this._to);if(f===47||this._splitOnBackslash&&f===92)if(v)this._from++;else break;else v=!1}return this}cmp(v){return this._caseSensitive?(0,i.compareSubstring)(v,this._value,0,v.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(v,this._value,0,v.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var I;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(I||(I={}));class P{constructor(v,f){this._ignorePathCasing=v,this._ignoreQueryAndFragment=f,this._states=[],this._stateIdx=0}reset(v){return this._value=v,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(v)),this._pathIterator.reset(v.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(v)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(v){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(v,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(v,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(v);if(this._states[this._stateIdx]===4)return(0,i.compare)(v,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(v,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=P;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(b||(b={}));class E{static forUris(v=()=>!1,f=()=>!1){return new E(new P(v,f))}static forPaths(v=!1){return new E(new T(void 0,!v))}static forStrings(){return new E(new R)}static forConfigKeys(){return new E(new k)}constructor(v){this._iter=v}clear(){this._root=void 0}fill(v,f){if(f){const m=f.slice(0);(0,D.shuffle)(m);for(const y of m)this.set(y,v)}else{const m=v.slice(0);(0,D.shuffle)(m);for(const y of m)this.set(y[0],y[1])}}set(v,f){const m=this._iter.reset(v);let y;this._root||(this._root=new w,this._root.segment=m.value());const u=[];for(y=this._root;;){const c=m.cmp(y.segment);if(c>0)y.left||(y.left=new w,y.left.segment=m.value()),u.push([-1,y]),y=y.left;else if(c<0)y.right||(y.right=new w,y.right.segment=m.value()),u.push([1,y]),y=y.right;else if(m.hasNext())m.next(),y.mid||(y.mid=new w,y.mid.segment=m.value()),u.push([0,y]),y=y.mid;else break}const S=y.value;y.value=f,y.key=v;for(let c=u.length-1;c>=0;c--){const h=u[c][1];h.updateHeight();const d=h.balanceFactor();if(d<-1||d>1){const n=u[c][0],o=u[c+1][0];if(n===1&&o===1)u[c][1]=h.rotateLeft();else if(n===-1&&o===-1)u[c][1]=h.rotateRight();else if(n===1&&o===-1)h.right=u[c+1][1]=u[c+1][1].rotateRight(),u[c][1]=h.rotateLeft();else if(n===-1&&o===1)h.left=u[c+1][1]=u[c+1][1].rotateLeft(),u[c][1]=h.rotateRight();else throw new Error;if(c>0)switch(u[c-1][0]){case-1:u[c-1][1].left=u[c][1];break;case 1:u[c-1][1].right=u[c][1];break;case 0:u[c-1][1].mid=u[c][1];break}else this._root=u[0][1]}}return S}get(v){return this._getNode(v)?.value}_getNode(v){const f=this._iter.reset(v);let m=this._root;for(;m;){const y=f.cmp(m.segment);if(y>0)m=m.left;else if(y<0)m=m.right;else if(f.hasNext())f.next(),m=m.mid;else break}return m}has(v){const f=this._getNode(v);return!(f?.value===void 0&&f?.mid===void 0)}delete(v){return this._delete(v,!1)}deleteSuperstr(v){return this._delete(v,!0)}_delete(v,f){const m=this._iter.reset(v),y=[];let u=this._root;for(;u;){const S=m.cmp(u.segment);if(S>0)y.push([-1,u]),u=u.left;else if(S<0)y.push([1,u]),u=u.right;else if(m.hasNext())m.next(),y.push([0,u]),u=u.mid;else break}if(!!u){if(f?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const S=this._min(u.right);if(S.key){const{key:c,value:h,segment:d}=S;this._delete(S.key,!1),u.key=c,u.value=h,u.segment=d}}else{const S=u.left??u.right;if(y.length>0){const[c,h]=y[y.length-1];switch(c){case-1:h.left=S;break;case 0:h.mid=S;break;case 1:h.right=S;break}}else this._root=S}for(let S=y.length-1;S>=0;S--){const c=y[S][1];c.updateHeight();const h=c.balanceFactor();if(h>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),y[S][1]=c.rotateLeft()):h<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),y[S][1]=c.rotateRight()),S>0)switch(y[S-1][0]){case-1:y[S-1][1].left=y[S][1];break;case 1:y[S-1][1].right=y[S][1];break;case 0:y[S-1][1].mid=y[S][1];break}else this._root=y[0][1]}}}_min(v){for(;v.left;)v=v.left;return v}findSubstr(v){const f=this._iter.reset(v);let m=this._root,y;for(;m;){const u=f.cmp(m.segment);if(u>0)m=m.left;else if(u<0)m=m.right;else if(f.hasNext())f.next(),y=m.value||y,m=m.mid;else break}return m&&m.value||y}findSuperstr(v){const f=this._iter.reset(v);let m=this._root;for(;m;){const y=f.cmp(m.segment);if(y>0)m=m.left;else if(y<0)m=m.right;else if(f.hasNext())f.next(),m=m.mid;else return m.mid?this._entries(m.mid):void 0}}forEach(v){for(const[f,m]of this)v(m,f)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(v){const f=[];return this._dfsEntries(v,f),f[Symbol.iterator]()}_dfsEntries(v,f){!v||(v.left&&this._dfsEntries(v.left,f),v.value&&f.push([v.key,v.value]),v.mid&&this._dfsEntries(v.mid,f),v.right&&this._dfsEntries(v.right,f))}_isBalanced(){const v=f=>{if(!f)return!0;const m=f.balanceFactor();return m<-1||m>1?!1:v(f.left)&&v(f.right)};return v(this._root)}}e.TernarySearchTree=E}),define(se[8],oe([0,1,12,5]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,k=/^\//,T=/^\/\//;function I(t,r){if(!t.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!R.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!k.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(t,r){return!t&&!r?"file":t}function w(t,r){switch(t){case"https":case"http":case"file":r?r[0]!==E&&(r=E+r):r=E;break}return r}const b="",E="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(r){return r instanceof v?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,s,l,a,g,C=!1){typeof r=="object"?(this.scheme=r.scheme||b,this.authority=r.authority||b,this.path=r.path||b,this.query=r.query||b,this.fragment=r.fragment||b):(this.scheme=P(r,C),this.authority=s||b,this.path=w(this.scheme,l||b),this.query=a||b,this.fragment=g||b,I(this,C))}get fsPath(){return c(this,!1)}with(r){if(!r)return this;let{scheme:s,authority:l,path:a,query:g,fragment:C}=r;return s===void 0?s=this.scheme:s===null&&(s=b),l===void 0?l=this.authority:l===null&&(l=b),a===void 0?a=this.path:a===null&&(a=b),g===void 0?g=this.query:g===null&&(g=b),C===void 0?C=this.fragment:C===null&&(C=b),s===this.scheme&&l===this.authority&&a===this.path&&g===this.query&&C===this.fragment?this:new m(s,l,a,g,C)}static parse(r,s=!1){const l=p.exec(r);return l?new m(l[2]||b,o(l[4]||b),o(l[5]||b),o(l[7]||b),o(l[9]||b),s):new m(b,b,b,b,b)}static file(r){let s=b;if(i.isWindows&&(r=r.replace(/\\/g,E)),r[0]===E&&r[1]===E){const l=r.indexOf(E,2);l===-1?(s=r.substring(2),r=E):(s=r.substring(2,l),r=r.substring(l)||E)}return new m("file",s,r,b,b)}static from(r){const s=new m(r.scheme,r.authority,r.path,r.query,r.fragment);return I(s,!0),s}static joinPath(r,...s){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return i.isWindows&&r.scheme==="file"?l=v.file(D.win32.join(c(r,!0),...s)).path:l=D.posix.join(r.path,...s),r.with({path:l})}toString(r=!1){return h(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof v)return r;{const s=new m(r);return s._formatted=r.external,s._fsPath=r._sep===f?r.fsPath:null,s}}else return r}}e.URI=v;const f=i.isWindows?1:void 0;class m extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(r=!1){return r?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=f),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,r){let s,l=-1;for(let a=0;a<t.length;a++){const g=t.charCodeAt(a);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||r&&g===47)l!==-1&&(s+=encodeURIComponent(t.substring(l,a)),l=-1),s!==void 0&&(s+=t.charAt(a));else{s===void 0&&(s=t.substr(0,a));const C=y[g];C!==void 0?(l!==-1&&(s+=encodeURIComponent(t.substring(l,a)),l=-1),s+=C):l===-1&&(l=a)}}return l!==-1&&(s+=encodeURIComponent(t.substring(l))),s!==void 0?s:t}function S(t){let r;for(let s=0;s<t.length;s++){const l=t.charCodeAt(s);l===35||l===63?(r===void 0&&(r=t.substr(0,s)),r+=y[l]):r!==void 0&&(r+=t[s])}return r!==void 0?r:t}function c(t,r){let s;return t.authority&&t.path.length>1&&t.scheme==="file"?s=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?r?s=t.path.substr(1):s=t.path[1].toLowerCase()+t.path.substr(2):s=t.path,i.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=c;function h(t,r){const s=r?S:u;let l="",{scheme:a,authority:g,path:C,query:A,fragment:V}=t;if(a&&(l+=a,l+=":"),(g||a==="file")&&(l+=E,l+=E),g){let _=g.indexOf("@");if(_!==-1){const F=g.substr(0,_);g=g.substr(_+1),_=F.indexOf(":"),_===-1?l+=s(F,!1):(l+=s(F.substr(0,_),!1),l+=":",l+=s(F.substr(_+1),!1)),l+="@"}g=g.toLowerCase(),_=g.indexOf(":"),_===-1?l+=s(g,!1):(l+=s(g.substr(0,_),!1),l+=g.substr(_))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const _=C.charCodeAt(1);_>=65&&_<=90&&(C=`/${String.fromCharCode(_+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const _=C.charCodeAt(0);_>=65&&_<=90&&(C=`${String.fromCharCode(_+32)}:${C.substr(2)}`)}l+=s(C,!0)}return A&&(l+="?",l+=s(A,!1)),V&&(l+="#",l+=r?V:u(V,!1)),l}function d(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+d(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(t){return t.match(n)?t.replace(n,r=>d(r)):t}}),define(se[142],oe([0,1,8]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(w){const b=w;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=i;function R(w){const b=[];let E;try{const p=JSON.parse(w.arguments),v=p[p.length-1];v&&v.__$stack&&(p.pop(),E=v.__$stack),b.push(...p)}catch{b.push("Unable to log remote console arguments",w.arguments)}return{args:b,stack:E}}e.parse=R;function k(w){if(typeof w!="string")return k(R(w).stack);const b=w;if(b){const E=T(b),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(p&&p.length===4)return{uri:D.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=k;function T(w){if(!w)return w;const b=w.indexOf(`
`);return b===-1?w:w.substring(0,b)}function I(w,b){const{args:E,stack:p}=R(w),v=typeof E[0]=="string"&&E.length===1;let f=T(p);f&&(f=`(${f.trim()})`);let m=[];if(typeof E[0]=="string"?f&&v?m=[`%c[${b}] %c${E[0]} %c${f}`,P("blue"),P(""),P("grey")]:m=[`%c[${b}] %c${E[0]}`,P("blue"),P(""),...E.slice(1)]:m=[`%c[${b}]%`,P("blue"),...E],f&&!v&&m.push(f),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,m)}e.log=I;function P(w){return`color: ${w}`}}),define(se[67],oe([0,1,17,27,8]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(w){return JSON.stringify(w,I)}e.stringify=k;function T(w){let b=JSON.parse(w);return b=P(b),b}e.parse=T;function I(w,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,i.regExpFlags)(b)}:b}function P(w,b=0){if(!w||b>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return R.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 15:return new Date(w.source)}if(w instanceof D.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let E=0;E<w.length;++E)w[E]=P(w[E],b+1);else for(const E in w)Object.hasOwnProperty.call(w,E)&&(w[E]=P(w[E],b+1))}return w}e.revive=P}),define(se[23],oe([0,1,5,8]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.vscodeUserData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls",P.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}setServerRootPath(w){this._remoteResourcesPath=`${w}/${R.vscodeRemoteResource}`}set(w,b,E){this._hosts[w]=b,this._ports[w]=E}setConnectionToken(w,b){this._connectionTokens[w]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(w){if(this._delegate)return this._delegate(w);const b=w.authority;let E=this._hosts[b];E&&E.indexOf(":")!==-1&&E.indexOf("[")===-1&&(E=`[${E}]`);const p=this._ports[b],v=this._connectionTokens[b];let f=`path=${encodeURIComponent(w.path)}`;return typeof v=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),i.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${E}:${p}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new k;class T{asBrowserUri(w,b){const E=this.toUri(w,b);return E.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===R.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${R.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?E.with({scheme:R.vscodeFileResource,authority:E.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(w,b){const E=this.toUri(w,b);return E.scheme===R.vscodeFileResource?E.with({scheme:R.file,authority:E.authority!==T.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(w,b){return i.URI.isUri(w)?w:i.URI.parse(b.toUrl(w))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T;var I;(function(P){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);P.CoopAndCoep=Object.freeze(w.get("3"));const b="vscode-coi";function E(v){let f;typeof v=="string"?f=new URL(v).searchParams:v instanceof URL?f=v.searchParams:i.URI.isUri(v)&&(f=new URL(v.toString(!0)).searchParams);const m=f?.get(b);if(!!m)return w.get(m)}P.getHeadersFromQuery=E;function p(v,f,m){if(!globalThis.crossOriginIsolated)return;const y=f&&m?"3":m?"2":"1";v instanceof URLSearchParams?v.set(b,y):v[b]=y}P.addSearchParam=p})(I=e.COI||(e.COI={}))}),define(se[20],oe([0,1,48,23,12,5,27,8]),function(Z,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function P(v){return(0,I.uriToFsPath)(v,!0)}e.originalFSPath=P;class w{constructor(f){this._ignorePathCasing=f}compare(f,m,y=!1){return f===m?0:(0,T.compare)(this.getComparisonKey(f,y),this.getComparisonKey(m,y))}isEqual(f,m,y=!1){return f===m?!0:!f||!m?!1:this.getComparisonKey(f,y)===this.getComparisonKey(m,y)}getComparisonKey(f,m=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,m,y=!1){if(f.scheme===m.scheme){if(f.scheme===i.Schemas.file)return D.isEqualOrParent(P(f),P(m),this._ignorePathCasing(f))&&f.query===m.query&&(y||f.fragment===m.fragment);if((0,e.isEqualAuthority)(f.authority,m.authority))return D.isEqualOrParent(f.path,m.path,this._ignorePathCasing(f),"/")&&f.query===m.query&&(y||f.fragment===m.fragment)}return!1}joinPath(f,...m){return I.URI.joinPath(f,...m)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return R.posix.basename(f.path)}extname(f){return R.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let m;return f.scheme===i.Schemas.file?m=I.URI.file(R.dirname(P(f))).path:(m=R.posix.dirname(f.path),f.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),m="/")),f.with({path:m})}normalizePath(f){if(!f.path.length)return f;let m;return f.scheme===i.Schemas.file?m=I.URI.file(R.normalize(P(f))).path:m=R.posix.normalize(f.path),f.with({path:m})}relativePath(f,m){if(f.scheme!==m.scheme||!(0,e.isEqualAuthority)(f.authority,m.authority))return;if(f.scheme===i.Schemas.file){const S=R.relative(P(f),P(m));return k.isWindows?D.toSlashes(S):S}let y=f.path||"/";const u=m.path||"/";if(this._ignorePathCasing(f)){let S=0;for(const c=Math.min(y.length,u.length);S<c&&!(y.charCodeAt(S)!==u.charCodeAt(S)&&y.charAt(S).toLowerCase()!==u.charAt(S).toLowerCase());S++);y=u.substr(0,S)+y.substr(S)}return R.posix.relative(y,u)}resolvePath(f,m){if(f.scheme===i.Schemas.file){const y=I.URI.file(R.resolve(P(f),m));return f.with({authority:y.authority,path:y.path})}return m=D.toPosixPath(m),f.with({path:R.posix.resolve(f.path,m)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,m){return f===m||f!==void 0&&m!==void 0&&(0,T.equalsIgnoreCase)(f,m)}hasTrailingPathSeparator(f,m=R.sep){if(f.scheme===i.Schemas.file){const y=P(f);return y.length>D.getRoot(y).length&&y[y.length-1]===m}else{const y=f.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,m=R.sep){return(0,e.hasTrailingPathSeparator)(f,m)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,m=R.sep){let y=!1;if(f.scheme===i.Schemas.file){const u=P(f);y=u!==void 0&&u.length===D.getRoot(u).length&&u[u.length-1]===m}else{m="/";const u=f.path;y=u.length===1&&u.charCodeAt(u.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(f,m)?f.with({path:f.path+"/"}):f}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(v=>v.scheme===i.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new w(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(v,f){const m=[];for(let y=0;y<v.length;y++){const u=f(v[y]);v.some((S,c)=>c===y?!1:(0,e.isEqualOrParent)(u,f(S)))||m.push(v[y])}return m}e.distinctParents=b;var E;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function f(m){const y=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(c=>{const[h,d]=c.split(":");h&&d&&y.set(h,d)});const S=m.path.substring(0,m.path.indexOf(";"));return S&&y.set(v.META_DATA_MIME,S),y}v.parseMetaData=f})(E=e.DataUri||(e.DataUri={}));function p(v,f,m){if(f){let y=v.path;return y&&y[0]!==R.posix.sep&&(y=R.posix.sep+y),v.with({scheme:m,authority:f,path:y})}return v.with({scheme:m})}e.toLocalResource=p}),define(se[6],oe([0,1,22,11,3,2,20,5]),function(Z,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(Q){return!!Q&&typeof Q.then=="function"}e.isThenable=P;function w(Q){const M=new D.CancellationTokenSource,O=Q(M.token),B=new Promise((z,Y)=>{const ne=M.token.onCancellationRequested(()=>{ne.dispose(),M.dispose(),Y(new i.CancellationError)});Promise.resolve(O).then(X=>{ne.dispose(),M.dispose(),z(X)},X=>{ne.dispose(),M.dispose(),Y(X)})});return new class{cancel(){M.cancel()}then(z,Y){return B.then(z,Y)}catch(z){return this.then(void 0,z)}finally(z){return B.finally(z)}}}e.createCancelablePromise=w;function b(Q,M,O){return new Promise((B,z)=>{const Y=M.onCancellationRequested(()=>{Y.dispose(),B(O)});Q.then(B,z).finally(()=>Y.dispose())})}e.raceCancellation=b;function E(Q,M){return new Promise((O,B)=>{const z=M.onCancellationRequested(()=>{z.dispose(),B(new i.CancellationError)});Q.then(O,B).finally(()=>z.dispose())})}e.raceCancellationError=E;async function p(Q){let M=-1;const O=Q.map((z,Y)=>z.then(ne=>(M=Y,ne))),B=await Promise.race(O);return Q.forEach((z,Y)=>{Y!==M&&z.cancel()}),B}e.raceCancellablePromises=p;function v(Q,M,O){let B;const z=setTimeout(()=>{B?.(void 0),O?.()},M);return Promise.race([Q.finally(()=>clearTimeout(z)),new Promise(Y=>B=Y)])}e.raceTimeout=v;function f(Q){return new Promise((M,O)=>{const B=Q();P(B)?B.then(M,O):M(B)})}e.asPromise=f;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(O,O).then(B)})}return new Promise((O,B)=>{this.queuedPromise.then(O,B)})}return this.activePromise=M(),new Promise((O,B)=>{this.activePromise.then(z=>{this.activePromise=null,O(z)},z=>{this.activePromise=null,B(z)})})}}e.Throttler=m;class y{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=y;class u{constructor(){this.promiseMap=new Map}queue(M,O){const z=(this.promiseMap.get(M)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(M)===z&&this.promiseMap.delete(M)});return this.promiseMap.set(M,z),z}}e.SequencerByKey=u;const S=(Q,M)=>{let O=!0;const B=setTimeout(()=>{O=!1,M()},Q);return{isTriggered:()=>O,dispose:()=>{clearTimeout(B),O=!1}}},c=Q=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,Q())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(M){this.defaultDelay=M,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,O=this.defaultDelay){this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,Y)=>{this.doResolve=z,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}}));const B=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?c(B):S(O,B),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=h;class d{constructor(M){this.delayer=new h(M),this.throttler=new m}trigger(M,O){return this.delayer.trigger(()=>this.throttler.queue(M),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=d;class n{constructor(){this._isOpen=!1,this._promise=new Promise((M,O)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class o extends n{constructor(M){super(),this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function t(Q,M){return M?new Promise((O,B)=>{const z=setTimeout(()=>{Y.dispose(),O()},Q),Y=M.onCancellationRequested(()=>{clearTimeout(z),Y.dispose(),B(new i.CancellationError)})}):w(O=>t(Q,O))}e.timeout=t;function r(Q,M=0){const O=setTimeout(Q,M);return(0,k.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=r;function s(Q){const M=[];let O=0;const B=Q.length;function z(){return O<B?Q[O++]():null}function Y(ne){ne!=null&&M.push(ne);const X=z();return X?X.then(Y):Promise.resolve(M)}return Promise.resolve(null).then(Y)}e.sequence=s;function l(Q,M=B=>!!B,O=null){let B=0;const z=Q.length,Y=()=>{if(B>=z)return Promise.resolve(O);const ne=Q[B++];return Promise.resolve(ne()).then(te=>M(te)?Promise.resolve(te):Y())};return Y()}e.first=l;function a(Q,M=B=>!!B,O=null){if(Q.length===0)return Promise.resolve(O);let B=Q.length;const z=()=>{B=-1;for(const Y of Q)Y.cancel?.()};return new Promise((Y,ne)=>{for(const X of Q)X.then(te=>{--B>=0&&M(te)?(z(),Y(te)):B===0&&Y(O)}).catch(te=>{--B>=0&&(z(),ne(te))})})}e.firstParallel=a;class g{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new R.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(M){return this._size++,new Promise((O,B)=>{this.outstandingPromises.push({factory:M,c:O,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const O=M.factory();O.then(M.c,M.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=g;class C extends g{constructor(){super(1)}}e.Queue=C;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const M=new W;return this.drainers.add(M),M.p}isDrained(){for(const[,M]of this.queues)if(M.size>0)return!1;return!0}queueFor(M,O=T.extUri){const B=O.getComparisonKey(M);let z=this.queues.get(B);return z||(z=new C,R.Event.once(z.onDrained)(()=>{z?.dispose(),this.queues.delete(B),this.onDidQueueDrain()}),this.queues.set(B,z)),z}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const M of this.drainers)M.complete();this.drainers.clear()}dispose(){for(const[,M]of this.queues)M.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class V{constructor(M,O){this._token=-1,typeof M=="function"&&typeof O=="number"&&this.setIfNotSet(M,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},O)}setIfNotSet(M,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},O))}}e.TimeoutTimer=V;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,O){this.cancel(),this._token=setInterval(()=>{M()},O)}}e.IntervalTimer=_;class F{constructor(M,O){this.timeoutToken=-1,this.runner=M,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=F;class N{constructor(M,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=M,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(M=this.timeout){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(M/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=N;class L extends F{constructor(M,O){super(M,O),this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner?.(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L;class U extends k.Disposable{constructor(M,O){super(),this.options=M,this.handler=O,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(M){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+M.length>this.options.maxBufferedWork)return!1}else if(this.pending+M.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...M),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Q=>{(0,I.setTimeout0)(()=>{if(M)return;const O=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:e.runWhenIdle=(Q,M)=>{const O=requestIdleCallback(Q,typeof M=="number"?{timeout:M}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(O))}}}}();class ${constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function H(Q,M,O){let B;for(let z=0;z<O;z++)try{return await Q()}catch(Y){B=Y,await t(M)}throw B}e.retry=H;class q{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(M,O,B){return this._pending={taskId:M,cancel:()=>B?.(),promise:O},O.then(()=>this.donePending(M),()=>this.donePending(M)),O}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let O,B;const z=new Promise((Y,ne)=>{O=Y,B=ne});this._next={run:M,promise:z,promiseResolve:O,promiseReject:B}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=q;class x{constructor(M,O=()=>Date.now()){this.interval=M,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const M=this.nowFn();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class W{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,O)=>{this.completeCallback=M,this.errorCallback=O})}complete(M){return new Promise(O=>{this.completeCallback(M),this.resolved=!0,O()})}error(M){return new Promise(O=>{this.errorCallback(M),this.rejected=!0,O()})}cancel(){new Promise(M=>{this.errorCallback(new i.CancellationError),this.rejected=!0,M()})}}e.DeferredPromise=W;var j;(function(Q){async function M(B){let z;const Y=await Promise.all(B.map(ne=>ne.then(X=>X,X=>{z||(z=X)})));if(typeof z<"u")throw z;return Y}Q.settled=M;function O(B){return new Promise(async(z,Y)=>{try{await B(z,Y)}catch(ne){Y(ne)}})}Q.withAsyncBody=O})(j=e.Promises||(e.Promises={}));var K;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(K||(K={}));class ee{static fromArray(M){return new ee(O=>{O.emitMany(M)})}static fromPromise(M){return new ee(async O=>{O.emitMany(await M)})}static fromPromises(M){return new ee(async O=>{await Promise.all(M.map(async B=>O.emitOne(await B)))})}static merge(M){return new ee(async O=>{await Promise.all(M.map(async B=>{for await(const z of B)O.emitOne(z)}))})}constructor(M){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const O={emitOne:B=>this.emitOne(B),emitMany:B=>this.emitMany(B),reject:B=>this.reject(B)};try{await Promise.resolve(M(O)),this.resolve()}catch(B){this.reject(B)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(M<this._results.length)return{done:!1,value:this._results[M++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(M,O){return new ee(async B=>{for await(const z of M)B.emitOne(O(z))})}map(M){return ee.map(this,M)}static filter(M,O){return new ee(async B=>{for await(const z of M)O(z)&&B.emitOne(z)})}filter(M){return ee.filter(this,M)}static coalesce(M){return ee.filter(M,O=>!!O)}coalesce(){return ee.coalesce(this)}static async toPromise(M){const O=[];for await(const B of M)O.push(B);return O}toPromise(){return ee.toPromise(this)}emitOne(M){this._state===0&&(this._results.push(M),this._onStateChanged.fire())}emitMany(M){this._state===0&&(this._results=this._results.concat(M),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(M){this._state===0&&(this._state=2,this._error=M,this._onStateChanged.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class ce extends ee{constructor(M,O){super(O),this._source=M}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function J(Q){const M=new D.CancellationTokenSource,O=Q(M.token);return new ce(M,async B=>{const z=M.token.onCancellationRequested(()=>{z.dispose(),M.dispose(),B.reject(new i.CancellationError)});try{for await(const Y of O){if(M.token.isCancellationRequested)return;B.emitOne(Y)}z.dispose(),M.dispose()}catch(Y){z.dispose(),M.dispose(),B.reject(Y)}})}e.createCancelableAsyncIterable=J}),define(se[88],oe([0,1,19,6,48,37,12,5,27]),function(Z,e,D,i,R,k,T,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",E="[^/\\\\]",p=/\//g;function v(W,j){switch(W){case 0:return"";case 1:return`${E}*?`;default:return`(?:${b}|${E}+${b}${j?`|${b}${E}+`:""})*?`}}function f(W,j){if(!W)return[];const K=[];let ee=!1,ce=!1,J="";for(const Q of W){switch(Q){case j:if(!ee&&!ce){K.push(J),J="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}J+=Q}return J&&K.push(J),K}e.splitGlobAware=f;function m(W){if(!W)return"";let j="";const K=f(W,e.GLOB_SPLIT);if(K.every(ee=>ee===e.GLOBSTAR))j=".*";else{let ee=!1;K.forEach((ce,J)=>{if(ce===e.GLOBSTAR){if(ee)return;j+=v(2,J===K.length-1)}else{let Q=!1,M="",O=!1,B="";for(const z of ce){if(z!=="}"&&Q){M+=z;continue}if(O&&(z!=="]"||!B)){let Y;z==="-"?Y=z:(z==="^"||z==="!")&&!B?Y="^":z===e.GLOB_SPLIT?Y="":Y=(0,P.escapeRegExpCharacters)(z),B+=Y;continue}switch(z){case"{":Q=!0;continue;case"[":O=!0;continue;case"}":{j+=`(?:${f(M,",").map(X=>m(X)).join("|")})`,Q=!1,M="";break}case"]":{j+="["+B+"]",O=!1,B="";break}case"?":j+=E;continue;case"*":j+=v(1);continue;default:j+=(0,P.escapeRegExpCharacters)(z)}}J<K.length-1&&(K[J+1]!==e.GLOBSTAR||J+2<K.length)&&(j+=b)}ee=ce===e.GLOBSTAR})}return j}const y=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new k.LRUCache(1e4),o=function(){return!1},t=function(){return null};function r(W,j){if(!W)return t;let K;typeof W!="string"?K=W.pattern:K=W,K=K.trim();const ee=`${K}_${!!j.trimForExclusions}`;let ce=n.get(ee);if(ce)return s(ce,W);let J;return y.test(K)?ce=a(K.substr(4),K):(J=u.exec(l(K,j)))?ce=g(J[1],K):(j.trimForExclusions?c:S).test(K)?ce=C(K,j):(J=h.exec(l(K,j)))?ce=A(J[1].substr(1),K,!0):(J=d.exec(l(K,j)))?ce=A(J[1],K,!1):ce=V(K),n.set(ee,ce),s(ce,W)}function s(W,j){if(typeof j=="string")return W;const K=function(ee,ce){return(0,R.isEqualOrParent)(ee,j.base,!I.isLinux)?W(ee.substr(j.base.length+1),ce):null};return K.allBasenames=W.allBasenames,K.allPaths=W.allPaths,K.basenames=W.basenames,K.patterns=W.patterns,K}function l(W,j){return j.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function a(W,j){return function(K,ee){return typeof K=="string"&&K.endsWith(W)?j:null}}function g(W,j){const K=`/${W}`,ee=`\\${W}`,ce=function(Q,M){return typeof Q!="string"?null:M?M===W?j:null:Q===W||Q.endsWith(K)||Q.endsWith(ee)?j:null},J=[W];return ce.basenames=J,ce.patterns=[j],ce.allBasenames=J,ce}function C(W,j){const K=q(W.slice(1,-1).split(",").map(M=>r(M,j)).filter(M=>M!==t),W),ee=K.length;if(!ee)return t;if(ee===1)return K[0];const ce=function(M,O){for(let B=0,z=K.length;B<z;B++)if(K[B](M,O))return W;return null},J=K.find(M=>!!M.allBasenames);J&&(ce.allBasenames=J.allBasenames);const Q=K.reduce((M,O)=>O.allPaths?M.concat(O.allPaths):M,[]);return Q.length&&(ce.allPaths=Q),ce}function A(W,j,K){const ee=T.sep===T.posix.sep,ce=ee?W:W.replace(p,T.sep),J=T.sep+ce,Q=T.posix.sep+W;let M;return K?M=function(O,B){return typeof O=="string"&&(O===ce||O.endsWith(J)||!ee&&(O===W||O.endsWith(Q)))?j:null}:M=function(O,B){return typeof O=="string"&&(O===ce||!ee&&O===W)?j:null},M.allPaths=[(K?"*/":"./")+W],M}function V(W){try{const j=new RegExp(`^${m(W)}$`);return function(K){return j.lastIndex=0,typeof K=="string"&&j.test(K)?W:null}}catch{return t}}function _(W,j,K){return!W||typeof j!="string"?!1:F(W)(j,void 0,K)}e.match=_;function F(W,j={}){if(!W)return o;if(typeof W=="string"||N(W)){const K=r(W,j);if(K===t)return o;const ee=function(ce,J){return!!K(ce,J)};return K.allBasenames&&(ee.allBasenames=K.allBasenames),K.allPaths&&(ee.allPaths=K.allPaths),ee}return $(W,j)}e.parse=F;function N(W){const j=W;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=N;function L(W){return W.allBasenames||[]}e.getBasenameTerms=L;function U(W){return W.allPaths||[]}e.getPathTerms=U;function $(W,j){const K=q(Object.getOwnPropertyNames(W).map(M=>H(M,W[M],j)).filter(M=>M!==t)),ee=K.length;if(!ee)return t;if(!K.some(M=>!!M.requiresSiblings)){if(ee===1)return K[0];const M=function(z,Y){let ne;for(let X=0,te=K.length;X<te;X++){const re=K[X](z,Y);if(typeof re=="string")return re;(0,i.isThenable)(re)&&(ne||(ne=[]),ne.push(re))}return ne?(async()=>{for(const X of ne){const te=await X;if(typeof te=="string")return te}return null})():null},O=K.find(z=>!!z.allBasenames);O&&(M.allBasenames=O.allBasenames);const B=K.reduce((z,Y)=>Y.allPaths?z.concat(Y.allPaths):z,[]);return B.length&&(M.allPaths=B),M}const ce=function(M,O,B){let z,Y;for(let ne=0,X=K.length;ne<X;ne++){const te=K[ne];te.requiresSiblings&&B&&(O||(O=(0,T.basename)(M)),z||(z=O.substr(0,O.length-(0,T.extname)(M).length)));const re=te(M,O,z,B);if(typeof re=="string")return re;(0,i.isThenable)(re)&&(Y||(Y=[]),Y.push(re))}return Y?(async()=>{for(const ne of Y){const X=await ne;if(typeof X=="string")return X}return null})():null},J=K.find(M=>!!M.allBasenames);J&&(ce.allBasenames=J.allBasenames);const Q=K.reduce((M,O)=>O.allPaths?M.concat(O.allPaths):M,[]);return Q.length&&(ce.allPaths=Q),ce}function H(W,j,K){if(j===!1)return t;const ee=r(W,K);if(ee===t)return t;if(typeof j=="boolean")return ee;if(j){const ce=j.when;if(typeof ce=="string"){const J=(Q,M,O,B)=>{if(!B||!ee(Q,M))return null;const z=ce.replace("$(basename)",O),Y=B(z);return(0,i.isThenable)(Y)?Y.then(ne=>ne?W:null):Y?W:null};return J.requiresSiblings=!0,J}}return ee}function q(W,j){const K=W.filter(M=>!!M.basenames);if(K.length<2)return W;const ee=K.reduce((M,O)=>{const B=O.basenames;return B?M.concat(B):M},[]);let ce;if(j){ce=[];for(let M=0,O=ee.length;M<O;M++)ce.push(j)}else ce=K.reduce((M,O)=>{const B=O.patterns;return B?M.concat(B):M},[]);const J=function(M,O){if(typeof M!="string")return null;if(!O){let z;for(z=M.length;z>0;z--){const Y=M.charCodeAt(z-1);if(Y===47||Y===92)break}O=M.substr(z)}const B=ee.indexOf(O);return B!==-1?ce[B]:null};J.basenames=ee,J.patterns=ce,J.allBasenames=ee;const Q=W.filter(M=>!M.basenames);return Q.push(J),Q}function x(W,j){return(0,D.equals)(W,j,(K,ee)=>typeof K=="string"&&typeof ee=="string"?K===ee:typeof K!="string"&&typeof ee!="string"?K.base===ee.base&&K.pattern===ee.pattern:!1)}e.patternsEquals=x}),define(se[143],oe([0,1,8]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(b){return b.toJSON()}class R{constructor(E){this._uriTransformer=E}transformIncoming(E){const p=this._uriTransformer.transformIncoming(E);return p===E?E:i(D.URI.from(p))}transformOutgoing(E){const p=this._uriTransformer.transformOutgoing(E);return p===E?E:i(D.URI.from(p))}transformOutgoingURI(E){const p=this._uriTransformer.transformOutgoing(E);return p===E?E:D.URI.from(p)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function k(b,E,p){if(!b||p>200)return null;if(typeof b=="object"){if(b instanceof D.URI)return E.transformOutgoing(b);for(const v in b)if(Object.hasOwnProperty.call(b,v)){const f=k(b[v],E,p+1);f!==null&&(b[v]=f)}}return null}function T(b,E){const p=k(b,E,0);return p===null?b:p}e.transformOutgoingURIs=T;function I(b,E,p,v){if(!b||v>200)return null;if(typeof b=="object"){if(b.$mid===1)return p?D.URI.revive(E.transformIncoming(b)):E.transformIncoming(b);for(const f in b)if(Object.hasOwnProperty.call(b,f)){const m=I(b[f],E,p,v+1);m!==null&&(b[f]=m)}}return null}function P(b,E){const p=I(b,E,!1,0);return p===null?b:p}e.transformIncomingURIs=P;function w(b,E){const p=I(b,E,!0,0);return p===null?b:p}e.transformAndReviveIncomingURIs=w}),define(se[144],oe([0,1,34,11,49,30,130]),function(Z,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(b){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(b)}value(){if(this._value===void 0){let b=0,E=0;const p=(0,D.networkInterfaces)();for(const v in p){const f=p[v];if(f)for(const{mac:m,internal:y}of f)y||(E+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(b+=1))}this._value=E>0?b/E:0}return this._value}};let I;async function P(){return I||(I=(async()=>await w()||k.generateUuid())()),I}e.getMachineId=P;async function w(){try{const b=await new Promise((p,v)=>{Z(["crypto"],p,v)}),E=(0,T.getMac)();return b.createHash("sha256").update(E,"utf8").digest("hex")}catch(b){i.onUnexpectedError(b);return}}}),define(se[28],oe([0,1,53,34,282,6,48,83,12,5,20,8]),function(Z,e,D,i,R,k,T,I,P,w,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function v($,H=p.UNLINK){if((0,T.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return H===p.UNLINK?m($):f($)}async function f($){try{const H=(0,T.randomPath)((0,i.tmpdir)());try{await D.promises.rename($,H)}catch(q){return q.code==="ENOENT"?void 0:m($)}m(H).catch(q=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function m($){return(0,R.promisify)(D.rm)($,{recursive:!0,force:!0,maxRetries:3})}function y($){if((0,T.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync($,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function u($,H){return h(await(H?S($):(0,R.promisify)(D.readdir)($)))}async function S($){try{return await(0,R.promisify)(D.readdir)($,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const H=[],q=await u($);for(const x of q){let W=!1,j=!1,K=!1;try{const ee=await e.Promises.lstat((0,P.join)($,x));W=ee.isFile(),j=ee.isDirectory(),K=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}H.push({name:x,isFile:()=>W,isDirectory:()=>j,isSymbolicLink:()=>K})}return H}function c($){return h(D.readdirSync($))}e.readdirSync=c;function h($){return $.map(H=>typeof H=="string"?w.isMacintosh?(0,I.normalizeNFC)(H):H:(H.name=w.isMacintosh?(0,I.normalizeNFC)(H.name):H.name,H))}async function d($){const H=await u($),q=[];for(const x of H)await o.existsDirectory((0,P.join)($,x))&&q.push(x);return q}function n($,H=1e3){return new Promise(q=>{let x=!1;const W=setInterval(()=>{x||(x=!0,D.access($,j=>{x=!1,j&&(clearInterval(W),q(void 0))}))},H)})}e.whenDeleted=n;var o;(function($){async function H(W){let j;try{if(j=await e.Promises.lstat(W),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(w.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw ee}throw K}}$.stat=H;async function q(W){try{const{stat:j,symbolicLink:K}=await $.stat(W);return j.isFile()&&K?.dangling!==!0}catch{}return!1}$.existsFile=q;async function x(W){try{const{stat:j,symbolicLink:K}=await $.stat(W);return j.isDirectory()&&K?.dangling!==!0}catch{}return!1}$.existsDirectory=x})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new k.ResourceQueue;function r($,H,q){return t.queueFor(E.URI.file($),b.extUriBiasedIgnorePathCase).queue(()=>{const x=C(q);return new Promise((W,j)=>a($,H,x,K=>K?j(K):W()))})}let s=!0;function l($){s=$}e.configureFlushOnWrite=l;function a($,H,q,x){if(!s)return D.writeFile($,H,{mode:q.mode,flag:q.flag},x);D.open($,q.flag,q.mode,(W,j)=>{if(W)return x(W);D.writeFile(j,H,K=>{if(K)return D.close(j,()=>x(K));D.fdatasync(j,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),l(!1)),D.close(j,ce=>x(ce))))})})}function g($,H,q){const x=C(q);if(!s)return D.writeFileSync($,H,{mode:x.mode,flag:x.flag});const W=D.openSync($,x.flag,x.mode);try{D.writeFileSync(W,H);try{D.fdatasyncSync(W)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),l(!1)}}finally{D.closeSync(W)}}e.writeFileSync=g;function C($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function A($,H){if($!==H)try{await e.Promises.rename($,H)}catch(q){if($.toLowerCase()!==H.toLowerCase()&&q.code==="EXDEV"||$.endsWith("."))await V($,H,{preserveSymlinks:!1}),await v($,p.MOVE);else throw q}}async function V($,H,q){return F($,H,{root:{source:$,target:H},options:q,handledSourcePaths:new Set})}const _=511;async function F($,H,q){if(q.handledSourcePaths.has($))return;q.handledSourcePaths.add($);const{stat:x,symbolicLink:W}=await o.stat($);if(W){if(q.options.preserveSymlinks)try{return await U($,H,q)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(W.dangling)return}return x.isDirectory()?N($,H,x.mode&_,q):L($,H,x.mode&_)}async function N($,H,q,x){await e.Promises.mkdir(H,{recursive:!0,mode:q});const W=await u($);for(const j of W)await F((0,P.join)($,j),(0,P.join)(H,j),x)}async function L($,H,q){await e.Promises.copyFile($,H),await e.Promises.chmod(H,q)}async function U($,H,q){let x=await e.Promises.readlink($);(0,T.isEqualOrParent)(x,q.root.source,!w.isLinux)&&(x=(0,P.join)(q.root.target,x.substr(q.root.source.length+1))),await e.Promises.symlink(x,H)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return($,H,q,x,W)=>new Promise((j,K)=>{D.read($,H,q,x,W,(ee,ce,J)=>ee?K(ee):j({bytesRead:ce,buffer:J}))})}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return($,H,q,x,W)=>new Promise((j,K)=>{D.write($,H,q,x,W,(ee,ce,J)=>ee?K(ee):j({bytesWritten:ce,buffer:J}))})}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists($){try{return await e.Promises.access($),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return d}get writeFile(){return r}get rm(){return v}get move(){return A}get copy(){return V}}}),define(se[145],oe([0,1,53,12,5,27,28]),function(Z,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(p){if(R.isLinux)return p;const v=(0,i.dirname)(p);if(p===v)return p;const f=((0,i.basename)(p)||p).toLowerCase();try{const y=(0,T.readdirSync)(v).filter(u=>u.toLowerCase()===f);if(y.length===1){const u=I(v);if(u)return(0,i.join)(u,y[0])}else if(y.length>1){const u=y.indexOf(f);if(u>=0){const S=I(v);if(S)return(0,i.join)(S,y[u])}}}catch{}return null}e.realcaseSync=I;async function P(p){if(R.isLinux)return p;const v=(0,i.dirname)(p);if(p===v)return p;const f=((0,i.basename)(p)||p).toLowerCase();try{const y=(await T.Promises.readdir(v)).filter(u=>u.toLowerCase()===f);if(y.length===1){const u=await P(v);if(u)return(0,i.join)(u,y[0])}else if(y.length>1){const u=y.indexOf(f);if(u>=0){const S=await P(v);if(S)return(0,i.join)(S,y[u])}}}catch{}return null}e.realcase=P;async function w(p){try{return await T.Promises.realpath(p)}catch{const f=E(p);return await T.Promises.access(f,D.constants.R_OK),f}}e.realpath=w;function b(p){try{return D.realpathSync(p)}catch{const f=E(p);return D.accessSync(f,D.constants.R_OK),f}}e.realpathSync=b;function E(p){return(0,k.rtrim)((0,i.normalize)(p),i.sep)}}),define(se[89],oe([0,1,34,12,28]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,T=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var P;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(P||(P={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class E{constructor(d,n,o){this.exePath=d,this.displayName=n,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:h=!1}={}){return h?w===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:h=!1,findPreview:d=!1}={}){const n=p({useAlternateBitness:h});if(!n)return null;const o=i.join(n,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(o))return null;let t=-1,r=null;for(const a of await R.Promises.readdir(o)){let g=-1;if(d){const A=a.indexOf("-");if(A<0)continue;const V=a.substring(0,A);if(!k.test(V)||a.substring(A+1)!=="preview")continue;g=parseInt(V,10)}else{if(!k.test(a))continue;g=parseInt(a,10)}if(g<=t)continue;const C=i.join(o,a,"pwsh.exe");!await R.SymlinkSupport.existsFile(C)||(r=C,t=g)}if(!r)return null;const s=n.includes("x86")?" (x86)":"",l=d?" Preview":"";return new E(r,`PowerShell${l}${s}`,!0)}async function f({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const d=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(d))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=h?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(d))if(n.test(t)){const r=i.join(d,t,"pwsh.exe");return new E(r,o)}return null}function m(){const h=i.join(D.homedir(),".dotnet","tools","pwsh.exe");return new E(h,".NET Core PowerShell Global Tool")}function y(){const h=i.join(process.env.windir,w===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(h,"Windows PowerShell",!0)}async function*u(){let h=await v();h&&(yield h),h=await v({useAlternateBitness:!0}),h&&(yield h),h=await f(),h&&(yield h),h=m(),h&&(yield h),h=await v({findPreview:!0}),h&&(yield h),h=await f({findPreview:!0}),h&&(yield h),h=await v({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=y(),h&&(yield h)}async function*S(){for await(const h of u())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=S;async function c(){for await(const h of S())return h;return null}e.getFirstAvailablePowerShellInstallation=c}),define(se[90],oe([0,1,12,5,36,85,15,28]),function(Z,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function P(E=R.env){return E.comspec||"cmd.exe"}e.getWindowsShell=P;function w(E){let p=[],v=!1;const f=function(m){if(v){p.push(m);return}(!E.send(m,u=>{if(u&&console.error(u),v=!1,p.length>0){const S=p.slice(0);p=[],S.forEach(c=>f(c))}})||i.isWindows)&&(v=!0)};return{send:f}}e.createQueuedSender=w;var b;(function(E){async function p(v,f,m){if(D.isAbsolute(v))return v;if(f===void 0&&(f=R.cwd()),D.dirname(v)!=="."||(m===void 0&&T.isString(R.env.PATH)&&(m=R.env.PATH.split(D.delimiter)),m===void 0||m.length===0))return D.join(f,v);async function u(S){if(await I.Promises.exists(S)){let c;try{c=await I.Promises.stat(S)}catch(h){h.message.startsWith("EACCES")&&(c=await I.Promises.lstat(S))}return c?!c.isDirectory():!1}return!1}for(const S of m){let c;if(D.isAbsolute(S)?c=D.join(S,v):c=D.join(f,S,v),await u(c))return c;let h=c+".com";if(await u(h)||(h=c+".exe",await u(h)))return h}return D.join(f,v)}E.findExecutable=p})(b=e.win32||(e.win32={}))}),define(se[146],oe([0,1,50,23]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(T){return new Promise((I,P)=>{let w;const b=new Map;function E(v,f,m,y,u){const S=b.get(f);if(v===T||S){const c={name:p(m),cmd:m,pid:v,ppid:f,load:y,mem:u};b.set(v,c),v===T&&(w=c),S&&(S.children||(S.children=[]),S.children.push(c),S.children.length>1&&(S.children=S.children.sort((h,d)=>h.pid-d.pid)))}}function p(v){const f=/--vscode-window-kind=shared-process/,m=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,S=/--utility-sub-type=node.mojom.NodeService/,c=/--crashes-directory/,h=/\\pipe\\winpty-control/,d=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(c.exec(v))return"electron-crash-reporter";if(h.exec(v))return"winpty-process";if(d.exec(v))return"console-window-host (Windows internal process)";let o=n.exec(v);if(o&&o.length===2){if(o[1]==="renderer")return f.exec(v)?"shared-process":m.exec(v)?"issue-reporter":y.exec(v)?"process-explorer":"window";if(o[1]==="utility"){if(u.exec(v))return"utility-network-service";if(S.exec(v))return"extension-host"}return o[1]}const t=/[a-zA-Z-]+\.js/g;let r="";do o=t.exec(v),o&&(r+=o+" ");while(o);return r&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${r}`:v}if(process.platform==="win32"){const v=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,m)=>{Z(["windows-process-tree"],f,m)}).then(f=>{f.getProcessList(T,m=>{if(!m){P(new Error(`Root process ${T} not found`));return}f.getProcessCpuUsage(m,y=>{const u=new Map;y.forEach(S=>{const c=v(S.commandLine||"");u.set(S.pid,{name:p(c),cmd:c,pid:S.pid,ppid:S.ppid,load:S.cpu||0,mem:S.memory||0})}),w=u.get(T),w?(u.forEach(S=>{const c=u.get(S.ppid);c&&(c.children||(c.children=[]),c.children.push(S))}),u.forEach(S=>{S.children&&(S.children=S.children.sort((c,h)=>c.pid-h.pid))}),I(w)):P(new Error(`Root process ${T} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let v=function(){let f=[w];const m=[];for(;f.length;){const u=f.shift();u&&(m.push(u.pid),u.children&&(f=f.concat(u.children)))}let y=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Z).fsPath);y+=" "+m.join(" "),(0,D.exec)(y,{},(u,S,c)=>{if(u||c)P(u||new Error(c.toString()));else{const h=S.toString().split(`
`);for(let d=0;d<m.length;d++){const n=b.get(m[d]);n.load=parseFloat(h[d])}if(!w){P(new Error(`Root process ${T} not found`));return}I(w)}})};(0,D.exec)("which ps",{},(f,m,y)=>{if(f||y)if(process.platform!=="linux")P(f||new Error(y.toString()));else{const u=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh",Z).fsPath);(0,D.exec)(u,{},(S,c,h)=>{S||h?P(S||new Error(h.toString())):(k(c,E),v())})}else{const u=m.toString().trim(),S="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${u} ${S}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,h,d)=>{c||d&&!d.includes("screen size is bogus")?P(c||new Error(d.toString())):(k(h,E),process.platform==="linux"?v():w?I(w):P(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=R;function k(T,I){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=T.toString().split(`
`);for(const b of w){const E=P.exec(b.trim());E&&E.length===6&&I(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(se[147],oe([0,1,34,5,89,90]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(v,f){return v===1?i.isWindows?E():k.getWindowsShell(f):w(v,f)}e.getSystemShell=T;function I(v,f){return v===1?i.isWindows?p(f):k.getWindowsShell(f):w(v,f)}e.getSystemShellSync=I;let P=null;function w(v,f){if(i.isLinux&&v===2||i.isMacintosh&&v===3)return"/bin/bash";if(!P){let m;if(i.isWindows)m="/bin/bash";else{if(m=f.SHELL,!m)try{m=(0,D.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}P=m}return P}let b=null;async function E(){return b||(b=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),b}function p(v){if(b)return b;const f=i.isWindows&&parseFloat((0,D.release)())>=10,m=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${v.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?y:k.getWindowsShell(v)}});var ve=this&&this.__decorate||function(Z,e,D,i){var R=arguments.length,k=R<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,D):i,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(Z,e,D,i);else for(var I=Z.length-1;I>=0;I--)(T=Z[I])&&(k=(R<3?T(k):R>3?T(e,D,k):T(e,D))||k);return R>3&&k&&Object.defineProperty(e,D,k),k};define(se[39],oe([0,1,19,6,17,22,63,11,3,2,67,27,15]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var v;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(v||(v={}));function f(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(m||(m={}));function y(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(u||(u={}));class S{constructor(j){this.buffer=j,this.pos=0}read(j){const K=this.buffer.slice(this.pos,this.pos+j);return this.pos+=K.byteLength,K}}class c{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var h;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(h||(h={}));function d(W){const j=R.VSBuffer.alloc(4);return j.writeUInt32BE(W,0),j}function n(W){return W.read(4).readUInt32BE(0)}function o(W){const j=R.VSBuffer.alloc(1);return j.writeUInt8(W,0),j}const t={Undefined:o(h.Undefined),String:o(h.String),Buffer:o(h.Buffer),VSBuffer:o(h.VSBuffer),Array:o(h.Array),Object:o(h.Object)},r=typeof Buffer<"u";function s(W,j){if(typeof j>"u")W.write(t.Undefined);else if(typeof j=="string"){const K=R.VSBuffer.fromString(j);W.write(t.String),W.write(d(K.byteLength)),W.write(K)}else if(r&&Buffer.isBuffer(j)){const K=R.VSBuffer.wrap(j);W.write(t.Buffer),W.write(d(K.byteLength)),W.write(K)}else if(j instanceof R.VSBuffer)W.write(t.VSBuffer),W.write(d(j.byteLength)),W.write(j);else if(Array.isArray(j)){W.write(t.Array),W.write(d(j.length));for(const K of j)s(W,K)}else{const K=R.VSBuffer.fromString(JSON.stringify(j));W.write(t.Object),W.write(d(K.byteLength)),W.write(K)}}function l(W){switch(W.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return W.read(n(W)).toString();case h.Buffer:return W.read(n(W)).buffer;case h.VSBuffer:return W.read(n(W));case h.Array:{const K=n(W),ee=[];for(let ce=0;ce<K;ce++)ee.push(l(W));return ee}case h.Object:return JSON.parse(W.read(n(W)).toString())}}class a{constructor(j,K,ee=null,ce=1e3){this.protocol=j,this.ctx=K,this.logger=ee,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(j,K){this.channels.set(j,K),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const K=this.send([j.type]);this.logger?.logOutgoing(K,0,1,y(j.type));return}case 201:case 202:case 204:case 203:{const K=this.send([j.type,j.id],j.data);this.logger?.logOutgoing(K,j.id,1,y(j.type),j.data);return}}}send(j,K=void 0){const ee=new c;return s(ee,j),s(ee,K),this.sendBuffer(ee.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onRawMessage(j){const K=new S(j),ee=l(K),ce=l(K),J=ee[0];switch(J){case 100:return this.logger?.logIncoming(j.byteLength,ee[1],1,`${f(J)}: ${ee[2]}.${ee[3]}`,ce),this.onPromise({type:J,id:ee[1],channelName:ee[2],name:ee[3],arg:ce});case 102:return this.logger?.logIncoming(j.byteLength,ee[1],1,`${f(J)}: ${ee[2]}.${ee[3]}`,ce),this.onEventListen({type:J,id:ee[1],channelName:ee[2],name:ee[3],arg:ce});case 101:return this.logger?.logIncoming(j.byteLength,ee[1],1,`${f(J)}`),this.disposeActiveRequest({type:J,id:ee[1]});case 103:return this.logger?.logIncoming(j.byteLength,ee[1],1,`${f(J)}`),this.disposeActiveRequest({type:J,id:ee[1]})}}onPromise(j){const K=this.channels.get(j.channelName);if(!K){this.collectPendingRequest(j);return}const ee=new k.CancellationTokenSource;let ce;try{ce=K.call(this.ctx,j.name,j.arg,ee.token)}catch(M){ce=Promise.reject(M)}const J=j.id;ce.then(M=>{this.sendResponse({id:J,data:M,type:201}),this.activeRequests.delete(j.id)},M=>{M instanceof Error?this.sendResponse({id:J,data:{message:M.message,name:M.name,stack:M.stack?M.stack.split?M.stack.split(`
`):M.stack:void 0},type:202}):this.sendResponse({id:J,data:M,type:203}),this.activeRequests.delete(j.id)});const Q=(0,w.toDisposable)(()=>ee.cancel());this.activeRequests.set(j.id,Q)}onEventListen(j){const K=this.channels.get(j.channelName);if(!K){this.collectPendingRequest(j);return}const ee=j.id,J=K.listen(this.ctx,j.name,j.arg)(Q=>this.sendResponse({id:ee,data:Q,type:204}));this.activeRequests.set(j.id,J)}disposeActiveRequest(j){const K=this.activeRequests.get(j.id);K&&(K.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let K=this.pendingRequests.get(j.channelName);K||(K=[],this.pendingRequests.set(j.channelName,K));const ee=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:j,timeoutTimer:ee})}flushPendingRequests(j){const K=this.pendingRequests.get(j);if(K){for(const ee of K)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.onPromise(ee.request);break;case 102:this.onEventListen(ee.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var g;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class C{constructor(j,K=null){this.protocol=j,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new P.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=K}getChannel(j){const K=this;return{call(ee,ce,J){return K.isDisposed?Promise.reject(new I.CancellationError):K.requestPromise(j,ee,ce,J)},listen(ee,ce){return K.isDisposed?P.Event.None:K.requestEvent(j,ee,ce)}}}requestPromise(j,K,ee,ce=k.CancellationToken.None){const J=this.lastRequestId++,M={id:J,type:100,channelName:j,name:K,arg:ee};if(ce.isCancellationRequested)return Promise.reject(new I.CancellationError);let O;return new Promise((z,Y)=>{if(ce.isCancellationRequested)return Y(new I.CancellationError);const ne=()=>{const le=ue=>{switch(ue.type){case 201:this.handlers.delete(J),z(ue.data);break;case 202:{this.handlers.delete(J);const Se=new Error(ue.data.message);Se.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,Se.name=ue.data.name,Y(Se);break}case 203:this.handlers.delete(J),Y(ue.data);break}};this.handlers.set(J,le),this.sendRequest(M)};let X=null;this.state===u.Idle?ne():(X=(0,i.createCancelablePromise)(le=>this.whenInitialized()),X.then(()=>{X=null,ne()}));const te=()=>{X?(X.cancel(),X=null):this.sendRequest({id:J,type:101}),Y(new I.CancellationError)},re=ce.onCancellationRequested(te);O=(0,w.combinedDisposable)((0,w.toDisposable)(te),re),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(j,K,ee){const ce=this.lastRequestId++,Q={id:ce,type:102,channelName:j,name:K,arg:ee};let M=null;const O=new P.Emitter({onWillAddFirstListener:()=>{M=(0,i.createCancelablePromise)(z=>this.whenInitialized()),M.then(()=>{M=null,this.activeRequests.add(O),this.sendRequest(Q)})},onDidRemoveLastListener:()=>{M?(M.cancel(),M=null):(this.activeRequests.delete(O),this.sendRequest({id:ce,type:103}))}}),B=z=>O.fire(z.data);return this.handlers.set(ce,B),O.event}sendRequest(j){switch(j.type){case 100:case 102:{const K=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger?.logOutgoing(K,j.id,0,`${f(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const K=this.send([j.type,j.id]);this.logger?.logOutgoing(K,j.id,0,f(j.type));return}}}send(j,K=void 0){const ee=new c;return s(ee,j),s(ee,K),this.sendBuffer(ee.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onBuffer(j){const K=new S(j),ee=l(K),ce=l(K),J=ee[0];switch(J){case 200:return this.logger?.logIncoming(j.byteLength,0,0,y(J)),this.onResponse({type:ee[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(j.byteLength,ee[1],0,y(J),ce),this.onResponse({type:ee[0],id:ee[1],data:ce})}}onResponse(j){if(j.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(j.id)?.(j)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([T.memoize],C.prototype,"onDidInitializePromise",null),e.ChannelClient=C;class A{get connections(){const j=[];return this._connections.forEach(K=>j.push(K)),j}constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new P.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new P.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:K,onDidClientDisconnect:ee})=>{P.Event.once(K.onMessage)(J=>{const Q=new S(J),M=l(Q),O=new a(K,M),B=new C(K);this.channels.forEach((Y,ne)=>O.registerChannel(ne,Y));const z={channelServer:O,channelClient:B,ctx:M};this._connections.add(z),this._onDidAddConnection.fire(z),ee(()=>{O.dispose(),B.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)})})})}getChannel(j,K){const ee=this;return{call(ce,J,Q){let M;if((0,p.isFunction)(K)){const B=(0,D.getRandomElement)(ee.connections.filter(K));M=B?Promise.resolve(B):P.Event.toPromise(P.Event.filter(ee.onDidAddConnection,K))}else M=K.routeCall(ee,ce,J);const O=M.then(B=>B.channelClient.getChannel(j));return _(O).call(ce,J,Q)},listen(ce,J){if((0,p.isFunction)(K))return ee.getMulticastEvent(j,K,ce,J);const Q=K.routeEvent(ee,ce,J).then(M=>M.channelClient.getChannel(j));return _(Q).listen(ce,J)}}}getMulticastEvent(j,K,ee,ce){const J=this;let Q=new w.DisposableStore;const M=new P.Emitter({onWillAddFirstListener:()=>{Q=new w.DisposableStore;const O=new P.EventMultiplexer,B=new Map,z=ne=>{const te=ne.channelClient.getChannel(j).listen(ee,ce),re=O.add(te);B.set(ne,re)},Y=ne=>{const X=B.get(ne);!X||(X.dispose(),B.delete(ne))};J.connections.filter(K).forEach(z),P.Event.filter(J.onDidAddConnection,K)(z,void 0,Q),J.onDidRemoveConnection(Y,void 0,Q),O.event(M.fire,M,Q),Q.add(O)},onDidRemoveLastListener:()=>{Q.dispose()}});return M.event}registerChannel(j,K){this.channels.set(j,K),this._connections.forEach(ee=>{ee.channelServer.registerChannel(j,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class V{constructor(j,K,ee=null){const ce=new c;s(ce,K),j.send(ce.buffer),this.channelClient=new C(j,ee),this.channelServer=new a(j,K,ee)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,K){this.channelServer.registerChannel(j,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=V;function _(W){return{call(j,K,ee){return W.then(ce=>ce.call(j,K,ee))},listen(j,K){const ee=new P.Relay;return W.then(ce=>ee.input=ce.listen(j,K)),ee.event}}}e.getDelayedChannel=_;function F(W){let j=!1;return{call(K,ee,ce){return j?W.call(K,ee,ce):(0,i.timeout)(0).then(()=>j=!0).then(()=>W.call(K,ee,ce))},listen(K,ee){if(j)return W.listen(K,ee);const ce=new P.Relay;return(0,i.timeout)(0).then(()=>j=!0).then(()=>ce.input=W.listen(K,ee)),ce.event}}}e.getNextTickChannel=F;class N{constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const K of j.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await P.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=N;var L;(function(W){function j(J,Q){const M=J,O=Q&&Q.disableMarshalling,B=new Map;for(const z in M)ee(z)&&B.set(z,P.Event.buffer(M[z],!0));return new class{listen(z,Y,ne){const X=B.get(Y);if(X)return X;if(ce(Y)){const te=M[Y];if(typeof te=="function")return te.call(M,ne)}throw new Error(`Event not found: ${Y}`)}call(z,Y,ne){const X=M[Y];if(typeof X=="function"){if(!O&&Array.isArray(ne))for(let te=0;te<ne.length;te++)ne[te]=(0,b.revive)(ne[te]);return X.apply(M,ne)}throw new Error(`Method not found: ${Y}`)}}}W.fromService=j;function K(J,Q){const M=Q&&Q.disableMarshalling;return new Proxy({},{get(O,B){if(typeof B=="string")return Q?.properties?.has(B)?Q.properties.get(B):ce(B)?function(z){return J.listen(B,z)}:ee(B)?J.listen(B):async function(...z){let Y;Q&&!(0,p.isUndefinedOrNull)(Q.context)?Y=[Q.context,...z]:Y=z;const ne=await J.call(B,Y);return M?ne:(0,b.revive)(ne)};throw new Error(`Property not found: ${String(B)}`)}})}W.toService=K;function ee(J){return J[0]==="o"&&J[1]==="n"&&E.isUpperAsciiLetter(J.charCodeAt(2))}function ce(J){return/^onDynamic/.test(J)&&E.isUpperAsciiLetter(J.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const j=W.toString();if(j!=="[object Object]")return j}return W}function H(W){return Array.isArray(W)?W.map($):$(W)}function q(W,j,K,ee,ce,J,Q){Q=H(Q);const M=U[ce],O=M[ee%M.length];let B=[`%c[${W}]%c[${String(j).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(J)?(B=B.concat(Q),B.push(")")):B.push(Q),console.log.apply(console,B)}class x{constructor(j,K){this._outgoingPrefix=j,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,K,ee,ce,J){this._totalOutgoing+=j,q(this._outgoingPrefix,this._totalOutgoing,j,K,ee,ce,J)}logIncoming(j,K,ee,ce,J){this._totalIncoming+=j,q(this._incomingPrefix,this._totalIncoming,j,K,ee,ce,J)}}e.IPCLogger=x}),define(se[148],oe([0,1,17,3,39]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(P){this.port=P,this.onMessage=i.Event.fromDOMEventEmitter(this.port,"message",w=>D.VSBuffer.wrap(w.data)),P.start()}send(P){this.port.postMessage(P.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class T extends R.IPCClient{constructor(P,w){const b=new k(P);super(b,w),this.protocol=b}dispose(){this.protocol.disconnect()}}e.Client=T}),define(se[91],oe([0,1,17,3,2,39]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(r){r.enableDiagnostics=!1,r.records=[];const s=new WeakMap;let l=0;function a(C,A){if(!s.has(C)){const V=String(++l);s.set(C,V)}return s.get(C)}function g(C,A,V,_){if(!r.enableDiagnostics)return;const F=a(C,A);if(_ instanceof D.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const N=D.VSBuffer.alloc(_.byteLength);N.set(_),r.records.push({timestamp:Date.now(),id:F,label:A,type:V,buff:N})}else r.records.push({timestamp:Date.now(),id:F,label:A,type:V,data:_})}r.traceSocketEvent=g})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var P;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function b(){return w||(w=D.VSBuffer.alloc(0)),w}class E{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,l){if(s===0)return b();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const A=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=s),A}if(this._chunks[0].byteLength>s){const A=this._chunks[0].slice(0,s);return l&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),A}const a=D.VSBuffer.alloc(s);let g=0,C=0;for(;s>0;){const A=this._chunks[C];if(A.byteLength>s){const V=A.slice(0,s);a.set(V,g),g+=s,l&&(this._chunks[C]=A.slice(s),this._totalLength-=s),s-=s}else a.set(A,g),g+=A.byteLength,l?(this._chunks.shift(),this._totalLength-=A.byteLength):C++,s-=A.byteLength}return a}}e.ChunkStream=E;var p;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(p||(p={}));function v(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(s,l,a,g){this.type=s,this.id=l,this.ack=a,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends R.Disposable{constructor(s){super(),this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,g=this._state.id,C=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new m(a,g,C,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=D.VSBuffer.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:v(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(l,s.data)}_bufferAdd(s,l){const a=this._totalLength===0;return this._data.push(s,l),this._totalLength+=s.byteLength+l.byteLength,a}_bufferTake(){const s=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,l){this._bufferAdd(s,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class S extends R.Disposable{constructor(s){super(),this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new m(1,0,0,s))}}e.Protocol=S;class c extends k.IPCClient{static fromSocket(s,l){return new c(new S(s),l)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,l,a=null){super(s,l,a),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=c;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class d{constructor(s){this.data=s,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let s=0,l=this._first;for(;l;)l=l.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let l=0,a=this._first;for(;a;)s[l++]=a.data,a=a.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const l=new d(s);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class o{static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let l=0;l<o._HISTORY_LENGTH;l++)this.lastRuns[l]=s-1e3*l;setInterval(()=>{for(let l=o._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),l=(1+o._HISTORY_LENGTH)*1e3;let a=0;for(let g=0;g<o._HISTORY_LENGTH;g++)s-this.lastRuns[g]<=l&&a++;return 1-a/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class t{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,l=null,a=o.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.push(this._socket.onClose(g=>this._onSocketClose.fire(g))),l&&this._socketReader.acceptChunk(l),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new m(5,0,0,b());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new m(7,0,0,b());this._socketWriter.write(s)}sendResume(){const s=new m(8,0,0,b());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,l){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new m(3,0,this._incomingAckId,b());this._socketWriter.write(s);const l=this._outgoingUnackMsg.toArray();for(let a=0,g=l.length;a<g;a++)this._socketWriter.write(l[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new m(6,0,0,b())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let a=0,g=l.length;a<g;a++)this._socketWriter.write(l[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new m(1,l,this._incomingAckId,s);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(s){const l=new m(2,0,0,s);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),l=Date.now()-s.writtenTime,a=Date.now()-this._socketReader.lastReadTime,g=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&a>=2e4&&g>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:a});return}const C=Math.max(2e4-l,2e4-a,2e4-g,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},C)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new m(3,0,this._incomingAckId,b());this._socketWriter.write(s)}_sendKeepAlive(){const s=new m(9,0,0,b());this._socketWriter.write(s)}}e.PersistentProtocol=t}),define(se[149],oe([0,1,92,3,39,148]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends R.IPCServer{static getOnDidClientConnect(){const P=i.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(w,b)=>b);return i.Event.map(P,w=>{const{port1:b,port2:E}=new MessageChannel,v={protocol:new k.Protocol(b),onDidClientDisconnect:i.Event.fromDOMEventEmitter(b,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",w,[E]),v})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(se[68],oe([0,1,50,6,17,22,142,11,3,2,32,90,85,39]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends v.ChannelServer{constructor(u){super({send:S=>{try{process.send?.(S.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",S=>R.VSBuffer.wrap(Buffer.from(S,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=f;class m{constructor(u,S){this.modulePath=u,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new i.Delayer(c),this.child=null,this._client=null}getChannel(u){const S=this;return{call(c,h,d){return S.requestPromise(u,c,h,d)},listen(c,h){return S.requestEvent(u,c,h)}}}requestPromise(u,S,c,h=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const d=this.getCachedChannel(u),n=(0,i.createCancelablePromise)(r=>d.call(S,c,r)),o=h.onCancellationRequested(()=>n.cancel()),t=(0,w.toDisposable)(()=>n.cancel());return this.activeRequests.add(t),n.finally(()=>{o.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(u,S,c){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let h;const d=new P.Emitter({onWillAddFirstListener:()=>{h=this.getCachedChannel(u).listen(S,c)(d.fire,d),this.activeRequests.add(h)},onDidRemoveLastListener:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return d.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,p.removeDangerousEnvVariables)(S.env),this.child=(0,D.fork)(this.modulePath,u,S);const c=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,T.isRemoteConsoleLog)(s)){(0,T.log)(s,`IPC Library: ${this.options.serverName}`);return}c.fire(R.VSBuffer.wrap(Buffer.from(s,"base64")))});const d=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,n=s=>this.child&&this.child.connected&&d.send(s.buffer.toString("base64")),o=c.event,t={send:n,onMessage:o};this._client=new v.ChannelClient(t);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,l)=>{process.removeListener("exit",r),this.activeRequests.forEach(a=>(0,w.dispose)(a)),this.activeRequests.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+l),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:l})})}return this._client}getCachedChannel(u){let S=this.channels.get(u);return S||(S=this.client.getChannel(u),this.channels.set(u,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(se[150],oe([0,1,17,11,3,2,12,5,30,39,91]),function(Z,e,D,i,R,k,T,I,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function E(){return{crypto:Z.__$__nodeRequire("crypto"),zlib:Z.__$__nodeRequire("zlib"),net:Z.__$__nodeRequire("net"),os:Z.__$__nodeRequire("os")}}class p{traceSocketEvent(a,g){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,g)}constructor(a,g=""){this._canWrite=!0,this.debugLabel=g,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,i.onUnexpectedError)(C)}},this.socket.on("error",this._errorListener),this._closeListener=C=>{this.traceSocketEvent("close",{hadError:C}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(a){const g=C=>{this.traceSocketEvent("read",C),a(D.VSBuffer.wrap(C))};return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(a){const g=C=>{a({type:0,hadError:C,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(a){const g=()=>{a()};return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(a){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,i.onUnexpectedError)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,i.onUnexpectedError)(g)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,g)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.NodeSocket=p;var v;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var f;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(f||(f={}));class m extends k.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,g){this.socket.traceSocketEvent(a,g)}constructor(a,g,C,A){super(),this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:g,inflateBytesLength:C?.byteLength||0,recordInflateBytes:A}),this._flowManager=this._register(new y(this,g,C,A,this._onData,(V,_)=>this._write(V,_))),this._register(this._flowManager.onError(V=>{console.error(V),(0,i.onUnexpectedError)(V),this._onClose.fire({type:0,hadError:!0,error:V})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(V=>this._acceptChunk(V))),this._register(this.socket.onClose(V=>this._onClose.fire(V)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,g){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let C=2;a.byteLength<126?C+=0:a.byteLength<2**16?C+=2:C+=8;const A=D.VSBuffer.alloc(C);if(g?A.writeUInt8(194,0):A.writeUInt8(130,0),a.byteLength<126)A.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){A.writeUInt8(126,1);let V=1;A.writeUInt8(a.byteLength>>>8&255,++V),A.writeUInt8(a.byteLength>>>0&255,++V)}else{A.writeUInt8(127,1);let V=1;A.writeUInt8(0,++V),A.writeUInt8(0,++V),A.writeUInt8(0,++V),A.writeUInt8(0,++V),A.writeUInt8(a.byteLength>>>24&255,++V),A.writeUInt8(a.byteLength>>>16&255,++V),A.writeUInt8(a.byteLength>>>8&255,++V),A.writeUInt8(a.byteLength>>>0&255,++V)}this.socket.write(D.VSBuffer.concat([A,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const g=this._incomingData.peek(this._state.readLen),C=g.readUInt8(0),A=(C&128)>>>7,V=(C&64)>>>6,_=g.readUInt8(1),F=(_&128)>>>7,N=_&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(V)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const g=this._incomingData.read(this._state.readLen),C=g.readUInt8(1),A=(C&128)>>>7;let V=C&127,_=1;V===126?V=g.readUInt8(++_)*2**8+g.readUInt8(++_):V===127&&(V=g.readUInt8(++_)*0+g.readUInt8(++_)*0+g.readUInt8(++_)*0+g.readUInt8(++_)*0+g.readUInt8(++_)*2**24+g.readUInt8(++_)*2**16+g.readUInt8(++_)*2**8+g.readUInt8(++_));let F=0;A&&(F=g.readUInt8(++_)*2**24+g.readUInt8(++_)*2**16+g.readUInt8(++_)*2**8+g.readUInt8(++_)),this._state.state=3,this._state.readLen=V,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const g=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",g),c(g,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",g),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(g,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=m;class y extends k.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(a,g,C,A,V,_){super(),this._tracer=a,this._onData=V,this._writeFn=_,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,g?(this._zlibInflateStream=this._register(new u(this._tracer,A,C,{windowBits:15})),this._zlibDeflateStream=this._register(new S(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const g=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(g,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,g){return new Promise((C,A)=>{a.write(g),a.flush(V=>C(V))})}acceptFrame(a,g,C){this._readQueue.push({data:a,isCompressed:g,isLastFrameOfMessage:C}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const g=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(g)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,g,C){return new Promise((A,V)=>{a.write(g),C&&a.write(D.VSBuffer.fromByteArray([0,0,255,255])),a.flush(_=>A(_))})}}class u extends k.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}constructor(a,g,C,A){super(),this._tracer=a,this._recordInflateBytes=g,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=E().zlib.createInflateRaw(A),this._zlibInflate.on("error",V=>{this._tracer.traceSocketEvent("zlibInflateError",{message:V?.message,code:V?.code}),this._onError.fire(V)}),this._zlibInflate.on("data",V=>{this._tracer.traceSocketEvent("zlibInflateData",V),this._pendingInflateData.push(D.VSBuffer.wrap(V))}),C&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this._zlibInflate.write(C.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const g=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(g)})}}class S extends k.Disposable{constructor(a,g){super(),this._tracer=a,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=E().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",C=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this._onError.fire(C)}),this._zlibDeflate.on("data",C=>{this._tracer.traceSocketEvent("zlibDeflateData",C),this._pendingDeflateData.push(D.VSBuffer.wrap(C))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let g=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,g=g.slice(0,g.byteLength-4),a(g)})}}function c(l,a){if(a===0)return;const g=l.byteLength>>>2;for(let N=0;N<g;N++){const L=l.readUInt32BE(N*4);l.writeUInt32BE(L^a,N*4)}const C=g*4,A=l.byteLength-C,V=a>>>24&255,_=a>>>16&255,F=a>>>8&255;A>=1&&l.writeUInt8(l.readUInt8(C)^V,C),A>=2&&l.writeUInt8(l.readUInt8(C+1)^_,C+1),A>=3&&l.writeUInt8(l.readUInt8(C+2)^F,C+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function d(){const l=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):a=(0,T.join)(E().os.tmpdir(),`vscode-ipc-${l}.sock`),o(a),a}e.createRandomIPCHandle=d;function n(l,a,g){const C=E().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${C}-${g}-${a}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${C.substr(0,8)}-${g}-${a}.sock`):A=(0,T.join)(l,`${g}-${a}.sock`),o(A),A}e.createStaticIPCHandle=n;function o(l){const a=h[I.platform];typeof a=="number"&&l.length>=a&&console.warn(`WARNING: IPC handle "${l}" is longer than ${a} chars, try a shorter --user-data-dir`)}class t extends w.IPCServer{static toClientConnectionEvent(a){const g=R.Event.fromNodeEventEmitter(a,"connection");return R.Event.map(g,C=>({protocol:new b.Protocol(new p(C,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(C,"close"))}))}constructor(a){super(t.toClientConnectionEvent(a)),this.server=a}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function r(l){return new Promise((a,g)=>{const C=E().net.createServer();C.on("error",g),C.listen(l,()=>{C.removeListener("error",g),a(new t(C))})})}e.serve=r;function s(l,a){return new Promise((g,C)=>{const A=E().net.createConnection(l,()=>{A.removeListener("error",C),g(b.Client.fromSocket(new p(A,`ipc-client${a}`),a))});A.once("error",C)})}e.connect=s}),define(se[69],oe([0,1,6,3,2,15]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function I(E){const p=E;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var P;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(P=e.StorageState||(e.StorageState={}));class w extends R.Disposable{constructor(p,v=Object.create(null)){super(),this.database=p,this.options=v,this._onDidChangeStorage=this._register(new i.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((v,f)=>this.accept(f,v)),p.deleted?.forEach(v=>this.accept(v,void 0))}accept(p,v){if(this.state===P.Closed)return;let f=!1;(0,k.isUndefinedOrNull)(v)?f=this.cache.delete(p):this.cache.get(p)!==v&&(this.cache.set(p,v),f=!0),f&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,v){const f=this.cache.get(p);return(0,k.isUndefinedOrNull)(f)?v:f}getBoolean(p,v){const f=this.get(p);return(0,k.isUndefinedOrNull)(f)?v:f==="true"}getNumber(p,v){const f=this.get(p);return(0,k.isUndefinedOrNull)(f)?v:parseInt(f,10)}async set(p,v){if(this.state===P.Closed)return;if((0,k.isUndefinedOrNull)(v))return this.delete(p);const f=String(v);if(this.cache.get(p)!==f)return this.cache.set(p,f),this.pendingInserts.set(p,f),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===P.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert?.forEach((v,f)=>this.items.set(f,v)),p.delete?.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=b}),define(se[151],oe([9,10]),function(Z,e){return Z.create("vs/base/node/zip",e)}),define(se[152],oe([9,10]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(se[153],oe([9,10]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(se[154],oe([9,10]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(se[155],oe([9,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(se[156],oe([9,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(se[157],oe([9,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(se[158],oe([9,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(se[159],oe([9,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(se[160],oe([9,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(se[161],oe([9,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(se[162],oe([9,10]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(se[163],oe([9,10]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(se[164],oe([9,10]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(se[165],oe([9,10]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(se[166],oe([9,10]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(se[167],oe([9,10]),function(Z,e){return Z.create("vs/platform/languagePacks/common/languagePacks",e)}),define(se[168],oe([9,10]),function(Z,e){return Z.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(se[169],oe([9,10]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(se[170],oe([9,10]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(se[171],oe([9,10]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(se[172],oe([9,10]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(se[173],oe([9,10]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalProfiles",e)}),define(se[174],oe([9,10]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(se[175],oe([9,10]),function(Z,e){return Z.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(se[176],oe([9,10]),function(Z,e){return Z.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(se[177],oe([9,10]),function(Z,e){return Z.create("vs/platform/userDataSync/common/settingsSync",e)}),define(se[178],oe([9,10]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(se[179],oe([9,10]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSync",e)}),define(se[180],oe([9,10]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(se[181],oe([9,10]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(se[182],oe([9,10]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(se[93],oe([0,1,65,63,23,12,36,20,8]),function(Z,e,D,i,R,k,T,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class w{get appRoot(){return(0,k.dirname)(R.FileAccess.asFileUri("",Z).fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return P.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get remoteTunnelLogResource(){return P.URI.file((0,k.join)(this.logsPath,"remoteTunnel.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(P.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=T.env.VSCODE_PORTABLE;return m?P.URI.file((0,k.join)(m,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,k.resolve)(m):(0,k.normalize)((0,k.join)(R.FileAccess.asFileUri("",Z).fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?P.URI.file((0,k.resolve)(m)):P.URI.file((0,k.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,k.resolve)(m);const y=T.env.VSCODE_EXTENSIONS;if(y)return y;const u=T.env.VSCODE_PORTABLE;return u?(0,k.join)(u,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(y=>/^[^:/?#]+?:\/\//.test(y)?P.URI.parse(y):P.URI.file((0,k.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?P.URI.parse(m):P.URI.file((0,k.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(m))}get extensionLogLevel(){const m=[];for(const y of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);u&&u[1]&&u[2]&&m.push([u[1],u[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return P.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=T.env.VSCODE_PORTABLE;return m?P.URI.file((0,k.join)(m,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this._args}constructor(m,y,u){this._args=m,this.paths=y,this.productService=u,this.editSessionId=this.args.editSessionId}}ve([i.memoize],w.prototype,"appRoot",null),ve([i.memoize],w.prototype,"userHome",null),ve([i.memoize],w.prototype,"userDataPath",null),ve([i.memoize],w.prototype,"appSettingsHome",null),ve([i.memoize],w.prototype,"tmpDir",null),ve([i.memoize],w.prototype,"cacheHome",null),ve([i.memoize],w.prototype,"stateResource",null),ve([i.memoize],w.prototype,"userRoamingDataHome",null),ve([i.memoize],w.prototype,"userDataSyncHome",null),ve([i.memoize],w.prototype,"userDataSyncLogResource",null),ve([i.memoize],w.prototype,"editSessionsLogResource",null),ve([i.memoize],w.prototype,"remoteTunnelLogResource",null),ve([i.memoize],w.prototype,"sync",null),ve([i.memoize],w.prototype,"machineSettingsResource",null),ve([i.memoize],w.prototype,"workspaceStorageHome",null),ve([i.memoize],w.prototype,"localHistoryHome",null),ve([i.memoize],w.prototype,"keyboardLayoutResource",null),ve([i.memoize],w.prototype,"argvResource",null),ve([i.memoize],w.prototype,"isExtensionDevelopment",null),ve([i.memoize],w.prototype,"untitledWorkspacesHome",null),ve([i.memoize],w.prototype,"installSourcePath",null),ve([i.memoize],w.prototype,"builtinExtensionsPath",null),ve([i.memoize],w.prototype,"extensionsPath",null),ve([i.memoize],w.prototype,"extensionDevelopmentLocationURI",null),ve([i.memoize],w.prototype,"extensionDevelopmentKind",null),ve([i.memoize],w.prototype,"extensionTestsLocationURI",null),ve([i.memoize],w.prototype,"debugExtensionHost",null),ve([i.memoize],w.prototype,"logLevel",null),ve([i.memoize],w.prototype,"extensionLogLevel",null),ve([i.memoize],w.prototype,"serviceMachineIdResource",null),ve([i.memoize],w.prototype,"telemetryLogResource",null),ve([i.memoize],w.prototype,"disableWorkspaceTrust",null),ve([i.memoize],w.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=w;function b(f,m){return v(f["inspect-extensions"],f["inspect-brk-extensions"],5870,m,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=b;function E(f,m){return v(f["inspect-search"],f["inspect-brk-search"],5876,m,f.extensionEnvironment)}e.parseSearchPort=E;function p(f,m){return v(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,m,f.extensionEnvironment)}e.parsePtyHostPort=p;function v(f,m,y,u,S,c){const d=Number(m||f)||(u?null:y),n=d?Boolean(!!m):!1;let o;if(c)try{o=JSON.parse(c)}catch{}return{port:d,break:n,debugId:S,env:o}}}),define(se[183],oe([0,1,283,5,153]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,R.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,R.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(12,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,R.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(17,null)},category:{type:"string",cat:"e",description:(0,R.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,R.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,R.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,R.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(m,y,u=T){const S=m.find(l=>l.length>0&&l[0]!=="-"),c={},h=["_"],d=[],n={};let o;for(const l in y){const a=y[l];a.type==="subcommand"?l===S&&(o=a):(a.alias&&(c[l]=a.alias),a.type==="string"||a.type==="string[]"?(h.push(l),a.deprecates&&h.push(...a.deprecates)):a.type==="boolean"&&(d.push(l),a.deprecates&&d.push(...a.deprecates)),a.global&&(n[l]=a))}if(o&&S){const l=n;for(const A in o.options)l[A]=o.options[A];const a=m.filter(A=>A!==S),g=u.getSubcommandReporter?u.getSubcommandReporter(S):void 0,C=I(a,l,g);return{[S]:C,_:[]}}const t=D(m,{string:h,boolean:d,alias:c}),r={},s=t;r._=t._.map(l=>String(l)).filter(l=>l.length>0),delete s._;for(const l in y){const a=y[l];if(a.type==="subcommand")continue;a.alias&&delete s[a.alias];let g=s[l];if(a.deprecates)for(const C of a.deprecates)s.hasOwnProperty(C)&&(g||(g=s[C],g&&u.onDeprecatedOption(C,a.deprecationMessage||(0,R.localize)(36,null,l))),delete s[C]);if(typeof g<"u"){if(a.type==="string[]"){if(Array.isArray(g)||(g=[g]),!a.allowEmptyValue){const C=g.filter(A=>A.length>0);C.length!==g.length&&(u.onEmptyValue(l),g=C.length>0?C:void 0)}}else a.type==="string"&&(Array.isArray(g)?(g=g.pop(),u.onMultipleValues(l,g)):!g&&!a.allowEmptyValue&&(u.onEmptyValue(l),g=void 0));r[l]=g,a.deprecationMessage&&u.onDeprecatedOption(l,a.deprecationMessage)}delete s[l]}for(const l in s)u.onUnknownOption(l);return r}e.parseArgs=I;function P(m,y){let u="";return y.args&&(Array.isArray(y.args)?u=` <${y.args.join("> <")}>`:u=` <${y.args}>`),y.alias?`-${y.alias} --${m}${u}`:`--${m}${u}`}function w(m,y){const u=[];for(const S in m){const c=m[S],h=P(S,c);u.push([h,c.description])}return b(u,y)}e.formatOptions=w;function b(m,y){const S=m.reduce((d,n)=>Math.max(d,n[0].length),12)+2+1;if(y-S<25)return m.reduce((d,n)=>d.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const c=y-S-1,h=[];for(const d of m){const n=d[0],o=p(d[1],c),t=E(S-n.length-2);h.push("  "+n+t+o[0]);for(let r=1;r<o.length;r++)h.push(E(S)+o[r])}return h}function E(m){return" ".repeat(m)}function p(m,y){const u=[];for(;m.length;){const S=m.length<y?m.length:m.lastIndexOf(" ",y),c=m.slice(0,S).trim();m=m.slice(S),u.push(c)}return u}function v(m,y,u,S,c){const h=process.stdout.isTTY&&process.stdout.columns||80,d=c?.noInputFiles!==!0?`[${(0,R.localize)(37,null)}...]`:"",n=[`${m} ${u}`];n.push(""),n.push(`${(0,R.localize)(38,null)}: ${y} [${(0,R.localize)(39,null)}]${d}`),n.push(""),c?.noPipe!==!0&&(i.isWindows?n.push((0,R.localize)(40,null,y)):n.push((0,R.localize)(41,null,y)),n.push(""));const o={},t=[];for(const r in S){const s=S[r];if(s.type==="subcommand")s.description&&t.push({command:r,description:s.description});else if(s.description&&s.cat){let l=o[s.cat];l||(o[s.cat]=l={}),l[r]=s}}for(const r in o){const s=r,l=o[s];l&&(n.push(k[s]),n.push(...w(l,h)),n.push(""))}return t.length&&(n.push((0,R.localize)(42,null)),n.push(...b(t.map(r=>[r.command,r.description]),h)),n.push("")),n.join(`
`)}e.buildHelpMessage=v;function f(m,y){return`${m||(0,R.localize)(43,null)}
${y||(0,R.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=f}),define(se[184],oe([0,1,284,154,183]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const k=2048;function T(p,v){const f=(h,d)=>{console.warn((0,i.localize)(0,null,h,d))},m=h=>{console.warn((0,i.localize)(1,null,h))},y=(h,d)=>{console.warn((0,i.localize)(2,null,h,d))},u=h=>({onUnknownOption:d=>{h!=="tunnel"&&console.warn((0,i.localize)(3,null,d,h))},onMultipleValues:f,onEmptyValue:m,onDeprecatedOption:y,getSubcommandReporter:h!=="tunnel"?u:void 0}),S={onUnknownOption:h=>{console.warn((0,i.localize)(4,null,h))},onMultipleValues:f,onEmptyValue:m,onDeprecatedOption:y,getSubcommandReporter:u},c=(0,R.parseArgs)(p,R.OPTIONS,v?S:void 0);return c.goto&&c._.forEach(h=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(h),(0,i.localize)(5,null))),c["max-memory"]&&D(parseInt(c["max-memory"])>=k,`The max-memory argument cannot be specified lower than ${k} MB.`),c}function I(p){const v=p.findIndex(f=>!/^-/.test(f));if(v>-1)return[...p.slice(0,v),...p.slice(v+1)]}function P(p){let[,...v]=p;process.env.VSCODE_DEV&&(v=I(v)||[]);const f=!E(process.env);return T(v,f)}e.parseMainProcessArgv=P;function w(p){let[,,...v]=p;return process.env.VSCODE_DEV&&(v=I(v)||[]),T(v,!0)}e.parseCLIProcessArgv=w;function b(p,...v){const f=p.indexOf("--");return f===-1?p.push(...v):p.splice(f,0,...v),p}e.addArg=b;function E(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function Z(e,D,i){function R(T,I){const P=k(T,I),w=[P];return e.isAbsolute(P)||w.unshift(i),e.resolve(...w)}function k(T,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,I);const b=T["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(E,"AppData","Roaming")}break;case"darwin":w=e.join(D.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,I)}return{getUserDataPath:R}}if(typeof define=="function")define(se[185],oe([285,34,36]),function(e,D,i){return Z(e,D,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=Z(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[186],oe([0,1,34,93,185]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends i.AbstractNativeEnvironmentService{constructor(I,P){super(I,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(I,P.nameShort)},P)}}e.NativeEnvironmentService=k}),define(se[187],oe([0,1,8]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,I=/^\s*url\s*=\s*(.+\S)\s*$/mg,P=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function w(y){const u=y.match(T);return u?u[1]:null}function b(y){if(y.indexOf("://")===-1){const u=y.match(i);return u?w(u[2]):null}try{const u=D.URI.parse(y);if(u.authority)return w(u.authority)}catch{}return null}function E(y,u){const S=new Set;let c;for(;c=I.exec(y);){const d=b(c[1]);d&&S.add(d)}const h=new Set(u);return Array.from(S).map(d=>h.has(d)?d:d.replace(P,"a"))}e.getDomainsOfRemotes=E;function p(y){const u=y.match(k);return u?u[2]:null}function v(y,u,S){return y&&u?(S&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${y}${u}`:`${y}/${u}`):null}function f(y,u){if(y.indexOf("://")===-1){const S=y.match(R);if(S)return v(S[2],S[3],u)}try{const S=D.URI.parse(y);if(S.authority)return v(p(S.authority),S.path,u)}catch{}return null}function m(y,u=!1){const S=[];let c;for(;c=I.exec(y);){const h=f(c[1],u);h&&S.push(h)}return S}e.getRemotes=m}),define(se[188],oe([0,1,15,157]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function R(T,I,P){try{k(T,I,P)}catch(w){console.error(w?.message??w)}return T}e.localizeManifest=R;function k(T,I,P){const w=(b,E,p)=>{const v=b[E];if((0,D.isString)(v)){const f=v,m=f.length;if(m>1&&f[0]==="%"&&f[m-1]==="%"){const y=f.substr(1,m-2);let u=I[y];u===void 0&&P&&(u=P[y]);const S=typeof u=="string"?u:u?.message,c=P?.[y],h=typeof c=="string"?c:c?.message;if(!S){h||console.warn(`[${T.name}]: ${(0,i.localize)(0,null,y)}`);return}if(p&&(E==="title"||E==="category")&&h&&h!==S){const d={value:S,original:h};b[E]=d}else b[E]=S}}else if((0,D.isObject)(v))for(const f in v)v.hasOwnProperty(f)&&(f==="commands"?w(v,f,!0):w(v,f,p));else if(Array.isArray(v))for(let f=0;f<v.length;f++)w(v,f,p)};for(const b in T)T.hasOwnProperty(b)&&w(T,b)}}),define(se[189],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,T,I,P){return this.channel.call("promptImportantExtensionsInstallNotification",[k,T,I,P])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class i{constructor(k){this.service=k}listen(k,T){throw new Error(`Event not found: ${T}`)}call(k,T,I){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(I[0],I[1],I[2],I[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(se[70],oe([0,1,20,87,162,54]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function P(u){return u=u.trim(),u==="*"||T.test(u)}e.isValidVersionStr=P;function w(u){if(!P(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const S=u.match(T);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=w;function b(u){if(!u)return null;const S=u.majorBase,c=u.majorMustEqual,h=u.minorBase;let d=u.minorMustEqual;const n=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(S===0||(d=!1),o=!1);let t=0;if(u.preRelease){const r=I.exec(u.preRelease);if(r){const[,s,l,a]=r;t=Date.UTC(Number(s),Number(l)-1,Number(a))}}return{majorBase:S,majorMustEqual:c,minorBase:h,minorMustEqual:d,patchBase:n,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:t}}e.normalizeVersion=b;function E(u,S,c){let h;typeof u=="string"?h=b(w(u)):h=u;let d;S instanceof Date?d=S.getTime():typeof S=="string"&&(d=new Date(S).getTime());let n;if(typeof c=="string"?n=b(w(c)):n=c,!h||!n)return!1;const o=h.majorBase,t=h.minorBase,r=h.patchBase;let s=n.majorBase,l=n.minorBase,a=n.patchBase;const g=n.notBefore;let C=n.majorMustEqual,A=n.minorMustEqual,V=n.patchMustEqual;return n.isMinimum?o>s?!0:o<s?!1:t>l?!0:t<l||d&&d<g?!1:r>=a:(o===1&&s===0&&(!C||!A||!V)&&(s=1,l=0,a=0,C=!0,A=!1,V=!1),o<s?!1:o>s?!C:t<l?!1:t>l?!A:r<a?!1:r>a?!V:!(d&&d<g))}e.isValidVersion=E;function p(u,S,c,h,d){const n=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return n.push([i.default.Error,R.localize(0,null)]),n;if(typeof h.name!="string")return n.push([i.default.Error,R.localize(1,null,"name")]),n;if(typeof h.version!="string")return n.push([i.default.Error,R.localize(2,null,"version")]),n;if(!h.engines)return n.push([i.default.Error,R.localize(3,null,"engines")]),n;if(typeof h.engines.vscode!="string")return n.push([i.default.Error,R.localize(4,null,"engines.vscode")]),n;if(typeof h.extensionDependencies<"u"&&!y(h.extensionDependencies))return n.push([i.default.Error,R.localize(5,null,"extensionDependencies")]),n;if(typeof h.activationEvents<"u"){if(!y(h.activationEvents))return n.push([i.default.Error,R.localize(6,null,"activationEvents")]),n;if(typeof h.main>"u"&&typeof h.browser>"u")return n.push([i.default.Error,R.localize(7,null,"activationEvents","main")]),n}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&n.push([i.default.Warning,R.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return n.push([i.default.Error,R.localize(9,null,"main")]),n;{const r=(0,D.joinPath)(c,h.main);(0,D.isEqualOrParent)(r,c)||n.push([i.default.Warning,R.localize(10,null,r.path,c.path)])}if(typeof h.activationEvents>"u")return n.push([i.default.Error,R.localize(11,null,"activationEvents","main")]),n}if(typeof h.browser<"u"){if(typeof h.browser!="string")return n.push([i.default.Error,R.localize(12,null,"browser")]),n;{const r=(0,D.joinPath)(c,h.browser);(0,D.isEqualOrParent)(r,c)||n.push([i.default.Warning,R.localize(13,null,r.path,c.path)])}if(typeof h.activationEvents>"u")return n.push([i.default.Error,R.localize(14,null,"activationEvents","browser")]),n}if(!k.valid(h.version))return n.push([i.default.Error,R.localize(15,null)]),n;const o=[];if(!v(u,S,h,d,o))for(const r of o)n.push([i.default.Error,r]);return n}e.validateExtensionManifest=p;function v(u,S,c,h,d){return h||typeof c.main>"u"&&typeof c.browser>"u"?!0:m(u,S,c.engines.vscode,d)}e.isValidExtensionVersion=v;function f(u,S,c){return u==="*"||m(S,c,u)}e.isEngineValid=f;function m(u,S,c,h=[]){const d=b(w(c));if(!d)return h.push(R.localize(16,null,c)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return h.push(R.localize(17,null,c)),!1}else if(!d.majorMustEqual)return h.push(R.localize(18,null,c)),!1;return E(u,S,d)?!0:(h.push(R.localize(19,null,u,c)),!1)}function y(u){if(!Array.isArray(u))return!1;for(let S=0,c=u.length;S<c;S++)if(typeof u[S]!="string")return!1;return!0}}),define(se[44],oe([0,1,17,30]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(k,T,I){let P=I&&I.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const b=(await T.readFile(k.serviceMachineIdResource)).value.toString();P=(0,i.isUUID)(b)?b:null}catch{P=null}if(!P){P=(0,i.generateUuid)();try{await T.writeFile(k.serviceMachineIdResource,D.VSBuffer.fromString(P))}catch{}}return I?.store("storage.serviceMachineId",P,-1,1),P}e.getServiceMachineId=R}),define(se[55],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,k=[],T=!1){this.ctor=R,this.staticArguments=k,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=D}),define(se[94],oe([0,1,55]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const i=[];var R;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(R=e.InstantiationType||(e.InstantiationType={}));function k(I,P,w){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],Boolean(w))),i.push([I,P])}e.registerSingleton=k;function T(){return i}e.getSingletonServiceDescriptors=T}),define(se[190],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(k,T){this.key=k,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class i{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(const T of this._nodes.values())T.outgoing.size===0&&k.push(T);return k}insertEdge(k,T){const I=this.lookupOrInsertNode(k),P=this.lookupOrInsertNode(T);I.outgoing.set(P.key,P),P.incoming.set(I.key,I)}removeNode(k){const T=this._hashFn(k);this._nodes.delete(T);for(const I of this._nodes.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(k){const T=this._hashFn(k);let I=this._nodes.get(T);return I||(I=new D(T,k),this._nodes.set(T,I)),I}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){const k=[];for(const[T,I]of this._nodes)k.push(`${T}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,T]of this._nodes){const I=new Set([k]),P=this._findCycle(T,I);if(P)return P}}_findCycle(k,T){for(const[I,P]of k.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const w=this._findCycle(P,T);if(w)return w;T.delete(I)}}}e.Graph=i}),define(se[4],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function I(P){return P[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=I})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function i(T,I,P){I[D.DI_TARGET]===I?I[D.DI_DEPENDENCIES].push({id:T,index:P}):(I[D.DI_DEPENDENCIES]=[{id:T,index:P}],I[D.DI_TARGET]=I)}function R(T){if(D.serviceIds.has(T))return D.serviceIds.get(T);const I=function(P,w,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(I,P,b)};return I.toString=()=>T,D.serviceIds.set(T,I),I}e.createDecorator=R;function k(T){return T}e.refineServiceDecorator=k}),define(se[191],oe([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(se[16],oe([0,1,15,8,4]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function k(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof i.URI)}e.isConfigurationOverrides=k;function T(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=T;var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function P(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=P;function w(u,S){const c=Object.create(null);for(const h in u)b(c,h,u[h],S);return c}e.toValuesTree=w;function b(u,S,c,h){const d=S.split("."),n=d.pop();let o=u;for(let t=0;t<d.length;t++){const r=d[t];let s=o[r];switch(typeof s){case"undefined":s=o[r]=Object.create(null);break;case"object":break;default:h(`Ignoring ${S} as ${d.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[n]=c}catch{h(`Ignoring ${S} as ${d.join(".")} is ${JSON.stringify(o)}`)}else h(`Ignoring ${S} as ${d.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=b;function E(u,S){const c=S.split(".");p(u,c)}e.removeFromValueTree=E;function p(u,S){const c=S.shift();if(S.length===0){delete u[c];return}if(Object.keys(u).indexOf(c)!==-1){const h=u[c];typeof h=="object"&&!Array.isArray(h)&&(p(h,S),Object.keys(h).length===0&&delete u[c])}}function v(u,S,c){function h(o,t){let r=o;for(const s of t){if(typeof r!="object"||r===null)return;r=r[s]}return r}const d=S.split("."),n=h(u,d);return typeof n>"u"?c:n}e.getConfigurationValue=v;function f(u,S,c){Object.keys(S).forEach(h=>{h!=="__proto__"&&(h in u?D.isObject(u[h])&&D.isObject(S[h])?f(u[h],S[h],c):c&&(u[h]=S[h]):u[h]=S[h])})}e.merge=f;function m(u,S,c){const h=u.inspect(S),d=u.inspect(c);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:h.defaultValue}e.getMigratedSettingValue=m;function y(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(se[192],oe([0,1,5,27,4]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.isMacintosh),k.set("isLinux",D.isLinux),k.set("isWindows",D.isWindows),k.set("isWeb",D.isWeb),k.set("isMacNative",D.isMacintosh&&!D.isWeb),k.set("isEdge",D.isEdge),k.set("isFirefox",D.isFirefox),k.set("isChrome",D.isChrome),k.set("isSafari",D.isSafari);const T=Object.prototype.hasOwnProperty;var I;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return E.INSTANCE}static true(){return p.INSTANCE}static has(L){return v.create(L)}static equals(L,U){return f.create(L,U)}static notEquals(L,U){return u.create(L,U)}static regex(L,U){return t.create(L,U)}static in(L,U){return m.create(L,U)}static notIn(L,U){return y.create(L,U)}static not(L){return S.create(L)}static and(...L){return l.create(L,null,!0)}static or(...L){return a.create(L,null,!0)}static greater(L,U){return h.create(L,U)}static greaterEquals(L,U){return d.create(L,U)}static smaller(L,U){return n.create(L,U)}static smallerEquals(L,U){return o.create(L,U)}static deserialize(L,U=!1){if(!!L)return this._deserializeOrExpression(L,U)}static _deserializeOrExpression(L,U){const $=L.split("||");return a.create($.map(H=>this._deserializeAndExpression(H,U)),null,!0)}static _deserializeAndExpression(L,U){const $=L.split("&&");return l.create($.map(H=>this._deserializeOne(H,U)),null,!0)}static _deserializeOne(L,U){if(L=L.trim(),L.indexOf("!=")>=0){const $=L.split("!=");return u.create($[0].trim(),this._deserializeValue($[1],U))}if(L.indexOf("==")>=0){const $=L.split("==");return f.create($[0].trim(),this._deserializeValue($[1],U))}if(L.indexOf("=~")>=0){const $=L.split("=~");return t.create($[0].trim(),this._deserializeRegexValue($[1],U))}if(L.indexOf(" not in ")>=0){const $=L.split(" not in ");return y.create($[0].trim(),this._deserializeValue($[1],U))}if(L.indexOf(" in ")>=0){const $=L.split(" in ");return m.create($[0].trim(),this._deserializeValue($[1],U))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const $=L.split(">=");return d.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const $=L.split(">");return h.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const $=L.split("<=");return o.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const $=L.split("<");return n.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(L)?S.create(L.substr(1).trim()):v.create(L)}static _deserializeValue(L,U){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const $=/^'([^']*)'$/.exec(L);return $?$[1].trim():L}static _deserializeRegexValue(L,U){if((0,i.isFalsyOrWhitespace)(L)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=L.indexOf("/"),H=L.lastIndexOf("/");if($===H||$<0){if(U)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const q=L.slice($+1,H),x=L[H+1]==="i"?"i":"";try{return new RegExp(q,x)}catch(W){if(U)throw new Error(`bad regexp-value '${L}', parse error: ${W}`);return console.warn(`bad regexp-value '${L}', parse error: ${W}`),null}}}e.ContextKeyExpr=P;function w(N,L){const U=N?N.substituteConstants():void 0,$=L?L.substituteConstants():void 0;return!U&&!$?!0:!U||!$?!1:U.equals($)}e.expressionsAreEqualWithConstantSubstitution=w;function b(N,L){return N.cmp(L)}class E{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class p{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class v{static create(L,U=null){const $=k.get(L);return typeof $=="boolean"?$?p.INSTANCE:E.INSTANCE:new v(L,U)}constructor(L,U){this.key=L,this.negated=U,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=k.get(this.key);return typeof L=="boolean"?L?p.INSTANCE:E.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class f{static create(L,U,$=null){if(typeof U=="boolean")return U?v.create(L,$):S.create(L,$);const H=k.get(L);return typeof H=="boolean"?U===(H?"true":"false")?p.INSTANCE:E.INSTANCE:new f(L,U,$)}constructor(L,U,$){this.key=L,this.value=U,this.negated=$,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=k.get(this.key);if(typeof L=="boolean"){const U=L?"true":"false";return this.value===U?p.INSTANCE:E.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class m{static create(L,U){return new m(L,U)}constructor(L,U){this.key=L,this.valueKey=U,this.type=10,this.negated=null}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const U=L.getValue(this.valueKey),$=L.getValue(this.key);return Array.isArray(U)?U.includes($):typeof $=="string"&&typeof U=="object"&&U!==null?T.call(U,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=y.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=m;class y{static create(L,U){return new y(L,U)}constructor(L,U){this.key=L,this.valueKey=U,this.type=11,this._negated=m.create(L,U)}cmp(L){return L.type!==this.type?this.type-L.type:this._negated.cmp(L._negated)}equals(L){return L.type===this.type?this._negated.equals(L._negated):!1}substituteConstants(){return this}evaluate(L){return!this._negated.evaluate(L)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(L){return L.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=y;class u{static create(L,U,$=null){if(typeof U=="boolean")return U?S.create(L,$):v.create(L,$);const H=k.get(L);return typeof H=="boolean"?U===(H?"true":"false")?E.INSTANCE:p.INSTANCE:new u(L,U,$)}constructor(L,U,$){this.key=L,this.value=U,this.negated=$,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=k.get(this.key);if(typeof L=="boolean"){const U=L?"true":"false";return this.value===U?E.INSTANCE:p.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=u;class S{static create(L,U=null){const $=k.get(L);return typeof $=="boolean"?$?E.INSTANCE:p.INSTANCE:new S(L,U)}constructor(L,U){this.key=L,this.negated=U,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=k.get(this.key);return typeof L=="boolean"?L?E.INSTANCE:p.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=S;function c(N,L){if(typeof N=="string"){const U=parseFloat(N);isNaN(U)||(N=U)}return typeof N=="string"||typeof N=="number"?L(N):E.INSTANCE}class h{static create(L,U,$=null){return c(U,H=>new h(L,H,$))}constructor(L,U,$){this.key=L,this.value=U,this.negated=$,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=h;class d{static create(L,U,$=null){return c(U,H=>new d(L,H,$))}constructor(L,U,$){this.key=L,this.value=U,this.negated=$,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=d;class n{static create(L,U,$=null){return c(U,H=>new n(L,H,$))}constructor(L,U,$){this.key=L,this.value=U,this.negated=$,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class o{static create(L,U,$=null){return c(U,H=>new o(L,H,$))}constructor(L,U,$){this.key=L,this.value=U,this.negated=$,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class t{static create(L,U){return new t(L,U)}constructor(L,U){this.key=L,this.regexp=U,this.type=7,this.negated=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const U=this.regexp?this.regexp.source:"",$=L.regexp?L.regexp.source:"";return U<$?-1:U>$?1:0}equals(L){if(L.type===this.type){const U=this.regexp?this.regexp.source:"",$=L.regexp?L.regexp.source:"";return this.key===L.key&&U===$}return!1}substituteConstants(){return this}evaluate(L){const U=L.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class r{static create(L){return new r(L)}constructor(L){this._actual=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new r(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function s(N){let L=null;for(let U=0,$=N.length;U<$;U++){const H=N[U].substituteConstants();if(N[U]!==H&&L===null){L=[];for(let q=0;q<U;q++)L[q]=N[q]}L!==null&&(L[U]=H)}return L===null?N:L}class l{static create(L,U,$){return l._normalizeArr(L,U,$)}constructor(L,U){this.expr=L,this.negated=U,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let U=0,$=this.expr.length;U<$;U++){const H=b(this.expr[U],L.expr[U]);if(H!==0)return H}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].equals(L.expr[U]))return!1;return!0}return!1}substituteConstants(){const L=s(this.expr);return L===this.expr?this:l.create(L,this.negated,!1)}evaluate(L){for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].evaluate(L))return!1;return!0}static _normalizeArr(L,U,$){const H=[];let q=!1;for(const x of L)if(!!x){if(x.type===1){q=!0;continue}if(x.type===0)return E.INSTANCE;if(x.type===6){H.push(...x.expr);continue}H.push(x)}if(H.length===0&&q)return p.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(b);for(let x=1;x<H.length;x++)H[x-1].equals(H[x])&&(H.splice(x,1),x--);if(H.length===1)return H[0];for(;H.length>1;){const x=H[H.length-1];if(x.type!==9)break;H.pop();const W=H.pop(),j=H.length===0,K=a.create(x.expr.map(ee=>l.create([ee,W],null,$)),null,j);K&&(H.push(K),H.sort(b))}if(H.length===1)return H[0];if($){for(let x=0;x<H.length;x++)for(let W=x+1;W<H.length;W++)if(H[x].negate().equals(H[W]))return E.INSTANCE;if(H.length===1)return H[0]}return new l(H,U)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const U of this.expr)L.push(...U.keys());return L}map(L){return new l(this.expr.map(U=>U.map(L)),null)}negate(){if(!this.negated){const L=[];for(const U of this.expr)L.push(U.negate());this.negated=a.create(L,this,!0)}return this.negated}}class a{static create(L,U,$){return a._normalizeArr(L,U,$)}constructor(L,U){this.expr=L,this.negated=U,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let U=0,$=this.expr.length;U<$;U++){const H=b(this.expr[U],L.expr[U]);if(H!==0)return H}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].equals(L.expr[U]))return!1;return!0}return!1}substituteConstants(){const L=s(this.expr);return L===this.expr?this:a.create(L,this.negated,!1)}evaluate(L){for(let U=0,$=this.expr.length;U<$;U++)if(this.expr[U].evaluate(L))return!0;return!1}static _normalizeArr(L,U,$){let H=[],q=!1;if(L){for(let x=0,W=L.length;x<W;x++){const j=L[x];if(!!j){if(j.type===0){q=!0;continue}if(j.type===1)return p.INSTANCE;if(j.type===9){H=H.concat(j.expr);continue}H.push(j)}}if(H.length===0&&q)return E.INSTANCE;H.sort(b)}if(H.length!==0){if(H.length===1)return H[0];for(let x=1;x<H.length;x++)H[x-1].equals(H[x])&&(H.splice(x,1),x--);if(H.length===1)return H[0];if($){for(let x=0;x<H.length;x++)for(let W=x+1;W<H.length;W++)if(H[x].negate().equals(H[W]))return p.INSTANCE;if(H.length===1)return H[0]}return new a(H,U)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const U of this.expr)L.push(...U.keys());return L}map(L){return new a(this.expr.map(U=>U.map(L)),null)}negate(){if(!this.negated){const L=[];for(const U of this.expr)L.push(U.negate());for(;L.length>1;){const U=L.shift(),$=L.shift(),H=[];for(const q of F(U))for(const x of F($))H.push(l.create([q,x],null,!1));L.unshift(a.create(H,null,!1))}this.negated=a.create(L,this,!0)}return this.negated}}class g extends v{static all(){return g._info.values()}constructor(L,U,$){super(L,null),this._defaultValue=U,typeof $=="object"?g._info.push({...$,key:L}):$!==!0&&g._info.push({key:L,description:$,type:U!=null?typeof U:void 0})}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return f.create(this.key,L)}notEqualsTo(L){return u.create(this.key,L)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function C(N,L){return N<L?-1:N>L?1:0}function A(N,L,U,$){return N<U?-1:N>U?1:L<$?-1:L>$?1:0}function V(N,L){if(N.type===0||L.type===1)return!0;if(N.type===9)return L.type===9?_(N.expr,L.expr):!1;if(L.type===9){for(const U of L.expr)if(V(N,U))return!0;return!1}if(N.type===6){if(L.type===6)return _(L.expr,N.expr);for(const U of N.expr)if(V(U,L))return!0;return!1}return N.equals(L)}e.implies=V;function _(N,L){let U=0,$=0;for(;U<N.length&&$<L.length;){const H=N[U].cmp(L[$]);if(H<0)return!1;H===0&&U++,$++}return U===N.length}function F(N){return N.type===9?N.expr:[N]}}),define(se[95],oe([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function i(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=i;class R{async getPerformanceInfo(T,I){return{}}async getSystemInfo(T,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,I){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=R}),define(se[96],oe([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(se[13],oe([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(se[29],oe([0,1,156,4]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY="DEFAULT_PROFILE_EXTENSIONS_MIGRATION";function R(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function k(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function T(u,S){switch(u){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function I(u,S){return S==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function P(u,S,c){return I(S,c)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===c?!0:w(c).includes(u)}e.isTargetPlatformCompatible=P;function w(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=w;function b(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=b;var E;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var p;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var v;(function(u){u.Install="install",u.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var m;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(S,c){super(S),this.code=c,this.name=c}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(se[193],oe([0,1,3,2,67,32,8,143,29]),function(Z,e,D,i,R,k,T,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function w(y,u){return T.URI.revive(u?u.transformIncoming(y):y)}function b(y,u){return u?u.transformOutgoingURI(y):y}function E(y,u){u=u||I.DefaultURITransformer;const S=y.manifest;return{...(0,I.transformAndReviveIncomingURIs)({...y,manifest:void 0},u),manifest:S}}function p(y,u){return u?(0,k.cloneAndChange)(y,S=>S instanceof T.URI?u.transformOutgoingURI(S):void 0):y}class v{constructor(u,S){this.service=u,this.getUriTransformer=S,this.onInstallExtension=D.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(u.onDidUninstallExtension,!0)}listen(u,S){const c=this.getUriTransformer(u);switch(S){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,h=>h.map(d=>({...d,local:d.local?p(d.local,c):d.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(u,S,c){const h=this.getUriTransformer(u);switch(S){case"zip":return this.service.zip(E(c[0],h)).then(d=>b(d,h));case"unzip":return this.service.unzip(w(c[0],h));case"install":return this.service.install(w(c[0],h),(0,R.revive)(c[1]));case"getManifest":return this.service.getManifest(w(c[0],h));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(c[0]);case"installFromGallery":return this.service.installFromGallery(c[0],(0,R.revive)(c[1]));case"uninstall":return this.service.uninstall(E(c[0],h),(0,R.revive)(c[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(E(c[0],h));case"getInstalled":return this.service.getInstalled(c[0],T.URI.revive(c[1])).then(d=>d.map(n=>p(n,h)));case"getMetadata":return this.service.getMetadata(E(c[0],h));case"updateMetadata":return this.service.updateMetadata(E(c[0],h),c[1]).then(d=>p(d,h));case"updateExtensionScope":return this.service.updateExtensionScope(E(c[0],h),c[1]).then(d=>p(d,h));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(c[0],c[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=v;class f extends i.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(u){super(),this.channel=u,this._onInstallExtension=this._register(new D.Emitter),this._onDidInstallExtensions=this._register(new D.Emitter),this._onUninstallExtension=this._register(new D.Emitter),this._onDidUninstallExtension=this._register(new D.Emitter),this._register(this.channel.listen("onInstallExtension")(S=>this._onInstallExtension.fire({identifier:S.identifier,source:this.isUriComponents(S.source)?T.URI.revive(S.source):S.source,profileLocation:T.URI.revive(S.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(S=>this._onDidInstallExtensions.fire(S.map(c=>({...c,local:c.local?E(c.local,null):c.local,source:this.isUriComponents(c.source)?T.URI.revive(c.source):c.source,profileLocation:T.URI.revive(c.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(S=>this._onUninstallExtension.fire({identifier:S.identifier,profileLocation:T.URI.revive(S.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(S=>this._onDidUninstallExtension.fire({...S,profileLocation:T.URI.revive(S.profileLocation)})))}isUriComponents(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(u){const S=await this.getTargetPlatform();return u.allTargetPlatforms.some(c=>(0,P.isTargetPlatformCompatible)(c,u.allTargetPlatforms,S))}zip(u){return Promise.resolve(this.channel.call("zip",[u]).then(S=>T.URI.revive(S)))}unzip(u){return Promise.resolve(this.channel.call("unzip",[u]))}install(u,S){return Promise.resolve(this.channel.call("install",[u,S])).then(c=>E(c,null))}getManifest(u){return Promise.resolve(this.channel.call("getManifest",[u]))}installFromGallery(u,S){return Promise.resolve(this.channel.call("installFromGallery",[u,S])).then(c=>E(c,null))}uninstall(u,S){return Promise.resolve(this.channel.call("uninstall",[u,S]))}reinstallFromGallery(u){return Promise.resolve(this.channel.call("reinstallFromGallery",[u]))}getInstalled(u=null,S){return Promise.resolve(this.channel.call("getInstalled",[u,S])).then(c=>c.map(h=>E(h,null)))}getMetadata(u){return Promise.resolve(this.channel.call("getMetadata",[u]))}updateMetadata(u,S){return Promise.resolve(this.channel.call("updateMetadata",[u,S])).then(c=>E(c,null))}updateExtensionScope(u,S){return Promise.resolve(this.channel.call("updateExtensionScope",[u,S])).then(c=>E(c,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(u,S){const c=await this.channel.call("download",[u,S]);return T.URI.revive(c)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class m{constructor(u){this.service=u}listen(u,S){throw new Error("Invalid listen")}call(u,S,c){switch(S){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(c[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=m}),define(se[97],oe([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,D.createDecorator)("IExtensionSignatureVerificationService");class i{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((k,T)=>Z(["node-vsce-sign"],async I=>k(I),T))),this.moduleLoadingPromise}async verify(k,T){let I;try{I=await this.vsceSign()}catch{return!1}return I.verify(k,T)}}e.ExtensionSignatureVerificationService=i}),define(se[98],oe([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(i=e.RecommendationSource||(e.RecommendationSource={}));function R(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var k;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(se[14],oe([0,1,49,12,27,15,8,164,4]),function(Z,e,D,i,R,k,T,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function w(q){return q.create===!0}e.isFileOpenForWriteOptions=w;var b;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var E;(function(q){q[q.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var p;(function(q){q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=v;function f(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=f;function m(q){return!!(q.capabilities&32768)}e.hasFileCloneCapability=m;function y(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function u(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=u;function S(q){return v(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var c;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(c=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(x,W){super(x),this.code=W}}e.FileSystemProviderError=h;function d(q,x){const W=new h(q.toString(),x);return o(W,x),W}e.createFileSystemProviderError=d;function n(q){return q||d((0,I.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=n;function o(q,x){return q.name=x?`${x} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=o;function t(q){if(!q)return c.Unknown;if(q instanceof h)return q.code;const x=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!x)return c.Unknown;switch(x[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=t;function r(q){if(q instanceof A)return q.fileOperationResult;switch(t(q)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class l{constructor(x,W,j){this.resource=x,this.operation=W,this.target=j}isOperation(x){return this.operation===x}}e.FileOperationEvent=l;var a;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class g{constructor(x,W){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=x;const j=new Map;for(const K of x){const ee=j.get(K.type);switch(ee?ee.push([K.resource,K]):j.set(K.type,[[K.resource,K]]),K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}}for(const[K,ee]of j)switch(K){case 1:this.added=D.TernarySearchTree.forUris(()=>W),this.added.fill(ee);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>W),this.updated.fill(ee);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>W),this.deleted.fill(ee);break}}contains(x,...W){return this.doContains(x,{includeChildren:!1},...W)}affects(x,...W){return this.doContains(x,{includeChildren:!0},...W)}doContains(x,W,...j){if(!x)return!1;const K=j.length>0;return!!((!K||j.includes(1))&&(this.added?.get(x)||W.includeChildren&&this.added?.findSuperstr(x))||(!K||j.includes(0))&&(this.updated?.get(x)||W.includeChildren&&this.updated?.findSuperstr(x))||(!K||j.includes(2))&&(this.deleted?.findSubstr(x)||W.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=g;function C(q,x,W){return!q||!x||q===x||x.length>q.length?!1:(x.charAt(x.length-1)!==i.sep&&(x+=i.sep),W?(0,R.startsWithIgnoreCase)(q,x):q.indexOf(x)===0)}e.isParent=C;class A extends Error{constructor(x,W,j){super(x),this.fileOperationResult=W,this.options=j}}e.FileOperationError=A;class V extends A{constructor(x,W,j){super(x,2,j),this.stat=W}}e.NotModifiedSinceFileOperationError=V;var _;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",q[q.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=N;async function L(q,x){if(!x.hasProvider(T.URI.from({scheme:q.scheme})))return new Promise(W=>{const j=x.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===q.scheme&&K.added&&(j.dispose(),W())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(x){return(0,k.isNumber)(x)||(x=0),x<U.KB?(0,I.localize)(1,null,x.toFixed(0)):x<U.MB?(0,I.localize)(2,null,(x/U.KB).toFixed(2)):x<U.GB?(0,I.localize)(3,null,(x/U.MB).toFixed(2)):x<U.TB?(0,I.localize)(4,null,(x/U.GB).toFixed(2)):(0,I.localize)(5,null,(x/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var $;(function(q){q[q.IA32=0]="IA32",q[q.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function H(q){return{maxFileSize:q===0?300*U.MB:16*U.GB,maxHeapSize:q===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=H});var G=this&&this.__param||function(Z,e){return function(D,i){e(D,i,Z)}};define(se[194],oe([0,1,99,43,14]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(I){this.fileService=I}async checksum(I){const P=(await this.fileService.readFileStream(I)).value;return new Promise((w,b)=>{const E=(0,D.createHash)("md5");(0,i.listenStream)(P,{onData:p=>E.update(p.buffer),onError:p=>b(p),onEnd:()=>w(E.digest("base64").replace(/=+$/,""))})})}};k=ve([G(0,R.IFileService)],k),e.ChecksumService=k}),define(se[195],oe([0,1,17,38,11,3,2,43,8,30,14]),function(Z,e,D,i,R,k,T,I,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends T.Disposable{constructor(v,f){super(),this.channel=v,this.extraCapabilities=f,this.onDidChangeCapabilities=k.Event.None,this._onDidChange=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,w.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,f){const{buffer:m}=await this.channel.call("readFile",[v,f]);return m}readFileStream(v,f,m){const y=(0,I.newWriteableStream)(S=>D.VSBuffer.concat(S.map(c=>D.VSBuffer.wrap(c))).buffer),u=this.channel.listen("readFileStream",[v,f])(S=>{if(S instanceof D.VSBuffer)y.write(S.buffer);else{if(S==="end")y.end();else{let c=S;c instanceof Error||(c=(0,b.createFileSystemProviderError)((0,i.toErrorMessage)(c),b.FileSystemProviderErrorCode.Unknown)),y.error(c),y.end()}u.dispose()}});return m.onCancellationRequested(()=>{y.error((0,R.canceled)()),y.end(),u.dispose()}),y}writeFile(v,f,m){return this.channel.call("writeFile",[v,D.VSBuffer.wrap(f),m])}open(v,f){return this.channel.call("open",[v,f])}close(v){return this.channel.call("close",[v])}async read(v,f,m,y,u){const[S,c]=await this.channel.call("read",[v,f,u]);return m.set(S.buffer.slice(0,c),y),c}write(v,f,m,y,u){return this.channel.call("write",[v,f,D.VSBuffer.wrap(m),y,u])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,f){return this.channel.call("delete",[v,f])}rename(v,f,m){return this.channel.call("rename",[v,f,m])}copy(v,f,m){return this.channel.call("copy",[v,f,m])}cloneFile(v,f){return this.channel.call("cloneFile",[v,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const f=v;this._onDidChange.fire(f.map(m=>({resource:P.URI.revive(m.resource),type:m.type})))}else{const f=v;this._onDidWatchError.fire(f)}}))}watch(v,f){const m=(0,w.generateUuid)();return this.channel.call("watch",[this.sessionId,m,v,f]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,m]))}}e.DiskFileSystemProviderClient=E}),define(se[100],oe([0,1,17,11,165,14]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(b,E,p,v,f,m){let y;try{await I(b,E,p,v,f,m)}catch(u){y=u}finally{y&&f.errorTransformer&&(y=f.errorTransformer(y)),typeof y<"u"&&p.error(y),p.end()}}e.readFileIntoStream=T;async function I(b,E,p,v,f,m){P(m);const y=await b.open(E,{create:!1});try{P(m);let u=0,S=0,c=f&&typeof f.length=="number"?f.length:void 0,h=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof c=="number"?c:f.bufferSize)),d=f&&typeof f.position=="number"?f.position:0,n=0;do S=await b.read(y,d,h.buffer,n,h.byteLength-n),d+=S,n+=S,u+=S,typeof c=="number"&&(c-=S),n===h.byteLength&&(await p.write(v(h)),h=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof c=="number"?c:f.bufferSize)),n=0);while(S>0&&(typeof c!="number"||c>0)&&P(m)&&w(u,f));if(n>0){let o=n;typeof c=="number"&&(o=Math.min(n,c)),p.write(v(h.slice(0,o)))}}catch(u){throw(0,k.ensureFileSystemProviderError)(u)}finally{await b.close(y)}}function P(b){if(b.isCancellationRequested)throw(0,i.canceled)();return!0}function w(b,E){if(E?.limits){if(typeof E.limits.memory=="number"&&b>E.limits.memory)throw(0,k.createFileSystemProviderError)((0,R.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&b>E.limits.size)throw(0,k.createFileSystemProviderError)((0,R.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(se[56],oe([0,1,88,2,12,5,8,14]),function(Z,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(u){return u.recursive===!0}e.isRecursiveWatchRequest=P;class w extends i.Disposable{constructor(S,c,h,d){super(),this.onFileChanges=S,this.onLogMessage=c,this.verboseLogging=h,this.options=d,this.watcherDisposables=this._register(new i.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const S=new i.DisposableStore;this.watcherDisposables.value=S,this.watcher=this.createWatcher(S),this.watcher.setVerboseLogging(this.verboseLogging),S.add(this.watcher.onDidChangeFile(c=>this.onFileChanges(c))),S.add(this.watcher.onDidLogMessage(c=>this.onLogMessage(c))),S.add(this.watcher.onDidError(c=>this.onError(c)))}onError(S){this.options.restartOnError?this.restartCounter<w.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${S}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${S}`):this.error(S)}restart(S){this.restartCounter++,this.init(),this.watch(S)}async watch(S){this.requests=S,await this.watcher?.watch(S)}async setVerboseLogging(S){this.verboseLogging=S,await this.watcher?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${S}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=w,w.MAX_RESTARTS=5;class b extends w{constructor(S,c,h){super(S,c,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class E extends w{constructor(S,c,h){super(S,c,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function p(u){return u.map(S=>({type:S.type,resource:T.URI.file(S.path)}))}e.toFileChanges=p;function v(u){const S=new y;for(const c of u)S.processEvent(c);return S.coalesce()}e.coalesceEvents=v;function f(u,S){return typeof S=="string"&&!S.startsWith(D.GLOBSTAR)&&!(0,R.isAbsolute)(S)?{base:u,pattern:S}:S}e.normalizeWatcherPattern=f;function m(u,S){const c=[];for(const h of S)c.push((0,D.parse)(f(u,h)));return c}e.parseWatcherPatterns=m;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(S){return k.isLinux?S.path:S.path.toLowerCase()}processEvent(S){const c=this.mapPathToChange.get(this.toKey(S));let h=!1;if(c){const d=c.type,n=S.type;c.path!==S.path&&(S.type===2||S.type===1)?h=!0:d===1&&n===2?(this.mapPathToChange.delete(this.toKey(S)),this.coalesced.delete(c)):d===2&&n===1?c.type=0:d===1&&n===0||(c.type=n)}else h=!0;h&&(this.coalesced.add(S),this.mapPathToChange.set(this.toKey(S),S))}coalesce(){const S=[],c=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(S.push(h),!1):!0).sort((h,d)=>h.path.length-d.path.length).filter(h=>c.some(d=>(0,I.isParent)(h.path,d,!k.isLinux))?!1:(c.push(h.path),!0)).concat(S)}}}),define(se[196],oe([0,1,53,6,22,48,2,83,12,5,145,28,56]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class v extends T.Disposable{constructor(y,u,S,c){super(),this.request=y,this.onDidFilesChange=u,this.onLogMessage=S,this.verboseLogging=c,this.throttledFileChangesWorker=new i.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.onDidFilesChange(h)),this.fileChangesDelayer=this._register(new i.ThrottledDelayer(v.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new R.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const y=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const u=await E.Promises.stat(y);this._register(await this.doWatch(y,u.isDirectory()))}catch(y){y.code!=="ENOENT"?this.error(y):this.trace(y)}}async normalizePath(y){let u=y.path;try{u=await E.Promises.realpath(y.path),y.path===u&&(u=await(0,b.realcase)(y.path)??y.path),y.path!==u&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${y.path}, real: ${u})`)}catch{}return u}async doWatch(y,u){if(w.isMacintosh&&(0,k.isEqualOrParent)(y,"/Volumes/",!0))return this.error(`Refusing to watch ${y} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const S=new R.CancellationTokenSource(this.cts.token),c=new T.DisposableStore;try{const h=(0,P.basename)(y),d=(0,D.watch)(y);c.add((0,T.toDisposable)(()=>{d.removeAllListeners(),d.close()})),this.trace(`Started watching: '${y}'`);const n=new Set;if(u)try{for(const t of await E.Promises.readdir(y))n.add(t)}catch(t){this.error(t)}const o=new Map;c.add((0,T.toDisposable)(()=>{for(const[,t]of o)t.dispose();o.clear()})),d.on("error",(t,r)=>{this.error(`Failed to watch ${y} for changes using fs.watch() (${t}, ${r})`),this.dispose()}),d.on("change",(t,r)=>{if(S.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${r}`);let s="";if(r&&(s=r.toString(),w.isMacintosh&&(s=(0,I.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(u)if(t==="rename"){o.get(s)?.dispose();const l=setTimeout(async()=>{if(o.delete(s),s===h&&!await E.Promises.exists(y)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,P.join)(y,s));if(S.token.isCancellationRequested)return;let g;a?n.has(s)?g=0:(g=1,n.add(s)):(n.delete(s),g=2),this.onFileChange({path:(0,P.join)(this.request.path,s),type:g})},v.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,T.toDisposable)(()=>clearTimeout(l)))}else{let l;n.has(s)?l=0:(l=1,n.add(s)),this.onFileChange({path:(0,P.join)(this.request.path,s),type:l})}else if(t==="rename"||s!==h){const l=setTimeout(async()=>{const a=await E.Promises.exists(y);S.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),c.add(await this.doWatch(y,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},v.FILE_DELETE_HANDLER_DELAY);c.clear(),c.add((0,T.toDisposable)(()=>clearTimeout(l)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(h){await E.Promises.exists(y)&&!S.token.isCancellationRequested&&this.error(`Failed to watch ${y} for changes using fs.watch() (${h.toString()})`)}return(0,T.toDisposable)(()=>{S.dispose(!0),c.dispose()})}async onFileChange(y,u=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),!u&&this.excludes.some(S=>S(y.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${y.path}`):!u&&this.includes&&this.includes.length>0&&!this.includes.some(S=>S(y.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${y.path}`):this.fileChangesBuffer.push(y);try{await this.fileChangesDelayer.trigger(async()=>{const S=this.fileChangesBuffer;this.fileChangesBuffer=[];const c=(0,p.coalesceEvents)(S);if(c.length>0){if(this.verboseLogging)for(const d of c)this.trace(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);this.throttledFileChangesWorker.work(c)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(y){if(w.isLinux)return E.Promises.exists(y);try{const u=(0,P.basename)(y);return(await E.Promises.readdir((0,P.dirname)(y))).some(c=>c===u)}catch(u){return this.trace(u),!1}}setVerboseLogging(y){this.verboseLogging=y}error(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${y}`})}warn(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${y}`})}trace(y){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=v,v.FILE_DELETE_HANDLER_DELAY=100,v.FILE_CHANGES_HANDLER_DELAY=50;async function f(m,y,u,S,c=512){const h=await E.Promises.open(m,"r"),d=Buffer.allocUnsafe(c),n=new R.CancellationTokenSource(S);let o,t=!1;const r={path:m,excludes:[],recursive:!1},s=new v(r,l=>{(async()=>{for(const{type:a}of l)if(a===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:g}=await E.Promises.read(h,d,0,c,null);if(!g||n.token.isCancellationRequested)break;y(d.slice(0,g))}}catch(g){o=new Error(g),n.dispose(!0)}finally{t=!1}}})()});return await s.ready,u(),new Promise((l,a)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await E.Promises.close(h)}catch(g){o=new Error(g)}o?a(o):l()})})}e.watchFileContents=f}),define(se[197],oe([0,1,3,88,2,5,196]),function(Z,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends R.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(w){const b=this.normalizeRequests(w),E=b.filter(v=>{const f=this.watchers.get(v.path);return f?!(0,i.patternsEquals)(f.request.excludes,v.excludes)||!(0,i.patternsEquals)(f.request.includes,v.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:v})=>!b.find(f=>f.path===v.path&&(0,i.patternsEquals)(f.excludes,v.excludes)&&(0,i.patternsEquals)(f.includes,v.includes))).map(({request:v})=>v.path);E.length&&this.trace(`Request to start watching: ${E.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const v of p)this.stopWatching(v);for(const v of E)this.startWatching(v)}startWatching(w){const b=new T.NodeJSFileWatcherLibrary(w,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),E={request:w,instance:b};this.watchers.set(w.path,E)}async stop(){for(const[w]of this.watchers)this.stopWatching(w);this.watchers.clear()}stopWatching(w){const b=this.watchers.get(w);b&&(this.watchers.delete(w),b.instance.dispose())}normalizeRequests(w){const b=new Map;for(const E of w){const p=k.isLinux?E.path:E.path.toLowerCase();b.set(p,E)}return Array.from(b.values())}async setVerboseLogging(w){this.verboseLogging=w;for(const[,b]of this.watchers)b.instance.setVerboseLogging(w)}trace(w){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(w)})}toMessage(w,b){return b?`[File Watcher (node.js)] ${w} (path: ${b.request.path})`:`[File Watcher (node.js)] ${w}`}}e.NodeJSWatcher=I}),define(se[198],oe([0,1,56,197]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends D.AbstractNonRecursiveWatcherClient{constructor(T,I,P){super(T,I,P),this.init()}createWatcher(){return new i.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(se[199],oe([0,1,23,39,68,56]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends k.AbstractUniversalWatcherClient{constructor(P,w,b){super(P,w,b),this.init()}createWatcher(P){const w=P.add(new R.Client(D.FileAccess.asFileUri("bootstrap-fork",Z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(w.onDidProcessExit(({code:b,signal:E})=>this.onError(`terminated by itself with code ${b}, signal: ${E}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(w.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(se[71],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(const[k,T]of R)this.set(k,T)}set(R,k){const T=this._entries.get(R);return this._entries.set(R,k),T}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(se[200],oe([0,1,6,11,2,55,190,4,71,82]),function(Z,e,D,i,R,k,T,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class E extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class p{constructor(y=new P.ServiceCollection,u=!1,S,c=b){this._services=y,this._strict=u,this._parent=S,this._enableTracing=c,this._activeInstantiations=new Set,this._services.set(I.IInstantiationService,this),this._globalGraph=c?S?._globalGraph??new T.Graph(h=>h):void 0}createChild(y){return new p(y,this._strict,this,this._enableTracing)}invokeFunction(y,...u){const S=f.traceInvocation(this._enableTracing,y);let c=!1;try{return y({get:d=>{if(c)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(d,S);if(!n)throw new Error(`[invokeFunction] unknown service '${d}'`);return n}},...u)}finally{c=!0,S.stop()}}createInstance(y,...u){let S,c;return y instanceof k.SyncDescriptor?(S=f.traceCreation(this._enableTracing,y.ctor),c=this._createInstance(y.ctor,y.staticArguments.concat(u),S)):(S=f.traceCreation(this._enableTracing,y),c=this._createInstance(y,u,S)),S.stop(),c}_createInstance(y,u=[],S){const c=I._util.getServiceDependencies(y).sort((n,o)=>n.index-o.index),h=[];for(const n of c){const o=this._getOrCreateServiceInstance(n.id,S);o||this._throwIfStrict(`[createInstance] ${y.name} depends on UNKNOWN service ${n.id}.`,!1),h.push(o)}const d=c.length>0?c[0].index:u.length;if(u.length!==d){console.trace(`[createInstance] First service dependency of ${y.name} at position ${d+1} conflicts with ${u.length} static arguments`);const n=d-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,d)}return Reflect.construct(y,u.concat(h))}_setServiceInstance(y,u){if(this._services.get(y)instanceof k.SyncDescriptor)this._services.set(y,u);else if(this._parent)this._parent._setServiceInstance(y,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(y){const u=this._services.get(y);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(y):u}_getOrCreateServiceInstance(y,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(y));const S=this._getServiceInstanceOrDescriptor(y);return S instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(y,S,u.branch(y,!0)):(u.branch(y,!1),S)}_safeCreateAndCacheServiceInstance(y,u,S){if(this._activeInstantiations.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this._activeInstantiations.add(y);try{return this._createAndCacheServiceInstance(y,u,S)}finally{this._activeInstantiations.delete(y)}}_createAndCacheServiceInstance(y,u,S){const c=new T.Graph(n=>n.id.toString());let h=0;const d=[{id:y,desc:u,_trace:S}];for(;d.length;){const n=d.pop();if(c.lookupOrInsertNode(n),h++>1e3)throw new E(c);for(const o of I._util.getServiceDependencies(n.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(o.id);if(t||this._throwIfStrict(`[createInstance] ${y} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(o.id)),t instanceof k.SyncDescriptor){const r={id:o.id,desc:t,_trace:n._trace.branch(o.id,!0)};c.insertEdge(n,r),d.push(r)}}}for(;;){const n=c.roots();if(n.length===0){if(!c.isEmpty())throw new E(c);break}for(const{data:o}of n){if(this._getServiceInstanceOrDescriptor(o.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}c.removeNode(o)}}return this._getServiceInstanceOrDescriptor(y)}_createServiceInstanceWithOwner(y,u,S=[],c,h){if(this._services.get(y)instanceof k.SyncDescriptor)return this._createServiceInstance(y,u,S,c,h);if(this._parent)return this._parent._createServiceInstanceWithOwner(y,u,S,c,h);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(y,u,S=[],c,h){if(c){const d=new p(void 0,this._strict,this,this._enableTracing);d._globalGraphImplicitDependency=String(y);const n=new Map,o=new D.IdleValue(()=>{const t=d._createInstance(u,S,h);for(const[r,s]of n){const l=t[r];if(typeof l=="function")for(const a of s)l.apply(t,a)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,r){if(!o.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let a=n.get(r);return a||(a=new w.LinkedList,n.set(r,a)),(C,A,V)=>{const _=a.push([C,A,V]);return(0,R.toDisposable)(_)}}if(r in t)return t[r];const s=o.value;let l=s[r];return typeof l!="function"||(l=l.bind(s),t[r]=l),l},set(t,r,s){return o.value[r]=s,!0}})}else return this._createInstance(u,S,h)}_throwIfStrict(y,u){if(u&&console.warn(y),this._strict)throw new Error(y)}}e.InstantiationService=p;var v;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(v||(v={}));class f{static traceInvocation(y,u){return y?new f(1,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f._None}static traceCreation(y,u){return y?new f(0,u.name):f._None}constructor(y,u){this.type=y,this.name=u,this._start=Date.now(),this._dep=[]}branch(y,u){const S=new f(2,y.toString());return this._dep.push([y,u,S]),S}stop(){const y=Date.now()-this._start;f._totals+=y;let u=!1;function S(h,d){const n=[],o=new Array(h+1).join("	");for(const[t,r,s]of d._dep)if(r&&s){u=!0,n.push(`${o}CREATES -> ${t}`);const l=S(h+1,s);l&&n.push(l)}else n.push(`${o}uses -> ${t}`);return n.join(`
`)}const c=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(y>2||u)&&f.all.add(c.join(`
`))}}e.Trace=f,f.all=new Set,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(se[201],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,k){this.server=R,this.router=k}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,k){this.server.registerChannel(R,k)}}e.MessagePortMainProcessService=D}),define(se[57],oe([0,1,39,55,94,4]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(v,f,m,y){const u=m.getChannel(v);return I(f)?y.createInstance(new i.SyncDescriptor(f.channelClientCtor,[u])):D.ProxyChannel.toService(u,f?.proxyOptions)}}function I(p){return!!p?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let P=class extends T{constructor(v,f,m,y){super(v,f,m,y)}};P=ve([G(2,e.IMainProcessService),G(3,k.IInstantiationService)],P);function w(p,v,f){(0,R.registerSingleton)(p,new i.SyncDescriptor(P,[v,f],!0))}e.registerMainProcessRemoteService=w,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let b=class extends T{constructor(v,f,m,y){super(v,f,m,y)}};b=ve([G(2,e.ISharedProcessService),G(3,k.IInstantiationService)],b);function E(p,v,f){(0,R.registerSingleton)(p,new i.SyncDescriptor(b,[v,f],!0))}e.registerSharedProcessRemoteService=E}),define(se[72],oe([0,1,22,2,5,167,29,4]),function(Z,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let P=class extends i.Disposable{constructor(b){super(),this.extensionGalleryService=b}async getAvailableLanguages(){const b=new D.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let E;try{E=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const v=E.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(m=>m.startsWith("lp-"))).map(f=>{const m=f.properties.localizedLanguages?.[0],y=this.getLocale(f);return{...this.createQuickPickItem(y,m,f),extensionId:f.identifier.id,galleryExtension:f}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(b){return b.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(b,E,p){const v=E??b;let f;if(v!==b&&(f=`(${b})`),b.toLowerCase()===R.language.toLowerCase()&&(f??="",f+=(0,k.localize)(0,null)),p?.installCount){f??="";const m=p.installCount;let y;m>1e6?y=`${Math.floor(m/1e5)/10}M`:m>1e3?y=`${Math.floor(m/1e3)}K`:y=String(m),f+=` $(cloud-download) ${y}`}return{id:b,label:v,description:f}}};P=ve([G(0,T.IExtensionGalleryService)],P),e.LanguagePackBaseService=P}),define(se[202],oe([0,1,2,72]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(T){super(),this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=ve([G(0,i.ILanguagePackService)],R),e.LocalizationsUpdater=R}),define(se[7],oe([0,1,38,3,2,37,5,8,4]),function(Z,e,D,i,R,k,T,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function w(){return new Date().toISOString()}var b;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function E(l,a,g){switch(a){case b.Trace:l.trace(g);break;case b.Debug:l.debug(g);break;case b.Info:l.info(g);break;case b.Warning:l.warn(g);break;case b.Error:l.error(g);break;default:throw new Error("Invalid log level")}}e.log=E;function p(l){let a="";for(let g=0;g<l.length;g++){let C=l[g];if(typeof C=="object")try{C=JSON.stringify(C)}catch{}a+=(g>0?" ":"")+C}return a}e.format=p;class v extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class f extends v{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...g){this.checkLogLevel(b.Trace)&&this.log(b.Trace,p([a,...g]))}debug(a,...g){this.checkLogLevel(b.Debug)&&this.log(b.Debug,p([a,...g]))}info(a,...g){this.checkLogLevel(b.Info)&&this.log(b.Info,p([a,...g]))}warn(a,...g){this.checkLogLevel(b.Warning)&&this.log(b.Warning,p([a,...g]))}error(a,...g){if(this.checkLogLevel(b.Error))if(a instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=a.stack,this.log(b.Error,p(C))}else this.log(b.Error,p([a,...g]))}flush(){}}e.AbstractMessageLogger=f;class m extends v{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!T.isWindows}trace(a,...g){this.getLevel()<=b.Trace&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,a,...g):console.log(`[main ${w()}]`,a,...g))}debug(a,...g){this.getLevel()<=b.Debug&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,a,...g):console.log(`[main ${w()}]`,a,...g))}info(a,...g){this.getLevel()<=b.Info&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,a,...g):console.log(`[main ${w()}]`,a,...g))}warn(a,...g){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,a,...g):console.warn(`[main ${w()}]`,a,...g))}error(a,...g){this.getLevel()<=b.Error&&(this.useColors?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,a,...g):console.error(`[main ${w()}]`,a,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class y extends v{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...g){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",a,...g)}debug(a,...g){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...g)}info(a,...g){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",a,...g)}warn(a,...g){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",a,...g)}error(a,...g){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",a,...g)}dispose(){}flush(){}}e.ConsoleLogger=y;class u extends v{constructor(a,g=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(g)}trace(a,...g){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(a),...g])}debug(a,...g){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(a),...g])}info(a,...g){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(a),...g])}warn(a,...g){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(a),...g])}error(a,...g){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(a),...g])}extractMessage(a){return typeof a=="string"?a:(0,D.toErrorMessage)(a,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class S extends v{constructor(a){super(),this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const g of this.logServices)g.setLevel(a);super.setLevel(a)}trace(a,...g){for(const C of this.logServices)C.trace(a,...g)}debug(a,...g){for(const C of this.logServices)C.debug(a,...g)}info(a,...g){for(const C of this.logServices)C.info(a,...g)}warn(a,...g){for(const C of this.logServices)C.warn(a,...g)}error(a,...g){for(const C of this.logServices)C.error(a,...g)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=S;class c extends R.Disposable{constructor(a){super(),this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...g){this.logger.trace(a,...g)}debug(a,...g){this.logger.debug(a,...g)}info(a,...g){this.logger.info(a,...g)}warn(a,...g){this.logger.warn(a,...g)}error(a,...g){this.logger.error(a,...g)}flush(){this.logger.flush()}}e.LogService=c;class h extends R.Disposable{constructor(a,g){super(),this.logLevel=a,this.loggerItems=new k.ResourceMap,this._register(g(C=>this.setLevel(C)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:a})=>a)}getLogger(a){return this.loggerItems.get(a)?.logger}createLogger(a,g,C){let A=this.loggerItems.get(a)?.logger;return A||(C=g?.always?b.Trace:C,A=this.doCreateLogger(a,C??this.logLevel,g),this.loggerItems.set(a,{logger:A,logLevel:C})),A}setLevel(a,g){const C=I.URI.isUri(a)?a:void 0,A=C?g:a;if(C){const V=this.loggerItems.get(C);V&&V.logLevel!==A&&(V.logLevel=A,V.logger.setLevel(A))}else this.logLevel=A,this.loggerItems.forEach(({logLevel:V,logger:_})=>{V===void 0&&_.setLevel(this.logLevel)})}getLogLevel(a){return this.loggerItems.get(a)?.logLevel}dispose(){this.loggerItems.forEach(({logger:a})=>a.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=h;class d{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(a){}getLevel(){return b.Info}trace(a,...g){}debug(a,...g){}info(a,...g){}warn(a,...g){}error(a,...g){}critical(a,...g){}dispose(){}flush(){}}e.NullLogger=d;class n extends d{}e.NullLogService=n;class o extends h{constructor(){super(b.Info,i.Event.None)}doCreateLogger(a,g,C){return new d}}e.NullLoggerService=o;function t(l){if(l.verbose)return b.Trace;if(typeof l.logLevel=="string"){const a=s(l.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function r(l){switch(l){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=r;function s(l){switch(l){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=s}),define(se[203],oe([0,1,6,11,2,12,28,13,7]),function(Z,e,D,i,R,k,T,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends R.Disposable{constructor(E,p){super(),this.environmentService=E,this.logService=p,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,k.basename)(this.environmentService.logsPath),p=(0,k.dirname)(this.environmentService.logsPath),m=(await T.Promises.readdir(p)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==E),y=m.slice(0,Math.max(0,m.length-9));y.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${y.join(", ")}'`),await Promise.all(y.map(u=>T.Promises.rm((0,k.join)(p,u)))))}catch(E){(0,i.onUnexpectedError)(E)}}};w=ve([G(0,I.IEnvironmentService),G(1,P.ILogService)],w),e.LogsDataCleaner=w}),define(se[204],oe([0,1,19,6,11,3,2,12,56,7]),function(Z,e,D,i,R,k,T,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends T.Disposable{constructor(p,v){super(),this.logService=p,this.options=v,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new i.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}watch(p,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,v):this.watchNonRecursive(p,v)}watchUniversal(p,v){const f={path:this.toFilePath(p),excludes:v.excludes,includes:v.includes,recursive:v.recursive},m=(0,D.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,R.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,P.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const v of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const v of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(v)&&p.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,v){const f={path:this.toFilePath(p),excludes:v.excludes,includes:v.includes,recursive:!1},m=(0,D.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,R.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,P.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,I.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(se[205],oe([0,1,19,6,17,22,3,66,64,2,49,23,206,20,43,163,14,100,7]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends w.Disposable{constructor(d){super(),this.logService=d,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new i.ResourceQueue)}registerProvider(d,n){if(this.provider.has(d))throw new Error(`A filesystem provider for the scheme '${d}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${d}`);const o=new w.DisposableStore;return this.provider.set(d,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:d,provider:n}),o.add(n.onDidChangeFile(t=>this._onDidFilesChange.fire(new y.FileChangesEvent(t,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&o.add(n.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),o.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:d}))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:d,provider:n}),this.provider.delete(d),(0,w.dispose)(o)})}getProvider(d){return this.provider.get(d)}async activateProvider(d){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:d,join(o){n.push(o)}}),!this.provider.has(d)&&await i.Promises.settled(n)}async canHandleResource(d){return await this.activateProvider(d.scheme),this.hasProvider(d)}hasProvider(d){return this.provider.has(d.scheme)}hasCapability(d,n){const o=this.provider.get(d.scheme);return!!(o&&o.capabilities&n)}listCapabilities(){return P.Iterable.map(this.provider,([d,n])=>({scheme:d,capabilities:n.capabilities}))}async withProvider(d){if(!(0,v.isAbsolutePath)(d))throw new y.FileOperationError((0,m.localize)(0,null,this.resourceForError(d)),8);await this.activateProvider(d.scheme);const n=this.provider.get(d.scheme);if(!n){const o=new Error;throw o.name="ENOPRO",o.message=(0,m.localize)(1,null,d.toString()),o}return n}async withReadProvider(d){const n=await this.withProvider(d);if((0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n)||(0,y.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${d.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(d){const n=await this.withProvider(d);if((0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${d.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(d,n){try{return await this.doResolveFile(d,n)}catch(o){throw(0,y.toFileSystemProviderErrorCode)(o)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,m.localize)(2,null,this.resourceForError(d)),1):(0,y.ensureFileSystemProviderError)(o)}}async doResolveFile(d,n){const o=await this.withProvider(d),t=this.isPathCaseSensitive(o),r=n?.resolveTo,s=n?.resolveSingleChildDescendants,l=n?.resolveMetadata,a=await o.stat(d);let g;return this.toFileStat(o,d,a,void 0,!!l,(C,A)=>(g||(g=b.TernarySearchTree.forUris(()=>!t),g.set(d,!0),r&&g.fill(!0,r)),g.get(C.resource)||g.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&s?A===1:!1))}async toFileStat(d,n,o,t,r,s){const{providerExtUri:l}=this.getExtUri(d),a={resource:n,name:l.basename(n),isFile:(o.type&y.FileType.File)!==0,isDirectory:(o.type&y.FileType.Directory)!==0,isSymbolicLink:(o.type&y.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&y.FilePermission.Readonly)||Boolean(d.capabilities&2048),etag:(0,y.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(a.isDirectory&&s(a,t)){try{const g=await d.readdir(n),C=await i.Promises.settled(g.map(async([A,V])=>{try{const _=l.joinPath(n,A),F=r?await d.stat(_):{type:V};return await this.toFileStat(d,_,F,g.length,r,s)}catch(_){return this.logService.trace(_),null}}));a.children=(0,D.coalesce)(C)}catch(g){this.logService.trace(g),a.children=[]}return a}return a}async resolveAll(d){return i.Promises.settled(d.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(d){const n=await this.withProvider(d),o=await n.stat(d);return this.toFileStat(n,d,o,void 0,!0,()=>!1)}async exists(d){const n=await this.withProvider(d);try{return!!await n.stat(d)}catch{return!1}}async canCreateFile(d,n){try{await this.doValidateCreateFile(d,n)}catch(o){return o}return!0}async doValidateCreateFile(d,n){if(!n?.overwrite&&await this.exists(d))throw new y.FileOperationError((0,m.localize)(3,null,this.resourceForError(d)),3,n)}async createFile(d,n=R.VSBuffer.fromString(""),o){await this.doValidateCreateFile(d,o);const t=await this.writeFile(d,n);return this._onDidRunOperation.fire(new y.FileOperationEvent(d,0,t)),t}async writeFile(d,n,o){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(d),d),{providerExtUri:r}=this.getExtUri(t);try{await this.validateWriteFile(t,d,o)||await this.mkdirp(t,r.dirname(d));let l;if((0,y.hasReadWriteCapability)(t)&&!(n instanceof R.VSBuffer))if((0,f.isReadableStream)(n)){const a=await(0,f.peekStream)(n,3);a.ended?l=R.VSBuffer.concat(a.buffer):l=a}else l=(0,f.peekReadable)(n,a=>R.VSBuffer.concat(a),3);else l=n;!(0,y.hasOpenReadWriteCloseCapability)(t)||(0,y.hasReadWriteCapability)(t)&&l instanceof R.VSBuffer?await this.doWriteUnbuffered(t,d,o,l):await this.doWriteBuffered(t,d,o,l instanceof R.VSBuffer?(0,R.bufferToReadable)(l):l),this._onDidRunOperation.fire(new y.FileOperationEvent(d,4))}catch(s){throw new y.FileOperationError((0,m.localize)(4,null,this.resourceForError(d),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),o)}return this.resolve(d,{resolveMetadata:!0})}async validateWriteFile(d,n,o){if(!!o?.unlock&&!(d.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(n)));let r;try{r=await d.stat(n)}catch{return}if((r.type&y.FileType.Directory)!==0)throw new y.FileOperationError((0,m.localize)(6,null,this.resourceForError(n)),0,o);if(this.throwIfFileIsReadonly(n,r),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==y.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&o.mtime<r.mtime&&o.etag!==(0,y.etag)({mtime:o.mtime,size:r.size}))throw new y.FileOperationError((0,m.localize)(7,null),3,o);return r}async readFile(d,n,o){const t=await this.withReadProvider(d);return n?.atomic?this.doReadFileAtomic(t,d,n,o):this.doReadFile(t,d,n,o)}async doReadFileAtomic(d,n,o,t){return new Promise((r,s)=>{this.writeQueue.queueFor(n,this.getExtUri(d).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(d,n,o,t);r(l)}catch(l){s(l)}})})}async doReadFile(d,n,o,t){const r=await this.doReadFileStream(d,n,{...o,preferUnbuffered:!0},t);return{...r,value:await(0,R.streamToBuffer)(r.value)}}async readFileStream(d,n,o){const t=await this.withReadProvider(d);return this.doReadFileStream(t,d,n,o)}async doReadFileStream(d,n,o,t){const r=new k.CancellationTokenSource(t),s=this.validateReadFile(n,o).then(a=>a,a=>{throw r.cancel(),a});let l;try{return typeof o?.etag=="string"&&o.etag!==y.ETAG_DISABLED&&await s,o?.atomic&&(0,y.hasFileAtomicReadCapability)(d)||!((0,y.hasOpenReadWriteCloseCapability)(d)||(0,y.hasFileReadStreamCapability)(d))||(0,y.hasReadWriteCapability)(d)&&o?.preferUnbuffered?l=this.readFileUnbuffered(d,n,o):(0,y.hasFileReadStreamCapability)(d)?l=this.readFileStreamed(d,n,r.token,o):l=this.readFileBuffered(d,n,r.token,o),{...await s,value:l}}catch(a){l&&await(0,f.consumeStream)(l);const g=(0,m.localize)(8,null,this.resourceForError(n),(0,y.ensureFileSystemProviderError)(a).toString());throw a instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(g,a.stat,o):new y.FileOperationError(g,(0,y.toFileOperationResult)(a),o)}}readFileStreamed(d,n,o,t=Object.create(null)){const r=d.readFileStream(n,t,o);return(0,f.transform)(r,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>new y.FileOperationError((0,m.localize)(9,null,this.resourceForError(n),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),t)},s=>R.VSBuffer.concat(s))}readFileBuffered(d,n,o,t=Object.create(null)){const r=(0,R.newWriteableBufferStream)();return(0,u.readFileIntoStream)(d,n,r,s=>s,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new y.FileOperationError((0,m.localize)(10,null,this.resourceForError(n),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),t)},o),r}readFileUnbuffered(d,n,o){const t=(0,f.newWriteableStream)(r=>R.VSBuffer.concat(r));return(async()=>{try{let r;o?.atomic&&(0,y.hasFileAtomicReadCapability)(d)?r=await d.readFile(n,{atomic:!0}):r=await d.readFile(n),typeof o?.position=="number"&&(r=r.slice(o.position)),typeof o?.length=="number"&&(r=r.slice(0,o.length)),this.validateReadFileLimits(n,r.byteLength,o),t.end(R.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(d,n){const o=await this.resolve(d,{resolveMetadata:!0});if(o.isDirectory)throw new y.FileOperationError((0,m.localize)(11,null,this.resourceForError(d)),0,n);if(typeof n?.etag=="string"&&n.etag!==y.ETAG_DISABLED&&n.etag===o.etag)throw new y.NotModifiedSinceFileOperationError((0,m.localize)(12,null),o,n);return this.validateReadFileLimits(d,o.size,n),o}validateReadFileLimits(d,n,o){if(o?.limits){let t;if(typeof o.limits.memory=="number"&&n>o.limits.memory&&(t=9),typeof o.limits.size=="number"&&n>o.limits.size&&(t=7),typeof t=="number")throw new y.FileOperationError((0,m.localize)(13,null,this.resourceForError(d)),t)}}async canMove(d,n,o){return this.doCanMoveCopy(d,n,"move",o)}async canCopy(d,n,o){return this.doCanMoveCopy(d,n,"copy",o)}async doCanMoveCopy(d,n,o,t){if(d.toString()!==n.toString())try{const r=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(d),d):await this.withReadProvider(d),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(r,d,s,n,o,t)}catch(r){return r}return!0}async move(d,n,o){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(d),d),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(t,d,r,n,"move",!!o),l=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(d,s==="move"?2:3,l)),l}async copy(d,n,o){const t=await this.withReadProvider(d),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(t,d,r,n,"copy",!!o),l=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(d,s==="copy"?3:2,l)),l}async doMoveCopy(d,n,o,t,r,s){if(n.toString()===t.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(d,n,o,t,r,s);if(l&&!a&&s&&await this.del(t,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(t)),r==="copy"){if(d===o&&(0,y.hasFileFolderCopyCapability)(d))await d.copy(n,t,{overwrite:s});else{const g=await this.resolve(n);g.isDirectory?await this.doCopyFolder(d,g,o,t):await this.doCopyFile(d,n,o,t)}return r}else return d===o?(await d.rename(n,t,{overwrite:s}),r):(await this.doMoveCopy(d,n,o,t,"copy",s),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(d,n,o,t){if((0,y.hasOpenReadWriteCloseCapability)(d)&&(0,y.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(d,n,o,t);if((0,y.hasOpenReadWriteCloseCapability)(d)&&(0,y.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(d,n,o,t);if((0,y.hasReadWriteCapability)(d)&&(0,y.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(d,n,o,t);if((0,y.hasReadWriteCapability)(d)&&(0,y.hasReadWriteCapability)(o))return this.doPipeUnbuffered(d,n,o,t)}async doCopyFolder(d,n,o,t){await o.mkdir(t),Array.isArray(n.children)&&await i.Promises.settled(n.children.map(async r=>{const s=this.getExtUri(o).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(d,await this.resolve(r.resource),o,s):this.doCopyFile(d,r.resource,o,s)}))}async doValidateMoveCopy(d,n,o,t,r,s){let l=!1;if(d===o){const{providerExtUri:g,isPathCaseSensitive:C}=this.getExtUri(d);if(C||(l=g.isEqual(n,t)),l&&r==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(n),this.resourceForError(t)));if(!l&&g.isEqualOrParent(t,n))throw new Error((0,m.localize)(15,null,this.resourceForError(n),this.resourceForError(t)))}const a=await this.exists(t);if(a&&!l){if(!s)throw new y.FileOperationError((0,m.localize)(16,null,this.resourceForError(n),this.resourceForError(t)),4);if(d===o){const{providerExtUri:g}=this.getExtUri(d);if(g.isEqualOrParent(n,t))throw new Error((0,m.localize)(17,null,this.resourceForError(n),this.resourceForError(t)))}}return{exists:a,isSameResourceWithDifferentPathCase:l}}getExtUri(d){const n=this.isPathCaseSensitive(d);return{providerExtUri:n?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(d){return!!(d.capabilities&1024)}async createFolder(d){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(d),d);await this.mkdirp(n,d);const o=await this.resolve(d,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(d,0,o)),o}async mkdirp(d,n){const o=[],{providerExtUri:t}=this.getExtUri(d);for(;!t.isEqual(n,t.dirname(n));)try{if(((await d.stat(n)).type&y.FileType.Directory)===0)throw new Error((0,m.localize)(18,null,this.resourceForError(n)));break}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;o.push(t.basename(n)),n=t.dirname(n)}for(let r=o.length-1;r>=0;r--){n=t.joinPath(n,o[r]);try{await d.mkdir(n)}catch(s){if((0,y.toFileSystemProviderErrorCode)(s)!==y.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(d,n){try{await this.doValidateDelete(d,n)}catch(o){return o}return!0}async doValidateDelete(d,n){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(d),d);if(!!n?.useTrash&&!(o.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(d)));let r;try{r=await o.stat(d)}catch{}if(r)this.throwIfFileIsReadonly(d,r);else throw new y.FileOperationError((0,m.localize)(20,null,this.resourceForError(d)),1);if(!!!n?.recursive){const l=await this.resolve(d);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(d)))}return o}async del(d,n){const o=await this.doValidateDelete(d,n),t=!!n?.useTrash,r=!!n?.recursive;await o.delete(d,{recursive:r,useTrash:t}),this._onDidRunOperation.fire(new y.FileOperationEvent(d,1))}async cloneFile(d,n){const o=await this.withProvider(d),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(o===t&&this.getExtUri(o).providerExtUri.isEqual(d,n))return;if(o===t&&(0,y.hasFileCloneCapability)(o))return o.cloneFile(d,n);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n));const r=this.writeQueue.queueFor(d,this.getExtUri(o).providerExtUri);return o===t&&(0,y.hasFileFolderCopyCapability)(o)?r.queue(()=>o.copy(d,n,{overwrite:!0})):r.queue(()=>this.doCopyFile(o,d,t,n))}watch(d,n={recursive:!1,excludes:[]}){const o=new w.DisposableStore;let t=!1,r=()=>{t=!0};return o.add((0,w.toDisposable)(()=>r())),(async()=>{try{const s=await this.doWatch(d,n);t?(0,w.dispose)(s):r=()=>(0,w.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(d,n){const o=await this.withProvider(d),t=(0,I.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(d),n]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:o.watch(d,n)},this.activeWatchers.set(t,r)),r.count+=1,(0,w.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,w.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,d]of this.activeWatchers)(0,w.dispose)(d.disposable);this.activeWatchers.clear()}async doWriteBuffered(d,n,o,t){return this.writeQueue.queueFor(n,this.getExtUri(d).providerExtUri).queue(async()=>{const r=await d.open(n,{create:!0,unlock:o?.unlock??!1});try{(0,f.isReadableStream)(t)||(0,f.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(d,r,t):await this.doWriteReadableBufferedQueued(d,r,t)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await d.close(r)}})}async doWriteStreamBufferedQueued(d,n,o){let t=0,r;if((0,f.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=R.VSBuffer.concat(o.buffer);await this.doWriteBuffer(d,n,s,s.byteLength,t,0),t+=s.byteLength}if(o.ended)return;r=o.stream}else r=o;return new Promise((s,l)=>{(0,f.listenStream)(r,{onData:async a=>{r.pause();try{await this.doWriteBuffer(d,n,a,a.byteLength,t,0)}catch(g){return l(g)}t+=a.byteLength,setTimeout(()=>r.resume())},onError:a=>l(a),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(d,n,o){let t=0,r;for(;(r=o.read())!==null;)await this.doWriteBuffer(d,n,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(d,n,o,t,r,s){let l=0;for(;l<t;)l+=await d.write(n,r+l,o.buffer,s+l,t-l)}async doWriteUnbuffered(d,n,o,t){return this.writeQueue.queueFor(n,this.getExtUri(d).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(d,n,o,t))}async doWriteUnbufferedQueued(d,n,o,t){let r;t instanceof R.VSBuffer?r=t:(0,f.isReadableStream)(t)?r=await(0,R.streamToBuffer)(t):(0,f.isReadableBufferedStream)(t)?r=await(0,R.bufferedStreamToBuffer)(t):r=(0,R.readableToBuffer)(t),await d.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(d,n,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(d,n,o,t))}async doPipeBufferedQueued(d,n,o,t){let r,s;try{r=await d.open(n,{create:!1}),s=await o.open(t,{create:!0,unlock:!1});const l=R.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,g=0,C=0;do C=await d.read(r,a,l.buffer,g,l.byteLength-g),await this.doWriteBuffer(o,s,l,C,a,g),a+=C,g+=C,g===l.byteLength&&(g=0);while(C>0)}catch(l){throw(0,y.ensureFileSystemProviderError)(l)}finally{await i.Promises.settled([typeof r=="number"?d.close(r):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(d,n,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(d,n,o,t))}async doPipeUnbufferedQueued(d,n,o,t){return o.writeFile(t,await d.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(d,n,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(d,n,o,t))}async doPipeUnbufferedToBufferedQueued(d,n,o,t){const r=await o.open(t,{create:!0,unlock:!1});try{const s=await d.readFile(n);await this.doWriteBuffer(o,r,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await o.close(r)}}async doPipeBufferedToUnbuffered(d,n,o,t){const r=await(0,R.streamToBuffer)(this.readFileBuffered(d,n,k.CancellationToken.None));await this.doWriteUnbuffered(o,t,void 0,r)}throwIfFileSystemIsReadonly(d,n){if(d.capabilities&2048)throw new y.FileOperationError((0,m.localize)(22,null,this.resourceForError(n)),6);return d}throwIfFileIsReadonly(d,n){if((n.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,m.localize)(23,null,this.resourceForError(d)),6)}resourceForError(d){return d.scheme===E.Schemas.file?d.fsPath:d.toString(!0)}};c=ve([G(0,S.ILogService)],c),e.FileService=c}),define(se[207],oe([0,1,53,286,6,37,17,3,48,2,12,5,20,43,28,166,14,100,204,38,199,198]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u,S,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(D)}catch(o){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(o)}`)}})();class n extends S.AbstractDiskFileSystemProvider{constructor(t,r){super(t,r),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new k.ResourceMap(s=>p.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:r,symbolicLink:s}=await f.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(r,s),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(t){try{const r=await f.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),s=[];return await Promise.all(r.map(async l=>{try{let a;l.isSymbolicLink()?a=(await this.stat((0,p.joinPath)(t,l.name))).type:a=this.toType(l),s.push([l.name,a])}catch(a){this.logService.trace(a)}})),s}catch(r){throw this.toFileSystemProviderError(r)}}toType(t,r){let s;return r?.dangling?s=y.FileType.Unknown:t.isFile()?s=y.FileType.File:t.isDirectory()?s=y.FileType.Directory:s=y.FileType.Unknown,r&&(s|=y.FileType.SymbolicLink),s}async createResourceLock(t){const r=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let s;for(;s=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await s.wait();const l=new R.Barrier;return this.resourceLocks.set(t,l),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,w.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(t)===l&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),l.open()})}async readFile(t,r){let s;try{r?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),s=await this.createResourceLock(t));const l=this.toFilePath(t);return await f.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{s?.dispose()}}traceLock(t){n.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,r,s){const l=(0,v.newWriteableStream)(a=>T.VSBuffer.concat(a.map(g=>T.VSBuffer.wrap(g))).buffer);return(0,u.readFileIntoStream)(this,t,l,a=>a.buffer,{...r,bufferSize:256*1024},s),l}async writeFile(t,r,s){let l;try{const a=this.toFilePath(t);if(!s.create||!s.overwrite){if(await f.Promises.exists(a)){if(!s.overwrite)throw(0,y.createFileSystemProviderError)((0,m.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,y.createFileSystemProviderError)((0,m.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(l,0,r,0,r.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(t,a)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(t){n.canFlush=t}async open(t,r){const s=this.toFilePath(t);let l;(0,y.isFileOpenForWriteOptions)(r)&&(l=await this.createResourceLock(t));let a;try{if((0,y.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:C}=await f.SymlinkSupport.stat(s);C.mode&128||await f.Promises.chmod(s,C.mode|128)}catch(C){this.logService.trace(C)}let g;if((0,y.isFileOpenForWriteOptions)(r)){if(E.isWindows)try{await f.Promises.truncate(s,0),g="r+"}catch(C){C.code!=="ENOENT"&&this.logService.trace(C)}g||(g="w")}else g="r";a=await f.Promises.open(s,g)}catch(g){throw l?.dispose(),(0,y.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(t,g):this.toFileSystemProviderError(g)}if(this.mapHandleToPos.set(a,0),(0,y.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(a,t),l){const g=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${s})`),this.mapHandleToLock.set(a,l),g&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${s})`),g.dispose())}return a}async close(t){const r=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&n.canFlush)try{await f.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.logService.error(s)}return await f.Promises.close(t)}catch(s){throw this.toFileSystemProviderError(s)}finally{r&&(this.mapHandleToLock.get(t)===r&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,s,l,a){const g=this.normalizePos(t,r);let C=null;try{C=(await f.Promises.read(t,s,l,a,g)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(t,g,C)}return C}normalizePos(t,r){return r===this.mapHandleToPos.get(t)?null:r}updatePos(t,r,s){const l=this.mapHandleToPos.get(t);typeof l=="number"&&(typeof r=="number"||(typeof s=="number"?this.mapHandleToPos.set(t,l+s):this.mapHandleToPos.delete(t)))}async write(t,r,s,l,a){return(0,R.retry)(()=>this.doWrite(t,r,s,l,a),100,3)}async doWrite(t,r,s,l,a){const g=this.normalizePos(t,r);let C=null;try{C=(await f.Promises.write(t,s,l,a,g)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),A)}finally{this.updatePos(t,g,C)}return C}async mkdir(t){try{await f.Promises.mkdir(this.toFilePath(t))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(t,r){try{const s=this.toFilePath(t);r.recursive?await f.Promises.rm(s,f.RimRafMode.MOVE):await f.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(t,r,s){const l=this.toFilePath(t),a=this.toFilePath(r);if(l!==a)try{await this.validateTargetDeleted(t,r,"move",s.overwrite),await f.Promises.move(l,a)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,m.localize)(2,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(a)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(t,r,s){const l=this.toFilePath(t),a=this.toFilePath(r);if(l!==a)try{await this.validateTargetDeleted(t,r,"copy",s.overwrite),await f.Promises.copy(l,a,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,m.localize)(3,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(a)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(t,r,s,l){const a=this.toFilePath(t),g=this.toFilePath(r);let C=!1;if(!!(this.capabilities&1024)||(C=(0,P.isEqual)(a,g,!0)),C&&s==="copy")throw(0,y.createFileSystemProviderError)((0,m.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!C&&await f.Promises.exists(g)){if(!l)throw(0,y.createFileSystemProviderError)((0,m.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(t,r){return this.doCloneFile(t,r,!1)}async doCloneFile(t,r,s){const l=this.toFilePath(t),a=this.toFilePath(r),g=!!(this.capabilities&1024);if((0,P.isEqual)(l,a,!g))return;const C=new w.DisposableStore;try{const[A,V]=await Promise.all([this.createResourceLock(t),this.createResourceLock(r)]);C.add(A),C.add(V),s&&await f.Promises.mkdir((0,b.dirname)(a),{recursive:!0}),await f.Promises.copyFile(l,a)}catch(A){if(A.code==="ENOENT"&&!s)return this.doCloneFile(t,r,!0);throw this.toFileSystemProviderError(A)}finally{C.dispose()}}createUniversalWatcher(t,r,s){return new h.UniversalWatcherClient(l=>t(l),l=>r(l),s)}createNonRecursiveWatcher(t,r,s){return new d.NodeJSWatcherClient(l=>t(l),l=>r(l),s)}toFileSystemProviderError(t){if(t instanceof y.FileSystemProviderError)return t;let r;switch(t.code){case"ENOENT":r=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=y.FileSystemProviderErrorCode.NoPermissions;break;default:r=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(t,r)}async toFileSystemProviderWriteError(t,r){let s=this.toFileSystemProviderError(r);if(t&&s.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await f.SymlinkSupport.stat(this.toFilePath(t));l.mode&128||(s=(0,y.createFileSystemProviderError)(r,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return s}}e.DiskFileSystemProvider=n,n.TRACE_LOG_RESOURCE_LOCKS=!1,n.canFlush=!0}),define(se[101],oe([0,1,6,3,2,4,7]),function(Z,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,k.createDecorator)("lifecycleSharedProcessService");let I=class extends R.Disposable{constructor(w){super(),this.logService=w,this.pendingWillShutdownPromise=void 0,this._onWillShutdown=this._register(new i.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const w=[];return this._onWillShutdown.fire({join(b){w.push(b)}}),this.pendingWillShutdownPromise=(async()=>{try{await D.Promises.settled(w)}catch(b){this.logService.error(b)}})(),this.pendingWillShutdownPromise}};I=ve([G(0,T.ILogService)],I),e.SharedProcessLifecycleService=I}),define(se[102],oe([0,1,3,8,7]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(p,v){this.logService=p,this.loggerService=v,this.onDidChangeLogLevel=D.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(p,v,f){switch(v){case"setLevel":return f[1]?this.loggerService.setLevel(i.URI.revive(f[1]),f[0]):this.logService.setLevel(f[0])}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=k;class T{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p,v){T.setLevel(this.channel,p,v)}static setLevel(p,v,f){return p.call("setLevel",[v,f])}}e.LogLevelChannelClient=T;class I{constructor(p){this.loggerService=p,this.loggers=new Map}listen(p,v){throw new Error(`Event not found: ${v}`)}async call(p,v,f){switch(v){case"createLogger":this.createLogger(i.URI.revive(f[0]),f[1]);return;case"log":return this.log(i.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${v}`)}createLogger(p,v){this.loggers.set(p.toString(),this.loggerService.createLogger(p,v))}consoleLog(p,v){let f=console.log;switch(p){case R.LogLevel.Error:f=console.error;break;case R.LogLevel.Warning:f=console.warn;break;case R.LogLevel.Info:f=console.info;break}f.call(console,...v)}log(p,v){const f=this.loggers.get(p.toString());if(!f)throw new Error("Create the logger before logging");for(const[m,y]of v)(0,R.log)(f,m,y)}}e.LoggerChannel=I;class P extends R.AbstractLoggerService{constructor(p,v,f){super(p,v),this.channel=f}createConsoleMainLogger(){return new R.AdapterLogger({log:(p,v)=>{this.channel.call("consoleLog",[p,v])}})}doCreateLogger(p,v,f){return new w(this.channel,p,v,f)}}e.LoggerChannelClient=P;class w extends R.AbstractMessageLogger{constructor(p,v,f,m){super(m?.always),this.channel=p,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[v,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,v){const f=[[p,v]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(p){this.channel.call("log",[this.file,p])}}class b extends R.LogService{constructor(p,v){super(v),this.parent=p,this._register(p.onDidChangeLogLevel(f=>v.setLevel(f)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=b}),define(se[58],oe([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(se[59],oe([0,1,3,64,2,4]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,k.createDecorator)("policy");class T extends R.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(w){const b=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...w,...this.policyDefinitions},b!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(w),i.Iterable.reduce(this.policies.entries(),(E,[p,v])=>({...E,[p]:v}),{})}getPolicyValue(w){return this.policies.get(w)}serialize(){return i.Iterable.reduce(Object.entries(this.policyDefinitions),(w,[b,E])=>({...w,[b]:{definition:E,value:this.policies.get(b)}}),{})}}e.AbstractPolicyService=T;class I{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(se[208],oe([0,1,3,2,59]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class k{constructor(P){this.service=P,this.disposables=new i.DisposableStore}listen(P,w){switch(w){case"onDidChange":return D.Event.map(this.service.onDidChange,b=>b.reduce((E,p)=>({...E,[p]:this.service.getPolicyValue(p)??null}),{}),this.disposables)}throw new Error(`Event not found: ${w}`)}call(P,w,b){switch(w){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(b)}throw new Error(`Call not found: ${w}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=k;class T extends R.AbstractPolicyService{constructor(P,w){super(),this.channel=w;for(const b in P){const{definition:E,value:p}=P[b];this.policyDefinitions[b]=E,p!==void 0&&this.policies.set(b,p)}this.channel.listen("onDidChange")(b=>{for(const E in b){const p=b[E];p===null?this.policies.delete(E):this.policies.set(E,p)}this._onDidChange.fire(Object.keys(b))})}async initializePolicies(P){const w=await this.channel.call("registerPolicyDefinitions",P);for(const b in w)this.policies.set(b,w[b])}}e.PolicyChannelClient=T}),define(se[103],oe([0,1,23,5,36,20]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof i.globals.vscode<"u"&&typeof i.globals.vscode.context<"u"){const I=i.globals.vscode.context.configuration();if(I)T=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Z?.__$__nodeRequire=="function"){const I=(0,k.dirname)(D.FileAccess.asFileUri("",Z));if(T=Z.__$__nodeRequire((0,k.joinPath)(I,"product.json").fsPath),R.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const P=Z.__$__nodeRequire((0,k.joinPath)(I,"package.json").fsPath);Object.assign(T,{version:P.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(se[25],oe([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(se[209],oe([0,1,6,11,2,12,28,7,25]),function(Z,e,D,i,R,k,T,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let w=class extends R.Disposable{constructor(E,p,v){super(),this.productService=p,this.logService=v,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},3e4)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),v=(0,k.dirname)(E),f=(0,k.basename)(E),m=await T.Promises.readdir(v);await Promise.all(m.map(async y=>{if(y===f)return;const u=(0,k.join)(v,y),S=await T.Promises.stat(u);if(S.isDirectory()&&p-S.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),T.Promises.rm(u)}))}catch(p){(0,i.onUnexpectedError)(p)}}};w=ve([G(1,P.IProductService),G(2,I.ILogService)],w),e.CodeCacheCleaner=w}),define(se[210],oe([0,1,6,11,2,12,28,13,7,25]),function(Z,e,D,i,R,k,T,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let b=class extends R.Disposable{constructor(p,v,f){super(),this.environmentService=p,this.logService=v,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),v=JSON.parse(await T.Promises.readFile((0,k.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const S of Object.keys(v)){const c=v[S];p[`${c.hash}.${S}`]=!0}const f=(0,k.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(f))return;const y=await T.Promises.readdir(f);for(const S of y){if(p[S]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${S}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${S}`),await T.Promises.rm((0,k.join)(f,S))}const u=Date.now();for(const S of Object.keys(p)){const c=(0,k.join)(f,S),h=await T.Promises.readdir(c);for(const d of h){if(d==="tcf.json")continue;const n=(0,k.join)(c,d),o=await T.Promises.stat(n);o.isDirectory()&&u-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(S,d)}`),await T.Promises.rm(n))}}}catch(p){(0,i.onUnexpectedError)(p)}}};b=ve([G(0,I.INativeEnvironmentService),G(1,P.ILogService),G(2,w.IProductService)],b),e.LanguagePackCachedDataCleaner=b}),define(se[211],oe([0,1,12,4]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,i.createDecorator)("IV8InspectProfilingService");var R;(function(k){function T(P){return Boolean(P.samples&&P.timeDeltas)}k.isValidProfile=T;function I(P,w="noAbsolutePaths"){for(const b of P.nodes)b.callFrame&&b.callFrame.url&&((0,D.isAbsolute)(b.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(b.callFrame.url))&&(b.callFrame.url=(0,D.join)(w,(0,D.basename)(b.callFrame.url)));return P}k.rewriteAbsolutePaths=I})(R=e.Utils||(e.Utils={}))}),define(se[212],oe([0,1,30]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class i{constructor(){this._sessions=new Map}async startProfiling(k){const I=await(await new Promise((w,b)=>{Z(["v8-inspect-profiler"],w,b)})).startProfiling({port:k.port,checkForPaused:!0}),P=(0,D.generateUuid)();return this._sessions.set(P,I),P}async stopProfiling(k){const T=this._sessions.get(k);if(!T)throw new Error(`UNKNOWN session '${k}'`);const I=await T.stop();return this._sessions.delete(k),I.profile}}e.InspectProfilingService=i}),define(se[40],oe([0,1,127,15]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(T,I){D.ok(i.isString(T)),D.ok(i.isObject(I)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,I)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new R}),define(se[104],oe([0,1,3,40]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class k{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(P,w){this.schemasById[R(P)]=w,this._onDidChangeSchema.fire(P)}notifySchemaChanged(P){this._onDidChangeSchema.fire(P)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new k;i.Registry.add(e.Extensions.JSONContribution,T)}),define(se[45],oe([0,1,19,3,15,152,16,104,40]),function(Z,e,D,i,R,k,T,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=P.Registry.as(I.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,o=!0){this.registerConfigurations([n],o)}registerConfigurations(n,o=!0){const t=this.doRegisterConfigurations(n,o);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(n){const o=this.doDeregisterConfigurations(n);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:n,remove:o}){const t=[];t.push(...this.doDeregisterConfigurations(o)),t.push(...this.doRegisterConfigurations(n,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(n){const o=[],t=[];for(const{overrides:r,source:s}of n)for(const l in r)if(o.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const a=this.configurationDefaultsOverrides.get(l),g=a?.valuesSources??new Map;if(s)for(const _ of Object.keys(r[l]))g.set(_,s);const C={...a?.value||{},...r[l]};this.configurationDefaultsOverrides.set(l,{source:s,value:C,valuesSources:g});const A=(0,T.getLanguageTagSettingPlainKey)(l),V={type:"object",default:C,description:k.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:C,source:R.isString(s)?void 0:s,defaultValueSource:s};t.push(...m(l)),this.configurationProperties[l]=V,this.defaultLanguageConfigurationOverridesNode.properties[l]=V}else{this.configurationDefaultsOverrides.set(l,{value:r[l],source:s});const a=this.configurationProperties[l];a&&(this.updatePropertyDefaultValue(l,a),this.updateSchema(l,a))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const o=[];for(const{overrides:t,source:r}of n)for(const s in t){const l=this.configurationDefaultsOverrides.get(s),a=R.isString(r)?r:r?.id,g=R.isString(l?.source)?l?.source:l?.source?.id;if(a===g)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const C=this.configurationProperties[s];C&&(this.updatePropertyDefaultValue(s,C),this.updateSchema(s,C))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const o of n)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,o){const t=[];return n.forEach(r=>{t.push(...this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),t}doDeregisterConfigurations(n){const o=[],t=r=>{if(r.properties)for(const s in r.properties){o.push(s);const l=this.configurationProperties[s];l?.policy?.name&&this.policyConfigurations.delete(l.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,r.properties[s])}r.allOf?.forEach(s=>t(s))};for(const r of n){t(r);const s=this.configurationContributors.indexOf(r);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(n,o=!0,t,r,s=3){s=R.isUndefinedOrNull(n.scope)?s:n.scope;const l=[],a=n.properties;if(a)for(const C in a){const A=a[C];if(o&&c(C,A)){delete a[C];continue}if(A.source=t,A.defaultDefaultValue=a[C].default,this.updatePropertyDefaultValue(C,A),e.OVERRIDE_PROPERTY_REGEX.test(C)?A.scope=void 0:(A.scope=R.isUndefinedOrNull(A.scope)?s:A.scope,A.restricted=R.isUndefinedOrNull(A.restricted)?!!r?.includes(C):A.restricted),a[C].hasOwnProperty("included")&&!a[C].included){this.excludedConfigurationProperties[C]=a[C],delete a[C];continue}else this.configurationProperties[C]=a[C],a[C].policy?.name&&this.policyConfigurations.set(a[C].policy.name,C);!a[C].deprecationMessage&&a[C].markdownDeprecationMessage&&(a[C].deprecationMessage=a[C].markdownDeprecationMessage),l.push(C)}const g=n.allOf;if(g)for(const C of g)l.push(...this.validateAndRegisterProperties(C,o,t,r,s));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const o=t=>{const r=t.properties;if(r)for(const l in r)this.updateSchema(l,r[l]);t.allOf?.forEach(o)};o(n)}updateSchema(n,o){switch(e.allSettings.properties[n]=o,o.scope){case 1:e.applicationSettings.properties[n]=o;break;case 2:e.machineSettings.properties[n]=o;break;case 6:e.machineOverridableSettings.properties[n]=o;break;case 3:e.windowSettings.properties[n]=o;break;case 4:e.resourceSettings.properties[n]=o;break;case 5:e.resourceSettings.properties[n]=o,this.resourceLanguageSettingsSchema.properties[n]=o;break}}removeFromSchema(n,o){switch(delete e.allSettings.properties[n],o.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const o=`[${n}]`,t={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,t),e.allSettings.properties[o]=t,e.applicationSettings.properties[o]=t,e.machineSettings.properties[o]=t,e.machineOverridableSettings.properties[o]=t,e.windowSettings.properties[o]=t,e.resourceSettings.properties[o]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,o){const t=this.configurationDefaultsOverrides.get(n);let r=t?.value,s=t?.source;R.isUndefined(r)&&(r=o.defaultDefaultValue,s=void 0),R.isUndefined(r)&&(r=u(o.type)),o.default=r,o.defaultValueSource=s}}const v="\\[([^\\]]+)\\]",f=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function m(d){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(d)){let o=f.exec(d);for(;o?.length;){const t=o[1].trim();t&&n.push(t),o=f.exec(d)}}return(0,D.distinct)(n)}e.overrideIdentifiersFromKey=m;function y(d){return d.reduce((n,o)=>`${n}[${o}]`,"")}e.keyFromOverrideIdentifiers=y;function u(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const S=new p;P.Registry.add(e.Extensions.Configuration,S);function c(d,n){return d.trim()?e.OVERRIDE_PROPERTY_REGEX.test(d)?k.localize(7,null,d):S.getConfigurationProperties()[d]!==void 0?k.localize(8,null,d):n.policy?.name&&S.getPolicyConfigurations().get(n.policy?.name)!==void 0?k.localize(9,null,d,n.policy?.name,S.getPolicyConfigurations().get(n.policy?.name)):null:k.localize(6,null)}e.validateProperty=c;function h(){const d=[],n=S.getConfigurationProperties();for(const o of Object.keys(n))d.push([o,n[o].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.getScopes=h}),define(se[73],oe([0,1,19,3,35,2,37,32,15,8,16,45,40]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(o={},t=[],r=[],s){this._contents=o,this._keys=t,this._overrides=r,this.raw=s,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const o=this.raw.map(t=>{if(t instanceof v)return t;const r=new f("");return r.parseRaw(t),r.configurationModel});this._rawConfiguration=o.reduce((t,r)=>r===t?r:t.merge(r),o[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(o){return o?(0,b.getConfigurationValue)(this.contents,o):this.contents}inspect(o,t){const r=this.rawConfiguration.getValue(o),s=t?this.rawConfiguration.getOverrideValue(o,t):void 0,l=t?this.rawConfiguration.override(t).getValue(o):r;return{value:r,override:s,merged:l}}getOverrideValue(o,t){const r=this.getContentsForOverrideIdentifer(t);return r?o?(0,b.getConfigurationValue)(r,o):r:void 0}getKeysForOverrideIdentifier(o){const t=[];for(const r of this.overrides)r.identifiers.includes(o)&&t.push(...r.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const o=[];for(const t of this.overrides)o.push(...t.identifiers);return D.distinct(o)}override(o){let t=this.overrideConfigurations.get(o);return t||(t=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,t)),t}merge(...o){const t=I.deepClone(this.contents),r=I.deepClone(this.overrides),s=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const a of o)if(l.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(t,a.contents);for(const g of a.overrides){const[C]=r.filter(A=>D.equals(A.identifiers,g.identifiers));C?(this.mergeContents(C.contents,g.contents),C.keys.push(...g.keys),C.keys=D.distinct(C.keys)):r.push(I.deepClone(g))}for(const g of a.keys)s.indexOf(g)===-1&&s.push(g)}return new v(t,s,r,l.every(a=>a instanceof v)?void 0:l)}freeze(){return this.frozen=!0,this}clone(){return new v(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}createOverrideConfigurationModel(o){const t=this.getContentsForOverrideIdentifer(o);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const r={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let l=this.contents[s];const a=t[s];a&&(typeof l=="object"&&typeof a=="object"?(l=I.deepClone(l),this.mergeContents(l,a)):l=a),r[s]=l}return new v(r,this.keys,this.overrides)}mergeContents(o,t){for(const r of Object.keys(t)){if(r in o&&P.isObject(o[r])&&P.isObject(t[r])){this.mergeContents(o[r],t[r]);continue}o[r]=I.deepClone(t[r])}}checkAndFreeze(o){return this.frozen&&!Object.isFrozen(o)?I.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let t=null,r=null;const s=l=>{l&&(r?this.mergeContents(r,l):r=I.deepClone(l))};for(const l of this.overrides)D.equals(l.identifiers,[o])?t=l.contents:l.identifiers.includes(o)&&s(l.contents);return s(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,t){this.addKey(o),(0,b.addToValueTree)(this.contents,o,t,r=>{throw new Error(r)})}removeValue(o){this.removeKey(o)&&(0,b.removeFromValueTree)(this.contents,o)}addKey(o){let t=this.keys.length;for(let r=0;r<t;r++)o.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,o)}removeKey(o){const t=this.keys.indexOf(o);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=v;class f{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,t){if(!P.isUndefinedOrNull(o)){const r=this.doParseContent(o);this.parseRaw(r,t)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,t){this._raw=o;const{contents:r,keys:s,overrides:l,restricted:a,hasExcludedProperties:g}=this.doParseRaw(o,t);this._configurationModel=new v(r,s,l,g?[o]:void 0),this._restrictedConfigurations=a||[]}doParseContent(o){let t={},r=null,s=[];const l=[],a=[];function g(A){Array.isArray(s)?s.push(A):r!==null&&(s[r]=A)}const C={onObjectBegin:()=>{const A={};g(A),l.push(s),s=A,r=null},onObjectProperty:A=>{r=A},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const A=[];g(A),l.push(s),s=A,r=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:g,onError:(A,V,_)=>{a.push({error:A,offset:V,length:_})}};if(o)try{R.visit(o,C),t=s[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return t}doParseRaw(o,t){const r=p.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=this.filter(o,r,!0,t);o=s.raw;const l=(0,b.toValuesTree)(o,C=>console.error(`Conflict in settings file ${this._name}: ${C}`)),a=Object.keys(o),g=this.toOverrides(o,C=>console.error(`Conflict in settings file ${this._name}: ${C}`));return{contents:l,keys:a,overrides:g,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}filter(o,t,r,s){let l=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:o,restricted:[],hasExcludedProperties:l};const a={},g=[];for(const C in o)if(E.OVERRIDE_PROPERTY_REGEX.test(C)&&r){const A=this.filter(o[C],t,!1,s);a[C]=A.raw,l=l||A.hasExcludedProperties,g.push(...A.restricted)}else{const A=t[C],V=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&g.push(C),(V===void 0||s.scopes===void 0||s.scopes.includes(V))&&!(s.skipRestricted&&A?.restricted)?a[C]=o[C]:l=!0}return{raw:a,restricted:g,hasExcludedProperties:l}}toOverrides(o,t){const r=[];for(const s of Object.keys(o))if(E.OVERRIDE_PROPERTY_REGEX.test(s)){const l={};for(const a in o[s])l[a]=o[s][a];r.push({identifiers:(0,E.overrideIdentifiersFromKey)(s),keys:Object.keys(l),contents:(0,b.toValuesTree)(l,t)})}return r}}e.ConfigurationModelParser=f;class m extends k.Disposable{constructor(o,t,r,s){super(),this.userSettingsResource=o,this.scopes=t,this.fileService=s,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.any(i.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),i.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&r.isEqual(l.resource,o)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class y{constructor(o,t,r,s,l,a,g,C,A,V,_,F,N){this.key=o,this.overrides=t,this.value=r,this.overrideIdentifiers=s,this.defaultConfiguration=l,this.policyConfiguration=a,this.applicationConfiguration=g,this.userConfiguration=C,this.localUserConfiguration=A,this.remoteUserConfiguration=V,this.workspaceConfiguration=_,this.folderConfigurationModel=F,this.memoryInspectValue=N}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class u{constructor(o,t,r,s,l=new v,a=new v,g=new T.ResourceMap,C=new v,A=new T.ResourceMap,V=!0){this._defaultConfiguration=o,this._policyConfiguration=t,this._applicationConfiguration=r,this._localUserConfiguration=s,this._remoteUserConfiguration=l,this._workspaceConfiguration=a,this._folderConfigurations=g,this._memoryConfiguration=C,this._memoryConfigurationByResource=A,this._freeze=V,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(o,t,r){return this.getConsolidatedConfigurationModel(o,t,r).getValue(o)}updateValue(o,t,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new v,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,t===void 0?s.removeValue(o):s.setValue(o,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,t,r){const s=this.getConsolidatedConfigurationModel(o,t,r),l=D.distinct(s.overrides.map(C=>C.identifiers).flat()).filter(C=>s.getOverrideValue(o,C)!==void 0),a=this.getFolderConfigurationModelForResource(t.resource,r),g=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration;return new y(o,t,s.getValue(o),l.length?l:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),r?this._workspaceConfiguration.freeze():void 0,a?a.freeze():void 0,g.inspect(o,t.overrideIdentifier))}keys(o){const t=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(o){this._policyConfiguration=o}updateApplicationConfiguration(o){this._applicationConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,t){this._folderConfigurations.set(o,t),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,t){const r=[];if(!t){const{added:s,updated:l,removed:a}=h(this._defaultConfiguration,o);t=[...s,...l,...a]}for(const s of t)for(const l of(0,E.overrideIdentifiersFromKey)(s)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(l),g=o.getKeysForOverrideIdentifier(l),C=[...g.filter(A=>a.indexOf(A)===-1),...a.filter(A=>g.indexOf(A)===-1),...a.filter(A=>!I.equals(this._defaultConfiguration.override(l).getValue(A),o.override(l).getValue(A)))];r.push([l,C])}return this.updateDefaultConfiguration(o),{keys:t,overrides:r}}compareAndUpdatePolicyConfiguration(o){const{added:t,updated:r,removed:s}=h(this._policyConfiguration,o),l=[...t,...r,...s];return l.length&&this.updatePolicyConfiguration(o),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:t,updated:r,removed:s,overrides:l}=h(this.applicationConfiguration,o),a=[...t,...r,...s];return a.length&&this.updateApplicationConfiguration(o),{keys:a,overrides:l}}compareAndUpdateLocalUserConfiguration(o){const{added:t,updated:r,removed:s,overrides:l}=h(this.localUserConfiguration,o),a=[...t,...r,...s];return a.length&&this.updateLocalUserConfiguration(o),{keys:a,overrides:l}}compareAndUpdateRemoteUserConfiguration(o){const{added:t,updated:r,removed:s,overrides:l}=h(this.remoteUserConfiguration,o),a=[...t,...r,...s];return a.length&&this.updateRemoteUserConfiguration(o),{keys:a,overrides:l}}compareAndUpdateWorkspaceConfiguration(o){const{added:t,updated:r,removed:s,overrides:l}=h(this.workspaceConfiguration,o),a=[...t,...r,...s];return a.length&&this.updateWorkspaceConfiguration(o),{keys:a,overrides:l}}compareAndUpdateFolderConfiguration(o,t){const r=this.folderConfigurations.get(o),{added:s,updated:l,removed:a,overrides:g}=h(r,t),C=[...s,...l,...a];return(C.length||!r)&&this.updateFolderConfiguration(o,t),{keys:C,overrides:g}}compareAndDeleteFolderConfiguration(o){const t=this.folderConfigurations.get(o);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:r,updated:s,removed:l,overrides:a}=h(t,void 0);return{keys:[...r,...s,...l],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(o,t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier&&(s=s.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(o)!==void 0&&(s=s.merge(this._policyConfiguration)),s}getConsolidatedConfigurationModelForResource({resource:o},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&o){const s=t.getFolder(o);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const l=this._memoryConfigurationByResource.get(o);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let t=this._foldersConsolidatedConfigurations.get(o);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(o);s?(t=r.merge(s),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(o,t)):t=r}return t}getFolderConfigurationModelForResource(o,t){if(t&&o){const r=t.getFolder(o);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,t)=>{const{contents:r,overrides:s,keys:l}=this._folderConfigurations.get(t);return o.push([t,{contents:r,overrides:s,keys:l}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>o.add(t)),this.userConfiguration.freeze().keys.forEach(t=>o.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>o.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>o.add(r))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>o.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>o.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>o.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>o.add(r))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(o).forEach(s=>t.add(s))),[...t.values()]}static parse(o){const t=this.parseConfigurationModel(o.defaults),r=this.parseConfigurationModel(o.policy),s=this.parseConfigurationModel(o.application),l=this.parseConfigurationModel(o.user),a=this.parseConfigurationModel(o.workspace),g=o.folders.reduce((C,A)=>(C.set(w.URI.revive(A[0]),this.parseConfigurationModel(A[1])),C),new T.ResourceMap);return new u(t,r,s,l,new v,a,g,new v,new T.ResourceMap,!1)}static parseConfigurationModel(o){return new v(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=u;function S(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const o=new Set,t=new Map;for(const s of n)s.keys.forEach(l=>o.add(l)),s.overrides.forEach(([l,a])=>{const g=(0,T.getOrSet)(t,l,new Set);a.forEach(C=>g.add(C))});const r=[];return t.forEach((s,l)=>r.push([l,[...s.values()]])),{keys:[...o.values()],overrides:r}}e.mergeChanges=S;class c{constructor(o,t,r,s){this.change=o,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;o.keys.forEach(g=>l.add(g)),o.overrides.forEach(([,g])=>g.forEach(C=>l.add(C))),this.affectedKeys=[...l.values()];const a=new v;this.affectedKeys.forEach(g=>a.setValue(g,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(o,t,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(o,t,this.currentWorkspace);return!I.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(o,t){let r=(0,b.toValuesTree)({[t]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(o=o[s],!o)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=c;function h(n,o){const{added:t,removed:r,updated:s}=d(o?.rawConfiguration,n?.rawConfiguration),l=[],a=n?.getAllOverrideIdentifiers()||[],g=o?.getAllOverrideIdentifiers()||[];if(o){const C=g.filter(A=>!a.includes(A));for(const A of C)l.push([A,o.getKeysForOverrideIdentifier(A)])}if(n){const C=a.filter(A=>!g.includes(A));for(const A of C)l.push([A,n.getKeysForOverrideIdentifier(A)])}if(o&&n){for(const C of a)if(g.includes(C)){const A=d({contents:n.getOverrideValue(void 0,C)||{},keys:n.getKeysForOverrideIdentifier(C)},{contents:o.getOverrideValue(void 0,C)||{},keys:o.getKeysForOverrideIdentifier(C)});l.push([C,[...A.added,...A.removed,...A.updated]])}}return{added:t,removed:r,updated:s,overrides:l}}function d(n,o){const t=n?o?n.keys.filter(l=>o.keys.indexOf(l)===-1):[...n.keys]:[],r=o?n?o.keys.filter(l=>n.keys.indexOf(l)===-1):[...o.keys]:[],s=[];if(n&&o){for(const l of o.keys)if(n.keys.indexOf(l)!==-1){const a=(0,b.getConfigurationValue)(o.contents,l),g=(0,b.getConfigurationValue)(n.contents,l);I.equals(a,g)||s.push(l)}}return{added:t,removed:r,updated:s}}}),define(se[213],oe([0,1,19,3,2,32,15,16,73,45,7,59,40]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class v extends R.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new f(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(p.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(({properties:S,defaultsOverrides:c})=>this.onDidUpdateConfiguration(S,c))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(S,c){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:S})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=v;class f extends P.ConfigurationModel{constructor(S={}){const c=p.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(c),d=Object.create(null),n=[];for(const o in c){const t=S[o],r=t!==void 0?t:c[o].default;(0,I.addToValueTree)(d,o,r,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(d))w.OVERRIDE_PROPERTY_REGEX.test(o)&&n.push({identifiers:(0,w.overrideIdentifiersFromKey)(o),keys:Object.keys(d[o]),contents:(0,I.toValuesTree)(d[o],t=>console.error(`Conflict in default settings file: ${t}`))});super(d,h,n)}}e.DefaultConfigurationModel=f;class m{constructor(){this.onDidChangeConfiguration=i.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=m;let y=class extends R.Disposable{get configurationModel(){return this._configurationModel}constructor(S,c,h){super(),this.defaultConfiguration=S,this.policyService=c,this.logService=h,this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new P.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(S=>this.onDidChangePolicies(S))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:S})=>this.update(await this.registerPolicyDefinitions(S),!0))),this._configurationModel}async registerPolicyDefinitions(S){const c={},h=[],d=p.Registry.as(w.Extensions.Configuration).getConfigurationProperties();for(const n of S){const o=d[n];if(!o){h.push(n);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}h.push(n),c[o.policy.name]={type:o.type}}}return(0,T.isEmptyObject)(c)||await this.policyService.registerPolicyDefinitions(c),h}onDidChangePolicies(S){const c=p.Registry.as(w.Extensions.Configuration).getPolicyConfigurations(),h=(0,D.coalesce)(S.map(d=>c.get(d)));this.update(h,!0)}update(S,c){const h=p.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),d=[],n=this._configurationModel.isEmpty();for(const o of S){const t=h[o]?.policy?.name;if(t){const r=this.policyService.getPolicyValue(t);(n?r!==void 0:!(0,k.equals)(this._configurationModel.getValue(o),r))&&d.push([o,r])}else this._configurationModel.getValue(o)!==void 0&&d.push([o,void 0])}if(d.length){const o=this._configurationModel;this._configurationModel=new P.ConfigurationModel;for(const t of o.keys)this._configurationModel.setValue(t,o.getValue(t));for(const[t,r]of d)r===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,r);c&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};y=ve([G(1,E.IPolicyService),G(2,b.ILogService)],y),e.PolicyConfiguration=y}),define(se[214],oe([0,1,6,3,2,20,16,73,213,59]),function(Z,e,D,i,R,k,T,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends R.Disposable{constructor(p,v,f,m){super(),this.settingsResource=p,this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new P.DefaultConfiguration),this.policyConfiguration=f instanceof w.NullPolicyService?new P.NullPolicyConfiguration:this._register(new P.PolicyConfiguration(this.defaultConfiguration,f,m)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,v)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:y,properties:u})=>this.onDidDefaultConfigurationChange(y,u))),this._register(this.policyConfiguration.onDidChangeConfiguration(y=>this.onDidPolicyConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[p,v,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(p,v,new I.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(p,v){const f=typeof p=="string"?p:void 0,m=(0,T.isConfigurationOverrides)(p)?p:(0,T.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(f,m,void 0)}updateValue(p,v,f,m){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const v=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(f,v,2)}onDidDefaultConfigurationChange(p,v){const f=this.configuration.toData(),m=this.configuration.compareAndUpdateDefaultConfiguration(p,v);this.trigger(m,f,7)}onDidPolicyConfigurationChange(p){const v=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(p);this.trigger(f,v,7)}trigger(p,v,f){const m=new I.ConfigurationChangeEvent(p,{data:v},this.configuration);m.source=f,m.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(p){switch(p){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(se[215],oe([0,1,11,4]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var R;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends D.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof k&&I._code===R.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof k&&I._code===R.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof k&&I._code===R.NoResolverFound}static isHandled(I){return I instanceof k&&I.isHandled}constructor(I,P=R.Unknown,w){super(I),this._message=I,this._code=P,this._detail=w,this.isHandled=P===R.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}}e.RemoteAuthorityResolverError=k}),define(se[105],oe([0,1,23]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(w){return w.scheme===D.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=i;function R(w){if(!w)return;const b=w.indexOf("+");return b<0?w:w.substr(0,b)}e.getRemoteName=R;function k(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.getRemoteServerRootPath=k;function T(w){const{host:b,port:E}=P(w);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:E}}e.parseAuthorityWithPort=T;function I(w,b){let{host:E,port:p}=P(w);return typeof p>"u"&&(p=b),{host:E,port:p}}e.parseAuthorityWithOptionalPort=I;function P(w){const b=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const E=w.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const p=w.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:w,port:void 0}}}),define(se[46],oe([0,1,27,4,105]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=k;function T(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var P;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class w{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,y){if(typeof m>"u"||m===null)return typeof y>"u"||y===null;if(typeof y>"u"||y===null)return!1;if(typeof m=="string"||typeof y=="string"){const u=typeof m=="string"?m:m.value,S=typeof y=="string"?y:y.value;return D.equalsIgnoreCase(u,S)}return m._lower===y._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=w;function b(f){return E(f)}e.isApplicationScopedExtension=b;function E(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function p(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function v(f,m){if(m){const y=`onResolveRemoteAuthority:${(0,R.getRemoteName)(m)}`;return f.activationEvents?.indexOf(y)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(se[33],oe([0,1,27,29,46,5,8,11,36]),function(Z,e,D,i,R,k,T,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function w(o,t){return o.uuid&&t.uuid?o.uuid===t.uuid:o.id===t.id?!0:(0,D.compareIgnoreCase)(o.id,t.id)===0}e.areSameExtensions=w;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{static create(t){const r=t.manifest?t.manifest.version:t.version,s=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new E(t.identifier,r,s)}static parse(t){const r=b.exec(t);return r&&r[1]&&r[2]?new E({id:r[1]},r[2],r[4]||void 0):null}constructor(t,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof E?w(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=E;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(o){const t=p.exec(o);return t&&t[1]?[m(t[1]),t[2]]:[m(o),void 0]}e.getIdAndVersion=v;function f(o,t){return`${o}.${t}`}e.getExtensionId=f;function m(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=m;function y(o,t){return m(f(o,t))}e.getGalleryExtensionId=y;function u(o,t){const r=[],s=l=>{for(const a of r)if(a.some(g=>w(t(g),t(l))))return a;return null};for(const l of o){const a=s(l);a?a.push(l):r.push([l])}return r}e.groupByExtension=u;function S(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function c(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.getGalleryExtensionTelemetryData=c,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function h(o,t){const r=[],s=t.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const l=s.shift();if(l&&r.every(a=>!w(a.identifier,{id:l}))){const a=o.filter(g=>w(g.identifier,{id:l}));a.length===1&&(r.push(a[0]),s.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=h;async function d(o,t){if(!k.isLinux)return!1;let r;try{r=(await o.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await o.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){t.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(l))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=d;async function n(o,t){const r=await d(o,t),s=(0,i.getTargetPlatform)(r?"alpine":k.platform,P.arch);return t.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=n}),define(se[60],oe([0,1,6,17,2,3,37,8,33,14,4,7]),function(Z,e,D,i,R,k,T,I,P,w,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let p=class extends R.Disposable{constructor(f,m){super(),this.fileService=f,this.logService=m,this._onAddExtensions=this._register(new k.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new k.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new k.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new k.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(f){return this.withProfileExtensions(f)}async addExtensionsToProfile(f,m){this._onAddExtensions.fire({extensions:f.map(y=>y[0]),profileLocation:m});try{const u=(await this.withProfileExtensions(m,S=>(S=S.filter(c=>f.some(([h])=>!(0,P.areSameExtensions)(c.identifier,h.identifier))),S.push(...f.map(([c,h])=>({identifier:c.identifier,version:c.manifest.version,location:c.location,metadata:h}))),S))).filter(S=>f.some(([c])=>(0,P.areSameExtensions)(S.identifier,c.identifier)));return this._onDidAddExtensions.fire({extensions:f.map(S=>S[0]),profileLocation:m}),u}catch(y){throw this._onDidAddExtensions.fire({extensions:f.map(u=>u[0]),error:y,profileLocation:m}),y}}async removeExtensionFromProfile(f,m){this._onRemoveExtensions.fire({extensions:[f],profileLocation:m});try{await this.withProfileExtensions(m,y=>y.filter(u=>!(0,P.areSameExtensions)(u.identifier,f.identifier))),this._onDidRemoveExtensions.fire({extensions:[f],profileLocation:m})}catch(y){throw this._onDidRemoveExtensions.fire({extensions:[f],error:y,profileLocation:m}),y}}async withProfileExtensions(f,m){return this.getResourceAccessQueue(f).queue(async()=>{let y=[];try{const u=await this.fileService.readFile(f),S=JSON.parse(u.value.toString());for(const c of S){if(!c.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",c);continue}if(!c.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",c);continue}if(!c.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",c);continue}y.push({identifier:c.identifier,location:I.URI.revive(c.location),version:c.version,metadata:c.metadata})}}catch(u){u.fileOperationResult!==1&&this.logService.error(u)}if(m){y=m(y);const u=y.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),metadata:S.metadata}));await this.fileService.writeFile(f,i.VSBuffer.fromString(JSON.stringify(u)))}return y})}getResourceAccessQueue(f){let m=this.resourcesAccessQueueMap.get(f);return m||(m=new D.Queue,this.resourcesAccessQueueMap.set(f,m)),m}};p=ve([G(0,w.IFileService),G(1,E.ILogService)],p),e.ExtensionsProfileScannerService=p}),define(se[216],oe([0,1,22,33]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function R(k,T,I,P,w){try{const b=await k.getExtensionsControlManifest();if(!b.deprecated)return;const E=await k.getInstalled(1);for(const[p,v]of Object.entries(b.deprecated)){if(!v?.extension)continue;const{id:f,autoMigrate:m,preRelease:y}=v.extension;if(!m)continue;const u=E.find(c=>(0,i.areSameExtensions)(c.identifier,{id:p}));if(!u)continue;const S=(await T.getExtensions([{id:f,preRelease:y}],{targetPlatform:await k.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!S){w.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{w.info(`Migrating '${u.identifier.id}' extension to '${f}' extension...`);const c=!P.getDisabledExtensions().some(d=>(0,i.areSameExtensions)(d,u.identifier));await k.uninstall(u),w.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let h=E.find(d=>(0,i.areSameExtensions)(d.identifier,{id:f}));(!h||!h.isPreReleaseVersion&&c)&&(h=await k.installFromGallery(S,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),w.info(`Installed the pre-release extension '${h.identifier.id}'`),c||(await P.disableExtension(h.identifier),w.info(`Disabled the pre-release extension '${h.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),m.storage&&(I.addToMigrationList((0,i.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,i.getExtensionId)(h.manifest.publisher,h.manifest.name)),w.info("Added pre-release extension to the storage migration list"))),w.info(`Migrated '${u.identifier.id}' extension to '${f}' extension.`)}catch(c){w.error(c)}}}catch(b){w.error(b)}}e.migrateUnsupportedExtensions=R}),define(se[217],oe([0,1,6,11,2,23,5,20,54,30,28,16,13,29,33,97,14,7]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let S=class St extends R.Disposable{constructor(h,d,n,o,t,r){super(),this.fileService=d,this.extensionGalleryService=n,this.configurationService=o,this.extensionSignatureVerificationService=t,this.logService=r,this.extensionsDownloadDir=h.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(h,d){await this.cleanUpPromise;const n=(0,I.joinPath)(this.extensionsDownloadDir,this.getName(h));try{await this.downloadFile(h,n,t=>this.extensionGalleryService.download(h,t,d))}catch(t){throw new v.ExtensionManagementError(t.message,v.ExtensionManagementErrorCode.Download)}let o=!1;if(h.isSigned&&this.configurationService.getValue("extensions.verifySignature")===!0){const t=await this.downloadSignatureArchive(h);try{o=await this.extensionSignatureVerificationService.verify(n.fsPath,t.fsPath),this.logService.info(`Verified extension: ${h.identifier.id}`,o)}catch(r){throw await this.delete(t),await this.delete(n),new v.ExtensionManagementError(r.code,v.ExtensionManagementErrorCode.Signature)}}return{location:n,verified:o}}async downloadSignatureArchive(h){await this.cleanUpPromise;const d=(0,I.joinPath)(this.extensionsDownloadDir,`${this.getName(h)}${St.SignatureArchiveExtension}`);return await this.downloadFile(h,d,n=>this.extensionGalleryService.downloadSignatureArchive(h,n)),d}async downloadFile(h,d,n){if(await this.fileService.exists(d))return;if(d.scheme!==k.Schemas.file){await n(d);return}const o=(0,I.joinPath)(this.extensionsDownloadDir,`.${(0,w.generateUuid)()}`);await this.fileService.exists(o)||await n(o);try{await this.rename(o,d,Date.now()+2*60*1e3)}catch(t){try{await this.fileService.del(o)}catch{}if(t.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",h.identifier.id,d.path);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(t)}. Deleted the file from downloaded location`,o.path),t}}async delete(h){await this.cleanUpPromise,await this.fileService.del(h)}async rename(h,d,n){try{await b.Promises.rename(h.fsPath,d.fsPath)}catch(o){if(T.isWindows&&o&&o.code==="EPERM"&&Date.now()<n)return this.logService.info(`Failed renaming ${h} to ${d} with 'EPERM' error. Trying again...`),this.rename(h,d,n);throw o}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const d=[],n=[],o=[];for(const s of h.children)if(s.name.endsWith(St.SignatureArchiveExtension))o.push(s.resource);else{const l=f.ExtensionKey.parse(s.name);l&&n.push([l,s])}const t=(0,f.groupByExtension)(n,([s])=>s),r=[];for(const s of t)s.sort((l,a)=>P.rcompare(l[0].version,a[0].version)),d.push(...s.slice(1).map(l=>l[1].resource)),r.push(s[0][1]);r.sort((s,l)=>s.mtime-l.mtime),d.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(s=>s.resource)),d.push(...o),await D.Promises.settled(d.map(s=>(this.logService.trace("Deleting from cache",s.path),this.fileService.del(s))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?f.ExtensionKey.create(h).toString().toLowerCase():(0,w.generateUuid)()}};S.SignatureArchiveExtension=".sigzip",S=ve([G(0,p.INativeEnvironmentService),G(1,y.IFileService),G(2,v.IExtensionGalleryService),G(3,E.IConfigurationService),G(4,m.IExtensionSignatureVerificationService),G(5,u.ILogService)],S),e.ExtensionsDownloader=S}),define(se[218],oe([0,1,2,12,28,46]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(P,w){super(),this.environmentService=P,this.extensionsManifestCache=(0,i.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(w.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(w.onDidUninstallExtension(b=>this.onDidUnInstallExtension(b)))}onDidInstallExtensions(P){P.some(w=>!!w.local)&&this.invalidate()}onDidUnInstallExtension(P){P.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(se[219],oe([0,1,3,2,37,33,46]),function(Z,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class I extends i.Disposable{constructor(w,b,E,p,v,f){super(),this.extensionManagementService=w,this.userDataProfilesService=b,this.extensionsProfileScannerService=E,this.uriIdentityService=p,this.fileService=v,this.logService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new i.DisposableMap),this.initialize().then(null,m=>f.error(m))}async initialize(){await this.extensionManagementService.migrateDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles,[]),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(w=>this.onDidChangeProfiles(w.added,w.removed))),this._register(this.extensionsProfileScannerService.onAddExtensions(w=>this.onAddExtensions(w))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(w=>this.onDidAddExtensions(w))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(w=>this.onRemoveExtensions(w))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(w=>this.onDidRemoveExtensions(w))),this._register(this.fileService.onDidFilesChange(w=>this.onDidFilesChange(w)))}async onDidChangeProfiles(w,b){try{await Promise.all(b.map(E=>(this.extensionsProfileWatchDisposables.deleteAndDispose(E.id),this.removeExtensionsFromProfile(E.extensionsResource))))}catch(E){this.logService.error(E)}try{w.length&&await Promise.all(w.map(E=>(this.extensionsProfileWatchDisposables.set(E.id,(0,i.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(E.extensionsResource)),this.fileService.watch(E.extensionsResource))),this.populateExtensionsFromProfile(E.extensionsResource))))}catch(E){this.logService.error(E)}}async onAddExtensions(w){for(const b of w.extensions)this.addExtensionWithKey(this.getKey(b.identifier,b.manifest.version),w.profileLocation)}async onDidAddExtensions(w){for(const b of w.extensions){const E=this.getKey(b.identifier,b.manifest.version);w.error?this.removeExtensionWithKey(E,w.profileLocation):this.addExtensionWithKey(E,w.profileLocation)}}async onRemoveExtensions(w){for(const b of w.extensions)this.removeExtensionWithKey(this.getKey(b.identifier,b.manifest.version),w.profileLocation)}async onDidRemoveExtensions(w){const b=[];for(const E of w.extensions){const p=this.getKey(E.identifier,E.manifest.version);w.error?this.addExtensionWithKey(p,w.profileLocation):(this.removeExtensionWithKey(p,w.profileLocation),this.allExtensions.has(p)||b.push(E))}b.length&&await this.extensionManagementService.markAsUninstalled(...b)}onDidFilesChange(w){for(const b of this.userDataProfilesService.profiles)w.contains(b.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(b.extensionsResource)}async onDidExtensionsProfileChange(w){const b=[],E=[],p=await this.extensionsProfileScannerService.scanProfileExtensions(w),v=new Set,f=new Set;for(const[m,y]of this.allExtensions)y.has(w)&&f.add(m);for(const m of p){const y=this.getKey(m.identifier,m.version);v.add(y),f.has(y)||(b.push(m.identifier),this.addExtensionWithKey(y,w))}for(const m of f)if(!v.has(m)){const y=this.fromKey(m);y&&(E.push(y.identifier),this.removeExtensionWithKey(m,w))}(b.length||E.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b.length?{extensions:b,profileLocation:w}:void 0,removed:E.length?{extensions:E,profileLocation:w}:void 0})}async populateExtensionsFromProfile(w){const b=await this.extensionsProfileScannerService.scanProfileExtensions(w);for(const E of b)this.addExtensionWithKey(this.getKey(E.identifier,E.version),w)}async removeExtensionsFromProfile(w){for(const b of[...this.allExtensions.keys()])this.removeExtensionWithKey(b,w);await this.uninstallExtensionsNotInProfiles()}async uninstallExtensionsNotInProfiles(){const b=(await this.extensionManagementService.getAllUserInstalled()).filter(E=>!this.allExtensions.has(this.getKey(E.identifier,E.manifest.version)));b.length&&await this.extensionManagementService.markAsUninstalled(...b)}addExtensionWithKey(w,b){let E=this.allExtensions.get(w);E||this.allExtensions.set(w,E=new R.ResourceSet(p=>this.uriIdentityService.extUri.getComparisonKey(p))),E.add(b)}removeExtensionWithKey(w,b){const E=this.allExtensions.get(w);E&&E.delete(b),E?.size||this.allExtensions.delete(w)}getKey(w,b){return`${T.ExtensionIdentifier.toKey(w.id)}@${b}`}fromKey(w){const[b,E]=(0,k.getIdAndVersion)(w);return E?{identifier:{id:b},version:E}:void 0}}e.ExtensionsWatcher=I}),define(se[220],oe([0,1,99,19,6,2,23,12,28,13,29,33,7,72,5,8]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends v.LanguagePackBaseService{constructor(h,d,n,o){super(n),this.extensionManagementService=h,this.logService=o,this.cache=this._register(new u(d,o)),this.extensionManagementService.registerParticipant({postInstall:async t=>this.postInstallExtension(t),postUninstall:async t=>this.postUninstallExtension(t)})}async getBuiltInExtensionTranslationsUri(h){const n=(await this.cache.getLanguagePacks())[f.Language.value()];if(!n){this.logService.warn(`No language pack found for ${f.Language.value()}`);return}const o=n.translations[h];return o?m.URI.file(o):void 0}async getInstalledLanguages(){const h=await this.cache.getLanguagePacks(),d=Object.keys(h).map(n=>{const o=h[n];return{...this.createQuickPickItem(n,o.label),extensionId:o.extensions[0].extensionIdentifier.id}});return d.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),d.sort((n,o)=>n.label.localeCompare(o.label)),d}async postInstallExtension(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",h.identifier.id),await this.update())}async postUninstallExtension(h){const d=await this.cache.getLanguagePacks();Object.keys(d).some(n=>d[n]&&d[n].extensions.some(o=>(0,E.areSameExtensions)(o.extensionIdentifier,h.identifier)))&&(this.logService.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,d]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),n=await this.cache.update(d);return!(0,i.equals)(Object.keys(h),Object.keys(n))}};y=ve([G(0,b.IExtensionManagementService),G(1,w.INativeEnvironmentService),G(2,b.IExtensionGalleryService),G(3,p.ILogService)],y),e.NativeLanguagePackService=y;let u=class extends k.Disposable{constructor(h,d){super(),this.logService=d,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(h.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(h){return this.withLanguagePacks(d=>{Object.keys(d).forEach(n=>delete d[n]),this.createLanguagePacksFromExtensions(d,...h)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(h,...d){for(const n of d)n&&n.manifest&&n.manifest.contributes&&n.manifest.contributes.localizations&&n.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(h,n);Object.keys(h).forEach(n=>this.updateHash(h[n]))}createLanguagePacksFromExtension(h,d){const n=d.identifier,o=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const t of o)if(d.location.scheme===T.Schemas.file&&S(t)){let r=h[t.languageId];r||(r={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},h[t.languageId]=r);const s=r.extensions.filter(l=>(0,E.areSameExtensions)(l.extensionIdentifier,n))[0];s?s.version=d.manifest.version:r.extensions.push({extensionIdentifier:n,version:d.manifest.version});for(const l of t.translations)r.translations[l.id]=(0,I.join)(d.location.fsPath,l.path)}}updateHash(h){if(h){const d=(0,D.createHash)("md5");for(const n of h.extensions)d.update(n.extensionIdentifier.uuid||n.extensionIdentifier.id).update(n.version);h.hash=d.digest("hex")}}withLanguagePacks(h=()=>null){return this.languagePacksFileLimiter.queue(()=>{let d=null;return P.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,n=>n.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(n)).then(n=>{try{return JSON.parse(n)}catch{return{}}}).then(n=>(d=h(n),n)).then(n=>{for(const t of Object.keys(n))n[t]||delete n[t];this.languagePacks=n,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),P.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>d,n=>this.logService.error(n))})}};u=ve([G(0,w.INativeEnvironmentService),G(1,p.ILogService)],u);function S(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const h of c.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(se[221],oe([0,1,6,17,22,11,3,2,30,91,215,105]),function(Z,e,D,i,R,k,T,I,P,w,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var v;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function f(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function m(J){const Q=new R.CancellationTokenSource;return setTimeout(()=>Q.cancel(),J),Q.token}function y(J,Q){if(J.isCancellationRequested||Q.isCancellationRequested)return R.CancellationToken.Cancelled;const M=new R.CancellationTokenSource;return J.onCancellationRequested(()=>M.cancel()),Q.onCancellationRequested(()=>M.cancel()),M.token}class u{get didTimeout(){return this._state==="timedout"}constructor(Q){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((M,O)=>{this._resolvePromise=M,this._rejectPromise=O}),Q.isCancellationRequested?this._timeout():this._disposables.add(Q.onCancellationRequested(()=>this._timeout()))}registerDisposable(Q){this._state==="pending"?this._disposables.add(Q):Q.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Q=new Error("Time limit reached");return Q.code="ETIMEDOUT",Q.syscall="connect",Q}resolve(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Q))}reject(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Q))}}function S(J,Q){const M=new u(Q);return M.registerDisposable(J.onControlMessage(O=>{const B=JSON.parse(O.toString()),z=W(B);z?M.reject(z):M.resolve(B)})),M.promise}function c(J,Q,M,O,B,z,Y,ne){const X=new u(ne);return Q.connect(M,O,B,z,Y,(te,re)=>{X.didTimeout?(te&&J.error(te),re?.dispose()):te||!re?X.reject(te):X.resolve(re)}),X.promise}function h(J,Q){const M=new u(Q);return J.then(O=>{M.didTimeout||M.resolve(O)},O=>{M.didTimeout||M.reject(O)}),M.promise}async function d(J,Q,M,O){const B=ee(J,Q);J.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let z;try{z=await c(J.logService,J.socketFactory,J.host,J.port,(0,E.getRemoteServerRootPath)(J),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,`renderer-${f(Q)}-${J.reconnectionToken}`,O)}catch(re){throw J.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),J.logService.error(re),re}J.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let Y,ne;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(z,null),Y=J.reconnectionProtocol,ne=!1):(Y=new w.PersistentProtocol(z,null),ne=!0),J.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const X=await h(J.signService.createNewMessage((0,P.generateUuid)()),O),te={type:"auth",auth:J.connectionToken||"00000000000000000000",data:X.data};Y.sendControl(i.VSBuffer.fromString(JSON.stringify(te)));try{const re=await S(Y,y(O,m(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(J.logService.trace(`${B} 4/6. received SignRequest control message.`),!await h(J.signService.validate(X,re.signedData),O)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const ue=await h(J.signService.sign(re.data),O),Se={type:"connectionType",commit:J.commit,signedData:ue,desiredConnectionType:Q};return M&&(Se.args=M),J.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(i.VSBuffer.fromString(JSON.stringify(Se))),{protocol:Y,ownsProtocol:ne}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(J.logService.error(`${B} the handshake timed out. Error:`),J.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${B} received error control message when negotiating connection. Error:`),J.logService.error(re)),ne&&x(Y),re}}async function n(J,Q,M,O){const B=Date.now(),z=ee(J,Q),{protocol:Y,ownsProtocol:ne}=await d(J,Q,M,O),X=new u(O);return X.registerDisposable(Y.onControlMessage(te=>{const re=JSON.parse(te.toString()),le=W(re);le?(J.logService.error(`${z} received error control message when negotiating connection. Error:`),J.logService.error(le),ne&&x(Y),X.reject(le)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${ce(B)}!`),X.resolve({protocol:Y,firstMessage:re}))})),X.promise}async function o(J,Q){const{protocol:M}=await n(J,1,void 0,Q);return{protocol:M}}async function t(J,Q,M){const{protocol:O,firstMessage:B}=await n(J,2,Q,M),z=B&&B.debugPort;return{protocol:O,debugPort:z}}async function r(J,Q,M){const O=Date.now(),B=ee(J,3),{protocol:z}=await d(J,3,Q,M);return J.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${ce(O)}!`),z}async function s(J,Q,M){const{host:O,port:B,connectionToken:z}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,host:O,port:B,connectionToken:z,reconnectionToken:Q,reconnectionProtocol:M,socketFactory:J.socketFactory,signService:J.signService,logService:J.logService}}async function l(J,Q,M){return g(J,async O=>{const{protocol:B}=await o(O,R.CancellationToken.None);return new H(J,Q,M,O.reconnectionToken,B)})}e.connectRemoteAgentManagement=l;async function a(J,Q){return g(J,async M=>{const{protocol:O,debugPort:B}=await t(M,Q,R.CancellationToken.None);return new q(J,Q,M.reconnectionToken,O,B)})}e.connectRemoteAgentExtensionHost=a;async function g(J,Q){for(let O=1;;O++)try{const B=(0,P.generateUuid)(),z=await s(J,B,null);return await Q(z)}catch(B){if(O<5)J.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(B);else throw J.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(B),$.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(B)),B}}async function C(J,Q,M){const O=await s(J,(0,P.generateUuid)(),null);return await r(O,{host:Q,port:M},R.CancellationToken.None)}e.connectRemoteAgentTunnel=C;function A(J){return(0,D.createCancelablePromise)(Q=>new Promise((M,O)=>{const B=setTimeout(M,J*1e3);Q.onCancellationRequested(()=>{clearTimeout(B),M()})}))}var V;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(V=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class _{constructor(Q,M){this.reconnectionToken=Q,this.millisSinceLastIncomingData=M,this.type=0}}e.ConnectionLostEvent=_;class F{constructor(Q,M,O,B){this.reconnectionToken=Q,this.millisSinceLastIncomingData=M,this.durationSeconds=O,this.cancellableTimer=B,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class N{constructor(Q,M,O){this.reconnectionToken=Q,this.millisSinceLastIncomingData=M,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=N;class L{constructor(Q,M,O){this.reconnectionToken=Q,this.millisSinceLastIncomingData=M,this.attempt=O,this.type=4}}e.ConnectionGainEvent=L;class U{constructor(Q,M,O,B){this.reconnectionToken=Q,this.millisSinceLastIncomingData=M,this.attempt=O,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=U;class $ extends I.Disposable{static triggerPermanentFailure(Q,M,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Q,this._permanentFailureAttempt=M,this._permanentFailureHandled=O,this._instances.forEach(B=>B._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Q=>Q._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Q=>Q._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||$._permanentFailure}constructor(Q,M,O,B,z){super(),this._connectionType=Q,this._options=M,this.reconnectionToken=O,this.protocol=B,this._reconnectionFailureIsFatal=z,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new L(this.reconnectionToken,0,0)),this._register(B.onSocketClose(Y=>{const ne=K(this._connectionType,this.reconnectionToken,!0);Y?Y.type===0?(this._options.logService.info(`${ne} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this._options.logService.error(Y.error)):(this._options.logService.info(`${ne} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this._options.logService.error(Y.event)):this._options.logService.info(`${ne} received socket close event.`),this._beginReconnecting()})),this._register(B.onSocketTimeout(Y=>{const ne=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ne} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),$._instances.push(this),this._register((0,I.toDisposable)(()=>{const Y=$._instances.indexOf(this);Y>=0&&$._instances.splice(Y,1)})),this._isPermanentFailure&&this._gotoPermanentFailure($._permanentFailureMillisSinceLastIncomingData,$._permanentFailureAttempt,$._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const Q=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Q} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const B=O<M.length?M[O]:M[M.length-1];try{if(B>0){const Y=A(B);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,Y)),this._options.logService.info(`${Q} waiting for ${B} seconds before reconnecting...`);try{await Y}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${Q} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${Q} resolving connection...`);const z=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Q} connecting to ${z.host}:${z.port}...`),await this._reconnect(z,m(p)),this._options.logService.info(`${Q} reconnected!`),this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${Q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(z)){this._options.logService.info(`${Q} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this._options.logService.info(`${Q} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((0,k.isCancellationError)(z)){this._options.logService.info(`${Q} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if(z instanceof b.RemoteAuthorityResolverError){this._options.logService.error(`${Q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,b.RemoteAuthorityResolverError.isHandled(z));break}this._options.logService.error(`${Q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(Q,M,O){this._reconnectionFailureIsFatal?$.triggerPermanentFailure(Q,M,O):this._gotoPermanentFailure(Q,M,O)}_gotoPermanentFailure(Q,M,O){this._onDidStateChange.fire(new U(this.reconnectionToken,Q,M,O)),x(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=$,$._permanentFailure=!1,$._permanentFailureMillisSinceLastIncomingData=0,$._permanentFailureAttempt=0,$._permanentFailureHandled=!1,$._instances=[];class H extends ${constructor(Q,M,O,B,z){super(1,Q,B,z,!0),this.client=this._register(new w.Client(z,{remoteAuthority:M,clientId:O},Q.ipcLogger))}async _reconnect(Q,M){await o(Q,M)}}e.ManagementPersistentConnection=H;class q extends ${constructor(Q,M,O,B,z){super(2,Q,O,B,!1),this._startArguments=M,this.debugPort=z}async _reconnect(Q,M){await t(Q,this._startArguments,M)}}e.ExtensionHostPersistentConnection=q;function x(J){try{J.acceptDisconnect();const Q=J.getSocket();J.dispose(),Q.dispose()}catch(Q){(0,k.onUnexpectedError)(Q)}}function W(J){if(J&&J.type==="error"){const Q=new Error(`Connection error: ${J.reason}`);return Q.code="VSCODE_CONNECTION_ERROR",Q}return null}function j(J,Q){for(;J.length<Q;)J+=" ";return J}function K(J,Q,M){return`[remote-connection][${j(f(J),13)}][${Q.substr(0,5)}\u2026][${M?"reconnect":"initial"}]`}function ee(J,Q){return`${K(Q,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.host}:${J.port}]`}function ce(J){return`${Date.now()-J} ms`}}),define(se[222],oe([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(se[223],oe([0,1,84,150]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,k,T,I,P,w){const b=p=>w(p,void 0),E=D.createConnection({host:R,port:k},()=>{E.removeListener("error",b);const p=Buffer.alloc(16);for(let y=0;y<16;y++)p[y]=Math.round(Math.random()*256);const v=p.toString("base64"),f=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${k}${T}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`];E.write(f.join(`\r
`)+`\r
\r
`);const m=y=>{y.toString().indexOf(`\r
\r
`)>=0&&(E.off("data",m),w(void 0,new i.NodeSocket(E,P)))};E.on("data",m)});E.setNoDelay(!0),E.once("error",b)}}}),define(se[106],oe([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,D.createDecorator)("IRemoteTunnelService");var i;(function(R){R.disconnected={type:"disconnected"},R.uninitialized={type:"uninitialized"},R.connected=k=>({type:"connected",info:k}),R.connecting=k=>({type:"connecting",progress:k})})(i=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride"}),define(se[224],oe([0,1,133,16,7]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(I,P){this.configurationService=I,this.logService=P}async request(I,P){this.logService.trace("RequestService#request (browser) - begin",I.url),I.proxyAuthorization||(I.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const w=await(0,D.request)(I,P);return this.logService.trace("RequestService#request (browser) - success",I.url),w}catch(w){throw this.logService.error("RequestService#request (browser) - error",I.url,w),w}}async resolveProxy(I){}};k=ve([G(0,i.IConfigurationService),G(1,R.ILogService)],k),e.RequestService=k}),define(se[47],oe([0,1,17,169,45,4,40]),function(Z,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function I(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.isSuccess=I;function P(m){return m.res.statusCode===204}async function w(m){return P(m)?null:(await(0,D.streamToBuffer)(m.stream)).toString()}e.asText=w;async function b(m){if(!I(m))throw new Error("Server returned "+m.res.statusCode);return w(m)}e.asTextOrError=b;async function E(m){if(!I(m))throw new Error("Server returned "+m.res.statusCode);if(P(m))return null;const u=(await(0,D.streamToBuffer)(m.stream)).toString();try{return JSON.parse(u)}catch(S){throw S.message+=`:
`+u,S}}e.asJson=E;function p(m){f(m)}e.updateProxyConfigurationsScope=p;let v;function f(m){const y=T.Registry.as(R.Extensions.Configuration),u=v;v={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[v],remove:u?[u]:[]})}f(2)}),define(se[225],oe([0,1,22,23,14,47]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(P,w){this.requestService=P,this.fileService=w}async download(P,w,b=D.CancellationToken.None){if(P.scheme===i.Schemas.file||P.scheme===i.Schemas.vscodeRemote){await this.fileService.copy(P,w);return}const E={type:"GET",url:P.toString(!0)},p=await this.requestService.request(E,b);if(p.res.statusCode===200)await this.fileService.writeFile(w,p.stream);else{const v=await(0,k.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${v}`)}}};T=ve([G(0,k.IRequestService),G(1,R.IFileService)],T),e.DownloadService=T}),define(se[226],oe([0,1,19,22,2,20,187,14,7,25,47]),function(Z,e,D,i,R,k,T,I,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let E=class extends R.Disposable{constructor(v,f,m,y){super(),this.fileService=v,this.productService=f,this.requestService=m,this.logService=y,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,u])=>this.allConfigBasedTips.set(u.configPath,u))}getConfigBasedTips(v){return this.getValidConfigBasedTips(v)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(v){const f=[];for(const[m,y]of this.allConfigBasedTips)if(!(y.configScheme&&y.configScheme!==v.scheme))try{const u=await this.fileService.readFile((0,k.joinPath)(v,m)),S=new Map;Object.entries(y.recommendations).forEach(([h,d])=>{if((0,D.isNonEmptyArray)(d.remotes))for(const n of d.remotes)S.set(n,{extensionId:h,extensionName:d.name,configName:y.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled});else f.push({extensionId:h,extensionName:d.name,configName:y.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled})});const c=(0,T.getDomainsOfRemotes)(u.value.toString(),[...S.keys()]);for(const h of c){const d=S.get(h);d&&f.push(d)}}catch{}return f}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const v=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},i.CancellationToken.None);if(v.res.statusCode!==200)return[];const f=await(0,b.asJson)(v);return f?f.workspaceRecommendations||[]:[]}catch(v){return this.logService.error(v),[]}}};E=ve([G(0,I.IFileService),G(1,w.IProductService),G(2,b.IRequestService),G(3,P.ILogService)],E),e.ExtensionTipsService=E}),define(se[227],oe([0,1,17,22]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class R{constructor(I){this.service=I}listen(I,P){throw new Error("Invalid listen")}call(I,P,w,b=i.CancellationToken.None){switch(P){case"request":return this.service.request(w[0],b).then(async({res:E,stream:p})=>{const v=await(0,D.streamToBuffer)(p);return[{statusCode:E.statusCode,headers:E.headers},v]});case"resolveProxy":return this.service.resolveProxy(w[0])}throw new Error("Invalid call")}}e.RequestChannel=R;class k{constructor(I){this.channel=I}async request(I,P){const[w,b]=await this.channel.call("request",[I],P);return{res:w,stream:(0,D.bufferToStream)(b)}}async resolveProxy(I){return this.channel.call("resolveProxy",[I])}}e.RequestChannelClient=k}),define(se[228],oe([0,1,224,227]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class R{constructor(T,I,P){this.configurationService=I,this.logService=P,this.browserRequestService=new D.RequestService(I,P),this.mainRequestService=new i.RequestChannelClient(T.getChannel("request"))}request(T,I){return this.getRequestService().request(T,I)}async resolveProxy(T){return this.getRequestService().resolveProxy(T)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=R}),define(se[107],oe([0,1,66,4]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function R(k){return(0,D.hash)({moduleId:k.process.moduleId,windowId:k.reply.windowId})}e.hash=R,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(se[229],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(se[230],oe([0,1,92,6,22,3,2,23,30,7,107,229]),function(Z,e,D,i,R,k,T,I,P,w,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(m){this.logService=m,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(m){const y=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${y})`);const u=(0,b.hash)(m);this.processeDisposables.has(u)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${y})`),this.doDisposeWorker(m));const S=new R.CancellationTokenSource;let c,h,d;this.processeDisposables.set(u,r=>{S.dispose(!0),c?.terminate(m,R.CancellationToken.None),h?.close(),d?.close(),this.processeDisposables.delete(u);const s=this.processResolvers.get(u);s&&(this.processResolvers.delete(u),s({reason:r}))}),c=await this.getOrCreateWebWorker(m);const n=new Promise(r=>{this.processResolvers.set(u,r)});if(S.token.isCancellationRequested)return n;const{port1:o,port2:t}=new MessageChannel;return h=o,d=t,await c.spawn(m,d,S.token),S.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${y})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",m,[h])),n}getOrCreateWebWorker(m){let y=this.workers.get(m.process.moduleId);if(!y){this.logService.trace(`SharedProcess: creating new web worker (${m.process.moduleId})`);const u=new v(m.process.type,this.logService);y=u.init(),u.onDidProcessSelfTerminate(({configuration:S,reason:c})=>{this.doDisposeWorker(S,c)}),this.workers.set(m.process.moduleId,y)}return y}async disposeWorker(m){return this.doDisposeWorker(m)}doDisposeWorker(m,y){const u=this.processeDisposables.get((0,b.hash)(m));u&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),u(y))}};p=ve([G(0,w.ILogService)],p),e.SharedProcessWorkerService=p;class v extends T.Disposable{constructor(m,y){super(),this.type=m,this.logService=y,this._onDidProcessSelfTerminate=this._register(new k.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const m=new i.DeferredPromise,y=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return y.onerror=u=>{this.logService.error(`SharedProcess: worker error (${this.type})`,u.message)},y.onmessageerror=u=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,u)},y.onmessage=u=>{const{id:S,message:c,configuration:h,nonce:d}=u.data;switch(S){case E.SharedProcessWorkerMessages.Ready:m.complete(y);break;case E.SharedProcessWorkerMessages.Ack:if(d){const n=this.mapMessageNonceToPendingMessageResolve.get(d);n&&(this.mapMessageNonceToPendingMessageResolve.delete(d),n())}break;case E.SharedProcessWorkerMessages.SelfTerminated:h&&c&&this._onDidProcessSelfTerminate.fire({configuration:h,reason:JSON.parse(c)});break;case E.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,c);break;case E.SharedProcessWorkerMessages.Info:c&&this.logService.info(c);break;case E.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,c);break;case E.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,c);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,u)}},y.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),m.p}async send(m,y,u){const S=await this.workerReady;if(!y.isCancellationRequested)return new Promise(c=>{const h=(0,P.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(h,c);const d={...m,nonce:h};u?S.postMessage(d,[u]):S.postMessage(d),y.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(h)&&c()})})}spawn(m,y,u){const S={id:E.SharedProcessWorkerMessages.Spawn,configuration:m,environment:{bootstrapPath:I.FileAccess.asFileUri("bootstrap-fork",Z).fsPath}};return this.send(S,u,y)}terminate(m,y){const u={id:E.SharedProcessWorkerMessages.Terminate,configuration:m};return this.send(u,y)}}}),define(se[231],oe([0,1,63,23,186]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class k extends R.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:i.Schemas.vscodeUserData})}}ve([D.memoize],k.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=k}),define(se[232],oe([0,1,50,12,170,22,38,11,5,30,147,184,6]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let f;async function m(u,S,c){return S["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(c)&&!S["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(c)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=p.Promises.withAsyncBody(async(h,d)=>{const n=new k.CancellationTokenSource,o=setTimeout(()=>{n.dispose(!0),d(new Error((0,R.localize)(0,null)))},v);try{h(await y(u,n.token))}catch(t){!(0,I.isCancellationError)(t)&&!n.token.isCancellationRequested?d(new Error((0,R.localize)(1,null,(0,T.toErrorMessage)(t)))):h({})}finally{clearTimeout(o),n.dispose()}})),f)}e.getResolvedShellEnv=m;async function y(u,S){const c=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",c);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",h);const d=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(d+"(.*)"+d),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",o);const t=await(0,b.getSystemShell)(P.OS,o);return u.trace("getUnixShellEnvironment#shell",t),new Promise((r,s)=>{if(S.isCancellationRequested)return s((0,I.canceled)());const l=(0,i.basename)(t);let a,g;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(a=`& '${process.execPath}' ${C} -p '''${d}'' + JSON.stringify(process.env) + ''${d}'''`,g=["-Login","-Command"]):(a=`'${process.execPath}' ${C} -p '"${d}" + JSON.stringify(process.env) + "${d}"'`,l==="tcsh"?g=["-ic"]:g=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),a);const A=(0,D.spawn)(t,[...g,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});S.onCancellationRequested(()=>(A.kill(),s((0,I.canceled)()))),A.on("error",F=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(F)),s(F)});const V=[];A.stdout.on("data",F=>V.push(F));const _=[];A.stderr.on("data",F=>_.push(F)),A.on("close",(F,N)=>{const L=Buffer.concat(V).toString("utf8");u.trace("getUnixShellEnvironment#raw",L);const U=Buffer.concat(_).toString("utf8");if(U.trim()&&u.trace("getUnixShellEnvironment#stderr",U),F||N)return s(new Error((0,R.localize)(2,null,F,N)));const $=n.exec(L),H=$?$[1]:"{}";try{const q=JSON.parse(H);c?q.ELECTRON_RUN_AS_NODE=c:delete q.ELECTRON_RUN_AS_NODE,h?q.ELECTRON_NO_ATTACH_CONSOLE=h:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",q),r(q)}catch(q){u.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(q)),s(q)}})})}}),define(se[108],oe([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(se[233],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((R,k)=>Z(["vsda"],R,k))}async createNewMessage(R){try{const k=await this.vsda(),T=new k.validator;if(T){const I=String(D._nextId++);return this.validators.set(I,T),{id:I,data:T.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,k){if(!R.id)return!0;const T=this.validators.get(R.id);if(!T)return!1;this.validators.delete(R.id);try{return T.validate(k)==="ok"}catch{return!1}}async sign(R){try{const k=await this.vsda(),T=new k.signer;if(T)return T.sign(R)}catch{}return R}}e.SignService=D,D._nextId=1}),define(se[74],oe([0,1,3,2]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class R extends i.Disposable{constructor(E,p,v){super(),this.channel=E,this.profile=p,this.workspace=v}async getItems(){const E={profile:this.profile,workspace:this.workspace},p=await this.channel.call("getItems",E);return new Map(p)}updateItems(E){const p={profile:this.profile,workspace:this.workspace};return E.insert&&(p.insert=Array.from(E.insert.entries())),E.delete&&(p.delete=Array.from(E.delete.values())),this.channel.call("updateItems",p)}}class k extends R{constructor(E,p){super(E,p,void 0),this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(E=>this.onDidChangeStorage(E)))}onDidChangeStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class T extends k{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class I extends k{constructor(E,p){super(E,p)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=I;class P extends R{constructor(E,p){super(E,void 0,p),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P;class w{constructor(E){this.channel=E}isUsed(E){const p={payload:E,profile:void 0,workspace:void 0};return this.channel.call("isUsed",p)}}e.StorageClient=w}),define(se[109],oe([0,1,5,36,8,30]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(w){if(D.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function I(w,b,E,p,v,f,m,y,u,S){const c=Object.create(null);c["common.machineId"]=m,c.sessionID=(0,k.generateUuid)()+Date.now(),c.commitHash=v,c.version=f,c["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,D.PlatformToString)(D.platform),c["common.nodePlatform"]=i.platform,c["common.nodeArch"]=p,c["common.product"]=S||"desktop",y&&(c["common.msftInternal"]=y);let h=0;const d=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),D.isLinuxSnap&&(c["common.snap"]="true");const n=T(E);n&&(c["common.platformDetail"]=n);try{const o=await w.readFile(R.URI.file(u));c["common.source"]=o.value.toString().slice(0,30)}catch{}return c}e.resolveCommonProperties=I;function P(w){const b=i.env.USERDNSDOMAIN;if(!b)return!1;const E=b.toLowerCase();return w.some(p=>E===p)}e.verifyMicrosoftInternalDomain=P}),define(se[24],oe([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(i=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(se[234],oe([0,1,34,6,35,23,12,5,8,144,28,146,95,14,25,24]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const y=new Map;async function u(n,o){const t=`${n}::${o.join(":")}`,r=y.get(t);if(r)return r;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,a=new Map,g=2e4;function C(V,_,F,N){const L=_.substring(V.length+1);return i.Promises.withAsyncBody(async U=>{let $;try{$=await b.Promises.readdir(_,{withFileTypes:!0})}catch{U();return}if(N.count>=g){N.count+=$.length,N.maxReached=!0,U();return}let H=$.length;if(H===0){U();return}let q=$;N.count+$.length>g&&(N.maxReached=!0,H=g-N.count,q=$.slice(0,H)),N.count+=$.length;for(const x of q)if(x.isDirectory()){if(F.includes(x.name)||await C(V,(0,T.join)(_,x.name),F,N),--H===0){U();return}}else{const W=x.name.lastIndexOf(".");if(W>=0){const j=x.name.substring(W+1);j&&l.set(j,(l.get(j)??0)+1)}for(const j of s)j.relativePathPattern?.test(L)!==!1&&j.filePattern.test(x.name)&&a.set(j.tag,(a.get(j.tag)??0)+1);if(--H===0){U();return}}})}const A=i.Promises.withAsyncBody(async V=>{const _={count:0,maxReached:!1};await C(n,n,o,_);const F=await h(n);V({configFiles:S(a),fileTypes:S(l),fileCount:_.count,maxFilesReached:_.maxReached,launchConfigFiles:F})});return y.set(t,A),A}e.collectWorkspaceStats=u;function S(n){return Array.from(n.entries(),([o,t])=>({name:o,count:t})).sort((o,t)=>t.count-o.count)}function c(){const n={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},o=D.cpus();return o&&o.length>0&&(n.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),n}e.getMachineInfo=c;async function h(n){try{const o=new Map,t=(0,T.join)(n,".vscode","launch.json"),r=await b.Promises.readFile(t),s=[],l=(0,R.parse)(r.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,R.getNodeType)(l)==="object"&&l.configurations)for(const a of l.configurations){const g=a.type;g&&(o.has(g)?o.set(g,o.get(g)+1):o.set(g,1))}return S(o)}catch{return[]}}e.collectLaunchConfigs=h;let d=class{constructor(o,t){this.telemetryService=o,this.productService=t}formatMachineInfo(o){const t=[];return t.push(`OS Version:       ${o.os}`),t.push(`CPUs:             ${o.cpus}`),t.push(`Memory (System):  ${o.memory}`),t.push(`VM:               ${o.vmHint}`),t.join(`
`)}formatEnvironment(o){const t=[];t.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),t.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const r=D.cpus();return r&&r.length>0&&t.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),t.push(`Memory (System):  ${(D.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||t.push(`Load (avg):       ${D.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${o.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(o,t){return Promise.all([(0,E.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async r=>{let[s,l]=r,a=this.formatProcessList(o,s);return t.forEach(g=>{if((0,p.isRemoteDiagnosticError)(g))a+=`
${g.errorMessage}`,l+=`
${g.errorMessage}`;else if(a+=`

Remote: ${g.hostName}`,g.processes&&(a+=`
${this.formatProcessList(o,g.processes)}`),g.workspaceMetadata){l+=`
|  Remote: ${g.hostName}`;for(const C of Object.keys(g.workspaceMetadata)){const A=g.workspaceMetadata[C];let V=`${A.fileCount} files`;A.maxFilesReached&&(V=`more than ${V}`),l+=`|    Folder (${C}): ${V}`,l+=this.formatWorkspaceStats(A)}}}),{processInfo:a,workspaceInfo:l}})}async getSystemInfo(o,t){const{memory:r,vmHint:s,os:l,cpus:a}=c(),g={os:l,memory:r,cpus:a,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:t};return I.isWindows||(g.load=`${D.loadavg().map(C=>Math.round(C)).join(", ")}`),I.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(o,t){const r=[];return(0,E.listProcesses)(o.mainPID).then(async s=>(r.push(""),r.push(this.formatEnvironment(o)),r.push(""),r.push(this.formatProcessList(o,s)),o.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(o))),t.forEach(l=>{if((0,p.isRemoteDiagnosticError)(l))r.push(`
${l.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${l.hostName}`),r.push(this.formatMachineInfo(l.machineInfo)),l.processes&&r.push(this.formatProcessList(o,l.processes)),l.workspaceMetadata)for(const a of Object.keys(l.workspaceMetadata)){const g=l.workspaceMetadata[a];let C=`${g.fileCount} files`;g.maxFilesReached&&(C=`more than ${C}`),r.push(`Folder (${a}): ${C}`),r.push(this.formatWorkspaceStats(g))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(o){const t=[];let s=0;const l=(A,V)=>{const _=` ${A}(${V})`;s+_.length>60?(t.push(a),a="|                 ",s=a.length):s+=_.length,a+=_};let a="|      File types:";const g=10,C=o.fileTypes.length>g?g:o.fileTypes.length;for(let A=0;A<C;A++){const V=o.fileTypes[A];l(V.name,V.count)}if(t.push(a),o.configFiles.length>=0&&(a="|      Conf files:",s=0,o.configFiles.forEach(A=>{l(A.name,A.count)}),t.push(a)),o.launchConfigFiles.length>0){let A="|      Launch Configs:";o.launchConfigFiles.forEach(V=>{A+=V.count>1?` ${V.name}(${V.count})`:` ${V.name}`}),t.push(A)}return t.join(`
`)}expandGPUFeatures(o){const t=Math.max(...Object.keys(o).map(r=>r.length));return Object.keys(o).map(r=>`${r}:  ${" ".repeat(t-r.length)}  ${o[r]}`).join(`
                  `)}formatWorkspaceMetadata(o){const t=[],r=[];return o.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const a=P.URI.revive(l);if(a.scheme===k.Schemas.file){const g=a.fsPath;r.push(u(g,["node_modules",".git"]).then(C=>{let A=`${C.fileCount} files`;C.maxFilesReached&&(A=`more than ${A}`),t.push(`|    Folder (${(0,T.basename)(g)}): ${A}`),t.push(this.formatWorkspaceStats(C))}).catch(C=>{t.push(`|      Error: Unable to collect workspace stats for folder ${g} (${C.toString()})`)}))}else t.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(o,t){const r=new Map;o.windows.forEach(l=>r.set(l.pid,l.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.formatProcessItem(o.mainPID,r,s,t,0),s.join(`
`)}formatProcessItem(o,t,r,s,l){const a=l===0;let g;a?g=s.pid===o?`${this.productService.applicationName} main`:"remote agent":(g=`${"  ".repeat(l)} ${s.name}`,s.name==="window"&&(g=`${g} (${t.get(s.pid)})`));const C=process.platform==="win32"?s.mem:D.totalmem()*(s.mem/100);r.push(`${s.load.toFixed(0).padStart(5," ")}	${(C/v.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(s.children)&&s.children.forEach(A=>this.formatProcessItem(o,t,r,A,l+1))}async getWorkspaceFileExtensions(o){const t=new Set;for(const{uri:r}of o.folders){const s=P.URI.revive(r);if(s.scheme!==k.Schemas.file)continue;const l=s.fsPath;try{(await u(l,["node_modules",".git"])).fileTypes.forEach(g=>t.add(g.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(o){for(const{uri:t}of o.folders){const r=P.URI.revive(t);if(r.scheme!==k.Schemas.file)continue;const s=r.fsPath;try{const l=await u(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),l.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),l.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),l.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};d=ve([G(0,m.ITelemetryService),G(1,f.IProductService)],d),e.DiagnosticsService=d}),define(se[235],oe([0,1,106,3,24,13,2,7,12,50,25,5,6,101,16,168,34]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let u=class extends T.Disposable{constructor(c,h,d,n,o,t){super(),this.telemetryService=c,this.productService=h,this.environmentService=d,this.configurationService=t,this._onDidTokenFailedEmitter=new i.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new i.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeAccountEmitter=new i.Emitter,this.onDidChangeAccount=this._onDidChangeAccountEmitter.event,this._tunnelStatus=D.TunnelStates.disconnected,this._logger=this._register(n.createLogger(d.remoteTunnelLogResource,{name:"remoteTunnel"})),this._startTunnelProcessDelayer=new p.Delayer(100),this._register(o.onWillShutdown(r=>{this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),this.dispose()})),this._register(t.onDidChangeConfiguration(r=>{r.affectsConfiguration(D.CONFIGURATION_KEY_HOST_NAME)&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}))}async getAccount(){return this._account}async updateAccount(c){if(c&&this._account?c.token!==this._account.token||c.authenticationProviderId!==this._account.authenticationProviderId:c!==this._account){this._account=c,this._onDidChangeAccountEmitter.fire(c),this._logger.info(`Account updated: ${c?c.authenticationProviderId:"undefined"}`),this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:!!c});try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(h){this._logger.error(h)}}}getTunnelCommandLocation(){if(!this._tunnelCommand){let c;E.isMacintosh?c=this.environmentService.appRoot:c=(0,P.dirname)((0,P.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,P.join)(c,"bin",`${this.productService.tunnelApplicationName}${E.isWindows?".exe":""}`)}return this._tunnelCommand}async updateTunnelProcess(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),!this._account){this.setTunnelStatus(D.TunnelStates.disconnected);return}const{token:c,authenticationProviderId:h}=this._account;this.setTunnelStatus(D.TunnelStates.connecting((0,m.localize)(0,null)));const d=(s,l)=>{s=s.replaceAll(c,"*".repeat(4)),l?this._logger.error(s):this._logger.info(s)},n=this.runCodeTunneCommand("login",["user","login","--provider",h,"--access-token",c],d);this._tunnelProcess=n;try{if(await n,this._tunnelProcess!==n)return}catch(s){this._logger.error(s),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(!0),this.setTunnelStatus(D.TunnelStates.disconnected);return}const o=["--parent-process-id",String(process.pid),"--accept-server-license-terms"],t=this.getHostName();t?o.push("--name",t):o.push("--random-name");const r=this.runCodeTunneCommand("tunnel",o,(s,l)=>{l?this._logger.error(s):this._logger.info(s);const a=s.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(a){const g={link:a[1],domain:a[2],extensionId:"ms-vscode.remote-server",hostName:a[4]};this.setTunnelStatus(D.TunnelStates.connected(g))}else s.match(/error refreshing token/)&&(r.cancel(),this._onDidTokenFailedEmitter.fire(!0),this.setTunnelStatus(D.TunnelStates.disconnected))});this._tunnelProcess=r,r.finally(()=>{r===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._account=void 0,this.setTunnelStatus(D.TunnelStates.disconnected))})}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(c){c!==this._tunnelStatus&&(this._tunnelStatus=c,this._onDidChangeTunnelStatusEmitter.fire(c))}runCodeTunneCommand(c,h,d=()=>{}){return(0,p.createCancelablePromise)(n=>new Promise((o,t)=>{n.isCancellationRequested&&o();let r;if(n.onCancellationRequested(()=>{r&&(this._logger.info(`${c} terminating (${r.pid})`),r.kill())}),process.env.VSCODE_DEV)d("Compiling tunnel CLI from sources and run",!1),d(`${c} Spawning: cargo run -- tunnel ${h.join(" ")}`,!1),r=(0,w.spawn)("cargo",["run","--","tunnel",...h],{cwd:(0,P.join)(this.environmentService.appRoot,"cli")});else{d("Running tunnel CLI",!1);const s=this.getTunnelCommandLocation();d(`${c} Spawning: ${s} tunnel ${h.join(" ")}`,!1),r=(0,w.spawn)(s,["tunnel",...h],{cwd:(0,y.homedir)()})}r.stdout.on("data",s=>{if(r){const l=s.toString();d(l,!1)}}),r.stderr.on("data",s=>{if(r){const l=s.toString();d(l,!0)}}),r.on("exit",s=>{r&&(d(`${c} exit (${r.pid}):  + ${s}`,!1),r=void 0,s===0?o():t())}),r.on("error",s=>{r&&(d(`${c} error (${r.pid}):  + ${s}`,!0),r=void 0,t())})}))}getHostName(){const c=this.configurationService.getValue(D.CONFIGURATION_KEY_HOST_NAME);if(c&&c.match(/^([\w-]+)$/)&&c.length<=20)return c;const h=(0,y.hostname)();if(h&&h.match(/^([\w-]+)$/))return h.substring(0,20)}};u=ve([G(0,R.ITelemetryService),G(1,b.IProductService),G(2,k.INativeEnvironmentService),G(3,I.ILoggerService),G(4,v.ISharedProcessLifecycleService),G(5,f.IConfigurationService)],u),e.RemoteTunnelService=u}),define(se[110],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(k){this.appenders=k}listen(k,T){throw new Error(`Event not found: ${T}`)}call(k,T,{eventName:I,data:P}){return this.appenders.forEach(w=>w.log(I,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class i{constructor(k){this.channel=k}log(k,T){return this.channel.call("log",{eventName:k,data:T}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(se[51],oe([0,1,32,86,15,16,109,24]),function(Z,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,i.staticObservableValue)(0)}publicLog(r,s){return Promise.resolve(void 0)}publicLog2(r,s){return this.publicLog(r,s)}publicLogError(r,s){return Promise.resolve(void 0)}publicLogError2(r,s){return this.publicLogError(r,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class w{async publicLog(r,s,l){}async publicLogError(r,s,l){}}e.NullEndpointTelemetryService=w,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(t,r){return r.onDidChangeConfiguration(s=>{s.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(s.source),configurationKeys:u(s.sourceConfig)})})}e.configurationTelemetry=b;function E(t,r){return!(r.disableTelemetry||!t.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=E;function p(t){const r=t.getValue(I.TELEMETRY_SETTING_ID),s=t.getValue("telemetry.enableCrashReporter");if(t.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function v(t){const r={},s={},l={};y(t,l);for(let a in l){a=a.length>150?a.substr(a.length-149):a;const g=l[a];typeof g=="number"?s[a]=g:typeof g=="boolean"?s[a]=g?1:0:typeof g=="string"?(g.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${g.length}`),r[a]=g.substring(0,8191)):typeof g<"u"&&g!==null&&(r[a]=g)}return{properties:r,measurements:s}}e.validateTelemetryData=v;const f=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function m(t){if(!t)return"none";for(const r of f)if(t.startsWith(`${r}+`))return r;return"other"}e.cleanRemoteAuthority=m;function y(t,r,s=0,l){if(!!t)for(const a of Object.getOwnPropertyNames(t)){const g=t[a],C=l?l+a:a;Array.isArray(g)?r[C]=(0,D.safeStringify)(g):g instanceof Date?r[C]=g.toISOString():(0,R.isObject)(g)?s<2?y(g,r,s+1,C+"."):r[C]=(0,D.safeStringify)(g):r[C]=g}}function u(t){if(!t)return[];const r=[];return S(r,"",t),r}function S(t,r,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(l=>S(t,r?`${r}.${l}`:l,s[l])):t.push(r)}function c(t,r){const s=t.msftInternalDomains||[],l=r.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(s)||l}e.isInternalTelemetry=c;function h(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=h;function d(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const l=[];for(const A of r)for(;;){const V=A.exec(t);if(!V)break;l.push([V.index,A.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let C=0;for(s="";;){const A=g.exec(t);if(!A)break;const V=l.some(([_,F])=>A.index<F&&_<g.lastIndex);!a.test(A[0])&&!V&&(s+=t.substring(C,A.index)+"<REDACTED: user-file-path>",C=g.lastIndex)}return C<t.length&&(s+=t.substr(C)),s}function n(t){if(!t)return t;const r=t.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of s)if(l.regex.test(r))return`<REDACTED: ${l.label}>`;return t}function o(t,r){return(0,D.cloneAndChange)(t,s=>{if(typeof s=="string"){let l=s;l=d(l,r);for(const a of r)l=l.replace(a,"");return l=n(l),l}})}e.cleanData=o}),define(se[236],oe([0,1,44,51]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(k,T,I,P,w,b,E){const p={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${T.nameShort})`};if((0,i.supportsTelemetry)(T,I)&&(0,i.getTelemetryLevel)(P)===3){const v=await(0,D.getServiceMachineId)(I,w,b),{sessionId:f}=await E.getTelemetryInfo();p["X-Market-User-Id"]=v,p["VSCode-SessionId"]=f}return p}e.resolveMarketplaceHeaders=R}),define(se[237],oe([0,1,11,32,51]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function T(P,w,b){const E=await new Promise((y,u)=>{Z(["@microsoft/1ds-core-js"],y,u)}),p=await new Promise((y,u)=>{Z(["@microsoft/1ds-post-js"],y,u)}),v=new E.AppInsightsCore,f=new p.PostChannel,m={instrumentationKey:P,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(b){m.extensionConfig={};const y={alwaysUseXhrOverride:!0,httpXHROverride:b};m.extensionConfig[f.identifier]=y}return v.initialize(m,[]),v.addTelemetryInitializer(y=>{w&&(y.ext=y.ext??{},y.ext.utc=y.ext.utc??{},y.ext.utc.flags=8462029)}),v}class I{constructor(w,b,E,p,v){this._isInternalTelemetry=w,this._eventPrefix=b,this._defaultData=E,this._xhrOverride=v,this.endPointUrl=k,this._defaultData||(this._defaultData={}),typeof p=="function"?this._aiCoreOrKey=p():this._aiCoreOrKey=p,this._asyncAiCore=null}_withAIClient(w){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){w(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=T(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(b=>{w(b)},b=>{(0,D.onUnexpectedError)(b),console.error(b)})}}log(w,b){if(!this._aiCoreOrKey)return;b=(0,i.mixin)(b,this._defaultData),b=(0,R.validateTelemetryData)(b);const E=this._eventPrefix+"/"+w;try{this._withAIClient(p=>{p.pluginVersionString=b?.properties.version??"Unknown",p.track({name:E,baseData:{name:E,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(w=>{this._withAIClient(b=>{b.unload(!0,()=>{this._aiCoreOrKey=void 0,w(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(se[111],oe([0,1,2,13,7,51]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends D.Disposable{constructor(P,w,b=""){super(),this.prefix=b;const E=P.getLogger(w.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(P.createLogger(w.telemetryLogResource)),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(P,w){this.logger.trace(`${this.prefix}telemetry/${P}`,(0,k.validateTelemetryData)(w))}};T=ve([G(0,R.ILoggerService),G(1,i.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(se[112],oe([0,1,2,32,86,5,27,171,16,45,103,25,40,24,51]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(S,c,h){this._configurationService=c,this._productService=h,this._experimentProperties={},this.telemetryLevel=new R.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=S.appenders,this._commonProperties=S.commonProperties||Promise.resolve({}),this._piiPaths=S.piiPaths||[],this._sendErrorTelemetry=!!S.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(d),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(S,c){this._experimentProperties[S]=c}_updateTelemetryLevel(){let S=(0,f.getTelemetryLevel)(this._configurationService);const c=this._productService.enabledTelemetryLevels;if(c){this._sendErrorTelemetry=this.sendErrorTelemetry?c.error:!1;const h=c.usage?3:c.error?2:0;S=Math.min(S,h)}this.telemetryLevel.value=S}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const S=await this._commonProperties,c=S.sessionID,h=S["common.machineId"],d=S["common.firstSessionDate"],n=S["common.msftInternal"];return{sessionId:c,machineId:h,firstSessionDate:d,msftInternal:n}}dispose(){this._disposables.dispose()}_log(S,c,h,d){return this.telemetryLevel.value<c?Promise.resolve(void 0):this._commonProperties.then(n=>{h=(0,i.mixin)(h,this._experimentProperties),h=(0,f.cleanData)(h,this._cleanupPatterns),h=(0,i.mixin)(h,n),this._appenders.forEach(o=>o.log(S,h))},n=>{console.error(n)})}publicLog(S,c,h){return this._log(S,3,c,h)}publicLog2(S,c,h){return this.publicLog(S,c,h)}publicLogError(S,c){return this._sendErrorTelemetry?this._log(S,2,c,!0):Promise.resolve(void 0)}publicLogError2(S,c){return this.publicLogError(S,c)}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=ve([G(1,P.IConfigurationService),G(2,E.IProductService)],m),e.TelemetryService=m;function y(){const u=(0,I.localize)(0,null,b.default.nameLong),S=b.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=k.isWeb?"":(0,I.localize)(3,null),h=(0,I.localize)(4,null),d=(0,I.localize)(5,null),n=(0,I.localize)(6,null),o=(0,I.localize)(7,null),t=`
|       | ${h} | ${d} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,I.localize)(8,null);return`
${u} ${S} ${c}

&nbsp;

${o}
${t}

&nbsp;

${r}
`}p.Registry.as(w.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(w.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,I.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,I.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(se[238],oe([0,1,287,237]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class R extends i.AbstractOneDataSystemAppender{constructor(T,I,P,w){const b={sendPOST:(E,p)=>{const v={method:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data)}};try{const f=D.request(E.urlString,v,m=>{m.on("data",function(y){p(m.statusCode??200,m.headers,y.toString())}),m.on("error",function(y){p(0,{})})});f.write(E.data),f.end()}catch{p(0,{})}}};super(T,I,P,w,b)}}e.OneDataSystemAppender=R}),define(se[239],oe([0,1,23,68,16,13,7,25,24,110,111,112]),function(Z,e,D,i,R,k,T,I,P,w,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(f,m,y,u,S){this.configurationService=f,this.telemetryService=m,this.loggerService=y,this.environmentService=u,this.productService=S,this.customTelemetryServices=new Map}async getCustomTelemetryService(f){if(!this.customTelemetryServices.has(f.id)){const{machineId:m,sessionId:y}=await this.telemetryService.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=m,u["common.vscodesessionid"]=y;const S=[f.id,JSON.stringify(u),f.aiKey],h=new i.Client(D.FileAccess.asFileUri("bootstrap-fork",Z).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:S,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),d=[new w.TelemetryAppenderClient(h),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${f.id}] `)];this.customTelemetryServices.set(f.id,new E.TelemetryService({appenders:d,sendErrorTelemetry:f.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(f.id)}async publicLog(f,m,y){await(await this.getCustomTelemetryService(f)).publicLog(m,y)}async publicLogError(f,m,y){await(await this.getCustomTelemetryService(f)).publicLogError(m,y)}};p=ve([G(0,R.IConfigurationService),G(1,P.ITelemetryService),G(2,T.ILoggerService),G(3,k.IEnvironmentService),G(4,I.IProductService)],p),e.CustomEndpointTelemetryService=p}),define(se[240],oe([0,1,6,22,3,2,7]),function(Z,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends k.Disposable{constructor(w,b){super(),this._logService=b,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=w===void 0?15e3:w}createRequest(w){return new Promise((b,E)=>{const p=++this._lastRequestId;this._pendingRequests.set(p,b),this._onCreateRequest.fire({requestId:p,...w});const v=new i.CancellationTokenSource;(0,D.timeout)(this._timeout,v.token).then(()=>E(`Request ${p} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(p,[(0,k.toDisposable)(()=>v.cancel())])})}acceptReply(w,b){const E=this._pendingRequests.get(w);E?(this._pendingRequests.delete(w),(0,k.dispose)(this._pendingRequestDisposables.get(w)||[]),this._pendingRequestDisposables.delete(w),E(b)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${w}`)}};I=ve([G(1,T.ILogService)],I),e.RequestStore=I}),define(se[113],oe([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(c){c.Shell="terminal.integrated.shell.",c.ShellArgs="terminal.integrated.shellArgs.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(i=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(c){c.ShellLinux="terminal.integrated.shell.linux",c.ShellMacOs="terminal.integrated.shell.osx",c.ShellWindows="terminal.integrated.shell.windows",c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationShellLinux="terminal.integrated.automationShell.linux",c.AutomationShellMacOs="terminal.integrated.automationShell.osx",c.AutomationShellWindows="terminal.integrated.automationShell.windows",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ShellArgsLinux="terminal.integrated.shellArgs.linux",c.ShellArgsMacOs="terminal.integrated.shellArgs.osx",c.ShellArgsWindows="terminal.integrated.shellArgs.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.SmoothScrolling="terminal.integrated.smoothScrolling"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(c){c.FileName="ptyhost"})(k=e.TerminalLogConstants||(e.TerminalLogConstants={}));var T;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var I;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(I=e.WindowsShellType||(e.WindowsShellType={}));var P;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(P=e.TitleEventSource||(e.TitleEventSource={}));var w;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.Log="log",c.Heartbeat="heartbeat"})(w=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var b;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(p=e.TerminalLocation||(e.TerminalLocation={}));var v;(function(c){c.TerminalView="view",c.Editor="editor"})(v=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var m;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(m=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}));var u;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var S;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(S=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(se[241],oe([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(se[242],oe([0,1,34,23,32,12,5,36,27,15,28]),function(Z,e,D,i,R,k,T,I,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let d=0;return h&&h.length===4&&(d=parseInt(h[3])),d}e.getWindowsBuildNumber=E;async function p(h,d,n,o=I.env,t=b.Promises.exists){if(k.isAbsolute(h))return await t(h)?h:void 0;if(d===void 0&&(d=I.cwd()),k.dirname(h)!=="."){const a=k.join(d,h);return await t(a)?a:void 0}const s=(0,R.getCaseInsensitive)(o,"PATH");if(n===void 0&&(0,w.isString)(s)&&(n=s.split(k.delimiter)),n===void 0||n.length===0){const a=k.join(d,h);return await t(a)?a:void 0}for(const a of n){let g;if(k.isAbsolute(a)?g=k.join(a,h):g=k.join(d,a,h),await t(g))return g;if(T.isWindows){let C=g+".com";if(await t(C)||(C=g+".exe",await t(C)))return C}}const l=k.join(d,h);return await t(l)?l:void 0}e.findExecutable=p;function v(h,d,n,o,t){if(!d.shellIntegration.enabled||!h.executable||h.isFeatureTerminal||h.hideFromUser||h.ignoreShellIntegration||T.isWindows&&!d.windowsEnableConpty)return;const r=h.args,s=I.platform==="win32"?k.basename(h.executable).toLowerCase():k.basename(h.executable),l=k.dirname(i.FileAccess.asFileUri("",Z).fsPath);let a;const g={VSCODE_INJECTION:"1"};if(T.isWindows){if(s==="pwsh.exe")return!r||S(r)?a=e.shellIntegrationArgs.get(f.WindowsPwsh):u(r)&&(a=e.shellIntegrationArgs.get(f.WindowsPwshLogin)),a?(a=[...a],a[a.length-1]=(0,P.format)(a[a.length-1],l,""),{newArgs:a,envMixin:g}):void 0;o.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args);return}switch(s){case"bash":return!r||r.length===0?a=e.shellIntegrationArgs.get(f.Bash):c(r)&&(g.VSCODE_SHELL_LOGIN="1",a=e.shellIntegrationArgs.get(f.Bash)),a?(a=[...a],a[a.length-1]=(0,P.format)(a[a.length-1],l),{newArgs:a,envMixin:g}):void 0;case"pwsh":return!r||S(r)?a=e.shellIntegrationArgs.get(f.Pwsh):u(r)&&(a=e.shellIntegrationArgs.get(f.PwshLogin)),a?(a=[...a],a[a.length-1]=(0,P.format)(a[a.length-1],l,""),{newArgs:a,envMixin:g}):void 0;case"zsh":{if(!r||r.length===0?a=e.shellIntegrationArgs.get(f.Zsh):c(r)?a=e.shellIntegrationArgs.get(f.ZshLogin):(r===e.shellIntegrationArgs.get(f.Zsh)||r===e.shellIntegrationArgs.get(f.ZshLogin))&&(a=r),!a)return;a=[...a],a[a.length-1]=(0,P.format)(a[a.length-1],l);const C=k.join(D.tmpdir(),`${D.userInfo().username}-${t.applicationName}-zsh`);g.ZDOTDIR=C;const A=n?.ZDOTDIR??D.homedir()??"~";g.USER_ZDOTDIR=A;const V=[];return V.push({source:k.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:k.join(C,".zshrc")}),V.push({source:k.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:k.join(C,".zprofile")}),V.push({source:k.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:k.join(C,".zshenv")}),V.push({source:k.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:k.join(C,".zlogin")}),{newArgs:a,envMixin:g,filesToCopy:V}}}o.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args)}e.getShellIntegrationInjection=v;var f;(function(h){h.WindowsPwsh="windows-pwsh",h.WindowsPwshLogin="windows-pwsh-login",h.Pwsh="pwsh",h.PwshLogin="pwsh-login",h.Zsh="zsh",h.ZshLogin="zsh-login",h.Bash="bash"})(f=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(f.Zsh,["-i"]),e.shellIntegrationArgs.set(f.ZshLogin,["-il"]),e.shellIntegrationArgs.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const m=["-login","-l"],y=["-nol","-nologo"];function u(h){return typeof h=="string"?m.includes(h.toLowerCase()):h.length===1&&m.includes(h[0].toLowerCase())||h.length===2&&(m.includes(h[0].toLowerCase())||m.includes(h[1].toLowerCase()))&&(y.includes(h[0].toLowerCase())||y.includes(h[1].toLowerCase()))}function S(h){return typeof h=="string"?y.includes(h.toLowerCase()):h.length===0||h?.length===1&&y.includes(h[0].toLowerCase())}function c(h){return h==="string"&&m.includes(h.toLowerCase())||typeof h!="string"&&h.length===1&&m.includes(h[0].toLowerCase())}}),define(se[243],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var D;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST_DARK="hcDark",k.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function i(k){return k===D.HIGH_CONTRAST_DARK||k===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function R(k){return k===D.DARK||k===D.HIGH_CONTRAST_DARK}e.isDark=R}),define(se[114],oe([0,1,52,3,2,4,40,243]),function(Z,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var P;(function(y){function u(S){return S&&typeof S=="object"&&typeof S.id=="string"}y.isThemeColor=u})(P=e.ThemeColor||(e.ThemeColor={}));function w(y){return{id:y}}e.themeColorFromId=w;var b;(function(y){function u(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||P.isThemeColor(r.color))}y.isThemeIcon=u;const S=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function c(r){const s=S.exec(r);if(!s)return;const[,l]=s;return{id:l}}y.fromString=c;function h(r){return{id:r}}y.fromId=h;function d(r,s){let l=r.id;const a=l.lastIndexOf("~");return a!==-1&&(l=l.substring(0,a)),s&&(l=`${l}~${s}`),{id:l}}y.modify=d;function n(r){const s=r.id.lastIndexOf("~");if(s!==-1)return r.id.substring(s+1)}y.getModifier=n;function o(r,s){return r.id===s.id&&r.color?.id===s.color?.id}y.isEqual=o;function t(r,s){return{id:r.id,color:s?w(s):void 0}}y.asThemeIcon=t,y.asClassNameArray=D.CSSIcon.asClassNameArray,y.asClassName=D.CSSIcon.asClassName,y.asCSSSelector=D.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function E(y){switch(y){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(u){return this.themingParticipants.push(u),this.onThemingParticipantAddedEmitter.fire(u),(0,R.toDisposable)(()=>{const S=this.themingParticipants.indexOf(u);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const v=new p;T.Registry.add(e.Extensions.ThemingContribution,v);function f(y){return v.onColorThemeChange(y)}e.registerThemingParticipant=f;class m extends R.Disposable{constructor(u){super(),this.themeService=u,this.theme=u.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(u){this.theme=u,this.updateStyles()}updateStyles(){}getColor(u,S){let c=this.theme.getColor(u);return c&&S&&(c=S(c,this.theme)),c?c.toString():null}}e.Themable=m}),define(se[244],oe([0,1,52,8,173,114]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(p,v){const f=[{name:null,description:(0,R.localize)(0,null)}];return f.push(...p.map(m=>({name:m.profileName,description:I(m)}))),v&&f.push(...v.map(m=>({name:m.title,description:P(m)}))),{values:f.map(m=>m.name),markdownDescriptions:f.map(m=>m.description)}}e.createProfileSchemaEnums=T;function I(p){let v=`$(${k.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:D.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?v+=`
- args: "${p.args}"`:v+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(v+=`
- overrideName: ${p.overrideName}`),p.color&&(v+=`
- color: ${p.color}`),p.env&&(v+=`
- env: ${JSON.stringify(p.env)}`),v}function P(p){return`$(${k.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:D.Codicon.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function w(p,v){if(!p&&!v)return!0;if(typeof p=="string"&&typeof v=="string")return p===v;if(Array.isArray(p)&&Array.isArray(v)){if(p.length!==v.length)return!1;for(let f=0;f<p.length;f++)if(p[f]!==v[f])return!1;return!0}return!1}e.terminalProfileArgsMatch=w;function b(p,v){if(!p&&!v)return!0;if(!p||!v)return!1;if(k.ThemeIcon.isThemeIcon(p)&&k.ThemeIcon.isThemeIcon(v))return p.id===v.id&&p.color===v.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof v=="object"&&"light"in v&&"dark"in v){const f=p,m=v;if((i.URI.isUri(f.light)||E(f.light))&&(i.URI.isUri(f.dark)||E(f.dark))&&(i.URI.isUri(m.light)||E(m.light))&&(i.URI.isUri(m.dark)||E(m.dark)))return f.light.path===m.light.path&&f.dark.path===m.dark.path}if(i.URI.isUri(p)&&i.URI.isUri(v)||E(p)||E(v)){const f=p,m=v;return f.path===m.path&&f.scheme===m.scheme}return!1}e.terminalIconsEqual=b;function E(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.isUriComponents=E}),define(se[245],oe([0,1,52,172,45,40,244]),function(Z,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(D.Codicon.getAll(),h=>h.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),h=>`$(${h.id})`)};const I={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),...e.terminalIconSchema},color:{description:(0,i.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},P={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...I}},w={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...I}},b=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),v=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),f=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),m=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),y={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...I}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...I}},{type:"null"},P]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...I}},{type:"null"},P]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...I}},{type:"null"},P]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){k.Registry.as(R.Extensions.Configuration).registerConfiguration(y),c()}e.registerTerminalPlatformConfiguration=u;let S;function c(h,d){const n=k.Registry.as(R.Extensions.Configuration);let o;h&&(o=(0,T.createProfileSchemaEnums)(h?.profiles,d));const t=S;S={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:h?.os===3?o?.values:void 0,markdownEnumDescriptions:h?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:h?.os===2?o?.values:void 0,markdownEnumDescriptions:h?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:h?.os===1?o?.values:void 0,markdownEnumDescriptions:h?.os===1?o?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[S],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=c}),define(se[246],oe([0,1,50,52,12,5,28,89,242,114]),function(Z,e,D,i,R,k,T,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let b,E=!0;function p(o,t,r,s,l=process.env,a,g,C,A){return a=a||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},k.isWindows?v(r,a,l,g,s.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:s.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:s.getValue("terminal.integrated.defaultProfile.windows"),A,C):h(a,g,r,o&&typeof o=="object"?{...o}:s.getValue(k.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:s.getValue(k.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,C,l)}e.detectAvailableProfiles=p;async function v(o,t,r,s,l,a,g,C,A){const V=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${V?"Sysnative":"System32"}`;let F=!1;(0,P.getWindowsBuildNumber)()>=16299&&(F=!0),await y(C);const N=new Map;o&&(N.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),N.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0})),d(a,N);const L=await f(N.entries(),g,t,r,s,A);if(o||l)try{const U=await S(`${_}\\${F?"wsl":"bash"}.exe`,g);for(const $ of U)(!a||!($.profileName in a))&&L.push($)}catch{E&&(s?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return L}async function f(o,t,r,s=process.env,l,a){const g=[];for(const[C,A]of o){if(A===null)continue;let V,_,F;if("source"in A){const U=b?.get(A.source);if(!U)continue;V=U.paths,_=A.args||U.args,A.icon?F=m(A.icon):U.icon&&(F=U.icon)}else V=Array.isArray(A.path)?A.path:[A.path],_=k.isWindows||Array.isArray(A.args)?A.args:void 0,F=m(A.icon);const N=await a?.(V)||V.slice(),L=await n(C,t,N,r,s,_,A.env,A.overrideName,A.isAutoDetected,l);L?(L.isAutoDetected=A.isAutoDetected,L.icon=F,L.color=A.color,g.push(L)):l?.debug("Terminal profile not validated",C,V)}return l?.debug("Validated terminal profiles",g),g}function m(o){return typeof o=="string"?{id:o}:o}async function y(o){b&&!o||(b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),b.set("PowerShell",{profileName:"PowerShell",paths:o||await u(),icon:w.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function u(){const o=[];for await(const t of(0,I.enumeratePowerShellInstallations)())o.push(t.exePath);return o}async function S(o,t){const r=[],s=await new Promise((g,C)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(A,V)=>{if(A)return C("Problem occurred when getting wsl distros");g(V)})});if(!s)return[];const l=new RegExp(/[\r?\n]/),a=s.split(l).filter(g=>g.trim().length>0&&g!=="");for(const g of a){if(g===""||g.startsWith("docker-desktop"))continue;const C=`${g} (WSL)`,A={profileName:C,path:o,args:["-d",`${g}`],isDefault:C===t,icon:c(g),isAutoDetected:!1};r.push(A)}return r}function c(o){return o.includes("Ubuntu")?w.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):o.includes("Debian")?w.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):w.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function h(o,t,r,s,l,a,g,C){const A=new Map;if(r){const V=(await o.readFile("/etc/shells")).toString(),_=a||V.split(`
`).filter(N=>N.trim().indexOf("#")!==0&&N.trim().length>0),F=new Map;for(const N of _){let L=(0,R.basename)(N),U=F.get(L)||0;U++,U>1&&(L=`${L} (${U})`),F.set(L,U),A.set(L,{path:N,isAutoDetected:!0})}}return d(s,A),await f(A.entries(),l,o,C,t,g)}function d(o,t){if(!!o)for(const[r,s]of Object.entries(o))s===null||!("path"in s)&&!("source"in s)?t.delete(r):(s.icon=s.icon||t.get(r)?.icon,t.set(r,s))}async function n(o,t,r,s,l,a,g,C,A,V){if(r.length===0)return Promise.resolve(void 0);const _=r.shift();if(_==="")return n(o,t,r,s,l,a,g,C,A);const F={profileName:o,path:_,args:a,env:g,overrideName:C,isAutoDetected:A,isDefault:o===t};if((0,R.basename)(_)===_){const L=l.PATH?l.PATH.split(R.delimiter):void 0,U=await(0,P.findExecutable)(_,void 0,L,void 0,s.existsFile);return U?(F.path=U,F.isFromPath=!0,F):n(o,t,r,s,l,a)}return await s.existsFile((0,R.normalize)(_))?F:n(o,t,r,s,l,a,g,C,A)}}),define(se[247],oe([0,1,3,2,23,5,39,68,16,13,93,232,7,102,240,113,245,246]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var S;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(S||(S={}));let c=0,h=class extends i.Disposable{constructor(n,o,t,r){super(),this._reconnectConstants=n,this._configurationService=o,this._environmentService=t,this._logService=r,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,y.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,i.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new f.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(k.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(n){return this._logService.error("ptyHost was unable to resolve shell environment",n),{}}}_startPtyHost(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},o=(0,b.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);o&&(o.break&&o.port?n.debugBrk=o.port:!o.break&&o.port&&(n.debug=o.port));const t=new I.Client(R.FileAccess.asFileUri("bootstrap-fork",Z).fsPath,n);this._onPtyHostStart.fire(),T.ProxyChannel.toService(t.getChannel(m.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=S.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const s=t.getChannel(m.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const l=T.ProxyChannel.toService(t.getChannel(m.TerminalIpcChannels.PtyHost));return this._register(l.onProcessData(a=>this._onProcessData.fire(a))),this._register(l.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(l.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(l.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(l.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(l.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(l.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[t,l]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(n,o,t,r,s,l,a,g,C,A,V){const _=setTimeout(()=>this._handleUnresponsiveCreateProcess(),m.HeartbeatConstants.CreateProcessTimeout),F=await this._proxy.createProcess(n,o,t,r,s,l,a,g,C,A,V);return clearTimeout(_),c=Math.max(c,F),F}updateTitle(n,o,t){return this._proxy.updateTitle(n,o,t)}updateIcon(n,o,t,r){return this._proxy.updateIcon(n,o,t,r)}attachToProcess(n){return this._proxy.attachToProcess(n)}detachFromProcess(n,o){return this._proxy.detachFromProcess(n,o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(n){return this._proxy.start(n)}shutdown(n,o){return this._proxy.shutdown(n,o)}input(n,o){return this._proxy.input(n,o)}processBinary(n,o){return this._proxy.processBinary(n,o)}resize(n,o,t){return this._proxy.resize(n,o,t)}acknowledgeDataEvent(n,o){return this._proxy.acknowledgeDataEvent(n,o)}setUnicodeVersion(n,o){return this._proxy.setUnicodeVersion(n,o)}getInitialCwd(n){return this._proxy.getInitialCwd(n)}getCwd(n){return this._proxy.getCwd(n)}getLatency(n){return this._proxy.getLatency(n)}orphanQuestionReply(n){return this._proxy.orphanQuestionReply(n)}installAutoReply(n,o){return this._proxy.installAutoReply(n,o)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(n){return this._proxy.uninstallAutoReply(n)}getDefaultSystemShell(n){return this._proxy.getDefaultSystemShell(n)}async getProfiles(n,o,t,r=!1){const s=await this._shellEnv;return(0,u.detectAvailableProfiles)(o,t,r,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,n))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(n){return this._proxy.getWslPath(n)}getRevivedPtyNewId(n){return this._proxy.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this._proxy.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this._proxy.getTerminalLayoutInfo(n)}async requestDetachInstance(n,o){return this._proxy.requestDetachInstance(n,o)}async acceptDetachInstanceReply(n,o){return this._proxy.acceptDetachInstanceReply(n,o)}async freePortKillProcess(n){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(n)}async serializeTerminalState(n){return this._proxy.serializeTerminalState(n)}async reviveTerminalProcesses(n,o){return this._proxy.reviveTerminalProcesses(n,o)}async refreshProperty(n,o){return this._proxy.refreshProperty(n,o)}async updateProperty(n,o,t){return this._proxy.updateProperty(n,o,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier+m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${m.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(n,o){return this._resolveVariablesRequestStore.createRequest({workspaceId:n,originalText:o})}async acceptPtyHostResolvedVariables(n,o){this._resolveVariablesRequestStore.acceptReply(n,o)}};h=ve([G(1,P.IConfigurationService),G(2,w.IEnvironmentService),G(3,p.ILogService)],h),e.PtyHostService=h}),define(se[75],oe([0,1,3,16,4,7]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var T;(function(m){m.Http="http",m.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var P;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=E;function p(m,y,u,S){if(u===1)return!1;if(u===2&&E(y)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(S);if(c?.length===4&&parseInt(c[1])>=18)return!1}return m<1024}e.isPortPrivileged=p;class v{constructor(y,u,S){this.remoteAddress=y,this.localAddress=u,this._dispose=S,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=v;let f=class{constructor(y,u){this.logService=y,this.configurationService=u,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const y=this.configurationService.getValue("remote.localPortHost");return!y||y==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(y){return this._tunnelProvider=y,y?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(y){this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const y=[],u=Array.from(this._tunnels.values());for(const S of u){const c=Array.from(S.values());for(const h of c){const d=await h.value;d&&y.push(d)}}return y}async dispose(){for(const y of this._tunnels.values()){for(const{value:u}of y.values())await u.then(S=>S?.dispose());y.clear()}this._tunnels.clear()}setEnvironmentTunnel(y,u,S,c,h){this.addTunnelToMap(y,u,Promise.resolve({tunnelRemoteHost:y,tunnelRemotePort:u,localAddress:S,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(y,u){(E(y)||b(y))&&(y=e.LOCALHOST_ADDRESSES[0]);const S=this.getTunnelFromMap(y,u);if(S)return++S.refcount,S.value}openTunnel(y,u,S,c,h=!1,d,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${S} on local port ${c}.`),!y)return;if(u||(u="localhost"),this._tunnelProvider&&this._factoryInProgress.has(S)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(y,u,S,c,h,d,n);return o?o.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(t);return(t.tunnelRemoteHost!==u||t.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,privacy:y.privacy,protocol:y.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const u=this._tunnels.get(y.tunnelRemoteHost);if(u){const S=u.get(y.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,S))}}}}async tryDisposeTunnel(y,u,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${u}.`);const c=S.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(u),c}}async closeTunnel(y,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${u} `);const S=this._tunnels.get(y);if(S&&S.has(u)){const c=S.get(u);c.refcount=0,await this.tryDisposeTunnel(y,u,c)}}addTunnelToMap(y,u,S){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(u,{refcount:1,value:S})}async removeEmptyTunnelFromMap(y,u){const S=this._tunnels.get(y);S&&(await S.get(u)||S.delete(u),S.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,u){const S=[y];b(y)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):E(y)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const c=S.map(h=>this._tunnels.get(h));for(const h of c){const d=h?.get(u);if(d)return d}}canTunnel(y){return!!w(y)}createWithProvider(y,u,S,c,h,d,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${S} on local port ${c}.`);const o=S;this._factoryInProgress.add(o);const t=c===void 0?S:c,r={elevationRequired:h?this.isPortPrivileged(t):!1},s={remoteAddress:{host:u,port:S},localAddressPort:c,privacy:d,public:d?d!==I.Private:void 0,protocol:n},l=y.forwardPort(s,r);return l?(this.addTunnelToMap(u,S,l),l.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),l}};f=ve([G(0,k.ILogService),G(1,i.IConfigurationService)],f),e.AbstractTunnelService=f}),define(se[248],oe([0,1,7,75,2,11,6]),function(Z,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class I extends R.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(b){this._address=b,this._addressPromise&&(this._addressPromise.complete(b),this._addressPromise=null)}setTunnel(b){this._register(b)}}let P=class kt extends R.Disposable{constructor(b,E){super(),this._tunnelService=b,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(b=>b.dispose())}async createTunnel(){return{id:String(++kt._lastId)}}async startTunnel(b,E,p,v,f,m){const y=new I,u=await Promise.resolve(this._tunnelService.openTunnel(b,y,p,v,f,m));if(!u)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${v} (remote).`),y.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),y.dispose(),await u.dispose(),(0,k.canceled)();return y.setTunnel(u),this._tunnels.set(E,y),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${u.localAddress} (local) to ${p}:${v} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(b,E){const p=this._tunnels.get(b);!p||p.setAddress(E)}async destroyTunnel(b){const E=this._tunnels.get(b);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${b}.`),this._tunnels.delete(b),await E.dispose();return}this._disposedTunnels.add(b)}};P._lastId=0,P=ve([G(0,i.ISharedTunnelsService),G(1,D.ILogService)],P),e.SharedProcessTunnelService=P}),define(se[249],oe([0,1,84,34,131,223,6,2,16,7,25,221,75,108,5]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function m(h,d,n,o,t){let r;for(let s=3;s&&(r?.dispose(),r=await new y(h,d,n,o,t).waitForReady(),!(t&&R.BROWSER_RESTRICTED_PORTS[t]||!R.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));s--);return r}class y extends I.Disposable{constructor(d,n,o,t,r){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=r,this.privacy=p.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=d,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const d=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,p.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let o=await(0,R.findFreePortFaster)(d,2,1e3,n),t=null;return this._server.listen(o,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address(),t||(o=0,this._server.listen(o,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async _onConnection(d){d.pause();const n=(0,p.isLocalhost)(this.tunnelRemoteHost)||(0,p.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,E.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),t=o.getSocket().socket,r=o.readEntireBuffer();o.dispose(),r.byteLength>0&&d.write(r.buffer),d.on("end",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),t.end()}),d.on("close",()=>t.end()),d.on("error",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),t.destroy()}),t.on("end",()=>d.end()),t.on("close",()=>d.end()),t.on("error",()=>{d.destroy()}),d.pipe(t),t.pipe(d),d.localAddress&&this._socketsDispose.set(d.localAddress,()=>{d.end(),t.end()})}}let u=class extends p.AbstractTunnelService{constructor(d,n,o,t,r){super(n,r),this.socketFactory=d,this.signService=o,this.productService=t}isPortPrivileged(d){return(0,p.isPortPrivileged)(d,this.defaultTunnelHost,f.OS,i.release())}retainOrCreateTunnel(d,n,o,t,r,s,l){const a=this.getTunnelFromMap(n,o);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,n,o,t,r,s,l);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${o} on local port ${t}.`);const g={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:d,signService:this.signService,logService:this.logService,ipcLogger:null},C=m(g,this.defaultTunnelHost,n,o,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,o,C),C}}};u=ve([G(1,w.ILogService),G(2,v.ISignService),G(3,b.IProductService),G(4,P.IConfigurationService)],u),e.BaseTunnelService=u;let S=class extends u{constructor(d,n,o,t){super(k.nodeSocketFactory,d,n,o,t)}};S=ve([G(0,w.ILogService),G(1,v.ISignService),G(2,b.IProductService),G(3,P.IConfigurationService)],S),e.TunnelService=S;let c=class extends I.Disposable{constructor(d,n,o,t){super(),this.logService=d,this.productService=n,this.signService=o,this.configurationService=t,this._tunnelServices=new Map}async openTunnel(d,n,o,t,r,s,l,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${t} on local port ${r}.`),!this._tunnelServices.has(d)){const g=new S(this.logService,this.signService,this.productService,this.configurationService);this._register(g),this._tunnelServices.set(d,g),g.onTunnelClosed(async()=>{(await g.tunnels).length===0&&(g.dispose(),this._tunnelServices.delete(d))})}return this._tunnelServices.get(d).openTunnel(n,o,t,r,s,l,a)}};c=ve([G(0,w.ILogService),G(1,b.IProductService),G(2,v.ISignService),G(3,P.IConfigurationService)],c),e.SharedTunnelsService=c}),define(se[31],oe([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(se[250],oe([0,1,31,94,14,20,129,3,2]),function(Z,e,D,i,R,k,T,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class w{constructor(p){this.uri=p,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let b=class{constructor(p){this._fileService=p,this._dispooables=new P.DisposableStore,this._limit=2**16;const v=new Map,f=m=>{let y=v.get(m.scheme);return y===void 0&&(y=p.hasProvider(m)&&!this._fileService.hasCapability(m,1024),v.set(m.scheme,y)),y};this._dispooables.add(I.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(m=>{v.delete(m.scheme)})),this.extUri=new k.ExtUri(f),this._canonicalUris=new T.SkipList((m,y)=>this.extUri.compare(m,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,k.normalizePath)(p));const v=this._canonicalUris.get(p);return v?v.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new w(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((f,m)=>f[1].touch<m[1].touch?1:f[1].touch>m[1].touch?-1:0);w._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let f=0;f<v;f++)this._canonicalUris.set(p[f][0],p[f][1].touch())}};b=ve([G(0,R.IFileService)],b),e.UriIdentityService=b,(0,i.registerSingleton)(D.IUriIdentityService,b,1)}),define(se[251],oe([0,1,3,2,14,43,49,17]),function(Z,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends i.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(b,E,p,v){super(),this.fileSystemScheme=b,this.fileSystemProvider=E,this.userDataScheme=p,this.logService=v,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(f=>this.handleFileChanges(f)))}watch(b,E){this.watchResources.set(b,b);const p=this.fileSystemProvider.watch(this.toFileSystemResource(b),E);return(0,i.toDisposable)(()=>{this.watchResources.delete(b),p.dispose()})}stat(b){return this.fileSystemProvider.stat(this.toFileSystemResource(b))}mkdir(b){return this.fileSystemProvider.mkdir(this.toFileSystemResource(b))}rename(b,E,p){return this.fileSystemProvider.rename(this.toFileSystemResource(b),this.toFileSystemResource(E),p)}readFile(b){return this.fileSystemProvider.readFile(this.toFileSystemResource(b),{atomic:!0})}readFileStream(b,E,p){const v=(0,k.newWriteableStream)(f=>I.VSBuffer.concat(f.map(m=>I.VSBuffer.wrap(m))).buffer);return(async()=>{try{const f=await this.readFile(b);v.end(f)}catch(f){v.error(f),v.end()}})(),v}readdir(b){return this.fileSystemProvider.readdir(this.toFileSystemResource(b))}writeFile(b,E,p){return this.fileSystemProvider.writeFile(this.toFileSystemResource(b),E,p)}delete(b,E){return this.fileSystemProvider.delete(this.toFileSystemResource(b),E)}copy(b,E,p){if((0,R.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(b),this.toFileSystemResource(E),p);throw new Error("copy not supported")}handleFileChanges(b){const E=[];for(const p of b){if(p.resource.scheme!==this.fileSystemScheme)continue;const v=this.toUserDataResource(p.resource);this.watchResources.findSubstr(v)&&E.push({resource:v,type:p.type})}E.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(E))}toFileSystemResource(b){return b.with({scheme:this.fileSystemScheme})}toUserDataResource(b){return b.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(se[61],oe([0,1,81]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(T,I,P,w){const b=(0,D.setProperty)(T,I,P,w)[0];return b&&(T=T.substring(0,b.offset)+b.content+T.substring(b.offset+b.length)),T}e.edit=i;function R(T,I,P){let w=P;for(;w>=0;){if(T.charAt(w)===I.charAt(I.length-1)&&I.length===1)return w+1;if(w--,I.length===2&&w>=0&&T.charAt(w)===I.charAt(0))return w+2}return 0}e.getLineStartOffset=R;function k(T,I,P){let w=P;for(;w>=0;)if(T.charAt(w)===I.charAt(I.length-1)&&I.length===1||(w++,I.length===2&&w>=0&&T.charAt(w)===I.charAt(1)))return w;return T.length-1}e.getLineEndOffset=k}),define(se[252],oe([0,1,32,54,15]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(v,f,m,y,u,S){const c=[],h=[],d=[];if(!f){const U=v.filter(({identifier:$})=>u.every(H=>H.toLowerCase()!==$.id.toLowerCase()));return{local:{added:c,removed:h,updated:d},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}v=v.map(E),f=f.map(E),m=m?m.map(E):null;const n=new Map,o=U=>{U.uuid&&n.set(U.id.toLowerCase(),U.uuid)};v.forEach(({identifier:U})=>o(U)),f.forEach(({identifier:U})=>o(U)),m?.forEach(({identifier:U})=>o(U));const t=U=>{const $=U.identifier.uuid||n.get(U.identifier.id.toLowerCase());return $?`uuid:${$}`:`id:${U.identifier.id.toLowerCase()}`},r=(U,$)=>(U.set(t($),$),U),s=v.reduce(r,new Map),l=f.reduce(r,new Map),a=f.reduce((U,$)=>r(U,(0,D.deepClone)($)),new Map),g=m?m.reduce(r,new Map):null,C=y.reduce(r,new Map),A=u.reduce((U,$)=>{const H=n.get($.toLowerCase());return U.add(H?`uuid:${H}`:`id:${$.toLowerCase()}`)},new Set),V=S.reduce((U,{id:$,uuid:H})=>(H=H??n.get($.toLowerCase()),U.add(H?`uuid:${H}`:`id:${$.toLowerCase()}`)),new Set),_=T(s,l,A,!1);if(_.added.size>0||_.removed.size>0||_.updated.size>0){const U=T(g,s,A,!1),$=T(g,l,A,!0),H=(q,x,W,j)=>({...j,installed:x.installed||W.installed,version:W.version&&(!x.installed||i.gt(W.version,x.version))?W.version:x.version,state:P(x,W,g?.get(q)),preRelease:(x.installed?j.preRelease:W.preRelease)??x.preRelease});for(const q of $.removed.values()){const x=s.get(q);if(!x)continue;const W=(0,R.assertIsDefined)(g?.get(q)),j=!V.has(q)&&W.installed;x.installed&&j?h.push(x.identifier):a.set(q,x)}for(const q of $.added.values()){const x=(0,R.assertIsDefined)(l.get(q)),W=s.get(q);if(W){if(_.updated.has(q)){const j=H(q,W,x,x);I(W,x,!1,!1)||d.push(p(j,q)),a.set(q,j)}}else x.installed&&c.push(p(x,q))}for(const q of $.updated.values()){const x=(0,R.assertIsDefined)(l.get(q)),W=(0,R.assertIsDefined)(g?.get(q)),j=s.get(q);if(j)if(!V.has(q)&&W.installed&&j.installed&&!x.installed)h.push(j.identifier);else{const ee=H(q,j,x,x);d.push(p(ee,q)),a.set(q,ee)}else x.installed&&c.push(p(x,q))}for(const q of U.added.values())$.added.has(q)||a.set(q,(0,R.assertIsDefined)(s.get(q)));for(const q of U.updated.values()){if($.removed.has(q)||$.updated.has(q))continue;const x=(0,R.assertIsDefined)(s.get(q)),W=(0,R.assertIsDefined)(l.get(q));a.set(q,H(q,x,W,x))}for(const q of U.removed.values())$.updated.has(q)||$.removed.has(q)||C.has(q)||!(0,R.assertIsDefined)(l.get(q)).installed||V.has(q)||!(0,R.assertIsDefined)(g?.get(q)).installed||a.delete(q)}const F=[],N=T(l,a,new Set,!0),L=N.added.size>0||N.updated.size>0||N.removed.size>0;return L&&a.forEach((U,$)=>F.push(p(U,$))),{local:{added:c,removed:h,updated:d},remote:L?{added:[...N.added].map(U=>a.get(U)),updated:[...N.updated].map(U=>a.get(U)),removed:[...N.removed].map(U=>l.get(U)),all:F}:null}}e.merge=k;function T(v,f,m,y){const u=v?[...v.keys()].filter(n=>!m.has(n)):[],S=[...f.keys()].filter(n=>!m.has(n)),c=S.filter(n=>u.indexOf(n)===-1).reduce((n,o)=>(n.add(o),n),new Set),h=u.filter(n=>S.indexOf(n)===-1).reduce((n,o)=>(n.add(o),n),new Set),d=new Set;for(const n of u){if(h.has(n))continue;const o=v.get(n),t=f.get(n);(!t||!I(o,t,y,!0))&&d.add(n)}return{added:c,removed:h,updated:d}}function I(v,f,m,y){return!(v.disabled!==f.disabled||y&&v.installed!==f.installed||v.installed&&f.installed&&v.preRelease!==f.preRelease||!b(v.state,f.state)||m&&v.version!==f.version)}function P(v,f,m){const y=v.state,u=f.state,S=m?.state;if(!f.version||y&&i.gt(v.version,f.version))return y;if(u&&i.gt(f.version,v.version)||!y)return u;if(!u)return y;const c=(0,D.deepClone)(y),h=S?w(S,u):{added:Object.keys(u).reduce((n,o)=>(n.add(o),n),new Set),removed:new Set,updated:new Set},d=S?w(S,y):{added:Object.keys(y).reduce((n,o)=>(n.add(o),n),new Set),removed:new Set,updated:new Set};for(const n of[...h.added.values(),...h.updated.values()])c[n]=u[n];for(const n of h.removed.values())d.updated.has(n)||delete c[n];return c}function w(v,f){const m=Object.keys(v),y=Object.keys(f),u=y.filter(h=>m.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),S=m.filter(h=>y.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),c=new Set;for(const h of m){if(S.has(h))continue;const d=v[h],n=f[h];(0,D.equals)(d,n)||c.add(h)}return{added:u,removed:S,updated:c}}function b(v={},f={}){const{added:m,removed:y,updated:u}=w(v,f);return m.size===0&&y.size===0&&u.size===0}function E(v){return{...v,disabled:!!v.disabled,installed:!!v.installed}}function p(v,f){const m={identifier:{id:v.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},preRelease:!!v.preRelease};return v.version&&(m.version=v.version),v.disabled&&(m.disabled=!0),v.installed&&(m.installed=!0),v.state&&(m.state=v.state),m}}),define(se[115],oe([0,1,19,16,4]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(I){this.configurationService=I}hasToNeverSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,P){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(b=>b.toLowerCase());return w=w.filter(b=>b!==I&&b!==`-${I}`),P&&w.push(I.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,2)}updateSynchronizedExtensions(I,P){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(b=>b.toLowerCase());return w=w.filter(b=>b!==I&&b!==`-${I}`),P&&w.push(`-${I.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,2)}getIgnoredExtensions(I){const P=I.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),w=this.getConfiguredIgnoredExtensions().map(p=>p.toLowerCase()),b=[],E=[];if(Array.isArray(w))for(const p of w)p.startsWith("-")?E.push(p.substring(1)):b.push(p);return(0,D.distinct)([...P,...b].filter(p=>E.indexOf(p)===-1))}getConfiguredIgnoredExtensions(){let I=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.configurationService.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};k=ve([G(0,i.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(se[253],oe([0,1,19,35,32,192,61]),function(Z,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function I(h){return(0,i.parse)(h)||[]}e.parseKeybindings=I;async function P(h,d,n,o,t){const r=I(h),s=I(d),l=n?I(n):null,a=[...r,...s,...l||[]].map(H=>H.key),g=await t.resolveUserBindings(a),C=b(r,s,l,g);if(!C.hasLocalForwarded&&!C.hasRemoteForwarded)return{mergeContent:h,hasChanges:!1,hasConflicts:!1};if(!C.hasLocalForwarded&&C.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};if(C.hasLocalForwarded&&!C.hasRemoteForwarded)return{mergeContent:h,hasChanges:!0,hasConflicts:!1};const A=p(r),V=p(s),_=l?p(l):null,F=f(A,V,g),N=_?f(_,A,g):{added:[...A.keys()].reduce((H,q)=>(H.add(q),H),new Set),removed:new Set,updated:new Set},L=_?f(_,V,g):{added:[...V.keys()].reduce((H,q)=>(H.add(q),H),new Set),removed:new Set,updated:new Set},U=w(F,N,L);let $=h;for(const H of U.removed.values())U.conflicts.has(H)||($=S($,H,o));for(const H of U.added.values()){if(U.conflicts.has(H))continue;const q=V.get(H);if(q.some(x=>x.command!==`-${H}`&&C.conflicts.has(g[x.key]))){U.conflicts.add(H);continue}$=u($,q,o)}for(const H of U.updated.values()){if(U.conflicts.has(H))continue;const q=V.get(H);if(q.some(x=>x.command!==`-${H}`&&C.conflicts.has(g[x.key]))){U.conflicts.add(H);continue}$=c($,H,q,o)}return{mergeContent:$,hasChanges:!0,hasConflicts:U.conflicts.size>0}}e.merge=P;function w(h,d,n){const o=new Set,t=new Set,r=new Set,s=new Set;for(const l of d.removed.values())n.updated.has(l)&&s.add(l);for(const l of n.removed.values())s.has(l)||(d.updated.has(l)?s.add(l):t.add(l));for(const l of d.added.values())s.has(l)||n.added.has(l)&&h.updated.has(l)&&s.add(l);for(const l of n.added.values())s.has(l)||(d.added.has(l)?h.updated.has(l)&&s.add(l):o.add(l));for(const l of d.updated.values())s.has(l)||n.updated.has(l)&&h.updated.has(l)&&s.add(l);for(const l of n.updated.values())s.has(l)||(d.updated.has(l)?h.updated.has(l)&&s.add(l):r.add(l));return{added:o,removed:t,updated:r,conflicts:s}}function b(h,d,n,o){const t=new Set,r=E(h,o),s=E(d,o),l=n?E(n,o):null,a=v(r,s);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const g=l?v(l,r):{added:[...r.keys()].reduce((N,L)=>(N.add(L),N),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const C=l?v(l,s):{added:[...s.keys()].reduce((N,L)=>(N.add(L),N),new Set),removed:new Set,updated:new Set};if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:A,removed:V,updated:_,conflicts:F}=w(a,g,C);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:V,updated:_,conflicts:F}}function E(h,d){const n=new Map;for(const o of h){const t=d[o.key];let r=n.get(t);r||(r=[],n.set(t,r)),r.push(o)}return n}function p(h){const d=new Map;for(const n of h){const o=n.command[0]==="-"?n.command.substring(1):n.command;let t=d.get(o);t||(t=[],d.set(o,t)),t.push(n)}return d}function v(h,d){const n=[...h.keys()],o=[...d.keys()],t=o.filter(l=>n.indexOf(l)===-1).reduce((l,a)=>(l.add(a),l),new Set),r=n.filter(l=>o.indexOf(l)===-1).reduce((l,a)=>(l.add(a),l),new Set),s=new Set;for(const l of n){if(r.has(l))continue;const a=h.get(l).map(C=>({...C,key:l})),g=d.get(l).map(C=>({...C,key:l}));(0,D.equals)(a,g,(C,A)=>y(C,A))||s.add(l)}return{added:t,removed:r,updated:s}}function f(h,d,n){const o=[...h.keys()],t=[...d.keys()],r=t.filter(a=>o.indexOf(a)===-1).reduce((a,g)=>(a.add(g),a),new Set),s=o.filter(a=>t.indexOf(a)===-1).reduce((a,g)=>(a.add(g),a),new Set),l=new Set;for(const a of o){if(s.has(a))continue;const g=h.get(a).map(A=>({...A,key:n[A.key]})),C=d.get(a).map(A=>({...A,key:n[A.key]}));m(g,C)||l.add(a)}return{added:r,removed:s,updated:l}}function m(h,d){return!(!(0,D.equals)(h.filter(({command:n})=>n[0]!=="-"),d.filter(({command:n})=>n[0]!=="-"),(n,o)=>y(n,o))||!(0,D.equals)(h.filter(({command:n})=>n[0]==="-"),d.filter(({command:n})=>n[0]==="-"),(n,o)=>y(n,o)))}function y(h,d){if(h.command!==d.command||h.key!==d.key)return!1;const n=k.ContextKeyExpr.deserialize(h.when),o=k.ContextKeyExpr.deserialize(d.when);return!(n&&!o||!n&&o||n&&o&&!n.equals(o)||!R.equals(h.args,d.args))}function u(h,d,n){for(const o of d)h=T.edit(h,[-1],o,n);return h}function S(h,d,n){const o=I(h);for(let t=o.length-1;t>=0;t--)(o[t].command===d||o[t].command===`-${d}`)&&(h=T.edit(h,[t],void 0,n));return h}function c(h,d,n,o){const t=I(h),r=t.findIndex(s=>s.command===d||s.command===`-${d}`);for(let s=t.length-1;s>=0;s--)(t[s].command===d||t[s].command===`-${d}`)&&(h=T.edit(h,[s],void 0,o));for(let s=n.length-1;s>=0;s--)h=T.edit(h,[r],n[s],o);return h}}),define(se[254],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(k,T,I){const P={},w={},b=new Set;if(!T)return{local:{added:P,updated:w,removed:[...b.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const E=i(k,T);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:P,updated:w,removed:[...b.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=i(I,k),v=i(I,T),f={},m={},y=new Set,u=new Set;for(const S of p.removed.values())v.updated.has(S)?P[S]=T[S]:y.add(S);for(const S of v.removed.values())u.has(S)||(p.updated.has(S)?u.add(S):b.add(S));for(const S of p.updated.values())u.has(S)||(v.updated.has(S)?E.updated.has(S)&&u.add(S):m[S]=k[S]);for(const S of v.updated.values())u.has(S)||(p.updated.has(S)?E.updated.has(S)&&u.add(S):k[S]!==void 0&&(w[S]=T[S]));for(const S of p.added.values())u.has(S)||(v.added.has(S)?E.updated.has(S)&&u.add(S):f[S]=k[S]);for(const S of v.added.values())u.has(S)||(p.added.has(S)?E.updated.has(S)&&u.add(S):P[S]=T[S]);return{local:{added:P,removed:[...b.values()],updated:w},remote:{added:f,removed:[...y.values()],updated:m},conflicts:[...u.values()]}}e.merge=D;function i(k,T){const I=k?Object.keys(k):[],P=T?Object.keys(T):[],w=P.filter(p=>I.indexOf(p)===-1).reduce((p,v)=>(p.add(v),p),new Set),b=I.filter(p=>P.indexOf(p)===-1).reduce((p,v)=>(p.add(v),p),new Set),E=new Set;for(const p of I){if(b.has(p))continue;const v=k[p],f=T[p];v!==f&&E.add(p)}return{added:w,removed:b,updated:E}}function R(k,T){const{added:I,removed:P,updated:w}=i(k,T);return I.size===0&&P.size===0&&w.size===0}e.areSame=R}),define(se[255],oe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,k,T,I){const P={local:{added:[],removed:[],updated:[]},remote:{added:[],removed:[],updated:[]}};if(!k){const b=R.filter(({id:E})=>!I.includes(E));return b.length?P.remote.added=b:P.remote=null,P}const w=i(R,k,I);if(w.added.length>0||w.removed.length>0||w.updated.length>0){const b=i(T,R,I),E=i(T,k,I);for(const p of E.removed){const v=R.find(f=>f.id===p);v&&P.local.removed.push(v)}for(const p of E.added){const v=k.find(f=>f.id===p);b.added.includes(p)?w.updated.includes(p)&&P.local.updated.push(v):P.local.added.push(v)}for(const p of E.updated)P.local.updated.push(k.find(v=>v.id===p));for(const p of b.added)E.added.includes(p)||P.remote.added.push(R.find(v=>v.id===p));for(const p of b.updated)E.removed.includes(p)||E.updated.includes(p)||P.remote.updated.push(R.find(v=>v.id===p));for(const p of b.removed)P.remote.removed.push(k.find(v=>v.id===p))}return P.remote.added.length===0&&P.remote.removed.length===0&&P.remote.updated.length===0&&(P.remote=null),P}e.merge=D;function i(R,k,T){R=R?R.filter(({id:p})=>!T.includes(p)):[],k=k.filter(({id:p})=>!T.includes(p));const I=R.map(({id:p})=>p),P=k.map(({id:p})=>p),w=P.filter(p=>I.indexOf(p)===-1),b=I.filter(p=>P.indexOf(p)===-1),E=[];for(const{id:p,name:v,shortName:f}of R){if(b.includes(p))continue;const m=k.find(y=>y.id===p);(!m||m.name!==v||m.shortName!==f)&&E.push(p)}return{added:w,removed:b,updated:E}}}),define(se[26],oe([0,1,19,15,179,45,29,4,104,40]),function(Z,e,D,i,R,k,T,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function b(){const s=w.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(l=>!!s[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=b;function E(){const s=w.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(s).filter(C=>!!s[C].ignoreSync),a=Object.keys(s).filter(C=>s[C].scope===2||s[C].scope===6),g=b();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...a,...g])}e.getDefaultIgnoredSettings=E,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function p(){const s="vscode://schemas/ignoredSettings",l=w.Registry.as(k.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,R.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,R.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,R.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,R.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,R.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=w.Registry.as(P.Extensions.JSONContribution),g=()=>{const C=b(),A=E().filter(N=>N!==e.CONFIGURATION_SYNC_STORE_KEY),V=Object.keys(k.allSettings.properties).filter(N=>A.indexOf(N)===-1),_=A.filter(N=>C.indexOf(N)===-1),F={items:{type:"string",enum:[...V,..._.map(N=>`-${N}`)]}};a.registerSchema(s,F)};return l.onDidUpdateConfiguration(()=>g())}e.registerConfiguration=p;function v(s){return s&&(0,i.isObject)(s)&&(0,i.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=v;var f;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(f=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function m(s,...l){return s?[s,...l]:l}e.getPathSegments=m;function y(s,l,a,g){return g.joinPath(a.userDataSyncHome,...m(s,l,`lastSync${l}.json`))}e.getLastSyncResourceUri=y,e.IUserDataSyncStoreManagementService=(0,I.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,I.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,I.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(s){const l={};return l[e.HEADER_EXECUTION_ID]=s,l}e.createSyncHeaders=u;var S;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(S=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class c extends Error{constructor(l,a,g,C){super(l),this.code=a,this.resource=g,this.operationId=C,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=c;class h extends c{constructor(l,a,g,C,A){super(l,g,void 0,A),this.url=a,this.serverCode=C}}e.UserDataSyncStoreError=h;class d extends c{constructor(l,a){super(l,a)}}e.UserDataAutoSyncError=d,function(s){function l(a){if(a instanceof s)return a;const g=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(g&&g[1]){const C=g[2]==="unknown"?void 0:g[2],A=g[3]==="unknown"?void 0:g[3];return new s(a.message,g[1],C,A)}return new s(a.message,"Unknown")}s.toUserDataSyncError=l}(c=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var o;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(o=e.Change||(e.Change={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(s){return`sync.enable.${s}`}e.getEnablementKey=r,e.IUserDataSyncEnablementService=(0,I.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,I.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,I.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,I.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,I.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,I.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(se[256],oe([0,1,32,26]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(T,I,P,w,b){if(!I)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const E=k(T,I);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const p=P?k(P,I):{added:Object.keys(I).reduce((S,c)=>(S.add(c),S),new Set),removed:new Set,updated:new Set},v=P?k(P,T):{added:Object.keys(T).reduce((S,c)=>(S.add(c),S),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},m=D.deepClone(I),y=!P;for(const S of v.added.values())S!==i.SYNC_SERVICE_URL_TYPE&&y&&p.added.has(S)||(m[S]=T[S]);for(const S of v.updated.values())m[S]=T[S];for(const S of v.removed.values())w.unregistered.includes(S)||delete m[S];for(const S of p.added.values()){const c=I[S];if(w.machine.includes(S)){b.info(`GlobalState: Skipped adding ${S} in local storage because it is declared as machine scoped.`);continue}if(P&&v.added.has(S))continue;const h=T[S];h&&h.value===c.value||S===i.SYNC_SERVICE_URL_TYPE&&y&&v.added.has(S)||(h?f.updated[S]=c:f.added[S]=c)}for(const S of p.updated.values()){const c=I[S];if(w.machine.includes(S)){b.info(`GlobalState: Skipped updating ${S} in local storage because it is declared as machine scoped.`);continue}if(v.updated.has(S)||v.removed.has(S))continue;const h=T[S];h&&h.value===c.value||(f.updated[S]=c)}for(const S of p.removed.values()){if(w.machine.includes(S)){b.trace(`GlobalState: Skipped removing ${S} in local storage because it is declared as machine scoped.`);continue}v.updated.has(S)||v.removed.has(S)||f.removed.push(S)}const u=k(I,m);return{local:f,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:m}}}e.merge=R;function k(T,I){const P=Object.keys(T),w=Object.keys(I),b=w.filter(v=>P.indexOf(v)===-1).reduce((v,f)=>(v.add(f),v),new Set),E=P.filter(v=>w.indexOf(v)===-1).reduce((v,f)=>(v.add(f),v),new Set),p=new Set;for(const v of P){if(E.has(v))continue;const f=T[v],m=I[v];D.equals(f,m)||p.add(v)}return{added:b,removed:E,updated:p}}}),define(se[257],oe([0,1,19,35,81,42,32,61,26]),function(Z,e,D,i,R,k,T,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function w(a,g,C){let A=[];C?A=E(C):A=b(g);const V=[],_=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(A))for(const F of A)F.startsWith("-")?_.push(F.substring(1)):V.push(F);return(0,D.distinct)([...a,...V].filter(F=>_.indexOf(F)===-1))}e.getIgnoredSettings=w;function b(a){let g=a.inspect("settingsSync.ignoredSettings").userValue;return g!==void 0||(g=a.inspect("sync.ignoredSettings").userValue,g!==void 0)?g:a.getValue("settingsSync.ignoredSettings")||[]}function E(a){const g=(0,i.parse)(a);return g?g["settingsSync.ignoredSettings"]||g["sync.ignoredSettings"]||[]:[]}function p(a,g){const C=(0,i.parse)(a)||{};let A="{}";for(const V of Object.keys(C)){const _=(0,R.setProperty)(A,[V],C[V],g);A=(0,R.applyEdits)(A,_)}return A}e.removeComments=p;function v(a,g,C,A){if(C.length){const V=l(g),_=(0,i.parse)(g)||{},F=(0,i.parse)(a);if(!F)return a;const N=[];for(const L of C){const U=_[L],$=F[L];U===void 0?a=I.edit(a,[L],void 0,A):$!==void 0?a=I.edit(a,[L],U,A):N.push(n(L,V))}N.sort((L,U)=>L.startOffset-U.startOffset),N.forEach(L=>a=S(L.setting.key,g,a,A))}return a}e.updateIgnoredSettings=v;function f(a,g,C,A,V,_){const F=v(a,g,A,_),N=C!==F,L=C!==g;if(!N&&!L)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!L)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(L&&!N)return{conflictsSettings:[],localContent:v(g,a,A,_),remoteContent:null,hasConflicts:!1};if(C===null&&y(a)){const z=m(a,g,A)?null:v(g,a,A,_);return{conflictsSettings:[],localContent:z,remoteContent:null,hasConflicts:!1}}let U=a,$=g;const H=(0,i.parse)(a),q=(0,i.parse)(g),x=C?(0,i.parse)(C):null,W=A.reduce((z,Y)=>(z.add(Y),z),new Set),j=u(H,q,W),K=u(x,H,W),ee=u(x,q,W),ce=new Map,J=new Set,Q=z=>{J.add(z);const Y=V.filter(({key:ne})=>ne===z)[0];Y?(U=I.edit(U,[z],Y.value,_),$=I.edit($,[z],Y.value,_)):ce.set(z,{key:z,localValue:H[z],remoteValue:q[z]})};for(const z of K.removed.values())ee.updated.has(z)?Q(z):$=I.edit($,[z],void 0,_);for(const z of ee.removed.values())J.has(z)||(K.updated.has(z)?Q(z):U=I.edit(U,[z],void 0,_));for(const z of K.updated.values())J.has(z)||(ee.updated.has(z)?j.updated.has(z)&&Q(z):$=I.edit($,[z],H[z],_));for(const z of ee.updated.values())J.has(z)||(K.updated.has(z)?j.updated.has(z)&&Q(z):U=I.edit(U,[z],q[z],_));for(const z of K.added.values())J.has(z)||(ee.added.has(z)?j.updated.has(z)&&Q(z):$=S(z,U,$,_));for(const z of ee.added.values())J.has(z)||(K.added.has(z)?j.updated.has(z)&&Q(z):U=S(z,$,U,_));const M=ce.size>0||!m(U,$,A),O=M||!m(U,a,[]),B=M||!m($,g,[]);return{localContent:O?U:null,remoteContent:B?$:null,conflictsSettings:[...ce.values()],hasConflicts:M}}e.merge=f;function m(a,g,C){if(a===g)return!0;const A=(0,i.parse)(a),V=(0,i.parse)(g),_=C.reduce((L,U)=>(L.add(U),L),new Set),F=l(a).filter(L=>!(L.setting&&_.has(L.setting.key))),N=l(g).filter(L=>!(L.setting&&_.has(L.setting.key)));if(F.length!==N.length)return!1;for(let L=0;L<F.length;L++){const U=F[L],$=N[L];if(U.setting&&$.setting){if(U.setting.key!==$.setting.key||!T.equals(A[U.setting.key],V[U.setting.key]))return!1}else if(!U.setting&&!$.setting){if(U.value!==$.value)return!1}else return!1}return!0}e.areSame=m;function y(a){return a?l(a).length===0:!0}e.isEmpty=y;function u(a,g,C){const A=a?Object.keys(a).filter(L=>!C.has(L)):[],V=Object.keys(g).filter(L=>!C.has(L)),_=V.filter(L=>A.indexOf(L)===-1).reduce((L,U)=>(L.add(U),L),new Set),F=A.filter(L=>V.indexOf(L)===-1).reduce((L,U)=>(L.add(U),L),new Set),N=new Set;if(a)for(const L of A){if(F.has(L))continue;const U=a[L],$=g[L];T.equals(U,$)||N.add(L)}return{added:_,removed:F,updated:N}}function S(a,g,C,A){const V=(0,i.parse)(g),_=l(g),F=l(C),N=c(a,_,F);return h(C,a,V[a],N,F,A)}e.addSetting=S;function c(a,g,C){const A=g.findIndex(_=>_.setting?.key===a),V=g[A-1];if(V){if(V.setting){const F=n(V.setting.key,C);if(F)return{index:C.indexOf(F),insertAfter:!0}}else{const F=o(A,g);if(F){const N=n(F.setting.key,C);if(N){const L=t(C.indexOf(N),C),U=r(g,F,g[A]);if(L){const $=r(C,N,L),H=s(U,$);return H?{index:C.indexOf(H),insertAfter:!0}:{index:C.indexOf(L),insertAfter:!1}}else{const $=r(C,N,C[C.length-1]),H=s(U,$);return H?{index:C.indexOf(H),insertAfter:!0}:{index:C.length-1,insertAfter:!0}}}}}const _=g[A+1];if(_)if(_.setting){const F=n(_.setting.key,C);if(F)return{index:C.indexOf(F),insertAfter:!1}}else{const F=t(A,g);if(F){const N=n(F.setting.key,C);if(N){const L=o(C.indexOf(N),C),U=r(g,g[A],F);if(L){const $=r(C,L,N),H=s(U.reverse(),$.reverse());return H?{index:C.indexOf(H),insertAfter:!1}:{index:C.indexOf(L),insertAfter:!0}}else{const $=r(C,C[0],N),H=s(U.reverse(),$.reverse());return H?{index:C.indexOf(H),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:C.length-1,insertAfter:!0}}function h(a,g,C,A,V,_){let F;return A.index===-1?F=(0,R.setProperty)(a,[g],C,_):F=d(a,g,C,A,V,_).map(N=>(0,R.withFormatting)(a,N,_)[0]),(0,R.applyEdits)(a,F)}function d(a,g,C,A,V,_){const F=`${JSON.stringify(g)}: ${JSON.stringify(C)}`,N=(0,k.getEOL)(_,a),L=V[A.index];if(A.insertAfter){const U=[];if(L.setting)U.push({offset:L.endOffset,length:0,content:","+F});else{const $=t(A.index,V),H=o(A.index,V),q=H?.setting?.commaOffset;H&&q===void 0&&U.push({offset:H.endOffset,length:0,content:","});const x=q!==void 0&&q>L.endOffset;U.push({offset:x?q+1:L.endOffset,length:0,content:$?N+F+",":N+F})}return U}else{if(L.setting)return[{offset:L.startOffset,length:0,content:F+","}];const U=(V[A.index-1]&&!V[A.index-1].setting?N:"")+F+(t(A.index,V)?",":"")+N;return[{offset:L.startOffset,length:0,content:U}]}}function n(a,g){return g.filter(C=>C.setting?.key===a)[0]}function o(a,g){for(let C=a-1;C>=0;C--)if(g[C].setting)return g[C]}function t(a,g){for(let C=a+1;C<g.length;C++)if(g[C].setting)return g[C]}function r(a,g,C){const A=a.indexOf(g),V=a.indexOf(C);return a.filter((_,F)=>A<F&&F<V)}function s(a,g){if(a.length&&g.length){let C=0;for(;C<g.length&&C<a.length;C++)if(a[C].value!==g[C].value)return g[C-1];return g[C-1]}}function l(a){const g=[];let C=-1,A,V;const _={onObjectBegin:F=>{C++},onObjectProperty:(F,N,L)=>{C===0&&(A=N,V=F)},onObjectEnd:(F,N)=>{C--,C===0&&g.push({startOffset:A,endOffset:F+N,value:a.substring(A,F+N),setting:{key:V,commaOffset:void 0}})},onArrayBegin:(F,N)=>{C++},onArrayEnd:(F,N)=>{C--,C===0&&g.push({startOffset:A,endOffset:F+N,value:a.substring(A,F+N),setting:{key:V,commaOffset:void 0}})},onLiteralValue:(F,N,L)=>{C===0&&g.push({startOffset:A,endOffset:N+L,value:a.substring(A,N+L),setting:{key:V,commaOffset:void 0}})},onSeparator:(F,N,L)=>{if(C===0&&F===","){let U=g.length-1;for(;U>=0&&!g[U].setting;U--);const $=g[U];$&&g.splice(U,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:N}})}},onComment:(F,N)=>{C===0&&g.push({startOffset:F,endOffset:F+N,value:a.substring(F,F+N)})}};return(0,i.visit)(a,_),g}}),define(se[76],oe([0,1,3,2,4,26]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let T=class extends i.Disposable{get account(){return this._account}constructor(P,w){super(),this.userDataSyncStoreService=P,this.logService=w,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(P.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(P.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(P){(P&&this._account?P.token!==this._account.token||P.authenticationProviderId!==this._account.authenticationProviderId:P!==this._account)&&(this._account=P,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(P))}};T=ve([G(0,k.IUserDataSyncStoreService),G(1,k.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(se[258],oe([0,1,2,8]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(p){this.service=p}listen(p,v){switch(v){case"onError":return this.service.onError}throw new Error(`Event not found: ${v}`)}call(p,v,f){switch(v){case"triggerSync":return this.service.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class k{constructor(p){this.service=p}listen(p,v){throw new Error(`Event not found: ${v}`)}call(p,v,f){switch(v){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(i.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class T{constructor(p){this.channel=p}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(p){return this.channel.call("resolveUserKeybindings",[p])}async resolveFormattingOptions(p){return this.channel.call("resolveFormattingOptions",[p])}}e.UserDataSyncUtilServiceClient=T;class I{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${v}`)}async call(p,v,f){switch(v){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(f[0],f[1]);case"setEnablements":return this.service.setEnablements(f)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=I;class P{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${v}`)}call(p,v,f){switch(v){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=P;class w{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${v}`)}call(p,v,f){switch(v){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;class b extends D.Disposable{constructor(p){super(),this.channel=p,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(p){return this.channel.call("switch",[p])}async getPreviousUserDataSyncStore(){const p=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(p)}revive(p){return{url:i.URI.revive(p.url),type:p.type,defaultUrl:i.URI.revive(p.defaultUrl),insidersUrl:i.URI.revive(p.insidersUrl),stableUrl:i.URI.revive(p.stableUrl),canSwitch:p.canSwitch,authenticationProviders:p.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=b}),define(se[259],oe([0,1,13,7]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends i.AbstractLogger{constructor(T,I){super(),this.logger=this._register(T.createLogger(I.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...I){this.logger.trace(T,...I)}debug(T,...I){this.logger.debug(T,...I)}info(T,...I){this.logger.info(T,...I)}warn(T,...I){this.logger.warn(T,...I)}error(T,...I){this.logger.error(T,...I)}flush(){this.logger.flush()}};R=ve([G(0,i.ILoggerService),G(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(se[260],oe([0,1,6,3,2]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends R.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:P,getActiveWindowId:w}){super(),this.disposables=this._register(new R.DisposableStore),i.Event.latch(i.Event.any(I,P))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>w()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(se[116],oe([0,1,182,12,49,20,8,4,23]),function(Z,e,D,i,R,k,T,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function w(o){const t=o;return typeof t?.id=="string"&&T.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=w,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function b(o,t){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,i.basename)(o)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=o;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=b;function E(o){const t=o;return typeof t?.id=="string"&&T.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=E;function p(o){const t=o;if(t?.uri)return{id:t.id,uri:T.URI.revive(t.uri)};const r=o;if(r?.configPath)return{id:r.id,configPath:T.URI.revive(r.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=p;var v;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function f(o){const t=o;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=f;function m(o){const t=o;return!!(t&&typeof t=="object"&&T.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=m;class y{constructor(t,r,s,l,a){this._id=t,this._transient=s,this._configuration=l,this._ignorePathCasing=a,this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class u{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,k.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function S(o){return new u({uri:o,index:0,name:(0,k.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(o,t){return k.extUriBiasedIgnorePathCase.isEqualOrParent(o,t.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function h(o){let t;return T.URI.isUri(o)?t=o:t=o.configuration,t?.scheme===P.Schemas.tmp}e.isTemporaryWorkspace=h;function d(o,t){return!c(o,t)&&!h(o)}e.isSavedWorkspace=d;function n(o){return(typeof o=="string"?(0,i.extname)(o):(0,k.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(se[21],oe([0,1,66,3,2,20,8,174,13,14,4,7,116,37,31,6,30,27]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function S(o){const t=o;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&T.URI.isUri(t.location)&&T.URI.isUri(t.globalStorageHome)&&T.URI.isUri(t.settingsResource)&&T.URI.isUri(t.keybindingsResource)&&T.URI.isUri(t.tasksResource)&&T.URI.isUri(t.snippetsHome)&&T.URI.isUri(t.extensionsResource))}e.isUserDataProfile=S,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function c(o,t){return{id:o.id,isDefault:o.isDefault,name:o.name,shortName:o.shortName,location:T.URI.revive(o.location).with({scheme:t}),globalStorageHome:T.URI.revive(o.globalStorageHome).with({scheme:t}),settingsResource:T.URI.revive(o.settingsResource).with({scheme:t}),keybindingsResource:T.URI.revive(o.keybindingsResource).with({scheme:t}),tasksResource:T.URI.revive(o.tasksResource).with({scheme:t}),snippetsHome:T.URI.revive(o.snippetsHome).with({scheme:t}),extensionsResource:T.URI.revive(o.extensionsResource)?.with({scheme:t}),useDefaultFlags:o.useDefaultFlags,isTransient:o.isTransient}}e.reviveProfile=c;function h(o,t,r,s){return{id:o,name:t,location:r,isDefault:!1,shortName:s?.shortName,globalStorageHome:(0,k.joinPath)(r,"globalStorage"),settingsResource:(0,k.joinPath)(r,"settings.json"),keybindingsResource:(0,k.joinPath)(r,"keybindings.json"),tasksResource:(0,k.joinPath)(r,"tasks.json"),snippetsHome:(0,k.joinPath)(r,"snippets"),extensionsResource:(0,k.joinPath)(r,"extensions.json"),useDefaultFlags:s?.useDefaultFlags,isTransient:s?.transient}}e.toUserDataProfile=h;let d=class extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(t,r,s,l){super(),this.environmentService=t,this.fileService=r,this.uriIdentityService=s,this.logService=l,this.enabled=!1,this._onDidChangeProfiles=this._register(new i.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new i.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new i.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new i.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new v.ResourceMap},this.profilesHome=(0,k.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const t=this.enabled?this.getStoredProfiles().map(a=>h((0,k.basename)(a.location),a.name,a.location,{shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})):[];let r;const s=new v.ResourceMap,l=h((0,D.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,I.localize)(0,null),this.environmentService.userRoamingDataHome);if(t.unshift({...l,isDefault:!0}),t.length){const a=this.getStoredProfileAssociations();if(a.workspaces)for(const[g,C]of Object.entries(a.workspaces)){const A=T.URI.parse(g),V=T.URI.parse(C),_=t.find(F=>this.uriIdentityService.extUri.isEqual(F.location,V));_&&s.set(A,_)}if(a.emptyWindow){const g=T.URI.parse(a.emptyWindow);r=t.find(C=>this.uriIdentityService.extUri.isEqual(C.location,g))}}this._profilesObject={profiles:t,workspaces:s,emptyWindow:r}}return this._profilesObject}async createTransientProfile(t){const r="Temp",s=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let l=0;for(const g of this.profiles){const C=s.exec(g.name),A=C?parseInt(C[1]):0;l=A>l?A:l}const a=`${r} ${l+1}`;return this.createProfile((0,D.hash)((0,y.generateUuid)()).toString(16),a,{transient:!0},t)}async createNamedProfile(t,r,s){return this.createProfile((0,D.hash)((0,y.generateUuid)()).toString(16),t,r,s)}async createProfile(t,r,s,l){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=await this.doCreateProfile(t,r,s);return l&&await this.setProfileForWorkspace(l,a),a}async doCreateProfile(t,r,s){let l=this.profileCreationPromises.get(r);return l||(l=(async()=>{try{const a=this.profiles.find(A=>A.name===r||A.id===t);if(a)return a;const g=h(t,r,(0,k.joinPath)(this.profilesHome,t),s);await this.fileService.createFolder(g.location);const C=[];return this._onWillCreateProfile.fire({profile:g,join(A){C.push(A)}}),await m.Promises.settled(C),this.updateProfiles([g],[],[]),g}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,l)),l}async updateProfile(t,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let s=this.profiles.find(l=>l.id===t.id);if(!s)throw new Error(`Profile '${t.name}' does not exist`);return s=h(s.id,r.name??s.name,s.location,{shortName:r.shortName??s.shortName,transient:r.transient??s.isTransient,useDefaultFlags:r.useDefaultFlags??s.useDefaultFlags}),this.updateProfiles([],[],[s]),s}async removeProfile(t){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(l=>l.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const s=[];this._onWillRemoveProfile.fire({profile:r,join(l){s.push(l)}});try{await Promise.allSettled(s)}catch(l){this.logService.error(l)}r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const l of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(l)?.id&&this.profilesObject.workspaces.delete(l);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(l){this.logService.error(l)}}getOrSetProfileForWorkspace(t,r=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let s=this.getProfileForWorkspace(t);return s||(s=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,s)),s}async setProfileForWorkspace(t,r){this.setProfileForWorkspaceSync(t,r)}setProfileForWorkspaceSync(t,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(l=>l.id===r.id);if(!s)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(t,s)}unsetWorkspace(t,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(t,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(s=>!this.uriIdentityService.extUri.isEqual(s.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.getWorkspace(t);return T.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(t){return(0,p.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,p.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}isProfileAssociatedToWorkspace(t){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,t.location)||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,t.location)||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location)))}updateProfiles(t,r,s){const l=[...this.profiles,...t],a=[];this.transientProfilesObject.profiles=[];for(let g of l)g.isDefault||r.some(C=>g.id===C.id)||(g=s.find(C=>g.id===C.id)??g,g.isTransient?this.transientProfilesObject.profiles.push(g):a.push({location:g.location,name:g.name,shortName:g.shortName,useDefaultFlags:g.useDefaultFlags}));this.saveStoredProfiles(a),this._profilesObject=void 0,this.triggerProfilesChanges(t,r,s)}triggerProfilesChanges(t,r,s){this._onDidChangeProfiles.fire({added:t,removed:r,updated:s,all:this.profiles})}updateWorkspaceAssociation(t,r,s){s=r?.isTransient?!0:s,s||this.updateWorkspaceAssociation(t,void 0,!0);const l=this.getWorkspace(t),a=s?this.transientProfilesObject:this.profilesObject;T.URI.isUri(l)?(a.workspaces.delete(l),r&&a.workspaces.set(l,r)):a.emptyWindow=r,s||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[s,l]of this.profilesObject.workspaces.entries())t[s.toString()]=l.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:t,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}};d.PROFILES_KEY="userDataProfiles",d.PROFILE_ASSOCIATIONS_KEY="profileAssociations",d=ve([G(0,P.IEnvironmentService),G(1,w.IFileService),G(2,f.IUriIdentityService),G(3,E.ILogService)],d),e.UserDataProfilesService=d;class n extends d{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(t){this.storedProfiles=t}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(t){this.storedProfileAssociations=t}}e.InMemoryUserDataProfilesService=n}),define(se[261],oe([0,1,6,2,21]),function(Z,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let k=class extends i.Disposable{constructor(I){super(),this._register(new D.RunOnceScheduler(()=>{I.cleanUp()},10*1e3)).schedule()}};k=ve([G(0,R.IUserDataProfilesService)],k),e.UserDataProfilesCleaner=k}),define(se[262],oe([0,1,19,6,22,11,3,2,5,8,155,29,33,46,7,25,24,21]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let S=class extends I.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(t,r,s,l,a){super(),this.galleryService=t,this.telemetryService=r,this.logService=s,this.productService=l,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(({task:g})=>g.cancel()),this.uninstallingExtensions.forEach(g=>g.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(s=>(0,E.isTargetPlatformCompatible)(s,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.galleryService.isEnabled())throw new E.ExtensionManagementError(b.localize(0,null),E.ExtensionManagementErrorCode.Internal);const s=await this.checkAndGetCompatibleVersion(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(s.manifest,s.extension,r)}catch(s){throw d(this.telemetryService,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(t),error:s}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(s),h(s)}}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,r)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,r,s){const l={...s,installOnlyNewlyAddedFromExtensionPack:w.URI.isUri(r)?s.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:!s.profileLocation||(0,v.isApplicationScopedExtension)(t)?this.userDataProfilesService.defaultProfile.extensionsResource:s.profileLocation},a=F=>`${p.ExtensionKey.create(F).toString()}${l.profileLocation?`-${l.profileLocation.toString()}`:""}`;if(!w.URI.isUri(r)){const F=this.installingExtensions.get(a(r));if(F){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:N}=await F.task.waitUntilTaskIsFinished();return N}}const g=[],C=[],A=[],V=this.createInstallExtensionTask(t,r,l);w.URI.isUri(r)||this.installingExtensions.set(a(r),{task:V,waitingTasks:[]}),this._onInstallExtension.fire({identifier:V.identifier,source:r,profileLocation:l.profileLocation}),this.logService.info("Installing extension:",V.identifier.id),g.push({task:V,manifest:t});let _=!1;try{if(l.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",V.identifier.id);else try{const N=await this.getAllDepsAndPackExtensions(V.identifier,t,!!l.installOnlyNewlyAddedFromExtensionPack,!!l.installPreReleaseVersion,l.profileLocation),L=await this.getInstalled(void 0,l.profileLocation);for(const{gallery:U,manifest:$}of N){_=_||!!$.extensionDependencies?.some(x=>(0,p.areSameExtensions)({id:x},V.identifier));const H=a(U),q=this.installingExtensions.get(H);if(q){if(this.canWaitForTask(V,q.task)){this.logService.info("Waiting for already requested installing extension",U.identifier.id,V.identifier.id),q.waitingTasks.push(V);const x=q.task.identifier;C.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,W=>W.some(j=>(0,p.areSameExtensions)(j.identifier,x)))).then(W=>{if(!W.find(K=>(0,p.areSameExtensions)(K.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else if(!L.some(({identifier:x})=>(0,p.areSameExtensions)(x,U.identifier))){const x=this.createInstallExtensionTask($,U,{...l,donotIncludePackAndDependencies:!0});this.installingExtensions.set(H,{task:x,waitingTasks:[V]}),this._onInstallExtension.fire({identifier:x.identifier,source:U,profileLocation:l.profileLocation}),this.logService.info("Installing extension:",x.identifier.id,V.identifier.id),g.push({task:x,manifest:$})}}}catch(N){if(w.URI.isUri(V.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",V.identifier.id,N.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",V.identifier.id,N.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",V.identifier.id),N}const F=g.reduce((N,{task:L,manifest:U})=>(N.set(L.identifier.id.toLowerCase(),{task:L,manifest:U}),N),new Map);for(;F.size;){let N;const L=[...F.values()].filter(({manifest:U})=>!U.extensionDependencies?.some($=>F.has($.toLowerCase())));L.length?N=F.size===1?L:L.filter(({task:U})=>!(U===V&&!_)):(this.logService.info("Found extensions with circular dependencies",L.map(({task:U})=>U.identifier.id)),N=[...F.values()]),await this.joinAllSettled(N.map(async({task:U})=>{const $=new Date().getTime();try{const{local:H}=await U.run();if(await this.joinAllSettled(this.participants.map(q=>q.postInstall(H,U.source,l,R.CancellationToken.None))),!w.URI.isUri(U.source)){const q=U.operation===3,x=q?void 0:(new Date().getTime()-U.source.lastUpdated)/1e3;if(d(this.telemetryService,q?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(U.source),wasVerified:U.wasVerified,duration:new Date().getTime()-$,durationSinceUpdate:x}),P.isWeb&&U.operation!==3)try{await this.galleryService.reportStatistic(H.manifest.publisher,H.manifest.name,H.manifest.version,"install")}catch{}}A.push({local:H,identifier:U.identifier,operation:U.operation,source:U.source,context:l.context,profileLocation:l.profileLocation,applicationScoped:H.isApplicationScoped})}catch(H){throw w.URI.isUri(U.source)||d(this.telemetryService,U.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(U.source),wasVerified:U.wasVerified,duration:new Date().getTime()-$,error:H}),this.logService.error("Error while installing the extension:",U.identifier.id),H}finally{F.delete(U.identifier.id.toLowerCase())}}))}return C.length&&await this.joinAllSettled(C),A.forEach(({identifier:N})=>this.logService.info("Extension installed successfully:",N.id)),this._onDidInstallExtensions.fire(A),A.filter(({identifier:N})=>(0,p.areSameExtensions)(N,V.identifier))[0].local}catch(F){if(g.forEach(({task:N})=>N.cancel()),A.length)try{const N=await Promise.allSettled(A.map(({local:L})=>this.createUninstallExtensionTask(L,{versionOnly:!0,profileLocation:l.profileLocation}).run()));for(let L=0;L<N.length;L++){const U=N[L],{identifier:$}=A[L];U.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",$.id):this.logService.warn("Rollback: Error while uninstalling extension",$.id,(0,k.getErrorMessage)(U.reason))}}catch(N){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(N),A.map(({identifier:L})=>L.id))}throw this._onDidInstallExtensions.fire(g.map(({task:N})=>({identifier:N.identifier,operation:2,source:N.source,context:l.context,profileLocation:l.profileLocation}))),F}finally{for(const[F,{task:N,waitingTasks:L}]of this.installingExtensions.entries()){const U=L.indexOf(V);U!==-1&&L.splice(U,1),L.length===0&&(N===V||U!==-1)&&this.installingExtensions.delete(F)}}}canWaitForTask(t,r){for(const[,{task:s,waitingTasks:l}]of this.installingExtensions.entries())if(s===t&&(l.includes(r)||l.some(a=>this.canWaitForTask(a,r)))||s===r&&l[0]&&!this.canWaitForTask(t,l[0]))return!1;return!0}async joinAllSettled(t){const r=[],s=[],l=await Promise.allSettled(t);for(const a of l)a.status==="fulfilled"?r.push(a.value):s.push(a.reason);if(s.length)throw c(s);return r}async getAllDepsAndPackExtensions(t,r,s,l,a){if(!this.galleryService.isEnabled())return[];const g=await this.getInstalled(void 0,a),C=[t],A=[],V=async(_,F)=>{const N=F.extensionDependencies||[],L=[...N];if(F.extensionPack){const U=s?g.find($=>(0,p.areSameExtensions)($.identifier,_)):void 0;for(const $ of F.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(H=>(0,p.areSameExtensions)({id:H},{id:$}))||L.every(H=>!(0,p.areSameExtensions)({id:H},{id:$}))&&L.push($)}if(L.length){const U=[...C,...A.map(H=>H.gallery.identifier)],$=L.filter(H=>U.every(q=>!(0,p.areSameExtensions)(q,{id:H})));if($.length){const H=await this.galleryService.getExtensions($.map(q=>({id:q,preRelease:l})),R.CancellationToken.None);for(const q of H){if(U.find(j=>(0,p.areSameExtensions)(j,q.identifier)))continue;const x=N.some(j=>(0,p.areSameExtensions)({id:j},q.identifier));let W;try{W=await this.checkAndGetCompatibleVersion(q,!1,l)}catch(j){if(j instanceof E.ExtensionManagementError&&j.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!x){this.logService.info("Skipping the packed extension as it cannot be installed",q.identifier.id);continue}else throw j}A.push({gallery:W.extension,manifest:W.manifest}),await V(W.extension.identifier,W.manifest)}}}};return await V(t,r),A}async checkAndGetCompatibleVersion(t,r,s){if((await this.getExtensionsControlManifest()).malicious.some(C=>(0,p.areSameExtensions)(t.identifier,C)))throw new E.ExtensionManagementError(b.localize(1,null,t.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const C=await this.getTargetPlatform();throw new E.ExtensionManagementError(b.localize(2,null,t.identifier.id,this.productService.nameLong,(0,E.TargetPlatformToString)(C)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(t,r,s);if(a){if(s&&!r&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(b.localize(3,null,t.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],R.CancellationToken.None))[0]?new E.ExtensionManagementError(b.localize(4,null,t.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(b.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const g=await this.galleryService.getManifest(a,R.CancellationToken.None);if(g===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(g.version!==a.version)throw new E.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:g}}async getCompatibleVersion(t,r,s){const l=await this.getTargetPlatform();let a=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==s&&(a=(await this.galleryService.getExtensions([{...t.identifier,preRelease:s}],{targetPlatform:l,compatible:!0},R.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(t,s,l)&&(a=t),a||(r?a=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:l,compatible:!0},R.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(t,s,l)),a}async uninstallExtension(t,r){const s={...r,profileLocation:!r.profileLocation||t.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation},l=_=>`${_.id.toLowerCase()}${s.versionOnly?`-${t.manifest.version}`:""}${s.profileLocation?`@${s.profileLocation.toString()}`:""}`,a=this.uninstallingExtensions.get(l(t.identifier));if(a)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),a.waitUntilTaskIsFinished();const g=_=>{const F=this.createUninstallExtensionTask(_,s);return this.uninstallingExtensions.set(l(F.extension.identifier),F),s.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,s.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this._onUninstallExtension.fire({identifier:_.identifier,profileLocation:s.profileLocation,applicationScoped:_.isApplicationScoped}),F},C=(_,F)=>{F?s.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,s.profileLocation.toString(),F.message):this.logService.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,F.message):s.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,s.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),d(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(_),error:F}),this._onDidUninstallExtension.fire({identifier:_.identifier,error:F?.code,profileLocation:s.profileLocation,applicationScoped:_.isApplicationScoped})},A=[],V=[];try{A.push(g(t));const _=await this.getInstalled(1,s.profileLocation);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const F=this.getAllPackExtensionsToUninstall(t,_);for(const N of F)this.uninstallingExtensions.has(l(N.identifier))?this.logService.info("Extensions is already requested to uninstall",N.identifier.id):A.push(g(N))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(A.map(F=>F.extension),_,t),await this.joinAllSettled(A.map(async F=>{try{if(await F.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(F.extension,s,R.CancellationToken.None))),F.extension.identifier.uuid)try{await this.galleryService.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}C(F.extension)}catch(N){const L=N instanceof E.ExtensionManagementError?N:new E.ExtensionManagementError((0,k.getErrorMessage)(N),E.ExtensionManagementErrorCode.Internal);throw C(F.extension,L),L}finally{V.push(F)}}))}catch(_){const F=_ instanceof E.ExtensionManagementError?_:new E.ExtensionManagementError((0,k.getErrorMessage)(_),E.ExtensionManagementErrorCode.Internal);for(const N of A){try{N.cancel()}catch{}V.includes(N)||C(N.extension,F)}throw F}finally{for(const _ of A)this.uninstallingExtensions.delete(l(_.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}checkForDependents(t,r,s){for(const l of t){const a=this.getDependents(l,r);if(a.length){const g=a.filter(C=>!t.some(A=>(0,p.areSameExtensions)(A.identifier,C.identifier)));if(g.length)throw new Error(this.getDependentsErrorMessage(l,g,s))}}}getDependentsErrorMessage(t,r,s){return s===t?r.length===1?b.localize(6,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(7,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(8,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(9,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(10,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(11,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,s=[]){if(s.indexOf(t)!==-1)return[];s.push(t);const l=t.manifest.extensionPack?t.manifest.extensionPack:[];if(l.length){const a=r.filter(C=>!C.isBuiltin&&l.some(A=>(0,p.areSameExtensions)({id:A},C.identifier))),g=[];for(const C of a)g.push(...this.getAllPackExtensionsToUninstall(C,r,s));return[...a,...g]}return[]}getDependents(t,r){return r.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(l=>(0,p.areSameExtensions)({id:l},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};S=ve([G(0,E.IExtensionGalleryService),G(1,y.ITelemetryService),G(2,f.ILogService),G(3,m.IProductService),G(4,u.IUserDataProfilesService)],S),e.AbstractExtensionManagementService=S;function c(o){const t=Array.isArray(o)?o:[o];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,s)=>new Error(`${r.message}${r.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=c;function h(o){if(o instanceof E.ExtensionManagementError)return o;const t=new E.ExtensionManagementError(o.message,E.ExtensionManagementErrorCode.Internal);return t.stack=o.stack,t}function d(o,t,{extensionData:r,wasVerified:s,duration:l,error:a,durationSinceUpdate:g}){let C,A;a&&(a instanceof E.ExtensionManagementError?(C=a.code,a.code===E.ExtensionManagementErrorCode.Signature&&(A=a.message)):C=E.ExtensionManagementErrorCode.Internal),o.publicLog(t,{...r,wasVerified:s,success:!a,duration:l,errorcode:C,errorcodeDetail:A,durationSinceUpdate:g})}e.reportTelemetry=d;class n{constructor(){this.barrier=new i.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(t=>new Promise((r,s)=>{const l=t.onCancellationRequested(()=>{l.dispose(),s(new k.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n}),define(se[77],oe([0,1,19,6,32,17,11,35,137,2,23,12,5,20,54,87,15,8,158,13,33,46,70,14,4,7,25,3,67,60,21,31,188]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u,S,c,h,d,n,o,t,r,s,l,a,g,C,A,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var _;(function(q){function x(W,j){if(W===j)return!0;const K=Object.keys(W),ee=new Set;for(const ce of Object.keys(j))ee.add(ce);if(K.length!==ee.size)return!1;for(const ce of K){if(W[ce]!==j[ce])return!1;ee.delete(ce)}return ee.size===0}q.equals=x})(_=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let F=class extends w.Disposable{constructor(x,W,j,K,ee,ce,J,Q,M,O,B,z){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=W,this.extensionsControlLocation=j,this.cacheLocation=K,this.userDataProfilesService=ee,this.extensionsProfileScannerService=ce,this.fileService=J,this.logService=Q,this.environmentService=M,this.productService=O,this.uriIdentityService=B,this.instantiationService=z,this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(U,(0,v.joinPath)(this.cacheLocation,d.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(U,(0,v.joinPath)(this.cacheLocation,d.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(L,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,h.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(x,W,j){const[K,ee]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(W)]),ce=j?await this.scanExtensionsUnderDevelopment(x,[...K,...ee]):[];return this.dedupExtensions(K,ee,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const W=[];W.push(this.scanDefaultSystemExtensions(!!x.useCache,x.language)),W.push(this.scanDevSystemExtensions(x.language,!!x.checkControlFile));const[j,K]=await Promise.all(W);return this.applyScanOptions([...j,...K],0,x,!1)}async scanUserExtensions(x){const W=x.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",W);const j=await this.createExtensionScannerInput(W,!!x.profileLocation,1,!x.includeUninstalled,x.language);let ee=await(x.useCache&&!j.devMode&&j.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(j);return ee=await this.applyScanOptions(ee,1,x,!0),this.logService.trace("Scanned user extensions:",ee.length),ee}async scanExtensionsUnderDevelopment(x,W){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const j=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(K=>K.scheme===b.Schemas.file).map(async K=>{const ee=await this.createExtensionScannerInput(K,!1,1,!0,x.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(ee)).map(J=>(J.type=W.find(Q=>(0,h.areSameExtensions)(Q.identifier,J.identifier))?.type??J.type,this.extensionsScanner.validate(J,ee)))}))).flat();return this.applyScanOptions(j,"development",x,!0)}return[]}async scanExistingExtension(x,W,j){const K=await this.createExtensionScannerInput(x,!1,W,!0,j.language),ee=await this.extensionsScanner.scanExtension(K);return!ee||!j.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(x,W,j){const K=await this.createExtensionScannerInput(x,!1,W,!0,j.language),ee=await this.extensionsScanner.scanOneOrMultipleExtensions(K);return this.applyScanOptions(ee,W,j,!0)}async scanMetadata(x){const W=(0,v.joinPath)(x,"package.json"),j=(await this.fileService.readFile(W)).value.toString();return JSON.parse(j).__metadata}async updateMetadata(x,W){const j=(0,v.joinPath)(x,"package.json"),K=(await this.fileService.readFile(j)).value.toString(),ee=JSON.parse(K);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,ee.__metadata={...ee.__metadata,...W},await this.fileService.writeFile((0,v.joinPath)(x,"package.json"),k.VSBuffer.fromString(JSON.stringify(ee,null,"	")))}async applyScanOptions(x,W,j,K){return j.includeAllVersions||(x=this.dedupExtensions(W===0?x:void 0,W===1?x:void 0,W==="development"?x:void 0,await this.getTargetPlatform(),K)),j.includeInvalid||(x=x.filter(ee=>ee.isValid)),x.sort((ee,ce)=>{const J=E.basename(ee.location.fsPath),Q=E.basename(ce.location.fsPath);return J<Q?-1:J>Q?1:0})}dedupExtensions(x,W,j,K,ee){const ce=(Q,M,O)=>{if(Q.isValid&&!M.isValid)return!1;if(Q.isValid===M.isValid){if(ee&&f.gt(Q.manifest.version,M.manifest.version))return this.logService.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${Q.location.path} with version ${Q.manifest.version}`),!1;if(f.eq(Q.manifest.version,M.manifest.version)){if(Q.type===0)return this.logService.debug(`Skipping extension ${M.location.path} in favour of system extension ${Q.location.path} with same version`),!1;if(Q.targetPlatform===K)return this.logService.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${Q.location.path} with ${M.location.path}.`):this.logService.debug(`Overwriting user extension ${Q.location.path} with ${M.location.path}.`),!0},J=new Map;return x?.forEach(Q=>{const M=d.ExtensionIdentifier.toKey(Q.identifier.id),O=J.get(M);(!O||ce(O,Q,!1))&&J.set(M,Q)}),W?.forEach(Q=>{const M=d.ExtensionIdentifier.toKey(Q.identifier.id),O=J.get(M);if(!O&&x&&Q.type===0){this.logService.debug(`Skipping obsolete system extension ${Q.location.path}.`);return}(!O||ce(O,Q,!1))&&J.set(M,Q)}),j?.forEach(Q=>{const M=d.ExtensionIdentifier.toKey(Q.identifier.id),O=J.get(M);(!O||ce(O,Q,!0))&&J.set(M,Q),J.set(M,Q)}),[...J.values()]}async scanDefaultSystemExtensions(x,W){this.logService.trace("Started scanning system extensions");const j=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,W),ee=await(x&&!j.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(j);return this.logService.trace("Scanned system extensions:",ee.length),ee}async scanDevSystemExtensions(x,W){const j=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!j?.length)return[];this.logService.trace("Started scanning dev system extensions");const K=W?await this.getBuiltInExtensionControl():{},ee=[],ce=u.URI.file(E.normalize(E.join(b.FileAccess.asFileUri("",Z).fsPath,"..",".build","builtInExtensions")));for(const Q of j){const M=K[Q.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":ee.push((0,v.joinPath)(ce,Q.name));break;default:ee.push(u.URI.file(M));break}}const J=await Promise.all(ee.map(async Q=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(Q,!1,0,!0,x))));return this.logService.trace("Scanned dev system extensions:",J.length),(0,D.coalesce)(J)}async getBuiltInExtensionControl(){try{const x=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(x.value.toString())}catch{return{}}}async createExtensionScannerInput(x,W,j,K,ee,ce=!0){const J=await this.getTranslations(ee??p.language),Q=await this.getMtime(x),M=W&&!this.uriIdentityService.extUri.isEqual(x,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=M?await this.getMtime(M):void 0;return new N(x,Q,M,O,W,j,K,ce,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,ee,J)}async getMtime(x){try{const W=await this.fileService.stat(x);if(typeof W.mtime=="number")return W.mtime}catch{}}};F=ve([G(4,C.IUserDataProfilesService),G(5,g.IExtensionsProfileScannerService),G(6,o.IFileService),G(7,r.ILogService),G(8,c.IEnvironmentService),G(9,s.IProductService),G(10,A.IUriIdentityService),G(11,t.IInstantiationService)],F),e.AbstractExtensionsScannerService=F;class N{constructor(x,W,j,K,ee,ce,J,Q,M,O,B,z,Y,ne){this.location=x,this.mtime=W,this.applicationExtensionslocation=j,this.applicationExtensionslocationMtime=K,this.profile=ee,this.type=ce,this.excludeObsolete=J,this.validate=Q,this.productVersion=M,this.productDate=O,this.productCommit=B,this.devMode=z,this.language=Y,this.translations=ne}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,W){return(0,v.isEqual)(x.location,W.location)&&x.mtime===W.mtime&&(0,v.isEqual)(x.applicationExtensionslocation,W.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&x.profile===W.profile&&x.type===W.type&&x.excludeObsolete===W.excludeObsolete&&x.validate===W.validate&&x.productVersion===W.productVersion&&x.productDate===W.productDate&&x.productCommit===W.productCommit&&x.devMode===W.devMode&&x.language===W.language&&_.equals(x.translations,W.translations)}}let L=class extends w.Disposable{constructor(x,W,j,K,ee){super(),this.obsoleteFile=x,this.extensionsProfileScannerService=W,this.uriIdentityService=j,this.fileService=K,this.logService=ee}async scanExtensions(x){const W=x.profile?await this.scanExtensionsFromProfile(x):await this.scanExtensionsFromLocation(x);let j={};if(x.excludeObsolete&&x.type===1)try{const K=(await this.fileService.readFile(this.obsoleteFile)).value.toString();j=JSON.parse(K)}catch{}return(0,y.isEmptyObject)(j)?W:W.filter(K=>!j[h.ExtensionKey.create(K).toString()])}async scanExtensionsFromLocation(x){const W=await this.fileService.resolve(x.location);if(!W.children?.length)return[];const j=await Promise.all(W.children.map(async K=>{if(!K.isDirectory||x.type===1&&(0,v.basename)(K.resource).indexOf(".")===0)return null;const ee=new N(K.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(ee)}));return(0,D.coalesce)(j).sort((K,ee)=>K.location.path<ee.location.path?-1:1)}async scanExtensionsFromProfile(x){let W=await this.scanExtensionsFromProfileResource(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(x.location,x.applicationExtensionslocation)){W=W.filter(K=>!K.metadata?.isApplicationScoped);const j=await this.scanExtensionsFromProfileResource(x.applicationExtensionslocation,K=>!!K.metadata?.isApplicationScoped,x);W.push(...j)}return W}async scanExtensionsFromProfileResource(x,W,j){const K=await this.extensionsProfileScannerService.scanProfileExtensions(x);if(!K.length)return[];const ee=await Promise.all(K.map(async ce=>{if(W(ce)){const J=new N(ce.location,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(J,ce.metadata)}return null}));return(0,D.coalesce)(ee)}async scanOneOrMultipleExtensions(x){try{if(await this.fileService.exists((0,v.joinPath)(x.location,"package.json"))){const W=await this.scanExtension(x);return W?[W]:[]}else return await this.scanExtensions(x)}catch(W){return this.logService.error(`Error scanning extensions at ${x.location.path}:`,(0,T.getErrorMessage)(W)),[]}}async scanExtension(x,W){try{let j=await this.scanExtensionManifest(x.location);if(j){j.publisher||(j.publisher=d.UNDEFINED_PUBLISHER),W=W??j.__metadata,delete j.__metadata;const K=(0,h.getGalleryExtensionId)(j.publisher,j.name),ee=W?.id?{id:K,uuid:W.id}:{id:K},ce=W?.isSystem?0:x.type,J=ce===0||!!W?.isBuiltin;j=await this.translateManifest(x.location,j,N.createNlsConfiguration(x));const Q={type:ce,identifier:ee,manifest:j,location:x.location,isBuiltin:J,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return x.validate?this.validate(Q,x):Q}}catch(j){x.type!==0&&this.logService.error(j)}return null}validate(x,W){let j=!0;const K=(0,n.validateExtensionManifest)(W.productVersion,W.productDate,W.location,x.manifest,x.isBuiltin);for(const[ee,ce]of K)ee===m.default.Error&&(j=!1,this.logService.error(this.formatMessage(W.location,ce)));return x.isValid=j,x.validations=K,x}async scanExtensionManifest(x){const W=(0,v.joinPath)(x,"package.json");let j;try{j=(await this.fileService.readFile(W)).value.toString()}catch(ee){return(0,o.toFileOperationResult)(ee)!==1&&this.logService.error(this.formatMessage(x,(0,S.localize)(0,null,W.path,ee.message))),null}let K;try{K=JSON.parse(j)}catch{const ce=[];(0,I.parse)(j,ce);for(const J of ce)this.logService.error(this.formatMessage(x,(0,S.localize)(1,null,W.path,J.offset,J.length,(0,P.getParseErrorMessage)(J.error))));return null}return(0,I.getNodeType)(K)!=="object"?(this.logService.error(this.formatMessage(x,(0,S.localize)(2,null,W.path))),null):K}async translateManifest(x,W,j){const K=await this.getLocalizedMessages(x,W,j);if(K)try{const ee=[],ce=await this.resolveOriginalMessageBundle(K.default,ee);if(ee.length>0)return ee.forEach(Q=>{this.logService.error(this.formatMessage(x,(0,S.localize)(3,null,K.default?.path,(0,P.getParseErrorMessage)(Q.error))))}),W;if((0,I.getNodeType)(K)!=="object")return this.logService.error(this.formatMessage(x,(0,S.localize)(4,null,K.default?.path))),W;const J=K.values||Object.create(null);return(0,V.localizeManifest)(W,J,ce)}catch{}return W}async getLocalizedMessages(x,W,j){const K=(0,v.joinPath)(x,"package.nls.json"),ee=(M,O)=>{O.forEach(B=>{this.logService.error(this.formatMessage(x,(0,S.localize)(5,null,M?.path,(0,P.getParseErrorMessage)(B.error))))})},ce=M=>{this.logService.error(this.formatMessage(x,(0,S.localize)(6,null,M?.path)))},J=`${W.publisher}.${W.name}`,Q=j.translations[J];if(Q)try{const M=u.URI.file(Q),O=(await this.fileService.readFile(M)).value.toString(),B=[],z=(0,I.parse)(O,B);return B.length>0?(ee(M,B),{values:void 0,default:K}):(0,I.getNodeType)(z)!=="object"?(ce(M),{values:void 0,default:K}):{values:z.contents?z.contents.package:void 0,default:K}}catch{return{values:void 0,default:K}}else{if(!await this.fileService.exists(K))return;let O;try{O=await this.findMessageBundles(x,j)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const B=(await this.fileService.readFile(O.localized)).value.toString(),z=[],Y=(0,I.parse)(B,z);return z.length>0?(ee(O.localized,z),{values:void 0,default:O.original}):(0,I.getNodeType)(Y)!=="object"?(ce(O.localized),{values:void 0,default:O.original}):{values:Y,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(x,W){if(x)try{const j=(await this.fileService.readFile(x)).value.toString();return(0,I.parse)(j,W)}catch{}}findMessageBundles(x,W){return new Promise((j,K)=>{const ee=ce=>{const J=(0,v.joinPath)(x,`package.nls.${ce}.json`);this.fileService.exists(J).then(Q=>{Q&&j({localized:J,original:(0,v.joinPath)(x,"package.nls.json")});const M=ce.lastIndexOf("-");M===-1?j({localized:(0,v.joinPath)(x,"package.nls.json"),original:null}):(ce=ce.substring(0,M),ee(ce))})};if(W.devMode||W.pseudo||!W.language)return j({localized:(0,v.joinPath)(x,"package.nls.json"),original:null});ee(W.language)})}formatMessage(x,W){return`[${x.path}]: ${W}`}};L=ve([G(1,g.IExtensionsProfileScannerService),G(2,A.IUriIdentityService),G(3,o.IFileService),G(4,r.ILogService)],L);let U=class extends L{constructor(x,W,j,K,ee,ce){super(W,j,K,ee,ce),this.cacheFile=x,this.cacheValidatorThrottler=this._register(new i.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(x){const W=await this.readExtensionCache();if(this.input=x,W&&W.input&&N.equals(W.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),W.result.map(K=>(K.location=u.URI.revive(K.location),K));const j=await super.scanExtensions(x);return await this.writeExtensionCache({input:x,result:j}),j}async readExtensionCache(){try{const x=await this.fileService.readFile(this.cacheFile),W=JSON.parse(x.value.toString());return{result:W.result,input:(0,a.revive)(W.input)}}catch(x){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(x))}return null}async writeExtensionCache(x){try{await this.fileService.writeFile(this.cacheFile,k.VSBuffer.fromString(JSON.stringify(x)))}catch(W){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(W))}}async validateCache(){if(!this.input)return;const x=await this.readExtensionCache();if(!x)return;const W=x.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!R.equals(j,W))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(K){this.logService.error(K)}}};U=ve([G(2,g.IExtensionsProfileScannerService),G(3,A.IUriIdentityService),G(4,o.IFileService),G(5,r.ILogService)],U);function $(q,x){const W=(0,h.getExtensionId)(q.manifest.publisher,q.manifest.name);return{id:W,identifier:new d.ExtensionIdentifier(W),isBuiltin:q.type===0,isUserBuiltin:q.type===1&&q.isBuiltin,isUnderDevelopment:x,extensionLocation:q.location,uuid:q.identifier.uuid,targetPlatform:q.targetPlatform,...q.manifest}}e.toExtensionDescription=$;class H extends F{constructor(x,W,j,K,ee,ce,J,Q,M,O,B,z){super(x,W,(0,v.joinPath)(j,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(K,d.MANIFEST_CACHE_FOLDER),ee,ce,J,Q,M,O,B,z),this.translationsPromise=(async()=>{if(p.translationsConfigFile)try{const Y=await this.fileService.readFile(u.URI.file(p.translationsConfigFile));return JSON.parse(Y.value.toString())}catch{}return Object.create(null)})()}getTranslations(x){return this.translationsPromise}}e.NativeExtensionsScannerService=H}),define(se[263],oe([0,1,50,6,38,3,2,23,12,28,7,21]),function(Z,e,D,i,R,k,T,I,P,w,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends T.Disposable{constructor(f,m){super(),this.userDataProfilesService=f,this.logService=m,this.processesLimiter=new i.Limiter(5)}async postUninstall(f){const m=this.parseScript(f,"uninstall");return m&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(m.script,"uninstall",m.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${y}`)))),w.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(f,m){const y=`vscode:${m}`;if(f.location.scheme===I.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[y]=="string"){const u=f.manifest.scripts[y].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${y} should be a node script`),null):{script:(0,P.join)(f.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}runLifecycleHook(f,m,y,u,S){return new Promise((c,h)=>{const d=this.start(f,m,y,S);let n;const o=t=>{n&&(clearTimeout(n),n=null),t?h(t):c(void 0)};d.on("error",t=>{o((0,R.toErrorMessage)(t)||"Unknown")}),d.on("exit",(t,r)=>{o(t?`post-${m} process exited with code ${t}`:void 0)}),u&&(n=setTimeout(()=>{n=null,d.kill(),h("timed out")},5e3))})}start(f,m,y,u){const S={silent:!0,execArgv:void 0},c=(0,D.fork)(f,[`--type=extension-post-${m}`,...y],S);c.stdout.setEncoding("utf8"),c.stderr.setEncoding("utf8");const h=k.Event.fromNodeEventEmitter(c.stdout,"data"),d=k.Event.fromNodeEventEmitter(c.stderr,"data");h(t=>this.logService.info(u.identifier.id,u.manifest.version,`post-${m}`,t)),d(t=>this.logService.error(u.identifier.id,u.manifest.version,`post-${m}`,t));const n=k.Event.any(k.Event.map(h,t=>({data:`%c${t}`,format:[""]})),k.Event.map(d,t=>({data:`%c${t}`,format:["color: red"]})));return k.Event.debounce(n,(t,r)=>t?{data:t.data+r.data,format:[...t.format,...r.format]}:{data:r.data,format:r.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),c}getExtensionStoragePath(f){return(0,P.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};p=ve([G(0,E.IUserDataProfilesService),G(1,b.ILogService)],p),e.ExtensionsLifecycle=p}),define(se[264],oe([0,1,8,13,60,77,14,4,7,25,31,21]),function(Z,e,D,i,R,k,T,I,P,w,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends k.NativeExtensionsScannerService{constructor(f,m,y,u,S,c,h,d){super(D.URI.file(S.builtinExtensionsPath),D.URI.file(S.extensionsPath),S.userHome,D.URI.file(S.userDataPath),f,m,y,u,S,c,h,d)}};p=ve([G(0,E.IUserDataProfilesService),G(1,R.IExtensionsProfileScannerService),G(2,T.IFileService),G(3,P.ILogService),G(4,i.INativeEnvironmentService),G(5,w.IProductService),G(6,b.IUriIdentityService),G(7,I.IInstantiationService)],p),e.ExtensionsScannerService=p}),define(se[18],oe([0,1,6,3,2,206,15,69,4,21]),function(Z,e,D,i,R,k,T,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,P.createDecorator)("storageService");var b;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(S){S[S.APPLICATION=-1]="APPLICATION",S[S.PROFILE=0]="PROFILE",S[S.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var p;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function v(S){const c=S.get(e.TARGET_KEY);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.loadKeyTargets=v;class f extends R.Disposable{constructor(c={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=c,this._onDidChangeValue=this._register(new i.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new i.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new i.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(c,h){if(h===e.TARGET_KEY){switch(c){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:c})}else this._onDidChangeValue.fire({scope:c,key:h,target:this.getKeyTargets(c)[h]})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}get(c,h,d){return this.getStorage(h)?.get(c,d)}getBoolean(c,h,d){return this.getStorage(h)?.getBoolean(c,d)}getNumber(c,h,d){return this.getStorage(h)?.getNumber(c,d)}store(c,h,d,n){if((0,T.isUndefinedOrNull)(h)){this.remove(c,d);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,d,n),this.getStorage(d)?.set(c,h)})}remove(c,h){this.withPausedEmitters(()=>{this.updateKeyTarget(c,h,void 0),this.getStorage(h)?.delete(c)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,h){const d=[],n=this.getKeyTargets(c);for(const o of Object.keys(n))n[o]===h&&d.push(o);return d}updateKeyTarget(c,h,d){const n=this.getKeyTargets(h);typeof d=="number"?n[c]!==d&&(n[c]=d,this.getStorage(h)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[c]=="number"&&(delete n[c],this.getStorage(h)?.set(e.TARGET_KEY,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(c){switch(c){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(c){const h=this.getStorage(c);return h?v(h):Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=b.NONE){this._onWillSaveState.fire({reason:c});const h=this.getStorage(-1),d=this.getStorage(0),n=this.getStorage(1);switch(c){case b.NONE:await D.Promises.settled([h?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await D.Promises.settled([h?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.getStorage(-1)?.items??new Map,h=this.getStorage(0)?.items??new Map,d=this.getStorage(1)?.items??new Map;return u(c,h,d,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(c,h){return this.emitWillSaveState(b.NONE),(0,w.isUserDataProfile)(c)?this.switchToProfile(c,h):this.switchToWorkspace(c,h)}canSwitchProfile(c,h){return!(c.id===h.id||m(h)&&m(c))}switchData(c,h,d,n){this.withPausedEmitters(()=>{if(n)for(const[o,t]of c)h.set(o,t);else{const o=new Set;for(const[t,r]of c)o.add(t),h.get(t)!==r&&this.emitDidChangeValue(d,t);for(const[t]of h.items)o.has(t)||this.emitDidChangeValue(d,t)}})}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function m(S){return S.isDefault||!!S.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=m;class y extends f{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(c=>this.emitDidChangeValue(1,c))),this._register(this.profileStorage.onDidChangeStorage(c=>this.emitDidChangeValue(0,c))),this._register(this.applicationStorage.onDidChangeStorage(c=>this.emitDidChangeValue(-1,c)))}getStorage(c){switch(c){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(c){return!1}}e.InMemoryStorageService=y;async function u(S,c,h,d,n,o){const t=_=>{try{return JSON.parse(_)}catch{return _}},r=new Map,s=new Map;S.forEach((_,F)=>{r.set(F,_),s.set(F,t(_))});const l=new Map,a=new Map;c.forEach((_,F)=>{l.set(F,_),a.set(F,t(_))});const g=new Map,C=new Map;h.forEach((_,F)=>{g.set(F,_),C.set(F,t(_))}),console.group(d!==n?`Storage: Application (path: ${d})`:`Storage: Application & Profile (path: ${d}, default profile)`);const A=[];if(r.forEach((_,F)=>{A.push({key:F,value:_})}),console.table(A),console.groupEnd(),console.log(s),d!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const _=[];l.forEach((F,N)=>{_.push({key:N,value:F})}),console.table(_),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const V=[];g.forEach((_,F)=>{V.push({key:F,value:_})}),console.table(V),console.groupEnd(),console.log(C)}e.logStorage=u}),define(se[117],oe([0,1,3,2,15,29,33,18]),function(Z,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=class extends i.Disposable{constructor(E,p){super(),this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new w(E)),this._register(this.storageManger.onDidChange(v=>this._onDidChangeEnablement.fire({extensions:v,source:"storage"}))),this._register(p.onDidInstallExtensions(v=>v.forEach(({local:f,operation:m})=>{f&&m===4&&this._removeFromDisabledExtensions(f.identifier)})))}async enableExtension(E,p){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:p}),!0):!1}async disableExtension(E,p){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:p}),!0):!1}getDisabledExtensions(){return this._getExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){const p=this.getDisabledExtensions();return p.every(v=>!(0,T.areSameExtensions)(v,E))?(p.push(E),this._setDisabledExtensions(p),!0):!1}_removeFromDisabledExtensions(E){const p=this.getDisabledExtensions();for(let v=0;v<p.length;v++){const f=p[v];if((0,T.areSameExtensions)(f,E))return p.splice(v,1),this._setDisabledExtensions(p),!0}return!1}_setDisabledExtensions(E){this._setExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,p){this.storageManger.set(E,p,0)}};P=ve([G(0,I.IStorageService),G(1,k.IExtensionManagementService)],P),e.GlobalExtensionEnablementService=P;class w extends i.Disposable{constructor(E){super(),this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(p=>this.onDidStorageChange(p)))}get(E,p){let v;return p===0?((0,R.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,p)),v=this.storage[E]):v=this._get(E,p),JSON.parse(v)}set(E,p,v){const f=JSON.stringify(p.map(({id:y,uuid:u})=>({id:y,uuid:u})));this._get(E,v)!==f&&(v===0&&(p.length?this.storage[E]=f:delete this.storage[E]),this._set(E,p.length?f:void 0,v))}onDidStorageChange(E){if(E.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const v=this.get(E.key,E.scope);delete this.storage[E.key];const f=this.get(E.key,E.scope),m=v.filter(u=>!f.some(S=>(0,T.areSameExtensions)(u,S))),y=f.filter(u=>!v.some(S=>(0,T.areSameExtensions)(S,u)));(m.length||y.length)&&this._onDidChange.fire([...m,...y])}}_get(E,p){return this.storageService.get(E,p,"[]")}_set(E,p,v){p?this.storageService.store(E,p,v,1):this.storageService.remove(E,v)}}e.StorageManager=w}),define(se[265],oe([0,1,19,22,11,5,36,15,8,16,13,29,33,70,14,7,25,47,236,18,24]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u,S,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const d=k.isWeb?"web":(0,E.getTargetPlatform)(k.platform,T.arch);var n;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished",M[M.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function o(...M){return String(M.reduce((O,B)=>O|B,0))}var t;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class g{constructor(O=a){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(O,B=this.state.pageSize){return new g({...this.state,pageNumber:O,pageSize:B})}withFilter(O,...B){const z=[...this.state.criteria,...B.length?B.map(Y=>({filterType:O,value:Y})):[{filterType:O}]];return new g({...this.state,criteria:z})}withSortBy(O){return new g({...this.state,sortBy:O})}withSortOrder(O){return new g({...this.state,sortOrder:O})}withFlags(...O){return new g({...this.state,flags:O.reduce((B,z)=>B|z,0)})}withAssetTypes(...O){return new g({...this.state,assetTypes:O})}withSource(O){return new g({...this.state,source:O})}get raw(){const{criteria:O,pageNumber:B,pageSize:z,sortBy:Y,sortOrder:ne,flags:X,assetTypes:te}=this.state;return{filters:[{criteria:O,pageNumber:B,pageSize:z,sortBy:Y,sortOrder:ne}],assetTypes:te,flags:X}}get searchText(){const O=this.state.criteria.filter(B=>B.filterType===t.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function C(M,O){const B=(M||[]).filter(z=>z.statisticName===O)[0];return B?B.value:0}function A(M){const O="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(z=>z.assetType.indexOf(O)===0).reduce((z,Y)=>{const ne=F(M,Y.assetType);return ne&&z.push([Y.assetType.substring(O.length),ne]),z},[])}function V(M){if(M.properties){const O=M.properties.filter(Y=>Y.key===r.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=O.filter(Y=>B.test(Y.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return F(M,r.Repository)}function _(M){return{uri:`${M.fallbackAssetUri}/${r.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${r.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function F(M,O){return M.files.filter(z=>z.assetType===O)[0]?{uri:`${M.assetUri}/${O}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${O}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}:null}function N(M,O){const B=M.properties?M.properties.filter(Y=>Y.key===O):[],z=B.length>0&&B[0].value;return z?z.split(",").map(Y=>(0,p.adoptToGalleryExtensionId)(Y)):[]}function L(M){const O=M.properties?M.properties.filter(B=>B.key===s.Engine):[];return O.length>0&&O[0].value||""}function U(M){const O=M.properties?M.properties.filter(B=>B.key===s.PreRelease):[];return O.length>0&&O[0].value==="true"}function $(M){const O=M.properties?M.properties.filter(z=>z.key===s.LocalizedLanguages):[],B=O.length>0&&O[0].value||"";return B?B.split(","):[]}function H(M){return M.properties?.find(O=>O.key===s.SponsorLink)?.value}function q(M){return M.indexOf("preview")!==-1}function x(M){return M.targetPlatform?(0,E.toTargetPlatform)(M.targetPlatform):"undefined"}function W(M){const O=(0,D.distinct)(M.versions.map(x)),B=!!M.tags?.includes(E.WEB_EXTENSION_TAG),z=O.indexOf("web");return B?z===-1&&O.push("web"):z!==-1&&O.splice(z,1),O}function j(M,O){const B=(0,E.getFallbackTargetPlarforms)(O);for(let z=0;z<M.length;z++){const Y=M[z];if(Y.version===M[z-1]?.version){let ne=z;const X=x(Y);if(X===O)for(;ne>0&&M[ne-1].version===Y.version;)ne--;else if(B.includes(X))for(;ne>0&&M[ne-1].version===Y.version&&x(M[ne-1])!==O;)ne--;ne!==z&&(M.splice(z,1),M.splice(ne,0,Y))}}return M}e.sortExtensionVersions=j;function K(M,O,B){M.telemetryData={index:O,querySource:B}}function ee(M,O,B){const z=M.versions[0],Y={manifest:F(O,r.Manifest),readme:F(O,r.Details),changelog:F(O,r.Changelog),license:F(O,r.License),repository:V(O),download:_(O),icon:F(O,r.Icon),signature:F(O,r.Signature),coreTranslations:A(O)};return{identifier:{id:(0,p.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:O.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(z),description:M.shortDescription||"",installCount:C(M.statistics,"install"),rating:C(M.statistics,"averagerating"),ratingCount:C(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:B,assets:Y,properties:{dependencies:N(O,s.Dependency),extensionPack:N(O,s.ExtensionPack),engine:L(O),localizedLanguages:$(O),targetPlatform:x(O),isPreReleaseVersion:U(O)},hasPreReleaseVersion:U(z),hasReleaseVersion:!0,preview:q(M.flags),isSigned:!!Y.signature}}let ce=class{constructor(O,B,z,Y,ne,X,te,re){this.requestService=B,this.logService=z,this.environmentService=Y,this.telemetryService=ne,this.fileService=X,this.productService=te,this.configurationService=re;const le=te.extensionsGallery,ue=le?.servicePPEUrl&&re.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=ue?le.servicePPEUrl:le?.serviceUrl,this.extensionsGallerySearchUrl=ue?void 0:le?.searchUrl,this.extensionsControlUrl=le?.controlUrl,this.commonHeadersPromise=(0,S.resolveMarketplaceHeaders)(te.version,te,this.environmentService,this.configurationService,this.fileService,O,this.telemetryService)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,B,z){const Y=i.CancellationToken.isCancellationToken(B)?{}:B,ne=i.CancellationToken.isCancellationToken(B)?B:z,X=[],te=[],re=[],le=[];let ue=!0;for(const Ee of O){Ee.uuid?te.push(Ee.uuid):X.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);re.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&le.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),ue=ue&&!!Ee.hasPreRelease&&!Ce}if(!te.length&&!X.length)return[];let Se=new g().withPage(1,O.length);te.length&&(Se=Se.withFilter(t.ExtensionId,...te)),X.length&&(Se=Se.withFilter(t.ExtensionName,...X)),(Y.queryAllVersions||ue)&&(Se=Se.withFlags(Se.flags,n.IncludeVersions)),Y.source&&(Se=Se.withSource(Y.source));const{extensions:we}=await this.queryGalleryExtensions(Se,{targetPlatform:Y.targetPlatform??d,includePreRelease:re,versions:le,compatible:!!Y.compatible},ne);return Y.source&&we.forEach((Ee,Ce)=>K(Ee,Ce,Y.source)),we}async getCompatibleExtension(O,B,z){if((0,E.isNotWebExtensionInWebTargetPlatform)(O.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(O,B,z))return O;const Y=new g().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,O.identifier.uuid),{extensions:ne}=await this.queryGalleryExtensions(Y,{targetPlatform:z,compatible:!0,includePreRelease:B},i.CancellationToken.None);return ne[0]||null}async isExtensionCompatible(O,B,z){if(!(0,E.isTargetPlatformCompatible)(O.properties.targetPlatform,O.allTargetPlatforms,z)||!B&&O.properties.isPreReleaseVersion)return!1;let Y=O.properties.engine;if(!Y){const ne=await this.getManifest(O,i.CancellationToken.None);if(!ne)throw new Error("Manifest was not found");Y=ne.engines.vscode}return(0,v.isEngineValid)(Y,this.productService.version,this.productService.date)}async isValidVersion(O,B,z,Y,ne){if(!(0,E.isTargetPlatformCompatible)(x(O),Y,ne)||B!=="any"&&U(O)!==(B==="prerelease"))return!1;if(z)try{const X=await this.getEngine(O);if(!(0,v.isEngineValid)(X,this.productService.version,this.productService.date))return!1}catch(X){return this.logService.error(`Error while getting the engine for the version ${O.version}.`,(0,R.getErrorMessage)(X)),!1}return!0}async query(O,B){let z=O.text||"";const Y=O.pageSize??50;let ne=new g().withPage(1,Y);z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,Se,we)=>(ne=ne.withFilter(t.Category,we||Se),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,Se,we)=>(ne=ne.withFilter(t.Tag,we||Se),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(ne=ne.withFilter(t.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),ne=ne.withFilter(t.SearchText,z)),ne=ne.withSortBy(0)):O.ids?ne=ne.withFilter(t.ExtensionId,...O.ids):O.names?ne=ne.withFilter(t.ExtensionName,...O.names):ne=ne.withSortBy(4),typeof O.sortBy=="number"&&(ne=ne.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(ne=ne.withSortOrder(O.sortOrder)),O.source&&(ne=ne.withSource(O.source));const X=async(ue,Se)=>{const{extensions:we,total:Ee}=await this.queryGalleryExtensions(ue,{targetPlatform:d,compatible:!1,includePreRelease:!!O.includePreRelease},Se);return we.forEach((Ce,Ae)=>K(Ce,(ue.pageNumber-1)*ue.pageSize+Ae,O.source)),{extensions:we,total:Ee}},{extensions:te,total:re}=await X(ne,B),le=async(ue,Se)=>{if(Se.isCancellationRequested)throw new R.CancellationError;const{extensions:we}=await X(ne.withPage(ue+1),Se);return we};return{firstPage:te,total:re,pageSize:ne.pageSize,getPage:le}}async queryGalleryExtensions(O,B,z){const Y=O.flags;!!(O.flags&n.IncludeLatestVersionOnly)&&!!(O.flags&n.IncludeVersions)&&(O=O.withFlags(O.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(O.flags&n.IncludeLatestVersionOnly)&&!(O.flags&n.IncludeVersions)&&(O=O.withFlags(O.flags,n.IncludeLatestVersionOnly)),B.versions?.length&&(O=O.withFlags(O.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),O=O.withFlags(O.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:ne,total:X}=await this.queryRawGalleryExtensions(O,z);if(!(O.flags&n.IncludeLatestVersionOnly)){const ue=[];for(const Se of ne){const we=await this.toGalleryExtensionWithCriteria(Se,B);we&&ue.push(we)}return{extensions:ue,total:X}}const re=[],le=new Map;for(let ue=0;ue<ne.length;ue++){const Se=ne[ue],we={id:(0,p.getGalleryExtensionId)(Se.publisher.publisherName,Se.extensionName),uuid:Se.extensionId},Ee=(0,I.isBoolean)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(Ae=>(0,p.areSameExtensions)(Ae,we))?.includePreRelease;if(B.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(W(Se),B.targetPlatform))continue;const Ce=await this.toGalleryExtensionWithCriteria(Se,B);!Ce||Ce.properties.isPreReleaseVersion&&(!Ee||!Ce.hasReleaseVersion)||!Ce.properties.isPreReleaseVersion&&Ce.properties.targetPlatform!==B.targetPlatform&&Ce.hasPreReleaseVersion?le.set(Se.extensionId,ue):re.push([ue,Ce])}if(le.size){const ue=new Date().getTime(),Se=new g().withFlags(Y&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,le.size).withFilter(t.ExtensionId,...le.keys()),{extensions:we}=await this.queryGalleryExtensions(Se,B,z);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:le.size});for(const Ee of we){const Ce=le.get(Ee.identifier.uuid);re.push([Ce,Ee])}}return{extensions:re.sort((ue,Se)=>ue[0]-Se[0]).map(([,ue])=>ue),total:X}}async toGalleryExtensionWithCriteria(O,B){const z={id:(0,p.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},Y=B.versions?.find(re=>(0,p.areSameExtensions)(re,z))?.version,ne=(0,I.isBoolean)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(re=>(0,p.areSameExtensions)(re,z))?.includePreRelease,X=W(O),te=j(O.versions,B.targetPlatform);if(B.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(X,B.targetPlatform))return null;for(let re=0;re<te.length;re++){const le=te[re];if(!(Y&&le.version!==Y)){if(await this.isValidVersion(le,ne?"any":"release",B.compatible,X,B.targetPlatform))return ee(O,le,X);if(Y&&le.version===Y)return null}}return Y||B.compatible?null:ee(O,O.versions[0],X)}async queryRawGalleryExtensions(O,B){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,o(n.Unpublished));const z=await this.commonHeadersPromise,Y=JSON.stringify(O.raw),ne={...z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Y.length)},X=new Date().getTime();let te,re,le=0;try{if(te=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&O.criteria.some(Se=>Se.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:Y,headers:ne},B),te.res.statusCode&&te.res.statusCode>=400&&te.res.statusCode<500)return{galleryExtensions:[],total:le};const ue=await(0,u.asJson)(te);if(ue){const Se=ue.results[0],we=Se.extensions,Ee=Se.resultMetadata&&Se.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return le=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:le}}return{galleryExtensions:[],total:le}}catch(ue){throw re=ue,ue}finally{this.telemetryService.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(Y.length),duration:new Date().getTime()-X,success:!!te&&(0,u.isSuccess)(te),responseBodySize:te?.res.headers["Content-Length"],statusCode:te?String(te.res.statusCode):void 0,errorCode:re?(0,R.isCancellationError)(re)?"canceled":(0,R.getErrorMessage)(re).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(O,B,z,Y){if(!this.isEnabled())return;const ne=k.isWeb?this.api(`/itemName/${O}.${B}/version/${z}/statType/${Y==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${O}/extensions/${B}/${z}/stats?statType=${Y}`),X=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",re={...await this.commonHeadersPromise,Accept:X};try{await this.requestService.request({type:"POST",url:ne,headers:re},i.CancellationToken.None)}catch{}}async download(O,B,z){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const Y=(0,p.getGalleryExtensionTelemetryData)(O),ne=new Date().getTime(),X=ue=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Y,duration:ue}),te=z===2?"install":z===3?"update":"",re=te?{uri:`${O.assets.download.uri}${P.URI.parse(O.assets.download.uri).query?"&":"?"}${te}=true`,fallbackUri:`${O.assets.download.fallbackUri}${P.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${te}=true`}:O.assets.download,le=await this.getAsset(re);await this.fileService.writeFile(B,le.stream),X(new Date().getTime()-ne)}async downloadSignatureArchive(O,B){if(!O.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",O.identifier.id);const z=await this.getAsset(O.assets.signature);await this.fileService.writeFile(B,z.stream)}async getReadme(O,B){if(O.assets.readme){const z=await this.getAsset(O.assets.readme,{},B);return await(0,u.asTextOrError)(z)||""}return""}async getManifest(O,B){if(O.assets.manifest){const z=await this.getAsset(O.assets.manifest,{},B),Y=await(0,u.asTextOrError)(z);return Y?JSON.parse(Y):null}return null}async getManifestFromRawExtensionVersion(O,B){const z=F(O,r.Manifest);if(!z)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},ne=await this.getAsset(z,{headers:Y});return await(0,u.asJson)(ne)}async getCoreTranslation(O,B){const z=O.assets.coreTranslations.filter(Y=>Y[0]===B.toUpperCase())[0];if(z){const Y=await this.getAsset(z[1]),ne=await(0,u.asTextOrError)(Y);return ne?JSON.parse(ne):null}return null}async getChangelog(O,B){if(O.assets.changelog){const z=await this.getAsset(O.assets.changelog,{},B);return await(0,u.asTextOrError)(z)||""}return""}async getAllCompatibleVersions(O,B,z){let Y=new g().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);O.identifier.uuid?Y=Y.withFilter(t.ExtensionId,O.identifier.uuid):Y=Y.withFilter(t.ExtensionName,O.identifier.id);const{galleryExtensions:ne}=await this.queryRawGalleryExtensions(Y,i.CancellationToken.None);if(!ne.length)return[];const X=W(ne[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(X,z))return[];const te=[];await Promise.all(ne[0].versions.map(async ue=>{try{await this.isValidVersion(ue,B?"any":"release",!0,X,z)&&te.push(ue)}catch{}}));const re=[],le=new Set;for(const ue of j(te,z))le.has(ue.version)||(le.add(ue.version),re.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:U(ue)}));return re}async getAsset(O,B={},z=i.CancellationToken.None){const Y=await this.commonHeadersPromise,ne={type:"GET"},X={...Y,...B.headers||{}};B={...B,...ne,headers:X};const te=O.uri,re=O.fallbackUri,le={...B,url:te};try{const ue=await this.requestService.request(le,z);if(ue.res.statusCode===200)return ue;const Se=await(0,u.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${Se}`)}catch(ue){if((0,R.isCancellationError)(ue))throw ue;const Se=(0,R.getErrorMessage)(ue);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:te,message:Se});const we={...B,url:re};return this.requestService.request(we,z)}}async getEngine(O){let B=L(O);if(!B){const z=await this.getManifestFromRawExtensionVersion(O,i.CancellationToken.None);if(!z)throw new Error("Manifest was not found");B=z.engines.vscode}return B}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,u.asJson)(O),z=[],Y={};if(B){for(const ne of B.malicious)z.push({id:ne});if(B.migrateToPreRelease)for(const[ne,X]of Object.entries(B.migrateToPreRelease))(!X.engine||(0,v.isEngineValid)(X.engine,this.productService.version,this.productService.date))&&(Y[ne.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(B.deprecated)for(const[ne,X]of Object.entries(B.deprecated))X&&(Y[ne.toLowerCase()]=(0,I.isBoolean)(X)?{}:X)}return{malicious:z,deprecated:Y}}};ce=ve([G(1,u.IRequestService),G(2,m.ILogService),G(3,b.IEnvironmentService),G(4,h.ITelemetryService),G(5,f.IFileService),G(6,y.IProductService),G(7,w.IConfigurationService)],ce);let J=class extends ce{constructor(O,B,z,Y,ne,X,te,re){super(O,B,z,Y,ne,X,te,re)}};J=ve([G(0,c.IStorageService),G(1,u.IRequestService),G(2,m.ILogService),G(3,b.IEnvironmentService),G(4,h.ITelemetryService),G(5,f.IFileService),G(6,y.IProductService),G(7,w.IConfigurationService)],J),e.ExtensionGalleryService=J;let Q=class extends ce{constructor(O,B,z,Y,ne,X,te){super(void 0,O,B,z,Y,ne,X,te)}};Q=ve([G(0,u.IRequestService),G(1,m.ILogService),G(2,b.IEnvironmentService),G(3,h.ITelemetryService),G(4,f.IFileService),G(5,y.IProductService),G(6,w.IConfigurationService)],Q),e.ExtensionGalleryServiceWithNoStorageService=Q}),define(se[78],oe([0,1,4,3,2,18,33,25,19,7,15]),function(Z,e,D,i,R,k,T,I,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class Ze extends R.Disposable{static toKey(f){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const m=E.exec(f);if(m&&m[1])return{id:m[1],version:m[2]}}static async removeOutdatedExtensionVersions(f,m){const y=await f.getInstalled(),u=[];for(const[S,c]of Ze.readAllExtensionsWithKeysForSync(m)){const h=y.find(d=>(0,T.areSameExtensions)(d.identifier,{id:S}))?.manifest.version;for(const d of c)h!==d&&u.push(Ze.toKey({id:S,version:d}))}for(const S of u)m.remove(S,0)}static readAllExtensionsWithKeysForSync(f){const m=new Map,y=f.keys(0,1);for(const u of y){const S=Ze.fromKey(u);if(S){let c=m.get(S.id.toLowerCase());c||m.set(S.id.toLowerCase(),c=[]),c.push(S.version)}}return m}constructor(f,m,y){super(),this.storageService=f,this.productService=m,this.logService=y,this._onDidChangeExtensionStorageToSync=this._register(new i.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Ze.readAllExtensionsWithKeysForSync(f),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const m=Ze.fromKey(f.key);if(m){if(this.storageService.get(f.key,0)===void 0)this.extensionsWithKeysForSync.delete(m.id.toLowerCase());else{let y=this.extensionsWithKeysForSync.get(m.id.toLowerCase());y||this.extensionsWithKeysForSync.set(m.id.toLowerCase(),y=[]),y.push(m.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(f){if((0,b.isString)(f))return f;const m=f.manifest?f.manifest.publisher:f.publisher,y=f.manifest?f.manifest.name:f.name;return(0,T.getExtensionId)(m,y)}getExtensionState(f,m){const y=this.getExtensionId(f),u=this.storageService.get(y,m?0:1);if(u)try{return JSON.parse(u)}catch(S){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${m}): ${S}`)}}setExtensionState(f,m,y){const u=this.getExtensionId(f);m===void 0?this.storageService.remove(u,y?0:1):this.storageService.store(u,JSON.stringify(m),y?0:1,1)}setKeysForSync(f,m){this.storageService.store(Ze.toKey(f),JSON.stringify(m),0,1)}getKeysForSync(f){const m=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],y=this.storageService.get(Ze.toKey(f),0),u=y?JSON.parse(y):void 0;return u&&m?(0,P.distinct)([...u,...m]):u||m}addToMigrationList(f,m){if(f!==m){const y=this.migrationList.filter(u=>!u.includes(f)&&!u.includes(m));y.push([f,m]),this.migrationList=y}}getSourceExtensionToMigrate(f){const m=this.migrationList.find(([,y])=>f===y);return m?m[0]:void 0}get migrationList(){const f=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const m=JSON.parse(f);if(Array.isArray(m))return m}catch{}return[]}set migrationList(f){f.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(f),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};p=ve([G(0,k.IStorageService),G(1,I.IProductService),G(2,w.ILogService)],p),e.ExtensionStorageService=p}),define(se[266],oe([0,1,19,6,3,12,5,36,8,159,13,29,33,226,98,14,7,58,25,47,18,24]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u,S,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const n="extensionTips/promptedExecutableTips",o="extensionTips/lastPromptedMediumImpExeTime";let t=class extends v.ExtensionTipsService{constructor(s,l,a,g,C,A,V,_,F,N){super(V,_,F,N),this.environmentService=s,this.telemetryService=l,this.extensionManagementService=a,this.storageService=g,this.nativeHostService=C,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&Object.entries(_.exeBasedExtensionTips).forEach(([L,U])=>{const $=[],H=[],q=[];Object.entries(U.recommendations).forEach(([x,W])=>{W.important?U.important?$.push({extensionId:x,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):H.push({extensionId:x,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):q.push({extensionId:x,extensionName:W.name,isExtensionPack:!!W.isExtensionPack})}),$.length&&this.highImportanceExecutableTips.set(L,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:$}),H.length&&this.mediumImportanceExecutableTips.set(L,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:H}),q.length&&this.allOtherExecutableTips.set(L,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:q})}),(0,i.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),a=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,a),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,a)}groupImportantTipsByExe(s,l){const a=new Map;s.forEach(_=>a.set(_.extensionId.toLowerCase(),_));const{installed:g,uninstalled:C}=this.groupByInstalled([...a.keys()],l);for(const _ of g){const F=a.get(_);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:F.exeName})}for(const _ of C){const F=a.get(_);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:F.exeName})}const A=this.getPromptedExecutableTips(),V=new Map;for(const _ of C){const F=a.get(_);if(F&&(!A[F.exeName]||!A[F.exeName].includes(F.extensionId))){let N=V.get(F.exeName);N||(N=[],V.set(F.exeName,N)),N.push(F)}}return V}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(a=>{switch(a){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const g=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const g=this._register((0,i.disposableTimeout)(()=>{g.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),l=Date.now()-s,a=7*24*60*60*1e3;if(l<a){const A=this._register((0,i.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},a-l));return}const[g,C]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(C).then(A=>{switch(A){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(C[0].exeName,C);const V=this._register((0,i.disposableTimeout)(()=>{V.dispose(),this.promptMediumImportanceExeBasedTip()},a));break}case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const V=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(V(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const V=this._register((0,i.disposableTimeout)(()=>{V.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(s){const l=await this.extensionManagementService.getInstalled(1),a=s.filter(C=>!C.whenNotInstalled||C.whenNotInstalled.every(A=>l.every(V=>!(0,p.areSameExtensions)(V.identifier,{id:A})))).map(({extensionId:C})=>C.toLowerCase()),g=(0,w.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(a,g,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(o,-1);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(o,s,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(n,-1,"{}"))}addToRecommendedExecutables(s,l){const a=this.getPromptedExecutableTips();a[s]=l.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(n,JSON.stringify(a),-1,0)}groupByInstalled(s,l){const a=[],g=[],C=l.reduce((A,V)=>(A.add(V.identifier.id.toLowerCase()),A),new Set);return s.forEach(A=>{C.has(A.toLowerCase())?a.push(A):g.push(A)}),{installed:a,uninstalled:g}}async getValidExecutableBasedExtensionTips(s){const l=[],a=new Map;for(const g of s.keys()){const C=s.get(g);if(!C||!(0,D.isNonEmptyArray)(C.recommendations))continue;const A=[];T.isWindows?C.windowsPath&&A.push(C.windowsPath.replace("%USERPROFILE%",I.env.USERPROFILE).replace("%ProgramFiles(x86)%",I.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",I.env.ProgramFiles).replace("%APPDATA%",I.env.APPDATA).replace("%WINDIR%",I.env.WINDIR)):(A.push((0,k.join)("/usr/local/bin",g)),A.push((0,k.join)("/usr/bin",g)),A.push((0,k.join)(this.environmentService.userHome.fsPath,g)));for(const V of A){let _=a.get(V);if(_===void 0&&(_=await this.fileService.exists(P.URI.file(V)),a.set(V,_)),_)for(const{extensionId:F,extensionName:N,isExtensionPack:L,whenNotInstalled:U}of C.recommendations)l.push({extensionId:F,extensionName:N,isExtensionPack:L,exeName:g,exeFriendlyName:C.exeFriendlyName,windowsPath:C.windowsPath,whenNotInstalled:U})}}return l}};t=ve([G(0,b.INativeEnvironmentService),G(1,d.ITelemetryService),G(2,E.IExtensionManagementService),G(3,h.IStorageService),G(4,u.INativeHostService),G(5,f.IExtensionRecommendationNotificationService),G(6,m.IFileService),G(7,S.IProductService),G(8,c.IRequestService),G(9,y.ILogService)],t),e.ExtensionTipsService=t}),define(se[267],oe([0,1,6,2,20,69,18,74,21]),function(Z,e,D,i,R,k,T,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class w extends T.AbstractStorageService{constructor(E,p,v,f){super(),this.initialWorkspace=E,this.initialProfiles=p,this.mainProcessService=v,this.environmentService=f,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new i.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new i.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const E=this._register(new I.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),p=this._register(new k.Storage(E));return this._register(p.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v))),p}createProfileStorage(E){this.profileStorageDisposables.clear(),this.profileStorageProfile=E;let p;if((0,T.isProfileUsingDefaultStorage)(E))p=this.applicationStorage;else{const v=this.profileStorageDisposables.add(new I.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),E));p=this.profileStorageDisposables.add(new k.Storage(v))}return this.profileStorageDisposables.add(p.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),p}createWorkspaceStorage(E){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=E?.id;let p;if(E){const v=this.workspaceStorageDisposables.add(new I.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),E));p=this.workspaceStorageDisposables.add(new k.Storage(v)),this.workspaceStorageDisposables.add(p.onDidChangeStorage(f=>this.emitDidChangeValue(1,f)))}return p}async doInitialize(){await D.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(E){switch(E){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(E){switch(E){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,R.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(E,p){if(!this.canSwitchProfile(this.profileStorageProfile,E))return;const v=this.profileStorage,f=v.items;v!==this.applicationStorage&&await v.close(),this.profileStorage=this.createProfileStorage(E),await this.profileStorage.init(),this.switchData(f,this.profileStorage,0,p)}async switchToWorkspace(E,p){const v=this.workspaceStorage,f=v?.items??new Map;await v?.close(),this.workspaceStorage=this.createWorkspaceStorage(E),await this.workspaceStorage.init(),this.switchData(f,this.workspaceStorage,1,p)}hasScope(E){return(0,P.isUserDataProfile)(E)?this.profileStorageProfile.id===E.id:this.workspaceStorageId===E.id}}e.NativeStorageService=w}),define(se[268],oe([0,1,3,2,20,13,57,21]),function(Z,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let P=class extends i.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(b,E,p){super(),this._profiles=[],this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this.channel=E.getChannel("userDataProfiles"),this.profilesHome=(0,R.joinPath)(p.userRoamingDataHome,"profiles"),this._profiles=b.map(v=>(0,I.reviveProfile)(v,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(v=>{const f=v.added.map(u=>(0,I.reviveProfile)(u,this.profilesHome.scheme)),m=v.removed.map(u=>(0,I.reviveProfile)(u,this.profilesHome.scheme)),y=v.updated.map(u=>(0,I.reviveProfile)(u,this.profilesHome.scheme));this._profiles=v.all.map(u=>(0,I.reviveProfile)(u,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:f,removed:m,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(b){this.enabled=b}isEnabled(){return this.enabled}async createNamedProfile(b,E,p){const v=await this.channel.call("createNamedProfile",[b,E,p]);return(0,I.reviveProfile)(v,this.profilesHome.scheme)}async createProfile(b,E,p,v){const f=await this.channel.call("createProfile",[b,E,p,v]);return(0,I.reviveProfile)(f,this.profilesHome.scheme)}async createTransientProfile(b){const E=await this.channel.call("createTransientProfile",[b]);return(0,I.reviveProfile)(E,this.profilesHome.scheme)}async setProfileForWorkspace(b,E){await this.channel.call("setProfileForWorkspace",[b,E])}removeProfile(b){return this.channel.call("removeProfile",[b])}async updateProfile(b,E){const p=await this.channel.call("updateProfile",[b,E]);return(0,I.reviveProfile)(p,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};P=ve([G(1,T.IMainProcessService),G(2,k.IEnvironmentService)],P),e.UserDataProfilesNativeService=P}),define(se[41],oe([0,1,19,6,17,22,3,35,2,27,15,175,16,13,14,7,44,18,24,31,26,21]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u,S,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=void 0;function n(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=n;function o(a,g){return`${(0,w.uppercaseFirstLetter)(a)}${g.isDefault?"":` (${g.name})`}`}e.getSyncResourceLogLabel=o;let t=class extends P.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(g,C,A,V,_,F,N,L,U,$,H,q){super(),this.syncResource=g,this.collection=C,this.fileService=A,this.environmentService=V,this.userDataSyncStoreService=F,this.userDataSyncBackupStoreService=N,this.userDataSyncEnablementService=L,this.telemetryService=U,this.logService=$,this.configurationService=H,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new i.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=o(g.syncResource,g.profile),this.extUri=q.extUri,this.syncFolder=this.extUri.joinPath(V.userDataSyncHome,...(0,h.getPathSegments)(g.profile.isDefault?void 0:g.profile.id,g.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,h.PREVIEW_DIR_NAME),this.lastSyncResource=(0,h.getLastSyncResourceUri)(g.profile.isDefault?void 0:g.profile.id,g.syncResource,V,this.extUri),this.currentMachineIdPromise=(0,y.getServiceMachineId)(V,A,_)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const g=await this.syncPreviewPromise;this.syncPreviewPromise=null;const C=await this.performSync(g.remoteUserData,g.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(C)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const g=await this.getLastSyncUserData();(g?await this.hasRemoteChanged(g):!0)&&this._onDidChangeLocal.fire()}}setStatus(g){this._status!==g&&(this._status=g,this._onDidChangStatus.fire(g))}async sync(g,C={}){await this._sync(g,!0,this.getUserDataSyncConfiguration(),C)}async preview(g,C,A={}){return this._sync(g,!1,C,A)}async apply(g,C={}){try{this.syncHeaders={...C};const A=await this.doApply(g);return this.setStatus(A),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(g,C,A,V){try{if(this.syncHeaders={...V},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const F=await this.getLastSyncUserData(),N=await this.getLatestRemoteUserData(g,F);return _=await this.performSync(N,F,C,A),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(g){const C=this.parseSyncData(g);if(!C)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const A=await this.getLastSyncUserData(),V=await this.getLatestRemoteUserData(null,A),_=await this.isRemoteDataFromCurrentMachine(V),F=await this.generateSyncPreview({ref:V.ref,syncData:C},A,_,this.getUserDataSyncConfiguration(),k.CancellationToken.None),N=[];for(const L of F){const U=await this.getAcceptResult(L,L.remoteResource,void 0,k.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(L,L.previewResource,L.remoteContent,k.CancellationToken.None);N.push([L,{...U,remoteChange:$!==0?$:2}])}await this.applyResult(V,A,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(g){const C=await this.currentMachineIdPromise;return!!g.syncData?.machineId&&g.syncData.machineId===C}async getLatestRemoteUserData(g,C){if(C){const A=g?g[this.resource]:void 0;if(C.ref===A||A===void 0&&C.syncData===null)return C}return this.getRemoteUserData(C)}async performSync(g,C,A,V){if(g.syncData&&g.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new h.UserDataSyncError((0,E.localize)(0,null,this.resource,this.version,g.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(g,C,A,V)}catch(_){if(_ instanceof h.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(g,C,A,V);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),g=await this.getRemoteUserData(null),C=await this.getLastSyncUserData(),this.performSync(g,C,A,V)}throw _}}async doSync(g,C,A,V){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,i.createCancelablePromise)(F=>this.doGenerateSyncResourcePreview(g,C,A,V,F)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:F})=>F==="conflict")?"hasConflicts":A?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(g){return await this.updateSyncResourcePreview(g,async C=>{const A=await this.getMergeResult(C,k.CancellationToken.None);await this.fileService.writeFile(C.previewResource,R.VSBuffer.fromString(A?.content||""));const V=A&&!A.hasConflicts?await this.getAcceptResult(C,C.previewResource,void 0,k.CancellationToken.None):void 0;return C.acceptResult=V,C.mergeState=A.hasConflicts?"conflict":V?"accepted":"preview",C.localChange=V?V.localChange:A.localChange,C.remoteChange=V?V.remoteChange:A.remoteChange,C}),this.syncPreviewPromise}async accept(g,C){return await this.updateSyncResourcePreview(g,async A=>{const V=await this.getAcceptResult(A,g,C,k.CancellationToken.None);return A.acceptResult=V,A.mergeState="accepted",A.localChange=V.localChange,A.remoteChange=V.remoteChange,A}),this.syncPreviewPromise}async discard(g){return await this.updateSyncResourcePreview(g,async C=>{const A=await this.getMergeResult(C,k.CancellationToken.None);return await this.fileService.writeFile(C.previewResource,R.VSBuffer.fromString(A.content||"")),C.acceptResult=void 0,C.mergeState="preview",C.localChange=A.localChange,C.remoteChange=A.remoteChange,C}),this.syncPreviewPromise}async updateSyncResourcePreview(g,C){if(!this.syncPreviewPromise)return;let A=await this.syncPreviewPromise;const V=A.resourcePreviews.findIndex(({localResource:_,remoteResource:F,previewResource:N})=>this.extUri.isEqual(_,g)||this.extUri.isEqual(F,g)||this.extUri.isEqual(N,g));V!==-1&&(this.syncPreviewPromise=(0,i.createCancelablePromise)(async _=>{const F=[...A.resourcePreviews];return F[V]=await C(F[V]),{...A,resourcePreviews:F}}),A=await this.syncPreviewPromise,this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(g){if(!this.syncPreviewPromise)return"idle";const C=await this.syncPreviewPromise;return C.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":C.resourcePreviews.some(({mergeState:A})=>A!=="accepted")?"syncing":(await this.applyResult(C.remoteUserData,C.lastSyncUserData,C.resourcePreviews.map(A=>[A,A.acceptResult]),g),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(g){const C=g.filter(({mergeState:A})=>A==="conflict");(0,D.equals)(this._conflicts,C,(A,V)=>this.extUri.isEqual(A.previewResource,V.previewResource))||(this._conflicts=C,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const g=await this.getLastSyncUserData();return!!g&&g.syncData!==null}async resolvePreviewContent(g){const C=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(C)for(const A of C.resourcePreviews){if(this.extUri.isEqual(A.acceptedResource,g))return A.acceptResult?A.acceptResult.content:null;if(this.extUri.isEqual(A.remoteResource,g))return A.remoteContent;if(this.extUri.isEqual(A.localResource,g))return A.localContent;if(this.extUri.isEqual(A.baseResource,g))return A.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(g,C,A,V,_){const F=await this.isRemoteDataFromCurrentMachine(g),N=await this.generateSyncPreview(g,C,F,V,_),L=[];for(const U of N){const $=U.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(U.localChange===0&&U.remoteChange===0)L.push({...U,acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const H=A?await this.getMergeResult(U,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(U.previewResource,R.VSBuffer.fromString(H?.content||""));const q=H&&!H.hasConflicts?await this.getAcceptResult(U,U.previewResource,void 0,_):void 0;L.push({...U,acceptResult:q,mergeState:H?.hasConflicts?"conflict":q?"accepted":"preview",localChange:q?q.localChange:H?H.localChange:U.localChange,remoteChange:q?q.remoteChange:H?H.remoteChange:U.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:g,lastSyncUserData:C,resourcePreviews:L,isLastSyncFromCurrentMachine:F}}async getLastSyncUserData(){try{const g=await this.fileService.readFile(this.lastSyncResource),C=JSON.parse(g.value.toString()),A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=C.version&&A&&C.version!==A,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${C.version} is not compatible with current sync state version ${A}.`),await this.resetLocal(),null;const V=C;if(V.content===null)return{ref:C.ref,syncData:null};const _=JSON.parse(V.content);if(n(_))return{...C,syncData:_,content:void 0}}catch(g){g instanceof f.FileOperationError&&g.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Not synced yet. Last sync resource does not exist.`):this.logService.error(g)}return null}async updateLastSyncUserData(g,C={}){if(C.ref||C.content||C.version)throw new Error("Cannot have core properties as additional");const A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),V={ref:g.ref,content:g.syncData?JSON.stringify(g.syncData):null,version:A,...C};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(V)))}async getRemoteUserData(g){const{ref:C,content:A}=await this.getUserData(g);let V=null;return A!==null&&(V=this.parseSyncData(A)),{ref:C,syncData:V}}parseSyncData(g){try{const C=JSON.parse(g);if(n(C))return C}catch(C){this.logService.error(C)}throw new h.UserDataSyncError((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(g){const C=g?{ref:g.ref,content:g.syncData?JSON.stringify(g.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,C,this.collection,this.syncHeaders)}async updateRemoteUserData(g,C){const A=await this.currentMachineIdPromise,V={version:this.version,machineId:A,content:g};try{return C=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(V),C,this.collection,this.syncHeaders),{ref:C,syncData:V}}catch(_){throw _ instanceof h.UserDataSyncError&&_.code==="TooLarge"&&(_=new h.UserDataSyncError(_.message,_.code,this.resource)),_}}async backupLocal(g){const C={version:this.version,content:g};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(C))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=ve([G(2,f.IFileService),G(3,v.IEnvironmentService),G(4,u.IStorageService),G(5,h.IUserDataSyncStoreService),G(6,h.IUserDataSyncBackupStoreService),G(7,h.IUserDataSyncEnablementService),G(8,S.ITelemetryService),G(9,h.IUserDataSyncLogService),G(10,p.IConfigurationService),G(11,c.IUriIdentityService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(g,C,A,V,_,F,N,L,U,$,H,q,x){super(C,A,V,_,F,N,L,U,$,H,q,x),this.file=g,this._register(this.fileService.watch(this.extUri.dirname(g))),this._register(this.fileService.onDidFilesChange(W=>this.onFileChanges(W)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(g,C,A){try{C?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(g),A?void 0:C):await this.fileService.createFile(this.file,R.VSBuffer.fromString(g),{overwrite:A})}catch(V){throw V instanceof f.FileOperationError&&V.fileOperationResult===1||V instanceof f.FileOperationError&&V.fileOperationResult===3?new h.UserDataSyncError(V.message,"LocalPreconditionFailed"):V}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(g){if(!(g instanceof f.FileOperationError&&g.fileOperationResult===1))throw g}}onFileChanges(g){!g.contains(this.file)||this.triggerLocalChange()}};r=ve([G(3,f.IFileService),G(4,v.IEnvironmentService),G(5,u.IStorageService),G(6,h.IUserDataSyncStoreService),G(7,h.IUserDataSyncBackupStoreService),G(8,h.IUserDataSyncEnablementService),G(9,S.ITelemetryService),G(10,h.IUserDataSyncLogService),G(11,p.IConfigurationService),G(12,c.IUriIdentityService)],r),e.AbstractFileSynchroniser=r;let s=class extends r{constructor(g,C,A,V,_,F,N,L,U,$,H,q,x,W){super(g,C,A,V,_,F,N,L,U,$,H,x,W),this.userDataSyncUtilService=q,this._formattingOptions=void 0}hasErrors(g,C){const A=[],V=(0,I.parse)(g,A,{allowEmptyContent:!0,allowTrailingComma:!0});return A.length>0||!(0,b.isUndefined)(V)&&C!==Array.isArray(V)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};s=ve([G(3,f.IFileService),G(4,v.IEnvironmentService),G(5,u.IStorageService),G(6,h.IUserDataSyncStoreService),G(7,h.IUserDataSyncBackupStoreService),G(8,h.IUserDataSyncEnablementService),G(9,S.ITelemetryService),G(10,h.IUserDataSyncLogService),G(11,h.IUserDataSyncUtilService),G(12,p.IConfigurationService),G(13,c.IUriIdentityService)],s),e.AbstractJsonFileSynchroniser=s;let l=class{constructor(g,C,A,V,_,F){this.resource=g,this.userDataProfilesService=C,this.environmentService=A,this.logService=V,this.fileService=_,this.extUri=F.extUri,this.lastSyncResource=(0,h.getLastSyncResourceUri)(void 0,this.resource,A,this.extUri)}async initialize({ref:g,content:C}){if(!C){this.logService.info("Remote content does not exist.",this.resource);return}const A=this.parseSyncData(C);if(!!A)try{await this.doInitialize({ref:g,syncData:A})}catch(V){this.logService.error(V)}}parseSyncData(g){try{const C=JSON.parse(g);if(n(C))return C}catch(C){this.logService.error(C)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(g,C={}){const A={ref:g.ref,content:g.syncData?JSON.stringify(g.syncData):null,...C};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(A)))}};l=ve([G(1,d.IUserDataProfilesService),G(2,v.IEnvironmentService),G(3,m.ILogService),G(4,f.IFileService),G(5,c.IUriIdentityService)],l),e.AbstractInitializer=l}),define(se[118],oe([0,1,19,17,3,35,5,15,176,16,13,14,18,24,31,21,41,253,26]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function c(n,o,t){try{const r=JSON.parse(n);if(!o)return(0,I.isUndefined)(r.all)?null:r.all;switch(T.OS){case 2:return(0,I.isUndefined)(r.mac)?null:r.mac;case 3:return(0,I.isUndefined)(r.linux)?null:r.linux;case 1:return(0,I.isUndefined)(r.windows)?null:r.windows}}catch(r){return t.error(r),null}}e.getKeybindingsContentFromSyncContent=c;let h=class extends y.AbstractJsonFileSynchroniser{constructor(o,t,r,s,l,a,g,C,A,V,_,F,N){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},t,C,A,V,r,s,g,F,l,_,a,N),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(a.onDidChangeConfiguration,L=>L.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,t,r,s){const l=o.syncData?c(o.syncData.content,s.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&r?o:t;const a=t?this.getKeybindingsContentFromLastSyncUserData(t):null,g=await this.getLocalFileContent(),C=await this.getFormattingOptions();let A=null,V=!1,_=!1,F=!1;if(l){let U=g?g.value.toString():"[]";if(U=U||"[]",this.hasErrors(U,!0))throw new S.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==U||a!==l){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const $=await(0,u.merge)(U,l,a,C,this.userDataSyncUtilService);$.hasChanges&&(A=$.mergeContent,F=$.hasConflicts,V=F||$.mergeContent!==U,_=F||$.mergeContent!==l)}}else g&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),A=g.value.toString(),_=!0);const N={content:F?a:A,localChange:V?g?2:1:0,remoteChange:_?2:0,hasConflicts:F},L=g?g.value.toString():null;return[{fileContent:g,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:L,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:l,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const t=this.getKeybindingsContentFromLastSyncUserData(o);if(t===null)return!0;const r=await this.getLocalFileContent(),s=r?r.value.toString():"",l=await this.getFormattingOptions(),a=await(0,u.merge)(s||"[]",t,t,l,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==t}async getMergeResult(o,t){return o.previewResult}async getAcceptResult(o,t,r,s){if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,r,s){const{fileContent:l}=r[0][0];let{content:a,localChange:g,remoteChange:C}=r[0][1];if(g===0&&C===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new S.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(g!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),l&&await this.backupLocal(this.toSyncContent(l.value.toString())),await this.updateLocalFileContent(a||"[]",l,s),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),C!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const A=this.toSyncContent(a||"[]",o.syncData?.content);o=await this.updateRemoteUserData(A,s?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=(0,k.parse)(o.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)?this.resolvePreviewContent(o):null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:c(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,t){let r={};try{r=JSON.parse(t||"{}")}catch(s){this.logService.error(s)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=o,T.OS){case 2:r.mac=o;break;case 3:r.linux=o;break;case 1:r.windows=o;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};h=ve([G(2,S.IUserDataSyncStoreService),G(3,S.IUserDataSyncBackupStoreService),G(4,S.IUserDataSyncLogService),G(5,w.IConfigurationService),G(6,S.IUserDataSyncEnablementService),G(7,E.IFileService),G(8,b.IEnvironmentService),G(9,p.IStorageService),G(10,S.IUserDataSyncUtilService),G(11,v.ITelemetryService),G(12,f.IUriIdentityService)],h),e.KeybindingsSynchroniser=h;let d=class extends y.AbstractInitializer{constructor(o,t,r,s,l){super("keybindings",t,r,s,o,l)}async doInitialize(o){const t=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,i.VSBuffer.fromString(t)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,k.parse)(o.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return c(o,!0,this.logService)}catch(t){return this.logService.error(t),null}}};d=ve([G(0,E.IFileService),G(1,m.IUserDataProfilesService),G(2,b.IEnvironmentService),G(3,S.IUserDataSyncLogService),G(4,f.IUriIdentityService)],d),e.KeybindingsInitializer=d}),define(se[119],oe([0,1,17,3,177,16,73,13,29,14,18,24,31,21,41,61,257,26]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function S(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function c(n){const o=JSON.parse(n);return S(o)?o:{settings:n}}e.parseSettingsSyncContent=c;let h=class extends f.AbstractJsonFileSynchroniser{constructor(o,t,r,s,l,a,g,C,A,V,_,F,N,L){super(o.settingsResource,{syncResource:"settings",profile:o},t,r,s,l,a,g,_,F,C,A,V,L),this.extensionManagementService=N,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(o){const t=await this.getLastSyncUserData(),r=await this.getLatestRemoteUserData(o,t),s=this.getSettingsSyncContent(r),l=new T.ConfigurationModelParser(u.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&l.parse(s.settings),l.configurationModel.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(o,t,r){const s=await this.getLocalFileContent(),l=await this.getFormattingOptions(),a=this.getSettingsSyncContent(o);t=t===null&&r?o:t;const g=t?this.getSettingsSyncContent(t):null,C=await this.getIgnoredSettings();let A=null,V=!1,_=!1,F=!1;if(a){let $=s?s.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const H=(0,y.merge)($,a.settings,g?g.settings:null,C,[],l);A=H.localContent||H.remoteContent,V=H.localContent!==null,_=H.remoteContent!==null,F=H.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=s.value.toString().trim()||"{}",this.validateContent(A),_=!0);const N=s?s.value.toString():null,L=g?.settings??null,U={content:F?L:A,localChange:V?2:0,remoteChange:_?2:0,hasConflicts:F};return[{fileContent:s,baseResource:this.baseResource,baseContent:L,localResource:this.localResource,localContent:N,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const t=this.getSettingsSyncContent(o);if(t===null)return!0;const r=await this.getLocalFileContent(),s=r?r.value.toString().trim():"",l=await this.getIgnoredSettings(),a=await this.getFormattingOptions();return(0,y.merge)(s||"{}",t.settings,t.settings,l,[],a).remoteContent!==null}async getMergeResult(o,t){const r=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...o.previewResult,content:o.previewResult.content?(0,y.updateIgnoredSettings)(o.previewResult.content,"{}",s,r):null}}async getAcceptResult(o,t,r,s){const l=await this.getFormattingOptions(),a=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?(0,y.updateIgnoredSettings)(o.fileContent.value.toString(),"{}",a,l):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent!==null?(0,y.updateIgnoredSettings)(o.remoteContent,o.fileContent?o.fileContent.value.toString():"{}",a,l):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:r!==null?(0,y.updateIgnoredSettings)(r,o.fileContent?o.fileContent.value.toString():"{}",a,l):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,r,s){const{fileContent:l}=r[0][0];let{content:a,localChange:g,remoteChange:C}=r[0][1];if(g===0&&C===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.validateContent(a),g!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),l&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(l.value.toString()))),await this.updateLocalFileContent(a,l,s),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),C!==0){const A=await this.getFormattingOptions(),V=this.getSettingsSyncContent(o),_=await this.getIgnoredSettings(a);a=(0,y.updateIgnoredSettings)(a,V?V.settings:"{}",_,A),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),o=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(a)),s?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(o),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=await this.getFormattingOptions(),r=(0,m.edit)(o.value.toString(),[u.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,y.isEmpty)(r)}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)||this.extUri.isEqual(this.baseResource,o)?this.resolvePreviewContent(o):null}async resolvePreviewContent(o){let t=await super.resolvePreviewContent(o);if(t){const r=await this.getFormattingOptions(),s=await this.getIgnoredSettings();t=(0,y.updateIgnoredSettings)(t,"{}",s,r)}return t}getSettingsSyncContent(o){return o.syncData?this.parseSettingsSyncContent(o.syncData.content):null}parseSettingsSyncContent(o){try{return c(o)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(o){return{settings:o}}async getIgnoredSettings(o){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const r=i.Event.any(i.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:l})=>!!l)),i.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{r.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,y.getIgnoredSettings)(t,this.configurationService,o)}validateContent(o){if(this.hasErrors(o,!1))throw new u.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource)}};h=ve([G(2,w.IFileService),G(3,I.IEnvironmentService),G(4,b.IStorageService),G(5,u.IUserDataSyncStoreService),G(6,u.IUserDataSyncBackupStoreService),G(7,u.IUserDataSyncLogService),G(8,u.IUserDataSyncUtilService),G(9,k.IConfigurationService),G(10,u.IUserDataSyncEnablementService),G(11,E.ITelemetryService),G(12,P.IExtensionManagementService),G(13,p.IUriIdentityService)],h),e.SettingsSynchroniser=h;let d=class extends f.AbstractInitializer{constructor(o,t,r,s,l){super("settings",t,r,s,o,l)}async doInitialize(o){const t=o.syncData?this.parseSettingsSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,D.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,y.isEmpty)(o.value.toString().trim())}catch(o){return o.fileOperationResult===1}}parseSettingsSyncContent(o){try{return c(o)}catch(t){this.logService.error(t)}return null}};d=ve([G(0,w.IFileService),G(1,v.IUserDataProfilesService),G(2,I.IEnvironmentService),G(3,u.IUserDataSyncLogService),G(4,p.IUriIdentityService)],d),e.SettingsInitializer=d}),define(se[120],oe([0,1,17,3,32,16,13,14,18,24,31,21,41,254,26]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function m(S){return JSON.parse(S.content)}e.parseSnippets=m;let y=class extends p.AbstractSynchroniser{constructor(c,h,d,n,o,t,r,s,l,a,g,C){super({syncResource:"snippets",profile:c},h,n,d,o,t,r,a,g,s,l,C),this.version=1,this.snippetsFolder=c.snippetsHome,this._register(this.fileService.watch(d.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(i.Event.filter(this.fileService.onDidFilesChange,A=>A.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(c,h,d){const n=await this.getSnippetsFileContents(),o=this.toSnippetsContents(n),t=c.syncData?this.parseSnippets(c.syncData):null;h=h===null&&d?c:h;const r=h&&h.syncData?this.parseSnippets(h.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,v.merge)(o,t,r);return this.getResourcePreviews(s,n,t||{},r||{})}async hasRemoteChanged(c){const h=c.syncData?this.parseSnippets(c.syncData):null;if(h===null)return!0;const d=await this.getSnippetsFileContents(),n=this.toSnippetsContents(d),o=(0,v.merge)(n,h,h);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async getMergeResult(c,h){return c.previewResult}async getAcceptResult(c,h,d,n){if(this.extUri.isEqualOrParent(h,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:c.fileContent?c.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(h,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:c.remoteContent,localChange:c.remoteContent!==null?c.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(h,this.syncPreviewFolder))return d===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:d,localChange:d===null?c.fileContent!==null?3:0:2,remoteChange:d===null?c.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async applyResult(c,h,d,n){const o=d.map(([t,r])=>({...t,acceptResult:r}));o.every(({localChange:t,remoteChange:r})=>t===0&&r===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:t})=>t!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,n)),o.some(({remoteChange:t})=>t!==0)&&(c=await this.updateRemoteSnippets(o,c,n)),h?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(c),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:t}of o)try{await this.fileService.del(t)}catch{}}getResourcePreviews(c,h,d,n){const o=new Map;for(const t of Object.keys(c.local.added)){const r={content:c.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(c.local.updated)){const r={content:c.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},s=h[t]?h[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of c.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=h[t]?h[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(c.remote.added)){const r={content:c.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},s=h[t]?h[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(c.remote.updated)){const r={content:c.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},s=h[t]?h[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of c.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of c.conflicts){const r={content:n[t]??null,hasConflicts:!0,localChange:h[t]?2:1,remoteChange:d[t]?2:1},s=h[t]?h[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t]||null,localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(h))if(!o.has(t)){const r={content:h[t]?h[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=h[t]?h[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t]||null,localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(c){return this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(c):null}async hasLocalData(){try{const c=await this.getSnippetsFileContents();if(Object.keys(c).length)return!0}catch{}return!1}async updateLocalBackup(c){const h={};for(const d of c)d.fileContent&&(h[this.extUri.basename(d.localResource)]=d.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(h)))}async updateLocalSnippets(c,h){for(const{fileContent:d,acceptResult:n,localResource:o,remoteResource:t,localChange:r}of c)if(r!==0){const s=t?this.extUri.basename(t):this.extUri.basename(o),l=this.extUri.joinPath(this.snippetsFolder,s);r===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(l)),await this.fileService.del(l),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(l))):r===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(l)),await this.fileService.createFile(l,D.VSBuffer.fromString(n.content),{overwrite:h}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(l))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(l)),await this.fileService.writeFile(l,D.VSBuffer.fromString(n.content),h?void 0:d),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(l)))}}async updateRemoteSnippets(c,h,d){const n=h.syncData?this.parseSnippets(h.syncData):{},o=(0,R.deepClone)(n);for(const{acceptResult:t,localResource:r,remoteResource:s,remoteChange:l}of c)if(l!==0){const a=r?this.extUri.basename(r):this.extUri.basename(s);l===3?delete o[a]:o[a]=t.content}return(0,v.areSame)(n,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),h=await this.updateRemoteUserData(JSON.stringify(o),d?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),h}parseSnippets(c){return m(c)}toSnippetsContents(c){const h={};for(const d of Object.keys(c))h[d]=c[d].value.toString();return h}async getSnippetsFileContents(){const c={};let h;try{h=await this.fileService.resolve(this.snippetsFolder)}catch(d){if(d instanceof I.FileOperationError&&d.fileOperationResult===1)return c;throw d}for(const d of h.children||[]){const n=d.resource,o=this.extUri.extname(n);if(o===".json"||o===".code-snippets"){const t=this.extUri.relativePath(this.snippetsFolder,n),r=await this.fileService.readFile(n);c[t]=r}}return c}};y=ve([G(2,T.IEnvironmentService),G(3,I.IFileService),G(4,P.IStorageService),G(5,f.IUserDataSyncStoreService),G(6,f.IUserDataSyncBackupStoreService),G(7,f.IUserDataSyncLogService),G(8,k.IConfigurationService),G(9,f.IUserDataSyncEnablementService),G(10,w.ITelemetryService),G(11,b.IUriIdentityService)],y),e.SnippetsSynchroniser=y;let u=class extends p.AbstractInitializer{constructor(c,h,d,n,o){super("snippets",h,d,n,c,o)}async doInitialize(c){const h=c.syncData?JSON.parse(c.syncData.content):null;if(!h){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(h)){const o=h[n];if(o){const t=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,n);await this.fileService.createFile(t,D.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(t))}}await this.updateLastSyncUserData(c)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(c){return c.fileOperationResult===1}}};u=ve([G(0,I.IFileService),G(1,E.IUserDataProfilesService),G(2,T.IEnvironmentService),G(3,f.IUserDataSyncLogService),G(4,b.IUriIdentityService)],u),e.SnippetsInitializer=u}),define(se[121],oe([0,1,17,16,13,14,18,24,31,21,41,26]),function(Z,e,D,i,R,k,T,I,P,w,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function p(y,u){try{return JSON.parse(y).tasks??null}catch(S){return u.error(S),null}}e.getTasksContentFromSyncContent=p;let v=class extends b.AbstractFileSynchroniser{constructor(u,S,c,h,d,n,o,t,r,s,l,a){super(u.tasksResource,{syncResource:"tasks",profile:u},S,t,r,s,c,h,o,l,d,n,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(u,S,c,h){const d=u.syncData?p(u.syncData.content,this.logService):null;S=S===null&&c?u:S;const n=S?.syncData?p(S.syncData.content,this.logService):null,o=await this.getLocalFileContent();let t=null,r=!1,s=!1,l=!1;if(u.syncData){const C=o?o.value.toString():null;if(!n||n!==C||n!==d){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const A=m(C,d,n);t=A.content,l=A.hasConflicts,r=A.hasLocalChanged,s=A.hasRemoteChanged}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=o.value.toString(),s=!0);const a={content:l?n:t,localChange:r?o?2:1:0,remoteChange:s?2:0,hasConflicts:l},g=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:n,localResource:this.localResource,localContent:g,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:d,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const S=u?.syncData?p(u.syncData.content,this.logService):null;if(S===null)return!0;const c=await this.getLocalFileContent(),h=c?c.value.toString():null,d=m(h,S,S);return d.hasLocalChanged||d.hasRemoteChanged}async getMergeResult(u,S){return u.previewResult}async getAcceptResult(u,S,c,h){if(this.extUri.isEqual(S,this.localResource))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(S,this.remoteResource))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(S,this.previewResource))return c===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:c,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${S.toString()}`)}async applyResult(u,S,c,h){const{fileContent:d}=c[0][0],{content:n,localChange:o,remoteChange:t}=c[0][1];if(o===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),d&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(d.value.toString()))),n?await this.updateLocalFileContent(n,d,h):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const r=JSON.stringify(this.toTasksSyncContent(n));u=await this.updateRemoteUserData(r,h?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}S?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(u){return this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)?this.resolvePreviewContent(u):null}toTasksSyncContent(u){return u?{tasks:u}:{}}};v=ve([G(2,E.IUserDataSyncStoreService),G(3,E.IUserDataSyncBackupStoreService),G(4,E.IUserDataSyncLogService),G(5,i.IConfigurationService),G(6,E.IUserDataSyncEnablementService),G(7,k.IFileService),G(8,R.IEnvironmentService),G(9,T.IStorageService),G(10,I.ITelemetryService),G(11,P.IUriIdentityService)],v),e.TasksSynchroniser=v;let f=class extends b.AbstractInitializer{constructor(u,S,c,h,d){super("tasks",S,c,h,u,d),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(u){const S=u.syncData?p(u.syncData.content,this.logService):null;if(!S){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,D.VSBuffer.fromString(S)),await this.updateLastSyncUserData(u)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};f=ve([G(0,k.IFileService),G(1,w.IUserDataProfilesService),G(2,R.IEnvironmentService),G(3,E.IUserDataSyncLogService),G(4,P.IUriIdentityService)],f),e.TasksInitializer=f;function m(y,u,S){if(y===null&&u===null&&S===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(y===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const c=S!==y,h=S!==u;return!c&&!h?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:c&&!h?{content:y,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:h&&!c?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:y,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(se[122],oe([0,1,42,16,13,14,18,24,31,21,41,255,26]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let v=class extends b.AbstractSynchroniser{constructor(u,S,c,h,d,n,o,t,r,s,l,a,g){super({syncResource:"profiles",profile:u},S,h,d,n,o,t,l,a,r,s,g),this.userDataProfilesService=c,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?m(u.syncData):null}async getRemoteSyncedProfiles(u){const S=await this.getLastSyncUserData(),c=await this.getLatestRemoteUserData(u,S);return c?.syncData?m(c.syncData):null}async generateSyncPreview(u,S,c){const h=u.syncData?m(u.syncData):null,d=S?.syncData?m(S.syncData):null,n=this.getLocalUserDataProfiles(),{local:o,remote:t}=(0,E.merge)(n,h,d,[]),r={local:o,remote:t,content:d?this.stringifyRemoteProfiles(d):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:t!==null?2:0},s=f(n,!1);return[{baseResource:this.baseResource,baseContent:d?this.stringifyRemoteProfiles(d):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:h?this.stringifyRemoteProfiles(h):null,remoteProfiles:h,previewResource:this.previewResource,previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const S=u?.syncData?m(u.syncData):null,c=this.getLocalUserDataProfiles(),{remote:h}=(0,E.merge)(c,S,S,[]);return!!h?.added.length||!!h?.removed.length||!!h?.updated.length}async getMergeResult(u,S){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,S,c,h){if(this.extUri.isEqual(S,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(S,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(S,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${S.toString()}`)}async acceptLocal(u){const S=this.getLocalUserDataProfiles(),c=(0,E.merge)(S,null,null,[]),{local:h,remote:d}=c;return{content:u.localContent,local:h,remote:d,localChange:h.added.length>0||h.removed.length>0||h.updated.length>0?2:0,remoteChange:d!==null?2:0}}async acceptRemote(u){const S=u.remoteContent?JSON.parse(u.remoteContent):null,c=[],h=[];for(const d of this.getLocalUserDataProfiles()){const n=S?.find(o=>o.id===d.id);n&&(c.push({id:d.id,name:d.name,collection:n.collection}),h.push(d))}if(S!==null){const d=(0,E.merge)(h,S,c,[]),{local:n,remote:o}=d;return{content:u.remoteContent,local:n,remote:o,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,S,c,h){const{local:d,remote:n,localChange:o,remoteChange:t}=c[0][1];if(o===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`),o!==0){await this.backupLocal(f(this.getLocalUserDataProfiles(),!1));const r=[];for(const s of d.added)r.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${s.name}' profile...`),await this.userDataProfilesService.createProfile(s.id,s.name,{shortName:s.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${s.name}'.`)})());for(const s of d.removed)r.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${s.name}' profile...`),await this.userDataProfilesService.removeProfile(s),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${s.name}'.`)})());for(const s of d.updated){const l=this.userDataProfilesService.profiles.find(a=>a.id===s.id);l?r.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${s.name}' profile...`),await this.userDataProfilesService.updateProfile(l,{name:s.name,shortName:s.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${s.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${s.id}' to update.`)}await Promise.all(r)}if(t!==0){const r=c[0][0].remoteProfiles||[];this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);for(const s of n?.added||[]){const l=await this.userDataSyncStoreService.createCollection(this.syncHeaders);r.push({id:s.id,name:s.name,collection:l,shortName:s.shortName})}for(const s of n?.removed||[])r.splice(r.findIndex(({id:l})=>s.id===l),1);for(const s of n?.updated||[]){const l=r.find(({id:a})=>s.id===a);l&&r.splice(r.indexOf(l),1,{id:s.id,name:s.name,collection:l.collection,shortName:s.shortName})}u=await this.updateRemoteUserData(this.stringifyRemoteProfiles(r),h?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${n?.added.length?` Added: ${JSON.stringify(n.added.map(s=>s.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(s=>s.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(s=>s.name))}.`:""}`);for(const s of n?.removed||[])await this.userDataSyncStoreService.deleteCollection(s.collection,this.syncHeaders)}S?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(u){if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)){const S=await this.resolvePreviewContent(u);return S&&(0,D.toFormattedString)(JSON.parse(S),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(u=>!u.isDefault&&!u.isTransient)}stringifyRemoteProfiles(u){return JSON.stringify([...u].sort((S,c)=>S.name.localeCompare(c.name)))}};v=ve([G(2,w.IUserDataProfilesService),G(3,k.IFileService),G(4,R.IEnvironmentService),G(5,T.IStorageService),G(6,p.IUserDataSyncStoreService),G(7,p.IUserDataSyncBackupStoreService),G(8,p.IUserDataSyncLogService),G(9,i.IConfigurationService),G(10,p.IUserDataSyncEnablementService),G(11,I.ITelemetryService),G(12,P.IUriIdentityService)],v),e.UserDataProfilesManifestSynchroniser=v;function f(y,u){const S=[...y].sort((c,h)=>c.name.localeCompare(h.name)).map(c=>({id:c.id,name:c.name}));return u?(0,D.toFormattedString)(S,{}):JSON.stringify(S)}e.stringifyLocalProfiles=f;function m(y){return JSON.parse(y.content)}e.parseUserDataProfilesManifest=m}),define(se[269],oe([0,1,6,17,65,2,20,16,13,14,21,26]),function(Z,e,D,i,R,k,T,I,P,w,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let p=class extends k.Disposable{constructor(f,m,y,u,S){super(),this.environmentService=f,this.fileService=m,this.configurationService=y,this.logService=u,this.userDataProfilesService=S;for(const c of this.userDataProfilesService.profiles)for(const h of E.ALL_SYNC_RESOURCES)this.cleanUpBackup(this.getResourceBackupHome(c,h))}async getAllRefs(f,m){const y=this.getResourceBackupHome(f,m),u=await this.fileService.resolve(y);return u.children?u.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort().reverse().map(c=>({ref:c.name,created:this.getCreationTime(c)})):[]}async resolveContent(f,m,y){const u=this.getResourceBackupHome(f,m),S=(0,T.joinPath)(u,y);try{return(await this.fileService.readFile(S)).value.toString()}catch(c){return this.logService.error(c),null}}async backup(f,m,y){const u=this.getResourceBackupHome(f,m),S=(0,T.joinPath)(u,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(S,i.VSBuffer.fromString(y))}catch(c){this.logService.error(c)}try{this.cleanUpBackup(u)}catch{}}getResourceBackupHome(f,m){return(0,T.joinPath)(this.environmentService.userDataSyncHome,...f.isDefault?[m]:[f.id,m])}async cleanUpBackup(f){try{try{if(!await this.fileService.exists(f))return}catch{return}const m=await this.fileService.resolve(f);if(m.children){const y=m.children.filter(h=>h.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(h.name)).sort(),u=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let S=y.filter(h=>Date.now()-this.getCreationTime(h)>u);const c=y.length-S.length;c<10&&(S=S.slice(10-c)),await D.Promises.settled(S.map(async h=>{this.logService.info("Deleting from backup",h.resource.path),await this.fileService.del(h.resource)}))}}catch(m){this.logService.error(m)}}getCreationTime(f){return f.ctime||new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};p=ve([G(0,P.IEnvironmentService),G(1,w.IFileService),G(2,I.IConfigurationService),G(3,E.IUserDataSyncLogService),G(4,b.IUserDataProfilesService)],p),e.UserDataSyncBackupStoreService=p}),define(se[270],oe([0,1,3,2,5,13,18,24,26]),function(Z,e,D,i,R,k,T,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const w="sync.enable";let b=class extends i.Disposable{constructor(p,v,f,m){super(),this.storageService=p,this.telemetryService=v,this.environmentService=f,this.userDataSyncStoreManagementService=m,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(p.onDidChangeValue(y=>this.onDidStorageChange(y)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(w,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(w,{enabled:p}),this.storageService.store(w,p,-1,1))}isResourceEnabled(p){return this.storageService.getBoolean((0,P.getEnablementKey)(p),-1,!0)}setResourceEnablement(p,v){if(this.isResourceEnabled(p)!==v){const f=(0,P.getEnablementKey)(p);this.storeResourceEnablement(f,v)}}getResourceSyncStateVersion(p){}storeResourceEnablement(p,v){this.storageService.store(p,v,-1,R.isWeb?0:1)}onDidStorageChange(p){if(p.scope!==-1)return;if(w===p.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const v=P.ALL_SYNC_RESOURCES.filter(f=>(0,P.getEnablementKey)(f)===p.key)[0];if(v){this._onDidChangeResourceEnablement.fire([v,this.isResourceEnabled(v)]);return}}};b=ve([G(0,T.IStorageService),G(1,I.ITelemetryService),G(2,k.IEnvironmentService),G(3,P.IUserDataSyncStoreManagementService)],b),e.UserDataSyncEnablementService=b}),define(se[79],oe([0,1,3,2,5,27,180,13,14,4,25,44,18,26]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,w.createDecorator)("IUserDataSyncMachinesService");const f="sync.currentMachineName",m="Safari",y="Chrome",u="Edge",S="Firefox",c="Android";function h(o){switch(o){case m:case y:case u:case S:case c:case(0,R.PlatformToString)(0):return!0}return!1}e.isWebPlatform=h;function d(){return R.isSafari?m:R.isChrome?y:R.isEdge?u:R.isFirefox?S:R.isAndroid?c:(0,R.PlatformToString)(R.isWeb?0:R.platform)}let n=class st extends i.Disposable{constructor(t,r,s,l,a,g){super(),this.storageService=s,this.userDataSyncStoreService=l,this.logService=a,this.productService=g,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(t,r,s)}async getMachines(t){const r=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(l=>({...l,isCurrent:l.id===r}))}async addCurrentMachine(t){const r=await this.currentMachineIdPromise,s=await this.readMachinesData(t);s.machines.some(({id:l})=>l===r)||(s.machines.push({id:r,name:this.computeCurrentMachineName(s.machines),platform:d()}),await this.writeMachinesData(s))}async removeCurrentMachine(t){const r=await this.currentMachineIdPromise,s=await this.readMachinesData(t),l=s.machines.filter(({id:a})=>a!==r);l.length!==s.machines.length&&(s.machines=l,await this.writeMachinesData(s))}async renameMachine(t,r,s){const l=await this.readMachinesData(s),a=l.machines.find(({id:g})=>g===t);if(a){a.name=r,await this.writeMachinesData(l);const g=await this.currentMachineIdPromise;t===g&&this.storageService.store(f,r,-1,1)}}async setEnablements(t){const r=await this.readMachinesData();for(const[s,l]of t){const a=r.machines.find(g=>g.id===s);a&&(a.disabled=l?void 0:!0)}await this.writeMachinesData(r)}computeCurrentMachineName(t){const r=this.storageService.get(f,-1);if(r)return r;const s=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${d()} (${this.productService.nameShort})`,l=new RegExp(`${(0,k.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let a=0;for(const g of t){const C=l.exec(g.name),A=C?parseInt(C[1]):0;a=A>a?A:a}return`${s} #${a+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const r=this.parse(this.userData);if(r.version!==st.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return r}async writeMachinesData(t){const r=JSON.stringify(t),s=await this.userDataSyncStoreService.writeResource(st.RESOURCE,r,this.userData?.ref||null);this.userData={ref:s,content:r},this._onDidChange.fire()}async readUserData(t){if(this.userData){const r=t&&t.latest?t.latest[st.RESOURCE]:void 0;if(this.userData.ref===r)return this.userData;if(r===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(st.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(r){this.logService.error(r)}return{version:st.VERSION,machines:[]}}};n.VERSION=1,n.RESOURCE="machines",n=ve([G(0,I.IEnvironmentService),G(1,P.IFileService),G(2,p.IStorageService),G(3,v.IUserDataSyncStoreService),G(4,v.IUserDataSyncLogService),G(5,b.IProductService)],n),e.UserDataSyncMachinesService=n}),define(se[271],oe([0,1,6,65,38,11,3,2,5,20,8,178,25,18,24,26,76,79]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const S="sync.disableMachineEventually",c="sync.sessionId",h="sync.storeUrl",d="sync.productQuality";let n=class extends I.Disposable{get syncUrl(){const r=this.storageService.get(h,-1);return r?b.URI.parse(r):void 0}set syncUrl(r){r?this.storageService.store(h,r.toString(),-1,1):this.storageService.remove(h,-1)}get productQuality(){return this.storageService.get(d,-1)}set productQuality(r){r?this.storageService.store(d,r,-1,1):this.storageService.remove(d,-1)}constructor(r,s,l,a,g,C,A,V,_,F){super(),this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=l,this.userDataSyncEnablementService=a,this.userDataSyncService=g,this.logService=C,this.userDataSyncAccountService=A,this.telemetryService=V,this.userDataSyncMachinesService=_,this.storageService=F,this.autoSync=this._register(new I.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=r.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,w.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(A.onDidChangeAccount(()=>this.updateAutoSync())),this._register(l.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(g.onDidChangeLocal(N=>this.triggerSync([N],!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,N])=>N)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:r,message:s}=this.isAutoSyncEnabled();r?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(l=>this.onDidFinishSync(l))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(r,s,l){try{this.userDataSyncAccountService.account&&!l&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(c,-1),r?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),s)this.updateEnablement(!1);else throw a}}updateEnablement(r){this.userDataSyncEnablementService.isEnabled()!==r&&(this.userDataSyncEnablementService.setEnablement(r),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(r){if(!r){this.successiveFailures=0;return}const s=m.UserDataSyncError.toUserDataSyncError(r);s instanceof m.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?P.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(S,!0,-1,1),await(0,D.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(S,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(S,-1)}async triggerSync(r,s,l){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...r),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",l)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};n=ve([G(0,p.IProductService),G(1,m.IUserDataSyncStoreManagementService),G(2,m.IUserDataSyncStoreService),G(3,m.IUserDataSyncEnablementService),G(4,m.IUserDataSyncService),G(5,m.IUserDataSyncLogService),G(6,y.IUserDataSyncAccountService),G(7,f.ITelemetryService),G(8,u.IUserDataSyncMachinesService),G(9,v.IStorageService)],n),e.UserDataAutoSyncService=n;class o extends I.Disposable{constructor(r,s,l,a,g,C,A,V){super(),this.lastSyncUrl=r,this.interval=s,this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=a,this.userDataSyncService=g,this.userDataSyncMachinesService=C,this.logService=A,this.storageService=V,this.intervalHandler=this._register(new I.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,I.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(r,s){const l=(0,D.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(g){if((0,k.isCancellationError)(g))return}return this.doSync(r,s,a)});return this.syncPromise=l,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,w.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const r=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!r&&(!(0,w.isEqual)(s.defaultUrl,r.defaultUrl)||!(0,w.isEqual)(s.insidersUrl,r.insidersUrl)||!(0,w.isEqual)(s.stableUrl,r.stableUrl))}async doSync(r,s,l){this.logService.info(`Auto Sync: Triggered by ${r}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),l.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new m.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new m.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new m.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const g=this.storageService.get(c,-1);if(g&&this.manifest&&g!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new m.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new m.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new m.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const C=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(l.isCancellationRequested)return;const A=C.find(V=>V.isCurrent);if(A?.disabled)throw new m.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(V){throw new m.UserDataAutoSyncError((0,R.toErrorMessage)(V),V instanceof m.UserDataSyncError?V.code:"Unknown")}if(this.manifest&&this.manifest.session!==g&&this.storageService.store(c,this.manifest.session,-1,1),l.isCancellationRequested)return;A||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(g){this.logService.error(g),a=g}this._onDidFinishSync.fire(a)}register(r){return super._register(r)}}o.INTERVAL_SYNCING="Interval"}),define(se[62],oe([0,1,2,69,4,18]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataSyncProfilesStorageService=e.IUserDataSyncProfilesStorageService=void 0,e.IUserDataSyncProfilesStorageService=(0,R.createDecorator)("IUserDataSyncProfilesStorageService");let T=class extends D.Disposable{constructor(w){super(),this.storageService=w}async readStorageData(w){return this.withProfileScopedStorageService(w,async b=>this.getItems(b))}async updateStorageData(w,b,E){return this.withProfileScopedStorageService(w,async p=>this.writeItems(p,b,E))}async withProfileScopedStorageService(w,b){if(this.storageService.hasScope(w))return b(this.storageService);const E=await this.createStorageDatabase(w),p=new I(E);try{await p.initialize();const v=await b(p);return await p.flush(),v}finally{p.dispose(),await this.closeAndDispose(E)}}getItems(w){const b=new Map,E=p=>{for(const v of w.keys(0,p))b.set(v,{value:w.get(v,0),target:p})};return E(0),E(1),b}writeItems(w,b,E){for(const[p,v]of b)w.store(p,v,0,E)}async closeAndDispose(w){try{await w.close()}finally{(0,D.isDisposable)(w)&&w.dispose()}}};T=ve([G(0,k.IStorageService)],T),e.AbstractUserDataSyncProfilesStorageService=T;class I extends k.AbstractStorageService{constructor(w){super({flushInterval:100}),this.profileStorage=this._register(new i.Storage(w))}doInitialize(){return this.profileStorage.init()}getStorage(w){return w===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(se[123],oe([0,1,6,22,11,3,42,2,27,16,13,117,29,33,78,14,4,71,7,18,24,31,21,41,252,115,26,62]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u,S,c,h,d,n,o,t,r,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function a(F,N){const L=JSON.parse(F.content);if(F.version===1||F.version===2){const U=(await N.getInstalled(0)).filter($=>$.isBuiltin);for(const $ of L)F.version===1&&($.enabled===!1&&($.disabled=!0),delete $.enabled),F.version===2&&U.every(H=>!(0,v.areSameExtensions)(H.identifier,$.identifier))&&($.installed=!0)}return L}function g(F){return JSON.parse(F.content)}e.parseExtensions=g;function C(F,N){return F.sort((L,U)=>!L.identifier.uuid&&U.identifier.uuid?-1:L.identifier.uuid&&!U.identifier.uuid?1:(0,P.compare)(L.identifier.id,U.identifier.id)),N?(0,T.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=C;let A=class extends o.AbstractSynchroniser{constructor(N,L,U,$,H,q,x,W,j,K,ee,ce,J,Q,M,O,B){super({syncResource:"extensions",profile:N},L,$,U,H,q,x,ce,J,K,ee,M),this.extensionManagementService=W,this.ignoredExtensionsManagementService=j,this.instantiationService=B,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(V),this._register(k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtensions,z=>z.some(({local:Y})=>!!Y)),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,z=>!z.error),k.Event.filter(O.onDidChange,z=>z.valueChanges.some(({profile:Y,changes:ne})=>this.syncResource.profile.id===Y.id&&ne.some(X=>X.key===p.DISABLED_EXTENSIONS_STORAGE_PATH))),Q.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(N,L){const U=N.syncData?await a(N.syncData,this.extensionManagementService):null,$=L?.skippedExtensions||[],H=L?.builtinExtensions||[],q=L?.syncData?await a(L.syncData,this.extensionManagementService):null,{localExtensions:x,ignoredExtensions:W}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);U?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:j,remote:K}=(0,t.merge)(x,U,q,$,W,H),ee={local:j,remote:K,content:this.getPreviewContent(x,j.added,j.updated,j.removed),localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?2:0,remoteChange:K!==null?2:0},ce=this.stringify(x,!1);return[{skippedExtensions:$,builtinExtensions:H,baseResource:this.baseResource,baseContent:q?this.stringify(q,!1):ce,localResource:this.localResource,localContent:ce,localExtensions:x,remoteResource:this.remoteResource,remoteExtensions:U,remoteContent:U?this.stringify(U,!1):null,previewResource:this.previewResource,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(N){const L=N.syncData?await a(N.syncData,this.extensionManagementService):null,{localExtensions:U,ignoredExtensions:$}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:H}=(0,t.merge)(U,L,L,N.skippedExtensions||[],$,N.builtinExtensions||[]);return H!==null}getPreviewContent(N,L,U,$){const H=[...L,...U],q=new Set,x=W=>{q.add(W.id.toLowerCase()),W.uuid&&q.add(W.uuid)};H.forEach(({identifier:W})=>x(W)),$.forEach(x);for(const W of N)q.has(W.identifier.id.toLowerCase())||W.identifier.uuid&&q.has(W.identifier.uuid)||H.push(W);return this.stringify(H,!1)}async getMergeResult(N,L){return{...N.previewResult,hasConflicts:!1}}async getAcceptResult(N,L,U,$){if(this.extUri.isEqual(L,this.localResource))return this.acceptLocal(N);if(this.extUri.isEqual(L,this.remoteResource))return this.acceptRemote(N);if(this.extUri.isEqual(L,this.previewResource))return N.previewResult;throw new Error(`Invalid Resource: ${L.toString()}`)}async acceptLocal(N){const L=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(L),$=(0,t.merge)(N.localExtensions,null,null,N.skippedExtensions,U,N.builtinExtensions),{local:H,remote:q}=$;return{content:N.localContent,local:H,remote:q,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:q!==null?2:0}}async acceptRemote(N){const L=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(L),$=N.remoteContent?JSON.parse(N.remoteContent):null;if($!==null){const H=(0,t.merge)(N.localExtensions,$,N.localExtensions,[],U,N.builtinExtensions),{local:q,remote:x}=H;return{content:N.remoteContent,local:q,remote:x,localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:x!==null?2:0}}else return{content:N.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(N,L,U,$){let{skippedExtensions:H,localExtensions:q}=U[0][0];const{local:x,remote:W,localChange:j,remoteChange:K}=U[0][1];if(j===0&&K===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),j!==0&&(await this.backupLocal(JSON.stringify(q)),H=await this.localExtensionsProvider.updateLocalExtensions(x.added,x.removed,x.updated,H,this.syncResource.profile)),W){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const ee=JSON.stringify(W.all);N=await this.updateRemoteUserData(ee,$?null:N.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${W.added.length?` Added: ${JSON.stringify(W.added.map(ce=>ce.identifier.id))}.`:""}${W.updated.length?` Updated: ${JSON.stringify(W.updated.map(ce=>ce.identifier.id))}.`:""}${W.removed.length?` Removed: ${JSON.stringify(W.removed.map(ce=>ce.identifier.id))}.`:""}`)}if(L?.ref!==N.ref){this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`);const ee=q.filter(ce=>!ce.installed).map(ce=>ce.identifier);await this.updateLastSyncUserData(N,{skippedExtensions:H,builtinExtensions:ee}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${H.length?` Skipped: ${JSON.stringify(H.map(ce=>ce.identifier.id))}.`:""}`)}}async resolveContent(N){if(this.extUri.isEqual(this.remoteResource,N)||this.extUri.isEqual(this.baseResource,N)||this.extUri.isEqual(this.localResource,N)||this.extUri.isEqual(this.acceptedResource,N)){const L=await this.resolvePreviewContent(N);return L&&this.stringify(JSON.parse(L),!0)}return null}stringify(N,L){return C(N,L)}async hasLocalData(){try{const{localExtensions:N}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(N.some(L=>L.installed||L.disabled))return!0}catch{}return!1}};A=ve([G(2,b.IEnvironmentService),G(3,m.IFileService),G(4,c.IStorageService),G(5,s.IUserDataSyncStoreService),G(6,s.IUserDataSyncBackupStoreService),G(7,p.IExtensionManagementService),G(8,r.IIgnoredExtensionsManagementService),G(9,s.IUserDataSyncLogService),G(10,w.IConfigurationService),G(11,s.IUserDataSyncEnablementService),G(12,h.ITelemetryService),G(13,f.IExtensionStorageService),G(14,d.IUriIdentityService),G(15,l.IUserDataSyncProfilesStorageService),G(16,y.IInstantiationService)],A),e.ExtensionsSynchroniser=A;let V=class{constructor(N,L,U,$,H,q){this.extensionManagementService=N,this.userDataSyncProfilesStorageService=L,this.extensionGalleryService=U,this.ignoredExtensionsManagementService=$,this.instantiationService=H,this.logService=q}async getLocalExtensions(N){const L=await this.extensionManagementService.getInstalled(void 0,N.extensionsResource),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(L);return{localExtensions:await this.withProfileScopedServices(N,async(H,q)=>{const x=H.getDisabledExtensions();return L.map(W=>{const{identifier:j,isBuiltin:K,manifest:ee,preRelease:ce}=W,J={identifier:j,preRelease:ce,version:ee.version};x.some(Q=>(0,v.areSameExtensions)(Q,j))&&(J.disabled=!0),K||(J.installed=!0);try{const Q=q.getKeysForSync({id:j.id,version:ee.version});if(Q){const M=q.getExtensionState(W,!0)||{};J.state=Object.keys(M).reduce((O,B)=>(Q.includes(B)&&(O[B]=M[B]),O),{})}}catch(Q){this.logService.info(`${(0,o.getSyncResourceLogLabel)("extensions",N)}: Error while parsing extension state`,(0,R.getErrorMessage)(Q))}return J})}),ignoredExtensions:U}}async updateLocalExtensions(N,L,U,$,H){const q=(0,o.getSyncResourceLogLabel)("extensions",H);return this.withProfileScopedServices(H,async(x,W)=>{const j=[],K=[],ee=await this.extensionManagementService.getInstalled(void 0,H.extensionsResource);if(L.length){const J=ee.filter(({identifier:Q,isBuiltin:M})=>!M&&L.some(O=>(0,v.areSameExtensions)(Q,O)));await D.Promises.settled(J.map(async Q=>{this.logService.trace(`${q}: Uninstalling local extension...`,Q.identifier.id),await this.extensionManagementService.uninstall(Q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:H.extensionsResource}),this.logService.info(`${q}: Uninstalled local extension.`,Q.identifier.id),j.push(Q.identifier)}))}(N.length||U.length)&&await D.Promises.settled([...N,...U].map(async J=>{const Q=ee.find(O=>(0,v.areSameExtensions)(O.identifier,J.identifier));if(Q&&Q.isBuiltin){J.state&&Q.manifest.version===J.version&&this.updateExtensionState(J.state,Q,Q.manifest.version,W),x.getDisabledExtensions().some(B=>(0,v.areSameExtensions)(B,J.identifier))!==!!J.disabled&&(J.disabled?(this.logService.trace(`${q}: Disabling extension...`,J.identifier.id),await x.disableExtension(J.identifier),this.logService.info(`${q}: Disabled extension`,J.identifier.id)):(this.logService.trace(`${q}: Enabling extension...`,J.identifier.id),await x.enableExtension(J.identifier),this.logService.info(`${q}: Enabled extension`,J.identifier.id))),j.push(J.identifier);return}const M=(await this.extensionGalleryService.getExtensions([{...J.identifier,preRelease:J.preRelease}],i.CancellationToken.None))[0];if(J.state&&(Q?Q.manifest.version===J.version:!!M)&&this.updateExtensionState(J.state,Q||M,Q?.manifest.version,W),M)try{x.getDisabledExtensions().some(B=>(0,v.areSameExtensions)(B,J.identifier))!==!!J.disabled&&(J.disabled?(this.logService.trace(`${q}: Disabling extension...`,J.identifier.id,M.version),await x.disableExtension(M.identifier),this.logService.info(`${q}: Disabled extension`,J.identifier.id,M.version)):(this.logService.trace(`${q}: Enabling extension...`,J.identifier.id,M.version),await x.enableExtension(M.identifier),this.logService.info(`${q}: Enabled extension`,J.identifier.id,M.version))),(!Q||Q.preRelease!==J.preRelease)&&(await this.extensionManagementService.canInstall(M)?(this.logService.trace(`${q}: Installing extension...`,J.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:J.preRelease,profileLocation:H.extensionsResource}),this.logService.info(`${q}: Installed extension.`,J.identifier.id,M.version),j.push(M.identifier)):(this.logService.info(`${q}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),K.push(J)))}catch(O){K.push(J),O instanceof p.ExtensionManagementError&&[p.ExtensionManagementErrorCode.Incompatible,p.ExtensionManagementErrorCode.IncompatiblePreRelease,p.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(O.code)?this.logService.info(`${q}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):(this.logService.error(O),this.logService.info(`${q}: Skipped synchronizing extension`,M.displayName||M.identifier.id))}else K.push(J),this.logService.info(`${q}: Skipped synchronizing extension because the extension is not found.`,J.identifier.id)}));const ce=[];for(const J of $)j.some(Q=>(0,v.areSameExtensions)(Q,J.identifier))||ce.push(J);for(const J of K)ce.some(Q=>(0,v.areSameExtensions)(Q.identifier,J.identifier))||ce.push(J);return ce})}updateExtensionState(N,L,U,$){const H=$.getExtensionState(L,!0)||{},q=U?$.getKeysForSync({id:L.identifier.id,version:U}):void 0;q?q.forEach(x=>{H[x]=N[x]}):Object.keys(N).forEach(x=>H[x]=N[x]),$.setExtensionState(L,H,!0)}async withProfileScopedServices(N,L){return this.userDataSyncProfilesStorageService.withProfileScopedStorageService(N,async U=>{const $=new I.DisposableStore,H=this.instantiationService.createChild(new u.ServiceCollection([c.IStorageService,U])),q=$.add(H.createInstance(E.GlobalExtensionEnablementService)),x=$.add(H.createInstance(f.ExtensionStorageService));try{return await L(q,x)}finally{$.dispose()}})}};V=ve([G(0,p.IExtensionManagementService),G(1,l.IUserDataSyncProfilesStorageService),G(2,p.IExtensionGalleryService),G(3,r.IIgnoredExtensionsManagementService),G(4,y.IInstantiationService),G(5,s.IUserDataSyncLogService)],V),e.LocalExtensionsProvider=V;let _=class extends o.AbstractInitializer{constructor(N,L,U,$,H,q,x){super("extensions",$,H,q,U,x),this.extensionManagementService=N,this.ignoredExtensionsManagementService=L}async parseExtensions(N){return N.syncData?await a(N.syncData,this.extensionManagementService):null}generatePreview(N,L){const U=[],$=[],H=[];for(const q of N){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(q.identifier.id))continue;const x=L.find(W=>(0,v.areSameExtensions)(W.identifier,q.identifier));x?(U.push(x),q.disabled&&H.push(q.identifier)):q.installed&&($.push({...q.identifier,preRelease:!!q.preRelease}),q.disabled&&H.push(q.identifier))}return{installedExtensions:U,newExtensions:$,disabledExtensions:H,remoteExtensions:N}}};_=ve([G(0,p.IExtensionManagementService),G(1,r.IIgnoredExtensionsManagementService),G(2,m.IFileService),G(3,n.IUserDataProfilesService),G(4,b.IEnvironmentService),G(5,S.ILogService),G(6,d.IUriIdentityService)],_),e.AbstractExtensionsInitializer=_}),define(se[124],oe([0,1,17,11,3,35,42,5,30,16,13,14,7,44,18,24,31,41,61,256,26,21,62,4]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u,S,c,h,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",r=["locale"];function s(V,_){const F=V.storage?Object.keys(V.storage).sort():[],N={};return F.forEach(L=>N[L]=V.storage[L]),V.storage=N,_?(0,T.toFormattedString)(V,{}):JSON.stringify(V)}e.stringify=s;const l=1;let a=class extends u.AbstractSynchroniser{constructor(_,F,N,L,U,$,H,q,x,W,j,K,ee,ce){super({syncResource:"globalState",profile:_},F,L,q,K,U,$,x,W,H,j,ee),this.userDataSyncProfilesStorageService=N,this.version=l,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=ce.createInstance(g),this._register(L.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(R.Event.any(R.Event.filter(L.onDidFilesChange,J=>J.contains(this.environmentService.argvResource)),R.Event.filter(N.onDidChange,J=>!!(J.targetChanges.some(Q=>this.syncResource.profile.id===Q.id)||J.valueChanges.some(({profile:Q,changes:M})=>this.syncResource.profile.id===Q.id&&M.some(O=>O.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(_,F,N){const L=_.syncData?JSON.parse(_.syncData.content):null;F=F===null&&N?_:F;const U=F&&F.syncData?JSON.parse(F.syncData.content):null,$=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);L?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=await this.getStorageKeys(U),{local:q,remote:x}=(0,c.merge)($.storage,L?L.storage:null,U?U.storage:null,H,this.logService),W={content:null,local:q,remote:x,localChange:Object.keys(q.added).length>0||Object.keys(q.updated).length>0||q.removed.length>0?2:0,remoteChange:x.all!==null?2:0},j=s($,!1);return[{baseResource:this.baseResource,baseContent:U?s(U,!1):j,localResource:this.localResource,localContent:j,localUserData:$,remoteResource:this.remoteResource,remoteContent:L?s(L,!1):null,previewResource:this.previewResource,previewResult:W,localChange:W.localChange,remoteChange:W.remoteChange,acceptedResource:this.acceptedResource,storageKeys:H}]}async hasRemoteChanged(_){const F=_.syncData?JSON.parse(_.syncData.content):null;if(F===null)return!0;const N=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),L=await this.getStorageKeys(F),{remote:U}=(0,c.merge)(N.storage,F.storage,F.storage,L,this.logService);return U.all!==null}async getMergeResult(_,F){return{..._.previewResult,hasConflicts:!1}}async getAcceptResult(_,F,N,L){if(this.extUri.isEqual(F,this.localResource))return this.acceptLocal(_);if(this.extUri.isEqual(F,this.remoteResource))return this.acceptRemote(_);if(this.extUri.isEqual(F,this.previewResource))return _.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async acceptLocal(_){return{content:_.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(_.localUserData.storage),removed:[],updated:[],all:_.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(_){if(_.remoteContent!==null){const F=JSON.parse(_.remoteContent),{local:N,remote:L}=(0,c.merge)(_.localUserData.storage,F.storage,null,_.storageKeys,this.logService);return{content:_.remoteContent,local:N,remote:L,localChange:Object.keys(N.added).length>0||Object.keys(N.updated).length>0||N.removed.length>0?2:0,remoteChange:L!==null?2:0}}else return{content:_.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(_,F,N,L){const{localUserData:U}=N[0][0],{local:$,remote:H,localChange:q,remoteChange:x}=N[0][1];if(q===0&&x===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),q!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(U)),await this.localGlobalStateProvider.writeLocalGlobalState($,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),x!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const W=JSON.stringify({storage:H.all});_=await this.updateRemoteUserData(W,L?null:_.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${H.added.length?` Added: ${H.added}.`:""}${H.updated.length?` Updated: ${H.updated}.`:""}${H.removed.length?` Removed: ${H.removed}.`:""}`)}F?.ref!==_.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(_),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(_){if(this.extUri.isEqual(this.remoteResource,_)||this.extUri.isEqual(this.baseResource,_)||this.extUri.isEqual(this.localResource,_)||this.extUri.isEqual(this.acceptedResource,_)){const F=await this.resolvePreviewContent(_);return F&&s(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:_}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(_).length>1||_[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(_){const F=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),N=[],L=[];for(const[H,q]of F)q.target===0?N.push(H):q.target===1&&L.push(H);const U=[...N,...L],$=_?.storage?Object.keys(_.storage).filter(H=>!H.startsWith(t)&&!U.includes(H)&&F.get(H)!==void 0):[];if(!I.isWeb){const H=[...h.ALL_SYNC_RESOURCES.map(q=>(0,h.getEnablementKey)(q)),h.SYNC_SERVICE_URL_TYPE];$.push(...H),L.push(...H)}return{user:N,machine:L,unregistered:$}}};a=ve([G(2,n.IUserDataSyncProfilesStorageService),G(3,E.IFileService),G(4,h.IUserDataSyncStoreService),G(5,h.IUserDataSyncBackupStoreService),G(6,h.IUserDataSyncLogService),G(7,b.IEnvironmentService),G(8,h.IUserDataSyncEnablementService),G(9,m.ITelemetryService),G(10,w.IConfigurationService),G(11,f.IStorageService),G(12,y.IUriIdentityService),G(13,o.IInstantiationService)],a),e.GlobalStateSynchroniser=a;let g=class{constructor(_,F,N,L){this.fileService=_,this.environmentService=F,this.userDataSyncProfilesStorageService=N,this.logService=L}async getLocalGlobalState(_){const F={};if(_.isDefault){const L=await this.getLocalArgvContent(),U=(0,k.parse)(L);for(const $ of r)U[$]!==void 0&&(F[`${t}${$}`]={version:1,value:U[$]})}const N=await this.userDataSyncProfilesStorageService.readStorageData(_);for(const[L,U]of N)U.value&&U.target===0&&(F[L]={version:1,value:U.value});return{storage:F}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const _=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),_.value.toString()}catch(_){this.logService.debug((0,i.getErrorMessage)(_))}return"{}"}async writeLocalGlobalState({added:_,removed:F,updated:N},L){const U=(0,u.getSyncResourceLogLabel)("globalState",L),$={},H=new Map,q=await this.userDataSyncProfilesStorageService.readStorageData(L),x=(W,j)=>{for(const K of W){if(K.startsWith(t)){$[K.substring(t.length)]=j?j[K].value:void 0;continue}if(j){const ee=j[K];ee.value!==q.get(K)?.value&&H.set(K,ee.value)}else q.get(K)!==void 0&&H.set(K,void 0)}};if(x(Object.keys(_),_),x(Object.keys(N),N),x(F),Object.keys($).length){this.logService.trace(`${U}: Updating locale...`);const W=await this.getLocalArgvContent();let j=W;for(const K of Object.keys($))j=(0,S.edit)(j,[K],$[K],{});W!==j&&(this.logService.trace(`${U}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(j)),this.logService.info(`${U}: Updated locale.`)),this.logService.info(`${U}: Updated locale`)}H.size&&(this.logService.trace(`${U}: Updating global state...`),await this.userDataSyncProfilesStorageService.updateStorageData(L,H,0),this.logService.info(`${U}: Updated global state`,[...H.keys()]))}};g=ve([G(0,E.IFileService),G(1,b.IEnvironmentService),G(2,n.IUserDataSyncProfilesStorageService),G(3,h.IUserDataSyncLogService)],g),e.LocalGlobalStateProvider=g;let C=class extends u.AbstractInitializer{constructor(_,F,N,L,U,$){super("globalState",N,L,U,F,$),this.storageService=_}async doInitialize(_){const F=_.syncData?JSON.parse(_.syncData.content):null;if(!F){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const N={},L={};for(const U of Object.keys(F.storage))U.startsWith(t)?N[U.substring(t.length)]=F.storage[U].value:this.storageService.get(U,0)===void 0&&(L[U]=F.storage[U].value);if(Object.keys(N).length){let U="{}";try{U=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const $ of Object.keys(N))U=(0,S.edit)(U,[$],N[$],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(U))}if(Object.keys(L).length)for(const U of Object.keys(L))this.storageService.store(U,L[U],0,0)}};C=ve([G(0,f.IStorageService),G(1,E.IFileService),G(2,d.IUserDataProfilesService),G(3,b.IEnvironmentService),G(4,h.IUserDataSyncLogService),G(5,y.IUriIdentityService)],C),e.GlobalStateInitializer=C;let A=class{constructor(_,F,N,L,U){this.userDataSyncStoreClient=_,this.storageService=F,this.environmentService=N,this.fileService=L,this.logService=U}getSyncStoreType(_){return this.parseGlobalState(_)?.storage[h.SYNC_SERVICE_URL_TYPE]?.value}async sync(_){const F=(0,h.createSyncHeaders)((0,P.generateUuid)());try{return await this.doSync(_,F)}catch(N){if(N instanceof h.UserDataSyncError)switch(N.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(_,F)}throw N}}async doSync(_,F){const N=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,F),L=this.parseGlobalState(N)||{storage:{}};L.storage[h.SYNC_SERVICE_URL_TYPE]={value:_,version:l};const U=await(0,v.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:l,machineId:U,content:s(L,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify($),N.ref,void 0,F)}parseGlobalState({content:_}){if(!_)return null;const F=JSON.parse(_);if((0,u.isSyncData)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};A=ve([G(1,f.IStorageService),G(2,b.IEnvironmentService),G(3,E.IFileService),G(4,p.ILogService)],A),e.UserDataSyncStoreTypeSynchronizer=A}),define(se[272],oe([0,1,8,181,13,14,44,18,31,26,21,41,120,119,118,16,121,123,124,4,122,42]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u,S,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class xe{constructor(t,r,s,l,a,g,C,A,V,_){this.userDataSyncStoreService=t,this.userDataSyncBackupStoreService=r,this.logService=s,this.environmentService=a,this.storageService=g,this.fileService=C,this.userDataProfilesService=A,this.configurationService=V,this.instantiationService=_,this.extUri=l.extUri}async getRemoteSyncedProfiles(){const t=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(t.content){const r=this.parseSyncData(t.content,"profiles");return(0,h.parseUserDataProfilesManifest)(r)}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.userDataSyncStoreService.getAllResourceRefs(t,r?.collection)).map(({created:l,ref:a})=>({created:l,uri:this.toUri({remote:!0,syncResource:t,profile:r?.id??this.userDataProfilesService.defaultProfile.id,collection:r?.collection,ref:a,node:void 0})}))}async getLocalSyncResourceHandles(t,r){return(await this.userDataSyncBackupStoreService.getAllRefs(r,t)).map(({created:l,ref:a})=>({created:l,uri:this.toUri({remote:!1,syncResource:t,profile:r.id,collection:void 0,ref:a,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const r=this.resolveUri(t),s=r?this.userDataProfilesService.profiles.find(l=>l.id===r.profile):void 0;return r&&s?{profile:s,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.resolveUri(t);if(!r)return[];const s=this.userDataProfilesService.profiles.find(l=>l.id===r.profile);switch(r.syncResource){case"settings":return this.getSettingsAssociatedResources(t,s);case"keybindings":return this.getKeybindingsAssociatedResources(t,s);case"tasks":return this.getTasksAssociatedResources(t,s);case"snippets":return this.getSnippetsAssociatedResources(t,s);case"globalState":return this.getGlobalStateAssociatedResources(t,s);case"extensions":return this.getExtensionsAssociatedResources(t,s);case"profiles":return this.getProfilesAssociatedResources(t,s)}}async getMachineId({uri:t}){const r=this.resolveUri(t);if(!!r){if(r.remote){if(r.ref){const{content:s}=await this.getUserData(r.syncResource,r.ref,r.collection);if(s)return this.parseSyncData(s,r.syncResource)?.machineId}return}return(0,T.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(t){const r=this.resolveUri(t);if(!r||r.node===xe.NOT_EXISTING_RESOURCE)return null;if(r.ref){const s=await this.getContentFromStore(r.remote,r.syncResource,r.profile,r.collection,r.ref);return r.node&&s?this.resolveNodeContent(r.syncResource,s,r.node):s}return!r.remote&&!r.node?this.resolveLatestContent(r.syncResource,r.profile):null}async getContentFromStore(t,r,s,l,a){if(t){const{content:C}=await this.getUserData(r,a,l);return C}const g=this.userDataProfilesService.profiles.find(C=>C.id===s);return g?this.userDataSyncBackupStoreService.resolveContent(g,r,a):null}resolveNodeContent(t,r,s){const l=this.parseSyncData(r,t);switch(t){case"settings":return this.resolveSettingsNodeContent(l,s);case"keybindings":return this.resolveKeybindingsNodeContent(l,s);case"tasks":return this.resolveTasksNodeContent(l,s);case"snippets":return this.resolveSnippetsNodeContent(l,s);case"globalState":return this.resolveGlobalStateNodeContent(l,s);case"extensions":return this.resolveExtensionsNodeContent(l,s);case"profiles":return this.resolveProfileNodeContent(l,s)}}async resolveLatestContent(t,r){const s=this.userDataProfilesService.profiles.find(l=>l.id===r);if(!s)return null;switch(t){case"globalState":return this.resolveLatestGlobalStateContent(s);case"extensions":return this.resolveLatestExtensionsContent(s);case"profiles":return this.resolveLatestProfilesContent(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}getSettingsAssociatedResources(t,r){const s=this.extUri.joinPath(t,"settings.json"),l=r?r.settingsResource:this.extUri.joinPath(t,xe.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:l}]}resolveSettingsNodeContent(t,r){switch(r){case"settings.json":return(0,v.parseSettingsSyncContent)(t.content).settings}return null}getKeybindingsAssociatedResources(t,r){const s=this.extUri.joinPath(t,"keybindings.json"),l=r?r.keybindingsResource:this.extUri.joinPath(t,xe.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:l}]}resolveKeybindingsNodeContent(t,r){switch(r){case"keybindings.json":return(0,f.getKeybindingsContentFromSyncContent)(t.content,!!this.configurationService.getValue(w.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(t,r){const s=this.extUri.joinPath(t,"tasks.json"),l=r?r.tasksResource:this.extUri.joinPath(t,xe.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:l}]}resolveTasksNodeContent(t,r){switch(r){case"tasks.json":return(0,y.getTasksContentFromSyncContent)(t.content,this.logService)}return null}async getSnippetsAssociatedResources(t,r){const s=await this.resolveContent(t);if(s){const l=this.parseSyncData(s,"snippets");if(l){const a=(0,p.parseSnippets)(l),g=[];for(const C of Object.keys(a)){const A=this.extUri.joinPath(t,C),V=r?this.extUri.joinPath(r.snippetsHome,C):this.extUri.joinPath(t,xe.NOT_EXISTING_RESOURCE);g.push({resource:A,comparableResource:V})}return g}}return[]}resolveSnippetsNodeContent(t,r){return(0,p.parseSnippets)(t)[r]||null}getExtensionsAssociatedResources(t,r){const s=this.extUri.joinPath(t,"extensions.json"),l=r?this.toUri({remote:!1,syncResource:"extensions",profile:r.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,xe.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:l}]}resolveExtensionsNodeContent(t,r){switch(r){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(t),!0)}return null}async resolveLatestExtensionsContent(t){const{localExtensions:r}=await this.instantiationService.createInstance(u.LocalExtensionsProvider).getLocalExtensions(t);return(0,u.stringify)(r,!0)}getGlobalStateAssociatedResources(t,r){const s=this.extUri.joinPath(t,"globalState.json"),l=r?this.toUri({remote:!1,syncResource:"globalState",profile:r.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,xe.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:l}]}resolveGlobalStateNodeContent(t,r){switch(r){case"globalState.json":return(0,S.stringify)(JSON.parse(t.content),!0)}return null}async resolveLatestGlobalStateContent(t){const r=await this.instantiationService.createInstance(S.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,S.stringify)(r,!0)}getProfilesAssociatedResources(t,r){const s=this.extUri.joinPath(t,"profiles.json"),l=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:l}]}resolveProfileNodeContent(t,r){switch(r){case"profiles.json":return(0,d.toFormattedString)(JSON.parse(t.content),{})}return null}async resolveLatestProfilesContent(t){return(0,h.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}toUri(t){const r=t.remote?xe.REMOTE_BACKUP_AUTHORITY:xe.LOCAL_BACKUP_AUTHORITY,s=[t.syncResource,t.profile];return t.collection&&s.push(`collection:${t.collection}`),t.ref&&s.push(`ref:${t.ref}`),t.node&&s.push(t.node),this.extUri.joinPath(D.URI.from({scheme:w.USER_DATA_SYNC_SCHEME,authority:r,path:"/"}),...s)}resolveUri(t){if(t.scheme!==w.USER_DATA_SYNC_SCHEME||t.authority!==xe.LOCAL_BACKUP_AUTHORITY&&t.authority!==xe.REMOTE_BACKUP_AUTHORITY)return;const r=[];for(;t.path!=="/";)r.unshift(this.extUri.basename(t)),t=this.extUri.dirname(t);if(r.length<2)return;const s=t.authority===xe.REMOTE_BACKUP_AUTHORITY,l=r.shift(),a=r.shift();let g,C,A;for(;r.length;){const V=r.shift();V.startsWith("collection:")?g=V.substring(11):V.startsWith("ref:")?C=V.substring(4):A=V}return{remote:s,syncResource:l,profile:a,collection:g,ref:C,node:A}}parseSyncData(t,r){try{const s=JSON.parse(t);if((0,E.isSyncData)(s))return s}catch(s){this.logService.error(s)}throw new w.UserDataSyncError((0,i.localize)(0,null),"IncompatibleRemoteContent",r)}async getUserData(t,r,s){const l=await this.userDataSyncStoreService.resolveResourceContent(t,r,s);return{ref:r,content:l}}};n.NOT_EXISTING_RESOURCE="not-existing-resource",n.REMOTE_BACKUP_AUTHORITY="remote-backup",n.LOCAL_BACKUP_AUTHORITY="local-backup",n=ve([G(0,w.IUserDataSyncStoreService),G(1,w.IUserDataSyncBackupStoreService),G(2,w.IUserDataSyncLogService),G(3,P.IUriIdentityService),G(4,R.IEnvironmentService),G(5,I.IStorageService),G(6,k.IFileService),G(7,b.IUserDataProfilesService),G(8,m.IConfigurationService),G(9,c.IInstantiationService)],n),e.UserDataSyncResourceProviderService=n}),define(se[273],oe([0,1,19,6,22,38,3,2,20,15,30,16,13,29,4,25,18,24,21,123,124,118,119,120,121,122,26]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u,S,c,h,d,n,o,t,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let a=class extends I.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(_,F,N,L,U,$,H,q,x,W,j){super(),this.userDataSyncStoreService=_,this.userDataSyncStoreManagementService=F,this.instantiationService=N,this.logService=L,this.telemetryService=U,this.storageService=$,this.userDataSyncEnablementService=H,this.userDataProfilesService=q,this.productService=x,this.environmentService=W,this.userDataSyncResourceProviderService=j,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=F.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(l,-1,void 0),this._register((0,I.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(_,F){this.checkEnablement(),this.logService.info("Sync started.");const N=new Date().getTime(),L=(0,b.generateUuid)();try{const q=(0,s.createSyncHeaders)(L);F&&(q["Cache-Control"]="no-cache"),_=await this.userDataSyncStoreService.manifest(_,q)}catch(q){const x=s.UserDataSyncError.toUserDataSyncError(q);throw A(x,L,this.userDataSyncStoreManagementService,this.telemetryService),x}const U=!1,$=this;let H;return{manifest:_,async run(){if(U)throw new Error("Can run a task only once");H=(0,i.createCancelablePromise)(q=>$.sync(_,!1,L,q)),await H.finally(()=>H=void 0),$.logService.info(`Sync done. Took ${new Date().getTime()-N}ms`),$.updateLastSyncTime()},stop(){return H?.cancel(),$.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new s.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const _=new Date().getTime(),F=(0,b.generateUuid)(),N=(0,s.createSyncHeaders)(F);let L;try{L=await this.userDataSyncStoreService.manifest(null,N)}catch(H){const q=s.UserDataSyncError.toUserDataSyncError(H);throw A(q,F,this.userDataSyncStoreManagementService,this.telemetryService),q}await this.resetLocal();const U=this,$=new R.CancellationTokenSource;return{id:F,async merge(){return U.sync(L,!0,F,$.token)},async apply(){await U.applyManualSync(L,F,$.token),U.logService.info(`Sync done. Took ${new Date().getTime()-_}ms`),U.updateLastSyncTime()},stop(){return $.cancel(),U.stop()},dispose(){$.cancel(),U.stop()}}}async sync(_,F,N,L){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const U=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(U,_,F,N,L));const $=U.enabled.find(H=>H.resource==="profiles");if($){const H=await $.getLastSyncedProfiles()||[];if(L.isCancellationRequested)return;await this.syncRemoteProfiles(H,_,F,N,L)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(_,F,N,L,U){for(const $ of _){if(U.isCancellationRequested)return;const H=this.userDataProfilesService.profiles.find(x=>x.id===$.id);if(!H){this.logService.error(`Settings Profile with id:${$.id} and name: ${$.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",$.name);const q=this.getOrCreateActiveProfileSynchronizer(H,$);this._syncErrors.push(...await this.syncProfile(q,F,N,L,U))}for(const[$,H]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(q=>q.id===H[0].profile.id)||(H[1].dispose(),this.activeProfileSynchronizers.delete($))}async applyManualSync(_,F,N){const L=this.getActiveProfileSynchronizers();for(const x of L){if(N.isCancellationRequested)return;await x.apply(F,N)}const U=L.find(x=>x.profile.isDefault);if(!U)return;const $=U.enabled.find(x=>x.resource==="profiles");if(!$)return;const q=(await $.getRemoteSyncedProfiles(_?.latest??null)||[]).filter(x=>L.every(W=>W.profile.id!==x.id));q.length&&await this.syncRemoteProfiles(q,_,!1,F,N)}async syncProfile(_,F,N,L,U){return(await _.sync(F,N,L,U)).map(([H,q])=>({profile:_.profile,syncResource:H,error:q}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(_=>_.stop()))}async resolveContent(_){const F=await this.userDataSyncResourceProviderService.resolveContent(_);if(F)return F;for(const N of this.getActiveProfileSynchronizers())for(const L of N.enabled){const U=await L.resolveContent(_);if(U)return U}return null}async replace(_){this.checkEnablement();const F=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(_);if(!F)return;const N=await this.resolveContent(_.uri);!N||await this.performAction(F.profile,async L=>{if(F.syncResource===L.resource)return await L.replace(N),!0})}async accept(_,F,N,L){this.checkEnablement(),await this.performAction(_.profile,async U=>{if(_.syncResource===U.resource)return await U.accept(F,N),L&&await U.apply((0,w.isBoolean)(L)?!1:L.force,(0,s.createSyncHeaders)((0,b.generateUuid)())),!0})}getRemoteProfiles(){return this.userDataSyncResourceProviderService.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(_,F){return this.userDataSyncResourceProviderService.getRemoteSyncResourceHandles(_,F)}async getLocalSyncResourceHandles(_,F){return this.userDataSyncResourceProviderService.getLocalSyncResourceHandles(_,F??this.userDataProfilesService.defaultProfile)}async getAssociatedResources(_){return this.userDataSyncResourceProviderService.getAssociatedResources(_)}async getMachineId(_){return this.userDataSyncResourceProviderService.getMachineId(_)}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async F=>{if(F.resource!=="globalState"&&await F.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async F=>{if(await F.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(_){this.logService.error(_)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this.storageService.remove(l,-1);for(const[_]of this.activeProfileSynchronizers.values())try{await _.resetLocal()}catch(F){this.logService.error(F)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performAction(_,F){const N=new I.DisposableStore;try{const L=this.activeProfileSynchronizers.get(_.id);if(L){const x=await this.performActionWithProfileSynchronizer(L[0],F,N);return(0,w.isUndefined)(x)?null:x}if(_.isDefault){const x=N.add(this.instantiationService.createInstance(g,_,void 0)),W=await this.performActionWithProfileSynchronizer(x,F,N);return(0,w.isUndefined)(W)?null:W}if(this.userDataProfilesService.isEnabled()||this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,P.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl)))return null;const U=N.add(this.instantiationService.createInstance(r.UserDataProfilesManifestSynchroniser,_,void 0)),$=await this.userDataSyncStoreService.manifest(null),q=(await U.getRemoteSyncedProfiles($?.latest??null)||[]).find(x=>x.id===_.id);if(q){const x=N.add(this.instantiationService.createInstance(g,_,q.collection)),W=await this.performActionWithProfileSynchronizer(x,F,N);return(0,w.isUndefined)(W)?null:W}return null}finally{N.dispose()}}async performActionWithProfileSynchronizer(_,F,N){const L=[..._.enabled,..._.disabled.map(U=>N.add(_.createSynchronizer(U)))];for(const U of L){const $=await F(U);if(!(0,w.isUndefined)($))return $}}setStatus(_){const F=this._status;this._status!==_&&(this._status=_,this._onDidChangeStatus.fire(_),F==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const _=this.getActiveProfileSynchronizers().map(F=>F.conflicts).flat();(0,D.equals)(this._conflicts,_,(F,N)=>F.profile.id===N.profile.id&&F.syncResource===N.syncResource&&(0,D.equals)(F.conflicts,N.conflicts,(L,U)=>(0,P.isEqual)(L.previewResource,U.previewResource)))||(this._conflicts=_,this._onDidChangeConflicts.fire(_))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(_,F){let N=this.activeProfileSynchronizers.get(_.id);if(N&&N[0].collection!==F?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.activeProfileSynchronizers.delete(_.id)),!N){const L=new I.DisposableStore,U=L.add(this.instantiationService.createInstance(g,_,F?.collection));L.add(U.onDidChangeStatus($=>this.setStatus($))),L.add(U.onDidChangeConflicts($=>this.updateConflicts())),L.add(U.onDidChangeLocal($=>this._onDidChangeLocal.fire($))),this.activeProfileSynchronizers.set(_.id,N=[U,L])}return N[0]}getActiveProfileSynchronizers(){const _=[];for(const[F]of this.activeProfileSynchronizers.values())_.push(F);return _}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,_])=>_.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};a=ve([G(0,s.IUserDataSyncStoreService),G(1,s.IUserDataSyncStoreManagementService),G(2,f.IInstantiationService),G(3,s.IUserDataSyncLogService),G(4,u.ITelemetryService),G(5,y.IStorageService),G(6,s.IUserDataSyncEnablementService),G(7,S.IUserDataProfilesService),G(8,m.IProductService),G(9,p.IEnvironmentService),G(10,s.IUserDataSyncResourceProviderService)],a),e.UserDataSyncService=a;let g=class extends I.Disposable{get enabled(){return this._enabled.sort((_,F)=>_[1]-F[1]).map(([_])=>_)}get disabled(){return s.ALL_SYNC_RESOURCES.filter(_=>!this.userDataSyncEnablementService.isResourceEnabled(_))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(_,F,N,L,U,$,H,q,x,W,j,K){super(),this.profile=_,this.collection=F,this.userDataSyncEnablementService=N,this.instantiationService=L,this.extensionGalleryService=U,this.userDataSyncStoreManagementService=$,this.telemetryService=H,this.logService=q,this.productService=x,this.userDataProfilesService=W,this.configurationService=j,this.environmentService=K,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(N.onDidChangeResourceEnablement(([ee,ce])=>this.onDidChangeResourceEnablement(ee,ce))),this._register((0,I.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,ee])=>ee.dispose())));for(const ee of s.ALL_SYNC_RESOURCES)N.isResourceEnabled(ee)&&this.registerSynchronizer(ee)}onDidChangeResourceEnablement(_,F){F?this.registerSynchronizer(_):this.deRegisterSynchronizer(_)}registerSynchronizer(_){if(this._enabled.some(([U])=>U.resource===_))return;if(_==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(_==="profiles"){if(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())return;if(this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,P.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl))){this.logService.debug("Skipping profiles sync");return}}const F=new I.DisposableStore,N=F.add(this.createSynchronizer(_));F.add(N.onDidChangeStatus(()=>this.updateStatus())),F.add(N.onDidChangeConflicts(()=>this.updateConflicts())),F.add(N.onDidChangeLocal(()=>this._onDidChangeLocal.fire(_)));const L=this.getOrder(_);this._enabled.push([N,L,F])}deRegisterSynchronizer(_){const F=this._enabled.findIndex(([N])=>N.resource===_);if(F!==-1){const N=this._enabled.splice(F,1);for(const[L,,U]of N){if(L.status!=="idle"){const $=L.conflicts.conflicts.length>0;L.stop(),$&&this.updateConflicts(),this.updateStatus()}U.dispose()}}}createSynchronizer(_){switch(_){case"settings":return this.instantiationService.createInstance(n.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(d.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(o.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(t.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(h.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(c.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(r.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(_,F,N,L){if(L.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const $=[],H=(0,s.createSyncHeaders)(N),q=(this.collection?_?.collections?.[this.collection]?.latest:_?.latest)??null,x=F?await this.getUserDataSyncConfiguration(q):{};for(const W of U){if(L.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(W.resource))return[];try{if(F){const j=await W.preview(q,x,H);if(j)for(const K of j.resourcePreviews)(K.localChange!==0||K.remoteChange!==0)&&K.mergeState==="preview"&&await W.merge(K.previewResource)}else await W.sync(q,H)}catch(j){const K=s.UserDataSyncError.toUserDataSyncError(j);if(A(K,N,this.userDataSyncStoreManagementService,this.telemetryService),C(j))throw K;this.logService.error(j),this.logService.error(`${W.resource}: ${(0,k.toErrorMessage)(j)}`),$.push([W.resource,K])}}return $}finally{this.updateStatus()}}async apply(_,F){const N=(0,s.createSyncHeaders)(_);for(const L of this.enabled){if(F.isCancellationRequested)return;try{await L.apply(!1,N)}catch(U){const $=s.UserDataSyncError.toUserDataSyncError(U);if(A($,_,this.userDataSyncStoreManagementService,this.telemetryService),C(U))throw $;this.logService.error(U),this.logService.error(`${L.resource}: ${(0,k.toErrorMessage)(U)}`)}}}async stop(){for(const _ of this.enabled)try{_.status!=="idle"&&await _.stop()}catch(F){this.logService.error(F)}}async resetLocal(){for(const _ of this.enabled)try{await _.resetLocal()}catch(F){this.logService.error(`${_.resource}: ${(0,k.toErrorMessage)(F)}`),this.logService.error(F)}}async getUserDataSyncConfiguration(_){if(!this.profile.isDefault)return{};const F=this.configurationService.getValue(s.USER_DATA_SYNC_CONFIGURATION_SCOPE),N=this.enabled.find(L=>L instanceof n.SettingsSynchroniser);if(N){const L=await N.getRemoteUserDataSyncConfiguration(_);return{...F,...L}}return F}setStatus(_){this._status!==_&&(this._status=_,this._onDidChangeStatus.fire(_))}updateStatus(){return this.updateConflicts(),this.enabled.some(_=>_.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(_=>_.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const _=this.enabled.filter(F=>F.status==="hasConflicts").filter(F=>F.conflicts.conflicts.length>0).map(F=>F.conflicts);(0,D.equals)(this._conflicts,_,(F,N)=>F.syncResource===N.syncResource&&(0,D.equals)(F.conflicts,N.conflicts,(L,U)=>(0,P.isEqual)(L.previewResource,U.previewResource)))||(this._conflicts=_,this._onDidChangeConflicts.fire(_))}getOrder(_){switch(_){case"profiles":return 0;case"settings":return 1;case"keybindings":return 2;case"snippets":return 3;case"tasks":return 4;case"globalState":return 5;case"extensions":return 6}}};g=ve([G(2,s.IUserDataSyncEnablementService),G(3,f.IInstantiationService),G(4,v.IExtensionGalleryService),G(5,s.IUserDataSyncStoreManagementService),G(6,u.ITelemetryService),G(7,s.IUserDataSyncLogService),G(8,m.IProductService),G(9,S.IUserDataProfilesService),G(10,E.IConfigurationService),G(11,p.IEnvironmentService)],g);function C(V){if(V instanceof s.UserDataSyncError)switch(V.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function A(V,_,F,N){N.publicLog2("sync/error",{code:V.code,serverCode:V instanceof s.UserDataSyncStoreError?String(V.serverCode):void 0,url:V instanceof s.UserDataSyncStoreError?V.url:void 0,resource:V.resource,executionId:_,service:F.userDataSyncStore.url.toString()})}}),define(se[274],oe([0,1,3,2,8,21,26]),function(Z,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function I(p,v){return{...p,profile:(0,k.reviveProfile)(p.profile,v.profilesHome.scheme)}}function P(p){return{created:p.created,uri:R.URI.revive(p.uri)}}class w{constructor(v,f,m){this.service=v,this.userDataProfilesService=f,this.logService=m,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(v,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(v,f,m){try{return await this._call(v,f,m)}catch(y){throw this.logService.error(y),y}}async _call(v,f,m){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(R.URI.revive(m[0]));case"accept":return this.service.accept(I(m[0],this.userDataProfilesService),R.URI.revive(m[1]),m[2],m[3]);case"getRemoteProfiles":return this.service.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(m[0],(0,k.reviveProfile)(m[1],this.userDataProfilesService.profilesHome.scheme));case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(m[0],m[1]);case"replace":return this.service.replace(P(m[0]));case"getAssociatedResources":return this.service.getAssociatedResources(P(m[0]));case"getMachineId":return this.service.getMachineId(P(m[0]));case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const y=f.substring(11),u=m[0],S=this.getManualSyncTask(u);switch(m=m.slice(1),y){case"merge":return S.merge();case"apply":return S.apply();case"stop":return S.stop();case"dispose":return this.disposeManualSyncTask(S)}}throw new Error("Invalid call")}getManualSyncTask(v){const f=this.manualSyncTasks.get(this.createKey(v));if(!f)throw new Error(`Manual sync taks not found: ${v}`);return f.manualSyncTask}async createManualSyncTask(){const v=new i.DisposableStore,f=v.add(await this.service.createManualSyncTask());return this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:v}),f.id}disposeManualSyncTask(v){v.dispose();const f=this.createKey(v.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(v){return`manualSyncTask-${v}`}}e.UserDataSyncChannel=w;let b=class extends i.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(v,f){super(),this.userDataProfilesService=f,this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(m,y,u){return v.call(m,y,u).then(null,S=>{throw T.UserDataSyncError.toUserDataSyncError(S)})},listen(m,y){return v.listen(m,y)}},this.channel.call("_getInitialData").then(([m,y,u])=>{this.updateStatus(m),this.updateConflicts(y),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(m=>this.updateConflicts(m))),this._register(this.channel.listen("onSyncErrors")(m=>this._onSyncErrors.fire(m.map(y=>({...y,error:T.UserDataSyncError.toUserDataSyncError(y.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const v=await this.channel.call("createManualSyncTask"),f=this;return new E(v,{async call(y,u,S){return f.channel.call(`manualSync/${y}`,[v,...Array.isArray(u)?u:[u]],S)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(v,f,m,y){return this.channel.call("accept",[v,f,m,y])}resolveContent(v){return this.channel.call("resolveContent",[v])}getRemoteProfiles(){return this.channel.call("getRemoteProfiles")}async getLocalSyncResourceHandles(v,f){return(await this.channel.call("getLocalSyncResourceHandles",[v,f])).map(({created:y,uri:u})=>({created:y,uri:R.URI.revive(u)}))}async getRemoteSyncResourceHandles(v,f){return(await this.channel.call("getRemoteSyncResourceHandles",[v,f])).map(({created:y,uri:u})=>({created:y,uri:R.URI.revive(u)}))}async getAssociatedResources(v){return(await this.channel.call("getAssociatedResources",[v])).map(({resource:m,comparableResource:y})=>({resource:R.URI.revive(m),comparableResource:R.URI.revive(y)}))}getMachineId(v){return this.channel.call("getMachineId",[v])}replace(v){return this.channel.call("replace",[v])}async updateStatus(v){this._status=v,this._onDidChangeStatus.fire(v)}async updateConflicts(v){this._conflicts=v.map(f=>({syncResource:f.syncResource,profile:(0,k.reviveProfile)(f.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:f.conflicts.map(m=>({...m,baseResource:R.URI.revive(m.baseResource),localResource:R.URI.revive(m.localResource),remoteResource:R.URI.revive(m.remoteResource),previewResource:R.URI.revive(m.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(v){this._lastSyncTime!==v&&(this._lastSyncTime=v,this._onDidChangeLastSyncTime.fire(v))}};b=ve([G(1,k.IUserDataProfilesService)],b),e.UserDataSyncChannelClient=b;class E extends i.Disposable{constructor(v,f){super(),this.id=v,this.channel=f}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(se[275],oe([0,1,6,22,11,3,2,139,5,20,15,8,30,16,13,14,25,47,44,18,26]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u,S,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const d="sync.previous.store",n="sync.donot-make-requests-until",o="sync.user-session-id",t="sync.machine-session-id",r=100,s=1e3*60*5;let l=class extends T.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(h.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(_){this.storageService.store(h.SYNC_SERVICE_URL_TYPE,_,-1,P.isWeb?0:1)}constructor(_,F,N){super(),this.productService=_,this.configurationService=F,this.storageService=N,this._onDidChangeUserDataSyncStore=this._register(new k.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(k.Event.filter(N.onDidChangeValue,L=>L.key===h.SYNC_SERVICE_URL_TYPE&&L.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[h.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(h.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(_,F){_=P.isWeb&&_?.web?{..._,..._.web}:_;const N={..._||{},...F||{}};if(N&&(0,b.isString)(N.url)&&(0,b.isObject)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(L=>Array.isArray(N.authenticationProviders[L].scopes))){const L=N,U=!!L.canSwitch&&!F?.url,$=L.url===L.insidersUrl?"insiders":"stable",H=(U?this.userDataSyncStoreType:void 0)||$,q=F?.url||(H==="insiders"?L.insidersUrl:H==="stable"?L.stableUrl:L.url);return{url:E.URI.parse(q),type:H,defaultType:$,defaultUrl:E.URI.parse(L.url),stableUrl:E.URI.parse(L.stableUrl),insidersUrl:E.URI.parse(L.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(L.authenticationProviders).reduce((x,W)=>(x.push({id:W,scopes:L.authenticationProviders[W].scopes}),x),[])}}}};l=ve([G(0,y.IProductService),G(1,v.IConfigurationService),G(2,c.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let a=class extends l{constructor(_,F,N){super(_,F,N);const L=this.storageService.get(d,-1);L&&(this.previousConfigurationSyncStore=JSON.parse(L));const U=this.productService[h.CONFIGURATION_SYNC_STORE_KEY];U?this.storageService.store(d,JSON.stringify(U),-1,1):this.storageService.remove(d,-1)}async switch(_){_!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=_,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=ve([G(0,y.IProductService),G(1,v.IConfigurationService),G(2,c.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let g=class extends T.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(_,F,N,L,U,$,H){super(),this.requestService=N,this.logService=L,this.storageService=H,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new k.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new k.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(_),this.commonHeadersPromise=(0,S.getServiceMachineId)(U,$,H).then(q=>{const x={"X-Client-Name":`${F.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(x["X-Client-Commit"]=F.commit),x}),this.session=new A(r,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(_,F){this.authToken={token:_,type:F}}updateUserDataSyncStoreUrl(_){this.userDataSyncStoreUrl=_?(0,w.joinPath)(_,"v1"):void 0}initDonotMakeRequestsUntil(){const _=this.storageService.getNumber(n,-1);_&&Date.now()<_&&this.setDonotMakeRequestsUntil(new Date(_))}setDonotMakeRequestsUntil(_){this._donotMakeRequestsUntil?.getTime()!==_?.getTime()&&(this._donotMakeRequestsUntil=_,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(n,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(F=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(n,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(_={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,w.joinPath)(this.userDataSyncStoreUrl,"collection").toString();_={..._},_["Content-Type"]="application/json";const N=await this.request(F,{type:"GET",headers:_},[],i.CancellationToken.None);return await(0,u.asJson)(N)||[]}async createCollection(_={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,w.joinPath)(this.userDataSyncStoreUrl,"collection").toString();_={..._},_["Content-Type"]=I.Mimes.text;const N=await this.request(F,{type:"POST",headers:_},[],i.CancellationToken.None),L=await(0,u.asTextOrError)(N);if(!L)throw new h.UserDataSyncStoreError("Server did not return the collection id",F,"NoCollection",N.res.statusCode,N.res.headers[h.HEADER_OPERATION_ID]);return L}async deleteCollection(_,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=_?(0,w.joinPath)(this.userDataSyncStoreUrl,"collection",_).toString():(0,w.joinPath)(this.userDataSyncStoreUrl,"collection").toString();F={...F},await this.request(N,{type:"DELETE",headers:F},[],i.CancellationToken.None)}async getAllResourceRefs(_,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=this.getResourceUrl(this.userDataSyncStoreUrl,F,_),L={},U=await this.request(N.toString(),{type:"GET",headers:L},[],i.CancellationToken.None);return(await(0,u.asJson)(U)||[]).map(({url:H,created:q})=>({ref:(0,w.relativePath)(N,N.with({path:H})),created:q*1e3}))}async resolveResourceContent(_,F,N,L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,w.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,N,_),F).toString();L={...L},L["Cache-Control"]="no-cache";const $=await this.request(U,{type:"GET",headers:L},[],i.CancellationToken.None);return await(0,u.asTextOrError)($)}async deleteResource(_,F,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=F!==null?(0,w.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,N,_),F).toString():this.getResourceUrl(this.userDataSyncStoreUrl,N,_).toString(),U={};await this.request(L,{type:"DELETE",headers:U},[],i.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":I.Mimes.text};await this.request(_,{type:"DELETE",headers:F},[],i.CancellationToken.None)}async readResource(_,F,N,L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,w.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,N,_),"latest").toString();L={...L},L["Cache-Control"]="no-cache",F&&(L["If-None-Match"]=F.ref);const $=await this.request(U,{type:"GET",headers:L},[304],i.CancellationToken.None);let H=null;if($.res.statusCode===304&&(H=F),H===null){const q=$.res.headers.etag;if(!q)throw new h.UserDataSyncStoreError("Server did not return the ref",U,"NoRef",$.res.statusCode,$.res.headers[h.HEADER_OPERATION_ID]);const x=await(0,u.asTextOrError)($);if(!x&&$.res.statusCode===304)throw new h.UserDataSyncStoreError("Empty response",U,"EmptyResponse",$.res.statusCode,$.res.headers[h.HEADER_OPERATION_ID]);H={ref:q,content:x}}return H}async writeResource(_,F,N,L,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=this.getResourceUrl(this.userDataSyncStoreUrl,L,_).toString();U={...U},U["Content-Type"]=I.Mimes.text,N&&(U["If-Match"]=N);const H=await this.request($,{type:"POST",data:F,headers:U},[],i.CancellationToken.None),q=H.res.headers.etag;if(!q)throw new h.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",H.res.statusCode,H.res.headers[h.HEADER_OPERATION_ID]);return q}async manifest(_,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,w.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",_&&(F["If-None-Match"]=_.ref);const L=await this.request(N,{type:"GET",headers:F},[304],i.CancellationToken.None);let U=null;if(L.res.statusCode===304&&(U=_),!U){const H=L.res.headers.etag;if(!H)throw new h.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",L.res.statusCode,L.res.headers[h.HEADER_OPERATION_ID]);const q=await(0,u.asTextOrError)(L);if(!q&&L.res.statusCode===304)throw new h.UserDataSyncStoreError("Empty response",N,"EmptyResponse",L.res.statusCode,L.res.headers[h.HEADER_OPERATION_ID]);q&&(U={...JSON.parse(q),ref:H})}const $=this.storageService.get(o,-1);return $&&U&&$!==U.session&&this.clearSession(),U===null&&$&&this.clearSession(),U&&this.storageService.store(o,U.session,-1,1),U}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteResources(),await this.deleteCollection(),this.clearSession()}getResourceUrl(_,F,N){return F?(0,w.joinPath)(_,"collection",F,"resource",N):(0,w.joinPath)(_,"resource",N)}clearSession(){this.storageService.remove(o,-1),this.storageService.remove(t,-1)}async request(_,F,N,L){if(!this.authToken)throw new h.UserDataSyncStoreError("No Auth Token Available",_,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new h.UserDataSyncStoreError(`${F.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const U=await this.commonHeadersPromise;F.headers={...F.headers||{},...U,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:_,type:F.type,headers:{...F.headers,authorization:void 0}});let $;try{$=await this.session.request(_,F,L)}catch(W){if(!(W instanceof h.UserDataSyncStoreError)){let j="RequestFailed";const K=(0,R.getErrorMessage)(W).toLowerCase();K.includes("xhr timeout")?j="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?j="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":K.includes("headers must be an object")?j="RequestHeadersNotObject":(0,R.isCancellationError)(W)&&(j="RequestCanceled"),W=new h.UserDataSyncStoreError(`Connection refused for the request '${_}'.`,_,j,void 0,void 0)}throw this.logService.info("Request failed",_),W}const H=$.res.headers[h.HEADER_OPERATION_ID],q={url:_,status:$.res.statusCode,"execution-id":F.headers[h.HEADER_EXECUTION_ID],"operation-id":H},x=(0,u.isSuccess)($)||$.res.statusCode&&N.indexOf($.res.statusCode)!==-1;if(x?this.logService.trace("Request succeeded",q):this.logService.info("Request failed",q),$.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new h.UserDataSyncStoreError(`Request '${_}' failed because of Unauthorized (401).`,_,"Unauthorized",$.res.statusCode,H);if(this._onTokenSucceed.fire(),$.res.statusCode===409)throw new h.UserDataSyncStoreError(`${F.type} request '${_}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,_,"Conflict",$.res.statusCode,H);if($.res.statusCode===410)throw new h.UserDataSyncStoreError(`${F.type} request '${_}' failed because the requested resource is not longer available (410).`,_,"Gone",$.res.statusCode,H);if($.res.statusCode===412)throw new h.UserDataSyncStoreError(`${F.type} request '${_}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,_,"PreconditionFailed",$.res.statusCode,H);if($.res.statusCode===413)throw new h.UserDataSyncStoreError(`${F.type} request '${_}' failed because of too large payload (413).`,_,"TooLarge",$.res.statusCode,H);if($.res.statusCode===426)throw new h.UserDataSyncStoreError(`${F.type} request '${_}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,_,"UpgradeRequired",$.res.statusCode,H);if($.res.statusCode===429){const W=$.res.headers["retry-after"];throw W?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(W)*1e3)),new h.UserDataSyncStoreError(`${F.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",$.res.statusCode,H)):new h.UserDataSyncStoreError(`${F.type} request '${_}' failed because of too many requests (429).`,_,"RemoteTooManyRequests",$.res.statusCode,H)}if(!x)throw new h.UserDataSyncStoreError("Server returned "+$.res.statusCode,_,"Unknown",$.res.statusCode,H);return $}addSessionHeaders(_){let F=this.storageService.get(t,-1);F===void 0&&(F=(0,p.generateUuid)(),this.storageService.store(t,F,-1,1)),_["X-Machine-Session-Id"]=F;const N=this.storageService.get(o,-1);N!==void 0&&(_["X-User-Session-Id"]=N)}};g=ve([G(1,y.IProductService),G(2,u.IRequestService),G(3,h.IUserDataSyncLogService),G(4,f.IEnvironmentService),G(5,m.IFileService),G(6,c.IStorageService)],g),e.UserDataSyncStoreClient=g;let C=class extends g{constructor(_,F,N,L,U,$,H){super(_.userDataSyncStore?.url,F,N,L,U,$,H),this._register(_.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(_.userDataSyncStore?.url)))}};C=ve([G(0,h.IUserDataSyncStoreManagementService),G(1,y.IProductService),G(2,u.IRequestService),G(3,h.IUserDataSyncLogService),G(4,f.IEnvironmentService),G(5,m.IFileService),G(6,c.IStorageService)],C),e.UserDataSyncStoreService=C;class A{constructor(_,F,N,L){this.limit=_,this.interval=F,this.requestService=N,this.logService=L,this.requests=[],this.startTime=void 0}request(_,F,N){if(this.isExpired()&&this.reset(),F.url=_,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new h.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,_,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(_),this.requestService.request(F,N)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(se[276],oe([0,1,3,58,25,18,24,271,26,76,79]),function(Z,e,D,i,R,k,T,I,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends I.UserDataAutoSyncService{constructor(v,f,m,y,u,S,c,h,d,n,o){super(v,f,m,y,u,c,h,d,n,o),this._register(D.Event.debounce(D.Event.any(D.Event.map(S.onDidFocusWindow,()=>"windowFocus"),D.Event.map(S.onDidOpenWindow,()=>"windowOpen")),(t,r)=>t?[...t,r]:[r],1e3)(t=>this.triggerSync(t,!0,!1)))}};E=ve([G(0,R.IProductService),G(1,P.IUserDataSyncStoreManagementService),G(2,P.IUserDataSyncStoreService),G(3,P.IUserDataSyncEnablementService),G(4,P.IUserDataSyncService),G(5,i.INativeHostService),G(6,P.IUserDataSyncLogService),G(7,w.IUserDataSyncAccountService),G(8,T.ITelemetryService),G(9,b.IUserDataSyncMachinesService),G(10,k.IStorageService)],E),e.UserDataAutoSyncService=E}),define(se[277],oe([0,1,3,2,57,7,62,18,74,21]),function(Z,e,D,i,R,k,T,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncProfilesStorageService=void 0;let b=class extends T.AbstractUserDataSyncProfilesStorageService{constructor(p,v,f,m){super(f),this.mainProcessService=p;const y=p.getChannel("profileStorageListener"),u=this._register(new i.MutableDisposable);this._onDidChange=this._register(new D.Emitter({onWillAddFirstListener:()=>{u.value=y.listen("onDidChange")(S=>{m.trace("profile storage changes",S),this._onDidChange.fire({targetChanges:S.targetChanges.map(c=>(0,w.reviveProfile)(c,v.profilesHome.scheme)),valueChanges:S.valueChanges.map(c=>({...c,profile:(0,w.reviveProfile)(c.profile,v.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(p){const v=this.mainProcessService.getChannel("storage");return(0,I.isProfileUsingDefaultStorage)(p)?new P.ApplicationStorageDatabaseClient(v):new P.ProfileStorageDatabaseClient(v,p)}};b=ve([G(0,R.IMainProcessService),G(1,w.IUserDataProfilesService),G(2,I.IStorageService),G(3,k.ILogService)],b),e.UserDataSyncProfilesStorageService=b}),define(se[278],oe([0,1,99,23,5,20]),function(Z,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(w){function b(){let E=w.scheme===i.Schemas.file?(0,k.originalFSPath)(w):w.toString();return R.isLinux||(E=E.toLowerCase()),(0,D.createHash)("md5").update(E).digest("hex")}return{id:b(),configPath:w}}e.getWorkspaceIdentifier=T;function I(w,b){function E(){if(w.scheme!==i.Schemas.file)return(0,D.createHash)("md5").update(w.toString()).digest("hex");if(!b)return;let v;return R.isLinux?v=b.ino:R.isMacintosh?v=b.birthtime.getTime():R.isWindows&&(typeof b.birthtimeMs=="number"?v=Math.floor(b.birthtimeMs):v=b.birthtime.getTime()),(0,D.createHash)("md5").update(w.fsPath).update(v?String(v):"").digest("hex")}const p=E();if(typeof p=="string")return{id:p,uri:w}}e.getSingleFolderWorkspaceIdentifier=I;function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=P}),define(se[279],oe([0,1,6,11,2,12,28,13,57,7,58,74,116,278]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let f=class extends R.Disposable{constructor(y,u,S,c){super(),this.environmentService=y,this.logService=u,this.nativeHostService=S,this.mainProcessService=c,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const y=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),u=new E.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(y.map(async S=>{const c=(0,k.join)(this.environmentService.workspaceStorageHome.fsPath,S);S.length===v.NON_EMPTY_WORKSPACE_ID_LENGTH||S===p.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(n=>n.workspace?.id===S)||await u.isUsed(c)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${S} as it seems to be an unused empty workspace.`),await T.Promises.rm(c))}))}catch(y){(0,i.onUnexpectedError)(y)}}};f=ve([G(0,I.INativeEnvironmentService),G(1,w.ILogService),G(2,b.INativeHostService),G(3,P.IMainProcessService)],f),e.UnusedWorkspaceStorageDataCleaner=f}),define(se[125],oe([0,1,53,6,12,15,28,151,288,289]),function(Z,e,D,i,R,k,T,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class b extends Error{constructor(n,o){let t=o.message;switch(n){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=n,this.cause=o}}e.ExtractError=b;function E(d){const n=d.externalFileAttributes>>16||33188;return[448,56,7].map(o=>n&o).reduce((o,t)=>o+t,n&61440)}function p(d){if(d instanceof b)return d;let n;return/end of central directory record signature not found/.test(d.message)&&(n="CorruptZip"),new b(n,d)}function v(d,n,o,t,r,s){const l=R.dirname(n),a=R.join(t,l);if(!a.startsWith(t))return Promise.reject(new Error(I.localize(0,null,n)));const g=R.join(t,n);let C;return s.onCancellationRequested(()=>{C?.destroy()}),Promise.resolve(T.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((A,V)=>{if(!s.isCancellationRequested)try{C=(0,D.createWriteStream)(g,{mode:o}),C.once("close",()=>A()),C.once("error",V),d.once("error",V),d.pipe(C)}catch(_){V(_)}}))}function f(d,n,o,t){let r=(0,i.createCancelablePromise)(()=>Promise.resolve()),s=0;return t.onCancellationRequested(()=>{r.cancel(),d.close()}),new Promise((l,a)=>{const g=new i.Sequencer,C=A=>{A.isCancellationRequested||(s++,d.readEntry())};d.once("error",a),d.once("close",()=>r.then(()=>{t.isCancellationRequested||d.entryCount===s?l():a(new b("Incomplete",new Error(I.localize(1,null,s,d.entryCount))))},a)),d.readEntry(),d.on("entry",A=>{if(t.isCancellationRequested)return;if(!o.sourcePathRegex.test(A.fileName)){C(t);return}const V=A.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(V)){const N=R.join(n,V);r=(0,i.createCancelablePromise)(L=>T.Promises.mkdir(N,{recursive:!0}).then(()=>C(L)).then(void 0,a));return}const _=y(d,A),F=E(A);r=(0,i.createCancelablePromise)(N=>g.queue(()=>_.then(L=>v(L,V,F,n,o,N).then(()=>C(N)))).then(null,a))})})}function m(d,n=!1){return new Promise((o,t)=>{(0,P.open)(d,n?{lazyEntries:!0}:void 0,(r,s)=>{r?t(p(r)):o((0,k.assertIsDefined)(s))})})}function y(d,n){return new Promise((o,t)=>{d.openReadStream(n,(r,s)=>{r?t(p(r)):o((0,k.assertIsDefined)(s))})})}function u(d,n){return new Promise((o,t)=>{const r=new w.ZipFile;n.forEach(l=>{l.contents?r.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&r.addFile(l.localPath,l.path)}),r.end();const s=(0,D.createWriteStream)(d);r.outputStream.pipe(s),r.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>o(d))})}e.zip=u;function S(d,n,o={},t){const r=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let s=m(d,!0);return o.overwrite&&(s=s.then(l=>T.Promises.rm(n).then(()=>l))),s.then(l=>f(l,n,{sourcePathRegex:r},t))}e.extract=S;function c(d,n){return m(d).then(o=>new Promise((t,r)=>{o.on("entry",s=>{s.fileName===n&&y(o,s).then(l=>t(l),l=>r(l))}),o.once("close",()=>r(new Error(I.localize(2,null,n))))}))}function h(d,n){return c(d,n).then(o=>new Promise((t,r)=>{const s=[];o.once("error",r),o.on("data",l=>s.push(l)),o.on("end",()=>t(Buffer.concat(s)))}))}e.buffer=h}),define(se[280],oe([0,1,125,161]),function(Z,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(k){return(0,D.buffer)(k,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=R}),define(se[126],oe([0,1,6,17,22,38,11,3,2,37,23,12,5,20,54,15,8,30,28,125,160,96,13,262,29,33,60,77,217,263,280,218,219,46,70,14,4,7,25,24,31,21]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u,S,c,h,d,n,o,t,r,s,l,a,g,C,A,V,_,F,N,L,U,$,H,q,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,L.refineServiceDecorator)(t.IExtensionManagementService);let W=class extends o.AbstractExtensionManagementService{constructor(O,B,z,Y,ne,X,te,re,le,ue,Se,we){super(O,B,z,ue,we),this.extensionsScannerService=ne,this.extensionsProfileScannerService=X,this.downloadService=te,this.fileService=le,this.uriIdentityService=Se,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new w.ResourceSet;const Ee=this._register(re.createInstance(g.ExtensionsLifecycle));this.extensionsScanner=this._register(re.createInstance(j,Ae=>Ee.postUninstall(Ae))),this.manifestCache=this._register(new A.ExtensionsManifestCache(Y,this)),this.extensionsDownloader=this._register(re.createInstance(a.ExtensionsDownloader));const Ce=this._register(new V.ExtensionsWatcher(this,we,X,Se,le,z));this._register(Ce.onDidChangeExtensionsByAnotherSource(Ae=>this.onDidChangeExtensionsFromAnotherSource(Ae))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,r.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(O){this.logService.trace("ExtensionManagementService#zip",O.identifier.id);const B=await this.collectFiles(O),z=await(0,c.zip)((0,v.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,B);return y.URI.file(z)}async unzip(O){return this.logService.trace("ExtensionManagementService#unzip",O.toString()),(await this.install(O)).identifier}async getManifest(O){const{location:B,cleanup:z}=await this.downloadVsix(O),Y=E.resolve(B.fsPath);try{return await(0,C.getManifest)(Y)}finally{await z()}}getInstalled(O,B){return this.extensionsScanner.scanExtensions(O??null,B)}getAllUserInstalled(){return this.extensionsScanner.scanAllUserExtensions(!1)}async install(O,B={}){this.logService.trace("ExtensionManagementService#install",O.toString());const{location:z,cleanup:Y}=await this.downloadVsix(O);try{const ne=await(0,C.getManifest)(E.resolve(z.fsPath));if(ne.engines&&ne.engines.vscode&&!(0,F.isEngineValid)(ne.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,r.getGalleryExtensionId)(ne.publisher,ne.name),this.productService.version));return await this.installExtension(ne,z,B)}finally{await Y()}}getMetadata(O){return this.extensionsScannerService.scanMetadata(O.location)}async updateMetadata(O,B){this.logService.trace("ExtensionManagementService#updateMetadata",O.identifier.id);const z={...B};return B.isPreReleaseVersion&&(z.preRelease=!0),O=await this.extensionsScanner.updateMetadata(O,z),this.manifestCache.invalidate(),O}async updateExtensionScope(O,B){return this.logService.trace("ExtensionManagementService#updateExtensionScope",O.identifier.id),O=await this.extensionsScanner.updateMetadata(O,{isMachineScoped:B}),this.manifestCache.invalidate(),O}async reinstallFromGallery(O){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",O.identifier.id),!this.galleryService.isEnabled())throw new Error(h.localize(1,null));const B=await this.getTargetPlatform(),[z]=await this.galleryService.getExtensions([{...O.identifier,preRelease:O.preRelease}],{targetPlatform:B,compatible:!0},R.CancellationToken.None);if(!z)throw new Error(h.localize(2,null));await this.extensionsScanner.setUninstalled(O);try{await this.extensionsScanner.removeUninstalledExtension(O)}catch(Y){throw new Error(h.localize(3,null,(0,k.toErrorMessage)(Y)))}await this.installFromGallery(z)}markAsUninstalled(...O){return this.extensionsScanner.setUninstalled(...O)}removeUninstalledExtensions(){return this.extensionsScanner.cleanUp()}migrateDefaultProfileExtensions(){return this.extensionsScanner.migrateDefaultProfileExtensions()}async download(O,B){const{location:z}=await this.extensionsDownloader.download(O,B);return z}async downloadVsix(O){if(O.scheme===b.Schemas.file)return{location:O,async cleanup(){}};this.logService.trace("Downloading extension from",O.toString());const B=(0,v.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,u.generateUuid)());return await this.downloadService.download(O,B),this.logService.info("Downloaded extension to",B.toString()),{location:B,cleanup:async()=>{try{await this.fileService.del(B)}catch(Y){this.logService.error(Y)}}}}createInstallExtensionTask(O,B,z){let Y;if(y.URI.isUri(B))Y=new ce(O,B,z,this.galleryService,this.extensionsScanner,this.logService);else{const ne=r.ExtensionKey.create(B).toString();Y=this.installGalleryExtensionsTasks.get(ne),Y||(this.installGalleryExtensionsTasks.set(ne,Y=new ee(O,B,z,this.extensionsDownloader,this.extensionsScanner,this.logService)),Y.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(ne)))}return new J(Y,z.profileLocation,this.extensionsProfileScannerService)}createUninstallExtensionTask(O,B){return new Q(O,B.profileLocation,this.extensionsProfileScannerService)}async collectFiles(O){const B=async Y=>{let ne=await S.Promises.readdir(Y);ne=ne.map(re=>E.join(Y,re));const X=await Promise.all(ne.map(re=>S.Promises.stat(re)));let te=Promise.resolve([]);return X.forEach((re,le)=>{const ue=ne[le];re.isFile()&&(te=te.then(Se=>[...Se,ue])),re.isDirectory()&&(te=te.then(Se=>B(ue).then(we=>[...Se,...we])))}),te};return(await B(O.location.fsPath)).map(Y=>({path:`extension/${E.relative(O.location.fsPath,Y)}`,localPath:Y}))}async onDidChangeExtensionsFromAnotherSource({added:O,removed:B}){if(B)for(const z of B.extensions)this._onDidUninstallExtension.fire({identifier:z,profileLocation:B.profileLocation});if(O){const Y=(await this.extensionsScanner.scanExtensions(1,O.profileLocation)).filter(ne=>O.extensions.some(X=>(0,r.areSameExtensions)(X,ne.identifier)));this._onDidInstallExtensions.fire(Y.map(ne=>({identifier:ne.identifier,local:ne,profileLocation:O.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(B=>this.knownDirectories.add(B)));const O=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const B of O.children??[])B.isDirectory&&this.knownDirectories.add(B.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(B=>this.onDidFilesChange(B)))}async onDidFilesChange(O){const B=[];for(const z of O.rawAdded){if(this.knownDirectories.has(z)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(z),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(z,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(z).startsWith(".")||!(await this.fileService.stat(z)).isDirectory)continue;const Y=await this.extensionsScanner.scanUserExtensionAtLocation(z);Y&&Y.installedTimestamp===void 0&&(this.knownDirectories.add(z),B.push(Y))}B.length&&(await this.extensionsProfileScannerService.addExtensionsToProfile(B.map(z=>[z,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this._onDidInstallExtensions.fire(B.map(z=>({local:z,version:z.manifest.version,identifier:z.identifier,operation:1,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}))))}};W=ve([G(0,t.IExtensionGalleryService),G(1,H.ITelemetryService),G(2,U.ILogService),G(3,n.INativeEnvironmentService),G(4,l.IExtensionsScannerService),G(5,s.IExtensionsProfileScannerService),G(6,d.IDownloadService),G(7,L.IInstantiationService),G(8,N.IFileService),G(9,$.IProductService),G(10,q.IUriIdentityService),G(11,x.IUserDataProfilesService)],W),e.ExtensionManagementService=W;let j=class extends P.Disposable{constructor(O,B,z,Y,ne,X){super(),this.beforeRemovingExtension=O,this.fileService=B,this.extensionsScannerService=z,this.userDataProfilesService=Y,this.extensionsProfileScannerService=ne,this.logService=X,this._onExtract=this._register(new I.Emitter),this.onExtract=this._onExtract.event,this._migrateDefaultProfileExtensionsPromise=void 0,this.uninstalledPath=(0,v.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions()}async scanExtensions(O,B){await this.migrateDefaultProfileExtensions();const z={includeInvalid:!0,profileLocation:B};let Y=[];return O===null||O===0?Y.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},z,!1)):O===1&&Y.push(...await this.extensionsScannerService.scanUserExtensions(z)),Y=O!==null?Y.filter(ne=>ne.type===O):Y,Promise.all(Y.map(ne=>this.toLocalExtension(ne)))}async scanAllUserExtensions(O){const B=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!O,includeInvalid:!0});return Promise.all(B.map(z=>this.toLocalExtension(z)))}async scanUserExtensionAtLocation(O){try{const B=await this.extensionsScannerService.scanExistingExtension(O,1,{includeInvalid:!0});if(B)return await this.toLocalExtension(B)}catch(B){this.logService.error(B)}return null}async extractUserExtension(O,B,z,Y){await this.migrateDefaultProfileExtensions();const ne=O.toString(),X=E.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),te=E.join(this.extensionsScannerService.userExtensionsLocation.fsPath,ne);try{await S.Promises.rm(te)}catch{throw new t.ExtensionManagementError(h.localize(4,null,te,O.id),t.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(O,B,X,Y),await this.extensionsScannerService.updateMetadata(y.URI.file(X),z);try{this._onExtract.fire(y.URI.file(te)),await this.rename(O,X,te,Date.now()+2*60*1e3),this.logService.info("Renamed to",te)}catch(re){try{await S.Promises.rm(X)}catch{}if(re.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",O.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(re)}. Deleted from extracted location`,X),re}return this.scanLocalExtension(y.URI.file(te),1)}async updateMetadata(O,B){return await this.extensionsScannerService.updateMetadata(O.location,B),this.scanLocalExtension(O.location,O.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...O){const B=O.map(z=>r.ExtensionKey.create(z));await this.withUninstalledExtensions(z=>B.forEach(Y=>{z[Y.toString()]=!0,this.logService.info("Marked extension as uninstalled",Y.toString())}))}async setInstalled(O){await this.withUninstalledExtensions(Y=>delete Y[O.toString()]);const z=(await this.scanAllUserExtensions(!0)).find(Y=>r.ExtensionKey.create(Y).equals(O))||null;return z?this.updateMetadata(z,{installedTimestamp:Date.now()}):null}async removeExtension(O,B){this.logService.trace(`Deleting ${B} extension from disk`,O.identifier.id,O.location.fsPath),await S.Promises.rm(O.location.fsPath),this.logService.info("Deleted from disk",O.identifier.id,O.location.fsPath)}async removeUninstalledExtension(O){await this.removeExtension(O,"uninstalled"),await this.withUninstalledExtensions(B=>delete B[r.ExtensionKey.create(O).toString()])}async withUninstalledExtensions(O){return this.uninstalledFileLimiter.queue(async()=>{let B;try{B=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(Y){if(Y.code!=="ENOENT")throw Y}let z={};if(B)try{z=JSON.parse(B)}catch{}return O&&(O(z),Object.keys(z).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(z)):await S.Promises.rm(this.uninstalledPath)),z})}async extractAtLocation(O,B,z,Y){this.logService.trace(`Started extracting the extension from ${B} to ${z}`);try{await S.Promises.rm(z)}catch(ne){throw new t.ExtensionManagementError(this.joinErrors(ne).message,t.ExtensionManagementErrorCode.Delete)}try{await(0,c.extract)(B,z,{sourcePath:"extension",overwrite:!0},Y),this.logService.info(`Extracted extension to ${z}:`,O.id)}catch(ne){try{await S.Promises.rm(z)}catch{}let X=t.ExtensionManagementErrorCode.Extract;throw ne instanceof c.ExtractError&&(ne.type==="CorruptZip"?X=t.ExtensionManagementErrorCode.CorruptZip:ne.type==="Incomplete"&&(X=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(ne.message,X)}}async rename(O,B,z,Y){try{await S.Promises.rename(B,z)}catch(ne){if(p.isWindows&&ne&&ne.code==="EPERM"&&Date.now()<Y)return this.logService.info(`Failed renaming ${B} to ${z} with 'EPERM' error. Trying again...`,O.id),this.rename(O,B,z,Y);throw new t.ExtensionManagementError(ne.message||h.localize(5,null,B,z),ne.code||t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(O,B){const z=await this.extensionsScannerService.scanExistingExtension(O,B,{includeInvalid:!0});if(z)return this.toLocalExtension(z);throw new Error(h.localize(6,null,O.path))}async toLocalExtension(O){const B=await this.fileService.resolve(O.location);let z,Y;return B.children&&(z=B.children.find(({name:ne})=>/^readme(\.txt|\.md|)$/i.test(ne))?.resource,Y=B.children.find(({name:ne})=>/^changelog(\.txt|\.md|)$/i.test(ne))?.resource),{identifier:O.identifier,type:O.type,isBuiltin:O.isBuiltin||!!O.metadata?.isBuiltin,location:O.location,manifest:O.manifest,targetPlatform:O.targetPlatform,validations:O.validations,isValid:O.isValid,readmeUrl:z,changelogUrl:Y,publisherDisplayName:O.metadata?.publisherDisplayName||null,publisherId:O.metadata?.publisherId||null,isApplicationScoped:!!O.metadata?.isApplicationScoped,isMachineScoped:!!O.metadata?.isMachineScoped,isPreReleaseVersion:!!O.metadata?.isPreReleaseVersion,preRelease:!!O.metadata?.preRelease,installedTimestamp:O.metadata?.installedTimestamp,updated:!!O.metadata?.updated}}async removeUninstalledExtensions(){const O=await this.getUninstalledExtensions(),B=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),z=new Set;for(const X of B)O[r.ExtensionKey.create(X).toString()]||z.add(X.identifier.id.toLowerCase());const Y=(0,r.groupByExtension)(B,X=>X.identifier);await D.Promises.settled(Y.map(async X=>{const te=X.sort((re,le)=>f.rcompare(re.manifest.version,le.manifest.version))[0];z.has(te.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(te))}));const ne=B.filter(X=>O[r.ExtensionKey.create(X).toString()]);await D.Promises.settled(ne.map(X=>this.removeUninstalledExtension(X)))}migrateDefaultProfileExtensions(){return this._migrateDefaultProfileExtensionsPromise||(this._migrateDefaultProfileExtensionsPromise=(async()=>{try{const O=(0,v.joinPath)(this.userDataProfilesService.defaultProfile.location,".migrated-default-profile");if(await this.fileService.exists(O))return;if(!await this.fileService.exists(this.userDataProfilesService.defaultProfile.extensionsResource)){this.logService.info("Started migrating default profile extensions from extensions installation folder to extensions manifest.");const B=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(B.map(z=>[z,z.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Completed migrating default profile extensions from extensions installation folder to extensions manifest.")}try{await this.fileService.createFile(O,i.VSBuffer.fromString(""))}catch(B){this.logService.warn("Failed to create migration marker file for default profile extensions migration.",(0,T.getErrorMessage)(B))}}catch(O){throw this.logService.error(O),O}})()),this._migrateDefaultProfileExtensionsPromise}joinErrors(O){const B=Array.isArray(O)?O:[O];return B.length===1?B[0]instanceof Error?B[0]:new Error(B[0]):B.reduce((z,Y)=>new Error(`${z.message}${z.message?",":""}${Y instanceof Error?Y.message:Y}`),new Error(""))}};j=ve([G(1,N.IFileService),G(2,l.IExtensionsScannerService),G(3,x.IUserDataProfilesService),G(4,s.IExtensionsProfileScannerService),G(5,U.ILogService)],j),e.ExtensionsScanner=j;class K extends o.AbstractExtensionTask{get operation(){return(0,m.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(O,B,z,Y,ne){super(),this.identifier=O,this.source=B,this.options=z,this.extensionsScanner=Y,this.logService=ne,this.wasVerified=!1,this._operation=2}async installExtension(O,B){try{const z=await this.unsetUninstalledAndGetLocal(O.key);if(z)return this.extensionsScanner.updateMetadata(z,O.metadata)}catch{throw p.isMacintosh?new t.ExtensionManagementError(h.localize(7,null),t.ExtensionManagementErrorCode.Internal):new t.ExtensionManagementError(h.localize(8,null),t.ExtensionManagementErrorCode.Internal)}return this.extract(O,B)}async unsetUninstalledAndGetLocal(O){if(!await this.isUninstalled(O))return null;this.logService.trace("Removing the extension from uninstalled list:",O.id);const z=await this.extensionsScanner.setInstalled(O);return this.logService.info("Removed the extension from uninstalled list:",O.id),z}async isUninstalled(O){return!!(await this.extensionsScanner.getUninstalledExtensions())[O.toString()]}async extract({zipPath:O,key:B,metadata:z},Y){const ne=await this.extensionsScanner.extractUserExtension(B,O,z,Y);return this.logService.info("Extracting completed.",B.id),ne}}class ee extends K{constructor(O,B,z,Y,ne,X){super(B.identifier,B,z,ne,X),this.manifest=O,this.gallery=B,this.extensionsDownloader=Y}async doRun(O){const z=(await this.extensionsScanner.scanExtensions(null,void 0)).find(te=>(0,r.areSameExtensions)(te.identifier,this.gallery.identifier));z&&(this._operation=3);const Y={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,_.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||z?.isMachineScoped,isBuiltin:this.options.isBuiltin||z?.isBuiltin,isSystem:z?.type===0?!0:void 0,updated:!!z,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,m.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:z?.preRelease)};if(z?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(z,Y),metadata:Y};const{location:ne,verified:X}=await this.extensionsDownloader.download(this.gallery,this._operation);try{this.wasVerified=!!X,this.validateManifest(ne.fsPath);const te=await this.installExtension({zipPath:ne.fsPath,key:r.ExtensionKey.create(this.gallery),metadata:Y},O);return z&&!this.options.profileLocation&&(z.targetPlatform!==te.targetPlatform||f.neq(z.manifest.version,te.manifest.version))&&await this.extensionsScanner.setUninstalled(z),{local:te,metadata:Y}}catch(te){try{await this.extensionsDownloader.delete(ne)}catch(re){this.logService.warn("Error while deleting the downloaded file",ne.toString(),(0,T.getErrorMessage)(re))}throw te}}async validateManifest(O){try{await(0,C.getManifest)(O)}catch(B){throw new t.ExtensionManagementError((0,o.joinErrors)(B).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=ee;class ce extends K{constructor(O,B,z,Y,ne,X){super({id:(0,r.getGalleryExtensionId)(O.publisher,O.name)},B,z,ne,X),this.manifest=O,this.location=B,this.galleryService=Y}async doRun(O){const B=new r.ExtensionKey(this.identifier,this.manifest.version),Y=(await this.extensionsScanner.scanExtensions(1,void 0)).find(te=>(0,r.areSameExtensions)(this.identifier,te.identifier)),ne=await this.getMetadata(this.identifier.id,this.manifest.version,O);if(ne.isApplicationScoped=(0,_.isApplicationScopedExtension)(this.manifest),ne.isMachineScoped=this.options.isMachineScoped||Y?.isMachineScoped,ne.isBuiltin=this.options.isBuiltin||Y?.isBuiltin,ne.installedTimestamp=Date.now(),Y)if(this._operation=3,B.equals(new r.ExtensionKey(Y.identifier,Y.manifest.version)))try{await this.extensionsScanner.removeExtension(Y,"existing")}catch{throw new Error(h.localize(9,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&f.gt(Y.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(Y);else{const te=await this.unsetUninstalledAndGetLocal(B);if(te)try{await this.extensionsScanner.removeExtension(te,"existing")}catch{throw new Error(h.localize(10,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:E.resolve(this.location.fsPath),key:B,metadata:ne},O),metadata:ne}}async getMetadata(O,B,z){try{let[Y]=await this.galleryService.getExtensions([{id:O,version:B}],z);if(Y||([Y]=await this.galleryService.getExtensions([{id:O}],z)),Y)return{id:Y.identifier.uuid,publisherDisplayName:Y.publisherDisplayName,publisherId:Y.publisherId,isPreReleaseVersion:Y.properties.isPreReleaseVersion,preRelease:Y.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class J{constructor(O,B,z){this.task=O,this.profileLocation=B,this.extensionsProfileScannerService=z,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const O=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[O.local,O.metadata]],this.profileLocation),O}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class Q extends o.AbstractExtensionTask{constructor(O,B,z){super(),this.extension=O,this.profileLocation=B,this.extensionsProfileScannerService=z}async doRun(O){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(se[281],oe([0,1,2,29,78,216,126,7,18]),function(Z,e,D,i,R,k,T,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let w=class extends D.Disposable{constructor(E,p,v,f,m,y){super(),E.migrateDefaultProfileExtensions().then(()=>m.store(i.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY,!0,-1,1),u=>null),E.removeUninstalledExtensions(),(0,k.migrateUnsupportedExtensions)(E,p,v,f,y),R.ExtensionStorageService.removeOutdatedExtensionVersions(E,m)}};w=ve([G(0,T.INativeServerExtensionManagementService),G(1,i.IExtensionGalleryService),G(2,R.IExtensionStorageService),G(3,i.IGlobalExtensionEnablementService),G(4,P.IStorageService),G(5,I.ILogService)],w),e.ExtensionsContributions=w}),define(se[290],oe([0,1,92,34,38,11,2,23,20,8,39,149,209,210,202,203,279,191,194,16,214,95,234,96,225,13,231,117,265,29,97,193,266,126,98,189,14,205,207,55,4,200,71,201,57,72,220,7,102,58,103,25,47,18,267,109,24,110,111,112,51,239,113,241,247,78,115,26,76,269,258,259,79,270,273,274,275,276,277,62,260,108,233,75,249,222,248,107,230,31,250,5,251,195,212,211,77,264,21,60,208,59,268,228,238,261,235,106,101,272,281]),function(Z,e,D,i,R,k,T,I,P,w,b,E,p,v,f,m,y,u,S,c,h,d,n,o,t,r,s,l,a,g,C,A,V,_,F,N,L,U,$,H,q,x,W,j,K,ee,ce,J,Q,M,O,B,z,Y,ne,X,te,re,le,ue,Se,we,Ee,Ce,Ae,Ne,Ge,We,ae,fe,ge,be,Ie,Le,Re,Fe,_e,Me,ze,ke,Oe,ie,he,de,me,pe,Pe,De,Be,$e,Te,je,Ve,et,ot,pt,Lt,Tt,yt,wt,At,Et,_t,Ot,Ut,Mt,Nt,bt,Ct,Ft,$t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Wt extends T.Disposable{constructor(ye){super(),this.configuration=ye,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.lifecycleService=void 0,this.registerListeners()}registerListeners(){const ye=async()=>{this.lifecycleService&&(await this.lifecycleService.fireOnWillShutdown(),this.lifecycleService.dispose(),this.lifecycleService=void 0),this.dispose()};process.once("exit",ye),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Ue="vscode:electron-main->shared-process=disposeWorker",qe=(Ke,tt)=>{this.onDisposeWorker(tt)};D.ipcRenderer.on(Ue,qe),this._register((0,T.toDisposable)(()=>D.ipcRenderer.removeListener(Ue,qe)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,We.registerConfiguration)(),ye.invokeFunction(Ue=>{const qe=Ue.get(J.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(qe)}),this._register((0,T.combinedDisposable)(ye.createInstance(p.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(v.LanguagePackCachedDataCleaner),ye.createInstance(y.UnusedWorkspaceStorageDataCleaner),ye.createInstance(m.LogsDataCleaner),ye.createInstance(f.LocalizationsUpdater),ye.createInstance($t.ExtensionsContributions),ye.createInstance(Mt.UserDataProfilesCleaner)))}async initServices(){const ye=new W.ServiceCollection,Ue={_serviceBrand:void 0,...O.default};ye.set(B.IProductService,Ue);const qe=new b.StaticRouter(Xe=>Xe==="main"),Ke=new j.MessagePortMainProcessService(this.server,qe);ye.set(K.IMainProcessService,Ke);const tt=this.configuration.policiesData?new At.PolicyChannelClient(this.configuration.policiesData,Ke.getChannel("policy")):new Et.NullPolicyService;ye.set(Et.IPolicyService,tt);const He=new s.SharedProcessEnvironmentService(this.configuration.args,Ue);ye.set(r.INativeEnvironmentService,He);const lt=new Q.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),it=new Q.LoggerChannelClient(this.configuration.logLevel,lt.onDidChangeLogLevel,Ke.getChannel("logger"));ye.set(J.ILoggerService,it);const ht=this._register(new J.MultiplexLogService([this._register(new J.ConsoleLogger(this.configuration.logLevel)),this._register(it.createLogger((0,P.joinPath)(w.URI.file(He.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ye=this._register(new Q.FollowerLogService(lt,ht));ye.set(J.ILogService,Ye),this.lifecycleService=new Ct.SharedProcessLifecycleService(Ye),ye.set(Ct.ISharedProcessLifecycleService,this.lifecycleService),this.sharedProcessWorkerService=new Be.SharedProcessWorkerService(Ye),ye.set(De.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Qe=this._register(new U.FileService(Ye));ye.set(L.IFileService,Qe);const dt=this._register(new $.DiskFileSystemProvider(Ye));Qe.registerProvider(I.Schemas.file,dt);const ft=this._register(new Ve.FileUserDataProvider(I.Schemas.file,this._register(new et.DiskFileSystemProviderClient(Ke.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:je.isLinux})),I.Schemas.vscodeUserData,Ye));Qe.registerProvider(I.Schemas.vscodeUserData,ft);const nt=this._register(new _t.UserDataProfilesNativeService(this.configuration.profiles,Ke,He));ye.set(yt.IUserDataProfilesService,nt);const Je=this._register(new h.ConfigurationService(nt.defaultProfile.settingsResource,Qe,tt,Ye));ye.set(c.IConfigurationService,Je);const at=new ne.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Ke,He);ye.set(Y.IStorageService,at),this._register((0,T.toDisposable)(()=>at.flush())),await Promise.all([Je.initialize(),at.initialize()]),ye.set($e.IUriIdentityService,new Te.UriIdentityService(Qe)),ye.set(z.IRequestService,new Ot.SharedProcessRequestService(Ke,Je,Ye)),ye.set(u.IChecksumService,new H.SyncDescriptor(S.ChecksumService,void 0,!1)),ye.set(pt.IV8InspectProfilingService,new H.SyncDescriptor(ot.InspectProfilingService,void 0,!1));const ut=b.ProxyChannel.toService(Ke.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(M.INativeHostService,ut),ye.set(o.IDownloadService,new H.SyncDescriptor(t.DownloadService,void 0,!0));const gt=this._register(new Oe.ActiveWindowManager(ut)),mt=new b.StaticRouter(Xe=>gt.getActiveClientId().then(vt=>Xe===vt));ye.set(F.IExtensionRecommendationNotificationService,new N.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",mt)));let rt;const ct=[],It=(0,Se.isInternalTelemetry)(Ue,Je);if((0,Se.supportsTelemetry)(Ue,He)){const Xe=new le.TelemetryLogAppender(it,He);ct.push(Xe);const{installSourcePath:vt}=He;if(Ue.aiConfig?.ariaKey){const Rt=new Ut.OneDataSystemAppender(It,"monacoworkbench",null,Ue.aiConfig.ariaKey);this._register((0,T.toDisposable)(()=>Rt.flush())),ct.push(Rt)}rt=new ue.TelemetryService({appenders:ct,commonProperties:(0,X.resolveCommonProperties)(Qe,(0,i.release)(),(0,i.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,It,vt),sendErrorTelemetry:!0,piiPaths:(0,Se.getPiiPathsFromEnvironment)(He)},Je,Ue)}else{rt=Se.NullTelemetryService;const Xe=Se.NullAppender;ct.push(Xe)}this.server.registerChannel("telemetryAppender",new re.TelemetryAppenderChannel(ct)),ye.set(te.ITelemetryService,rt);const jt=new we.CustomEndpointTelemetryService(Je,rt,it,He,Ue);ye.set(te.ICustomEndpointTelemetryService,jt),ye.set(wt.IExtensionsProfileScannerService,new H.SyncDescriptor(wt.ExtensionsProfileScannerService,void 0,!0)),ye.set(Lt.IExtensionsScannerService,new H.SyncDescriptor(Tt.ExtensionsScannerService,void 0,!0)),ye.set(C.IExtensionSignatureVerificationService,new H.SyncDescriptor(C.ExtensionSignatureVerificationService,void 0,!0)),ye.set(_.INativeServerExtensionManagementService,new H.SyncDescriptor(_.ExtensionManagementService,void 0,!0)),ye.set(g.IExtensionGalleryService,new H.SyncDescriptor(a.ExtensionGalleryService,void 0,!0)),ye.set(g.IExtensionTipsService,new H.SyncDescriptor(V.ExtensionTipsService,void 0,!1)),ye.set(ee.ILanguagePackService,new H.SyncDescriptor(ce.NativeLanguagePackService,void 0,!1)),ye.set(d.IDiagnosticsService,new H.SyncDescriptor(n.DiagnosticsService,void 0,!1)),ye.set(ae.IUserDataSyncAccountService,new H.SyncDescriptor(ae.UserDataSyncAccountService,void 0,!0)),ye.set(We.IUserDataSyncLogService,new H.SyncDescriptor(be.UserDataSyncLogService,void 0,!0)),ye.set(We.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Xe=>Xe.ctx!=="main"))),ye.set(g.IGlobalExtensionEnablementService,new H.SyncDescriptor(l.GlobalExtensionEnablementService,void 0,!1)),ye.set(Ge.IIgnoredExtensionsManagementService,new H.SyncDescriptor(Ge.IgnoredExtensionsManagementService,void 0,!0)),ye.set(Ne.IExtensionStorageService,new H.SyncDescriptor(Ne.ExtensionStorageService)),ye.set(We.IUserDataSyncStoreManagementService,new H.SyncDescriptor(_e.UserDataSyncStoreManagementService,void 0,!0)),ye.set(We.IUserDataSyncStoreService,new H.SyncDescriptor(_e.UserDataSyncStoreService,void 0,!0)),ye.set(Ie.IUserDataSyncMachinesService,new H.SyncDescriptor(Ie.UserDataSyncMachinesService,void 0,!0)),ye.set(We.IUserDataSyncBackupStoreService,new H.SyncDescriptor(fe.UserDataSyncBackupStoreService,void 0,!1)),ye.set(We.IUserDataSyncEnablementService,new H.SyncDescriptor(Le.UserDataSyncEnablementService,void 0,!0)),ye.set(We.IUserDataSyncService,new H.SyncDescriptor(Re.UserDataSyncService,void 0,!1)),ye.set(ke.IUserDataSyncProfilesStorageService,new H.SyncDescriptor(ze.UserDataSyncProfilesStorageService,void 0,!0)),ye.set(We.IUserDataSyncResourceProviderService,new H.SyncDescriptor(Ft.UserDataSyncResourceProviderService,void 0,!0));const Dt=new Ae.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Je.getValue("terminal.integrated.persistentSessionScrollback")??100},Je,He,Ye);return Dt.initialize(),ye.set(Ce.ILocalPtyService,this._register(Dt)),ye.set(ie.ISignService,new H.SyncDescriptor(he.SignService,void 0,!1)),ye.set(de.ISharedTunnelsService,new H.SyncDescriptor(me.SharedTunnelsService)),ye.set(pe.ISharedProcessTunnelService,new H.SyncDescriptor(Pe.SharedProcessTunnelService)),ye.set(bt.IRemoteTunnelService,new H.SyncDescriptor(Nt.RemoteTunnelService)),new x.InstantiationService(ye)}initChannels(ye){const Ue=new Q.LogLevelChannel(ye.get(J.ILogService),ye.get(J.ILoggerService));this.server.registerChannel("logLevel",Ue);const qe=new A.ExtensionManagementChannel(ye.get(g.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",qe);const Ke=b.ProxyChannel.fromService(ye.get(ee.ILanguagePackService));this.server.registerChannel("languagePacks",Ke);const tt=b.ProxyChannel.fromService(ye.get(d.IDiagnosticsService));this.server.registerChannel("diagnostics",tt);const He=new A.ExtensionTipsChannel(ye.get(g.IExtensionTipsService));this.server.registerChannel("extensionTipsService",He);const lt=b.ProxyChannel.fromService(ye.get(u.IChecksumService));this.server.registerChannel("checksum",lt);const it=b.ProxyChannel.fromService(ye.get(pt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",it);const ht=new ge.UserDataSyncMachinesServiceChannel(ye.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ht);const Ye=b.ProxyChannel.fromService(ye.get(te.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ye);const Qe=new ge.UserDataSyncAccountServiceChannel(ye.get(ae.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Qe);const dt=new ge.UserDataSyncStoreManagementServiceChannel(ye.get(We.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",dt);const ft=new Fe.UserDataSyncChannel(ye.get(We.IUserDataSyncService),ye.get(yt.IUserDataProfilesService),ye.get(J.ILogService));this.server.registerChannel("userDataSync",ft);const nt=this._register(ye.get(q.IInstantiationService).createInstance(Me.UserDataAutoSyncService)),Je=new ge.UserDataAutoSyncChannel(nt);this.server.registerChannel("userDataAutoSync",Je);const at=ye.get(Ce.ILocalPtyService),ut=b.ProxyChannel.fromService(at);this.server.registerChannel(Ee.TerminalIpcChannels.LocalPty,ut);const gt=b.ProxyChannel.fromService(ye.get(pe.ISharedProcessTunnelService));this.server.registerChannel(pe.ipcSharedProcessTunnelChannelName,gt);const mt=b.ProxyChannel.fromService(ye.get(De.ISharedProcessWorkerService));this.server.registerChannel(De.ipcSharedProcessWorkerChannelName,mt);const rt=b.ProxyChannel.fromService(ye.get(bt.IRemoteTunnelService));this.server.registerChannel("remoteTunnel",rt)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Ue=>{(0,k.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,k.setUnexpectedErrorHandler)(Ue=>{const qe=(0,R.toErrorMessage)(Ue,!0);!qe||ye.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function zt(Pt){const ye=new Wt(Pt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=zt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/96db0b339360bc72d27d869d81a557540ad5f800/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
