/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","os","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","vs/platform/state/electron-main/state","vs/base/common/map","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/functional","vs/base/common/objects","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/userDataSync/electron-main/userDataSyncProfilesStorageIpc","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],te=function(z){for(var e=[],E=0,t=z.length;E<t;E++)e[E]=ee[z[E]];return e};define(ee[119],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function E(R){return R?R.replace(/\$\((.*?)\)/g,(D,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=E;class t{constructor(D,P,p){this.id=D,this.definition=P,this.description=p,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var k;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function P(b){if(b instanceof t)return["codicon","codicon-"+b.id];const I=D.exec(b.id);if(!I)return P(t.error);const[,C,d]=I,m=["codicon","codicon-"+C];return d&&m.push("codicon-modifier-"+d.substring(1)),m}R.asClassNameArray=P;function p(b){return P(b).join(" ")}R.asClassName=p;function S(b){return"."+P(b).join(".")}R.asCSSSelector=S})(k=e.CSSIcon||(e.CSSIcon={}))}),define(ee[120],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(P,p){const S=Math.pow(10,p);return Math.round(P*S)/S}class t{constructor(p,S,b,I=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,p))|0,this.g=Math.min(255,Math.max(0,S))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=E(Math.max(Math.min(1,I),0),3)}static equals(p,S){return p.r===S.r&&p.g===S.g&&p.b===S.b&&p.a===S.a}}e.RGBA=t;class k{constructor(p,S,b,I){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,p),0)|0,this.s=E(Math.max(Math.min(1,S),0),3),this.l=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,I),0),3)}static equals(p,S){return p.h===S.h&&p.s===S.s&&p.l===S.l&&p.a===S.a}static fromRGBA(p){const S=p.r/255,b=p.g/255,I=p.b/255,C=p.a,d=Math.max(S,b,I),m=Math.min(S,b,I);let h=0,w=0;const u=(m+d)/2,v=d-m;if(v>0){switch(w=Math.min(u<=.5?v/(2*u):v/(2-2*u),1),d){case S:h=(b-I)/v+(b<I?6:0);break;case b:h=(I-S)/v+2;break;case I:h=(S-b)/v+4;break}h*=60,h=Math.round(h)}return new k(h,w,u,C)}static _hue2rgb(p,S,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?p+(S-p)*6*b:b<1/2?S:b<2/3?p+(S-p)*(2/3-b)*6:p}static toRGBA(p){const S=p.h/360,{s:b,l:I,a:C}=p;let d,m,h;if(b===0)d=m=h=I;else{const w=I<.5?I*(1+b):I+b-I*b,u=2*I-w;d=k._hue2rgb(u,w,S+1/3),m=k._hue2rgb(u,w,S),h=k._hue2rgb(u,w,S-1/3)}return new t(Math.round(d*255),Math.round(m*255),Math.round(h*255),C)}}e.HSLA=k;class R{constructor(p,S,b,I){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,p),0)|0,this.s=E(Math.max(Math.min(1,S),0),3),this.v=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,I),0),3)}static equals(p,S){return p.h===S.h&&p.s===S.s&&p.v===S.v&&p.a===S.a}static fromRGBA(p){const S=p.r/255,b=p.g/255,I=p.b/255,C=Math.max(S,b,I),d=Math.min(S,b,I),m=C-d,h=C===0?0:m/C;let w;return m===0?w=0:C===S?w=((b-I)/m%6+6)%6:C===b?w=(I-S)/m+2:w=(S-b)/m+4,new R(Math.round(w*60),h,C,p.a)}static toRGBA(p){const{h:S,s:b,v:I,a:C}=p,d=I*b,m=d*(1-Math.abs(S/60%2-1)),h=I-d;let[w,u,v]=[0,0,0];return S<60?(w=d,u=m):S<120?(w=m,u=d):S<180?(u=d,v=m):S<240?(u=m,v=d):S<300?(w=m,v=d):S<=360&&(w=d,v=m),w=Math.round((w+h)*255),u=Math.round((u+h)*255),v=Math.round((v+h)*255),new t(w,u,v,C)}}e.HSVA=R;class D{static fromHex(p){return D.Format.CSS.parseHex(p)||D.red}static equals(p,S){return!p&&!S?!0:!p||!S?!1:p.equals(S)}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}constructor(p){if(p)if(p instanceof t)this.rgba=p;else if(p instanceof k)this._hsla=p,this.rgba=k.toRGBA(p);else if(p instanceof R)this._hsva=p,this.rgba=R.toRGBA(p);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(p){return!!p&&t.equals(this.rgba,p.rgba)&&k.equals(this.hsla,p.hsla)&&R.equals(this.hsva,p.hsva)}getRelativeLuminance(){const p=D._relativeLuminanceForComponent(this.rgba.r),S=D._relativeLuminanceForComponent(this.rgba.g),b=D._relativeLuminanceForComponent(this.rgba.b),I=.2126*p+.7152*S+.0722*b;return E(I,4)}static _relativeLuminanceForComponent(p){const S=p/255;return S<=.03928?S/12.92:Math.pow((S+.055)/1.055,2.4)}getContrastRatio(p){const S=this.getRelativeLuminance(),b=p.getRelativeLuminance();return S>b?(S+.05)/(b+.05):(b+.05)/(S+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(p){const S=this.getRelativeLuminance(),b=p.getRelativeLuminance();return S>b}isDarkerThan(p){const S=this.getRelativeLuminance(),b=p.getRelativeLuminance();return S<b}lighten(p){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*p,this.hsla.a))}darken(p){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*p,this.hsla.a))}transparent(p){const{r:S,g:b,b:I,a:C}=this.rgba;return new D(new t(S,b,I,C*p))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(p){const S=p.rgba,b=this.rgba.a,I=S.a,C=b+I*(1-b);if(C<1e-6)return D.transparent;const d=this.rgba.r*b/C+S.r*I*(1-b)/C,m=this.rgba.g*b/C+S.g*I*(1-b)/C,h=this.rgba.b*b/C+S.b*I*(1-b)/C;return new D(new t(d,m,h,C))}makeOpaque(p){if(this.isOpaque()||p.rgba.a!==1)return this;const{r:S,g:b,b:I,a:C}=this.rgba;return new D(new t(p.rgba.r-C*(p.rgba.r-S),p.rgba.g-C*(p.rgba.g-b),p.rgba.b-C*(p.rgba.b-I),1))}flatten(...p){const S=p.reduceRight((b,I)=>D._flatten(I,b));return D._flatten(this,S)}static _flatten(p,S){const b=1-p.rgba.a;return new D(new t(b*S.rgba.r+p.rgba.a*p.rgba.r,b*S.rgba.g+p.rgba.a*p.rgba.g,b*S.rgba.b+p.rgba.a*p.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(p,S,b){if(p.isLighterThan(S))return p;b=b||.5;const I=p.getRelativeLuminance(),C=S.getRelativeLuminance();return b=b*(C-I)/C,p.lighten(b)}static getDarkerColor(p,S,b){if(p.isDarkerThan(S))return p;b=b||.5;const I=p.getRelativeLuminance(),C=S.getRelativeLuminance();return b=b*(I-C)/I,p.darken(b)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(P){let p;(function(S){let b;(function(I){function C(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:P.Format.CSS.formatRGBA(n)}I.formatRGB=C;function d(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}I.formatRGBA=d;function m(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(n)}I.formatHSL=m;function h(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}I.formatHSLA=h;function w(n){const r=n.toString(16);return r.length!==2?"0"+r:r}function u(n){return`#${w(n.rgba.r)}${w(n.rgba.g)}${w(n.rgba.b)}`}I.formatHex=u;function v(n,r=!1){return r&&n.rgba.a===1?P.Format.CSS.formatHex(n):`#${w(n.rgba.r)}${w(n.rgba.g)}${w(n.rgba.b)}${w(Math.round(n.rgba.a*255))}`}I.formatHexA=v;function g(n){return n.isOpaque()?P.Format.CSS.formatHex(n):P.Format.CSS.formatRGBA(n)}I.format=g;function f(n){const r=n.length;if(r===0||n.charCodeAt(0)!==35)return null;if(r===7){const i=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),o=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),s=16*c(n.charCodeAt(5))+c(n.charCodeAt(6));return new P(new t(i,o,s,1))}if(r===9){const i=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),o=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),s=16*c(n.charCodeAt(5))+c(n.charCodeAt(6)),l=16*c(n.charCodeAt(7))+c(n.charCodeAt(8));return new P(new t(i,o,s,l/255))}if(r===4){const i=c(n.charCodeAt(1)),o=c(n.charCodeAt(2)),s=c(n.charCodeAt(3));return new P(new t(16*i+i,16*o+o,16*s+s))}if(r===5){const i=c(n.charCodeAt(1)),o=c(n.charCodeAt(2)),s=c(n.charCodeAt(3)),l=c(n.charCodeAt(4));return new P(new t(16*i+i,16*o+o,16*s+s,(16*l+l)/255))}return null}I.parseHex=f;function c(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=S.CSS||(S.CSS={}))})(p=P.Format||(P.Format={}))}(D=e.Color||(e.Color={}))}),define(ee[53],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(D){return(P,p,S)=>{let b=null,I=null;if(typeof S.value=="function"?(b="value",I=S.value):typeof S.get=="function"&&(b="get",I=S.get),!I)throw new Error("not supported");S[b]=D(I,p)}}function t(D,P,p){let S=null,b=null;if(typeof p.value=="function"?(S="value",b=p.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(S="get",b=p.get),!b)throw new Error("not supported");const I=`$memoize$${P}`;p[S]=function(...C){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,C)}),this[I]}}e.memoize=t;function k(D,P,p){return E((S,b)=>{const I=`$debounce$${b}`,C=`$debounce$result$${b}`;return function(...d){this[C]||(this[C]=p?p():void 0),clearTimeout(this[I]),P&&(this[C]=P(this[C],...d),d=[this[C]]),this[I]=setTimeout(()=>{S.apply(this,d),this[C]=p?p():void 0},D)}})}e.debounce=k;function R(D,P,p){return E((S,b)=>{const I=`$throttle$timer$${b}`,C=`$throttle$result$${b}`,d=`$throttle$lastRun$${b}`,m=`$throttle$pending$${b}`;return function(...h){if(this[C]||(this[C]=p?p():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),P&&(this[C]=P(this[C],...h)),this[m])return;const w=this[d]+D;w<=Date.now()?(this[d]=Date.now(),S.apply(this,[this[C]]),this[C]=p?p():void 0):(this[m]=!0,this[I]=setTimeout(()=>{this[m]=!1,this[d]=Date.now(),S.apply(this,[this[C]]),this[C]=p?p():void 0},w-Date.now()))}})}e.throttle=R}),define(ee[16],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?g.isErrorNoTelemetry(n)?new g(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(r=>{r(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=E,e.errorHandler=new E;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function k(c){p(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function R(c){p(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=R;function D(c){if(c instanceof Error){const{name:n,message:r}=c,i=c.stacktrace||c.stack;return{$isError:!0,name:n,message:r,stack:i,noTelemetry:g.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=D;const P="Canceled";function p(c){return c instanceof S?!0:c instanceof Error&&c.name===P&&c.message===P}e.isCancellationError=p;class S extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=S;function b(){const c=new Error(P);return c.name=c.message,c}e.canceled=b;function I(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=I;function C(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=C;function d(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function m(c){const n=new Error(`${c} has been disposed`);return n.name="DISPOSED",n}e.disposed=m;function h(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=h;class w extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=w;class u extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=u;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class g extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof g)return n;const r=new g;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=g;class f extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(ee[24],te([0,1,16]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(B,x=0){return B[B.length-(1+x)]}e.tail=t;function k(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=k;function R(B,x,Z=(ce,ge)=>ce===ge){if(B===x)return!0;if(!B||!x||B.length!==x.length)return!1;for(let ce=0,ge=B.length;ce<ge;ce++)if(!Z(B[ce],x[ce]))return!1;return!0}e.equals=R;function D(B,x){const Z=B.length-1;x<Z&&(B[x]=B[Z]),B.pop()}e.removeFastWithoutKeepingOrder=D;function P(B,x,Z){return p(B.length,ce=>Z(B[ce],x))}e.binarySearch=P;function p(B,x){let Z=0,ce=B-1;for(;Z<=ce;){const ge=(Z+ce)/2|0,De=x(ge);if(De<0)Z=ge+1;else if(De>0)ce=ge-1;else return ge}return-(Z+1)}e.binarySearch2=p;function S(B,x){let Z=0,ce=B.length;if(ce===0)return 0;for(;Z<ce;){const ge=Math.floor((Z+ce)/2);x(B[ge])?ce=ge:Z=ge+1}return Z}e.findFirstInSorted=S;function b(B,x,Z){if(B=B|0,B>=x.length)throw new TypeError("invalid index");const ce=x[Math.floor(x.length*Math.random())],ge=[],De=[],Te=[];for(const Me of x){const Le=Z(Me,ce);Le<0?ge.push(Me):Le>0?De.push(Me):Te.push(Me)}return B<ge.length?b(B,ge,Z):B<ge.length+Te.length?Te[0]:b(B-(ge.length+Te.length),De,Z)}e.quickSelect=b;function I(B,x){const Z=[];let ce;for(const ge of B.slice(0).sort(x))!ce||x(ce[0],ge)!==0?(ce=[ge],Z.push(ce)):ce.push(ge);return Z}e.groupBy=I;function C(B,x,Z){const ce=[];function ge(Me,Le,ve){if(Le===0&&ve.length===0)return;const pe=ce[ce.length-1];pe&&pe.start+pe.deleteCount===Me?(pe.deleteCount+=Le,pe.toInsert.push(...ve)):ce.push({start:Me,deleteCount:Le,toInsert:ve})}let De=0,Te=0;for(;;){if(De===B.length){ge(De,0,x.slice(Te));break}if(Te===x.length){ge(De,B.length-De,[]);break}const Me=B[De],Le=x[Te],ve=Z(Me,Le);ve===0?(De+=1,Te+=1):ve<0?(ge(De,1,[]),De+=1):ve>0&&(ge(De,0,[Le]),Te+=1)}return ce}e.sortedDiff=C;function d(B,x,Z){const ce=C(B,x,Z),ge=[],De=[];for(const Te of ce)ge.push(...B.slice(Te.start,Te.start+Te.deleteCount)),De.push(...Te.toInsert);return{removed:ge,added:De}}e.delta=d;function m(B,x,Z){if(Z===0)return[];const ce=B.slice(0,Z).sort(x);return w(B,x,ce,Z,B.length),ce}e.top=m;function h(B,x,Z,ce,ge){return Z===0?Promise.resolve([]):new Promise((De,Te)=>{(async()=>{const Me=B.length,Le=B.slice(0,Z).sort(x);for(let ve=Z,pe=Math.min(Z+ce,Me);ve<Me;ve=pe,pe=Math.min(pe+ce,Me)){if(ve>Z&&await new Promise(Se=>setTimeout(Se)),ge&&ge.isCancellationRequested)throw new E.CancellationError;w(B,x,Le,ve,pe)}return Le})().then(De,Te)})}e.topAsync=h;function w(B,x,Z,ce,ge){for(const De=Z.length;ce<ge;ce++){const Te=B[ce];if(x(Te,Z[De-1])<0){Z.pop();const Me=S(Z,Le=>x(Te,Le)<0);Z.splice(Me,0,Te)}}}function u(B){return B.filter(x=>!!x)}e.coalesce=u;function v(B){let x=0;for(let Z=0;Z<B.length;Z++)B[Z]&&(B[x]=B[Z],x+=1);B.length=x}e.coalesceInPlace=v;function g(B,x,Z){B.splice(Z,0,B.splice(x,1)[0])}e.move=g;function f(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=f;function c(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=c;function n(B,x=Z=>Z){const Z=new Set;return B.filter(ce=>{const ge=x(ce);return Z.has(ge)?!1:(Z.add(ge),!0)})}e.distinct=n;function r(B){const x=new Set;return Z=>{const ce=B(Z);return x.has(ce)?!1:(x.add(ce),!0)}}e.uniqueFilter=r;function i(B,x){const Z=o(B,x);if(Z!==-1)return B[Z]}e.findLast=i;function o(B,x){for(let Z=B.length-1;Z>=0;Z--){const ce=B[Z];if(x(ce))return Z}return-1}e.lastIndex=o;function s(B,x){return B.length>0?B[0]:x}e.firstOrDefault=s;function l(B,x){return B.length>0?B[B.length-1]:x}e.lastOrDefault=l;function a(B,x,Z=(ce,ge)=>ce===ge){let ce=0;for(let ge=0,De=Math.min(B.length,x.length);ge<De&&Z(B[ge],x[ge]);ge++)ce++;return ce}e.commonPrefixLength=a;function y(B){return[].concat(...B)}e.flatten=y;function M(B,x){let Z=typeof x=="number"?B:0;typeof x=="number"?Z=B:(Z=0,x=B);const ce=[];if(Z<=x)for(let ge=Z;ge<x;ge++)ce.push(ge);else for(let ge=Z;ge>x;ge--)ce.push(ge);return ce}e.range=M;function T(B,x,Z){return B.reduce((ce,ge)=>(ce[x(ge)]=Z?Z(ge):ge,ce),Object.create(null))}e.index=T;function U(B,x){return B.push(x),()=>Y(B,x)}e.insert=U;function Y(B,x){const Z=B.indexOf(x);if(Z>-1)return B.splice(Z,1),x}e.remove=Y;function G(B,x,Z){const ce=B.slice(0,x),ge=B.slice(x);return ce.concat(Z,ge)}e.arrayInsert=G;function V(B,x){let Z;if(typeof x=="number"){let ce=x;Z=()=>{const ge=Math.sin(ce++)*179426549;return ge-Math.floor(ge)}}else Z=Math.random;for(let ce=B.length-1;ce>0;ce-=1){const ge=Math.floor(Z()*(ce+1)),De=B[ce];B[ce]=B[ge],B[ge]=De}}e.shuffle=V;function oe(B,x){const Z=B.indexOf(x);Z>-1&&(B.splice(Z,1),B.unshift(x))}e.pushToStart=oe;function ae(B,x){const Z=B.indexOf(x);Z>-1&&(B.splice(Z,1),B.push(x))}e.pushToEnd=ae;function se(B,x){for(const Z of x)B.push(Z)}e.pushMany=se;function fe(B,x){return Array.isArray(B)?B.map(x):x(B)}e.mapArrayOrNot=fe;function K(B){return Array.isArray(B)?B:[B]}e.asArray=K;function H(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=H;function F(B,x){for(const Z of B){const ce=x(Z);if(ce!==void 0)return ce}}e.mapFind=F;function A(B,x,Z){const ce=_(B,x),ge=B.length,De=Z.length;B.length=ge+De;for(let Te=ge-1;Te>=ce;Te--)B[Te+De]=B[Te];for(let Te=0;Te<De;Te++)B[Te+ce]=Z[Te]}e.insertInto=A;function O(B,x,Z,ce){const ge=_(B,x),De=B.splice(ge,Z);return A(B,ge,ce),De}e.splice=O;function _(B,x){return x<0?Math.max(x+B.length,0):Math.min(x,B.length)}var ne;(function(B){function x(ge){return ge<0}B.isLessThan=x;function Z(ge){return ge>0}B.isGreaterThan=Z;function ce(ge){return ge===0}B.isNeitherLessOrGreaterThan=ce,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(ne=e.CompareResult||(e.CompareResult={}));function N(B,x){return(Z,ce)=>x(B(Z),B(ce))}e.compareBy=N;function j(...B){return(x,Z)=>{for(const ce of B){const ge=ce(x,Z);if(!ne.isNeitherLessOrGreaterThan(ge))return ge}return ne.neitherLessOrGreaterThan}}e.tieBreakComparators=j;const L=(B,x)=>B-x;e.numberComparator=L;function W(B,x){if(B.length===0)return;let Z=B[0];for(let ce=1;ce<B.length;ce++){const ge=B[ce];x(ge,Z)>0&&(Z=ge)}return Z}e.findMaxBy=W;function $(B,x){if(B.length===0)return;let Z=B[0];for(let ce=1;ce<B.length;ce++){const ge=B[ce];x(ge,Z)>=0&&(Z=ge)}return Z}e.findLastMaxBy=$;function q(B,x){return W(B,(Z,ce)=>-x(Z,ce))}e.findMinBy=q;class X{constructor(x){this.items=x,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(x){let Z=this.firstIdx;for(;Z<this.items.length&&x(this.items[Z]);)Z++;const ce=Z===this.firstIdx?null:this.items.slice(this.firstIdx,Z);return this.firstIdx=Z,ce}takeFromEndWhile(x){let Z=this.lastIdx;for(;Z>=0&&x(this.items[Z]);)Z--;const ce=Z===this.lastIdx?null:this.items.slice(Z+1,this.lastIdx+1);return this.lastIdx=Z,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const x=this.items[this.firstIdx];return this.firstIdx++,x}removeLast(){const x=this.items[this.lastIdx];return this.lastIdx--,x}takeCount(x){const Z=this.items.slice(this.firstIdx,this.firstIdx+x);return this.firstIdx+=x,Z}}e.ArrayQueue=X;class re{constructor(x){this.iterate=x}forEach(x){this.iterate(Z=>(x(Z),!0))}toArray(){const x=[];return this.iterate(Z=>(x.push(Z),!0)),x}filter(x){return new re(Z=>this.iterate(ce=>x(ce)?Z(ce):!0))}map(x){return new re(Z=>this.iterate(ce=>Z(x(ce))))}some(x){let Z=!1;return this.iterate(ce=>(Z=x(ce),!Z)),Z}findFirst(x){let Z;return this.iterate(ce=>x(ce)?(Z=ce,!1):!0),Z}findLast(x){let Z;return this.iterate(ce=>(x(ce)&&(Z=ce),!0)),Z}findLastMaxBy(x){let Z,ce=!0;return this.iterate(ge=>((ce||ne.isGreaterThan(x(ge,Z)))&&(ce=!1,Z=ge),!0)),Z}}e.CallbackIterable=re,re.empty=new re(B=>{})}),define(ee[121],te([0,1,16]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(p,S){if(!p)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=t;function k(p,S="Unreachable"){throw new Error(S)}e.assertNever=k;function R(p){if(!p)throw new E.BugIndicatingError("Assertion Failed")}e.assert=R;function D(p){if(!p()){debugger;p(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function P(p,S){let b=0;for(;b<p.length-1;){const I=p[b],C=p[b+1];if(!S(I,C))return!1;b++}return!0}e.checkAdjacentItems=P}),define(ee[49],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(t){const k=this;let R=!1,D;return function(){return R||(R=!0,D=t.apply(k,arguments)),D}}e.once=E}),define(ee[66],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(t){function k(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function D(){return R}t.empty=D;function*P(f){yield f}t.single=P;function p(f){return k(f)?f:P(f)}t.wrap=p;function S(f){return f||R}t.from=S;function b(f){return!f||f[Symbol.iterator]().next().done===!0}t.isEmpty=b;function I(f){return f[Symbol.iterator]().next().value}t.first=I;function C(f,c){for(const n of f)if(c(n))return!0;return!1}t.some=C;function d(f,c){for(const n of f)if(c(n))return n}t.find=d;function*m(f,c){for(const n of f)c(n)&&(yield n)}t.filter=m;function*h(f,c){let n=0;for(const r of f)yield c(r,n++)}t.map=h;function*w(...f){for(const c of f)for(const n of c)yield n}t.concat=w;function u(f,c,n){let r=n;for(const i of f)r=c(r,i);return r}t.reduce=u;function*v(f,c,n=f.length){for(c<0&&(c+=f.length),n<0?n+=f.length:n>f.length&&(n=f.length);c<n;c++)yield f[c]}t.slice=v;function g(f,c=Number.POSITIVE_INFINITY){const n=[];if(c===0)return[n,f];const r=f[Symbol.iterator]();for(let i=0;i<c;i++){const o=r.next();if(o.done)return[n,t.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return r}}]}t.consume=g})(E=e.Iterable||(e.Iterable={}))}),define(ee[42],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(n,r=!1){let i=0;const o=n.length;let s="",l=0,a=16,y=0;function M(ae){let se=0,fe=0;for(;se<ae;){const K=n.charCodeAt(i);if(K>=48&&K<=57)fe=fe*16+K-48;else if(K>=65&&K<=70)fe=fe*16+K-65+10;else if(K>=97&&K<=102)fe=fe*16+K-97+10;else break;i++,se++}return se<ae&&(fe=-1),fe}function T(ae){i=ae,s="",l=0,a=16,y=0}function U(){const ae=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&S(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&S(n.charCodeAt(i)))for(i++;i<n.length&&S(n.charCodeAt(i));)i++;else return y=3,n.substring(ae,i);let se=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&S(n.charCodeAt(i))){for(i++;i<n.length&&S(n.charCodeAt(i));)i++;se=i}else y=3;return n.substring(ae,se)}function Y(){let ae="",se=i;for(;;){if(i>=o){ae+=n.substring(se,i),y=2;break}const fe=n.charCodeAt(i);if(fe===34){ae+=n.substring(se,i),i++;break}if(fe===92){if(ae+=n.substring(se,i),i++,i>=o){y=2;break}switch(n.charCodeAt(i++)){case 34:ae+='"';break;case 92:ae+="\\";break;case 47:ae+="/";break;case 98:ae+="\b";break;case 102:ae+="\f";break;case 110:ae+=`
`;break;case 114:ae+="\r";break;case 116:ae+="	";break;case 117:{const H=M(4);H>=0?ae+=String.fromCharCode(H):y=4;break}default:y=5}se=i;continue}if(fe>=0&&fe<=31)if(p(fe)){ae+=n.substring(se,i),y=2;break}else y=6;i++}return ae}function G(){if(s="",y=0,l=i,i>=o)return l=o,a=17;let ae=n.charCodeAt(i);if(P(ae)){do i++,s+=String.fromCharCode(ae),ae=n.charCodeAt(i);while(P(ae));return a=15}if(p(ae))return i++,s+=String.fromCharCode(ae),ae===13&&n.charCodeAt(i)===10&&(i++,s+=`
`),a=14;switch(ae){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,s=Y(),a=10;case 47:{const se=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<o&&!p(n.charCodeAt(i));)i++;return s=n.substring(se,i),a=12}if(n.charCodeAt(i+1)===42){i+=2;const fe=o-1;let K=!1;for(;i<fe;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,K=!0;break}i++}return K||(i++,y=1),s=n.substring(se,i),a=13}return s+=String.fromCharCode(ae),i++,a=16}case 45:if(s+=String.fromCharCode(ae),i++,i===o||!S(n.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=U(),a=11;default:for(;i<o&&V(ae);)i++,ae=n.charCodeAt(i);if(l!==i){switch(s=n.substring(l,i),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode(ae),i++,a=16}}function V(ae){if(P(ae)||p(ae))return!1;switch(ae){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let ae;do ae=G();while(ae>=12&&ae<=15);return ae}return{setPosition:T,getPosition:()=>i,scan:r?oe:G,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>y}}e.createScanner=D;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function p(n){return n===10||n===13||n===8232||n===8233}function S(n){return n>=48&&n<=57}var b;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(b||(b={}));function I(n,r){const i=[],o=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function y(M,T,U,Y){l.value=M,l.offset=T,l.length=U,l.type=Y,l.colonOffset=void 0,s=l}try{g(n,{onObjectBegin:(M,T)=>{if(r<=M)throw o;s=void 0,a=r>M,i.push("")},onObjectProperty:(M,T,U)=>{if(r<T||(y(M,T,U,"property"),i[i.length-1]=M,r<=T+U))throw o},onObjectEnd:(M,T)=>{if(r<=M)throw o;s=void 0,i.pop()},onArrayBegin:(M,T)=>{if(r<=M)throw o;s=void 0,i.push(0)},onArrayEnd:(M,T)=>{if(r<=M)throw o;s=void 0,i.pop()},onLiteralValue:(M,T,U)=>{if(r<T||(y(M,T,U,c(M)),r<=T+U))throw o},onSeparator:(M,T,U)=>{if(r<=T)throw o;if(M===":"&&s&&s.type==="property")s.colonOffset=T,a=!1,s=void 0;else if(M===","){const Y=i[i.length-1];typeof Y=="number"?i[i.length-1]=Y+1:(a=!0,i[i.length-1]=""),s=void 0}}})}catch(M){if(M!==o)throw M}return{path:i,previousNode:s,isAtPropertyKey:a,matches:M=>{let T=0;for(let U=0;T<M.length&&U<i.length;U++)if(M[T]===i[U]||M[T]==="*")T++;else if(M[T]!=="**")return!1;return T===M.length}}}e.getLocation=I;function C(n,r=[],i=R.DEFAULT){let o=null,s=[];const l=[];function a(M){Array.isArray(s)?s.push(M):o!==null&&(s[o]=M)}return g(n,{onObjectBegin:()=>{const M={};a(M),l.push(s),s=M,o=null},onObjectProperty:M=>{o=M},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const M=[];a(M),l.push(s),s=M,o=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:a,onError:(M,T,U)=>{r.push({error:M,offset:T,length:U})}},i),s[0]}e.parse=C;function d(n,r=[],i=R.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(M){o.type==="property"&&(o.length=M-o.offset,o=o.parent)}function l(M){return o.children.push(M),M}g(n,{onObjectBegin:M=>{o=l({type:"object",offset:M,length:-1,parent:o,children:[]})},onObjectProperty:(M,T,U)=>{o=l({type:"property",offset:T,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:M,offset:T,length:U,parent:o})},onObjectEnd:(M,T)=>{o.length=M+T-o.offset,o=o.parent,s(M+T)},onArrayBegin:(M,T)=>{o=l({type:"array",offset:M,length:-1,parent:o,children:[]})},onArrayEnd:(M,T)=>{o.length=M+T-o.offset,o=o.parent,s(M+T)},onLiteralValue:(M,T,U)=>{l({type:c(M),offset:T,length:U,parent:o,value:M}),s(T+U)},onSeparator:(M,T,U)=>{o.type==="property"&&(M===":"?o.colonOffset=T:M===","&&s(T))},onError:(M,T,U)=>{r.push({error:M,offset:T,length:U})}},i);const y=o.children[0];return y&&delete y.parent,y}e.parseTree=d;function m(n,r){if(!n)return;let i=n;for(const o of r)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===o){i=l.children[1],s=!0;break}if(!s)return}else{const s=o;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=m;function h(n){if(!n.parent||!n.parent.children)return[];const r=h(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;r.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&r.push(i)}return r}e.getNodePath=h;function w(n){switch(n.type){case"array":return n.children.map(w);case"object":{const r=Object.create(null);for(const i of n.children){const o=i.children[1];o&&(r[i.children[0].value]=w(o))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=w;function u(n,r,i=!1){return r>=n.offset&&r<n.offset+n.length||i&&r===n.offset+n.length}e.contains=u;function v(n,r,i=!1){if(u(n,r,i)){const o=n.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=r;s++){const l=v(o[s],r,i);if(l)return l}return n}}e.findNodeAtOffset=v;function g(n,r,i=R.DEFAULT){const o=D(n,!1);function s(N){return N?()=>N(o.getTokenOffset(),o.getTokenLength()):()=>!0}function l(N){return N?j=>N(j,o.getTokenOffset(),o.getTokenLength()):()=>!0}const a=s(r.onObjectBegin),y=l(r.onObjectProperty),M=s(r.onObjectEnd),T=s(r.onArrayBegin),U=s(r.onArrayEnd),Y=l(r.onLiteralValue),G=l(r.onSeparator),V=s(r.onComment),oe=l(r.onError),ae=i&&i.disallowComments,se=i&&i.allowTrailingComma;function fe(){for(;;){const N=o.scan();switch(o.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:ae||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(N){case 12:case 13:ae?K(10):V();break;case 16:K(1);break;case 15:case 14:break;default:return N}}}function K(N,j=[],L=[]){if(oe(N),j.length+L.length>0){let W=o.getToken();for(;W!==17;){if(j.indexOf(W)!==-1){fe();break}else if(L.indexOf(W)!==-1)break;W=fe()}}}function H(N){const j=o.getTokenValue();return N?Y(j):y(j),fe(),!0}function F(){switch(o.getToken()){case 11:{let N=0;try{N=JSON.parse(o.getTokenValue()),typeof N!="number"&&(K(2),N=0)}catch{K(2)}Y(N);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return fe(),!0}function A(){return o.getToken()!==10?(K(3,[],[2,5]),!1):(H(!1),o.getToken()===6?(G(":"),fe(),ne()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function O(){a(),fe();let N=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(N||K(4,[],[]),G(","),fe(),o.getToken()===2&&se)break}else N&&K(6,[],[]);A()||K(4,[],[2,5]),N=!0}return M(),o.getToken()!==2?K(7,[2],[]):fe(),!0}function _(){T(),fe();let N=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(N||K(4,[],[]),G(","),fe(),o.getToken()===4&&se)break}else N&&K(6,[],[]);ne()||K(4,[],[4,5]),N=!0}return U(),o.getToken()!==4?K(8,[4],[]):fe(),!0}function ne(){switch(o.getToken()){case 3:return _();case 1:return O();case 10:return H(!0);default:return F()}}return fe(),o.getToken()===17?i.allowEmptyContent?!0:(K(4,[],[]),!1):ne()?(o.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=g;function f(n,r){const i=D(n),o=[];let s,l=0,a;do switch(a=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:l!==a&&o.push(n.substring(l,a)),r!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,r)),l=i.getPosition();break}while(s!==17);return o.join("")}e.stripComments=f;function c(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ee[122],te([0,1,42]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(S,b,I){let C,d,m,h,w;if(b){for(h=b.offset,w=h+b.length,m=h;m>0&&!p(S,m-1);)m--;let a=w;for(;a<S.length&&!p(S,a);)a++;d=S.substring(m,a),C=D(d,I)}else d=S,C=0,m=0,h=0,w=S.length;const u=P(I,S);let v=!1,g=0,f;I.insertSpaces?f=R(" ",I.tabSize||4):f="	";const c=(0,E.createScanner)(d,!1);let n=!1;function r(){return u+R(f,C+g)}function i(){let a=c.scan();for(v=!1;a===15||a===14;)v=v||a===14,a=c.scan();return n=a===16||c.getTokenError()!==0,a}const o=[];function s(a,y,M){!n&&y<w&&M>h&&S.substring(y,M)!==a&&o.push({offset:y,length:M-y,content:a})}let l=i();if(l!==17){const a=c.getTokenOffset()+m,y=R(f,C);s(y,m,a)}for(;l!==17;){let a=c.getTokenOffset()+c.getTokenLength()+m,y=i(),M="";for(;!v&&(y===12||y===13);){const U=c.getTokenOffset()+m;s(" ",a,U),a=c.getTokenOffset()+c.getTokenLength()+m,M=y===12?r():"",y=i()}if(y===2)l!==1&&(g--,M=r());else if(y===4)l!==3&&(g--,M=r());else{switch(l){case 3:case 1:g++,M=r();break;case 5:case 12:M=r();break;case 13:v?M=r():M=" ";break;case 6:M=" ";break;case 10:if(y===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?M=" ":y!==5&&y!==17&&(n=!0);break;case 16:n=!0;break}v&&(y===12||y===13)&&(M=r())}const T=c.getTokenOffset()+m;s(M,a,T),l=y}return o}e.format=t;function k(S,b){const I=JSON.stringify(S,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?I.replace(/\r\n|\r|\n/g,b.eol):I}e.toFormattedString=k;function R(S,b){let I="";for(let C=0;C<b;C++)I+=S;return I}function D(S,b){let I=0,C=0;const d=b.tabSize||4;for(;I<S.length;){const m=S.charAt(I);if(m===" ")C++;else if(m==="	")C+=d;else break;I++}return Math.floor(C/d)}function P(S,b){for(let I=0;I<b.length;I++){const C=b.charAt(I);if(C==="\r")return I+1<b.length&&b.charAt(I+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=P;function p(S,b){return`\r
`.indexOf(S.charAt(b))!==-1}e.isEOL=p}),define(ee[123],te([0,1,42,122]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(S,b,I){return R(S,b,void 0,I)}e.removeProperty=k;function R(S,b,I,C,d){const m=b.slice(),h=[],w=(0,E.parseTree)(S,h);let u,v;for(;m.length>0&&(v=m.pop(),u=(0,E.findNodeAtLocation)(w,m),u===void 0&&I!==void 0);)typeof v=="string"?I={[v]:I}:I=[I];if(u)if(u.type==="object"&&typeof v=="string"&&Array.isArray(u.children)){const g=(0,E.findNodeAtLocation)(u,[v]);if(g!==void 0)if(I===void 0){if(!g.parent)throw new Error("Malformed AST");const f=u.children.indexOf(g.parent);let c,n=g.parent.offset+g.parent.length;if(f>0){const r=u.children[f-1];c=r.offset+r.length}else c=u.offset+1,u.children.length>1&&(n=u.children[1].offset);return D(S,{offset:c,length:n-c,content:""},C)}else return D(S,{offset:g.offset,length:g.length,content:JSON.stringify(I)},C);else{if(I===void 0)return[];const f=`${JSON.stringify(v)}: ${JSON.stringify(I)}`,c=d?d(u.children.map(r=>r.children[0].value)):u.children.length;let n;if(c>0){const r=u.children[c-1];n={offset:r.offset+r.length,length:0,content:","+f}}else u.children.length===0?n={offset:u.offset+1,length:0,content:f}:n={offset:u.offset+1,length:0,content:f+","};return D(S,n,C)}}else if(u.type==="array"&&typeof v=="number"&&Array.isArray(u.children))if(I!==void 0){const g=`${JSON.stringify(I)}`;let f;if(u.children.length===0||v===0)f={offset:u.offset+1,length:0,content:u.children.length===0?g:g+","};else{const c=v===-1||v>u.children.length?u.children.length:v,n=u.children[c-1];f={offset:n.offset+n.length,length:0,content:","+g}}return D(S,f,C)}else{const g=v,f=u.children[g];let c;if(u.children.length===1)c={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===g){const n=u.children[g-1],r=n.offset+n.length,i=u.offset+u.length;c={offset:r,length:i-2-r,content:""}}else c={offset:f.offset,length:u.children[g+1].offset-f.offset,content:""};return D(S,c,C)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${u.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return D(S,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(I)},C)}}e.setProperty=R;function D(S,b,I){let C=P(S,b),d=b.offset,m=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;d>0&&!(0,t.isEOL)(C,d-1);)d--;for(;m<C.length&&!(0,t.isEOL)(C,m);)m++}const h=(0,t.format)(C,{offset:d,length:m-d},I);for(let u=h.length-1;u>=0;u--){const v=h[u];C=P(C,v),d=Math.min(d,v.offset),m=Math.max(m,v.offset+v.length),m+=v.content.length-v.length}const w=S.length-(C.length-m)-d;return[{offset:d,length:w,content:C.substring(d,m)}]}e.withFormatting=D;function P(S,b){return S.substring(0,b.offset)+b.content+S.substring(b.offset+b.length)}e.applyEdit=P;function p(S,b){const I=b.slice(0).sort((d,m)=>{const h=d.offset-m.offset;return h===0?d.length-m.length:h});let C=S.length;for(let d=I.length-1;d>=0;d--){const m=I[d];if(m.offset+m.length<=C)S=P(S,m);else throw new Error("Overlapping edit");C=m.offset}return S}e.applyEdits=p}),define(ee[124],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new E(()=>k(this.getValue()))}}e.Lazy=E}),define(ee[2],te([0,1,49,66]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function D(l){R=l}if(e.setDisposableTracker=D,k){const l="__is_disposable_tracked__";D(new class{trackDisposable(a){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[l]||console.log(y)},3e3)}setParent(a,y){if(a&&a!==v.None)try{a[l]=!0}catch{}}markAsDisposed(a){if(a&&a!==v.None)try{a[l]=!0}catch{}}markAsSingleton(a){}})}function P(l){return R?.trackDisposable(l),l}function p(l){R?.markAsDisposed(l)}function S(l,a){R?.setParent(l,a)}function b(l,a){if(!!R)for(const y of l)R.setParent(y,a)}function I(l){return R?.markAsSingleton(l),l}e.markAsSingleton=I;function C(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=C;function d(l){if(t.Iterable.is(l)){const a=[];for(const y of l)if(y)try{y.dispose()}catch(M){a.push(M)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=d;function m(l){for(const a of l)C(a)&&a.dispose();return[]}e.disposeIfDisposable=m;function h(...l){const a=w(()=>d(l));return b(l,a),a}e.combinedDisposable=h;function w(l){const a=P({dispose:(0,E.once)(()=>{p(a),l()})});return a}e.toDisposable=w;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{d(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return S(a,this),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new u,P(this),S(this._store,this)}dispose(){p(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&S(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&S(a,null),a}}e.MutableDisposable=g;class f{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(a){let y=a;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,p(this))},this}}e.SafeDisposable=c;class n{constructor(){this.references=new Map}acquire(a,...y){let M=this.references.get(a);M||(M={counter:0,object:this.createReferencedObject(a,...y)},this.references.set(a,M));const{object:T}=M,U=(0,E.once)(()=>{--M.counter===0&&(this.destroyReferencedObject(a,M.object),this.references.delete(a))});return M.counter++,{object:T,dispose:U}}}e.ReferenceCollection=n;class r{constructor(a){this.referenceCollection=a}async acquire(a,...y){const M=this.referenceCollection.acquire(a,...y);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}e.AsyncReferenceCollection=r;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function o(l){const a=new u;try{l(a)}finally{a.dispose()}}e.disposeOnReturn=o;class s{constructor(){this._store=new Map,this._isDisposed=!1,P(this)}dispose(){p(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{d(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,y,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(a)?.dispose(),this._store.set(a,y)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=s}),define(ee[94],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(R){this.element=R,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class t{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let R=this._first;for(;R!==E.Undefined;){const D=R.next;R.prev=E.Undefined,R.next=E.Undefined,R=D}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const P=new E(R);if(this._first===E.Undefined)this._first=P,this._last=P;else if(D){const S=this._last;this._last=P,P.prev=S,S.next=P}else{const S=this._first;this._first=P,P.next=S,S.prev=P}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(P))}}shift(){if(this._first!==E.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==E.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==E.Undefined&&R.next!==E.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===E.Undefined&&R.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):R.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):R.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==E.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),define(ee[38],te([0,1]),function(z,e){"use strict";var E,t,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(m,h,w){let u=m.get(h);return u===void 0&&(u=w,m.set(h,u)),u}e.getOrSet=R;function D(m){const h=[];return m.forEach((w,u)=>{h.push(`${u} => ${w}`)}),`Map(${m.size}) {${h.join(", ")}}`}e.mapToString=D;function P(m){const h=[];return m.forEach(w=>{h.push(w)}),`Set(${m.size}) {${h.join(", ")}}`}e.setToString=P;class p{constructor(h,w){this.uri=h,this.value=w}}class S{constructor(h,w){this[E]="ResourceMap",h instanceof S?(this.map=new Map(h.map),this.toKey=w??S.defaultToKey):(this.map=new Map,this.toKey=h??S.defaultToKey)}set(h,w){return this.map.set(this.toKey(h),new p(h,w)),this}get(h){return this.map.get(this.toKey(h))?.value}has(h){return this.map.has(this.toKey(h))}get size(){return this.map.size}clear(){this.map.clear()}delete(h){return this.map.delete(this.toKey(h))}forEach(h,w){typeof w<"u"&&(h=h.bind(w));for(const[u,v]of this.map)h(v.value,v.uri,this)}*values(){for(const h of this.map.values())yield h.value}*keys(){for(const h of this.map.values())yield h.uri}*entries(){for(const h of this.map.values())yield[h.uri,h.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.map)yield[h.uri,h.value]}}e.ResourceMap=S,S.defaultToKey=m=>m.toString();class b{constructor(h,w){this[t]="ResourceSet",!h||typeof h=="function"?this._map=new S(h):(this._map=new S(w),h.forEach(this.add,this))}get size(){return this._map.size}add(h){return this._map.set(h,h),this}clear(){this._map.clear()}delete(h){return this._map.delete(h)}forEach(h,w){this._map.forEach((u,v)=>h.call(w,v,v,this))}has(h){return this._map.has(h)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var I;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class C{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(h){return this._map.has(h)}get(h,w=0){const u=this._map.get(h);if(!!u)return w!==0&&this.touch(u,w),u.value}set(h,w,u=0){let v=this._map.get(h);if(v)v.value=w,u!==0&&this.touch(v,u);else{switch(v={key:h,value:w,next:void 0,previous:void 0},u){case 0:this.addItemLast(v);break;case 1:this.addItemFirst(v);break;case 2:this.addItemLast(v);break;default:this.addItemLast(v);break}this._map.set(h,v),this._size++}return this}delete(h){return!!this.remove(h)}remove(h){const w=this._map.get(h);if(!!w)return this._map.delete(h),this.removeItem(w),this._size--,w.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const h=this._head;return this._map.delete(h.key),this.removeItem(h),this._size--,h.value}forEach(h,w){const u=this._state;let v=this._head;for(;v;){if(w?h.bind(w)(v.value,v.key,this):h(v.value,v.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const h=this,w=this._state;let u=this._head;const v={[Symbol.iterator](){return v},next(){if(h._state!==w)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:u.key,done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return v}values(){const h=this,w=this._state;let u=this._head;const v={[Symbol.iterator](){return v},next(){if(h._state!==w)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:u.value,done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return v}entries(){const h=this,w=this._state;let u=this._head;const v={[Symbol.iterator](){return v},next(){if(h._state!==w)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:[u.key,u.value],done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return v}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(h){if(h>=this.size)return;if(h===0){this.clear();return}let w=this._head,u=this.size;for(;w&&u>h;)this._map.delete(w.key),w=w.next,u--;this._head=w,this._size=u,w&&(w.previous=void 0),this._state++}addItemFirst(h){if(!this._head&&!this._tail)this._tail=h;else if(this._head)h.next=this._head,this._head.previous=h;else throw new Error("Invalid list");this._head=h,this._state++}addItemLast(h){if(!this._head&&!this._tail)this._head=h;else if(this._tail)h.previous=this._tail,this._tail.next=h;else throw new Error("Invalid list");this._tail=h,this._state++}removeItem(h){if(h===this._head&&h===this._tail)this._head=void 0,this._tail=void 0;else if(h===this._head){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this._head=h.next}else if(h===this._tail){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this._tail=h.previous}else{const w=h.next,u=h.previous;if(!w||!u)throw new Error("Invalid list");w.previous=u,u.next=w}h.next=void 0,h.previous=void 0,this._state++}touch(h,w){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(w!==1&&w!==2)){if(w===1){if(h===this._head)return;const u=h.next,v=h.previous;h===this._tail?(v.next=void 0,this._tail=v):(u.previous=v,v.next=u),h.previous=void 0,h.next=this._head,this._head.previous=h,this._head=h,this._state++}else if(w===2){if(h===this._tail)return;const u=h.next,v=h.previous;h===this._head?(u.previous=void 0,this._head=u):(u.previous=v,v.next=u),h.next=void 0,h.previous=this._tail,this._tail.next=h,this._tail=h,this._state++}}}toJSON(){const h=[];return this.forEach((w,u)=>{h.push([u,w])}),h}fromJSON(h){this.clear();for(const[w,u]of h)this.set(w,u)}}e.LinkedMap=C;class d extends C{constructor(h,w=1){super(),this._limit=h,this._ratio=Math.min(Math.max(0,w),1)}get limit(){return this._limit}set limit(h){this._limit=h,this.checkTrim()}get ratio(){return this._ratio}set ratio(h){this._ratio=Math.min(Math.max(0,h),1),this.checkTrim()}get(h,w=2){return super.get(h,w)}peek(h){return super.get(h,0)}set(h,w){return super.set(h,w,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d}),define(ee[76],te([0,1,38]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new E.LRUCache(1e4);function k(S){return p(S,"NFC",t)}e.normalizeNFC=k;const R=new E.LRUCache(1e4);function D(S){return p(S,"NFD",R)}e.normalizeNFD=D;const P=/[^\u0000-\u0080]/;function p(S,b,I){if(!S)return S;const C=I.get(S);if(C)return C;let d;return P.test(S)?d=S.normalize(b):d=S,I.set(S,d),d}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(b){return D(b).replace(S,"")}}()}),function(){function z(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function D(p){R.push(p,Date.now())}function P(){const p=[];for(let S=0;S<R.length;S+=2)p.push({name:R[S],startTime:R[S+1]});return p}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(k+D.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function E(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=E(t))}(),function(z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var t in E)(typeof exports=="object"?exports:z)[t]=E[t]}}(typeof self<"u"?self:this,function(){return function(z){var e={};function E(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return z[t].call(k.exports,k,k.exports,E),k.l=!0,k.exports}return E.m=z,E.c=e,E.d=function(t,k,R){E.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},E.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},E.t=function(t,k){if(1&k&&(t=E(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(E.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var D in t)E.d(R,D,function(P){return t[P]}.bind(null,D));return R},E.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return E.d(k,"a",k),k},E.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},E.p="",E(E.s=0)}([function(z,e,E){(function(t){var k;e=z.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],p=e.src=[],S=0,b=S++;p[b]="0|[1-9]\\d*";var I=S++;p[I]="[0-9]+";var C=S++;p[C]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=S++;p[d]="("+p[b]+")\\.("+p[b]+")\\.("+p[b]+")";var m=S++;p[m]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var h=S++;p[h]="(?:"+p[b]+"|"+p[C]+")";var w=S++;p[w]="(?:"+p[I]+"|"+p[C]+")";var u=S++;p[u]="(?:-("+p[h]+"(?:\\."+p[h]+")*))";var v=S++;p[v]="(?:-?("+p[w]+"(?:\\."+p[w]+")*))";var g=S++;p[g]="[0-9A-Za-z-]+";var f=S++;p[f]="(?:\\+("+p[g]+"(?:\\."+p[g]+")*))";var c=S++,n="v?"+p[d]+p[u]+"?"+p[f]+"?";p[c]="^"+n+"$";var r="[v=\\s]*"+p[m]+p[v]+"?"+p[f]+"?",i=S++;p[i]="^"+r+"$";var o=S++;p[o]="((?:<|>)?=?)";var s=S++;p[s]=p[I]+"|x|X|\\*";var l=S++;p[l]=p[b]+"|x|X|\\*";var a=S++;p[a]="[v=\\s]*("+p[l]+")(?:\\.("+p[l]+")(?:\\.("+p[l]+")(?:"+p[u]+")?"+p[f]+"?)?)?";var y=S++;p[y]="[v=\\s]*("+p[s]+")(?:\\.("+p[s]+")(?:\\.("+p[s]+")(?:"+p[v]+")?"+p[f]+"?)?)?";var M=S++;p[M]="^"+p[o]+"\\s*"+p[a]+"$";var T=S++;p[T]="^"+p[o]+"\\s*"+p[y]+"$";var U=S++;p[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=S++;p[Y]="(?:~>?)";var G=S++;p[G]="(\\s*)"+p[Y]+"\\s+",P[G]=new RegExp(p[G],"g");var V=S++;p[V]="^"+p[Y]+p[a]+"$";var oe=S++;p[oe]="^"+p[Y]+p[y]+"$";var ae=S++;p[ae]="(?:\\^)";var se=S++;p[se]="(\\s*)"+p[ae]+"\\s+",P[se]=new RegExp(p[se],"g");var fe=S++;p[fe]="^"+p[ae]+p[a]+"$";var K=S++;p[K]="^"+p[ae]+p[y]+"$";var H=S++;p[H]="^"+p[o]+"\\s*("+r+")$|^$";var F=S++;p[F]="^"+p[o]+"\\s*("+n+")$|^$";var A=S++;p[A]="(\\s*)"+p[o]+"\\s*("+r+"|"+p[a]+")",P[A]=new RegExp(p[A],"g");var O=S++;p[O]="^\\s*("+p[a]+")\\s+-\\s+("+p[a]+")\\s*$";var _=S++;p[_]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var ne=S++;p[ne]="(<|>)?=?\\s*\\*";for(var N=0;N<35;N++)k(N,p[N]),P[N]||(P[N]=new RegExp(p[N]));function j(J,ue){if(J instanceof L)return J;if(typeof J!="string"||J.length>R||!(ue?P[i]:P[c]).test(J))return null;try{return new L(J,ue)}catch{return null}}function L(J,ue){if(J instanceof L){if(J.loose===ue)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(J,ue);k("SemVer",J,ue),this.loose=ue;var de=J.trim().match(ue?P[i]:P[c]);if(!de)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Ce=+ye;if(Ce>=0&&Ce<D)return Ce}return ye}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=j,e.valid=function(J,ue){var de=j(J,ue);return de?de.version:null},e.clean=function(J,ue){var de=j(J.trim().replace(/^[=v]+/,""),ue);return de?de.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(J){return k("SemVer.compare",this.version,this.loose,J),J instanceof L||(J=new L(J,this.loose)),this.compareMain(J)||this.comparePre(J)},L.prototype.compareMain=function(J){return J instanceof L||(J=new L(J,this.loose)),$(this.major,J.major)||$(this.minor,J.minor)||$(this.patch,J.patch)},L.prototype.comparePre=function(J){if(J instanceof L||(J=new L(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var ue=0;do{var de=this.prerelease[ue],ye=J.prerelease[ue];if(k("prerelease compare",ue,de,ye),de===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(de===void 0)return-1;if(de!==ye)return $(de,ye)}while(++ue)},L.prototype.inc=function(J,ue){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,ue,de,ye){typeof de=="string"&&(ye=de,de=void 0);try{return new L(J,de).inc(ue,ye).version}catch{return null}},e.diff=function(J,ue){if(B(J,ue))return null;var de=j(J),ye=j(ue);if(de.prerelease.length||ye.prerelease.length){for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==ye[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==ye[Ce])return Ce},e.compareIdentifiers=$;var W=/^[0-9]+$/;function $(J,ue){var de=W.test(J),ye=W.test(ue);return de&&ye&&(J=+J,ue=+ue),de&&!ye?-1:ye&&!de?1:J<ue?-1:J>ue?1:0}function q(J,ue,de){return new L(J,de).compare(new L(ue,de))}function X(J,ue,de){return q(J,ue,de)>0}function re(J,ue,de){return q(J,ue,de)<0}function B(J,ue,de){return q(J,ue,de)===0}function x(J,ue,de){return q(J,ue,de)!==0}function Z(J,ue,de){return q(J,ue,de)>=0}function ce(J,ue,de){return q(J,ue,de)<=0}function ge(J,ue,de,ye){var Ce;switch(ue){case"===":typeof J=="object"&&(J=J.version),typeof de=="object"&&(de=de.version),Ce=J===de;break;case"!==":typeof J=="object"&&(J=J.version),typeof de=="object"&&(de=de.version),Ce=J!==de;break;case"":case"=":case"==":Ce=B(J,de,ye);break;case"!=":Ce=x(J,de,ye);break;case">":Ce=X(J,de,ye);break;case">=":Ce=Z(J,de,ye);break;case"<":Ce=re(J,de,ye);break;case"<=":Ce=ce(J,de,ye);break;default:throw new TypeError("Invalid operator: "+ue)}return Ce}function De(J,ue){if(J instanceof De){if(J.loose===ue)return J;J=J.value}if(!(this instanceof De))return new De(J,ue);k("comparator",J,ue),this.loose=ue,this.parse(J),this.semver===Te?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(J,ue){return $(ue,J)},e.major=function(J,ue){return new L(J,ue).major},e.minor=function(J,ue){return new L(J,ue).minor},e.patch=function(J,ue){return new L(J,ue).patch},e.compare=q,e.compareLoose=function(J,ue){return q(J,ue,!0)},e.rcompare=function(J,ue,de){return q(ue,J,de)},e.sort=function(J,ue){return J.sort(function(de,ye){return e.compare(de,ye,ue)})},e.rsort=function(J,ue){return J.sort(function(de,ye){return e.rcompare(de,ye,ue)})},e.gt=X,e.lt=re,e.eq=B,e.neq=x,e.gte=Z,e.lte=ce,e.cmp=ge,e.Comparator=De;var Te={};function Me(J,ue){if(J instanceof Me)return J.loose===ue?J:new Me(J.raw,ue);if(J instanceof De)return new Me(J.value,ue);if(!(this instanceof Me))return new Me(J,ue);if(this.loose=ue,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Le(J){return!J||J.toLowerCase()==="x"||J==="*"}function ve(J,ue,de,ye,Ce,Fe,Oe,$e,Ne,je,Xe,Be,Ge){return((ue=Le(de)?"":Le(ye)?">="+de+".0.0":Le(Ce)?">="+de+"."+ye+".0":">="+ue)+" "+($e=Le(Ne)?"":Le(je)?"<"+(+Ne+1)+".0.0":Le(Xe)?"<"+Ne+"."+(+je+1)+".0":Be?"<="+Ne+"."+je+"."+Xe+"-"+Be:"<="+$e)).trim()}function pe(J,ue){for(var de=0;de<J.length;de++)if(!J[de].test(ue))return!1;if(ue.prerelease.length){for(de=0;de<J.length;de++)if(k(J[de].semver),J[de].semver!==Te&&J[de].semver.prerelease.length>0){var ye=J[de].semver;if(ye.major===ue.major&&ye.minor===ue.minor&&ye.patch===ue.patch)return!0}return!1}return!0}function Se(J,ue,de){try{ue=new Me(ue,de)}catch{return!1}return ue.test(J)}function ke(J,ue,de,ye){var Ce,Fe,Oe,$e,Ne;switch(J=new L(J,ye),ue=new Me(ue,ye),de){case">":Ce=X,Fe=ce,Oe=re,$e=">",Ne=">=";break;case"<":Ce=re,Fe=Z,Oe=X,$e="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(J,ue,ye))return!1;for(var je=0;je<ue.set.length;++je){var Xe=ue.set[je],Be=null,Ge=null;if(Xe.forEach(function(Q){Q.semver===Te&&(Q=new De(">=0.0.0")),Be=Be||Q,Ge=Ge||Q,Ce(Q.semver,Be.semver,ye)?Be=Q:Oe(Q.semver,Ge.semver,ye)&&(Ge=Q)}),Be.operator===$e||Be.operator===Ne||(!Ge.operator||Ge.operator===$e)&&Fe(J,Ge.semver)||Ge.operator===Ne&&Oe(J,Ge.semver))return!1}return!0}De.prototype.parse=function(J){var ue=this.loose?P[H]:P[F],de=J.match(ue);if(!de)throw new TypeError("Invalid comparator: "+J);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new L(de[2],this.loose):this.semver=Te},De.prototype.toString=function(){return this.value},De.prototype.test=function(J){return k("Comparator.test",J,this.loose),this.semver===Te||(typeof J=="string"&&(J=new L(J,this.loose)),ge(J,this.operator,this.semver,this.loose))},De.prototype.intersects=function(J,ue){if(!(J instanceof De))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Me(J.value,ue),Se(this.value,de,ue);if(J.operator==="")return de=new Me(this.value,ue),Se(J.semver,de,ue);var ye=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Fe=this.semver.version===J.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),$e=ge(this.semver,"<",J.semver,ue)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Ne=ge(this.semver,">",J.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return ye||Ce||Fe&&Oe||$e||Ne},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(J){var ue=this.loose;J=J.trim(),k("range",J,ue);var de=ue?P[_]:P[O];J=J.replace(de,ve),k("hyphen replace",J),J=J.replace(P[A],"$1$2$3"),k("comparator trim",J,P[A]),J=(J=(J=J.replace(P[G],"$1~")).replace(P[se],"$1^")).split(/\s+/).join(" ");var ye=ue?P[H]:P[F],Ce=J.split(" ").map(function(Fe){return function(Oe,$e){return k("comp",Oe),Oe=function(Ne,je){return Ne.trim().split(/\s+/).map(function(Xe){return function(Be,Ge){k("caret",Be,Ge);var Q=Ge?P[K]:P[fe];return Be.replace(Q,function(le,he,me,be,Ae){var Ue;return k("caret",Be,le,he,me,be,Ae),Le(he)?Ue="":Le(me)?Ue=">="+he+".0.0 <"+(+he+1)+".0.0":Le(be)?Ue=he==="0"?">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":">="+he+"."+me+".0 <"+(+he+1)+".0.0":Ae?(k("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ue=he==="0"?me==="0"?">="+he+"."+me+"."+be+Ae+" <"+he+"."+me+"."+(+be+1):">="+he+"."+me+"."+be+Ae+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+be+Ae+" <"+(+he+1)+".0.0"):(k("no pr"),Ue=he==="0"?me==="0"?">="+he+"."+me+"."+be+" <"+he+"."+me+"."+(+be+1):">="+he+"."+me+"."+be+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+be+" <"+(+he+1)+".0.0"),k("caret return",Ue),Ue})}(Xe,je)}).join(" ")}(Oe,$e),k("caret",Oe),Oe=function(Ne,je){return Ne.trim().split(/\s+/).map(function(Xe){return function(Be,Ge){var Q=Ge?P[oe]:P[V];return Be.replace(Q,function(le,he,me,be,Ae){var Ue;return k("tilde",Be,le,he,me,be,Ae),Le(he)?Ue="":Le(me)?Ue=">="+he+".0.0 <"+(+he+1)+".0.0":Le(be)?Ue=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":Ae?(k("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ue=">="+he+"."+me+"."+be+Ae+" <"+he+"."+(+me+1)+".0"):Ue=">="+he+"."+me+"."+be+" <"+he+"."+(+me+1)+".0",k("tilde return",Ue),Ue})}(Xe,je)}).join(" ")}(Oe,$e),k("tildes",Oe),Oe=function(Ne,je){return k("replaceXRanges",Ne,je),Ne.split(/\s+/).map(function(Xe){return function(Be,Ge){Be=Be.trim();var Q=Ge?P[T]:P[M];return Be.replace(Q,function(le,he,me,be,Ae,Ue){k("xRange",Be,le,he,me,be,Ae,Ue);var it=Le(me),xe=it||Le(be),He=xe||Le(Ae);return he==="="&&He&&(he=""),it?le=he===">"||he==="<"?"<0.0.0":"*":he&&He?(xe&&(be=0),He&&(Ae=0),he===">"?(he=">=",xe?(me=+me+1,be=0,Ae=0):He&&(be=+be+1,Ae=0)):he==="<="&&(he="<",xe?me=+me+1:be=+be+1),le=he+me+"."+be+"."+Ae):xe?le=">="+me+".0.0 <"+(+me+1)+".0.0":He&&(le=">="+me+"."+be+".0 <"+me+"."+(+be+1)+".0"),k("xRange return",le),le})}(Xe,je)}).join(" ")}(Oe,$e),k("xrange",Oe),Oe=function(Ne,je){return k("replaceStars",Ne,je),Ne.trim().replace(P[ne],"")}(Oe,$e),k("stars",Oe),Oe}(Fe,ue)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Fe){return!!Fe.match(ye)})),Ce=Ce.map(function(Fe){return new De(Fe,ue)})},Me.prototype.intersects=function(J,ue){if(!(J instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(ye){return J.set.some(function(Ce){return Ce.every(function(Fe){return ye.intersects(Fe,ue)})})})})},e.toComparators=function(J,ue){return new Me(J,ue).set.map(function(de){return de.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new L(J,this.loose));for(var ue=0;ue<this.set.length;ue++)if(pe(this.set[ue],J))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(J,ue,de){var ye=null,Ce=null;try{var Fe=new Me(ue,de)}catch{return null}return J.forEach(function(Oe){Fe.test(Oe)&&(ye&&Ce.compare(Oe)!==-1||(Ce=new L(ye=Oe,de)))}),ye},e.minSatisfying=function(J,ue,de){var ye=null,Ce=null;try{var Fe=new Me(ue,de)}catch{return null}return J.forEach(function(Oe){Fe.test(Oe)&&(ye&&Ce.compare(Oe)!==1||(Ce=new L(ye=Oe,de)))}),ye},e.validRange=function(J,ue){try{return new Me(J,ue).range||"*"}catch{return null}},e.ltr=function(J,ue,de){return ke(J,ue,"<",de)},e.gtr=function(J,ue,de){return ke(J,ue,">",de)},e.outside=ke,e.prerelease=function(J,ue){var de=j(J,ue);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(J,ue,de){return J=new Me(J,de),ue=new Me(ue,de),J.intersects(ue)},e.coerce=function(J){if(J instanceof L)return J;if(typeof J!="string")return null;var ue=J.match(P[U]);return ue==null?null:j((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,E(1))},function(z,e){var E,t,k=z.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P(w){if(E===setTimeout)return setTimeout(w,0);if((E===R||!E)&&setTimeout)return E=setTimeout,setTimeout(w,0);try{return E(w,0)}catch{try{return E.call(null,w,0)}catch{return E.call(this,w,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:R}catch{E=R}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var p,S=[],b=!1,I=-1;function C(){b&&p&&(b=!1,p.length?S=p.concat(S):I=-1,S.length&&d())}function d(){if(!b){var w=P(C);b=!0;for(var u=S.length;u;){for(p=S,S=[];++I<u;)p&&p[I].run();I=-1,u=S.length}p=null,b=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(w)}}function m(w,u){this.fun=w,this.array=u}function h(){}k.nextTick=function(w){var u=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)u[v-1]=arguments[v];S.push(new m(w,u)),S.length!==1||b||P(d)},m.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=h,k.addListener=h,k.once=h,k.off=h,k.removeListener=h,k.removeAllListeners=h,k.emit=h,k.prependListener=h,k.prependOnceListener=h,k.listeners=function(w){return[]},k.binding=function(w){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(w){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ee[125],te([0,1]),function(z,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(P,p,S){this.level=P,this.key=p,this.value=S,this.forward=[]}}const k=void 0;class R{constructor(P,p=2**16){this.comparator=P,this[E]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(p)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(P){return Boolean(R._search(this,P,this.comparator))}get(P){return R._search(this,P,this.comparator)?.value}set(P,p){return R._insert(this,P,p,this.comparator)&&(this._size+=1),this}delete(P){const p=R._delete(this,P,this.comparator);return p&&(this._size-=1),p}forEach(P,p){let S=this._header.forward[0];for(;S;)P.call(p,S.value,S.key,this),S=S.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",p=this._header.forward[0];for(;p;)P+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return P}static _search(P,p,S){let b=P._header;for(let I=P._level-1;I>=0;I--)for(;b.forward[I]&&S(b.forward[I].key,p)<0;)b=b.forward[I];if(b=b.forward[0],b&&S(b.key,p)===0)return b}static _insert(P,p,S,b){const I=[];let C=P._header;for(let d=P._level-1;d>=0;d--){for(;C.forward[d]&&b(C.forward[d].key,p)<0;)C=C.forward[d];I[d]=C}if(C=C.forward[0],C&&b(C.key,p)===0)return C.value=S,!1;{const d=R._randomLevel(P);if(d>P._level){for(let m=P._level;m<d;m++)I[m]=P._header;P._level=d}C=new t(d,p,S);for(let m=0;m<d;m++)C.forward[m]=I[m].forward[m],I[m].forward[m]=C;return!0}}static _randomLevel(P,p=.5){let S=1;for(;Math.random()<p&&S<P._maxLevel;)S+=1;return S}static _delete(P,p,S){const b=[];let I=P._header;for(let C=P._level-1;C>=0;C--){for(;I.forward[C]&&S(I.forward[C].key,p)<0;)I=I.forward[C];b[C]=I}if(I=I.forward[0],!I||S(I.key,p)!==0)return!1;for(let C=0;C<P._level&&b[C].forward[C]===I;C++)b[C].forward[C]=I.forward[C];for(;P._level>0&&P._header.forward[P._level-1]===k;)P._level-=1;return!0}}e.SkipList=R}),define(ee[57],te([0,1,16,2]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const c=f;return c?typeof c.read=="function":!1}e.isReadable=k;function R(f){const c=f;return c?[c.on,c.pause,c.resume,c.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=R;function D(f){const c=f;return c?R(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=D;function P(f,c){return new p(f,c)}e.newWriteableStream=P;class p{constructor(c,n){this.reducer=c,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c<"u"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(n=>n(c))}emitError(c){this.listeners.error.length===0?(0,E.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(n=>n(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,n){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(c,n){if(this.state.destroyed)return;let r;switch(c){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const i=r.indexOf(n);i>=0&&r.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(f,c){const n=[];let r;for(;(r=f.read())!==null;)n.push(r);return c(n)}e.consumeReadable=S;function b(f,c,n){const r=[];let i;for(;(i=f.read())!==null&&r.length<n;)r.push(i);return i===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i<"u"){const o=i;return i=void 0,o}return f.read()}}}e.peekReadable=b;function I(f,c){return new Promise((n,r)=>{const i=[];C(f,{onData:o=>{c&&i.push(o)},onError:o=>{c?r(o):n(void 0)},onEnd:()=>{n(c?c(i):void 0)}})})}e.consumeStream=I;function C(f,c){let n=!1;return f.on("error",r=>{n||c.onError(r)}),f.on("end",()=>{n||c.onEnd()}),f.on("data",r=>{n||c.onData(r)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=C;function d(f,c){return new Promise((n,r)=>{const i=new t.DisposableStore,o=[],s=y=>{if(o.push(y),o.length>c)return i.dispose(),f.pause(),n({stream:f,buffer:o,ended:!1})},l=y=>r(y),a=()=>n({stream:f,buffer:o,ended:!0});i.add((0,t.toDisposable)(()=>f.removeListener("error",l))),f.on("error",l),i.add((0,t.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),i.add((0,t.toDisposable)(()=>f.removeListener("data",s))),f.on("data",s)})}e.peekStream=d;function m(f,c){const n=P(c);return n.end(f),n}e.toStream=m;function h(){const f=P(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=h;function w(f){let c=!1;return{read:()=>c?null:(c=!0,f)}}e.toReadable=w;function u(f,c,n){const r=P(n);return C(f,{onData:i=>r.write(c.data(i)),onError:i=>r.error(c.error?c.error(i):i),onEnd:()=>r.end()}),r}e.transform=u;function v(f,c,n){let r=!1;return{read:()=>{const i=c.read();return r?i:(r=!0,i!==null?n([f,i]):f)}}}e.prefixedReadable=v;function g(f,c,n){let r=!1;const i=P(n);return C(c,{onData:o=>r?i.write(o):(r=!0,i.write(n([f,o]))),onError:o=>i.error(o),onEnd:()=>{r||(r=!0,i.write(f)),i.end()}}),i}e.prefixedStream=g}),define(ee[17],te([0,1,57]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class D{static alloc(y){return t?new D(Buffer.allocUnsafe(y)):new D(new Uint8Array(y))}static wrap(y){return t&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new D(y)}static fromString(y,M){return!(M?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(y)):(k||(k=new TextEncoder),new D(k.encode(y)))}static fromByteArray(y){const M=D.alloc(y.length);for(let T=0,U=y.length;T<U;T++)M.buffer[T]=y[T];return M}static concat(y,M){if(typeof M>"u"){M=0;for(let Y=0,G=y.length;Y<G;Y++)M+=y[Y].byteLength}const T=D.alloc(M);let U=0;for(let Y=0,G=y.length;Y<G;Y++){const V=y[Y];T.set(V,U),U+=V.byteLength}return T}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=D.alloc(this.byteLength);return y.set(this),y}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(y,M){return new D(this.buffer.subarray(y,M))}set(y,M){if(y instanceof D)this.buffer.set(y.buffer,M);else if(y instanceof Uint8Array)this.buffer.set(y,M);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),M);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return S(this.buffer,y)}writeUInt32BE(y,M){b(this.buffer,y,M)}readUInt32LE(y){return I(this.buffer,y)}writeUInt32LE(y,M){C(this.buffer,y,M)}readUInt8(y){return d(this.buffer,y)}writeUInt8(y,M){m(this.buffer,y,M)}}e.VSBuffer=D;function P(a,y){return a[y+0]<<0>>>0|a[y+1]<<8>>>0}e.readUInt16LE=P;function p(a,y,M){a[M+0]=y&255,y=y>>>8,a[M+1]=y&255}e.writeUInt16LE=p;function S(a,y){return a[y]*2**24+a[y+1]*2**16+a[y+2]*2**8+a[y+3]}e.readUInt32BE=S;function b(a,y,M){a[M+3]=y,y=y>>>8,a[M+2]=y,y=y>>>8,a[M+1]=y,y=y>>>8,a[M]=y}e.writeUInt32BE=b;function I(a,y){return a[y+0]<<0>>>0|a[y+1]<<8>>>0|a[y+2]<<16>>>0|a[y+3]<<24>>>0}e.readUInt32LE=I;function C(a,y,M){a[M+0]=y&255,y=y>>>8,a[M+1]=y&255,y=y>>>8,a[M+2]=y&255,y=y>>>8,a[M+3]=y&255}e.writeUInt32LE=C;function d(a,y){return a[y]}e.readUInt8=d;function m(a,y,M){a[M]=y}e.writeUInt8=m;function h(a){return E.consumeReadable(a,y=>D.concat(y))}e.readableToBuffer=h;function w(a){return E.toReadable(a)}e.bufferToReadable=w;function u(a){return E.consumeStream(a,y=>D.concat(y))}e.streamToBuffer=u;async function v(a){return a.ended?D.concat(a.buffer):D.concat([...a.buffer,await u(a.stream)])}e.bufferedStreamToBuffer=v;function g(a){return E.toStream(a,y=>D.concat(y))}e.bufferToStream=g;function f(a){return E.transform(a,{data:y=>typeof y=="string"?D.fromString(y):D.wrap(y)},y=>D.concat(y))}e.streamToBufferReadableStream=f;function c(a){return E.newWriteableStream(y=>D.concat(y),a)}e.newWriteableBufferStream=c;function n(a,y){return E.prefixedReadable(a,y,M=>D.concat(M))}e.prefixedBufferReadable=n;function r(a,y){return E.prefixedStream(a,y,M=>D.concat(M))}e.prefixedBufferStream=r;function i(a){let y=0,M=0,T=0;const U=new Uint8Array(Math.floor(a.length/4*3)),Y=V=>{switch(M){case 3:U[T++]=y|V,M=0;break;case 2:U[T++]=y|V>>>2,y=V<<6,M=3;break;case 1:U[T++]=y|V>>>4,y=V<<4,M=2;break;default:y=V<<2,M=1}};for(let V=0;V<a.length;V++){const oe=a.charCodeAt(V);if(oe>=65&&oe<=90)Y(oe-65);else if(oe>=97&&oe<=122)Y(oe-97+26);else if(oe>=48&&oe<=57)Y(oe-48+52);else if(oe===43||oe===45)Y(62);else if(oe===47||oe===95)Y(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${a[V]}`)}}const G=T;for(;M>0;)Y(0);return D.wrap(U).slice(0,G)}e.decodeBase64=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:a},y=!0,M=!1){const T=M?s:o;let U="";const Y=a.byteLength%3;let G=0;for(;G<a.byteLength-Y;G+=3){const V=a[G+0],oe=a[G+1],ae=a[G+2];U+=T[V>>>2],U+=T[(V<<4|oe>>>4)&63],U+=T[(oe<<2|ae>>>6)&63],U+=T[ae&63]}if(Y===1){const V=a[G+0];U+=T[V>>>2],U+=T[V<<4&63],y&&(U+="==")}else if(Y===2){const V=a[G+0],oe=a[G+1];U+=T[V>>>2],U+=T[(V<<4|oe>>>4)&63],U+=T[oe<<2&63],y&&(U+="=")}return U}e.encodeBase64=l}),define(ee[12],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(r){return typeof r=="string"}e.isString=E;function t(r){return Array.isArray(r)&&r.every(i=>E(i))}e.isStringArray=t;function k(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=k;function R(r){const i=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof i}e.isTypedArray=R;function D(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=D;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function p(r){return r===!0||r===!1}e.isBoolean=p;function S(r){return typeof r>"u"}e.isUndefined=S;function b(r){return!I(r)}e.isDefined=b;function I(r){return S(r)||r===null}e.isUndefinedOrNull=I;function C(r,i){if(!r)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=C;function d(r){if(I(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=d;function m(...r){const i=[];for(let o=0;o<r.length;o++){const s=r[o];if(I(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(s)}return i}e.assertAllDefined=m;const h=Object.prototype.hasOwnProperty;function w(r){if(!k(r))return!1;for(const i in r)if(h.call(r,i))return!1;return!0}e.isEmptyObject=w;function u(r){return typeof r=="function"}e.isFunction=u;function v(...r){return r.length>0&&r.every(u)}e.areFunctions=v;function g(r,i){const o=Math.min(r.length,i.length);for(let s=0;s<o;s++)f(r[s],i[s])}e.validateConstraints=g;function f(r,i){if(E(i)){if(typeof r!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(r instanceof i)return}catch{}if(!I(r)&&r.constructor===i||i.length===1&&i.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function c(r){return r===null?void 0:r}e.withNullAsUndefined=c;function n(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=n}),define(ee[50],te([0,1,12]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const v=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([g,f])=>{v[g]=f&&typeof f=="object"?t(f):f}),v}e.deepClone=t;function k(u){if(!u||typeof u!="object")return u;const v=[u];for(;v.length>0;){const g=v.shift();Object.freeze(g);for(const f in g)if(R.call(g,f)){const c=g[f];typeof c=="object"&&!Object.isFrozen(c)&&!(0,E.isTypedArray)(c)&&v.push(c)}}return u}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function D(u,v){return P(u,v,new Set)}e.cloneAndChange=D;function P(u,v,g){if((0,E.isUndefinedOrNull)(u))return u;const f=v(u);if(typeof f<"u")return f;if(Array.isArray(u)){const c=[];for(const n of u)c.push(P(n,v,g));return c}if((0,E.isObject)(u)){if(g.has(u))throw new Error("Cannot clone recursive data-structure");g.add(u);const c={};for(const n in u)R.call(u,n)&&(c[n]=P(u[n],v,g));return g.delete(u),c}return u}function p(u,v,g=!0){return(0,E.isObject)(u)?((0,E.isObject)(v)&&Object.keys(v).forEach(f=>{f in u?g&&((0,E.isObject)(u[f])&&(0,E.isObject)(v[f])?p(u[f],v[f],g):u[f]=v[f]):u[f]=v[f]}),u):v}e.mixin=p;function S(u,v){if(u===v)return!0;if(u==null||v===null||v===void 0||typeof u!=typeof v||typeof u!="object"||Array.isArray(u)!==Array.isArray(v))return!1;let g,f;if(Array.isArray(u)){if(u.length!==v.length)return!1;for(g=0;g<u.length;g++)if(!S(u[g],v[g]))return!1}else{const c=[];for(f in u)c.push(f);c.sort();const n=[];for(f in v)n.push(f);if(n.sort(),!S(c,n))return!1;for(g=0;g<c.length;g++)if(!S(u[c[g]],v[c[g]]))return!1}return!0}e.equals=S;function b(u){const v=new Set;return JSON.stringify(u,(g,f)=>{if((0,E.isObject)(f)||Array.isArray(f)){if(v.has(f))return"[Circular]";v.add(f)}return f})}e.safeStringify=b;function I(u,v){const g=Object.create(null);return!u||!v||Object.keys(v).forEach(c=>{const n=u[c],r=v[c];S(n,r)||(g[c]=r)}),g}e.distinct=I;function C(u,v){const g=v.toLowerCase(),f=Object.keys(u).find(c=>c.toLowerCase()===g);return f?u[f]:u[v]}e.getCaseInsensitive=C;function d(u,v){const g=Object.create(null);for(const[f,c]of Object.entries(u))v(f,c)&&(g[f]=c);return g}e.filter=d;function m(u){let v=[],g=Object.getPrototypeOf(u);for(;Object.prototype!==g;)v=v.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return v}e.getAllPropertyNames=m;function h(u){const v=[];for(const g of m(u))typeof u[g]=="function"&&v.push(g);return v}e.getAllMethodNames=h;function w(u,v){const g=c=>function(){const n=Array.prototype.slice.call(arguments,0);return v(c,n)},f={};for(const c of u)f[c]=g(c);return f}e.createProxyObject=w}),define(ee[29],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return E.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(P){for(let p=0;p<P.length;p++)P[p]=Math.floor(Math.random()*256);return P};const R=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let p=0,S="";return S+=D[R[p++]],S+=D[R[p++]],S+=D[R[p++]],S+=D[R[p++]],S+="-",S+=D[R[p++]],S+=D[R[p++]],S+="-",S+=D[R[p++]],S+=D[R[p++]],S+="-",S+=D[R[p++]],S+=D[R[p++]],S+="-",S+=D[R[p++]],S+=D[R[p++]],S+=D[R[p++]],S+=D[R[p++]],S+=D[R[p++]],S+=D[R[p++]],S}}()}),define(ee[126],te([0,1,77,39,49]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,P){if(await new Promise((b,I)=>{const C=t.createReadStream(D),d=E.createHash("sha1");C.pipe(d);const m=(0,k.once)((h,w)=>{C.removeAllListeners(),d.removeAllListeners(),h?I(h):b(w)});C.once("error",m),C.once("end",m),d.once("error",m),d.once("data",h=>m(void 0,h.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=R}),define(ee[127],te([0,1,27]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(D){const P=D.replace(/\-/g,":").toLowerCase();return!t.has(P)}function R(){const D=(0,E.networkInterfaces)();for(const P in D){const p=D[P];if(p){for(const{mac:S}of p)if(k(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(ee[95],te([0,1,78]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(P,p,S,b=1){let I=!1;return new Promise(C=>{const d=setTimeout(()=>{if(!I)return I=!0,C(0)},S);k(P,p,b,m=>{if(!I)return I=!0,clearTimeout(d),C(m)})})}e.findFreePort=t;function k(P,p,S,b){if(p===0)return b(0);const I=new E.Socket;I.once("connect",()=>(D(I),k(P+S,p-1,S,b))),I.once("data",()=>{}),I.once("error",C=>(D(I),C.code!=="ECONNREFUSED"?k(P+S,p-1,S,b):b(P))),I.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(P,p,S,b="127.0.0.1"){let I=!1,C,d=1;const m=E.createServer({pauseOnConnect:!0});function h(w,u){I||(I=!0,m.removeAllListeners(),m.close(),C&&clearTimeout(C),u(w))}return new Promise(w=>{C=setTimeout(()=>{h(0,w)},S),m.on("listening",()=>{h(P,w)}),m.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&d<p?(P++,d++,m.listen(P,b)):h(0,w)}),m.on("close",()=>{h(0,w)}),m.listen(P,b)})}e.findFreePortFaster=R;function D(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(p){console.error(p)}}}),define(ee[128],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[129],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=E}),define(ee[40],te([0,1,13,16]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,P){const p=(S,...b)=>{this.validateEvent(D,S)&&P(S,...b)};return this.mapListenerToWrapper.set(P,p),E.ipcMain.on(D,p),this}once(D,P){return E.ipcMain.once(D,(p,...S)=>{this.validateEvent(D,p)&&P(p,...S)}),this}handle(D,P){return E.ipcMain.handle(D,(p,...S)=>this.validateEvent(D,p)?P(p,...S):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return E.ipcMain.removeHandler(D),this}removeListener(D,P){const p=this.mapListenerToWrapper.get(P);return p&&(E.ipcMain.removeListener(D,p),this.mapListenerToWrapper.delete(P)),this}validateEvent(D,P){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const p=P.senderFrame,S=p.url;if(!S)return!0;let b="unknown";try{b=new URL(S).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${S}'.`),!1}return b!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${b}'.`),!1):p.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(ee[130],te([0,1,13,40,12,128]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(p,S,b,I,C)=>{const d=P(p,I,b);d.popup({window:(0,k.withNullAsUndefined)(E.BrowserWindow.fromWebContents(p.sender)),x:C?C.x:void 0,y:C?C.y:void 0,positioningItem:C?C.positioningItem:void 0,callback:()=>{d&&p.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,S)}})})}e.registerContextMenuListener=D;function P(p,S,b){const I=new E.Menu;return b.forEach(C=>{let d;C.type==="separator"?d=new E.MenuItem({type:C.type}):Array.isArray(C.submenu)?d=new E.MenuItem({submenu:P(p,S,C.submenu),label:C.label}):d=new E.MenuItem({label:C.label,type:C.type,accelerator:C.accelerator,checked:C.checked,enabled:C.enabled,visible:C.visible,click:(m,h,w)=>p.sender.send(S,C.id,w)}),I.append(d)}),I}}),define(ee[131],te([11,10]),function(z,e){return z.create("vs/base/common/date",e)}),define(ee[132],te([0,1,131]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,D=R*7,P=R*30,p=R*365;function S(I,C,d){typeof I!="number"&&(I=I.getTime());const m=Math.round((new Date().getTime()-I)/1e3);if(m<-30)return(0,E.localize)(0,null,S(new Date().getTime()+m*1e3,!1));if(m<30)return(0,E.localize)(1,null);let h;return m<t?(h=m,C?h===1?d?(0,E.localize)(2,null,h):(0,E.localize)(3,null,h):d?(0,E.localize)(4,null,h):(0,E.localize)(5,null,h):h===1?d?(0,E.localize)(6,null,h):(0,E.localize)(7,null,h):d?(0,E.localize)(8,null,h):(0,E.localize)(9,null,h)):m<k?(h=Math.floor(m/t),C?h===1?d?(0,E.localize)(10,null,h):(0,E.localize)(11,null,h):d?(0,E.localize)(12,null,h):(0,E.localize)(13,null,h):h===1?d?(0,E.localize)(14,null,h):(0,E.localize)(15,null,h):d?(0,E.localize)(16,null,h):(0,E.localize)(17,null,h)):m<R?(h=Math.floor(m/k),C?h===1?d?(0,E.localize)(18,null,h):(0,E.localize)(19,null,h):d?(0,E.localize)(20,null,h):(0,E.localize)(21,null,h):h===1?d?(0,E.localize)(22,null,h):(0,E.localize)(23,null,h):d?(0,E.localize)(24,null,h):(0,E.localize)(25,null,h)):m<D?(h=Math.floor(m/R),C?h===1?(0,E.localize)(26,null,h):(0,E.localize)(27,null,h):h===1?(0,E.localize)(28,null,h):(0,E.localize)(29,null,h)):m<P?(h=Math.floor(m/D),C?h===1?d?(0,E.localize)(30,null,h):(0,E.localize)(31,null,h):d?(0,E.localize)(32,null,h):(0,E.localize)(33,null,h):h===1?d?(0,E.localize)(34,null,h):(0,E.localize)(35,null,h):d?(0,E.localize)(36,null,h):(0,E.localize)(37,null,h)):m<p?(h=Math.floor(m/P),C?h===1?d?(0,E.localize)(38,null,h):(0,E.localize)(39,null,h):d?(0,E.localize)(40,null,h):(0,E.localize)(41,null,h):h===1?d?(0,E.localize)(42,null,h):(0,E.localize)(43,null,h):d?(0,E.localize)(44,null,h):(0,E.localize)(45,null,h)):(h=Math.floor(m/p),C?h===1?d?(0,E.localize)(46,null,h):(0,E.localize)(47,null,h):d?(0,E.localize)(48,null,h):(0,E.localize)(49,null,h):h===1?d?(0,E.localize)(50,null,h):(0,E.localize)(51,null,h):d?(0,E.localize)(52,null,h):(0,E.localize)(53,null,h))}e.fromNow=S;function b(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(ee[133],te([11,10]),function(z,e){return z.create("vs/base/common/errorMessage",e)}),define(ee[43],te([0,1,24,12,133]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(I,C){return C&&(I.stack||I.stacktrace)?k.localize(0,null,P(I),D(I.stack)||D(I.stacktrace)):P(I)}function D(I){return Array.isArray(I)?I.join(`
`):I}function P(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?k.localize(1,null,I.message):I.message||k.localize(2,null)}function p(I=null,C=!1){if(!I)return k.localize(3,null);if(Array.isArray(I)){const d=E.coalesce(I),m=p(d[0],C);return d.length>1?k.localize(4,null,m,d.length):m}if(t.isString(I))return I;if(I.detail){const d=I.detail;if(d.error)return R(d.error,C);if(d.exception)return R(d.exception,C)}return I.stack?R(I,C):I.message?I.message:k.localize(5,null)}e.toErrorMessage=p;function S(I){const C=I;return C instanceof Error&&Array.isArray(C.actions)}e.isErrorWithActions=S;function b(I,C){let d;return typeof I=="string"?d=new Error(I):d=I,d.actions=C,d}e.createErrorWithActions=b}),define(ee[134],te([11,10]),function(z,e){return z.create("vs/base/common/jsonErrorMessages",e)}),define(ee[135],te([0,1,134]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ee[136],te([11,10]),function(z,e){return z.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,136]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,R=!1,D=!1,P=!1,p=!1,S=!1,b=!1,I=!1,C=!1,d,m=e.LANGUAGE_DEFAULT,h,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const v=typeof u?.versions?.electron=="string",g=v&&u?.type==="renderer";if(typeof navigator=="object"&&!g)w=navigator.userAgent,t=w.indexOf("Windows")>=0,k=w.indexOf("Macintosh")>=0,b=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=w.indexOf("Linux")>=0,C=w?.indexOf("Mobi")>=0,p=!0,d=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,m=d;else if(typeof u=="object"){t=u.platform==="win32",k=u.platform==="darwin",R=u.platform==="linux",D=R&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,S=v,I=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT;const a=u.env.VSCODE_NLS_CONFIG;if(a)try{const y=JSON.parse(a),M=y.availableLanguages["*"];d=y.locale,m=M||e.LANGUAGE_DEFAULT,h=y._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var f;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function c(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let n=0;k?n=1:t?n=3:R&&(n=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=R,e.isLinuxSnap=D,e.isNative=P,e.isElectron=S,e.isWeb=p,e.isWebWorker=p&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=C,e.isCI=I,e.platform=n,e.userAgent=w,e.language=m;var r;(function(a){function y(){return e.language}a.value=y;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=M;function T(){return e.language==="en"}a.isDefault=T})(r=e.Language||(e.Language={})),e.locale=d,e.translationsConfigFile=h,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,U=a.length;T<U;T++){const Y=a[T];if(Y.id===M.data.vscodeScheduleAsyncWork){a.splice(T,1),Y.callback();return}}});let y=0;return M=>{const T=++y;a.push({id:T,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return a=>setTimeout(a)})();var i;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||b?2:t?1:3;let o=!0,s=!1;function l(){if(!s){s=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,o=new Uint16Array(a.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[32],te([0,1,4]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const k=E.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ee[9],te([0,1,32]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,D=122,P=46,p=47,S=92,b=58,I=63;class C extends Error{constructor(f,c,n){let r;typeof c=="string"&&c.indexOf("not ")===0?(r="must not be",c=c.replace(/^not /,"")):r="must be";const i=f.indexOf(".")!==-1?"property":"argument";let o=`The "${f}" ${i} ${r} of type ${c}`;o+=`. Received type ${typeof n}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function d(g,f){if(typeof g!="string")throw new C(f,"string",g)}function m(g){return g===p||g===S}function h(g){return g===p}function w(g){return g>=t&&g<=R||g>=k&&g<=D}function u(g,f,c,n){let r="",i=0,o=-1,s=0,l=0;for(let a=0;a<=g.length;++a){if(a<g.length)l=g.charCodeAt(a);else{if(n(l))break;l=p}if(n(l)){if(!(o===a-1||s===1))if(s===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const y=r.lastIndexOf(c);y===-1?(r="",i=0):(r=r.slice(0,y),i=r.length-1-r.lastIndexOf(c)),o=a,s=0;continue}else if(r.length!==0){r="",i=0,o=a,s=0;continue}}f&&(r+=r.length>0?`${c}..`:"..",i=2)}else r.length>0?r+=`${c}${g.slice(o+1,a)}`:r=g.slice(o+1,a),i=a-o-1;o=a,s=0}else l===P&&s!==-1?++s:s=-1}return r}function v(g,f){if(f===null||typeof f!="object")throw new C("pathObject","Object",f);const c=f.dir||f.root,n=f.base||`${f.name||""}${f.ext||""}`;return c?c===f.root?`${c}${n}`:`${c}${g}${n}`:n}e.win32={resolve(...g){let f="",c="",n=!1;for(let r=g.length-1;r>=-1;r--){let i;if(r>=0){if(i=g[r],d(i,"path"),i.length===0)continue}else f.length===0?i=E.cwd():(i=E.env[`=${f}`]||E.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==f.toLowerCase()&&i.charCodeAt(2)===S)&&(i=`${f}\\`));const o=i.length;let s=0,l="",a=!1;const y=i.charCodeAt(0);if(o===1)m(y)&&(s=1,a=!0);else if(m(y))if(a=!0,m(i.charCodeAt(1))){let M=2,T=M;for(;M<o&&!m(i.charCodeAt(M));)M++;if(M<o&&M!==T){const U=i.slice(T,M);for(T=M;M<o&&m(i.charCodeAt(M));)M++;if(M<o&&M!==T){for(T=M;M<o&&!m(i.charCodeAt(M));)M++;(M===o||M!==T)&&(l=`\\\\${U}\\${i.slice(T,M)}`,s=M)}}}else s=1;else w(y)&&i.charCodeAt(1)===b&&(l=i.slice(0,2),s=2,o>2&&m(i.charCodeAt(2))&&(a=!0,s=3));if(l.length>0)if(f.length>0){if(l.toLowerCase()!==f.toLowerCase())continue}else f=l;if(n){if(f.length>0)break}else if(c=`${i.slice(s)}\\${c}`,n=a,a&&f.length>0)break}return c=u(c,!n,"\\",m),n?`${f}\\${c}`:`${f}${c}`||"."},normalize(g){d(g,"path");const f=g.length;if(f===0)return".";let c=0,n,r=!1;const i=g.charCodeAt(0);if(f===1)return h(i)?"\\":g;if(m(i))if(r=!0,m(g.charCodeAt(1))){let s=2,l=s;for(;s<f&&!m(g.charCodeAt(s));)s++;if(s<f&&s!==l){const a=g.slice(l,s);for(l=s;s<f&&m(g.charCodeAt(s));)s++;if(s<f&&s!==l){for(l=s;s<f&&!m(g.charCodeAt(s));)s++;if(s===f)return`\\\\${a}\\${g.slice(l)}\\`;s!==l&&(n=`\\\\${a}\\${g.slice(l,s)}`,c=s)}}}else c=1;else w(i)&&g.charCodeAt(1)===b&&(n=g.slice(0,2),c=2,f>2&&m(g.charCodeAt(2))&&(r=!0,c=3));let o=c<f?u(g.slice(c),!r,"\\",m):"";return o.length===0&&!r&&(o="."),o.length>0&&m(g.charCodeAt(f-1))&&(o+="\\"),n===void 0?r?`\\${o}`:o:r?`${n}\\${o}`:`${n}${o}`},isAbsolute(g){d(g,"path");const f=g.length;if(f===0)return!1;const c=g.charCodeAt(0);return m(c)||f>2&&w(c)&&g.charCodeAt(1)===b&&m(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let f,c;for(let i=0;i<g.length;++i){const o=g[i];d(o,"path"),o.length>0&&(f===void 0?f=c=o:f+=`\\${o}`)}if(f===void 0)return".";let n=!0,r=0;if(typeof c=="string"&&m(c.charCodeAt(0))){++r;const i=c.length;i>1&&m(c.charCodeAt(1))&&(++r,i>2&&(m(c.charCodeAt(2))?++r:n=!1))}if(n){for(;r<f.length&&m(f.charCodeAt(r));)r++;r>=2&&(f=`\\${f.slice(r)}`)}return e.win32.normalize(f)},relative(g,f){if(d(g,"from"),d(f,"to"),g===f)return"";const c=e.win32.resolve(g),n=e.win32.resolve(f);if(c===n||(g=c.toLowerCase(),f=n.toLowerCase(),g===f))return"";let r=0;for(;r<g.length&&g.charCodeAt(r)===S;)r++;let i=g.length;for(;i-1>r&&g.charCodeAt(i-1)===S;)i--;const o=i-r;let s=0;for(;s<f.length&&f.charCodeAt(s)===S;)s++;let l=f.length;for(;l-1>s&&f.charCodeAt(l-1)===S;)l--;const a=l-s,y=o<a?o:a;let M=-1,T=0;for(;T<y;T++){const Y=g.charCodeAt(r+T);if(Y!==f.charCodeAt(s+T))break;Y===S&&(M=T)}if(T!==y){if(M===-1)return n}else{if(a>y){if(f.charCodeAt(s+T)===S)return n.slice(s+T+1);if(T===2)return n.slice(s+T)}o>y&&(g.charCodeAt(r+T)===S?M=T:T===2&&(M=3)),M===-1&&(M=0)}let U="";for(T=r+M+1;T<=i;++T)(T===i||g.charCodeAt(T)===S)&&(U+=U.length===0?"..":"\\..");return s+=M,U.length>0?`${U}${n.slice(s,l)}`:(n.charCodeAt(s)===S&&++s,n.slice(s,l))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const f=e.win32.resolve(g);if(f.length<=2)return g;if(f.charCodeAt(0)===S){if(f.charCodeAt(1)===S){const c=f.charCodeAt(2);if(c!==I&&c!==P)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(w(f.charCodeAt(0))&&f.charCodeAt(1)===b&&f.charCodeAt(2)===S)return`\\\\?\\${f}`;return g},dirname(g){d(g,"path");const f=g.length;if(f===0)return".";let c=-1,n=0;const r=g.charCodeAt(0);if(f===1)return m(r)?g:".";if(m(r)){if(c=n=1,m(g.charCodeAt(1))){let s=2,l=s;for(;s<f&&!m(g.charCodeAt(s));)s++;if(s<f&&s!==l){for(l=s;s<f&&m(g.charCodeAt(s));)s++;if(s<f&&s!==l){for(l=s;s<f&&!m(g.charCodeAt(s));)s++;if(s===f)return g;s!==l&&(c=n=s+1)}}}}else w(r)&&g.charCodeAt(1)===b&&(c=f>2&&m(g.charCodeAt(2))?3:2,n=c);let i=-1,o=!0;for(let s=f-1;s>=n;--s)if(m(g.charCodeAt(s))){if(!o){i=s;break}}else o=!1;if(i===-1){if(c===-1)return".";i=c}return g.slice(0,i)},basename(g,f){f!==void 0&&d(f,"ext"),d(g,"path");let c=0,n=-1,r=!0,i;if(g.length>=2&&w(g.charCodeAt(0))&&g.charCodeAt(1)===b&&(c=2),f!==void 0&&f.length>0&&f.length<=g.length){if(f===g)return"";let o=f.length-1,s=-1;for(i=g.length-1;i>=c;--i){const l=g.charCodeAt(i);if(m(l)){if(!r){c=i+1;break}}else s===-1&&(r=!1,s=i+1),o>=0&&(l===f.charCodeAt(o)?--o===-1&&(n=i):(o=-1,n=s))}return c===n?n=s:n===-1&&(n=g.length),g.slice(c,n)}for(i=g.length-1;i>=c;--i)if(m(g.charCodeAt(i))){if(!r){c=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":g.slice(c,n)},extname(g){d(g,"path");let f=0,c=-1,n=0,r=-1,i=!0,o=0;g.length>=2&&g.charCodeAt(1)===b&&w(g.charCodeAt(0))&&(f=n=2);for(let s=g.length-1;s>=f;--s){const l=g.charCodeAt(s);if(m(l)){if(!i){n=s+1;break}continue}r===-1&&(i=!1,r=s+1),l===P?c===-1?c=s:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||r===-1||o===0||o===1&&c===r-1&&c===n+1?"":g.slice(c,r)},format:v.bind(null,"\\"),parse(g){d(g,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return f;const c=g.length;let n=0,r=g.charCodeAt(0);if(c===1)return m(r)?(f.root=f.dir=g,f):(f.base=f.name=g,f);if(m(r)){if(n=1,m(g.charCodeAt(1))){let M=2,T=M;for(;M<c&&!m(g.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&m(g.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&!m(g.charCodeAt(M));)M++;M===c?n=M:M!==T&&(n=M+1)}}}}else if(w(r)&&g.charCodeAt(1)===b){if(c<=2)return f.root=f.dir=g,f;if(n=2,m(g.charCodeAt(2))){if(c===3)return f.root=f.dir=g,f;n=3}}n>0&&(f.root=g.slice(0,n));let i=-1,o=n,s=-1,l=!0,a=g.length-1,y=0;for(;a>=n;--a){if(r=g.charCodeAt(a),m(r)){if(!l){o=a+1;break}continue}s===-1&&(l=!1,s=a+1),r===P?i===-1?i=a:y!==1&&(y=1):i!==-1&&(y=-1)}return s!==-1&&(i===-1||y===0||y===1&&i===s-1&&i===o+1?f.base=f.name=g.slice(o,s):(f.name=g.slice(o,i),f.base=g.slice(o,s),f.ext=g.slice(i,s))),o>0&&o!==n?f.dir=g.slice(0,o-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let f="",c=!1;for(let n=g.length-1;n>=-1&&!c;n--){const r=n>=0?g[n]:E.cwd();d(r,"path"),r.length!==0&&(f=`${r}/${f}`,c=r.charCodeAt(0)===p)}return f=u(f,!c,"/",h),c?`/${f}`:f.length>0?f:"."},normalize(g){if(d(g,"path"),g.length===0)return".";const f=g.charCodeAt(0)===p,c=g.charCodeAt(g.length-1)===p;return g=u(g,!f,"/",h),g.length===0?f?"/":c?"./":".":(c&&(g+="/"),f?`/${g}`:g)},isAbsolute(g){return d(g,"path"),g.length>0&&g.charCodeAt(0)===p},join(...g){if(g.length===0)return".";let f;for(let c=0;c<g.length;++c){const n=g[c];d(n,"path"),n.length>0&&(f===void 0?f=n:f+=`/${n}`)}return f===void 0?".":e.posix.normalize(f)},relative(g,f){if(d(g,"from"),d(f,"to"),g===f||(g=e.posix.resolve(g),f=e.posix.resolve(f),g===f))return"";const c=1,n=g.length,r=n-c,i=1,o=f.length-i,s=r<o?r:o;let l=-1,a=0;for(;a<s;a++){const M=g.charCodeAt(c+a);if(M!==f.charCodeAt(i+a))break;M===p&&(l=a)}if(a===s)if(o>s){if(f.charCodeAt(i+a)===p)return f.slice(i+a+1);if(a===0)return f.slice(i+a)}else r>s&&(g.charCodeAt(c+a)===p?l=a:a===0&&(l=0));let y="";for(a=c+l+1;a<=n;++a)(a===n||g.charCodeAt(a)===p)&&(y+=y.length===0?"..":"/..");return`${y}${f.slice(i+l)}`},toNamespacedPath(g){return g},dirname(g){if(d(g,"path"),g.length===0)return".";const f=g.charCodeAt(0)===p;let c=-1,n=!0;for(let r=g.length-1;r>=1;--r)if(g.charCodeAt(r)===p){if(!n){c=r;break}}else n=!1;return c===-1?f?"/":".":f&&c===1?"//":g.slice(0,c)},basename(g,f){f!==void 0&&d(f,"ext"),d(g,"path");let c=0,n=-1,r=!0,i;if(f!==void 0&&f.length>0&&f.length<=g.length){if(f===g)return"";let o=f.length-1,s=-1;for(i=g.length-1;i>=0;--i){const l=g.charCodeAt(i);if(l===p){if(!r){c=i+1;break}}else s===-1&&(r=!1,s=i+1),o>=0&&(l===f.charCodeAt(o)?--o===-1&&(n=i):(o=-1,n=s))}return c===n?n=s:n===-1&&(n=g.length),g.slice(c,n)}for(i=g.length-1;i>=0;--i)if(g.charCodeAt(i)===p){if(!r){c=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":g.slice(c,n)},extname(g){d(g,"path");let f=-1,c=0,n=-1,r=!0,i=0;for(let o=g.length-1;o>=0;--o){const s=g.charCodeAt(o);if(s===p){if(!r){c=o+1;break}continue}n===-1&&(r=!1,n=o+1),s===P?f===-1?f=o:i!==1&&(i=1):f!==-1&&(i=-1)}return f===-1||n===-1||i===0||i===1&&f===n-1&&f===c+1?"":g.slice(f,n)},format:v.bind(null,"/"),parse(g){d(g,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return f;const c=g.charCodeAt(0)===p;let n;c?(f.root="/",n=1):n=0;let r=-1,i=0,o=-1,s=!0,l=g.length-1,a=0;for(;l>=n;--l){const y=g.charCodeAt(l);if(y===p){if(!s){i=l+1;break}continue}o===-1&&(s=!1,o=l+1),y===P?r===-1?r=l:a!==1&&(a=1):r!==-1&&(a=-1)}if(o!==-1){const y=i===0&&c?1:i;r===-1||a===0||a===1&&r===o-1&&r===i+1?f.base=f.name=g.slice(y,o):(f.name=g.slice(y,r),f.base=g.slice(y,o),f.ext=g.slice(r,o))}return i>0?f.dir=g.slice(0,i-1):c&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ee[79],te([0,1,4]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(P,...p){const S=p.reduce((C,d)=>(C[d]=!0,C),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(C=>!S[C]).forEach(C=>{for(let d=0;d<b.length;d++)if(C.search(b[d])!==-1){delete P[C];break}})}e.sanitizeProcessEnvironment=R;function D(P){!P||(delete P.DEBUG,E.isMacintosh&&delete P.DYLD_LIBRARY_PATH,E.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(ee[80],te([0,1,4]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=E.globals.performance&&typeof E.globals.performance.now=="function";class k{static create(D=!0){return new k(D)}constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ee[3],te([0,1,16,49,2,94,80]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,p=!1;var S;(function(l){l.None=()=>k.Disposable.None;function a(q){if(p){const{onDidAddListener:X}=q,re=m.create();let B=0;q.onDidAddListener=()=>{++B===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),X?.()}}}function y(q,X){return fe(q,()=>{},0,void 0,void 0,X)}l.defer=y;function M(q,X=0,re){return l.debounce(q,(B,x)=>B?(B.push(x),B):[x],X,void 0,void 0,re)}l.accumulate=M;function T(q){return(X,re=null,B)=>{let x=!1,Z;return Z=q(ce=>{if(!x)return Z?Z.dispose():x=!0,X.call(re,ce)},null,B),x&&Z.dispose(),Z}}l.once=T;function U(q,X,re){return se((B,x=null,Z)=>q(ce=>B.call(x,X(ce)),null,Z),re)}l.map=U;function Y(q,X,re){return se((B,x=null,Z)=>q(ce=>{X(ce),B.call(x,ce)},null,Z),re)}l.forEach=Y;function G(q,X,re){return se((B,x=null,Z)=>q(ce=>X(ce)&&B.call(x,ce),null,Z),re)}l.filter=G;function V(q){return q}l.signal=V;function oe(...q){return(X,re=null,B)=>(0,k.combinedDisposable)(...q.map(x=>x(Z=>X.call(re,Z),null,B)))}l.any=oe;function ae(q,X,re,B){let x=re;return U(q,Z=>(x=X(x,Z),x),B)}l.reduce=ae;function se(q,X){let re;const B={onWillAddFirstListener(){re=q(x.fire,x)},onDidRemoveLastListener(){re?.dispose()}};X||a(B);const x=new w(B);return X?.add(x),x.event}function fe(q,X,re=100,B=!1,x,Z){let ce,ge,De,Te=0;const Me={leakWarningThreshold:x,onWillAddFirstListener(){ce=q(ve=>{Te++,ge=X(ge,ve),B&&!De&&(Le.fire(ge),ge=void 0),clearTimeout(De),De=setTimeout(()=>{const pe=ge;ge=void 0,De=void 0,(!B||Te>1)&&Le.fire(pe),Te=0},re)})},onDidRemoveLastListener(){ce.dispose()}};Z||a(Me);const Le=new w(Me);return Z?.add(Le),Le.event}l.debounce=fe;function K(q,X=(B,x)=>B===x,re){let B=!0,x;return G(q,Z=>{const ce=B||!X(Z,x);return B=!1,x=Z,ce},re)}l.latch=K;function H(q,X,re){return[l.filter(q,X,re),l.filter(q,B=>!X(B),re)]}l.split=H;function F(q,X=!1,re=[]){let B=re.slice(),x=q(ge=>{B?B.push(ge):ce.fire(ge)});const Z=()=>{B?.forEach(ge=>ce.fire(ge)),B=null},ce=new w({onWillAddFirstListener(){x||(x=q(ge=>ce.fire(ge)))},onDidAddFirstListener(){B&&(X?setTimeout(Z):Z())},onDidRemoveLastListener(){x&&x.dispose(),x=null}});return ce.event}l.buffer=F;class A{constructor(X){this.event=X,this.disposables=new k.DisposableStore}map(X){return new A(U(this.event,X,this.disposables))}forEach(X){return new A(Y(this.event,X,this.disposables))}filter(X){return new A(G(this.event,X,this.disposables))}reduce(X,re){return new A(ae(this.event,X,re,this.disposables))}latch(){return new A(K(this.event,void 0,this.disposables))}debounce(X,re=100,B=!1,x){return new A(fe(this.event,X,re,B,x,this.disposables))}on(X,re,B){return this.event(X,re,B)}once(X,re,B){return T(this.event)(X,re,B)}dispose(){this.disposables.dispose()}}function O(q){return new A(q)}l.chain=O;function _(q,X,re=B=>B){const B=(...ge)=>ce.fire(re(...ge)),x=()=>q.on(X,B),Z=()=>q.removeListener(X,B),ce=new w({onWillAddFirstListener:x,onDidRemoveLastListener:Z});return ce.event}l.fromNodeEventEmitter=_;function ne(q,X,re=B=>B){const B=(...ge)=>ce.fire(re(...ge)),x=()=>q.addEventListener(X,B),Z=()=>q.removeEventListener(X,B),ce=new w({onWillAddFirstListener:x,onDidRemoveLastListener:Z});return ce.event}l.fromDOMEventEmitter=ne;function N(q){return new Promise(X=>T(q)(X))}l.toPromise=N;function j(q,X){return X(void 0),q(re=>X(re))}l.runAndSubscribe=j;function L(q,X){let re=null;function B(Z){re?.dispose(),re=new k.DisposableStore,X(Z,re)}B(void 0);const x=q(Z=>B(Z));return(0,k.toDisposable)(()=>{x.dispose(),re?.dispose()})}l.runAndSubscribeWithStore=L;class W{constructor(X,re){this.obs=X,this._counter=0,this._hasChanged=!1;const B={onWillAddFirstListener:()=>{X.addObserver(this)},onDidRemoveLastListener:()=>{X.removeObserver(this)}};re||a(B),this.emitter=new w(B),re&&re.add(this.emitter)}beginUpdate(X){this._counter++}handleChange(X,re){this._hasChanged=!0}endUpdate(X){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function $(q,X){return new W(q,X).emitter.event}l.fromObservable=$})(S=e.Event||(e.Event={}));class b{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${b._idPool++}`,b.all.add(this)}start(a){this._stopWatch=new D.StopWatch(!0),this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=b,b.all=new Set,b._idPool=0;let I=-1;function C(l){const a=I;return I=l,{dispose(){I=a}}}e.setGlobalLeakWarningThreshold=C;class d{constructor(a,y=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=y,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(a,y){const M=this.threshold;if(M<=0||y<M)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let U,Y=0;for(const[G,V]of this._stacks)(!U||Y<V)&&(U=G,Y=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${Y}):`),console.warn(U)}return()=>{const U=this._stacks.get(a.value)||0;this._stacks.set(a.value,U-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(a,y,M){this.callback=a,this.callbackThis=y,this.stack=M,this.subscription=new k.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class w{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=I>0||this._options?.leakWarningThreshold?new d(this._options?.leakWarningThreshold??I):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const y of a)y.subscription.isset()&&(y.subscription.unset(),y.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,y,M)=>{if(this._listeners||(this._listeners=new R.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.Disposable.None;const T=this._listeners.isEmpty();T&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let U,Y;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(Y=m.create(),U=this._leakageMon.check(Y,this._listeners.size+1)),P&&(Y=Y??m.create());const G=new h(a,y,Y),V=this._listeners.push(G);T&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,a,y);const oe=G.subscription.set(()=>{U?.(),this._disposed||(V(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return M instanceof k.DisposableStore?M.add(oe):Array.isArray(M)&&M.push(oe),oe}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const y of this._listeners)this._deliveryQueue.push(this,y,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=w;class u{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(a,y,M){this._queue.push(new g(a,y,M))}clear(a){const y=new R.LinkedList;for(const M of this._queue)M.emitter!==a&&y.push(M);this._queue=y}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(y){(0,E.onUnexpectedError)(y)}}}}e.EventDeliveryQueue=u;class v extends u{clear(a){this._queue.clear()}}class g{constructor(a,y,M){this.emitter=a,this.listener=y,this.event=M}}class f extends w{async fireAsync(a,y,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,a]);for(;this._asyncDeliveryQueue.size>0&&!y.isCancellationRequested;){const[T,U]=this._asyncDeliveryQueue.shift(),Y=[],G={...U,token:y,waitUntil:V=>{if(Object.isFrozen(Y))throw new Error("waitUntil can NOT be called asynchronous");M&&(V=M(V,T.callback)),Y.push(V)}};try{T.invoke(G)}catch(V){(0,E.onUnexpectedError)(V);continue}Object.freeze(Y),await Promise.allSettled(Y).then(V=>{for(const oe of V)oe.status==="rejected"&&(0,E.onUnexpectedError)(oe.reason)})}}}}e.AsyncEmitter=f;class c extends w{constructor(a){super(a),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=c;class n extends c{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=n;class r extends w{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){!this.hasListeners()||(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(y=>super.fire(y)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=r;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const y={event:a,listener:null};this.events.push(y),this.hasListeners&&this.hook(y);const M=()=>{this.hasListeners&&this.unhook(y);const T=this.events.indexOf(y);this.events.splice(T,1)};return(0,k.toDisposable)((0,t.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(y=>this.emitter.fire(y))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class o{constructor(){this.buffers=[]}wrapEvent(a){return(y,M,T)=>a(U=>{const Y=this.buffers[this.buffers.length-1];Y?Y.push(()=>y.call(M,U)):y.call(M,U)},void 0,T)}bufferEvents(a){const y=[];this.buffers.push(y);const M=a();return this.buffers.pop(),y.forEach(T=>T()),M}}e.EventBufferer=o;class s{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=k.Disposable.None,this.emitter=new w({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(ee[22],te([0,1,3]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(P,p){const S=setTimeout(P.bind(p),0);return{dispose(){clearTimeout(S)}}});var k;(function(P){function p(S){return S===P.None||S===P.Cancelled||S instanceof R?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}P.isCancellationToken=p,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=D}),define(ee[137],te([0,1,22]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new E.CancellationTokenSource,p=this.task(P.token);return this.result={promise:p,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=t;class k{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const p=JSON.stringify(P);return this.lastArgKey!==p&&(this.lastArgKey=p,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=k;class R{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const p=this.fn(P);return this._map.set(P,p),p}}e.CachedFunction=R}),define(ee[96],te([0,1,3,2]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=D=>({onDidChange:E.Event.None,value:D});e.staticObservableValue=k;class R extends t.Disposable{get value(){return this._value}set value(P){P!==this._value&&(this._value=P,this.changeEmitter.fire(P))}constructor(P){super(),this._value=P,this.changeEmitter=this._register(new E.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=R}),define(ee[25],te([0,1,137,124]),function(z,e,E,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function P(Q,...le){return le.length===0?Q:Q.replace(D,function(he,me){const be=parseInt(me,10);return isNaN(be)||be<0||be>=le.length?he:le[be]})}e.format=P;const p=/{([^}]+)}/g;function S(Q,le){return Q.replace(p,(he,me)=>le[me]??he)}e.format2=S;function b(Q){return Q.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=b;function I(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function C(Q,le){let he=0;const me=le.charCodeAt(0);for(let be=Q.length-1;be>=0;be--)Q.charCodeAt(be)===me&&he++;return he}e.count=C;function d(Q,le,he="\u2026"){return Q.length<=le?Q:`${Q.substr(0,le)}${he}`}e.truncate=d;function m(Q,le=" "){const he=h(Q,le);return w(he,le)}e.trim=m;function h(Q,le){if(!Q||!le)return Q;const he=le.length;if(he===0||Q.length===0)return Q;let me=0;for(;Q.indexOf(le,me)===me;)me=me+he;return Q.substring(me)}e.ltrim=h;function w(Q,le){if(!Q||!le)return Q;const he=le.length,me=Q.length;if(he===0||me===0)return Q;let be=me,Ae=-1;for(;Ae=Q.lastIndexOf(le,be-1),!(Ae===-1||Ae+he!==be);){if(Ae===0)return"";be=Ae}return Q.substring(0,be)}e.rtrim=w;function u(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function v(Q){return Q.replace(/\*/g,"")}e.stripWildcards=v;function g(Q,le,he={}){if(!Q)throw new Error("Cannot create regex from empty string");le||(Q=I(Q)),he.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(Q,me)}e.createRegExp=g;function f(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function c(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function n(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=n;function r(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=r;function i(Q){for(let le=0,he=Q.length;le<he;le++){const me=Q.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=i;function o(Q,le=0,he=Q.length){for(let me=le;me<he;me++){const be=Q.charCodeAt(me);if(be!==32&&be!==9)return Q.substring(le,me)}return Q.substring(le,he)}e.getLeadingWhitespace=o;function s(Q,le=Q.length-1){for(let he=le;he>=0;he--){const me=Q.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=s;function l(Q,le,he){const me=[];let be=0;for(const Ae of Q.matchAll(le)){if(me.push(Q.slice(be,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");be=Ae.index+Ae[0].length,me.push(he(Ae[0],...Ae.slice(1),Ae.index,Q,Ae.groups))}return me.push(Q.slice(be)),Promise.all(me).then(Ae=>Ae.join(""))}e.replaceAsync=l;function a(Q,le){return Q<le?-1:Q>le?1:0}e.compare=a;function y(Q,le,he=0,me=Q.length,be=0,Ae=le.length){for(;he<me&&be<Ae;he++,be++){const xe=Q.charCodeAt(he),He=le.charCodeAt(be);if(xe<He)return-1;if(xe>He)return 1}const Ue=me-he,it=Ae-be;return Ue<it?-1:Ue>it?1:0}e.compareSubstring=y;function M(Q,le){return T(Q,le,0,Q.length,0,le.length)}e.compareIgnoreCase=M;function T(Q,le,he=0,me=Q.length,be=0,Ae=le.length){for(;he<me&&be<Ae;he++,be++){let xe=Q.charCodeAt(he),He=le.charCodeAt(be);if(xe===He)continue;if(xe>=128||He>=128)return y(Q.toLowerCase(),le.toLowerCase(),he,me,be,Ae);Y(xe)&&(xe-=32),Y(He)&&(He-=32);const et=xe-He;if(et!==0)return et}const Ue=me-he,it=Ae-be;return Ue<it?-1:Ue>it?1:0}e.compareSubstringIgnoreCase=T;function U(Q){return Q>=48&&Q<=57}e.isAsciiDigit=U;function Y(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=Y;function G(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=G;function V(Q,le){return Q.length===le.length&&T(Q,le)===0}e.equalsIgnoreCase=V;function oe(Q,le){const he=le.length;return le.length>Q.length?!1:T(Q,le,0,he)===0}e.startsWithIgnoreCase=oe;function ae(Q,le){const he=Math.min(Q.length,le.length);let me;for(me=0;me<he;me++)if(Q.charCodeAt(me)!==le.charCodeAt(me))return me;return he}e.commonPrefixLength=ae;function se(Q,le){const he=Math.min(Q.length,le.length);let me;const be=Q.length-1,Ae=le.length-1;for(me=0;me<he;me++)if(Q.charCodeAt(be-me)!==le.charCodeAt(Ae-me))return me;return he}e.commonSuffixLength=se;function fe(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=fe;function K(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=K;function H(Q,le){return(Q-55296<<10)+(le-56320)+65536}e.computeCodePoint=H;function F(Q,le,he){const me=Q.charCodeAt(he);if(fe(me)&&he+1<le){const be=Q.charCodeAt(he+1);if(K(be))return H(me,be)}return me}e.getNextCodePoint=F;function A(Q,le){const he=Q.charCodeAt(le-1);if(K(he)&&le>1){const me=Q.charCodeAt(le-2);if(fe(me))return H(me,he)}return he}class O{get offset(){return this._offset}constructor(le,he=0){this._str=le,this._len=le.length,this._offset=he}setOffset(le){this._offset=le}prevCodePoint(){const le=A(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=F(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=O;class _{get offset(){return this._iterator.offset}constructor(le,he=0){this._iterator=new O(le,he)}nextGraphemeLength(){const le=Fe.getInstance(),he=this._iterator,me=he.offset;let be=le.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Ae=he.offset,Ue=le.getGraphemeBreakType(he.nextCodePoint());if(ye(be,Ue)){he.setOffset(Ae);break}be=Ue}return he.offset-me}prevGraphemeLength(){const le=Fe.getInstance(),he=this._iterator,me=he.offset;let be=le.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Ae=he.offset,Ue=le.getGraphemeBreakType(he.prevCodePoint());if(ye(Ue,be)){he.setOffset(Ae);break}be=Ue}return me-he.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=_;function ne(Q,le){return new _(Q,le).nextGraphemeLength()}e.nextCharLength=ne;function N(Q,le){return new _(Q,le).prevGraphemeLength()}e.prevCharLength=N;function j(Q,le){le>0&&K(Q.charCodeAt(le))&&le--;const he=le+ne(Q,le);return[he-N(Q,he),he]}e.getCharContainingOffset=j;function L(Q){const le=new _(Q);let he=0;for(;!le.eol();)he++,le.nextGraphemeLength();return he}e.charCount=L;let W;function $(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(Q){return W||(W=$()),W.test(Q)}e.containsRTL=q;const X=/^[\t\n\r\x20-\x7E]*$/;function re(Q){return X.test(Q)}e.isBasicASCII=re,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=B;function x(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=x;function Z(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=Z;function ce(Q,le){if(Q.length<le)return Q;const he=/\b/g;let me=0;for(;he.test(Q)&&!(Q.length-he.lastIndex<le);)me=he.lastIndex,he.lastIndex+=1;return Q.substring(me).replace(/^\s/,"")}e.lcut=ce;const ge=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Te=/\x1b\[0?m/g;function Me(Q){return Q&&(Q=Q.replace(ge,""),Q=Q.replace(De,""),Q=Q.replace(Te,"")),Q}e.removeAnsiEscapeCodes=Me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function ve(Q){return Le(Q)?Q.substr(1):Q}e.stripUTF8BOM=ve;function pe(Q,le){if(!Q||!le||Q.length<le.length)return!1;const he=le.length,me=Q.toLowerCase();let be=0,Ae=-1;for(;be<he;){const Ue=me.indexOf(le[be],Ae+1);if(Ue<0)return!1;Ae=Ue,be++}return!0}e.fuzzyContains=pe;function Se(Q,le=!1){return Q?(le&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=Se;function ke(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=ke;function J(Q,le=1){if(le===0)return"";let he=-1;do he=Q.indexOf(`
`,he+1),le--;while(le>0&&he>=0);return he===-1?Q:(Q[he-1]==="\r"&&he--,Q.substr(0,he))}e.getNLines=J;function ue(Q){return Q=Q%(2*26),Q<26?String.fromCharCode(97+Q):String.fromCharCode(65+Q-26)}e.singleLetterHash=ue;function de(Q){return Fe.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=de;function ye(Q,le){return Q===0?le!==5&&le!==7:Q===2&&le===3?!1:Q===4||Q===2||Q===3||le===4||le===2||le===3?!0:!(Q===8&&(le===8||le===9||le===11||le===12)||(Q===11||Q===9)&&(le===9||le===10)||(Q===12||Q===10)&&le===10||le===5||le===13||le===7||Q===1||Q===13&&le===14||Q===6&&le===6)}var Ce;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Fe{static getInstance(){return Fe._INSTANCE||(Fe._INSTANCE=new Fe),Fe._INSTANCE}constructor(){this._data=Oe()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const he=this._data,me=he.length/3;let be=1;for(;be<=me;)if(le<he[3*be])be=2*be;else if(le>he[3*be+1])be=2*be+1;else return he[3*be+2];return 0}}Fe._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function $e(Q,le){if(Q===0)return 0;const he=Ne(Q,le);if(he!==void 0)return he;const me=new O(le,Q);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=$e;function Ne(Q,le){const he=new O(le,Q);let me=he.prevCodePoint();for(;je(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!Z(me))return;let be=he.offset;return be>0&&he.prevCodePoint()===8205&&(be=he.offset),be}function je(Q){return 127995<=Q&&Q<=127999}var Xe;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.noBreakWhitespace="\xA0";class Be{static getInstance(le){return Be.cache.get(Array.from(le))}static getLocales(){return Be._locales.getValue()}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Be,k=Be,Be.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.cache=new E.LRUCachedFunction(Q=>{function le(He){const et=new Map;for(let nt=0;nt<He.length;nt+=2)et.set(He[nt],He[nt+1]);return et}function he(He,et){const nt=new Map(He);for(const[ct,gt]of et)nt.set(ct,gt);return nt}function me(He,et){if(!He)return et;const nt=new Map;for(const[ct,gt]of He)et.has(ct)&&nt.set(ct,gt);return nt}const be=k.ambiguousCharacterData.getValue();let Ae=Q.filter(He=>!He.startsWith("_")&&He in be);Ae.length===0&&(Ae=["_default"]);let Ue;for(const He of Ae){const et=le(be[He]);Ue=me(Ue,et)}const it=le(be._common),xe=he(it,Ue);return new Be(xe)}),Be._locales=new t.Lazy(()=>Object.keys(Be.ambiguousCharacterData.getValue()).filter(Q=>!Q.startsWith("_")));class Ge{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ge.getRawData())),this._data}static isInvisibleCharacter(le){return Ge.getData().has(le)}static get codePoints(){return Ge.getData()}}e.InvisibleCharacters=Ge,Ge._data=void 0}),define(ee[30],te([0,1,9,4,25,12]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(s){return s===47||s===92}e.isPathSeparator=D;function P(s){return s.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=P;function p(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=p;function S(s,l=E.posix.sep){if(!s)return"";const a=s.length,y=s.charCodeAt(0);if(D(y)){if(D(s.charCodeAt(1))&&!D(s.charCodeAt(2))){let T=3;const U=T;for(;T<a&&!D(s.charCodeAt(T));T++);if(U!==T&&!D(s.charCodeAt(T+1))){for(T+=1;T<a;T++)if(D(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,l)}}return l}else if(u(y)&&s.charCodeAt(1)===58)return D(s.charCodeAt(2))?s.slice(0,2)+l:s.slice(0,2);let M=s.indexOf("://");if(M!==-1){for(M+=3;M<a;M++)if(D(s.charCodeAt(M)))return s.slice(0,M+1)}return""}e.getRoot=S;function b(s){if(!t.isWindows||!s||s.length<5)return!1;let l=s.charCodeAt(0);if(l!==92||(l=s.charCodeAt(1),l!==92))return!1;let a=2;const y=a;for(;a<s.length&&(l=s.charCodeAt(a),l!==92);a++);return!(y===a||(l=s.charCodeAt(a+1),isNaN(l)||l===92))}e.isUNC=b;const I=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(s,l=t.isWindows){const a=l?I:C;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||l&&d.test(s)||s==="."||s===".."||l&&s[s.length-1]==="."||l&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=m;function h(s,l,a){const y=s===l;return!a||y?y:!s||!l?!1:(0,k.equalsIgnoreCase)(s,l)}e.isEqual=h;function w(s,l,a,y=E.sep){if(s===l)return!0;if(!s||!l||l.length>s.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(s,l))return!1;if(l.length===s.length)return!0;let T=l.length;return l.charAt(l.length-1)===y&&T--,s.charAt(T)===y}return l.charAt(l.length-1)!==y&&(l+=y),s.indexOf(l)===0}e.isEqualOrParent=w;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function v(s,l){return t.isWindows&&s.endsWith(":")&&(s+=E.sep),(0,E.isAbsolute)(s)||(s=(0,E.join)(l,s)),s=(0,E.normalize)(s),t.isWindows?(s=(0,k.rtrim)(s,E.sep),s.endsWith(":")&&(s+=E.sep)):(s=(0,k.rtrim)(s,E.sep),s||(s=E.sep)),s}e.sanitizeFilePath=v;function g(s){const l=(0,E.normalize)(s);return t.isWindows?s.length>3?!1:f(l)&&(s.length===2||l.charCodeAt(2)===92):l===E.posix.sep}e.isRootOrDriveLetter=g;function f(s,l=t.isWindows){return l?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function c(s){return f(s)?s[0]:void 0}e.getDriveLetter=c;function n(s,l,a){return l.length>s.length?-1:s===l?0:(a&&(s=s.toLowerCase(),l=l.toLowerCase()),s.indexOf(l))}e.indexOfPath=n;function r(s){const l=s.split(":");let a,y,M;for(const T of l){const U=Number(T);(0,R.isNumber)(U)?y===void 0?y=U:M===void 0&&(M=U):a=a?[a,T].join(":"):T}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:y!==void 0?y:void 0,column:M!==void 0?M:y!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(s,l,a=8){let y="";for(let T=0;T<a;T++)y+=i.charAt(Math.floor(Math.random()*i.length));let M;return l?M=`${l}-${y}`:M=y,s?(0,E.join)(s,M):M}e.randomPath=o}),define(ee[67],te([0,1,25]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(u){return k(u,0)}e.hash=t;function k(u,v){switch(typeof u){case"object":return u===null?R(349,v):Array.isArray(u)?p(u,v):S(u,v);case"string":return P(u,v);case"boolean":return D(u,v);case"number":return R(u,v);case"undefined":return R(937,v);default:return R(617,v)}}e.doHash=k;function R(u,v){return(v<<5)-v+u|0}e.numberHash=R;function D(u,v){return R(u?433:863,v)}function P(u,v){v=R(149417,v);for(let g=0,f=u.length;g<f;g++)v=R(u.charCodeAt(g),v);return v}e.stringHash=P;function p(u,v){return v=R(104579,v),u.reduce((g,f)=>k(f,g),v)}function S(u,v){return v=R(181387,v),Object.keys(u).sort().reduce((g,f)=>(g=P(f,g),k(u[f],g)),v)}class b{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=k(v,this._value),this._value}}e.Hasher=b;var I;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function C(u,v,g=32){const f=g-v,c=~((1<<f)-1);return(u<<v|(c&u)>>>f)>>>0}function d(u,v=0,g=u.byteLength,f=0){for(let c=0;c<g;c++)u[v+c]=f}function m(u,v,g="0"){for(;u.length<v;)u=g+u;return u}function h(u,v=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(g=>g.toString(16).padStart(2,"0")).join(""):m((u>>>0).toString(16),v/4)}e.toHexString=h;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const g=v.length;if(g===0)return;const f=this._buff;let c=this._buffLen,n=this._leftoverHighSurrogate,r,i;for(n!==0?(r=n,i=-1,n=0):(r=v.charCodeAt(0),i=0);;){let o=r;if(E.isHighSurrogate(r))if(i+1<g){const s=v.charCodeAt(i+1);E.isLowSurrogate(s)?(i++,o=E.computeCodePoint(r,s)):o=65533}else{n=r;break}else E.isLowSurrogate(r)&&(o=65533);if(c=this._push(f,c,o),i++,i<g)r=v.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=n}_push(v,g,f){return f<128?v[g++]=f:f<2048?(v[g++]=192|(f&1984)>>>6,v[g++]=128|(f&63)>>>0):f<65536?(v[g++]=224|(f&61440)>>>12,v[g++]=128|(f&4032)>>>6,v[g++]=128|(f&63)>>>0):(v[g++]=240|(f&1835008)>>>18,v[g++]=128|(f&258048)>>>12,v[g++]=128|(f&4032)>>>6,v[g++]=128|(f&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=w._bigBlock32,g=this._buffDV;for(let a=0;a<64;a+=4)v.setUint32(a,g.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)v.setUint32(a,C(v.getUint32(a-12,!1)^v.getUint32(a-32,!1)^v.getUint32(a-56,!1)^v.getUint32(a-64,!1),1),!1);let f=this._h0,c=this._h1,n=this._h2,r=this._h3,i=this._h4,o,s,l;for(let a=0;a<80;a++)a<20?(o=c&n|~c&r,s=1518500249):a<40?(o=c^n^r,s=1859775393):a<60?(o=c&n|c&r|n&r,s=2400959708):(o=c^n^r,s=3395469782),l=C(f,5)+o+i+s+v.getUint32(a*4,!1)&4294967295,i=r,r=n,n=C(c,30),c=f,f=l;this._h0=this._h0+f&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ee[97],te([0,1,25]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",D="warning",P="warn",p="info",S="ignore";function b(C){return C?E.equalsIgnoreCase(R,C)?k.Error:E.equalsIgnoreCase(D,C)||E.equalsIgnoreCase(P,C)?k.Warning:E.equalsIgnoreCase(p,C)?k.Info:k.Ignore:k.Ignore}k.fromValue=b;function I(C){switch(C){case k.Error:return R;case k.Warning:return D;case k.Info:return p;default:return S}}k.toString=I}(t||(t={})),e.default=t}),define(ee[58],te([0,1,24,25]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this._value="",this._pos=0}reset(d){return this._value=d,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(d){const m=d.charCodeAt(0),h=this._value.charCodeAt(this._pos);return m-h}value(){return this._value[this._pos]}}e.StringIterator=k;class R{constructor(d=!0){this._caseSensitive=d}reset(d){return this._value=d,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let d=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(d)this._from++;else break;else d=!1;return this}cmp(d){return this._caseSensitive?(0,t.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class D{constructor(d=!0,m=!0){this._splitOnBackslash=d,this._caseSensitive=m}reset(d){this._from=0,this._to=0,this._value=d,this._valueLen=d.length;for(let m=d.length-1;m>=0;m--,this._valueLen--){const h=this._value.charCodeAt(m);if(!(h===47||this._splitOnBackslash&&h===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let d=!0;for(;this._to<this._valueLen;this._to++){const m=this._value.charCodeAt(this._to);if(m===47||this._splitOnBackslash&&m===92)if(d)this._from++;else break;else d=!1}return this}cmp(d){return this._caseSensitive?(0,t.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=D;var P;(function(C){C[C.Scheme=1]="Scheme",C[C.Authority=2]="Authority",C[C.Path=3]="Path",C[C.Query=4]="Query",C[C.Fragment=5]="Fragment"})(P||(P={}));class p{constructor(d,m){this._ignorePathCasing=d,this._ignoreQueryAndFragment=m,this._states=[],this._stateIdx=0}reset(d){return this._value=d,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new D(!1,!this._ignorePathCasing(d)),this._pathIterator.reset(d.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(d)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(d){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(d,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(d,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(d);if(this._states[this._stateIdx]===4)return(0,t.compare)(d,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(d,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(C){C[C.Left=-1]="Left",C[C.Mid=0]="Mid",C[C.Right=1]="Right"})(b||(b={}));class I{static forUris(d=()=>!1,m=()=>!1){return new I(new p(d,m))}static forPaths(d=!1){return new I(new D(void 0,!d))}static forStrings(){return new I(new k)}static forConfigKeys(){return new I(new R)}constructor(d){this._iter=d}clear(){this._root=void 0}fill(d,m){if(m){const h=m.slice(0);(0,E.shuffle)(h);for(const w of h)this.set(w,d)}else{const h=d.slice(0);(0,E.shuffle)(h);for(const w of h)this.set(w[0],w[1])}}set(d,m){const h=this._iter.reset(d);let w;this._root||(this._root=new S,this._root.segment=h.value());const u=[];for(w=this._root;;){const g=h.cmp(w.segment);if(g>0)w.left||(w.left=new S,w.left.segment=h.value()),u.push([-1,w]),w=w.left;else if(g<0)w.right||(w.right=new S,w.right.segment=h.value()),u.push([1,w]),w=w.right;else if(h.hasNext())h.next(),w.mid||(w.mid=new S,w.mid.segment=h.value()),u.push([0,w]),w=w.mid;else break}const v=w.value;w.value=m,w.key=d;for(let g=u.length-1;g>=0;g--){const f=u[g][1];f.updateHeight();const c=f.balanceFactor();if(c<-1||c>1){const n=u[g][0],r=u[g+1][0];if(n===1&&r===1)u[g][1]=f.rotateLeft();else if(n===-1&&r===-1)u[g][1]=f.rotateRight();else if(n===1&&r===-1)f.right=u[g+1][1]=u[g+1][1].rotateRight(),u[g][1]=f.rotateLeft();else if(n===-1&&r===1)f.left=u[g+1][1]=u[g+1][1].rotateLeft(),u[g][1]=f.rotateRight();else throw new Error;if(g>0)switch(u[g-1][0]){case-1:u[g-1][1].left=u[g][1];break;case 1:u[g-1][1].right=u[g][1];break;case 0:u[g-1][1].mid=u[g][1];break}else this._root=u[0][1]}}return v}get(d){return this._getNode(d)?.value}_getNode(d){const m=this._iter.reset(d);let h=this._root;for(;h;){const w=m.cmp(h.segment);if(w>0)h=h.left;else if(w<0)h=h.right;else if(m.hasNext())m.next(),h=h.mid;else break}return h}has(d){const m=this._getNode(d);return!(m?.value===void 0&&m?.mid===void 0)}delete(d){return this._delete(d,!1)}deleteSuperstr(d){return this._delete(d,!0)}_delete(d,m){const h=this._iter.reset(d),w=[];let u=this._root;for(;u;){const v=h.cmp(u.segment);if(v>0)w.push([-1,u]),u=u.left;else if(v<0)w.push([1,u]),u=u.right;else if(h.hasNext())h.next(),w.push([0,u]),u=u.mid;else break}if(!!u){if(m?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const v=this._min(u.right);if(v.key){const{key:g,value:f,segment:c}=v;this._delete(v.key,!1),u.key=g,u.value=f,u.segment=c}}else{const v=u.left??u.right;if(w.length>0){const[g,f]=w[w.length-1];switch(g){case-1:f.left=v;break;case 0:f.mid=v;break;case 1:f.right=v;break}}else this._root=v}for(let v=w.length-1;v>=0;v--){const g=w[v][1];g.updateHeight();const f=g.balanceFactor();if(f>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),w[v][1]=g.rotateLeft()):f<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),w[v][1]=g.rotateRight()),v>0)switch(w[v-1][0]){case-1:w[v-1][1].left=w[v][1];break;case 1:w[v-1][1].right=w[v][1];break;case 0:w[v-1][1].mid=w[v][1];break}else this._root=w[0][1]}}}_min(d){for(;d.left;)d=d.left;return d}findSubstr(d){const m=this._iter.reset(d);let h=this._root,w;for(;h;){const u=m.cmp(h.segment);if(u>0)h=h.left;else if(u<0)h=h.right;else if(m.hasNext())m.next(),w=h.value||w,h=h.mid;else break}return h&&h.value||w}findSuperstr(d){const m=this._iter.reset(d);let h=this._root;for(;h;){const w=m.cmp(h.segment);if(w>0)h=h.left;else if(w<0)h=h.right;else if(m.hasNext())m.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(d){for(const[m,h]of this)d(h,m)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(d){const m=[];return this._dfsEntries(d,m),m[Symbol.iterator]()}_dfsEntries(d,m){!d||(d.left&&this._dfsEntries(d.left,m),d.value&&m.push([d.key,d.value]),d.mid&&this._dfsEntries(d.mid,m),d.right&&this._dfsEntries(d.right,m))}_isBalanced(){const d=m=>{if(!m)return!0;const h=m.balanceFactor();return h<-1||h>1?!1:d(m.left)&&d(m.right)};return d(this._root)}}e.TernarySearchTree=I}),define(ee[7],te([0,1,9,4]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function P(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(i,o){return!i&&!o?"file":i}function S(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==I&&(o=I+o):o=I;break}return o}const b="",I="/",C=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(o){return o instanceof d?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,s,l,a,y,M=!1){typeof o=="object"?(this.scheme=o.scheme||b,this.authority=o.authority||b,this.path=o.path||b,this.query=o.query||b,this.fragment=o.fragment||b):(this.scheme=p(o,M),this.authority=s||b,this.path=S(this.scheme,l||b),this.query=a||b,this.fragment=y||b,P(this,M))}get fsPath(){return g(this,!1)}with(o){if(!o)return this;let{scheme:s,authority:l,path:a,query:y,fragment:M}=o;return s===void 0?s=this.scheme:s===null&&(s=b),l===void 0?l=this.authority:l===null&&(l=b),a===void 0?a=this.path:a===null&&(a=b),y===void 0?y=this.query:y===null&&(y=b),M===void 0?M=this.fragment:M===null&&(M=b),s===this.scheme&&l===this.authority&&a===this.path&&y===this.query&&M===this.fragment?this:new h(s,l,a,y,M)}static parse(o,s=!1){const l=C.exec(o);return l?new h(l[2]||b,r(l[4]||b),r(l[5]||b),r(l[7]||b),r(l[9]||b),s):new h(b,b,b,b,b)}static file(o){let s=b;if(t.isWindows&&(o=o.replace(/\\/g,I)),o[0]===I&&o[1]===I){const l=o.indexOf(I,2);l===-1?(s=o.substring(2),o=I):(s=o.substring(2,l),o=o.substring(l)||I)}return new h("file",s,o,b,b)}static from(o){const s=new h(o.scheme,o.authority,o.path,o.query,o.fragment);return P(s,!0),s}static joinPath(o,...s){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return t.isWindows&&o.scheme==="file"?l=d.file(E.win32.join(g(o,!0),...s)).path:l=E.posix.join(o.path,...s),o.with({path:l})}toString(o=!1){return f(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof d)return o;{const s=new h(o);return s._formatted=o.external,s._fsPath=o._sep===m?o.fsPath:null,s}}else return o}}e.URI=d;const m=t.isWindows?1:void 0;class h extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(o=!1){return o?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=m),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,o){let s,l=-1;for(let a=0;a<i.length;a++){const y=i.charCodeAt(a);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||o&&y===47)l!==-1&&(s+=encodeURIComponent(i.substring(l,a)),l=-1),s!==void 0&&(s+=i.charAt(a));else{s===void 0&&(s=i.substr(0,a));const M=w[y];M!==void 0?(l!==-1&&(s+=encodeURIComponent(i.substring(l,a)),l=-1),s+=M):l===-1&&(l=a)}}return l!==-1&&(s+=encodeURIComponent(i.substring(l))),s!==void 0?s:i}function v(i){let o;for(let s=0;s<i.length;s++){const l=i.charCodeAt(s);l===35||l===63?(o===void 0&&(o=i.substr(0,s)),o+=w[l]):o!==void 0&&(o+=i[s])}return o!==void 0?o:i}function g(i,o){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=g;function f(i,o){const s=o?v:u;let l="",{scheme:a,authority:y,path:M,query:T,fragment:U}=i;if(a&&(l+=a,l+=":"),(y||a==="file")&&(l+=I,l+=I),y){let Y=y.indexOf("@");if(Y!==-1){const G=y.substr(0,Y);y=y.substr(Y+1),Y=G.indexOf(":"),Y===-1?l+=s(G,!1):(l+=s(G.substr(0,Y),!1),l+=":",l+=s(G.substr(Y+1),!1)),l+="@"}y=y.toLowerCase(),Y=y.indexOf(":"),Y===-1?l+=s(y,!1):(l+=s(y.substr(0,Y),!1),l+=y.substr(Y))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const Y=M.charCodeAt(1);Y>=65&&Y<=90&&(M=`/${String.fromCharCode(Y+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const Y=M.charCodeAt(0);Y>=65&&Y<=90&&(M=`${String.fromCharCode(Y+32)}:${M.substr(2)}`)}l+=s(M,!0)}return T&&(l+="?",l+=s(T,!1)),U&&(l+="#",l+=o?U:u(U,!1)),l}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(n)?i.replace(n,o=>c(o)):i}}),define(ee[138],te([0,1,7]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(S){const b=S;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=t;function k(S){const b=[];let I;try{const C=JSON.parse(S.arguments),d=C[C.length-1];d&&d.__$stack&&(C.pop(),I=d.__$stack),b.push(...C)}catch{b.push("Unable to log remote console arguments",S.arguments)}return{args:b,stack:I}}e.parse=k;function R(S){if(typeof S!="string")return R(k(S).stack);const b=S;if(b){const I=D(b),C=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(C&&C.length===4)return{uri:E.URI.file(C[1]),line:Number(C[2]),column:Number(C[3])}}}e.getFirstFrame=R;function D(S){if(!S)return S;const b=S.indexOf(`
`);return b===-1?S:S.substring(0,b)}function P(S,b){const{args:I,stack:C}=k(S),d=typeof I[0]=="string"&&I.length===1;let m=D(C);m&&(m=`(${m.trim()})`);let h=[];if(typeof I[0]=="string"?m&&d?h=[`%c[${b}] %c${I[0]} %c${m}`,p("blue"),p(""),p("grey")]:h=[`%c[${b}] %c${I[0]}`,p("blue"),p(""),...I.slice(1)]:h=[`%c[${b}]%`,p("blue"),...I],m&&!d&&h.push(m),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,h)}e.log=P;function p(S){return`color: ${S}`}}),define(ee[68],te([0,1,17,25,7]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(S){return JSON.stringify(S,P)}e.stringify=R;function D(S){let b=JSON.parse(S);return b=p(b),b}e.parse=D;function P(S,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,t.regExpFlags)(b)}:b}function p(S,b=0){if(!S||b>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return k.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 15:return new Date(S.source)}if(S instanceof E.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let I=0;I<S.length;++I)S[I]=p(S[I],b+1);else for(const I in S)Object.hasOwnProperty.call(S,I)&&(S[I]=p(S[I],b+1))}return S}e.revive=p}),define(ee[14],te([0,1,4,7]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebook="vscode-notebook",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractive="vscode-interactive",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}setServerRootPath(S){this._remoteResourcesPath=`${S}/${k.vscodeRemoteResource}`}set(S,b,I){this._hosts[S]=b,this._ports[S]=I}setConnectionToken(S,b){this._connectionTokens[S]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(S){if(this._delegate)return this._delegate(S);const b=S.authority;let I=this._hosts[b];I&&I.indexOf(":")!==-1&&I.indexOf("[")===-1&&(I=`[${I}]`);const C=this._ports[b],d=this._connectionTokens[b];let m=`path=${encodeURIComponent(S.path)}`;return typeof d=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(d)}`),t.URI.from({scheme:E.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${I}:${C}`,path:this._remoteResourcesPath,query:m})}}e.RemoteAuthorities=new R;class D{asBrowserUri(S,b){const I=this.toUri(S,b);return I.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===k.file&&(E.isNative||E.isWebWorker&&E.globals.origin===`${k.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?I.with({scheme:k.vscodeFileResource,authority:I.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(S,b){const I=this.toUri(S,b);return I.scheme===k.vscodeFileResource?I.with({scheme:k.file,authority:I.authority!==D.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(S,b){return t.URI.isUri(S)?S:t.URI.parse(b.toUrl(S))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D;var P;(function(p){const S=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(S.get("3"));const b="vscode-coi";function I(d){let m;typeof d=="string"?m=new URL(d).searchParams:d instanceof URL?m=d.searchParams:t.URI.isUri(d)&&(m=new URL(d.toString(!0)).searchParams);const h=m?.get(b);if(!!h)return S.get(h)}p.getHeadersFromQuery=I;function C(d,m,h){if(!globalThis.crossOriginIsolated)return;const w=m&&h?"3":h?"2":"1";d instanceof URLSearchParams?d.set(b,w):d[b]=w}p.addSearchParam=C})(P=e.COI||(e.COI={}))}),define(ee[19],te([0,1,30,14,9,4,25,7]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(d){return(0,P.uriToFsPath)(d,!0)}e.originalFSPath=p;class S{constructor(m){this._ignorePathCasing=m}compare(m,h,w=!1){return m===h?0:(0,D.compare)(this.getComparisonKey(m,w),this.getComparisonKey(h,w))}isEqual(m,h,w=!1){return m===h?!0:!m||!h?!1:this.getComparisonKey(m,w)===this.getComparisonKey(h,w)}getComparisonKey(m,h=!1){return m.with({path:this._ignorePathCasing(m)?m.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(m){return this._ignorePathCasing(m)}isEqualOrParent(m,h,w=!1){if(m.scheme===h.scheme){if(m.scheme===t.Schemas.file)return E.isEqualOrParent(p(m),p(h),this._ignorePathCasing(m))&&m.query===h.query&&(w||m.fragment===h.fragment);if((0,e.isEqualAuthority)(m.authority,h.authority))return E.isEqualOrParent(m.path,h.path,this._ignorePathCasing(m),"/")&&m.query===h.query&&(w||m.fragment===h.fragment)}return!1}joinPath(m,...h){return P.URI.joinPath(m,...h)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return k.posix.basename(m.path)}extname(m){return k.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let h;return m.scheme===t.Schemas.file?h=P.URI.file(k.dirname(p(m))).path:(h=k.posix.dirname(m.path),m.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),h="/")),m.with({path:h})}normalizePath(m){if(!m.path.length)return m;let h;return m.scheme===t.Schemas.file?h=P.URI.file(k.normalize(p(m))).path:h=k.posix.normalize(m.path),m.with({path:h})}relativePath(m,h){if(m.scheme!==h.scheme||!(0,e.isEqualAuthority)(m.authority,h.authority))return;if(m.scheme===t.Schemas.file){const v=k.relative(p(m),p(h));return R.isWindows?E.toSlashes(v):v}let w=m.path||"/";const u=h.path||"/";if(this._ignorePathCasing(m)){let v=0;for(const g=Math.min(w.length,u.length);v<g&&!(w.charCodeAt(v)!==u.charCodeAt(v)&&w.charAt(v).toLowerCase()!==u.charAt(v).toLowerCase());v++);w=u.substr(0,v)+w.substr(v)}return k.posix.relative(w,u)}resolvePath(m,h){if(m.scheme===t.Schemas.file){const w=P.URI.file(k.resolve(p(m),h));return m.with({authority:w.authority,path:w.path})}return h=E.toPosixPath(h),m.with({path:k.posix.resolve(m.path,h)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,h){return m===h||m!==void 0&&h!==void 0&&(0,D.equalsIgnoreCase)(m,h)}hasTrailingPathSeparator(m,h=k.sep){if(m.scheme===t.Schemas.file){const w=p(m);return w.length>E.getRoot(w).length&&w[w.length-1]===h}else{const w=m.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,h=k.sep){return(0,e.hasTrailingPathSeparator)(m,h)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,h=k.sep){let w=!1;if(m.scheme===t.Schemas.file){const u=p(m);w=u!==void 0&&u.length===E.getRoot(u).length&&u[u.length-1]===h}else{h="/";const u=m.path;w=u.length===1&&u.charCodeAt(u.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(m,h)?m.with({path:m.path+"/"}):m}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(d=>d.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new S(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(d,m){const h=[];for(let w=0;w<d.length;w++){const u=m(d[w]);d.some((v,g)=>g===w?!1:(0,e.isEqualOrParent)(u,m(v)))||h.push(d[w])}return h}e.distinctParents=b;var I;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function m(h){const w=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(g=>{const[f,c]=g.split(":");f&&c&&w.set(f,c)});const v=h.path.substring(0,h.path.indexOf(";"));return v&&w.set(d.META_DATA_MIME,v),w}d.parseMetaData=m})(I=e.DataUri||(e.DataUri={}));function C(d,m,h){if(m){let w=d.path;return w&&w[0]!==k.posix.sep&&(w=k.posix.sep+w),d.with({scheme:h,authority:m,path:w})}return d.with({scheme:h})}e.toLocalResource=C}),define(ee[8],te([0,1,22,16,3,2,19,4]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p(j){return!!j&&typeof j.then=="function"}e.isThenable=p;function S(j){const L=new E.CancellationTokenSource,W=j(L.token),$=new Promise((q,X)=>{const re=L.token.onCancellationRequested(()=>{re.dispose(),L.dispose(),X(new t.CancellationError)});Promise.resolve(W).then(B=>{re.dispose(),L.dispose(),q(B)},B=>{re.dispose(),L.dispose(),X(B)})});return new class{cancel(){L.cancel()}then(q,X){return $.then(q,X)}catch(q){return this.then(void 0,q)}finally(q){return $.finally(q)}}}e.createCancelablePromise=S;function b(j,L,W){return new Promise(($,q)=>{const X=L.onCancellationRequested(()=>{X.dispose(),$(W)});j.then($,q).finally(()=>X.dispose())})}e.raceCancellation=b;function I(j,L){return new Promise((W,$)=>{const q=L.onCancellationRequested(()=>{q.dispose(),$(new t.CancellationError)});j.then(W,$).finally(()=>q.dispose())})}e.raceCancellationError=I;async function C(j){let L=-1;const W=j.map((q,X)=>q.then(re=>(L=X,re))),$=await Promise.race(W);return j.forEach((q,X)=>{X!==L&&q.cancel()}),$}e.raceCancellablePromises=C;function d(j,L,W){let $;const q=setTimeout(()=>{$?.(void 0),W?.()},L);return Promise.race([j.finally(()=>clearTimeout(q)),new Promise(X=>$=X)])}e.raceTimeout=d;function m(j){return new Promise((L,W)=>{const $=j();p($)?$.then(L,W):L($)})}e.asPromise=m;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(W,W).then($)})}return new Promise((W,$)=>{this.queuedPromise.then(W,$)})}return this.activePromise=L(),new Promise((W,$)=>{this.activePromise.then(q=>{this.activePromise=null,W(q)},q=>{this.activePromise=null,$(q)})})}}e.Throttler=h;class w{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=w;class u{constructor(){this.promiseMap=new Map}queue(L,W){const q=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(L)===q&&this.promiseMap.delete(L)});return this.promiseMap.set(L,q),q}}e.SequencerByKey=u;const v=(j,L)=>{let W=!0;const $=setTimeout(()=>{W=!1,L()},j);return{isTriggered:()=>W,dispose:()=>{clearTimeout($),W=!1}}},g=j=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,j())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,W=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,X)=>{this.doResolve=q,this.doReject=X}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}}));const $=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=W===e.MicrotaskDelay?g($):v(W,$),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class c{constructor(L){this.delayer=new f(L),this.throttler=new h}trigger(L,W){return this.delayer.trigger(()=>this.throttler.queue(L),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class n{constructor(){this._isOpen=!1,this._promise=new Promise((L,W)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class r extends n{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function i(j,L){return L?new Promise((W,$)=>{const q=setTimeout(()=>{X.dispose(),W()},j),X=L.onCancellationRequested(()=>{clearTimeout(q),X.dispose(),$(new t.CancellationError)})}):S(W=>i(j,W))}e.timeout=i;function o(j,L=0){const W=setTimeout(j,L);return(0,R.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=o;function s(j){const L=[];let W=0;const $=j.length;function q(){return W<$?j[W++]():null}function X(re){re!=null&&L.push(re);const B=q();return B?B.then(X):Promise.resolve(L)}return Promise.resolve(null).then(X)}e.sequence=s;function l(j,L=$=>!!$,W=null){let $=0;const q=j.length,X=()=>{if($>=q)return Promise.resolve(W);const re=j[$++];return Promise.resolve(re()).then(x=>L(x)?Promise.resolve(x):X())};return X()}e.first=l;function a(j,L=$=>!!$,W=null){if(j.length===0)return Promise.resolve(W);let $=j.length;const q=()=>{$=-1;for(const X of j)X.cancel?.()};return new Promise((X,re)=>{for(const B of j)B.then(x=>{--$>=0&&L(x)?(q(),X(x)):$===0&&X(W)}).catch(x=>{--$>=0&&(q(),re(x))})})}e.firstParallel=a;class y{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((W,$)=>{this.outstandingPromises.push({factory:L,c:W,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const W=L.factory();W.then(L.c,L.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=y;class M extends y{constructor(){super(1)}}e.Queue=M;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new F;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,W=D.extUri){const $=W.getComparisonKey(L);let q=this.queues.get($);return q||(q=new M,k.Event.once(q.onDrained)(()=>{q?.dispose(),this.queues.delete($),this.onDidQueueDrain()}),this.queues.set($,q)),q}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class U{constructor(L,W){this._token=-1,typeof L=="function"&&typeof W=="number"&&this.setIfNotSet(L,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},W)}setIfNotSet(L,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},W))}}e.TimeoutTimer=U;class Y{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,W){this.cancel(),this._token=setInterval(()=>{L()},W)}}e.IntervalTimer=Y;class G{constructor(L,W){this.timeoutToken=-1,this.runner=L,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=G;class V{constructor(L,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=V;class oe extends G{constructor(L,W){super(L,W),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=oe;class ae extends R.Disposable{constructor(L,W){super(),this.options=L,this.handler=W,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new G(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ae,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=j=>{(0,P.setTimeout0)(()=>{if(L)return;const W=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(j,L)=>{const W=requestIdleCallback(j,typeof L=="number"?{timeout:L}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(W))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function fe(j,L,W){let $;for(let q=0;q<W;q++)try{return await j()}catch(X){$=X,await i(L)}throw $}e.retry=fe;class K{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(L,W,$){return this._pending={taskId:L,cancel:()=>$?.(),promise:W},W.then(()=>this.donePending(L),()=>this.donePending(L)),W}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let W,$;const q=new Promise((X,re)=>{W=X,$=re});this._next={run:L,promise:q,promiseResolve:W,promiseReject:$}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=K;class H{constructor(L,W=()=>Date.now()){this.interval=L,this.nowFn=W,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class F{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,W)=>{this.completeCallback=L,this.errorCallback=W})}complete(L){return new Promise(W=>{this.completeCallback(L),this.resolved=!0,W()})}error(L){return new Promise(W=>{this.errorCallback(L),this.rejected=!0,W()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=F;var A;(function(j){async function L($){let q;const X=await Promise.all($.map(re=>re.then(B=>B,B=>{q||(q=B)})));if(typeof q<"u")throw q;return X}j.settled=L;function W($){return new Promise(async(q,X)=>{try{await $(q,X)}catch(re){X(re)}})}j.withAsyncBody=W})(A=e.Promises||(e.Promises={}));var O;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(O||(O={}));class _{static fromArray(L){return new _(W=>{W.emitMany(L)})}static fromPromise(L){return new _(async W=>{W.emitMany(await L)})}static fromPromises(L){return new _(async W=>{await Promise.all(L.map(async $=>W.emitOne(await $)))})}static merge(L){return new _(async W=>{await Promise.all(L.map(async $=>{for await(const q of $)W.emitOne(q)}))})}constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const W={emitOne:$=>this.emitOne($),emitMany:$=>this.emitMany($),reject:$=>this.reject($)};try{await Promise.resolve(L(W)),this.resolve()}catch($){this.reject($)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,W){return new _(async $=>{for await(const q of L)$.emitOne(W(q))})}map(L){return _.map(this,L)}static filter(L,W){return new _(async $=>{for await(const q of L)W(q)&&$.emitOne(q)})}filter(L){return _.filter(this,L)}static coalesce(L){return _.filter(L,W=>!!W)}coalesce(){return _.coalesce(this)}static async toPromise(L){const W=[];for await(const $ of L)W.push($);return W}toPromise(){return _.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=_,_.EMPTY=_.fromArray([]);class ne extends _{constructor(L,W){super(W),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ne;function N(j){const L=new E.CancellationTokenSource,W=j(L.token);return new ne(L,async $=>{const q=L.token.onCancellationRequested(()=>{q.dispose(),L.dispose(),$.reject(new t.CancellationError)});try{for await(const X of W){if(L.token.isCancellationRequested)return;$.emitOne(X)}q.dispose(),L.dispose()}catch(X){q.dispose(),L.dispose(),$.reject(X)}})}e.createCancelableAsyncIterable=N}),define(ee[98],te([0,1,24,8,30,38,9,4,25]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",I="[^/\\\\]",C=/\//g;function d(F,A){switch(F){case 0:return"";case 1:return`${I}*?`;default:return`(?:${b}|${I}+${b}${A?`|${b}${I}+`:""})*?`}}function m(F,A){if(!F)return[];const O=[];let _=!1,ne=!1,N="";for(const j of F){switch(j){case A:if(!_&&!ne){O.push(N),N="";continue}break;case"{":_=!0;break;case"}":_=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}N+=j}return N&&O.push(N),O}e.splitGlobAware=m;function h(F){if(!F)return"";let A="";const O=m(F,e.GLOB_SPLIT);if(O.every(_=>_===e.GLOBSTAR))A=".*";else{let _=!1;O.forEach((ne,N)=>{if(ne===e.GLOBSTAR){if(_)return;A+=d(2,N===O.length-1)}else{let j=!1,L="",W=!1,$="";for(const q of ne){if(q!=="}"&&j){L+=q;continue}if(W&&(q!=="]"||!$)){let X;q==="-"?X=q:(q==="^"||q==="!")&&!$?X="^":q===e.GLOB_SPLIT?X="":X=(0,p.escapeRegExpCharacters)(q),$+=X;continue}switch(q){case"{":j=!0;continue;case"[":W=!0;continue;case"}":{A+=`(?:${m(L,",").map(B=>h(B)).join("|")})`,j=!1,L="";break}case"]":{A+="["+$+"]",W=!1,$="";break}case"?":A+=I;continue;case"*":A+=d(1);continue;default:A+=(0,p.escapeRegExpCharacters)(q)}}N<O.length-1&&(O[N+1]!==e.GLOBSTAR||N+2<O.length)&&(A+=b)}_=ne===e.GLOBSTAR})}return A}const w=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new R.LRUCache(1e4),r=function(){return!1},i=function(){return null};function o(F,A){if(!F)return i;let O;typeof F!="string"?O=F.pattern:O=F,O=O.trim();const _=`${O}_${!!A.trimForExclusions}`;let ne=n.get(_);if(ne)return s(ne,F);let N;return w.test(O)?ne=a(O.substr(4),O):(N=u.exec(l(O,A)))?ne=y(N[1],O):(A.trimForExclusions?g:v).test(O)?ne=M(O,A):(N=f.exec(l(O,A)))?ne=T(N[1].substr(1),O,!0):(N=c.exec(l(O,A)))?ne=T(N[1],O,!1):ne=U(O),n.set(_,ne),s(ne,F)}function s(F,A){if(typeof A=="string")return F;const O=function(_,ne){return(0,k.isEqualOrParent)(_,A.base,!P.isLinux)?F(_.substr(A.base.length+1),ne):null};return O.allBasenames=F.allBasenames,O.allPaths=F.allPaths,O.basenames=F.basenames,O.patterns=F.patterns,O}function l(F,A){return A.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function a(F,A){return function(O,_){return typeof O=="string"&&O.endsWith(F)?A:null}}function y(F,A){const O=`/${F}`,_=`\\${F}`,ne=function(j,L){return typeof j!="string"?null:L?L===F?A:null:j===F||j.endsWith(O)||j.endsWith(_)?A:null},N=[F];return ne.basenames=N,ne.patterns=[A],ne.allBasenames=N,ne}function M(F,A){const O=K(F.slice(1,-1).split(",").map(L=>o(L,A)).filter(L=>L!==i),F),_=O.length;if(!_)return i;if(_===1)return O[0];const ne=function(L,W){for(let $=0,q=O.length;$<q;$++)if(O[$](L,W))return F;return null},N=O.find(L=>!!L.allBasenames);N&&(ne.allBasenames=N.allBasenames);const j=O.reduce((L,W)=>W.allPaths?L.concat(W.allPaths):L,[]);return j.length&&(ne.allPaths=j),ne}function T(F,A,O){const _=D.sep===D.posix.sep,ne=_?F:F.replace(C,D.sep),N=D.sep+ne,j=D.posix.sep+F;let L;return O?L=function(W,$){return typeof W=="string"&&(W===ne||W.endsWith(N)||!_&&(W===F||W.endsWith(j)))?A:null}:L=function(W,$){return typeof W=="string"&&(W===ne||!_&&W===F)?A:null},L.allPaths=[(O?"*/":"./")+F],L}function U(F){try{const A=new RegExp(`^${h(F)}$`);return function(O){return A.lastIndex=0,typeof O=="string"&&A.test(O)?F:null}}catch{return i}}function Y(F,A,O){return!F||typeof A!="string"?!1:G(F)(A,void 0,O)}e.match=Y;function G(F,A={}){if(!F)return r;if(typeof F=="string"||V(F)){const O=o(F,A);if(O===i)return r;const _=function(ne,N){return!!O(ne,N)};return O.allBasenames&&(_.allBasenames=O.allBasenames),O.allPaths&&(_.allPaths=O.allPaths),_}return se(F,A)}e.parse=G;function V(F){const A=F;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=V;function oe(F){return F.allBasenames||[]}e.getBasenameTerms=oe;function ae(F){return F.allPaths||[]}e.getPathTerms=ae;function se(F,A){const O=K(Object.getOwnPropertyNames(F).map(L=>fe(L,F[L],A)).filter(L=>L!==i)),_=O.length;if(!_)return i;if(!O.some(L=>!!L.requiresSiblings)){if(_===1)return O[0];const L=function(q,X){let re;for(let B=0,x=O.length;B<x;B++){const Z=O[B](q,X);if(typeof Z=="string")return Z;(0,t.isThenable)(Z)&&(re||(re=[]),re.push(Z))}return re?(async()=>{for(const B of re){const x=await B;if(typeof x=="string")return x}return null})():null},W=O.find(q=>!!q.allBasenames);W&&(L.allBasenames=W.allBasenames);const $=O.reduce((q,X)=>X.allPaths?q.concat(X.allPaths):q,[]);return $.length&&(L.allPaths=$),L}const ne=function(L,W,$){let q,X;for(let re=0,B=O.length;re<B;re++){const x=O[re];x.requiresSiblings&&$&&(W||(W=(0,D.basename)(L)),q||(q=W.substr(0,W.length-(0,D.extname)(L).length)));const Z=x(L,W,q,$);if(typeof Z=="string")return Z;(0,t.isThenable)(Z)&&(X||(X=[]),X.push(Z))}return X?(async()=>{for(const re of X){const B=await re;if(typeof B=="string")return B}return null})():null},N=O.find(L=>!!L.allBasenames);N&&(ne.allBasenames=N.allBasenames);const j=O.reduce((L,W)=>W.allPaths?L.concat(W.allPaths):L,[]);return j.length&&(ne.allPaths=j),ne}function fe(F,A,O){if(A===!1)return i;const _=o(F,O);if(_===i)return i;if(typeof A=="boolean")return _;if(A){const ne=A.when;if(typeof ne=="string"){const N=(j,L,W,$)=>{if(!$||!_(j,L))return null;const q=ne.replace("$(basename)",W),X=$(q);return(0,t.isThenable)(X)?X.then(re=>re?F:null):X?F:null};return N.requiresSiblings=!0,N}}return _}function K(F,A){const O=F.filter(L=>!!L.basenames);if(O.length<2)return F;const _=O.reduce((L,W)=>{const $=W.basenames;return $?L.concat($):L},[]);let ne;if(A){ne=[];for(let L=0,W=_.length;L<W;L++)ne.push(A)}else ne=O.reduce((L,W)=>{const $=W.patterns;return $?L.concat($):L},[]);const N=function(L,W){if(typeof L!="string")return null;if(!W){let q;for(q=L.length;q>0;q--){const X=L.charCodeAt(q-1);if(X===47||X===92)break}W=L.substr(q)}const $=_.indexOf(W);return $!==-1?ne[$]:null};N.basenames=_,N.patterns=ne,N.allBasenames=_;const j=F.filter(L=>!L.basenames);return j.push(N),j}function H(F,A){return(0,E.equals)(F,A,(O,_)=>typeof O=="string"&&typeof _=="string"?O===_:typeof O!="string"&&typeof _!="string"?O.base===_.base&&O.pattern===_.pattern:!1)}e.patternsEquals=H}),define(ee[33],te([0,1,24,30,9,4,19,25]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function p(i,o){const{os:s,tildify:l,relative:a}=o;if(a){const T=S(i,a,s);if(typeof T=="string")return T}let y=i.fsPath;if(s===1&&!R.isWindows?y=y.replace(/\//g,"\\"):s!==1&&R.isWindows&&(y=y.replace(/\\/g,"/")),s!==1&&l?.userHome){const T=l.userHome.fsPath;let U;i.scheme!==l.userHome.scheme&&i.path.startsWith(k.posix.sep)?U=l.userHome.with({path:i.path}).fsPath:U=i.fsPath,y=C(U,T,s)}return(s===1?k.win32:k.posix).normalize(b(y,s===1))}e.getPathLabel=p;function S(i,o,s){const l=s===1?k.win32:k.posix,a=s===3?D.extUri:D.extUriIgnorePathCase,y=o.getWorkspace(),M=(0,E.firstOrDefault)(y.folders);if(!M)return;i.scheme!==M.uri.scheme&&i.path.startsWith(k.posix.sep)&&(i=M.uri.with({path:i.path}));const T=o.getWorkspaceFolder(i);if(!T)return;let U;if(a.isEqual(T.uri,i)?U="":U=a.relativePath(T.uri,i)??"",U&&(U=l.normalize(U)),y.folders.length>1&&!o.noPrefix){const Y=T.name?T.name:a.basenameOrAuthority(T.uri);U=U?`${Y} \u2022 ${U}`:Y}return U}function b(i,o=R.isWindows){return(0,t.hasDriveLetter)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=b;let I=Object.create(null);function C(i,o,s=R.OS){if(s===1||!i||!o)return i;let l=I.original===o?I.normalized:void 0;l||(l=o,R.isWindows&&(l=(0,t.toSlashes)(l)),l=`${(0,P.rtrim)(l,k.posix.sep)}${k.posix.sep}`,I={original:o,normalized:l});let a=i;return R.isWindows&&(a=(0,t.toSlashes)(a)),(s===3?a.startsWith(l):(0,P.startsWithIgnoreCase)(a,l))?`~/${a.substr(l.length)}`:i}e.tildify=C;function d(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=d;const m="\u2026",h="\\\\",w="~";function u(i,o=k.sep){const s=new Array(i.length);let l=!1;for(let a=0;a<i.length;a++){const y=i[a];if(y===""){s[a]=`.${o}`;continue}if(!y){s[a]=y;continue}l=!0;let M="",T=y;T.indexOf(h)===0?(M=T.substr(0,T.indexOf(h)+h.length),T=T.substr(T.indexOf(h)+h.length)):T.indexOf(o)===0?(M=T.substr(0,T.indexOf(o)+o.length),T=T.substr(T.indexOf(o)+o.length)):T.indexOf(w)===0&&(M=T.substr(0,T.indexOf(w)+w.length),T=T.substr(T.indexOf(w)+w.length));const U=T.split(o);for(let Y=1;l&&Y<=U.length;Y++)for(let G=U.length-Y;l&&G>=0;G--){l=!1;let V=U.slice(G,G+Y).join(o);for(let oe=0;!l&&oe<i.length;oe++)if(oe!==a&&i[oe]&&i[oe].indexOf(V)>-1){const ae=G+Y===U.length,se=G>0&&i[oe].indexOf(o)>-1?o+V:V,fe=i[oe].endsWith(se);l=!ae||fe}if(!l){let oe="";(U[0].endsWith(":")||M!=="")&&(G===1&&(G=0,Y++,V=U[0]+o+V),G>0&&(oe=U[0]+o),oe=M+oe),G>0&&(oe=oe+m+o),oe=oe+V,G+Y<U.length&&(oe=oe+o+m),s[a]=oe}}l&&(s[a]=y)}return s}e.shorten=u;var v;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function g(i,o=Object.create(null)){const s=[];let l=!1,a="";for(const y of i)if(y==="$"||l&&y==="{")a&&s.push({value:a,type:v.TEXT}),a="",l=!0;else if(y==="}"&&l){const M=o[a];if(typeof M=="string")M.length&&s.push({value:M,type:v.VARIABLE});else if(M){const T=s[s.length-1];(!T||T.type!==v.SEPARATOR)&&s.push({value:M.label,type:v.SEPARATOR})}a="",l=!1}else a+=y;return a&&!l&&s.push({value:a,type:v.TEXT}),s.filter((y,M)=>{if(y.type===v.SEPARATOR){const T=s[M-1],U=s[M+1];return[T,U].every(Y=>Y&&(Y.type===v.VARIABLE||Y.type===v.TEXT)&&Y.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=g;function f(i,o){return R.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function c(i,o){return R.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,s=>s==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function r(i){const o=i.indexOf("/")!==-1?k.posix:k.win32,s=o.basename(i),l=o.dirname(i);return s.length?{name:s,parentPath:l}:{name:l,parentPath:""}}e.splitName=r}),define(ee[139],te([0,1,7]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(b){return b.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const C=this._uriTransformer.transformIncoming(I);return C===I?I:t(E.URI.from(C))}transformOutgoing(I){const C=this._uriTransformer.transformOutgoing(I);return C===I?I:t(E.URI.from(C))}transformOutgoingURI(I){const C=this._uriTransformer.transformOutgoing(I);return C===I?I:E.URI.from(C)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function R(b,I,C){if(!b||C>200)return null;if(typeof b=="object"){if(b instanceof E.URI)return I.transformOutgoing(b);for(const d in b)if(Object.hasOwnProperty.call(b,d)){const m=R(b[d],I,C+1);m!==null&&(b[d]=m)}}return null}function D(b,I){const C=R(b,I,0);return C===null?b:C}e.transformOutgoingURIs=D;function P(b,I,C,d){if(!b||d>200)return null;if(typeof b=="object"){if(b.$mid===1)return C?E.URI.revive(I.transformIncoming(b)):I.transformIncoming(b);for(const m in b)if(Object.hasOwnProperty.call(b,m)){const h=P(b[m],I,C,d+1);h!==null&&(b[m]=h)}}return null}function p(b,I){const C=P(b,I,!1,0);return C===null?b:C}e.transformIncomingURIs=p;function S(b,I){const C=P(b,I,!0,0);return C===null?b:C}e.transformAndReviveIncomingURIs=S}),define(ee[81],te([0,1,27,16,58,29,127]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(b){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(b)}value(){if(this._value===void 0){let b=0,I=0;const C=(0,E.networkInterfaces)();for(const d in C){const m=C[d];if(m)for(const{mac:h,internal:w}of m)w||(I+=1,this._isVirtualMachineMacAddress(h.toUpperCase())&&(b+=1))}this._value=I>0?b/I:0}return this._value}};let P;async function p(){return P||(P=(async()=>await S()||R.generateUuid())()),P}e.getMachineId=p;async function S(){try{const b=await new Promise((C,d)=>{z(["crypto"],C,d)}),I=(0,D.getMac)();return b.createHash("sha256").update(I,"utf8").digest("hex")}catch(b){t.onUnexpectedError(b);return}}}),define(ee[23],te([0,1,39,27,140,8,30,76,9,4,19,7]),function(z,e,E,t,k,R,D,P,p,S,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var C;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(C=e.RimRafMode||(e.RimRafMode={}));async function d(se,fe=C.UNLINK){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return fe===C.UNLINK?h(se):m(se)}async function m(se){try{const fe=(0,D.randomPath)((0,t.tmpdir)());try{await E.promises.rename(se,fe)}catch(K){return K.code==="ENOENT"?void 0:h(se)}h(fe).catch(K=>{})}catch(fe){if(fe.code!=="ENOENT")throw fe}}async function h(se){return(0,k.promisify)(E.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function w(se){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function u(se,fe){return f(await(fe?v(se):(0,k.promisify)(E.readdir)(se)))}async function v(se){try{return await(0,k.promisify)(E.readdir)(se,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const fe=[],K=await u(se);for(const H of K){let F=!1,A=!1,O=!1;try{const _=await e.Promises.lstat((0,p.join)(se,H));F=_.isFile(),A=_.isDirectory(),O=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}fe.push({name:H,isFile:()=>F,isDirectory:()=>A,isSymbolicLink:()=>O})}return fe}function g(se){return f(E.readdirSync(se))}e.readdirSync=g;function f(se){return se.map(fe=>typeof fe=="string"?S.isMacintosh?(0,P.normalizeNFC)(fe):fe:(fe.name=S.isMacintosh?(0,P.normalizeNFC)(fe.name):fe.name,fe))}async function c(se){const fe=await u(se),K=[];for(const H of fe)await r.existsDirectory((0,p.join)(se,H))&&K.push(H);return K}function n(se,fe=1e3){return new Promise(K=>{let H=!1;const F=setInterval(()=>{H||(H=!0,E.access(se,A=>{H=!1,A&&(clearInterval(F),K(void 0))}))},fe)})}e.whenDeleted=n;var r;(function(se){async function fe(F){let A;try{if(A=await e.Promises.lstat(F),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(F),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(S.isWindows&&O.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw _}throw O}}se.stat=fe;async function K(F){try{const{stat:A,symbolicLink:O}=await se.stat(F);return A.isFile()&&O?.dangling!==!0}catch{}return!1}se.existsFile=K;async function H(F){try{const{stat:A,symbolicLink:O}=await se.stat(F);return A.isDirectory()&&O?.dangling!==!0}catch{}return!1}se.existsDirectory=H})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function o(se,fe,K){return i.queueFor(I.URI.file(se),b.extUriBiasedIgnorePathCase).queue(()=>{const H=M(K);return new Promise((F,A)=>a(se,fe,H,O=>O?A(O):F()))})}let s=!0;function l(se){s=se}e.configureFlushOnWrite=l;function a(se,fe,K,H){if(!s)return E.writeFile(se,fe,{mode:K.mode,flag:K.flag},H);E.open(se,K.flag,K.mode,(F,A)=>{if(F)return H(F);E.writeFile(A,fe,O=>{if(O)return E.close(A,()=>H(O));E.fdatasync(A,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),l(!1)),E.close(A,ne=>H(ne))))})})}function y(se,fe,K){const H=M(K);if(!s)return E.writeFileSync(se,fe,{mode:H.mode,flag:H.flag});const F=E.openSync(se,H.flag,H.mode);try{E.writeFileSync(F,fe);try{E.fdatasyncSync(F)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),l(!1)}}finally{E.closeSync(F)}}e.writeFileSync=y;function M(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,fe){if(se!==fe)try{await e.Promises.rename(se,fe)}catch(K){if(se.toLowerCase()!==fe.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await U(se,fe,{preserveSymlinks:!1}),await d(se,C.MOVE);else throw K}}async function U(se,fe,K){return G(se,fe,{root:{source:se,target:fe},options:K,handledSourcePaths:new Set})}const Y=511;async function G(se,fe,K){if(K.handledSourcePaths.has(se))return;K.handledSourcePaths.add(se);const{stat:H,symbolicLink:F}=await r.stat(se);if(F){if(K.options.preserveSymlinks)try{return await ae(se,fe,K)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(F.dangling)return}return H.isDirectory()?V(se,fe,H.mode&Y,K):oe(se,fe,H.mode&Y)}async function V(se,fe,K,H){await e.Promises.mkdir(fe,{recursive:!0,mode:K});const F=await u(se);for(const A of F)await G((0,p.join)(se,A),(0,p.join)(fe,A),H)}async function oe(se,fe,K){await e.Promises.copyFile(se,fe),await e.Promises.chmod(fe,K)}async function ae(se,fe,K){let H=await e.Promises.readlink(se);(0,D.isEqualOrParent)(H,K.root.source,!S.isLinux)&&(H=(0,p.join)(K.root.target,H.substr(K.root.source.length+1))),await e.Promises.symlink(H,fe)}e.Promises=new class{get access(){return(0,k.promisify)(E.access)}get stat(){return(0,k.promisify)(E.stat)}get lstat(){return(0,k.promisify)(E.lstat)}get utimes(){return(0,k.promisify)(E.utimes)}get read(){return(se,fe,K,H,F)=>new Promise((A,O)=>{E.read(se,fe,K,H,F,(_,ne,N)=>_?O(_):A({bytesRead:ne,buffer:N}))})}get readFile(){return(0,k.promisify)(E.readFile)}get write(){return(se,fe,K,H,F)=>new Promise((A,O)=>{E.write(se,fe,K,H,F,(_,ne,N)=>_?O(_):A({bytesWritten:ne,buffer:N}))})}get appendFile(){return(0,k.promisify)(E.appendFile)}get fdatasync(){return(0,k.promisify)(E.fdatasync)}get truncate(){return(0,k.promisify)(E.truncate)}get rename(){return(0,k.promisify)(E.rename)}get copyFile(){return(0,k.promisify)(E.copyFile)}get open(){return(0,k.promisify)(E.open)}get close(){return(0,k.promisify)(E.close)}get symlink(){return(0,k.promisify)(E.symlink)}get readlink(){return(0,k.promisify)(E.readlink)}get chmod(){return(0,k.promisify)(E.chmod)}get mkdir(){return(0,k.promisify)(E.mkdir)}get unlink(){return(0,k.promisify)(E.unlink)}get rmdir(){return(0,k.promisify)(E.rmdir)}get realpath(){return(0,k.promisify)(E.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return c}get writeFile(){return o}get rm(){return d}get move(){return T}get copy(){return U}}}),define(ee[99],te([0,1,39,9,4,25,23]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(C){if(k.isLinux)return C;const d=(0,t.dirname)(C);if(C===d)return C;const m=((0,t.basename)(C)||C).toLowerCase();try{const w=(0,D.readdirSync)(d).filter(u=>u.toLowerCase()===m);if(w.length===1){const u=P(d);if(u)return(0,t.join)(u,w[0])}else if(w.length>1){const u=w.indexOf(m);if(u>=0){const v=P(d);if(v)return(0,t.join)(v,w[u])}}}catch{}return null}e.realcaseSync=P;async function p(C){if(k.isLinux)return C;const d=(0,t.dirname)(C);if(C===d)return C;const m=((0,t.basename)(C)||C).toLowerCase();try{const w=(await D.Promises.readdir(d)).filter(u=>u.toLowerCase()===m);if(w.length===1){const u=await p(d);if(u)return(0,t.join)(u,w[0])}else if(w.length>1){const u=w.indexOf(m);if(u>=0){const v=await p(d);if(v)return(0,t.join)(v,w[u])}}}catch{}return null}e.realcase=p;async function S(C){try{return await D.Promises.realpath(C)}catch{const m=I(C);return await D.Promises.access(m,E.constants.R_OK),m}}e.realpath=S;function b(C){try{return E.realpathSync(C)}catch{const m=I(C);return E.accessSync(m,E.constants.R_OK),m}}e.realpathSync=b;function I(C){return(0,R.rtrim)((0,t.normalize)(C),t.sep)}}),define(ee[141],te([0,1,27,9,23]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var p;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(p||(p={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class I{constructor(c,n,r){this.exePath=c,this.displayName=n,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function C({useAlternateBitness:f=!1}={}){return f?S===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:f=!1,findPreview:c=!1}={}){const n=C({useAlternateBitness:f});if(!n)return null;const r=t.join(n,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let i=-1,o=null;for(const a of await k.Promises.readdir(r)){let y=-1;if(c){const T=a.indexOf("-");if(T<0)continue;const U=a.substring(0,T);if(!R.test(U)||a.substring(T+1)!=="preview")continue;y=parseInt(U,10)}else{if(!R.test(a))continue;y=parseInt(a,10)}if(y<=i)continue;const M=t.join(r,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(M)||(o=M,i=y)}if(!o)return null;const s=n.includes("x86")?" (x86)":"",l=c?" Preview":"";return new I(o,`PowerShell${l}${s}`,!0)}async function m({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=f?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(c))if(n.test(i)){const o=t.join(c,i,"pwsh.exe");return new I(o,r)}return null}function h(){const f=t.join(E.homedir(),".dotnet","tools","pwsh.exe");return new I(f,".NET Core PowerShell Global Tool")}function w(){const f=t.join(process.env.windir,S===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(f,"Windows PowerShell",!0)}async function*u(){let f=await d();f&&(yield f),f=await d({useAlternateBitness:!0}),f&&(yield f),f=await m(),f&&(yield f),f=h(),f&&(yield f),f=await d({findPreview:!0}),f&&(yield f),f=await m({findPreview:!0}),f&&(yield f),f=await d({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=w(),f&&(yield f)}async function*v(){for await(const f of u())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=v;async function g(){for await(const f of v())return f;return null}e.getFirstAvailablePowerShellInstallation=g}),define(ee[82],te([0,1,9,4,32,79,12,23]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function p(I=k.env){return I.comspec||"cmd.exe"}e.getWindowsShell=p;function S(I){let C=[],d=!1;const m=function(h){if(d){C.push(h);return}(!I.send(h,u=>{if(u&&console.error(u),d=!1,C.length>0){const v=C.slice(0);C=[],v.forEach(g=>m(g))}})||t.isWindows)&&(d=!0)};return{send:m}}e.createQueuedSender=S;var b;(function(I){async function C(d,m,h){if(E.isAbsolute(d))return d;if(m===void 0&&(m=k.cwd()),E.dirname(d)!=="."||(h===void 0&&D.isString(k.env.PATH)&&(h=k.env.PATH.split(E.delimiter)),h===void 0||h.length===0))return E.join(m,d);async function u(v){if(await P.Promises.exists(v)){let g;try{g=await P.Promises.stat(v)}catch(f){f.message.startsWith("EACCES")&&(g=await P.Promises.lstat(v))}return g?!g.isDirectory():!1}return!1}for(const v of h){let g;if(E.isAbsolute(v)?g=E.join(v,d):g=E.join(m,v,d),await u(g))return g;let f=g+".com";if(await u(f)||(f=g+".exe",await u(f)))return f}return E.join(m,d)}I.findExecutable=C})(b=e.win32||(e.win32={}))}),define(ee[100],te([0,1,44,14]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(D){return new Promise((P,p)=>{let S;const b=new Map;function I(d,m,h,w,u){const v=b.get(m);if(d===D||v){const g={name:C(h),cmd:h,pid:d,ppid:m,load:w,mem:u};b.set(d,g),d===D&&(S=g),v&&(v.children||(v.children=[]),v.children.push(g),v.children.length>1&&(v.children=v.children.sort((f,c)=>f.pid-c.pid)))}}function C(d){const m=/--vscode-window-kind=shared-process/,h=/--vscode-window-kind=issue-reporter/,w=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,v=/--utility-sub-type=node.mojom.NodeService/,g=/--crashes-directory/,f=/\\pipe\\winpty-control/,c=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(g.exec(d))return"electron-crash-reporter";if(f.exec(d))return"winpty-process";if(c.exec(d))return"console-window-host (Windows internal process)";let r=n.exec(d);if(r&&r.length===2){if(r[1]==="renderer")return m.exec(d)?"shared-process":h.exec(d)?"issue-reporter":w.exec(d)?"process-explorer":"window";if(r[1]==="utility"){if(u.exec(d))return"utility-network-service";if(v.exec(d))return"extension-host"}return r[1]}const i=/[a-zA-Z-]+\.js/g;let o="";do r=i.exec(d),r&&(o+=r+" ");while(r);return o&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${o}`:d}if(process.platform==="win32"){const d=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,h)=>{z(["windows-process-tree"],m,h)}).then(m=>{m.getProcessList(D,h=>{if(!h){p(new Error(`Root process ${D} not found`));return}m.getProcessCpuUsage(h,w=>{const u=new Map;w.forEach(v=>{const g=d(v.commandLine||"");u.set(v.pid,{name:C(g),cmd:g,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),S=u.get(D),S?(u.forEach(v=>{const g=u.get(v.ppid);g&&(g.children||(g.children=[]),g.children.push(v))}),u.forEach(v=>{v.children&&(v.children=v.children.sort((g,f)=>g.pid-f.pid))}),P(S)):p(new Error(`Root process ${D} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let d=function(){let m=[S];const h=[];for(;m.length;){const u=m.shift();u&&(h.push(u.pid),u.children&&(m=m.concat(u.children)))}let w=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",z).fsPath);w+=" "+h.join(" "),(0,E.exec)(w,{},(u,v,g)=>{if(u||g)p(u||new Error(g.toString()));else{const f=v.toString().split(`
`);for(let c=0;c<h.length;c++){const n=b.get(h[c]);n.load=parseFloat(f[c])}if(!S){p(new Error(`Root process ${D} not found`));return}P(S)}})};(0,E.exec)("which ps",{},(m,h,w)=>{if(m||w)if(process.platform!=="linux")p(m||new Error(w.toString()));else{const u=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",z).fsPath);(0,E.exec)(u,{},(v,g,f)=>{v||f?p(v||new Error(f.toString())):(R(g,I),d())})}else{const u=h.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${u} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,f,c)=>{g||c&&!c.includes("screen size is bogus")?p(g||new Error(c.toString())):(R(f,I),process.platform==="linux"?d():S?P(S):p(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=k;function R(D,P){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=D.toString().split(`
`);for(const b of S){const I=p.exec(b.trim());I&&I.length===6&&P(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(ee[142],te([0,1,27,4,141,82]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(d,m){return d===1?t.isWindows?I():R.getWindowsShell(m):S(d,m)}e.getSystemShell=D;function P(d,m){return d===1?t.isWindows?C(m):R.getWindowsShell(m):S(d,m)}e.getSystemShellSync=P;let p=null;function S(d,m){if(t.isLinux&&d===2||t.isMacintosh&&d===3)return"/bin/bash";if(!p){let h;if(t.isWindows)h="/bin/bash";else{if(h=m.SHELL,!h)try{h=(0,E.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}p=h}return p}let b=null;async function I(){return b||(b=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),b}function C(d){if(b)return b;const m=t.isWindows&&parseFloat((0,E.release)())>=10,h=d.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${d.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return m?w:R.getWindowsShell(d)}});var we=this&&this.__decorate||function(z,e,E,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,E):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(z,e,E,t);else for(var P=z.length-1;P>=0;P--)(D=z[P])&&(R=(k<3?D(R):k>3?D(e,E,R):D(e,E))||R);return k>3&&R&&Object.defineProperty(e,E,R),R};define(ee[45],te([0,1,24,8,17,22,53,16,3,2,68,25,12]),function(z,e,E,t,k,R,D,P,p,S,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var d;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(d||(d={}));function m(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(h||(h={}));function w(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(u||(u={}));class v{constructor(A){this.buffer=A,this.pos=0}read(A){const O=this.buffer.slice(this.pos,this.pos+A);return this.pos+=O.byteLength,O}}class g{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var f;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(f||(f={}));function c(F){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(F,0),A}function n(F){return F.read(4).readUInt32BE(0)}function r(F){const A=k.VSBuffer.alloc(1);return A.writeUInt8(F,0),A}const i={Undefined:r(f.Undefined),String:r(f.String),Buffer:r(f.Buffer),VSBuffer:r(f.VSBuffer),Array:r(f.Array),Object:r(f.Object)},o=typeof Buffer<"u";function s(F,A){if(typeof A>"u")F.write(i.Undefined);else if(typeof A=="string"){const O=k.VSBuffer.fromString(A);F.write(i.String),F.write(c(O.byteLength)),F.write(O)}else if(o&&Buffer.isBuffer(A)){const O=k.VSBuffer.wrap(A);F.write(i.Buffer),F.write(c(O.byteLength)),F.write(O)}else if(A instanceof k.VSBuffer)F.write(i.VSBuffer),F.write(c(A.byteLength)),F.write(A);else if(Array.isArray(A)){F.write(i.Array),F.write(c(A.length));for(const O of A)s(F,O)}else{const O=k.VSBuffer.fromString(JSON.stringify(A));F.write(i.Object),F.write(c(O.byteLength)),F.write(O)}}function l(F){switch(F.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return F.read(n(F)).toString();case f.Buffer:return F.read(n(F)).buffer;case f.VSBuffer:return F.read(n(F));case f.Array:{const O=n(F),_=[];for(let ne=0;ne<O;ne++)_.push(l(F));return _}case f.Object:return JSON.parse(F.read(n(F)).toString())}}class a{constructor(A,O,_=null,ne=1e3){this.protocol=A,this.ctx=O,this.logger=_,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(N=>this.onRawMessage(N)),this.sendResponse({type:200})}registerChannel(A,O){this.channels.set(A,O),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const O=this.send([A.type]);this.logger?.logOutgoing(O,0,1,w(A.type));return}case 201:case 202:case 204:case 203:{const O=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(O,A.id,1,w(A.type),A.data);return}}}send(A,O=void 0){const _=new g;return s(_,A),s(_,O),this.sendBuffer(_.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const O=new v(A),_=l(O),ne=l(O),N=_[0];switch(N){case 100:return this.logger?.logIncoming(A.byteLength,_[1],1,`${m(N)}: ${_[2]}.${_[3]}`,ne),this.onPromise({type:N,id:_[1],channelName:_[2],name:_[3],arg:ne});case 102:return this.logger?.logIncoming(A.byteLength,_[1],1,`${m(N)}: ${_[2]}.${_[3]}`,ne),this.onEventListen({type:N,id:_[1],channelName:_[2],name:_[3],arg:ne});case 101:return this.logger?.logIncoming(A.byteLength,_[1],1,`${m(N)}`),this.disposeActiveRequest({type:N,id:_[1]});case 103:return this.logger?.logIncoming(A.byteLength,_[1],1,`${m(N)}`),this.disposeActiveRequest({type:N,id:_[1]})}}onPromise(A){const O=this.channels.get(A.channelName);if(!O){this.collectPendingRequest(A);return}const _=new R.CancellationTokenSource;let ne;try{ne=O.call(this.ctx,A.name,A.arg,_.token)}catch(L){ne=Promise.reject(L)}const N=A.id;ne.then(L=>{this.sendResponse({id:N,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:N,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:N,data:L,type:203}),this.activeRequests.delete(A.id)});const j=(0,S.toDisposable)(()=>_.cancel());this.activeRequests.set(A.id,j)}onEventListen(A){const O=this.channels.get(A.channelName);if(!O){this.collectPendingRequest(A);return}const _=A.id,N=O.listen(this.ctx,A.name,A.arg)(j=>this.sendResponse({id:_,data:j,type:204}));this.activeRequests.set(A.id,N)}disposeActiveRequest(A){const O=this.activeRequests.get(A.id);O&&(O.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let O=this.pendingRequests.get(A.channelName);O||(O=[],this.pendingRequests.set(A.channelName,O));const _=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:A,timeoutTimer:_})}flushPendingRequests(A){const O=this.pendingRequests.get(A);if(O){for(const _ of O)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.onPromise(_.request);break;case 102:this.onEventListen(_.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var y;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(A,O=null){this.protocol=A,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(_=>this.onBuffer(_)),this.logger=O}getChannel(A){const O=this;return{call(_,ne,N){return O.isDisposed?Promise.reject(new P.CancellationError):O.requestPromise(A,_,ne,N)},listen(_,ne){return O.isDisposed?p.Event.None:O.requestEvent(A,_,ne)}}}requestPromise(A,O,_,ne=R.CancellationToken.None){const N=this.lastRequestId++,L={id:N,type:100,channelName:A,name:O,arg:_};if(ne.isCancellationRequested)return Promise.reject(new P.CancellationError);let W;return new Promise((q,X)=>{if(ne.isCancellationRequested)return X(new P.CancellationError);const re=()=>{const ce=ge=>{switch(ge.type){case 201:this.handlers.delete(N),q(ge.data);break;case 202:{this.handlers.delete(N);const De=new Error(ge.data.message);De.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,De.name=ge.data.name,X(De);break}case 203:this.handlers.delete(N),X(ge.data);break}};this.handlers.set(N,ce),this.sendRequest(L)};let B=null;this.state===u.Idle?re():(B=(0,t.createCancelablePromise)(ce=>this.whenInitialized()),B.then(()=>{B=null,re()}));const x=()=>{B?(B.cancel(),B=null):this.sendRequest({id:N,type:101}),X(new P.CancellationError)},Z=ne.onCancellationRequested(x);W=(0,S.combinedDisposable)((0,S.toDisposable)(x),Z),this.activeRequests.add(W)}).finally(()=>{this.activeRequests.delete(W)})}requestEvent(A,O,_){const ne=this.lastRequestId++,j={id:ne,type:102,channelName:A,name:O,arg:_};let L=null;const W=new p.Emitter({onWillAddFirstListener:()=>{L=(0,t.createCancelablePromise)(q=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(W),this.sendRequest(j)})},onDidRemoveLastListener:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(W),this.sendRequest({id:ne,type:103}))}}),$=q=>W.fire(q.data);return this.handlers.set(ne,$),W.event}sendRequest(A){switch(A.type){case 100:case 102:{const O=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(O,A.id,0,`${m(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const O=this.send([A.type,A.id]);this.logger?.logOutgoing(O,A.id,0,m(A.type));return}}}send(A,O=void 0){const _=new g;return s(_,A),s(_,O),this.sendBuffer(_.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const O=new v(A),_=l(O),ne=l(O),N=_[0];switch(N){case 200:return this.logger?.logIncoming(A.byteLength,0,0,w(N)),this.onResponse({type:_[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,_[1],0,w(N),ne),this.onResponse({type:_[0],id:_[1],data:ne})}}onResponse(A){if(A.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}we([D.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class T{get connections(){const A=[];return this._connections.forEach(O=>A.push(O)),A}constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:O,onDidClientDisconnect:_})=>{p.Event.once(O.onMessage)(N=>{const j=new v(N),L=l(j),W=new a(O,L),$=new M(O);this.channels.forEach((X,re)=>W.registerChannel(re,X));const q={channelServer:W,channelClient:$,ctx:L};this._connections.add(q),this._onDidAddConnection.fire(q),_(()=>{W.dispose(),$.dispose(),this._connections.delete(q),this._onDidRemoveConnection.fire(q)})})})}getChannel(A,O){const _=this;return{call(ne,N,j){let L;if((0,C.isFunction)(O)){const $=(0,E.getRandomElement)(_.connections.filter(O));L=$?Promise.resolve($):p.Event.toPromise(p.Event.filter(_.onDidAddConnection,O))}else L=O.routeCall(_,ne,N);const W=L.then($=>$.channelClient.getChannel(A));return Y(W).call(ne,N,j)},listen(ne,N){if((0,C.isFunction)(O))return _.getMulticastEvent(A,O,ne,N);const j=O.routeEvent(_,ne,N).then(L=>L.channelClient.getChannel(A));return Y(j).listen(ne,N)}}}getMulticastEvent(A,O,_,ne){const N=this;let j=new S.DisposableStore;const L=new p.Emitter({onWillAddFirstListener:()=>{j=new S.DisposableStore;const W=new p.EventMultiplexer,$=new Map,q=re=>{const x=re.channelClient.getChannel(A).listen(_,ne),Z=W.add(x);$.set(re,Z)},X=re=>{const B=$.get(re);!B||(B.dispose(),$.delete(re))};N.connections.filter(O).forEach(q),p.Event.filter(N.onDidAddConnection,O)(q,void 0,j),N.onDidRemoveConnection(X,void 0,j),W.event(L.fire,L,j),j.add(W)},onDidRemoveLastListener:()=>{j.dispose()}});return L.event}registerChannel(A,O){this.channels.set(A,O),this._connections.forEach(_=>{_.channelServer.registerChannel(A,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class U{constructor(A,O,_=null){const ne=new g;s(ne,O),A.send(ne.buffer),this.channelClient=new M(A,_),this.channelServer=new a(A,O,_)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,O){this.channelServer.registerChannel(A,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function Y(F){return{call(A,O,_){return F.then(ne=>ne.call(A,O,_))},listen(A,O){const _=new p.Relay;return F.then(ne=>_.input=ne.listen(A,O)),_.event}}}e.getDelayedChannel=Y;function G(F){let A=!1;return{call(O,_,ne){return A?F.call(O,_,ne):(0,t.timeout)(0).then(()=>A=!0).then(()=>F.call(O,_,ne))},listen(O,_){if(A)return F.listen(O,_);const ne=new p.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>ne.input=F.listen(O,_)),ne.event}}}e.getNextTickChannel=G;class V{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const O of A.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await p.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=V;var oe;(function(F){function A(N,j){const L=N,W=j&&j.disableMarshalling,$=new Map;for(const q in L)_(q)&&$.set(q,p.Event.buffer(L[q],!0));return new class{listen(q,X,re){const B=$.get(X);if(B)return B;if(ne(X)){const x=L[X];if(typeof x=="function")return x.call(L,re)}throw new Error(`Event not found: ${X}`)}call(q,X,re){const B=L[X];if(typeof B=="function"){if(!W&&Array.isArray(re))for(let x=0;x<re.length;x++)re[x]=(0,b.revive)(re[x]);return B.apply(L,re)}throw new Error(`Method not found: ${X}`)}}}F.fromService=A;function O(N,j){const L=j&&j.disableMarshalling;return new Proxy({},{get(W,$){if(typeof $=="string")return j?.properties?.has($)?j.properties.get($):ne($)?function(q){return N.listen($,q)}:_($)?N.listen($):async function(...q){let X;j&&!(0,C.isUndefinedOrNull)(j.context)?X=[j.context,...q]:X=q;const re=await N.call($,X);return L?re:(0,b.revive)(re)};throw new Error(`Property not found: ${String($)}`)}})}F.toService=O;function _(N){return N[0]==="o"&&N[1]==="n"&&I.isUpperAsciiLetter(N.charCodeAt(2))}function ne(N){return/^onDynamic/.test(N)&&I.isUpperAsciiLetter(N.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const A=F.toString();if(A!=="[object Object]")return A}return F}function fe(F){return Array.isArray(F)?F.map(se):se(F)}function K(F,A,O,_,ne,N,j){j=fe(j);const L=ae[ne],W=L[_%L.length];let $=[`%c[${F}]%c[${String(A).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${N}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(N)?($=$.concat(j),$.push(")")):$.push(j),console.log.apply(console,$)}class H{constructor(A,O){this._outgoingPrefix=A,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,O,_,ne,N){this._totalOutgoing+=A,K(this._outgoingPrefix,this._totalOutgoing,A,O,_,ne,N)}logIncoming(A,O,_,ne,N){this._totalIncoming+=A,K(this._incomingPrefix,this._totalIncoming,A,O,_,ne,N)}}e.IPCLogger=H}),define(ee[143],te([0,1,17,3,45]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(p){this.port=p,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",S=>E.VSBuffer.wrap(S.data)),p.start()}send(p){this.port.postMessage(p.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends k.IPCClient{constructor(p,S){const b=new R(p);super(b,S),this.protocol=b}dispose(){this.protocol.disconnect()}}e.Client=D}),define(ee[101],te([0,1,17,3,2,45]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(o){o.enableDiagnostics=!1,o.records=[];const s=new WeakMap;let l=0;function a(M,T){if(!s.has(M)){const U=String(++l);s.set(M,U)}return s.get(M)}function y(M,T,U,Y){if(!o.enableDiagnostics)return;const G=a(M,T);if(Y instanceof E.VSBuffer||Y instanceof Uint8Array||Y instanceof ArrayBuffer||ArrayBuffer.isView(Y)){const V=E.VSBuffer.alloc(Y.byteLength);V.set(Y),o.records.push({timestamp:Date.now(),id:G,label:T,type:U,buff:V})}else o.records.push({timestamp:Date.now(),id:G,label:T,type:U,data:Y})}o.traceSocketEvent=y})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var p;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p=e.SocketCloseEventType||(e.SocketCloseEventType={}));let S=null;function b(){return S||(S=E.VSBuffer.alloc(0)),S}class I{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,l){if(s===0)return b();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const T=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=s),T}if(this._chunks[0].byteLength>s){const T=this._chunks[0].slice(0,s);return l&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),T}const a=E.VSBuffer.alloc(s);let y=0,M=0;for(;s>0;){const T=this._chunks[M];if(T.byteLength>s){const U=T.slice(0,s);a.set(U,y),y+=s,l&&(this._chunks[M]=T.slice(s),this._totalLength-=s),s-=s}else a.set(T,y),y+=T.byteLength,l?(this._chunks.shift(),this._totalLength-=T.byteLength):M++,s-=T.byteLength}return a}}e.ChunkStream=I;var C;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume",o[o.KeepAlive=9]="KeepAlive"})(C||(C={}));function d(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(s,l,a,y){this.type=s,this.id=l,this.ack=a,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends k.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:d(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,y=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new h(a,y,M,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=E.VSBuffer.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:d(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(l,s.data)}_bufferAdd(s,l){const a=this._totalLength===0;return this._data.push(s,l),this._totalLength+=s.byteLength+l.byteLength,a}_bufferTake(){const s=E.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,l){this._bufferAdd(s,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class v extends k.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new h(1,0,0,s))}}e.Protocol=v;class g extends R.IPCClient{static fromSocket(s,l){return new g(new v(s),l)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,l,a=null){super(s,l,a),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=g;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class c{constructor(s){this.data=s,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let s=0,l=this._first;for(;l;)l=l.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let l=0,a=this._first;for(;a;)s[l++]=a.data,a=a.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const l=new c(s);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class r{static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let l=0;l<r._HISTORY_LENGTH;l++)this.lastRuns[l]=s-1e3*l;setInterval(()=>{for(let l=r._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),l=(1+r._HISTORY_LENGTH)*1e3;let a=0;for(let y=0;y<r._HISTORY_LENGTH;y++)s-this.lastRuns[y]<=l&&a++;return 1-a/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class i{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,l=null,a=r.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(y=>this._receiveMessage(y))),this._socketDisposables.push(this._socket.onClose(y=>this._onSocketClose.fire(y))),l&&this._socketReader.acceptChunk(l),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new h(5,0,0,b());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new h(7,0,0,b());this._socketWriter.write(s)}sendResume(){const s=new h(8,0,0,b());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,l){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new h(3,0,this._incomingAckId,b());this._socketWriter.write(s);const l=this._outgoingUnackMsg.toArray();for(let a=0,y=l.length;a<y;a++)this._socketWriter.write(l[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new h(6,0,0,b())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let a=0,y=l.length;a<y;a++)this._socketWriter.write(l[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new h(1,l,this._incomingAckId,s);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(s){const l=new h(2,0,0,s);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),l=Date.now()-s.writtenTime,a=Date.now()-this._socketReader.lastReadTime,y=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&a>=2e4&&y>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:a});return}const M=Math.max(2e4-l,2e4-a,2e4-y,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new h(3,0,this._incomingAckId,b());this._socketWriter.write(s)}_sendKeepAlive(){const s=new h(9,0,0,b());this._socketWriter.write(s)}}e.PersistentProtocol=i}),define(ee[144],te([0,1,40,17,3,2,45,129]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function p(b,I){const C=k.Event.fromNodeEventEmitter(E.validatedIpcMain,I,(m,h)=>({event:m,message:h})),d=k.Event.filter(C,({event:m})=>m.sender.id===b);return k.Event.map(d,({message:m})=>m&&t.VSBuffer.wrap(m))}class S extends D.IPCServer{static getOnDidClientConnect(){const I=k.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:C})=>C);return k.Event.map(I,C=>{const d=C.id;S.Clients.get(d)?.dispose();const h=new k.Emitter;S.Clients.set(d,(0,R.toDisposable)(()=>h.fire()));const w=p(d,"vscode:message"),u=k.Event.any(k.Event.signal(p(d,"vscode:disconnect")),h.event);return{protocol:new P.Protocol(C,w),onDidClientDisconnect:u}})}constructor(){super(S.getOnDidClientConnect())}}e.Server=S,S.Clients=new Map}),define(ee[102],te([0,1,40,3,29,143]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(S,b){super({addEventListener:(I,C)=>S.addListener(I,C),removeEventListener:(I,C)=>S.removeListener(I,C),postMessage:I=>S.postMessage(I),start:()=>S.start(),close:()=>S.close()},b)}}e.Client=D;async function P(p){if(p.isDestroyed()||p.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const S=(0,k.generateUuid)();p.webContents.send("vscode:createMessageChannel",S);const b=t.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(C,d)=>({nonce:d,port:C.ports[0]})),{port:I}=await t.Event.toPromise(t.Event.once(t.Event.filter(b,C=>C.nonce===S)));return I}e.connect=P}),define(ee[145],te([0,1,44,8,17,22,138,16,3,2,50,82,79,45]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends d.ChannelServer{constructor(u){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",v=>k.VSBuffer.wrap(Buffer.from(v,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=m;class h{constructor(u,v){this.modulePath=u,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new t.Delayer(g),this.child=null,this._client=null}getChannel(u){const v=this;return{call(g,f,c){return v.requestPromise(u,g,f,c)},listen(g,f){return v.requestEvent(u,g,f)}}}requestPromise(u,v,g,f=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(u),n=(0,t.createCancelablePromise)(o=>c.call(v,g,o)),r=f.onCancellationRequested(()=>n.cancel()),i=(0,S.toDisposable)(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(u,v,g){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let f;const c=new p.Emitter({onWillAddFirstListener:()=>{f=this.getCachedChannel(u).listen(v,g)(c.fire,c),this.activeRequests.add(f)},onDidRemoveLastListener:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,C.removeDangerousEnvVariables)(v.env),this.child=(0,E.fork)(this.modulePath,u,v);const g=new p.Emitter;p.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,D.isRemoteConsoleLog)(s)){(0,D.log)(s,`IPC Library: ${this.options.serverName}`);return}g.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const c=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,n=s=>this.child&&this.child.connected&&c.send(s.buffer.toString("base64")),r=g.event,i={send:n,onMessage:r};this._client=new d.ChannelClient(i);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,l)=>{process.removeListener("exit",o),this.activeRequests.forEach(a=>(0,S.dispose)(a)),this.activeRequests.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+l),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:l})})}return this._client}getCachedChannel(u){let v=this.channels.get(u);return v||(v=this.client.getChannel(u),this.channels.set(u,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(ee[83],te([0,1,17,16,3,2,9,4,29,45,101]),function(z,e,E,t,k,R,D,P,p,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function I(){return{crypto:z.__$__nodeRequire("crypto"),zlib:z.__$__nodeRequire("zlib"),net:z.__$__nodeRequire("net"),os:z.__$__nodeRequire("os")}}class C{traceSocketEvent(a,y){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,y)}constructor(a,y=""){this._canWrite=!0,this.debugLabel=y,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,t.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener),this._closeListener=M=>{this.traceSocketEvent("close",{hadError:M}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(a){const y=M=>{this.traceSocketEvent("read",M),a(E.VSBuffer.wrap(M))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(a){const y=M=>{a({type:0,hadError:M,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(a){const y=()=>{a()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(a){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,t.onUnexpectedError)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,t.onUnexpectedError)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=C;var d;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(d||(d={}));var m;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(m||(m={}));class h extends R.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,y){this.socket.traceSocketEvent(a,y)}constructor(a,y,M,T){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:M?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new w(this,y,M,T,this._onData,(U,Y)=>this._write(U,Y))),this._register(this._flowManager.onError(U=>{console.error(U),(0,t.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(U=>this._acceptChunk(U))),this._register(this.socket.onClose(U=>this._onClose.fire(U)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,y){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let M=2;a.byteLength<126?M+=0:a.byteLength<2**16?M+=2:M+=8;const T=E.VSBuffer.alloc(M);if(y?T.writeUInt8(194,0):T.writeUInt8(130,0),a.byteLength<126)T.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){T.writeUInt8(126,1);let U=1;T.writeUInt8(a.byteLength>>>8&255,++U),T.writeUInt8(a.byteLength>>>0&255,++U)}else{T.writeUInt8(127,1);let U=1;T.writeUInt8(0,++U),T.writeUInt8(0,++U),T.writeUInt8(0,++U),T.writeUInt8(0,++U),T.writeUInt8(a.byteLength>>>24&255,++U),T.writeUInt8(a.byteLength>>>16&255,++U),T.writeUInt8(a.byteLength>>>8&255,++U),T.writeUInt8(a.byteLength>>>0&255,++U)}this.socket.write(E.VSBuffer.concat([T,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const y=this._incomingData.peek(this._state.readLen),M=y.readUInt8(0),T=(M&128)>>>7,U=(M&64)>>>6,Y=y.readUInt8(1),G=(Y&128)>>>7,V=Y&127;this._state.state=2,this._state.readLen=2+(G?4:0)+(V===126?2:0)+(V===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(U)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const y=this._incomingData.read(this._state.readLen),M=y.readUInt8(1),T=(M&128)>>>7;let U=M&127,Y=1;U===126?U=y.readUInt8(++Y)*2**8+y.readUInt8(++Y):U===127&&(U=y.readUInt8(++Y)*0+y.readUInt8(++Y)*0+y.readUInt8(++Y)*0+y.readUInt8(++Y)*0+y.readUInt8(++Y)*2**24+y.readUInt8(++Y)*2**16+y.readUInt8(++Y)*2**8+y.readUInt8(++Y));let G=0;T&&(G=y.readUInt8(++Y)*2**24+y.readUInt8(++Y)*2**16+y.readUInt8(++Y)*2**8+y.readUInt8(++Y)),this._state.state=3,this._state.readLen=U,this._state.mask=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const y=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),g(y,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(y,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class w extends R.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:E.VSBuffer.alloc(0)}constructor(a,y,M,T,U,Y){super(),this._tracer=a,this._onData=U,this._writeFn=Y,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,y?(this._zlibInflateStream=this._register(new u(this._tracer,T,M,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(G=>this._onError.fire(G))),this._register(this._zlibDeflateStream.onError(G=>this._onError.fire(G)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const y=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(y,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,y){return new Promise((M,T)=>{a.write(y),a.flush(U=>M(U))})}acceptFrame(a,y,M){this._readQueue.push({data:a,isCompressed:y,isLastFrameOfMessage:M}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const y=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(y)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,y,M){return new Promise((T,U)=>{a.write(y),M&&a.write(E.VSBuffer.fromByteArray([0,0,255,255])),a.flush(Y=>T(Y))})}}class u extends R.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?E.VSBuffer.concat(this._recordedInflateBytes):E.VSBuffer.alloc(0)}constructor(a,y,M,T){super(),this._tracer=a,this._recordInflateBytes=y,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=I().zlib.createInflateRaw(T),this._zlibInflate.on("error",U=>{this._tracer.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibInflate.on("data",U=>{this._tracer.traceSocketEvent("zlibInflateData",U),this._pendingInflateData.push(E.VSBuffer.wrap(U))}),M&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this._zlibInflate.write(M.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const y=E.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(y)})}}class v extends R.Disposable{constructor(a,y){super(),this._tracer=a,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=I().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",M=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibDeflate.on("data",M=>{this._tracer.traceSocketEvent("zlibDeflateData",M),this._pendingDeflateData.push(E.VSBuffer.wrap(M))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let y=E.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,y=y.slice(0,y.byteLength-4),a(y)})}}function g(l,a){if(a===0)return;const y=l.byteLength>>>2;for(let V=0;V<y;V++){const oe=l.readUInt32BE(V*4);l.writeUInt32BE(oe^a,V*4)}const M=y*4,T=l.byteLength-M,U=a>>>24&255,Y=a>>>16&255,G=a>>>8&255;T>=1&&l.writeUInt8(l.readUInt8(M)^U,M),T>=2&&l.writeUInt8(l.readUInt8(M+1)^Y,M+1),T>=3&&l.writeUInt8(l.readUInt8(M+2)^G,M+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const f={[2]:107,[1]:103};function c(){const l=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):a=(0,D.join)(I().os.tmpdir(),`vscode-ipc-${l}.sock`),r(a),a}e.createRandomIPCHandle=c;function n(l,a,y){const M=I().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${y}-${a}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${y}-${a}.sock`):T=(0,D.join)(l,`${y}-${a}.sock`),r(T),T}e.createStaticIPCHandle=n;function r(l){const a=f[P.platform];typeof a=="number"&&l.length>=a&&console.warn(`WARNING: IPC handle "${l}" is longer than ${a} chars, try a shorter --user-data-dir`)}class i extends S.IPCServer{static toClientConnectionEvent(a){const y=k.Event.fromNodeEventEmitter(a,"connection");return k.Event.map(y,M=>({protocol:new b.Protocol(new C(M,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(M,"close"))}))}constructor(a){super(i.toClientConnectionEvent(a)),this.server=a}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function o(l){return new Promise((a,y)=>{const M=I().net.createServer();M.on("error",y),M.listen(l,()=>{M.removeListener("error",y),a(new i(M))})})}e.serve=o;function s(l,a){return new Promise((y,M)=>{const T=I().net.createConnection(l,()=>{T.removeListener("error",M),y(b.Client.fromSocket(new C(T,`ipc-client${a}`),a))});T.once("error",M)})}e.connect=s}),define(ee[103],te([0,1,8,3,2,12]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function P(I){const C=I;return C?.changed instanceof Map||C?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var p;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(p=e.StorageState||(e.StorageState={}));class S extends k.Disposable{constructor(C,d=Object.create(null)){super(),this.database=C,this.options=d,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=p.None,this.cache=new Map,this.flushDelayer=new E.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(C=>this.onDidChangeItemsExternal(C)))}onDidChangeItemsExternal(C){C.changed?.forEach((d,m)=>this.accept(m,d)),C.deleted?.forEach(d=>this.accept(d,void 0))}accept(C,d){if(this.state===p.Closed)return;let m=!1;(0,R.isUndefinedOrNull)(d)?m=this.cache.delete(C):this.cache.get(C)!==d&&(this.cache.set(C,d),m=!0),m&&this._onDidChangeStorage.fire(C)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===p.None&&(this.state=p.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(C,d){const m=this.cache.get(C);return(0,R.isUndefinedOrNull)(m)?d:m}getBoolean(C,d){const m=this.get(C);return(0,R.isUndefinedOrNull)(m)?d:m==="true"}getNumber(C,d){const m=this.get(C);return(0,R.isUndefinedOrNull)(m)?d:parseInt(m,10)}async set(C,d){if(this.state===p.Closed)return;if((0,R.isUndefinedOrNull)(d))return this.delete(C);const m=String(d);if(this.cache.get(C)!==m)return this.cache.set(C,m),this.pendingInserts.set(C,m),this.pendingDeletes.delete(C),this._onDidChangeStorage.fire(C),this.doFlush()}async delete(C){if(!(this.state===p.Closed||!this.cache.delete(C)))return this.pendingDeletes.has(C)||this.pendingDeletes.add(C),this.pendingInserts.delete(C),this._onDidChangeStorage.fire(C),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=p.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const C={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(C).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(C){if(!!this.hasPending)return this.doFlush(C)}async doFlush(C){return this.flushDelayer.trigger(()=>this.flushPending(),C)}async whenFlushed(){if(!!this.hasPending)return new Promise(C=>this.whenFlushedCallbacks.push(C))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=S,S.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(C){C.insert?.forEach((d,m)=>this.items.set(m,d)),C.delete?.forEach(d=>this.items.delete(d))}async close(){}}e.InMemoryStorageDatabase=b}),define(ee[146],te([0,1,8,3,38,9,23]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{get onDidChangeItemsExternal(){return t.Event.None}constructor(b,I=Object.create(null)){this.path=b,this.options=I,this.name=(0,R.basename)(this.path),this.logger=new p(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const b=await this.whenConnected,I=new Map;return(await this.all(b,"SELECT * FROM ItemTable")).forEach(d=>I.set(d.key,d.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(b){const I=await this.whenConnected;return this.doUpdateItems(I,b)}doUpdateItems(b,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,k.mapToString)(I.insert):"0"}), delete(${I.delete?(0,k.setToString)(I.delete):"0"})`),this.transaction(b,()=>{const C=I.insert,d=I.delete;if(C&&C.size>0){const m=[];m.push([]);let h=0;C.forEach((w,u)=>{let v=m[h];v.length>P.MAX_HOST_PARAMETERS&&(h++,v=[],m.push(v)),v.push(u,w)}),m.forEach(w=>{this.prepare(b,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,u=>u.run(w),()=>{const u=[];let v=0;return C.forEach((g,f)=>{u.push(f),v+=g.length}),`Keys: ${u.join(", ")} Length: ${v}`})})}if(d&&d.size){const m=[];m.push([]);let h=0;d.forEach(w=>{let u=m[h];u.length>P.MAX_HOST_PARAMETERS&&(h++,u=[],m.push(u)),u.push(w)}),m.forEach(w=>{this.prepare(b,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,u=>u.run(w),()=>{const u=[];return d.forEach(v=>{u.push(v)}),`Keys: ${u.join(", ")}`})})}})}async close(b){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,b)}doClose(b,I){return new Promise((C,d)=>{b.db.close(m=>(m&&this.handleSQLiteError(b,`[storage ${this.name}] close(): ${m}`),this.path===P.IN_MEMORY_PATH?C():!b.isErroneous&&!b.isInMemory?this.backup().then(C,h=>(this.logger.error(`[storage ${this.name}] backup(): ${h}`),C())):typeof I=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(h=>{const w=()=>this.doClose(h,void 0);return this.doUpdateItems(h,{insert:I()}).then(()=>w(),u=>(w(),Promise.reject(u)))})).then(C,d):d(m||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const b=this.toBackupPath(this.path);return D.Promises.copy(this.path,b,{preserveSymlinks:!1})}toBackupPath(b){return`${b}.backup`}async checkIntegrity(b){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${b})`);const I=await this.whenConnected,C=await this.get(I,b?"PRAGMA integrity_check":"PRAGMA quick_check"),d=b?C.integrity_check:C.quick_check;return I.isErroneous?`${d} (last error: ${I.lastError})`:I.isInMemory?`${d} (in-memory!)`:d}async connect(b,I=!0){this.logger.trace(`[storage ${this.name}] open(${b}, retryOnBusy: ${I})`);try{return await this.doConnect(b)}catch(C){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${C}`),C.code==="SQLITE_BUSY"&&I)return await(0,E.timeout)(P.BUSY_OPEN_TIMEOUT),this.connect(b,!1);try{await D.Promises.unlink(b);try{await D.Promises.rename(this.toBackupPath(b),b)}catch{}return await this.doConnect(b)}catch(d){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${d}`),this.doConnect(P.IN_MEMORY_PATH)}}}handleSQLiteError(b,I){b.isErroneous=!0,b.lastError=I,this.logger.error(I)}doConnect(b){return new Promise((I,C)=>{new Promise((d,m)=>{z(["@vscode/sqlite3"],d,m)}).then(d=>{const m={db:new(this.logger.isTracing?d.verbose().Database:d.Database)(b,h=>h?m.db&&h.code!=="SQLITE_CANTOPEN"?m.db.close(()=>C(h)):C(h):this.exec(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(m),w=>m.db.close(()=>C(w)))),isInMemory:b===P.IN_MEMORY_PATH};m.db.on("error",h=>this.handleSQLiteError(m,`[storage ${this.name}] Error (event): ${h}`)),this.logger.isTracing&&m.db.on("trace",h=>this.logger.trace(`[storage ${this.name}] Trace (event): ${h}`))},C)})}exec(b,I){return new Promise((C,d)=>{b.db.exec(I,m=>m?(this.handleSQLiteError(b,`[storage ${this.name}] exec(): ${m}`),d(m)):C())})}get(b,I){return new Promise((C,d)=>{b.db.get(I,(m,h)=>m?(this.handleSQLiteError(b,`[storage ${this.name}] get(): ${m}`),d(m)):C(h))})}all(b,I){return new Promise((C,d)=>{b.db.all(I,(m,h)=>m?(this.handleSQLiteError(b,`[storage ${this.name}] all(): ${m}`),d(m)):C(h))})}transaction(b,I){return new Promise((C,d)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),I(),b.db.run("END TRANSACTION",m=>m?(this.handleSQLiteError(b,`[storage ${this.name}] transaction(): ${m}`),d(m)):C())})})}prepare(b,I,C,d){const m=b.db.prepare(I),h=w=>{this.handleSQLiteError(b,`[storage ${this.name}] prepare(): ${w} (${I}). Details: ${d()}`)};m.on("error",h),C(m),m.finalize(w=>{w&&h(w),m.removeListener("error",h)})}}e.SQLiteStorageDatabase=P,P.IN_MEMORY_PATH=":memory:",P.BUSY_OPEN_TIMEOUT=2e3,P.MAX_HOST_PARAMETERS=256;class p{constructor(b){b&&typeof b.logTrace=="function"&&process.env[p.VSCODE_TRACE_STORAGE]&&(this.logTrace=b.logTrace),b&&typeof b.logError=="function"&&(this.logError=b.logError)}get isTracing(){return!!this.logTrace}trace(b){this.logTrace?.(b)}error(b){this.logError?.(b)}}p.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[147],te([11,10]),function(z,e){return z.create("vs/code/electron-main/app",e)}),define(ee[148],te([11,10]),function(z,e){return z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[149],te([11,10]),function(z,e){return z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[150],te([11,10]),function(z,e){return z.create("vs/platform/environment/node/argv",e)}),define(ee[151],te([11,10]),function(z,e){return z.create("vs/platform/environment/node/argvHelper",e)}),define(ee[152],te([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[153],te([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[154],te([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[155],te([11,10]),function(z,e){return z.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[156],te([11,10]),function(z,e){return z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[157],te([11,10]),function(z,e){return z.create("vs/platform/files/common/fileService",e)}),define(ee[158],te([11,10]),function(z,e){return z.create("vs/platform/files/common/files",e)}),define(ee[159],te([11,10]),function(z,e){return z.create("vs/platform/files/common/io",e)}),define(ee[160],te([11,10]),function(z,e){return z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[161],te([11,10]),function(z,e){return z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[162],te([11,10]),function(z,e){return z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[163],te([11,10]),function(z,e){return z.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[164],te([11,10]),function(z,e){return z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[165],te([11,10]),function(z,e){return z.create("vs/platform/request/common/request",e)}),define(ee[166],te([11,10]),function(z,e){return z.create("vs/platform/shell/node/shellEnv",e)}),define(ee[167],te([11,10]),function(z,e){return z.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[168],te([11,10]),function(z,e){return z.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[169],te([11,10]),function(z,e){return z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[170],te([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[171],te([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[172],te([11,10]),function(z,e){return z.create("vs/platform/workspace/common/workspace",e)}),define(ee[173],te([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[174],te([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[175],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(ee[176],te([0,1,7]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function k(D){let P=[];try{Array.isArray(D.workspaces)&&(P=D.workspaces.map(p=>({workspace:{id:p.id,configPath:E.URI.parse(p.configURIPath)},remoteAuthority:p.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=k;function R(D){let P=[];try{Array.isArray(D.folders)&&(P=D.folders.map(p=>({folderUri:E.URI.parse(p.folderUri),remoteAuthority:p.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=R}),define(ee[177],te([0,1,3,2]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new E.Emitter,this._onReloadEmitter=new E.Emitter,this._onTerminateEmitter=new E.Emitter,this._onAttachEmitter=new E.Emitter}call(P,p,S){switch(p){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:S[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:S[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:S[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:S[0],port:S[1],subId:S[2]}))}throw new Error("Method not implemented.")}listen(P,p,S){switch(p){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(P){super(),this.channel=P}reload(P){this.channel.call("reload",[P])}get onReload(){return this.channel.listen("reload")}close(P){this.channel.call("close",[P])}get onClose(){return this.channel.listen("close")}attachSession(P,p,S){this.channel.call("attach",[P,p,S])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(P,p){this.channel.call("terminate",[P,p])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(P,p){return this.channel.call("openExtensionDevelopmentHostWindow",[P,p])}}e.ExtensionHostDebugChannelClient=R}),define(ee[178],te([0,1,132,53,14,9,32,19,7]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",z).fsPath)}get userHome(){return p.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return p.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.paths.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return p.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return p.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get remoteTunnelLogResource(){return p.URI.file((0,R.join)(this.logsPath,"remoteTunnel.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(p.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=D.env.VSCODE_PORTABLE;return h?p.URI.file((0,R.join)(h,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,R.resolve)(h):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?p.URI.file((0,R.resolve)(h)):p.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,R.resolve)(h);const w=D.env.VSCODE_EXTENSIONS;if(w)return w;const u=D.env.VSCODE_PORTABLE;return u?(0,R.join)(u,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(w=>/^[^:/?#]+?:\/\//.test(w)?p.URI.parse(w):p.URI.file((0,R.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?p.URI.parse(h):p.URI.file((0,R.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const w of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(w);u&&u[1]&&u[2]&&h.push([u[1],u[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return p.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=D.env.VSCODE_PORTABLE;return h?p.URI.file((0,R.join)(h,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this._args}constructor(h,w,u){this._args=h,this.paths=w,this.productService=u,this.editSessionId=this.args.editSessionId}}we([t.memoize],S.prototype,"appRoot",null),we([t.memoize],S.prototype,"userHome",null),we([t.memoize],S.prototype,"userDataPath",null),we([t.memoize],S.prototype,"appSettingsHome",null),we([t.memoize],S.prototype,"tmpDir",null),we([t.memoize],S.prototype,"cacheHome",null),we([t.memoize],S.prototype,"stateResource",null),we([t.memoize],S.prototype,"userRoamingDataHome",null),we([t.memoize],S.prototype,"userDataSyncHome",null),we([t.memoize],S.prototype,"userDataSyncLogResource",null),we([t.memoize],S.prototype,"editSessionsLogResource",null),we([t.memoize],S.prototype,"remoteTunnelLogResource",null),we([t.memoize],S.prototype,"sync",null),we([t.memoize],S.prototype,"machineSettingsResource",null),we([t.memoize],S.prototype,"workspaceStorageHome",null),we([t.memoize],S.prototype,"localHistoryHome",null),we([t.memoize],S.prototype,"keyboardLayoutResource",null),we([t.memoize],S.prototype,"argvResource",null),we([t.memoize],S.prototype,"isExtensionDevelopment",null),we([t.memoize],S.prototype,"untitledWorkspacesHome",null),we([t.memoize],S.prototype,"installSourcePath",null),we([t.memoize],S.prototype,"builtinExtensionsPath",null),we([t.memoize],S.prototype,"extensionsPath",null),we([t.memoize],S.prototype,"extensionDevelopmentLocationURI",null),we([t.memoize],S.prototype,"extensionDevelopmentKind",null),we([t.memoize],S.prototype,"extensionTestsLocationURI",null),we([t.memoize],S.prototype,"debugExtensionHost",null),we([t.memoize],S.prototype,"logLevel",null),we([t.memoize],S.prototype,"extensionLogLevel",null),we([t.memoize],S.prototype,"serviceMachineIdResource",null),we([t.memoize],S.prototype,"telemetryLogResource",null),we([t.memoize],S.prototype,"disableWorkspaceTrust",null),we([t.memoize],S.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=S;function b(m,h){return d(m["inspect-extensions"],m["inspect-brk-extensions"],5870,h,m.debugId,m.extensionEnvironment)}e.parseExtensionHostPort=b;function I(m,h){return d(m["inspect-search"],m["inspect-brk-search"],5876,h,m.extensionEnvironment)}e.parseSearchPort=I;function C(m,h){return d(m["inspect-ptyhost"],m["inspect-brk-ptyhost"],5877,h,m.extensionEnvironment)}e.parsePtyHostPort=C;function d(m,h,w,u,v,g){const c=Number(h||m)||(u?null:w),n=c?Boolean(!!h):!1;let r;if(g)try{r=JSON.parse(g)}catch{}return{port:c,break:n,debugId:v,env:r}}}),define(ee[104],te([0,1,275,4,150]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(12,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},category:{type:"string",cat:"e",description:(0,k.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(h,w,u=D){const v=h.find(l=>l.length>0&&l[0]!=="-"),g={},f=["_"],c=[],n={};let r;for(const l in w){const a=w[l];a.type==="subcommand"?l===v&&(r=a):(a.alias&&(g[l]=a.alias),a.type==="string"||a.type==="string[]"?(f.push(l),a.deprecates&&f.push(...a.deprecates)):a.type==="boolean"&&(c.push(l),a.deprecates&&c.push(...a.deprecates)),a.global&&(n[l]=a))}if(r&&v){const l=n;for(const T in r.options)l[T]=r.options[T];const a=h.filter(T=>T!==v),y=u.getSubcommandReporter?u.getSubcommandReporter(v):void 0,M=P(a,l,y);return{[v]:M,_:[]}}const i=E(h,{string:f,boolean:c,alias:g}),o={},s=i;o._=i._.map(l=>String(l)).filter(l=>l.length>0),delete s._;for(const l in w){const a=w[l];if(a.type==="subcommand")continue;a.alias&&delete s[a.alias];let y=s[l];if(a.deprecates)for(const M of a.deprecates)s.hasOwnProperty(M)&&(y||(y=s[M],y&&u.onDeprecatedOption(M,a.deprecationMessage||(0,k.localize)(36,null,l))),delete s[M]);if(typeof y<"u"){if(a.type==="string[]"){if(Array.isArray(y)||(y=[y]),!a.allowEmptyValue){const M=y.filter(T=>T.length>0);M.length!==y.length&&(u.onEmptyValue(l),y=M.length>0?M:void 0)}}else a.type==="string"&&(Array.isArray(y)?(y=y.pop(),u.onMultipleValues(l,y)):!y&&!a.allowEmptyValue&&(u.onEmptyValue(l),y=void 0));o[l]=y,a.deprecationMessage&&u.onDeprecatedOption(l,a.deprecationMessage)}delete s[l]}for(const l in s)u.onUnknownOption(l);return o}e.parseArgs=P;function p(h,w){let u="";return w.args&&(Array.isArray(w.args)?u=` <${w.args.join("> <")}>`:u=` <${w.args}>`),w.alias?`-${w.alias} --${h}${u}`:`--${h}${u}`}function S(h,w){const u=[];for(const v in h){const g=h[v],f=p(v,g);u.push([f,g.description])}return b(u,w)}e.formatOptions=S;function b(h,w){const v=h.reduce((c,n)=>Math.max(c,n[0].length),12)+2+1;if(w-v<25)return h.reduce((c,n)=>c.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const g=w-v-1,f=[];for(const c of h){const n=c[0],r=C(c[1],g),i=I(v-n.length-2);f.push("  "+n+i+r[0]);for(let o=1;o<r.length;o++)f.push(I(v)+r[o])}return f}function I(h){return" ".repeat(h)}function C(h,w){const u=[];for(;h.length;){const v=h.length<w?h.length:h.lastIndexOf(" ",w),g=h.slice(0,v).trim();h=h.slice(v),u.push(g)}return u}function d(h,w,u,v,g){const f=process.stdout.isTTY&&process.stdout.columns||80,c=g?.noInputFiles!==!0?`[${(0,k.localize)(37,null)}...]`:"",n=[`${h} ${u}`];n.push(""),n.push(`${(0,k.localize)(38,null)}: ${w} [${(0,k.localize)(39,null)}]${c}`),n.push(""),g?.noPipe!==!0&&(t.isWindows?n.push((0,k.localize)(40,null,w)):n.push((0,k.localize)(41,null,w)),n.push(""));const r={},i=[];for(const o in v){const s=v[o];if(s.type==="subcommand")s.description&&i.push({command:o,description:s.description});else if(s.description&&s.cat){let l=r[s.cat];l||(r[s.cat]=l={}),l[o]=s}}for(const o in r){const s=o,l=r[s];l&&(n.push(R[s]),n.push(...S(l,f)),n.push(""))}return i.length&&(n.push((0,k.localize)(42,null)),n.push(...b(i.map(o=>[o.command,o.description]),f)),n.push("")),n.join(`
`)}e.buildHelpMessage=d;function m(h,w){return`${h||(0,k.localize)(43,null)}
${w||(0,k.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=m}),define(ee[179],te([0,1,78,177,104]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.windowsMainService=P}call(P,p,S){return p==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(S[0],S[1]):super.call(P,p,S)}async openExtensionDevelopmentHostWindow(P,p){const S=(0,k.parseArgs)(P,k.OPTIONS);S.debugRenderer=p;const b=S.extensionDevelopmentPath;if(!b)return{success:!1};const[I]=await this.windowsMainService.openExtensionDevelopmentHostWindow(b,{context:5,cli:S,forceProfile:S.profile,forceTempProfile:S["profile-temp"]});if(!p)return{success:!0};const C=I.win;if(!C)return{success:!0};const d=C.webContents.debugger;let m=d.isAttached()?1/0:0;const h=(0,E.createServer)(w=>{m++===0&&d.attach();let u=!1;const v=c=>{u||w.write(JSON.stringify(c)+"\0")},g=(c,n,r,i)=>v({method:n,params:r,sessionId:i});C.on("close",()=>{d.removeListener("message",g),w.end(),u=!0}),d.addListener("message",g);let f=Buffer.alloc(0);w.on("data",c=>{f=Buffer.concat([f,c]);for(let n=f.indexOf(0);n!==-1;n=f.indexOf(0)){let r;try{const i=f.slice(0,n).toString("utf8");f=f.slice(n+1),r=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}d.sendCommand(r.method,r.params,r.sessionId).then(i=>v({id:r.id,sessionId:r.sessionId,result:i})).catch(i=>v({id:r.id,sessionId:r.sessionId,error:{code:0,message:i.message}}))}}),w.on("error",c=>{console.error("error on cdp pipe:",c)}),w.on("close",()=>{u=!0,--m===0&&d.detach()})});return await new Promise(w=>h.listen(0,w)),C.on("close",()=>h.close()),{rendererDebugPort:h.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(ee[59],te([0,1,276,151,104]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(C,d){const m=(f,c)=>{console.warn((0,t.localize)(0,null,f,c))},h=f=>{console.warn((0,t.localize)(1,null,f))},w=(f,c)=>{console.warn((0,t.localize)(2,null,f,c))},u=f=>({onUnknownOption:c=>{f!=="tunnel"&&console.warn((0,t.localize)(3,null,c,f))},onMultipleValues:m,onEmptyValue:h,onDeprecatedOption:w,getSubcommandReporter:f!=="tunnel"?u:void 0}),v={onUnknownOption:f=>{console.warn((0,t.localize)(4,null,f))},onMultipleValues:m,onEmptyValue:h,onDeprecatedOption:w,getSubcommandReporter:u},g=(0,k.parseArgs)(C,k.OPTIONS,d?v:void 0);return g.goto&&g._.forEach(f=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,t.localize)(5,null))),g["max-memory"]&&E(parseInt(g["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),g}function P(C){const d=C.findIndex(m=>!/^-/.test(m));if(d>-1)return[...C.slice(0,d),...C.slice(d+1)]}function p(C){let[,...d]=C;process.env.VSCODE_DEV&&(d=P(d)||[]);const m=!I(process.env);return D(d,m)}e.parseMainProcessArgv=p;function S(C){let[,,...d]=C;return process.env.VSCODE_DEV&&(d=P(d)||[]),D(d,!0)}e.parseCLIProcessArgv=S;function b(C,...d){const m=C.indexOf("--");return m===-1?C.push(...d):C.splice(m,0,...d),C}e.addArg=b;function I(C){return C.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),function(){"use strict";function z(e,E,t){function k(D,P){const p=R(D,P),S=[p];return e.isAbsolute(p)||S.unshift(t),e.resolve(...S)}function R(D,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,P);const b=D["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(I,"AppData","Roaming")}break;case"darwin":S=e.join(E.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,P)}return{getUserDataPath:k}}if(typeof define=="function")define(ee[180],te([181,27,32]),function(e,E,t){return z(e,E,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=z(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[182],te([0,1,27,178,180]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(P,p){super(P,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,k.getUserDataPath)(P,p.nameShort)},p)}}e.NativeEnvironmentService=R}),define(ee[183],te([0,1,39,27,30]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(D){const P=(0,k.randomPath)((0,t.tmpdir)());try{return(0,E.writeFileSync)(P,""),D&&console.log(`Marker file for --wait created: ${P}`),P}catch(p){D&&console.error(`Failed to create marker file for --wait: ${p}`);return}}e.createWaitMarkerFileSync=R}),define(ee[184],te([0,1,12,153]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(D,P,p){try{R(D,P,p)}catch(S){console.error(S?.message??S)}return D}e.localizeManifest=k;function R(D,P,p){const S=(b,I,C)=>{const d=b[I];if((0,E.isString)(d)){const m=d,h=m.length;if(h>1&&m[0]==="%"&&m[h-1]==="%"){const w=m.substr(1,h-2);let u=P[w];u===void 0&&p&&(u=p[w]);const v=typeof u=="string"?u:u?.message,g=p?.[w],f=typeof g=="string"?g:g?.message;if(!v){f||console.warn(`[${D.name}]: ${(0,t.localize)(0,null,w)}`);return}if(C&&(I==="title"||I==="category")&&f&&f!==v){const c={value:v,original:f};b[I]=c}else b[I]=v}}else if((0,E.isObject)(d))for(const m in d)d.hasOwnProperty(m)&&(m==="commands"?S(d,m,!0):S(d,m,C));else if(Array.isArray(d))for(let m=0;m<d.length;m++)S(d,m,C)};for(const b in D)D.hasOwnProperty(b)&&S(D,b)}}),define(ee[185],te([0,1,19,97,155,186]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function p(u){return u=u.trim(),u==="*"||D.test(u)}e.isValidVersionStr=p;function S(u){if(!p(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=u.match(D);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=S;function b(u){if(!u)return null;const v=u.majorBase,g=u.majorMustEqual,f=u.minorBase;let c=u.minorMustEqual;const n=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(v===0||(c=!1),r=!1);let i=0;if(u.preRelease){const o=P.exec(u.preRelease);if(o){const[,s,l,a]=o;i=Date.UTC(Number(s),Number(l)-1,Number(a))}}return{majorBase:v,majorMustEqual:g,minorBase:f,minorMustEqual:c,patchBase:n,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=b;function I(u,v,g){let f;typeof u=="string"?f=b(S(u)):f=u;let c;v instanceof Date?c=v.getTime():typeof v=="string"&&(c=new Date(v).getTime());let n;if(typeof g=="string"?n=b(S(g)):n=g,!f||!n)return!1;const r=f.majorBase,i=f.minorBase,o=f.patchBase;let s=n.majorBase,l=n.minorBase,a=n.patchBase;const y=n.notBefore;let M=n.majorMustEqual,T=n.minorMustEqual,U=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:i>l?!0:i<l||c&&c<y?!1:o>=a:(r===1&&s===0&&(!M||!T||!U)&&(s=1,l=0,a=0,M=!0,T=!1,U=!1),r<s?!1:r>s?!M:i<l?!1:i>l?!T:o<a?!1:o>a?!U:!(c&&c<y))}e.isValidVersion=I;function C(u,v,g,f,c){const n=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return n.push([t.default.Error,k.localize(0,null)]),n;if(typeof f.name!="string")return n.push([t.default.Error,k.localize(1,null,"name")]),n;if(typeof f.version!="string")return n.push([t.default.Error,k.localize(2,null,"version")]),n;if(!f.engines)return n.push([t.default.Error,k.localize(3,null,"engines")]),n;if(typeof f.engines.vscode!="string")return n.push([t.default.Error,k.localize(4,null,"engines.vscode")]),n;if(typeof f.extensionDependencies<"u"&&!w(f.extensionDependencies))return n.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),n;if(typeof f.activationEvents<"u"){if(!w(f.activationEvents))return n.push([t.default.Error,k.localize(6,null,"activationEvents")]),n;if(typeof f.main>"u"&&typeof f.browser>"u")return n.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),n}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&n.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return n.push([t.default.Error,k.localize(9,null,"main")]),n;{const o=(0,E.joinPath)(g,f.main);(0,E.isEqualOrParent)(o,g)||n.push([t.default.Warning,k.localize(10,null,o.path,g.path)])}if(typeof f.activationEvents>"u")return n.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),n}if(typeof f.browser<"u"){if(typeof f.browser!="string")return n.push([t.default.Error,k.localize(12,null,"browser")]),n;{const o=(0,E.joinPath)(g,f.browser);(0,E.isEqualOrParent)(o,g)||n.push([t.default.Warning,k.localize(13,null,o.path,g.path)])}if(typeof f.activationEvents>"u")return n.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),n}if(!R.valid(f.version))return n.push([t.default.Error,k.localize(15,null)]),n;const r=[];if(!d(u,v,f,c,r))for(const o of r)n.push([t.default.Error,o]);return n}e.validateExtensionManifest=C;function d(u,v,g,f,c){return f||typeof g.main>"u"&&typeof g.browser>"u"?!0:h(u,v,g.engines.vscode,c)}e.isValidExtensionVersion=d;function m(u,v,g){return u==="*"||h(v,g,u)}e.isEngineValid=m;function h(u,v,g,f=[]){const c=b(S(g));if(!c)return f.push(k.localize(16,null,g)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return f.push(k.localize(17,null,g)),!1}else if(!c.majorMustEqual)return f.push(k.localize(18,null,g)),!1;return I(u,v,c)?!0:(f.push(k.localize(19,null,u,g)),!1)}function w(u){if(!Array.isArray(u))return!1;for(let v=0,g=u.length;v<g;v++)if(typeof u[v]!="string")return!1;return!0}}),define(ee[187],te([0,1,17,29]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,D,P){let p=P&&P.get("storage.serviceMachineId",-1)||null;if(p)return p;try{const b=(await D.readFile(R.serviceMachineIdResource)).value.toString();p=(0,t.isUUID)(b)?b:null}catch{p=null}if(!p){p=(0,t.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,E.VSBuffer.fromString(p))}catch{}}return P?.store("storage.serviceMachineId",p,-1,1),p}e.getServiceMachineId=k}),define(ee[69],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(k,R=[],D=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=E}),define(ee[188],te([0,1,69]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function R(P,p,S){p instanceof E.SyncDescriptor||(p=new E.SyncDescriptor(p,[],Boolean(S))),t.push([P,p])}e.registerSingleton=R;function D(){return t}e.getSingletonServiceDescriptors=D}),define(ee[189],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(R,D){this.key=R,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const P=this.lookupOrInsertNode(R),p=this.lookupOrInsertNode(D);P.outgoing.set(p.key,p),p.incoming.set(P.key,P)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const P of this._nodes.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let P=this._nodes.get(D);return P||(P=new E(D,R),this._nodes.set(D,P)),P}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,P]of this._nodes)R.push(`${D}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const P=new Set([R]),p=this._findCycle(D,P);if(p)return p}}_findCycle(R,D){for(const[P,p]of R.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const S=this._findCycle(p,D);if(S)return S;D.delete(P)}}}e.Graph=t}),define(ee[5],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(p){return p[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(E=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,P,p){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:D,index:p}):(P[E.DI_DEPENDENCIES]=[{id:D,index:p}],P[E.DI_TARGET]=P)}function k(D){if(E.serviceIds.has(D))return E.serviceIds.get(D);const P=function(p,S,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,p,b)};return P.toString=()=>D,E.serviceIds.set(D,P),P}e.createDecorator=k;function R(D){return D}e.refineServiceDecorator=R}),define(ee[60],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(ee[18],te([0,1,12,7,5]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationOverrides=R;function D(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function p(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=p;function S(u,v){const g=Object.create(null);for(const f in u)b(g,f,u[f],v);return g}e.toValuesTree=S;function b(u,v,g,f){const c=v.split("."),n=c.pop();let r=u;for(let i=0;i<c.length;i++){const o=c[i];let s=r[o];switch(typeof s){case"undefined":s=r[o]=Object.create(null);break;case"object":break;default:f(`Ignoring ${v} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=g}catch{f(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(r)}`)}else f(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=b;function I(u,v){const g=v.split(".");C(u,g)}e.removeFromValueTree=I;function C(u,v){const g=v.shift();if(v.length===0){delete u[g];return}if(Object.keys(u).indexOf(g)!==-1){const f=u[g];typeof f=="object"&&!Array.isArray(f)&&(C(f,v),Object.keys(f).length===0&&delete u[g])}}function d(u,v,g){function f(r,i){let o=r;for(const s of i){if(typeof o!="object"||o===null)return;o=o[s]}return o}const c=v.split("."),n=f(u,c);return typeof n>"u"?g:n}e.getConfigurationValue=d;function m(u,v,g){Object.keys(v).forEach(f=>{f!=="__proto__"&&(f in u?E.isObject(u[f])&&E.isObject(v[f])?m(u[f],v[f],g):g&&(u[f]=v[f]):u[f]=v[f])})}e.merge=m;function h(u,v,g){const f=u.inspect(v),c=u.inspect(g);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:f.defaultValue}e.getMigratedSettingValue=h;function w(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(ee[70],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,P){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=P}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const P of Object.keys(this.secretVault[R]||{}))D.push({account:P,password:this.secretVault[R][P]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(ee[84],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(D,P){return{}}async getSystemInfo(D,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,P){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=k}),define(ee[105],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(ee[34],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[26],te([0,1,53,9,83,34,182,5]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(R.IEnvironmentService);class p extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}we([E.memoize],p.prototype,"cachedLanguagesPath",null),we([E.memoize],p.prototype,"backupHome",null),we([E.memoize],p.prototype,"mainIPCHandle",null),we([E.memoize],p.prototype,"mainLockfile",null),we([E.memoize],p.prototype,"disableUpdates",null),we([E.memoize],p.prototype,"disableKeytar",null),we([E.memoize],p.prototype,"crossOriginIsolated",null),we([E.memoize],p.prototype,"codeCachePath",null),we([E.memoize],p.prototype,"useCodeCache",null),e.EnvironmentMainService=p}),define(ee[190],te([0,1,152,5]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY="DEFAULT_PROFILE_EXTENSIONS_MIGRATION";function k(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(u,v){switch(u){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function P(u,v){return v==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function p(u,v,g){return P(v,g)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===g?!0:S(g).includes(u)}e.isTargetPlatformCompatible=p;function S(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function b(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=b;var I;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var C;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var m;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var h;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(h=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(v,g){super(v),this.code=g,this.name=g}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ee[191],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(ee[192],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[106],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(ee[193],te([0,1,44,14,9,4,79,23,82,156,106]),function(z,e,E,t,k,R,D,P,p,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=S.localize(0,null);class C{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends C{openTerminal(f,c){return this.spawnTerminal(E,f,p.getWindowsShell(),c)}spawnTerminal(f,c,n,r){const i=c.windowsExec||d.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const o=k.basename(i).toLowerCase();if(o==="cmder"||o==="cmder.exe")return f.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return i.indexOf(" ")>=0&&s.push('""'),s.push(i),(o==="wt"||o==="wt.exe")&&s.push("-d ."),new Promise((l,a)=>{const y=w(process),M=f.spawn(n,s,{cwd:r,env:y});M.on("error",a),M.on("exit",()=>l())})}runInTerminal(f,c,n,r,i){const o="windowsExec"in i&&i.windowsExec?i.windowsExec:d.getDefaultTerminalWindows();return new Promise((s,l)=>{const a=`"${c} - ${I}"`,y=`""${n.join('" "')}" & pause"`,M=["/c","start",a,"/wait",o,"/c",y],T=Object.assign({},w(process),r);Object.keys(T).filter(G=>T[G]===null).forEach(G=>delete T[G]);const U={cwd:c,env:T,windowsVerbatimArguments:!0};E.spawn(d.CMD,M,U).on("error",G=>{l(u(G))}),s(void 0)})}static getDefaultTerminalWindows(){if(!d._DEFAULT_TERMINAL_WINDOWS){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return d._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=d,d.CMD="cmd.exe";class m extends C{openTerminal(f,c){return this.spawnTerminal(E,f,c)}runInTerminal(f,c,n,r,i){const o=i.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((s,l)=>{if(o===b.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const a=o===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,z).fsPath,"-t",f||I,"-w",c];for(const Y of n)M.push("-a"),M.push(Y);if(r){const Y=Object.assign({},w(process),r);for(const G in Y){const V=Y[G];V===null?(M.push("-u"),M.push(G)):(M.push("-e"),M.push(`${G}=${V}`))}}let T="";const U=E.spawn(m.OSASCRIPT,M);U.on("error",Y=>{l(u(Y))}),U.stderr.on("data",Y=>{T+=Y.toString()}),U.on("exit",Y=>{if(Y===0)s(void 0);else if(T){const G=T.split(`
`,1);l(new Error(G[0]))}else l(new Error(S.localize(1,null,a,Y)))})}else l(new Error(S.localize(2,null,o)))})}spawnTerminal(f,c,n){const r=c.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((i,o)=>{const s=["-a",r];n&&s.push(n);const l=w(process),a=f.spawn("/usr/bin/open",s,{cwd:n,env:l});a.on("error",o),a.on("exit",()=>i())})}}e.MacExternalTerminalService=m,m.OSASCRIPT="/usr/bin/osascript";class h extends C{openTerminal(f,c){return this.spawnTerminal(E,f,c)}runInTerminal(f,c,n,r,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((s,l)=>{const a=[];o.then(y=>{y.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const M=`${v(n)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;a.push(`''${M}''`);const T=Object.assign({},w(process),r);Object.keys(T).filter(V=>T[V]===null).forEach(V=>delete T[V]);const U={cwd:c,env:T};let Y="";const G=E.spawn(y,a,U);G.on("error",V=>{l(u(V))}),G.stderr.on("data",V=>{Y+=V.toString()}),G.on("exit",V=>{if(V===0)s(void 0);else if(Y){const oe=Y.split(`
`,1);l(new Error(oe[0]))}else l(new Error(S.localize(4,null,y,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!h._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)h._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const f=await P.Promises.exists("/etc/debian_version");h._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{f?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(f,c,n){const r=c.linuxExec?Promise.resolve(c.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((i,o)=>{r.then(s=>{const l=w(process),a=f.spawn(s,[],{cwd:n,env:l});a.on("error",o),a.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=S.localize(3,null);function w(g){const f={...g.env};return(0,D.sanitizeProcessEnvironment)(f),f}function u(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(S.localize(5,null,g.path)):g}function v(g){let f="";for(const c of g)c.indexOf(" ")>=0?f+='"'+c+'"':f+=c,f+=" ";return f}}),define(ee[15],te([0,1,58,9,25,12,7,158,5]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,p.createDecorator)("fileService");function S(K){return K.create===!0}e.isFileOpenForWriteOptions=S;var b;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var I;(function(K){K[K.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var C;(function(K){K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead",K[K.FileClone=32768]="FileClone"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=d;function m(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=m;function h(K){return!!(K.capabilities&32768)}e.hasFileCloneCapability=h;function w(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function u(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=u;function v(K){return d(K)?!!(K.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var g;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(H,F){super(H),this.code=F}}e.FileSystemProviderError=f;function c(K,H){const F=new f(K.toString(),H);return r(F,H),F}e.createFileSystemProviderError=c;function n(K){return K||c((0,P.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=n;function r(K,H){return K.name=H?`${H} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=r;function i(K){if(!K)return g.Unknown;if(K instanceof f)return K.code;const H=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!H)return g.Unknown;switch(H[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=i;function o(K){if(K instanceof T)return K.fileOperationResult;switch(i(K)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var s;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class l{constructor(H,F,A){this.resource=H,this.operation=F,this.target=A}isOperation(H){return this.operation===H}}e.FileOperationEvent=l;var a;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class y{constructor(H,F){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=H;const A=new Map;for(const O of H){const _=A.get(O.type);switch(_?_.push([O.resource,O]):A.set(O.type,[[O.resource,O]]),O.type){case 1:this.rawAdded.push(O.resource);break;case 0:this.rawUpdated.push(O.resource);break;case 2:this.rawDeleted.push(O.resource);break}}for(const[O,_]of A)switch(O){case 1:this.added=E.TernarySearchTree.forUris(()=>F),this.added.fill(_);break;case 0:this.updated=E.TernarySearchTree.forUris(()=>F),this.updated.fill(_);break;case 2:this.deleted=E.TernarySearchTree.forUris(()=>F),this.deleted.fill(_);break}}contains(H,...F){return this.doContains(H,{includeChildren:!1},...F)}affects(H,...F){return this.doContains(H,{includeChildren:!0},...F)}doContains(H,F,...A){if(!H)return!1;const O=A.length>0;return!!((!O||A.includes(1))&&(this.added?.get(H)||F.includeChildren&&this.added?.findSuperstr(H))||(!O||A.includes(0))&&(this.updated?.get(H)||F.includeChildren&&this.updated?.findSuperstr(H))||(!O||A.includes(2))&&(this.deleted?.findSubstr(H)||F.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=y;function M(K,H,F){return!K||!H||K===H||H.length>K.length?!1:(H.charAt(H.length-1)!==t.sep&&(H+=t.sep),F?(0,k.startsWithIgnoreCase)(K,H):K.indexOf(H)===0)}e.isParent=M;class T extends Error{constructor(H,F,A){super(H),this.fileOperationResult=F,this.options=A}}e.FileOperationError=T;class U extends T{constructor(H,F,A){super(H,2,A),this.stat=F}}e.NotModifiedSinceFileOperationError=U;var Y;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",K[K.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var G;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(G=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=V;async function oe(K,H){if(!H.hasProvider(D.URI.from({scheme:K.scheme})))return new Promise(F=>{const A=H.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===K.scheme&&O.added&&(A.dispose(),F())})})}e.whenProviderRegistered=oe,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ae{static formatSize(H){return(0,R.isNumber)(H)||(H=0),H<ae.KB?(0,P.localize)(1,null,H.toFixed(0)):H<ae.MB?(0,P.localize)(2,null,(H/ae.KB).toFixed(2)):H<ae.GB?(0,P.localize)(3,null,(H/ae.MB).toFixed(2)):H<ae.TB?(0,P.localize)(4,null,(H/ae.GB).toFixed(2)):(0,P.localize)(5,null,(H/ae.TB).toFixed(2))}}e.ByteSize=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;var se;(function(K){K[K.IA32=0]="IA32",K[K.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function fe(K){return{maxFileSize:K===0?300*ae.MB:16*ae.GB,maxHeapSize:K===0?700*ae.MB:2*700*ae.MB}}e.getPlatformLimits=fe}),define(ee[194],te([0,1,17,43,16,3,2,57,7,29,15]),function(z,e,E,t,k,R,D,P,p,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class I extends D.Disposable{constructor(d,m){super(),this.channel=d,this.extraCapabilities=m,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,S.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(d){return this.channel.call("stat",[d])}readdir(d){return this.channel.call("readdir",[d])}async readFile(d,m){const{buffer:h}=await this.channel.call("readFile",[d,m]);return h}readFileStream(d,m,h){const w=(0,P.newWriteableStream)(v=>E.VSBuffer.concat(v.map(g=>E.VSBuffer.wrap(g))).buffer),u=this.channel.listen("readFileStream",[d,m])(v=>{if(v instanceof E.VSBuffer)w.write(v.buffer);else{if(v==="end")w.end();else{let g=v;g instanceof Error||(g=(0,b.createFileSystemProviderError)((0,t.toErrorMessage)(g),b.FileSystemProviderErrorCode.Unknown)),w.error(g),w.end()}u.dispose()}});return h.onCancellationRequested(()=>{w.error((0,k.canceled)()),w.end(),u.dispose()}),w}writeFile(d,m,h){return this.channel.call("writeFile",[d,E.VSBuffer.wrap(m),h])}open(d,m){return this.channel.call("open",[d,m])}close(d){return this.channel.call("close",[d])}async read(d,m,h,w,u){const[v,g]=await this.channel.call("read",[d,m,u]);return h.set(v.buffer.slice(0,g),w),g}write(d,m,h,w,u){return this.channel.call("write",[d,m,E.VSBuffer.wrap(h),w,u])}mkdir(d){return this.channel.call("mkdir",[d])}delete(d,m){return this.channel.call("delete",[d,m])}rename(d,m,h){return this.channel.call("rename",[d,m,h])}copy(d,m,h){return this.channel.call("copy",[d,m,h])}cloneFile(d,m){return this.channel.call("cloneFile",[d,m])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(d=>{if(Array.isArray(d)){const m=d;this._onDidChange.fire(m.map(h=>({resource:p.URI.revive(h.resource),type:h.type})))}else{const m=d;this._onDidWatchError.fire(m)}}))}watch(d,m){const h=(0,S.generateUuid)();return this.channel.call("watch",[this.sessionId,h,d,m]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,h]))}}e.DiskFileSystemProviderClient=I}),define(ee[107],te([0,1,17,16,159,15]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(b,I,C,d,m,h){let w;try{await P(b,I,C,d,m,h)}catch(u){w=u}finally{w&&m.errorTransformer&&(w=m.errorTransformer(w)),typeof w<"u"&&C.error(w),C.end()}}e.readFileIntoStream=D;async function P(b,I,C,d,m,h){p(h);const w=await b.open(I,{create:!1});try{p(h);let u=0,v=0,g=m&&typeof m.length=="number"?m.length:void 0,f=E.VSBuffer.alloc(Math.min(m.bufferSize,typeof g=="number"?g:m.bufferSize)),c=m&&typeof m.position=="number"?m.position:0,n=0;do v=await b.read(w,c,f.buffer,n,f.byteLength-n),c+=v,n+=v,u+=v,typeof g=="number"&&(g-=v),n===f.byteLength&&(await C.write(d(f)),f=E.VSBuffer.alloc(Math.min(m.bufferSize,typeof g=="number"?g:m.bufferSize)),n=0);while(v>0&&(typeof g!="number"||g>0)&&p(h)&&S(u,m));if(n>0){let r=n;typeof g=="number"&&(r=Math.min(n,g)),C.write(d(f.slice(0,r)))}}catch(u){throw(0,R.ensureFileSystemProviderError)(u)}finally{await b.close(w)}}function p(b){if(b.isCancellationRequested)throw(0,t.canceled)();return!0}function S(b,I){if(I?.limits){if(typeof I.limits.memory=="number"&&b>I.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&b>I.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[71],te([0,1,98,2,9,4,7,15]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function p(u){return u.recursive===!0}e.isRecursiveWatchRequest=p;class S extends t.Disposable{constructor(v,g,f,c){super(),this.onFileChanges=v,this.onLogMessage=g,this.verboseLogging=f,this.options=c,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const v=new t.DisposableStore;this.watcherDisposables.value=v,this.watcher=this.createWatcher(v),this.watcher.setVerboseLogging(this.verboseLogging),v.add(this.watcher.onDidChangeFile(g=>this.onFileChanges(g))),v.add(this.watcher.onDidLogMessage(g=>this.onLogMessage(g))),v.add(this.watcher.onDidError(g=>this.onError(g)))}onError(v){this.options.restartOnError?this.restartCounter<S.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${v}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${v}`):this.error(v)}restart(v){this.restartCounter++,this.init(),this.watch(v)}async watch(v){this.requests=v,await this.watcher?.watch(v)}async setVerboseLogging(v){this.verboseLogging=v,await this.watcher?.setVerboseLogging(v)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${v}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.MAX_RESTARTS=5;class b extends S{constructor(v,g,f){super(v,g,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class I extends S{constructor(v,g,f){super(v,g,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function C(u){return u.map(v=>({type:v.type,resource:D.URI.file(v.path)}))}e.toFileChanges=C;function d(u){const v=new w;for(const g of u)v.processEvent(g);return v.coalesce()}e.coalesceEvents=d;function m(u,v){return typeof v=="string"&&!v.startsWith(E.GLOBSTAR)&&!(0,k.isAbsolute)(v)?{base:u,pattern:v}:v}e.normalizeWatcherPattern=m;function h(u,v){const g=[];for(const f of v)g.push((0,E.parse)(m(u,f)));return g}e.parseWatcherPatterns=h;class w{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(v){return R.isLinux?v.path:v.path.toLowerCase()}processEvent(v){const g=this.mapPathToChange.get(this.toKey(v));let f=!1;if(g){const c=g.type,n=v.type;g.path!==v.path&&(v.type===2||v.type===1)?f=!0:c===1&&n===2?(this.mapPathToChange.delete(this.toKey(v)),this.coalesced.delete(g)):c===2&&n===1?g.type=0:c===1&&n===0||(g.type=n)}else f=!0;f&&(this.coalesced.add(v),this.mapPathToChange.set(this.toKey(v),v))}coalesce(){const v=[],g=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(v.push(f),!1):!0).sort((f,c)=>f.path.length-c.path.length).filter(f=>g.some(c=>(0,P.isParent)(f.path,c,!R.isLinux))?!1:(g.push(f.path),!0)).concat(v)}}}),define(ee[195],te([0,1,39,8,22,30,2,76,9,4,99,23,71]),function(z,e,E,t,k,R,D,P,p,S,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends D.Disposable{constructor(w,u,v,g){super(),this.request=w,this.onDidFilesChange=u,this.onLogMessage=v,this.verboseLogging=g,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(d.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,C.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,C.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const w=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const u=await I.Promises.stat(w);this._register(await this.doWatch(w,u.isDirectory()))}catch(w){w.code!=="ENOENT"?this.error(w):this.trace(w)}}async normalizePath(w){let u=w.path;try{u=await I.Promises.realpath(w.path),w.path===u&&(u=await(0,b.realcase)(w.path)??w.path),w.path!==u&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${u})`)}catch{}return u}async doWatch(w,u){if(S.isMacintosh&&(0,R.isEqualOrParent)(w,"/Volumes/",!0))return this.error(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const v=new k.CancellationTokenSource(this.cts.token),g=new D.DisposableStore;try{const f=(0,p.basename)(w),c=(0,E.watch)(w);g.add((0,D.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${w}'`);const n=new Set;if(u)try{for(const i of await I.Promises.readdir(w))n.add(i)}catch(i){this.error(i)}const r=new Map;g.add((0,D.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),c.on("error",(i,o)=>{this.error(`Failed to watch ${w} for changes using fs.watch() (${i}, ${o})`),this.dispose()}),c.on("change",(i,o)=>{if(v.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${o}`);let s="";if(o&&(s=o.toString(),S.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||i!=="change"&&i!=="rename"))if(u)if(i==="rename"){r.get(s)?.dispose();const l=setTimeout(async()=>{if(r.delete(s),s===f&&!await I.Promises.exists(w)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,p.join)(w,s));if(v.token.isCancellationRequested)return;let y;a?n.has(s)?y=0:(y=1,n.add(s)):(n.delete(s),y=2),this.onFileChange({path:(0,p.join)(this.request.path,s),type:y})},d.FILE_DELETE_HANDLER_DELAY);r.set(s,(0,D.toDisposable)(()=>clearTimeout(l)))}else{let l;n.has(s)?l=0:(l=1,n.add(s)),this.onFileChange({path:(0,p.join)(this.request.path,s),type:l})}else if(i==="rename"||s!==f){const l=setTimeout(async()=>{const a=await I.Promises.exists(w);v.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),g.add(await this.doWatch(w,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},d.FILE_DELETE_HANDLER_DELAY);g.clear(),g.add((0,D.toDisposable)(()=>clearTimeout(l)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await I.Promises.exists(w)&&!v.token.isCancellationRequested&&this.error(`Failed to watch ${w} for changes using fs.watch() (${f.toString()})`)}return(0,D.toDisposable)(()=>{v.dispose(!0),g.dispose()})}async onFileChange(w,u=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),!u&&this.excludes.some(v=>v(w.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${w.path}`):!u&&this.includes&&this.includes.length>0&&!this.includes.some(v=>v(w.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${w.path}`):this.fileChangesBuffer.push(w);try{await this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const g=(0,C.coalesceEvents)(v);if(g.length>0){if(this.verboseLogging)for(const c of g)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(g)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(w){if(S.isLinux)return I.Promises.exists(w);try{const u=(0,p.basename)(w);return(await I.Promises.readdir((0,p.dirname)(w))).some(g=>g===u)}catch(u){return this.trace(u),!1}}setVerboseLogging(w){this.verboseLogging=w}error(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}warn(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}trace(w){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d,d.FILE_DELETE_HANDLER_DELAY=100,d.FILE_CHANGES_HANDLER_DELAY=50;async function m(h,w,u,v,g=512){const f=await I.Promises.open(h,"r"),c=Buffer.allocUnsafe(g),n=new k.CancellationTokenSource(v);let r,i=!1;const o={path:h,excludes:[],recursive:!1},s=new d(o,l=>{(async()=>{for(const{type:a}of l)if(a===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:y}=await I.Promises.read(f,c,0,g,null);if(!y||n.token.isCancellationRequested)break;w(c.slice(0,y))}}catch(y){r=new Error(y),n.dispose(!0)}finally{i=!1}}})()});return await s.ready,u(),new Promise((l,a)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await I.Promises.close(f)}catch(y){r=new Error(y)}r?a(r):l()})})}e.watchFileContents=m}),define(ee[196],te([0,1,3,98,2,4,195]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new E.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new E.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=E.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(S){const b=this.normalizeRequests(S),I=b.filter(d=>{const m=this.watchers.get(d.path);return m?!(0,t.patternsEquals)(m.request.excludes,d.excludes)||!(0,t.patternsEquals)(m.request.includes,d.includes):!0}),C=Array.from(this.watchers.values()).filter(({request:d})=>!b.find(m=>m.path===d.path&&(0,t.patternsEquals)(m.excludes,d.excludes)&&(0,t.patternsEquals)(m.includes,d.includes))).map(({request:d})=>d.path);I.length&&this.trace(`Request to start watching: ${I.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),C.length&&this.trace(`Request to stop watching: ${C.join(",")}`);for(const d of C)this.stopWatching(d);for(const d of I)this.startWatching(d)}startWatching(S){const b=new D.NodeJSFileWatcherLibrary(S,C=>this._onDidChangeFile.fire(C),C=>this._onDidLogMessage.fire(C),this.verboseLogging),I={request:S,instance:b};this.watchers.set(S.path,I)}async stop(){for(const[S]of this.watchers)this.stopWatching(S);this.watchers.clear()}stopWatching(S){const b=this.watchers.get(S);b&&(this.watchers.delete(S),b.instance.dispose())}normalizeRequests(S){const b=new Map;for(const I of S){const C=R.isLinux?I.path:I.path.toLowerCase();b.set(C,I)}return Array.from(b.values())}async setVerboseLogging(S){this.verboseLogging=S;for(const[,b]of this.watchers)b.instance.setVerboseLogging(S)}trace(S){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(S)})}toMessage(S,b){return b?`[File Watcher (node.js)] ${S} (path: ${b.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=P}),define(ee[197],te([0,1,71,196]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends E.AbstractNonRecursiveWatcherClient{constructor(D,P,p){super(D,P,p),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(ee[198],te([0,1,14,45,145,71]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(p,S,b){super(p,S,b),this.init()}createWatcher(p){const S=p.add(new k.Client(E.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(S.onDidProcessExit(({code:b,signal:I})=>this.onError(`terminated by itself with code ${b}, signal: ${I}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(ee[85],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...k){this._entries=new Map;for(const[R,D]of k)this.set(R,D)}set(k,R){const D=this._entries.get(k);return this._entries.set(k,R),D}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=E}),define(ee[199],te([0,1,8,16,2,69,189,5,85,94]),function(z,e,E,t,k,R,D,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class I extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class C{constructor(w=new p.ServiceCollection,u=!1,v,g=b){this._services=w,this._strict=u,this._parent=v,this._enableTracing=g,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=g?v?._globalGraph??new D.Graph(f=>f):void 0}createChild(w){return new C(w,this._strict,this,this._enableTracing)}invokeFunction(w,...u){const v=m.traceInvocation(this._enableTracing,w);let g=!1;try{return w({get:c=>{if(g)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(c,v);if(!n)throw new Error(`[invokeFunction] unknown service '${c}'`);return n}},...u)}finally{g=!0,v.stop()}}createInstance(w,...u){let v,g;return w instanceof R.SyncDescriptor?(v=m.traceCreation(this._enableTracing,w.ctor),g=this._createInstance(w.ctor,w.staticArguments.concat(u),v)):(v=m.traceCreation(this._enableTracing,w),g=this._createInstance(w,u,v)),v.stop(),g}_createInstance(w,u=[],v){const g=P._util.getServiceDependencies(w).sort((n,r)=>n.index-r.index),f=[];for(const n of g){const r=this._getOrCreateServiceInstance(n.id,v);r||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${n.id}.`,!1),f.push(r)}const c=g.length>0?g[0].index:u.length;if(u.length!==c){console.trace(`[createInstance] First service dependency of ${w.name} at position ${c+1} conflicts with ${u.length} static arguments`);const n=c-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,c)}return Reflect.construct(w,u.concat(f))}_setServiceInstance(w,u){if(this._services.get(w)instanceof R.SyncDescriptor)this._services.set(w,u);else if(this._parent)this._parent._setServiceInstance(w,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){const u=this._services.get(w);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):u}_getOrCreateServiceInstance(w,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(w));const v=this._getServiceInstanceOrDescriptor(w);return v instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,v,u.branch(w,!0)):(u.branch(w,!1),v)}_safeCreateAndCacheServiceInstance(w,u,v){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,u,v)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,u,v){const g=new D.Graph(n=>n.id.toString());let f=0;const c=[{id:w,desc:u,_trace:v}];for(;c.length;){const n=c.pop();if(g.lookupOrInsertNode(n),f++>1e3)throw new I(g);for(const r of P._util.getServiceDependencies(n.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(r.id);if(i||this._throwIfStrict(`[createInstance] ${w} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),i instanceof R.SyncDescriptor){const o={id:r.id,desc:i,_trace:n._trace.branch(r.id,!0)};g.insertEdge(n,o),c.push(o)}}}for(;;){const n=g.roots();if(n.length===0){if(!g.isEmpty())throw new I(g);break}for(const{data:r}of n){if(this._getServiceInstanceOrDescriptor(r.id)instanceof R.SyncDescriptor){const o=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,o)}g.removeNode(r)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,u,v=[],g,f){if(this._services.get(w)instanceof R.SyncDescriptor)return this._createServiceInstance(w,u,v,g,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,u,v,g,f);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(w,u,v=[],g,f){if(g){const c=new C(void 0,this._strict,this,this._enableTracing);c._globalGraphImplicitDependency=String(w);const n=new Map,r=new E.IdleValue(()=>{const i=c._createInstance(u,v,f);for(const[o,s]of n){const l=i[o];if(typeof l=="function")for(const a of s)l.apply(i,a)}return n.clear(),i});return new Proxy(Object.create(null),{get(i,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let a=n.get(o);return a||(a=new S.LinkedList,n.set(o,a)),(M,T,U)=>{const Y=a.push([M,T,U]);return(0,k.toDisposable)(Y)}}if(o in i)return i[o];const s=r.value;let l=s[o];return typeof l!="function"||(l=l.bind(s),i[o]=l),l},set(i,o,s){return r.value[o]=s,!0}})}else return this._createInstance(u,v,f)}_throwIfStrict(w,u){if(u&&console.warn(w),this._strict)throw new Error(w)}}e.InstantiationService=C;var d;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(d||(d={}));class m{static traceInvocation(w,u){return w?new m(1,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m._None}static traceCreation(w,u){return w?new m(0,u.name):m._None}constructor(w,u){this.type=w,this.name=u,this._start=Date.now(),this._dep=[]}branch(w,u){const v=new m(2,w.toString());return this._dep.push([w,u,v]),v}stop(){const w=Date.now()-this._start;m._totals+=w;let u=!1;function v(f,c){const n=[],r=new Array(f+1).join("	");for(const[i,o,s]of c._dep)if(o&&s){u=!0,n.push(`${r}CREATES -> ${i}`);const l=v(f+1,s);l&&n.push(l)}else n.push(`${r}uses -> ${i}`);return n.join(`
`)}const g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(w>2||u)&&m.all.add(g.join(`
`))}}e.Trace=m,m.all=new Set,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(ee[6],te([0,1,43,3,2,38,4,7,5]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function S(){return new Date().toISOString()}var b;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function I(l,a,y){switch(a){case b.Trace:l.trace(y);break;case b.Debug:l.debug(y);break;case b.Info:l.info(y);break;case b.Warning:l.warn(y);break;case b.Error:l.error(y);break;default:throw new Error("Invalid log level")}}e.log=I;function C(l){let a="";for(let y=0;y<l.length;y++){let M=l[y];if(typeof M=="object")try{M=JSON.stringify(M)}catch{}a+=(y>0?" ":"")+M}return a}e.format=C;class d extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=d;class m extends d{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...y){this.checkLogLevel(b.Trace)&&this.log(b.Trace,C([a,...y]))}debug(a,...y){this.checkLogLevel(b.Debug)&&this.log(b.Debug,C([a,...y]))}info(a,...y){this.checkLogLevel(b.Info)&&this.log(b.Info,C([a,...y]))}warn(a,...y){this.checkLogLevel(b.Warning)&&this.log(b.Warning,C([a,...y]))}error(a,...y){if(this.checkLogLevel(b.Error))if(a instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=a.stack,this.log(b.Error,C(M))}else this.log(b.Error,C([a,...y]))}flush(){}}e.AbstractMessageLogger=m;class h extends d{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!D.isWindows}trace(a,...y){this.getLevel()<=b.Trace&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...y):console.log(`[main ${S()}]`,a,...y))}debug(a,...y){this.getLevel()<=b.Debug&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...y):console.log(`[main ${S()}]`,a,...y))}info(a,...y){this.getLevel()<=b.Info&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...y):console.log(`[main ${S()}]`,a,...y))}warn(a,...y){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,a,...y):console.warn(`[main ${S()}]`,a,...y))}error(a,...y){this.getLevel()<=b.Error&&(this.useColors?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,a,...y):console.error(`[main ${S()}]`,a,...y))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class w extends d{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...y){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",a,...y)}debug(a,...y){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...y)}info(a,...y){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",a,...y)}warn(a,...y){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",a,...y)}error(a,...y){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",a,...y)}dispose(){}flush(){}}e.ConsoleLogger=w;class u extends d{constructor(a,y=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(y)}trace(a,...y){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(a),...y])}debug(a,...y){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(a),...y])}info(a,...y){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(a),...y])}warn(a,...y){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(a),...y])}error(a,...y){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(a),...y])}extractMessage(a){return typeof a=="string"?a:(0,E.toErrorMessage)(a,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class v extends d{constructor(a){super(),this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const y of this.logServices)y.setLevel(a);super.setLevel(a)}trace(a,...y){for(const M of this.logServices)M.trace(a,...y)}debug(a,...y){for(const M of this.logServices)M.debug(a,...y)}info(a,...y){for(const M of this.logServices)M.info(a,...y)}warn(a,...y){for(const M of this.logServices)M.warn(a,...y)}error(a,...y){for(const M of this.logServices)M.error(a,...y)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=v;class g extends k.Disposable{constructor(a){super(),this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...y){this.logger.trace(a,...y)}debug(a,...y){this.logger.debug(a,...y)}info(a,...y){this.logger.info(a,...y)}warn(a,...y){this.logger.warn(a,...y)}error(a,...y){this.logger.error(a,...y)}flush(){this.logger.flush()}}e.LogService=g;class f extends k.Disposable{constructor(a,y){super(),this.logLevel=a,this.loggerItems=new R.ResourceMap,this._register(y(M=>this.setLevel(M)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:a})=>a)}getLogger(a){return this.loggerItems.get(a)?.logger}createLogger(a,y,M){let T=this.loggerItems.get(a)?.logger;return T||(M=y?.always?b.Trace:M,T=this.doCreateLogger(a,M??this.logLevel,y),this.loggerItems.set(a,{logger:T,logLevel:M})),T}setLevel(a,y){const M=P.URI.isUri(a)?a:void 0,T=M?y:a;if(M){const U=this.loggerItems.get(M);U&&U.logLevel!==T&&(U.logLevel=T,U.logger.setLevel(T))}else this.logLevel=T,this.loggerItems.forEach(({logLevel:U,logger:Y})=>{U===void 0&&Y.setLevel(this.logLevel)})}getLogLevel(a){return this.loggerItems.get(a)?.logLevel}dispose(){this.loggerItems.forEach(({logger:a})=>a.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=f;class c{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(a){}getLevel(){return b.Info}trace(a,...y){}debug(a,...y){}info(a,...y){}warn(a,...y){}error(a,...y){}critical(a,...y){}dispose(){}flush(){}}e.NullLogger=c;class n extends c{}e.NullLogService=n;class r extends f{constructor(){super(b.Info,t.Event.None)}doCreateLogger(a,y,M){return new c}}e.NullLoggerService=r;function i(l){if(l.verbose)return b.Trace;if(typeof l.logLevel=="string"){const a=s(l.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function o(l){switch(l){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=o;function s(l){switch(l){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=s});var ie=this&&this.__param||function(z,e){return function(E,t){e(E,t,z)}};define(ee[200],te([0,1,70,3,2,6,4,8]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let p=class bt extends k.Disposable{constructor(b){super(),this.logService=b,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(b,I){this.logService.trace("Getting password from keytar:",b,I);let C;try{C=await this.withKeytar()}catch{return null}const d=await(0,P.retry)(()=>C.getPassword(b,I),50,3);if(!d)return this.logService.trace("Did not get a password from keytar for account:",I),d;let m,h;try{const w=JSON.parse(d);m=w.content,h=w.hasNextChunk}catch{}if(!m||!h)return this.logService.trace("Got password from keytar for account:",I),d;try{let w=1;for(;h;){const u=await(0,P.retry)(()=>C.getPassword(b,`${I}-${w}`),50,3),v=JSON.parse(u);m+=v.content,h=v.hasNextChunk,w++}return this.logService.trace(`Got ${w}-chunked password from keytar for account:`,I),m}catch(w){return this.logService.error(w),d}}async setPassword(b,I,C){this.logService.trace("Setting password using keytar:",b,I);let d;try{d=await this.withKeytar()}catch(m){throw this.surfaceKeytarLoadError?.(m),m}if(D.isWindows&&C.length>bt.MAX_PASSWORD_LENGTH){let m=0,h=0,w=!0;for(;w;){const u=C.substring(m,m+bt.PASSWORD_CHUNK_SIZE);m+=bt.PASSWORD_CHUNK_SIZE,w=C.length-m>0;const v={content:u,hasNextChunk:w};await(0,P.retry)(()=>d.setPassword(b,h?`${I}-${h}`:I,JSON.stringify(v)),50,3),h++}this.logService.trace(`Got${h?` ${h}-chunked`:""} password from keytar for account:`,I)}else await(0,P.retry)(()=>d.setPassword(b,I,C),50,3),this.logService.trace("Got password from keytar for account:",I);this._onDidChangePassword.fire({service:b,account:I})}async deletePassword(b,I){this.logService.trace("Deleting password using keytar:",b,I);let C;try{C=await this.withKeytar()}catch(u){throw this.surfaceKeytarLoadError?.(u),u}const d=await C.getPassword(b,I);if(!d)return this.logService.trace("Did not get a password to delete from keytar for account:",I),!1;let m,h;try{const u=JSON.parse(d);m=u.content,h=u.hasNextChunk}catch{}let w=0;if(m&&h)try{for(w++;h;){const u=`${I}-${w}`,v=await C.getPassword(b,u);await C.deletePassword(b,u),h=JSON.parse(v).hasNextChunk,w++}}catch(u){this.logService.error(u)}return await C.deletePassword(b,I)?(this._onDidChangePassword.fire({service:b,account:I}),this.logService.trace(`Deleted${w?` ${w}-chunked`:""} password from keytar for account:`,I),!0):(this.logService.trace(`Keytar failed to delete${w?` ${w}-chunked`:""} password for account:`,I),!1)}async findPassword(b){let I;try{I=await this.withKeytar()}catch{return null}return await I.findPassword(b)}async findCredentials(b){let I;try{I=await this.withKeytar()}catch{return[]}return await I.findCredentials(b)}clear(){return this._keytarCache instanceof E.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};p.MAX_PASSWORD_LENGTH=2500,p.PASSWORD_CHUNK_SIZE=p.MAX_PASSWORD_LENGTH-100,p=we([ie(0,R.ILogService)],p),e.BaseCredentialsMainService=p}),define(ee[201],te([0,1,6]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let t=class{constructor(R,D){this.machineId=R,this.logService=D}encryption(){return new Promise((R,D)=>z(["vscode-encrypt"],R,D))}async encrypt(R){let D;try{D=await this.encryption()}catch{return R}try{return D.encrypt(this.machineId,R)}catch(P){return this.logService.error(P),R}}async decrypt(R){let D;try{D=await this.encryption()}catch{return R}try{return D.decrypt(this.machineId,R)}catch(P){return this.logService.error(P),R}}};t=we([ie(1,E.ILogService)],t),e.EncryptionMainService=t}),define(ee[202],te([0,1,24,8,16,3,2,9,71,6]),function(z,e,E,t,k,R,D,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends D.Disposable{constructor(C,d){super(),this.logService=C,this.options=d,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(C,d){return d.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(C,d):this.watchNonRecursive(C,d)}watchUniversal(C,d){const m={path:this.toFilePath(C),excludes:d.excludes,includes:d.includes,recursive:d.recursive},h=(0,E.insert)(this.universalPathsToWatch,m);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{h(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(C=>(0,k.onUnexpectedError)(C))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(d=>this._onDidChangeFile.fire((0,p.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)})));const C=this.options?.watcher?.recursive?.usePolling;if(C===!0)for(const d of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(C))for(const d of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(d)&&C.includes(d.path)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(C,d){const m={path:this.toFilePath(C),excludes:d.excludes,includes:d.includes,recursive:!1},h=(0,E.insert)(this.nonRecursivePathsToWatch,m);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{h(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(C=>(0,k.onUnexpectedError)(C))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(C=>this._onDidChangeFile.fire((0,p.toFileChanges)(C)),C=>this.onWatcherLogMessage(C),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(C){C.type==="error"&&this._onDidWatchError.fire(C.message),this.logService[C.type](C.message)}toFilePath(C){return(0,P.normalize)(C.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(ee[203],te([0,1,24,8,17,22,3,67,66,2,58,14,72,19,57,157,15,107,6]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends S.Disposable{constructor(c){super(),this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(c,n){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${c}`);const r=new S.DisposableStore;return this.provider.set(c,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:n}),r.add(n.onDidChangeFile(i=>this._onDidFilesChange.fire(new w.FileChangesEvent(i,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),r.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:c}))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:n}),this.provider.delete(c),(0,S.dispose)(r)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(r){n.push(r)}}),!this.provider.has(c)&&await t.Promises.settled(n)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,n){const r=this.provider.get(c.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return p.Iterable.map(this.provider,([c,n])=>({scheme:c,capabilities:n.capabilities}))}async withProvider(c){if(!(0,d.isAbsolutePath)(c))throw new w.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const n=this.provider.get(c.scheme);if(!n){const r=new Error;throw r.name="ENOPRO",r.message=(0,h.localize)(1,null,c.toString()),r}return n}async withReadProvider(c){const n=await this.withProvider(c);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n)||(0,w.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const n=await this.withProvider(c);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,n){try{return await this.doResolveFile(c,n)}catch(r){throw(0,w.toFileSystemProviderErrorCode)(r)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,w.ensureFileSystemProviderError)(r)}}async doResolveFile(c,n){const r=await this.withProvider(c),i=this.isPathCaseSensitive(r),o=n?.resolveTo,s=n?.resolveSingleChildDescendants,l=n?.resolveMetadata,a=await r.stat(c);let y;return this.toFileStat(r,c,a,void 0,!!l,(M,T)=>(y||(y=b.TernarySearchTree.forUris(()=>!i),y.set(c,!0),o&&y.fill(!0,o)),y.get(M.resource)||y.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&s?T===1:!1))}async toFileStat(c,n,r,i,o,s){const{providerExtUri:l}=this.getExtUri(c),a={resource:n,name:l.basename(n),isFile:(r.type&w.FileType.File)!==0,isDirectory:(r.type&w.FileType.Directory)!==0,isSymbolicLink:(r.type&w.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&w.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,w.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(a.isDirectory&&s(a,i)){try{const y=await c.readdir(n),M=await t.Promises.settled(y.map(async([T,U])=>{try{const Y=l.joinPath(n,T),G=o?await c.stat(Y):{type:U};return await this.toFileStat(c,Y,G,y.length,o,s)}catch(Y){return this.logService.trace(Y),null}}));a.children=(0,E.coalesce)(M)}catch(y){this.logService.trace(y),a.children=[]}return a}return a}async resolveAll(c){return t.Promises.settled(c.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(c){const n=await this.withProvider(c),r=await n.stat(c);return this.toFileStat(n,c,r,void 0,!0,()=>!1)}async exists(c){const n=await this.withProvider(c);try{return!!await n.stat(c)}catch{return!1}}async canCreateFile(c,n){try{await this.doValidateCreateFile(c,n)}catch(r){return r}return!0}async doValidateCreateFile(c,n){if(!n?.overwrite&&await this.exists(c))throw new w.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,n)}async createFile(c,n=k.VSBuffer.fromString(""),r){await this.doValidateCreateFile(c,r);const i=await this.writeFile(c,n);return this._onDidRunOperation.fire(new w.FileOperationEvent(c,0,i)),i}async writeFile(c,n,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:o}=this.getExtUri(i);try{await this.validateWriteFile(i,c,r)||await this.mkdirp(i,o.dirname(c));let l;if((0,w.hasReadWriteCapability)(i)&&!(n instanceof k.VSBuffer))if((0,m.isReadableStream)(n)){const a=await(0,m.peekStream)(n,3);a.ended?l=k.VSBuffer.concat(a.buffer):l=a}else l=(0,m.peekReadable)(n,a=>k.VSBuffer.concat(a),3);else l=n;!(0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i)&&l instanceof k.VSBuffer?await this.doWriteUnbuffered(i,c,r,l):await this.doWriteBuffered(i,c,r,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l),this._onDidRunOperation.fire(new w.FileOperationEvent(c,4))}catch(s){throw new w.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),r)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,n,r){if(!!r?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(n)));let o;try{o=await c.stat(n)}catch{return}if((o.type&w.FileType.Directory)!==0)throw new w.FileOperationError((0,h.localize)(6,null,this.resourceForError(n)),0,r);if(this.throwIfFileIsReadonly(n,o),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==w.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&r.mtime<o.mtime&&r.etag!==(0,w.etag)({mtime:r.mtime,size:o.size}))throw new w.FileOperationError((0,h.localize)(7,null),3,r);return o}async readFile(c,n,r){const i=await this.withReadProvider(c);return n?.atomic?this.doReadFileAtomic(i,c,n,r):this.doReadFile(i,c,n,r)}async doReadFileAtomic(c,n,r,i){return new Promise((o,s)=>{this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(c,n,r,i);o(l)}catch(l){s(l)}})})}async doReadFile(c,n,r,i){const o=await this.doReadFileStream(c,n,{...r,preferUnbuffered:!0},i);return{...o,value:await(0,k.streamToBuffer)(o.value)}}async readFileStream(c,n,r){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,n,r)}async doReadFileStream(c,n,r,i){const o=new R.CancellationTokenSource(i),s=this.validateReadFile(n,r).then(a=>a,a=>{throw o.cancel(),a});let l;try{return typeof r?.etag=="string"&&r.etag!==w.ETAG_DISABLED&&await s,r?.atomic&&(0,w.hasFileAtomicReadCapability)(c)||!((0,w.hasOpenReadWriteCloseCapability)(c)||(0,w.hasFileReadStreamCapability)(c))||(0,w.hasReadWriteCapability)(c)&&r?.preferUnbuffered?l=this.readFileUnbuffered(c,n,r):(0,w.hasFileReadStreamCapability)(c)?l=this.readFileStreamed(c,n,o.token,r):l=this.readFileBuffered(c,n,o.token,r),{...await s,value:l}}catch(a){l&&await(0,m.consumeStream)(l);const y=(0,h.localize)(8,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(a).toString());throw a instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(y,a.stat,r):new w.FileOperationError(y,(0,w.toFileOperationResult)(a),r)}}readFileStreamed(c,n,r,i=Object.create(null)){const o=c.readFileStream(n,i,r);return(0,m.transform)(o,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new w.FileOperationError((0,h.localize)(9,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),i)},s=>k.VSBuffer.concat(s))}readFileBuffered(c,n,r,i=Object.create(null)){const o=(0,k.newWriteableBufferStream)();return(0,u.readFileIntoStream)(c,n,o,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new w.FileOperationError((0,h.localize)(10,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),i)},r),o}readFileUnbuffered(c,n,r){const i=(0,m.newWriteableStream)(o=>k.VSBuffer.concat(o));return(async()=>{try{let o;r?.atomic&&(0,w.hasFileAtomicReadCapability)(c)?o=await c.readFile(n,{atomic:!0}):o=await c.readFile(n),typeof r?.position=="number"&&(o=o.slice(r.position)),typeof r?.length=="number"&&(o=o.slice(0,r.length)),this.validateReadFileLimits(n,o.byteLength,r),i.end(k.VSBuffer.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async validateReadFile(c,n){const r=await this.resolve(c,{resolveMetadata:!0});if(r.isDirectory)throw new w.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.ETAG_DISABLED&&n.etag===r.etag)throw new w.NotModifiedSinceFileOperationError((0,h.localize)(12,null),r,n);return this.validateReadFileLimits(c,r.size,n),r}validateReadFileLimits(c,n,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&n>r.limits.size&&(i=7),typeof i=="number")throw new w.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,n,r){return this.doCanMoveCopy(c,n,"move",r)}async canCopy(c,n,r){return this.doCanMoveCopy(c,n,"copy",r)}async doCanMoveCopy(c,n,r,i){if(c.toString()!==n.toString())try{const o=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(o,c,s,n,r,i)}catch(o){return o}return!0}async move(c,n,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(i,c,o,n,"move",!!r),l=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(c,s==="move"?2:3,l)),l}async copy(c,n,r){const i=await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(i,c,o,n,"copy",!!r),l=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(c,s==="copy"?3:2,l)),l}async doMoveCopy(c,n,r,i,o,s){if(n.toString()===i.toString())return o;const{exists:l,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(c,n,r,i,o,s);if(l&&!a&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i)),o==="copy"){if(c===r&&(0,w.hasFileFolderCopyCapability)(c))await c.copy(n,i,{overwrite:s});else{const y=await this.resolve(n);y.isDirectory?await this.doCopyFolder(c,y,r,i):await this.doCopyFile(c,n,r,i)}return o}else return c===r?(await c.rename(n,i,{overwrite:s}),o):(await this.doMoveCopy(c,n,r,i,"copy",s),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(c,n,r,i){if((0,w.hasOpenReadWriteCloseCapability)(c)&&(0,w.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(c,n,r,i);if((0,w.hasOpenReadWriteCloseCapability)(c)&&(0,w.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(c,n,r,i);if((0,w.hasReadWriteCapability)(c)&&(0,w.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(c,n,r,i);if((0,w.hasReadWriteCapability)(c)&&(0,w.hasReadWriteCapability)(r))return this.doPipeUnbuffered(c,n,r,i)}async doCopyFolder(c,n,r,i){await r.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async o=>{const s=this.getExtUri(r).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.doCopyFolder(c,await this.resolve(o.resource),r,s):this.doCopyFile(c,o.resource,r,s)}))}async doValidateMoveCopy(c,n,r,i,o,s){let l=!1;if(c===r){const{providerExtUri:y,isPathCaseSensitive:M}=this.getExtUri(c);if(M||(l=y.isEqual(n,i)),l&&o==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(n),this.resourceForError(i)));if(!l&&y.isEqualOrParent(i,n))throw new Error((0,h.localize)(15,null,this.resourceForError(n),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!l){if(!s)throw new w.FileOperationError((0,h.localize)(16,null,this.resourceForError(n),this.resourceForError(i)),4);if(c===r){const{providerExtUri:y}=this.getExtUri(c);if(y.isEqualOrParent(n,i))throw new Error((0,h.localize)(17,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:l}}getExtUri(c){const n=this.isPathCaseSensitive(c);return{providerExtUri:n?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(n,c);const r=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(c,0,r)),r}async mkdirp(c,n){const r=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(n,i.dirname(n));)try{if(((await c.stat(n)).type&w.FileType.Directory)===0)throw new Error((0,h.localize)(18,null,this.resourceForError(n)));break}catch(o){if((0,w.toFileSystemProviderErrorCode)(o)!==w.FileSystemProviderErrorCode.FileNotFound)throw o;r.push(i.basename(n)),n=i.dirname(n)}for(let o=r.length-1;o>=0;o--){n=i.joinPath(n,r[o]);try{await c.mkdir(n)}catch(s){if((0,w.toFileSystemProviderErrorCode)(s)!==w.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(c,n){try{await this.doValidateDelete(c,n)}catch(r){return r}return!0}async doValidateDelete(c,n){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let o;try{o=await r.stat(c)}catch{}if(o)this.throwIfFileIsReadonly(c,o);else throw new w.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!n?.recursive){const l=await this.resolve(c);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return r}async del(c,n){const r=await this.doValidateDelete(c,n),i=!!n?.useTrash,o=!!n?.recursive;await r.delete(c,{recursive:o,useTrash:i}),this._onDidRunOperation.fire(new w.FileOperationEvent(c,1))}async cloneFile(c,n){const r=await this.withProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(r===i&&this.getExtUri(r).providerExtUri.isEqual(c,n))return;if(r===i&&(0,w.hasFileCloneCapability)(r))return r.cloneFile(c,n);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n));const o=this.writeQueue.queueFor(c,this.getExtUri(r).providerExtUri);return r===i&&(0,w.hasFileFolderCopyCapability)(r)?o.queue(()=>r.copy(c,n,{overwrite:!0})):o.queue(()=>this.doCopyFile(r,c,i,n))}watch(c,n={recursive:!1,excludes:[]}){const r=new S.DisposableStore;let i=!1,o=()=>{i=!0};return r.add((0,S.toDisposable)(()=>o())),(async()=>{try{const s=await this.doWatch(c,n);i?(0,S.dispose)(s):o=()=>(0,S.dispose)(s)}catch(s){this.logService.error(s)}})(),r}async doWatch(c,n){const r=await this.withProvider(c),i=(0,P.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(c),n]);let o=this.activeWatchers.get(i);return o||(o={count:0,disposable:r.watch(c,n)},this.activeWatchers.set(i,o)),o.count+=1,(0,S.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,S.dispose)(o.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,S.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,n,r,i){return this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(async()=>{const o=await c.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,m.isReadableStream)(i)||(0,m.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,o,i):await this.doWriteReadableBufferedQueued(c,o,i)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await c.close(o)}})}async doWriteStreamBufferedQueued(c,n,r){let i=0,o;if((0,m.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=k.VSBuffer.concat(r.buffer);await this.doWriteBuffer(c,n,s,s.byteLength,i,0),i+=s.byteLength}if(r.ended)return;o=r.stream}else o=r;return new Promise((s,l)=>{(0,m.listenStream)(o,{onData:async a=>{o.pause();try{await this.doWriteBuffer(c,n,a,a.byteLength,i,0)}catch(y){return l(y)}i+=a.byteLength,setTimeout(()=>o.resume())},onError:a=>l(a),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(c,n,r){let i=0,o;for(;(o=r.read())!==null;)await this.doWriteBuffer(c,n,o,o.byteLength,i,0),i+=o.byteLength}async doWriteBuffer(c,n,r,i,o,s){let l=0;for(;l<i;)l+=await c.write(n,o+l,r.buffer,s+l,i-l)}async doWriteUnbuffered(c,n,r,i){return this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,n,r,i))}async doWriteUnbufferedQueued(c,n,r,i){let o;i instanceof k.VSBuffer?o=i:(0,m.isReadableStream)(i)?o=await(0,k.streamToBuffer)(i):(0,m.isReadableBufferedStream)(i)?o=await(0,k.bufferedStreamToBuffer)(i):o=(0,k.readableToBuffer)(i),await c.writeFile(n,o.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(c,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,n,r,i))}async doPipeBufferedQueued(c,n,r,i){let o,s;try{o=await c.open(n,{create:!1}),s=await r.open(i,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,y=0,M=0;do M=await c.read(o,a,l.buffer,y,l.byteLength-y),await this.doWriteBuffer(r,s,l,M,a,y),a+=M,y+=M,y===l.byteLength&&(y=0);while(M>0)}catch(l){throw(0,w.ensureFileSystemProviderError)(l)}finally{await t.Promises.settled([typeof o=="number"?c.close(o):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async doPipeUnbuffered(c,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,n,r,i))}async doPipeUnbufferedQueued(c,n,r,i){return r.writeFile(i,await c.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,n,r,i))}async doPipeUnbufferedToBufferedQueued(c,n,r,i){const o=await r.open(i,{create:!0,unlock:!1});try{const s=await c.readFile(n);await this.doWriteBuffer(r,o,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await r.close(o)}}async doPipeBufferedToUnbuffered(c,n,r,i){const o=await(0,k.streamToBuffer)(this.readFileBuffered(c,n,R.CancellationToken.None));await this.doWriteUnbuffered(r,i,void 0,o)}throwIfFileSystemIsReadonly(c,n){if(c.capabilities&2048)throw new w.FileOperationError((0,h.localize)(22,null,this.resourceForError(n)),6);return c}throwIfFileIsReadonly(c,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===I.Schemas.file?c.fsPath:c.toString(!0)}};g=we([ie(0,v.ILogService)],g),e.FileService=g}),define(ee[86],te([0,1,39,277,8,38,17,3,30,2,9,4,19,57,23,161,15,107,202,43,198,197]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u,v,g,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(E)}catch(r){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(r)}`)}})();class n extends v.AbstractDiskFileSystemProvider{constructor(i,o){super(i,o),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new R.ResourceMap(s=>C.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:o,symbolicLink:s}=await m.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(o,s),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(i){try{const o=await m.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),s=[];return await Promise.all(o.map(async l=>{try{let a;l.isSymbolicLink()?a=(await this.stat((0,C.joinPath)(i,l.name))).type:a=this.toType(l),s.push([l.name,a])}catch(a){this.logService.trace(a)}})),s}catch(o){throw this.toFileSystemProviderError(o)}}toType(i,o){let s;return o?.dangling?s=w.FileType.Unknown:i.isFile()?s=w.FileType.File:i.isDirectory()?s=w.FileType.Directory:s=w.FileType.Unknown,o&&(s|=w.FileType.SymbolicLink),s}async createResourceLock(i){const o=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let s;for(;s=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await s.wait();const l=new k.Barrier;return this.resourceLocks.set(i,l),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,S.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.resourceLocks.get(i)===l&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),l.open()})}async readFile(i,o){let s;try{o?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),s=await this.createResourceLock(i));const l=this.toFilePath(i);return await m.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{s?.dispose()}}traceLock(i){n.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,o,s){const l=(0,d.newWriteableStream)(a=>D.VSBuffer.concat(a.map(y=>D.VSBuffer.wrap(y))).buffer);return(0,u.readFileIntoStream)(this,i,l,a=>a.buffer,{...o,bufferSize:256*1024},s),l}async writeFile(i,o,s){let l;try{const a=this.toFilePath(i);if(!s.create||!s.overwrite){if(await m.Promises.exists(a)){if(!s.overwrite)throw(0,w.createFileSystemProviderError)((0,h.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,w.createFileSystemProviderError)((0,h.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(l,0,o,0,o.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(i){n.canFlush=i}async open(i,o){const s=this.toFilePath(i);let l;(0,w.isFileOpenForWriteOptions)(o)&&(l=await this.createResourceLock(i));let a;try{if((0,w.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:M}=await m.SymlinkSupport.stat(s);M.mode&128||await m.Promises.chmod(s,M.mode|128)}catch(M){this.logService.trace(M)}let y;if((0,w.isFileOpenForWriteOptions)(o)){if(I.isWindows)try{await m.Promises.truncate(s,0),y="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}y||(y="w")}else y="r";a=await m.Promises.open(s,y)}catch(y){throw l?.dispose(),(0,w.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(i,y):this.toFileSystemProviderError(y)}if(this.mapHandleToPos.set(a,0),(0,w.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(a,i),l){const y=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${s})`),this.mapHandleToLock.set(a,l),y&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${s})`),y.dispose())}return a}async close(i){const o=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&n.canFlush)try{await m.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.logService.error(s)}return await m.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}finally{o&&(this.mapHandleToLock.get(i)===o&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),o.dispose())}}async read(i,o,s,l,a){const y=this.normalizePos(i,o);let M=null;try{M=(await m.Promises.read(i,s,l,a,y)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(i,y,M)}return M}normalizePos(i,o){return o===this.mapHandleToPos.get(i)?null:o}updatePos(i,o,s){const l=this.mapHandleToPos.get(i);typeof l=="number"&&(typeof o=="number"||(typeof s=="number"?this.mapHandleToPos.set(i,l+s):this.mapHandleToPos.delete(i)))}async write(i,o,s,l,a){return(0,k.retry)(()=>this.doWrite(i,o,s,l,a),100,3)}async doWrite(i,o,s,l,a){const y=this.normalizePos(i,o);let M=null;try{M=(await m.Promises.write(i,s,l,a,y)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),T)}finally{this.updatePos(i,y,M)}return M}async mkdir(i){try{await m.Promises.mkdir(this.toFilePath(i))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(i,o){try{const s=this.toFilePath(i);o.recursive?await m.Promises.rm(s,m.RimRafMode.MOVE):await m.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(i,o,s){const l=this.toFilePath(i),a=this.toFilePath(o);if(l!==a)try{await this.validateTargetDeleted(i,o,"move",s.overwrite),await m.Promises.move(l,a)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,h.localize)(2,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(a)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(i,o,s){const l=this.toFilePath(i),a=this.toFilePath(o);if(l!==a)try{await this.validateTargetDeleted(i,o,"copy",s.overwrite),await m.Promises.copy(l,a,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,h.localize)(3,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(a)),y.toString()))),this.toFileSystemProviderError(y)}}async validateTargetDeleted(i,o,s,l){const a=this.toFilePath(i),y=this.toFilePath(o);let M=!1;if(!!(this.capabilities&1024)||(M=(0,p.isEqual)(a,y,!0)),M&&s==="copy")throw(0,w.createFileSystemProviderError)((0,h.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!M&&await m.Promises.exists(y)){if(!l)throw(0,w.createFileSystemProviderError)((0,h.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(i,o){return this.doCloneFile(i,o,!1)}async doCloneFile(i,o,s){const l=this.toFilePath(i),a=this.toFilePath(o),y=!!(this.capabilities&1024);if((0,p.isEqual)(l,a,!y))return;const M=new S.DisposableStore;try{const[T,U]=await Promise.all([this.createResourceLock(i),this.createResourceLock(o)]);M.add(T),M.add(U),s&&await m.Promises.mkdir((0,b.dirname)(a),{recursive:!0}),await m.Promises.copyFile(l,a)}catch(T){if(T.code==="ENOENT"&&!s)return this.doCloneFile(i,o,!0);throw this.toFileSystemProviderError(T)}finally{M.dispose()}}createUniversalWatcher(i,o,s){return new f.UniversalWatcherClient(l=>i(l),l=>o(l),s)}createNonRecursiveWatcher(i,o,s){return new c.NodeJSWatcherClient(l=>i(l),l=>o(l),s)}toFileSystemProviderError(i){if(i instanceof w.FileSystemProviderError)return i;let o;switch(i.code){case"ENOENT":o=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=w.FileSystemProviderErrorCode.NoPermissions;break;default:o=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(i,o)}async toFileSystemProviderWriteError(i,o){let s=this.toFileSystemProviderError(o);if(i&&s.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await m.SymlinkSupport.stat(this.toFilePath(i));l.mode&128||(s=(0,w.createFileSystemProviderError)(o,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return s}}e.DiskFileSystemProvider=n,n.TRACE_LOG_RESOURCE_LOCKS=!1,n.canFlush=!0}),define(ee[204],te([0,1,3,86,2,17,57,22]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class p extends k.Disposable{constructor(I,C){super(),this.provider=I,this.logService=C,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(I,C,d){const m=this.getUriTransformer(I);switch(C){case"stat":return this.stat(m,d[0]);case"readdir":return this.readdir(m,d[0]);case"open":return this.open(m,d[0],d[1]);case"close":return this.close(d[0]);case"read":return this.read(d[0],d[1],d[2]);case"readFile":return this.readFile(m,d[0],d[1]);case"write":return this.write(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.writeFile(m,d[0],d[1],d[2]);case"rename":return this.rename(m,d[0],d[1],d[2]);case"copy":return this.copy(m,d[0],d[1],d[2]);case"cloneFile":return this.cloneFile(m,d[0],d[1]);case"mkdir":return this.mkdir(m,d[0]);case"delete":return this.delete(m,d[0],d[1]);case"watch":return this.watch(m,d[0],d[1],d[2],d[3]);case"unwatch":return this.unwatch(d[0],d[1])}throw new Error(`IPC Command ${C} not found`)}listen(I,C,d){const m=this.getUriTransformer(I);switch(C){case"fileChange":return this.onFileChange(m,d[0]);case"readFileStream":return this.onReadFileStream(m,d[0],d[1])}throw new Error(`Unknown event ${C}`)}stat(I,C){const d=this.transformIncoming(I,C,!0);return this.provider.stat(d)}readdir(I,C){const d=this.transformIncoming(I,C);return this.provider.readdir(d)}async readFile(I,C,d){const m=this.transformIncoming(I,C,!0),h=await this.provider.readFile(m,d);return R.VSBuffer.wrap(h)}onReadFileStream(I,C,d){const m=this.transformIncoming(I,C,!0),h=new P.CancellationTokenSource,w=new E.Emitter({onDidRemoveLastListener:()=>{h.cancel()}}),u=this.provider.readFileStream(m,d,h.token);return(0,D.listenStream)(u,{onData:v=>w.fire(R.VSBuffer.wrap(v)),onError:v=>w.fire(v),onEnd:()=>{w.fire("end"),w.dispose(),h.dispose()}}),w.event}writeFile(I,C,d,m){const h=this.transformIncoming(I,C);return this.provider.writeFile(h,d.buffer,m)}open(I,C,d){const m=this.transformIncoming(I,C,!0);return this.provider.open(m,d)}close(I){return this.provider.close(I)}async read(I,C,d){const m=R.VSBuffer.alloc(d),h=0,w=await this.provider.read(I,C,m.buffer,h,d);return[m,w]}write(I,C,d,m,h){return this.provider.write(I,C,d.buffer,m,h)}mkdir(I,C){const d=this.transformIncoming(I,C);return this.provider.mkdir(d)}delete(I,C,d){const m=this.transformIncoming(I,C);return this.provider.delete(m,d)}rename(I,C,d,m){const h=this.transformIncoming(I,C),w=this.transformIncoming(I,d);return this.provider.rename(h,w,m)}copy(I,C,d,m){const h=this.transformIncoming(I,C),w=this.transformIncoming(I,d);return this.provider.copy(h,w,m)}cloneFile(I,C,d){const m=this.transformIncoming(I,C),h=this.transformIncoming(I,d);return this.provider.cloneFile(m,h)}onFileChange(I,C){const d=new E.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(C,this.createSessionFileWatcher(I,d))},onDidRemoveLastListener:()=>{(0,k.dispose)(this.sessionToWatcher.get(C)),this.sessionToWatcher.delete(C)}});return d.event}async watch(I,C,d,m,h){const w=this.sessionToWatcher.get(C);if(w){const u=this.transformIncoming(I,m),v=w.watch(d,u,h);this.watchRequests.set(C+d,v)}}async unwatch(I,C){const d=I+C,m=this.watchRequests.get(d);m&&((0,k.dispose)(m),this.watchRequests.delete(d))}dispose(){super.dispose();for(const[,I]of this.watchRequests)I.dispose();this.watchRequests.clear();for(const[,I]of this.sessionToWatcher)I.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=p;class S extends k.Disposable{constructor(I,C,d,m){super(),this.uriTransformer=I,this.logService=d,this.environmentService=m,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(C)}registerListeners(I){const C=this._register(new E.Emitter);this._register(C.event(d=>{I.fire(d.map(m=>({resource:this.uriTransformer.transformOutgoingURI(m.resource),type:m.type})))})),this._register(this.fileWatcher.onDidChangeFile(d=>C.fire(d))),this._register(this.fileWatcher.onDidWatchError(d=>I.fire(d)))}getRecursiveWatcherOptions(I){}getExtraExcludes(I){}watch(I,C,d){const m=this.getExtraExcludes(this.environmentService);return Array.isArray(m)&&(d.excludes=[...d.excludes,...m]),this.watcherRequests.set(I,this.fileWatcher.watch(C,d)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(I)),this.watcherRequests.delete(I)})}dispose(){super.dispose();for(const[,I]of this.watcherRequests)I.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=S}),define(ee[205],te([0,1,13,160,4,7,15,9,204,139]),function(z,e,E,t,k,R,D,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class b extends p.AbstractDiskFileSystemProviderChannel{constructor(d,m,h){super(d,m),this.environmentService=h}getUriTransformer(d){return S.DefaultURITransformer}transformIncoming(d,m){return R.URI.revive(m)}async delete(d,m,h){if(!h.useTrash)return super.delete(d,m,h);const w=this.transformIncoming(d,m),u=(0,P.normalize)(w.fsPath);try{await E.shell.trashItem(u)}catch{throw(0,D.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,P.basename)(u)):(0,t.localize)(1,null,(0,P.basename)(u)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(d,m){return new I(d,m,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=b;class I extends p.AbstractSessionFileWatcher{watch(d,m,h){if(h.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(d,m,h)}}}),define(ee[206],te([0,1,6]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,D){switch(D){case E.LogLevel.Trace:return R.trace;case E.LogLevel.Debug:return R.debug;case E.LogLevel.Info:return R.info;case E.LogLevel.Warning:return R.warn;case E.LogLevel.Error:return R.error;default:throw new Error("Invalid log level")}}class k extends E.AbstractLogger{constructor(D=E.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(P=>{this._logger?.setLevel(P)}))}set logger(D){this._logger=D;for(const{level:P,args:p}of this.buffer)t(D,P).apply(D,p);this.buffer=[]}_log(D,...P){this._logger?t(this._logger,D).apply(this._logger,P):this.getLevel()<=D&&this.buffer.push({level:D,args:P})}trace(D,...P){this._log(E.LogLevel.Trace,D,...P)}debug(D,...P){this._log(E.LogLevel.Debug,D,...P)}info(D,...P){this._log(E.LogLevel.Info,D,...P)}warn(D,...P){this._log(E.LogLevel.Warning,D,...P)}error(D,...P){this._log(E.LogLevel.Error,D,...P)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(ee[207],te([0,1,3,7,6]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(C,d){this.logService=C,this.loggerService=d,this.onDidChangeLogLevel=E.Event.buffer(C.onDidChangeLogLevel,!0)}listen(C,d){switch(d){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${d}`)}async call(C,d,m){switch(d){case"setLevel":return m[1]?this.loggerService.setLevel(t.URI.revive(m[1]),m[0]):this.logService.setLevel(m[0])}throw new Error(`Call not found: ${d}`)}}e.LogLevelChannel=R;class D{constructor(C){this.channel=C}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(C,d){D.setLevel(this.channel,C,d)}static setLevel(C,d,m){return C.call("setLevel",[d,m])}}e.LogLevelChannelClient=D;class P{constructor(C){this.loggerService=C,this.loggers=new Map}listen(C,d){throw new Error(`Event not found: ${d}`)}async call(C,d,m){switch(d){case"createLogger":this.createLogger(t.URI.revive(m[0]),m[1]);return;case"log":return this.log(t.URI.revive(m[0]),m[1]);case"consoleLog":return this.consoleLog(m[0],m[1])}throw new Error(`Call not found: ${d}`)}createLogger(C,d){this.loggers.set(C.toString(),this.loggerService.createLogger(C,d))}consoleLog(C,d){let m=console.log;switch(C){case k.LogLevel.Error:m=console.error;break;case k.LogLevel.Warning:m=console.warn;break;case k.LogLevel.Info:m=console.info;break}m.call(console,...d)}log(C,d){const m=this.loggers.get(C.toString());if(!m)throw new Error("Create the logger before logging");for(const[h,w]of d)(0,k.log)(m,h,w)}}e.LoggerChannel=P;class p extends k.AbstractLoggerService{constructor(C,d,m){super(C,d),this.channel=m}createConsoleMainLogger(){return new k.AdapterLogger({log:(C,d)=>{this.channel.call("consoleLog",[C,d])}})}doCreateLogger(C,d,m){return new S(this.channel,C,d,m)}}e.LoggerChannelClient=p;class S extends k.AbstractMessageLogger{constructor(C,d,m,h){super(h?.always),this.channel=C,this.file=d,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.channel.call("createLogger",[d,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(C,d){const m=[[C,d]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(C){this.channel.call("log",[this.file,C])}}class b extends k.LogService{constructor(C,d){super(d),this.parent=C,this._register(C.onDidChangeLogLevel(m=>d.setLevel(m)))}setLevel(C){super.setLevel(C),this.parent.setLevel(C)}}e.FollowerLogService=b}),define(ee[208],te([0,1,15,6]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(k||(k={}));async function R(S,b,I,C,d){try{const m=await new Promise((w,u)=>{z(["spdlog"],w,u)});m.setFlushOn(t.LogLevel.Trace);const h=await m.createAsyncRotatingLogger(S,b,I,C);return d?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(m){console.error(m)}return null}function D(S,b,I){switch(b){case t.LogLevel.Trace:S.trace(I);break;case t.LogLevel.Debug:S.debug(I);break;case t.LogLevel.Info:S.info(I);break;case t.LogLevel.Warning:S.warn(I);break;case t.LogLevel.Error:S.error(I);break;default:throw new Error("Invalid log level")}}function P(S,b){switch(b){case t.LogLevel.Trace:S.setLevel(k.Trace);break;case t.LogLevel.Debug:S.setLevel(k.Debug);break;case t.LogLevel.Info:S.setLevel(k.Info);break;case t.LogLevel.Warning:S.setLevel(k.Warning);break;case t.LogLevel.Error:S.setLevel(k.Error);break;case t.LogLevel.Off:S.setLevel(k.Off);break;default:throw new Error("Invalid log level")}}class p extends t.AbstractMessageLogger{constructor(b,I,C,d,m){super(),this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(b,I,C,d),this._register(this.onDidChangeLogLevel(h=>{this._logger&&P(this._logger,h)}))}async _createSpdLogLogger(b,I,C,d){const m=C?6:1,h=30/m*E.ByteSize.MB,w=await R(b,I,h,m,d);if(w){this._logger=w,P(this._logger,this.getLevel());for(const{level:u,message:v}of this.buffer)D(this._logger,u,v);this.buffer=[]}}log(b,I){this._logger?D(this._logger,b,I):this.getLevel()<=b&&this.buffer.push({level:b,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=p}),define(ee[209],te([0,1,29,6,208]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let R=class extends t.AbstractLoggerService{constructor(P){super(P.getLevel(),P.onDidChangeLogLevel)}doCreateLogger(P,p,S){return new k.SpdLogLogger(S?.name||(0,E.generateUuid)(),P.fsPath,!S?.donotRotate,!!S?.donotUseFormatters,p)}};R=we([ie(0,t.ILogService)],R),e.LoggerService=R}),define(ee[210],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(D){return!E(D)&&!t(D)&&!k(D)}e.isMenubarMenuItemAction=R}),define(ee[36],te([0,1,3,66,2,5]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(S){const b=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...S,...this.policyDefinitions},b!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(S),t.Iterable.reduce(this.policies.entries(),(I,[C,d])=>({...I,[C]:d}),{})}getPolicyValue(S){return this.policies.get(S)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(S,[b,I])=>({...S,[b]:{definition:I,value:this.policies.get(b)}}),{})}}e.AbstractPolicyService=D;class P{constructor(){this.onDidChange=E.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ee[211],te([0,1,8,3,66,12,15,6,36]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function S(I,C){const d=[];for(const m of k.Iterable.concat(I.keys(),C.keys()))I.get(m)!==C.get(m)&&d.push(m);return d}let b=class extends p.AbstractPolicyService{constructor(C,d,m){super(),this.file=C,this.fileService=d,this.logService=m,this.throttledDelayer=this._register(new E.ThrottledDelayer(500));const h=t.Event.filter(d.onDidFilesChange,w=>w.affects(C));this._register(d.watch(C)),this._register(h(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(C){await this.refresh()}async read(){const C=new Map;try{const d=await this.fileService.readFile(this.file),m=JSON.parse(d.value.toString());if(!(0,R.isObject)(m))throw new Error("Policy file isn't a JSON object");for(const h of Object.keys(m))this.policyDefinitions[h]&&C.set(h,m[h])}catch(d){d.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",d)}return C}async refresh(){const C=await this.read(),d=S(this.policies,C);this.policies=C,d.length>0&&this._onDidChange.fire(d)}};b=we([ie(1,D.IFileService),ie(2,P.ILogService)],b),e.FilePolicyService=b}),define(ee[212],te([0,1,3,2,36]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(p){this.service=p,this.disposables=new t.DisposableStore}listen(p,S){switch(S){case"onDidChange":return E.Event.map(this.service.onDidChange,b=>b.reduce((I,C)=>({...I,[C]:this.service.getPolicyValue(C)??null}),{}),this.disposables)}throw new Error(`Event not found: ${S}`)}call(p,S,b){switch(S){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(b)}throw new Error(`Call not found: ${S}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends k.AbstractPolicyService{constructor(p,S){super(),this.channel=S;for(const b in p){const{definition:I,value:C}=p[b];this.policyDefinitions[b]=I,C!==void 0&&this.policies.set(b,C)}this.channel.listen("onDidChange")(b=>{for(const I in b){const C=b[I];C===null?this.policies.delete(I):this.policies.set(I,C)}this._onDidChange.fire(Object.keys(b))})}async initializePolicies(p){const S=await this.channel.call("registerPolicyDefinitions",p);for(const b in S)this.policies.set(b,S[b])}}e.PolicyChannelClient=D}),define(ee[54],te([0,1,14,4,32,19]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const P=t.globals.vscode.context.configuration();if(P)D=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof z?.__$__nodeRequire=="function"){const P=(0,R.dirname)(E.FileAccess.asFileUri("",z));if(D=z.__$__nodeRequire((0,R.joinPath)(P,"product.json").fsPath),k.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const p=z.__$__nodeRequire((0,R.joinPath)(P,"package.json").fsPath);Object.assign(D,{version:p.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(ee[20],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[213],te([0,1,77,6,20]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(P,p){this.productService=P,this.logService=p,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(P,p){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const S=/^(.*)#([^#]+)$/.exec(p);if(!S)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",p),!1;const[,b,I]=S;let C=this.trustedExtensionUrlPublicKeys.get(P);if(!C){if(C=this.productService.trustedExtensionUrlPublicKeys[P],!C||C.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.trustedExtensionUrlPublicKeys.set(P,[...C])}const d=Buffer.from(decodeURIComponent(I),"base64");if(d.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",p),!1;const m=d.slice(0,6),h=d.readUIntBE(0,6),w=Date.now()-h;if(w<0||w>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",p),!1;const u=d.slice(6),v=E.createVerify("SHA256");v.write(m),v.write(Buffer.from(b)),v.end();for(let g=0;g<C.length;g++){let f=C[g];if(f!==null){if(typeof f=="string")try{f=E.createPublicKey({key:Buffer.from(f,"base64"),format:"der",type:"spki"}),C[g]=f}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${g+1} for ${P}:`,c),C[g]=null;continue}if(v.verify(f,u))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",p),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",p),!1}};R=we([ie(0,k.IProductService),ie(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(ee[214],te([0,1,8,6]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let k=class{constructor(D,P,p){this._window=D,this._sessionId=P,this._logService=p}async inspect(D){await this._connect();const P=this._window.webContents.debugger;await P.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,E.timeout)(D);const p=await P.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),p.profile}async _connect(){const D=this._window.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async _disconnect(){const D=this._window.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};k=we([ie(2,t.ILogService)],k),e.WindowProfiler=k}),define(ee[61],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(ee[46],te([0,1,121,12]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(D,P){E.ok(t.isString(D)),E.ok(t.isObject(P)),E.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,P)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new k}),define(ee[215],te([0,1,3,46]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this._onDidChangeSchema=new E.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,S){this.schemasById[k(p)]=S,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;t.Registry.add(e.Extensions.JSONContribution,D)}),define(ee[62],te([0,1,24,3,12,148,18,215,46]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=p.Registry.as(P.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const i=this.doRegisterConfigurations(n,r);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const r=this.doDeregisterConfigurations(n);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:n,remove:r}){const i=[];i.push(...this.doDeregisterConfigurations(r)),i.push(...this.doRegisterConfigurations(n,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,E.distinct)(i)})}registerDefaultConfigurations(n){const r=[],i=[];for(const{overrides:o,source:s}of n)for(const l in o)if(r.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const a=this.configurationDefaultsOverrides.get(l),y=a?.valuesSources??new Map;if(s)for(const Y of Object.keys(o[l]))y.set(Y,s);const M={...a?.value||{},...o[l]};this.configurationDefaultsOverrides.set(l,{source:s,value:M,valuesSources:y});const T=(0,D.getLanguageTagSettingPlainKey)(l),U={type:"object",default:M,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:k.isString(s)?void 0:s,defaultValueSource:s};i.push(...h(l)),this.configurationProperties[l]=U,this.defaultLanguageConfigurationOverridesNode.properties[l]=U}else{this.configurationDefaultsOverrides.set(l,{value:o[l],source:s});const a=this.configurationProperties[l];a&&(this.updatePropertyDefaultValue(l,a),this.updateSchema(l,a))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const r=[];for(const{overrides:i,source:o}of n)for(const s in i){const l=this.configurationDefaultsOverrides.get(s),a=k.isString(o)?o:o?.id,y=k.isString(l?.source)?l?.source:l?.source?.id;if(a===y)if(r.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const M=this.configurationProperties[s];M&&(this.updatePropertyDefaultValue(s,M),this.updateSchema(s,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const r of n)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,r){const i=[];return n.forEach(o=>{i.push(...this.validateAndRegisterProperties(o,r,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),i}doDeregisterConfigurations(n){const r=[],i=o=>{if(o.properties)for(const s in o.properties){r.push(s);const l=this.configurationProperties[s];l?.policy?.name&&this.policyConfigurations.delete(l.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,o.properties[s])}o.allOf?.forEach(s=>i(s))};for(const o of n){i(o);const s=this.configurationContributors.indexOf(o);s!==-1&&this.configurationContributors.splice(s,1)}return r}validateAndRegisterProperties(n,r=!0,i,o,s=3){s=k.isUndefinedOrNull(n.scope)?s:n.scope;const l=[],a=n.properties;if(a)for(const M in a){const T=a[M];if(r&&g(M,T)){delete a[M];continue}if(T.source=i,T.defaultDefaultValue=a[M].default,this.updatePropertyDefaultValue(M,T),e.OVERRIDE_PROPERTY_REGEX.test(M)?T.scope=void 0:(T.scope=k.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=k.isUndefinedOrNull(T.restricted)?!!o?.includes(M):T.restricted),a[M].hasOwnProperty("included")&&!a[M].included){this.excludedConfigurationProperties[M]=a[M],delete a[M];continue}else this.configurationProperties[M]=a[M],a[M].policy?.name&&this.policyConfigurations.set(a[M].policy.name,M);!a[M].deprecationMessage&&a[M].markdownDeprecationMessage&&(a[M].deprecationMessage=a[M].markdownDeprecationMessage),l.push(M)}const y=n.allOf;if(y)for(const M of y)l.push(...this.validateAndRegisterProperties(M,r,i,o,s));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const r=i=>{const o=i.properties;if(o)for(const l in o)this.updateSchema(l,o[l]);i.allOf?.forEach(r)};r(n)}updateSchema(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.resourceLanguageSettingsSchema.properties[n]=r;break}}removeFromSchema(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const r=`[${n}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,r){const i=this.configurationDefaultsOverrides.get(n);let o=i?.value,s=i?.source;k.isUndefined(o)&&(o=r.defaultDefaultValue,s=void 0),k.isUndefined(o)&&(o=u(r.type)),r.default=o,r.defaultValueSource=s}}const d="\\[([^\\]]+)\\]",m=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(c){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let r=m.exec(c);for(;r?.length;){const i=r[1].trim();i&&n.push(i),r=m.exec(c)}}return(0,E.distinct)(n)}e.overrideIdentifiersFromKey=h;function w(c){return c.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=w;function u(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const v=new C;p.Registry.add(e.Extensions.Configuration,v);function g(c,n){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?R.localize(7,null,c):v.getConfigurationProperties()[c]!==void 0?R.localize(8,null,c):n.policy?.name&&v.getPolicyConfigurations().get(n.policy?.name)!==void 0?R.localize(9,null,c,n.policy?.name,v.getPolicyConfigurations().get(n.policy?.name)):null:R.localize(6,null)}e.validateProperty=g;function f(){const c=[],n=v.getConfigurationProperties();for(const r of Object.keys(n))c.push([r,n[r].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=f}),define(ee[108],te([0,1,24,3,42,2,38,50,12,7,18,62,46]),function(z,e,E,t,k,R,D,P,p,S,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class d{constructor(r={},i=[],o=[],s){this._contents=r,this._keys=i,this._overrides=o,this.raw=s,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof d)return i;const o=new m("");return o.parseRaw(i),o.configurationModel});this._rawConfiguration=r.reduce((i,o)=>o===i?o:i.merge(o),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,b.getConfigurationValue)(this.contents,r):this.contents}inspect(r,i){const o=this.rawConfiguration.getValue(r),s=i?this.rawConfiguration.getOverrideValue(r,i):void 0,l=i?this.rawConfiguration.override(i).getValue(r):o;return{value:o,override:s,merged:l}}getOverrideValue(r,i){const o=this.getContentsForOverrideIdentifer(i);return o?r?(0,b.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const o of this.overrides)o.identifiers.includes(r)&&i.push(...o.keys);return E.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return E.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=P.deepClone(this.contents),o=P.deepClone(this.overrides),s=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const a of r)if(l.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(i,a.contents);for(const y of a.overrides){const[M]=o.filter(T=>E.equals(T.identifiers,y.identifiers));M?(this.mergeContents(M.contents,y.contents),M.keys.push(...y.keys),M.keys=E.distinct(M.keys)):o.push(P.deepClone(y))}for(const y of a.keys)s.indexOf(y)===-1&&s.push(y)}return new d(i,s,o,l.every(a=>a instanceof d)?void 0:l)}freeze(){return this.frozen=!0,this}clone(){return new d(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const o={};for(const s of E.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[s];const a=i[s];a&&(typeof l=="object"&&typeof a=="object"?(l=P.deepClone(l),this.mergeContents(l,a)):l=a),o[s]=l}return new d(o,this.keys,this.overrides)}mergeContents(r,i){for(const o of Object.keys(i)){if(o in r&&p.isObject(r[o])&&p.isObject(i[o])){this.mergeContents(r[o],i[o]);continue}r[o]=P.deepClone(i[o])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?P.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,o=null;const s=l=>{l&&(o?this.mergeContents(o,l):o=P.deepClone(l))};for(const l of this.overrides)E.equals(l.identifiers,[r])?i=l.contents:l.identifiers.includes(r)&&s(l.contents);return s(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,b.addToValueTree)(this.contents,r,i,o=>{throw new Error(o)})}removeValue(r){this.removeKey(r)&&(0,b.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let o=0;o<i;o++)r.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,r)}removeKey(r){const i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=d;class m{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!p.isUndefinedOrNull(r)){const o=this.doParseContent(r);this.parseRaw(o,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:o,keys:s,overrides:l,restricted:a,hasExcludedProperties:y}=this.doParseRaw(r,i);this._configurationModel=new d(o,s,l,y?[r]:void 0),this._restrictedConfigurations=a||[]}doParseContent(r){let i={},o=null,s=[];const l=[],a=[];function y(T){Array.isArray(s)?s.push(T):o!==null&&(s[o]=T)}const M={onObjectBegin:()=>{const T={};y(T),l.push(s),s=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const T=[];y(T),l.push(s),s=T,o=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:y,onError:(T,U,Y)=>{a.push({error:T,offset:U,length:Y})}};if(r)try{k.visit(r,M),i=s[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(r,i){const o=C.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),s=this.filter(r,o,!0,i);r=s.raw;const l=(0,b.toValuesTree)(r,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),a=Object.keys(r),y=this.toOverrides(r,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:l,keys:a,overrides:y,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}filter(r,i,o,s){let l=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:l};const a={},y=[];for(const M in r)if(I.OVERRIDE_PROPERTY_REGEX.test(M)&&o){const T=this.filter(r[M],i,!1,s);a[M]=T.raw,l=l||T.hasExcludedProperties,y.push(...T.restricted)}else{const T=i[M],U=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&y.push(M),(U===void 0||s.scopes===void 0||s.scopes.includes(U))&&!(s.skipRestricted&&T?.restricted)?a[M]=r[M]:l=!0}return{raw:a,restricted:y,hasExcludedProperties:l}}toOverrides(r,i){const o=[];for(const s of Object.keys(r))if(I.OVERRIDE_PROPERTY_REGEX.test(s)){const l={};for(const a in r[s])l[a]=r[s][a];o.push({identifiers:(0,I.overrideIdentifiersFromKey)(s),keys:Object.keys(l),contents:(0,b.toValuesTree)(l,i)})}return o}}e.ConfigurationModelParser=m;class h extends R.Disposable{constructor(r,i,o,s){super(),this.userSettingsResource=r,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&o.isEqual(l.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class w{constructor(r,i,o,s,l,a,y,M,T,U,Y,G,V){this.key=r,this.overrides=i,this.value=o,this.overrideIdentifiers=s,this.defaultConfiguration=l,this.policyConfiguration=a,this.applicationConfiguration=y,this.userConfiguration=M,this.localUserConfiguration=T,this.remoteUserConfiguration=U,this.workspaceConfiguration=Y,this.folderConfigurationModel=G,this.memoryInspectValue=V}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class u{constructor(r,i,o,s,l=new d,a=new d,y=new D.ResourceMap,M=new d,T=new D.ResourceMap,U=!0){this._defaultConfiguration=r,this._policyConfiguration=i,this._applicationConfiguration=o,this._localUserConfiguration=s,this._remoteUserConfiguration=l,this._workspaceConfiguration=a,this._folderConfigurations=y,this._memoryConfiguration=M,this._memoryConfigurationByResource=T,this._freeze=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(r,i,o){return this.getConsolidatedConfigurationModel(r,i,o).getValue(r)}updateValue(r,i,o={}){let s;o.resource?(s=this._memoryConfigurationByResource.get(o.resource),s||(s=new d,this._memoryConfigurationByResource.set(o.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(r):s.setValue(r,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,o){const s=this.getConsolidatedConfigurationModel(r,i,o),l=E.distinct(s.overrides.map(M=>M.identifiers).flat()).filter(M=>s.getOverrideValue(r,M)!==void 0),a=this.getFolderConfigurationModelForResource(i.resource,o),y=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration;return new w(r,i,s.getValue(r),l.length?l:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),o?this._workspaceConfiguration.freeze():void 0,a?a.freeze():void 0,y.inspect(r,i.overrideIdentifier))}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const o=[];if(!i){const{added:s,updated:l,removed:a}=f(this._defaultConfiguration,r);i=[...s,...l,...a]}for(const s of i)for(const l of(0,I.overrideIdentifiersFromKey)(s)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(l),y=r.getKeysForOverrideIdentifier(l),M=[...y.filter(T=>a.indexOf(T)===-1),...a.filter(T=>y.indexOf(T)===-1),...a.filter(T=>!P.equals(this._defaultConfiguration.override(l).getValue(T),r.override(l).getValue(T)))];o.push([l,M])}return this.updateDefaultConfiguration(r),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:o,removed:s}=f(this._policyConfiguration,r),l=[...i,...o,...s];return l.length&&this.updatePolicyConfiguration(r),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:o,removed:s,overrides:l}=f(this.applicationConfiguration,r),a=[...i,...o,...s];return a.length&&this.updateApplicationConfiguration(r),{keys:a,overrides:l}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:o,removed:s,overrides:l}=f(this.localUserConfiguration,r),a=[...i,...o,...s];return a.length&&this.updateLocalUserConfiguration(r),{keys:a,overrides:l}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:o,removed:s,overrides:l}=f(this.remoteUserConfiguration,r),a=[...i,...o,...s];return a.length&&this.updateRemoteUserConfiguration(r),{keys:a,overrides:l}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:o,removed:s,overrides:l}=f(this.workspaceConfiguration,r),a=[...i,...o,...s];return a.length&&this.updateWorkspaceConfiguration(r),{keys:a,overrides:l}}compareAndUpdateFolderConfiguration(r,i){const o=this.folderConfigurations.get(r),{added:s,updated:l,removed:a,overrides:y}=f(o,i),M=[...s,...l,...a];return(M.length||!o)&&this.updateFolderConfiguration(r,i),{keys:M,overrides:y}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:s,removed:l,overrides:a}=f(i,void 0);return{keys:[...o,...s,...l],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,i,o){let s=this.getConsolidatedConfigurationModelForResource(i,o);return i.overrideIdentifier&&(s=s.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(s=s.merge(this._policyConfiguration)),s}getConsolidatedConfigurationModelForResource({resource:r},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const s=i.getFolder(r);s&&(o=this.getFolderConsolidatedConfiguration(s.uri)||o);const l=this._memoryConfigurationByResource.get(r);l&&(o=o.merge(l))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(r);s?(i=o.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=o}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const o=i.getFolder(r);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:o,overrides:s,keys:l}=this._folderConfigurations.get(i);return r.push([i,{contents:o,overrides:s,keys:l}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),o=this.parseConfigurationModel(r.policy),s=this.parseConfigurationModel(r.application),l=this.parseConfigurationModel(r.user),a=this.parseConfigurationModel(r.workspace),y=r.folders.reduce((M,T)=>(M.set(S.URI.revive(T[0]),this.parseConfigurationModel(T[1])),M),new D.ResourceMap);return new u(i,o,s,l,new d,a,y,new d,new D.ResourceMap,!1)}static parseConfigurationModel(r){return new d(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=u;function v(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,i=new Map;for(const s of n)s.keys.forEach(l=>r.add(l)),s.overrides.forEach(([l,a])=>{const y=(0,D.getOrSet)(i,l,new Set);a.forEach(M=>y.add(M))});const o=[];return i.forEach((s,l)=>o.push([l,[...s.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=v;class g{constructor(r,i,o,s){this.change=r,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;r.keys.forEach(y=>l.add(y)),r.overrides.forEach(([,y])=>y.forEach(M=>l.add(M))),this.affectedKeys=[...l.values()];const a=new d;this.affectedKeys.forEach(y=>a.setValue(y,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!P.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let o=(0,b.toValuesTree)({[i]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(r=r[s],!r)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=g;function f(n,r){const{added:i,removed:o,updated:s}=c(r?.rawConfiguration,n?.rawConfiguration),l=[],a=n?.getAllOverrideIdentifiers()||[],y=r?.getAllOverrideIdentifiers()||[];if(r){const M=y.filter(T=>!a.includes(T));for(const T of M)l.push([T,r.getKeysForOverrideIdentifier(T)])}if(n){const M=a.filter(T=>!y.includes(T));for(const T of M)l.push([T,n.getKeysForOverrideIdentifier(T)])}if(r&&n){for(const M of a)if(y.includes(M)){const T=c({contents:n.getOverrideValue(void 0,M)||{},keys:n.getKeysForOverrideIdentifier(M)},{contents:r.getOverrideValue(void 0,M)||{},keys:r.getKeysForOverrideIdentifier(M)});l.push([M,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:o,updated:s,overrides:l}}function c(n,r){const i=n?r?n.keys.filter(l=>r.keys.indexOf(l)===-1):[...n.keys]:[],o=r?n?r.keys.filter(l=>n.keys.indexOf(l)===-1):[...r.keys]:[],s=[];if(n&&r){for(const l of r.keys)if(n.keys.indexOf(l)!==-1){const a=(0,b.getConfigurationValue)(r.contents,l),y=(0,b.getConfigurationValue)(n.contents,l);P.equals(a,y)||s.push(l)}}return{added:i,removed:o,updated:s}}}),define(ee[216],te([0,1,24,3,2,50,12,18,108,62,6,36,46]),function(z,e,E,t,k,R,D,P,p,S,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class d extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new m(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(C.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:g})=>this.onDidUpdateConfiguration(v,g))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(v,g){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:v})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=d;class m extends p.ConfigurationModel{constructor(v={}){const g=C.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(g),c=Object.create(null),n=[];for(const r in g){const i=v[r],o=i!==void 0?i:g[r].default;(0,P.addToValueTree)(c,r,o,s=>console.error(`Conflict in default settings: ${s}`))}for(const r of Object.keys(c))S.OVERRIDE_PROPERTY_REGEX.test(r)&&n.push({identifiers:(0,S.overrideIdentifiersFromKey)(r),keys:Object.keys(c[r]),contents:(0,P.toValuesTree)(c[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(c,f,n)}}e.DefaultConfigurationModel=m;class h{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new p.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=h;let w=class extends k.Disposable{get configurationModel(){return this._configurationModel}constructor(v,g,f){super(),this.defaultConfiguration=v,this.policyService=g,this.logService=f,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new p.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(v=>this.onDidChangePolicies(v))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:v})=>this.update(await this.registerPolicyDefinitions(v),!0))),this._configurationModel}async registerPolicyDefinitions(v){const g={},f=[],c=C.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(const n of v){const r=c[n];if(!r){f.push(n);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}f.push(n),g[r.policy.name]={type:r.type}}}return(0,D.isEmptyObject)(g)||await this.policyService.registerPolicyDefinitions(g),f}onDidChangePolicies(v){const g=C.Registry.as(S.Extensions.Configuration).getPolicyConfigurations(),f=(0,E.coalesce)(v.map(c=>g.get(c)));this.update(f,!0)}update(v,g){const f=C.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),c=[],n=this._configurationModel.isEmpty();for(const r of v){const i=f[r]?.policy?.name;if(i){const o=this.policyService.getPolicyValue(i);(n?o!==void 0:!(0,R.equals)(this._configurationModel.getValue(r),o))&&c.push([r,o])}else this._configurationModel.getValue(r)!==void 0&&c.push([r,void 0])}if(c.length){const r=this._configurationModel;this._configurationModel=new p.ConfigurationModel;for(const i of r.keys)this._configurationModel.setValue(i,r.getValue(i));for(const[i,o]of c)o===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,o);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};w=we([ie(1,I.IPolicyService),ie(2,b.ILogService)],w),e.PolicyConfiguration=w}),define(ee[217],te([0,1,8,3,2,19,18,108,216,36]),function(z,e,E,t,k,R,D,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends k.Disposable{constructor(C,d,m,h){super(),this.settingsResource=C,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new p.DefaultConfiguration),this.policyConfiguration=m instanceof S.NullPolicyService?new p.NullPolicyConfiguration:this._register(new p.PolicyConfiguration(this.defaultConfiguration,m,h)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,d)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:w,properties:u})=>this.onDidDefaultConfigurationChange(w,u))),this._register(this.policyConfiguration.onDidChangeConfiguration(w=>this.onDidPolicyConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[C,d,m]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(C,d,new P.ConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(C,d){const m=typeof C=="string"?C:void 0,h=(0,D.isConfigurationOverrides)(C)?C:(0,D.isConfigurationOverrides)(d)?d:{};return this.configuration.getValue(m,h,void 0)}updateValue(C,d,m,h){return Promise.reject(new Error("not supported"))}inspect(C){return this.configuration.inspect(C,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const C=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(C)}onDidChangeUserConfiguration(C){const d=this.configuration.toData(),m=this.configuration.compareAndUpdateLocalUserConfiguration(C);this.trigger(m,d,2)}onDidDefaultConfigurationChange(C,d){const m=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(C,d);this.trigger(h,m,7)}onDidPolicyConfigurationChange(C){const d=this.configuration.toData(),m=this.configuration.compareAndUpdatePolicyConfiguration(C);this.trigger(m,d,7)}trigger(C,d,m){const h=new P.ConfigurationChangeEvent(C,{data:d},this.configuration);h.source=m,h.sourceConfig=this.getTargetConfiguration(m),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(C){switch(C){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(ee[218],te([0,1,16,5]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends E.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof R&&P._code===k.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof R&&P._code===k.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof R&&P._code===k.NoResolverFound}static isHandled(P){return P instanceof R&&P.isHandled}constructor(P,p=k.Unknown,S){super(P),this._message=P,this._code=p,this._detail=S,this.isHandled=p===k.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R}),define(ee[63],te([0,1,14]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(S){return S.scheme===E.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=t;function k(S){if(!S)return;const b=S.indexOf("+");return b<0?S:S.substr(0,b)}e.getRemoteName=k;function R(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(S){const{host:b,port:I}=p(S);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:I}}e.parseAuthorityWithPort=D;function P(S,b){let{host:I,port:C}=p(S);return typeof C>"u"&&(C=b),{host:I,port:C}}e.parseAuthorityWithOptionalPort=P;function p(S){const b=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const I=S.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const C=S.match(/(.*):(\d+)$/);return C?{host:C[1],port:parseInt(C[2],10)}:{host:S,port:void 0}}}),define(ee[109],te([0,1,25,5,63]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=R;function D(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var p;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(p=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,w){if(typeof h>"u"||h===null)return typeof w>"u"||w===null;if(typeof w>"u"||w===null)return!1;if(typeof h=="string"||typeof w=="string"){const u=typeof h=="string"?h:h.value,v=typeof w=="string"?w:w.value;return E.equalsIgnoreCase(u,v)}return h._lower===w._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.ExtensionIdentifier=S;function b(m){return I(m)}e.isApplicationScopedExtension=b;function I(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function C(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=C;function d(m,h){if(h){const w=`onResolveRemoteAuthority:${(0,k.getRemoteName)(h)}`;return m.activationEvents?.indexOf(w)!==-1}return!1}e.isResolverExtension=d,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[110],te([0,1,25,190,109,4,7,16,32]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function S(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,E.compareIgnoreCase)(r.id,i.id)===0}e.areSameExtensions=S;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class I{static create(i){const o=i.manifest?i.manifest.version:i.version,s=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new I(i.identifier,o,s)}static parse(i){const o=b.exec(i);return o&&o[1]&&o[2]?new I({id:o[1]},o[2],o[4]||void 0):null}constructor(i,o,s="undefined"){this.version=o,this.targetPlatform=s,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof I?S(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=I;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(r){const i=C.exec(r);return i&&i[1]?[h(i[1]),i[2]]:[h(r),void 0]}e.getIdAndVersion=d;function m(r,i){return`${r}.${i}`}e.getExtensionId=m;function h(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function w(r,i){return h(m(r,i))}e.getGalleryExtensionId=w;function u(r,i){const o=[],s=l=>{for(const a of o)if(a.some(y=>S(i(y),i(l))))return a;return null};for(const l of r){const a=s(l);a?a.push(l):o.push([l])}return o}e.groupByExtension=u;function v(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function g(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(r,i){const o=[],s=i.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const l=s.shift();if(l&&o.every(a=>!S(a.identifier,{id:l}))){const a=r.filter(y=>S(y.identifier,{id:l}));a.length===1&&(o.push(a[0]),s.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=f;async function c(r,i){if(!R.isLinux)return!1;let o;try{o=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(l))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function n(r,i){const o=await c(r,i),s=(0,t.getTargetPlatform)(o?"alpine":R.platform,p.arch);return i.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=n}),define(ee[87],te([0,1,8,17,2,3,38,7,110,15,5,6]),function(z,e,E,t,k,R,D,P,p,S,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let C=class extends k.Disposable{constructor(m,h){super(),this.fileService=m,this.logService=h,this._onAddExtensions=this._register(new R.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new R.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new R.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new R.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new D.ResourceMap}scanProfileExtensions(m){return this.withProfileExtensions(m)}async addExtensionsToProfile(m,h){this._onAddExtensions.fire({extensions:m.map(w=>w[0]),profileLocation:h});try{const u=(await this.withProfileExtensions(h,v=>(v=v.filter(g=>m.some(([f])=>!(0,p.areSameExtensions)(g.identifier,f.identifier))),v.push(...m.map(([g,f])=>({identifier:g.identifier,version:g.manifest.version,location:g.location,metadata:f}))),v))).filter(v=>m.some(([g])=>(0,p.areSameExtensions)(v.identifier,g.identifier)));return this._onDidAddExtensions.fire({extensions:m.map(v=>v[0]),profileLocation:h}),u}catch(w){throw this._onDidAddExtensions.fire({extensions:m.map(u=>u[0]),error:w,profileLocation:h}),w}}async removeExtensionFromProfile(m,h){this._onRemoveExtensions.fire({extensions:[m],profileLocation:h});try{await this.withProfileExtensions(h,w=>w.filter(u=>!(0,p.areSameExtensions)(u.identifier,m.identifier))),this._onDidRemoveExtensions.fire({extensions:[m],profileLocation:h})}catch(w){throw this._onDidRemoveExtensions.fire({extensions:[m],error:w,profileLocation:h}),w}}async withProfileExtensions(m,h){return this.getResourceAccessQueue(m).queue(async()=>{let w=[];try{const u=await this.fileService.readFile(m),v=JSON.parse(u.value.toString());for(const g of v){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}w.push({identifier:g.identifier,location:P.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(u){u.fileOperationResult!==1&&this.logService.error(u)}if(h){w=h(w);const u=w.map(v=>({identifier:v.identifier,version:v.version,location:v.location.toJSON(),metadata:v.metadata}));await this.fileService.writeFile(m,t.VSBuffer.fromString(JSON.stringify(u)))}return w})}getResourceAccessQueue(m){let h=this.resourcesAccessQueueMap.get(m);return h||(h=new E.Queue,this.resourcesAccessQueueMap.set(m,h)),h}};C=we([ie(0,S.IFileService),ie(1,I.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(ee[219],te([0,1,8,17,22,16,3,2,29,101,218,63]),function(z,e,E,t,k,R,D,P,p,S,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var d;(function(N){N[N.Management=1]="Management",N[N.ExtensionHost=2]="ExtensionHost",N[N.Tunnel=3]="Tunnel"})(d=e.ConnectionType||(e.ConnectionType={}));function m(N){switch(N){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(N){const j=new k.CancellationTokenSource;return setTimeout(()=>j.cancel(),N),j.token}function w(N,j){if(N.isCancellationRequested||j.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return N.onCancellationRequested(()=>L.cancel()),j.onCancellationRequested(()=>L.cancel()),L.token}class u{get didTimeout(){return this._state==="timedout"}constructor(j){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((L,W)=>{this._resolvePromise=L,this._rejectPromise=W}),j.isCancellationRequested?this._timeout():this._disposables.add(j.onCancellationRequested(()=>this._timeout()))}registerDisposable(j){this._state==="pending"?this._disposables.add(j):j.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(j))}reject(j){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(j))}}function v(N,j){const L=new u(j);return L.registerDisposable(N.onControlMessage(W=>{const $=JSON.parse(W.toString()),q=F($);q?L.reject(q):L.resolve($)})),L.promise}function g(N,j,L,W,$,q,X,re){const B=new u(re);return j.connect(L,W,$,q,X,(x,Z)=>{B.didTimeout?(x&&N.error(x),Z?.dispose()):x||!Z?B.reject(x):B.resolve(Z)}),B.promise}function f(N,j){const L=new u(j);return N.then(W=>{L.didTimeout||L.resolve(W)},W=>{L.didTimeout||L.reject(W)}),L.promise}async function c(N,j,L,W){const $=_(N,j);N.logService.trace(`${$} 1/6. invoking socketFactory.connect().`);let q;try{q=await g(N.logService,N.socketFactory,N.host,N.port,(0,I.getRemoteServerRootPath)(N),`reconnectionToken=${N.reconnectionToken}&reconnection=${N.reconnectionProtocol?"true":"false"}`,`renderer-${m(j)}-${N.reconnectionToken}`,W)}catch(Z){throw N.logService.error(`${$} socketFactory.connect() failed or timed out. Error:`),N.logService.error(Z),Z}N.logService.trace(`${$} 2/6. socketFactory.connect() was successful.`);let X,re;N.reconnectionProtocol?(N.reconnectionProtocol.beginAcceptReconnection(q,null),X=N.reconnectionProtocol,re=!1):(X=new S.PersistentProtocol(q,null),re=!0),N.logService.trace(`${$} 3/6. sending AuthRequest control message.`);const B=await f(N.signService.createNewMessage((0,p.generateUuid)()),W),x={type:"auth",auth:N.connectionToken||"00000000000000000000",data:B.data};X.sendControl(t.VSBuffer.fromString(JSON.stringify(x)));try{const Z=await v(X,w(W,h(1e4)));if(Z.type!=="sign"||typeof Z.data!="string"){const Te=new Error("Unexpected handshake message");throw Te.code="VSCODE_CONNECTION_ERROR",Te}if(N.logService.trace(`${$} 4/6. received SignRequest control message.`),!await f(N.signService.validate(B,Z.signedData),W)){const Te=new Error("Refused to connect to unsupported server");throw Te.code="VSCODE_CONNECTION_ERROR",Te}const ge=await f(N.signService.sign(Z.data),W),De={type:"connectionType",commit:N.commit,signedData:ge,desiredConnectionType:j};return L&&(De.args=L),N.logService.trace(`${$} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(t.VSBuffer.fromString(JSON.stringify(De))),{protocol:X,ownsProtocol:re}}catch(Z){throw Z&&Z.code==="ETIMEDOUT"&&(N.logService.error(`${$} the handshake timed out. Error:`),N.logService.error(Z)),Z&&Z.code==="VSCODE_CONNECTION_ERROR"&&(N.logService.error(`${$} received error control message when negotiating connection. Error:`),N.logService.error(Z)),re&&H(X),Z}}async function n(N,j,L,W){const $=Date.now(),q=_(N,j),{protocol:X,ownsProtocol:re}=await c(N,j,L,W),B=new u(W);return B.registerDisposable(X.onControlMessage(x=>{const Z=JSON.parse(x.toString()),ce=F(Z);ce?(N.logService.error(`${q} received error control message when negotiating connection. Error:`),N.logService.error(ce),re&&H(X),B.reject(ce)):(N.reconnectionProtocol?.endAcceptReconnection(),N.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${ne($)}!`),B.resolve({protocol:X,firstMessage:Z}))})),B.promise}async function r(N,j){const{protocol:L}=await n(N,1,void 0,j);return{protocol:L}}async function i(N,j,L){const{protocol:W,firstMessage:$}=await n(N,2,j,L),q=$&&$.debugPort;return{protocol:W,debugPort:q}}async function o(N,j,L){const W=Date.now(),$=_(N,3),{protocol:q}=await c(N,3,j,L);return N.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${ne(W)}!`),q}async function s(N,j,L){const{host:W,port:$,connectionToken:q}=await N.addressProvider.getAddress();return{commit:N.commit,quality:N.quality,host:W,port:$,connectionToken:q,reconnectionToken:j,reconnectionProtocol:L,socketFactory:N.socketFactory,signService:N.signService,logService:N.logService}}async function l(N,j,L){return y(N,async W=>{const{protocol:$}=await r(W,k.CancellationToken.None);return new fe(N,j,L,W.reconnectionToken,$)})}e.connectRemoteAgentManagement=l;async function a(N,j){return y(N,async L=>{const{protocol:W,debugPort:$}=await i(L,j,k.CancellationToken.None);return new K(N,j,L.reconnectionToken,W,$)})}e.connectRemoteAgentExtensionHost=a;async function y(N,j){for(let W=1;;W++)try{const $=(0,p.generateUuid)(),q=await s(N,$,null);return await j(q)}catch($){if(W<5)N.logService.error(`[remote-connection][attempt ${W}] An error occurred in initial connection! Will retry... Error:`),N.logService.error($);else throw N.logService.error(`[remote-connection][attempt ${W}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),N.logService.error($),se.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled($)),$}}async function M(N,j,L){const W=await s(N,(0,p.generateUuid)(),null);return await o(W,{host:j,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function T(N){return(0,E.createCancelablePromise)(j=>new Promise((L,W)=>{const $=setTimeout(L,N*1e3);j.onCancellationRequested(()=>{clearTimeout($),L()})}))}var U;(function(N){N[N.ConnectionLost=0]="ConnectionLost",N[N.ReconnectionWait=1]="ReconnectionWait",N[N.ReconnectionRunning=2]="ReconnectionRunning",N[N.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",N[N.ConnectionGain=4]="ConnectionGain"})(U=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class Y{constructor(j,L){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=Y;class G{constructor(j,L,W,$){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.durationSeconds=W,this.cancellableTimer=$,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=G;class V{constructor(j,L,W){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=V;class oe{constructor(j,L,W){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=W,this.type=4}}e.ConnectionGainEvent=oe;class ae{constructor(j,L,W,$){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=W,this.handled=$,this.type=3}}e.ReconnectionPermanentFailureEvent=ae;class se extends P.Disposable{static triggerPermanentFailure(j,L,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=j,this._permanentFailureAttempt=L,this._permanentFailureHandled=W,this._instances.forEach($=>$._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(j=>j._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(j=>j._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}constructor(j,L,W,$,q){super(),this._connectionType=j,this._options=L,this.reconnectionToken=W,this.protocol=$,this._reconnectionFailureIsFatal=q,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new oe(this.reconnectionToken,0,0)),this._register($.onSocketClose(X=>{const re=O(this._connectionType,this.reconnectionToken,!0);X?X.type===0?(this._options.logService.info(`${re} received socket close event (hadError: ${X.hadError}).`),X.error&&this._options.logService.error(X.error)):(this._options.logService.info(`${re} received socket close event (wasClean: ${X.wasClean}, code: ${X.code}, reason: ${X.reason}).`),X.event&&this._options.logService.error(X.event)):this._options.logService.info(`${re} received socket close event.`),this._beginReconnecting()})),this._register($.onSocketTimeout(X=>{const re=O(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${X.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${X.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${X.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,P.toDisposable)(()=>{const X=se._instances.indexOf(this);X>=0&&se._instances.splice(X,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const j=O(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const $=W<L.length?L[W]:L[L.length-1];try{if($>0){const X=T($);this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$,X)),this._options.logService.info(`${j} waiting for ${$} seconds before reconnecting...`);try{await X}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this._options.logService.info(`${j} resolving connection...`);const q=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${j} connecting to ${q.host}:${q.port}...`),await this._reconnect(q,h(C)),this._options.logService.info(`${j} reconnected!`),this._onDidStateChange.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this._options.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(q)){this._options.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this._options.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((0,R.isCancellationError)(q)){this._options.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if(q instanceof b.RemoteAuthorityResolverError){this._options.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,b.RemoteAuthorityResolverError.isHandled(q));break}this._options.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(j,L,W){this._reconnectionFailureIsFatal?se.triggerPermanentFailure(j,L,W):this._gotoPermanentFailure(j,L,W)}_gotoPermanentFailure(j,L,W){this._onDidStateChange.fire(new ae(this.reconnectionToken,j,L,W)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class fe extends se{constructor(j,L,W,$,q){super(1,j,$,q,!0),this.client=this._register(new S.Client(q,{remoteAuthority:L,clientId:W},j.ipcLogger))}async _reconnect(j,L){await r(j,L)}}e.ManagementPersistentConnection=fe;class K extends se{constructor(j,L,W,$,q){super(2,j,W,$,!1),this._startArguments=L,this.debugPort=q}async _reconnect(j,L){await i(j,this._startArguments,L)}}e.ExtensionHostPersistentConnection=K;function H(N){try{N.acceptDisconnect();const j=N.getSocket();N.dispose(),j.dispose()}catch(j){(0,R.onUnexpectedError)(j)}}function F(N){if(N&&N.type==="error"){const j=new Error(`Connection error: ${N.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function A(N,j){for(;N.length<j;)N+=" ";return N}function O(N,j,L){return`[remote-connection][${A(m(N),13)}][${j.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function _(N,j){return`${O(j,N.reconnectionToken,!!N.reconnectionProtocol)}[${N.host}:${N.port}]`}function ne(N){return`${Date.now()-N} ms`}}),define(ee[220],te([0,1,78,83]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,D,P,p,S){const b=C=>S(C,void 0),I=E.createConnection({host:k,port:R},()=>{I.removeListener("error",b);const C=Buffer.alloc(16);for(let w=0;w<16;w++)C[w]=Math.round(Math.random()*256);const d=C.toString("base64"),m=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${D}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];I.write(m.join(`\r
`)+`\r
\r
`);const h=w=>{w.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",h),S(void 0,new t.NodeSocket(I,p)))};I.on("data",h)});I.setNoDelay(!0),I.once("error",b)}}}),define(ee[221],te([0,1,27,44,39,181]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function P(d=!1){return(D===void 0||d)&&(D=p()),D}e.hasWSLFeatureInstalled=P;async function p(){const d=S();if(d===void 0)return!1;if(d>=22e3){const m=I();if(m)return new Promise(h=>{t.execFile(m,["--status"],w=>h(!w))})}else{const m=C();if(m)try{if((await k.promises.stat(m)).isFile())return!0}catch{}}return!1}function S(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(d)return parseInt(d[3])}function b(d){const m=process.env.SystemRoot;if(m){const h=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(m,h?"Sysnative":"System32",d)}}function I(){return b("wsl.exe")}function C(){return b("lxss\\LxssManager.dll")}}),define(ee[55],te([0,1,17,165,62,5,46]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function P(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=P;function p(h){return h.res.statusCode===204}async function S(h){return p(h)?null:(await(0,E.streamToBuffer)(h.stream)).toString()}e.asText=S;async function b(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);return S(h)}e.asTextOrError=b;async function I(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);if(p(h))return null;const u=(await(0,E.streamToBuffer)(h.stream)).toString();try{return JSON.parse(u)}catch(v){throw v.message+=`:
`+u,v}}e.asJson=I;function C(h){m(h)}e.updateProxyConfigurationsScope=C;let d;function m(h){const w=D.Registry.as(k.Extensions.Configuration),u=d;d={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[d],remove:u?[u]:[]})}m(2)}),define(ee[222],te([0,1,17,22]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(P){this.service=P}listen(P,p){throw new Error("Invalid listen")}call(P,p,S,b=t.CancellationToken.None){switch(p){case"request":return this.service.request(S[0],b).then(async({res:I,stream:C})=>{const d=await(0,E.streamToBuffer)(C);return[{statusCode:I.statusCode,headers:I.headers},d]});case"resolveProxy":return this.service.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(P){this.channel=P}async request(P,p){const[S,b]=await this.channel.call("request",[P],p);return{res:S,stream:(0,E.bufferToStream)(b)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}}e.RequestChannelClient=R}),define(ee[223],te([0,1,224,12]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(D,P){return D.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:D.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function R(D,P,p={}){const S=(0,E.parse)(D),b=p.proxyUrl||k(S,P);if(!b)return null;const I=(0,E.parse)(b);if(!/^https?:$/.test(I.protocol||""))return null;const C={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,t.isBoolean)(p.strictSSL)?p.strictSSL:!0};return S.protocol==="http:"?new(await new Promise((d,m)=>{z(["http-proxy-agent"],d,m)}))(C):new(await new Promise((d,m)=>{z(["https-proxy-agent"],d,m)}))(C)}e.getProxyAgent=R}),define(ee[111],te([0,1,44,9,166,22,43,16,4,29,142,59,8]),function(z,e,E,t,k,R,D,P,p,S,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const d=1e4;let m;async function h(u,v,g){return v["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(g)&&!v["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(g)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=C.Promises.withAsyncBody(async(f,c)=>{const n=new R.CancellationTokenSource,r=setTimeout(()=>{n.dispose(!0),c(new Error((0,k.localize)(0,null)))},d);try{f(await w(u,n.token))}catch(i){!(0,P.isCancellationError)(i)&&!n.token.isCancellationRequested?c(new Error((0,k.localize)(1,null,(0,D.toErrorMessage)(i)))):f({})}finally{clearTimeout(r),n.dispose()}})),m)}e.getResolvedShellEnv=h;async function w(u,v){const g=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",g);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",f);const c=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(c+"(.*)"+c),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",r);const i=await(0,b.getSystemShell)(p.OS,r);return u.trace("getUnixShellEnvironment#shell",i),new Promise((o,s)=>{if(v.isCancellationRequested)return s((0,P.canceled)());const l=(0,t.basename)(i);let a,y;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(a=`& '${process.execPath}' ${M} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,y=["-Login","-Command"]):(a=`'${process.execPath}' ${M} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,l==="tcsh"?y=["-ic"]:y=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),a);const T=(0,E.spawn)(i,[...y,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});v.onCancellationRequested(()=>(T.kill(),s((0,P.canceled)()))),T.on("error",G=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(G)),s(G)});const U=[];T.stdout.on("data",G=>U.push(G));const Y=[];T.stderr.on("data",G=>Y.push(G)),T.on("close",(G,V)=>{const oe=Buffer.concat(U).toString("utf8");u.trace("getUnixShellEnvironment#raw",oe);const ae=Buffer.concat(Y).toString("utf8");if(ae.trim()&&u.trace("getUnixShellEnvironment#stderr",ae),G||V)return s(new Error((0,k.localize)(2,null,G,V)));const se=n.exec(oe),fe=se?se[1]:"{}";try{const K=JSON.parse(fe);g?K.ELECTRON_RUN_AS_NODE=g:delete K.ELECTRON_RUN_AS_NODE,f?K.ELECTRON_NO_ATTACH_CONSOLE=f:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",K),o(K)}catch(K){u.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(K)),s(K)}})})}}),define(ee[88],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[225],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>z(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),D=new R.validator;if(D){const P=String(E._nextId++);return this.validators.set(P,D),{id:P,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const D=this.validators.get(k.id);if(!D)return!1;this.validators.delete(k.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=E,E._nextId=1}),define(ee[37],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,E.createDecorator)("stateMainService")}),define(ee[21],te([0,1,13,40,8,3,2,4,32,12,5,6,37,26]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,b.createDecorator)("lifecycleMainService");var m;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(m=e.ShutdownReason||(e.ShutdownReason={}));var h;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(h=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let w=class Et extends D.Disposable{get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(v,g,f){super(),this.logService=v,this.stateMainService=g,this.environmentMainService=f,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(Et.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(Et.QUIT_AND_RESTART_KEY)}registerListeners(){const v=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),P.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};E.app.addListener("before-quit",v);const g=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!P.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",g),E.app.once("will-quit",f=>{this.trace("Lifecycle#app.on(will-quit)"),f.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),E.app.removeListener("before-quit",v),E.app.removeListener("window-all-closed",g),E.app.quit()})})}fireOnWillShutdown(v){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const g=[];return this._onWillShutdown.fire({reason:v,join(f){g.push(f)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(g)}catch(f){this.logService.error(f)}try{await this.stateMainService.close()}catch(f){this.logService.error(f)}})(),this.pendingWillShutdownPromise}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===v)return;this.trace(`lifecycle (main): phase changed (value: ${v})`),this._phase=v;const g=this.phaseWhen.get(this._phase);g&&(g.open(),this.phaseWhen.delete(this._phase))}async when(v){if(v<=this._phase)return;let g=this.phaseWhen.get(v);g||(g=new k.Barrier,this.phaseWhen.set(v,g)),await g.wait()}registerWindow(v){const g=new D.DisposableStore;this.windowCounter++,g.add(v.onWillLoad(c=>this._onWillLoadWindow.fire({window:v,workspace:c.workspace,reason:c.reason})));const f=(0,S.assertIsDefined)(v.win);f.on("close",c=>{const n=v.id;if(this.windowToCloseRequest.has(n)){this.windowToCloseRequest.delete(n);return}this.trace(`Lifecycle#window.on('close') - window ID ${v.id}`),c.preventDefault(),this.unload(v,1).then(r=>{if(r){this.windowToCloseRequest.delete(n);return}this.windowToCloseRequest.add(n),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${n}`),this._onBeforeCloseWindow.fire(v),v.close()})}),f.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.windowCounter--,g.dispose(),this.windowCounter===0&&(!P.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(v,g){await this.unload(v,3)||v.reload(g)}unload(v,g){const f=this.mapWindowIdToPendingUnload.get(v.id);if(f)return f;const c=this.doUnload(v,g).finally(()=>{this.mapWindowIdToPendingUnload.delete(v.id)});return this.mapWindowIdToPendingUnload.set(v.id,c),c}async doUnload(v,g){if(!v.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${v.id}`);const f=this._quitRequested?2:g,c=await this.onBeforeUnloadWindowInRenderer(v,f);return c?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.handleWindowUnloadVeto(c)):(await this.onWillUnloadWindowInRenderer(v,f),!1)}handleWindowUnloadVeto(v){return v?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(v){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(v),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(v,g){return new Promise(f=>{const c=this.oneTimeListenerTokenGenerator++,n=`vscode:ok${c}`,r=`vscode:cancel${c}`;t.validatedIpcMain.once(n,()=>{f(!1)}),t.validatedIpcMain.once(r,()=>{f(!0)}),v.send("vscode:onBeforeUnload",{okChannel:n,cancelChannel:r,reason:g})})}onWillUnloadWindowInRenderer(v,g){return new Promise(f=>{const n=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(n,()=>f()),v.send("vscode:onWillUnload",{replyChannel:n,reason:g})})}quit(v){return this.trace(`Lifecycle#quit() - begin (willRestart: ${v})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(v&&this.stateMainService.setItem(Et.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(g=>{this.pendingQuitPromiseResolve=g,this.trace("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.pendingQuitPromise)}trace(v){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(v):this.logService.trace(v)}async relaunch(v){this.trace("Lifecycle#relaunch()");const g=process.argv.slice(1);if(v?.addArgs&&g.push(...v.addArgs),v?.removeArgs)for(const n of v.removeArgs){const r=g.indexOf(n);r>=0&&g.splice(r,1)}const f=()=>{try{if(P.isWindows){const n=(0,p.cwd)();n!==process.cwd()&&process.chdir(n)}}catch(n){this.logService.error(n)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:g})};E.app.once("quit",f),await this.quit(!0)&&E.app.removeListener("quit",f)}async kill(v){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const g of E.BrowserWindow.getAllWindows())if(g&&!g.isDestroyed()){let f;g.webContents&&!g.webContents.isDestroyed()?f=new Promise(c=>g.once("closed",c)):f=Promise.resolve(),g.destroy(),await f}})()]),E.app.exit(v)}};w.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",w=we([ie(0,I.ILogService),ie(1,C.IStateMainService),ie(2,d.IEnvironmentMainService)],w),e.LifecycleMainService=w}),define(ee[226],te([0,1,4,3,2,5,21]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let P=class extends k.Disposable{constructor(b){super(),this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,b.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const b=await new Promise((I,C)=>{z(["native-keymap"],I,C)});this._keyboardLayoutData=p(b),E.isCI||b.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=p(b),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=we([ie(0,D.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function p(S){const b=S.getKeyMap(),I=S.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:I}}}),define(ee[227],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,E.createDecorator)("stateService")}),define(ee[228],te([0,1,8,17,12,34,15,6]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class p{constructor(I,C,d){this.storagePath=I,this.logService=C,this.fileService=d,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new E.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(I){I.fileOperationResult!==1&&this.logService.error(I)}}getItem(I,C){const d=this.storage[I];return(0,k.isUndefinedOrNull)(d)?C:d}setItem(I,C){this.setItems([{key:I,data:C}])}setItems(I){let C=!1;for(const{key:d,data:m}of I)this.storage[d]!==m&&((0,k.isUndefinedOrNull)(m)?(0,k.isUndefined)(this.storage[d])||(this.storage[d]=void 0,C=!0):(this.storage[d]=m,C=!0));C&&this.save()}removeItem(I){(0,k.isUndefined)(this.storage[I])||(this.storage[I]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const I=JSON.stringify(this.storage,null,4);if(I!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(I)),this.lastSavedStorageContents=I}catch(C){this.logService.error(C)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=p;let S=class{constructor(I,C,d){this.fileStorage=new p(I.stateResource,C,d)}async init(){await this.fileStorage.init()}getItem(I,C){return this.fileStorage.getItem(I,C)}};S=we([ie(0,R.IEnvironmentService),ie(1,P.ILogService),ie(2,D.IFileService)],S),e.StateService=S}),define(ee[229],te([0,1,228]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends E.StateService{setItem(R,D){this.fileStorage.setItem(R,D)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(ee[112],te([0,1,4,32,7,29]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(S){if(E.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function P(S,b,I,C,d,m,h,w,u,v){const g=Object.create(null);g["common.machineId"]=h,g.sessionID=(0,R.generateUuid)()+Date.now(),g.commitHash=d,g.version=m,g["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,E.PlatformToString)(E.platform),g["common.nodePlatform"]=t.platform,g["common.nodeArch"]=C,g["common.product"]=v||"desktop",w&&(g["common.msftInternal"]=w);let f=0;const c=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),E.isLinuxSnap&&(g["common.snap"]="true");const n=D(I);n&&(g["common.platformDetail"]=n);try{const r=await S.readFile(k.URI.file(u));g["common.source"]=r.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=P;function p(S){const b=t.env.USERDNSDOMAIN;if(!b)return!1;const I=b.toLowerCase();return S.some(C=>I===C)}e.verifyMicrosoftInternalDomain=p}),define(ee[35],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[230],te([0,1,27,8,42,14,9,4,7,81,23,100,84,15,20,35]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const w=new Map;async function u(n,r){const i=`${n}::${r.join(":")}`,o=w.get(i);if(o)return o;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,a=new Map,y=2e4;function M(U,Y,G,V){const oe=Y.substring(U.length+1);return t.Promises.withAsyncBody(async ae=>{let se;try{se=await b.Promises.readdir(Y,{withFileTypes:!0})}catch{ae();return}if(V.count>=y){V.count+=se.length,V.maxReached=!0,ae();return}let fe=se.length;if(fe===0){ae();return}let K=se;V.count+se.length>y&&(V.maxReached=!0,fe=y-V.count,K=se.slice(0,fe)),V.count+=se.length;for(const H of K)if(H.isDirectory()){if(G.includes(H.name)||await M(U,(0,D.join)(Y,H.name),G,V),--fe===0){ae();return}}else{const F=H.name.lastIndexOf(".");if(F>=0){const A=H.name.substring(F+1);A&&l.set(A,(l.get(A)??0)+1)}for(const A of s)A.relativePathPattern?.test(oe)!==!1&&A.filePattern.test(H.name)&&a.set(A.tag,(a.get(A.tag)??0)+1);if(--fe===0){ae();return}}})}const T=t.Promises.withAsyncBody(async U=>{const Y={count:0,maxReached:!1};await M(n,n,r,Y);const G=await f(n);U({configFiles:v(a),fileTypes:v(l),fileCount:Y.count,maxFilesReached:Y.maxReached,launchConfigFiles:G})});return w.set(i,T),T}e.collectWorkspaceStats=u;function v(n){return Array.from(n.entries(),([r,i])=>({name:r,count:i})).sort((r,i)=>i.count-r.count)}function g(){const n={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},r=E.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.getMachineInfo=g;async function f(n){try{const r=new Map,i=(0,D.join)(n,".vscode","launch.json"),o=await b.Promises.readFile(i),s=[],l=(0,k.parse)(o.toString(),s);if(s.length)return console.log(`Unable to parse ${i}`),[];if((0,k.getNodeType)(l)==="object"&&l.configurations)for(const a of l.configurations){const y=a.type;y&&(r.has(y)?r.set(y,r.get(y)+1):r.set(y,1))}return v(r)}catch{return[]}}e.collectLaunchConfigs=f;let c=class{constructor(r,i){this.telemetryService=r,this.productService=i}formatMachineInfo(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}formatEnvironment(r){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const o=E.cpus();return o&&o.length>0&&i.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),i.push(`Memory (System):  ${(E.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||i.push(`Load (avg):       ${E.loadavg().map(s=>Math.round(s)).join(", ")}`),i.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([(0,I.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async o=>{let[s,l]=o,a=this.formatProcessList(r,s);return i.forEach(y=>{if((0,C.isRemoteDiagnosticError)(y))a+=`
${y.errorMessage}`,l+=`
${y.errorMessage}`;else if(a+=`

Remote: ${y.hostName}`,y.processes&&(a+=`
${this.formatProcessList(r,y.processes)}`),y.workspaceMetadata){l+=`
|  Remote: ${y.hostName}`;for(const M of Object.keys(y.workspaceMetadata)){const T=y.workspaceMetadata[M];let U=`${T.fileCount} files`;T.maxFilesReached&&(U=`more than ${U}`),l+=`|    Folder (${M}): ${U}`,l+=this.formatWorkspaceStats(T)}}}),{processInfo:a,workspaceInfo:l}})}async getSystemInfo(r,i){const{memory:o,vmHint:s,os:l,cpus:a}=g(),y={os:l,memory:o,cpus:a,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return P.isWindows||(y.load=`${E.loadavg().map(M=>Math.round(M)).join(", ")}`),P.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(r,i){const o=[];return(0,I.listProcesses)(r.mainPID).then(async s=>(o.push(""),o.push(this.formatEnvironment(r)),o.push(""),o.push(this.formatProcessList(r,s)),r.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(r))),i.forEach(l=>{if((0,C.isRemoteDiagnosticError)(l))o.push(`
${l.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${l.hostName}`),o.push(this.formatMachineInfo(l.machineInfo)),l.processes&&o.push(this.formatProcessList(r,l.processes)),l.workspaceMetadata)for(const a of Object.keys(l.workspaceMetadata)){const y=l.workspaceMetadata[a];let M=`${y.fileCount} files`;y.maxFilesReached&&(M=`more than ${M}`),o.push(`Folder (${a}): ${M}`),o.push(this.formatWorkspaceStats(y))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(r){const i=[];let s=0;const l=(T,U)=>{const Y=` ${T}(${U})`;s+Y.length>60?(i.push(a),a="|                 ",s=a.length):s+=Y.length,a+=Y};let a="|      File types:";const y=10,M=r.fileTypes.length>y?y:r.fileTypes.length;for(let T=0;T<M;T++){const U=r.fileTypes[T];l(U.name,U.count)}if(i.push(a),r.configFiles.length>=0&&(a="|      Conf files:",s=0,r.configFiles.forEach(T=>{l(T.name,T.count)}),i.push(a)),r.launchConfigFiles.length>0){let T="|      Launch Configs:";r.launchConfigFiles.forEach(U=>{T+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),i.push(T)}return i.join(`
`)}expandGPUFeatures(r){const i=Math.max(...Object.keys(r).map(o=>o.length));return Object.keys(r).map(o=>`${o}:  ${" ".repeat(i-o.length)}  ${r[o]}`).join(`
                  `)}formatWorkspaceMetadata(r){const i=[],o=[];return r.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(i.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const a=p.URI.revive(l);if(a.scheme===R.Schemas.file){const y=a.fsPath;o.push(u(y,["node_modules",".git"]).then(M=>{let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),i.push(`|    Folder (${(0,D.basename)(y)}): ${T}`),i.push(this.formatWorkspaceStats(M))}).catch(M=>{i.push(`|      Error: Unable to collect workspace stats for folder ${y} (${M.toString()})`)}))}else i.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(s=>i.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(r,i){const o=new Map;r.windows.forEach(l=>o.set(l.pid,l.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(r.mainPID,o,s,i,0),s.join(`
`)}formatProcessItem(r,i,o,s,l){const a=l===0;let y;a?y=s.pid===r?`${this.productService.applicationName} main`:"remote agent":(y=`${"  ".repeat(l)} ${s.name}`,s.name==="window"&&(y=`${y} (${i.get(s.pid)})`));const M=process.platform==="win32"?s.mem:E.totalmem()*(s.mem/100);o.push(`${s.load.toFixed(0).padStart(5," ")}	${(M/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(s.children)&&s.children.forEach(T=>this.formatProcessItem(r,i,o,T,l+1))}async getWorkspaceFileExtensions(r){const i=new Set;for(const{uri:o}of r.folders){const s=p.URI.revive(o);if(s.scheme!==R.Schemas.file)continue;const l=s.fsPath;try{(await u(l,["node_modules",".git"])).fileTypes.forEach(y=>i.add(y.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const o=p.URI.revive(i);if(o.scheme!==R.Schemas.file)continue;const s=o.fsPath;try{const l=await u(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),l.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),l.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),l.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};c=we([ie(0,h.ITelemetryService),ie(1,m.IProductService)],c),e.DiagnosticsService=c}),define(ee[231],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:P,data:p}){return this.appenders.forEach(S=>S.log(P,p)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class t{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ee[73],te([0,1,50,96,12,18,112,35]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class p{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(o,s){return Promise.resolve(void 0)}publicLog2(o,s){return this.publicLog(o,s)}publicLogError(o,s){return Promise.resolve(void 0)}publicLogError2(o,s){return this.publicLogError(o,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class S{async publicLog(o,s,l){}async publicLogError(o,s,l){}}e.NullEndpointTelemetryService=S,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(i,o){return o.onDidChangeConfiguration(s=>{s.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(s.source),configurationKeys:u(s.sourceConfig)})})}e.configurationTelemetry=b;function I(i,o){return!(o.disableTelemetry||!i.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=I;function C(i){const o=i.getValue(P.TELEMETRY_SETTING_ID),s=i.getValue("telemetry.enableCrashReporter");if(i.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=C;function d(i){const o={},s={},l={};w(i,l);for(let a in l){a=a.length>150?a.substr(a.length-149):a;const y=l[a];typeof y=="number"?s[a]=y:typeof y=="boolean"?s[a]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${y.length}`),o[a]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(o[a]=y)}return{properties:o,measurements:s}}e.validateTelemetryData=d;const m=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function h(i){if(!i)return"none";for(const o of m)if(i.startsWith(`${o}+`))return o;return"other"}e.cleanRemoteAuthority=h;function w(i,o,s=0,l){if(!!i)for(const a of Object.getOwnPropertyNames(i)){const y=i[a],M=l?l+a:a;Array.isArray(y)?o[M]=(0,E.safeStringify)(y):y instanceof Date?o[M]=y.toISOString():(0,k.isObject)(y)?s<2?w(y,o,s+1,M+"."):o[M]=(0,E.safeStringify)(y):o[M]=y}}function u(i){if(!i)return[];const o=[];return v(o,"",i),o}function v(i,o,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(l=>v(i,o?`${o}.${l}`:l,s[l])):i.push(o)}function g(i,o){const s=i.msftInternalDomains||[],l=o.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(s)||l}e.isInternalTelemetry=g;function f(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=f;function c(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let s=i;const l=[];for(const T of o)for(;;){const U=T.exec(i);if(!U)break;l.push([U.index,T.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let M=0;for(s="";;){const T=y.exec(i);if(!T)break;const U=l.some(([Y,G])=>T.index<G&&Y<y.lastIndex);!a.test(T[0])&&!U&&(s+=i.substring(M,T.index)+"<REDACTED: user-file-path>",M=y.lastIndex)}return M<i.length&&(s+=i.substr(M)),s}function n(i){if(!i)return i;const o=i.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of s)if(l.regex.test(o))return`<REDACTED: ${l.label}>`;return i}function r(i,o){return(0,E.cloneAndChange)(i,s=>{if(typeof s=="string"){let l=s;l=c(l,o);for(const a of o)l=l.replace(a,"");return l=n(l),l}})}e.cleanData=r}),define(ee[232],te([0,1,187,73]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,D,P,p,S,b,I){const C={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`};if((0,t.supportsTelemetry)(D,P)&&(0,t.getTelemetryLevel)(p)===3){const d=await(0,E.getServiceMachineId)(P,S,b),{sessionId:m}=await I.getTelemetryInfo();C["X-Market-User-Id"]=d,C["VSCode-SessionId"]=m}return C}e.resolveMarketplaceHeaders=k}),define(ee[233],te([0,1,2,50,96,4,25,167,18,62,54,20,46,35,73]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let h=class{constructor(v,g,f){this._configurationService=g,this._productService=f,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new E.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(v,g){this._experimentProperties[v]=g}_updateTelemetryLevel(){let v=(0,m.getTelemetryLevel)(this._configurationService);const g=this._productService.enabledTelemetryLevels;if(g){this._sendErrorTelemetry=this.sendErrorTelemetry?g.error:!1;const f=g.usage?3:g.error?2:0;v=Math.min(v,f)}this.telemetryLevel.value=v}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const v=await this._commonProperties,g=v.sessionID,f=v["common.machineId"],c=v["common.firstSessionDate"],n=v["common.msftInternal"];return{sessionId:g,machineId:f,firstSessionDate:c,msftInternal:n}}dispose(){this._disposables.dispose()}_log(v,g,f,c){return this.telemetryLevel.value<g?Promise.resolve(void 0):this._commonProperties.then(n=>{f=(0,t.mixin)(f,this._experimentProperties),f=(0,m.cleanData)(f,this._cleanupPatterns),f=(0,t.mixin)(f,n),this._appenders.forEach(r=>r.log(v,f))},n=>{console.error(n)})}publicLog(v,g,f){return this._log(v,3,g,f)}publicLog2(v,g,f){return this.publicLog(v,g,f)}publicLogError(v,g){return this._sendErrorTelemetry?this._log(v,2,g,!0):Promise.resolve(void 0)}publicLogError2(v,g){return this.publicLogError(v,g)}};h.IDLE_START_EVENT_NAME="UserIdleStart",h.IDLE_STOP_EVENT_NAME="UserIdleStop",h=we([ie(1,p.IConfigurationService),ie(2,I.IProductService)],h),e.TelemetryService=h;function w(){const u=(0,P.localize)(0,null,b.default.nameLong),v=b.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=R.isWeb?"":(0,P.localize)(3,null),f=(0,P.localize)(4,null),c=(0,P.localize)(5,null),n=(0,P.localize)(6,null),r=(0,P.localize)(7,null),i=`
|       | ${f} | ${c} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,P.localize)(8,null);return`
${u} ${v} ${g}

&nbsp;

${r}
${i}

&nbsp;

${o}
`}C.Registry.as(S.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[d.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(S.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[d.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,P.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,P.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${d.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[234],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var E;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(E=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===E.HIGH_CONTRAST_DARK||R===E.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===E.DARK||R===E.HIGH_CONTRAST_DARK}e.isDark=k}),define(ee[235],te([0,1,119,3,2,5,46,234]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var p;(function(w){function u(v){return v&&typeof v=="object"&&typeof v.id=="string"}w.isThemeColor=u})(p=e.ThemeColor||(e.ThemeColor={}));function S(w){return{id:w}}e.themeColorFromId=S;var b;(function(w){function u(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||p.isThemeColor(o.color))}w.isThemeIcon=u;const v=new RegExp(`^\\$\\((${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?)\\)$`);function g(o){const s=v.exec(o);if(!s)return;const[,l]=s;return{id:l}}w.fromString=g;function f(o){return{id:o}}w.fromId=f;function c(o,s){let l=o.id;const a=l.lastIndexOf("~");return a!==-1&&(l=l.substring(0,a)),s&&(l=`${l}~${s}`),{id:l}}w.modify=c;function n(o){const s=o.id.lastIndexOf("~");if(s!==-1)return o.id.substring(s+1)}w.getModifier=n;function r(o,s){return o.id===s.id&&o.color?.id===s.color?.id}w.isEqual=r;function i(o,s){return{id:o.id,color:s?S(s):void 0}}w.asThemeIcon=i,w.asClassNameArray=E.CSSIcon.asClassNameArray,w.asClassName=E.CSSIcon.asClassName,w.asCSSSelector=E.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=E.Codicon.file,e.FolderThemeIcon=E.Codicon.folder;function I(w){switch(w){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class C{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(u){return this.themingParticipants.push(u),this.onThemingParticipantAddedEmitter.fire(u),(0,k.toDisposable)(()=>{const v=this.themingParticipants.indexOf(u);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const d=new C;D.Registry.add(e.Extensions.ThemingContribution,d);function m(w){return d.onColorThemeChange(w)}e.registerThemingParticipant=m;class h extends k.Disposable{constructor(u){super(),this.themeService=u,this.theme=u.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(u){this.theme=u,this.updateStyles()}updateStyles(){}getColor(u,v){let g=this.theme.getColor(u);return g&&v&&(g=v(g,this.theme)),g?g.toString():null}}e.Themable=h}),define(ee[64],te([0,1,13,3,2,4,18,5,37]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const S="#FFFFFF",b="#1E1E1E",I="#000000",C="#FFFFFF",d="theme",m="themeBackground",h="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let w=class extends k.Disposable{constructor(v,g){super(),this.stateMainService=v,this.configurationService=g,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,E.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return v.dark?I:C;let g=this.stateMainService.getItem(m,null);if(!g)switch(this.stateMainService.getItem(d,"vs-dark").split(" ")[0]){case"vs":g=S;break;case"hc-black":g=I;break;case"hc-light":g=C;break;default:g=b}return R.isMacintosh&&g.toUpperCase()===b&&(g="#171717"),g}saveWindowSplash(v,g){this.stateMainService.setItems([{key:d,data:g.baseTheme},{key:m,data:g.colorInfo.background},{key:h,data:g}]),typeof v=="number"&&this.updateBackgroundColor(v,g)}updateBackgroundColor(v,g){for(const f of E.BrowserWindow.getAllWindows())if(f.id===v){f.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(h)}};w=we([ie(0,p.IStateMainService),ie(1,D.IConfigurationService)],w),e.ThemeMainService=w}),define(ee[113],te([0,1,3,18,5,6]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(h){h.Http="http",h.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var p;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(p=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=I;function C(h,w,u,v){if(u===1)return!1;if(u===2&&I(w)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(g?.length===4&&parseInt(g[1])>=18)return!1}return h<1024}e.isPortPrivileged=C;class d{constructor(w,u,v){this.remoteAddress=w,this.localAddress=u,this._dispose=v,this._onDispose=new E.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=d;let m=class{constructor(w,u){this.logService=w,this.configurationService=u,this._onTunnelOpened=new E.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new E.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new E.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const w=this.configurationService.getValue("remote.localPortHost");return!w||w==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(w){return this._tunnelProvider=w,w?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],u=Array.from(this._tunnels.values());for(const v of u){const g=Array.from(v.values());for(const f of g){const c=await f.value;c&&w.push(c)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:u}of w.values())await u.then(v=>v?.dispose());w.clear()}this._tunnels.clear()}setEnvironmentTunnel(w,u,v,g,f){this.addTunnelToMap(w,u,Promise.resolve({tunnelRemoteHost:w,tunnelRemotePort:u,localAddress:v,privacy:g,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(w,u){(I(w)||b(w))&&(w=e.LOCALHOST_ADDRESSES[0]);const v=this.getTunnelFromMap(w,u);if(v)return++v.refcount,v.value}openTunnel(w,u,v,g,f=!1,c,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${v} on local port ${g}.`),!w)return;if(u||(u="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(w,u,v,g,f,c,n);return r?r.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(i);return(i.tunnelRemoteHost!==u||i.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const u=this._tunnels.get(w.tunnelRemoteHost);if(u){const v=u.get(w.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,v))}}}}async tryDisposeTunnel(w,u,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${u}.`);const g=v.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(u),g}}async closeTunnel(w,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${u} `);const v=this._tunnels.get(w);if(v&&v.has(u)){const g=v.get(u);g.refcount=0,await this.tryDisposeTunnel(w,u,g)}}addTunnelToMap(w,u,v){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(u,{refcount:1,value:v})}async removeEmptyTunnelFromMap(w,u){const v=this._tunnels.get(w);v&&(await v.get(u)||v.delete(u),v.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,u){const v=[w];b(w)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):I(w)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const g=v.map(f=>this._tunnels.get(f));for(const f of g){const c=f?.get(u);if(c)return c}}canTunnel(w){return!!S(w)}createWithProvider(w,u,v,g,f,c,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${v} on local port ${g}.`);const r=v;this._factoryInProgress.add(r);const i=g===void 0?v:g,o={elevationRequired:f?this.isPortPrivileged(i):!1},s={remoteAddress:{host:u,port:v},localAddressPort:g,privacy:c,public:c?c!==P.Private:void 0,protocol:n},l=w.forwardPort(s,o);return l?(this.addTunnelToMap(u,v,l),l.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),l}};m=we([ie(0,R.ILogService),ie(1,t.IConfigurationService)],m),e.AbstractTunnelService=m}),define(ee[236],te([0,1,78,27,95,220,8,2,18,6,20,219,113,88,4]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function h(f,c,n,r,i){let o;for(let s=3;s&&(o?.dispose(),o=await new w(f,c,n,r,i).waitForReady(),!(i&&k.BROWSER_RESTRICTED_PORTS[i]||!k.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));s--);return o}class w extends P.Disposable{constructor(c,n,r,i,o){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=o,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=E.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const c=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,C.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let r=await(0,k.findFreePortFaster)(c,2,1e3,n),i=null;return this._server.listen(r,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address(),i||(r=0,this._server.listen(r,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async _onConnection(c){c.pause();const n=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,I.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),i=r.getSocket().socket,o=r.readEntireBuffer();r.dispose(),o.byteLength>0&&c.write(o.buffer),c.on("end",()=>{c.localAddress&&this._socketsDispose.delete(c.localAddress),i.end()}),c.on("close",()=>i.end()),c.on("error",()=>{c.localAddress&&this._socketsDispose.delete(c.localAddress),i.destroy()}),i.on("end",()=>c.end()),i.on("close",()=>c.end()),i.on("error",()=>{c.destroy()}),c.pipe(i),i.pipe(c),c.localAddress&&this._socketsDispose.set(c.localAddress,()=>{c.end(),i.end()})}}let u=class extends C.AbstractTunnelService{constructor(c,n,r,i,o){super(n,o),this.socketFactory=c,this.signService=r,this.productService=i}isPortPrivileged(c){return(0,C.isPortPrivileged)(c,this.defaultTunnelHost,m.OS,t.release())}retainOrCreateTunnel(c,n,r,i,o,s,l){const a=this.getTunnelFromMap(n,r);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,n,r,i,o,s,l);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${i}.`);const y={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},M=h(y,this.defaultTunnelHost,n,r,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,r,M),M}}};u=we([ie(1,S.ILogService),ie(2,d.ISignService),ie(3,b.IProductService),ie(4,p.IConfigurationService)],u),e.BaseTunnelService=u;let v=class extends u{constructor(c,n,r,i){super(R.nodeSocketFactory,c,n,r,i)}};v=we([ie(0,S.ILogService),ie(1,d.ISignService),ie(2,b.IProductService),ie(3,p.IConfigurationService)],v),e.TunnelService=v;let g=class extends P.Disposable{constructor(c,n,r,i){super(),this.logService=c,this.productService=n,this.signService=r,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(c,n,r,i,o,s,l,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${i} on local port ${o}.`),!this._tunnelServices.has(c)){const y=new v(this.logService,this.signService,this.productService,this.configurationService);this._register(y),this._tunnelServices.set(c,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(n,r,i,o,s,l,a)}};g=we([ie(0,S.ILogService),ie(1,b.IProductService),ie(2,d.ISignService),ie(3,p.IConfigurationService)],g),e.SharedTunnelsService=g}),define(ee[47],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(ee[237],te([0,1,4,168,62,46]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[238],te([0,1,3,47]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(P){this.service=P}listen(P,p){switch(p){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${p}`)}call(P,p,S){switch(p){case"checkForUpdates":return this.service.checkForUpdates(S);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(S)}throw new Error(`Call not found: ${p}`)}}e.UpdateChannel=k;class R{get state(){return this._state}set state(P){this._state=P,this._onStateChange.fire(P)}constructor(P){this.channel=P,this._onStateChange=new E.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(p=>this.state=p),this.channel.call("_getInitialState").then(p=>this.state=p)}checkForUpdates(P){return this.channel.call("checkForUpdates",P)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(P){return this.channel.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=R}),define(ee[89],te([0,1,8,22,3,18,26,21,6,20,55,47]),function(z,e,E,t,k,R,D,P,p,S,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function C(m,h,w){return`${w.updateUrl}/api/update/${m}/${h}/${w.commit}`}e.createUpdateURL=C;let d=class{get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}constructor(h,w,u,v,g,f){this.lifecycleMainService=h,this.configurationService=w,this.environmentMainService=u,this.requestService=v,this.logService=g,this.productService=f,this._state=I.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const h=this.getUpdateMode(),w=this.getProductQuality(h);if(!w){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(w),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(I.State.Idle(this.getUpdateType())),h==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}h==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,u=>this.logService.error(u))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(h){return h==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(h=60*60*1e3){return(0,E.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(h){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(h){}getUpdateType(){return 1}doQuitAndInstall(){}};d=we([ie(0,P.ILifecycleMainService),ie(1,R.IConfigurationService),ie(2,D.IEnvironmentMainService),ie(3,b.IRequestService),ie(4,p.ILogService),ie(5,S.IProductService)],d),e.AbstractUpdateService=d}),define(ee[239],te([0,1,13,53,3,2,18,26,21,6,20,55,35,47,89]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let h=class extends m.AbstractUpdateService{get onRawError(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"error",(u,v)=>v)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(u,v,g)=>({url:v,version:g,productVersion:g}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(u,v,g,f)=>({releaseNotes:v,version:g,productVersion:g,date:f}))}constructor(u,v,g,f,c,n,r){super(u,v,f,c,n,r),this.telemetryService=g,this.disposables=new R.DisposableStore}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(u){this.logService.error("UpdateService error:",u);const g=(this.state.type==="checking for updates"?this.state.explicit:!0)?u:void 0;this.setState(d.State.Idle(1,g))}buildUpdateFeedUrl(u){let v;this.productService.darwinUniversalAssetId?v=this.productService.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const g=(0,m.createUpdateURL)(v,u,this.productService);try{E.autoUpdater.setFeedURL({url:g})}catch(f){this.logService.error("Failed to set update feed URL",f);return}return g}doCheckForUpdates(u){this.setState(d.State.CheckingForUpdates(u)),E.autoUpdater.checkForUpdates()}onUpdateAvailable(u){this.state.type==="checking for updates"&&this.setState(d.State.Downloading(u))}onUpdateDownloaded(u){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:u.version}),this.setState(d.State.Ready(u)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(d.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};we([t.memoize],h.prototype,"onRawError",null),we([t.memoize],h.prototype,"onRawUpdateNotAvailable",null),we([t.memoize],h.prototype,"onRawUpdateAvailable",null),we([t.memoize],h.prototype,"onRawUpdateDownloaded",null),h=we([ie(0,p.ILifecycleMainService),ie(1,D.IConfigurationService),ie(2,C.ITelemetryService),ie(3,P.IEnvironmentMainService),ie(4,I.IRequestService),ie(5,S.ILogService),ie(6,b.IProductService)],h),e.DarwinUpdateService=h}),define(ee[240],te([0,1,44,39,8,3,9,26,21,6,35,47]),function(z,e,E,t,k,R,D,P,p,S,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let C=class{get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}constructor(h,w,u){if(this.lifecycleMainService=h,this.logService=u,this._state=I.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,w.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(I.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}scheduleCheckForUpdates(h=60*60*1e3){return(0,k.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(h){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(h){}};C=we([ie(0,p.ILifecycleMainService),ie(1,P.IEnvironmentMainService),ie(2,S.ILogService)],C);let d=class extends C{constructor(h,w,u,v,g,f){super(u,v,g),this.snap=h,this.snapRevision=w,this.telemetryService=f;const c=(0,t.watch)(D.dirname(this.snap)),n=R.Event.fromNodeEventEmitter(c,"change",(s,l)=>l),r=R.Event.filter(n,s=>s==="current"),o=R.Event.debounce(r,(s,l)=>l,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{o.dispose(),c.close()})}doCheckForUpdates(){this.setState(I.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(h=>{h?this.setState(I.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2)))},h=>{this.logService.error(h),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2,h.message||h))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const h=await new Promise((u,v)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(g,f)=>g?v(g):u(f))),w=D.basename(h);return this.snapRevision!==w}isLatestVersion(){return this.isUpdateAvailable().then(void 0,h=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};d=we([ie(2,p.ILifecycleMainService),ie(3,P.IEnvironmentMainService),ie(4,S.ILogService),ie(5,b.ITelemetryService)],d),e.SnapUpdateService=d}),define(ee[48],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(ee[241],te([0,1,48,188,15,19,125,3,2]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(C){this.uri=C,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let b=class{constructor(C){this._fileService=C,this._dispooables=new p.DisposableStore,this._limit=2**16;const d=new Map,m=h=>{let w=d.get(h.scheme);return w===void 0&&(w=C.hasProvider(h)&&!this._fileService.hasCapability(h,1024),d.set(h.scheme,w)),w};this._dispooables.add(P.Event.any(C.onDidChangeFileSystemProviderRegistrations,C.onDidChangeFileSystemProviderCapabilities)(h=>{d.delete(h.scheme)})),this.extUri=new R.ExtUri(m),this._canonicalUris=new D.SkipList((h,w)=>this.extUri.compare(h,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(C){this._fileService.hasProvider(C)&&(C=(0,R.normalizePath)(C));const d=this._canonicalUris.get(C);return d?d.touch().uri.with({fragment:C.fragment}):(this._canonicalUris.set(C,new S(C)),this._checkTrim(),C)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const C=[...this._canonicalUris.entries()].sort((m,h)=>m[1].touch<h[1].touch?1:m[1].touch>h[1].touch?-1:0);S._clock=0,this._canonicalUris.clear();const d=this._limit*.5;for(let m=0;m<d;m++)this._canonicalUris.set(C[m][0],C[m][1].touch())}};b=we([ie(0,k.IFileService)],b),e.UriIdentityService=b,(0,t.registerSingleton)(E.IUriIdentityService,b,1)}),define(ee[114],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(ee[242],te([0,1,7]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(P){this.handler=P}listen(P,p){throw new Error(`Event not found: ${p}`)}call(P,p,S){switch(p){case"handleURL":return this.handler.handleURL(E.URI.revive(S[0]),S[1])}throw new Error(`Call not found: ${p}`)}}e.URLHandlerChannel=t;class k{constructor(P){this.channel=P}handleURL(P,p){return this.channel.call("handleURL",[P.toJSON(),p])}}e.URLHandlerChannelClient=k;class R{constructor(P){this.next=P}async routeCall(P,p,S,b){if(p!=="handleURL")throw new Error(`Call not found: ${p}`);if(S){const I=E.URI.revive(S);if(I&&I.query){const C=/\bwindowId=(\d+)/.exec(I.query);if(C){const d=C[1],m=new RegExp(`window:${d}`),h=P.connections.find(w=>m.test(w.ctx));if(h)return h}}}return this.next.routeCall(P,p,S,b)}routeEvent(P,p){throw new Error(`Event not found: ${p}`)}}e.URLHandlerRouter=R}),define(ee[243],te([0,1,8,2,7,20]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(S,b){const I=[...this.handlers.values()];return(0,E.first)(I.map(C=>()=>C.handleURL(S,b)),void 0,!1).then(C=>C||!1)}registerHandler(S){return this.handlers.add(S),(0,t.toDisposable)(()=>this.handlers.delete(S))}}e.AbstractURLService=D;let P=class extends D{constructor(S){super(),this.productService=S}create(S){let{authority:b,path:I,query:C,fragment:d}=S||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&I&&I.indexOf("/")!==0&&(I=`/${I}`),k.URI.from({scheme:this.productService.urlProtocol,authority:b,path:I,query:C,fragment:d})}};P=we([ie(0,R.IProductService)],P),e.NativeURLService=P}),define(ee[244],te([0,1,13,8,3,2,4,7]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function p(b){try{return P.URI.parse(b)}catch{return null}}class S{constructor(I,C,d,m,h){if(this.urlService=C,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=I,D.isWindows){const v=m.isBuilt?[]:[`"${m.appRoot}"`];v.push("--open-url","--"),E.app.setAsDefaultProtocolClient(h.urlProtocol,process.execPath,v)}const w=k.Event.map(k.Event.fromNodeEventEmitter(E.app,"open-url",(v,g)=>({event:v,url:g})),({event:v,url:g})=>(v.preventDefault(),g));this.disposables.add(w(v=>{const g=p(v);!g||this.urlService.open(g,{originalUrl:v})})),d.getWindows().filter(v=>v.isReady).length>0?this.flush():k.Event.once(d.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const C of this.uris)await this.urlService.open(C.uri,{originalUrl:C.url})||I.push(C);I.length!==0&&(this.uris=I,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=S}),define(ee[245],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(ee[246],te([0,1,13,2,14,7]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const p=this.handleWebviewRequest.bind(this);E.protocol.registerFileProtocol(k.Schemas.vscodeWebview,p)}handleWebviewRequest(p,S){try{const b=R.URI.parse(p.url),I=D.validWebviewFilePaths.get(b.path);if(typeof I=="string"){const C=`vs/workbench/contrib/webview/browser/pre/${I}`,d=k.FileAccess.asFileUri(C,z);return S({path:decodeURIComponent(d.fsPath),headers:{...k.COI.getHeadersFromQuery(p.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return S({error:-10})}catch{}return S({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ee[74],te([0,1,4]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(b){return!!b.workspaceUri}e.isWorkspaceToOpen=t;function k(b){return!!b.folderUri}e.isFolderToOpen=k;function R(b){return!!b.fileUri}e.isFileToOpen=R;function D(b){const I=P(b),C=b.getValue("window.menuBarVisibility");return C==="default"||I==="native"&&C==="compact"||E.isMacintosh&&E.isNative?"classic":C}e.getMenuBarVisibility=D;function P(b){if(E.isWeb)return"custom";const I=b.getValue("window");if(I){if(E.isMacintosh&&I.nativeTabs===!0||E.isMacintosh&&I.nativeFullScreen===!1)return"native";const m=I.titleBarStyle;if(m==="native"||m==="custom")return m}return E.isLinux?"native":"custom"}e.getTitleBarStyle=P;function p(b){if(!E.isWindows||E.isWeb||P(b)==="native")return!1;const I=b.getValue("window.experimental.windowControlsOverlay.enabled");return typeof I=="boolean"?I:!1}e.useWindowControlsOverlay=p;function S(b=0){return Math.pow(1.2,b)}e.zoomLevelToZoomFactor=S}),define(ee[115],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(E=e.LoadReason||(e.LoadReason={}));var t;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=k;var R;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(ee[31],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(ee[247],te([0,1,13,22,3,67,2,29,70,105,6,20,31]),function(z,e,E,t,k,R,D,P,p,S,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var d;(function(h){h[h.Initial=1]="Initial",h[h.StoredCredentialsUsed=2]="StoredCredentialsUsed",h[h.LoginDialogShown=3]="LoginDialogShown"})(d||(d={}));let m=class extends D.Disposable{constructor(w,u,v,g,f){super(),this.logService=w,this.windowsMainService=u,this.credentialsService=v,this.encryptionMainService=g,this.productService=f,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=d.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const w=k.Event.fromNodeEventEmitter(E.app,"login",(u,v,g,f,c)=>({event:u,webContents:v,req:g,authInfo:f,callback:c}));this._register(w(this.onLogin,this))}async onLogin({event:w,authInfo:u,req:v,callback:g}){if(!u.isProxy)return;if(!this.pendingProxyResolve&&this.state===d.LoginDialogShown&&v.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let f;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),f=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(u);try{f=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}g(f?.username,f?.password)}async resolveProxyCredentials(w){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const u=await this.doResolveProxyCredentials(w);if(u)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),u;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(w){this.logService.trace("auth#doResolveProxyCredentials - enter",w);const u=String((0,R.hash)({scheme:w.scheme,host:w.host,port:w.port}));let v,g;try{const r=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,u);if(r){const i=JSON.parse(await this.encryptionMainService.decrypt(r));v=i.username,g=i.password}}catch(r){this.logService.error(r)}if(this.state!==d.StoredCredentialsUsed&&typeof v=="string"&&typeof g=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=d.StoredCredentialsUsed,{username:v,password:g};const f=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!f){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${f.id} to handle proxy login`);const c={authInfo:w,username:this.sessionCredentials?.username??v,password:this.sessionCredentials?.password??g,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};f.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.state=d.LoginDialogShown;const n=await new Promise(r=>{const i=async(o,s,l)=>{if(s===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${f.id}`),f.win?.webContents.off("ipc-message",i),l){const a={username:l.username,password:l.password};try{if(l.remember){const y=await this.encryptionMainService.encrypt(JSON.stringify(a));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,u,y)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,u)}catch(y){this.logService.error(y)}r({username:a.username,password:a.password})}else r(void 0)};f.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=n,n}};m=we([ie(0,b.ILogService),ie(1,C.IWindowsMainService),ie(2,p.ICredentialsMainService),ie(3,S.IEncryptionMainService),ie(4,I.IProductService)],m),e.ProxyAuthHandler=m}),define(ee[248],te([0,1,70,6,34,20,31,200]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let p=class extends P.BaseCredentialsMainService{constructor(b,I,C,d){super(b),this.environmentMainService=I,this.productService=C,this.windowsMainService=d,this.surfaceKeytarLoadError=m=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",m.message??m)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new E.InMemoryCredentialsProvider,this._keytarCache;const b=await new Promise((I,C)=>{z(["keytar"],I,C)});return await b.findCredentials("test-keytar-loads"),this._keytarCache=b,this._keytarCache}};p=we([ie(0,t.ILogService),ie(1,k.INativeEnvironmentService),ie(2,R.IProductService),ie(3,D.IWindowsMainService)],p),e.CredentialsNativeMainService=p}),define(ee[249],te([0,1,16,2,3,6,21,80,44,278,8,14,50,4,32,13,31]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const u=h.utilityProcess,v=typeof u<"u";let g=class Nt{constructor(r,i,o){this._logService=r,this._windowsMainService=o,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(s=>{this._shutdown=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(r){const i=this._extHosts.get(r);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(r){return this._getExtHost(r).onStdout}onDynamicStderr(r){return this._getExtHost(r).onStderr}onDynamicMessage(r){return this._getExtHost(r).onMessage}onDynamicError(r){return this._getExtHost(r).onError}onDynamicExit(r){return this._getExtHost(r).onExit}async canUseUtilityProcess(){return v}async createExtensionHost(r){if(this._shutdown)throw(0,E.canceled)();const i=String(++Nt._lastId);let o;if(r){if(!v)throw new Error("Cannot use UtilityProcess!");o=new c(i,this._logService,this._windowsMainService)}else o=new f(i,this._logService);return this._extHosts.set(i,o),o.onExit(({pid:s,code:l,signal:a})=>{this._logService.info(`Extension host with pid ${s} exited with code: ${l}, signal: ${a}.`),setTimeout(()=>{o.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(r,i){if(this._shutdown)throw(0,E.canceled)();return this._getExtHost(r).start(i)}async enableInspectPort(r){if(this._shutdown)throw(0,E.canceled)();const i=this._extHosts.get(r);return i?i.enableInspectPort():!1}async kill(r){if(this._shutdown)throw(0,E.canceled)();const i=this._extHosts.get(r);!i||i.kill()}async _killAllNow(){for(const[,r]of this._extHosts)r.kill()}async _waitForAllExit(r){const i=[];for(const[,o]of this._extHosts)i.push(o.waitForExit(r));return b.Promises.settled(i).then(()=>{})}};g._lastId=0,g=we([ie(0,R.ILogService),ie(1,D.ILifecycleMainService),ie(2,w.IWindowsMainService)],g),e.ExtensionHostStarter=g;let f=class extends t.Disposable{constructor(r,i){super(),this.id=r,this._logService=i,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){d.isCI&&this._logService.info("Calling fork to start extension host...");const i=P.StopWatch.create(!1);this._process=(0,p.fork)(I.FileAccess.asFileUri("bootstrap-fork",z).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,C.mixin)({cwd:(0,m.cwd)()},r));const o=i.elapsed(),s=this._process.pid;this._logService.info(`Starting extension host with pid ${s} (fork() took ${o} ms).`);const l=new S.StringDecoder("utf-8");this._process.stdout?.on("data",y=>{const M=typeof y=="string"?y:l.write(y);this._onStdout.fire(M)});const a=new S.StringDecoder("utf-8");this._process.stderr?.on("data",y=>{const M=typeof y=="string"?y:a.write(y);this._onStderr.fire(M)}),this._process.on("message",y=>{this._onMessage.fire(y)}),this._process.on("error",y=>{this._onError.fire({error:(0,E.transformErrorForSerialization)(y)})}),this._process.on("exit",(y,M)=>{this._hasExited=!0,this._onExit.fire({pid:s,code:y,signal:M})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):d.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,b.timeout)(r)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${r}ms.`),this._process.kill())}};f=we([ie(1,R.ILogService)],f);let c=class extends t.Disposable{constructor(r,i,o){super(),this.id=r,this._logService=i,this._windowsMainService=o,this.onError=k.Event.None,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){const i=this._windowsMainService.getWindowById(r.responseWindowId);if(!i){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const o=i.win;if(!o||o.isDestroyed()||o.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,l=I.FileAccess.asFileUri("bootstrap-fork.js",z).fsPath,a=["--type=extensionHost","--skipWorkspaceStorageLock"],y=r.execArgv||[],M={...r.env},T=!0,U="pipe";for(const se of Object.keys(M))M[se]=String(M[se]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=u.fork(l,a,{serviceName:s,env:M,execArgv:y,allowLoadingUnsignedLibraries:T,stdio:U});const Y=new S.StringDecoder("utf-8");this._process.stdout?.on("data",se=>{const fe=typeof se=="string"?se:Y.write(se);this._onStdout.fire(fe)});const G=new S.StringDecoder("utf-8");this._process.stderr?.on("data",se=>{const fe=typeof se=="string"?se:G.write(se);this._onStderr.fire(fe)}),this._process.on("message",se=>{this._onMessage.fire(se)}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const V=k.Event.fromNodeEventEmitter(this._process,"exit",se=>se);this._register(V(se=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${se}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:se,signal:""})}));const{port1:oe,port2:ae}=new h.MessageChannelMain;this._process.postMessage("null",[ae]),o.webContents.postMessage(r.responseChannel,r.responseNonce,[oe])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):!1):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,b.timeout)(r)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${r}ms, will kill it now.`),this._process.kill())}};c=we([ie(1,R.ILogService),ie(2,w.IWindowsMainService)],c)}),define(ee[250],te([0,1,13,24,4,7,23,18,59,5,6,114,31]),function(z,e,E,t,k,R,D,P,p,S,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,S.createDecorator)(e.ID);let d=class{constructor(h,w,u,v){this.logService=h,this.windowsMainService=w,this.urlService=u,this.configurationService=v}async start(h,w){this.logService.trace("Received data from other instance: ",h,w),k.isMacintosh&&E.app.focus({steal:!0});const u=this.parseOpenUrl(h);if(u.length){let v=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const g=(0,t.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));g&&(v=g.ready())}v.then(()=>{for(const{uri:g,url:f}of u)this.urlService.open(g,{originalUrl:f})})}else return this.startOpenWindow(h,w)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?(0,t.coalesce)(h._urls.map(w=>{try{return{uri:R.URI.parse(w),url:w}}catch{return null}})):[]}async startOpenWindow(h,w){const u=(0,p.isLaunchedFromCli)(w)?0:4;let v=[];const g=h.wait&&h.waitMarkerFilePath?R.URI.file(h.waitMarkerFilePath):void 0,f=h.remote||void 0,c={context:u,cli:h,userEnv:w,waitMarkerFileURI:g,remoteAuthority:f,forceProfile:h.profile,forceTempProfile:h["profile-temp"]};if(h.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,c);else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let n=!1;if(h["new-window"]||h["unity-launch"]||c.forceProfile||c.forceTempProfile)n=!0;else if(h["reuse-window"])n=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":n=!0;break;case"off":n=!1;break;default:n=!k.isMacintosh}if(n)v=await this.windowsMainService.open({...c,forceNewWindow:!0,forceEmpty:!0});else{const r=this.windowsMainService.getLastActiveWindow();r?(this.windowsMainService.openExistingWindow(r,c),v=[r]):v=await this.windowsMainService.open({...c,forceEmpty:!0})}}else v=await this.windowsMainService.open({...c,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,mergeMode:h.merge,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],gotoLineMode:h.goto});if(g&&v.length===1&&v[0])return Promise.race([v[0].whenClosedOrLoaded,(0,D.whenDeleted)(g.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};d=we([ie(0,b.ILogService),ie(1,C.IWindowsMainService),ie(2,I.IURLService),ie(3,P.IConfigurationService)],d),e.LaunchMainService=d}),define(ee[251],te([0,1,13,3,2,246,31]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends k.Disposable{constructor(S){super(),this.windowsMainService=S,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(S,b){let I;if(typeof S.windowId=="number"){const{windowId:C}=S,d=this.windowsMainService.getWindowById(C);if(!d?.win)throw new Error(`Invalid windowId: ${C}`);I=d.win.webContents}else{const{webContentsId:C}=S;if(I=E.webContents.fromId(C),!I)throw new Error(`Invalid webContentsId: ${C}`)}I.isDestroyed()||I.setIgnoreMenuShortcuts(b)}async findInFrame(S,b,I,C){const m=this.getFrameByName(S,b);if(typeof m.findInFrame=="function"){m.findInFrame(I,{findNext:C.findNext,forward:C.forward});const h=(w,u)=>{u.finalUpdate&&(this._onFoundInFrame.fire(u),m.removeListener("found-in-frame",h))};m.on("found-in-frame",h)}}async stopFindInFrame(S,b,I){const d=this.getFrameByName(S,b);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(I.keepSelection?"keepSelection":"clearSelection")}getFrameByName(S,b){const I=this.windowsMainService.getWindowById(S.windowId);if(!I?.win)throw new Error(`Invalid windowId: ${S}`);const C=I.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===b);if(!C)throw new Error(`Unknown frame: ${b}`);return C}};P=we([ie(0,D.IWindowsMainService)],P),e.WebviewMainService=P}),define(ee[252],te([0,1,8,3,2]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:p,getActiveWindowId:S}){super(),this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(P,p))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,E.createCancelablePromise)(()=>S()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(ee[28],te([0,1,172,9,58,19,7,5,14]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function S(r){const i=r;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=S,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function b(r,i){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,t.basename)(r)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const o=r;if(o.configuration)return{id:o.id,configPath:o.configuration};if(o.folders.length===1)return{id:o.id,uri:o.folders[0].uri}}e.toWorkspaceIdentifier=b;function I(r){const i=r;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=I;function C(r){const i=r;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const o=r;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=C;var d;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(d=e.WorkbenchState||(e.WorkbenchState={}));function m(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=m;function h(r){const i=r;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=h;class w{constructor(i,o,s,l,a){this._id=i,this._transient=s,this._configuration=l,this._ignorePathCasing=a,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class u{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,R.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function v(r){return new u({uri:r,index:0,name:(0,R.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(r,i){return R.extUriBiasedIgnorePathCase.isEqualOrParent(r,i.untitledWorkspacesHome)}e.isUntitledWorkspace=g;function f(r){let i;return D.URI.isUri(r)?i=r:i=r.configuration,i?.scheme===p.Schemas.tmp}e.isTemporaryWorkspace=f;function c(r,i){return!g(r,i)&&!f(r)}e.isSavedWorkspace=c;function n(r){return(typeof r=="string"?(0,t.extname)(r):(0,R.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(ee[56],te([0,1,13,8,67,33,2,76,4,12,23,149,5,6,28]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,C.createDecorator)("dialogMainService");let h=class{constructor(u){this.logService=u,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(u,v){return this.doPick({...u,pickFolders:!0,pickFiles:!0,title:(0,I.localize)(0,null)},v)}pickFolder(u,v){return this.doPick({...u,pickFolders:!0,title:(0,I.localize)(1,null)},v)}pickFile(u,v){return this.doPick({...u,pickFiles:!0,title:(0,I.localize)(2,null)},v)}pickWorkspace(u,v){const g=(0,I.localize)(3,null),f=(0,R.mnemonicButtonLabel)((0,I.localize)(4,null)),c=m.WORKSPACE_FILTER;return this.doPick({...u,pickFiles:!0,title:g,filters:c,buttonLabel:f},v)}async doPick(u,v){const g={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(g.properties=void 0,u.pickFiles&&u.pickFolders&&(g.properties=["multiSelections","openDirectory","openFile","createDirectory"])),g.properties||(g.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),p.isMacintosh&&g.properties.push("treatPackageAsDirectory");const f=await this.showOpenDialog(g,(0,S.withNullAsUndefined)(v||E.BrowserWindow.getFocusedWindow()));if(f&&f.filePaths&&f.filePaths.length>0)return f.filePaths}getWindowDialogQueue(u){if(u){let v=this.windowDialogQueues.get(u.id);return v||(v=new t.Queue,this.windowDialogQueues.set(u.id,v)),v}else return this.noWindowDialogueQueue}showMessageBox(u,v){return this.getWindowDialogQueue(v).queue(async()=>v?E.dialog.showMessageBox(v,u):E.dialog.showMessageBox(u))}async showSaveDialog(u,v){const g=this.acquireFileDialogLock(u,v);if(!g)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(v).queue(async()=>{let f;return v?f=await E.dialog.showSaveDialog(v,u):f=await E.dialog.showSaveDialog(u),f.filePath=this.normalizePath(f.filePath),f})}finally{(0,D.dispose)(g)}}normalizePath(u){return u&&p.isMacintosh&&(u=(0,P.normalizeNFC)(u)),u}normalizePaths(u){return u.map(v=>this.normalizePath(v))}async showOpenDialog(u,v){u.defaultPath&&(await b.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const g=this.acquireFileDialogLock(u,v);if(!g)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(v).queue(async()=>{let f;return v?f=await E.dialog.showOpenDialog(v,u):f=await E.dialog.showOpenDialog(u),f.filePaths=this.normalizePaths(f.filePaths),f})}finally{(0,D.dispose)(g)}}acquireFileDialogLock(u,v){if(!v)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",u);let g=this.windowFileDialogLocks.get(v.id);g||(g=new Set,this.windowFileDialogLocks.set(v.id,g));const f=(0,k.hash)(u);if(!g.has(f))return this.logService.trace("[DialogMainService]: new file dialog lock created",u),g.add(f),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",u),g?.delete(f),g?.size===0&&this.windowFileDialogLocks.delete(v.id)})}};h=we([ie(0,d.ILogService)],h),e.DialogMainService=h}),define(ee[253],te([0,1,3,2,68,28]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(p,S){super(),this.logService=p,this.storageMainService=S,this.onDidChangeApplicationStorageEmitter=this._register(new E.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(S.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(p,S){this._register(E.Event.debounce(p.onDidChangeStorage,(b,I)=>(b?b.push(I):b=[I],b),D.STORAGE_CHANGE_DEBOUNCE_TIME)(b=>{b.length&&S.fire(this.serializeStorageChangeEvents(b,p))}))}serializeStorageChangeEvents(p,S){const b=new Map,I=new Set;return p.forEach(C=>{const d=S.get(C.key);typeof d=="string"?b.set(C.key,d):I.add(C.key)}),{changed:Array.from(b.entries()),deleted:Array.from(I.values())}}listen(p,S,b){switch(S){case"onDidChangeStorage":{const I=b.profile?(0,k.revive)(b.profile):void 0;if(!I)return this.onDidChangeApplicationStorageEmitter.event;let C=this.mapProfileToOnDidChangeProfileStorageEmitter.get(I.id);return C||(C=this._register(new E.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(I),C),this.mapProfileToOnDidChangeProfileStorageEmitter.set(I.id,C)),C.event}}throw new Error(`Event not found: ${S}`)}async call(p,S,b){const I=b.profile?(0,k.revive)(b.profile):void 0,C=(0,R.reviveIdentifier)(b.workspace),d=await this.withStorageInitialized(I,C);switch(S){case"getItems":return Array.from(d.items.entries());case"updateItems":{const m=b;if(m.insert)for(const[h,w]of m.insert)d.set(h,w);m.delete?.forEach(h=>d.delete(h));break}case"isUsed":{const m=b.payload;if(typeof m=="string")return this.storageMainService.isUsed(m)}default:throw new Error(`Call not found: ${S}`)}}async withStorageInitialized(p,S){let b;S?b=this.storageMainService.workspaceStorage(S):p?b=this.storageMainService.profileStorage(p):b=this.storageMainService.applicationStorage;try{await b.init()}catch(I){this.logService.error(`StorageIPC#init: Unable to init ${S?"workspace":p?"profile":"application"} storage due to ${I}`)}return b}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(ee[41],te([0,1,67,3,2,19,7,169,34,15,5,6,28,38,48,8,29,25]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function v(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&D.URI.isUri(i.location)&&D.URI.isUri(i.globalStorageHome)&&D.URI.isUri(i.settingsResource)&&D.URI.isUri(i.keybindingsResource)&&D.URI.isUri(i.tasksResource)&&D.URI.isUri(i.snippetsHome)&&D.URI.isUri(i.extensionsResource))}e.isUserDataProfile=v,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function g(r,i){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:D.URI.revive(r.location).with({scheme:i}),globalStorageHome:D.URI.revive(r.globalStorageHome).with({scheme:i}),settingsResource:D.URI.revive(r.settingsResource).with({scheme:i}),keybindingsResource:D.URI.revive(r.keybindingsResource).with({scheme:i}),tasksResource:D.URI.revive(r.tasksResource).with({scheme:i}),snippetsHome:D.URI.revive(r.snippetsHome).with({scheme:i}),extensionsResource:D.URI.revive(r.extensionsResource)?.with({scheme:i}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=g;function f(r,i,o,s){return{id:r,name:i,location:o,isDefault:!1,shortName:s?.shortName,globalStorageHome:(0,R.joinPath)(o,"globalStorage"),settingsResource:(0,R.joinPath)(o,"settings.json"),keybindingsResource:(0,R.joinPath)(o,"keybindings.json"),tasksResource:(0,R.joinPath)(o,"tasks.json"),snippetsHome:(0,R.joinPath)(o,"snippets"),extensionsResource:(0,R.joinPath)(o,"extensions.json"),useDefaultFlags:s?.useDefaultFlags,isTransient:s?.transient}}e.toUserDataProfile=f;let c=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,o,s,l){super(),this.environmentService=i,this.fileService=o,this.uriIdentityService=s,this.logService=l,this.enabled=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=this.enabled?this.getStoredProfiles().map(a=>f((0,R.basename)(a.location),a.name,a.location,{shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})):[];let o;const s=new d.ResourceMap,l=f((0,E.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.environmentService.userRoamingDataHome);if(i.unshift({...l,isDefault:!0}),i.length){const a=this.getStoredProfileAssociations();if(a.workspaces)for(const[y,M]of Object.entries(a.workspaces)){const T=D.URI.parse(y),U=D.URI.parse(M),Y=i.find(G=>this.uriIdentityService.extUri.isEqual(G.location,U));Y&&s.set(T,Y)}if(a.emptyWindow){const y=D.URI.parse(a.emptyWindow);o=i.find(M=>this.uriIdentityService.extUri.isEqual(M.location,y))}}this._profilesObject={profiles:i,workspaces:s,emptyWindow:o}}return this._profilesObject}async createTransientProfile(i){const o="Temp",s=new RegExp(`${(0,u.escapeRegExpCharacters)(o)}\\s(\\d+)`);let l=0;for(const y of this.profiles){const M=s.exec(y.name),T=M?parseInt(M[1]):0;l=T>l?T:l}const a=`${o} ${l+1}`;return this.createProfile((0,E.hash)((0,w.generateUuid)()).toString(16),a,{transient:!0},i)}async createNamedProfile(i,o,s){return this.createProfile((0,E.hash)((0,w.generateUuid)()).toString(16),i,o,s)}async createProfile(i,o,s,l){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=await this.doCreateProfile(i,o,s);return l&&await this.setProfileForWorkspace(l,a),a}async doCreateProfile(i,o,s){let l=this.profileCreationPromises.get(o);return l||(l=(async()=>{try{const a=this.profiles.find(T=>T.name===o||T.id===i);if(a)return a;const y=f(i,o,(0,R.joinPath)(this.profilesHome,i),s);await this.fileService.createFolder(y.location);const M=[];return this._onWillCreateProfile.fire({profile:y,join(T){M.push(T)}}),await h.Promises.settled(M),this.updateProfiles([y],[],[]),y}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,l)),l}async updateProfile(i,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let s=this.profiles.find(l=>l.id===i.id);if(!s)throw new Error(`Profile '${i.name}' does not exist`);return s=f(s.id,o.name??s.name,s.location,{shortName:o.shortName??s.shortName,transient:o.transient??s.isTransient,useDefaultFlags:o.useDefaultFlags??s.useDefaultFlags}),this.updateProfiles([],[],[s]),s}async removeProfile(i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(i.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(l=>l.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);const s=[];this._onWillRemoveProfile.fire({profile:o,join(l){s.push(l)}});try{await Promise.allSettled(s)}catch(l){this.logService.error(l)}o.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const l of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(l)?.id&&this.profilesObject.workspaces.delete(l);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(o.location,{recursive:!0})}catch(l){this.logService.error(l)}}getOrSetProfileForWorkspace(i,o=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let s=this.getProfileForWorkspace(i);return s||(s=o,this.profiles.length>1&&this.setProfileForWorkspaceSync(i,s)),s}async setProfileForWorkspace(i,o){this.setProfileForWorkspaceSync(i,o)}setProfileForWorkspaceSync(i,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(l=>l.id===o.id);if(!s)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(i,s)}unsetWorkspace(i,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(i,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(o=>o.isDirectory&&this.profiles.every(s=>!this.uriIdentityService.extUri.isEqual(s.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(i.map(o=>this.removeProfile(o)))}getProfileForWorkspace(i){const o=this.getWorkspace(i);return D.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(i){return(0,C.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,C.isWorkspaceIdentifier)(i)?i.configPath:"empty-window"}isProfileAssociatedToWorkspace(i){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,i.location)||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,i.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,i.location)||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,i.location)))}updateProfiles(i,o,s){const l=[...this.profiles,...i],a=[];this.transientProfilesObject.profiles=[];for(let y of l)y.isDefault||o.some(M=>y.id===M.id)||(y=s.find(M=>y.id===M.id)??y,y.isTransient?this.transientProfilesObject.profiles.push(y):a.push({location:y.location,name:y.name,shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}));this.saveStoredProfiles(a),this._profilesObject=void 0,this.triggerProfilesChanges(i,o,s)}triggerProfilesChanges(i,o,s){this._onDidChangeProfiles.fire({added:i,removed:o,updated:s,all:this.profiles})}updateWorkspaceAssociation(i,o,s){s=o?.isTransient?!0:s,s||this.updateWorkspaceAssociation(i,void 0,!0);const l=this.getWorkspace(i),a=s?this.transientProfilesObject:this.profilesObject;D.URI.isUri(l)?(a.workspaces.delete(l),o&&a.workspaces.set(l,o)):a.emptyWindow=o,s||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[s,l]of this.profilesObject.workspaces.entries())i[s.toString()]=l.location.toString();const o=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:i,emptyWindow:o}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}};c.PROFILES_KEY="userDataProfiles",c.PROFILE_ASSOCIATIONS_KEY="profileAssociations",c=we([ie(0,p.IEnvironmentService),ie(1,S.IFileService),ie(2,m.IUriIdentityService),ie(3,I.ILogService)],c),e.UserDataProfilesService=c;class n extends c{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=n}),define(ee[116],te([0,1,24,8,50,17,16,42,135,2,14,9,4,19,186,97,12,7,154,34,110,109,185,15,5,6,20,3,68,87,41,48,184]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u,v,g,f,c,n,r,i,o,s,l,a,y,M,T,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var Y;(function(K){function H(F,A){if(F===A)return!0;const O=Object.keys(F),_=new Set;for(const ne of Object.keys(A))_.add(ne);if(O.length!==_.size)return!1;for(const ne of O){if(F[ne]!==A[ne])return!1;_.delete(ne)}return _.size===0}K.equals=H})(Y=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let G=class extends S.Disposable{constructor(H,F,A,O,_,ne,N,j,L,W,$,q){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=F,this.extensionsControlLocation=A,this.cacheLocation=O,this.userDataProfilesService=_,this.extensionsProfileScannerService=ne,this.fileService=N,this.logService=j,this.environmentService=L,this.productService=W,this.uriIdentityService=$,this.instantiationService=q,this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ae,(0,d.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ae,(0,d.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(oe,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(H,F,A){const[O,_]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(F)]),ne=A?await this.scanExtensionsUnderDevelopment(H,[...O,..._]):[];return this.dedupExtensions(O,_,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const F=[];F.push(this.scanDefaultSystemExtensions(!!H.useCache,H.language)),F.push(this.scanDevSystemExtensions(H.language,!!H.checkControlFile));const[A,O]=await Promise.all(F);return this.applyScanOptions([...A,...O],0,H,!1)}async scanUserExtensions(H){const F=H.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",F);const A=await this.createExtensionScannerInput(F,!!H.profileLocation,1,!H.includeUninstalled,H.language);let _=await(H.useCache&&!A.devMode&&A.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return _=await this.applyScanOptions(_,1,H,!0),this.logService.trace("Scanned user extensions:",_.length),_}async scanExtensionsUnderDevelopment(H,F){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const A=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(O=>O.scheme===b.Schemas.file).map(async O=>{const _=await this.createExtensionScannerInput(O,!1,1,!0,H.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(_)).map(N=>(N.type=F.find(j=>(0,f.areSameExtensions)(j.identifier,N.identifier))?.type??N.type,this.extensionsScanner.validate(N,_)))}))).flat();return this.applyScanOptions(A,"development",H,!0)}return[]}async scanExistingExtension(H,F,A){const O=await this.createExtensionScannerInput(H,!1,F,!0,A.language),_=await this.extensionsScanner.scanExtension(O);return!_||!A.includeInvalid&&!_.isValid?null:_}async scanOneOrMultipleExtensions(H,F,A){const O=await this.createExtensionScannerInput(H,!1,F,!0,A.language),_=await this.extensionsScanner.scanOneOrMultipleExtensions(O);return this.applyScanOptions(_,F,A,!0)}async scanMetadata(H){const F=(0,d.joinPath)(H,"package.json"),A=(await this.fileService.readFile(F)).value.toString();return JSON.parse(A).__metadata}async updateMetadata(H,F){const A=(0,d.joinPath)(H,"package.json"),O=(await this.fileService.readFile(A)).value.toString(),_=JSON.parse(O);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,_.__metadata={..._.__metadata,...F},await this.fileService.writeFile((0,d.joinPath)(H,"package.json"),R.VSBuffer.fromString(JSON.stringify(_,null,"	")))}async applyScanOptions(H,F,A,O){return A.includeAllVersions||(H=this.dedupExtensions(F===0?H:void 0,F===1?H:void 0,F==="development"?H:void 0,await this.getTargetPlatform(),O)),A.includeInvalid||(H=H.filter(_=>_.isValid)),H.sort((_,ne)=>{const N=I.basename(_.location.fsPath),j=I.basename(ne.location.fsPath);return N<j?-1:N>j?1:0})}dedupExtensions(H,F,A,O,_){const ne=(j,L,W)=>{if(j.isValid&&!L.isValid)return!1;if(j.isValid===L.isValid){if(_&&m.gt(j.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${j.location.path} with version ${j.manifest.version}`),!1;if(m.eq(j.manifest.version,L.manifest.version)){if(j.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${j.location.path} with same version`),!1;if(j.targetPlatform===O)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return W?this.logService.warn(`Overwriting user extension ${j.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${j.location.path} with ${L.location.path}.`),!0},N=new Map;return H?.forEach(j=>{const L=c.ExtensionIdentifier.toKey(j.identifier.id),W=N.get(L);(!W||ne(W,j,!1))&&N.set(L,j)}),F?.forEach(j=>{const L=c.ExtensionIdentifier.toKey(j.identifier.id),W=N.get(L);if(!W&&H&&j.type===0){this.logService.debug(`Skipping obsolete system extension ${j.location.path}.`);return}(!W||ne(W,j,!1))&&N.set(L,j)}),A?.forEach(j=>{const L=c.ExtensionIdentifier.toKey(j.identifier.id),W=N.get(L);(!W||ne(W,j,!0))&&N.set(L,j),N.set(L,j)}),[...N.values()]}async scanDefaultSystemExtensions(H,F){this.logService.trace("Started scanning system extensions");const A=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,F),_=await(H&&!A.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return this.logService.trace("Scanned system extensions:",_.length),_}async scanDevSystemExtensions(H,F){const A=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!A?.length)return[];this.logService.trace("Started scanning dev system extensions");const O=F?await this.getBuiltInExtensionControl():{},_=[],ne=u.URI.file(I.normalize(I.join(b.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions")));for(const j of A){const L=O[j.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":_.push((0,d.joinPath)(ne,j.name));break;default:_.push(u.URI.file(L));break}}const N=await Promise.all(_.map(async j=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(j,!1,0,!0,H))));return this.logService.trace("Scanned dev system extensions:",N.length),(0,E.coalesce)(N)}async getBuiltInExtensionControl(){try{const H=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(H.value.toString())}catch{return{}}}async createExtensionScannerInput(H,F,A,O,_,ne=!0){const N=await this.getTranslations(_??C.language),j=await this.getMtime(H),L=F&&!this.uriIdentityService.extUri.isEqual(H,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,W=L?await this.getMtime(L):void 0;return new V(H,j,L,W,F,A,O,ne,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,_,N)}async getMtime(H){try{const F=await this.fileService.stat(H);if(typeof F.mtime=="number")return F.mtime}catch{}}};G=we([ie(4,M.IUserDataProfilesService),ie(5,y.IExtensionsProfileScannerService),ie(6,r.IFileService),ie(7,o.ILogService),ie(8,g.IEnvironmentService),ie(9,s.IProductService),ie(10,T.IUriIdentityService),ie(11,i.IInstantiationService)],G),e.AbstractExtensionsScannerService=G;class V{constructor(H,F,A,O,_,ne,N,j,L,W,$,q,X,re){this.location=H,this.mtime=F,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=O,this.profile=_,this.type=ne,this.excludeObsolete=N,this.validate=j,this.productVersion=L,this.productDate=W,this.productCommit=$,this.devMode=q,this.language=X,this.translations=re}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,F){return(0,d.isEqual)(H.location,F.location)&&H.mtime===F.mtime&&(0,d.isEqual)(H.applicationExtensionslocation,F.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&H.profile===F.profile&&H.type===F.type&&H.excludeObsolete===F.excludeObsolete&&H.validate===F.validate&&H.productVersion===F.productVersion&&H.productDate===F.productDate&&H.productCommit===F.productCommit&&H.devMode===F.devMode&&H.language===F.language&&Y.equals(H.translations,F.translations)}}let oe=class extends S.Disposable{constructor(H,F,A,O,_){super(),this.obsoleteFile=H,this.extensionsProfileScannerService=F,this.uriIdentityService=A,this.fileService=O,this.logService=_}async scanExtensions(H){const F=H.profile?await this.scanExtensionsFromProfile(H):await this.scanExtensionsFromLocation(H);let A={};if(H.excludeObsolete&&H.type===1)try{const O=(await this.fileService.readFile(this.obsoleteFile)).value.toString();A=JSON.parse(O)}catch{}return(0,w.isEmptyObject)(A)?F:F.filter(O=>!A[f.ExtensionKey.create(O).toString()])}async scanExtensionsFromLocation(H){const F=await this.fileService.resolve(H.location);if(!F.children?.length)return[];const A=await Promise.all(F.children.map(async O=>{if(!O.isDirectory||H.type===1&&(0,d.basename)(O.resource).indexOf(".")===0)return null;const _=new V(O.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(_)}));return(0,E.coalesce)(A).sort((O,_)=>O.location.path<_.location.path?-1:1)}async scanExtensionsFromProfile(H){let F=await this.scanExtensionsFromProfileResource(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(H.location,H.applicationExtensionslocation)){F=F.filter(O=>!O.metadata?.isApplicationScoped);const A=await this.scanExtensionsFromProfileResource(H.applicationExtensionslocation,O=>!!O.metadata?.isApplicationScoped,H);F.push(...A)}return F}async scanExtensionsFromProfileResource(H,F,A){const O=await this.extensionsProfileScannerService.scanProfileExtensions(H);if(!O.length)return[];const _=await Promise.all(O.map(async ne=>{if(F(ne)){const N=new V(ne.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(N,ne.metadata)}return null}));return(0,E.coalesce)(_)}async scanOneOrMultipleExtensions(H){try{if(await this.fileService.exists((0,d.joinPath)(H.location,"package.json"))){const F=await this.scanExtension(H);return F?[F]:[]}else return await this.scanExtensions(H)}catch(F){return this.logService.error(`Error scanning extensions at ${H.location.path}:`,(0,D.getErrorMessage)(F)),[]}}async scanExtension(H,F){try{let A=await this.scanExtensionManifest(H.location);if(A){A.publisher||(A.publisher=c.UNDEFINED_PUBLISHER),F=F??A.__metadata,delete A.__metadata;const O=(0,f.getGalleryExtensionId)(A.publisher,A.name),_=F?.id?{id:O,uuid:F.id}:{id:O},ne=F?.isSystem?0:H.type,N=ne===0||!!F?.isBuiltin;A=await this.translateManifest(H.location,A,V.createNlsConfiguration(H));const j={type:ne,identifier:_,manifest:A,location:H.location,isBuiltin:N,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return H.validate?this.validate(j,H):j}}catch(A){H.type!==0&&this.logService.error(A)}return null}validate(H,F){let A=!0;const O=(0,n.validateExtensionManifest)(F.productVersion,F.productDate,F.location,H.manifest,H.isBuiltin);for(const[_,ne]of O)_===h.default.Error&&(A=!1,this.logService.error(this.formatMessage(F.location,ne)));return H.isValid=A,H.validations=O,H}async scanExtensionManifest(H){const F=(0,d.joinPath)(H,"package.json");let A;try{A=(await this.fileService.readFile(F)).value.toString()}catch(_){return(0,r.toFileOperationResult)(_)!==1&&this.logService.error(this.formatMessage(H,(0,v.localize)(0,null,F.path,_.message))),null}let O;try{O=JSON.parse(A)}catch{const ne=[];(0,P.parse)(A,ne);for(const N of ne)this.logService.error(this.formatMessage(H,(0,v.localize)(1,null,F.path,N.offset,N.length,(0,p.getParseErrorMessage)(N.error))));return null}return(0,P.getNodeType)(O)!=="object"?(this.logService.error(this.formatMessage(H,(0,v.localize)(2,null,F.path))),null):O}async translateManifest(H,F,A){const O=await this.getLocalizedMessages(H,F,A);if(O)try{const _=[],ne=await this.resolveOriginalMessageBundle(O.default,_);if(_.length>0)return _.forEach(j=>{this.logService.error(this.formatMessage(H,(0,v.localize)(3,null,O.default?.path,(0,p.getParseErrorMessage)(j.error))))}),F;if((0,P.getNodeType)(O)!=="object")return this.logService.error(this.formatMessage(H,(0,v.localize)(4,null,O.default?.path))),F;const N=O.values||Object.create(null);return(0,U.localizeManifest)(F,N,ne)}catch{}return F}async getLocalizedMessages(H,F,A){const O=(0,d.joinPath)(H,"package.nls.json"),_=(L,W)=>{W.forEach($=>{this.logService.error(this.formatMessage(H,(0,v.localize)(5,null,L?.path,(0,p.getParseErrorMessage)($.error))))})},ne=L=>{this.logService.error(this.formatMessage(H,(0,v.localize)(6,null,L?.path)))},N=`${F.publisher}.${F.name}`,j=A.translations[N];if(j)try{const L=u.URI.file(j),W=(await this.fileService.readFile(L)).value.toString(),$=[],q=(0,P.parse)(W,$);return $.length>0?(_(L,$),{values:void 0,default:O}):(0,P.getNodeType)(q)!=="object"?(ne(L),{values:void 0,default:O}):{values:q.contents?q.contents.package:void 0,default:O}}catch{return{values:void 0,default:O}}else{if(!await this.fileService.exists(O))return;let W;try{W=await this.findMessageBundles(H,A)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const $=(await this.fileService.readFile(W.localized)).value.toString(),q=[],X=(0,P.parse)($,q);return q.length>0?(_(W.localized,q),{values:void 0,default:W.original}):(0,P.getNodeType)(X)!=="object"?(ne(W.localized),{values:void 0,default:W.original}):{values:X,default:W.original}}catch{return{values:void 0,default:W.original}}}}async resolveOriginalMessageBundle(H,F){if(H)try{const A=(await this.fileService.readFile(H)).value.toString();return(0,P.parse)(A,F)}catch{}}findMessageBundles(H,F){return new Promise((A,O)=>{const _=ne=>{const N=(0,d.joinPath)(H,`package.nls.${ne}.json`);this.fileService.exists(N).then(j=>{j&&A({localized:N,original:(0,d.joinPath)(H,"package.nls.json")});const L=ne.lastIndexOf("-");L===-1?A({localized:(0,d.joinPath)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,L),_(ne))})};if(F.devMode||F.pseudo||!F.language)return A({localized:(0,d.joinPath)(H,"package.nls.json"),original:null});_(F.language)})}formatMessage(H,F){return`[${H.path}]: ${F}`}};oe=we([ie(1,y.IExtensionsProfileScannerService),ie(2,T.IUriIdentityService),ie(3,r.IFileService),ie(4,o.ILogService)],oe);let ae=class extends oe{constructor(H,F,A,O,_,ne){super(F,A,O,_,ne),this.cacheFile=H,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(H){const F=await this.readExtensionCache();if(this.input=H,F&&F.input&&V.equals(F.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),F.result.map(O=>(O.location=u.URI.revive(O.location),O));const A=await super.scanExtensions(H);return await this.writeExtensionCache({input:H,result:A}),A}async readExtensionCache(){try{const H=await this.fileService.readFile(this.cacheFile),F=JSON.parse(H.value.toString());return{result:F.result,input:(0,a.revive)(F.input)}}catch(H){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(H))}return null}async writeExtensionCache(H){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(H)))}catch(F){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(F))}}async validateCache(){if(!this.input)return;const H=await this.readExtensionCache();if(!H)return;const F=H.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(A,F))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(O){this.logService.error(O)}}};ae=we([ie(2,y.IExtensionsProfileScannerService),ie(3,T.IUriIdentityService),ie(4,r.IFileService),ie(5,o.ILogService)],ae);function se(K,H){const F=(0,f.getExtensionId)(K.manifest.publisher,K.manifest.name);return{id:F,identifier:new c.ExtensionIdentifier(F),isBuiltin:K.type===0,isUserBuiltin:K.type===1&&K.isBuiltin,isUnderDevelopment:H,extensionLocation:K.location,uuid:K.identifier.uuid,targetPlatform:K.targetPlatform,...K.manifest}}e.toExtensionDescription=se;class fe extends G{constructor(H,F,A,O,_,ne,N,j,L,W,$,q){super(H,F,(0,d.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,d.joinPath)(O,c.MANIFEST_CACHE_FOLDER),_,ne,N,j,L,W,$,q),this.translationsPromise=(async()=>{if(C.translationsConfigFile)try{const X=await this.fileService.readFile(u.URI.file(C.translationsConfigFile));return JSON.parse(X.value.toString())}catch{}return Object.create(null)})()}getTranslations(H){return this.translationsPromise}}e.NativeExtensionsScannerService=fe}),define(ee[254],te([0,1,7,34,87,116,15,5,6,20,48,41]),function(z,e,E,t,k,R,D,P,p,S,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let C=class extends R.NativeExtensionsScannerService{constructor(m,h,w,u,v,g,f,c){super(E.URI.file(v.builtinExtensionsPath),E.URI.file(v.extensionsPath),v.userHome,E.URI.file(v.userDataPath),m,h,w,u,v,g,f,c)}};C=we([ie(0,I.IUserDataProfilesService),ie(1,k.IExtensionsProfileScannerService),ie(2,D.IFileService),ie(3,p.ILogService),ie(4,t.INativeEnvironmentService),ie(5,S.IProductService),ie(6,b.IUriIdentityService),ie(7,P.IInstantiationService)],C),e.ExtensionsScannerService=C}),define(ee[255],te([0,1,13,2,14,9,4,58,7,29,40,34,6,41]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let m=class extends t.Disposable{constructor(w,u,v){super(),this.environmentService=w,this.logService=v,this.validRoots=P.TernarySearchTree.forPaths(!D.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(w.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:w}=E.session;w.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(u,v)=>this.handleResourceRequest(u,v)),w.protocol.interceptFileProtocol(k.Schemas.file,(u,v)=>this.handleFileRequest(u,v)),this._register((0,t.toDisposable)(()=>{w.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(w){const u=(0,R.normalize)(w);return this.validRoots.get(u)?t.Disposable.None:(this.validRoots.set(u,!0),(0,t.toDisposable)(()=>this.validRoots.delete(u)))}handleFileRequest(w,u){const v=p.URI.parse(w.url);return this.logService.error(`Refused to load resource ${v.fsPath} from ${k.Schemas.file}: protocol (original URL: ${w.url})`),u({error:-3})}handleResourceRequest(w,u){const v=this.requestToNormalizedFilePath(w);let g;return this.environmentService.crossOriginIsolated&&((0,R.basename)(v)==="workbench.html"||(0,R.basename)(v)==="workbench-dev.html"?g=k.COI.CoopAndCoep:g=k.COI.getHeadersFromQuery(w.url)),this.validRoots.findSubstr(v)?u({path:v,headers:g}):this.validExtensions.has((0,R.extname)(v).toLowerCase())?u({path:v}):(this.logService.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${v} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),u({error:-3}))}requestToNormalizedFilePath(w){const u=p.URI.parse(w.url),v=k.FileAccess.asFileUri(u);return(0,R.normalize)(v.fsPath)}createIPCObjectUrl(){let w;const u=p.URI.from({scheme:"vscode",path:(0,S.generateUuid)()}),v=u.toString(),g=async()=>w;return b.validatedIpcMain.handle(v,g),this.logService.trace(`IPC Object URL: Registered new channel ${v}.`),{resource:u,update:f=>w=f,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${v}.`),b.validatedIpcMain.removeHandler(v)}}}};m=we([ie(0,I.INativeEnvironmentService),ie(1,d.IUserDataProfilesService),ie(2,C.ILogService)],m),e.ProtocolMainService=m}),define(ee[256],te([0,1,13,40,8,3,2,14,12,102,26,21,6,54,61,64,43,41,36]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends D.Disposable{constructor(c,n,r,i,o,s,l,a,y){super(),this.machineId=c,this.userEnv=n,this.environmentMainService=r,this.userDataProfilesService=i,this.lifecycleMainService=o,this.logService=s,this.policyService=l,this.themeMainService=a,this.protocolMainService=y,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(c,n)=>this.onWindowConnection(c,n)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(c,n)=>this.onWorkerConnection(c,n)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(c,n){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const r=await this.connect();if(c.sender.isDestroyed())return r.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",n,[r])}onWorkerConnection(c,n){this.logService.trace("SharedProcess: onWorkerConnection",n);const r=new D.DisposableStore,i=s=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${s}')`,n),r.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",n))},o=E.BrowserWindow.fromId(n.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!n.reply.channel){i("unavailable");return}r.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===o)(()=>i("load"))),r.add(R.Event.fromNodeEventEmitter(o,"closed")(()=>i("closed"))),o.webContents.postMessage(n.reply.channel,n.reply.nonce,c.ports)}onWillShutdown(){const c=this.window;!c||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch{}this.window=void 0},0))}send(c,...n){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${c}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(c,...n)}catch(r){this.logService.warn(`Error sending IPC message to channel '${c}' of shared process: ${(0,w.toErrorMessage)(r)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new E.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:d.default,policiesData:this.policyService.serialize()}),this.window.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,n)=>this._onDidError.fire({type:2,details:n})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,n,r)=>this._onDidError.fire({type:3,details:{reason:r,exitCode:n}})))}async connect(){await this.whenIpcReady;const c=(0,p.assertIsDefined)(this.window);return(0,S.connect)(c)}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const c=this.window;return c?!c.isDestroyed()&&!c.webContents.isDestroyed():!1}};g=we([ie(2,b.IEnvironmentMainService),ie(3,u.IUserDataProfilesService),ie(4,I.ILifecycleMainService),ie(5,C.ILogService),ie(6,v.IPolicyService),ie(7,h.IThemeMainService),ie(8,m.IProtocolMainService)],g),e.SharedProcess=g}),define(ee[90],te([0,1,8,3,2,72,12,103,5,41]),function(z,e,E,t,k,R,D,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,p.createDecorator)("storageService");var b;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var I;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(I=e.StorageScope||(e.StorageScope={}));var C;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));function d(v){const g=v.get(e.TARGET_KEY);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.loadKeyTargets=d;class m extends k.Disposable{constructor(g={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super(),this.options=g,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new E.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,E.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,f){if(f===e.TARGET_KEY){switch(g){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:f,target:this.getKeyTargets(g)[f]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,f,c){return this.getStorage(f)?.get(g,c)}getBoolean(g,f,c){return this.getStorage(f)?.getBoolean(g,c)}getNumber(g,f,c){return this.getStorage(f)?.getNumber(g,c)}store(g,f,c,n){if((0,D.isUndefinedOrNull)(f)){this.remove(g,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,c,n),this.getStorage(c)?.set(g,f)})}remove(g,f){this.withPausedEmitters(()=>{this.updateKeyTarget(g,f,void 0),this.getStorage(f)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,f){const c=[],n=this.getKeyTargets(g);for(const r of Object.keys(n))n[r]===f&&c.push(r);return c}updateKeyTarget(g,f,c){const n=this.getKeyTargets(f);typeof c=="number"?n[g]!==c&&(n[g]=c,this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[g]=="number"&&(delete n[g],this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const f=this.getStorage(g);return f?d(f):Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=b.NONE){this._onWillSaveState.fire({reason:g});const f=this.getStorage(-1),c=this.getStorage(0),n=this.getStorage(1);switch(g){case b.NONE:await E.Promises.settled([f?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await E.Promises.settled([f?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return u(g,f,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(g,f){return this.emitWillSaveState(b.NONE),(0,S.isUserDataProfile)(g)?this.switchToProfile(g,f):this.switchToWorkspace(g,f)}canSwitchProfile(g,f){return!(g.id===f.id||h(f)&&h(g))}switchData(g,f,c,n){this.withPausedEmitters(()=>{if(n)for(const[r,i]of g)f.set(r,i);else{const r=new Set;for(const[i,o]of g)r.add(i),f.get(i)!==o&&this.emitDidChangeValue(c,i);for(const[i]of f.items)r.has(i)||this.emitDidChangeValue(c,i)}})}}e.AbstractStorageService=m,m.DEFAULT_FLUSH_INTERVAL=60*1e3;function h(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=h;class w extends m{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g)))}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(g){return!1}}e.InMemoryStorageService=w;async function u(v,g,f,c,n,r){const i=Y=>{try{return JSON.parse(Y)}catch{return Y}},o=new Map,s=new Map;v.forEach((Y,G)=>{o.set(G,Y),s.set(G,i(Y))});const l=new Map,a=new Map;g.forEach((Y,G)=>{l.set(G,Y),a.set(G,i(Y))});const y=new Map,M=new Map;f.forEach((Y,G)=>{y.set(G,Y),M.set(G,i(Y))}),console.group(c!==n?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const T=[];if(o.forEach((Y,G)=>{T.push({key:G,value:Y})}),console.table(T),console.groupEnd(),console.log(s),c!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const Y=[];l.forEach((G,V)=>{Y.push({key:V,value:G})}),console.table(Y),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const U=[];y.forEach((Y,G)=>{U.push({key:G,value:Y})}),console.table(U),console.groupEnd(),console.log(M)}e.logStorage=u}),define(ee[257],te([0,1,24,8,3,2,9,80,7,23,103,146,6,90,35,28]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class w extends R.Disposable{get storage(){return this._storage}constructor(r,i){super(),this.logService=r,this.fileService=i,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new b.Storage(new b.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=b.StorageState.None}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===b.StorageState.None)try{const r=await this.doCreate();this._storage.dispose(),this._storage=r,this._register(r.onDidChangeStorage(o=>this._onDidChangeStorage.fire({key:o}))),await this.doInit(r);const i=r.getBoolean(d.IS_NEW_KEY);i===void 0?r.set(d.IS_NEW_KEY,!0):i&&r.set(d.IS_NEW_KEY,!1)}catch(r){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.state=b.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===C.LogLevel.Trace?r=>this.logService.trace(r):void 0,logError:r=>this.logService.error(r)}}doInit(r){return r.init()}get items(){return this._storage.items}get(r,i){return this._storage.get(r,i)}set(r,i){return this._storage.set(r,i)}delete(r){return this._storage.delete(r)}async close(){const r=new P.StopWatch(!1);await this.doClose(),r.stop(),r.elapsed()>w.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(r),this._onDidCloseStorage.fire()}async logSlowClose(r){if(!!this.path)try{const i=(0,E.top)(Array.from(this._storage.items.entries()).map(([s,l])=>({key:s,length:l.length})),(s,l)=>l.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),o=(await this.fileService.stat(p.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${o}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=b.StorageState.Closed,await this._storage.close()}}w.LOG_SLOW_CLOSE_THRESHOLD=2e3;class u extends w{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,u.STORAGE_NAME)}constructor(r,i,o,s){super(o,s),this.profile=r,this.options=i}async doCreate(){return new b.Storage(new I.SQLiteStorageDatabase(this.path??I.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}u.STORAGE_NAME="state.vscdb";class v extends u{constructor(r,i,o,s){super(r,i,o,s)}}e.ProfileStorageMain=v;class g extends u{constructor(r,i,o,s){super(i.defaultProfile,r,o,s)}async doInit(r){await super.doInit(r),this.updateTelemetryState(r)}updateTelemetryState(r){r.get(m.firstSessionDateStorageKey,void 0)===void 0&&r.set(m.firstSessionDateStorageKey,new Date().toUTCString());const o=r.get(m.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();r.set(m.lastSessionDateStorageKey,typeof o>"u"?null:o),r.set(m.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=g;class f extends w{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,f.WORKSPACE_STORAGE_NAME)}constructor(r,i,o,s,l){super(o,l),this.workspace=r,this.options=i,this.environmentService=s}async doCreate(){const{storageFilePath:r,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new b.Storage(new I.SQLiteStorageDatabase(r,{logging:this.createLoggingOptions()}),{hint:i?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:I.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,D.join)(r,f.WORKSPACE_STORAGE_NAME);return await S.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await S.Promises.mkdir(r,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(r),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(r){let i;if((0,h.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,h.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const o=(0,D.join)(r,f.WORKSPACE_META_NAME);await S.Promises.exists(o)||await S.Promises.writeFile(o,JSON.stringify(i,void 0,2))}catch(o){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.WorkspaceStorageMain=f,f.WORKSPACE_STORAGE_NAME="state.vscdb",f.WORKSPACE_META_NAME="workspace.json";class c extends w{get path(){}async doCreate(){return new b.Storage(new b.InMemoryStorageDatabase)}}e.InMemoryStorageMain=c}),define(ee[258],te([0,1,68,34,15,6,227,48,41]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let S=class At extends p.UserDataProfilesService{constructor(I,C,d,m,h){super(d,m,C,h),this.stateService=I}getStoredProfiles(){return(0,E.revive)(this.stateService.getItem(At.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,E.revive)(this.stateService.getItem(At.PROFILE_ASSOCIATIONS_KEY,{}))}};S=we([ie(0,D.IStateService),ie(1,P.IUriIdentityService),ie(2,t.IEnvironmentService),ie(3,k.IFileService),ie(4,R.ILogService)],S),e.UserDataProfilesService=S}),define(ee[51],te([0,1,7,34,15,5,6,37,48,41,258]),function(z,e,E,t,k,R,D,P,p,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(S.IUserDataProfilesService);let I=class ht extends b.UserDataProfilesService{constructor(d,m,h,w,u){super(d,m,h,w,u),this.stateMainService=d}setEnablement(d){super.setEnablement(d),this.enabled||(this.saveStoredProfiles([]),this.saveStoredProfileAssociations({}))}saveStoredProfiles(d){d.length?this.stateMainService.setItem(ht.PROFILES_KEY,d):this.stateMainService.removeItem(ht.PROFILES_KEY)}saveStoredProfileAssociations(d){d.emptyWindow||d.workspaces?this.stateMainService.setItem(ht.PROFILE_ASSOCIATIONS_KEY,d):this.stateMainService.removeItem(ht.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const d="workspaceAndProfileInfo",m=this.stateMainService.getItem(d,void 0);if(m){this.stateMainService.removeItem(d);const h=m.reduce((w,{workspace:u,profile:v})=>(w[E.URI.revive(u).toString()]=E.URI.revive(v).toString(),w),{});this.stateMainService.setItem(ht.PROFILE_ASSOCIATIONS_KEY,{workspaces:h})}return super.getStoredProfileAssociations()}};I=we([ie(0,P.IStateMainService),ie(1,p.IUriIdentityService),ie(2,t.IEnvironmentService),ie(3,k.IFileService),ie(4,D.ILogService)],I),e.UserDataProfilesMainService=I}),define(ee[91],te([0,1,7,49,3,2,34,15,5,21,6,90,257,41,51,48]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,p.createDecorator)("storageMainService");let w=class extends R.Disposable{constructor(g,f,c,n,r,i){super(),this.logService=g,this.environmentService=f,this.userDataProfilesService=c,this.lifecycleMainService=n,this.fileService=r,this.uriIdentityService=i,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new k.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(g=>{g.window.profile&&this.profileStorage(g.window.profile).init(),g.workspace&&this.workspaceStorage(g.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(g=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=g.reason,g.join(this.applicationStorage.close());for(const[,f]of this.mapProfileToStorage)g.join(f.close());for(const[,f]of this.mapWorkspaceToStorage)g.join(f.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(g=>{g.join((async()=>{await this.fileService.exists(g.profile.globalStorageHome)||await this.fileService.createFolder(g.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(g=>{const f=this.mapProfileToStorage.get(g.profile.id);f&&g.join(f.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const g=new C.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,t.once)(g.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),g}profileStorage(g){if((0,I.isProfileUsingDefaultStorage)(g))return this.applicationStorage;let f=this.mapProfileToStorage.get(g.id);if(!f){this.logService.trace(`StorageMainService: creating profile storage (${g.name})`),f=this.createProfileStorage(g),this.mapProfileToStorage.set(g.id,f);const c=this._register(f.onDidChangeStorage(n=>this._onDidChangeProfileStorage.fire({...n,storage:f,profile:g})));(0,t.once)(f.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${g.name})`),this.mapProfileToStorage.delete(g.id),c.dispose()})}return f}createProfileStorage(g){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService,this.fileService):new C.ProfileStorageMain(g,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(g){let f=this.mapWorkspaceToStorage.get(g.id);return f||(this.logService.trace(`StorageMainService: creating workspace storage (${g.id})`),f=this.createWorkspaceStorage(g),this.mapWorkspaceToStorage.set(g.id,f),(0,t.once)(f.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${g.id})`),this.mapWorkspaceToStorage.delete(g.id)})),f}createWorkspaceStorage(g){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService,this.fileService):new C.WorkspaceStorageMain(g,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(g){const f=E.URI.file(g);for(const c of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(!!c.path&&this.uriIdentityService.extUri.isEqualOrParent(E.URI.file(c.path),f))return!0;return!1}};w=we([ie(0,b.ILogService),ie(1,D.IEnvironmentService),ie(2,m.IUserDataProfilesMainService),ie(3,S.ILifecycleMainService),ie(4,P.IFileService),ie(5,h.IUriIdentityService)],w),e.StorageMainService=w,e.IApplicationStorageMainService=(0,p.createDecorator)("applicationStorageMainService");let u=class extends I.AbstractStorageService{constructor(g,f){super(),this.userDataProfilesService=g,this.storageMainService=f,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(g){if(g===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(g){if(g===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};u=we([ie(0,d.IUserDataProfilesService),ie(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(ee[259],te([0,1,2,21,51]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends E.Disposable{constructor(P,p){super(),this.userDataProfilesService=p,this._register(P.onWillLoadWindow(S=>{S.reason===2&&this.unsetTransientProfileForWorkspace(S.window.openedWorkspace??"empty-window")})),this._register(P.onBeforeCloseWindow(S=>this.unsetTransientProfileForWorkspace(S.openedWorkspace??"empty-window")))}async unsetTransientProfileForWorkspace(P){this.userDataProfilesService.getOrSetProfileForWorkspace(P).isTransient&&(this.userDataProfilesService.unsetWorkspace(P,!0),await this.userDataProfilesService.cleanUpTransientProfiles())}};R=we([ie(0,t.ILifecycleMainService),ie(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(ee[260],te([0,1,3,2,90]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends t.Disposable{constructor(P,p,S){super(),this.storageMainService=P,this.userDataProfilesService=p,this.logService=S;const b=this._register(new t.MutableDisposable);this._onDidChange=this._register(new E.Emitter({onWillAddFirstListener:()=>b.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>b.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new t.DisposableStore;return P.add(E.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(p,S)=>(p?p.push(S.key):p=[S.key],p),100)(p=>this.onDidChangeApplicationStorage(p))),P.add(E.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(p,S)=>{p||(p=new Map);let b=p.get(S.profile.id);return b||p.set(S.profile.id,b={profile:S.profile,keys:[],storage:S.storage}),b.keys.push(S.key),p},100)(p=>this.onDidChangeProfileStorage(p))),P}onDidChangeApplicationStorage(P){const p=P.includes(k.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],S=[];if(P=P.filter(b=>b!==k.TARGET_KEY),P.length){const b=(0,k.loadKeyTargets)(this.storageMainService.applicationStorage.storage);S.push({profile:this.userDataProfilesService.defaultProfile,changes:P.map(I=>({key:I,scope:0,target:b[I]}))})}this.triggerEvents(p,S)}onDidChangeProfileStorage(P){const p=[],S=new Map;for(const[b,I]of P.entries()){I.keys.includes(k.TARGET_KEY)&&p.push(I.profile);const C=I.keys.filter(d=>d!==k.TARGET_KEY);if(C.length){const d=(0,k.loadKeyTargets)(I.storage.storage);S.set(b,{profile:I.profile,changes:C.map(m=>({key:m,scope:0,target:d[m]}))})}}this.triggerEvents(p,[...S.values()])}triggerEvents(P,p){(P.length||p.length)&&this._onDidChange.fire({valueChanges:p,targetChanges:P})}listen(P,p,S){switch(p){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${p}`)}async call(P,p){throw new Error(`Call not found: ${p}`)}}e.ProfileStorageChangesListenerChannel=R}),define(ee[117],te([0,1,19,7,28]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(p,S,b){for(const C of p){const d=C.openedWorkspace;if((0,k.isWorkspaceIdentifier)(d)){const m=await b(d);if(m){if(m.folders.some(h=>E.extUriBiasedIgnorePathCase.isEqualOrParent(S,h.uri)))return C}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(S,d.configPath))return C}}const I=p.filter(C=>(0,k.isSingleFolderWorkspaceIdentifier)(C.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(S,C.openedWorkspace.uri));if(I.length)return I.sort((C,d)=>-(C.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(p,S){for(const b of p)if((0,k.isWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.configPath,S)||(0,k.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.uri,S))return b}e.findWindowOnWorkspaceOrFolder=D;function P(p,S){const b=I=>S.some(C=>E.extUriBiasedIgnorePathCase.isEqual(t.URI.file(C),t.URI.file(I)));for(const I of p)if(I.config?.extensionDevelopmentPath?.some(C=>b(C)))return I}e.findWindowOnExtensionDevelopmentPath=P}),define(ee[261],te([0,1,13,2,4,19,7,18,21,6,37,31,115,28]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let m=class Tt extends t.Disposable{get state(){return this._state}constructor(f,c,n,r,i){super(),this.windowsMainService=f,this.stateMainService=c,this.lifecycleMainService=n,this.logService=r,this.configurationService=i,this._state=h(this.stateMainService.getItem(Tt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){E.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(f=>this.onBeforeCloseWindow(f)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(f=>{f.newCount-f.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(f=>this.onBeforeCloseWindow(f))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const f=new Set,c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(o=>!o.isExtensionDevelopmentHost)),i&&(c.lastActiveWindow=this.toWindowState(i),c.lastActiveWindow.uiState.mode===3&&f.add(c.lastActiveWindow.uiState.display))}const n=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);n&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(n),c.lastPluginDevelopmentHostWindow.uiState.mode===3&&(f.has(c.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!n.win?.isSimpleFullScreen()&&(c.lastPluginDevelopmentHostWindow.uiState.mode=1):f.add(c.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const o=this.toWindowState(i);return o.uiState.mode===3&&(f.has(o.uiState.display)?k.isMacintosh&&o.windowId!==c.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(o.uiState.mode=1):f.add(o.uiState.display)),o}));const r=u(c);this.stateMainService.setItem(Tt.windowsStateStorageKey,r),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",r)}onBeforeCloseWindow(f){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(f);f.isExtensionDevelopmentHost&&!f.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!f.isExtensionDevelopmentHost&&f.openedWorkspace&&this._state.openedWindows.forEach(n=>{const r=(0,d.isWorkspaceIdentifier)(f.openedWorkspace)&&n.workspace?.id===f.openedWorkspace.id,i=(0,d.isSingleFolderWorkspaceIdentifier)(f.openedWorkspace)&&n.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(n.folderUri,f.openedWorkspace.uri);(r||i)&&(n.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(f){return{windowId:f.id,workspace:(0,d.isWorkspaceIdentifier)(f.openedWorkspace)?f.openedWorkspace:void 0,folderUri:(0,d.isSingleFolderWorkspaceIdentifier)(f.openedWorkspace)?f.openedWorkspace.uri:void 0,backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.serializeWindowState()}}getNewWindowState(f){const c=this.doGetNewWindowState(f),n=this.configurationService.getValue("window");if(c.mode===3){let r;c.hasDefaultState?r=!!(n?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(n.newWindowDimensions)>=0):r=!!(this.lifecycleMainService.wasRestarted||n?.restoreFullscreen),r||(c.mode=1)}return c}doGetNewWindowState(f){const c=this.windowsMainService.getLastActiveWindow();if(!f.extensionTestsPath){if(!!f.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=f.workspace;if((0,d.isWorkspaceIdentifier)(l)){const y=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===l.id).map(M=>M.uiState);if(y.length)return y[0]}if((0,d.isSingleFolderWorkspaceIdentifier)(l)){const y=this.state.openedWindows.filter(M=>M.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(M.folderUri,l.uri)).map(M=>M.uiState);if(y.length)return y[0]}else if(f.backupPath){const y=this.state.openedWindows.filter(M=>M.backupPath===f.backupPath).map(M=>M.uiState);if(y.length)return y[0]}const a=this.lastClosedState||this.state.lastActiveWindow;if(!c&&a)return a.uiState}let n;const r=E.screen.getAllDisplays();if(r.length===1)n=r[0];else{if(k.isMacintosh){const l=E.screen.getCursorScreenPoint();n=E.screen.getDisplayNearestPoint(l)}!n&&c&&(n=E.screen.getDisplayMatching(c.getBounds())),n||(n=E.screen.getPrimaryDisplay()||r[0])}let i=(0,C.defaultWindowState)();i.x=Math.round(n.bounds.x+n.bounds.width/2-i.width/2),i.y=Math.round(n.bounds.y+n.bounds.height/2-i.height/2);const o=this.configurationService.getValue("window");let s=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")i.mode=0,s=!1;else if(o.newWindowDimensions==="fullscreen")i.mode=3,s=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&c){const l=c.serializeWindowState();l.mode===3?i.mode=3:i=l,s=i.mode!==3&&o.newWindowDimensions==="offset"}}return s&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(f){if(this.windowsMainService.getWindows().length===0)return f;f.x=typeof f.x=="number"?f.x:0,f.y=typeof f.y=="number"?f.y:0;const c=this.windowsMainService.getWindows().map(n=>n.getBounds());for(;c.some(n=>n.x===f.x||n.y===f.y);)f.x+=30,f.y+=30;return f}};m.windowsStateStorageKey="windowsState",m=we([ie(0,I.IWindowsMainService),ie(1,b.IStateMainService),ie(2,p.ILifecycleMainService),ie(3,S.ILogService),ie(4,P.IConfigurationService)],m),e.WindowsStateHandler=m;function h(g){const f={openedWindows:[]},c=g||{openedWindows:[]};return c.lastActiveWindow&&(f.lastActiveWindow=w(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(f.lastPluginDevelopmentHostWindow=w(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(f.openedWindows=c.openedWindows.map(n=>w(n))),f}e.restoreWindowsState=h;function w(g){const f={uiState:g.uiState};return g.backupPath&&(f.backupPath=g.backupPath),g.remoteAuthority&&(f.remoteAuthority=g.remoteAuthority),g.folder&&(f.folderUri=D.URI.parse(g.folder)),g.workspaceIdentifier&&(f.workspace={id:g.workspaceIdentifier.id,configPath:D.URI.parse(g.workspaceIdentifier.configURIPath)}),f}function u(g){return{lastActiveWindow:g.lastActiveWindow&&v(g.lastActiveWindow),lastPluginDevelopmentHostWindow:g.lastPluginDevelopmentHostWindow&&v(g.lastPluginDevelopmentHostWindow),openedWindows:g.openedWindows.map(f=>v(f))}}e.getWindowsStateStoreData=u;function v(g){return{workspaceIdentifier:g.workspace&&{id:g.workspace.id,configURIPath:g.workspace.configPath.toString()},folder:g.folderUri&&g.folderUri.toString(),backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.uiState}}}),define(ee[92],te([0,1,30,42,123,33,14,9,4,19,7,5,63,28]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,I.createDecorator)("workspacesService");function m(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function h(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=h;function w(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=w;function u(M){return v(M)||g(M)}e.isStoredWorkspaceFolder=u;function v(M){const T=M;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function g(M){const T=M;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function f(M,T,U,Y,G){if(M.scheme!==Y.scheme)return{name:U,uri:M.toString(!0)};let V=T?void 0:G.relativePath(Y,M);if(V!==void 0)V.length===0?V=".":p.isWindows&&(V=c(V));else if(M.scheme===D.Schemas.file)V=M.fsPath,p.isWindows&&(V=c(V));else if(G.isEqualAuthority(M.authority,Y.authority))V=M.path;else return{name:U,uri:M.toString(!0)};return{name:U,path:V}}e.getStoredWorkspaceFolder=f;function c(M){return M=(0,R.normalizeDriveLetter)(M),(0,E.isUNC)(M)||(M=(0,E.toSlashes)(M)),M}function n(M,T,U){const Y=[],G=new Set,V=U.dirname(T);for(const oe of M){let ae;if(v(oe))oe.path&&(ae=U.resolvePath(V,oe.path));else if(g(oe))try{ae=b.URI.parse(oe.uri),ae.path[0]!==P.posix.sep&&(ae=ae.with({path:P.posix.sep+ae.path}))}catch(se){console.warn(se)}if(ae){const se=U.getComparisonKey(ae);if(!G.has(se)){G.add(se);const fe=oe.name||U.basenameOrAuthority(ae);Y.push(new d.WorkspaceFolder({uri:ae,name:fe,index:Y.length},oe))}}}return Y}e.toWorkspaceFolders=n;function r(M,T,U,Y,G){const V=i(T,M),oe=G.dirname(T),ae=G.dirname(Y),se=[];for(const F of V.folders){const A=v(F)?G.resolvePath(oe,F.path):b.URI.parse(F.uri);let O;U?O=!1:O=!v(F)||(0,P.isAbsolute)(F.path),se.push(f(A,O,F.name,ae,G))}const fe={insertSpaces:!1,tabSize:4,eol:p.isLinux||p.isMacintosh?`
`:`\r
`},K=k.setProperty(M,["folders"],se,fe);let H=k.applyEdits(M,K);return(0,S.isEqualAuthority)(V.remoteAuthority,(0,C.getRemoteAuthority)(Y))&&(H=k.applyEdits(H,k.removeProperty(H,["remoteAuthority"],fe))),H}e.rewriteWorkspaceFileForNewLocation=r;function i(M,T){const U=t.parse(T);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(Y=>u(Y));else throw new Error(`${M} looks like an invalid workspace file.`);return U}function o(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function s(M){return typeof M.folderUri=="string"}function l(M){return typeof M.fileUri=="string"}function a(M,T){const U={workspaces:[],files:[]};if(M){const Y=function(V,oe){for(let ae=0;ae<V.length;ae++)try{oe(V[ae],ae)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(V[ae])}: ${se.toString()}. Skip entry.`)}},G=M;Array.isArray(G.entries)&&Y(G.entries,V=>{const oe=V.label,ae=V.remoteAuthority;o(V)?U.workspaces.push({label:oe,remoteAuthority:ae,workspace:{id:V.workspace.id,configPath:b.URI.parse(V.workspace.configPath)}}):s(V)?U.workspaces.push({label:oe,remoteAuthority:ae,folderUri:b.URI.parse(V.folderUri)}):l(V)&&U.files.push({label:oe,remoteAuthority:ae,fileUri:b.URI.parse(V.fileUri)})})}return U}e.restoreRecentlyOpened=a;function y(M){const T={entries:[]};for(const U of M.workspaces)h(U)?T.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):T.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of M.files)T.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return T}e.toStoreData=y}),define(ee[93],te([0,1,77,14,4,19]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(S){function b(){let I=S.scheme===t.Schemas.file?(0,R.originalFSPath)(S):S.toString();return k.isLinux||(I=I.toLowerCase()),(0,E.createHash)("md5").update(I).digest("hex")}return{id:b(),configPath:S}}e.getWorkspaceIdentifier=D;function P(S,b){function I(){if(S.scheme!==t.Schemas.file)return(0,E.createHash)("md5").update(S.toString()).digest("hex");if(!b)return;let d;return k.isLinux?d=b.ino:k.isMacintosh?d=b.birthtime.getTime():k.isWindows&&(typeof b.birthtimeMs=="number"?d=Math.floor(b.birthtimeMs):d=b.birthtime.getTime()),(0,E.createHash)("md5").update(S.fsPath).update(d?String(d):"").digest("hex")}const C=I();if(typeof C=="string")return{id:C,uri:S}}e.getSingleFolderWorkspaceIdentifier=P;function p(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=p}),define(ee[262],te([0,1,77,30,14,9,4,19,23,176,18,26,37,15,6,175,28,93]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class Ot{constructor(f,c,n,r){this.environmentMainService=f,this.configurationService=c,this.logService=n,this.stateMainService=r,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=P.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,o)=>(0,t.isEqual)(i,o,!D.isLinux)}}async initialize(){const f=await this.initializeAndMigrateBackupWorkspacesMetadata();this.emptyWindows=await this.validateEmptyWorkspaces(f.emptyWindows),this.workspaces=await this.validateWorkspaces((0,S.deserializeWorkspaceInfos)(f)),this.folders=await this.validateFolders((0,S.deserializeFolderInfos)(f)),this.storeWorkspacesMetadata()}async initializeAndMigrateBackupWorkspacesMetadata(){let f=this.stateMainService.getItem(Ot.backupWorkspacesMetadataStorageKey);if(!f)try{const c=(0,R.join)(this.backupHome,"workspaces.json"),n=await p.Promises.readFile(c,"utf8");try{await p.Promises.unlink(c)}catch{}const r=JSON.parse(n);f={workspaces:Array.isArray(r.rootURIWorkspaces)?r.rootURIWorkspaces:[],folders:Array.isArray(r.folderWorkspaceInfos)?r.folderWorkspaceInfos:[],emptyWindows:Array.isArray(r.emptyWorkspaceInfos)?r.emptyWorkspaceInfos:[]}}catch(c){c.code!=="ENOENT"&&this.logService.error(`Backup: Could not migrate legacy backup workspaces metadata: ${c.toString()}`)}return f??{workspaces:[],folders:[],emptyWindows:[]}}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(f,c){this.workspaces.some(r=>f.workspace.id===r.workspace.id)||(this.workspaces.push(f),this.storeWorkspacesMetadata());const n=(0,R.join)(this.backupHome,f.workspace.id);return c?this.moveBackupFolder(n,c).then(()=>n):n}async moveBackupFolder(f,c){if(await p.Promises.exists(f)&&await this.convertToEmptyWindowBackup(f),await p.Promises.exists(c))try{await p.Promises.rename(c,f)}catch(n){this.logService.error(`Backup: Could not move backup folder to new location: ${n.toString()}`)}}registerFolderBackup(f){return this.folders.some(c=>this.backupUriComparer.isEqual(f.folderUri,c.folderUri))||(this.folders.push(f),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,this.getFolderHash(f))}registerEmptyWindowBackup(f){return this.emptyWindows.some(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,f.backupFolder))||(this.emptyWindows.push(f),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,f.backupFolder)}async validateWorkspaces(f){if(!Array.isArray(f))return[];const c=new Set,n=[];for(const r of f){const i=r.workspace;if(!(0,w.isWorkspaceIdentifier)(i))return[];if(!c.has(i.id)){c.add(i.id);const o=(0,R.join)(this.backupHome,i.id);await this.doHasBackups(o)?i.configPath.scheme!==k.Schemas.file||await p.Promises.exists(i.configPath.fsPath)?n.push(r):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return n}async validateFolders(f){if(!Array.isArray(f))return[];const c=[],n=new Set;for(const r of f){const i=r.folderUri,o=this.backupUriComparer.getComparisonKey(i);if(!n.has(o)){n.add(o);const s=(0,R.join)(this.backupHome,this.getFolderHash(r));await this.doHasBackups(s)?i.scheme!==k.Schemas.file||await p.Promises.exists(i.fsPath)?c.push(r):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateEmptyWorkspaces(f){if(!Array.isArray(f))return[];const c=[],n=new Set;for(const r of f){const i=r.backupFolder;if(typeof i!="string")return[];if(!n.has(i)){n.add(i);const o=(0,R.join)(this.backupHome,i);await this.doHasBackups(o)?c.push(r):await this.deleteStaleBackup(o)}}return c}async deleteStaleBackup(f){try{await p.Promises.rm(f,p.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}prepareNewEmptyWindowBackup(){let f=(0,u.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,f.id));)f=(0,u.createEmptyWorkspaceIdentifier)();return{backupFolder:f.id}}async convertToEmptyWindowBackup(f){const c=this.prepareNewEmptyWindowBackup(),n=(0,R.join)(this.backupHome,c.backupFolder);try{await p.Promises.rename(f,n)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push(c),!0}async getDirtyWorkspaces(){const f=[];for(const c of this.workspaces)await this.hasBackups(c)&&f.push(c);for(const c of this.folders)await this.hasBackups(c)&&f.push(c);return f}hasBackups(f){let c;return(0,S.isEmptyWindowBackupInfo)(f)?c=(0,R.join)(this.backupHome,f.backupFolder):(0,h.isFolderBackupInfo)(f)?c=(0,R.join)(this.backupHome,this.getFolderHash(f)):c=(0,R.join)(this.backupHome,f.workspace.id),this.doHasBackups(c)}async doHasBackups(f){try{const c=await p.Promises.readdir(f);for(const n of c)try{if((await p.Promises.readdir((0,R.join)(f,n))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const f={workspaces:this.workspaces.map(({workspace:c,remoteAuthority:n})=>{const r={id:c.id,configURIPath:c.configPath.toString()};return n&&(r.remoteAuthority=n),r}),folders:this.folders.map(({folderUri:c,remoteAuthority:n})=>{const r={folderUri:c.toString()};return n&&(r.remoteAuthority=n),r}),emptyWindows:this.emptyWindows.map(({backupFolder:c,remoteAuthority:n})=>{const r={backupFolder:c};return n&&(r.remoteAuthority=n),r})};this.stateMainService.setItem(Ot.backupWorkspacesMetadataStorageKey,f)}getFolderHash(f){const c=f.folderUri;let n;return c.scheme===k.Schemas.file?n=D.isLinux?c.fsPath:c.fsPath.toLowerCase():n=c.toString().toLowerCase(),(0,E.createHash)("md5").update(n).digest("hex")}};v.backupWorkspacesMetadataStorageKey="backupWorkspaces",v=we([ie(0,I.IEnvironmentMainService),ie(1,b.IConfigurationService),ie(2,m.ILogService),ie(3,C.IStateMainService)],v),e.BackupMainService=v}),define(ee[52],te([0,1,13,3,42,33,2,14,9,19,12,23,174,60,56,26,5,6,20,51,117,28,92,93]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u,v,g,f,c,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,w.createDecorator)("workspacesManagementMainService");let i=class extends D.Disposable{constructor(s,l,a,y,M,T){super(),this.environmentMainService=s,this.logService=l,this.userDataProfilesMainService=a,this.backupMainService=y,this.dialogMainService=M,this.productService=T,this._onDidDeleteUntitledWorkspace=this._register(new t.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new t.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const s=(await I.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(l=>(0,S.joinPath)(this.untitledWorkspacesHome,l,c.UNTITLED_WORKSPACE_NAME));for(const l of s){const a=(0,r.getWorkspaceIdentifier)(l),y=await this.resolveLocalWorkspace(l);y?this.untitledWorkspaces.push({workspace:a,remoteAuthority:y.remoteAuthority}):await this.deleteUntitledWorkspace(a)}}catch(s){s.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${s}).`)}}resolveLocalWorkspace(s){return this.doResolveLocalWorkspace(s,l=>I.Promises.readFile(l,"utf8"))}doResolveLocalWorkspace(s,l){if(!!this.isWorkspacePath(s)&&s.scheme===P.Schemas.file)try{const a=l(s.fsPath);return a instanceof Promise?a.then(y=>this.doResolveWorkspace(s,y),y=>{}):this.doResolveWorkspace(s,a)}catch{return}}isWorkspacePath(s){return(0,c.isUntitledWorkspace)(s,this.environmentMainService)||(0,c.hasWorkspaceFileExtension)(s)}doResolveWorkspace(s,l){try{const a=this.doParseStoredWorkspace(s,l),y=(0,r.getWorkspaceIdentifier)(s);return{id:y.id,configPath:y.configPath,folders:(0,n.toWorkspaceFolders)(a.folders,y.configPath,S.extUriBiasedIgnorePathCase),remoteAuthority:a.remoteAuthority,transient:a.transient}}catch(a){this.logService.warn(a.toString())}}doParseStoredWorkspace(s,l){const a=(0,k.parse)(l);if(a&&Array.isArray(a.folders))a.folders=a.folders.filter(y=>(0,n.isStoredWorkspaceFolder)(y));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return a}async createUntitledWorkspace(s,l){const{workspace:a,storedWorkspace:y}=this.newUntitledWorkspace(s,l),M=a.configPath.fsPath;return await I.Promises.mkdir((0,p.dirname)(M),{recursive:!0}),await I.Promises.writeFile(M,JSON.stringify(y,null,"	")),this.untitledWorkspaces.push({workspace:a,remoteAuthority:l}),a}newUntitledWorkspace(s=[],l){const a=(Date.now()+Math.round(Math.random()*1e3)).toString(),y=(0,S.joinPath)(this.untitledWorkspacesHome,a),M=(0,S.joinPath)(y,c.UNTITLED_WORKSPACE_NAME),T=[];for(const U of s)T.push((0,n.getStoredWorkspaceFolder)(U.uri,!0,U.name,y,S.extUriBiasedIgnorePathCase));return{workspace:(0,r.getWorkspaceIdentifier)(M),storedWorkspace:{folders:T,remoteAuthority:l}}}async getWorkspaceIdentifier(s){return(0,r.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,c.isUntitledWorkspace)(s.configPath,this.environmentMainService)}async deleteUntitledWorkspace(s){!this.isUntitledWorkspace(s)||(await this.doDeleteUntitledWorkspace(s),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(s),this._onDidDeleteUntitledWorkspace.fire(s))}async doDeleteUntitledWorkspace(s){const l=(0,S.originalFSPath)(s.configPath);try{await I.Promises.rm((0,p.dirname)(l));const a=(0,p.join)(this.environmentMainService.workspaceStorageHome.fsPath,s.id);await I.Promises.exists(a)&&await I.Promises.writeFile((0,p.join)(a,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(y=>y.workspace.id!==s.id)}catch(a){this.logService.warn(`Unable to delete untitled workspace ${l} (${a}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(s,l,a){if(!s||!s.win||!s.isReady||!await this.isValidTargetWorkspacePath(s,l,a))return;const M=await this.doEnterWorkspace(s,(0,r.getWorkspaceIdentifier)(a));if(!!M)return this._onDidEnterWorkspace.fire({window:s,workspace:M.workspace}),M}async isValidTargetWorkspacePath(s,l,a){if(!a)return!0;if((0,c.isWorkspaceIdentifier)(s.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,a))return!1;if((0,f.findWindowOnWorkspaceOrFolder)(l,a)){const y={title:this.productService.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,C.localize)(0,null))],message:(0,C.localize)(1,null,(0,S.basename)(a)),detail:(0,C.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(y,(0,b.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1}return!0}async doEnterWorkspace(s,l){if(!s.config)return;s.focus();let a;return s.config.extensionDevelopmentPath||(s.config.backupPath?a=await this.backupMainService.registerWorkspaceBackup({workspace:l,remoteAuthority:s.remoteAuthority},s.config.backupPath):a=this.backupMainService.registerWorkspaceBackup({workspace:l,remoteAuthority:s.remoteAuthority})),(0,c.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=l,s.config.backupPath=a,{workspace:l,backupPath:a}}};i=we([ie(0,h.IEnvironmentMainService),ie(1,u.ILogService),ie(2,g.IUserDataProfilesMainService),ie(3,d.IBackupMainService),ie(4,m.IDialogMainService),ie(5,v.IProductService)],i),e.WorkspacesManagementMainService=i}),define(ee[118],te([0,1,13,40,22,5,31,28,52,12,6]),function(z,e,E,t,k,R,D,P,p,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let I=class{constructor(d,m,h){this.windowsMainService=d,this.workspacesManagementMainService=m,this.logService=h}async getRemoteDiagnostics(d){const m=this.windowsMainService.getWindows();return(await Promise.all(m.map(async w=>{const u=w.remoteAuthority;if(!u)return;const v=`vscode:getDiagnosticInfoResponse${w.id}`,g={includeProcesses:d.includeProcesses,folders:d.includeWorkspaceMetadata?await this.getFolderURIs(w):void 0};return new Promise(f=>{w.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:v,args:g}),t.validatedIpcMain.once(v,(c,n)=>{n||f({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),f(n)}),setTimeout(()=>{f({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter(w=>!!w)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const d=[];for(const m of E.BrowserWindow.getAllWindows()){const h=this.windowsMainService.getWindowById(m.id);h?d.push(await this.codeWindowToInfo(h)):d.push(this.browserWindowToInfo(m))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:d,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async codeWindowToInfo(d){const m=await this.getFolderURIs(d),h=(0,S.assertIsDefined)(d.win);return this.browserWindowToInfo(h,m,d.remoteAuthority)}browserWindowToInfo(d,m=[],h){return{pid:d.webContents.getOSProcessId(),title:d.getTitle(),folderURIs:m,remoteAuthority:h}}async getFolderURIs(d){const m=[],h=d.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(h))m.push(h.uri);else if((0,P.isWorkspaceIdentifier)(h)){const w=await this.workspacesManagementMainService.resolveLocalWorkspace(h.configPath);w&&w.folders.forEach(v=>{m.push(v.uri)})}return m}};I=we([ie(0,D.IWindowsMainService),ie(1,p.IWorkspacesManagementMainService),ie(2,b.ILogService)],I),e.DiagnosticsMainService=I}),define(ee[65],te([0,1,44,13,27,140,53,3,33,2,14,9,4,7,99,81,23,95,164,56,26,5,21,6,20,64,31,28,52,17,221,214]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u,v,g,f,c,n,r,i,o,s,l,a,y,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let U=class extends S.Disposable{constructor(G,V,oe,ae,se,fe,K,H,F){super(),this.sharedProcess=G,this.windowsMainService=V,this.dialogMainService=oe,this.lifecycleMainService=ae,this.environmentMainService=se,this.logService=fe,this.productService=K,this.themeMainService=H,this.workspacesManagementMainService=F,this.onDidOpenWindow=P.Event.map(this.windowsMainService.onDidOpenWindow,A=>A.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:A,x:O,y:_})=>({windowId:A.id,x:O,y:_})),({windowId:A})=>!!this.windowsMainService.getWindowById(A)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(A,O)=>O.id),A=>!!this.windowsMainService.getWindowById(A)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(A,O)=>O.id),A=>!!this.windowsMainService.getWindowById(A)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(A,O)=>O.id),A=>!!this.windowsMainService.getWindowById(A)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),A=>!!A),A=>A.id),P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(A,O)=>O.id),A=>!!this.windowsMainService.getWindowById(A))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new P.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(A,O,_)=>_),A=>!(Array.isArray(A)&&A.length===1&&A[0]==="workArea")),P.Event.fromNodeEventEmitter(t.screen,"display-added"),P.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(V=>({id:V.id,workspace:V.openedWorkspace??(0,l.toWorkspaceIdentifier)(V.backupPath,V.isExtensionDevelopmentHost),title:V.win?.getTitle()??"",filename:V.getRepresentedFilename(),dirty:V.isDocumentEdited()}))}async getWindowCount(G){return this.windowsMainService.getWindowCount()}async getActiveWindowId(G){const V=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(V)return V.id}openWindow(G,V,oe){return Array.isArray(V)?this.doOpenWindow(G,V,oe):this.doOpenEmptyWindow(G,V)}async doOpenWindow(G,V,oe=Object.create(null)){V.length>0&&await this.windowsMainService.open({context:5,contextWindowId:G,urisToOpen:V,cli:this.environmentMainService.args,forceNewWindow:oe.forceNewWindow,forceReuseWindow:oe.forceReuseWindow,preferNewWindow:oe.preferNewWindow,diffMode:oe.diffMode,mergeMode:oe.mergeMode,addMode:oe.addMode,gotoLineMode:oe.gotoLineMode,noRecentEntry:oe.noRecentEntry,waitMarkerFileURI:oe.waitMarkerFileURI,remoteAuthority:oe.remoteAuthority||void 0})}async doOpenEmptyWindow(G,V){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:G},V)}async toggleFullScreen(G){this.windowById(G)?.toggleFullScreen()}async handleTitleDoubleClick(G){this.windowById(G)?.handleTitleDoubleClick()}async isMaximized(G){const V=this.windowById(G);return V?.win?V.win.isMaximized():!1}async maximizeWindow(G){const V=this.windowById(G);V?.win&&V.win.maximize()}async unmaximizeWindow(G){const V=this.windowById(G);V?.win&&V.win.unmaximize()}async minimizeWindow(G){const V=this.windowById(G);V?.win&&V.win.minimize()}async updateWindowControls(G,V){const oe=this.windowById(G);oe&&oe.updateWindowControls(V)}async focusWindow(G,V){V&&typeof V.windowId=="number"&&(G=V.windowId),this.windowById(G)?.focus({force:V?.force??!1})}async setMinimumSize(G,V,oe){const ae=this.windowById(G);if(ae?.win){const[se,fe]=ae.win.getSize(),[K,H]=ae.win.getMinimumSize(),[F,A]=[V??K,oe??H],[O,_]=[Math.max(se,F),Math.max(fe,A)];(K!==F||H!==A)&&ae.win.setMinimumSize(F,A),(se!==O||fe!==_)&&ae.win.setSize(O,_)}}async saveWindowSplash(G,V){this.themeMainService.saveWindowSplash(G,V)}async installShellCommand(G){const{source:V,target:oe}=await this.getShellCommandLink();try{const{symbolicLink:ae}=await w.SymlinkSupport.stat(V);if(ae&&!ae.dangling){const se=await(0,m.realpath)(V);if(oe===se)return}await w.Promises.unlink(V)}catch(ae){if(ae.code!=="ENOENT")throw ae}try{await w.Promises.symlink(oe,V)}catch(ae){if(ae.code!=="EACCES"&&ae.code!=="ENOENT")throw ae;const{response:se}=await this.showMessageBox(G,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,p.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,p.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const fe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${oe}' '${V}'\\" with administrator privileges"`;await(0,R.promisify)(E.exec)(fe)}catch{throw new Error((0,v.localize)(3,null,V))}}}async uninstallShellCommand(G){const{source:V}=await this.getShellCommandLink();try{await w.Promises.unlink(V)}catch(oe){switch(oe.code){case"EACCES":{const{response:ae}=await this.showMessageBox(G,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,p.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,p.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ae===0)try{const se=`osascript -e "do shell script \\"rm '${V}'\\" with administrator privileges"`;await(0,R.promisify)(E.exec)(se)}catch{throw new Error((0,v.localize)(7,null,V))}break}case"ENOENT":break;default:throw oe}}}async getShellCommandLink(){const G=(0,I.resolve)(this.environmentMainService.appRoot,"bin","code"),V=`/usr/local/bin/${this.productService.applicationName}`;if(!await w.Promises.exists(G))throw new Error((0,v.localize)(8,null,G));return{source:V,target:G}}async showMessageBox(G,V){return this.dialogMainService.showMessageBox(V,this.toBrowserWindow(G))}async showSaveDialog(G,V){return this.dialogMainService.showSaveDialog(V,this.toBrowserWindow(G))}async showOpenDialog(G,V){return this.dialogMainService.showOpenDialog(V,this.toBrowserWindow(G))}toBrowserWindow(G){const V=this.windowById(G);if(V?.win)return V.win}async pickFileFolderAndOpen(G,V){const oe=await this.dialogMainService.pickFileFolder(V);oe&&await this.doOpenPicked(await Promise.all(oe.map(async ae=>await w.SymlinkSupport.existsDirectory(ae)?{folderUri:d.URI.file(ae)}:{fileUri:d.URI.file(ae)})),V,G)}async pickFolderAndOpen(G,V){const oe=await this.dialogMainService.pickFolder(V);oe&&await this.doOpenPicked(oe.map(ae=>({folderUri:d.URI.file(ae)})),V,G)}async pickFileAndOpen(G,V){const oe=await this.dialogMainService.pickFile(V);oe&&await this.doOpenPicked(oe.map(ae=>({fileUri:d.URI.file(ae)})),V,G)}async pickWorkspaceAndOpen(G,V){const oe=await this.dialogMainService.pickWorkspace(V);oe&&await this.doOpenPicked(oe.map(ae=>({workspaceUri:d.URI.file(ae)})),V,G)}async doOpenPicked(G,V,oe){await this.windowsMainService.open({context:3,contextWindowId:oe,cli:this.environmentMainService.args,urisToOpen:G,forceNewWindow:V.forceNewWindow})}async showItemInFolder(G,V){t.shell.showItemInFolder(V)}async setRepresentedFilename(G,V){this.windowById(G)?.setRepresentedFilename(V)}async setDocumentEdited(G,V){this.windowById(G)?.setDocumentEdited(V)}async openExternal(G,V){return C.isLinuxSnap?this.safeSnapOpenExternal(V):t.shell.openExternal(V),!0}safeSnapOpenExternal(G){const V=process.env.GDK_PIXBUF_MODULE_FILE,oe=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(G),process.env.GDK_PIXBUF_MODULE_FILE=V,process.env.GDK_PIXBUF_MODULEDIR=oe}moveItemToTrash(G,V){return t.shell.trashItem(V)}async isAdmin(){let G;return C.isWindows?G=(await new Promise((V,oe)=>{z(["native-is-elevated"],V,oe)}))():G=process.getuid()===0,G}async writeElevated(G,V,oe,ae){const se=await new Promise((fe,K)=>{z(["@vscode/sudo-prompt"],fe,K)});return new Promise((fe,K)=>{const H=[`"${this.cliPath}"`];ae?.unlock&&H.push("--file-chmod"),H.push("--file-write",`"${V.fsPath}"`,`"${oe.fsPath}"`);const F={name:this.productService.nameLong.replace("-",""),icns:C.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(H.join(" "),F,(A,O,_)=>{O&&this.logService.trace(`[sudo-prompt] received stdout: ${O}`),_&&this.logService.trace(`[sudo-prompt] received stderr: ${_}`),A?K(A):fe(void 0)})})}get cliPath(){return C.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):C.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin","code"):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return h.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return C.isWindows&&(0,M.hasWSLFeatureInstalled)()}async killProcess(G,V,oe){process.kill(V,oe)}async readClipboardText(G,V){return t.clipboard.readText(V)}async writeClipboardText(G,V,oe){return t.clipboard.writeText(V,oe)}async readClipboardFindText(G){return t.clipboard.readFindText()}async writeClipboardFindText(G,V){return t.clipboard.writeFindText(V)}async writeClipboardBuffer(G,V,oe,ae){return t.clipboard.writeBuffer(V,Buffer.from(oe.buffer),ae)}async readClipboardBuffer(G,V){return y.VSBuffer.wrap(t.clipboard.readBuffer(V))}async hasClipboard(G,V,oe){return t.clipboard.has(V,oe)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(G,V){this.windowById(G)?.updateTouchBar(V)}async notifyReady(G){this.windowById(G)?.setReady()}async relaunch(G,V){return this.lifecycleMainService.relaunch(V)}async reload(G,V){const oe=this.windowById(G);if(oe){if((0,l.isWorkspaceIdentifier)(oe.openedWorkspace)){const ae=oe.openedWorkspace.configPath;if(ae.scheme===b.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ae))?.transient)return this.openWindow(oe.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(oe,V?.disableExtensions!==void 0?{_:[],"disable-extensions":V.disableExtensions}:void 0)}}async closeWindow(G){this.closeWindowById(G,G)}async closeWindowById(G,V){const oe=this.windowById(V);if(oe?.win)return oe.win.close()}async quit(G){const V=this.windowsMainService.getLastActiveWindow();V?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&V.win?V.win.close():this.lifecycleMainService.quit()}async exit(G,V){await this.lifecycleMainService.kill(V)}async resolveProxy(G,V){const ae=this.windowById(G)?.win?.webContents?.session;if(ae)return ae.resolveProxy(V)}findFreePort(G,V,oe,ae,se=1){return(0,u.findFreePort)(V,oe,ae,se)}async openDevTools(G,V){const oe=this.windowById(G);oe?.win&&oe.win.webContents.openDevTools(V)}async toggleDevTools(G){const V=this.windowById(G);V?.win&&V.win.webContents.toggleDevTools()}async sendInputEvent(G,V){const oe=this.windowById(G);oe?.win&&(V.type==="mouseDown"||V.type==="mouseUp")&&oe.win.webContents.sendInputEvent(V)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async profileRenderer(G,V,oe){const ae=this.windowById(G);if(!ae||!ae.win)throw new Error;return await new T.WindowProfiler(ae.win,V,this.logService).inspect(oe)}async windowsGetStringRegKey(G,V,oe,ae){if(!C.isWindows)return;const se=await new Promise((fe,K)=>{z(["@vscode/windows-registry"],fe,K)});try{return se.GetStringRegKey(V,oe,ae)}catch{return}}windowById(G){if(typeof G=="number")return this.windowsMainService.getWindowById(G)}};we([D.memoize],U.prototype,"cliPath",null),U=we([ie(1,s.IWindowsMainService),ie(2,g.IDialogMainService),ie(3,n.ILifecycleMainService),ie(4,f.IEnvironmentMainService),ie(5,r.ILogService),ie(6,i.IProductService),ie(7,o.IThemeMainService),ie(8,a.IWorkspacesManagementMainService)],U),e.NativeHostMainService=U}),define(ee[263],te([0,1,13,40,27,33,2,14,4,100,162,84,118,56,26,5,6,65,54,20,61,74,30,12]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u,v,g,f,c,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,h.createDecorator)("issueMainService");let i=class Bt{constructor(s,l,a,y,M,T,U,Y,G){this.userEnv=s,this.environmentMainService=l,this.logService=a,this.diagnosticsService=y,this.diagnosticsMainService=M,this.dialogMainService=T,this.nativeHostMainService=U,this.protocolMainService=Y,this.productService=G,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[l,a]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),y=await this.diagnosticsService.getSystemInfo(l,a);this.safeSend(s,"vscode:issueSystemInfoResponse",y)}),t.validatedIpcMain.on("vscode:listProcesses",async s=>{const l=[];try{l.push({name:(0,b.localize)(0,null),rootProcess:await(0,S.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(y=>{(0,I.isRemoteDiagnosticError)(y)?l.push({name:y.hostName,rootProcess:y}):y.processes&&l.push({name:y.hostName,rootProcess:y.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(s,"vscode:listProcessesResponse",l)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{const l={title:this.productService.nameLong,message:(0,b.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,b.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,b.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(l,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",a.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const l=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",l)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,b.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,b.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,b.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(s,l)=>{const{id:a,from:y,args:M}=l;let T;switch(y){case"issueReporter":T=this.issueReporterParentWindow;break;case"processExplorer":T=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${y}`)}T?.webContents.send("vscode:runAction",{id:a,from:y,args:M})}),t.validatedIpcMain.on("vscode:openExternal",(s,l)=>{this.nativeHostMainService.openExternal(void 0,l)}),t.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const l=await this.diagnosticsMainService.getMainDiagnostics();this.safeSend(s,"vscode:windowsInfoResponse",l.windows)})}safeSend(s,l,...a){s.sender.isDestroyed()||s.sender.send(l,...a)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=E.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const l=new D.DisposableStore,a=l.add(this.protocolMainService.createIPCObjectUrl()),y=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(y,a,{backgroundColor:s.styles.backgroundColor,title:(0,b.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:v.default}),this.issueReporterWindow.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,l.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,l.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=E.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const l=new D.DisposableStore,a=l.add(this.protocolMainService.createIPCObjectUrl()),y=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(y,a,{backgroundColor:s.styles.backgroundColor,title:(0,b.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:v.default}),this.processExplorerWindow.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,l.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,l.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,l,a,y){const M=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:a.title,backgroundColor:a.backgroundColor||Bt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,`--vscode-window-kind=${y}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,c.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop,experimentalDarkMode:!0});return M.setMenuBarVisibility(!1),M}async getSystemStatus(){const[s,l]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,l)}getWindowPosition(s,l,a){let y;const M=E.screen.getAllDisplays();if(M.length===1)y=M[0];else{if(p.isMacintosh){const Y=E.screen.getCursorScreenPoint();y=E.screen.getDisplayNearestPoint(Y)}!y&&s&&(y=E.screen.getDisplayMatching(s.getBounds())),y||(y=E.screen.getPrimaryDisplay()||M[0])}const T={width:l,height:a},U=y.bounds;return T.x=U.x+U.width/2-T.width/2,T.y=U.y+U.height/2-T.height/2,U.width>0&&U.height>0&&(T.x<U.x&&(T.x=U.x),T.y<U.y&&(T.y=U.y),T.x>U.x+U.width&&(T.x=U.x),T.y>U.y+U.height&&(T.y=U.y),T.width>U.width&&(T.width=U.width),T.height>U.height&&(T.height=U.height)),T}async getPerformanceInfo(){try{const[s,l]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,l)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}async stopTracing(){if(!this.environmentMainService.args.trace)return;const s=await E.contentTracing.stopRecording(`${(0,n.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,b.localize)(9,null),detail:(0,b.localize)(10,null,s),buttons:[(0,R.mnemonicButtonLabel)((0,b.localize)(11,null))],defaultId:0,noLink:!0},(0,r.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,s)}};i.DEFAULT_BACKGROUND_COLOR="#1E1E1E",i=we([ie(1,m.IEnvironmentMainService),ie(2,w.ILogService),ie(3,I.IDiagnosticsService),ie(4,C.IDiagnosticsMainService),ie(5,d.IDialogMainService),ie(6,u.INativeHostMainService),ie(7,f.IProtocolMainService),ie(8,g.IProductService)],i),e.IssueMainService=i}),define(ee[264],te([0,1,22,18,26,21,6,65,20,55,35,47,89]),function(z,e,E,t,k,R,D,P,p,S,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let d=class extends C.AbstractUpdateService{constructor(h,w,u,v,g,f,c,n){super(h,w,v,g,f,n),this.telemetryService=u,this.nativeHostMainService=c}buildUpdateFeedUrl(h){return(0,C.createUpdateURL)(`linux-${process.arch}`,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(I.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},E.CancellationToken.None).then(S.asJson).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(I.State.Idle(1))):this.setState(I.State.AvailableForDownload(w))}).then(void 0,w=>{this.logService.error(w),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const u=h?w.message||w:void 0;this.setState(I.State.Idle(1,u))}))}async doDownloadUpdate(h){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(I.State.Idle(1))}};d=we([ie(0,R.ILifecycleMainService),ie(1,t.IConfigurationService),ie(2,b.ITelemetryService),ie(3,k.IEnvironmentMainService),ie(4,S.IRequestService),ie(5,D.ILogService),ie(6,P.INativeHostMainService),ie(7,p.IProductService)],d),e.LinuxUpdateService=d}),define(ee[265],te([0,1,44,39,27,8,22,53,9,7,126,23,18,26,15,21,6,65,20,55,35,47,89]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u,v,g,f,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(l,a=1e3){for(;!l();)await(0,R.timeout)(a)}let i;function o(){return typeof i>"u"&&(i=t.existsSync(p.join(p.dirname(process.execPath),"unins000.exe"))?0:1),i}let s=class extends n.AbstractUpdateService{get cachePath(){const a=p.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return I.Promises.mkdir(a,{recursive:!0}).then(()=>a)}constructor(a,y,M,T,U,Y,G,V,oe){super(a,y,T,U,Y,oe),this.telemetryService=M,this.fileService=G,this.nativeHostMainService=V}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(a){let y="win32";return process.arch!=="ia32"&&(y+=`-${process.arch}`),o()===1?y+="-archive":this.productService.target==="user"&&(y+="-user"),(0,n.createUpdateURL)(y,a,this.productService)}doCheckForUpdates(a){!this.url||(this.setState(c.State.CheckingForUpdates(a)),this.requestService.request({url:this.url},D.CancellationToken.None).then(g.asJson).then(y=>{const M=o();return!y||!y.url||!y.version||!y.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!a}),this.setState(c.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(c.State.AvailableForDownload(y)),Promise.resolve(null)):(this.setState(c.State.Downloading(y)),this.cleanup(y.version).then(()=>this.getUpdatePackagePath(y.version).then(T=>I.Promises.exists(T).then(U=>{if(U)return Promise.resolve(T);const Y=y.url,G=y.hash,V=`${T}.tmp`;return this.requestService.request({url:Y},D.CancellationToken.None).then(oe=>this.fileService.writeFile(S.URI.file(V),oe.stream)).then(G?()=>(0,b.checksum)(V,y.hash):()=>{}).then(()=>I.Promises.rename(V,T)).then(()=>T)})).then(T=>{const U=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},U&&y.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(y)):this.setState(c.State.Ready(y))})))}).then(void 0,y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!a});const M=a?y.message||y:void 0;this.setState(c.State.Idle(o(),M))}))}async doDownloadUpdate(a){a.update.url&&this.nativeHostMainService.openExternal(void 0,a.update.url),this.setState(c.State.Idle(o()))}async getUpdatePackagePath(a){const y=await this.cachePath;return p.join(y,`CodeSetup-${this.productService.quality}-${a}.exe`)}async cleanup(a=null){const y=a?Y=>!new RegExp(`${this.productService.quality}-${a}\\.exe$`).test(Y):()=>!0,M=await this.cachePath,U=(await I.Promises.readdir(M)).filter(y).map(async Y=>{try{await I.Promises.unlink(p.join(M,Y))}catch{}});await Promise.all(U)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const a=this.state.update;this.setState(c.State.Updating(a));const y=await this.cachePath;this.availableUpdate.updateFilePath=p.join(y,`CodeSetup-${this.productService.quality}-${a.version}.flag`),await I.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,E.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(o()))});const T=`${this.productService.win32MutexName}-ready`,U=await new Promise((Y,G)=>{z(["windows-mutex"],Y,G)});r(()=>U.isActive(T)).then(()=>this.setState(c.State.Ready(a)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,E.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return o()}async _applySpecificUpdate(a){if(this.state.type!=="idle")return;const y=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!y};this.setState(c.State.Downloading(M)),this.availableUpdate={packagePath:a},y?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(M)):this.setState(c.State.Ready(M))}};we([P.memoize],s.prototype,"cachePath",null),s=we([ie(0,h.ILifecycleMainService),ie(1,C.IConfigurationService),ie(2,f.ITelemetryService),ie(3,d.IEnvironmentMainService),ie(4,g.IRequestService),ie(5,w.ILogService),ie(6,m.IFileService),ie(7,u.INativeHostMainService),ie(8,v.IProductService)],s),e.Win32UpdateService=s}),define(ee[266],te([0,1,13,8,22,43,3,33,2,14,9,72,4,7,170,60,18,56,26,59,15,21,6,20,61,232,91,35,235,64,74,31,28,52,115,120,36,37,54,51]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u,v,g,f,c,n,r,i,o,s,l,a,y,M,T,U,Y,G,V,oe,ae,se,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var K;(function(F){F[F.NONE=0]="NONE",F[F.NAVIGATING=1]="NAVIGATING",F[F.READY=2]="READY"})(K||(K={}));let H=class Wt extends p.Disposable{get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(A,O,_,ne,N,j,L,W,$,q,X,re,B,x,Z,ce,ge,De,Te){super(),this.logService=O,this.environmentMainService=_,this.policyService=ne,this.userDataProfilesService=N,this.fileService=j,this.applicationStorageMainService=L,this.storageMainService=W,this.configurationService=$,this.themeMainService=q,this.workspacesManagementMainService=X,this.backupMainService=re,this.telemetryService=B,this.dialogMainService=x,this.lifecycleMainService=Z,this.productService=ce,this.protocolMainService=ge,this.windowsMainService=De,this.stateMainService=Te,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Me,Le]=this.restoreWindowState(A.state);this.windowState=Me,this.logService.trace("window#ctor: using window state",Me);const ve=this.windowState.mode===0||this.windowState.mode===3,pe=this.configurationService.getValue("window");let Se=!1;typeof pe?.experimental?.useSandbox=="boolean"?Se=pe.experimental.useSandbox:Se=typeof se.default.quality=="string"&&se.default.quality!=="stable";const ke={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!ve,title:this.productService.nameLong,webPreferences:{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(pe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...Se?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};C.isLinux?ke.icon=(0,b.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):C.isWindows&&!this.environmentMainService.isBuilt&&(ke.icon=(0,b.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),C.isMacintosh&&!this.useNativeFullScreen()&&(ke.fullscreenable=!1),C.isMacintosh&&(ke.acceptFirstMouse=!0,pe?.clickThroughInactive===!1&&(ke.acceptFirstMouse=!1));const J=C.isMacintosh&&pe?.nativeTabs===!0;J&&(ke.tabbingIdentifier=this.productService.nameShort);const ue=(0,M.getTitleBarStyle)(this.configurationService)==="custom";if(ue&&(ke.titleBarStyle="hidden",C.isMacintosh||(ke.frame=!1),(0,M.useWindowControlsOverlay)(this.configurationService))){const de=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),ye=V.Color.fromHex(de).isDarker()?"#FFFFFF":"#000000";ke.titleBarOverlay={height:29,color:de,symbolColor:ye},this.hasWindowControlOverlay=!0}if((0,I.mark)("code/willCreateCodeBrowserWindow"),this._win=new E.BrowserWindow(ke),(0,I.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,C.isMacintosh&&ue&&this._win.setSheetOffset(22),ue&&(C.isWindows&&(0,M.useWindowControlsOverlay)(this.configurationService)||C.isMacintosh)){const de=this.stateMainService.getItem(Wt.windowControlHeightStateStorageKey);de&&this.updateWindowControls({height:de})}C.isWindows&&ue&&this._win.hookWindowMessage(278,()=>{const[ye,Ce]=this._win.getPosition(),Fe=E.screen.getCursorScreenPoint(),Oe=Fe.x-ye,$e=Fe.y-Ce;return(()=>!(Oe>30&&$e>=0&&$e<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Oe,y:$e})),0}),(C.isMacintosh||C.isWindows)&&Le&&(!J||E.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(de=>typeof de=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),ve&&((0,I.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,I.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setRepresentedFilename(A){C.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return C.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){C.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return C.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){C.isMacintosh&&A?.force&&E.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function O(){_.dispose(),ne.dispose(),A()}const _=this.onDidClose(()=>O()),ne=this.onWillLoad(()=>O())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(O,_)=>this.onWindowError(2,_)),this._win.webContents.on("did-fail-load",(O,_,ne)=>this.onWindowError(3,{reason:ne,exitCode:_})),this._win.webContents.on("will-prevent-unload",O=>{O.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",O=>{this._config&&(this._config.maximized=!0),E.app.emit("browser-window-maximize",O,this._win)}),this._win.on("unmaximize",O=>{this._config&&(this._config.maximized=!1),E.app.emit("browser-window-unmaximize",O,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(O=>this.onConfigurationUpdated(O))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(O=>this.onDidDeleteUntitledWorkspace(O)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(O,_)=>{const ne=await this.getMarketplaceHeaders();_({cancel:!1,requestHeaders:Object.assign(O.requestHeaders,ne)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,o.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,O){switch(A){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:O?.reason,code:O?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const _=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,m.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,m.localize)(1,null)),(0,P.mnemonicButtonLabel)((0,m.localize)(2,null))],message:(0,m.localize)(3,null),detail:(0,m.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,m.localize)(5,null):void 0},this._win);if(_.response!==1){const ne=_.response===0;await this.destroyWindow(ne,_.checkboxChecked)}}else if(A===2){let _;O?_=(0,m.localize)(7,null,O.reason,O.exitCode??"<unknown>"):_=(0,m.localize)(6,null);const ne=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,m.localize)(8,null)),(0,P.mnemonicButtonLabel)((0,m.localize)(9,null))],message:_,detail:(0,m.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,m.localize)(11,null):void 0},this._win),N=ne.response===0;await this.destroyWindow(N,ne.checkboxChecked)}break}}async destroyWindow(A,O){const _=this._config?.workspace;if(O&&_)try{const ne=this.storageMainService.workspaceStorage(_);await ne.init(),ne.delete("memento/workbench.parts.editor"),await ne.close()}catch(ne){this.logService.error(ne)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let ne,N;(0,U.isSingleFolderWorkspaceIdentifier)(_)?ne={folderUri:_.uri}:(0,U.isWorkspaceIdentifier)(_)?ne={workspaceUri:_.configPath}:N=!0;const[j]=await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:ne?[ne]:void 0,forceEmpty:N,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});j.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const O=this.getMenuBarVisibility();O!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=O,this.setMenuBarVisibility(O));let _=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;_?.endsWith("/")&&(_=_.substr(0,_.length-1));const ne=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((_||"").indexOf("@")===-1&&(_!==this.currentHttpProxy||ne!==this.currentNoProxy)){this.currentHttpProxy=_,this.currentNoProxy=ne;const N=_||"",j=ne?`${ne},<local>`:"<local>";this.logService.trace(`Setting proxy to '${N}', bypassing '${j}'`),this._win.webContents.session.setProxy({proxyRules:N,proxyBypassRules:j,pacScript:""})}}addTabbedWindow(A){C.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,O=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!O.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),O.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(A,O),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(S.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0));const _=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:O.isReload?3:_?2:1})}updateConfiguration(A,O){const _=(this._config??this.pendingLoadConfig)?.userEnv;if(_){const ne=(0,g.isLaunchedFromCli)(_)&&!(0,g.isLaunchedFromCli)(A.userEnv),N=this.isExtensionDevelopmentHost;(ne||N)&&(A.userEnv={..._,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),O.disableExtensions!==void 0&&(A["disable-extensions"]=O.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,I.mark)("code/willOpenNewWindow"),A.perfMarks=(0,I.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const O=Object.assign({},this._config);O.workspace=await this.validateWorkspaceBeforeReload(O),delete O.filesToOpenOrCreate,delete O.filesToDiff,delete O.filesToMerge,delete O.filesToWait,this.isExtensionDevelopmentHost&&A&&(O.verbose=A.verbose,O.debugId=A.debugId,O.extensionEnvironment=A.extensionEnvironment,O["inspect-extensions"]=A["inspect-extensions"],O["inspect-brk-extensions"]=A["inspect-brk-extensions"],O["extensions-dir"]=A["extensions-dir"]),O.isInitialStartup=!1,O.policiesData=this.policyService.serialize(),O.continueOn=this.environmentMainService.continueOn,O.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(O,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,U.isWorkspaceIdentifier)(A.workspace)){const O=A.workspace.configPath;if(O.scheme===S.Schemas.file&&!await this.fileService.exists(O))return}else if((0,U.isSingleFolderWorkspaceIdentifier)(A.workspace)){const O=A.workspace.uri;if(O.scheme===S.Schemas.file&&!await this.fileService.exists(O))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,G.defaultWindowState)();if(this.isFullScreen){let _;try{_=E.screen.getDisplayMatching(this.getBounds())}catch{}const ne=(0,G.defaultWindowState)();return{mode:3,display:_?_.id:void 0,width:this.windowState.width||ne.width,height:this.windowState.height||ne.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let O;if(!C.isMacintosh&&this._win.isMaximized()?O=0:O=1,O===0?A.mode=0:A.mode=1,O===1||O===0){let _;O===1?_=this.getBounds():_=this._win.getNormalBounds(),A.x=_.x,A.y=_.y,A.width=_.width,A.height=_.height}return A}updateWindowControls(A){if(A.height&&this.stateMainService.setItem(Wt.windowControlHeightStateStorageKey,A.height),C.isWindows&&this.hasWindowControlOverlay)this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0});else if(C.isMacintosh&&A.height!==void 0){const O=(A.height-15)/2;this._win.setTrafficLightPosition({x:O,y:O})}}restoreWindowState(A){(0,I.mark)("code/willRestoreCodeWindowState");let O=!1;if(A)try{const _=E.screen.getAllDisplays();O=_.length>1,A=this.validateWindowState(A,_)}catch(_){this.logService.warn(`Unexpected error validating window state: ${_}
${_.stack}`)}return(0,I.mark)("code/didRestoreCodeWindowState"),[A||(0,G.defaultWindowState)(),O]}validateWindowState(A,O){if(this.logService.trace(`window#validateWindowState: validating window state on ${O.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(O.length===1){const N=this.getWorkingArea(O[0]);if(N){let j=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!N||(A.x<N.x&&(A.x=N.x),A.y<N.y&&(A.y=N.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",N),j(),A.width>N.width&&(A.width=N.width),A.height>N.height&&(A.height=N.height),A.x>N.x+N.width-128&&(A.x=N.x+N.width-A.width),A.y>N.y+N.height-128&&(A.y=N.y+N.height-A.height),j()}return A}if(A.display&&A.mode===3){const N=O.find(j=>j.id===A.display);if(N&&typeof N.bounds?.x=="number"&&typeof N.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const j=(0,G.defaultWindowState)(3);return j.x=N.bounds.x,j.y=N.bounds.y,j}}let _,ne;try{_=E.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),ne=this.getWorkingArea(_)}catch{}if(_&&ne&&A.x+A.width>ne.x&&A.y+A.height>ne.y&&A.x<ne.x+ne.width&&A.y<ne.y+ne.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",ne),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,O]=this._win.getPosition(),[_,ne]=this._win.getSize();return{x:A,y:O,width:_,height:ne}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return C.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(A)}doSetNativeFullScreen(A){C.isMacintosh&&(this.transientIsNativeFullScreen=A,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,M.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,O=!0){C.isMacintosh||(A==="toggle"&&O&&this.send("vscode:showInfoMessage",(0,m.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const O=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!O),this._win.autoHideMenuBar=O;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(C.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,O,..._){this.isReady?this.send(A,..._):this.ready().then(()=>{O.isCancellationRequested||this.send(A,..._)})}send(A,...O){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...O)}catch(_){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)(_)}`)}}}updateTouchBar(A){!C.isMacintosh||this.touchBarGroups.forEach((O,_)=>{const ne=A[_];O.segments=this.createTouchBarGroupSegments(ne)})}createTouchBar(){if(!!C.isMacintosh){for(let A=0;A<10;A++){const O=this.createTouchBarGroup();this.touchBarGroups.push(O)}this._win.setTouchBar(new E.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const O=this.createTouchBarGroupSegments(A),_=new E.TouchBar.TouchBarSegmentedControl({segments:O,mode:"buttons",segmentStyle:"automatic",change:ne=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:_.segments[ne].id,from:"touchbar"})}});return _}createTouchBarGroupSegments(A=[]){return A.map(_=>{let ne;_.icon&&!a.ThemeIcon.isThemeIcon(_.icon)&&_.icon?.dark?.scheme===S.Schemas.file&&(ne=E.nativeImage.createFromPath(d.URI.revive(_.icon.dark).fsPath),ne.isEmpty()&&(ne=void 0));let N;return typeof _.title=="string"?N=_.title:N=_.title.value,{id:_.id,label:ne?void 0:N,icon:ne}})}dispose(){super.dispose(),this._win=null}};H.windowControlHeightStateStorageKey="windowControlHeight",H=we([ie(1,n.ILogService),ie(2,v.IEnvironmentMainService),ie(3,oe.IPolicyService),ie(4,fe.IUserDataProfilesMainService),ie(5,f.IFileService),ie(6,s.IApplicationStorageMainService),ie(7,s.IStorageMainService),ie(8,w.IConfigurationService),ie(9,y.IThemeMainService),ie(10,Y.IWorkspacesManagementMainService),ie(11,h.IBackupMainService),ie(12,l.ITelemetryService),ie(13,u.IDialogMainService),ie(14,c.ILifecycleMainService),ie(15,r.IProductService),ie(16,i.IProtocolMainService),ie(17,T.IWindowsMainService),ie(18,ae.IStateMainService)],H),e.CodeWindow=H}),define(ee[75],te([0,1,13,24,8,3,33,2,14,4,19,7,23,173,5,21,6,91,92,28,52,38]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u,v,g,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,m.createDecorator)("workspacesHistoryMainService");let n=class rt extends P.Disposable{constructor(i,o,s,l){super(),this.logService=i,this.workspacesManagementMainService=o,this.lifecycleMainService=s,this.applicationStorageMainService=l,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let o=[],s=[];for(const a of i)if((0,v.isRecentWorkspace)(a))!this.workspacesManagementMainService.isUntitledWorkspace(a.workspace)&&!this.containsWorkspace(o,a.workspace)&&o.push(a);else if((0,v.isRecentFolder)(a))this.containsFolder(o,a.folderUri)||o.push(a);else{const y=this.containsFile(s,a.fileUri),M=a.fileUri.scheme===p.Schemas.file&&rt.COMMON_FILES_FILTER.indexOf((0,b.basename)(a.fileUri))>=0;!y&&!M&&(s.push(a),S.isWindows&&a.fileUri.scheme===p.Schemas.file&&E.app.addRecentDocument(a.fileUri.fsPath))}const l=await this.mergeEntriesFromStorage({workspaces:o,files:s});o=l.workspaces,s=l.files,o.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(o.length=rt.MAX_TOTAL_RECENT_ENTRIES),s.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(s.length=rt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:o,files:s}),this._onDidChangeRecentlyOpened.fire(),S.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(i){const o=y=>{const M=this.location(y);for(const T of i)if(b.extUriBiasedIgnorePathCase.isEqual(T,M))return!1;return!0},s=await this.getRecentlyOpened(),l=s.workspaces.filter(o),a=s.files.filter(o);(l.length!==s.workspaces.length||a.length!==s.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:l}),this._onDidChangeRecentlyOpened.fire(),S.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(i){const o=new c.ResourceMap(a=>b.extUriBiasedIgnorePathCase.getComparisonKey(a));if(i?.workspaces)for(const a of i.workspaces)o.set(this.location(a),a);const s=new c.ResourceMap(a=>b.extUriBiasedIgnorePathCase.getComparisonKey(a));if(i?.files)for(const a of i.files)s.set(this.location(a),a);const l=await this.getRecentlyOpenedFromStorage();for(const a of l.workspaces){const y=o.get(this.location(a));y?y.label=y.label??a.label:o.set(this.location(a),a)}for(const a of l.files){const y=s.get(this.location(a));y?y.label=y.label??a.label:s.set(this.location(a),a)}return{workspaces:[...o.values()],files:[...s.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let i;const o=this.applicationStorageMainService.get(rt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof o=="string")try{i=JSON.parse(o)}catch(s){this.logService.error("Unexpected error parsing opened paths list",s)}return(0,v.restoreRecentlyOpened)(i,this.logService)}async saveRecentlyOpened(i){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(rt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,v.toStoreData)(i)),-1,1)}location(i){return(0,v.isRecentFolder)(i)?i.folderUri:(0,v.isRecentFile)(i)?i.fileUri:i.workspace.configPath}containsWorkspace(i,o){return!!i.find(s=>(0,v.isRecentWorkspace)(s)&&s.workspace.id===o.id)}containsFolder(i,o){return!!i.find(s=>(0,v.isRecentFolder)(s)&&b.extUriBiasedIgnorePathCase.isEqual(s.folderUri,o))}containsFile(i,o){return!!i.find(s=>b.extUriBiasedIgnorePathCase.isEqual(s.fileUri,o))}async handleWindowsJumpList(){!S.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!S.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const o=[];for(const a of E.app.getJumpListSettings().removedItems){const y=a.args;if(y){const M=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(y);M&&o.push(I.URI.parse(M[2]))}}await this.removeRecentlyOpened(o);let s=!1;const l=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const y=(0,v.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:M,description:T}=this.getWindowsJumpListLabel(y,a.label);let U;return I.URI.isUri(y)?U=`--folder-uri "${y.toString()}"`:(s=!0,U=`--file-uri "${y.configPath.toString()}"`),{type:"task",title:M.substr(0,255),description:T.substr(0,255),program:process.execPath,args:U,iconPath:"explorer.exe",iconIndex:0}}));l.length>0&&i.push({type:"custom",name:s?(0,d.localize)(2,null):(0,d.localize)(3,null),items:l})}i.push({type:"recent"});try{const o=E.app.setJumpList(i);o&&o!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${o}`)}catch(o){this.logService.warn("updateWindowsJumpList#setJumpList",o)}}getWindowsJumpListLabel(i,o){if(o)return{title:(0,D.splitName)(o).name,description:o};if(I.URI.isUri(i))return{title:(0,b.basename)(i),description:this.renderJumpListPathDescription(i)};if(this.workspacesManagementMainService.isUntitledWorkspace(i))return{title:(0,d.localize)(4,null),description:""};let s=(0,b.basename)(i.configPath);return s.endsWith(g.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-g.WORKSPACE_EXTENSION.length-1)),{title:(0,d.localize)(5,null,s),description:this.renderJumpListPathDescription(i.configPath)}}renderJumpListPathDescription(i){return i.scheme==="file"?(0,D.normalizeDriveLetter)(i.fsPath):i.toString()}async updateMacOSRecentDocuments(){if(!S.isMacintosh)return;E.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),o=[];let s=0;for(let a=0;a<i.workspaces.length&&s<rt.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const y=this.location(i.workspaces[a]);if(y.scheme===p.Schemas.file){const M=(0,b.originalFSPath)(y);await C.Promises.exists(M)&&(o.push(M),s++)}}const l=[];for(let a=0;a<i.files.length&&s<rt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const y=this.location(i.files[a]);if(y.scheme===p.Schemas.file){const M=(0,b.originalFSPath)(y);if(rt.COMMON_FILES_FILTER.includes((0,b.basename)(y))||o.includes(M))continue;await C.Promises.exists(M)&&(l.push(M),s++)}}l.reverse().forEach(a=>E.app.addRecentDocument(a)),o.reverse().forEach(a=>E.app.addRecentDocument(a))}};n.MAX_TOTAL_RECENT_ENTRIES=500,n.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",n.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,n.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,n.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,n.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],n=we([ie(0,w.ILogService),ie(1,f.IWorkspacesManagementMainService),ie(2,h.ILifecycleMainService),ie(3,u.IApplicationStorageMainService)],n),e.WorkspacesHistoryMainService=n}),define(ee[267],te([0,1,13,8,22,33,4,7,163,18,26,21,6,210,65,20,37,35,47,74,31,75]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u,v,g,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let r=class Ft{constructor(s,l,a,y,M,T,U,Y,G,V,oe){this.updateService=s,this.configurationService=l,this.windowsMainService=a,this.environmentMainService=y,this.telemetryService=M,this.workspacesHistoryMainService=T,this.stateMainService=U,this.lifecycleMainService=Y,this.logService=G,this.nativeHostMainService=V,this.productService=oe,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,g.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(Ft.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,U,Y)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:U?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,U,Y)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:U?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,U,Y)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Y),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,U,Y)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Y),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,U,Y)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(Y),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const l=this.productService.requestFeatureUrl;l&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(l,"openUserVoiceUrl"));const a=this.productService.reportIssueUrl;a&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(a,"openReportIssues"));const y=this.productService.licenseUrl;y&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const T=y.indexOf("?")>0?"&":"?";this.openUrl(`${y}${T}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(y,"openLicenseUrl")});const M=this.productService.privacyStatementUrl;M&&y&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(M,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,l){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(Ft.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!D.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!E.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=E.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){E.Menu.setApplicationMenu(D.isMacintosh?new E.Menu:null);return}const l=new E.Menu;let a;if(D.isMacintosh){const M=new E.Menu;a=new E.MenuItem({label:this.productService.nameShort,submenu:M}),this.setMacApplicationMenu(M),l.append(a)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const M=new E.Menu;M.append(new E.MenuItem({label:this.mnemonicLabel(p.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),E.app.dock.setMenu(M)}if(this.shouldDrawMenu("File")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(1,null)),submenu:M});this.setMenuById(M,"File"),l.append(T)}if(this.shouldDrawMenu("Edit")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(2,null)),submenu:M});this.setMenuById(M,"Edit"),l.append(T)}if(this.shouldDrawMenu("Selection")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(3,null)),submenu:M});this.setMenuById(M,"Selection"),l.append(T)}if(this.shouldDrawMenu("View")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(4,null)),submenu:M});this.setMenuById(M,"View"),l.append(T)}if(this.shouldDrawMenu("Go")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(5,null)),submenu:M});this.setMenuById(M,"Go"),l.append(T)}if(this.shouldDrawMenu("Run")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(6,null)),submenu:M});this.setMenuById(M,"Run"),l.append(T)}if(this.shouldDrawMenu("Terminal")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(7,null)),submenu:M});this.setMenuById(M,"Terminal"),l.append(T)}let y;if(this.shouldDrawMenu("Window")){const M=new E.Menu;y=new E.MenuItem({label:this.mnemonicLabel(p.localize(8,null)),submenu:M,role:"window"}),this.setMacWindowMenu(M)}if(y&&l.append(y),this.shouldDrawMenu("Help")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(9,null)),submenu:M,role:"help"});this.setMenuById(M,"Help"),l.append(T)}l.items&&l.items.length>0?E.Menu.setApplicationMenu(l):E.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const l=this.createMenuItem(p.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),a=this.getUpdateMenuItems();let y;if(this.shouldDrawMenu("Preferences")){const ae=new E.Menu;this.setMenuById(ae,"Preferences"),y=new E.MenuItem({label:this.mnemonicLabel(p.localize(11,null)),submenu:ae})}const M=new E.Menu,T=new E.MenuItem({label:p.localize(12,null),role:"services",submenu:M}),U=new E.MenuItem({label:p.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),Y=new E.MenuItem({label:p.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),G=new E.MenuItem({label:p.localize(15,null),role:"unhide"}),V=new E.MenuItem(this.likeAction("workbench.action.quit",{label:p.localize(16,null,this.productService.nameLong),click:async(ae,se,fe)=>{const K=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!E.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.confirmBeforeQuit(fe)&&this.nativeHostMainService.quit(void 0)}})),oe=[l];oe.push(...a),y&&oe.push(i(),y),oe.push(i(),T,i(),U,Y,G,i(),V),oe.forEach(ae=>s.append(ae))}async confirmBeforeQuit(s){if(this.windowsMainService.getWindowCount()===0)return!0;const l=this.configurationService.getValue("window.confirmBeforeClose");if(l==="always"||l==="keyboardOnly"&&this.isKeyboardEvent(s)){const a={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(p.localize(17,null)),(0,R.mnemonicButtonLabel)(p.localize(18,null))],message:p.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:y}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,a);return y===0}return!0}shouldDrawMenu(s){if(!D.isMacintosh&&(0,g.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,l){l.forEach(a=>{if((0,d.isMenubarMenuItemSeparator)(a))s.append(i());else if((0,d.isMenubarMenuItemSubmenu)(a)){const y=new E.Menu,M=new E.MenuItem({label:this.mnemonicLabel(a.label),submenu:y});this.setMenu(y,a.submenu.items),s.append(M)}else(0,d.isMenubarMenuItemRecentAction)(a)?s.append(this.createOpenRecentMenuItem(a)):(0,d.isMenubarMenuItemAction)(a)&&(a.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[a.id]?s.append(new E.MenuItem(this.likeAction(a.id,{label:this.mnemonicLabel(a.label),click:this.fallbackMenuHandlers[a.id]}))):s.append(this.createMenuItem(a.label,a.id,!1,a.checked)):s.append(this.createMenuItem(a.label,a.id,a.enabled!==!1,!!a.checked)):s.append(this.createMenuItem(a.label,a.id,a.enabled!==!1,!!a.checked)))})}setMenuById(s,l){this.menubarMenus&&this.menubarMenus[l]&&this.setMenu(s,this.menubarMenus[l].items)}insertCheckForUpdatesItems(s){const l=this.getUpdateMenuItems();l.length&&(l.forEach(a=>s.append(a)),s.append(i()))}createOpenRecentMenuItem(s){const l=P.URI.revive(s.uri),a=s.id,y=a==="openRecentFile"?{fileUri:l}:a==="openRecentWorkspace"?{workspaceUri:l}:{folderUri:l};return new E.MenuItem(this.likeAction(a,{label:s.label,click:async(M,T,U)=>{const Y=this.isOptionClick(U);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[y],forceNewWindow:Y,gotoLineMode:!1,remoteAuthority:s.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([l])}},!1))}isOptionClick(s){return!!(s&&(!D.isMacintosh&&(s.ctrlKey||s.shiftKey)||D.isMacintosh&&(s.metaKey||s.altKey)))}isKeyboardEvent(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}createRoleMenuItem(s,l,a){const y={label:this.mnemonicLabel(s),role:a,enabled:!0};return new E.MenuItem(this.withKeybinding(l,y))}setMacWindowMenu(s){const l=new E.MenuItem({label:p.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),a=new E.MenuItem({label:p.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),y=new E.MenuItem({label:p.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),M=this.createMenuItem(p.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(i()),T.push(this.createMenuItem(p.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(p.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(p.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(p.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(p.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[l,a,i(),M,...T,i(),y].forEach(U=>s.append(U))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.mnemonicLabel(p.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:p.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.mnemonicLabel(p.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:p.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.mnemonicLabel(p.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new E.MenuItem({label:p.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.mnemonicLabel(p.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,l,a,y){const M=this.mnemonicLabel(s),T=typeof l=="function"?l:(oe,ae,se)=>{const fe=oe?oe.userSettingsLabel:null;let K=l;Array.isArray(l)&&(K=this.isOptionClick(se)?l[1]:l[0]),fe&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:fe}):this.runActionInRenderer({type:"commandId",commandId:K})},U=typeof a=="boolean"?a:this.windowsMainService.getWindowCount()>0,Y=typeof y=="boolean"?y:!1,G={label:M,click:T,enabled:U};Y&&(G.type="checkbox",G.checked=Y);let V;return typeof l=="string"?V=l:Array.isArray(l)&&(V=l[0]),D.isMacintosh&&(V==="editor.action.clipboardCutAction"?G.role="cut":V==="editor.action.clipboardCopyAction"?G.role="copy":V==="editor.action.clipboardPasteAction"&&(G.role="paste"),V==="undo"?G.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):V==="redo"?G.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):V==="editor.action.selectAll"&&(G.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.withKeybinding(V,G))}makeContextAwareClickHandler(s,l){return(a,y,M)=>{const T=E.BrowserWindow.getFocusedWindow();if(!T)return l.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return l.inDevTools(T.webContents.devToolsWebContents);s(a,y||T,M)}}runActionInRenderer(s){let l=E.BrowserWindow.getFocusedWindow();if(!l){const y=this.windowsMainService.getLastActiveWindow();y?.isMinimized()&&(l=y.win)}const a=l?this.windowsMainService.getWindowById(l.id):void 0;if(a){if(this.logService.trace("menubar#runActionInRenderer",s),D.isMacintosh&&!this.environmentMainService.isBuilt&&!a.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const y={id:s.commandId,from:"menu"};a.sendWhenReady("vscode:runAction",k.CancellationToken.None,y)}else{const y={userSettingsLabel:s.userSettingsLabel};a.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,y)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,l){const a=typeof s=="string"?this.keybindings[s]:void 0;if(a?.label){if(a.isNative!==!1)l.accelerator=a.label,l.userSettingsLabel=a.userSettingsLabel;else if(typeof l.label=="string"){const y=l.label.indexOf("[");y>=0?l.label=`${l.label.substr(0,y)} [${a.label}]`:l.label=`${l.label} [${a.label}]`}}else l.accelerator=void 0;return l}likeAction(s,l,a=!l.accelerator){a&&(l=this.withKeybinding(s,l));const y=l.click;return l.click=(M,T,U)=>{this.reportMenuActionTelemetry(s),y?.(M,T,U)},l}openUrl(s,l){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(l)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:n})}mnemonicLabel(s){return(0,R.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=we([ie(0,v.IUpdateService),ie(1,S.IConfigurationService),ie(2,f.IWindowsMainService),ie(3,b.IEnvironmentMainService),ie(4,u.ITelemetryService),ie(5,c.IWorkspacesHistoryMainService),ie(6,w.IStateMainService),ie(7,I.ILifecycleMainService),ie(8,C.ILogService),ie(9,m.INativeHostMainService),ie(10,h.IProductService)],r),e.Menubar=r;function i(){return new E.MenuItem({type:"separator"})}}),define(ee[268],te([0,1,5,21,6,267]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let D=class{constructor(p,S,b){this.instantiationService=p,this.lifecycleMainService=S,this.logService=b,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(p,S){this.logService.trace("menubarService#updateMenubar",p),(await this.menubar).updateMenu(S,p)}};D=we([ie(0,E.IInstantiationService),ie(1,t.ILifecycleMainService),ie(2,k.ILogService)],D),e.MenubarMainService=D}),define(ee[269],te([0,1,13,23,27,24,22,3,30,49,33,2,14,9,72,4,32,19,12,7,171,60,18,56,26,15,5,21,6,54,20,61,63,37,74,266,117,261,28,93,75,52,64,36,51]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u,v,g,f,c,n,r,i,o,s,l,a,y,M,T,U,Y,G,V,oe,ae,se,fe,K,H,F,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function _(j){return(0,se.isWorkspaceIdentifier)(j?.workspace)}function ne(j){return(0,se.isSingleFolderWorkspaceIdentifier)(j?.workspace)}let N=class ft extends I.Disposable{constructor(L,W,$,q,X,re,B,x,Z,ce,ge,De,Te,Me,Le,ve,pe,Se){super(),this.machineId=L,this.initialUserEnv=W,this.logService=$,this.stateMainService=q,this.policyService=X,this.environmentMainService=re,this.userDataProfilesMainService=B,this.lifecycleMainService=x,this.backupMainService=Z,this.configurationService=ce,this.workspacesHistoryMainService=ge,this.workspacesManagementMainService=De,this.instantiationService=Te,this.dialogMainService=Me,this.fileService=Le,this.productService=ve,this.protocolMainService=pe,this.themeMainService=Se,this._onDidOpenWindow=this._register(new P.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new P.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new P.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new P.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new P.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ae.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const W=new I.DisposableStore;if(W.add(P.Event.any(L.onDidClose,L.onDidDestroy)(()=>W.dispose())),L.config.extensionDevelopmentPath)for(const $ of L.config.extensionDevelopmentPath)W.add(this.protocolMainService.addValidFileRoot($));L.config.extensionTestsPath&&W.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,W){const $=this.environmentMainService.args,q=W?.remoteAuthority||void 0,X=!0,re=W?.forceReuseWindow,B=!re;return this.open({...L,cli:$,forceEmpty:X,forceNewWindow:B,forceReuseWindow:re,remoteAuthority:q})}openExistingWindow(L,W){L.focus(),this.handleWaitMarkerFile(W,[L])}async open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const W=[],$=[],q=[],X=[],re=[];let B,x=0;const Z=await this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",Z);for(const Me of Z)ne(Me)?L.addMode?W.push(Me):$.push(Me):_(Me)?q.push(Me):Me.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Me.remoteAuthority}),B.filesToOpenOrCreate.push(Me)):Me.backupPath?re.push({backupFolder:(0,d.basename)(Me.backupPath),remoteAuthority:Me.remoteAuthority}):x++;L.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),L.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&L.waitMarkerFileURI&&(B.filesToWait={paths:(0,R.coalesce)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(X.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),q.push(...X),re.push(...this.backupMainService.getEmptyWindowBackups())):re.length=0;const{windows:ce,filesOpenedInWindow:ge}=await this.doOpen(L,q,$,re,x,B,W);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${q.length}, foldersToOpen: ${$.length}, emptyToRestore: ${re.length}, emptyToOpen: ${x})`),ce.length>1)if(ge)ge.focus();else{const Me=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Le=!0,ve=!0;if(Me){const pe=ce.filter(Se=>this.windowsStateHandler.state.lastActiveWindow&&Se.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Le=!1,ve=!1)}if(Le)for(let pe=ce.length-1;pe>=0;pe--){const Se=ce[pe];if(!(Se.openedWorkspace&&X.some(ke=>Se.openedWorkspace&&ke.workspace.id===Se.openedWorkspace.id)||Se.backupPath&&re.some(ke=>Se.backupPath&&ke.backupFolder===(0,d.basename)(Se.backupPath)))){Se.focus(),ve=!1;break}}ve&&ce[ce.length-1].focus()}const De=B&&B.filesToDiff.length>0,Te=B&&B.filesToMerge.length>0;if(!ce.some(Me=>Me.isExtensionDevelopmentHost)&&!De&&!Te&&!L.noRecentEntry){const Me=[];for(const Le of Z)_(Le)&&!Le.transient?Me.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):ne(Le)?Me.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Me.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Me)}return this.handleWaitMarkerFile(L,ce),ce}handleWaitMarkerFile(L,W){const $=L.waitMarkerFileURI;L.context===0&&$&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.fileService.del($)}catch{}})()}async doOpen(L,W,$,q,X,re,B){const x=[];let Z;function ce(pe,Se){x.push(pe),Se&&(Z=pe,re=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:De}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&B.length>0){const pe=B[0].remoteAuthority,Se=this.getLastActiveWindowForAuthority(pe);Se&&ce(this.doAddFoldersToExistingWindow(Se,B.map(ke=>ke.workspace.uri)))}const Te=$.length+W.length+q.length;if(re&&Te===0){const pe=re.filesToOpenOrCreate[0]||re.filesToDiff[0]||re.filesToMerge[3],Se=this.getWindows().filter(J=>re&&(0,u.isEqualAuthority)(J.remoteAuthority,re.remoteAuthority));let ke;pe?.fileUri&&!De&&((L.context===4||L.context===0||L.context===1)&&(ke=await(0,oe.findWindowOnFile)(Se,pe.fileUri,async J=>J.configPath.scheme===C.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(J.configPath):void 0)),ke||(ke=this.doGetLastActiveWindow(Se))),ke?(0,se.isWorkspaceIdentifier)(ke.openedWorkspace)?W.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(ke.openedWorkspace)?$.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(L,ke,re),!0):ce(await this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:re,forceNewWindow:!0,remoteAuthority:re.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile}),!0)}const Me=(0,R.distinct)(W,pe=>pe.workspace.id);if(Me.length>0){const pe=(0,R.coalesce)(Me.map(Se=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.configPath)));if(pe.length>0){const Se=pe[0],ke=(0,u.isEqualAuthority)(re?.remoteAuthority,Se.remoteAuthority)?re:void 0;ce(this.doOpenFilesInExistingWindow(L,Se,ke),!!ke),ge=!0}for(const Se of Me){if(pe.some(ue=>ue.openedWorkspace&&ue.openedWorkspace.id===Se.workspace.id))continue;const ke=Se.remoteAuthority,J=(0,u.isEqualAuthority)(re?.remoteAuthority,ke)?re:void 0;ce(await this.doOpenFolderOrWorkspace(L,Se,ge,J),!!J),ge=!0}}const Le=(0,R.distinct)($,pe=>u.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(Le.length>0){const pe=(0,R.coalesce)(Le.map(Se=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.uri)));if(pe.length>0){const Se=pe[0],ke=(0,u.isEqualAuthority)(re?.remoteAuthority,Se.remoteAuthority)?re:void 0;ce(this.doOpenFilesInExistingWindow(L,Se,ke),!!ke),ge=!0}for(const Se of Le){if(pe.some(ue=>(0,se.isSingleFolderWorkspaceIdentifier)(ue.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(ue.openedWorkspace.uri,Se.workspace.uri)))continue;const ke=Se.remoteAuthority,J=(0,u.isEqualAuthority)(re?.remoteAuthority,ke)?re:void 0;ce(await this.doOpenFolderOrWorkspace(L,Se,ge,J),!!J),ge=!0}}const ve=(0,R.distinct)(q,pe=>pe.backupFolder);if(ve.length>0)for(const pe of ve){const Se=pe.remoteAuthority,ke=(0,u.isEqualAuthority)(re?.remoteAuthority,Se)?re:void 0;ce(await this.doOpenEmpty(L,!0,Se,ke,pe),!!ke),ge=!0}if(x.length===0||re){re&&!X&&X++;const pe=re?re.remoteAuthority:L.remoteAuthority;for(let Se=0;Se<X;Se++)ce(await this.doOpenEmpty(L,ge,pe,re),!!re),ge=!0}return{windows:(0,R.distinct)(x),filesOpenedInWindow:Z}}doOpenFilesInExistingWindow(L,W,$){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:$}),W.focus();const q={filesToOpenOrCreate:$?.filesToOpenOrCreate,filesToDiff:$?.filesToDiff,filesToMerge:$?.filesToMerge,filesToWait:$?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",D.CancellationToken.None,q),W}doAddFoldersToExistingWindow(L,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),L.focus();const $={foldersToAdd:W};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,$),L}doOpenEmpty(L,W,$,q,X){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!X,remoteAuthority:$,filesToOpen:q,forceNewWindow:W});let re;return!W&&typeof L.contextWindowId=="number"&&(re=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:$,forceNewWindow:W,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:q,windowToUse:re,emptyWindowBackupInfo:X,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}doOpenFolderOrWorkspace(L,W,$,q,X){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:q}),!$&&!X&&typeof L.contextWindowId=="number"&&(X=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:$,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:q,windowToUse:X,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}async getPathsToOpen(L){let W,$=!1,q=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(W=await this.doExtractPathsFromAPI(L),$=!0):L.forceEmpty?W=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(W=await this.doExtractPathsFromCLI(L.cli),W.length===0&&W.push(Object.create(null)),$=!0):(W=await this.doGetPathsFromLastSession(),W.length===0&&W.push(Object.create(null)),q=!0),!L.addMode&&$){const X=W.filter(re=>ne(re));if(X.length>1){const re=X[0].remoteAuthority;if(X.every(B=>(0,u.isEqualAuthority)(B.remoteAuthority,re))){const B=await this.workspacesManagementMainService.createUntitledWorkspace(X.map(x=>({uri:x.workspace.uri})));W.push({workspace:B,remoteAuthority:re}),W=W.filter(x=>!ne(x))}}}if(L.initialStartup&&!q&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const X=await this.doGetPathsFromLastSession();W.unshift(...X.filter(re=>_(re)||ne(re)||re.backupPath))}return W}async doExtractPathsFromAPI(L){const W={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},$=await Promise.all((0,R.coalesce)(L.urisToOpen||[]).map(async q=>{const X=await this.resolveOpenable(q,W);if(X)return X.label=q.label,X;const re=this.resourceFromOpenable(q),B={title:this.productService.nameLong,type:"info",buttons:[(0,b.mnemonicButtonLabel)((0,f.localize)(0,null))],defaultId:0,message:re.scheme===C.Schemas.file?(0,f.localize)(1,null):(0,f.localize)(2,null),detail:re.scheme===C.Schemas.file?(0,f.localize)(3,null,(0,b.getPathLabel)(re,{os:h.OS,tildify:this.environmentMainService})):(0,f.localize)(4,null,re.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(B,(0,v.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)($)}async doExtractPathsFromCLI(L){const W=[],$={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},q=L["folder-uri"];if(q){const B=await Promise.all(q.map(x=>{const Z=this.cliArgToUri(x);if(!!Z)return this.resolveOpenable({folderUri:Z},$)}));W.push(...(0,R.coalesce)(B))}const X=L["file-uri"];if(X){const B=await Promise.all(X.map(x=>{const Z=this.cliArgToUri(x);if(!!Z)return this.resolveOpenable((0,se.hasWorkspaceFileExtension)(x)?{workspaceUri:Z}:{fileUri:Z},$)}));W.push(...(0,R.coalesce)(B))}const re=await Promise.all(L._.map(B=>$.remoteAuthority?this.doResolveRemotePath(B,$):this.doResolveFilePath(B,$)));return W.push(...(0,R.coalesce)(re)),W}cliArgToUri(L){try{const W=g.URI.parse(L);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${L}, ${W.message}`)}}async doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];L!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const $=await Promise.all(W.map(async q=>{if(q.workspace){const X=await this.resolveOpenable({workspaceUri:q.workspace.configPath},{remoteAuthority:q.remoteAuthority,rejectTransientWorkspaces:!0});if(_(X))return X}else if(q.folderUri){const X=await this.resolveOpenable({folderUri:q.folderUri},{remoteAuthority:q.remoteAuthority});if(ne(X))return X}else if(L!=="folders"&&q.backupPath)return{backupPath:q.backupPath,remoteAuthority:q.remoteAuthority}}));return(0,R.coalesce)($)}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async resolveOpenable(L,W=Object.create(null)){const $=this.resourceFromOpenable(L);return $.scheme===C.Schemas.file?((0,G.isFileToOpen)(L)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath($.fsPath,W)):this.doResolveRemoteOpenable(L,W)}doResolveRemoteOpenable(L,W){let $=this.resourceFromOpenable(L);const q=(0,U.getRemoteAuthority)($)||W.remoteAuthority;if($=(0,u.removeTrailingPathSeparator)((0,u.normalizePath)($)),(0,G.isFileToOpen)(L)){if(W.gotoLineMode){const{path:X,line:re,column:B}=(0,p.parseLineAndColumnAware)($.path);return{fileUri:$.with({path:X}),options:{selection:re?{startLineNumber:re,startColumn:B||1}:void 0},remoteAuthority:q}}return{fileUri:$,remoteAuthority:q}}else if((0,G.isWorkspaceToOpen)(L))return{workspace:(0,fe.getWorkspaceIdentifier)($),remoteAuthority:q};return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)($),remoteAuthority:q}}resourceFromOpenable(L){return(0,G.isWorkspaceToOpen)(L)?L.workspaceUri:(0,G.isFolderToOpen)(L)?L.folderUri:L.fileUri}async doResolveFilePath(L,W){let $,q;W.gotoLineMode&&({path:L,line:$,column:q}=(0,p.parseLineAndColumnAware)(L)),L=(0,p.sanitizeFilePath)((0,d.normalize)(L),(0,w.cwd)());try{const X=await t.Promises.stat(L);if(X.isFile()){if(!W.forceOpenWorkspaceAsFile){const re=await this.workspacesManagementMainService.resolveLocalWorkspace(g.URI.file(L));if(re)return re.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:re.id,configPath:re.configPath},type:o.FileType.File,exists:!0,remoteAuthority:re.remoteAuthority,transient:re.transient}}return{fileUri:g.URI.file(L),type:o.FileType.File,exists:!0,options:{selection:$?{startLineNumber:$,startColumn:q||1}:void 0}}}else{if(X.isDirectory())return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(g.URI.file(L),X),type:o.FileType.Directory,exists:!0};if(!h.isWindows&&L==="/dev/null")return{fileUri:g.URI.file(L),type:o.FileType.File,exists:!0}}}catch{const re=g.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([re]),W.ignoreFileNotFound)return{fileUri:re,type:o.FileType.File,exists:!1}}}doResolveRemotePath(L,W){const $=L.charCodeAt(0),q=W.remoteAuthority;let X,re;W.gotoLineMode&&({path:L,line:X,column:re}=(0,p.parseLineAndColumnAware)(L)),$!==47&&((0,p.isWindowsDriveLetter)($)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,p.toSlashes)(L)),L=`/${L}`);const B=g.URI.from({scheme:C.Schemas.vscodeRemote,authority:q,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return W.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:X?{startLineNumber:X,startColumn:re||1}:void 0},remoteAuthority:W.remoteAuthority}:{workspace:(0,fe.getWorkspaceIdentifier)(B),remoteAuthority:q};if(W.gotoLineMode||d.posix.basename(L).indexOf(".")!==-1)return{fileUri:B,options:{selection:X?{startLineNumber:X,startColumn:re||1}:void 0},remoteAuthority:q}}return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:q}}shouldOpenNewWindow(L){const W=this.configurationService.getValue("window"),$=W?.openFoldersInNewWindow||"default",q=W?.openFilesInNewWindow||"off";let X=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&($==="on"||$==="off")&&(X=$==="on");let re=!1;return L.forceNewWindow||L.forceReuseWindow?re=!!L.forceNewWindow&&!L.forceReuseWindow:(h.isMacintosh?L.context===1&&(re=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(re=!0),!L.cli.extensionDevelopmentPath&&(q==="on"||q==="off")&&(re=q==="on")),{openFolderInNewWindow:!!X,openFilesInNewWindow:re}}async openExtensionDevelopmentHostWindow(L,W){const $=(0,oe.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if($)return this.lifecycleMainService.reload($,W.cli),$.focus(),[$];let q=W.cli["folder-uri"]||[],X=W.cli["file-uri"]||[],re=W.cli._;if(!re.length&&!q.length&&!X.length&&!W.cli.extensionTestsPath){const Z=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ce=Z?.workspace??Z?.folderUri;ce&&(g.URI.isUri(ce)?ce.scheme===C.Schemas.file?re=[ce.fsPath]:q=[ce.toString()]:ce.configPath.scheme===C.Schemas.file?re=[(0,u.originalFSPath)(ce.configPath)]:X=[ce.configPath.toString()])}let B=W.remoteAuthority;for(const Z of L)if(Z.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ce=g.URI.parse(Z),ge=(0,U.getRemoteAuthority)(ce);ge&&(B?(0,u.isEqualAuthority)(ge,B)||this.logService.error("more than one extension development path authority"):B=ge)}re=re.filter(Z=>{const ce=g.URI.file(Z);return(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:(0,u.isEqualAuthority)((0,U.getRemoteAuthority)(ce),B)}),q=q.filter(Z=>{const ce=this.cliArgToUri(Z);return ce&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,u.isEqualAuthority)((0,U.getRemoteAuthority)(ce),B):!1}),X=X.filter(Z=>{const ce=this.cliArgToUri(Z);return ce&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,u.isEqualAuthority)((0,U.getRemoteAuthority)(ce),B):!1}),W.cli._=re,W.cli["folder-uri"]=q,W.cli["file-uri"]=X;const x={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:!re.length&&!q.length&&!X.length,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:B,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile};return this.open(x)}async openInBrowserWindow(L){const W=this.configurationService.getValue("window"),$={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,d.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:await this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:y.default,isInitialStartup:L.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof W?.zoomLevel=="number"?W.zoomLevel:void 0,autoDetectHighContrast:W?.autoDetectHighContrast??!0,autoDetectColorScheme:W?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};let q;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(q=L.windowToUse||this.getLastActiveWindow(),q&&q.focus()),q){const X=q.config;!$.extensionDevelopmentPath&&X?.extensionDevelopmentPath&&($.extensionDevelopmentPath=X.extensionDevelopmentPath,$.extensionDevelopmentKind=X.extensionDevelopmentKind,$["enable-proposed-api"]=X["enable-proposed-api"],$.verbose=X.verbose,$["inspect-extensions"]=X["inspect-extensions"],$["inspect-brk-extensions"]=X["inspect-brk-extensions"],$.debugId=X.debugId,$.extensionEnvironment=X.extensionEnvironment,$["extensions-dir"]=X["extensions-dir"],$["disable-extensions"]=X["disable-extensions"])}else{const X=this.windowsStateHandler.getNewWindowState($);(0,m.mark)("code/willCreateCodeWindow");const re=q=this.instantiationService.createInstance(V.CodeWindow,{state:X,extensionDevelopmentPath:$.extensionDevelopmentPath,isExtensionTestHost:!!$.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(re),ft.WINDOWS.push(re),this._onDidOpenWindow.fire(re),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,S.once)(re.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(re)),(0,S.once)(re.onDidClose)(()=>this.onWindowClosed(re)),(0,S.once)(re.onDidDestroy)(()=>this._onDidDestroyWindow.fire(re)),re.onDidTriggerSystemContextMenu(({x,y:Z})=>this._onDidTriggerSystemContextMenu.fire({window:re,x,y:Z}));const B=(0,v.assertIsDefined)(re.win?.webContents);B.removeAllListeners("devtools-reload-page"),B.on("devtools-reload-page",()=>this.lifecycleMainService.reload(re)),this.lifecycleMainService.registerWindow(re)}return $.windowId=q.id,q.isReady?this.lifecycleMainService.unload(q,4).then(X=>{X||this.doOpenInBrowserWindow(q,$,L)}):this.doOpenInBrowserWindow(q,$,L),q}doOpenInBrowserWindow(L,W,$){W.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(W.workspace)?W.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:W.workspace,remoteAuthority:W.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(W.workspace)?W.backupPath=this.backupMainService.registerFolderBackup({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority}):W.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:$.emptyWindowBackupInfo?.backupFolder??(0,fe.createEmptyWorkspaceIdentifier)().id,remoteAuthority:W.remoteAuthority})),L.load(W)}async resolveProfileForBrowserWindow(L){let W;return this.userDataProfilesMainService.isEnabled()&&(L.forceProfile?W=this.userDataProfilesMainService.profiles.find($=>$.name===L.forceProfile)??await this.userDataProfilesMainService.createNamedProfile(L.forceProfile):L.forceTempProfile&&(W=await this.userDataProfilesMainService.createTransientProfile())),W?this.userDataProfilesMainService.setProfileForWorkspaceSync(L.workspace??"empty-window",W):W=this.userDataProfilesMainService.getOrSetProfileForWorkspace(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile),W}onWindowClosed(L){const W=ft.WINDOWS.indexOf(L);ft.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=E.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(W=>(0,u.isEqualAuthority)(W.remoteAuthority,L)))}doGetLastActiveWindow(L){const W=Math.max.apply(Math,L.map($=>$.lastFocusTime));return L.find($=>$.lastFocusTime===W)}sendToFocused(L,...W){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...W)}sendToAll(L,W,$){for(const q of this.getWindows())$&&$.indexOf(q.id)>=0||q.sendWhenReady(L,D.CancellationToken.None,W)}getWindows(){return ft.WINDOWS}getWindowCount(){return ft.WINDOWS.length}getWindowById(L){const W=this.getWindows().filter($=>$.id===L);return(0,R.firstOrDefault)(W)}getWindowByWebContents(L){const W=E.BrowserWindow.fromWebContents(L);if(!!W)return this.getWindowById(W.id)}};N.WINDOWS=[],N=we([ie(2,a.ILogService),ie(3,Y.IStateMainService),ie(4,A.IPolicyService),ie(5,i.IEnvironmentMainService),ie(6,O.IUserDataProfilesMainService),ie(7,l.ILifecycleMainService),ie(8,c.IBackupMainService),ie(9,n.IConfigurationService),ie(10,K.IWorkspacesHistoryMainService),ie(11,H.IWorkspacesManagementMainService),ie(12,s.IInstantiationService),ie(13,r.IDialogMainService),ie(14,o.IFileService),ie(15,M.IProductService),ie(16,T.IProtocolMainService),ie(17,F.IThemeMainService)],N),e.WindowsMainService=N}),define(ee[270],te([0,1,60,31,75,52]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(p,S,b,I){this.workspacesManagementMainService=p,this.windowsMainService=S,this.workspacesHistoryMainService=b,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(p,S){const b=this.windowsMainService.getWindowById(p);if(b)return this.workspacesManagementMainService.enterWorkspace(b,this.windowsMainService.getWindows(),S)}createUntitledWorkspace(p,S,b){return this.workspacesManagementMainService.createUntitledWorkspace(S,b)}deleteUntitledWorkspace(p,S){return this.workspacesManagementMainService.deleteUntitledWorkspace(S)}getWorkspaceIdentifier(p,S){return this.workspacesManagementMainService.getWorkspaceIdentifier(S)}getRecentlyOpened(p){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(p,S){return this.workspacesHistoryMainService.addRecentlyOpened(S)}removeRecentlyOpened(p,S){return this.workspacesHistoryMainService.removeRecentlyOpened(S)}clearRecentlyOpened(p){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=we([ie(0,R.IWorkspacesManagementMainService),ie(1,t.IWindowsMainService),ie(2,k.IWorkspacesHistoryMainService),ie(3,E.IBackupMainService)],D),e.WorkspacesMainService=D}),define(ee[271],te([0,1,13,40,27,17,43,16,30,49,42,33,2,14,9,4,12,7,29,81,130,45,144,102,247,147,60,262,18,70,179,84,118,56,105,201,26,59,111,191,213,192,249,106,193,194,15,205,86,69,5,85,263,226,250,21,6,207,268,65,20,63,256,88,37,253,91,112,35,231,233,73,47,238,239,264,240,265,114,242,243,244,245,251,31,269,252,28,92,75,270,52,248,36,212,51,222,55,87,116,254,259,260,8]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u,v,g,f,c,n,r,i,o,s,l,a,y,M,T,U,Y,G,V,oe,ae,se,fe,K,H,F,A,O,_,ne,N,j,L,W,$,q,X,re,B,x,Z,ce,ge,De,Te,Me,Le,ve,pe,Se,ke,J,ue,de,ye,Ce,Fe,Oe,$e,Ne,je,Xe,Be,Ge,Q,le,he,me,be,Ae,Ue,it,xe,He,et,nt,ct,gt,Ct,zt,$t,_t,jt,qt,Ht,Vt,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Pt=class extends C.Disposable{constructor(Ee,Pe,Re,Ie,We,ze,Ze,tt,_e,Ve,Ke){super(),this.mainProcessNodeIpcServer=Ee,this.userEnv=Pe,this.mainInstantiationService=Re,this.logService=Ie,this.environmentMainService=We,this.lifecycleMainService=ze,this.configurationService=Ze,this.stateMainService=tt,this.fileService=_e,this.productService=Ve,this.userDataProfilesMainService=Ke,this.configureSession(),this.registerListeners()}configureSession(){const Ee=_e=>_e?.startsWith(`${d.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((_e,Ve,Ke,Je)=>Ee(Je.requestingUrl)?Ke(Pe.has(Ve)):Ke(!1)),E.session.defaultSession.setPermissionCheckHandler((_e,Ve,Ke,Je)=>Ee(Je.requestingUrl)?Pe.has(Ve):!1);const Re=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Ie=_e=>{for(let Ve=_e;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},We=_e=>_e.resourceType==="xhr"||Ie(_e.frame),ze=_e=>{const Ve=_e.frame;if(!Ve||!this.windowsMainService)return!1;const Ke=E.BrowserWindow.getAllWindows();for(const Je of Ke)if(Ve.processId===Je.webContents.mainFrame.processId)return!0;return!1},Ze=(_e,Ve)=>{if(_e.path!=="/index.html")return!0;const Ke=Ve.frame;if(!Ke||!this.windowsMainService)return!1;for(const Je of this.windowsMainService.getWindows())if(Je.win&&Ke.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((_e,Ve)=>{const Ke=u.URI.parse(_e.url);return Ke.scheme===d.Schemas.vscodeWebview&&!Ze(Ke,_e)?(this.logService.error("Blocked vscode-webview request",_e.url),Ve({cancel:!0})):Ke.scheme===d.Schemas.vscodeFileResource&&!ze(_e)?(this.logService.error("Blocked vscode-file request",_e.url),Ve({cancel:!0})):Ke.path.endsWith(".svg")&&!Re.has(Ke.scheme)?Ve({cancel:!We(_e)}):Ve({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((_e,Ve)=>{const Ke=_e.responseHeaders,Je=Ke["content-type"]||Ke["Content-Type"];if(Je&&Array.isArray(Je)){const st=u.URI.parse(_e.url);if(st.path.endsWith(".svg")&&Re.has(st.scheme))return Ke["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Ke});if(!st.path.endsWith(d.Schemas.vscodeRemoteResource)&&Je.some(at=>at.toLowerCase().includes("image/svg")))return Ve({cancel:!We(_e)})}return Ve({cancel:!1})});const tt=E.session.defaultSession;typeof tt.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&tt.setCodeCachePath((0,m.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,P.setUnexpectedErrorHandler)(Re=>this.onUnexpectedError(Re)),process.on("uncaughtException",Re=>(0,P.onUnexpectedError)(Re)),process.on("unhandledRejection",Re=>(0,P.onUnexpectedError)(Re)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,f.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(Re,Ie)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),E.app.on("activate",async(Re,Ie)=>{this.logService.trace("app#activate"),Ie||await this.windowsMainService?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(Re,Ie)=>{Ie.on("will-navigate",We=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),We.preventDefault()}),Ie.setWindowOpenHandler(({url:We})=>(this.nativeHostMainService?.openExternal(void 0,We),{action:"deny"}))});let Ee=[],Pe;E.app.on("open-file",(Re,Ie)=>{this.logService.trace("app#open-file: ",Ie),Re.preventDefault(),Ee.push((0,Ue.hasWorkspaceFileExtension)(Ie)?{workspaceUri:u.URI.file(Ie)}:{fileUri:u.URI.file(Ie)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],Pe=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Re=>{const Ie=this.windowsMainService?.getWindowByWebContents(Re.sender);let We,ze;return Ie?.config?(We=Ie.config,ze={...process.env,...Ie.config.userEnv}):(We=this.environmentMainService.args,ze=process.env),this.resolveShellEnvironment(We,ze,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Re,Ie,We)=>{const ze=this.validateNlsPath([Ie]);if(!ze||typeof We!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(ze,R.VSBuffer.fromString(We))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Re,...Ie)=>{const We=this.validateNlsPath(Ie);if(!We)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(We)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Re=>Re.sender.reload())}validateNlsPath(Ee){let Pe;for(const Re of Ee)typeof Re=="string"&&(typeof Pe!="string"?Pe=Re:Pe=(0,m.join)(Pe,Re));if(!(typeof Pe!="string"||!(0,m.isAbsolute)(Pe)||!(0,p.isEqualOrParent)(Pe,this.environmentMainService.cachedLanguagesPath,!h.isLinux)))return u.URI.file(Pe)}onUnexpectedError(Ee){if(Ee){const Pe={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.logService.error(Ee.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ee=this.productService.win32AppUserModelId;h.isWindows&&Ee&&E.app.setAppUserModelId(Ee);try{h.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(_e){this.logService.error(_e)}const Pe=new n.Server;this.lifecycleMainService.onWillShutdown(_e=>{_e.reason===2&&Pe.dispose()}),this.logService.trace("Resolving machine identifier...");const Re=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Re}`);const{sharedProcess:Ie,sharedProcessReady:We,sharedProcessClient:ze}=this.setupSharedProcess(Re),Ze=await this.initServices(Re,Ie,We);this.setUpHandlers(Ze),Ze.invokeFunction(_e=>this.initChannels(_e,Pe,ze)),await Ze.invokeFunction(_e=>this.openFirstWindow(_e,Pe)),Ze.invokeFunction(_e=>this.afterWindowOpen(_e,Ie)),this._register(new It.RunOnceScheduler(()=>{this._register((0,It.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setUpHandlers(Ee){this._register(Ee.createInstance(i.ProxyAuthHandler)),this._register(Ee.createInstance(Ht.UserDataTransientProfilesHandler))}async resolveMachineId(){let Ee=this.stateMainService.getItem(J.machineIdKey);return(!Ee||h.isMacintosh&&Ee==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(Ee=await(0,g.getMachineId)(),this.stateMainService.setItem(J.machineIdKey,Ee)),Ee}setupSharedProcess(Ee){const Pe=this._register(this.mainInstantiationService.createInstance(Me.SharedProcess,Ee,this.userEnv)),Re=(async()=>{this.logService.trace("Main->SharedProcess#connect");const We=await Pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new r.Client(We,"main")})(),Ie=(async()=>(await Pe.whenReady(),Re))();return{sharedProcess:Pe,sharedProcessReady:Ie,sharedProcessClient:Re}}async initServices(Ee,Pe,Re){const Ie=new $.ServiceCollection;switch(process.platform){case"win32":Ie.set(Ce.IUpdateService,new L.SyncDescriptor(je.Win32UpdateService));break;case"linux":h.isLinuxSnap?Ie.set(Ce.IUpdateService,new L.SyncDescriptor(Ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(Ce.IUpdateService,new L.SyncDescriptor($e.LinuxUpdateService));break;case"darwin":Ie.set(Ce.IUpdateService,new L.SyncDescriptor(Oe.DarwinUpdateService));break}Ie.set(me.IWindowsMainService,new L.SyncDescriptor(be.WindowsMainService,[Ee,this.userEnv],!1));const We=new Y.DialogMainService(this.logService);Ie.set(Y.IDialogMainService,We),Ie.set(re.ILaunchMainService,new L.SyncDescriptor(re.LaunchMainService,void 0,!1)),Ie.set(U.IDiagnosticsMainService,new L.SyncDescriptor(U.DiagnosticsMainService,void 0,!1)),Ie.set(T.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(Re.then(tt=>tt.getChannel("diagnostics"))))),Ie.set(q.IIssueMainService,new L.SyncDescriptor(q.IssueMainService,[this.userEnv])),Ie.set(G.IEncryptionMainService,new L.SyncDescriptor(V.EncryptionMainService,[Ee])),Ie.set(X.IKeyboardLayoutMainService,new L.SyncDescriptor(X.KeyboardLayoutMainService)),Ie.set(ge.INativeHostMainService,new L.SyncDescriptor(ge.NativeHostMainService,[Pe],!1)),Ie.set(y.ICredentialsMainService,new L.SyncDescriptor(nt.CredentialsNativeMainService)),Ie.set(le.IWebviewManagerService,new L.SyncDescriptor(he.WebviewMainService)),Ie.set(ce.IMenubarMainService,new L.SyncDescriptor(ce.MenubarMainService)),Ie.set(fe.IExtensionUrlTrustService,new L.SyncDescriptor(K.ExtensionUrlTrustService)),Ie.set(H.IExtensionHostStarter,new L.SyncDescriptor(F.ExtensionHostStarter)),Ie.set(Se.IStorageMainService,new L.SyncDescriptor(Se.StorageMainService)),Ie.set(Se.IApplicationStorageMainService,new L.SyncDescriptor(Se.ApplicationStorageMainService)),h.isWindows?Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(O.WindowsExternalTerminalService)):h.isMacintosh?Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(O.MacExternalTerminalService)):h.isLinux&&Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(O.LinuxExternalTerminalService));const ze=new l.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateMainService);Ie.set(s.IBackupMainService,ze);const Ze=new et.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,ze,We,this.productService);if(Ie.set(et.IWorkspacesManagementMainService,Ze),Ie.set(it.IWorkspacesService,new L.SyncDescriptor(He.WorkspacesMainService,void 0,!1)),Ie.set(xe.IWorkspacesHistoryMainService,new L.SyncDescriptor(xe.WorkspacesHistoryMainService,void 0,!1)),Ie.set(Xe.IURLService,new L.SyncDescriptor(Ge.NativeURLService,void 0,!1)),(0,ye.supportsTelemetry)(this.productService,this.environmentMainService)){const tt=(0,ye.isInternalTelemetry)(this.productService,this.configurationService),_e=(0,c.getDelayedChannel)(Re.then(at=>at.getChannel("telemetryAppender"))),Ve=new ue.TelemetryAppenderClient(_e),Ke=(0,ke.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,Ee,tt,this.environmentMainService.installSourcePath),Je=(0,ye.getPiiPathsFromEnvironment)(this.environmentMainService),st={appenders:[Ve],commonProperties:Ke,piiPaths:Je,sendErrorTelemetry:!0};Ie.set(J.ITelemetryService,new L.SyncDescriptor(de.TelemetryService,[st],!1))}else Ie.set(J.ITelemetryService,ye.NullTelemetryService);return Ie.set(_t.IExtensionsProfileScannerService,new L.SyncDescriptor(_t.ExtensionsProfileScannerService,void 0,!0)),Ie.set(jt.IExtensionsScannerService,new L.SyncDescriptor(qt.ExtensionsScannerService,void 0,!0)),await It.Promises.settled([ze.initialize(),Ze.initialize()]),this.mainInstantiationService.createChild(Ie)}initChannels(Ee,Pe,Re){const Ie=c.ProxyChannel.fromService(Ee.get(re.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Ie);const We=c.ProxyChannel.fromService(Ee.get(U.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",We);const ze=new gt.PolicyChannel(Ee.get(ct.IPolicyService));Pe.registerChannel("policy",ze),Re.then(Qe=>Qe.registerChannel("policy",ze));const Ze=this.fileService.getProvider(d.Schemas.file);(0,w.assertType)(Ze instanceof j.DiskFileSystemProvider);const tt=new N.DiskFileSystemProviderChannel(Ze,this.logService,this.environmentMainService);Pe.registerChannel(_.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt),Re.then(Qe=>Qe.registerChannel(_.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt));const _e=c.ProxyChannel.fromService(Ee.get(Ct.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",_e),Re.then(Qe=>Qe.registerChannel("userDataProfiles",_e));const Ve=new zt.RequestChannel(Ee.get($t.IRequestService));Re.then(Qe=>Qe.registerChannel("request",Ve));const Ke=new Fe.UpdateChannel(Ee.get(Ce.IUpdateService));Pe.registerChannel("update",Ke);const Je=c.ProxyChannel.fromService(Ee.get(q.IIssueMainService));Pe.registerChannel("issue",Je);const st=c.ProxyChannel.fromService(Ee.get(G.IEncryptionMainService));Pe.registerChannel("encryption",st);const at=c.ProxyChannel.fromService(Ee.get(y.ICredentialsMainService));Pe.registerChannel("credentials",at);const kt=c.ProxyChannel.fromService(Ee.get(Le.ISignService));Pe.registerChannel("sign",kt);const Ye=c.ProxyChannel.fromService(Ee.get(X.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",Ye),this.nativeHostMainService=Ee.get(ge.INativeHostMainService);const mt=c.ProxyChannel.fromService(this.nativeHostMainService);Pe.registerChannel("nativeHost",mt),Re.then(Qe=>Qe.registerChannel("nativeHost",mt));const pt=c.ProxyChannel.fromService(Ee.get(it.IWorkspacesService));Pe.registerChannel("workspaces",pt);const St=c.ProxyChannel.fromService(Ee.get(ce.IMenubarMainService));Pe.registerChannel("menubar",St);const Mt=c.ProxyChannel.fromService(Ee.get(Xe.IURLService));Pe.registerChannel("url",Mt);const Dt=c.ProxyChannel.fromService(Ee.get(fe.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",Dt);const wt=c.ProxyChannel.fromService(Ee.get(le.IWebviewManagerService));Pe.registerChannel("webview",wt);const lt=this._register(new pe.StorageDatabaseChannel(this.logService,Ee.get(Se.IStorageMainService)));Pe.registerChannel("storage",lt),Re.then(Qe=>Qe.registerChannel("storage",lt));const yt=this._register(new Vt.ProfileStorageChangesListenerChannel(Ee.get(Se.IStorageMainService),Ee.get(Ct.IUserDataProfilesMainService),this.logService));Re.then(Qe=>Qe.registerChannel("profileStorageListener",yt));const vt=c.ProxyChannel.fromService(Ee.get(A.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",vt);const ut=new Z.LogLevelChannel(Ee.get(x.ILogService),Ee.get(x.ILoggerService));Pe.registerChannel("logLevel",ut),Re.then(Qe=>Qe.registerChannel("logLevel",ut));const qe=new Z.LoggerChannel(Ee.get(x.ILoggerService));Pe.registerChannel("logger",qe),Re.then(Qe=>Qe.registerChannel("logger",qe));const ot=new M.ElectronExtensionHostDebugBroadcastChannel(Ee.get(me.IWindowsMainService));Pe.registerChannel("extensionhostdebugservice",ot);const dt=c.ProxyChannel.fromService(Ee.get(H.IExtensionHostStarter));Pe.registerChannel(H.ipcExtensionHostStarterChannelName,dt)}async openFirstWindow(Ee,Pe){const Re=this.windowsMainService=Ee.get(me.IWindowsMainService),Ie=Ee.get(Xe.IURLService),We=Ee.get(ge.INativeHostMainService);this.lifecycleMainService.phase=2;const ze=[],Ze=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(qe=>{try{return{uri:u.URI.parse(qe),url:qe}}catch{return}}).filter(qe=>{if(!qe||this.shouldBlockURI(qe.uri))return!1;const ot=this.getWindowOpenableFromProtocolLink(qe.uri);return ot?(ze.push(ot),!1):!0}),tt=this,_e=this.environmentMainService,Ve=this.productService,Ke=this.logService;Ie.registerHandler({async handleURL(qe,ot){if(Ke.trace("app#handleURL: ",qe.toString(!0),ot),qe.scheme===Ve.urlProtocol&&qe.path==="workspace"&&(qe=qe.with({authority:"file",path:u.URI.parse(qe.query).path,query:""})),tt.shouldBlockURI(qe))return!0;let dt=!1;const Qe=new URLSearchParams(qe.query);Qe.get("windowId")==="_blank"&&(Qe.delete("windowId"),qe=qe.with({query:Qe.toString()}),dt=!0),dt||=h.isMacintosh&&Re.getWindowCount()===0;const Ut=Qe.get("continueOn");Ut!==null&&(_e.continueOn=Ut??void 0,Qe.delete("continueOn"),qe=qe.with({query:Qe.toString()}));const Rt=tt.getWindowOpenableFromProtocolLink(qe);if(Ke.trace("app#handleURL: windowOpenableFromProtocolLink = ",Rt),Rt){const[Lt]=await Re.open({context:5,cli:{..._e.args},urisToOpen:[Rt],forceNewWindow:dt,gotoLineMode:!0});return Lt.focus(),!0}if(dt){const[Lt]=await Re.open({context:5,cli:{..._e.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Te.getRemoteAuthority)(qe)});return await Lt.ready(),Ie.open(qe,ot)}return!1}});const Je=this._register(new Ae.ActiveWindowManager({onDidOpenWindow:We.onDidOpenWindow,onDidFocusWindow:We.onDidFocusWindow,getActiveWindowId:()=>We.getActiveWindowId(-1)})),st=new c.StaticRouter(qe=>Je.getActiveClientId().then(ot=>qe===ot)),at=new Be.URLHandlerRouter(st),kt=Pe.getChannel("urlHandler",at);Ie.registerHandler(new Be.URLHandlerChannelClient(kt)),this._register(new Q.ElectronURLListener(Ze,Ie,Re,this.environmentMainService,this.productService));const Ye=this.environmentMainService.args,mt=global.macOpenFiles,pt=(0,ae.isLaunchedFromCli)(process.env)?0:4,St=Ye._.length,Mt=!!Ye["folder-uri"],Dt=!!Ye["file-uri"],wt=Ye["skip-add-to-recently-opened"]===!0,lt=Ye.wait&&Ye.waitMarkerFilePath?u.URI.file(Ye.waitMarkerFilePath):void 0,yt=Ye.remote||void 0,vt=Ye.profile,ut=Ye["profile-temp"];if(ze.length>0)return Re.open({context:pt,cli:Ye,urisToOpen:ze,gotoLineMode:!0,initialStartup:!0});if(!St&&!Mt&&!Dt){if(Ye["new-window"]||vt||ut)return Re.open({context:pt,cli:Ye,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:wt,waitMarkerFileURI:lt,initialStartup:!0,remoteAuthority:yt,forceProfile:vt,forceTempProfile:ut});if(mt.length)return Re.open({context:1,cli:Ye,urisToOpen:mt.map(qe=>(0,Ue.hasWorkspaceFileExtension)(qe)?{workspaceUri:u.URI.file(qe)}:{fileUri:u.URI.file(qe)}),noRecentEntry:wt,waitMarkerFileURI:lt,initialStartup:!0})}return Re.open({context:pt,cli:Ye,forceNewWindow:Ye["new-window"]||!St&&Ye["unity-launch"],diffMode:Ye.diff,mergeMode:Ye.merge,noRecentEntry:wt,waitMarkerFileURI:lt,gotoLineMode:Ye.goto,initialStartup:!0,remoteAuthority:yt,forceProfile:vt,forceTempProfile:ut})}shouldBlockURI(Ee){return!!(Ee.authority===d.Schemas.file&&h.isWindows&&E.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,I.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,I.getPathLabel)(Ee,{os:h.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(Ee){if(!!Ee.path){if(Ee.authority===d.Schemas.file){const Pe=u.URI.file(Ee.fsPath);return(0,Ue.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(Ee.authority===d.Schemas.vscodeRemote){const Pe=Ee.path.indexOf(m.posix.sep,1);if(Pe!==-1){const Re=Ee.path.substring(1,Pe),Ie=Ee.path.substring(Pe),We=u.URI.from({scheme:d.Schemas.vscodeRemote,authority:Re,path:Ie,query:Ee.query,fragment:Ee.fragment});return(0,Ue.hasWorkspaceFileExtension)(Ie)?{workspaceUri:We}:/:[\d]+$/.test(Ie)?{fileUri:We}:{folderUri:We}}}}}afterWindowOpen(Ee,Pe){const Re=Ee.get(J.ITelemetryService),Ie=Ee.get(Ce.IUpdateService);this.lifecycleMainService.phase=3,this.handleSharedProcessErrors(Re,Pe),this.installMutex(),E.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(We,ze)=>{ze({url:We.url.replace(/^vscode-remote-resource:/,"http:"),method:We.method})}),(Ie instanceof je.Win32UpdateService||Ie instanceof $e.LinuxUpdateService||Ie instanceof Oe.DarwinUpdateService)&&Ie.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const Ee=this.productService.win32MutexName;if(h.isWindows&&Ee)try{const Pe=await new Promise((Ie,We)=>{z(["windows-mutex"],Ie,We)}),Re=new Pe.Mutex(Ee);(0,S.once)(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(Pe){this.logService.error(Pe)}}handleSharedProcessErrors(Ee,Pe){let Re=!1;(0,S.once)(this.lifecycleMainService.onWillShutdown)(()=>Re=!0),this._register(Pe.onDidError(({type:Ie,details:We})=>{let ze;switch(Ie){case 1:ze="SharedProcess: detected unresponsive window";break;case 2:ze=`SharedProcess: renderer process gone (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break;case 3:ze=`SharedProcess: failed to load (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break}(0,P.onUnexpectedError)(new Error(ze)),Ee.publicLog2("sharedprocesserror",{type:Ie,reason:We?.reason,code:We?.exitCode,visible:Pe.isVisible(),shuttingdown:Re})}))}async resolveShellEnvironment(Ee,Pe,Re){try{return await(0,se.getResolvedShellEnv)(this.logService,Ee,Pe)}catch(Ie){const We=(0,D.toErrorMessage)(Ie);Re?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",We):this.logService.error(We)}return{}}async updateCrashReporterEnablement(){try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Re=JSON.parse((0,b.stripComments)(Pe)),We=(0,ye.getTelemetryLevel)(this.configurationService)>=1;if(Re["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${We},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.generateUuid)()}"`,"}"],Ze=Pe.substring(0,Pe.length-2).concat(`,
`,ze.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Ze))}else{const ze=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${We},`);ze!==Pe&&await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(ze))}}catch(Ee){this.logService.error(Ee)}}};Pt=we([ie(2,W.IInstantiationService),ie(3,x.ILogService),ie(4,oe.IEnvironmentMainService),ie(5,B.ILifecycleMainService),ie(6,a.IConfigurationService),ie(7,ve.IStateMainService),ie(8,ne.IFileService),ie(9,De.IProductService),ie(10,Ct.IUserDataProfilesMainService)],Pt),e.CodeApplication=Pt}),define(ee[272],te([0,1,36,8,279,2]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends E.AbstractPolicyService{constructor(p){super(),this.productName=p,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(p){await this.throttler.queue(()=>new Promise((S,b)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,p,I=>{for(const C in I){const d=I[C];d===void 0?this.policies.delete(C):this.policies.set(C,d)}this._onDidChange.fire(Object.keys(I)),S()})}catch(I){b(I)}}))}}e.NativePolicyService=D}),define(ee[273],te([0,1,224,8,17,16,2,12,18,34,111,6,223,280]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let m=class extends D.Disposable{constructor(w,u,v){super(),this.environmentService=u,this.logService=v,this.configure(w.getValue()),this._register(w.onDidChangeConfiguration(()=>this.configure(w.getValue()),this))}configure(w){this.proxyUrl=w.http&&w.http.proxy,this.strictSSL=!!(w.http&&w.http.proxyStrictSSL),this.authorization=w.http&&w.http.proxyAuthorization}async request(w,u){this.logService.trace("RequestService#request (node) - begin",w.url);const{proxyUrl:v,strictSSL:g}=this;let f;try{f=await(0,b.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const c={...process.env,...f},n=w.agent?w.agent:await(0,C.getProxyAgent)(w.url||"",c,{proxyUrl:v,strictSSL:g});w.agent=n,w.strictSSL=g,this.authorization&&(w.headers={...w.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(w,u);return this.logService.trace("RequestService#request (node) - success",w.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",w.url,r),r}}async getNodeRequest(w){return((0,E.parse)(w.url).protocol==="https:"?await new Promise((g,f)=>{z(["https"],g,f)}):await new Promise((g,f)=>{z(["http"],g,f)})).request}_request(w,u){return t.Promises.withAsyncBody(async(v,g)=>{const f=(0,E.parse)(w.url),c=w.getRawRequest?w.getRawRequest(w):await this.getNodeRequest(w),n={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,P.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(n.auth=w.user+":"+w.password);const r=c(n,i=>{const o=(0,P.isNumber)(w.followRedirects)?w.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&o>0&&i.headers.location)this._request({...w,url:i.headers.location,followRedirects:o-1},u).then(v,g);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,d.createGunzip)())),v({res:i,stream:(0,k.streamToBufferReadableStream)(s)})}});r.on("error",g),w.timeout&&r.setTimeout(w.timeout),w.data&&typeof w.data=="string"&&r.write(w.data),r.end(),u.onCancellationRequested(()=>{r.abort(),g(new R.CancellationError)})})}async resolveProxy(w){}};m=we([ie(0,p.IConfigurationService),ie(1,S.INativeEnvironmentService),ie(2,I.ILogService)],m),e.RequestService=m}),define(ee[274],te([0,1,13,273]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(D){return E.net.request}class R extends t.RequestService{request(P,p){return super.request({...P||{},getRawRequest:k},p)}}e.RequestMainService=R}),define(ee[281],te([0,1,13,39,7,24,8,43,16,30,49,33,14,9,72,4,32,25,23,45,83,271,10,18,217,230,26,59,183,15,203,86,69,199,85,21,206,6,209,54,20,61,255,113,236,55,274,88,225,37,229,73,64,51,36,272,211,2,48,241,41,237]),function(z,e,E,t,k,R,D,P,p,S,b,I,C,d,m,h,w,u,v,g,f,c,n,r,i,o,s,l,a,y,M,T,U,Y,G,V,oe,ae,se,fe,K,H,F,A,O,_,ne,N,j,L,W,$,q,X,re,B,x,Z,ce,ge,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Te{main(){try{this.startup()}catch(ve){console.error(ve.message),E.app.exit(1)}}async startup(){(0,p.setUnexpectedErrorHandler)(Ce=>console.error(Ce));const[ve,pe,Se,ke,J,ue,de,ye]=this.createServices();try{try{await this.initServices(Se,ye,ke,J,de)}catch(Ce){throw this.handleStartupDataDirError(Se,de.nameLong,Ce),Ce}await ve.invokeFunction(async Ce=>{const Fe=Ce.get(ae.ILogService),Oe=Ce.get(V.ILifecycleMainService),$e=Ce.get(y.IFileService),Ne=Ce.get(ae.ILoggerService),je=await this.claimInstance(Fe,Se,Oe,ve,de,!0);return v.Promises.writeFile(Se.mainLockfile,String(process.pid)).catch(Xe=>{Fe.warn(`Error writing main lockfile: ${Xe.stack}`)}),ue.logger=Ne.createLogger(k.URI.file((0,d.join)(Se.logsPath,"main.log")),{name:"main"}),(0,b.once)(Oe.onWillShutdown)(Xe=>{$e.dispose(),ke.dispose(),Xe.join(v.Promises.unlink(Se.mainLockfile).catch(()=>{}))}),ve.createInstance(c.CodeApplication,je,pe).startup()})}catch(Ce){ve.invokeFunction(this.quit,Ce)}}createServices(){const ve=new G.ServiceCollection,pe=new Z.DisposableStore;process.once("exit",()=>pe.dispose());const Se={_serviceBrand:void 0,...fe.default};ve.set(K.IProductService,Se);const ke=new s.EnvironmentMainService(this.resolveArgs(),Se),J=this.patchEnvironment(ke);ve.set(s.IEnvironmentMainService,ke);const ue=new oe.BufferLogService,de=pe.add(new ae.MultiplexLogService([new ae.ConsoleMainLogger((0,ae.getLogLevel)(ke)),ue]));ve.set(ae.ILogService,de);const ye=new M.FileService(de);ve.set(y.IFileService,ye);const Ce=new T.DiskFileSystemProvider(de);ye.registerProvider(C.Schemas.file,Ce);const Fe=new ge.UriIdentityService(ye);ve.set(ce.IUriIdentityService,Fe),ve.set(ae.ILoggerService,new se.LoggerService(de));const Oe=new W.StateMainService(ke,de,ye);ve.set(L.IStateMainService,Oe);const $e=new X.UserDataProfilesMainService(Oe,Fe,ke,ye,de);ve.set(X.IUserDataProfilesMainService,$e);const Ne=h.isWindows&&Se.win32RegValueName?pe.add(new B.NativePolicyService(Se.win32RegValueName)):ke.policyFile?pe.add(new x.FilePolicyService(ke.policyFile,ye,de)):new re.NullPolicyService;ve.set(re.IPolicyService,Ne);const je=new i.ConfigurationService($e.defaultProfile.settingsResource,ye,Ne,de);return ve.set(r.IConfigurationService,je),ve.set(V.ILifecycleMainService,new U.SyncDescriptor(V.LifecycleMainService,void 0,!1)),ve.set(_.IRequestService,new U.SyncDescriptor(ne.RequestMainService,void 0,!0)),ve.set(q.IThemeMainService,new U.SyncDescriptor(q.ThemeMainService)),ve.set(N.ISignService,new U.SyncDescriptor(j.SignService,void 0,!1)),ve.set(A.ITunnelService,new U.SyncDescriptor(O.TunnelService)),ve.set(H.IProtocolMainService,new F.ProtocolMainService(ke,$e,de)),[new Y.InstantiationService(ve,!0),J,ke,je,Oe,ue,Se,$e]}patchEnvironment(ve){const pe={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Se=>{const ke=process.env[Se];typeof ke=="string"&&(pe[Se]=ke)}),Object.assign(process.env,pe),pe}async initServices(ve,pe,Se,ke,J){await D.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsPath,pe.defaultProfile.globalStorageHome.fsPath,ve.workspaceStorageHome.fsPath,ve.localHistoryHome.fsPath,ve.backupHome].map(ue=>ue?v.Promises.mkdir(ue,{recursive:!0}):void 0)),ke.init(),Se.initialize()]),pe.setEnablement(J.quality!=="stable"||Se.getValue(De.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(ve,pe,Se,ke,J,ue){let de;try{(0,m.mark)("code/willStartMainServer"),de=await(0,f.serve)(pe.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),(0,b.once)(Se.onWillShutdown)(()=>de.dispose())}catch(ye){if(ye.code!=="EADDRINUSE")throw this.handleStartupDataDirError(pe,J.nameLong,ye),ye;let Ce;try{Ce=await(0,f.connect)(pe.mainIPCHandle,"main")}catch(Ne){if(!ue||h.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,n.localize)(0,null,J.nameShort),(0,n.localize)(1,null),J.nameLong),Ne;try{(0,t.unlinkSync)(pe.mainIPCHandle)}catch(je){throw ve.warn("Could not delete obsolete instance handle",je),je}return this.claimInstance(ve,pe,Se,ke,J,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ve.error(Ne),Ce.dispose(),new Error(Ne)}let Fe;!pe.args.wait&&!pe.args.status&&(Fe=setTimeout(()=>{this.showStartupWarningDialog((0,n.localize)(2,null,J.nameShort),(0,n.localize)(3,null),J.nameLong)},1e4));const Oe=g.ProxyChannel.toService(Ce.getChannel("launch"),{disableMarshalling:!0}),$e=g.ProxyChannel.toService(Ce.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return ke.invokeFunction(async()=>{const Ne=new o.DiagnosticsService($.NullTelemetryService,J),je=await $e.getMainDiagnostics(),Xe=await $e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(je,Xe);throw console.log(Be),new p.ExpectedError});throw h.isWindows&&await this.windowsAllowSetForegroundWindow(Oe,ve),ve.trace("Sending env to running instance..."),await Oe.start(pe.args,process.env),Ce.dispose(),Fe&&clearTimeout(Fe),new p.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw ve.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new p.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}handleStartupDataDirError(ve,pe,Se){if(Se.code==="EACCES"||Se.code==="EPERM"){const ke=(0,R.coalesce)([ve.userDataPath,ve.extensionsPath,f.XDG_RUNTIME_DIR]).map(J=>(0,I.getPathLabel)(k.URI.file(J),{os:h.OS,tildify:ve}));this.showStartupWarningDialog((0,n.localize)(4,null),(0,n.localize)(5,null,(0,P.toErrorMessage)(Se),ke.join(`
`)),pe)}}showStartupWarningDialog(ve,pe,Se){E.dialog.showMessageBoxSync({title:Se,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,n.localize)(6,null))],message:ve,detail:pe,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ve,pe){if(h.isWindows){const Se=await ve.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",Se);try{(await new Promise((ke,J)=>{z(["windows-foreground-love"],ke,J)})).allowSetForegroundWindow(Se)}catch(ke){pe.error(ke)}}}quit(ve,pe){const Se=ve.get(ae.ILogService),ke=ve.get(V.ILifecycleMainService);let J=0;pe&&(pe.isExpected?pe.message&&Se.trace(pe.message):(J=1,pe.stack?Se.error(pe.stack):Se.error(`Startup error: ${pe.toString()}`))),ke.kill(J)}resolveArgs(){const ve=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const pe=(0,a.createWaitMarkerFileSync)(ve.verbose);pe&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",pe),ve.waitMarkerFilePath=pe)}return ve}validatePaths(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const pe=this.doValidatePaths(ve._,ve.goto);ve._=pe}return ve}doValidatePaths(ve,pe){const Se=(0,w.cwd)(),ke=ve.map(de=>{let ye=String(de),Ce;pe&&(Ce=(0,S.parseLineAndColumnAware)(ye),ye=Ce.path),ye&&(ye=this.preparePath(Se,ye));const Fe=(0,S.sanitizeFilePath)(ye,Se),Oe=(0,d.basename)(Fe);return Oe&&!(0,S.isValidBasename)(Oe)?null:pe&&Ce?(Ce.path=Fe,this.toPath(Ce)):Fe}),J=h.isWindows||h.isMacintosh,ue=(0,R.distinct)(ke,de=>de&&J?de.toLowerCase():de||"");return(0,R.coalesce)(ue)}preparePath(ve,pe){return h.isWindows&&(pe=(0,u.rtrim)(pe,'"')),pe=(0,u.trim)((0,u.trim)(pe," "),"	"),h.isWindows&&(pe=(0,d.resolve)(ve,pe),pe=(0,u.rtrim)(pe,".")),pe}toPath(ve){const pe=[ve.path];return typeof ve.line=="number"&&pe.push(String(ve.line)),typeof ve.column=="number"&&pe.push(String(ve.column)),pe.join(":")}}new Te().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/96db0b339360bc72d27d869d81a557540ad5f800/core/vs/code/electron-main/main.js.map
