/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var _e=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","fs","vs/editor/common/languages","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/hash","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/observableValue","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],ye=function(Z){for(var e=[],c=0,t=Z.length;c<t;c++)e[c]=_e[Z[c]];return e};define(_e[77],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function c(P){return P?P.replace(/\$\((.*?)\)/g,(y,T)=>` ${T} `).trim():""}e.getCodiconAriaLabel=c;class t{constructor(y,T,S){this.id=y,this.definition=T,this.description=S,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var I;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function T(A){if(A instanceof t)return["codicon","codicon-"+A.id];const k=y.exec(A.id);if(!k)return T(t.error);const[,E,_]=k,w=["codicon","codicon-"+E];return _&&w.push("codicon-modifier-"+_.substring(1)),w}P.asClassNameArray=T;function S(A){return T(A).join(" ")}P.asClassName=S;function D(A){return"."+T(A).join(".")}P.asCSSSelector=D})(I=e.CSSIcon||(e.CSSIcon={}))}),define(_e[78],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function c(y,T){const S=Object.create(null);for(const D of y){const A=T(D);let k=S[A];k||(k=S[A]=[]),k.push(D)}return S}e.groupBy=c;function t(y,T){const S=[],D=[];for(const A of y)T.has(A)||S.push(A);for(const A of T)y.has(A)||D.push(A);return{removed:S,added:D}}e.diffSets=t;function I(y,T){const S=[],D=[];for(const[A,k]of y)T.has(A)||S.push(k);for(const[A,k]of T)y.has(A)||D.push(k);return{removed:S,added:D}}e.diffMaps=I;class P{constructor(){this.map=new Map}add(T,S){let D=this.map.get(T);D||(D=new Set,this.map.set(T,D)),D.add(S)}delete(T,S){const D=this.map.get(T);!D||(D.delete(S),D.size===0&&this.map.delete(T))}forEach(T,S){const D=this.map.get(T);!D||D.forEach(S)}}e.SetMap=P}),define(_e[60],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function c(y){return(T,S,D)=>{let A=null,k=null;if(typeof D.value=="function"?(A="value",k=D.value):typeof D.get=="function"&&(A="get",k=D.get),!k)throw new Error("not supported");D[A]=y(k,S)}}function t(y,T,S){let D=null,A=null;if(typeof S.value=="function"?(D="value",A=S.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(D="get",A=S.get),!A)throw new Error("not supported");const k=`$memoize$${T}`;S[D]=function(...E){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,E)}),this[k]}}e.memoize=t;function I(y,T,S){return c((D,A)=>{const k=`$debounce$${A}`,E=`$debounce$result$${A}`;return function(..._){this[E]||(this[E]=S?S():void 0),clearTimeout(this[k]),T&&(this[E]=T(this[E],..._),_=[this[E]]),this[k]=setTimeout(()=>{D.apply(this,_),this[E]=S?S():void 0},y)}})}e.debounce=I;function P(y,T,S){return c((D,A)=>{const k=`$throttle$timer$${A}`,E=`$throttle$result$${A}`,_=`$throttle$lastRun$${A}`,w=`$throttle$pending$${A}`;return function(...f){if(this[E]||(this[E]=S?S():void 0),(this[_]===null||this[_]===void 0)&&(this[_]=-Number.MAX_VALUE),T&&(this[E]=T(this[E],...f)),this[w])return;const g=this[_]+y;g<=Date.now()?(this[_]=Date.now(),D.apply(this,[this[E]]),this[E]=S?S():void 0):(this[w]=!0,this[k]=setTimeout(()=>{this[w]=!1,this[_]=Date.now(),D.apply(this,[this[E]]),this[E]=S?S():void 0},g-Date.now()))}})}e.throttle=P}),define(_e[10],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class c{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?m.isErrorNoTelemetry(s)?new m(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(u=>{u(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=c,e.errorHandler=new c;function t(b){e.errorHandler.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=t;function I(b){S(b)||e.errorHandler.onUnexpectedError(b)}e.onUnexpectedError=I;function P(b){S(b)||e.errorHandler.onUnexpectedExternalError(b)}e.onUnexpectedExternalError=P;function y(b){if(b instanceof Error){const{name:s,message:u}=b,o=b.stacktrace||b.stack;return{$isError:!0,name:s,message:u,stack:o,noTelemetry:m.isErrorNoTelemetry(b)}}return b}e.transformErrorForSerialization=y;const T="Canceled";function S(b){return b instanceof D?!0:b instanceof Error&&b.name===T&&b.message===T}e.isCancellationError=S;class D extends Error{constructor(){super(T),this.name=this.message}}e.CancellationError=D;function A(){const b=new Error(T);return b.name=b.message,b}e.canceled=A;function k(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.illegalArgument=k;function E(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.illegalState=E;function _(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=_;function w(b){const s=new Error(`${b} has been disposed`);return s.name="DISPOSED",s}e.disposed=w;function f(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.getErrorMessage=f;class g extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=g;class h extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=h;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class m extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof m)return s;const u=new m;return u.message=s.message,u.stack=s.stack,u}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=m;class r extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype);debugger}}e.BugIndicatingError=r}),define(_e[17],ye([1,0,10]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(ne,ce=0){return ne[ne.length-(1+ce)]}e.tail=t;function I(ne){if(ne.length===0)throw new Error("Invalid tail call");return[ne.slice(0,ne.length-1),ne[ne.length-1]]}e.tail2=I;function P(ne,ce,fe=(J,re)=>J===re){if(ne===ce)return!0;if(!ne||!ce||ne.length!==ce.length)return!1;for(let J=0,re=ne.length;J<re;J++)if(!fe(ne[J],ce[J]))return!1;return!0}e.equals=P;function y(ne,ce){const fe=ne.length-1;ce<fe&&(ne[ce]=ne[fe]),ne.pop()}e.removeFastWithoutKeepingOrder=y;function T(ne,ce,fe){return S(ne.length,J=>fe(ne[J],ce))}e.binarySearch=T;function S(ne,ce){let fe=0,J=ne-1;for(;fe<=J;){const re=(fe+J)/2|0,ee=ce(re);if(ee<0)fe=re+1;else if(ee>0)J=re-1;else return re}return-(fe+1)}e.binarySearch2=S;function D(ne,ce){let fe=0,J=ne.length;if(J===0)return 0;for(;fe<J;){const re=Math.floor((fe+J)/2);ce(ne[re])?J=re:fe=re+1}return fe}e.findFirstInSorted=D;function A(ne,ce,fe){if(ne=ne|0,ne>=ce.length)throw new TypeError("invalid index");const J=ce[Math.floor(ce.length*Math.random())],re=[],ee=[],O=[];for(const W of ce){const q=fe(W,J);q<0?re.push(W):q>0?ee.push(W):O.push(W)}return ne<re.length?A(ne,re,fe):ne<re.length+O.length?O[0]:A(ne-(re.length+O.length),ee,fe)}e.quickSelect=A;function k(ne,ce){const fe=[];let J;for(const re of ne.slice(0).sort(ce))!J||ce(J[0],re)!==0?(J=[re],fe.push(J)):J.push(re);return fe}e.groupBy=k;function E(ne,ce,fe){const J=[];function re(W,q,X){if(q===0&&X.length===0)return;const ae=J[J.length-1];ae&&ae.start+ae.deleteCount===W?(ae.deleteCount+=q,ae.toInsert.push(...X)):J.push({start:W,deleteCount:q,toInsert:X})}let ee=0,O=0;for(;;){if(ee===ne.length){re(ee,0,ce.slice(O));break}if(O===ce.length){re(ee,ne.length-ee,[]);break}const W=ne[ee],q=ce[O],X=fe(W,q);X===0?(ee+=1,O+=1):X<0?(re(ee,1,[]),ee+=1):X>0&&(re(ee,0,[q]),O+=1)}return J}e.sortedDiff=E;function _(ne,ce,fe){const J=E(ne,ce,fe),re=[],ee=[];for(const O of J)re.push(...ne.slice(O.start,O.start+O.deleteCount)),ee.push(...O.toInsert);return{removed:re,added:ee}}e.delta=_;function w(ne,ce,fe){if(fe===0)return[];const J=ne.slice(0,fe).sort(ce);return g(ne,ce,J,fe,ne.length),J}e.top=w;function f(ne,ce,fe,J,re){return fe===0?Promise.resolve([]):new Promise((ee,O)=>{(async()=>{const W=ne.length,q=ne.slice(0,fe).sort(ce);for(let X=fe,ae=Math.min(fe+J,W);X<W;X=ae,ae=Math.min(ae+J,W)){if(X>fe&&await new Promise(ve=>setTimeout(ve)),re&&re.isCancellationRequested)throw new c.CancellationError;g(ne,ce,q,X,ae)}return q})().then(ee,O)})}e.topAsync=f;function g(ne,ce,fe,J,re){for(const ee=fe.length;J<re;J++){const O=ne[J];if(ce(O,fe[ee-1])<0){fe.pop();const W=D(fe,q=>ce(O,q)<0);fe.splice(W,0,O)}}}function h(ne){return ne.filter(ce=>!!ce)}e.coalesce=h;function v(ne){let ce=0;for(let fe=0;fe<ne.length;fe++)ne[fe]&&(ne[ce]=ne[fe],ce+=1);ne.length=ce}e.coalesceInPlace=v;function m(ne,ce,fe){ne.splice(fe,0,ne.splice(ce,1)[0])}e.move=m;function r(ne){return!Array.isArray(ne)||ne.length===0}e.isFalsyOrEmpty=r;function b(ne){return Array.isArray(ne)&&ne.length>0}e.isNonEmptyArray=b;function s(ne,ce=fe=>fe){const fe=new Set;return ne.filter(J=>{const re=ce(J);return fe.has(re)?!1:(fe.add(re),!0)})}e.distinct=s;function u(ne){const ce=new Set;return fe=>{const J=ne(fe);return ce.has(J)?!1:(ce.add(J),!0)}}e.uniqueFilter=u;function o(ne,ce){const fe=l(ne,ce);if(fe!==-1)return ne[fe]}e.findLast=o;function l(ne,ce){for(let fe=ne.length-1;fe>=0;fe--){const J=ne[fe];if(ce(J))return fe}return-1}e.lastIndex=l;function a(ne,ce){return ne.length>0?ne[0]:ce}e.firstOrDefault=a;function d(ne,ce){return ne.length>0?ne[ne.length-1]:ce}e.lastOrDefault=d;function n(ne,ce,fe=(J,re)=>J===re){let J=0;for(let re=0,ee=Math.min(ne.length,ce.length);re<ee&&fe(ne[re],ce[re]);re++)J++;return J}e.commonPrefixLength=n;function i(ne){return[].concat(...ne)}e.flatten=i;function p(ne,ce){let fe=typeof ce=="number"?ne:0;typeof ce=="number"?fe=ne:(fe=0,ce=ne);const J=[];if(fe<=ce)for(let re=fe;re<ce;re++)J.push(re);else for(let re=fe;re>ce;re--)J.push(re);return J}e.range=p;function C(ne,ce,fe){return ne.reduce((J,re)=>(J[ce(re)]=fe?fe(re):re,J),Object.create(null))}e.index=C;function R(ne,ce){return ne.push(ce),()=>U(ne,ce)}e.insert=R;function U(ne,ce){const fe=ne.indexOf(ce);if(fe>-1)return ne.splice(fe,1),ce}e.remove=U;function H(ne,ce,fe){const J=ne.slice(0,ce),re=ne.slice(ce);return J.concat(fe,re)}e.arrayInsert=H;function V(ne,ce){let fe;if(typeof ce=="number"){let J=ce;fe=()=>{const re=Math.sin(J++)*179426549;return re-Math.floor(re)}}else fe=Math.random;for(let J=ne.length-1;J>0;J-=1){const re=Math.floor(fe()*(J+1)),ee=ne[J];ne[J]=ne[re],ne[re]=ee}}e.shuffle=V;function L(ne,ce){const fe=ne.indexOf(ce);fe>-1&&(ne.splice(fe,1),ne.unshift(ce))}e.pushToStart=L;function M(ne,ce){const fe=ne.indexOf(ce);fe>-1&&(ne.splice(fe,1),ne.push(ce))}e.pushToEnd=M;function F(ne,ce){for(const fe of ce)ne.push(fe)}e.pushMany=F;function B(ne,ce){return Array.isArray(ne)?ne.map(ce):ce(ne)}e.mapArrayOrNot=B;function N(ne){return Array.isArray(ne)?ne:[ne]}e.asArray=N;function z(ne){return ne[Math.floor(Math.random()*ne.length)]}e.getRandomElement=z;function j(ne,ce){for(const fe of ne){const J=ce(fe);if(J!==void 0)return J}}e.mapFind=j;function x(ne,ce,fe){const J=K(ne,ce),re=ne.length,ee=fe.length;ne.length=re+ee;for(let O=re-1;O>=J;O--)ne[O+ee]=ne[O];for(let O=0;O<ee;O++)ne[O+J]=fe[O]}e.insertInto=x;function Q(ne,ce,fe,J){const re=K(ne,ce),ee=ne.splice(re,fe);return x(ne,re,J),ee}e.splice=Q;function K(ne,ce){return ce<0?Math.max(ce+ne.length,0):Math.min(ce,ne.length)}var le;(function(ne){function ce(re){return re<0}ne.isLessThan=ce;function fe(re){return re>0}ne.isGreaterThan=fe;function J(re){return re===0}ne.isNeitherLessOrGreaterThan=J,ne.greaterThan=1,ne.lessThan=-1,ne.neitherLessOrGreaterThan=0})(le=e.CompareResult||(e.CompareResult={}));function ie(ne,ce){return(fe,J)=>ce(ne(fe),ne(J))}e.compareBy=ie;function de(...ne){return(ce,fe)=>{for(const J of ne){const re=J(ce,fe);if(!le.isNeitherLessOrGreaterThan(re))return re}return le.neitherLessOrGreaterThan}}e.tieBreakComparators=de;const Y=(ne,ce)=>ne-ce;e.numberComparator=Y;function pe(ne,ce){if(ne.length===0)return;let fe=ne[0];for(let J=1;J<ne.length;J++){const re=ne[J];ce(re,fe)>0&&(fe=re)}return fe}e.findMaxBy=pe;function be(ne,ce){if(ne.length===0)return;let fe=ne[0];for(let J=1;J<ne.length;J++){const re=ne[J];ce(re,fe)>=0&&(fe=re)}return fe}e.findLastMaxBy=be;function Ce(ne,ce){return pe(ne,(fe,J)=>-ce(fe,J))}e.findMinBy=Ce;class Re{constructor(ce){this.items=ce,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ce){let fe=this.firstIdx;for(;fe<this.items.length&&ce(this.items[fe]);)fe++;const J=fe===this.firstIdx?null:this.items.slice(this.firstIdx,fe);return this.firstIdx=fe,J}takeFromEndWhile(ce){let fe=this.lastIdx;for(;fe>=0&&ce(this.items[fe]);)fe--;const J=fe===this.lastIdx?null:this.items.slice(fe+1,this.lastIdx+1);return this.lastIdx=fe,J}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ce=this.items[this.firstIdx];return this.firstIdx++,ce}removeLast(){const ce=this.items[this.lastIdx];return this.lastIdx--,ce}takeCount(ce){const fe=this.items.slice(this.firstIdx,this.firstIdx+ce);return this.firstIdx+=ce,fe}}e.ArrayQueue=Re;class We{constructor(ce){this.iterate=ce}forEach(ce){this.iterate(fe=>(ce(fe),!0))}toArray(){const ce=[];return this.iterate(fe=>(ce.push(fe),!0)),ce}filter(ce){return new We(fe=>this.iterate(J=>ce(J)?fe(J):!0))}map(ce){return new We(fe=>this.iterate(J=>fe(ce(J))))}some(ce){let fe=!1;return this.iterate(J=>(fe=ce(J),!fe)),fe}findFirst(ce){let fe;return this.iterate(J=>ce(J)?(fe=J,!1):!0),fe}findLast(ce){let fe;return this.iterate(J=>(ce(J)&&(fe=J),!0)),fe}findLastMaxBy(ce){let fe,J=!0;return this.iterate(re=>((J||le.isGreaterThan(ce(re,fe)))&&(J=!1,fe=re),!0)),fe}}e.CallbackIterable=We,We.empty=new We(ne=>{})}),define(_e[48],ye([1,0,10]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(S,D){if(!S)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=t;function I(S,D="Unreachable"){throw new Error(D)}e.assertNever=I;function P(S){if(!S)throw new c.BugIndicatingError("Assertion Failed")}e.assert=P;function y(S){if(!S()){debugger;S(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}e.assertFn=y;function T(S,D){let A=0;for(;A<S.length-1;){const k=S[A],E=S[A+1];if(!D(k,E))return!1;A++}return!0}e.checkAdjacentItems=T}),define(_e[61],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function c(t){const I=this;let P=!1,y;return function(){return P||(P=!0,y=t.apply(I,arguments)),y}}e.once=c}),define(_e[98],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(_e[62],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(t){function I(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}t.is=I;const P=Object.freeze([]);function y(){return P}t.empty=y;function*T(r){yield r}t.single=T;function S(r){return I(r)?r:T(r)}t.wrap=S;function D(r){return r||P}t.from=D;function A(r){return!r||r[Symbol.iterator]().next().done===!0}t.isEmpty=A;function k(r){return r[Symbol.iterator]().next().value}t.first=k;function E(r,b){for(const s of r)if(b(s))return!0;return!1}t.some=E;function _(r,b){for(const s of r)if(b(s))return s}t.find=_;function*w(r,b){for(const s of r)b(s)&&(yield s)}t.filter=w;function*f(r,b){let s=0;for(const u of r)yield b(u,s++)}t.map=f;function*g(...r){for(const b of r)for(const s of b)yield s}t.concat=g;function h(r,b,s){let u=s;for(const o of r)u=b(u,o);return u}t.reduce=h;function*v(r,b,s=r.length){for(b<0&&(b+=r.length),s<0?s+=r.length:s>r.length&&(s=r.length);b<s;b++)yield r[b]}t.slice=v;function m(r,b=Number.POSITIVE_INFINITY){const s=[];if(b===0)return[s,r];const u=r[Symbol.iterator]();for(let o=0;o<b;o++){const l=u.next();if(l.done)return[s,t.empty()];s.push(l.value)}return[s,{[Symbol.iterator](){return u}}]}t.consume=m})(c=e.Iterable||(e.Iterable={}))}),define(_e[144],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(s){s.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function y(s,u=!1){let o=0;const l=s.length;let a="",d=0,n=16,i=0;function p(M){let F=0,B=0;for(;F<M;){const N=s.charCodeAt(o);if(N>=48&&N<=57)B=B*16+N-48;else if(N>=65&&N<=70)B=B*16+N-65+10;else if(N>=97&&N<=102)B=B*16+N-97+10;else break;o++,F++}return F<M&&(B=-1),B}function C(M){o=M,a="",d=0,n=16,i=0}function R(){const M=o;if(s.charCodeAt(o)===48)o++;else for(o++;o<s.length&&D(s.charCodeAt(o));)o++;if(o<s.length&&s.charCodeAt(o)===46)if(o++,o<s.length&&D(s.charCodeAt(o)))for(o++;o<s.length&&D(s.charCodeAt(o));)o++;else return i=3,s.substring(M,o);let F=o;if(o<s.length&&(s.charCodeAt(o)===69||s.charCodeAt(o)===101))if(o++,(o<s.length&&s.charCodeAt(o)===43||s.charCodeAt(o)===45)&&o++,o<s.length&&D(s.charCodeAt(o))){for(o++;o<s.length&&D(s.charCodeAt(o));)o++;F=o}else i=3;return s.substring(M,F)}function U(){let M="",F=o;for(;;){if(o>=l){M+=s.substring(F,o),i=2;break}const B=s.charCodeAt(o);if(B===34){M+=s.substring(F,o),o++;break}if(B===92){if(M+=s.substring(F,o),o++,o>=l){i=2;break}switch(s.charCodeAt(o++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const z=p(4);z>=0?M+=String.fromCharCode(z):i=4;break}default:i=5}F=o;continue}if(B>=0&&B<=31)if(S(B)){M+=s.substring(F,o),i=2;break}else i=6;o++}return M}function H(){if(a="",i=0,d=o,o>=l)return d=l,n=17;let M=s.charCodeAt(o);if(T(M)){do o++,a+=String.fromCharCode(M),M=s.charCodeAt(o);while(T(M));return n=15}if(S(M))return o++,a+=String.fromCharCode(M),M===13&&s.charCodeAt(o)===10&&(o++,a+=`
`),n=14;switch(M){case 123:return o++,n=1;case 125:return o++,n=2;case 91:return o++,n=3;case 93:return o++,n=4;case 58:return o++,n=6;case 44:return o++,n=5;case 34:return o++,a=U(),n=10;case 47:{const F=o-1;if(s.charCodeAt(o+1)===47){for(o+=2;o<l&&!S(s.charCodeAt(o));)o++;return a=s.substring(F,o),n=12}if(s.charCodeAt(o+1)===42){o+=2;const B=l-1;let N=!1;for(;o<B;){if(s.charCodeAt(o)===42&&s.charCodeAt(o+1)===47){o+=2,N=!0;break}o++}return N||(o++,i=1),a=s.substring(F,o),n=13}return a+=String.fromCharCode(M),o++,n=16}case 45:if(a+=String.fromCharCode(M),o++,o===l||!D(s.charCodeAt(o)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=R(),n=11;default:for(;o<l&&V(M);)o++,M=s.charCodeAt(o);if(d!==o){switch(a=s.substring(d,o),a){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return a+=String.fromCharCode(M),o++,n=16}}function V(M){if(T(M)||S(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let M;do M=H();while(M>=12&&M<=15);return M}return{setPosition:C,getPosition:()=>o,scan:u?L:H,getToken:()=>n,getTokenValue:()=>a,getTokenOffset:()=>d,getTokenLength:()=>o-d,getTokenError:()=>i}}e.createScanner=y;function T(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function D(s){return s>=48&&s<=57}var A;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(A||(A={}));function k(s,u){const o=[],l=new Object;let a;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function i(p,C,R,U){d.value=p,d.offset=C,d.length=R,d.type=U,d.colonOffset=void 0,a=d}try{m(s,{onObjectBegin:(p,C)=>{if(u<=p)throw l;a=void 0,n=u>p,o.push("")},onObjectProperty:(p,C,R)=>{if(u<C||(i(p,C,R,"property"),o[o.length-1]=p,u<=C+R))throw l},onObjectEnd:(p,C)=>{if(u<=p)throw l;a=void 0,o.pop()},onArrayBegin:(p,C)=>{if(u<=p)throw l;a=void 0,o.push(0)},onArrayEnd:(p,C)=>{if(u<=p)throw l;a=void 0,o.pop()},onLiteralValue:(p,C,R)=>{if(u<C||(i(p,C,R,b(p)),u<=C+R))throw l},onSeparator:(p,C,R)=>{if(u<=C)throw l;if(p===":"&&a&&a.type==="property")a.colonOffset=C,n=!1,a=void 0;else if(p===","){const U=o[o.length-1];typeof U=="number"?o[o.length-1]=U+1:(n=!0,o[o.length-1]=""),a=void 0}}})}catch(p){if(p!==l)throw p}return{path:o,previousNode:a,isAtPropertyKey:n,matches:p=>{let C=0;for(let R=0;C<p.length&&R<o.length;R++)if(p[C]===o[R]||p[C]==="*")C++;else if(p[C]!=="**")return!1;return C===p.length}}}e.getLocation=k;function E(s,u=[],o=P.DEFAULT){let l=null,a=[];const d=[];function n(p){Array.isArray(a)?a.push(p):l!==null&&(a[l]=p)}return m(s,{onObjectBegin:()=>{const p={};n(p),d.push(a),a=p,l=null},onObjectProperty:p=>{l=p},onObjectEnd:()=>{a=d.pop()},onArrayBegin:()=>{const p=[];n(p),d.push(a),a=p,l=null},onArrayEnd:()=>{a=d.pop()},onLiteralValue:n,onError:(p,C,R)=>{u.push({error:p,offset:C,length:R})}},o),a[0]}e.parse=E;function _(s,u=[],o=P.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){l.type==="property"&&(l.length=p-l.offset,l=l.parent)}function d(p){return l.children.push(p),p}m(s,{onObjectBegin:p=>{l=d({type:"object",offset:p,length:-1,parent:l,children:[]})},onObjectProperty:(p,C,R)=>{l=d({type:"property",offset:C,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:p,offset:C,length:R,parent:l})},onObjectEnd:(p,C)=>{l.length=p+C-l.offset,l=l.parent,a(p+C)},onArrayBegin:(p,C)=>{l=d({type:"array",offset:p,length:-1,parent:l,children:[]})},onArrayEnd:(p,C)=>{l.length=p+C-l.offset,l=l.parent,a(p+C)},onLiteralValue:(p,C,R)=>{d({type:b(p),offset:C,length:R,parent:l,value:p}),a(C+R)},onSeparator:(p,C,R)=>{l.type==="property"&&(p===":"?l.colonOffset=C:p===","&&a(C))},onError:(p,C,R)=>{u.push({error:p,offset:C,length:R})}},o);const i=l.children[0];return i&&delete i.parent,i}e.parseTree=_;function w(s,u){if(!s)return;let o=s;for(const l of u)if(typeof l=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let a=!1;for(const d of o.children)if(Array.isArray(d.children)&&d.children[0].value===l){o=d.children[1],a=!0;break}if(!a)return}else{const a=l;if(o.type!=="array"||a<0||!Array.isArray(o.children)||a>=o.children.length)return;o=o.children[a]}return o}e.findNodeAtLocation=w;function f(s){if(!s.parent||!s.parent.children)return[];const u=f(s.parent);if(s.parent.type==="property"){const o=s.parent.children[0].value;u.push(o)}else if(s.parent.type==="array"){const o=s.parent.children.indexOf(s);o!==-1&&u.push(o)}return u}e.getNodePath=f;function g(s){switch(s.type){case"array":return s.children.map(g);case"object":{const u=Object.create(null);for(const o of s.children){const l=o.children[1];l&&(u[o.children[0].value]=g(l))}return u}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=g;function h(s,u,o=!1){return u>=s.offset&&u<s.offset+s.length||o&&u===s.offset+s.length}e.contains=h;function v(s,u,o=!1){if(h(s,u,o)){const l=s.children;if(Array.isArray(l))for(let a=0;a<l.length&&l[a].offset<=u;a++){const d=v(l[a],u,o);if(d)return d}return s}}e.findNodeAtOffset=v;function m(s,u,o=P.DEFAULT){const l=y(s,!1);function a(ie){return ie?()=>ie(l.getTokenOffset(),l.getTokenLength()):()=>!0}function d(ie){return ie?de=>ie(de,l.getTokenOffset(),l.getTokenLength()):()=>!0}const n=a(u.onObjectBegin),i=d(u.onObjectProperty),p=a(u.onObjectEnd),C=a(u.onArrayBegin),R=a(u.onArrayEnd),U=d(u.onLiteralValue),H=d(u.onSeparator),V=a(u.onComment),L=d(u.onError),M=o&&o.disallowComments,F=o&&o.allowTrailingComma;function B(){for(;;){const ie=l.scan();switch(l.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:M||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(ie){case 12:case 13:M?N(10):V();break;case 16:N(1);break;case 15:case 14:break;default:return ie}}}function N(ie,de=[],Y=[]){if(L(ie),de.length+Y.length>0){let pe=l.getToken();for(;pe!==17;){if(de.indexOf(pe)!==-1){B();break}else if(Y.indexOf(pe)!==-1)break;pe=B()}}}function z(ie){const de=l.getTokenValue();return ie?U(de):i(de),B(),!0}function j(){switch(l.getToken()){case 11:{let ie=0;try{ie=JSON.parse(l.getTokenValue()),typeof ie!="number"&&(N(2),ie=0)}catch{N(2)}U(ie);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return B(),!0}function x(){return l.getToken()!==10?(N(3,[],[2,5]),!1):(z(!1),l.getToken()===6?(H(":"),B(),le()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function Q(){n(),B();let ie=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(ie||N(4,[],[]),H(","),B(),l.getToken()===2&&F)break}else ie&&N(6,[],[]);x()||N(4,[],[2,5]),ie=!0}return p(),l.getToken()!==2?N(7,[2],[]):B(),!0}function K(){C(),B();let ie=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(ie||N(4,[],[]),H(","),B(),l.getToken()===4&&F)break}else ie&&N(6,[],[]);le()||N(4,[],[4,5]),ie=!0}return R(),l.getToken()!==4?N(8,[4],[]):B(),!0}function le(){switch(l.getToken()){case 3:return K();case 1:return Q();case 10:return z(!0);default:return j()}}return B(),l.getToken()===17?o.allowEmptyContent?!0:(N(4,[],[]),!1):le()?(l.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=m;function r(s,u){const o=y(s),l=[];let a,d=0,n;do switch(n=o.getPosition(),a=o.scan(),a){case 12:case 13:case 17:d!==n&&l.push(s.substring(d,n)),u!==void 0&&l.push(o.getTokenValue().replace(/[^\r\n]/g,u)),d=o.getPosition();break}while(a!==17);return l.join("")}e.stripComments=r;function b(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(_e[79],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new c(()=>I(this.getValue()))}}e.Lazy=c}),define(_e[6],ye([1,0,61,62]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let P=null;function y(d){P=d}if(e.setDisposableTracker=y,I){const d="__is_disposable_tracked__";y(new class{trackDisposable(n){const i=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[d]||console.log(i)},3e3)}setParent(n,i){if(n&&n!==v.None)try{n[d]=!0}catch{}}markAsDisposed(n){if(n&&n!==v.None)try{n[d]=!0}catch{}}markAsSingleton(n){}})}function T(d){return P?.trackDisposable(d),d}function S(d){P?.markAsDisposed(d)}function D(d,n){P?.setParent(d,n)}function A(d,n){if(!!P)for(const i of d)P.setParent(i,n)}function k(d){return P?.markAsSingleton(d),d}e.markAsSingleton=k;function E(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=E;function _(d){if(t.Iterable.is(d)){const n=[];for(const i of d)if(i)try{i.dispose()}catch(p){n.push(p)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(d)?[]:d}else if(d)return d.dispose(),d}e.dispose=_;function w(d){for(const n of d)E(n)&&n.dispose();return[]}e.disposeIfDisposable=w;function f(...d){const n=g(()=>_(d));return A(d,n),n}e.combinedDisposable=f;function g(d){const n=T({dispose:(0,c.once)(()=>{S(n),d()})});return n}e.toDisposable=g;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,T(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{_(this._toDispose)}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return D(n,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new h,T(this),D(this._store,this)}dispose(){S(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,T(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&D(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&D(n,null),n}}e.MutableDisposable=m;class r{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(n){let i=n;return this.unset=()=>i=void 0,this.isset=()=>i!==void 0,this.dispose=()=>{i&&(i(),i=void 0,S(this))},this}}e.SafeDisposable=b;class s{constructor(){this.references=new Map}acquire(n,...i){let p=this.references.get(n);p||(p={counter:0,object:this.createReferencedObject(n,...i)},this.references.set(n,p));const{object:C}=p,R=(0,c.once)(()=>{--p.counter===0&&(this.destroyReferencedObject(n,p.object),this.references.delete(n))});return p.counter++,{object:C,dispose:R}}}e.ReferenceCollection=s;class u{constructor(n){this.referenceCollection=n}async acquire(n,...i){const p=this.referenceCollection.acquire(n,...i);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(C){throw p.dispose(),C}}}e.AsyncReferenceCollection=u;class o{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=o;function l(d){const n=new h;try{d(n)}finally{n.dispose()}}e.disposeOnReturn=l;class a{constructor(){this._store=new Map,this._isDisposed=!1,T(this)}dispose(){S(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{_(this._store.values())}finally{this._store.clear()}}has(n){return this._store.has(n)}get(n){return this._store.get(n)}set(n,i,p=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),p||this._store.get(n)?.dispose(),this._store.set(n,i)}deleteAndDispose(n){this._store.get(n)?.dispose(),this._store.delete(n)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=a}),define(_e[63],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{constructor(P){this.element=P,this.next=c.Undefined,this.prev=c.Undefined}}c.Undefined=new c(void 0);class t{constructor(){this._first=c.Undefined,this._last=c.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===c.Undefined}clear(){let P=this._first;for(;P!==c.Undefined;){const y=P.next;P.prev=c.Undefined,P.next=c.Undefined,P=y}this._first=c.Undefined,this._last=c.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,y){const T=new c(P);if(this._first===c.Undefined)this._first=T,this._last=T;else if(y){const D=this._last;this._last=T,T.prev=D,D.next=T}else{const D=this._first;this._first=T,T.next=D,D.prev=T}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(T))}}shift(){if(this._first!==c.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==c.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==c.Undefined&&P.next!==c.Undefined){const y=P.prev;y.next=P.next,P.next.prev=y}else P.prev===c.Undefined&&P.next===c.Undefined?(this._first=c.Undefined,this._last=c.Undefined):P.next===c.Undefined?(this._last=this._last.prev,this._last.next=c.Undefined):P.prev===c.Undefined&&(this._first=this._first.next,this._first.prev=c.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==c.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),define(_e[28],ye([1,0]),function(Z,e){"use strict";var c,t,I;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function P(w,f,g){let h=w.get(f);return h===void 0&&(h=g,w.set(f,h)),h}e.getOrSet=P;function y(w){const f=[];return w.forEach((g,h)=>{f.push(`${h} => ${g}`)}),`Map(${w.size}) {${f.join(", ")}}`}e.mapToString=y;function T(w){const f=[];return w.forEach(g=>{f.push(g)}),`Set(${w.size}) {${f.join(", ")}}`}e.setToString=T;class S{constructor(f,g){this.uri=f,this.value=g}}class D{constructor(f,g){this[c]="ResourceMap",f instanceof D?(this.map=new Map(f.map),this.toKey=g??D.defaultToKey):(this.map=new Map,this.toKey=f??D.defaultToKey)}set(f,g){return this.map.set(this.toKey(f),new S(f,g)),this}get(f){return this.map.get(this.toKey(f))?.value}has(f){return this.map.has(this.toKey(f))}get size(){return this.map.size}clear(){this.map.clear()}delete(f){return this.map.delete(this.toKey(f))}forEach(f,g){typeof g<"u"&&(f=f.bind(g));for(const[h,v]of this.map)f(v.value,v.uri,this)}*values(){for(const f of this.map.values())yield f.value}*keys(){for(const f of this.map.values())yield f.uri}*entries(){for(const f of this.map.values())yield[f.uri,f.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.map)yield[f.uri,f.value]}}e.ResourceMap=D,D.defaultToKey=w=>w.toString();class A{constructor(f,g){this[t]="ResourceSet",!f||typeof f=="function"?this._map=new D(f):(this._map=new D(g),f.forEach(this.add,this))}get size(){return this._map.size}add(f){return this._map.set(f,f),this}clear(){this._map.clear()}delete(f){return this._map.delete(f)}forEach(f,g){this._map.forEach((h,v)=>f.call(g,v,v,this))}has(f){return this._map.has(f)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=A;var k;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(k=e.Touch||(e.Touch={}));class E{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(f){return this._map.has(f)}get(f,g=0){const h=this._map.get(f);if(!!h)return g!==0&&this.touch(h,g),h.value}set(f,g,h=0){let v=this._map.get(f);if(v)v.value=g,h!==0&&this.touch(v,h);else{switch(v={key:f,value:g,next:void 0,previous:void 0},h){case 0:this.addItemLast(v);break;case 1:this.addItemFirst(v);break;case 2:this.addItemLast(v);break;default:this.addItemLast(v);break}this._map.set(f,v),this._size++}return this}delete(f){return!!this.remove(f)}remove(f){const g=this._map.get(f);if(!!g)return this._map.delete(f),this.removeItem(g),this._size--,g.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const f=this._head;return this._map.delete(f.key),this.removeItem(f),this._size--,f.value}forEach(f,g){const h=this._state;let v=this._head;for(;v;){if(g?f.bind(g)(v.value,v.key,this):f(v.value,v.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const f=this,g=this._state;let h=this._head;const v={[Symbol.iterator](){return v},next(){if(f._state!==g)throw new Error("LinkedMap got modified during iteration.");if(h){const m={value:h.key,done:!1};return h=h.next,m}else return{value:void 0,done:!0}}};return v}values(){const f=this,g=this._state;let h=this._head;const v={[Symbol.iterator](){return v},next(){if(f._state!==g)throw new Error("LinkedMap got modified during iteration.");if(h){const m={value:h.value,done:!1};return h=h.next,m}else return{value:void 0,done:!0}}};return v}entries(){const f=this,g=this._state;let h=this._head;const v={[Symbol.iterator](){return v},next(){if(f._state!==g)throw new Error("LinkedMap got modified during iteration.");if(h){const m={value:[h.key,h.value],done:!1};return h=h.next,m}else return{value:void 0,done:!0}}};return v}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(f){if(f>=this.size)return;if(f===0){this.clear();return}let g=this._head,h=this.size;for(;g&&h>f;)this._map.delete(g.key),g=g.next,h--;this._head=g,this._size=h,g&&(g.previous=void 0),this._state++}addItemFirst(f){if(!this._head&&!this._tail)this._tail=f;else if(this._head)f.next=this._head,this._head.previous=f;else throw new Error("Invalid list");this._head=f,this._state++}addItemLast(f){if(!this._head&&!this._tail)this._head=f;else if(this._tail)f.previous=this._tail,this._tail.next=f;else throw new Error("Invalid list");this._tail=f,this._state++}removeItem(f){if(f===this._head&&f===this._tail)this._head=void 0,this._tail=void 0;else if(f===this._head){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this._head=f.next}else if(f===this._tail){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this._tail=f.previous}else{const g=f.next,h=f.previous;if(!g||!h)throw new Error("Invalid list");g.previous=h,h.next=g}f.next=void 0,f.previous=void 0,this._state++}touch(f,g){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(f===this._head)return;const h=f.next,v=f.previous;f===this._tail?(v.next=void 0,this._tail=v):(h.previous=v,v.next=h),f.previous=void 0,f.next=this._head,this._head.previous=f,this._head=f,this._state++}else if(g===2){if(f===this._tail)return;const h=f.next,v=f.previous;f===this._head?(h.previous=void 0,this._head=h):(h.previous=v,v.next=h),f.next=void 0,f.previous=this._tail,this._tail.next=f,this._tail=f,this._state++}}}toJSON(){const f=[];return this.forEach((g,h)=>{f.push([h,g])}),f}fromJSON(f){this.clear();for(const[g,h]of f)this.set(g,h)}}e.LinkedMap=E;class _ extends E{constructor(f,g=1){super(),this._limit=f,this._ratio=Math.min(Math.max(0,g),1)}get limit(){return this._limit}set limit(f){this._limit=f,this.checkTrim()}get ratio(){return this._ratio}set ratio(f){this._ratio=Math.min(Math.max(0,f),1),this.checkTrim()}get(f,g=2){return super.get(f,g)}peek(f){return super.get(f,0)}set(f,g){return super.set(f,g,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=_}),function(Z,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(_e[145],ye([0]),e):(Z=typeof globalThis<"u"?globalThis:Z||self,e(Z.marked={}))}(this,function(Z){"use strict";function e(ne,ce){for(var fe=0;fe<ce.length;fe++){var J=ce[fe];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(ne,J.key,J)}}function c(ne,ce,fe){return ce&&e(ne.prototype,ce),fe&&e(ne,fe),Object.defineProperty(ne,"prototype",{writable:!1}),ne}function t(ne,ce){if(!!ne){if(typeof ne=="string")return I(ne,ce);var fe=Object.prototype.toString.call(ne).slice(8,-1);if(fe==="Object"&&ne.constructor&&(fe=ne.constructor.name),fe==="Map"||fe==="Set")return Array.from(ne);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return I(ne,ce)}}function I(ne,ce){(ce==null||ce>ne.length)&&(ce=ne.length);for(var fe=0,J=new Array(ce);fe<ce;fe++)J[fe]=ne[fe];return J}function P(ne,ce){var fe=typeof Symbol<"u"&&ne[Symbol.iterator]||ne["@@iterator"];if(fe)return(fe=fe.call(ne)).next.bind(fe);if(Array.isArray(ne)||(fe=t(ne))||ce&&ne&&typeof ne.length=="number"){fe&&(ne=fe);var J=0;return function(){return J>=ne.length?{done:!0}:{done:!1,value:ne[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Z.defaults=y();function T(ne){Z.defaults=ne}var S=/[&<>"']/,D=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},_=function(ce){return E[ce]};function w(ne,ce){if(ce){if(S.test(ne))return ne.replace(D,_)}else if(A.test(ne))return ne.replace(k,_);return ne}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(ne){return ne.replace(f,function(ce,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var h=/(^|[^\[])\^/g;function v(ne,ce){ne=typeof ne=="string"?ne:ne.source,ce=ce||"";var fe={replace:function(re,ee){return ee=ee.source||ee,ee=ee.replace(h,"$1"),ne=ne.replace(re,ee),fe},getRegex:function(){return new RegExp(ne,ce)}};return fe}var m=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(ne,ce,fe){if(ne){var J;try{J=decodeURIComponent(g(fe)).replace(m,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}ce&&!r.test(fe)&&(fe=a(ce,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var s={},u=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ne,ce){s[" "+ne]||(u.test(ne)?s[" "+ne]=ne+"/":s[" "+ne]=p(ne,"/",!0)),ne=s[" "+ne];var fe=ne.indexOf(":")===-1;return ce.substring(0,2)==="//"?fe?ce:ne.replace(o,"$1")+ce:ce.charAt(0)==="/"?fe?ce:ne.replace(l,"$1")+ce:ne+ce}var d={exec:function(){}};function n(ne){for(var ce=1,fe,J;ce<arguments.length;ce++){fe=arguments[ce];for(J in fe)Object.prototype.hasOwnProperty.call(fe,J)&&(ne[J]=fe[J])}return ne}function i(ne,ce){var fe=ne.replace(/\|/g,function(ee,O,W){for(var q=!1,X=O;--X>=0&&W[X]==="\\";)q=!q;return q?"|":" |"}),J=fe.split(/ \|/),re=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>ce)J.splice(ce);else for(;J.length<ce;)J.push("");for(;re<J.length;re++)J[re]=J[re].trim().replace(/\\\|/g,"|");return J}function p(ne,ce,fe){var J=ne.length;if(J===0)return"";for(var re=0;re<J;){var ee=ne.charAt(J-re-1);if(ee===ce&&!fe)re++;else if(ee!==ce&&fe)re++;else break}return ne.slice(0,J-re)}function C(ne,ce){if(ne.indexOf(ce[1])===-1)return-1;for(var fe=ne.length,J=0,re=0;re<fe;re++)if(ne[re]==="\\")re++;else if(ne[re]===ce[0])J++;else if(ne[re]===ce[1]&&(J--,J<0))return re;return-1}function R(ne){ne&&ne.sanitize&&!ne.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function U(ne,ce){if(ce<1)return"";for(var fe="";ce>1;)ce&1&&(fe+=ne),ce>>=1,ne+=ne;return fe+ne}function H(ne,ce,fe,J){var re=ce.href,ee=ce.title?w(ce.title):null,O=ne[1].replace(/\\([\[\]])/g,"$1");if(ne[0].charAt(0)!=="!"){J.state.inLink=!0;var W={type:"link",raw:fe,href:re,title:ee,text:O,tokens:J.inlineTokens(O)};return J.state.inLink=!1,W}return{type:"image",raw:fe,href:re,title:ee,text:w(O)}}function V(ne,ce){var fe=ne.match(/^(\s+)(?:```)/);if(fe===null)return ce;var J=fe[1];return ce.split(`
`).map(function(re){var ee=re.match(/^\s+/);if(ee===null)return re;var O=ee[0];return O.length>=J.length?re.slice(J.length):re}).join(`
`)}var L=function(){function ne(fe){this.options=fe||Z.defaults}var ce=ne.prototype;return ce.space=function(J){var re=this.rules.block.newline.exec(J);if(re&&re[0].length>0)return{type:"space",raw:re[0]}},ce.code=function(J){var re=this.rules.block.code.exec(J);if(re){var ee=re[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:re[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:p(ee,`
`)}}},ce.fences=function(J){var re=this.rules.block.fences.exec(J);if(re){var ee=re[0],O=V(ee,re[3]||"");return{type:"code",raw:ee,lang:re[2]?re[2].trim():re[2],text:O}}},ce.heading=function(J){var re=this.rules.block.heading.exec(J);if(re){var ee=re[2].trim();if(/#$/.test(ee)){var O=p(ee,"#");(this.options.pedantic||!O||/ $/.test(O))&&(ee=O.trim())}return{type:"heading",raw:re[0],depth:re[1].length,text:ee,tokens:this.lexer.inline(ee)}}},ce.hr=function(J){var re=this.rules.block.hr.exec(J);if(re)return{type:"hr",raw:re[0]}},ce.blockquote=function(J){var re=this.rules.block.blockquote.exec(J);if(re){var ee=re[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:re[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},ce.list=function(J){var re=this.rules.block.list.exec(J);if(re){var ee,O,W,q,X,ae,ve,Te,ge,Pe,De,xe,je=re[1].trim(),nt=je.length>1,Xe={type:"list",raw:"",ordered:nt,start:nt?+je.slice(0,-1):"",loose:!1,items:[]};je=nt?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=nt?je:"[*+-]");for(var rt=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(xe=!1,!(!(re=rt.exec(J))||this.rules.block.hr.test(J)));){if(ee=re[0],J=J.substring(ee.length),Te=re[2].split(`
`,1)[0],ge=J.split(`
`,1)[0],this.options.pedantic?(q=2,De=Te.trimLeft()):(q=re[2].search(/[^ ]/),q=q>4?1:q,De=Te.slice(q),q+=re[1].length),ae=!1,!Te&&/^ *$/.test(ge)&&(ee+=ge+`
`,J=J.substring(ge.length+1),xe=!0),!xe)for(var Be=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),se=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:```|~~~)"),oe=new RegExp("^ {0,"+Math.min(3,q-1)+"}#");J&&(Pe=J.split(`
`,1)[0],Te=Pe,this.options.pedantic&&(Te=Te.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(se.test(Te)||oe.test(Te)||Be.test(Te)||dt.test(J)));){if(Te.search(/[^ ]/)>=q||!Te.trim())De+=`
`+Te.slice(q);else if(!ae)De+=`
`+Te;else break;!ae&&!Te.trim()&&(ae=!0),ee+=Pe+`
`,J=J.substring(Pe.length+1)}Xe.loose||(ve?Xe.loose=!0:/\n *\n *$/.test(ee)&&(ve=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(De),O&&(W=O[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:ee,task:!!O,checked:W,loose:!1,text:De}),Xe.raw+=ee}Xe.items[Xe.items.length-1].raw=ee.trimRight(),Xe.items[Xe.items.length-1].text=De.trimRight(),Xe.raw=Xe.raw.trimRight();var Se=Xe.items.length;for(X=0;X<Se;X++){this.lexer.state.top=!1,Xe.items[X].tokens=this.lexer.blockTokens(Xe.items[X].text,[]);var ue=Xe.items[X].tokens.filter(function(Le){return Le.type==="space"}),Ie=ue.every(function(Le){for(var Fe=Le.raw.split(""),Ge=0,Ye=P(Fe),it;!(it=Ye()).done;){var bt=it.value;if(bt===`
`&&(Ge+=1),Ge>1)return!0}return!1});!Xe.loose&&ue.length&&Ie&&(Xe.loose=!0,Xe.items[X].loose=!0)}return Xe}},ce.html=function(J){var re=this.rules.block.html.exec(J);if(re){var ee={type:"html",raw:re[0],pre:!this.options.sanitizer&&(re[1]==="pre"||re[1]==="script"||re[1]==="style"),text:re[0]};if(this.options.sanitize){var O=this.options.sanitizer?this.options.sanitizer(re[0]):w(re[0]);ee.type="paragraph",ee.text=O,ee.tokens=this.lexer.inline(O)}return ee}},ce.def=function(J){var re=this.rules.block.def.exec(J);if(re){re[3]&&(re[3]=re[3].substring(1,re[3].length-1));var ee=re[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:re[0],href:re[2],title:re[3]}}},ce.table=function(J){var re=this.rules.block.table.exec(J);if(re){var ee={type:"table",header:i(re[1]).map(function(ve){return{text:ve}}),align:re[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:re[3]&&re[3].trim()?re[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=re[0];var O=ee.align.length,W,q,X,ae;for(W=0;W<O;W++)/^ *-+: *$/.test(ee.align[W])?ee.align[W]="right":/^ *:-+: *$/.test(ee.align[W])?ee.align[W]="center":/^ *:-+ *$/.test(ee.align[W])?ee.align[W]="left":ee.align[W]=null;for(O=ee.rows.length,W=0;W<O;W++)ee.rows[W]=i(ee.rows[W],ee.header.length).map(function(ve){return{text:ve}});for(O=ee.header.length,q=0;q<O;q++)ee.header[q].tokens=this.lexer.inline(ee.header[q].text);for(O=ee.rows.length,q=0;q<O;q++)for(ae=ee.rows[q],X=0;X<ae.length;X++)ae[X].tokens=this.lexer.inline(ae[X].text);return ee}}},ce.lheading=function(J){var re=this.rules.block.lheading.exec(J);if(re)return{type:"heading",raw:re[0],depth:re[2].charAt(0)==="="?1:2,text:re[1],tokens:this.lexer.inline(re[1])}},ce.paragraph=function(J){var re=this.rules.block.paragraph.exec(J);if(re){var ee=re[1].charAt(re[1].length-1)===`
`?re[1].slice(0,-1):re[1];return{type:"paragraph",raw:re[0],text:ee,tokens:this.lexer.inline(ee)}}},ce.text=function(J){var re=this.rules.block.text.exec(J);if(re)return{type:"text",raw:re[0],text:re[0],tokens:this.lexer.inline(re[0])}},ce.escape=function(J){var re=this.rules.inline.escape.exec(J);if(re)return{type:"escape",raw:re[0],text:w(re[1])}},ce.tag=function(J){var re=this.rules.inline.tag.exec(J);if(re)return!this.lexer.state.inLink&&/^<a /i.test(re[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(re[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(re[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(re[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:re[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):w(re[0]):re[0]}},ce.link=function(J){var re=this.rules.inline.link.exec(J);if(re){var ee=re[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var O=p(ee.slice(0,-1),"\\");if((ee.length-O.length)%2===0)return}else{var W=C(re[2],"()");if(W>-1){var q=re[0].indexOf("!")===0?5:4,X=q+re[1].length+W;re[2]=re[2].substring(0,W),re[0]=re[0].substring(0,X).trim(),re[3]=""}}var ae=re[2],ve="";if(this.options.pedantic){var Te=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ae);Te&&(ae=Te[1],ve=Te[3])}else ve=re[3]?re[3].slice(1,-1):"";return ae=ae.trim(),/^</.test(ae)&&(this.options.pedantic&&!/>$/.test(ee)?ae=ae.slice(1):ae=ae.slice(1,-1)),H(re,{href:ae&&ae.replace(this.rules.inline._escapes,"$1"),title:ve&&ve.replace(this.rules.inline._escapes,"$1")},re[0],this.lexer)}},ce.reflink=function(J,re){var ee;if((ee=this.rules.inline.reflink.exec(J))||(ee=this.rules.inline.nolink.exec(J))){var O=(ee[2]||ee[1]).replace(/\s+/g," ");if(O=re[O.toLowerCase()],!O||!O.href){var W=ee[0].charAt(0);return{type:"text",raw:W,text:W}}return H(ee,O,ee[0],this.lexer)}},ce.emStrong=function(J,re,ee){ee===void 0&&(ee="");var O=this.rules.inline.emStrong.lDelim.exec(J);if(!!O&&!(O[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var W=O[1]||O[2]||"";if(!W||W&&(ee===""||this.rules.inline.punctuation.exec(ee))){var q=O[0].length-1,X,ae,ve=q,Te=0,ge=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,re=re.slice(-1*J.length+q);(O=ge.exec(re))!=null;)if(X=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!X){if(ae=X.length,O[3]||O[4]){ve+=ae;continue}else if((O[5]||O[6])&&q%3&&!((q+ae)%3)){Te+=ae;continue}if(ve-=ae,!(ve>0)){if(ae=Math.min(ae,ae+ve+Te),Math.min(q,ae)%2){var Pe=J.slice(1,q+O.index+ae);return{type:"em",raw:J.slice(0,q+O.index+ae+1),text:Pe,tokens:this.lexer.inlineTokens(Pe)}}var De=J.slice(2,q+O.index+ae-1);return{type:"strong",raw:J.slice(0,q+O.index+ae+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},ce.codespan=function(J){var re=this.rules.inline.code.exec(J);if(re){var ee=re[2].replace(/\n/g," "),O=/[^ ]/.test(ee),W=/^ /.test(ee)&&/ $/.test(ee);return O&&W&&(ee=ee.substring(1,ee.length-1)),ee=w(ee,!0),{type:"codespan",raw:re[0],text:ee}}},ce.br=function(J){var re=this.rules.inline.br.exec(J);if(re)return{type:"br",raw:re[0]}},ce.del=function(J){var re=this.rules.inline.del.exec(J);if(re)return{type:"del",raw:re[0],text:re[2],tokens:this.lexer.inlineTokens(re[2])}},ce.autolink=function(J,re){var ee=this.rules.inline.autolink.exec(J);if(ee){var O,W;return ee[2]==="@"?(O=w(this.options.mangle?re(ee[1]):ee[1]),W="mailto:"+O):(O=w(ee[1]),W=O),{type:"link",raw:ee[0],text:O,href:W,tokens:[{type:"text",raw:O,text:O}]}}},ce.url=function(J,re){var ee;if(ee=this.rules.inline.url.exec(J)){var O,W;if(ee[2]==="@")O=w(this.options.mangle?re(ee[0]):ee[0]),W="mailto:"+O;else{var q;do q=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(q!==ee[0]);O=w(ee[0]),ee[1]==="www."?W="http://"+O:W=O}return{type:"link",raw:ee[0],text:O,href:W,tokens:[{type:"text",raw:O,text:O}]}}},ce.inlineText=function(J,re){var ee=this.rules.inline.text.exec(J);if(ee){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):w(ee[0]):ee[0]:O=w(this.options.smartypants?re(ee[0]):ee[0]),{type:"text",raw:ee[0],text:O}}},ne}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=v(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=v(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=v(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=v(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=v(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=v(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=n({},M),M.gfm=n({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=v(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=v(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=n({},M.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:v(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=v(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=v(M._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=v(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=v(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=v(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=v(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=v(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=v(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=v(F.reflink).replace("label",F._label).replace("ref",M._label).getRegex(),F.nolink=v(F.nolink).replace("ref",M._label).getRegex(),F.reflinkSearch=v(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=n({},F),F.pedantic=n({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=n({},F.normal,{escape:v(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=v(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=n({},F.gfm,{br:v(F.br).replace("{2,}","*").getRegex(),text:v(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(ne){return ne.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function N(ne){var ce="",fe,J,re=ne.length;for(fe=0;fe<re;fe++)J=ne.charCodeAt(fe),Math.random()>.5&&(J="x"+J.toString(16)),ce+="&#"+J+";";return ce}var z=function(){function ne(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||Z.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:M.normal,inline:F.normal};this.options.pedantic?(J.block=M.pedantic,J.inline=F.pedantic):this.options.gfm&&(J.block=M.gfm,this.options.breaks?J.inline=F.breaks:J.inline=F.gfm),this.tokenizer.rules=J}ne.lex=function(J,re){var ee=new ne(re);return ee.lex(J)},ne.lexInline=function(J,re){var ee=new ne(re);return ee.inlineTokens(J)};var ce=ne.prototype;return ce.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var re;re=this.inlineQueue.shift();)this.inlineTokens(re.src,re.tokens);return this.tokens},ce.blockTokens=function(J,re){var ee=this;re===void 0&&(re=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(ve,Te,ge){return Te+"    ".repeat(ge.length)});for(var O,W,q,X;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ve){return(O=ve.call({lexer:ee},J,re))?(J=J.substring(O.raw.length),re.push(O),!0):!1}))){if(O=this.tokenizer.space(J)){J=J.substring(O.raw.length),O.raw.length===1&&re.length>0?re[re.length-1].raw+=`
`:re.push(O);continue}if(O=this.tokenizer.code(J)){J=J.substring(O.raw.length),W=re[re.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+O.raw,W.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=W.text):re.push(O);continue}if(O=this.tokenizer.fences(J)){J=J.substring(O.raw.length),re.push(O);continue}if(O=this.tokenizer.heading(J)){J=J.substring(O.raw.length),re.push(O);continue}if(O=this.tokenizer.hr(J)){J=J.substring(O.raw.length),re.push(O);continue}if(O=this.tokenizer.blockquote(J)){J=J.substring(O.raw.length),re.push(O);continue}if(O=this.tokenizer.list(J)){J=J.substring(O.raw.length),re.push(O);continue}if(O=this.tokenizer.html(J)){J=J.substring(O.raw.length),re.push(O);continue}if(O=this.tokenizer.def(J)){J=J.substring(O.raw.length),W=re[re.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+O.raw,W.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=W.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(J)){J=J.substring(O.raw.length),re.push(O);continue}if(O=this.tokenizer.lheading(J)){J=J.substring(O.raw.length),re.push(O);continue}if(q=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var ve=1/0,Te=J.slice(1),ge=void 0;ee.options.extensions.startBlock.forEach(function(Pe){ge=Pe.call({lexer:this},Te),typeof ge=="number"&&ge>=0&&(ve=Math.min(ve,ge))}),ve<1/0&&ve>=0&&(q=J.substring(0,ve+1))}(),this.state.top&&(O=this.tokenizer.paragraph(q))){W=re[re.length-1],X&&W.type==="paragraph"?(W.raw+=`
`+O.raw,W.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):re.push(O),X=q.length!==J.length,J=J.substring(O.raw.length);continue}if(O=this.tokenizer.text(J)){J=J.substring(O.raw.length),W=re[re.length-1],W&&W.type==="text"?(W.raw+=`
`+O.raw,W.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):re.push(O);continue}if(J){var ae="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(ae);break}else throw new Error(ae)}}return this.state.top=!0,re},ce.inline=function(J,re){return re===void 0&&(re=[]),this.inlineQueue.push({src:J,tokens:re}),re},ce.inlineTokens=function(J,re){var ee=this;re===void 0&&(re=[]);var O,W,q,X=J,ae,ve,Te;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(ae=this.tokenizer.rules.inline.reflinkSearch.exec(X))!=null;)ge.includes(ae[0].slice(ae[0].lastIndexOf("[")+1,-1))&&(X=X.slice(0,ae.index)+"["+U("a",ae[0].length-2)+"]"+X.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ae=this.tokenizer.rules.inline.blockSkip.exec(X))!=null;)X=X.slice(0,ae.index)+"["+U("a",ae[0].length-2)+"]"+X.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ae=this.tokenizer.rules.inline.escapedEmSt.exec(X))!=null;)X=X.slice(0,ae.index)+"++"+X.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(ve||(Te=""),ve=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(O=De.call({lexer:ee},J,re))?(J=J.substring(O.raw.length),re.push(O),!0):!1}))){if(O=this.tokenizer.escape(J)){J=J.substring(O.raw.length),re.push(O);continue}if(O=this.tokenizer.tag(J)){J=J.substring(O.raw.length),W=re[re.length-1],W&&O.type==="text"&&W.type==="text"?(W.raw+=O.raw,W.text+=O.text):re.push(O);continue}if(O=this.tokenizer.link(J)){J=J.substring(O.raw.length),re.push(O);continue}if(O=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(O.raw.length),W=re[re.length-1],W&&O.type==="text"&&W.type==="text"?(W.raw+=O.raw,W.text+=O.text):re.push(O);continue}if(O=this.tokenizer.emStrong(J,X,Te)){J=J.substring(O.raw.length),re.push(O);continue}if(O=this.tokenizer.codespan(J)){J=J.substring(O.raw.length),re.push(O);continue}if(O=this.tokenizer.br(J)){J=J.substring(O.raw.length),re.push(O);continue}if(O=this.tokenizer.del(J)){J=J.substring(O.raw.length),re.push(O);continue}if(O=this.tokenizer.autolink(J,N)){J=J.substring(O.raw.length),re.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(J,N))){J=J.substring(O.raw.length),re.push(O);continue}if(q=J,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,xe=J.slice(1),je=void 0;ee.options.extensions.startInline.forEach(function(nt){je=nt.call({lexer:this},xe),typeof je=="number"&&je>=0&&(De=Math.min(De,je))}),De<1/0&&De>=0&&(q=J.substring(0,De+1))}(),O=this.tokenizer.inlineText(q,B)){J=J.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(Te=O.raw.slice(-1)),ve=!0,W=re[re.length-1],W&&W.type==="text"?(W.raw+=O.raw,W.text+=O.text):re.push(O);continue}if(J){var Pe="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return re},c(ne,null,[{key:"rules",get:function(){return{block:M,inline:F}}}]),ne}(),j=function(){function ne(fe){this.options=fe||Z.defaults}var ce=ne.prototype;return ce.code=function(J,re,ee){var O=(re||"").match(/\S*/)[0];if(this.options.highlight){var W=this.options.highlight(J,O);W!=null&&W!==J&&(ee=!0,J=W)}return J=J.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+w(O,!0)+'">'+(ee?J:w(J,!0))+`</code></pre>
`:"<pre><code>"+(ee?J:w(J,!0))+`</code></pre>
`},ce.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},ce.html=function(J){return J},ce.heading=function(J,re,ee,O){if(this.options.headerIds){var W=this.options.headerPrefix+O.slug(ee);return"<h"+re+' id="'+W+'">'+J+"</h"+re+`>
`}return"<h"+re+">"+J+"</h"+re+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(J,re,ee){var O=re?"ol":"ul",W=re&&ee!==1?' start="'+ee+'"':"";return"<"+O+W+`>
`+J+"</"+O+`>
`},ce.listitem=function(J){return"<li>"+J+`</li>
`},ce.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(J){return"<p>"+J+`</p>
`},ce.table=function(J,re){return re&&(re="<tbody>"+re+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+re+`</table>
`},ce.tablerow=function(J){return`<tr>
`+J+`</tr>
`},ce.tablecell=function(J,re){var ee=re.header?"th":"td",O=re.align?"<"+ee+' align="'+re.align+'">':"<"+ee+">";return O+J+("</"+ee+`>
`)},ce.strong=function(J){return"<strong>"+J+"</strong>"},ce.em=function(J){return"<em>"+J+"</em>"},ce.codespan=function(J){return"<code>"+J+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(J){return"<del>"+J+"</del>"},ce.link=function(J,re,ee){if(J=b(this.options.sanitize,this.options.baseUrl,J),J===null)return ee;var O='<a href="'+w(J)+'"';return re&&(O+=' title="'+re+'"'),O+=">"+ee+"</a>",O},ce.image=function(J,re,ee){if(J=b(this.options.sanitize,this.options.baseUrl,J),J===null)return ee;var O='<img src="'+J+'" alt="'+ee+'"';return re&&(O+=' title="'+re+'"'),O+=this.options.xhtml?"/>":">",O},ce.text=function(J){return J},ne}(),x=function(){function ne(){}var ce=ne.prototype;return ce.strong=function(J){return J},ce.em=function(J){return J},ce.codespan=function(J){return J},ce.del=function(J){return J},ce.html=function(J){return J},ce.text=function(J){return J},ce.link=function(J,re,ee){return""+ee},ce.image=function(J,re,ee){return""+ee},ce.br=function(){return""},ne}(),Q=function(){function ne(){this.seen={}}var ce=ne.prototype;return ce.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(J,re){var ee=J,O=0;if(this.seen.hasOwnProperty(ee)){O=this.seen[J];do O++,ee=J+"-"+O;while(this.seen.hasOwnProperty(ee))}return re||(this.seen[J]=O,this.seen[ee]=0),ee},ce.slug=function(J,re){re===void 0&&(re={});var ee=this.serialize(J);return this.getNextSafeSlug(ee,re.dryrun)},ne}(),K=function(){function ne(fe){this.options=fe||Z.defaults,this.options.renderer=this.options.renderer||new j,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new Q}ne.parse=function(J,re){var ee=new ne(re);return ee.parse(J)},ne.parseInline=function(J,re){var ee=new ne(re);return ee.parseInline(J)};var ce=ne.prototype;return ce.parse=function(J,re){re===void 0&&(re=!0);var ee="",O,W,q,X,ae,ve,Te,ge,Pe,De,xe,je,nt,Xe,rt,Be,dt,se,oe,Se=J.length;for(O=0;O<Se;O++){if(De=J[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(oe=this.options.extensions.renderers[De.type].call({parser:this},De),oe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){ee+=oe||"";continue}switch(De.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(De.tokens),De.depth,g(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(ge="",Te="",X=De.header.length,W=0;W<X;W++)Te+=this.renderer.tablecell(this.parseInline(De.header[W].tokens),{header:!0,align:De.align[W]});for(ge+=this.renderer.tablerow(Te),Pe="",X=De.rows.length,W=0;W<X;W++){for(ve=De.rows[W],Te="",ae=ve.length,q=0;q<ae;q++)Te+=this.renderer.tablecell(this.parseInline(ve[q].tokens),{header:!1,align:De.align[q]});Pe+=this.renderer.tablerow(Te)}ee+=this.renderer.table(ge,Pe);continue}case"blockquote":{Pe=this.parse(De.tokens),ee+=this.renderer.blockquote(Pe);continue}case"list":{for(xe=De.ordered,je=De.start,nt=De.loose,X=De.items.length,Pe="",W=0;W<X;W++)rt=De.items[W],Be=rt.checked,dt=rt.task,Xe="",rt.task&&(se=this.renderer.checkbox(Be),nt?rt.tokens.length>0&&rt.tokens[0].type==="paragraph"?(rt.tokens[0].text=se+" "+rt.tokens[0].text,rt.tokens[0].tokens&&rt.tokens[0].tokens.length>0&&rt.tokens[0].tokens[0].type==="text"&&(rt.tokens[0].tokens[0].text=se+" "+rt.tokens[0].tokens[0].text)):rt.tokens.unshift({type:"text",text:se}):Xe+=se),Xe+=this.parse(rt.tokens,nt),Pe+=this.renderer.listitem(Xe,dt,Be);ee+=this.renderer.list(Pe,xe,je);continue}case"html":{ee+=this.renderer.html(De.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Pe=De.tokens?this.parseInline(De.tokens):De.text;O+1<Se&&J[O+1].type==="text";)De=J[++O],Pe+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);ee+=re?this.renderer.paragraph(Pe):Pe;continue}default:{var ue='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(ue);return}else throw new Error(ue)}}}return ee},ce.parseInline=function(J,re){re=re||this.renderer;var ee="",O,W,q,X=J.length;for(O=0;O<X;O++){if(W=J[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(q=this.options.extensions.renderers[W.type].call({parser:this},W),q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(W.type))){ee+=q||"";continue}switch(W.type){case"escape":{ee+=re.text(W.text);break}case"html":{ee+=re.html(W.text);break}case"link":{ee+=re.link(W.href,W.title,this.parseInline(W.tokens,re));break}case"image":{ee+=re.image(W.href,W.title,W.text);break}case"strong":{ee+=re.strong(this.parseInline(W.tokens,re));break}case"em":{ee+=re.em(this.parseInline(W.tokens,re));break}case"codespan":{ee+=re.codespan(W.text);break}case"br":{ee+=re.br();break}case"del":{ee+=re.del(this.parseInline(W.tokens,re));break}case"text":{ee+=re.text(W.text);break}default:{var ae='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(ae);return}else throw new Error(ae)}}}return ee},ne}();function le(ne,ce,fe){if(typeof ne>"u"||ne===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");if(typeof ce=="function"&&(fe=ce,ce=null),ce=n({},le.defaults,ce||{}),R(ce),fe){var J=ce.highlight,re;try{re=z.lex(ne,ce)}catch(X){return fe(X)}var ee=function(ae){var ve;if(!ae)try{ce.walkTokens&&le.walkTokens(re,ce.walkTokens),ve=K.parse(re,ce)}catch(Te){ae=Te}return ce.highlight=J,ae?fe(ae):fe(null,ve)};if(!J||J.length<3||(delete ce.highlight,!re.length))return ee();var O=0;le.walkTokens(re,function(X){X.type==="code"&&(O++,setTimeout(function(){J(X.text,X.lang,function(ae,ve){if(ae)return ee(ae);ve!=null&&ve!==X.text&&(X.text=ve,X.escaped=!0),O--,O===0&&ee()})},0))}),O===0&&ee();return}function W(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(X.message+"",!0)+"</pre>";throw X}try{var q=z.lex(ne,ce);if(ce.walkTokens){if(ce.async)return Promise.all(le.walkTokens(q,ce.walkTokens)).then(function(){return K.parse(q,ce)}).catch(W);le.walkTokens(q,ce.walkTokens)}return K.parse(q,ce)}catch(X){W(X)}}le.options=le.setOptions=function(ne){return n(le.defaults,ne),T(le.defaults),le},le.getDefaults=y,le.defaults=Z.defaults,le.use=function(){for(var ne=arguments.length,ce=new Array(ne),fe=0;fe<ne;fe++)ce[fe]=arguments[fe];var J=n.apply(void 0,[{}].concat(ce)),re=le.defaults.extensions||{renderers:{},childTokens:{}},ee;ce.forEach(function(O){if(O.extensions&&(ee=!0,O.extensions.forEach(function(q){if(!q.name)throw new Error("extension name required");if(q.renderer){var X=re.renderers?re.renderers[q.name]:null;X?re.renderers[q.name]=function(){for(var ae=arguments.length,ve=new Array(ae),Te=0;Te<ae;Te++)ve[Te]=arguments[Te];var ge=q.renderer.apply(this,ve);return ge===!1&&(ge=X.apply(this,ve)),ge}:re.renderers[q.name]=q.renderer}if(q.tokenizer){if(!q.level||q.level!=="block"&&q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");re[q.level]?re[q.level].unshift(q.tokenizer):re[q.level]=[q.tokenizer],q.start&&(q.level==="block"?re.startBlock?re.startBlock.push(q.start):re.startBlock=[q.start]:q.level==="inline"&&(re.startInline?re.startInline.push(q.start):re.startInline=[q.start]))}q.childTokens&&(re.childTokens[q.name]=q.childTokens)})),O.renderer&&function(){var q=le.defaults.renderer||new j,X=function(Te){var ge=q[Te];q[Te]=function(){for(var Pe=arguments.length,De=new Array(Pe),xe=0;xe<Pe;xe++)De[xe]=arguments[xe];var je=O.renderer[Te].apply(q,De);return je===!1&&(je=ge.apply(q,De)),je}};for(var ae in O.renderer)X(ae);J.renderer=q}(),O.tokenizer&&function(){var q=le.defaults.tokenizer||new L,X=function(Te){var ge=q[Te];q[Te]=function(){for(var Pe=arguments.length,De=new Array(Pe),xe=0;xe<Pe;xe++)De[xe]=arguments[xe];var je=O.tokenizer[Te].apply(q,De);return je===!1&&(je=ge.apply(q,De)),je}};for(var ae in O.tokenizer)X(ae);J.tokenizer=q}(),O.walkTokens){var W=le.defaults.walkTokens;J.walkTokens=function(q){var X=[];return X.push(O.walkTokens.call(this,q)),W&&(X=X.concat(W.call(this,q))),X}}ee&&(J.extensions=re),le.setOptions(J)})},le.walkTokens=function(ne,ce){for(var fe=[],J=function(){var W=ee.value;switch(fe=fe.concat(ce.call(le,W)),W.type){case"table":{for(var q=P(W.header),X;!(X=q()).done;){var ae=X.value;fe=fe.concat(le.walkTokens(ae.tokens,ce))}for(var ve=P(W.rows),Te;!(Te=ve()).done;)for(var ge=Te.value,Pe=P(ge),De;!(De=Pe()).done;){var xe=De.value;fe=fe.concat(le.walkTokens(xe.tokens,ce))}break}case"list":{fe=fe.concat(le.walkTokens(W.items,ce));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[W.type]?le.defaults.extensions.childTokens[W.type].forEach(function(je){fe=fe.concat(le.walkTokens(W[je],ce))}):W.tokens&&(fe=fe.concat(le.walkTokens(W.tokens,ce)))}},re=P(ne),ee;!(ee=re()).done;)J();return fe},le.parseInline=function(ne,ce){if(typeof ne>"u"||ne===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");ce=n({},le.defaults,ce||{}),R(ce);try{var fe=z.lexInline(ne,ce);return ce.walkTokens&&le.walkTokens(fe,ce.walkTokens),K.parseInline(fe,ce)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(J.message+"",!0)+"</pre>";throw J}},le.Parser=K,le.parser=K.parse,le.Renderer=j,le.TextRenderer=x,le.Lexer=z,le.lexer=z.lex,le.Tokenizer=L,le.Slugger=Q,le.parse=le;var ie=le.options,de=le.setOptions,Y=le.use,pe=le.walkTokens,be=le.parseInline,Ce=le,Re=K.parse,We=z.lex;Z.Lexer=z,Z.Parser=K,Z.Renderer=j,Z.Slugger=Q,Z.TextRenderer=x,Z.Tokenizer=L,Z.getDefaults=y,Z.lexer=We,Z.marked=le,Z.options=ie,Z.parse=Ce,Z.parseInline=be,Z.parser=Re,Z.setOptions=de,Z.use=Y,Z.walkTokens=pe,Object.defineProperty(Z,"__esModule",{value:!0})}),define(_e[80],ye([1,0,28]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new c.LRUCache(1e4);function I(D){return S(D,"NFC",t)}e.normalizeNFC=I;const P=new c.LRUCache(1e4);function y(D){return S(D,"NFD",P)}e.normalizeNFD=y;const T=/[^\u0000-\u0080]/;function S(D,A,k){if(!D)return D;const E=k.get(D);if(E)return E;let _;return T.test(D)?_=D.normalize(A):_=D,k.set(D,_),_}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(A){return y(A).replace(D,"")}}()}),define(_e[99],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(T,S,D){return Math.min(Math.max(T,S),D)}e.clamp=c;function t(T,S){return(S+T%S)%S}e.rot=t;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class P{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class y{constructor(S){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(S),this._values.fill(0,0,S)}update(S){const D=this._values[this._index];return this._values[this._index]=S,this._index=(this._index+1)%this._values.length,this._sum-=D,this._sum+=S,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),function(){function Z(I){const P=[];typeof I=="number"&&P.push("code/timeOrigin",I);function y(S){P.push(S,Date.now())}function T(){const S=[];for(let D=0;D<P.length;D+=2)S.push({name:P[D],startTime:P[D+1]});return S}return{mark:y,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const y of performance.getEntriesByType("mark"))P.push({name:y.name,startTime:Math.round(I+y.startTime)});return P}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function c(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=c(t))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var t in c)(typeof exports=="object"?exports:Z)[t]=c[t]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function c(t){if(e[t])return e[t].exports;var I=e[t]={i:t,l:!1,exports:{}};return Z[t].call(I.exports,I,I.exports,c),I.l=!0,I.exports}return c.m=Z,c.c=e,c.d=function(t,I,P){c.o(t,I)||Object.defineProperty(t,I,{enumerable:!0,get:P})},c.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},c.t=function(t,I){if(1&I&&(t=c(t)),8&I||4&I&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(c.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&I&&typeof t!="string")for(var y in t)c.d(P,y,function(T){return t[T]}.bind(null,y));return P},c.n=function(t){var I=t&&t.__esModule?function(){return t.default}:function(){return t};return c.d(I,"a",I),I},c.o=function(t,I){return Object.prototype.hasOwnProperty.call(t,I)},c.p="",c(c.s=0)}([function(Z,e,c){(function(t){var I;e=Z.exports=Y,I=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,y=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],S=e.src=[],D=0,A=D++;S[A]="0|[1-9]\\d*";var k=D++;S[k]="[0-9]+";var E=D++;S[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var _=D++;S[_]="("+S[A]+")\\.("+S[A]+")\\.("+S[A]+")";var w=D++;S[w]="("+S[k]+")\\.("+S[k]+")\\.("+S[k]+")";var f=D++;S[f]="(?:"+S[A]+"|"+S[E]+")";var g=D++;S[g]="(?:"+S[k]+"|"+S[E]+")";var h=D++;S[h]="(?:-("+S[f]+"(?:\\."+S[f]+")*))";var v=D++;S[v]="(?:-?("+S[g]+"(?:\\."+S[g]+")*))";var m=D++;S[m]="[0-9A-Za-z-]+";var r=D++;S[r]="(?:\\+("+S[m]+"(?:\\."+S[m]+")*))";var b=D++,s="v?"+S[_]+S[h]+"?"+S[r]+"?";S[b]="^"+s+"$";var u="[v=\\s]*"+S[w]+S[v]+"?"+S[r]+"?",o=D++;S[o]="^"+u+"$";var l=D++;S[l]="((?:<|>)?=?)";var a=D++;S[a]=S[k]+"|x|X|\\*";var d=D++;S[d]=S[A]+"|x|X|\\*";var n=D++;S[n]="[v=\\s]*("+S[d]+")(?:\\.("+S[d]+")(?:\\.("+S[d]+")(?:"+S[h]+")?"+S[r]+"?)?)?";var i=D++;S[i]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[v]+")?"+S[r]+"?)?)?";var p=D++;S[p]="^"+S[l]+"\\s*"+S[n]+"$";var C=D++;S[C]="^"+S[l]+"\\s*"+S[i]+"$";var R=D++;S[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=D++;S[U]="(?:~>?)";var H=D++;S[H]="(\\s*)"+S[U]+"\\s+",T[H]=new RegExp(S[H],"g");var V=D++;S[V]="^"+S[U]+S[n]+"$";var L=D++;S[L]="^"+S[U]+S[i]+"$";var M=D++;S[M]="(?:\\^)";var F=D++;S[F]="(\\s*)"+S[M]+"\\s+",T[F]=new RegExp(S[F],"g");var B=D++;S[B]="^"+S[M]+S[n]+"$";var N=D++;S[N]="^"+S[M]+S[i]+"$";var z=D++;S[z]="^"+S[l]+"\\s*("+u+")$|^$";var j=D++;S[j]="^"+S[l]+"\\s*("+s+")$|^$";var x=D++;S[x]="(\\s*)"+S[l]+"\\s*("+u+"|"+S[n]+")",T[x]=new RegExp(S[x],"g");var Q=D++;S[Q]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var K=D++;S[K]="^\\s*("+S[i]+")\\s+-\\s+("+S[i]+")\\s*$";var le=D++;S[le]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)I(ie,S[ie]),T[ie]||(T[ie]=new RegExp(S[ie]));function de(ge,Pe){if(ge instanceof Y)return ge;if(typeof ge!="string"||ge.length>P||!(Pe?T[o]:T[b]).test(ge))return null;try{return new Y(ge,Pe)}catch{return null}}function Y(ge,Pe){if(ge instanceof Y){if(ge.loose===Pe)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof Y))return new Y(ge,Pe);I("SemVer",ge,Pe),this.loose=Pe;var De=ge.trim().match(Pe?T[o]:T[b]);if(!De)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+De[1],this.minor=+De[2],this.patch=+De[3],this.major>y||this.major<0)throw new TypeError("Invalid major version");if(this.minor>y||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>y||this.patch<0)throw new TypeError("Invalid patch version");De[4]?this.prerelease=De[4].split(".").map(function(xe){if(/^[0-9]+$/.test(xe)){var je=+xe;if(je>=0&&je<y)return je}return xe}):this.prerelease=[],this.build=De[5]?De[5].split("."):[],this.format()}e.parse=de,e.valid=function(ge,Pe){var De=de(ge,Pe);return De?De.version:null},e.clean=function(ge,Pe){var De=de(ge.trim().replace(/^[=v]+/,""),Pe);return De?De.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(ge){return I("SemVer.compare",this.version,this.loose,ge),ge instanceof Y||(ge=new Y(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},Y.prototype.compareMain=function(ge){return ge instanceof Y||(ge=new Y(ge,this.loose)),be(this.major,ge.major)||be(this.minor,ge.minor)||be(this.patch,ge.patch)},Y.prototype.comparePre=function(ge){if(ge instanceof Y||(ge=new Y(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var Pe=0;do{var De=this.prerelease[Pe],xe=ge.prerelease[Pe];if(I("prerelease compare",Pe,De,xe),De===void 0&&xe===void 0)return 0;if(xe===void 0)return 1;if(De===void 0)return-1;if(De!==xe)return be(De,xe)}while(++Pe)},Y.prototype.inc=function(ge,Pe){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Pe),this.inc("pre",Pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Pe),this.inc("pre",Pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var De=this.prerelease.length;--De>=0;)typeof this.prerelease[De]=="number"&&(this.prerelease[De]++,De=-2);De===-1&&this.prerelease.push(0)}Pe&&(this.prerelease[0]===Pe?isNaN(this.prerelease[1])&&(this.prerelease=[Pe,0]):this.prerelease=[Pe,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,Pe,De,xe){typeof De=="string"&&(xe=De,De=void 0);try{return new Y(ge,De).inc(Pe,xe).version}catch{return null}},e.diff=function(ge,Pe){if(ne(ge,Pe))return null;var De=de(ge),xe=de(Pe);if(De.prerelease.length||xe.prerelease.length){for(var je in De)if((je==="major"||je==="minor"||je==="patch")&&De[je]!==xe[je])return"pre"+je;return"prerelease"}for(var je in De)if((je==="major"||je==="minor"||je==="patch")&&De[je]!==xe[je])return je},e.compareIdentifiers=be;var pe=/^[0-9]+$/;function be(ge,Pe){var De=pe.test(ge),xe=pe.test(Pe);return De&&xe&&(ge=+ge,Pe=+Pe),De&&!xe?-1:xe&&!De?1:ge<Pe?-1:ge>Pe?1:0}function Ce(ge,Pe,De){return new Y(ge,De).compare(new Y(Pe,De))}function Re(ge,Pe,De){return Ce(ge,Pe,De)>0}function We(ge,Pe,De){return Ce(ge,Pe,De)<0}function ne(ge,Pe,De){return Ce(ge,Pe,De)===0}function ce(ge,Pe,De){return Ce(ge,Pe,De)!==0}function fe(ge,Pe,De){return Ce(ge,Pe,De)>=0}function J(ge,Pe,De){return Ce(ge,Pe,De)<=0}function re(ge,Pe,De,xe){var je;switch(Pe){case"===":typeof ge=="object"&&(ge=ge.version),typeof De=="object"&&(De=De.version),je=ge===De;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof De=="object"&&(De=De.version),je=ge!==De;break;case"":case"=":case"==":je=ne(ge,De,xe);break;case"!=":je=ce(ge,De,xe);break;case">":je=Re(ge,De,xe);break;case">=":je=fe(ge,De,xe);break;case"<":je=We(ge,De,xe);break;case"<=":je=J(ge,De,xe);break;default:throw new TypeError("Invalid operator: "+Pe)}return je}function ee(ge,Pe){if(ge instanceof ee){if(ge.loose===Pe)return ge;ge=ge.value}if(!(this instanceof ee))return new ee(ge,Pe);I("comparator",ge,Pe),this.loose=Pe,this.parse(ge),this.semver===O?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(ge,Pe){return be(Pe,ge)},e.major=function(ge,Pe){return new Y(ge,Pe).major},e.minor=function(ge,Pe){return new Y(ge,Pe).minor},e.patch=function(ge,Pe){return new Y(ge,Pe).patch},e.compare=Ce,e.compareLoose=function(ge,Pe){return Ce(ge,Pe,!0)},e.rcompare=function(ge,Pe,De){return Ce(Pe,ge,De)},e.sort=function(ge,Pe){return ge.sort(function(De,xe){return e.compare(De,xe,Pe)})},e.rsort=function(ge,Pe){return ge.sort(function(De,xe){return e.rcompare(De,xe,Pe)})},e.gt=Re,e.lt=We,e.eq=ne,e.neq=ce,e.gte=fe,e.lte=J,e.cmp=re,e.Comparator=ee;var O={};function W(ge,Pe){if(ge instanceof W)return ge.loose===Pe?ge:new W(ge.raw,Pe);if(ge instanceof ee)return new W(ge.value,Pe);if(!(this instanceof W))return new W(ge,Pe);if(this.loose=Pe,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(De){return this.parseRange(De.trim())},this).filter(function(De){return De.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function q(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function X(ge,Pe,De,xe,je,nt,Xe,rt,Be,dt,se,oe,Se){return((Pe=q(De)?"":q(xe)?">="+De+".0.0":q(je)?">="+De+"."+xe+".0":">="+Pe)+" "+(rt=q(Be)?"":q(dt)?"<"+(+Be+1)+".0.0":q(se)?"<"+Be+"."+(+dt+1)+".0":oe?"<="+Be+"."+dt+"."+se+"-"+oe:"<="+rt)).trim()}function ae(ge,Pe){for(var De=0;De<ge.length;De++)if(!ge[De].test(Pe))return!1;if(Pe.prerelease.length){for(De=0;De<ge.length;De++)if(I(ge[De].semver),ge[De].semver!==O&&ge[De].semver.prerelease.length>0){var xe=ge[De].semver;if(xe.major===Pe.major&&xe.minor===Pe.minor&&xe.patch===Pe.patch)return!0}return!1}return!0}function ve(ge,Pe,De){try{Pe=new W(Pe,De)}catch{return!1}return Pe.test(ge)}function Te(ge,Pe,De,xe){var je,nt,Xe,rt,Be;switch(ge=new Y(ge,xe),Pe=new W(Pe,xe),De){case">":je=Re,nt=J,Xe=We,rt=">",Be=">=";break;case"<":je=We,nt=fe,Xe=Re,rt="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(ge,Pe,xe))return!1;for(var dt=0;dt<Pe.set.length;++dt){var se=Pe.set[dt],oe=null,Se=null;if(se.forEach(function(ue){ue.semver===O&&(ue=new ee(">=0.0.0")),oe=oe||ue,Se=Se||ue,je(ue.semver,oe.semver,xe)?oe=ue:Xe(ue.semver,Se.semver,xe)&&(Se=ue)}),oe.operator===rt||oe.operator===Be||(!Se.operator||Se.operator===rt)&&nt(ge,Se.semver)||Se.operator===Be&&Xe(ge,Se.semver))return!1}return!0}ee.prototype.parse=function(ge){var Pe=this.loose?T[z]:T[j],De=ge.match(Pe);if(!De)throw new TypeError("Invalid comparator: "+ge);this.operator=De[1],this.operator==="="&&(this.operator=""),De[2]?this.semver=new Y(De[2],this.loose):this.semver=O},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(ge){return I("Comparator.test",ge,this.loose),this.semver===O||(typeof ge=="string"&&(ge=new Y(ge,this.loose)),re(ge,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(ge,Pe){if(!(ge instanceof ee))throw new TypeError("a Comparator is required");var De;if(this.operator==="")return De=new W(ge.value,Pe),ve(this.value,De,Pe);if(ge.operator==="")return De=new W(this.value,Pe),ve(ge.semver,De,Pe);var xe=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),nt=this.semver.version===ge.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),rt=re(this.semver,"<",ge.semver,Pe)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),Be=re(this.semver,">",ge.semver,Pe)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return xe||je||nt&&Xe||rt||Be},e.Range=W,W.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},W.prototype.toString=function(){return this.range},W.prototype.parseRange=function(ge){var Pe=this.loose;ge=ge.trim(),I("range",ge,Pe);var De=Pe?T[K]:T[Q];ge=ge.replace(De,X),I("hyphen replace",ge),ge=ge.replace(T[x],"$1$2$3"),I("comparator trim",ge,T[x]),ge=(ge=(ge=ge.replace(T[H],"$1~")).replace(T[F],"$1^")).split(/\s+/).join(" ");var xe=Pe?T[z]:T[j],je=ge.split(" ").map(function(nt){return function(Xe,rt){return I("comp",Xe),Xe=function(Be,dt){return Be.trim().split(/\s+/).map(function(se){return function(oe,Se){I("caret",oe,Se);var ue=Se?T[N]:T[B];return oe.replace(ue,function(Ie,Le,Fe,Ge,Ye){var it;return I("caret",oe,Ie,Le,Fe,Ge,Ye),q(Le)?it="":q(Fe)?it=">="+Le+".0.0 <"+(+Le+1)+".0.0":q(Ge)?it=Le==="0"?">="+Le+"."+Fe+".0 <"+Le+"."+(+Fe+1)+".0":">="+Le+"."+Fe+".0 <"+(+Le+1)+".0.0":Ye?(I("replaceCaret pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),it=Le==="0"?Fe==="0"?">="+Le+"."+Fe+"."+Ge+Ye+" <"+Le+"."+Fe+"."+(+Ge+1):">="+Le+"."+Fe+"."+Ge+Ye+" <"+Le+"."+(+Fe+1)+".0":">="+Le+"."+Fe+"."+Ge+Ye+" <"+(+Le+1)+".0.0"):(I("no pr"),it=Le==="0"?Fe==="0"?">="+Le+"."+Fe+"."+Ge+" <"+Le+"."+Fe+"."+(+Ge+1):">="+Le+"."+Fe+"."+Ge+" <"+Le+"."+(+Fe+1)+".0":">="+Le+"."+Fe+"."+Ge+" <"+(+Le+1)+".0.0"),I("caret return",it),it})}(se,dt)}).join(" ")}(Xe,rt),I("caret",Xe),Xe=function(Be,dt){return Be.trim().split(/\s+/).map(function(se){return function(oe,Se){var ue=Se?T[L]:T[V];return oe.replace(ue,function(Ie,Le,Fe,Ge,Ye){var it;return I("tilde",oe,Ie,Le,Fe,Ge,Ye),q(Le)?it="":q(Fe)?it=">="+Le+".0.0 <"+(+Le+1)+".0.0":q(Ge)?it=">="+Le+"."+Fe+".0 <"+Le+"."+(+Fe+1)+".0":Ye?(I("replaceTilde pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),it=">="+Le+"."+Fe+"."+Ge+Ye+" <"+Le+"."+(+Fe+1)+".0"):it=">="+Le+"."+Fe+"."+Ge+" <"+Le+"."+(+Fe+1)+".0",I("tilde return",it),it})}(se,dt)}).join(" ")}(Xe,rt),I("tildes",Xe),Xe=function(Be,dt){return I("replaceXRanges",Be,dt),Be.split(/\s+/).map(function(se){return function(oe,Se){oe=oe.trim();var ue=Se?T[C]:T[p];return oe.replace(ue,function(Ie,Le,Fe,Ge,Ye,it){I("xRange",oe,Ie,Le,Fe,Ge,Ye,it);var bt=q(Fe),st=bt||q(Ge),et=st||q(Ye);return Le==="="&&et&&(Le=""),bt?Ie=Le===">"||Le==="<"?"<0.0.0":"*":Le&&et?(st&&(Ge=0),et&&(Ye=0),Le===">"?(Le=">=",st?(Fe=+Fe+1,Ge=0,Ye=0):et&&(Ge=+Ge+1,Ye=0)):Le==="<="&&(Le="<",st?Fe=+Fe+1:Ge=+Ge+1),Ie=Le+Fe+"."+Ge+"."+Ye):st?Ie=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":et&&(Ie=">="+Fe+"."+Ge+".0 <"+Fe+"."+(+Ge+1)+".0"),I("xRange return",Ie),Ie})}(se,dt)}).join(" ")}(Xe,rt),I("xrange",Xe),Xe=function(Be,dt){return I("replaceStars",Be,dt),Be.trim().replace(T[le],"")}(Xe,rt),I("stars",Xe),Xe}(nt,Pe)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(nt){return!!nt.match(xe)})),je=je.map(function(nt){return new ee(nt,Pe)})},W.prototype.intersects=function(ge,Pe){if(!(ge instanceof W))throw new TypeError("a Range is required");return this.set.some(function(De){return De.every(function(xe){return ge.set.some(function(je){return je.every(function(nt){return xe.intersects(nt,Pe)})})})})},e.toComparators=function(ge,Pe){return new W(ge,Pe).set.map(function(De){return De.map(function(xe){return xe.value}).join(" ").trim().split(" ")})},W.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new Y(ge,this.loose));for(var Pe=0;Pe<this.set.length;Pe++)if(ae(this.set[Pe],ge))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(ge,Pe,De){var xe=null,je=null;try{var nt=new W(Pe,De)}catch{return null}return ge.forEach(function(Xe){nt.test(Xe)&&(xe&&je.compare(Xe)!==-1||(je=new Y(xe=Xe,De)))}),xe},e.minSatisfying=function(ge,Pe,De){var xe=null,je=null;try{var nt=new W(Pe,De)}catch{return null}return ge.forEach(function(Xe){nt.test(Xe)&&(xe&&je.compare(Xe)!==1||(je=new Y(xe=Xe,De)))}),xe},e.validRange=function(ge,Pe){try{return new W(ge,Pe).range||"*"}catch{return null}},e.ltr=function(ge,Pe,De){return Te(ge,Pe,"<",De)},e.gtr=function(ge,Pe,De){return Te(ge,Pe,">",De)},e.outside=Te,e.prerelease=function(ge,Pe){var De=de(ge,Pe);return De&&De.prerelease.length?De.prerelease:null},e.intersects=function(ge,Pe,De){return ge=new W(ge,De),Pe=new W(Pe,De),ge.intersects(Pe)},e.coerce=function(ge){if(ge instanceof Y)return ge;if(typeof ge!="string")return null;var Pe=ge.match(T[R]);return Pe==null?null:de((Pe[1]||"0")+"."+(Pe[2]||"0")+"."+(Pe[3]||"0"))}}).call(this,c(1))},function(Z,e){var c,t,I=Z.exports={};function P(){throw new Error("setTimeout has not been defined")}function y(){throw new Error("clearTimeout has not been defined")}function T(g){if(c===setTimeout)return setTimeout(g,0);if((c===P||!c)&&setTimeout)return c=setTimeout,setTimeout(g,0);try{return c(g,0)}catch{try{return c.call(null,g,0)}catch{return c.call(this,g,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:P}catch{c=P}try{t=typeof clearTimeout=="function"?clearTimeout:y}catch{t=y}})();var S,D=[],A=!1,k=-1;function E(){A&&S&&(A=!1,S.length?D=S.concat(D):k=-1,D.length&&_())}function _(){if(!A){var g=T(E);A=!0;for(var h=D.length;h;){for(S=D,D=[];++k<h;)S&&S[k].run();k=-1,h=D.length}S=null,A=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===y||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(g)}}function w(g,h){this.fun=g,this.array=h}function f(){}I.nextTick=function(g){var h=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)h[v-1]=arguments[v];D.push(new w(g,h)),D.length!==1||A||T(_)},w.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=f,I.addListener=f,I.once=f,I.off=f,I.removeListener=f,I.removeAllListeners=f,I.emit=f,I.prependListener=f,I.prependOnceListener=f,I.listeners=function(g){return[]},I.binding=function(g){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(g){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(_e[100],ye([1,0,10,6]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(r){const b=r;return b?typeof b.read=="function":!1}e.isReadable=I;function P(r){const b=r;return b?[b.on,b.pause,b.resume,b.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=P;function y(r){const b=r;return b?P(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=y;function T(r,b){return new S(r,b)}e.newWriteableStream=T;class S{constructor(b,s){this.reducer=b,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b<"u"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(s=>s(b))}emitError(b){this.listeners.error.length===0?(0,c.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(s=>s(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,s){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(b,s){if(this.state.destroyed)return;let u;switch(b){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const o=u.indexOf(s);o>=0&&u.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(r,b){const s=[];let u;for(;(u=r.read())!==null;)s.push(u);return b(s)}e.consumeReadable=D;function A(r,b,s){const u=[];let o;for(;(o=r.read())!==null&&u.length<s;)u.push(o);return o===null&&u.length>0?b(u):{read:()=>{if(u.length>0)return u.shift();if(typeof o<"u"){const l=o;return o=void 0,l}return r.read()}}}e.peekReadable=A;function k(r,b){return new Promise((s,u)=>{const o=[];E(r,{onData:l=>{b&&o.push(l)},onError:l=>{b?u(l):s(void 0)},onEnd:()=>{s(b?b(o):void 0)}})})}e.consumeStream=k;function E(r,b){let s=!1;return r.on("error",u=>{s||b.onError(u)}),r.on("end",()=>{s||b.onEnd()}),r.on("data",u=>{s||b.onData(u)}),(0,t.toDisposable)(()=>s=!0)}e.listenStream=E;function _(r,b){return new Promise((s,u)=>{const o=new t.DisposableStore,l=[],a=i=>{if(l.push(i),l.length>b)return o.dispose(),r.pause(),s({stream:r,buffer:l,ended:!1})},d=i=>u(i),n=()=>s({stream:r,buffer:l,ended:!0});o.add((0,t.toDisposable)(()=>r.removeListener("error",d))),r.on("error",d),o.add((0,t.toDisposable)(()=>r.removeListener("end",n))),r.on("end",n),o.add((0,t.toDisposable)(()=>r.removeListener("data",a))),r.on("data",a)})}e.peekStream=_;function w(r,b){const s=T(b);return s.end(r),s}e.toStream=w;function f(){const r=T(()=>{throw new Error("not supported")});return r.end(),r}e.emptyStream=f;function g(r){let b=!1;return{read:()=>b?null:(b=!0,r)}}e.toReadable=g;function h(r,b,s){const u=T(s);return E(r,{onData:o=>u.write(b.data(o)),onError:o=>u.error(b.error?b.error(o):o),onEnd:()=>u.end()}),u}e.transform=h;function v(r,b,s){let u=!1;return{read:()=>{const o=b.read();return u?o:(u=!0,o!==null?s([r,o]):r)}}}e.prefixedReadable=v;function m(r,b,s){let u=!1;const o=T(s);return E(b,{onData:l=>u?o.write(l):(u=!0,o.write(s([r,l]))),onError:l=>o.error(l),onEnd:()=>{u||(u=!0,o.write(r)),o.end()}}),o}e.prefixedStream=m}),define(_e[23],ye([1,0,100]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let I,P;class y{static alloc(i){return t?new y(Buffer.allocUnsafe(i)):new y(new Uint8Array(i))}static wrap(i){return t&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new y(i)}static fromString(i,p){return!(p?.dontUseNodeBuffer||!1)&&t?new y(Buffer.from(i)):(I||(I=new TextEncoder),new y(I.encode(i)))}static fromByteArray(i){const p=y.alloc(i.length);for(let C=0,R=i.length;C<R;C++)p.buffer[C]=i[C];return p}static concat(i,p){if(typeof p>"u"){p=0;for(let U=0,H=i.length;U<H;U++)p+=i[U].byteLength}const C=y.alloc(p);let R=0;for(let U=0,H=i.length;U<H;U++){const V=i[U];C.set(V,R),R+=V.byteLength}return C}constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}clone(){const i=y.alloc(this.byteLength);return i.set(this),i}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(i,p){return new y(this.buffer.subarray(i,p))}set(i,p){if(i instanceof y)this.buffer.set(i.buffer,p);else if(i instanceof Uint8Array)this.buffer.set(i,p);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),p);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(i){return D(this.buffer,i)}writeUInt32BE(i,p){A(this.buffer,i,p)}readUInt32LE(i){return k(this.buffer,i)}writeUInt32LE(i,p){E(this.buffer,i,p)}readUInt8(i){return _(this.buffer,i)}writeUInt8(i,p){w(this.buffer,i,p)}}e.VSBuffer=y;function T(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0}e.readUInt16LE=T;function S(n,i,p){n[p+0]=i&255,i=i>>>8,n[p+1]=i&255}e.writeUInt16LE=S;function D(n,i){return n[i]*2**24+n[i+1]*2**16+n[i+2]*2**8+n[i+3]}e.readUInt32BE=D;function A(n,i,p){n[p+3]=i,i=i>>>8,n[p+2]=i,i=i>>>8,n[p+1]=i,i=i>>>8,n[p]=i}e.writeUInt32BE=A;function k(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0|n[i+2]<<16>>>0|n[i+3]<<24>>>0}e.readUInt32LE=k;function E(n,i,p){n[p+0]=i&255,i=i>>>8,n[p+1]=i&255,i=i>>>8,n[p+2]=i&255,i=i>>>8,n[p+3]=i&255}e.writeUInt32LE=E;function _(n,i){return n[i]}e.readUInt8=_;function w(n,i,p){n[p]=i}e.writeUInt8=w;function f(n){return c.consumeReadable(n,i=>y.concat(i))}e.readableToBuffer=f;function g(n){return c.toReadable(n)}e.bufferToReadable=g;function h(n){return c.consumeStream(n,i=>y.concat(i))}e.streamToBuffer=h;async function v(n){return n.ended?y.concat(n.buffer):y.concat([...n.buffer,await h(n.stream)])}e.bufferedStreamToBuffer=v;function m(n){return c.toStream(n,i=>y.concat(i))}e.bufferToStream=m;function r(n){return c.transform(n,{data:i=>typeof i=="string"?y.fromString(i):y.wrap(i)},i=>y.concat(i))}e.streamToBufferReadableStream=r;function b(n){return c.newWriteableStream(i=>y.concat(i),n)}e.newWriteableBufferStream=b;function s(n,i){return c.prefixedReadable(n,i,p=>y.concat(p))}e.prefixedBufferReadable=s;function u(n,i){return c.prefixedStream(n,i,p=>y.concat(p))}e.prefixedBufferStream=u;function o(n){let i=0,p=0,C=0;const R=new Uint8Array(Math.floor(n.length/4*3)),U=V=>{switch(p){case 3:R[C++]=i|V,p=0;break;case 2:R[C++]=i|V>>>2,i=V<<6,p=3;break;case 1:R[C++]=i|V>>>4,i=V<<4,p=2;break;default:i=V<<2,p=1}};for(let V=0;V<n.length;V++){const L=n.charCodeAt(V);if(L>=65&&L<=90)U(L-65);else if(L>=97&&L<=122)U(L-97+26);else if(L>=48&&L<=57)U(L-48+52);else if(L===43||L===45)U(62);else if(L===47||L===95)U(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${n[V]}`)}}const H=C;for(;p>0;)U(0);return y.wrap(R).slice(0,H)}e.decodeBase64=o;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:n},i=!0,p=!1){const C=p?a:l;let R="";const U=n.byteLength%3;let H=0;for(;H<n.byteLength-U;H+=3){const V=n[H+0],L=n[H+1],M=n[H+2];R+=C[V>>>2],R+=C[(V<<4|L>>>4)&63],R+=C[(L<<2|M>>>6)&63],R+=C[M&63]}if(U===1){const V=n[H+0];R+=C[V>>>2],R+=C[V<<4&63],i&&(R+="==")}else if(U===2){const V=n[H+0],L=n[H+1];R+=C[V>>>2],R+=C[(V<<4|L>>>4)&63],R+=C[L<<2&63],i&&(R+="=")}return R}e.encodeBase64=d}),define(_e[11],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function c(u){return typeof u=="string"}e.isString=c;function t(u){return Array.isArray(u)&&u.every(o=>c(o))}e.isStringArray=t;function I(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=I;function P(u){const o=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof o}e.isTypedArray=P;function y(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=y;function T(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=T;function S(u){return u===!0||u===!1}e.isBoolean=S;function D(u){return typeof u>"u"}e.isUndefined=D;function A(u){return!k(u)}e.isDefined=A;function k(u){return D(u)||u===null}e.isUndefinedOrNull=k;function E(u,o){if(!u)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}e.assertType=E;function _(u){if(k(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=_;function w(...u){const o=[];for(let l=0;l<u.length;l++){const a=u[l];if(k(a))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);o.push(a)}return o}e.assertAllDefined=w;const f=Object.prototype.hasOwnProperty;function g(u){if(!I(u))return!1;for(const o in u)if(f.call(u,o))return!1;return!0}e.isEmptyObject=g;function h(u){return typeof u=="function"}e.isFunction=h;function v(...u){return u.length>0&&u.every(h)}e.areFunctions=v;function m(u,o){const l=Math.min(u.length,o.length);for(let a=0;a<l;a++)r(u[a],o[a])}e.validateConstraints=m;function r(u,o){if(c(o)){if(typeof u!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(h(o)){try{if(u instanceof o)return}catch{}if(!k(u)&&u.constructor===o||o.length===1&&o.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r;function b(u){return u===null?void 0:u}e.withNullAsUndefined=b;function s(u){return typeof u>"u"?null:u}e.withUndefinedAsNull=s}),define(_e[24],ye([1,0,11]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const v=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([m,r])=>{v[m]=r&&typeof r=="object"?t(r):r}),v}e.deepClone=t;function I(h){if(!h||typeof h!="object")return h;const v=[h];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const r in m)if(P.call(m,r)){const b=m[r];typeof b=="object"&&!Object.isFrozen(b)&&!(0,c.isTypedArray)(b)&&v.push(b)}}return h}e.deepFreeze=I;const P=Object.prototype.hasOwnProperty;function y(h,v){return T(h,v,new Set)}e.cloneAndChange=y;function T(h,v,m){if((0,c.isUndefinedOrNull)(h))return h;const r=v(h);if(typeof r<"u")return r;if(Array.isArray(h)){const b=[];for(const s of h)b.push(T(s,v,m));return b}if((0,c.isObject)(h)){if(m.has(h))throw new Error("Cannot clone recursive data-structure");m.add(h);const b={};for(const s in h)P.call(h,s)&&(b[s]=T(h[s],v,m));return m.delete(h),b}return h}function S(h,v,m=!0){return(0,c.isObject)(h)?((0,c.isObject)(v)&&Object.keys(v).forEach(r=>{r in h?m&&((0,c.isObject)(h[r])&&(0,c.isObject)(v[r])?S(h[r],v[r],m):h[r]=v[r]):h[r]=v[r]}),h):v}e.mixin=S;function D(h,v){if(h===v)return!0;if(h==null||v===null||v===void 0||typeof h!=typeof v||typeof h!="object"||Array.isArray(h)!==Array.isArray(v))return!1;let m,r;if(Array.isArray(h)){if(h.length!==v.length)return!1;for(m=0;m<h.length;m++)if(!D(h[m],v[m]))return!1}else{const b=[];for(r in h)b.push(r);b.sort();const s=[];for(r in v)s.push(r);if(s.sort(),!D(b,s))return!1;for(m=0;m<b.length;m++)if(!D(h[b[m]],v[b[m]]))return!1}return!0}e.equals=D;function A(h){const v=new Set;return JSON.stringify(h,(m,r)=>{if((0,c.isObject)(r)||Array.isArray(r)){if(v.has(r))return"[Circular]";v.add(r)}return r})}e.safeStringify=A;function k(h,v){const m=Object.create(null);return!h||!v||Object.keys(v).forEach(b=>{const s=h[b],u=v[b];D(s,u)||(m[b]=u)}),m}e.distinct=k;function E(h,v){const m=v.toLowerCase(),r=Object.keys(h).find(b=>b.toLowerCase()===m);return r?h[r]:h[v]}e.getCaseInsensitive=E;function _(h,v){const m=Object.create(null);for(const[r,b]of Object.entries(h))v(r,b)&&(m[r]=b);return m}e.filter=_;function w(h){let v=[],m=Object.getPrototypeOf(h);for(;Object.prototype!==m;)v=v.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return v}e.getAllPropertyNames=w;function f(h){const v=[];for(const m of w(h))typeof h[m]=="function"&&v.push(m);return v}e.getAllMethodNames=f;function g(h,v){const m=b=>function(){const s=Array.prototype.slice.call(arguments,0);return v(b,s)},r={};for(const b of h)r[b]=m(b);return r}e.createProxyObject=g}),define(_e[101],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var c;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c=e.Constants||(e.Constants={}));function t(P){return P<0?0:P>255?255:P|0}e.toUint8=t;function I(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=I}),define(_e[31],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(I){return c.test(I)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(T){for(let S=0;S<T.length;S++)T[S]=Math.floor(Math.random()*256);return T};const P=new Uint8Array(16),y=[];for(let T=0;T<256;T++)y.push(T.toString(16).padStart(2,"0"));return function(){I(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let S=0,D="";return D+=y[P[S++]],D+=y[P[S++]],D+=y[P[S++]],D+=y[P[S++]],D+="-",D+=y[P[S++]],D+=y[P[S++]],D+="-",D+=y[P[S++]],D+=y[P[S++]],D+="-",D+=y[P[S++]],D+=y[P[S++]],D+="-",D+=y[P[S++]],D+=y[P[S++]],D+=y[P[S++]],D+=y[P[S++]],D+=y[P[S++]],D+=y[P[S++]],D}}()}),define(_e[102],ye([1,0,101]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(T){const S=(0,c.toUint8)(T);this._defaultValue=S,this._asciiMap=t._createAsciiMap(S),this._map=new Map}static _createAsciiMap(T){const S=new Uint8Array(256);return S.fill(T),S}set(T,S){const D=(0,c.toUint8)(S);T>=0&&T<256?this._asciiMap[T]=D:this._map.set(T,D)}get(T){return T>=0&&T<256?this._asciiMap[T]:this._map.get(T)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=t;var I;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(I||(I={}));class P{constructor(){this._actual=new t(0)}add(T){this._actual.set(T,1)}has(T){return this._actual.get(T)===1}clear(){return this._actual.clear()}}e.CharacterSet=P}),define(_e[49],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(I,P){this.lineNumber=I,this.column=P}with(I=this.lineNumber,P=this.column){return I===this.lineNumber&&P===this.column?this:new c(I,P)}delta(I=0,P=0){return this.with(this.lineNumber+I,this.column+P)}equals(I){return c.equals(this,I)}static equals(I,P){return!I&&!P?!0:!!I&&!!P&&I.lineNumber===P.lineNumber&&I.column===P.column}isBefore(I){return c.isBefore(this,I)}static isBefore(I,P){return I.lineNumber<P.lineNumber?!0:P.lineNumber<I.lineNumber?!1:I.column<P.column}isBeforeOrEqual(I){return c.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,P){return I.lineNumber<P.lineNumber?!0:P.lineNumber<I.lineNumber?!1:I.column<=P.column}static compare(I,P){const y=I.lineNumber|0,T=P.lineNumber|0;if(y===T){const S=I.column|0,D=P.column|0;return S-D}return y-T}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new c(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=c}),define(_e[35],ye([1,0,49]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,y,T,S){P>T||P===T&&y>S?(this.startLineNumber=T,this.startColumn=S,this.endLineNumber=P,this.endColumn=y):(this.startLineNumber=P,this.startColumn=y,this.endLineNumber=T,this.endColumn=S)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<P.startColumn||y.lineNumber===P.endLineNumber&&y.column>P.endColumn)}static strictContainsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<=P.startColumn||y.lineNumber===P.endLineNumber&&y.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<=P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,y){let T,S,D,A;return y.startLineNumber<P.startLineNumber?(T=y.startLineNumber,S=y.startColumn):y.startLineNumber===P.startLineNumber?(T=y.startLineNumber,S=Math.min(y.startColumn,P.startColumn)):(T=P.startLineNumber,S=P.startColumn),y.endLineNumber>P.endLineNumber?(D=y.endLineNumber,A=y.endColumn):y.endLineNumber===P.endLineNumber?(D=y.endLineNumber,A=Math.max(y.endColumn,P.endColumn)):(D=P.endLineNumber,A=P.endColumn),new t(T,S,D,A)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,y){let T=P.startLineNumber,S=P.startColumn,D=P.endLineNumber,A=P.endColumn;const k=y.startLineNumber,E=y.startColumn,_=y.endLineNumber,w=y.endColumn;return T<k?(T=k,S=E):T===k&&(S=Math.max(S,E)),D>_?(D=_,A=w):D===_&&(A=Math.min(A,w)),T>D||T===D&&S>A?null:new t(T,S,D,A)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,y){return!P&&!y?!0:!!P&&!!y&&P.startLineNumber===y.startLineNumber&&P.startColumn===y.startColumn&&P.endLineNumber===y.endLineNumber&&P.endColumn===y.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new c.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new c.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,y){return new t(this.startLineNumber,this.startColumn,P,y)}setStartPosition(P,y){return new t(P,y,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(P){return new t(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,y=P){return new t(P.lineNumber,P.column,y.lineNumber,y.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<P.startColumn)}static areIntersecting(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<=y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,y){if(P&&y){const D=P.startLineNumber|0,A=y.startLineNumber|0;if(D===A){const k=P.startColumn|0,E=y.startColumn|0;if(k===E){const _=P.endLineNumber|0,w=y.endLineNumber|0;if(_===w){const f=P.endColumn|0,g=y.endColumn|0;return f-g}return _-w}return k-E}return D-A}return(P?1:0)-(y?1:0)}static compareRangesUsingEnds(P,y){return P.endLineNumber===y.endLineNumber?P.endColumn===y.endColumn?P.startLineNumber===y.startLineNumber?P.startColumn-y.startColumn:P.startLineNumber-y.startLineNumber:P.endColumn-y.endColumn:P.endLineNumber-y.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(_e[146],ye([1,0,49,35]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class P extends t.Range{constructor(T,S,D,A){super(T,S,D,A),this.selectionStartLineNumber=T,this.selectionStartColumn=S,this.positionLineNumber=D,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return P.selectionsEqual(this,T)}static selectionsEqual(T,S){return T.selectionStartLineNumber===S.selectionStartLineNumber&&T.selectionStartColumn===S.selectionStartColumn&&T.positionLineNumber===S.positionLineNumber&&T.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(T,S){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,T,S):new P(T,S,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,S){return this.getDirection()===0?new P(T,S,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,T,S)}static fromPositions(T,S=T){return new P(T.lineNumber,T.column,S.lineNumber,S.column)}static fromRange(T,S){return S===0?new P(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new P(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new P(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,S){if(T&&!S||!T&&S)return!1;if(!T&&!S)return!0;if(T.length!==S.length)return!1;for(let D=0,A=T.length;D<A;D++)if(!this.selectionsEqual(T[D],S[D]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,S,D,A,k){return k===0?new P(T,S,D,A):new P(D,A,T,S)}}e.Selection=P}),define(_e[147],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(_e[148],ye([1,0,102]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends c.CharacterClassifier{constructor(T){super(0);for(let S=0,D=T.length;S<D;S++)this.set(T.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function P(y){const T={};return S=>(T.hasOwnProperty(S)||(T[S]=y(S)),T[S])}e.getMapForWordSeparators=P(y=>new I(y))}),define(_e[103],ye([1,0,62,6,63]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(k=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const _ of e.USUAL_WORD_SEPARATORS)k.indexOf(_)>=0||(E+="\\"+_);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=P();function y(k){let E=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)E=k;else{let _="g";k.ignoreCase&&(_+="i"),k.multiline&&(_+="m"),k.unicode&&(_+="u"),E=new RegExp(k.source,_)}return E.lastIndex=0,E}e.ensureValidWordDefinition=y;const T=new I.LinkedList;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(k){const E=T.unshift(k);return(0,t.toDisposable)(E)}e.setDefaultGetWordAtTextConfig=S;function D(k,E,_,w,f){if(f||(f=c.Iterable.first(T)),_.length>f.maxLen){let r=k-f.maxLen/2;return r<0?r=0:w+=r,_=_.substring(r,k+f.maxLen/2),D(k,E,_,w,f)}const g=Date.now(),h=k-1-w;let v=-1,m=null;for(let r=1;!(Date.now()-g>=f.timeBudget);r++){const b=h-f.windowSize*r;E.lastIndex=Math.max(0,b);const s=A(E,_,h,v);if(!s&&m||(m=s,b<=0))break;v=b}if(m){const r={word:m[0],startColumn:w+1+m.index,endColumn:w+1+m.index+m[0].length};return E.lastIndex=0,r}return null}e.getWordAtText=D;function A(k,E,_,w){let f;for(;f=k.exec(E);){const g=f.index||0;if(g<=_&&k.lastIndex>=_)return f;if(w>0&&g>w)return null}return null}}),define(_e[149],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class t{constructor(T){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=T.open,this.close=T.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(T.notIn))for(let S=0,D=T.notIn.length;S<D;S++)switch(T.notIn[S]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(T,S){if(T.getTokenCount()===0)return!0;const D=T.findTokenIndexAtOffset(S-2),A=T.getStandardTokenType(D);return this.isOK(A)}_findNeutralCharacterInRange(T,S){for(let D=T;D<=S;D++){const A=String.fromCharCode(D);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class I{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of T)P(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),P(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),P(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),P(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&P(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=I;function P(y,T,S){y.has(T)?y.get(T).push(S):y.set(T,[S])}}),define(_e[150],ye([1,0,102]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var t;(function(_){_[_.Invalid=0]="Invalid",_[_.Start=1]="Start",_[_.H=2]="H",_[_.HT=3]="HT",_[_.HTT=4]="HTT",_[_.HTTP=5]="HTTP",_[_.F=6]="F",_[_.FI=7]="FI",_[_.FIL=8]="FIL",_[_.BeforeColon=9]="BeforeColon",_[_.AfterColon=10]="AfterColon",_[_.AlmostThere=11]="AlmostThere",_[_.End=12]="End",_[_.Accept=13]="Accept",_[_.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(w,f,g){const h=new Uint8Array(w*f);for(let v=0,m=w*f;v<m;v++)h[v]=g;this._data=h,this.rows=w,this.cols=f}get(w,f){return this._data[w*this.cols+f]}set(w,f,g){this._data[w*this.cols+f]=g}}class P{constructor(w){let f=0,g=0;for(let v=0,m=w.length;v<m;v++){const[r,b,s]=w[v];b>f&&(f=b),r>g&&(g=r),s>g&&(g=s)}f++,g++;const h=new I(g,f,0);for(let v=0,m=w.length;v<m;v++){const[r,b,s]=w[v];h.set(r,b,s)}this._states=h,this._maxCharCode=f}nextState(w,f){return f<0||f>=this._maxCharCode?0:this._states.get(w,f)}}e.StateMachine=P;let y=null;function T(){return y===null&&(y=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var S;(function(_){_[_.None=0]="None",_[_.ForceTermination=1]="ForceTermination",_[_.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let D=null;function A(){if(D===null){D=new c.CharacterClassifier(0);const _=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<_.length;f++)D.set(_.charCodeAt(f),1);const w=".,;:";for(let f=0;f<w.length;f++)D.set(w.charCodeAt(f),2)}return D}class k{static _createLink(w,f,g,h,v){let m=v-1;do{const r=f.charCodeAt(m);if(w.get(r)!==2)break;m--}while(m>h);if(h>0){const r=f.charCodeAt(h-1),b=f.charCodeAt(m);(r===40&&b===41||r===91&&b===93||r===123&&b===125)&&m--}return{range:{startLineNumber:g,startColumn:h+1,endLineNumber:g,endColumn:m+2},url:f.substring(h,m+1)}}static computeLinks(w,f=T()){const g=A(),h=[];for(let v=1,m=w.getLineCount();v<=m;v++){const r=w.getLineContent(v),b=r.length;let s=0,u=0,o=0,l=1,a=!1,d=!1,n=!1,i=!1;for(;s<b;){let p=!1;const C=r.charCodeAt(s);if(l===13){let R;switch(C){case 40:a=!0,R=0;break;case 41:R=a?0:1;break;case 91:n=!0,d=!0,R=0;break;case 93:n=!1,R=d?0:1;break;case 123:i=!0,R=0;break;case 125:R=i?0:1;break;case 39:case 34:case 96:o===C?R=1:o===39||o===34||o===96?R=0:R=1;break;case 42:R=o===42?1:0;break;case 124:R=o===124?1:0;break;case 32:R=n?0:1;break;default:R=g.get(C)}R===1&&(h.push(k._createLink(g,r,v,u,s)),p=!0)}else if(l===12){let R;C===91?(d=!0,R=0):R=g.get(C),R===1?p=!0:l=13}else l=f.nextState(l,C),l===0&&(p=!0);p&&(l=1,a=!1,d=!1,i=!1,u=s+1,o=C),s++}l===13&&h.push(k._createLink(g,r,v,u,b))}return h}}e.LinkComputer=k;function E(_){return!_||typeof _.getLineCount!="function"||typeof _.getLineContent!="function"?[]:k.computeLinks(_)}e.computeLinks=E}),define(_e[104],ye([1,0,24]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var y;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(y=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(r){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace),this.bracketPairColorizationOptions=r.bracketPairColorizationOptions}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,r.bracketPairColorizationOptions)}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class A{constructor(r,b){this._findMatchBrand=void 0,this.range=r,this.matches=b}}e.FindMatch=A;var k;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function E(m){return m&&typeof m.read=="function"}e.isITextSnapshot=E;var _;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(_=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class f{constructor(r,b,s,u,o,l){this.identifier=r,this.range=b,this.text=s,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=o,this._isTracked=l}}e.ValidAnnotatedEditOperation=f;class g{constructor(r,b,s){this.regex=r,this.wordSeparators=b,this.simpleSearch=s}}e.SearchData=g;class h{constructor(r,b,s){this.reverseEdits=r,this.changes=b,this.trimAutoWhitespaceLineNumbers=s}}e.ApplyEditsResult=h;function v(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}e.shouldSynchronizeModel=v}),define(_e[151],ye([1,0,17,101]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,D){S=(0,t.toUint32)(S);const A=this.values,k=this.prefixSum,E=D.length;return E===0?!1:(this.values=new Uint32Array(A.length+E),this.values.set(A.subarray(0,S),0),this.values.set(A.subarray(S),S+E),this.values.set(D,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,D){return S=(0,t.toUint32)(S),D=(0,t.toUint32)(D),this.values[S]===D?!1:(this.values[S]=D,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,D){S=(0,t.toUint32)(S),D=(0,t.toUint32)(D);const A=this.values,k=this.prefixSum;if(S>=A.length)return!1;const E=A.length-S;return D>=E&&(D=E),D===0?!1:(this.values=new Uint32Array(A.length-D),this.values.set(A.subarray(0,S),0),this.values.set(A.subarray(S+D),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,t.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),S>=this.values.length&&(S=this.values.length-1);for(let A=D;A<=S;A++)this.prefixSum[A]=this.prefixSum[A-1]+this.values[A];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let D=0,A=this.values.length-1,k=0,E=0,_=0;for(;D<=A;)if(k=D+(A-D)/2|0,E=this.prefixSum[k],_=E-this.values[k],S<_)A=k-1;else if(S>=E)D=k+1;else break;return new y(k,S-_)}}e.PrefixSumComputer=I;class P{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const D=this._indexBySum[S],A=D>0?this._prefixSum[D-1]:0;return new y(D,S-A)}removeValues(S,D){this._values.splice(S,D),this._invalidate(S)}insertValues(S,D){this._values=(0,c.arrayInsert)(this._values,S,D),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,D=this._values.length;S<D;S++){const A=this._values[S],k=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=k+A;for(let E=0;E<A;E++)this._indexBySum[k+E]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,D){this._values[S]!==D&&(this._values[S]=D,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=P;class y{constructor(S,D){this.index=S,this.remainder=D,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=D}}e.PrefixSumIndexOfResult=y}),define(_e[152],ye([19,20]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(_e[153],ye([1,0,152]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,P=I*24,y=P*7,T=P*30,S=P*365;function D(k,E,_){typeof k!="number"&&(k=k.getTime());const w=Math.round((new Date().getTime()-k)/1e3);if(w<-30)return(0,c.localize)(0,null,D(new Date().getTime()+w*1e3,!1));if(w<30)return(0,c.localize)(1,null);let f;return w<t?(f=w,E?f===1?_?(0,c.localize)(2,null,f):(0,c.localize)(3,null,f):_?(0,c.localize)(4,null,f):(0,c.localize)(5,null,f):f===1?_?(0,c.localize)(6,null,f):(0,c.localize)(7,null,f):_?(0,c.localize)(8,null,f):(0,c.localize)(9,null,f)):w<I?(f=Math.floor(w/t),E?f===1?_?(0,c.localize)(10,null,f):(0,c.localize)(11,null,f):_?(0,c.localize)(12,null,f):(0,c.localize)(13,null,f):f===1?_?(0,c.localize)(14,null,f):(0,c.localize)(15,null,f):_?(0,c.localize)(16,null,f):(0,c.localize)(17,null,f)):w<P?(f=Math.floor(w/I),E?f===1?_?(0,c.localize)(18,null,f):(0,c.localize)(19,null,f):_?(0,c.localize)(20,null,f):(0,c.localize)(21,null,f):f===1?_?(0,c.localize)(22,null,f):(0,c.localize)(23,null,f):_?(0,c.localize)(24,null,f):(0,c.localize)(25,null,f)):w<y?(f=Math.floor(w/P),E?f===1?(0,c.localize)(26,null,f):(0,c.localize)(27,null,f):f===1?(0,c.localize)(28,null,f):(0,c.localize)(29,null,f)):w<T?(f=Math.floor(w/y),E?f===1?_?(0,c.localize)(30,null,f):(0,c.localize)(31,null,f):_?(0,c.localize)(32,null,f):(0,c.localize)(33,null,f):f===1?_?(0,c.localize)(34,null,f):(0,c.localize)(35,null,f):_?(0,c.localize)(36,null,f):(0,c.localize)(37,null,f)):w<S?(f=Math.floor(w/T),E?f===1?_?(0,c.localize)(38,null,f):(0,c.localize)(39,null,f):_?(0,c.localize)(40,null,f):(0,c.localize)(41,null,f):f===1?_?(0,c.localize)(42,null,f):(0,c.localize)(43,null,f):_?(0,c.localize)(44,null,f):(0,c.localize)(45,null,f)):(f=Math.floor(w/S),E?f===1?_?(0,c.localize)(46,null,f):(0,c.localize)(47,null,f):_?(0,c.localize)(48,null,f):(0,c.localize)(49,null,f):f===1?_?(0,c.localize)(50,null,f):(0,c.localize)(51,null,f):_?(0,c.localize)(52,null,f):(0,c.localize)(53,null,f))}e.fromNow=D;function A(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=A}),define(_e[154],ye([19,20]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(_e[50],ye([1,0,17,11,154]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(k,E){return E&&(k.stack||k.stacktrace)?I.localize(0,null,T(k),y(k.stack)||y(k.stacktrace)):T(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function T(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?I.localize(1,null,k.message):k.message||I.localize(2,null)}function S(k=null,E=!1){if(!k)return I.localize(3,null);if(Array.isArray(k)){const _=c.coalesce(k),w=S(_[0],E);return _.length>1?I.localize(4,null,w,_.length):w}if(t.isString(k))return k;if(k.detail){const _=k.detail;if(_.error)return P(_.error,E);if(_.exception)return P(_.exception,E)}return k.stack?P(k,E):k.message?k.message:I.localize(5,null)}e.toErrorMessage=S;function D(k){const E=k;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=D;function A(k,E){let _;return typeof k=="string"?_=new Error(k):_=k,_.actions=E,_}e.createErrorWithActions=A}),define(_e[155],ye([19,20]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(_e[12],ye([1,0,155]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,I=!1,P=!1,y=!1,T=!1,S=!1,D=!1,A=!1,k=!1,E=!1,_,w=e.LANGUAGE_DEFAULT,f,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const v=typeof h?.versions?.electron=="string",m=v&&h?.type==="renderer";if(typeof navigator=="object"&&!m)g=navigator.userAgent,t=g.indexOf("Windows")>=0,I=g.indexOf("Macintosh")>=0,A=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=g.indexOf("Linux")>=0,E=g?.indexOf("Mobi")>=0,S=!0,_=c.getConfiguredDefaultLocale(c.localize(0,null))||e.LANGUAGE_DEFAULT,w=_;else if(typeof h=="object"){t=h.platform==="win32",I=h.platform==="darwin",P=h.platform==="linux",y=P&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,D=v,k=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,_=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT;const n=h.env.VSCODE_NLS_CONFIG;if(n)try{const i=JSON.parse(n),p=i.availableLanguages["*"];_=i.locale,w=p||e.LANGUAGE_DEFAULT,f=i._translationsConfigFile}catch{}T=!0}else console.error("Unable to resolve platform.");var r;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(r=e.Platform||(e.Platform={}));function b(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let s=0;I?s=1:t?s=3:P&&(s=2),e.isWindows=t,e.isMacintosh=I,e.isLinux=P,e.isLinuxSnap=y,e.isNative=T,e.isElectron=D,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=A,e.isMobile=E,e.isCI=k,e.platform=s,e.userAgent=g,e.language=w;var u;(function(n){function i(){return e.language}n.value=i;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=p;function C(){return e.language==="en"}n.isDefault=C})(u=e.Language||(e.Language={})),e.locale=_,e.translationsConfigFile=f,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let C=0,R=n.length;C<R;C++){const U=n[C];if(U.id===p.data.vscodeScheduleAsyncWork){n.splice(C,1),U.callback();return}}});let i=0;return p=>{const C=++i;n.push({id:C,callback:p}),e.globals.postMessage({vscodeScheduleAsyncWork:C},"*")}}return n=>setTimeout(n)})();var o;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||A?2:t?1:3;let l=!0,a=!1;function d(){if(!a){a=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,l=new Uint16Array(n.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=d,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(_e[36],ye([1,0,12]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.process<"u"){const I=c.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(_e[9],ye([1,0,36]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,P=90,y=122,T=46,S=47,D=92,A=58,k=63;class E extends Error{constructor(r,b,s){let u;typeof b=="string"&&b.indexOf("not ")===0?(u="must not be",b=b.replace(/^not /,"")):u="must be";const o=r.indexOf(".")!==-1?"property":"argument";let l=`The "${r}" ${o} ${u} of type ${b}`;l+=`. Received type ${typeof s}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function _(m,r){if(typeof m!="string")throw new E(r,"string",m)}function w(m){return m===S||m===D}function f(m){return m===S}function g(m){return m>=t&&m<=P||m>=I&&m<=y}function h(m,r,b,s){let u="",o=0,l=-1,a=0,d=0;for(let n=0;n<=m.length;++n){if(n<m.length)d=m.charCodeAt(n);else{if(s(d))break;d=S}if(s(d)){if(!(l===n-1||a===1))if(a===2){if(u.length<2||o!==2||u.charCodeAt(u.length-1)!==T||u.charCodeAt(u.length-2)!==T){if(u.length>2){const i=u.lastIndexOf(b);i===-1?(u="",o=0):(u=u.slice(0,i),o=u.length-1-u.lastIndexOf(b)),l=n,a=0;continue}else if(u.length!==0){u="",o=0,l=n,a=0;continue}}r&&(u+=u.length>0?`${b}..`:"..",o=2)}else u.length>0?u+=`${b}${m.slice(l+1,n)}`:u=m.slice(l+1,n),o=n-l-1;l=n,a=0}else d===T&&a!==-1?++a:a=-1}return u}function v(m,r){if(r===null||typeof r!="object")throw new E("pathObject","Object",r);const b=r.dir||r.root,s=r.base||`${r.name||""}${r.ext||""}`;return b?b===r.root?`${b}${s}`:`${b}${m}${s}`:s}e.win32={resolve(...m){let r="",b="",s=!1;for(let u=m.length-1;u>=-1;u--){let o;if(u>=0){if(o=m[u],_(o,"path"),o.length===0)continue}else r.length===0?o=c.cwd():(o=c.env[`=${r}`]||c.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===D)&&(o=`${r}\\`));const l=o.length;let a=0,d="",n=!1;const i=o.charCodeAt(0);if(l===1)w(i)&&(a=1,n=!0);else if(w(i))if(n=!0,w(o.charCodeAt(1))){let p=2,C=p;for(;p<l&&!w(o.charCodeAt(p));)p++;if(p<l&&p!==C){const R=o.slice(C,p);for(C=p;p<l&&w(o.charCodeAt(p));)p++;if(p<l&&p!==C){for(C=p;p<l&&!w(o.charCodeAt(p));)p++;(p===l||p!==C)&&(d=`\\\\${R}\\${o.slice(C,p)}`,a=p)}}}else a=1;else g(i)&&o.charCodeAt(1)===A&&(d=o.slice(0,2),a=2,l>2&&w(o.charCodeAt(2))&&(n=!0,a=3));if(d.length>0)if(r.length>0){if(d.toLowerCase()!==r.toLowerCase())continue}else r=d;if(s){if(r.length>0)break}else if(b=`${o.slice(a)}\\${b}`,s=n,n&&r.length>0)break}return b=h(b,!s,"\\",w),s?`${r}\\${b}`:`${r}${b}`||"."},normalize(m){_(m,"path");const r=m.length;if(r===0)return".";let b=0,s,u=!1;const o=m.charCodeAt(0);if(r===1)return f(o)?"\\":m;if(w(o))if(u=!0,w(m.charCodeAt(1))){let a=2,d=a;for(;a<r&&!w(m.charCodeAt(a));)a++;if(a<r&&a!==d){const n=m.slice(d,a);for(d=a;a<r&&w(m.charCodeAt(a));)a++;if(a<r&&a!==d){for(d=a;a<r&&!w(m.charCodeAt(a));)a++;if(a===r)return`\\\\${n}\\${m.slice(d)}\\`;a!==d&&(s=`\\\\${n}\\${m.slice(d,a)}`,b=a)}}}else b=1;else g(o)&&m.charCodeAt(1)===A&&(s=m.slice(0,2),b=2,r>2&&w(m.charCodeAt(2))&&(u=!0,b=3));let l=b<r?h(m.slice(b),!u,"\\",w):"";return l.length===0&&!u&&(l="."),l.length>0&&w(m.charCodeAt(r-1))&&(l+="\\"),s===void 0?u?`\\${l}`:l:u?`${s}\\${l}`:`${s}${l}`},isAbsolute(m){_(m,"path");const r=m.length;if(r===0)return!1;const b=m.charCodeAt(0);return w(b)||r>2&&g(b)&&m.charCodeAt(1)===A&&w(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let r,b;for(let o=0;o<m.length;++o){const l=m[o];_(l,"path"),l.length>0&&(r===void 0?r=b=l:r+=`\\${l}`)}if(r===void 0)return".";let s=!0,u=0;if(typeof b=="string"&&w(b.charCodeAt(0))){++u;const o=b.length;o>1&&w(b.charCodeAt(1))&&(++u,o>2&&(w(b.charCodeAt(2))?++u:s=!1))}if(s){for(;u<r.length&&w(r.charCodeAt(u));)u++;u>=2&&(r=`\\${r.slice(u)}`)}return e.win32.normalize(r)},relative(m,r){if(_(m,"from"),_(r,"to"),m===r)return"";const b=e.win32.resolve(m),s=e.win32.resolve(r);if(b===s||(m=b.toLowerCase(),r=s.toLowerCase(),m===r))return"";let u=0;for(;u<m.length&&m.charCodeAt(u)===D;)u++;let o=m.length;for(;o-1>u&&m.charCodeAt(o-1)===D;)o--;const l=o-u;let a=0;for(;a<r.length&&r.charCodeAt(a)===D;)a++;let d=r.length;for(;d-1>a&&r.charCodeAt(d-1)===D;)d--;const n=d-a,i=l<n?l:n;let p=-1,C=0;for(;C<i;C++){const U=m.charCodeAt(u+C);if(U!==r.charCodeAt(a+C))break;U===D&&(p=C)}if(C!==i){if(p===-1)return s}else{if(n>i){if(r.charCodeAt(a+C)===D)return s.slice(a+C+1);if(C===2)return s.slice(a+C)}l>i&&(m.charCodeAt(u+C)===D?p=C:C===2&&(p=3)),p===-1&&(p=0)}let R="";for(C=u+p+1;C<=o;++C)(C===o||m.charCodeAt(C)===D)&&(R+=R.length===0?"..":"\\..");return a+=p,R.length>0?`${R}${s.slice(a,d)}`:(s.charCodeAt(a)===D&&++a,s.slice(a,d))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const r=e.win32.resolve(m);if(r.length<=2)return m;if(r.charCodeAt(0)===D){if(r.charCodeAt(1)===D){const b=r.charCodeAt(2);if(b!==k&&b!==T)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(g(r.charCodeAt(0))&&r.charCodeAt(1)===A&&r.charCodeAt(2)===D)return`\\\\?\\${r}`;return m},dirname(m){_(m,"path");const r=m.length;if(r===0)return".";let b=-1,s=0;const u=m.charCodeAt(0);if(r===1)return w(u)?m:".";if(w(u)){if(b=s=1,w(m.charCodeAt(1))){let a=2,d=a;for(;a<r&&!w(m.charCodeAt(a));)a++;if(a<r&&a!==d){for(d=a;a<r&&w(m.charCodeAt(a));)a++;if(a<r&&a!==d){for(d=a;a<r&&!w(m.charCodeAt(a));)a++;if(a===r)return m;a!==d&&(b=s=a+1)}}}}else g(u)&&m.charCodeAt(1)===A&&(b=r>2&&w(m.charCodeAt(2))?3:2,s=b);let o=-1,l=!0;for(let a=r-1;a>=s;--a)if(w(m.charCodeAt(a))){if(!l){o=a;break}}else l=!1;if(o===-1){if(b===-1)return".";o=b}return m.slice(0,o)},basename(m,r){r!==void 0&&_(r,"ext"),_(m,"path");let b=0,s=-1,u=!0,o;if(m.length>=2&&g(m.charCodeAt(0))&&m.charCodeAt(1)===A&&(b=2),r!==void 0&&r.length>0&&r.length<=m.length){if(r===m)return"";let l=r.length-1,a=-1;for(o=m.length-1;o>=b;--o){const d=m.charCodeAt(o);if(w(d)){if(!u){b=o+1;break}}else a===-1&&(u=!1,a=o+1),l>=0&&(d===r.charCodeAt(l)?--l===-1&&(s=o):(l=-1,s=a))}return b===s?s=a:s===-1&&(s=m.length),m.slice(b,s)}for(o=m.length-1;o>=b;--o)if(w(m.charCodeAt(o))){if(!u){b=o+1;break}}else s===-1&&(u=!1,s=o+1);return s===-1?"":m.slice(b,s)},extname(m){_(m,"path");let r=0,b=-1,s=0,u=-1,o=!0,l=0;m.length>=2&&m.charCodeAt(1)===A&&g(m.charCodeAt(0))&&(r=s=2);for(let a=m.length-1;a>=r;--a){const d=m.charCodeAt(a);if(w(d)){if(!o){s=a+1;break}continue}u===-1&&(o=!1,u=a+1),d===T?b===-1?b=a:l!==1&&(l=1):b!==-1&&(l=-1)}return b===-1||u===-1||l===0||l===1&&b===u-1&&b===s+1?"":m.slice(b,u)},format:v.bind(null,"\\"),parse(m){_(m,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return r;const b=m.length;let s=0,u=m.charCodeAt(0);if(b===1)return w(u)?(r.root=r.dir=m,r):(r.base=r.name=m,r);if(w(u)){if(s=1,w(m.charCodeAt(1))){let p=2,C=p;for(;p<b&&!w(m.charCodeAt(p));)p++;if(p<b&&p!==C){for(C=p;p<b&&w(m.charCodeAt(p));)p++;if(p<b&&p!==C){for(C=p;p<b&&!w(m.charCodeAt(p));)p++;p===b?s=p:p!==C&&(s=p+1)}}}}else if(g(u)&&m.charCodeAt(1)===A){if(b<=2)return r.root=r.dir=m,r;if(s=2,w(m.charCodeAt(2))){if(b===3)return r.root=r.dir=m,r;s=3}}s>0&&(r.root=m.slice(0,s));let o=-1,l=s,a=-1,d=!0,n=m.length-1,i=0;for(;n>=s;--n){if(u=m.charCodeAt(n),w(u)){if(!d){l=n+1;break}continue}a===-1&&(d=!1,a=n+1),u===T?o===-1?o=n:i!==1&&(i=1):o!==-1&&(i=-1)}return a!==-1&&(o===-1||i===0||i===1&&o===a-1&&o===l+1?r.base=r.name=m.slice(l,a):(r.name=m.slice(l,o),r.base=m.slice(l,a),r.ext=m.slice(o,a))),l>0&&l!==s?r.dir=m.slice(0,l-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let r="",b=!1;for(let s=m.length-1;s>=-1&&!b;s--){const u=s>=0?m[s]:c.cwd();_(u,"path"),u.length!==0&&(r=`${u}/${r}`,b=u.charCodeAt(0)===S)}return r=h(r,!b,"/",f),b?`/${r}`:r.length>0?r:"."},normalize(m){if(_(m,"path"),m.length===0)return".";const r=m.charCodeAt(0)===S,b=m.charCodeAt(m.length-1)===S;return m=h(m,!r,"/",f),m.length===0?r?"/":b?"./":".":(b&&(m+="/"),r?`/${m}`:m)},isAbsolute(m){return _(m,"path"),m.length>0&&m.charCodeAt(0)===S},join(...m){if(m.length===0)return".";let r;for(let b=0;b<m.length;++b){const s=m[b];_(s,"path"),s.length>0&&(r===void 0?r=s:r+=`/${s}`)}return r===void 0?".":e.posix.normalize(r)},relative(m,r){if(_(m,"from"),_(r,"to"),m===r||(m=e.posix.resolve(m),r=e.posix.resolve(r),m===r))return"";const b=1,s=m.length,u=s-b,o=1,l=r.length-o,a=u<l?u:l;let d=-1,n=0;for(;n<a;n++){const p=m.charCodeAt(b+n);if(p!==r.charCodeAt(o+n))break;p===S&&(d=n)}if(n===a)if(l>a){if(r.charCodeAt(o+n)===S)return r.slice(o+n+1);if(n===0)return r.slice(o+n)}else u>a&&(m.charCodeAt(b+n)===S?d=n:n===0&&(d=0));let i="";for(n=b+d+1;n<=s;++n)(n===s||m.charCodeAt(n)===S)&&(i+=i.length===0?"..":"/..");return`${i}${r.slice(o+d)}`},toNamespacedPath(m){return m},dirname(m){if(_(m,"path"),m.length===0)return".";const r=m.charCodeAt(0)===S;let b=-1,s=!0;for(let u=m.length-1;u>=1;--u)if(m.charCodeAt(u)===S){if(!s){b=u;break}}else s=!1;return b===-1?r?"/":".":r&&b===1?"//":m.slice(0,b)},basename(m,r){r!==void 0&&_(r,"ext"),_(m,"path");let b=0,s=-1,u=!0,o;if(r!==void 0&&r.length>0&&r.length<=m.length){if(r===m)return"";let l=r.length-1,a=-1;for(o=m.length-1;o>=0;--o){const d=m.charCodeAt(o);if(d===S){if(!u){b=o+1;break}}else a===-1&&(u=!1,a=o+1),l>=0&&(d===r.charCodeAt(l)?--l===-1&&(s=o):(l=-1,s=a))}return b===s?s=a:s===-1&&(s=m.length),m.slice(b,s)}for(o=m.length-1;o>=0;--o)if(m.charCodeAt(o)===S){if(!u){b=o+1;break}}else s===-1&&(u=!1,s=o+1);return s===-1?"":m.slice(b,s)},extname(m){_(m,"path");let r=-1,b=0,s=-1,u=!0,o=0;for(let l=m.length-1;l>=0;--l){const a=m.charCodeAt(l);if(a===S){if(!u){b=l+1;break}continue}s===-1&&(u=!1,s=l+1),a===T?r===-1?r=l:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||s===-1||o===0||o===1&&r===s-1&&r===b+1?"":m.slice(r,s)},format:v.bind(null,"/"),parse(m){_(m,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return r;const b=m.charCodeAt(0)===S;let s;b?(r.root="/",s=1):s=0;let u=-1,o=0,l=-1,a=!0,d=m.length-1,n=0;for(;d>=s;--d){const i=m.charCodeAt(d);if(i===S){if(!a){o=d+1;break}continue}l===-1&&(a=!1,l=d+1),i===T?u===-1?u=d:n!==1&&(n=1):u!==-1&&(n=-1)}if(l!==-1){const i=o===0&&b?1:o;u===-1||n===0||n===1&&u===l-1&&u===o+1?r.base=r.name=m.slice(i,l):(r.name=m.slice(i,u),r.base=m.slice(i,l),r.ext=m.slice(u,l))}return o>0?r.dir=m.slice(0,o-1):b&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=c.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=c.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=c.platform==="win32"?e.win32.join:e.posix.join,e.resolve=c.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=c.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=c.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=c.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=c.platform==="win32"?e.win32.extname:e.posix.extname,e.format=c.platform==="win32"?e.win32.format:e.posix.format,e.parse=c.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=c.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=c.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=c.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(_e[105],ye([1,0,9]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(A){const k=(0,c.extname)(A),E=t[k.toLowerCase()];return E!==void 0?E:y(A)}e.getMediaOrTextMime=P;function y(A){const k=(0,c.extname)(A);return I[k.toLowerCase()]}e.getMediaMime=y;function T(A){for(const k in I)if(I[k]===A)return k}e.getExtensionForMimeType=T;const S=/^(.+)\/(.+?)(;.+)?$/;function D(A,k){const E=S.exec(A);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:k?void 0:A}e.normalizeMimeType=D}),define(_e[106],ye([1,0,12]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var I;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(T,...S){const D=S.reduce((E,_)=>(E[_]=!0,E),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(E=>!D[E]).forEach(E=>{for(let _=0;_<A.length;_++)if(E.search(A[_])!==-1){delete T[E];break}})}e.sanitizeProcessEnvironment=P;function y(T){!T||(delete T.DEBUG,c.isMacintosh&&delete T.DYLD_LIBRARY_PATH,c.isLinux&&delete T.LD_PRELOAD)}e.removeDangerousEnvVariables=y}),define(_e[51],ye([1,0,12]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=c.globals.performance&&typeof c.globals.performance.now=="function";class I{static create(y=!0){return new I(y)}constructor(y){this._highResolution=t&&y,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?c.globals.performance.now():Date.now()}}e.StopWatch=I}),define(_e[4],ye([1,0,10,61,6,63,51]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const T=!1,S=!1;var D;(function(d){d.None=()=>I.Disposable.None;function n(Ce){if(S){const{onDidAddListener:Re}=Ce,We=w.create();let ne=0;Ce.onDidAddListener=()=>{++ne===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),We.print()),Re?.()}}}function i(Ce,Re){return B(Ce,()=>{},0,void 0,void 0,Re)}d.defer=i;function p(Ce,Re=0,We){return d.debounce(Ce,(ne,ce)=>ne?(ne.push(ce),ne):[ce],Re,void 0,void 0,We)}d.accumulate=p;function C(Ce){return(Re,We=null,ne)=>{let ce=!1,fe;return fe=Ce(J=>{if(!ce)return fe?fe.dispose():ce=!0,Re.call(We,J)},null,ne),ce&&fe.dispose(),fe}}d.once=C;function R(Ce,Re,We){return F((ne,ce=null,fe)=>Ce(J=>ne.call(ce,Re(J)),null,fe),We)}d.map=R;function U(Ce,Re,We){return F((ne,ce=null,fe)=>Ce(J=>{Re(J),ne.call(ce,J)},null,fe),We)}d.forEach=U;function H(Ce,Re,We){return F((ne,ce=null,fe)=>Ce(J=>Re(J)&&ne.call(ce,J),null,fe),We)}d.filter=H;function V(Ce){return Ce}d.signal=V;function L(...Ce){return(Re,We=null,ne)=>(0,I.combinedDisposable)(...Ce.map(ce=>ce(fe=>Re.call(We,fe),null,ne)))}d.any=L;function M(Ce,Re,We,ne){let ce=We;return R(Ce,fe=>(ce=Re(ce,fe),ce),ne)}d.reduce=M;function F(Ce,Re){let We;const ne={onWillAddFirstListener(){We=Ce(ce.fire,ce)},onDidRemoveLastListener(){We?.dispose()}};Re||n(ne);const ce=new g(ne);return Re?.add(ce),ce.event}function B(Ce,Re,We=100,ne=!1,ce,fe){let J,re,ee,O=0;const W={leakWarningThreshold:ce,onWillAddFirstListener(){J=Ce(X=>{O++,re=Re(re,X),ne&&!ee&&(q.fire(re),re=void 0),clearTimeout(ee),ee=setTimeout(()=>{const ae=re;re=void 0,ee=void 0,(!ne||O>1)&&q.fire(ae),O=0},We)})},onDidRemoveLastListener(){J.dispose()}};fe||n(W);const q=new g(W);return fe?.add(q),q.event}d.debounce=B;function N(Ce,Re=(ne,ce)=>ne===ce,We){let ne=!0,ce;return H(Ce,fe=>{const J=ne||!Re(fe,ce);return ne=!1,ce=fe,J},We)}d.latch=N;function z(Ce,Re,We){return[d.filter(Ce,Re,We),d.filter(Ce,ne=>!Re(ne),We)]}d.split=z;function j(Ce,Re=!1,We=[]){let ne=We.slice(),ce=Ce(re=>{ne?ne.push(re):J.fire(re)});const fe=()=>{ne?.forEach(re=>J.fire(re)),ne=null},J=new g({onWillAddFirstListener(){ce||(ce=Ce(re=>J.fire(re)))},onDidAddFirstListener(){ne&&(Re?setTimeout(fe):fe())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return J.event}d.buffer=j;class x{constructor(Re){this.event=Re,this.disposables=new I.DisposableStore}map(Re){return new x(R(this.event,Re,this.disposables))}forEach(Re){return new x(U(this.event,Re,this.disposables))}filter(Re){return new x(H(this.event,Re,this.disposables))}reduce(Re,We){return new x(M(this.event,Re,We,this.disposables))}latch(){return new x(N(this.event,void 0,this.disposables))}debounce(Re,We=100,ne=!1,ce){return new x(B(this.event,Re,We,ne,ce,this.disposables))}on(Re,We,ne){return this.event(Re,We,ne)}once(Re,We,ne){return C(this.event)(Re,We,ne)}dispose(){this.disposables.dispose()}}function Q(Ce){return new x(Ce)}d.chain=Q;function K(Ce,Re,We=ne=>ne){const ne=(...re)=>J.fire(We(...re)),ce=()=>Ce.on(Re,ne),fe=()=>Ce.removeListener(Re,ne),J=new g({onWillAddFirstListener:ce,onDidRemoveLastListener:fe});return J.event}d.fromNodeEventEmitter=K;function le(Ce,Re,We=ne=>ne){const ne=(...re)=>J.fire(We(...re)),ce=()=>Ce.addEventListener(Re,ne),fe=()=>Ce.removeEventListener(Re,ne),J=new g({onWillAddFirstListener:ce,onDidRemoveLastListener:fe});return J.event}d.fromDOMEventEmitter=le;function ie(Ce){return new Promise(Re=>C(Ce)(Re))}d.toPromise=ie;function de(Ce,Re){return Re(void 0),Ce(We=>Re(We))}d.runAndSubscribe=de;function Y(Ce,Re){let We=null;function ne(fe){We?.dispose(),We=new I.DisposableStore,Re(fe,We)}ne(void 0);const ce=Ce(fe=>ne(fe));return(0,I.toDisposable)(()=>{ce.dispose(),We?.dispose()})}d.runAndSubscribeWithStore=Y;class pe{constructor(Re,We){this.obs=Re,this._counter=0,this._hasChanged=!1;const ne={onWillAddFirstListener:()=>{Re.addObserver(this)},onDidRemoveLastListener:()=>{Re.removeObserver(this)}};We||n(ne),this.emitter=new g(ne),We&&We.add(this.emitter)}beginUpdate(Re){this._counter++}handleChange(Re,We){this._hasChanged=!0}endUpdate(Re){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function be(Ce,Re){return new pe(Ce,Re).emitter.event}d.fromObservable=be})(D=e.Event||(e.Event={}));class A{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${A._idPool++}`,A.all.add(this)}start(n){this._stopWatch=new y.StopWatch(!0),this.listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=A,A.all=new Set,A._idPool=0;let k=-1;function E(d){const n=k;return k=d,{dispose(){k=n}}}e.setGlobalLeakWarningThreshold=E;class _{constructor(n,i=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=i,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(n,i){const p=this.threshold;if(p<=0||i<p)return;this._stacks||(this._stacks=new Map);const C=this._stacks.get(n.value)||0;if(this._stacks.set(n.value,C+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let R,U=0;for(const[H,V]of this._stacks)(!R||U<V)&&(R=H,U=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${i} listeners already. MOST frequent listener (${U}):`),console.warn(R)}return()=>{const R=this._stacks.get(n.value)||0;this._stacks.set(n.value,R-1)}}}class w{static create(){return new w(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f{constructor(n,i,p){this.callback=n,this.callbackThis=i,this.stack=p,this.subscription=new I.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class g{constructor(n){this._disposed=!1,this._options=n,this._leakageMon=k>0||this._options?.leakWarningThreshold?new _(this._options?.leakWarningThreshold??k):void 0,this._perfMon=this._options?._profName?new A(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(T){const n=Array.from(this._listeners);queueMicrotask(()=>{for(const i of n)i.subscription.isset()&&(i.subscription.unset(),i.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(n,i,p)=>{if(this._listeners||(this._listeners=new P.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),I.Disposable.None;const C=this._listeners.isEmpty();C&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let R,U;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(U=w.create(),R=this._leakageMon.check(U,this._listeners.size+1)),T&&(U=U??w.create());const H=new f(n,i,U),V=this._listeners.push(H);C&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,n,i);const L=H.subscription.set(()=>{R?.(),this._disposed||(V(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return p instanceof I.DisposableStore?p.add(L):Array.isArray(p)&&p.push(L),L}),this._event}fire(n){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const i of this._listeners)this._deliveryQueue.push(this,i,n);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=g;class h{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(n,i,p){this._queue.push(new m(n,i,p))}clear(n){const i=new P.LinkedList;for(const p of this._queue)p.emitter!==n&&i.push(p);this._queue=i}deliver(){for(;this._queue.size>0;){const n=this._queue.shift();try{n.listener.invoke(n.event)}catch(i){(0,c.onUnexpectedError)(i)}}}}e.EventDeliveryQueue=h;class v extends h{clear(n){this._queue.clear()}}class m{constructor(n,i,p){this.emitter=n,this.listener=i,this.event=p}}class r extends g{async fireAsync(n,i,p){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const C of this._listeners)this._asyncDeliveryQueue.push([C,n]);for(;this._asyncDeliveryQueue.size>0&&!i.isCancellationRequested;){const[C,R]=this._asyncDeliveryQueue.shift(),U=[],H={...R,token:i,waitUntil:V=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");p&&(V=p(V,C.callback)),U.push(V)}};try{C.invoke(H)}catch(V){(0,c.onUnexpectedError)(V);continue}Object.freeze(U),await Promise.allSettled(U).then(V=>{for(const L of V)L.status==="rejected"&&(0,c.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=r;class b extends g{constructor(n){super(n),this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=n?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}e.PauseableEmitter=b;class s extends b{constructor(n){super(n),this._delay=n.delay??100}fire(n){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(n)}}e.DebounceEmitter=s;class u extends g{constructor(n){super(n),this._queuedEvents=[],this._mergeFn=n?.merge}fire(n){!this.hasListeners()||(this._queuedEvents.push(n),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(i=>super.fire(i)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=u;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const i={event:n,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const p=()=>{this.hasListeners&&this.unhook(i);const C=this.events.indexOf(i);this.events.splice(C,1)};return(0,I.toDisposable)((0,t.once)(p))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(i=>this.emitter.fire(i))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=o;class l{constructor(){this.buffers=[]}wrapEvent(n){return(i,p,C)=>n(R=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>i.call(p,R)):i.call(p,R)},void 0,C)}bufferEvents(n){const i=[];this.buffers.push(i);const p=n();return this.buffers.pop(),i.forEach(C=>C()),p}}e.EventBufferer=l;class a{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=I.Disposable.None,this.emitter=new g({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(_e[21],ye([1,0,4]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(T,S){const D=setTimeout(T.bind(S),0);return{dispose(){clearTimeout(D)}}});var I;(function(T){function S(D){return D===T.None||D===T.Cancelled||D instanceof P?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}T.isCancellationToken=S,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new c.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=I.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=y}),define(_e[156],ye([1,0,21]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new c.CancellationTokenSource,S=this.task(T.token);return this.result={promise:S,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=t;class I{constructor(T){this.fn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const S=JSON.stringify(T);return this.lastArgKey!==S&&(this.lastArgKey=S,this.lastCache=this.fn(T)),this.lastCache}}e.LRUCachedFunction=I;class P{get cachedValues(){return this._map}constructor(T){this.fn=T,this._map=new Map}get(T){if(this._map.has(T))return this._map.get(T);const S=this.fn(T);return this._map.set(T,S),S}}e.CachedFunction=P}),define(_e[157],ye([1,0,4,6]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const I=y=>({onDidChange:c.Event.None,value:y});e.staticObservableValue=I;class P extends t.Disposable{get value(){return this._value}set value(T){T!==this._value&&(this._value=T,this.changeEmitter.fire(T))}constructor(T){super(),this._value=T,this.changeEmitter=this._register(new c.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=P}),define(_e[8],ye([1,0,156,79]),function(Z,e,c,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=P;const y=/{(\d+)}/g;function T(ue,...Ie){return Ie.length===0?ue:ue.replace(y,function(Le,Fe){const Ge=parseInt(Fe,10);return isNaN(Ge)||Ge<0||Ge>=Ie.length?Le:Ie[Ge]})}e.format=T;const S=/{([^}]+)}/g;function D(ue,Ie){return ue.replace(S,(Le,Fe)=>Ie[Fe]??Le)}e.format2=D;function A(ue){return ue.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=A;function k(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function E(ue,Ie){let Le=0;const Fe=Ie.charCodeAt(0);for(let Ge=ue.length-1;Ge>=0;Ge--)ue.charCodeAt(Ge)===Fe&&Le++;return Le}e.count=E;function _(ue,Ie,Le="\u2026"){return ue.length<=Ie?ue:`${ue.substr(0,Ie)}${Le}`}e.truncate=_;function w(ue,Ie=" "){const Le=f(ue,Ie);return g(Le,Ie)}e.trim=w;function f(ue,Ie){if(!ue||!Ie)return ue;const Le=Ie.length;if(Le===0||ue.length===0)return ue;let Fe=0;for(;ue.indexOf(Ie,Fe)===Fe;)Fe=Fe+Le;return ue.substring(Fe)}e.ltrim=f;function g(ue,Ie){if(!ue||!Ie)return ue;const Le=Ie.length,Fe=ue.length;if(Le===0||Fe===0)return ue;let Ge=Fe,Ye=-1;for(;Ye=ue.lastIndexOf(Ie,Ge-1),!(Ye===-1||Ye+Le!==Ge);){if(Ye===0)return"";Ge=Ye}return ue.substring(0,Ge)}e.rtrim=g;function h(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function v(ue){return ue.replace(/\*/g,"")}e.stripWildcards=v;function m(ue,Ie,Le={}){if(!ue)throw new Error("Cannot create regex from empty string");Ie||(ue=k(ue)),Le.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Fe="";return Le.global&&(Fe+="g"),Le.matchCase||(Fe+="i"),Le.multiline&&(Fe+="m"),Le.unicode&&(Fe+="u"),new RegExp(ue,Fe)}e.createRegExp=m;function r(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=r;function b(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function s(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=s;function u(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=u;function o(ue){for(let Ie=0,Le=ue.length;Ie<Le;Ie++){const Fe=ue.charCodeAt(Ie);if(Fe!==32&&Fe!==9)return Ie}return-1}e.firstNonWhitespaceIndex=o;function l(ue,Ie=0,Le=ue.length){for(let Fe=Ie;Fe<Le;Fe++){const Ge=ue.charCodeAt(Fe);if(Ge!==32&&Ge!==9)return ue.substring(Ie,Fe)}return ue.substring(Ie,Le)}e.getLeadingWhitespace=l;function a(ue,Ie=ue.length-1){for(let Le=Ie;Le>=0;Le--){const Fe=ue.charCodeAt(Le);if(Fe!==32&&Fe!==9)return Le}return-1}e.lastNonWhitespaceIndex=a;function d(ue,Ie,Le){const Fe=[];let Ge=0;for(const Ye of ue.matchAll(Ie)){if(Fe.push(ue.slice(Ge,Ye.index)),Ye.index===void 0)throw new Error("match.index should be defined");Ge=Ye.index+Ye[0].length,Fe.push(Le(Ye[0],...Ye.slice(1),Ye.index,ue,Ye.groups))}return Fe.push(ue.slice(Ge)),Promise.all(Fe).then(Ye=>Ye.join(""))}e.replaceAsync=d;function n(ue,Ie){return ue<Ie?-1:ue>Ie?1:0}e.compare=n;function i(ue,Ie,Le=0,Fe=ue.length,Ge=0,Ye=Ie.length){for(;Le<Fe&&Ge<Ye;Le++,Ge++){const st=ue.charCodeAt(Le),et=Ie.charCodeAt(Ge);if(st<et)return-1;if(st>et)return 1}const it=Fe-Le,bt=Ye-Ge;return it<bt?-1:it>bt?1:0}e.compareSubstring=i;function p(ue,Ie){return C(ue,Ie,0,ue.length,0,Ie.length)}e.compareIgnoreCase=p;function C(ue,Ie,Le=0,Fe=ue.length,Ge=0,Ye=Ie.length){for(;Le<Fe&&Ge<Ye;Le++,Ge++){let st=ue.charCodeAt(Le),et=Ie.charCodeAt(Ge);if(st===et)continue;if(st>=128||et>=128)return i(ue.toLowerCase(),Ie.toLowerCase(),Le,Fe,Ge,Ye);U(st)&&(st-=32),U(et)&&(et-=32);const wt=st-et;if(wt!==0)return wt}const it=Fe-Le,bt=Ye-Ge;return it<bt?-1:it>bt?1:0}e.compareSubstringIgnoreCase=C;function R(ue){return ue>=48&&ue<=57}e.isAsciiDigit=R;function U(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=U;function H(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=H;function V(ue,Ie){return ue.length===Ie.length&&C(ue,Ie)===0}e.equalsIgnoreCase=V;function L(ue,Ie){const Le=Ie.length;return Ie.length>ue.length?!1:C(ue,Ie,0,Le)===0}e.startsWithIgnoreCase=L;function M(ue,Ie){const Le=Math.min(ue.length,Ie.length);let Fe;for(Fe=0;Fe<Le;Fe++)if(ue.charCodeAt(Fe)!==Ie.charCodeAt(Fe))return Fe;return Le}e.commonPrefixLength=M;function F(ue,Ie){const Le=Math.min(ue.length,Ie.length);let Fe;const Ge=ue.length-1,Ye=Ie.length-1;for(Fe=0;Fe<Le;Fe++)if(ue.charCodeAt(Ge-Fe)!==Ie.charCodeAt(Ye-Fe))return Fe;return Le}e.commonSuffixLength=F;function B(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=B;function N(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=N;function z(ue,Ie){return(ue-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=z;function j(ue,Ie,Le){const Fe=ue.charCodeAt(Le);if(B(Fe)&&Le+1<Ie){const Ge=ue.charCodeAt(Le+1);if(N(Ge))return z(Fe,Ge)}return Fe}e.getNextCodePoint=j;function x(ue,Ie){const Le=ue.charCodeAt(Ie-1);if(N(Le)&&Ie>1){const Fe=ue.charCodeAt(Ie-2);if(B(Fe))return z(Fe,Le)}return Le}class Q{get offset(){return this._offset}constructor(Ie,Le=0){this._str=Ie,this._len=Ie.length,this._offset=Le}setOffset(Ie){this._offset=Ie}prevCodePoint(){const Ie=x(this._str,this._offset);return this._offset-=Ie>=65536?2:1,Ie}nextCodePoint(){const Ie=j(this._str,this._len,this._offset);return this._offset+=Ie>=65536?2:1,Ie}eol(){return this._offset>=this._len}}e.CodePointIterator=Q;class K{get offset(){return this._iterator.offset}constructor(Ie,Le=0){this._iterator=new Q(Ie,Le)}nextGraphemeLength(){const Ie=nt.getInstance(),Le=this._iterator,Fe=Le.offset;let Ge=Ie.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const Ye=Le.offset,it=Ie.getGraphemeBreakType(Le.nextCodePoint());if(xe(Ge,it)){Le.setOffset(Ye);break}Ge=it}return Le.offset-Fe}prevGraphemeLength(){const Ie=nt.getInstance(),Le=this._iterator,Fe=Le.offset;let Ge=Ie.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const Ye=Le.offset,it=Ie.getGraphemeBreakType(Le.prevCodePoint());if(xe(it,Ge)){Le.setOffset(Ye);break}Ge=it}return Fe-Le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function le(ue,Ie){return new K(ue,Ie).nextGraphemeLength()}e.nextCharLength=le;function ie(ue,Ie){return new K(ue,Ie).prevGraphemeLength()}e.prevCharLength=ie;function de(ue,Ie){Ie>0&&N(ue.charCodeAt(Ie))&&Ie--;const Le=Ie+le(ue,Ie);return[Le-ie(ue,Le),Le]}e.getCharContainingOffset=de;function Y(ue){const Ie=new K(ue);let Le=0;for(;!Ie.eol();)Le++,Ie.nextGraphemeLength();return Le}e.charCount=Y;let pe;function be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ce(ue){return pe||(pe=be()),pe.test(ue)}e.containsRTL=Ce;const Re=/^[\t\n\r\x20-\x7E]*$/;function We(ue){return Re.test(ue)}e.isBasicASCII=We,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ne(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=ne;function ce(ue){return ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=ce;function fe(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129008||ue>=129280&&ue<=129535||ue>=129648&&ue<=129782}e.isEmojiImprecise=fe;function J(ue,Ie){if(ue.length<Ie)return ue;const Le=/\b/g;let Fe=0;for(;Le.test(ue)&&!(ue.length-Le.lastIndex<Ie);)Fe=Le.lastIndex,Le.lastIndex+=1;return ue.substring(Fe).replace(/^\s/,"")}e.lcut=J;const re=/\x1B\x5B[12]?K/g,ee=/\x1b\[\d+m/g,O=/\x1b\[0?m/g;function W(ue){return ue&&(ue=ue.replace(re,""),ue=ue.replace(ee,""),ue=ue.replace(O,"")),ue}e.removeAnsiEscapeCodes=W,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function q(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=q;function X(ue){return q(ue)?ue.substr(1):ue}e.stripUTF8BOM=X;function ae(ue,Ie){if(!ue||!Ie||ue.length<Ie.length)return!1;const Le=Ie.length,Fe=ue.toLowerCase();let Ge=0,Ye=-1;for(;Ge<Le;){const it=Fe.indexOf(Ie[Ge],Ye+1);if(it<0)return!1;Ye=it,Ge++}return!0}e.fuzzyContains=ae;function ve(ue,Ie=!1){return ue?(Ie&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=ve;function Te(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=Te;function ge(ue,Ie=1){if(Ie===0)return"";let Le=-1;do Le=ue.indexOf(`
`,Le+1),Ie--;while(Ie>0&&Le>=0);return Le===-1?ue:(ue[Le-1]==="\r"&&Le--,ue.substr(0,Le))}e.getNLines=ge;function Pe(ue){return ue=ue%(2*26),ue<26?String.fromCharCode(97+ue):String.fromCharCode(65+ue-26)}e.singleLetterHash=Pe;function De(ue){return nt.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=De;function xe(ue,Ie){return ue===0?Ie!==5&&Ie!==7:ue===2&&Ie===3?!1:ue===4||ue===2||ue===3||Ie===4||Ie===2||Ie===3?!0:!(ue===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(ue===11||ue===9)&&(Ie===9||Ie===10)||(ue===12||ue===10)&&Ie===10||Ie===5||Ie===13||Ie===7||ue===1||ue===13&&Ie===14||ue===6&&Ie===6)}var je;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class nt{static getInstance(){return nt._INSTANCE||(nt._INSTANCE=new nt),nt._INSTANCE}constructor(){this._data=Xe()}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Le=this._data,Fe=Le.length/3;let Ge=1;for(;Ge<=Fe;)if(Ie<Le[3*Ge])Ge=2*Ge;else if(Ie>Le[3*Ge+1])Ge=2*Ge+1;else return Le[3*Ge+2];return 0}}nt._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function rt(ue,Ie){if(ue===0)return 0;const Le=Be(ue,Ie);if(Le!==void 0)return Le;const Fe=new Q(Ie,ue);return Fe.prevCodePoint(),Fe.offset}e.getLeftDeleteOffset=rt;function Be(ue,Ie){const Le=new Q(Ie,ue);let Fe=Le.prevCodePoint();for(;dt(Fe)||Fe===65039||Fe===8419;){if(Le.offset===0)return;Fe=Le.prevCodePoint()}if(!fe(Fe))return;let Ge=Le.offset;return Ge>0&&Le.prevCodePoint()===8205&&(Ge=Le.offset),Ge}function dt(ue){return 127995<=ue&&ue<=127999}var se;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(se||(se={})),e.noBreakWhitespace="\xA0";class oe{static getInstance(Ie){return oe.cache.get(Array.from(Ie))}static getLocales(){return oe._locales.getValue()}constructor(Ie){this.confusableDictionary=Ie}isAmbiguous(Ie){return this.confusableDictionary.has(Ie)}getPrimaryConfusable(Ie){return this.confusableDictionary.get(Ie)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=oe,I=oe,oe.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),oe.cache=new c.LRUCachedFunction(ue=>{function Ie(et){const wt=new Map;for(let St=0;St<et.length;St+=2)wt.set(et[St],et[St+1]);return wt}function Le(et,wt){const St=new Map(et);for(const[Dt,ft]of wt)St.set(Dt,ft);return St}function Fe(et,wt){if(!et)return wt;const St=new Map;for(const[Dt,ft]of et)wt.has(Dt)&&St.set(Dt,ft);return St}const Ge=I.ambiguousCharacterData.getValue();let Ye=ue.filter(et=>!et.startsWith("_")&&et in Ge);Ye.length===0&&(Ye=["_default"]);let it;for(const et of Ye){const wt=Ie(Ge[et]);it=Fe(it,wt)}const bt=Ie(Ge._common),st=Le(bt,it);return new oe(st)}),oe._locales=new t.Lazy(()=>Object.keys(oe.ambiguousCharacterData.getValue()).filter(ue=>!ue.startsWith("_")));class Se{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Se.getRawData())),this._data}static isInvisibleCharacter(Ie){return Se.getData().has(Ie)}static get codePoints(){return Se.getData()}}e.InvisibleCharacters=Se,Se._data=void 0}),define(_e[32],ye([1,0,9,12,8,11]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(a){return a===47||a===92}e.isPathSeparator=y;function T(a){return a.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=T;function S(a){return a.indexOf("/")===-1&&(a=T(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=S;function D(a,d=c.posix.sep){if(!a)return"";const n=a.length,i=a.charCodeAt(0);if(y(i)){if(y(a.charCodeAt(1))&&!y(a.charCodeAt(2))){let C=3;const R=C;for(;C<n&&!y(a.charCodeAt(C));C++);if(R!==C&&!y(a.charCodeAt(C+1))){for(C+=1;C<n;C++)if(y(a.charCodeAt(C)))return a.slice(0,C+1).replace(/[\\/]/g,d)}}return d}else if(h(i)&&a.charCodeAt(1)===58)return y(a.charCodeAt(2))?a.slice(0,2)+d:a.slice(0,2);let p=a.indexOf("://");if(p!==-1){for(p+=3;p<n;p++)if(y(a.charCodeAt(p)))return a.slice(0,p+1)}return""}e.getRoot=D;function A(a){if(!t.isWindows||!a||a.length<5)return!1;let d=a.charCodeAt(0);if(d!==92||(d=a.charCodeAt(1),d!==92))return!1;let n=2;const i=n;for(;n<a.length&&(d=a.charCodeAt(n),d!==92);n++);return!(i===n||(d=a.charCodeAt(n+1),isNaN(d)||d===92))}e.isUNC=A;const k=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,_=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(a,d=t.isWindows){const n=d?k:E;return!(!a||a.length===0||/^\s+$/.test(a)||(n.lastIndex=0,n.test(a))||d&&_.test(a)||a==="."||a===".."||d&&a[a.length-1]==="."||d&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=w;function f(a,d,n){const i=a===d;return!n||i?i:!a||!d?!1:(0,I.equalsIgnoreCase)(a,d)}e.isEqual=f;function g(a,d,n,i=c.sep){if(a===d)return!0;if(!a||!d||d.length>a.length)return!1;if(n){if(!(0,I.startsWithIgnoreCase)(a,d))return!1;if(d.length===a.length)return!0;let C=d.length;return d.charAt(d.length-1)===i&&C--,a.charAt(C)===i}return d.charAt(d.length-1)!==i&&(d+=i),a.indexOf(d)===0}e.isEqualOrParent=g;function h(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=h;function v(a,d){return t.isWindows&&a.endsWith(":")&&(a+=c.sep),(0,c.isAbsolute)(a)||(a=(0,c.join)(d,a)),a=(0,c.normalize)(a),t.isWindows?(a=(0,I.rtrim)(a,c.sep),a.endsWith(":")&&(a+=c.sep)):(a=(0,I.rtrim)(a,c.sep),a||(a=c.sep)),a}e.sanitizeFilePath=v;function m(a){const d=(0,c.normalize)(a);return t.isWindows?a.length>3?!1:r(d)&&(a.length===2||d.charCodeAt(2)===92):d===c.posix.sep}e.isRootOrDriveLetter=m;function r(a,d=t.isWindows){return d?h(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=r;function b(a){return r(a)?a[0]:void 0}e.getDriveLetter=b;function s(a,d,n){return d.length>a.length?-1:a===d?0:(n&&(a=a.toLowerCase(),d=d.toLowerCase()),a.indexOf(d))}e.indexOfPath=s;function u(a){const d=a.split(":");let n,i,p;for(const C of d){const R=Number(C);(0,P.isNumber)(R)?i===void 0?i=R:p===void 0&&(p=R):n=n?[n,C].join(":"):C}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:i!==void 0?i:void 0,column:p!==void 0?p:i!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(a,d,n=8){let i="";for(let C=0;C<n;C++)i+=o.charAt(Math.floor(Math.random()*o.length));let p;return d?p=`${d}-${i}`:p=i,a?(0,c.join)(a,p):p}e.randomPath=l}),define(_e[107],ye([1,0,28,8]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...ee){return function(O,W){for(let q=0,X=ee.length;q<X;q++){const ae=ee[q](O,W);if(ae)return ae}return null}}e.or=I,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(ee,O,W){if(!W||W.length<O.length)return null;let q;return ee?q=t.startsWithIgnoreCase(W,O):q=W.indexOf(O)===0,q?O.length>0?[{start:0,end:O.length}]:[]:null}function y(ee,O){const W=O.toLowerCase().indexOf(ee.toLowerCase());return W===-1?null:[{start:W,end:W+ee.length}]}e.matchesContiguousSubString=y;function T(ee,O){return S(ee.toLowerCase(),O.toLowerCase(),0,0)}e.matchesSubString=T;function S(ee,O,W,q){if(W===ee.length)return[];if(q===O.length)return null;if(ee[W]===O[q]){let X=null;return(X=S(ee,O,W+1,q+1))?h({start:q,end:q+1},X):null}return S(ee,O,W,q+1)}function D(ee){return 97<=ee&&ee<=122}function A(ee){return 65<=ee&&ee<=90}e.isUpper=A;function k(ee){return 48<=ee&&ee<=57}function E(ee){return ee===32||ee===9||ee===10||ee===13}const _=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>_.add(ee.charCodeAt(0)));function w(ee){return E(ee)||_.has(ee)}function f(ee,O){return ee===O||w(ee)&&w(O)}function g(ee){return D(ee)||A(ee)||k(ee)}function h(ee,O){return O.length===0?O=[ee]:ee.end===O[0].start?O[0].start=ee.start:O.unshift(ee),O}function v(ee,O){for(let W=O;W<ee.length;W++){const q=ee.charCodeAt(W);if(A(q)||k(q)||W>0&&!g(ee.charCodeAt(W-1)))return W}return ee.length}function m(ee,O,W,q){if(W===ee.length)return[];if(q===O.length)return null;if(ee[W]!==O[q].toLowerCase())return null;{let X=null,ae=q+1;for(X=m(ee,O,W+1,q+1);!X&&(ae=v(O,ae))<O.length;)X=m(ee,O,W+1,ae),ae++;return X===null?null:h({start:q,end:q+1},X)}}function r(ee){let O=0,W=0,q=0,X=0,ae=0;for(let De=0;De<ee.length;De++)ae=ee.charCodeAt(De),A(ae)&&O++,D(ae)&&W++,g(ae)&&q++,k(ae)&&X++;const ve=O/ee.length,Te=W/ee.length,ge=q/ee.length,Pe=X/ee.length;return{upperPercent:ve,lowerPercent:Te,alphaPercent:ge,numericPercent:Pe}}function b(ee){const{upperPercent:O,lowerPercent:W}=ee;return W===0&&O>.6}function s(ee){const{upperPercent:O,lowerPercent:W,alphaPercent:q,numericPercent:X}=ee;return W>.2&&O<.8&&q>.6&&X<.2}function u(ee){let O=0,W=0,q=0,X=0;for(let ae=0;ae<ee.length;ae++)q=ee.charCodeAt(ae),A(q)&&O++,D(q)&&W++,E(q)&&X++;return(O===0||W===0)&&X===0?ee.length<=30:O<=5}function o(ee,O){if(!O||(O=O.trim(),O.length===0)||!u(ee)||O.length>60)return null;const W=r(O);if(!s(W)){if(!b(W))return null;O=O.toLowerCase()}let q=null,X=0;for(ee=ee.toLowerCase();X<O.length&&(q=m(ee,O,0,X))===null;)X=v(O,X+1);return q}e.matchesCamelCase=o;function l(ee,O,W=!1){if(!O||O.length===0)return null;let q=null,X=0;for(ee=ee.toLowerCase(),O=O.toLowerCase();X<O.length&&(q=a(ee,O,0,X,W))===null;)X=d(O,X+1);return q}e.matchesWords=l;function a(ee,O,W,q,X){if(W===ee.length)return[];if(q===O.length)return null;if(f(ee.charCodeAt(W),O.charCodeAt(q))){let ae=null,ve=q+1;if(ae=a(ee,O,W+1,q+1,X),!X)for(;!ae&&(ve=d(O,ve))<O.length;)ae=a(ee,O,W+1,ve,X),ve++;return ae?ee.charCodeAt(W)!==O.charCodeAt(q)?ae:h({start:q,end:q+1},ae):null}else return null}function d(ee,O){for(let W=O;W<ee.length;W++)if(w(ee.charCodeAt(W))||W>0&&w(ee.charCodeAt(W-1)))return W;return ee.length}const n=I(e.matchesPrefix,o,y),i=I(e.matchesPrefix,o,T),p=new c.LRUCache(1e4);function C(ee,O,W=!1){if(typeof ee!="string"||typeof O!="string")return null;let q=p.get(ee);q||(q=new RegExp(t.convertSimple2RegExpPattern(ee),"i"),p.set(ee,q));const X=q.exec(O);return X?[{start:X.index,end:X.index+X[0].length}]:W?i(ee,O):n(ee,O)}e.matchesFuzzy=C;function R(ee,O){const W=Re(ee,ee.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return W?H(W):null}e.matchesFuzzy2=R;function U(ee,O,W,q,X,ae){const ve=Math.min(13,ee.length);for(;W<ve;W++){const Te=Re(ee,O,W,q,X,ae,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Te)return Te}return[0,ae]}e.anyScore=U;function H(ee){if(typeof ee>"u")return[];const O=[],W=ee[1];for(let q=ee.length-1;q>1;q--){const X=ee[q]+W,ae=O[O.length-1];ae&&ae.end===X?ae.end=X+1:O.push({start:X,end:X+1})}return O}e.createMatches=H;const V=128;function L(){const ee=[],O=[];for(let W=0;W<=V;W++)O[W]=0;for(let W=0;W<=V;W++)ee.push(O.slice(0));return ee}function M(ee){const O=[];for(let W=0;W<=ee;W++)O[W]=0;return O}const F=M(2*V),B=M(2*V),N=L(),z=L(),j=L(),x=!1;function Q(ee,O,W,q,X){function ae(Te,ge,Pe=" "){for(;Te.length<ge;)Te=Pe+Te;return Te}let ve=` |   |${q.split("").map(Te=>ae(Te,3)).join("|")}
`;for(let Te=0;Te<=W;Te++)Te===0?ve+=" |":ve+=`${O[Te-1]}|`,ve+=ee[Te].slice(0,X+1).map(ge=>ae(ge.toString(),3)).join("|")+`
`;return ve}function K(ee,O,W,q){ee=ee.substr(O),W=W.substr(q),console.log(Q(z,ee,ee.length,W,W.length)),console.log(Q(j,ee,ee.length,W,W.length)),console.log(Q(N,ee,ee.length,W,W.length))}function le(ee,O){if(O<0||O>=ee.length)return!1;const W=ee.codePointAt(O);switch(W){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(W)}}function ie(ee,O){if(O<0||O>=ee.length)return!1;switch(ee.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function de(ee,O,W){return O[ee]!==W[ee]}function Y(ee,O,W,q,X,ae,ve=!1){for(;O<W&&X<ae;)ee[O]===q[X]&&(ve&&(F[O]=X),O+=1),X+=1;return O===W}e.isPatternInWord=Y;var pe;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var be;(function(ee){ee.Default=[-100,0];function O(W){return!W||W.length===2&&W[0]===-100&&W[1]===0}ee.isDefault=O})(be=e.FuzzyScore||(e.FuzzyScore={}));class Ce{constructor(O,W){this.firstMatchCanBeWeak=O,this.boostFullMatch=W}}e.FuzzyScoreOptions=Ce,Ce.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Re(ee,O,W,q,X,ae,ve=Ce.default){const Te=ee.length>V?V:ee.length,ge=q.length>V?V:q.length;if(W>=Te||ae>=ge||Te-W>ge-ae||!Y(O,W,Te,X,ae,ge,!0))return;We(Te,ge,W,ae,O,X);let Pe=1,De=1,xe=W,je=ae;const nt=[!1];for(Pe=1,xe=W;xe<Te;Pe++,xe++){const se=F[xe],oe=B[xe],Se=xe+1<Te?B[xe+1]:ge;for(De=se-ae+1,je=se;je<Se;De++,je++){let ue=Number.MIN_SAFE_INTEGER,Ie=!1;je<=oe&&(ue=ne(ee,O,xe,W,q,X,je,ge,ae,N[Pe-1][De-1]===0,nt));let Le=0;ue!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Le=ue+z[Pe-1][De-1]);const Fe=je>se,Ge=Fe?z[Pe][De-1]+(N[Pe][De-1]>0?-5:0):0,Ye=je>se+1&&N[Pe][De-1]>0,it=Ye?z[Pe][De-2]+(N[Pe][De-2]>0?-5:0):0;if(Ye&&(!Fe||it>=Ge)&&(!Ie||it>=Le))z[Pe][De]=it,j[Pe][De]=3,N[Pe][De]=0;else if(Fe&&(!Ie||Ge>=Le))z[Pe][De]=Ge,j[Pe][De]=2,N[Pe][De]=0;else if(Ie)z[Pe][De]=Le,j[Pe][De]=1,N[Pe][De]=N[Pe-1][De-1]+1;else throw new Error("not possible")}}if(x&&K(ee,W,q,ae),!nt[0]&&!ve.firstMatchCanBeWeak)return;Pe--,De--;const Xe=[z[Pe][De],ae];let rt=0,Be=0;for(;Pe>=1;){let se=De;do{const oe=j[Pe][se];if(oe===3)se=se-2;else if(oe===2)se=se-1;else break}while(se>=1);rt>1&&O[W+Pe-1]===X[ae+De-1]&&!de(se+ae-1,q,X)&&rt+1>N[Pe][se]&&(se=De),se===De?rt++:rt=1,Be||(Be=se),Pe--,De=se-1,Xe.push(De)}ge===Te&&ve.boostFullMatch&&(Xe[0]+=2);const dt=Be-Te;return Xe[0]-=dt,Xe}e.fuzzyScore=Re;function We(ee,O,W,q,X,ae){let ve=ee-1,Te=O-1;for(;ve>=W&&Te>=q;)X[ve]===ae[Te]&&(B[ve]=Te,ve--),Te--}function ne(ee,O,W,q,X,ae,ve,Te,ge,Pe,De){if(O[W]!==ae[ve])return Number.MIN_SAFE_INTEGER;let xe=1,je=!1;return ve===W-q?xe=ee[W]===X[ve]?7:5:de(ve,X,ae)&&(ve===0||!de(ve-1,X,ae))?(xe=ee[W]===X[ve]?7:5,je=!0):le(ae,ve)&&(ve===0||!le(ae,ve-1))?xe=5:(le(ae,ve-1)||ie(ae,ve-1))&&(xe=5,je=!0),xe>1&&W===q&&(De[0]=!0),je||(je=de(ve,X,ae)||le(ae,ve-1)||ie(ae,ve-1)),W===q?ve>ge&&(xe-=je?3:5):Pe?xe+=je?2:0:xe+=je?0:1,ve+1===Te&&(xe-=je?3:5),xe}function ce(ee,O,W,q,X,ae,ve){return J(ee,O,W,q,X,ae,!0,ve)}e.fuzzyScoreGracefulAggressive=ce;function fe(ee,O,W,q,X,ae,ve){return J(ee,O,W,q,X,ae,!1,ve)}e.fuzzyScoreGraceful=fe;function J(ee,O,W,q,X,ae,ve,Te){let ge=Re(ee,O,W,q,X,ae,Te);if(ge&&!ve)return ge;if(ee.length>=3){const Pe=Math.min(7,ee.length-1);for(let De=W+1;De<Pe;De++){const xe=re(ee,De);if(xe){const je=Re(xe,xe.toLowerCase(),W,q,X,ae,Te);je&&(je[0]-=3,(!ge||je[0]>ge[0])&&(ge=je))}}}return ge}function re(ee,O){if(O+1>=ee.length)return;const W=ee[O],q=ee[O+1];if(W!==q)return ee.slice(0,O)+q+W+ee.slice(O+2)}}),define(_e[81],ye([1,0,8]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(h){return I(h,0)}e.hash=t;function I(h,v){switch(typeof h){case"object":return h===null?P(349,v):Array.isArray(h)?S(h,v):D(h,v);case"string":return T(h,v);case"boolean":return y(h,v);case"number":return P(h,v);case"undefined":return P(937,v);default:return P(617,v)}}e.doHash=I;function P(h,v){return(v<<5)-v+h|0}e.numberHash=P;function y(h,v){return P(h?433:863,v)}function T(h,v){v=P(149417,v);for(let m=0,r=h.length;m<r;m++)v=P(h.charCodeAt(m),v);return v}e.stringHash=T;function S(h,v){return v=P(104579,v),h.reduce((m,r)=>I(r,m),v)}function D(h,v){return v=P(181387,v),Object.keys(h).sort().reduce((m,r)=>(m=T(r,m),I(h[r],m)),v)}class A{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=I(v,this._value),this._value}}e.Hasher=A;var k;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function E(h,v,m=32){const r=m-v,b=~((1<<r)-1);return(h<<v|(b&h)>>>r)>>>0}function _(h,v=0,m=h.byteLength,r=0){for(let b=0;b<m;b++)h[v+b]=r}function w(h,v,m="0"){for(;h.length<v;)h=m+h;return h}function f(h,v=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(m=>m.toString(16).padStart(2,"0")).join(""):w((h>>>0).toString(16),v/4)}e.toHexString=f;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const m=v.length;if(m===0)return;const r=this._buff;let b=this._buffLen,s=this._leftoverHighSurrogate,u,o;for(s!==0?(u=s,o=-1,s=0):(u=v.charCodeAt(0),o=0);;){let l=u;if(c.isHighSurrogate(u))if(o+1<m){const a=v.charCodeAt(o+1);c.isLowSurrogate(a)?(o++,l=c.computeCodePoint(u,a)):l=65533}else{s=u;break}else c.isLowSurrogate(u)&&(l=65533);if(b=this._push(r,b,l),o++,o<m)u=v.charCodeAt(o);else break}this._buffLen=b,this._leftoverHighSurrogate=s}_push(v,m,r){return r<128?v[m++]=r:r<2048?(v[m++]=192|(r&1984)>>>6,v[m++]=128|(r&63)>>>0):r<65536?(v[m++]=224|(r&61440)>>>12,v[m++]=128|(r&4032)>>>6,v[m++]=128|(r&63)>>>0):(v[m++]=240|(r&1835008)>>>18,v[m++]=128|(r&258048)>>>12,v[m++]=128|(r&4032)>>>6,v[m++]=128|(r&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,_(this._buff,this._buffLen),this._buffLen>56&&(this._step(),_(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=g._bigBlock32,m=this._buffDV;for(let n=0;n<64;n+=4)v.setUint32(n,m.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)v.setUint32(n,E(v.getUint32(n-12,!1)^v.getUint32(n-32,!1)^v.getUint32(n-56,!1)^v.getUint32(n-64,!1),1),!1);let r=this._h0,b=this._h1,s=this._h2,u=this._h3,o=this._h4,l,a,d;for(let n=0;n<80;n++)n<20?(l=b&s|~b&u,a=1518500249):n<40?(l=b^s^u,a=1859775393):n<60?(l=b&s|b&u|s&u,a=2400959708):(l=b^s^u,a=3395469782),d=E(r,5)+l+o+a+v.getUint32(n*4,!1)&4294967295,o=u,u=s,s=E(b,30),b=r,r=d;this._h0=this._h0+r&4294967295,this._h1=this._h1+b&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))}),define(_e[158],ye([1,0,77,107,8]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const P="$(",y=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(c.CSSIcon.iconNameCharacter),S=new RegExp(`(\\\\)?${y.source}`,"g");function D(h){return h.replace(S,(v,m)=>m?v:`\\${v}`)}e.escapeIcons=D;const A=new RegExp(`\\\\${y.source}`,"g");function k(h){return h.replace(A,v=>`\\${v}`)}e.markdownEscapeEscapedIcons=k;const E=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function _(h){return h.indexOf(P)===-1?h:h.replace(E,(v,m,r,b)=>r?v:m||b||"")}e.stripIcons=_;function w(h){const v=h.indexOf(P);return v===-1?{text:h}:f(h,v)}e.parseLabelWithIcons=w;function f(h,v){const m=[];let r="";function b(i){if(i){r+=i;for(const p of i)m.push(o)}}let s=-1,u="",o=0,l,a,d=v;const n=h.length;for(b(h.substr(0,v));d<n;)l=h[d],a=h[d+1],l===P[0]&&a===P[1]?(s=d,b(u),u=P,d++):l===")"&&s!==-1?(o+=d-s+1,s=-1,u=""):s!==-1?T.test(l)?u+=l:(b(u),s=-1,u=""):b(l),d++;return b(u),{text:r,iconOffsets:m}}function g(h,v,m=!1){const{text:r,iconOffsets:b}=v;if(!b||b.length===0)return(0,t.matchesFuzzy)(h,r,m);const s=(0,I.ltrim)(r," "),u=r.length-s.length,o=(0,t.matchesFuzzy)(h,s,m);if(o)for(const l of o){const a=b[l.start+u]+u;l.start+=a,l.end+=a}return o}e.matchesFuzzyIconAware=g}),define(_e[42],ye([1,0,8]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const P="error",y="warning",T="warn",S="info",D="ignore";function A(E){return E?c.equalsIgnoreCase(P,E)?I.Error:c.equalsIgnoreCase(y,E)||c.equalsIgnoreCase(T,E)?I.Warning:c.equalsIgnoreCase(S,E)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function k(E){switch(E){case I.Error:return P;case I.Warning:return y;case I.Info:return S;default:return D}}I.toString=k}(t||(t={})),e.default=t}),define(_e[64],ye([1,0,17,8]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class I{constructor(){this._value="",this._pos=0}reset(_){return this._value=_,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(_){const w=_.charCodeAt(0),f=this._value.charCodeAt(this._pos);return w-f}value(){return this._value[this._pos]}}e.StringIterator=I;class P{constructor(_=!0){this._caseSensitive=_}reset(_){return this._value=_,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let _=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(_)this._from++;else break;else _=!1;return this}cmp(_){return this._caseSensitive?(0,t.compareSubstring)(_,this._value,0,_.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(_,this._value,0,_.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class y{constructor(_=!0,w=!0){this._splitOnBackslash=_,this._caseSensitive=w}reset(_){this._from=0,this._to=0,this._value=_,this._valueLen=_.length;for(let w=_.length-1;w>=0;w--,this._valueLen--){const f=this._value.charCodeAt(w);if(!(f===47||this._splitOnBackslash&&f===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let _=!0;for(;this._to<this._valueLen;this._to++){const w=this._value.charCodeAt(this._to);if(w===47||this._splitOnBackslash&&w===92)if(_)this._from++;else break;else _=!1}return this}cmp(_){return this._caseSensitive?(0,t.compareSubstring)(_,this._value,0,_.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(_,this._value,0,_.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var T;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(T||(T={}));class S{constructor(_,w){this._ignorePathCasing=_,this._ignoreQueryAndFragment=w,this._states=[],this._stateIdx=0}reset(_){return this._value=_,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(_)),this._pathIterator.reset(_.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(_)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(_){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(_,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(_,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(_);if(this._states[this._stateIdx]===4)return(0,t.compare)(_,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(_,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const _=this.right;return this.right=_.left,_.left=this,this.updateHeight(),_.updateHeight(),_}rotateRight(){const _=this.left;return this.left=_.right,_.right=this,this.updateHeight(),_.updateHeight(),_}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(A||(A={}));class k{static forUris(_=()=>!1,w=()=>!1){return new k(new S(_,w))}static forPaths(_=!1){return new k(new y(void 0,!_))}static forStrings(){return new k(new I)}static forConfigKeys(){return new k(new P)}constructor(_){this._iter=_}clear(){this._root=void 0}fill(_,w){if(w){const f=w.slice(0);(0,c.shuffle)(f);for(const g of f)this.set(g,_)}else{const f=_.slice(0);(0,c.shuffle)(f);for(const g of f)this.set(g[0],g[1])}}set(_,w){const f=this._iter.reset(_);let g;this._root||(this._root=new D,this._root.segment=f.value());const h=[];for(g=this._root;;){const m=f.cmp(g.segment);if(m>0)g.left||(g.left=new D,g.left.segment=f.value()),h.push([-1,g]),g=g.left;else if(m<0)g.right||(g.right=new D,g.right.segment=f.value()),h.push([1,g]),g=g.right;else if(f.hasNext())f.next(),g.mid||(g.mid=new D,g.mid.segment=f.value()),h.push([0,g]),g=g.mid;else break}const v=g.value;g.value=w,g.key=_;for(let m=h.length-1;m>=0;m--){const r=h[m][1];r.updateHeight();const b=r.balanceFactor();if(b<-1||b>1){const s=h[m][0],u=h[m+1][0];if(s===1&&u===1)h[m][1]=r.rotateLeft();else if(s===-1&&u===-1)h[m][1]=r.rotateRight();else if(s===1&&u===-1)r.right=h[m+1][1]=h[m+1][1].rotateRight(),h[m][1]=r.rotateLeft();else if(s===-1&&u===1)r.left=h[m+1][1]=h[m+1][1].rotateLeft(),h[m][1]=r.rotateRight();else throw new Error;if(m>0)switch(h[m-1][0]){case-1:h[m-1][1].left=h[m][1];break;case 1:h[m-1][1].right=h[m][1];break;case 0:h[m-1][1].mid=h[m][1];break}else this._root=h[0][1]}}return v}get(_){return this._getNode(_)?.value}_getNode(_){const w=this._iter.reset(_);let f=this._root;for(;f;){const g=w.cmp(f.segment);if(g>0)f=f.left;else if(g<0)f=f.right;else if(w.hasNext())w.next(),f=f.mid;else break}return f}has(_){const w=this._getNode(_);return!(w?.value===void 0&&w?.mid===void 0)}delete(_){return this._delete(_,!1)}deleteSuperstr(_){return this._delete(_,!0)}_delete(_,w){const f=this._iter.reset(_),g=[];let h=this._root;for(;h;){const v=f.cmp(h.segment);if(v>0)g.push([-1,h]),h=h.left;else if(v<0)g.push([1,h]),h=h.right;else if(f.hasNext())f.next(),g.push([0,h]),h=h.mid;else break}if(!!h){if(w?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const v=this._min(h.right);if(v.key){const{key:m,value:r,segment:b}=v;this._delete(v.key,!1),h.key=m,h.value=r,h.segment=b}}else{const v=h.left??h.right;if(g.length>0){const[m,r]=g[g.length-1];switch(m){case-1:r.left=v;break;case 0:r.mid=v;break;case 1:r.right=v;break}}else this._root=v}for(let v=g.length-1;v>=0;v--){const m=g[v][1];m.updateHeight();const r=m.balanceFactor();if(r>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),g[v][1]=m.rotateLeft()):r<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),g[v][1]=m.rotateRight()),v>0)switch(g[v-1][0]){case-1:g[v-1][1].left=g[v][1];break;case 1:g[v-1][1].right=g[v][1];break;case 0:g[v-1][1].mid=g[v][1];break}else this._root=g[0][1]}}}_min(_){for(;_.left;)_=_.left;return _}findSubstr(_){const w=this._iter.reset(_);let f=this._root,g;for(;f;){const h=w.cmp(f.segment);if(h>0)f=f.left;else if(h<0)f=f.right;else if(w.hasNext())w.next(),g=f.value||g,f=f.mid;else break}return f&&f.value||g}findSuperstr(_){const w=this._iter.reset(_);let f=this._root;for(;f;){const g=w.cmp(f.segment);if(g>0)f=f.left;else if(g<0)f=f.right;else if(w.hasNext())w.next(),f=f.mid;else return f.mid?this._entries(f.mid):void 0}}forEach(_){for(const[w,f]of this)_(f,w)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(_){const w=[];return this._dfsEntries(_,w),w[Symbol.iterator]()}_dfsEntries(_,w){!_||(_.left&&this._dfsEntries(_.left,w),_.value&&w.push([_.key,_.value]),_.mid&&this._dfsEntries(_.mid,w),_.right&&this._dfsEntries(_.right,w))}_isBalanced(){const _=w=>{if(!w)return!0;const f=w.balanceFactor();return f<-1||f>1?!1:_(w.left)&&_(w.right)};return _(this._root)}}e.TernarySearchTree=k}),define(_e[2],ye([1,0,9,12]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,P=/^\//,y=/^\/\//;function T(o,l){if(!o.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!I.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!P.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(o,l){return!o&&!l?"file":o}function D(o,l){switch(o){case"https":case"http":case"file":l?l[0]!==k&&(l=k+l):l=k;break}return l}const A="",k="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class _{static isUri(l){return l instanceof _?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,a,d,n,i,p=!1){typeof l=="object"?(this.scheme=l.scheme||A,this.authority=l.authority||A,this.path=l.path||A,this.query=l.query||A,this.fragment=l.fragment||A):(this.scheme=S(l,p),this.authority=a||A,this.path=D(this.scheme,d||A),this.query=n||A,this.fragment=i||A,T(this,p))}get fsPath(){return m(this,!1)}with(l){if(!l)return this;let{scheme:a,authority:d,path:n,query:i,fragment:p}=l;return a===void 0?a=this.scheme:a===null&&(a=A),d===void 0?d=this.authority:d===null&&(d=A),n===void 0?n=this.path:n===null&&(n=A),i===void 0?i=this.query:i===null&&(i=A),p===void 0?p=this.fragment:p===null&&(p=A),a===this.scheme&&d===this.authority&&n===this.path&&i===this.query&&p===this.fragment?this:new f(a,d,n,i,p)}static parse(l,a=!1){const d=E.exec(l);return d?new f(d[2]||A,u(d[4]||A),u(d[5]||A),u(d[7]||A),u(d[9]||A),a):new f(A,A,A,A,A)}static file(l){let a=A;if(t.isWindows&&(l=l.replace(/\\/g,k)),l[0]===k&&l[1]===k){const d=l.indexOf(k,2);d===-1?(a=l.substring(2),l=k):(a=l.substring(2,d),l=l.substring(d)||k)}return new f("file",a,l,A,A)}static from(l){const a=new f(l.scheme,l.authority,l.path,l.query,l.fragment);return T(a,!0),a}static joinPath(l,...a){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return t.isWindows&&l.scheme==="file"?d=_.file(c.win32.join(m(l,!0),...a)).path:d=c.posix.join(l.path,...a),l.with({path:d})}toString(l=!1){return r(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof _)return l;{const a=new f(l);return a._formatted=l.external,a._fsPath=l._sep===w?l.fsPath:null,a}}else return l}}e.URI=_;const w=t.isWindows?1:void 0;class f extends _{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(l=!1){return l?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=w),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(o,l){let a,d=-1;for(let n=0;n<o.length;n++){const i=o.charCodeAt(n);if(i>=97&&i<=122||i>=65&&i<=90||i>=48&&i<=57||i===45||i===46||i===95||i===126||l&&i===47)d!==-1&&(a+=encodeURIComponent(o.substring(d,n)),d=-1),a!==void 0&&(a+=o.charAt(n));else{a===void 0&&(a=o.substr(0,n));const p=g[i];p!==void 0?(d!==-1&&(a+=encodeURIComponent(o.substring(d,n)),d=-1),a+=p):d===-1&&(d=n)}}return d!==-1&&(a+=encodeURIComponent(o.substring(d))),a!==void 0?a:o}function v(o){let l;for(let a=0;a<o.length;a++){const d=o.charCodeAt(a);d===35||d===63?(l===void 0&&(l=o.substr(0,a)),l+=g[d]):l!==void 0&&(l+=o[a])}return l!==void 0?l:o}function m(o,l){let a;return o.authority&&o.path.length>1&&o.scheme==="file"?a=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?l?a=o.path.substr(1):a=o.path[1].toLowerCase()+o.path.substr(2):a=o.path,t.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=m;function r(o,l){const a=l?v:h;let d="",{scheme:n,authority:i,path:p,query:C,fragment:R}=o;if(n&&(d+=n,d+=":"),(i||n==="file")&&(d+=k,d+=k),i){let U=i.indexOf("@");if(U!==-1){const H=i.substr(0,U);i=i.substr(U+1),U=H.indexOf(":"),U===-1?d+=a(H,!1):(d+=a(H.substr(0,U),!1),d+=":",d+=a(H.substr(U+1),!1)),d+="@"}i=i.toLowerCase(),U=i.indexOf(":"),U===-1?d+=a(i,!1):(d+=a(i.substr(0,U),!1),d+=i.substr(U))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const U=p.charCodeAt(1);U>=65&&U<=90&&(p=`/${String.fromCharCode(U+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const U=p.charCodeAt(0);U>=65&&U<=90&&(p=`${String.fromCharCode(U+32)}:${p.substr(2)}`)}d+=a(p,!0)}return C&&(d+="?",d+=a(C,!1)),R&&(d+="#",d+=l?R:h(R,!1)),d}function b(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+b(o.substr(3)):o}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(o){return o.match(s)?o.replace(s,l=>b(l)):o}}),define(_e[82],ye([1,0,23,8,2]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(D){return JSON.stringify(D,T)}e.stringify=P;function y(D){let A=JSON.parse(D);return A=S(A),A}e.parse=y;function T(D,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,t.regExpFlags)(A)}:A}function S(D,A=0){if(!D||A>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return I.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 15:return new Date(D.source)}if(D instanceof c.VSBuffer||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let k=0;k<D.length;++k)D[k]=S(D[k],A+1);else for(const k in D)Object.hasOwnProperty.call(D,k)&&(D[k]=S(D[k],A+1))}return D}e.revive=S}),define(_e[14],ye([1,0,12,2]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}setServerRootPath(D){this._remoteResourcesPath=`${D}/${I.vscodeRemoteResource}`}set(D,A,k){this._hosts[D]=A,this._ports[D]=k}setConnectionToken(D,A){this._connectionTokens[D]=A}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(D){if(this._delegate)return this._delegate(D);const A=D.authority;let k=this._hosts[A];k&&k.indexOf(":")!==-1&&k.indexOf("[")===-1&&(k=`[${k}]`);const E=this._ports[A],_=this._connectionTokens[A];let w=`path=${encodeURIComponent(D.path)}`;return typeof _=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(_)}`),t.URI.from({scheme:c.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${k}:${E}`,path:this._remoteResourcesPath,query:w})}}e.RemoteAuthorities=new P;class y{asBrowserUri(D,A){const k=this.toUri(D,A);return k.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===I.file&&(c.isNative||c.isWebWorker&&c.globals.origin===`${I.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?k.with({scheme:I.vscodeFileResource,authority:k.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(D,A){const k=this.toUri(D,A);return k.scheme===I.vscodeFileResource?k.with({scheme:I.file,authority:k.authority!==y.FALLBACK_AUTHORITY?k.authority:null,query:null,fragment:null}):k}toUri(D,A){return t.URI.isUri(D)?D:t.URI.parse(A.toUrl(D))}}y.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new y;var T;(function(S){const D=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(D.get("3"));const A="vscode-coi";function k(_){let w;typeof _=="string"?w=new URL(_).searchParams:_ instanceof URL?w=_.searchParams:t.URI.isUri(_)&&(w=new URL(_.toString(!0)).searchParams);const f=w?.get(A);if(!!f)return D.get(f)}S.getHeadersFromQuery=k;function E(_,w,f){if(!globalThis.crossOriginIsolated)return;const g=w&&f?"3":f?"2":"1";_ instanceof URLSearchParams?_.set(A,g):_[A]=g}S.addSearchParam=E})(T=e.COI||(e.COI={}))}),define(_e[22],ye([1,0,32,14,9,12,8,2]),function(Z,e,c,t,I,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(_){return(0,T.uriToFsPath)(_,!0)}e.originalFSPath=S;class D{constructor(w){this._ignorePathCasing=w}compare(w,f,g=!1){return w===f?0:(0,y.compare)(this.getComparisonKey(w,g),this.getComparisonKey(f,g))}isEqual(w,f,g=!1){return w===f?!0:!w||!f?!1:this.getComparisonKey(w,g)===this.getComparisonKey(f,g)}getComparisonKey(w,f=!1){return w.with({path:this._ignorePathCasing(w)?w.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(w){return this._ignorePathCasing(w)}isEqualOrParent(w,f,g=!1){if(w.scheme===f.scheme){if(w.scheme===t.Schemas.file)return c.isEqualOrParent(S(w),S(f),this._ignorePathCasing(w))&&w.query===f.query&&(g||w.fragment===f.fragment);if((0,e.isEqualAuthority)(w.authority,f.authority))return c.isEqualOrParent(w.path,f.path,this._ignorePathCasing(w),"/")&&w.query===f.query&&(g||w.fragment===f.fragment)}return!1}joinPath(w,...f){return T.URI.joinPath(w,...f)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return I.posix.basename(w.path)}extname(w){return I.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let f;return w.scheme===t.Schemas.file?f=T.URI.file(I.dirname(S(w))).path:(f=I.posix.dirname(w.path),w.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),f="/")),w.with({path:f})}normalizePath(w){if(!w.path.length)return w;let f;return w.scheme===t.Schemas.file?f=T.URI.file(I.normalize(S(w))).path:f=I.posix.normalize(w.path),w.with({path:f})}relativePath(w,f){if(w.scheme!==f.scheme||!(0,e.isEqualAuthority)(w.authority,f.authority))return;if(w.scheme===t.Schemas.file){const v=I.relative(S(w),S(f));return P.isWindows?c.toSlashes(v):v}let g=w.path||"/";const h=f.path||"/";if(this._ignorePathCasing(w)){let v=0;for(const m=Math.min(g.length,h.length);v<m&&!(g.charCodeAt(v)!==h.charCodeAt(v)&&g.charAt(v).toLowerCase()!==h.charAt(v).toLowerCase());v++);g=h.substr(0,v)+g.substr(v)}return I.posix.relative(g,h)}resolvePath(w,f){if(w.scheme===t.Schemas.file){const g=T.URI.file(I.resolve(S(w),f));return w.with({authority:g.authority,path:g.path})}return f=c.toPosixPath(f),w.with({path:I.posix.resolve(w.path,f)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,f){return w===f||w!==void 0&&f!==void 0&&(0,y.equalsIgnoreCase)(w,f)}hasTrailingPathSeparator(w,f=I.sep){if(w.scheme===t.Schemas.file){const g=S(w);return g.length>c.getRoot(g).length&&g[g.length-1]===f}else{const g=w.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,f=I.sep){return(0,e.hasTrailingPathSeparator)(w,f)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,f=I.sep){let g=!1;if(w.scheme===t.Schemas.file){const h=S(w);g=h!==void 0&&h.length===c.getRoot(h).length&&h[h.length-1]===f}else{f="/";const h=w.path;g=h.length===1&&h.charCodeAt(h.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(w,f)?w.with({path:w.path+"/"}):w}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(_=>_.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new D(_=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(_,w){const f=[];for(let g=0;g<_.length;g++){const h=w(_[g]);_.some((v,m)=>m===g?!1:(0,e.isEqualOrParent)(h,w(v)))||f.push(_[g])}return f}e.distinctParents=A;var k;(function(_){_.META_DATA_LABEL="label",_.META_DATA_DESCRIPTION="description",_.META_DATA_SIZE="size",_.META_DATA_MIME="mime";function w(f){const g=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(m=>{const[r,b]=m.split(":");r&&b&&g.set(r,b)});const v=f.path.substring(0,f.path.indexOf(";"));return v&&g.set(_.META_DATA_MIME,v),g}_.parseMetaData=w})(k=e.DataUri||(e.DataUri={}));function E(_,w,f){if(w){let g=_.path;return g&&g[0]!==I.posix.sep&&(g=I.posix.sep+g),_.with({scheme:f,authority:w,path:g})}return _.with({scheme:f})}e.toLocalResource=E}),define(_e[18],ye([1,0,21,10,4,6,22,12]),function(Z,e,c,t,I,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(de){return!!de&&typeof de.then=="function"}e.isThenable=S;function D(de){const Y=new c.CancellationTokenSource,pe=de(Y.token),be=new Promise((Ce,Re)=>{const We=Y.token.onCancellationRequested(()=>{We.dispose(),Y.dispose(),Re(new t.CancellationError)});Promise.resolve(pe).then(ne=>{We.dispose(),Y.dispose(),Ce(ne)},ne=>{We.dispose(),Y.dispose(),Re(ne)})});return new class{cancel(){Y.cancel()}then(Ce,Re){return be.then(Ce,Re)}catch(Ce){return this.then(void 0,Ce)}finally(Ce){return be.finally(Ce)}}}e.createCancelablePromise=D;function A(de,Y,pe){return new Promise((be,Ce)=>{const Re=Y.onCancellationRequested(()=>{Re.dispose(),be(pe)});de.then(be,Ce).finally(()=>Re.dispose())})}e.raceCancellation=A;function k(de,Y){return new Promise((pe,be)=>{const Ce=Y.onCancellationRequested(()=>{Ce.dispose(),be(new t.CancellationError)});de.then(pe,be).finally(()=>Ce.dispose())})}e.raceCancellationError=k;async function E(de){let Y=-1;const pe=de.map((Ce,Re)=>Ce.then(We=>(Y=Re,We))),be=await Promise.race(pe);return de.forEach((Ce,Re)=>{Re!==Y&&Ce.cancel()}),be}e.raceCancellablePromises=E;function _(de,Y,pe){let be;const Ce=setTimeout(()=>{be?.(void 0),pe?.()},Y);return Promise.race([de.finally(()=>clearTimeout(Ce)),new Promise(Re=>be=Re)])}e.raceTimeout=_;function w(de){return new Promise((Y,pe)=>{const be=de();S(be)?be.then(Y,pe):Y(be)})}e.asPromise=w;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const pe=()=>{this.queuedPromise=null;const be=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,be};this.queuedPromise=new Promise(be=>{this.activePromise.then(pe,pe).then(be)})}return new Promise((pe,be)=>{this.queuedPromise.then(pe,be)})}return this.activePromise=Y(),new Promise((pe,be)=>{this.activePromise.then(Ce=>{this.activePromise=null,pe(Ce)},Ce=>{this.activePromise=null,be(Ce)})})}}e.Throttler=f;class g{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=g;class h{constructor(){this.promiseMap=new Map}queue(Y,pe){const Ce=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.promiseMap.get(Y)===Ce&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,Ce),Ce}}e.SequencerByKey=h;const v=(de,Y)=>{let pe=!0;const be=setTimeout(()=>{pe=!1,Y()},de);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(be),pe=!1}}},m=de=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,de())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class r{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,pe=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ce,Re)=>{this.doResolve=Ce,this.doReject=Re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ce=this.task;return this.task=null,Ce()}}));const be=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=pe===e.MicrotaskDelay?m(be):v(pe,be),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=r;class b{constructor(Y){this.delayer=new r(Y),this.throttler=new f}trigger(Y,pe){return this.delayer.trigger(()=>this.throttler.queue(Y),pe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class s{constructor(){this._isOpen=!1,this._promise=new Promise((Y,pe)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class u extends s{constructor(Y){super(),this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function o(de,Y){return Y?new Promise((pe,be)=>{const Ce=setTimeout(()=>{Re.dispose(),pe()},de),Re=Y.onCancellationRequested(()=>{clearTimeout(Ce),Re.dispose(),be(new t.CancellationError)})}):D(pe=>o(de,pe))}e.timeout=o;function l(de,Y=0){const pe=setTimeout(de,Y);return(0,P.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=l;function a(de){const Y=[];let pe=0;const be=de.length;function Ce(){return pe<be?de[pe++]():null}function Re(We){We!=null&&Y.push(We);const ne=Ce();return ne?ne.then(Re):Promise.resolve(Y)}return Promise.resolve(null).then(Re)}e.sequence=a;function d(de,Y=be=>!!be,pe=null){let be=0;const Ce=de.length,Re=()=>{if(be>=Ce)return Promise.resolve(pe);const We=de[be++];return Promise.resolve(We()).then(ce=>Y(ce)?Promise.resolve(ce):Re())};return Re()}e.first=d;function n(de,Y=be=>!!be,pe=null){if(de.length===0)return Promise.resolve(pe);let be=de.length;const Ce=()=>{be=-1;for(const Re of de)Re.cancel?.()};return new Promise((Re,We)=>{for(const ne of de)ne.then(ce=>{--be>=0&&Y(ce)?(Ce(),Re(ce)):be===0&&Re(pe)}).catch(ce=>{--be>=0&&(Ce(),We(ce))})})}e.firstParallel=n;class i{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new I.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Y){return this._size++,new Promise((pe,be)=>{this.outstandingPromises.push({factory:Y,c:pe,e:be}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const pe=Y.factory();pe.then(Y.c,Y.e),pe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=i;class p extends i{constructor(){super(1)}}e.Queue=p;class C{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new j;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,pe=y.extUri){const be=pe.getComparisonKey(Y);let Ce=this.queues.get(be);return Ce||(Ce=new p,I.Event.once(Ce.onDrained)(()=>{Ce?.dispose(),this.queues.delete(be),this.onDidQueueDrain()}),this.queues.set(be,Ce)),Ce}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=C;class R{constructor(Y,pe){this._token=-1,typeof Y=="function"&&typeof pe=="number"&&this.setIfNotSet(Y,pe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,pe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},pe)}setIfNotSet(Y,pe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},pe))}}e.TimeoutTimer=R;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,pe){this.cancel(),this._token=setInterval(()=>{Y()},pe)}}e.IntervalTimer=U;class H{constructor(Y,pe){this.timeoutToken=-1,this.runner=Y,this.timeout=pe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=H;class V{constructor(Y,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=pe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=V;class L extends H{constructor(Y,pe){super(Y,pe),this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner?.(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L;class M extends P.Disposable{constructor(Y,pe){super(),this.options=Y,this.handler=pe,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new H(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=de=>{(0,T.setTimeout0)(()=>{if(Y)return;const pe=Date.now()+15;de(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(de,Y)=>{const pe=requestIdleCallback(de,typeof Y=="number"?{timeout:Y}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(pe))}}}}();class F{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(pe){this._error=pe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function B(de,Y,pe){let be;for(let Ce=0;Ce<pe;Ce++)try{return await de()}catch(Re){be=Re,await o(Y)}throw be}e.retry=B;class N{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Y,pe,be){return this._pending={taskId:Y,cancel:()=>be?.(),promise:pe},pe.then(()=>this.donePending(Y),()=>this.donePending(Y)),pe}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let pe,be;const Ce=new Promise((Re,We)=>{pe=Re,be=We});this._next={run:Y,promise:Ce,promiseResolve:pe,promiseReject:be}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=N;class z{constructor(Y,pe=()=>Date.now()){this.interval=Y,this.nowFn=pe,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class j{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,pe)=>{this.completeCallback=Y,this.errorCallback=pe})}complete(Y){return new Promise(pe=>{this.completeCallback(Y),this.resolved=!0,pe()})}error(Y){return new Promise(pe=>{this.errorCallback(Y),this.rejected=!0,pe()})}cancel(){new Promise(Y=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=j;var x;(function(de){async function Y(be){let Ce;const Re=await Promise.all(be.map(We=>We.then(ne=>ne,ne=>{Ce||(Ce=ne)})));if(typeof Ce<"u")throw Ce;return Re}de.settled=Y;function pe(be){return new Promise(async(Ce,Re)=>{try{await be(Ce,Re)}catch(We){Re(We)}})}de.withAsyncBody=pe})(x=e.Promises||(e.Promises={}));var Q;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(Q||(Q={}));class K{static fromArray(Y){return new K(pe=>{pe.emitMany(Y)})}static fromPromise(Y){return new K(async pe=>{pe.emitMany(await Y)})}static fromPromises(Y){return new K(async pe=>{await Promise.all(Y.map(async be=>pe.emitOne(await be)))})}static merge(Y){return new K(async pe=>{await Promise.all(Y.map(async be=>{for await(const Ce of be)pe.emitOne(Ce)}))})}constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const pe={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(Y(pe)),this.resolve()}catch(be){this.reject(be)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,pe){return new K(async be=>{for await(const Ce of Y)be.emitOne(pe(Ce))})}map(Y){return K.map(this,Y)}static filter(Y,pe){return new K(async be=>{for await(const Ce of Y)pe(Ce)&&be.emitOne(Ce)})}filter(Y){return K.filter(this,Y)}static coalesce(Y){return K.filter(Y,pe=>!!pe)}coalesce(){return K.coalesce(this)}static async toPromise(Y){const pe=[];for await(const be of Y)pe.push(be);return pe}toPromise(){return K.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=K,K.EMPTY=K.fromArray([]);class le extends K{constructor(Y,pe){super(pe),this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=le;function ie(de){const Y=new c.CancellationTokenSource,pe=de(Y.token);return new le(Y,async be=>{const Ce=Y.token.onCancellationRequested(()=>{Ce.dispose(),Y.dispose(),be.reject(new t.CancellationError)});try{for await(const Re of pe){if(Y.token.isCancellationRequested)return;be.emitOne(Re)}Ce.dispose(),Y.dispose()}catch(Re){Ce.dispose(),Y.dispose(),be.reject(Re)}})}e.createCancelableAsyncIterable=ie}),define(_e[108],ye([1,0,18,9]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new c.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),P=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(p,C,R=!1){const U=p||"",H=C||"",V=I.value.collator.compare(U,H);return I.value.collatorIsNumeric&&V===0&&U!==H?U<H?-1:1:V}e.compareFileNames=T;function S(p,C){const R=P.value.collator;return p=p||"",C=C||"",b(R,p,C)}e.compareFileNamesDefault=S;function D(p,C){const R=P.value.collator;return p=p||"",C=C||"",l(p,C)||b(R,p,C)}e.compareFileNamesUpper=D;function A(p,C){const R=P.value.collator;return p=p||"",C=C||"",o(p,C)||b(R,p,C)}e.compareFileNamesLower=A;function k(p,C){return p=p||"",C=C||"",p===C?0:p<C?-1:1}e.compareFileNamesUnicode=k;function E(p,C,R=!1){R||(p=p&&p.toLowerCase(),C=C&&C.toLowerCase());const[U,H]=m(p),[V,L]=m(C);return U!==V?U<V?-1:1:H===L?0:H<L?-1:1}e.noIntlCompareFileNames=E;function _(p,C){const[R,U]=m(p),[H,V]=m(C);let L=I.value.collator.compare(U,V);if(L===0){if(I.value.collatorIsNumeric&&U!==V)return U<V?-1:1;if(L=I.value.collator.compare(R,H),I.value.collatorIsNumeric&&L===0&&R!==H)return R<H?-1:1}return L}e.compareFileExtensions=_;function w(p,C){p=p||"",C=C||"";const R=r(p),U=r(C),H=P.value.collator,V=y.value.collator;return b(V,R,U)||b(H,p,C)}e.compareFileExtensionsDefault=w;function f(p,C){p=p||"",C=C||"";const R=r(p),U=r(C),H=P.value.collator,V=y.value.collator;return b(V,R,U)||l(p,C)||b(H,p,C)}e.compareFileExtensionsUpper=f;function g(p,C){p=p||"",C=C||"";const R=r(p),U=r(C),H=P.value.collator,V=y.value.collator;return b(V,R,U)||o(p,C)||b(H,p,C)}e.compareFileExtensionsLower=g;function h(p,C){p=p||"",C=C||"";const R=r(p).toLowerCase(),U=r(C).toLowerCase();return R!==U?R<U?-1:1:p!==C?p<C?-1:1:0}e.compareFileExtensionsUnicode=h;const v=/^(.*?)(\.([^.]*))?$/;function m(p,C=!1){const R=p?v.exec(p):[];let U=[R&&R[1]||"",R&&R[3]||""];return C&&(!U[0]&&U[1]||U[0]&&U[0].charAt(0)===".")&&(U=[U[0]+"."+U[1],""]),U}function r(p){const C=p?v.exec(p):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function b(p,C,R){const U=p.compare(C,R);return U!==0?U:C.length!==R.length?C.length<R.length?-1:1:0}function s(p){const C=p.charAt(0);return C.toLocaleUpperCase()!==C}function u(p){const C=p.charAt(0);return C.toLocaleLowerCase()!==C}function o(p,C){return s(p)&&u(C)?-1:u(p)&&s(C)?1:0}function l(p,C){return u(p)&&s(C)?-1:s(p)&&u(C)?1:0}function a(p,C,R=!1){return R||(p=p&&p.toLowerCase(),C=C&&C.toLowerCase()),p===C?0:p<C?-1:1}function d(p,C,R=!1){const U=p.split(t.sep),H=C.split(t.sep),V=U.length-1,L=H.length-1;let M,F;for(let B=0;;B++){if(M=V===B,F=L===B,M&&F)return T(U[B],H[B],R);if(M)return-1;if(F)return 1;const N=a(U[B],H[B],R);if(N!==0)return N}}e.comparePaths=d;function n(p,C,R){const U=p.toLowerCase(),H=C.toLowerCase(),V=i(p,C,R);if(V)return V;const L=U.endsWith(R),M=H.endsWith(R);if(L!==M)return L?-1:1;const F=T(U,H);return F!==0?F:U.localeCompare(H)}e.compareAnything=n;function i(p,C,R){const U=p.toLowerCase(),H=C.toLowerCase(),V=U.startsWith(R),L=H.startsWith(R);if(V!==L)return V?-1:1;if(V&&L){if(U.length<H.length)return-1;if(U.length>H.length)return 1}return 0}e.compareByPrefix=i}),define(_e[109],ye([1,0,108,107,81,9,12,8]),function(Z,e,c,t,I,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,D=[S,[]];function A(N,z,j,x){if(!N||!z)return D;const Q=N.length,K=z.length;if(Q<K)return D;const le=N.toLowerCase();return k(z,j,K,N,le,Q,x)}e.scoreFuzzy=A;function k(N,z,j,x,Q,K,le){const ie=[],de=[];for(let Ce=0;Ce<j;Ce++){const Re=Ce*K,We=Re-K,ne=Ce>0,ce=N[Ce],fe=z[Ce];for(let J=0;J<K;J++){const re=J>0,ee=Re+J,O=ee-1,W=We+J-1,q=re?ie[O]:0,X=ne&&re?ie[W]:0,ae=ne&&re?de[W]:0;let ve;!X&&ne?ve=0:ve=E(ce,fe,x,Q,J,ae),ve&&X+ve>=q&&(le||ne||Q.startsWith(z,J))?(de[ee]=ae+1,ie[ee]=X+ve):(de[ee]=S,ie[ee]=q)}}const Y=[];let pe=j-1,be=K-1;for(;pe>=0&&be>=0;){const Ce=pe*K+be;de[Ce]===S||(Y.push(be),pe--),be--}return[ie[j*K-1],Y.reverse()]}function E(N,z,j,x,Q,K){let le=0;if(!_(z,x[Q]))return le;if(le+=1,K>0&&(le+=K*5),N===j[Q]&&(le+=1),Q===0)le+=8;else{const ie=w(j.charCodeAt(Q-1));ie?le+=ie:(0,t.isUpper)(j.charCodeAt(Q))&&K===0&&(le+=2)}return le}function _(N,z){return N===z?!0:N==="/"||N==="\\"?z==="/"||z==="\\":!1}function w(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const f=[void 0,[]];function g(N,z,j=0,x=0){const Q=z;return Q.values&&Q.values.length>1?h(N,Q.values,j,x):v(N,z,j,x)}e.scoreFuzzy2=g;function h(N,z,j,x){let Q=0;const K=[];for(const le of z){const[ie,de]=v(N,le,j,x);if(typeof ie!="number")return f;Q+=ie,K.push(...de)}return[Q,i(K)]}function v(N,z,j,x){const Q=(0,t.fuzzyScore)(z.original,z.originalLowercase,j,N,N.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,t.createMatches)(Q)]:f}const m=Object.freeze({score:0}),r=1<<18,b=1<<17,s=1<<16;function u(N,z,j,x){const Q=x.values?x.values:[x];return(0,I.hash)({[x.normalized]:{values:Q.map(le=>({value:le.normalized,expectContiguousMatch:le.expectContiguousMatch})),label:N,description:z,allowNonContiguousMatches:j}})}function o(N,z,j,x,Q){if(!N||!z.normalized)return m;const K=x.getItemLabel(N);if(!K)return m;const le=x.getItemDescription(N),ie=u(K,le,j,z),de=Q[ie];if(de)return de;const Y=l(K,le,x.getItemPath(N),z,j);return Q[ie]=Y,Y}e.scoreItemFuzzy=o;function l(N,z,j,x,Q){const K=!j||!x.containsPathSeparator;return j&&(y.isLinux?x.pathNormalized===j:(0,T.equalsIgnoreCase)(x.pathNormalized,j))?{score:r,labelMatch:[{start:0,end:N.length}],descriptionMatch:z?[{start:0,end:z.length}]:void 0}:x.values&&x.values.length>1?a(N,z,j,x.values,K,Q):d(N,z,j,x,K,Q)}function a(N,z,j,x,Q,K){let le=0;const ie=[],de=[];for(const Y of x){const{score:pe,labelMatch:be,descriptionMatch:Ce}=d(N,z,j,Y,Q,K);if(pe===S)return m;le+=pe,be&&ie.push(...be),Ce&&de.push(...Ce)}return{score:le,labelMatch:i(ie),descriptionMatch:i(de)}}function d(N,z,j,x,Q,K){if(Q||!z){const[le,ie]=A(N,x.normalized,x.normalizedLowercase,K&&!x.expectContiguousMatch);if(le){const de=(0,t.matchesPrefix)(x.normalized,N);let Y;return de?(Y=b,Y+=Math.round(x.normalized.length/N.length*100)):Y=s,{score:Y+le,labelMatch:de||n(ie)}}}if(z){let le=z;j&&(le=`${z}${P.sep}`);const ie=le.length,de=`${le}${N}`,[Y,pe]=A(de,x.normalized,x.normalizedLowercase,K&&!x.expectContiguousMatch);if(Y){const be=n(pe),Ce=[],Re=[];return be.forEach(We=>{We.start<ie&&We.end>ie?(Ce.push({start:0,end:We.end-ie}),Re.push({start:We.start,end:ie})):We.start>=ie?Ce.push({start:We.start-ie,end:We.end-ie}):Re.push(We)}),{score:Y,labelMatch:Ce,descriptionMatch:Re}}}return m}function n(N){const z=[];if(!N)return z;let j;for(const x of N)j&&j.end===x?j.end+=1:(j={start:x,end:x+1},z.push(j));return z}function i(N){const z=N.sort((Q,K)=>Q.start-K.start),j=[];let x;for(const Q of z)!x||!p(x,Q)?(x=Q,j.push(Q)):(x.start=Math.min(x.start,Q.start),x.end=Math.max(x.end,Q.end));return j}function p(N,z){return!(N.end<z.start||z.end<N.start)}function C(N,z,j,x,Q,K){const le=o(N,j,x,Q,K),ie=o(z,j,x,Q,K),de=le.score,Y=ie.score;if((de===r||Y===r)&&de!==Y)return de===r?-1:1;if(de>s||Y>s){if(de!==Y)return de>Y?-1:1;if(de<b&&Y<b){const ce=U(le.labelMatch,ie.labelMatch);if(ce!==0)return ce}const We=Q.getItemLabel(N)||"",ne=Q.getItemLabel(z)||"";if(We.length!==ne.length)return We.length-ne.length}if(de!==Y)return de>Y?-1:1;const pe=Array.isArray(le.labelMatch)&&le.labelMatch.length>0,be=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0;if(pe&&!be)return-1;if(be&&!pe)return 1;const Ce=R(N,le,Q),Re=R(z,ie,Q);return Ce&&Re&&Ce!==Re?Re>Ce?-1:1:H(N,z,j,Q)}e.compareItemsByFuzzyScore=C;function R(N,z,j){let x=-1,Q=-1;if(z.descriptionMatch&&z.descriptionMatch.length?x=z.descriptionMatch[0].start:z.labelMatch&&z.labelMatch.length&&(x=z.labelMatch[0].start),z.labelMatch&&z.labelMatch.length){if(Q=z.labelMatch[z.labelMatch.length-1].end,z.descriptionMatch&&z.descriptionMatch.length){const K=j.getItemDescription(N);K&&(Q+=K.length)}}else z.descriptionMatch&&z.descriptionMatch.length&&(Q=z.descriptionMatch[z.descriptionMatch.length-1].end);return Q-x}function U(N,z){if(!N&&!z||(!N||!N.length)&&(!z||!z.length))return 0;if(!z||!z.length)return-1;if(!N||!N.length)return 1;const j=N[0].start,Q=N[N.length-1].end-j,K=z[0].start,ie=z[z.length-1].end-K;return Q===ie?0:ie<Q?1:-1}function H(N,z,j,x){const Q=x.getItemLabel(N)||"",K=x.getItemLabel(z)||"",le=x.getItemDescription(N),ie=x.getItemDescription(z),de=Q.length+(le?le.length:0),Y=K.length+(ie?ie.length:0);if(de!==Y)return de-Y;const pe=x.getItemPath(N),be=x.getItemPath(z);return pe&&be&&pe.length!==be.length?pe.length-be.length:Q!==K?(0,c.compareAnything)(Q,K,j.normalized):le&&ie&&le!==ie?(0,c.compareAnything)(le,ie,j.normalized):pe&&be&&pe!==be?(0,c.compareAnything)(pe,be,j.normalized):0}function V(N){return N.startsWith('"')&&N.endsWith('"')}const L=" ";function M(N){typeof N!="string"&&(N="");const z=N.toLowerCase(),{pathNormalized:j,normalized:x,normalizedLowercase:Q}=F(N),K=j.indexOf(P.sep)>=0,le=V(N);let ie;const de=N.split(L);if(de.length>1)for(const Y of de){const pe=V(Y),{pathNormalized:be,normalized:Ce,normalizedLowercase:Re}=F(Y);Ce&&(ie||(ie=[]),ie.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:be,normalized:Ce,normalizedLowercase:Re,expectContiguousMatch:pe}))}return{original:N,originalLowercase:z,pathNormalized:j,normalized:x,normalizedLowercase:Q,values:ie,containsPathSeparator:K,expectContiguousMatch:le}}e.prepareQuery=M;function F(N){let z;y.isWindows?z=N.replace(/\//g,P.sep):z=N.replace(/\\/g,P.sep);const j=(0,T.stripWildcards)(z).replace(/\s|"/g,"");return{pathNormalized:z,normalized:j,normalizedLowercase:j.toLowerCase()}}function B(N){return Array.isArray(N)?M(N.map(z=>z.original).join(L)):M(N.original)}e.pieceToQuery=B}),define(_e[37],ye([1,0,17,18,32,28,9,12,8]),function(Z,e,c,t,I,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const A="[/\\\\]",k="[^/\\\\]",E=/\//g;function _(j,x){switch(j){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${x?`|${A}${k}+`:""})*?`}}function w(j,x){if(!j)return[];const Q=[];let K=!1,le=!1,ie="";for(const de of j){switch(de){case x:if(!K&&!le){Q.push(ie),ie="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":le=!0;break;case"]":le=!1;break}ie+=de}return ie&&Q.push(ie),Q}e.splitGlobAware=w;function f(j){if(!j)return"";let x="";const Q=w(j,e.GLOB_SPLIT);if(Q.every(K=>K===e.GLOBSTAR))x=".*";else{let K=!1;Q.forEach((le,ie)=>{if(le===e.GLOBSTAR){if(K)return;x+=_(2,ie===Q.length-1)}else{let de=!1,Y="",pe=!1,be="";for(const Ce of le){if(Ce!=="}"&&de){Y+=Ce;continue}if(pe&&(Ce!=="]"||!be)){let Re;Ce==="-"?Re=Ce:(Ce==="^"||Ce==="!")&&!be?Re="^":Ce===e.GLOB_SPLIT?Re="":Re=(0,S.escapeRegExpCharacters)(Ce),be+=Re;continue}switch(Ce){case"{":de=!0;continue;case"[":pe=!0;continue;case"}":{x+=`(?:${w(Y,",").map(ne=>f(ne)).join("|")})`,de=!1,Y="";break}case"]":{x+="["+be+"]",pe=!1,be="";break}case"?":x+=k;continue;case"*":x+=_(1);continue;default:x+=(0,S.escapeRegExpCharacters)(Ce)}}ie<Q.length-1&&(Q[ie+1]!==e.GLOBSTAR||ie+2<Q.length)&&(x+=A)}K=le===e.GLOBSTAR})}return x}const g=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new P.LRUCache(1e4),u=function(){return!1},o=function(){return null};function l(j,x){if(!j)return o;let Q;typeof j!="string"?Q=j.pattern:Q=j,Q=Q.trim();const K=`${Q}_${!!x.trimForExclusions}`;let le=s.get(K);if(le)return a(le,j);let ie;return g.test(Q)?le=n(Q.substr(4),Q):(ie=h.exec(d(Q,x)))?le=i(ie[1],Q):(x.trimForExclusions?m:v).test(Q)?le=p(Q,x):(ie=r.exec(d(Q,x)))?le=C(ie[1].substr(1),Q,!0):(ie=b.exec(d(Q,x)))?le=C(ie[1],Q,!1):le=R(Q),s.set(K,le),a(le,j)}function a(j,x){if(typeof x=="string")return j;const Q=function(K,le){return(0,I.isEqualOrParent)(K,x.base,!T.isLinux)?j(K.substr(x.base.length+1),le):null};return Q.allBasenames=j.allBasenames,Q.allPaths=j.allPaths,Q.basenames=j.basenames,Q.patterns=j.patterns,Q}function d(j,x){return x.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function n(j,x){return function(Q,K){return typeof Q=="string"&&Q.endsWith(j)?x:null}}function i(j,x){const Q=`/${j}`,K=`\\${j}`,le=function(de,Y){return typeof de!="string"?null:Y?Y===j?x:null:de===j||de.endsWith(Q)||de.endsWith(K)?x:null},ie=[j];return le.basenames=ie,le.patterns=[x],le.allBasenames=ie,le}function p(j,x){const Q=N(j.slice(1,-1).split(",").map(Y=>l(Y,x)).filter(Y=>Y!==o),j),K=Q.length;if(!K)return o;if(K===1)return Q[0];const le=function(Y,pe){for(let be=0,Ce=Q.length;be<Ce;be++)if(Q[be](Y,pe))return j;return null},ie=Q.find(Y=>!!Y.allBasenames);ie&&(le.allBasenames=ie.allBasenames);const de=Q.reduce((Y,pe)=>pe.allPaths?Y.concat(pe.allPaths):Y,[]);return de.length&&(le.allPaths=de),le}function C(j,x,Q){const K=y.sep===y.posix.sep,le=K?j:j.replace(E,y.sep),ie=y.sep+le,de=y.posix.sep+j;let Y;return Q?Y=function(pe,be){return typeof pe=="string"&&(pe===le||pe.endsWith(ie)||!K&&(pe===j||pe.endsWith(de)))?x:null}:Y=function(pe,be){return typeof pe=="string"&&(pe===le||!K&&pe===j)?x:null},Y.allPaths=[(Q?"*/":"./")+j],Y}function R(j){try{const x=new RegExp(`^${f(j)}$`);return function(Q){return x.lastIndex=0,typeof Q=="string"&&x.test(Q)?j:null}}catch{return o}}function U(j,x,Q){return!j||typeof x!="string"?!1:H(j)(x,void 0,Q)}e.match=U;function H(j,x={}){if(!j)return u;if(typeof j=="string"||V(j)){const Q=l(j,x);if(Q===o)return u;const K=function(le,ie){return!!Q(le,ie)};return Q.allBasenames&&(K.allBasenames=Q.allBasenames),Q.allPaths&&(K.allPaths=Q.allPaths),K}return F(j,x)}e.parse=H;function V(j){const x=j;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=V;function L(j){return j.allBasenames||[]}e.getBasenameTerms=L;function M(j){return j.allPaths||[]}e.getPathTerms=M;function F(j,x){const Q=N(Object.getOwnPropertyNames(j).map(Y=>B(Y,j[Y],x)).filter(Y=>Y!==o)),K=Q.length;if(!K)return o;if(!Q.some(Y=>!!Y.requiresSiblings)){if(K===1)return Q[0];const Y=function(Ce,Re){let We;for(let ne=0,ce=Q.length;ne<ce;ne++){const fe=Q[ne](Ce,Re);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(We||(We=[]),We.push(fe))}return We?(async()=>{for(const ne of We){const ce=await ne;if(typeof ce=="string")return ce}return null})():null},pe=Q.find(Ce=>!!Ce.allBasenames);pe&&(Y.allBasenames=pe.allBasenames);const be=Q.reduce((Ce,Re)=>Re.allPaths?Ce.concat(Re.allPaths):Ce,[]);return be.length&&(Y.allPaths=be),Y}const le=function(Y,pe,be){let Ce,Re;for(let We=0,ne=Q.length;We<ne;We++){const ce=Q[We];ce.requiresSiblings&&be&&(pe||(pe=(0,y.basename)(Y)),Ce||(Ce=pe.substr(0,pe.length-(0,y.extname)(Y).length)));const fe=ce(Y,pe,Ce,be);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(Re||(Re=[]),Re.push(fe))}return Re?(async()=>{for(const We of Re){const ne=await We;if(typeof ne=="string")return ne}return null})():null},ie=Q.find(Y=>!!Y.allBasenames);ie&&(le.allBasenames=ie.allBasenames);const de=Q.reduce((Y,pe)=>pe.allPaths?Y.concat(pe.allPaths):Y,[]);return de.length&&(le.allPaths=de),le}function B(j,x,Q){if(x===!1)return o;const K=l(j,Q);if(K===o)return o;if(typeof x=="boolean")return K;if(x){const le=x.when;if(typeof le=="string"){const ie=(de,Y,pe,be)=>{if(!be||!K(de,Y))return null;const Ce=le.replace("$(basename)",pe),Re=be(Ce);return(0,t.isThenable)(Re)?Re.then(We=>We?j:null):Re?j:null};return ie.requiresSiblings=!0,ie}}return K}function N(j,x){const Q=j.filter(Y=>!!Y.basenames);if(Q.length<2)return j;const K=Q.reduce((Y,pe)=>{const be=pe.basenames;return be?Y.concat(be):Y},[]);let le;if(x){le=[];for(let Y=0,pe=K.length;Y<pe;Y++)le.push(x)}else le=Q.reduce((Y,pe)=>{const be=pe.patterns;return be?Y.concat(be):Y},[]);const ie=function(Y,pe){if(typeof Y!="string")return null;if(!pe){let Ce;for(Ce=Y.length;Ce>0;Ce--){const Re=Y.charCodeAt(Ce-1);if(Re===47||Re===92)break}pe=Y.substr(Ce)}const be=K.indexOf(pe);return be!==-1?le[be]:null};ie.basenames=K,ie.patterns=le,ie.allBasenames=K;const de=j.filter(Y=>!Y.basenames);return de.push(ie),de}function z(j,x){return(0,c.equals)(j,x,(Q,K)=>typeof Q=="string"&&typeof K=="string"?Q===K:typeof Q!="string"&&typeof K!="string"?Q.base===K.base&&Q.pattern===K.pattern:!1)}e.patternsEquals=z}),define(_e[110],ye([1,0,10,158,22,8,2]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(h="",v=!1){if(this.value=h,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(h,v=0){return this.value+=E(this.supportThemeIcons?(0,t.escapeIcons)(h):h).replace(/([ \t]+)/g,(m,r)=>"&nbsp;".repeat(r.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,v){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(h,v,m){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(h),")"),m&&(this.value+=` "${this._escape(this._escape(m,'"'),")")}"`),this.value+=")",this}_escape(h,v){const m=new RegExp((0,P.escapeRegExpCharacters)(v),"g");return h.replace(m,(r,b)=>h.charAt(b-1)!=="\\"?`\\${r}`:r)}}e.MarkdownString=S;function D(g){return A(g)?!g.value:Array.isArray(g)?g.every(D):!0}e.isEmptyMarkdownString=D;function A(g){return g instanceof S?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}e.isMarkdownString=A;function k(g,h){return g===h?!0:!g||!h?!1:g.value===h.value&&g.isTrusted===h.isTrusted&&g.supportThemeIcons===h.supportThemeIcons&&g.supportHtml===h.supportHtml&&(g.baseUri===h.baseUri||!!g.baseUri&&!!h.baseUri&&(0,I.isEqual)(y.URI.from(g.baseUri),y.URI.from(h.baseUri)))}e.markdownStringEqual=k;function E(g){return g.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function _(g){return g.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=_;function w(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=w;function f(g){const h=[],v=g.split("|").map(r=>r.trim());g=v[0];const m=v[1];if(m){const r=/height=(\d+)/.exec(m),b=/width=(\d+)/.exec(m),s=r?r[1]:"",u=b?b[1]:"",o=isFinite(parseInt(u)),l=isFinite(parseInt(s));o&&h.push(`width="${u}"`),l&&h.push(`height="${s}"`)}return{href:g,dimensions:h}}e.parseHrefAndDimensions=f}),define(_e[111],ye([1,0,17,32,9,12,22,8]),function(Z,e,c,t,I,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(o,l){const{os:a,tildify:d,relative:n}=l;if(n){const C=D(o,n,a);if(typeof C=="string")return C}let i=o.fsPath;if(a===1&&!P.isWindows?i=i.replace(/\//g,"\\"):a!==1&&P.isWindows&&(i=i.replace(/\\/g,"/")),a!==1&&d?.userHome){const C=d.userHome.fsPath;let R;o.scheme!==d.userHome.scheme&&o.path.startsWith(I.posix.sep)?R=d.userHome.with({path:o.path}).fsPath:R=o.fsPath,i=E(R,C,a)}return(a===1?I.win32:I.posix).normalize(A(i,a===1))}e.getPathLabel=S;function D(o,l,a){const d=a===1?I.win32:I.posix,n=a===3?y.extUri:y.extUriIgnorePathCase,i=l.getWorkspace(),p=(0,c.firstOrDefault)(i.folders);if(!p)return;o.scheme!==p.uri.scheme&&o.path.startsWith(I.posix.sep)&&(o=p.uri.with({path:o.path}));const C=l.getWorkspaceFolder(o);if(!C)return;let R;if(n.isEqual(C.uri,o)?R="":R=n.relativePath(C.uri,o)??"",R&&(R=d.normalize(R)),i.folders.length>1&&!l.noPrefix){const U=C.name?C.name:n.basenameOrAuthority(C.uri);R=R?`${U} \u2022 ${R}`:U}return R}function A(o,l=P.isWindows){return(0,t.hasDriveLetter)(o,l)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=A;let k=Object.create(null);function E(o,l,a=P.OS){if(a===1||!o||!l)return o;let d=k.original===l?k.normalized:void 0;d||(d=l,P.isWindows&&(d=(0,t.toSlashes)(d)),d=`${(0,T.rtrim)(d,I.posix.sep)}${I.posix.sep}`,k={original:l,normalized:d});let n=o;return P.isWindows&&(n=(0,t.toSlashes)(n)),(a===3?n.startsWith(d):(0,T.startsWithIgnoreCase)(n,d))?`~/${n.substr(d.length)}`:o}e.tildify=E;function _(o,l){return o.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=_;const w="\u2026",f="\\\\",g="~";function h(o,l=I.sep){const a=new Array(o.length);let d=!1;for(let n=0;n<o.length;n++){const i=o[n];if(i===""){a[n]=`.${l}`;continue}if(!i){a[n]=i;continue}d=!0;let p="",C=i;C.indexOf(f)===0?(p=C.substr(0,C.indexOf(f)+f.length),C=C.substr(C.indexOf(f)+f.length)):C.indexOf(l)===0?(p=C.substr(0,C.indexOf(l)+l.length),C=C.substr(C.indexOf(l)+l.length)):C.indexOf(g)===0&&(p=C.substr(0,C.indexOf(g)+g.length),C=C.substr(C.indexOf(g)+g.length));const R=C.split(l);for(let U=1;d&&U<=R.length;U++)for(let H=R.length-U;d&&H>=0;H--){d=!1;let V=R.slice(H,H+U).join(l);for(let L=0;!d&&L<o.length;L++)if(L!==n&&o[L]&&o[L].indexOf(V)>-1){const M=H+U===R.length,F=H>0&&o[L].indexOf(l)>-1?l+V:V,B=o[L].endsWith(F);d=!M||B}if(!d){let L="";(R[0].endsWith(":")||p!=="")&&(H===1&&(H=0,U++,V=R[0]+l+V),H>0&&(L=R[0]+l),L=p+L),H>0&&(L=L+w+l),L=L+V,H+U<R.length&&(L=L+l+w),a[n]=L}}d&&(a[n]=i)}return a}e.shorten=h;var v;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function m(o,l=Object.create(null)){const a=[];let d=!1,n="";for(const i of o)if(i==="$"||d&&i==="{")n&&a.push({value:n,type:v.TEXT}),n="",d=!0;else if(i==="}"&&d){const p=l[n];if(typeof p=="string")p.length&&a.push({value:p,type:v.VARIABLE});else if(p){const C=a[a.length-1];(!C||C.type!==v.SEPARATOR)&&a.push({value:p.label,type:v.SEPARATOR})}n="",d=!1}else n+=i;return n&&!d&&a.push({value:n,type:v.TEXT}),a.filter((i,p)=>{if(i.type===v.SEPARATOR){const C=a[p-1],R=a[p+1];return[C,R].every(U=>U&&(U.type===v.VARIABLE||U.type===v.TEXT)&&U.value.length>0)}return!0}).map(i=>i.value).join("")}e.template=m;function r(o,l){return P.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):o.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=r;function b(o,l){return P.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,""):P.isWindows?o.replace(/&&|&/g,a=>a==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=b;function s(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=s;function u(o){const l=o.indexOf("/")!==-1?I.posix:I.win32,a=l.basename(o),d=l.dirname(o);return a.length?{name:a,parentPath:d}:{name:d,parentPath:""}}e.splitName=u}),define(_e[112],ye([1,0,2]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(A){return A.toJSON()}class I{constructor(k){this._uriTransformer=k}transformIncoming(k){const E=this._uriTransformer.transformIncoming(k);return E===k?k:t(c.URI.from(E))}transformOutgoing(k){const E=this._uriTransformer.transformOutgoing(k);return E===k?k:t(c.URI.from(E))}transformOutgoingURI(k){const E=this._uriTransformer.transformOutgoing(k);return E===k?k:c.URI.from(E)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function P(A,k,E){if(!A||E>200)return null;if(typeof A=="object"){if(A instanceof c.URI)return k.transformOutgoing(A);for(const _ in A)if(Object.hasOwnProperty.call(A,_)){const w=P(A[_],k,E+1);w!==null&&(A[_]=w)}}return null}function y(A,k){const E=P(A,k,0);return E===null?A:E}e.transformOutgoingURIs=y;function T(A,k,E,_){if(!A||_>200)return null;if(typeof A=="object"){if(A.$mid===1)return E?c.URI.revive(k.transformIncoming(A)):k.transformIncoming(A);for(const w in A)if(Object.hasOwnProperty.call(A,w)){const f=T(A[w],k,E,_+1);f!==null&&(A[w]=f)}}return null}function S(A,k){const E=T(A,k,!1,0);return E===null?A:E}e.transformIncomingURIs=S;function D(A,k){const E=T(A,k,!0,0);return E===null?A:E}e.transformAndReviveIncomingURIs=D}),define(_e[29],ye([1,0,65,83,307,18,32,80,9,12,22,2]),function(Z,e,c,t,I,P,y,T,S,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function _(F,B=E.UNLINK){if((0,y.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return B===E.UNLINK?f(F):w(F)}async function w(F){try{const B=(0,y.randomPath)((0,t.tmpdir)());try{await c.promises.rename(F,B)}catch(N){return N.code==="ENOENT"?void 0:f(F)}f(B).catch(N=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function f(F){return(0,I.promisify)(c.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function g(F){if((0,y.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function h(F,B){return r(await(B?v(F):(0,I.promisify)(c.readdir)(F)))}async function v(F){try{return await(0,I.promisify)(c.readdir)(F,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const B=[],N=await h(F);for(const z of N){let j=!1,x=!1,Q=!1;try{const K=await e.Promises.lstat((0,S.join)(F,z));j=K.isFile(),x=K.isDirectory(),Q=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}B.push({name:z,isFile:()=>j,isDirectory:()=>x,isSymbolicLink:()=>Q})}return B}function m(F){return r(c.readdirSync(F))}e.readdirSync=m;function r(F){return F.map(B=>typeof B=="string"?D.isMacintosh?(0,T.normalizeNFC)(B):B:(B.name=D.isMacintosh?(0,T.normalizeNFC)(B.name):B.name,B))}async function b(F){const B=await h(F),N=[];for(const z of B)await u.existsDirectory((0,S.join)(F,z))&&N.push(z);return N}function s(F,B=1e3){return new Promise(N=>{let z=!1;const j=setInterval(()=>{z||(z=!0,c.access(F,x=>{z=!1,x&&(clearInterval(j),N(void 0))}))},B)})}e.whenDeleted=s;var u;(function(F){async function B(j){let x;try{if(x=await e.Promises.lstat(j),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(j),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(D.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw K}throw Q}}F.stat=B;async function N(j){try{const{stat:x,symbolicLink:Q}=await F.stat(j);return x.isFile()&&Q?.dangling!==!0}catch{}return!1}F.existsFile=N;async function z(j){try{const{stat:x,symbolicLink:Q}=await F.stat(j);return x.isDirectory()&&Q?.dangling!==!0}catch{}return!1}F.existsDirectory=z})(u=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new P.ResourceQueue;function l(F,B,N){return o.queueFor(k.URI.file(F),A.extUriBiasedIgnorePathCase).queue(()=>{const z=p(N);return new Promise((j,x)=>n(F,B,z,Q=>Q?x(Q):j()))})}let a=!0;function d(F){a=F}e.configureFlushOnWrite=d;function n(F,B,N,z){if(!a)return c.writeFile(F,B,{mode:N.mode,flag:N.flag},z);c.open(F,N.flag,N.mode,(j,x)=>{if(j)return z(j);c.writeFile(x,B,Q=>{if(Q)return c.close(x,()=>z(Q));c.fdatasync(x,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),d(!1)),c.close(x,le=>z(le))))})})}function i(F,B,N){const z=p(N);if(!a)return c.writeFileSync(F,B,{mode:z.mode,flag:z.flag});const j=c.openSync(F,z.flag,z.mode);try{c.writeFileSync(j,B);try{c.fdatasyncSync(j)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),d(!1)}}finally{c.closeSync(j)}}e.writeFileSync=i;function p(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function C(F,B){if(F!==B)try{await e.Promises.rename(F,B)}catch(N){if(F.toLowerCase()!==B.toLowerCase()&&N.code==="EXDEV"||F.endsWith("."))await R(F,B,{preserveSymlinks:!1}),await _(F,E.MOVE);else throw N}}async function R(F,B,N){return H(F,B,{root:{source:F,target:B},options:N,handledSourcePaths:new Set})}const U=511;async function H(F,B,N){if(N.handledSourcePaths.has(F))return;N.handledSourcePaths.add(F);const{stat:z,symbolicLink:j}=await u.stat(F);if(j){if(N.options.preserveSymlinks)try{return await M(F,B,N)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(j.dangling)return}return z.isDirectory()?V(F,B,z.mode&U,N):L(F,B,z.mode&U)}async function V(F,B,N,z){await e.Promises.mkdir(B,{recursive:!0,mode:N});const j=await h(F);for(const x of j)await H((0,S.join)(F,x),(0,S.join)(B,x),z)}async function L(F,B,N){await e.Promises.copyFile(F,B),await e.Promises.chmod(B,N)}async function M(F,B,N){let z=await e.Promises.readlink(F);(0,y.isEqualOrParent)(z,N.root.source,!D.isLinux)&&(z=(0,S.join)(N.root.target,z.substr(N.root.source.length+1))),await e.Promises.symlink(z,B)}e.Promises=new class{get access(){return(0,I.promisify)(c.access)}get stat(){return(0,I.promisify)(c.stat)}get lstat(){return(0,I.promisify)(c.lstat)}get utimes(){return(0,I.promisify)(c.utimes)}get read(){return(F,B,N,z,j)=>new Promise((x,Q)=>{c.read(F,B,N,z,j,(K,le,ie)=>K?Q(K):x({bytesRead:le,buffer:ie}))})}get readFile(){return(0,I.promisify)(c.readFile)}get write(){return(F,B,N,z,j)=>new Promise((x,Q)=>{c.write(F,B,N,z,j,(K,le,ie)=>K?Q(K):x({bytesWritten:le,buffer:ie}))})}get appendFile(){return(0,I.promisify)(c.appendFile)}get fdatasync(){return(0,I.promisify)(c.fdatasync)}get truncate(){return(0,I.promisify)(c.truncate)}get rename(){return(0,I.promisify)(c.rename)}get copyFile(){return(0,I.promisify)(c.copyFile)}get open(){return(0,I.promisify)(c.open)}get close(){return(0,I.promisify)(c.close)}get symlink(){return(0,I.promisify)(c.symlink)}get readlink(){return(0,I.promisify)(c.readlink)}get chmod(){return(0,I.promisify)(c.chmod)}get mkdir(){return(0,I.promisify)(c.mkdir)}get unlink(){return(0,I.promisify)(c.unlink)}get rmdir(){return(0,I.promisify)(c.rmdir)}get realpath(){return(0,I.promisify)(c.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return b}get writeFile(){return l}get rm(){return _}get move(){return C}get copy(){return R}}}),define(_e[113],ye([1,0,65,9,12,8,29]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function T(E){if(I.isLinux)return E;const _=(0,t.dirname)(E);if(E===_)return E;const w=((0,t.basename)(E)||E).toLowerCase();try{const g=(0,y.readdirSync)(_).filter(h=>h.toLowerCase()===w);if(g.length===1){const h=T(_);if(h)return(0,t.join)(h,g[0])}else if(g.length>1){const h=g.indexOf(w);if(h>=0){const v=T(_);if(v)return(0,t.join)(v,g[h])}}}catch{}return null}e.realcaseSync=T;async function S(E){if(I.isLinux)return E;const _=(0,t.dirname)(E);if(E===_)return E;const w=((0,t.basename)(E)||E).toLowerCase();try{const g=(await y.Promises.readdir(_)).filter(h=>h.toLowerCase()===w);if(g.length===1){const h=await S(_);if(h)return(0,t.join)(h,g[0])}else if(g.length>1){const h=g.indexOf(w);if(h>=0){const v=await S(_);if(v)return(0,t.join)(v,g[h])}}}catch{}return null}e.realcase=S;async function D(E){try{return await y.Promises.realpath(E)}catch{const w=k(E);return await y.Promises.access(w,c.constants.R_OK),w}}e.realpath=D;function A(E){try{return c.realpathSync(E)}catch{const w=k(E);return c.accessSync(w,c.constants.R_OK),w}}e.realpathSync=A;function k(E){return(0,P.rtrim)((0,t.normalize)(E),t.sep)}}),define(_e[114],ye([1,0,9,12,36,106,11,29]),function(Z,e,c,t,I,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function S(k=I.env){return k.comspec||"cmd.exe"}e.getWindowsShell=S;function D(k){let E=[],_=!1;const w=function(f){if(_){E.push(f);return}(!k.send(f,h=>{if(h&&console.error(h),_=!1,E.length>0){const v=E.slice(0);E=[],v.forEach(m=>w(m))}})||t.isWindows)&&(_=!0)};return{send:w}}e.createQueuedSender=D;var A;(function(k){async function E(_,w,f){if(c.isAbsolute(_))return _;if(w===void 0&&(w=I.cwd()),c.dirname(_)!=="."||(f===void 0&&y.isString(I.env.PATH)&&(f=I.env.PATH.split(c.delimiter)),f===void 0||f.length===0))return c.join(w,_);async function h(v){if(await T.Promises.exists(v)){let m;try{m=await T.Promises.stat(v)}catch(r){r.message.startsWith("EACCES")&&(m=await T.Promises.lstat(v))}return m?!m.isDirectory():!1}return!1}for(const v of f){let m;if(c.isAbsolute(v)?m=c.join(v,_):m=c.join(w,v,_),await h(m))return m;let r=m+".com";if(await h(r)||(r=m+".exe",await h(r)))return r}return c.join(w,_)}k.findExecutable=E})(A=e.win32||(e.win32={}))});var Ve=this&&this.__decorate||function(Z,e,c,t){var I=arguments.length,P=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,c):t,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(Z,e,c,t);else for(var T=Z.length-1;T>=0;T--)(y=Z[T])&&(P=(I<3?y(P):I>3?y(e,c,P):y(e,c))||P);return I>3&&P&&Object.defineProperty(e,c,P),P};define(_e[115],ye([1,0,17,18,23,21,60,10,4,6,82,8,11]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var _;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(_||(_={}));function w(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(f||(f={}));function g(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(h||(h={}));class v{constructor(x){this.buffer=x,this.pos=0}read(x){const Q=this.buffer.slice(this.pos,this.pos+x);return this.pos+=Q.byteLength,Q}}class m{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var r;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(r||(r={}));function b(j){const x=I.VSBuffer.alloc(4);return x.writeUInt32BE(j,0),x}function s(j){return j.read(4).readUInt32BE(0)}function u(j){const x=I.VSBuffer.alloc(1);return x.writeUInt8(j,0),x}const o={Undefined:u(r.Undefined),String:u(r.String),Buffer:u(r.Buffer),VSBuffer:u(r.VSBuffer),Array:u(r.Array),Object:u(r.Object)},l=typeof Buffer<"u";function a(j,x){if(typeof x>"u")j.write(o.Undefined);else if(typeof x=="string"){const Q=I.VSBuffer.fromString(x);j.write(o.String),j.write(b(Q.byteLength)),j.write(Q)}else if(l&&Buffer.isBuffer(x)){const Q=I.VSBuffer.wrap(x);j.write(o.Buffer),j.write(b(Q.byteLength)),j.write(Q)}else if(x instanceof I.VSBuffer)j.write(o.VSBuffer),j.write(b(x.byteLength)),j.write(x);else if(Array.isArray(x)){j.write(o.Array),j.write(b(x.length));for(const Q of x)a(j,Q)}else{const Q=I.VSBuffer.fromString(JSON.stringify(x));j.write(o.Object),j.write(b(Q.byteLength)),j.write(Q)}}function d(j){switch(j.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return j.read(s(j)).toString();case r.Buffer:return j.read(s(j)).buffer;case r.VSBuffer:return j.read(s(j));case r.Array:{const Q=s(j),K=[];for(let le=0;le<Q;le++)K.push(d(j));return K}case r.Object:return JSON.parse(j.read(s(j)).toString())}}class n{constructor(x,Q,K=null,le=1e3){this.protocol=x,this.ctx=Q,this.logger=K,this.timeoutDelay=le,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ie=>this.onRawMessage(ie)),this.sendResponse({type:200})}registerChannel(x,Q){this.channels.set(x,Q),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const Q=this.send([x.type]);this.logger?.logOutgoing(Q,0,1,g(x.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([x.type,x.id],x.data);this.logger?.logOutgoing(Q,x.id,1,g(x.type),x.data);return}}}send(x,Q=void 0){const K=new m;return a(K,x),a(K,Q),this.sendBuffer(K.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const Q=new v(x),K=d(Q),le=d(Q),ie=K[0];switch(ie){case 100:return this.logger?.logIncoming(x.byteLength,K[1],1,`${w(ie)}: ${K[2]}.${K[3]}`,le),this.onPromise({type:ie,id:K[1],channelName:K[2],name:K[3],arg:le});case 102:return this.logger?.logIncoming(x.byteLength,K[1],1,`${w(ie)}: ${K[2]}.${K[3]}`,le),this.onEventListen({type:ie,id:K[1],channelName:K[2],name:K[3],arg:le});case 101:return this.logger?.logIncoming(x.byteLength,K[1],1,`${w(ie)}`),this.disposeActiveRequest({type:ie,id:K[1]});case 103:return this.logger?.logIncoming(x.byteLength,K[1],1,`${w(ie)}`),this.disposeActiveRequest({type:ie,id:K[1]})}}onPromise(x){const Q=this.channels.get(x.channelName);if(!Q){this.collectPendingRequest(x);return}const K=new P.CancellationTokenSource;let le;try{le=Q.call(this.ctx,x.name,x.arg,K.token)}catch(Y){le=Promise.reject(Y)}const ie=x.id;le.then(Y=>{this.sendResponse({id:ie,data:Y,type:201}),this.activeRequests.delete(x.id)},Y=>{Y instanceof Error?this.sendResponse({id:ie,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:ie,data:Y,type:203}),this.activeRequests.delete(x.id)});const de=(0,D.toDisposable)(()=>K.cancel());this.activeRequests.set(x.id,de)}onEventListen(x){const Q=this.channels.get(x.channelName);if(!Q){this.collectPendingRequest(x);return}const K=x.id,ie=Q.listen(this.ctx,x.name,x.arg)(de=>this.sendResponse({id:K,data:de,type:204}));this.activeRequests.set(x.id,ie)}disposeActiveRequest(x){const Q=this.activeRequests.get(x.id);Q&&(Q.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let Q=this.pendingRequests.get(x.channelName);Q||(Q=[],this.pendingRequests.set(x.channelName,Q));const K=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:x,timeoutTimer:K})}flushPendingRequests(x){const Q=this.pendingRequests.get(x);if(Q){for(const K of Q)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=n;var i;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(i=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(x,Q=null){this.protocol=x,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=Q}getChannel(x){const Q=this;return{call(K,le,ie){return Q.isDisposed?Promise.reject(new T.CancellationError):Q.requestPromise(x,K,le,ie)},listen(K,le){return Q.isDisposed?S.Event.None:Q.requestEvent(x,K,le)}}}requestPromise(x,Q,K,le=P.CancellationToken.None){const ie=this.lastRequestId++,Y={id:ie,type:100,channelName:x,name:Q,arg:K};if(le.isCancellationRequested)return Promise.reject(new T.CancellationError);let pe;return new Promise((Ce,Re)=>{if(le.isCancellationRequested)return Re(new T.CancellationError);const We=()=>{const J=re=>{switch(re.type){case 201:this.handlers.delete(ie),Ce(re.data);break;case 202:{this.handlers.delete(ie);const ee=new Error(re.data.message);ee.stack=Array.isArray(re.data.stack)?re.data.stack.join(`
`):re.data.stack,ee.name=re.data.name,Re(ee);break}case 203:this.handlers.delete(ie),Re(re.data);break}};this.handlers.set(ie,J),this.sendRequest(Y)};let ne=null;this.state===h.Idle?We():(ne=(0,t.createCancelablePromise)(J=>this.whenInitialized()),ne.then(()=>{ne=null,We()}));const ce=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:ie,type:101}),Re(new T.CancellationError)},fe=le.onCancellationRequested(ce);pe=(0,D.combinedDisposable)((0,D.toDisposable)(ce),fe),this.activeRequests.add(pe)}).finally(()=>{this.activeRequests.delete(pe)})}requestEvent(x,Q,K){const le=this.lastRequestId++,de={id:le,type:102,channelName:x,name:Q,arg:K};let Y=null;const pe=new S.Emitter({onWillAddFirstListener:()=>{Y=(0,t.createCancelablePromise)(Ce=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(pe),this.sendRequest(de)})},onDidRemoveLastListener:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(pe),this.sendRequest({id:le,type:103}))}}),be=Ce=>pe.fire(Ce.data);return this.handlers.set(le,be),pe.event}sendRequest(x){switch(x.type){case 100:case 102:{const Q=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger?.logOutgoing(Q,x.id,0,`${w(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const Q=this.send([x.type,x.id]);this.logger?.logOutgoing(Q,x.id,0,w(x.type));return}}}send(x,Q=void 0){const K=new m;return a(K,x),a(K,Q),this.sendBuffer(K.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const Q=new v(x),K=d(Q),le=d(Q),ie=K[0];switch(ie){case 200:return this.logger?.logIncoming(x.byteLength,0,0,g(ie)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(x.byteLength,K[1],0,g(ie),le),this.onResponse({type:K[0],id:K[1],data:le})}}onResponse(x){if(x.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}this.handlers.get(x.id)?.(x)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ve([y.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class C{get connections(){const x=[];return this._connections.forEach(Q=>x.push(Q)),x}constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:Q,onDidClientDisconnect:K})=>{S.Event.once(Q.onMessage)(ie=>{const de=new v(ie),Y=d(de),pe=new n(Q,Y),be=new p(Q);this.channels.forEach((Re,We)=>pe.registerChannel(We,Re));const Ce={channelServer:pe,channelClient:be,ctx:Y};this._connections.add(Ce),this._onDidAddConnection.fire(Ce),K(()=>{pe.dispose(),be.dispose(),this._connections.delete(Ce),this._onDidRemoveConnection.fire(Ce)})})})}getChannel(x,Q){const K=this;return{call(le,ie,de){let Y;if((0,E.isFunction)(Q)){const be=(0,c.getRandomElement)(K.connections.filter(Q));Y=be?Promise.resolve(be):S.Event.toPromise(S.Event.filter(K.onDidAddConnection,Q))}else Y=Q.routeCall(K,le,ie);const pe=Y.then(be=>be.channelClient.getChannel(x));return U(pe).call(le,ie,de)},listen(le,ie){if((0,E.isFunction)(Q))return K.getMulticastEvent(x,Q,le,ie);const de=Q.routeEvent(K,le,ie).then(Y=>Y.channelClient.getChannel(x));return U(de).listen(le,ie)}}}getMulticastEvent(x,Q,K,le){const ie=this;let de=new D.DisposableStore;const Y=new S.Emitter({onWillAddFirstListener:()=>{de=new D.DisposableStore;const pe=new S.EventMultiplexer,be=new Map,Ce=We=>{const ce=We.channelClient.getChannel(x).listen(K,le),fe=pe.add(ce);be.set(We,fe)},Re=We=>{const ne=be.get(We);!ne||(ne.dispose(),be.delete(We))};ie.connections.filter(Q).forEach(Ce),S.Event.filter(ie.onDidAddConnection,Q)(Ce,void 0,de),ie.onDidRemoveConnection(Re,void 0,de),pe.event(Y.fire,Y,de),de.add(pe)},onDidRemoveLastListener:()=>{de.dispose()}});return Y.event}registerChannel(x,Q){this.channels.set(x,Q),this._connections.forEach(K=>{K.channelServer.registerChannel(x,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=C;class R{constructor(x,Q,K=null){const le=new m;a(le,Q),x.send(le.buffer),this.channelClient=new p(x,K),this.channelServer=new n(x,Q,K)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,Q){this.channelServer.registerChannel(x,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function U(j){return{call(x,Q,K){return j.then(le=>le.call(x,Q,K))},listen(x,Q){const K=new S.Relay;return j.then(le=>K.input=le.listen(x,Q)),K.event}}}e.getDelayedChannel=U;function H(j){let x=!1;return{call(Q,K,le){return x?j.call(Q,K,le):(0,t.timeout)(0).then(()=>x=!0).then(()=>j.call(Q,K,le))},listen(Q,K){if(x)return j.listen(Q,K);const le=new S.Relay;return(0,t.timeout)(0).then(()=>x=!0).then(()=>le.input=j.listen(Q,K)),le.event}}}e.getNextTickChannel=H;class V{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const Q of x.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await S.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=V;var L;(function(j){function x(ie,de){const Y=ie,pe=de&&de.disableMarshalling,be=new Map;for(const Ce in Y)K(Ce)&&be.set(Ce,S.Event.buffer(Y[Ce],!0));return new class{listen(Ce,Re,We){const ne=be.get(Re);if(ne)return ne;if(le(Re)){const ce=Y[Re];if(typeof ce=="function")return ce.call(Y,We)}throw new Error(`Event not found: ${Re}`)}call(Ce,Re,We){const ne=Y[Re];if(typeof ne=="function"){if(!pe&&Array.isArray(We))for(let ce=0;ce<We.length;ce++)We[ce]=(0,A.revive)(We[ce]);return ne.apply(Y,We)}throw new Error(`Method not found: ${Re}`)}}}j.fromService=x;function Q(ie,de){const Y=de&&de.disableMarshalling;return new Proxy({},{get(pe,be){if(typeof be=="string")return de?.properties?.has(be)?de.properties.get(be):le(be)?function(Ce){return ie.listen(be,Ce)}:K(be)?ie.listen(be):async function(...Ce){let Re;de&&!(0,E.isUndefinedOrNull)(de.context)?Re=[de.context,...Ce]:Re=Ce;const We=await ie.call(be,Re);return Y?We:(0,A.revive)(We)};throw new Error(`Property not found: ${String(be)}`)}})}j.toService=Q;function K(ie){return ie[0]==="o"&&ie[1]==="n"&&k.isUpperAsciiLetter(ie.charCodeAt(2))}function le(ie){return/^onDynamic/.test(ie)&&k.isUpperAsciiLetter(ie.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const x=j.toString();if(x!=="[object Object]")return x}return j}function B(j){return Array.isArray(j)?j.map(F):F(j)}function N(j,x,Q,K,le,ie,de){de=B(de);const Y=M[le],pe=Y[K%Y.length];let be=[`%c[${j}]%c[${String(x).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${pe}`];/\($/.test(ie)?(be=be.concat(de),be.push(")")):be.push(de),console.log.apply(console,be)}class z{constructor(x,Q){this._outgoingPrefix=x,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,Q,K,le,ie){this._totalOutgoing+=x,N(this._outgoingPrefix,this._totalOutgoing,x,Q,K,le,ie)}logIncoming(x,Q,K,le,ie){this._totalIncoming+=x,N(this._incomingPrefix,this._totalIncoming,x,Q,K,le,ie)}}e.IPCLogger=z}),define(_e[116],ye([1,0,23,4,6,115]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var y;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(y=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var T;(function(l){l.enableDiagnostics=!1,l.records=[];const a=new WeakMap;let d=0;function n(p,C){if(!a.has(p)){const R=String(++d);a.set(p,R)}return a.get(p)}function i(p,C,R,U){if(!l.enableDiagnostics)return;const H=n(p,C);if(U instanceof c.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const V=c.VSBuffer.alloc(U.byteLength);V.set(U),l.records.push({timestamp:Date.now(),id:H,label:C,type:R,buff:V})}else l.records.push({timestamp:Date.now(),id:H,label:C,type:R,data:U})}l.traceSocketEvent=i})(T=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let D=null;function A(){return D||(D=c.VSBuffer.alloc(0)),D}class k{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,d){if(a===0)return A();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const C=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=a),C}if(this._chunks[0].byteLength>a){const C=this._chunks[0].slice(0,a);return d&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),C}const n=c.VSBuffer.alloc(a);let i=0,p=0;for(;a>0;){const C=this._chunks[p];if(C.byteLength>a){const R=C.slice(0,a);n.set(R,i),i+=a,d&&(this._chunks[p]=C.slice(a),this._totalLength-=a),a-=a}else n.set(C,i),i+=C.byteLength,d?(this._chunks.shift(),this._totalLength-=C.byteLength):p++,a-=C.byteLength}return n}}e.ChunkStream=k;var E;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(E||(E={}));function _(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var w;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(a,d,n,i){this.type=a,this.id=d,this.ack=n,this.data=i,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends I.Disposable{constructor(a){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:_(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const n=this._state.messageType,i=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",d),this._onMessage.fire(new f(n,i,p,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(a){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=c.VSBuffer.alloc(13);d.writeUInt8(a.type,0),d.writeUInt32BE(a.id,1),d.writeUInt32BE(a.ack,5),d.writeUInt32BE(a.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:_(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",a.data),this._writeSoon(d,a.data)}_bufferAdd(a,d){const n=this._totalLength===0;return this._data.push(a,d),this._totalLength+=a.byteLength+d.byteLength,n}_bufferTake(){const a=c.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,d){this._bufferAdd(a,d)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const a=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this._socket.write(a)}}class v extends I.Disposable{constructor(a){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===1&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new f(1,0,0,a))}}e.Protocol=v;class m extends P.IPCClient{static fromSocket(a,d){return new m(new v(a),d)}get onDidDispose(){return this.protocol.onDidDispose}constructor(a,d,n=null){super(a,d,n),this.protocol=a}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=m;class r{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=r;class b{constructor(a){this.data=a,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let a=0,d=this._first;for(;d;)d=d.next,a++;return a}peek(){return this._first?this._first.data:null}toArray(){const a=[];let d=0,n=this._first;for(;n;)a[d++]=n.data,n=n.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const d=new b(a);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class u{static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}constructor(){this.lastRuns=[];const a=Date.now();for(let d=0;d<u._HISTORY_LENGTH;d++)this.lastRuns[d]=a-1e3*d;setInterval(()=>{for(let d=u._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}load(){const a=Date.now(),d=(1+u._HISTORY_LENGTH)*1e3;let n=0;for(let i=0;i<u._HISTORY_LENGTH;i++)a-this.lastRuns[i]<=d&&n++;return 1-n/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class o{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(a,d=null,n=u.getInstance()){this._onControlMessage=new r,this.onControlMessage=this._onControlMessage.event,this._onMessage=new r,this.onMessage=this._onMessage.event,this._onDidDispose=new r,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new r,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new r,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=a,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(i=>this._receiveMessage(i))),this._socketDisposables.push(this._socket.onClose(i=>this._onSocketClose.fire(i))),d&&this._socketReader.acceptChunk(d),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new f(5,0,0,A());this._socketWriter.write(a),this._socketWriter.flush()}sendPause(){const a=new f(7,0,0,A());this._socketWriter.write(a)}sendResume(){const a=new f(8,0,0,A());this._socketWriter.write(a)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,d){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=a,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(n=>this._onSocketClose.fire(n))),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const a=new f(3,0,this._incomingAckId,A());this._socketWriter.write(a);const d=this._outgoingUnackMsg.toArray();for(let n=0,i=d.length;n<i;n++)this._socketWriter.write(d[n]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new f(6,0,0,A())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data);break}case 2:{this._onControlMessage.fire(a.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const d=this._outgoingUnackMsg.toArray();for(let n=0,i=d.length;n<i;n++)this._socketWriter.write(d[n]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new f(1,d,this._incomingAckId,a);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(a){const d=new f(2,0,0,a);this._socketWriter.write(d)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const a=this._outgoingUnackMsg.peek(),d=Date.now()-a.writtenTime,n=Date.now()-this._socketReader.lastReadTime,i=Date.now()-this._lastSocketTimeoutTime;if(d>=2e4&&n>=2e4&&i>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:n});return}const p=Math.max(2e4-d,2e4-n,2e4-i,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},p)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new f(3,0,this._incomingAckId,A());this._socketWriter.write(a)}_sendKeepAlive(){const a=new f(9,0,0,A());this._socketWriter.write(a)}}e.PersistentProtocol=o}),define(_e[117],ye([1,0,23,10,4,6,9,12,31,115,116]),function(Z,e,c,t,I,P,y,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:Z.__$__nodeRequire("crypto"),zlib:Z.__$__nodeRequire("zlib"),net:Z.__$__nodeRequire("net"),os:Z.__$__nodeRequire("os")}}class E{traceSocketEvent(n,i){A.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,i)}constructor(n,i=""){this._canWrite=!0,this.debugLabel=i,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=p=>{if(this.traceSocketEvent("error",{code:p?.code,message:p?.message}),p){if(p.code==="EPIPE")return;(0,t.onUnexpectedError)(p)}},this.socket.on("error",this._errorListener),this._closeListener=p=>{this.traceSocketEvent("close",{hadError:p}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(n){const i=p=>{this.traceSocketEvent("read",p),n(c.VSBuffer.wrap(p))};return this.socket.on("data",i),{dispose:()=>this.socket.off("data",i)}}onClose(n){const i=p=>{n({type:0,hadError:p,error:void 0})};return this.socket.on("close",i),{dispose:()=>this.socket.off("close",i)}}onEnd(n){const i=()=>{n()};return this.socket.on("end",i),{dispose:()=>this.socket.off("end",i)}}write(n){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,i=>{if(i){if(i.code==="EPIPE")return;(0,t.onUnexpectedError)(i)}})}catch(i){if(i.code==="EPIPE")return;(0,t.onUnexpectedError)(i)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,i)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=E;var _;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var w;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(w||(w={}));class f extends P.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(n,i){this.socket.traceSocketEvent(n,i)}constructor(n,i,p,C){super(),this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:i,inflateBytesLength:p?.byteLength||0,recordInflateBytes:C}),this._flowManager=this._register(new g(this,i,p,C,this._onData,(R,U)=>this._write(R,U))),this._register(this._flowManager.onError(R=>{console.error(R),(0,t.onUnexpectedError)(R),this._onClose.fire({type:0,hadError:!0,error:R})})),this._incomingData=new A.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(R=>this._onClose.fire(R)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this._onData.event(n)}onClose(n){return this._onClose.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this._flowManager.writeMessage(n)}_write(n,i){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let p=2;n.byteLength<126?p+=0:n.byteLength<2**16?p+=2:p+=8;const C=c.VSBuffer.alloc(p);if(i?C.writeUInt8(194,0):C.writeUInt8(130,0),n.byteLength<126)C.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){C.writeUInt8(126,1);let R=1;C.writeUInt8(n.byteLength>>>8&255,++R),C.writeUInt8(n.byteLength>>>0&255,++R)}else{C.writeUInt8(127,1);let R=1;C.writeUInt8(0,++R),C.writeUInt8(0,++R),C.writeUInt8(0,++R),C.writeUInt8(0,++R),C.writeUInt8(n.byteLength>>>24&255,++R),C.writeUInt8(n.byteLength>>>16&255,++R),C.writeUInt8(n.byteLength>>>8&255,++R),C.writeUInt8(n.byteLength>>>0&255,++R)}this.socket.write(c.VSBuffer.concat([C,n]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(n){if(n.byteLength!==0){for(this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const i=this._incomingData.peek(this._state.readLen),p=i.readUInt8(0),C=(p&128)>>>7,R=(p&64)>>>6,U=i.readUInt8(1),H=(U&128)>>>7,V=U&127;this._state.state=2,this._state.readLen=2+(H?4:0)+(V===126?2:0)+(V===127?8:0),this._state.fin=C,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(R)),this._state.firstFrameOfMessage=Boolean(C),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const i=this._incomingData.read(this._state.readLen),p=i.readUInt8(1),C=(p&128)>>>7;let R=p&127,U=1;R===126?R=i.readUInt8(++U)*2**8+i.readUInt8(++U):R===127&&(R=i.readUInt8(++U)*0+i.readUInt8(++U)*0+i.readUInt8(++U)*0+i.readUInt8(++U)*0+i.readUInt8(++U)*2**24+i.readUInt8(++U)*2**16+i.readUInt8(++U)*2**8+i.readUInt8(++U));let H=0;C&&(H=i.readUInt8(++U)*2**24+i.readUInt8(++U)*2**16+i.readUInt8(++U)*2**8+i.readUInt8(++U)),this._state.state=3,this._state.readLen=R,this._state.mask=H,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const i=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",i),m(i,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",i),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(i,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=f;class g extends P.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:c.VSBuffer.alloc(0)}constructor(n,i,p,C,R,U){super(),this._tracer=n,this._onData=R,this._writeFn=U,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,i?(this._zlibInflateStream=this._register(new h(this._tracer,C,p,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(H=>this._onError.fire(H))),this._register(this._zlibDeflateStream.onError(H=>this._onError.fire(H)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(n){this._writeQueue.push(n),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const n=this._writeQueue.shift();if(this._zlibDeflateStream){const i=await this._deflateMessage(this._zlibDeflateStream,n);this._writeFn(i,!0)}else this._writeFn(n,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(n,i){return new Promise((p,C)=>{n.write(i),n.flush(R=>p(R))})}acceptFrame(n,i,p){this._readQueue.push({data:n,isCompressed:i,isLastFrameOfMessage:p}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const n=this._readQueue.shift();if(this._zlibInflateStream&&n.isCompressed){const i=await this._inflateFrame(this._zlibInflateStream,n.data,n.isLastFrameOfMessage);this._onData.fire(i)}else this._onData.fire(n.data)}this._isProcessingReadQueue=!1}}_inflateFrame(n,i,p){return new Promise((C,R)=>{n.write(i),p&&n.write(c.VSBuffer.fromByteArray([0,0,255,255])),n.flush(U=>C(U))})}}class h extends P.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?c.VSBuffer.concat(this._recordedInflateBytes):c.VSBuffer.alloc(0)}constructor(n,i,p,C){super(),this._tracer=n,this._recordInflateBytes=i,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=k().zlib.createInflateRaw(C),this._zlibInflate.on("error",R=>{this._tracer.traceSocketEvent("zlibInflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibInflate.on("data",R=>{this._tracer.traceSocketEvent("zlibInflateData",R),this._pendingInflateData.push(c.VSBuffer.wrap(R))}),p&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",p.buffer),this._zlibInflate.write(p.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(n){this._recordInflateBytes&&this._recordedInflateBytes.push(n.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",n),this._zlibInflate.write(n.buffer)}flush(n){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const i=c.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,n(i)})}}class v extends P.Disposable{constructor(n,i){super(),this._tracer=n,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=k().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",p=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:p?.message,code:p?.code}),this._onError.fire(p)}),this._zlibDeflate.on("data",p=>{this._tracer.traceSocketEvent("zlibDeflateData",p),this._pendingDeflateData.push(c.VSBuffer.wrap(p))})}write(n){this._tracer.traceSocketEvent("zlibDeflateWrite",n.buffer),this._zlibDeflate.write(n.buffer)}flush(n){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let i=c.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,i=i.slice(0,i.byteLength-4),n(i)})}}function m(d,n){if(n===0)return;const i=d.byteLength>>>2;for(let V=0;V<i;V++){const L=d.readUInt32BE(V*4);d.writeUInt32BE(L^n,V*4)}const p=i*4,C=d.byteLength-p,R=n>>>24&255,U=n>>>16&255,H=n>>>8&255;C>=1&&d.writeUInt8(d.readUInt8(p)^R,p),C>=2&&d.writeUInt8(d.readUInt8(p+1)^U,p+1),C>=3&&d.writeUInt8(d.readUInt8(p+2)^H,p+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const r={[2]:107,[1]:103};function b(){const d=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):n=(0,y.join)(k().os.tmpdir(),`vscode-ipc-${d}.sock`),u(n),n}e.createRandomIPCHandle=b;function s(d,n,i){const p=k().crypto.createHash("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${p}-${i}-${n}-sock`;let C;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?C=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${p.substr(0,8)}-${i}-${n}.sock`):C=(0,y.join)(d,`${i}-${n}.sock`),u(C),C}e.createStaticIPCHandle=s;function u(d){const n=r[T.platform];typeof n=="number"&&d.length>=n&&console.warn(`WARNING: IPC handle "${d}" is longer than ${n} chars, try a shorter --user-data-dir`)}class o extends D.IPCServer{static toClientConnectionEvent(n){const i=I.Event.fromNodeEventEmitter(n,"connection");return I.Event.map(i,p=>({protocol:new A.Protocol(new E(p,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(p,"close"))}))}constructor(n){super(o.toClientConnectionEvent(n)),this.server=n}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function l(d){return new Promise((n,i)=>{const p=k().net.createServer();p.on("error",i),p.listen(d,()=>{p.removeListener("error",i),n(new o(p))})})}e.serve=l;function a(d,n){return new Promise((i,p)=>{const C=k().net.createConnection(d,()=>{C.removeListener("error",p),i(A.Client.fromSocket(new E(C,`ipc-client${n}`),n))});C.once("error",p)})}e.connect=a}),define(_e[159],ye([1,0,37,9]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(P,y,T,S,D,A){if(Array.isArray(P)){let k=0;for(const E of P){const _=I(E,y,T,S,D,A);if(_===10)return _;_>k&&(k=_)}return k}else{if(typeof P=="string")return S?P==="*"?5:P===T?10:0:0;if(P){const{language:k,pattern:E,scheme:_,hasAccessToAllModels:w,notebookType:f}=P;if(!S&&!w)return 0;f&&D&&(y=D);let g=0;if(_)if(_===y.scheme)g=10;else if(_==="*")g=5;else return 0;if(k)if(k===T)g=10;else if(k==="*")g=Math.max(g,5);else return 0;if(f)if(f===A)g=10;else if(f==="*"&&A!==void 0)g=Math.max(g,5);else return 0;if(E){let h;if(typeof E=="string"?h=E:h={...E,base:(0,t.normalize)(E.base)},h===y.fsPath||(0,c.match)(h,y.fsPath))g=10;else return 0}return g}else return 0}}e.score=I}),define(_e[160],ye([1,0,8,49,151]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(T,S,D,A){this._uri=T,this._lines=S,this._eol=D,this._versionId=A,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(T){T.eol&&T.eol!==this._eol&&(this._eol=T.eol,this._lineStarts=null);const S=T.changes;for(const D of S)this._acceptDeleteRange(D.range),this._acceptInsertText(new t.Position(D.range.startLineNumber,D.range.startColumn),D.text);this._versionId=T.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const T=this._eol.length,S=this._lines.length,D=new Uint32Array(S);for(let A=0;A<S;A++)D[A]=this._lines[A].length+T;this._lineStarts=new I.PrefixSumComputer(D)}}_setLineText(T,S){this._lines[T]=S,this._lineStarts&&this._lineStarts.setValue(T,this._lines[T].length+this._eol.length)}_acceptDeleteRange(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this._setLineText(T.startLineNumber-1,this._lines[T.startLineNumber-1].substring(0,T.startColumn-1)+this._lines[T.startLineNumber-1].substring(T.endColumn-1));return}this._setLineText(T.startLineNumber-1,this._lines[T.startLineNumber-1].substring(0,T.startColumn-1)+this._lines[T.endLineNumber-1].substring(T.endColumn-1)),this._lines.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}_acceptInsertText(T,S){if(S.length===0)return;const D=(0,c.splitLines)(S);if(D.length===1){this._setLineText(T.lineNumber-1,this._lines[T.lineNumber-1].substring(0,T.column-1)+D[0]+this._lines[T.lineNumber-1].substring(T.column-1));return}D[D.length-1]+=this._lines[T.lineNumber-1].substring(T.column-1),this._setLineText(T.lineNumber-1,this._lines[T.lineNumber-1].substring(0,T.column-1)+D[0]);const A=new Uint32Array(D.length-1);for(let k=1;k<D.length;k++)this._lines.splice(T.lineNumber+k-1,0,D[k]),A[k-1]=D[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(T.lineNumber,A)}}e.MirrorTextModel=P}),define(_e[161],ye([1,0,8,148,49,35,104]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class S{constructor(v,m,r,b){this.searchString=v,this.isRegex=m,this.matchCase=r,this.wordSeparators=b}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=D(this.searchString):v=this.searchString.indexOf(`
`)>=0;let m=null;try{m=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!m)return null;let r=!this.isRegex&&!v;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new y.SearchData(m,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,r?this.searchString:null)}}e.SearchParams=S;function D(h){if(!h||h.length===0)return!1;for(let v=0,m=h.length;v<m;v++){const r=h.charCodeAt(v);if(r===10)return!0;if(r===92){if(v++,v>=m)break;const b=h.charCodeAt(v);if(b===110||b===114||b===87)return!0}}return!1}e.isMultilineRegexSource=D;function A(h,v,m){if(!m)return new y.FindMatch(h,null);const r=[];for(let b=0,s=v.length;b<s;b++)r[b]=v[b];return new y.FindMatch(h,r)}e.createFindMatch=A;class k{constructor(v){const m=[];let r=0;for(let b=0,s=v.length;b<s;b++)v.charCodeAt(b)===10&&(m[r++]=b);this._lineFeedsOffsets=m}findLineFeedCountBeforeOffset(v){const m=this._lineFeedsOffsets;let r=0,b=m.length-1;if(b===-1||v<=m[0])return 0;for(;r<b;){const s=r+((b-r)/2>>0);m[s]>=v?b=s-1:m[s+1]>=v?(r=s,b=s):r=s+1}return r+1}}class E{static findMatches(v,m,r,b,s){const u=m.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(v,r,new g(u.wordSeparators,u.regex),b,s):this._doFindMatchesLineByLine(v,r,u,b,s):[]}static _getMultilineMatchRange(v,m,r,b,s,u){let o,l=0;b?(l=b.findLineFeedCountBeforeOffset(s),o=m+s+l):o=m+s;let a;if(b){const p=b.findLineFeedCountBeforeOffset(s+u.length)-l;a=o+u.length+p}else a=o+u.length;const d=v.getPositionAt(o),n=v.getPositionAt(a);return new P.Range(d.lineNumber,d.column,n.lineNumber,n.column)}static _doFindMatchesMultiline(v,m,r,b,s){const u=v.getOffsetAt(m.getStartPosition()),o=v.getValueInRange(m,1),l=v.getEOL()===`\r
`?new k(o):null,a=[];let d=0,n;for(r.reset(0);n=r.next(o);)if(a[d++]=A(this._getMultilineMatchRange(v,u,o,l,n.index,n[0]),n,b),d>=s)return a;return a}static _doFindMatchesLineByLine(v,m,r,b,s){const u=[];let o=0;if(m.startLineNumber===m.endLineNumber){const a=v.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return o=this._findMatchesInLine(r,a,m.startLineNumber,m.startColumn-1,o,u,b,s),u}const l=v.getLineContent(m.startLineNumber).substring(m.startColumn-1);o=this._findMatchesInLine(r,l,m.startLineNumber,m.startColumn-1,o,u,b,s);for(let a=m.startLineNumber+1;a<m.endLineNumber&&o<s;a++)o=this._findMatchesInLine(r,v.getLineContent(a),a,0,o,u,b,s);if(o<s){const a=v.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);o=this._findMatchesInLine(r,a,m.endLineNumber,0,o,u,b,s)}return u}static _findMatchesInLine(v,m,r,b,s,u,o,l){const a=v.wordSeparators;if(!o&&v.simpleSearch){const i=v.simpleSearch,p=i.length,C=m.length;let R=-p;for(;(R=m.indexOf(i,R+p))!==-1;)if((!a||f(a,m,C,R,p))&&(u[s++]=new y.FindMatch(new P.Range(r,R+1+b,r,R+1+p+b),null),s>=l))return s;return s}const d=new g(v.wordSeparators,v.regex);let n;d.reset(0);do if(n=d.next(m),n&&(u[s++]=A(new P.Range(r,n.index+1+b,r,n.index+1+n[0].length+b),n,o),s>=l))return s;while(n);return s}static findNextMatch(v,m,r,b){const s=m.parseSearchRequest();if(!s)return null;const u=new g(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(v,r,u,b):this._doFindNextMatchLineByLine(v,r,u,b)}static _doFindNextMatchMultiline(v,m,r,b){const s=new I.Position(m.lineNumber,1),u=v.getOffsetAt(s),o=v.getLineCount(),l=v.getValueInRange(new P.Range(s.lineNumber,s.column,o,v.getLineMaxColumn(o)),1),a=v.getEOL()===`\r
`?new k(l):null;r.reset(m.column-1);const d=r.next(l);return d?A(this._getMultilineMatchRange(v,u,l,a,d.index,d[0]),d,b):m.lineNumber!==1||m.column!==1?this._doFindNextMatchMultiline(v,new I.Position(1,1),r,b):null}static _doFindNextMatchLineByLine(v,m,r,b){const s=v.getLineCount(),u=m.lineNumber,o=v.getLineContent(u),l=this._findFirstMatchInLine(r,o,u,m.column,b);if(l)return l;for(let a=1;a<=s;a++){const d=(u+a-1)%s,n=v.getLineContent(d+1),i=this._findFirstMatchInLine(r,n,d+1,1,b);if(i)return i}return null}static _findFirstMatchInLine(v,m,r,b,s){v.reset(b-1);const u=v.next(m);return u?A(new P.Range(r,u.index+1,r,u.index+1+u[0].length),u,s):null}static findPreviousMatch(v,m,r,b){const s=m.parseSearchRequest();if(!s)return null;const u=new g(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(v,r,u,b):this._doFindPreviousMatchLineByLine(v,r,u,b)}static _doFindPreviousMatchMultiline(v,m,r,b){const s=this._doFindMatchesMultiline(v,new P.Range(1,1,m.lineNumber,m.column),r,b,10*T);if(s.length>0)return s[s.length-1];const u=v.getLineCount();return m.lineNumber!==u||m.column!==v.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(v,new I.Position(u,v.getLineMaxColumn(u)),r,b):null}static _doFindPreviousMatchLineByLine(v,m,r,b){const s=v.getLineCount(),u=m.lineNumber,o=v.getLineContent(u).substring(0,m.column-1),l=this._findLastMatchInLine(r,o,u,b);if(l)return l;for(let a=1;a<=s;a++){const d=(s+u-a-1)%s,n=v.getLineContent(d+1),i=this._findLastMatchInLine(r,n,d+1,b);if(i)return i}return null}static _findLastMatchInLine(v,m,r,b){let s=null,u;for(v.reset(0);u=v.next(m);)s=A(new P.Range(r,u.index+1,r,u.index+1+u[0].length),u,b);return s}}e.TextModelSearch=E;function _(h,v,m,r,b){if(r===0)return!0;const s=v.charCodeAt(r-1);if(h.get(s)!==0||s===13||s===10)return!0;if(b>0){const u=v.charCodeAt(r);if(h.get(u)!==0)return!0}return!1}function w(h,v,m,r,b){if(r+b===m)return!0;const s=v.charCodeAt(r+b);if(h.get(s)!==0||s===13||s===10)return!0;if(b>0){const u=v.charCodeAt(r+b-1);if(h.get(u)!==0)return!0}return!1}function f(h,v,m,r,b){return _(h,v,m,r,b)&&w(h,v,m,r,b)}e.isValidMatch=f;class g{constructor(v,m){this._wordSeparators=v,this._searchRegex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const m=v.length;let r;do{if(this._prevMatchStartIndex+this._prevMatchLength===m||(r=this._searchRegex.exec(v),!r))return null;const b=r.index,s=r[0].length;if(b===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){c.getNextCodePoint(v,m,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=b,this._prevMatchLength=s,!this._wordSeparators||f(this._wordSeparators,v,m,b,s))return r}while(r);return null}}e.Searcher=g}),define(_e[118],ye([1,0,23,12]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(I||(I={}));function P(k){for(let E=0,_=k.length;E<_;E+=4){const w=k[E+0],f=k[E+1],g=k[E+2],h=k[E+3];k[E+0]=h,k[E+1]=g,k[E+2]=f,k[E+3]=w}}function y(k){const E=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return t.isLittleEndian()||P(E),c.VSBuffer.wrap(E)}function T(k){const E=k.buffer;if(t.isLittleEndian()||P(E),E.byteOffset%4===0)return new Uint32Array(E.buffer,E.byteOffset,E.length/4);{const _=new Uint8Array(E.byteLength);return _.set(E),new Uint32Array(_.buffer,_.byteOffset,_.length/4)}}function S(k){const E=new Uint32Array(D(k));let _=0;if(E[_++]=k.id,k.type==="full")E[_++]=1,E[_++]=k.data.length,E.set(k.data,_),_+=k.data.length;else{E[_++]=2,E[_++]=k.deltas.length;for(const w of k.deltas)E[_++]=w.start,E[_++]=w.deleteCount,w.data?(E[_++]=w.data.length,E.set(w.data,_),_+=w.data.length):E[_++]=0}return y(E)}e.encodeSemanticTokensDto=S;function D(k){let E=0;if(E+=1+1,k.type==="full")E+=1+k.data.length;else{E+=1,E+=(1+1+1)*k.deltas.length;for(const _ of k.deltas)_.data&&(E+=_.data.length)}return E}function A(k){const E=T(k);let _=0;const w=E[_++];if(E[_++]===1){const v=E[_++],m=E.subarray(_,_+v);return _+=v,{id:w,type:"full",data:m}}const g=E[_++],h=[];for(let v=0;v<g;v++){const m=E[_++],r=E[_++],b=E[_++];let s;b>0&&(s=E.subarray(_,_+b),_+=b),h[v]={start:m,deleteCount:r,data:s}}return{id:w,type:"delta",deltas:h}}e.decodeSemanticTokensDto=A}),define(_e[162],ye([1,0,4,6]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,S){return this._map.set(T,S),this.fire([T]),(0,t.toDisposable)(()=>{this._map.get(T)===S&&(this._map.delete(T),this.fire([T]))})}registerFactory(T,S){this._factories.get(T)?.dispose();const D=new P(this,T,S);return this._factories.set(T,D),(0,t.toDisposable)(()=>{const A=this._factories.get(T);!A||A!==D||(this._factories.delete(T),A.dispose())})}async getOrCreate(T){const S=this.get(T);if(S)return S;const D=this._factories.get(T);return!D||D.isResolved?null:(await D.resolve(),this.get(T))}get(T){return this._map.get(T)||null}isResolved(T){if(this.get(T))return!0;const D=this._factories.get(T);return!!(!D||D.isResolved)}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=I;class P extends t.Disposable{get isResolved(){return this._isResolved}constructor(T,S,D){super(),this._registry=T,this._languageId=S,this._factory=D,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const T=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,T&&!this._isDisposed&&this._register(this._registry.register(this._languageId,T))}}}),define(_e[66],ye([1,0,77,2,35,162]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class y{constructor(p,C,R){this._tokenBrand=void 0,this.offset=p,this.type=C,this.language=R}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=y;class T{constructor(p,C){this._tokenizationResultBrand=void 0,this.tokens=p,this.endState=C}}e.TokenizationResult=T;class S{constructor(p,C){this._encodedTokenizationResultBrand=void 0,this.tokens=p,this.endState=C}}e.EncodedTokenizationResult=S;var D;(function(i){i[i.Method=0]="Method",i[i.Function=1]="Function",i[i.Constructor=2]="Constructor",i[i.Field=3]="Field",i[i.Variable=4]="Variable",i[i.Class=5]="Class",i[i.Struct=6]="Struct",i[i.Interface=7]="Interface",i[i.Module=8]="Module",i[i.Property=9]="Property",i[i.Event=10]="Event",i[i.Operator=11]="Operator",i[i.Unit=12]="Unit",i[i.Value=13]="Value",i[i.Constant=14]="Constant",i[i.Enum=15]="Enum",i[i.EnumMember=16]="EnumMember",i[i.Keyword=17]="Keyword",i[i.Text=18]="Text",i[i.Color=19]="Color",i[i.File=20]="File",i[i.Reference=21]="Reference",i[i.Customcolor=22]="Customcolor",i[i.Folder=23]="Folder",i[i.TypeParameter=24]="TypeParameter",i[i.User=25]="User",i[i.Issue=26]="Issue",i[i.Snippet=27]="Snippet"})(D=e.CompletionItemKind||(e.CompletionItemKind={}));var A;(function(i){const p=new Map;p.set(0,c.Codicon.symbolMethod),p.set(1,c.Codicon.symbolFunction),p.set(2,c.Codicon.symbolConstructor),p.set(3,c.Codicon.symbolField),p.set(4,c.Codicon.symbolVariable),p.set(5,c.Codicon.symbolClass),p.set(6,c.Codicon.symbolStruct),p.set(7,c.Codicon.symbolInterface),p.set(8,c.Codicon.symbolModule),p.set(9,c.Codicon.symbolProperty),p.set(10,c.Codicon.symbolEvent),p.set(11,c.Codicon.symbolOperator),p.set(12,c.Codicon.symbolUnit),p.set(13,c.Codicon.symbolValue),p.set(15,c.Codicon.symbolEnum),p.set(14,c.Codicon.symbolConstant),p.set(15,c.Codicon.symbolEnum),p.set(16,c.Codicon.symbolEnumMember),p.set(17,c.Codicon.symbolKeyword),p.set(27,c.Codicon.symbolSnippet),p.set(18,c.Codicon.symbolText),p.set(19,c.Codicon.symbolColor),p.set(20,c.Codicon.symbolFile),p.set(21,c.Codicon.symbolReference),p.set(22,c.Codicon.symbolCustomColor),p.set(23,c.Codicon.symbolFolder),p.set(24,c.Codicon.symbolTypeParameter),p.set(25,c.Codicon.account),p.set(26,c.Codicon.issues);function C(H){let V=p.get(H);return V||(console.info("No codicon found for CompletionItemKind "+H),V=c.Codicon.symbolProperty),V}i.toIcon=C;const R=new Map;R.set("method",0),R.set("function",1),R.set("constructor",2),R.set("field",3),R.set("variable",4),R.set("class",5),R.set("struct",6),R.set("interface",7),R.set("module",8),R.set("property",9),R.set("event",10),R.set("operator",11),R.set("unit",12),R.set("value",13),R.set("constant",14),R.set("enum",15),R.set("enum-member",16),R.set("enumMember",16),R.set("keyword",17),R.set("snippet",27),R.set("text",18),R.set("color",19),R.set("file",20),R.set("reference",21),R.set("customcolor",22),R.set("folder",23),R.set("type-parameter",24),R.set("typeParameter",24),R.set("account",25),R.set("issue",26);function U(H,V){let L=R.get(H);return typeof L>"u"&&!V&&(L=9),L}i.fromString=U})(A=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(i){i[i.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(i){i[i.KeepWhitespace=1]="KeepWhitespace",i[i.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var _;(function(i){i[i.Invoke=0]="Invoke",i[i.TriggerCharacter=1]="TriggerCharacter",i[i.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(i){i[i.Automatic=0]="Automatic",i[i.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(i){i[i.Invoke=1]="Invoke",i[i.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(i){i[i.Invoke=1]="Invoke",i[i.TriggerCharacter=2]="TriggerCharacter",i[i.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(i){i[i.Text=0]="Text",i[i.Read=1]="Read",i[i.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(i){return i&&t.URI.isUri(i.uri)&&I.Range.isIRange(i.range)&&(I.Range.isIRange(i.originSelectionRange)||I.Range.isIRange(i.targetSelectionRange))}e.isLocationLink=v;var m;(function(i){i[i.File=0]="File",i[i.Module=1]="Module",i[i.Namespace=2]="Namespace",i[i.Package=3]="Package",i[i.Class=4]="Class",i[i.Method=5]="Method",i[i.Property=6]="Property",i[i.Field=7]="Field",i[i.Constructor=8]="Constructor",i[i.Enum=9]="Enum",i[i.Interface=10]="Interface",i[i.Function=11]="Function",i[i.Variable=12]="Variable",i[i.Constant=13]="Constant",i[i.String=14]="String",i[i.Number=15]="Number",i[i.Boolean=16]="Boolean",i[i.Array=17]="Array",i[i.Object=18]="Object",i[i.Key=19]="Key",i[i.Null=20]="Null",i[i.EnumMember=21]="EnumMember",i[i.Struct=22]="Struct",i[i.Event=23]="Event",i[i.Operator=24]="Operator",i[i.TypeParameter=25]="TypeParameter"})(m=e.SymbolKind||(e.SymbolKind={}));var r;(function(i){i[i.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var b;(function(i){const p=new Map;p.set(0,c.Codicon.symbolFile),p.set(1,c.Codicon.symbolModule),p.set(2,c.Codicon.symbolNamespace),p.set(3,c.Codicon.symbolPackage),p.set(4,c.Codicon.symbolClass),p.set(5,c.Codicon.symbolMethod),p.set(6,c.Codicon.symbolProperty),p.set(7,c.Codicon.symbolField),p.set(8,c.Codicon.symbolConstructor),p.set(9,c.Codicon.symbolEnum),p.set(10,c.Codicon.symbolInterface),p.set(11,c.Codicon.symbolFunction),p.set(12,c.Codicon.symbolVariable),p.set(13,c.Codicon.symbolConstant),p.set(14,c.Codicon.symbolString),p.set(15,c.Codicon.symbolNumber),p.set(16,c.Codicon.symbolBoolean),p.set(17,c.Codicon.symbolArray),p.set(18,c.Codicon.symbolObject),p.set(19,c.Codicon.symbolKey),p.set(20,c.Codicon.symbolNull),p.set(21,c.Codicon.symbolEnumMember),p.set(22,c.Codicon.symbolStruct),p.set(23,c.Codicon.symbolEvent),p.set(24,c.Codicon.symbolOperator),p.set(25,c.Codicon.symbolTypeParameter);function C(R){let U=p.get(R);return U||(console.info("No codicon found for SymbolKind "+R),U=c.Codicon.symbolProperty),U}i.toIcon=C})(b=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(p){this.value=p}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var u;(function(i){function p(C){return!C||typeof C!="object"?!1:typeof C.id=="string"&&typeof C.title=="string"}i.is=p})(u=e.Command||(e.Command={}));var o;(function(i){i[i.Collapsed=0]="Collapsed",i[i.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(i){i[i.Unresolved=0]="Unresolved",i[i.Resolved=1]="Resolved"})(l=e.CommentThreadState||(e.CommentThreadState={}));var a;(function(i){i[i.Editing=0]="Editing",i[i.Preview=1]="Preview"})(a=e.CommentMode||(e.CommentMode={}));var d;(function(i){i[i.Type=1]="Type",i[i.Parameter=2]="Parameter"})(d=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var n;(function(i){i[i.None=0]="None",i[i.Option=1]="Option",i[i.Default=2]="Default",i[i.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(_e[163],ye([19,20]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(_e[119],ye([1,0,163,12,103,17,24,147]),function(Z,e,c,t,I,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(se){se[se.None=0]="None",se[se.Keep=1]="Keep",se[se.Brackets=2]="Brackets",se[se.Advanced=3]="Advanced",se[se.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(oe){this._values=oe}hasChanged(oe){return this._values[oe]}}e.ConfigurationChangedEvent=D;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class k{constructor(oe,Se,ue,Ie){this.id=oe,this.name=Se,this.defaultValue=ue,this.schema=Ie}applyUpdate(oe,Se){return _(oe,Se)}compute(oe,Se,ue){return ue}}class E{constructor(oe,Se){this.newValue=oe,this.didChange=Se}}e.ApplyUpdateResult=E;function _(se,oe){if(typeof se!="object"||typeof oe!="object"||!se||!oe)return new E(oe,se!==oe);if(Array.isArray(se)||Array.isArray(oe)){const ue=Array.isArray(se)&&Array.isArray(oe)&&P.equals(se,oe);return new E(oe,!ue)}let Se=!1;for(const ue in oe)if(oe.hasOwnProperty(ue)){const Ie=_(se[ue],oe[ue]);Ie.didChange&&(se[ue]=Ie.newValue,Se=!0)}return new E(se,Se)}class w{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,Se){return _(oe,Se)}validate(oe){return this.defaultValue}}class f{constructor(oe,Se,ue,Ie){this.id=oe,this.name=Se,this.defaultValue=ue,this.schema=Ie}applyUpdate(oe,Se){return _(oe,Se)}validate(oe){return typeof oe>"u"?this.defaultValue:oe}compute(oe,Se,ue){return ue}}function g(se,oe){return typeof se>"u"?oe:se==="false"?!1:Boolean(se)}e.boolean=g;class h extends f{constructor(oe,Se,ue,Ie=void 0){typeof Ie<"u"&&(Ie.type="boolean",Ie.default=ue),super(oe,Se,ue,Ie)}validate(oe){return g(oe,this.defaultValue)}}function v(se,oe,Se,ue){if(typeof se>"u")return oe;let Ie=parseInt(se,10);return isNaN(Ie)?oe:(Ie=Math.max(Se,Ie),Ie=Math.min(ue,Ie),Ie|0)}e.clampedInt=v;class m extends f{static clampedInt(oe,Se,ue,Ie){return v(oe,Se,ue,Ie)}constructor(oe,Se,ue,Ie,Le,Fe=void 0){typeof Fe<"u"&&(Fe.type="integer",Fe.default=ue,Fe.minimum=Ie,Fe.maximum=Le),super(oe,Se,ue,Fe),this.minimum=Ie,this.maximum=Le}validate(oe){return m.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}class r extends f{static clamp(oe,Se,ue){return oe<Se?Se:oe>ue?ue:oe}static float(oe,Se){if(typeof oe=="number")return oe;if(typeof oe>"u")return Se;const ue=parseFloat(oe);return isNaN(ue)?Se:ue}constructor(oe,Se,ue,Ie,Le){typeof Le<"u"&&(Le.type="number",Le.default=ue),super(oe,Se,ue,Le),this.validationFn=Ie}validate(oe){return this.validationFn(r.float(oe,this.defaultValue))}}class b extends f{static string(oe,Se){return typeof oe!="string"?Se:oe}constructor(oe,Se,ue,Ie=void 0){typeof Ie<"u"&&(Ie.type="string",Ie.default=ue),super(oe,Se,ue,Ie)}validate(oe){return b.string(oe,this.defaultValue)}}function s(se,oe,Se){return typeof se!="string"||Se.indexOf(se)===-1?oe:se}e.stringSet=s;class u extends f{constructor(oe,Se,ue,Ie,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.enum=Ie,Le.default=ue),super(oe,Se,ue,Le),this._allowedValues=Ie}validate(oe){return s(oe,this.defaultValue,this._allowedValues)}}class o extends k{constructor(oe,Se,ue,Ie,Le,Fe,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.enum=Le,Ge.default=Ie),super(oe,Se,ue,Ge),this._allowedValues=Le,this._convert=Fe}validate(oe){return typeof oe!="string"?this.defaultValue:this._allowedValues.indexOf(oe)===-1?this.defaultValue:this._convert(oe)}}function l(se){switch(se){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class a extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,Se,ue){return ue===0?oe.accessibilitySupport:ue}}class d extends k{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:c.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{insertSpace:g(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(se){se[se.Hidden=0]="Hidden",se[se.Blink=1]="Blink",se[se.Smooth=2]="Smooth",se[se.Phase=3]="Phase",se[se.Expand=4]="Expand",se[se.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(se){switch(se){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(se){se[se.Line=1]="Line",se[se.Block=2]="Block",se[se.Underline=3]="Underline",se[se.LineThin=4]="LineThin",se[se.BlockOutline=5]="BlockOutline",se[se.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function C(se){switch(se){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=C;function R(se){switch(se){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class U extends w{constructor(){super(130)}compute(oe,Se,ue){const Ie=["monaco-editor"];return Se.get(34)&&Ie.push(Se.get(34)),oe.extraEditorClassName&&Ie.push(oe.extraEditorClassName),Se.get(67)==="default"?Ie.push("mouse-default"):Se.get(67)==="copy"&&Ie.push("mouse-copy"),Se.get(101)&&Ie.push("showUnused"),Se.get(128)&&Ie.push("showDeprecated"),Ie.join(" ")}}class H extends h{constructor(){super(33,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(oe,Se,ue){return ue&&oe.emptySelectionClipboard}}class V extends k{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:c.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:c.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{cursorMoveOnType:g(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":s(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":s(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Se.loop,this.defaultValue.loop)}}}class L extends k{constructor(){super(46,"fontLigatures",L.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"?L.OFF:oe==="true"?L.ON:oe:Boolean(oe)?L.ON:L.OFF}}e.EditorFontLigatures=L,L.OFF='"liga" off, "calt" off',L.ON='"liga" on, "calt" on';class M extends w{constructor(){super(45)}compute(oe,Se,ue){return oe.fontInfo}}class F extends f{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(22,null)})}validate(oe){const Se=r.float(oe,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:r.clamp(Se,6,100)}compute(oe,Se,ue){return oe.fontInfo.fontSize}}class B extends k{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.MINIMUM_VALUE,maximum:B.MAXIMUM_VALUE,errorMessage:c.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(24,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(m.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,B.MINIMUM_VALUE,B.MAXIMUM_VALUE))}}B.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],B.MINIMUM_VALUE=1,B.MAXIMUM_VALUE=1e3;class N extends k{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[c.localize(25,null),c.localize(26,null),c.localize(27,null)]},ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(29,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(30,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:c.localize(31,null),...Se},"editor.gotoLocation.multipleImplementations":{description:c.localize(32,null),...Se},"editor.gotoLocation.multipleReferences":{description:c.localize(33,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:ue,description:c.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:ue,description:c.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:ue,description:c.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:ue,description:c.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:ue,description:c.localize(38,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{multiple:s(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??s(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??s(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??s(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??s(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??s(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends k{constructor(){const oe={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:c.localize(39,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:c.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:c.localize(41,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:c.localize(42,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{enabled:g(Se.enabled,this.defaultValue.enabled),delay:m.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:g(Se.sticky,this.defaultValue.sticky),above:g(Se.above,this.defaultValue.above)}}}var j;(function(se){se[se.None=0]="None",se[se.Text=1]="Text",se[se.Blocks=2]="Blocks"})(j=e.RenderMinimap||(e.RenderMinimap={}));class x extends w{constructor(){super(133)}compute(oe,Se,ue){return x.computeLayout(Se,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio})}static computeContainedMinimapLineCount(oe){const Se=oe.height/oe.lineHeight,ue=oe.scrollBeyondLastLine?Se-1:0,Ie=(oe.viewLineCount+ue)/(oe.pixelRatio*oe.height),Le=Math.floor(oe.viewLineCount/Ie);return{typicalViewportLineCount:Se,extraLinesBeyondLastLine:ue,desiredRatio:Ie,minimapLineCount:Le}}static _computeMinimapLayout(oe,Se){const ue=oe.outerWidth,Ie=oe.outerHeight,Le=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Le*Ie),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ie};const Fe=Se.stableMinimapLayoutInput,Ge=Fe&&oe.outerHeight===Fe.outerHeight&&oe.lineHeight===Fe.lineHeight&&oe.typicalHalfwidthCharacterWidth===Fe.typicalHalfwidthCharacterWidth&&oe.pixelRatio===Fe.pixelRatio&&oe.scrollBeyondLastLine===Fe.scrollBeyondLastLine&&oe.minimap.enabled===Fe.minimap.enabled&&oe.minimap.side===Fe.minimap.side&&oe.minimap.size===Fe.minimap.size&&oe.minimap.showSlider===Fe.minimap.showSlider&&oe.minimap.renderCharacters===Fe.minimap.renderCharacters&&oe.minimap.maxColumn===Fe.minimap.maxColumn&&oe.minimap.scale===Fe.minimap.scale&&oe.verticalScrollbarWidth===Fe.verticalScrollbarWidth&&oe.isViewportWrapping===Fe.isViewportWrapping,Ye=oe.lineHeight,it=oe.typicalHalfwidthCharacterWidth,bt=oe.scrollBeyondLastLine,st=oe.minimap.renderCharacters;let et=Le>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const wt=oe.minimap.maxColumn,St=oe.minimap.size,Dt=oe.minimap.side,ft=oe.verticalScrollbarWidth,kt=oe.viewLineCount,Ut=oe.remainingWidth,Lt=oe.isViewportWrapping,Qe=st?2:3;let Pt=Math.floor(Le*Ie);const Ot=Pt/Le;let Bt=!1,pt=!1,Ae=Qe*et,Oe=et/Le,Ee=1;if(St==="fill"||St==="fit"){const{typicalViewportLineCount:ct,extraLinesBeyondLastLine:At,desiredRatio:Et,minimapLineCount:It}=x.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:bt,height:Ie,lineHeight:Ye,pixelRatio:Le});if(kt/It>1)Bt=!0,pt=!0,et=1,Ae=1,Oe=et/Le;else{let Ft=!1,mt=et+1;if(St==="fit"){const Nt=Math.ceil((kt+At)*Ae);Lt&&Ge&&Ut<=Se.stableFitRemainingWidth?(Ft=!0,mt=Se.stableFitMaxMinimapScale):Ft=Nt>Pt}if(St==="fill"||Ft){Bt=!0;const Nt=et;Ae=Math.min(Ye*Le,Math.max(1,Math.floor(1/Et))),Lt&&Ge&&Ut<=Se.stableFitRemainingWidth&&(mt=Se.stableFitMaxMinimapScale),et=Math.min(mt,Math.max(1,Math.floor(Ae/Qe))),et>Nt&&(Ee=Math.min(2,et/Nt)),Oe=et/Le/Ee,Pt=Math.ceil(Math.max(ct,kt+At)*Ae),Lt?(Se.stableMinimapLayoutInput=oe,Se.stableFitRemainingWidth=Ut,Se.stableFitMaxMinimapScale=et):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const te=Math.floor(wt*Oe),Ne=Math.min(te,Math.max(0,Math.floor((Ut-ft-2)*Oe/(it+Oe)))+e.MINIMAP_GUTTER_WIDTH);let $e=Math.floor(Le*Ne);const tt=$e/Le;$e=Math.floor($e*Ee);const qe=st?1:2,ot=Dt==="left"?0:ue-Ne-ft;return{renderMinimap:qe,minimapLeft:ot,minimapWidth:Ne,minimapHeightIsEditorHeight:Bt,minimapIsSampling:pt,minimapScale:et,minimapLineHeight:Ae,minimapCanvasInnerWidth:$e,minimapCanvasInnerHeight:Pt,minimapCanvasOuterWidth:tt,minimapCanvasOuterHeight:Ot}}static computeLayout(oe,Se){const ue=Se.outerWidth|0,Ie=Se.outerHeight|0,Le=Se.lineHeight|0,Fe=Se.lineNumbersDigitCount|0,Ge=Se.typicalHalfwidthCharacterWidth,Ye=Se.maxDigitWidth,it=Se.pixelRatio,bt=Se.viewLineCount,st=oe.get(125),et=st==="inherit"?oe.get(124):st,wt=et==="inherit"?oe.get(120):et,St=oe.get(123),Dt=Se.isDominatedByLongLines,ft=oe.get(51),kt=oe.get(61).renderType!==0,Ut=oe.get(62),Lt=oe.get(95),Qe=oe.get(66),Pt=oe.get(93),Ot=Pt.verticalScrollbarSize,Bt=Pt.verticalHasArrows,pt=Pt.arrowSize,Ae=Pt.horizontalScrollbarSize,Oe=oe.get(59),Ee=oe.get(38),te=oe.get(100)!=="never";let Ne;if(typeof Oe=="string"&&/^\d+(\.\d+)?ch$/.test(Oe)){const xt=parseFloat(Oe.substr(0,Oe.length-2));Ne=m.clampedInt(xt*Ge,0,0,1e3)}else Ne=m.clampedInt(Oe,0,0,1e3);Ee&&te&&(Ne+=16);let $e=0;if(kt){const xt=Math.max(Fe,Ut);$e=Math.round(xt*Ye)}let tt=0;ft&&(tt=Le);let qe=0,ot=qe+tt,ct=ot+$e,At=ct+Ne;const Et=ue-tt-$e-Ne;let It=!1,vt=!1,Ft=-1;et==="inherit"&&Dt?(It=!0,vt=!0):wt==="on"||wt==="bounded"?vt=!0:wt==="wordWrapColumn"&&(Ft=St);const mt=x._computeMinimapLayout({outerWidth:ue,outerHeight:Ie,lineHeight:Le,typicalHalfwidthCharacterWidth:Ge,pixelRatio:it,scrollBeyondLastLine:Lt,minimap:Qe,verticalScrollbarWidth:Ot,viewLineCount:bt,remainingWidth:Et,isViewportWrapping:vt},Se.memory||new A);mt.renderMinimap!==0&&mt.minimapLeft===0&&(qe+=mt.minimapWidth,ot+=mt.minimapWidth,ct+=mt.minimapWidth,At+=mt.minimapWidth);const Nt=Et-mt.minimapWidth,Gt=Math.max(1,Math.floor((Nt-Ot-2)/Ge)),_t=Bt?pt:0;return vt&&(Ft=Math.max(1,Gt),wt==="bounded"&&(Ft=Math.min(Ft,St))),{width:ue,height:Ie,glyphMarginLeft:qe,glyphMarginWidth:tt,lineNumbersLeft:ot,lineNumbersWidth:$e,decorationsLeft:ct,decorationsWidth:Ne,contentLeft:At,contentWidth:Nt,minimap:mt,viewportColumn:Gt,isWordWrapMinified:It,isViewportWrapping:vt,wrappingColumn:Ft,verticalScrollbarWidth:Ot,horizontalScrollbarHeight:Ae,overviewRuler:{top:_t,width:Ot,height:Ie-2*_t,right:0}}}}e.EditorLayoutInfoComputer=x;class Q extends k{constructor(){super(127,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(43,null),c.localize(44,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(45,null)}})}validate(oe){return s(oe,"simple",["simple","advanced"])}compute(oe,Se,ue){return Se.get(2)===2?"advanced":ue}}class K extends k{constructor(){const oe={enabled:!0};super(58,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"boolean",default:oe.enabled,description:c.localize(46,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:g(oe.enabled,this.defaultValue.enabled)}}}class le extends k{constructor(){const oe={enabled:!1,maxLineCount:5};super(105,"stickyScroll",oe,{"editor.stickyScroll.enabled":{type:"boolean",default:oe.enabled,description:c.localize(47,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:oe.maxLineCount,minimum:1,maximum:10,description:c.localize(48,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{enabled:g(Se.enabled,this.defaultValue.enabled),maxLineCount:m.clampedInt(Se.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class ie extends k{constructor(){const oe={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"string",default:oe.enabled,description:c.localize(49,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(50,null),c.localize(51,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(52,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(53,null)]},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:c.localize(54,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:c.localize(55,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:oe.padding,description:c.localize(56,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return typeof Se.enabled=="boolean"&&(Se.enabled=Se.enabled?"on":"off"),{enabled:s(Se.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:m.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(Se.fontFamily,this.defaultValue.fontFamily),padding:g(Se.padding,this.defaultValue.padding)}}}class de extends r{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>r.clamp(oe,0,150),{markdownDescription:c.localize(57,null)})}compute(oe,Se,ue){return oe.fontInfo.lineHeight}}class Y extends k{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:c.localize(58,null)},"editor.minimap.autohide":{type:"boolean",default:oe.autohide,description:c.localize(59,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(60,null),c.localize(61,null),c.localize(62,null)],default:oe.size,description:c.localize(63,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:c.localize(64,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:c.localize(65,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(66,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:c.localize(67,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:c.localize(68,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{enabled:g(Se.enabled,this.defaultValue.enabled),autohide:g(Se.autohide,this.defaultValue.autohide),size:s(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(Se.side,this.defaultValue.side,["right","left"]),showSlider:s(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Se.renderCharacters,this.defaultValue.renderCharacters),scale:m.clampedInt(Se.scale,1,1,3),maxColumn:m.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function pe(se){return se==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class be extends k{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(69,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(70,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{top:m.clampedInt(Se.top,0,0,1e3),bottom:m.clampedInt(Se.bottom,0,0,1e3)}}}class Ce extends k{constructor(){const oe={enabled:!0,cycle:!1};super(77,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:c.localize(71,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:c.localize(72,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{enabled:g(Se.enabled,this.defaultValue.enabled),cycle:g(Se.cycle,this.defaultValue.cycle)}}}class Re extends w{constructor(){super(131)}compute(oe,Se,ue){return oe.pixelRatio}}class We extends k{constructor(){const oe={other:"on",comments:"off",strings:"off"},Se=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(73,null),c.localize(74,null),c.localize(75,null)]}];super(80,"quickSuggestions",oe,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Se,default:oe.strings,description:c.localize(76,null)},comments:{anyOf:Se,default:oe.comments,description:c.localize(77,null)},other:{anyOf:Se,default:oe.other,description:c.localize(78,null)}},default:oe,markdownDescription:c.localize(79,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const it=oe?"on":"off";return{comments:it,strings:it,other:it}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:Se,comments:ue,strings:Ie}=oe,Le=["on","inline","off"];let Fe,Ge,Ye;return typeof Se=="boolean"?Fe=Se?"on":"off":Fe=s(Se,this.defaultValue.other,Le),typeof ue=="boolean"?Ge=ue?"on":"off":Ge=s(ue,this.defaultValue.comments,Le),typeof Ie=="boolean"?Ye=Ie?"on":"off":Ye=s(Ie,this.defaultValue.strings,Le),{other:Fe,comments:Ge,strings:Ye}}}var ne;(function(se){se[se.Off=0]="Off",se[se.On=1]="On",se[se.Relative=2]="Relative",se[se.Interval=3]="Interval",se[se.Custom=4]="Custom"})(ne=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ce extends k{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(80,null),c.localize(81,null),c.localize(82,null),c.localize(83,null)],default:"on",description:c.localize(84,null)})}validate(oe){let Se=this.defaultValue.renderType,ue=this.defaultValue.renderFn;return typeof oe<"u"&&(typeof oe=="function"?(Se=4,ue=oe):oe==="interval"?Se=3:oe==="relative"?Se=2:oe==="on"?Se=1:Se=0),{renderType:Se,renderFn:ue}}}function fe(se){const oe=se.get(88);return oe==="editable"?se.get(82):oe!=="on"}e.filterValidationDecorations=fe;class J extends k{constructor(){const oe=[],Se={type:"number",description:c.localize(85,null)};super(92,"rulers",oe,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:c.localize(86,null),format:"color-hex"}}}]},default:oe,description:c.localize(87,null)})}validate(oe){if(Array.isArray(oe)){const Se=[];for(const ue of oe)if(typeof ue=="number")Se.push({column:m.clampedInt(ue,0,0,1e4),color:null});else if(ue&&typeof ue=="object"){const Ie=ue;Se.push({column:m.clampedInt(Ie.column,0,0,1e4),color:Ie.color})}return Se.sort((ue,Ie)=>ue.column-Ie.column),Se}return this.defaultValue}}function re(se,oe){if(typeof se!="string")return oe;switch(se){case"hidden":return 2;case"visible":return 3;default:return 1}}class ee extends k{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(88,null),c.localize(89,null),c.localize(90,null)],default:"auto",description:c.localize(91,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(92,null),c.localize(93,null),c.localize(94,null)],default:"auto",description:c.localize(95,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:c.localize(96,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:c.localize(97,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:c.localize(98,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe,ue=m.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ie=m.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:m.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:re(Se.vertical,this.defaultValue.vertical),horizontal:re(Se.horizontal,this.defaultValue.horizontal),useShadows:g(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ue,horizontalSliderSize:m.clampedInt(Se.horizontalSliderSize,ue,0,1e3),verticalScrollbarSize:Ie,verticalSliderSize:m.clampedInt(Se.verticalSliderSize,Ie,0,1e3),scrollByPage:g(Se.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class O extends k{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:c.localize(99,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:c.localize(100,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:c.localize(101,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:c.localize(102,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:c.localize(103,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:c.localize(104,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:c.localize(105,null)}})}applyUpdate(oe,Se){let ue=!1;Se.allowedCharacters&&oe&&(y.equals(oe.allowedCharacters,Se.allowedCharacters)||(oe={...oe,allowedCharacters:Se.allowedCharacters},ue=!0)),Se.allowedLocales&&oe&&(y.equals(oe.allowedLocales,Se.allowedLocales)||(oe={...oe,allowedLocales:Se.allowedLocales},ue=!0));const Ie=super.applyUpdate(oe,Se);return ue?new E(Ie.newValue,!0):Ie}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{nonBasicASCII:ae(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ae(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ae(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(oe.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(oe,Se){if(typeof oe!="object"||!oe)return Se;const ue={};for(const[Ie,Le]of Object.entries(oe))Le===!0&&(ue[Ie]=!0);return ue}}class W extends k{constructor(){const oe={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:c.localize(106,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{enabled:g(Se.enabled,this.defaultValue.enabled),mode:s(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class q extends k{constructor(){const oe={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:c.localize(107,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:c.localize(108,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{enabled:g(Se.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(Se.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class X extends k{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(109,null),c.localize(110,null),c.localize(111,null)],default:oe.bracketPairs,description:c.localize(112,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(113,null),c.localize(114,null),c.localize(115,null)],default:oe.bracketPairsHorizontal,description:c.localize(116,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:c.localize(117,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:c.localize(118,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(119,null),c.localize(120,null),c.localize(121,null)],default:oe.highlightActiveIndentation,description:c.localize(122,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{bracketPairs:ae(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ae(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:ae(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ae(se,oe,Se){const ue=Se.indexOf(se);return ue===-1?oe:Se[ue]}class ve extends k{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(123,null),c.localize(124,null)],default:oe.insertMode,description:c.localize(125,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:c.localize(126,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:c.localize(127,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:c.localize(128,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:c.localize(129,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:c.localize(130,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:c.localize(131,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:c.localize(132,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:c.localize(133,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(134,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(135,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(136,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(137,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(138,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(139,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(140,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(141,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(142,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(143,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(144,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(145,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(146,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(147,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(148,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(149,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(150,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(151,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(163,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(164,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(165,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{insertMode:s(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:g(Se.showIcons,this.defaultValue.showIcons),showStatusBar:g(Se.showStatusBar,this.defaultValue.showStatusBar),preview:g(Se.preview,this.defaultValue.preview),previewMode:s(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Se.showMethods,this.defaultValue.showMethods),showFunctions:g(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Se.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(Se.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(Se.showFields,this.defaultValue.showFields),showVariables:g(Se.showVariables,this.defaultValue.showVariables),showClasses:g(Se.showClasses,this.defaultValue.showClasses),showStructs:g(Se.showStructs,this.defaultValue.showStructs),showInterfaces:g(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Se.showModules,this.defaultValue.showModules),showProperties:g(Se.showProperties,this.defaultValue.showProperties),showEvents:g(Se.showEvents,this.defaultValue.showEvents),showOperators:g(Se.showOperators,this.defaultValue.showOperators),showUnits:g(Se.showUnits,this.defaultValue.showUnits),showValues:g(Se.showValues,this.defaultValue.showValues),showConstants:g(Se.showConstants,this.defaultValue.showConstants),showEnums:g(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Se.showKeywords,this.defaultValue.showKeywords),showWords:g(Se.showWords,this.defaultValue.showWords),showColors:g(Se.showColors,this.defaultValue.showColors),showFiles:g(Se.showFiles,this.defaultValue.showFiles),showReferences:g(Se.showReferences,this.defaultValue.showReferences),showFolders:g(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Se.showSnippets,this.defaultValue.showSnippets),showUsers:g(Se.showUsers,this.defaultValue.showUsers),showIssues:g(Se.showIssues,this.defaultValue.showIssues)}}}class Te extends k{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(166,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ge extends w{constructor(){super(132)}compute(oe,Se,ue){return Se.get(82)?!0:oe.tabFocusMode}}var Pe;(function(se){se[se.None=0]="None",se[se.Same=1]="Same",se[se.Indent=2]="Indent",se[se.DeepIndent=3]="DeepIndent"})(Pe=e.WrappingIndent||(e.WrappingIndent={}));class De extends k{constructor(){super(126,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(167,null),c.localize(168,null),c.localize(169,null),c.localize(170,null)],description:c.localize(171,null),default:"same"}})}validate(oe){switch(oe){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(oe,Se,ue){return Se.get(2)===2?0:ue}}class xe extends w{constructor(){super(134)}compute(oe,Se,ue){const Ie=Se.get(133);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:Ie.isWordWrapMinified,isViewportWrapping:Ie.isViewportWrapping,wrappingColumn:Ie.wrappingColumn}}}class je extends k{constructor(){const oe={enabled:!0};super(32,"dropIntoEditor",oe,{"editor.dropIntoEditor.enabled":{type:"boolean",default:oe.enabled,markdownDescription:c.localize(172,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:g(oe.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",Xe="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Xe:t.isLinux?rt:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(se){return e.editorOptionsRegistry[se.id]=se,se}var dt;(function(se){se[se.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",se[se.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",se[se.accessibilitySupport=2]="accessibilitySupport",se[se.accessibilityPageSize=3]="accessibilityPageSize",se[se.ariaLabel=4]="ariaLabel",se[se.autoClosingBrackets=5]="autoClosingBrackets",se[se.autoClosingDelete=6]="autoClosingDelete",se[se.autoClosingOvertype=7]="autoClosingOvertype",se[se.autoClosingQuotes=8]="autoClosingQuotes",se[se.autoIndent=9]="autoIndent",se[se.automaticLayout=10]="automaticLayout",se[se.autoSurround=11]="autoSurround",se[se.bracketPairColorization=12]="bracketPairColorization",se[se.guides=13]="guides",se[se.codeLens=14]="codeLens",se[se.codeLensFontFamily=15]="codeLensFontFamily",se[se.codeLensFontSize=16]="codeLensFontSize",se[se.colorDecorators=17]="colorDecorators",se[se.columnSelection=18]="columnSelection",se[se.comments=19]="comments",se[se.contextmenu=20]="contextmenu",se[se.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",se[se.cursorBlinking=22]="cursorBlinking",se[se.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",se[se.cursorStyle=24]="cursorStyle",se[se.cursorSurroundingLines=25]="cursorSurroundingLines",se[se.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",se[se.cursorWidth=27]="cursorWidth",se[se.disableLayerHinting=28]="disableLayerHinting",se[se.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",se[se.domReadOnly=30]="domReadOnly",se[se.dragAndDrop=31]="dragAndDrop",se[se.dropIntoEditor=32]="dropIntoEditor",se[se.emptySelectionClipboard=33]="emptySelectionClipboard",se[se.extraEditorClassName=34]="extraEditorClassName",se[se.fastScrollSensitivity=35]="fastScrollSensitivity",se[se.find=36]="find",se[se.fixedOverflowWidgets=37]="fixedOverflowWidgets",se[se.folding=38]="folding",se[se.foldingStrategy=39]="foldingStrategy",se[se.foldingHighlight=40]="foldingHighlight",se[se.foldingImportsByDefault=41]="foldingImportsByDefault",se[se.foldingMaximumRegions=42]="foldingMaximumRegions",se[se.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",se[se.fontFamily=44]="fontFamily",se[se.fontInfo=45]="fontInfo",se[se.fontLigatures=46]="fontLigatures",se[se.fontSize=47]="fontSize",se[se.fontWeight=48]="fontWeight",se[se.formatOnPaste=49]="formatOnPaste",se[se.formatOnType=50]="formatOnType",se[se.glyphMargin=51]="glyphMargin",se[se.gotoLocation=52]="gotoLocation",se[se.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",se[se.hover=54]="hover",se[se.inDiffEditor=55]="inDiffEditor",se[se.inlineSuggest=56]="inlineSuggest",se[se.letterSpacing=57]="letterSpacing",se[se.lightbulb=58]="lightbulb",se[se.lineDecorationsWidth=59]="lineDecorationsWidth",se[se.lineHeight=60]="lineHeight",se[se.lineNumbers=61]="lineNumbers",se[se.lineNumbersMinChars=62]="lineNumbersMinChars",se[se.linkedEditing=63]="linkedEditing",se[se.links=64]="links",se[se.matchBrackets=65]="matchBrackets",se[se.minimap=66]="minimap",se[se.mouseStyle=67]="mouseStyle",se[se.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",se[se.mouseWheelZoom=69]="mouseWheelZoom",se[se.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",se[se.multiCursorModifier=71]="multiCursorModifier",se[se.multiCursorPaste=72]="multiCursorPaste",se[se.occurrencesHighlight=73]="occurrencesHighlight",se[se.overviewRulerBorder=74]="overviewRulerBorder",se[se.overviewRulerLanes=75]="overviewRulerLanes",se[se.padding=76]="padding",se[se.parameterHints=77]="parameterHints",se[se.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",se[se.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",se[se.quickSuggestions=80]="quickSuggestions",se[se.quickSuggestionsDelay=81]="quickSuggestionsDelay",se[se.readOnly=82]="readOnly",se[se.renameOnType=83]="renameOnType",se[se.renderControlCharacters=84]="renderControlCharacters",se[se.renderFinalNewline=85]="renderFinalNewline",se[se.renderLineHighlight=86]="renderLineHighlight",se[se.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",se[se.renderValidationDecorations=88]="renderValidationDecorations",se[se.renderWhitespace=89]="renderWhitespace",se[se.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",se[se.roundedSelection=91]="roundedSelection",se[se.rulers=92]="rulers",se[se.scrollbar=93]="scrollbar",se[se.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",se[se.scrollBeyondLastLine=95]="scrollBeyondLastLine",se[se.scrollPredominantAxis=96]="scrollPredominantAxis",se[se.selectionClipboard=97]="selectionClipboard",se[se.selectionHighlight=98]="selectionHighlight",se[se.selectOnLineNumbers=99]="selectOnLineNumbers",se[se.showFoldingControls=100]="showFoldingControls",se[se.showUnused=101]="showUnused",se[se.snippetSuggestions=102]="snippetSuggestions",se[se.smartSelect=103]="smartSelect",se[se.smoothScrolling=104]="smoothScrolling",se[se.stickyScroll=105]="stickyScroll",se[se.stickyTabStops=106]="stickyTabStops",se[se.stopRenderingLineAfter=107]="stopRenderingLineAfter",se[se.suggest=108]="suggest",se[se.suggestFontSize=109]="suggestFontSize",se[se.suggestLineHeight=110]="suggestLineHeight",se[se.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",se[se.suggestSelection=112]="suggestSelection",se[se.tabCompletion=113]="tabCompletion",se[se.tabIndex=114]="tabIndex",se[se.unicodeHighlighting=115]="unicodeHighlighting",se[se.unusualLineTerminators=116]="unusualLineTerminators",se[se.useShadowDOM=117]="useShadowDOM",se[se.useTabStops=118]="useTabStops",se[se.wordSeparators=119]="wordSeparators",se[se.wordWrap=120]="wordWrap",se[se.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",se[se.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",se[se.wordWrapColumn=123]="wordWrapColumn",se[se.wordWrapOverride1=124]="wordWrapOverride1",se[se.wordWrapOverride2=125]="wordWrapOverride2",se[se.wrappingIndent=126]="wrappingIndent",se[se.wrappingStrategy=127]="wrappingStrategy",se[se.showDeprecated=128]="showDeprecated",se[se.inlayHints=129]="inlayHints",se[se.editorClassName=130]="editorClassName",se[se.pixelRatio=131]="pixelRatio",se[se.tabFocusMode=132]="tabFocusMode",se[se.layoutInfo=133]="layoutInfo",se[se.wrappingInfo=134]="wrappingInfo"})(dt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(173,null)})),acceptSuggestionOnEnter:Be(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(174,null),""],markdownDescription:c.localize(175,null)})),accessibilitySupport:Be(new a),accessibilityPageSize:Be(new m(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(176,null),tags:["accessibility"]})),ariaLabel:Be(new b(4,"ariaLabel",c.localize(177,null))),autoClosingBrackets:Be(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(178,null),c.localize(179,null),""],description:c.localize(180,null)})),autoClosingDelete:Be(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(181,null),""],description:c.localize(182,null)})),autoClosingOvertype:Be(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(183,null),""],description:c.localize(184,null)})),autoClosingQuotes:Be(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(185,null),c.localize(186,null),""],description:c.localize(187,null)})),autoIndent:Be(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[c.localize(188,null),c.localize(189,null),c.localize(190,null),c.localize(191,null),c.localize(192,null)],description:c.localize(193,null)})),automaticLayout:Be(new h(10,"automaticLayout",!1)),autoSurround:Be(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(194,null),c.localize(195,null),c.localize(196,null),""],description:c.localize(197,null)})),bracketPairColorization:Be(new q),bracketPairGuides:Be(new X),stickyTabStops:Be(new h(106,"stickyTabStops",!1,{description:c.localize(198,null)})),codeLens:Be(new h(14,"codeLens",!0,{description:c.localize(199,null)})),codeLensFontFamily:Be(new b(15,"codeLensFontFamily","",{description:c.localize(200,null)})),codeLensFontSize:Be(new m(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(201,null)})),colorDecorators:Be(new h(17,"colorDecorators",!0,{description:c.localize(202,null)})),columnSelection:Be(new h(18,"columnSelection",!1,{description:c.localize(203,null)})),comments:Be(new d),contextmenu:Be(new h(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new h(21,"copyWithSyntaxHighlighting",!0,{description:c.localize(204,null)})),cursorBlinking:Be(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:c.localize(205,null)})),cursorSmoothCaretAnimation:Be(new h(23,"cursorSmoothCaretAnimation",!1,{description:c.localize(206,null)})),cursorStyle:Be(new o(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:c.localize(207,null)})),cursorSurroundingLines:Be(new m(25,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(208,null)})),cursorSurroundingLinesStyle:Be(new u(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(209,null),c.localize(210,null)],description:c.localize(211,null)})),cursorWidth:Be(new m(27,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(212,null)})),disableLayerHinting:Be(new h(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new h(29,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new h(30,"domReadOnly",!1)),dragAndDrop:Be(new h(31,"dragAndDrop",!0,{description:c.localize(213,null)})),emptySelectionClipboard:Be(new H),dropIntoEditor:Be(new je),stickyScroll:Be(new le),extraEditorClassName:Be(new b(34,"extraEditorClassName","")),fastScrollSensitivity:Be(new r(35,"fastScrollSensitivity",5,se=>se<=0?5:se,{markdownDescription:c.localize(214,null)})),find:Be(new V),fixedOverflowWidgets:Be(new h(37,"fixedOverflowWidgets",!1)),folding:Be(new h(38,"folding",!0,{description:c.localize(215,null)})),foldingStrategy:Be(new u(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(216,null),c.localize(217,null)],description:c.localize(218,null)})),foldingHighlight:Be(new h(40,"foldingHighlight",!0,{description:c.localize(219,null)})),foldingImportsByDefault:Be(new h(41,"foldingImportsByDefault",!1,{description:c.localize(220,null)})),foldingMaximumRegions:Be(new m(42,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(221,null)})),unfoldOnClickAfterEndOfLine:Be(new h(43,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(222,null)})),fontFamily:Be(new b(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(223,null)})),fontInfo:Be(new M),fontLigatures2:Be(new L),fontSize:Be(new F),fontWeight:Be(new B),formatOnPaste:Be(new h(49,"formatOnPaste",!1,{description:c.localize(224,null)})),formatOnType:Be(new h(50,"formatOnType",!1,{description:c.localize(225,null)})),glyphMargin:Be(new h(51,"glyphMargin",!0,{description:c.localize(226,null)})),gotoLocation:Be(new N),hideCursorInOverviewRuler:Be(new h(53,"hideCursorInOverviewRuler",!1,{description:c.localize(227,null)})),hover:Be(new z),inDiffEditor:Be(new h(55,"inDiffEditor",!1)),letterSpacing:Be(new r(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,se=>r.clamp(se,-5,20),{description:c.localize(228,null)})),lightbulb:Be(new K),lineDecorationsWidth:Be(new f(59,"lineDecorationsWidth",10)),lineHeight:Be(new de),lineNumbers:Be(new ce),lineNumbersMinChars:Be(new m(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new h(63,"linkedEditing",!1,{description:c.localize(229,null)})),links:Be(new h(64,"links",!0,{description:c.localize(230,null)})),matchBrackets:Be(new u(65,"matchBrackets","always",["always","near","never"],{description:c.localize(231,null)})),minimap:Be(new Y),mouseStyle:Be(new u(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new r(68,"mouseWheelScrollSensitivity",1,se=>se===0?1:se,{markdownDescription:c.localize(232,null)})),mouseWheelZoom:Be(new h(69,"mouseWheelZoom",!1,{markdownDescription:c.localize(233,null)})),multiCursorMergeOverlapping:Be(new h(70,"multiCursorMergeOverlapping",!0,{description:c.localize(234,null)})),multiCursorModifier:Be(new o(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[c.localize(235,null),c.localize(236,null)],markdownDescription:c.localize(237,null)})),multiCursorPaste:Be(new u(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(238,null),c.localize(239,null)],markdownDescription:c.localize(240,null)})),occurrencesHighlight:Be(new h(73,"occurrencesHighlight",!0,{description:c.localize(241,null)})),overviewRulerBorder:Be(new h(74,"overviewRulerBorder",!0,{description:c.localize(242,null)})),overviewRulerLanes:Be(new m(75,"overviewRulerLanes",3,0,3)),padding:Be(new be),parameterHints:Be(new Ce),peekWidgetDefaultFocus:Be(new u(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(243,null),c.localize(244,null)],description:c.localize(245,null)})),definitionLinkOpensInPeek:Be(new h(79,"definitionLinkOpensInPeek",!1,{description:c.localize(246,null)})),quickSuggestions:Be(new We),quickSuggestionsDelay:Be(new m(81,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(247,null)})),readOnly:Be(new h(82,"readOnly",!1)),renameOnType:Be(new h(83,"renameOnType",!1,{description:c.localize(248,null),markdownDeprecationMessage:c.localize(249,null)})),renderControlCharacters:Be(new h(84,"renderControlCharacters",!0,{description:c.localize(250,null),restricted:!0})),renderFinalNewline:Be(new h(85,"renderFinalNewline",!0,{description:c.localize(251,null)})),renderLineHighlight:Be(new u(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(252,null)],description:c.localize(253,null)})),renderLineHighlightOnlyWhenFocus:Be(new h(87,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(254,null)})),renderValidationDecorations:Be(new u(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new u(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(255,null),c.localize(256,null),c.localize(257,null),""],description:c.localize(258,null)})),revealHorizontalRightPadding:Be(new m(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new h(91,"roundedSelection",!0,{description:c.localize(259,null)})),rulers:Be(new J),scrollbar:Be(new ee),scrollBeyondLastColumn:Be(new m(94,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(260,null)})),scrollBeyondLastLine:Be(new h(95,"scrollBeyondLastLine",!0,{description:c.localize(261,null)})),scrollPredominantAxis:Be(new h(96,"scrollPredominantAxis",!0,{description:c.localize(262,null)})),selectionClipboard:Be(new h(97,"selectionClipboard",!0,{description:c.localize(263,null),included:t.isLinux})),selectionHighlight:Be(new h(98,"selectionHighlight",!0,{description:c.localize(264,null)})),selectOnLineNumbers:Be(new h(99,"selectOnLineNumbers",!0)),showFoldingControls:Be(new u(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(265,null),c.localize(266,null),c.localize(267,null)],description:c.localize(268,null)})),showUnused:Be(new h(101,"showUnused",!0,{description:c.localize(269,null)})),showDeprecated:Be(new h(128,"showDeprecated",!0,{description:c.localize(270,null)})),inlayHints:Be(new ie),snippetSuggestions:Be(new u(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(271,null),c.localize(272,null),c.localize(273,null),c.localize(274,null)],description:c.localize(275,null)})),smartSelect:Be(new Te),smoothScrolling:Be(new h(104,"smoothScrolling",!1,{description:c.localize(276,null)})),stopRenderingLineAfter:Be(new m(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new ve),inlineSuggest:Be(new W),suggestFontSize:Be(new m(109,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(277,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new m(110,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(278,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new h(111,"suggestOnTriggerCharacters",!0,{description:c.localize(279,null)})),suggestSelection:Be(new u(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(280,null),c.localize(281,null),c.localize(282,null)],description:c.localize(283,null)})),tabCompletion:Be(new u(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(284,null),c.localize(285,null),c.localize(286,null)],description:c.localize(287,null)})),tabIndex:Be(new m(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new O),unusualLineTerminators:Be(new u(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(288,null),c.localize(289,null),c.localize(290,null)],description:c.localize(291,null)})),useShadowDOM:Be(new h(117,"useShadowDOM",!0)),useTabStops:Be(new h(118,"useTabStops",!0,{description:c.localize(292,null)})),wordSeparators:Be(new b(119,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:c.localize(293,null)})),wordWrap:Be(new u(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(294,null),c.localize(295,null),c.localize(296,null),c.localize(297,null)],description:c.localize(298,null)})),wordWrapBreakAfterCharacters:Be(new b(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new b(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new m(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(299,null)})),wordWrapOverride1:Be(new u(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new u(125,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new U),pixelRatio:Be(new Re),tabFocusMode:Be(new ge),layoutInfo:Be(new x),wrappingInfo:Be(new xe),wrappingIndent:Be(new De),wrappingStrategy:Be(new Q)}}),define(_e[164],ye([19,20]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(_e[165],ye([19,20]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(_e[166],ye([19,20]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(_e[167],ye([19,20]),function(Z,e){return Z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(_e[168],ye([19,20]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(_e[169],ye([19,20]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(_e[170],ye([19,20]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(_e[171],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(_e[172],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(_e[173],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(_e[174],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(_e[175],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(_e[176],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(_e[177],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(_e[178],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostDebugService",e)}),define(_e[179],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostTunnelService",e)}),define(_e[180],ye([19,20]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(_e[181],ye([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(_e[182],ye([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/debug",e)}),define(_e[183],ye([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(_e[184],ye([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(_e[185],ye([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(_e[186],ye([19,20]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(_e[187],ye([19,20]),function(Z,e){return Z.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(_e[188],ye([19,20]),function(Z,e){return Z.create("vs/workbench/services/search/common/queryBuilder",e)}),define(_e[189],ye([1,0,22,42,166,308]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function S(h){return h=h.trim(),h==="*"||y.test(h)}e.isValidVersionStr=S;function D(h){if(!S(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=h.match(y);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=D;function A(h){if(!h)return null;const v=h.majorBase,m=h.majorMustEqual,r=h.minorBase;let b=h.minorMustEqual;const s=h.patchBase;let u=h.patchMustEqual;h.hasCaret&&(v===0||(b=!1),u=!1);let o=0;if(h.preRelease){const l=T.exec(h.preRelease);if(l){const[,a,d,n]=l;o=Date.UTC(Number(a),Number(d)-1,Number(n))}}return{majorBase:v,majorMustEqual:m,minorBase:r,minorMustEqual:b,patchBase:s,patchMustEqual:u,isMinimum:h.hasGreaterEquals,notBefore:o}}e.normalizeVersion=A;function k(h,v,m){let r;typeof h=="string"?r=A(D(h)):r=h;let b;v instanceof Date?b=v.getTime():typeof v=="string"&&(b=new Date(v).getTime());let s;if(typeof m=="string"?s=A(D(m)):s=m,!r||!s)return!1;const u=r.majorBase,o=r.minorBase,l=r.patchBase;let a=s.majorBase,d=s.minorBase,n=s.patchBase;const i=s.notBefore;let p=s.majorMustEqual,C=s.minorMustEqual,R=s.patchMustEqual;return s.isMinimum?u>a?!0:u<a?!1:o>d?!0:o<d||b&&b<i?!1:l>=n:(u===1&&a===0&&(!p||!C||!R)&&(a=1,d=0,n=0,p=!0,C=!1,R=!1),u<a?!1:u>a?!p:o<d?!1:o>d?!C:l<n?!1:l>n?!R:!(b&&b<i))}e.isValidVersion=k;function E(h,v,m,r,b){const s=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return s.push([t.default.Error,I.localize(0,null)]),s;if(typeof r.name!="string")return s.push([t.default.Error,I.localize(1,null,"name")]),s;if(typeof r.version!="string")return s.push([t.default.Error,I.localize(2,null,"version")]),s;if(!r.engines)return s.push([t.default.Error,I.localize(3,null,"engines")]),s;if(typeof r.engines.vscode!="string")return s.push([t.default.Error,I.localize(4,null,"engines.vscode")]),s;if(typeof r.extensionDependencies<"u"&&!g(r.extensionDependencies))return s.push([t.default.Error,I.localize(5,null,"extensionDependencies")]),s;if(typeof r.activationEvents<"u"){if(!g(r.activationEvents))return s.push([t.default.Error,I.localize(6,null,"activationEvents")]),s;if(typeof r.main>"u"&&typeof r.browser>"u")return s.push([t.default.Error,I.localize(7,null,"activationEvents","main")]),s}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&s.push([t.default.Warning,I.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return s.push([t.default.Error,I.localize(9,null,"main")]),s;{const l=(0,c.joinPath)(m,r.main);(0,c.isEqualOrParent)(l,m)||s.push([t.default.Warning,I.localize(10,null,l.path,m.path)])}if(typeof r.activationEvents>"u")return s.push([t.default.Error,I.localize(11,null,"activationEvents","main")]),s}if(typeof r.browser<"u"){if(typeof r.browser!="string")return s.push([t.default.Error,I.localize(12,null,"browser")]),s;{const l=(0,c.joinPath)(m,r.browser);(0,c.isEqualOrParent)(l,m)||s.push([t.default.Warning,I.localize(13,null,l.path,m.path)])}if(typeof r.activationEvents>"u")return s.push([t.default.Error,I.localize(14,null,"activationEvents","browser")]),s}if(!P.valid(r.version))return s.push([t.default.Error,I.localize(15,null)]),s;const u=[];if(!_(h,v,r,b,u))for(const l of u)s.push([t.default.Error,l]);return s}e.validateExtensionManifest=E;function _(h,v,m,r,b){return r||typeof m.main>"u"&&typeof m.browser>"u"?!0:f(h,v,m.engines.vscode,b)}e.isValidExtensionVersion=_;function w(h,v,m){return h==="*"||f(v,m,h)}e.isEngineValid=w;function f(h,v,m,r=[]){const b=A(D(m));if(!b)return r.push(I.localize(16,null,m)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return r.push(I.localize(17,null,m)),!1}else if(!b.majorMustEqual)return r.push(I.localize(18,null,m)),!1;return k(h,v,b)?!0:(r.push(I.localize(19,null,h,m)),!1)}function g(h){if(!Array.isArray(h))return!1;for(let v=0,m=h.length;v<m;v++)if(typeof h[v]!="string")return!1;return!0}}),define(_e[120],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(I,P=[],y=!1){this.ctor=I,this.staticArguments=P,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=c}),define(_e[84],ye([1,0,120]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var I;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(I=e.InstantiationType||(e.InstantiationType={}));function P(T,S,D){S instanceof c.SyncDescriptor||(S=new c.SyncDescriptor(S,[],Boolean(D))),t.push([T,S])}e.registerSingleton=P;function y(){return t}e.getSingletonServiceDescriptors=y}),define(_e[190],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(P,y){this.key=P,this.data=y,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const y of this._nodes.values())y.outgoing.size===0&&P.push(y);return P}insertEdge(P,y){const T=this.lookupOrInsertNode(P),S=this.lookupOrInsertNode(y);T.outgoing.set(S.key,S),S.incoming.set(T.key,T)}removeNode(P){const y=this._hashFn(P);this._nodes.delete(y);for(const T of this._nodes.values())T.outgoing.delete(y),T.incoming.delete(y)}lookupOrInsertNode(P){const y=this._hashFn(P);let T=this._nodes.get(y);return T||(T=new c(y,P),this._nodes.set(y,T)),T}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[y,T]of this._nodes)P.push(`${y}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,y]of this._nodes){const T=new Set([P]),S=this._findCycle(y,T);if(S)return S}}_findCycle(P,y){for(const[T,S]of P.outgoing){if(y.has(T))return[...y,T].join(" -> ");y.add(T);const D=this._findCycle(S,y);if(D)return D;y.delete(T)}}}e.Graph=t}),define(_e[3],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function T(S){return S[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=T})(c=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(y,T,S){T[c.DI_TARGET]===T?T[c.DI_DEPENDENCIES].push({id:y,index:S}):(T[c.DI_DEPENDENCIES]=[{id:y,index:S}],T[c.DI_TARGET]=T)}function I(y){if(c.serviceIds.has(y))return c.serviceIds.get(y);const T=function(S,D,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(T,S,A)};return T.toString=()=>y,c.serviceIds.set(y,T),T}e.createDecorator=I;function P(y){return y}e.refineServiceDecorator=P}),define(_e[52],ye([1,0,11,2,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function P(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationOverrides=P;function y(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=y;var T;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function D(h,v){const m=Object.create(null);for(const r in h)A(m,r,h[r],v);return m}e.toValuesTree=D;function A(h,v,m,r){const b=v.split("."),s=b.pop();let u=h;for(let o=0;o<b.length;o++){const l=b[o];let a=u[l];switch(typeof a){case"undefined":a=u[l]=Object.create(null);break;case"object":break;default:r(`Ignoring ${v} as ${b.slice(0,o+1).join(".")} is ${JSON.stringify(a)}`);return}u=a}if(typeof u=="object"&&u!==null)try{u[s]=m}catch{r(`Ignoring ${v} as ${b.join(".")} is ${JSON.stringify(u)}`)}else r(`Ignoring ${v} as ${b.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=A;function k(h,v){const m=v.split(".");E(h,m)}e.removeFromValueTree=k;function E(h,v){const m=v.shift();if(v.length===0){delete h[m];return}if(Object.keys(h).indexOf(m)!==-1){const r=h[m];typeof r=="object"&&!Array.isArray(r)&&(E(r,v),Object.keys(r).length===0&&delete h[m])}}function _(h,v,m){function r(u,o){let l=u;for(const a of o){if(typeof l!="object"||l===null)return;l=l[a]}return l}const b=v.split("."),s=r(h,b);return typeof s>"u"?m:s}e.getConfigurationValue=_;function w(h,v,m){Object.keys(v).forEach(r=>{r!=="__proto__"&&(r in h?c.isObject(h[r])&&c.isObject(v[r])?w(h[r],v[r],m):m&&(h[r]=v[r]):h[r]=v[r])})}e.merge=w;function f(h,v,m){const r=h.inspect(v),b=h.inspect(m);return typeof r.userValue<"u"||typeof r.workspaceValue<"u"||typeof r.workspaceFolderValue<"u"?r.value:typeof b.userValue<"u"||typeof b.workspaceValue<"u"||typeof b.workspaceFolderValue<"u"?b.value:r.defaultValue}e.getMigratedSettingValue=f;function g(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=g}),define(_e[53],ye([1,0,12,8,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",c.isMacintosh),P.set("isLinux",c.isLinux),P.set("isWindows",c.isWindows),P.set("isWeb",c.isWeb),P.set("isMacNative",c.isMacintosh&&!c.isWeb),P.set("isEdge",c.isEdge),P.set("isFirefox",c.isFirefox),P.set("isChrome",c.isChrome),P.set("isSafari",c.isSafari);const y=Object.prototype.hasOwnProperty;var T;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(T=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return k.INSTANCE}static true(){return E.INSTANCE}static has(L){return _.create(L)}static equals(L,M){return w.create(L,M)}static notEquals(L,M){return h.create(L,M)}static regex(L,M){return o.create(L,M)}static in(L,M){return f.create(L,M)}static notIn(L,M){return g.create(L,M)}static not(L){return v.create(L)}static and(...L){return d.create(L,null,!0)}static or(...L){return n.create(L,null,!0)}static greater(L,M){return r.create(L,M)}static greaterEquals(L,M){return b.create(L,M)}static smaller(L,M){return s.create(L,M)}static smallerEquals(L,M){return u.create(L,M)}static deserialize(L,M=!1){if(!!L)return this._deserializeOrExpression(L,M)}static _deserializeOrExpression(L,M){const F=L.split("||");return n.create(F.map(B=>this._deserializeAndExpression(B,M)),null,!0)}static _deserializeAndExpression(L,M){const F=L.split("&&");return d.create(F.map(B=>this._deserializeOne(B,M)),null,!0)}static _deserializeOne(L,M){if(L=L.trim(),L.indexOf("!=")>=0){const F=L.split("!=");return h.create(F[0].trim(),this._deserializeValue(F[1],M))}if(L.indexOf("==")>=0){const F=L.split("==");return w.create(F[0].trim(),this._deserializeValue(F[1],M))}if(L.indexOf("=~")>=0){const F=L.split("=~");return o.create(F[0].trim(),this._deserializeRegexValue(F[1],M))}if(L.indexOf(" not in ")>=0){const F=L.split(" not in ");return g.create(F[0].trim(),this._deserializeValue(F[1],M))}if(L.indexOf(" in ")>=0){const F=L.split(" in ");return f.create(F[0].trim(),this._deserializeValue(F[1],M))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const F=L.split(">=");return b.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const F=L.split(">");return r.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const F=L.split("<=");return u.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const F=L.split("<");return s.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(L)?v.create(L.substr(1).trim()):_.create(L)}static _deserializeValue(L,M){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const F=/^'([^']*)'$/.exec(L);return F?F[1].trim():L}static _deserializeRegexValue(L,M){if((0,t.isFalsyOrWhitespace)(L)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=L.indexOf("/"),B=L.lastIndexOf("/");if(F===B||F<0){if(M)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const N=L.slice(F+1,B),z=L[B+1]==="i"?"i":"";try{return new RegExp(N,z)}catch(j){if(M)throw new Error(`bad regexp-value '${L}', parse error: ${j}`);return console.warn(`bad regexp-value '${L}', parse error: ${j}`),null}}}e.ContextKeyExpr=S;function D(V,L){const M=V?V.substituteConstants():void 0,F=L?L.substituteConstants():void 0;return!M&&!F?!0:!M||!F?!1:M.equals(F)}e.expressionsAreEqualWithConstantSubstitution=D;function A(V,L){return V.cmp(L)}class k{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class E{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class _{static create(L,M=null){const F=P.get(L);return typeof F=="boolean"?F?E.INSTANCE:k.INSTANCE:new _(L,M)}constructor(L,M){this.key=L,this.negated=M,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:p(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=P.get(this.key);return typeof L=="boolean"?L?E.INSTANCE:k.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=_;class w{static create(L,M,F=null){if(typeof M=="boolean")return M?_.create(L,F):v.create(L,F);const B=P.get(L);return typeof B=="boolean"?M===(B?"true":"false")?E.INSTANCE:k.INSTANCE:new w(L,M,F)}constructor(L,M,F){this.key=L,this.value=M,this.negated=F,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=P.get(this.key);if(typeof L=="boolean"){const M=L?"true":"false";return this.value===M?E.INSTANCE:k.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class f{static create(L,M){return new f(L,M)}constructor(L,M){this.key=L,this.valueKey=M,this.type=10,this.negated=null}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const M=L.getValue(this.valueKey),F=L.getValue(this.key);return Array.isArray(M)?M.includes(F):typeof F=="string"&&typeof M=="object"&&M!==null?y.call(M,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=f;class g{static create(L,M){return new g(L,M)}constructor(L,M){this.key=L,this.valueKey=M,this.type=11,this._negated=f.create(L,M)}cmp(L){return L.type!==this.type?this.type-L.type:this._negated.cmp(L._negated)}equals(L){return L.type===this.type?this._negated.equals(L._negated):!1}substituteConstants(){return this}evaluate(L){return!this._negated.evaluate(L)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(L){return L.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=g;class h{static create(L,M,F=null){if(typeof M=="boolean")return M?v.create(L,F):_.create(L,F);const B=P.get(L);return typeof B=="boolean"?M===(B?"true":"false")?k.INSTANCE:E.INSTANCE:new h(L,M,F)}constructor(L,M,F){this.key=L,this.value=M,this.negated=F,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=P.get(this.key);if(typeof L=="boolean"){const M=L?"true":"false";return this.value===M?k.INSTANCE:E.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=h;class v{static create(L,M=null){const F=P.get(L);return typeof F=="boolean"?F?k.INSTANCE:E.INSTANCE:new v(L,M)}constructor(L,M){this.key=L,this.negated=M,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:p(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=P.get(this.key);return typeof L=="boolean"?L?k.INSTANCE:E.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function m(V,L){if(typeof V=="string"){const M=parseFloat(V);isNaN(M)||(V=M)}return typeof V=="string"||typeof V=="number"?L(V):k.INSTANCE}class r{static create(L,M,F=null){return m(M,B=>new r(L,B,F))}constructor(L,M,F){this.key=L,this.value=M,this.negated=F,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=r;class b{static create(L,M,F=null){return m(M,B=>new b(L,B,F))}constructor(L,M,F){this.key=L,this.value=M,this.negated=F,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=b;class s{static create(L,M,F=null){return m(M,B=>new s(L,B,F))}constructor(L,M,F){this.key=L,this.value=M,this.negated=F,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class u{static create(L,M,F=null){return m(M,B=>new u(L,B,F))}constructor(L,M,F){this.key=L,this.value=M,this.negated=F,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:C(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class o{static create(L,M){return new o(L,M)}constructor(L,M){this.key=L,this.regexp=M,this.type=7,this.negated=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const M=this.regexp?this.regexp.source:"",F=L.regexp?L.regexp.source:"";return M<F?-1:M>F?1:0}equals(L){if(L.type===this.type){const M=this.regexp?this.regexp.source:"",F=L.regexp?L.regexp.source:"";return this.key===L.key&&M===F}return!1}substituteConstants(){return this}evaluate(L){const M=L.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=l.create(this)),this.negated}}e.ContextKeyRegexExpr=o;class l{static create(L){return new l(L)}constructor(L){this._actual=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new l(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;function a(V){let L=null;for(let M=0,F=V.length;M<F;M++){const B=V[M].substituteConstants();if(V[M]!==B&&L===null){L=[];for(let N=0;N<M;N++)L[N]=V[N]}L!==null&&(L[M]=B)}return L===null?V:L}class d{static create(L,M,F){return d._normalizeArr(L,M,F)}constructor(L,M){this.expr=L,this.negated=M,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const B=A(this.expr[M],L.expr[M]);if(B!==0)return B}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(L.expr[M]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:d.create(L,this.negated,!1)}evaluate(L){for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].evaluate(L))return!1;return!0}static _normalizeArr(L,M,F){const B=[];let N=!1;for(const z of L)if(!!z){if(z.type===1){N=!0;continue}if(z.type===0)return k.INSTANCE;if(z.type===6){B.push(...z.expr);continue}B.push(z)}if(B.length===0&&N)return E.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(A);for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];for(;B.length>1;){const z=B[B.length-1];if(z.type!==9)break;B.pop();const j=B.pop(),x=B.length===0,Q=n.create(z.expr.map(K=>d.create([K,j],null,F)),null,x);Q&&(B.push(Q),B.sort(A))}if(B.length===1)return B[0];if(F){for(let z=0;z<B.length;z++)for(let j=z+1;j<B.length;j++)if(B[z].negate().equals(B[j]))return k.INSTANCE;if(B.length===1)return B[0]}return new d(B,M)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const M of this.expr)L.push(...M.keys());return L}map(L){return new d(this.expr.map(M=>M.map(L)),null)}negate(){if(!this.negated){const L=[];for(const M of this.expr)L.push(M.negate());this.negated=n.create(L,this,!0)}return this.negated}}class n{static create(L,M,F){return n._normalizeArr(L,M,F)}constructor(L,M){this.expr=L,this.negated=M,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const B=A(this.expr[M],L.expr[M]);if(B!==0)return B}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(L.expr[M]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:n.create(L,this.negated,!1)}evaluate(L){for(let M=0,F=this.expr.length;M<F;M++)if(this.expr[M].evaluate(L))return!0;return!1}static _normalizeArr(L,M,F){let B=[],N=!1;if(L){for(let z=0,j=L.length;z<j;z++){const x=L[z];if(!!x){if(x.type===0){N=!0;continue}if(x.type===1)return E.INSTANCE;if(x.type===9){B=B.concat(x.expr);continue}B.push(x)}}if(B.length===0&&N)return k.INSTANCE;B.sort(A)}if(B.length!==0){if(B.length===1)return B[0];for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];if(F){for(let z=0;z<B.length;z++)for(let j=z+1;j<B.length;j++)if(B[z].negate().equals(B[j]))return E.INSTANCE;if(B.length===1)return B[0]}return new n(B,M)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const M of this.expr)L.push(...M.keys());return L}map(L){return new n(this.expr.map(M=>M.map(L)),null)}negate(){if(!this.negated){const L=[];for(const M of this.expr)L.push(M.negate());for(;L.length>1;){const M=L.shift(),F=L.shift(),B=[];for(const N of H(M))for(const z of H(F))B.push(d.create([N,z],null,!1));L.unshift(n.create(B,null,!1))}this.negated=n.create(L,this,!0)}return this.negated}}class i extends _{static all(){return i._info.values()}constructor(L,M,F){super(L,null),this._defaultValue=M,typeof F=="object"?i._info.push({...F,key:L}):F!==!0&&i._info.push({key:L,description:F,type:M!=null?typeof M:void 0})}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return w.create(this.key,L)}notEqualsTo(L){return h.create(this.key,L)}}e.RawContextKey=i,i._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(V,L){return V<L?-1:V>L?1:0}function C(V,L,M,F){return V<M?-1:V>M?1:L<F?-1:L>F?1:0}function R(V,L){if(V.type===0||L.type===1)return!0;if(V.type===9)return L.type===9?U(V.expr,L.expr):!1;if(L.type===9){for(const M of L.expr)if(R(V,M))return!0;return!1}if(V.type===6){if(L.type===6)return U(L.expr,V.expr);for(const M of V.expr)if(R(M,L))return!0;return!1}return V.equals(L)}e.implies=R;function U(V,L){let M=0,F=0;for(;M<V.length&&F<L.length;){const B=V[M].cmp(L[F]);if(B<0)return!1;B===0&&M++,F++}return M===V.length}function H(V){return V.type===9?V.expr:[V]}}),define(_e[191],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(_e[121],ye([1,0,165,3]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY="DEFAULT_PROFILE_EXTENSIONS_MIGRATION";function I(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function P(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function y(h,v){switch(h){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function T(h,v){return v==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function S(h,v,m){return T(v,m)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===m?!0:D(m).includes(h)}e.isTargetPlatformCompatible=S;function D(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=D;function A(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=A;var k;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var E;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var _;(function(h){h.Install="install",h.Uninstall="uninstall"})(_=e.StatisticType||(e.StatisticType={}));var w;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var f;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(f=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class g extends Error{constructor(v,m){super(v),this.code=m,this.name=m}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,c.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,c.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(_e[192],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,c.createDecorator)("externalTerminal")}),define(_e[193],ye([1,0,44,14,9,12,106,29,114,167,192]),function(Z,e,c,t,I,P,y,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=D.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:_.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class _ extends E{openTerminal(r,b){return this.spawnTerminal(c,r,S.getWindowsShell(),b)}spawnTerminal(r,b,s,u){const o=b.windowsExec||_.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const l=I.basename(o).toLowerCase();if(l==="cmder"||l==="cmder.exe")return r.spawn(o,u?[u]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return o.indexOf(" ")>=0&&a.push('""'),a.push(o),(l==="wt"||l==="wt.exe")&&a.push("-d ."),new Promise((d,n)=>{const i=g(process),p=r.spawn(s,a,{cwd:u,env:i});p.on("error",n),p.on("exit",()=>d())})}runInTerminal(r,b,s,u,o){const l="windowsExec"in o&&o.windowsExec?o.windowsExec:_.getDefaultTerminalWindows();return new Promise((a,d)=>{const n=`"${b} - ${k}"`,i=`""${s.join('" "')}" & pause"`,p=["/c","start",n,"/wait",l,"/c",i],C=Object.assign({},g(process),u);Object.keys(C).filter(H=>C[H]===null).forEach(H=>delete C[H]);const R={cwd:b,env:C,windowsVerbatimArguments:!0};c.spawn(_.CMD,p,R).on("error",H=>{d(h(H))}),a(void 0)})}static getDefaultTerminalWindows(){if(!_._DEFAULT_TERMINAL_WINDOWS){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");_._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return _._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=_,_.CMD="cmd.exe";class w extends E{openTerminal(r,b){return this.spawnTerminal(c,r,b)}runInTerminal(r,b,s,u,o){const l=o.osxExec||A.DEFAULT_TERMINAL_OSX;return new Promise((a,d)=>{if(l===A.DEFAULT_TERMINAL_OSX||l==="iTerm.app"){const n=l===A.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",p=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`,Z).fsPath,"-t",r||k,"-w",b];for(const U of s)p.push("-a"),p.push(U);if(u){const U=Object.assign({},g(process),u);for(const H in U){const V=U[H];V===null?(p.push("-u"),p.push(H)):(p.push("-e"),p.push(`${H}=${V}`))}}let C="";const R=c.spawn(w.OSASCRIPT,p);R.on("error",U=>{d(h(U))}),R.stderr.on("data",U=>{C+=U.toString()}),R.on("exit",U=>{if(U===0)a(void 0);else if(C){const H=C.split(`
`,1);d(new Error(H[0]))}else d(new Error(D.localize(1,null,n,U)))})}else d(new Error(D.localize(2,null,l)))})}spawnTerminal(r,b,s){const u=b.osxExec||A.DEFAULT_TERMINAL_OSX;return new Promise((o,l)=>{const a=["-a",u];s&&a.push(s);const d=g(process),n=r.spawn("/usr/bin/open",a,{cwd:s,env:d});n.on("error",l),n.on("exit",()=>o())})}}e.MacExternalTerminalService=w,w.OSASCRIPT="/usr/bin/osascript";class f extends E{openTerminal(r,b){return this.spawnTerminal(c,r,b)}runInTerminal(r,b,s,u,o){const l=o.linuxExec?Promise.resolve(o.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((a,d)=>{const n=[];l.then(i=>{i.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const p=`${v(s)}; echo; read -p "${f.WAIT_MESSAGE}" -n1;`;n.push(`''${p}''`);const C=Object.assign({},g(process),u);Object.keys(C).filter(V=>C[V]===null).forEach(V=>delete C[V]);const R={cwd:b,env:C};let U="";const H=c.spawn(i,n,R);H.on("error",V=>{d(h(V))}),H.stderr.on("data",V=>{U+=V.toString()}),H.on("exit",V=>{if(V===0)a(void 0);else if(U){const L=U.split(`
`,1);d(new Error(L[0]))}else d(new Error(D.localize(4,null,i,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!f._DEFAULT_TERMINAL_LINUX_READY)if(!P.isLinux)f._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const r=await T.Promises.exists("/etc/debian_version");f._DEFAULT_TERMINAL_LINUX_READY=new Promise(b=>{r?b("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?b("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?b("konsole"):process.env.COLORTERM?b(process.env.COLORTERM):process.env.TERM?b(process.env.TERM):b("xterm")})}return f._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(r,b,s){const u=b.linuxExec?Promise.resolve(b.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((o,l)=>{u.then(a=>{const d=g(process),n=r.spawn(a,[],{cwd:s,env:d});n.on("error",l),n.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=f,f.WAIT_MESSAGE=D.localize(3,null);function g(m){const r={...m.env};return(0,y.sanitizeProcessEnvironment)(r),r}function h(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(D.localize(5,null,m.path)):m}function v(m){let r="";for(const b of m)b.indexOf(" ")>=0?r+='"'+b+'"':r+=b,r+=" ";return r}}),define(_e[38],ye([1,0,64,9,8,11,2,168,3]),function(Z,e,c,t,I,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function D(N){return N.create===!0}e.isFileOpenForWriteOptions=D;var A;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(A=e.FileType||(e.FileType={}));var k;(function(N){N[N.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var E;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead",N[N.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function _(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=_;function w(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=w;function f(N){return!!(N.capabilities&32768)}e.hasFileCloneCapability=f;function g(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function h(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=h;function v(N){return _(N)?!!(N.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var m;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class r extends Error{constructor(z,j){super(z),this.code=j}}e.FileSystemProviderError=r;function b(N,z){const j=new r(N.toString(),z);return u(j,z),j}e.createFileSystemProviderError=b;function s(N){return N||b((0,T.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=s;function u(N,z){return N.name=z?`${z} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=u;function o(N){if(!N)return m.Unknown;if(N instanceof r)return N.code;const z=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!z)return m.Unknown;switch(z[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=o;function l(N){if(N instanceof C)return N.fileOperationResult;switch(o(N)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var a;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY",N[N.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class d{constructor(z,j,x){this.resource=z,this.operation=j,this.target=x}isOperation(z){return this.operation===z}}e.FileOperationEvent=d;var n;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class i{constructor(z,j){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=z;const x=new Map;for(const Q of z){const K=x.get(Q.type);switch(K?K.push([Q.resource,Q]):x.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,K]of x)switch(Q){case 1:this.added=c.TernarySearchTree.forUris(()=>j),this.added.fill(K);break;case 0:this.updated=c.TernarySearchTree.forUris(()=>j),this.updated.fill(K);break;case 2:this.deleted=c.TernarySearchTree.forUris(()=>j),this.deleted.fill(K);break}}contains(z,...j){return this.doContains(z,{includeChildren:!1},...j)}affects(z,...j){return this.doContains(z,{includeChildren:!0},...j)}doContains(z,j,...x){if(!z)return!1;const Q=x.length>0;return!!((!Q||x.includes(1))&&(this.added?.get(z)||j.includeChildren&&this.added?.findSuperstr(z))||(!Q||x.includes(0))&&(this.updated?.get(z)||j.includeChildren&&this.updated?.findSuperstr(z))||(!Q||x.includes(2))&&(this.deleted?.findSubstr(z)||j.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=i;function p(N,z,j){return!N||!z||N===z||z.length>N.length?!1:(z.charAt(z.length-1)!==t.sep&&(z+=t.sep),j?(0,I.startsWithIgnoreCase)(N,z):N.indexOf(z)===0)}e.isParent=p;class C extends Error{constructor(z,j,x){super(z),this.fileOperationResult=j,this.options=x}}e.FileOperationError=C;class R extends C{constructor(z,j,x){super(z,2,x),this.stat=j}}e.NotModifiedSinceFileOperationError=R;var U;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var H;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(H=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=V;async function L(N,z){if(!z.hasProvider(y.URI.from({scheme:N.scheme})))return new Promise(j=>{const x=z.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===N.scheme&&Q.added&&(x.dispose(),j())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(z){return(0,P.isNumber)(z)||(z=0),z<M.KB?(0,T.localize)(1,null,z.toFixed(0)):z<M.MB?(0,T.localize)(2,null,(z/M.KB).toFixed(2)):z<M.GB?(0,T.localize)(3,null,(z/M.MB).toFixed(2)):z<M.TB?(0,T.localize)(4,null,(z/M.GB).toFixed(2)):(0,T.localize)(5,null,(z/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var F;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function B(N){return{maxFileSize:N===0?300*M.MB:16*M.GB,maxHeapSize:N===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=B}),define(_e[85],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...I){this._entries=new Map;for(const[P,y]of I)this.set(P,y)}set(I,P){const y=this._entries.get(I);return this._entries.set(I,P),y}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=c}),define(_e[194],ye([1,0,18,10,6,120,190,3,85,63]),function(Z,e,c,t,I,P,y,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const A=!1;class k extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class E{constructor(g=new S.ServiceCollection,h=!1,v,m=A){this._services=g,this._strict=h,this._parent=v,this._enableTracing=m,this._activeInstantiations=new Set,this._services.set(T.IInstantiationService,this),this._globalGraph=m?v?._globalGraph??new y.Graph(r=>r):void 0}createChild(g){return new E(g,this._strict,this,this._enableTracing)}invokeFunction(g,...h){const v=w.traceInvocation(this._enableTracing,g);let m=!1;try{return g({get:b=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(b,v);if(!s)throw new Error(`[invokeFunction] unknown service '${b}'`);return s}},...h)}finally{m=!0,v.stop()}}createInstance(g,...h){let v,m;return g instanceof P.SyncDescriptor?(v=w.traceCreation(this._enableTracing,g.ctor),m=this._createInstance(g.ctor,g.staticArguments.concat(h),v)):(v=w.traceCreation(this._enableTracing,g),m=this._createInstance(g,h,v)),v.stop(),m}_createInstance(g,h=[],v){const m=T._util.getServiceDependencies(g).sort((s,u)=>s.index-u.index),r=[];for(const s of m){const u=this._getOrCreateServiceInstance(s.id,v);u||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${s.id}.`,!1),r.push(u)}const b=m.length>0?m[0].index:h.length;if(h.length!==b){console.trace(`[createInstance] First service dependency of ${g.name} at position ${b+1} conflicts with ${h.length} static arguments`);const s=b-h.length;s>0?h=h.concat(new Array(s)):h=h.slice(0,b)}return Reflect.construct(g,h.concat(r))}_setServiceInstance(g,h){if(this._services.get(g)instanceof P.SyncDescriptor)this._services.set(g,h);else if(this._parent)this._parent._setServiceInstance(g,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){const h=this._services.get(g);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):h}_getOrCreateServiceInstance(g,h){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(g));const v=this._getServiceInstanceOrDescriptor(g);return v instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,v,h.branch(g,!0)):(h.branch(g,!1),v)}_safeCreateAndCacheServiceInstance(g,h,v){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,h,v)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,h,v){const m=new y.Graph(s=>s.id.toString());let r=0;const b=[{id:g,desc:h,_trace:v}];for(;b.length;){const s=b.pop();if(m.lookupOrInsertNode(s),r++>1e3)throw new k(m);for(const u of T._util.getServiceDependencies(s.desc.ctor)){const o=this._getServiceInstanceOrDescriptor(u.id);if(o||this._throwIfStrict(`[createInstance] ${g} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(u.id)),o instanceof P.SyncDescriptor){const l={id:u.id,desc:o,_trace:s._trace.branch(u.id,!0)};m.insertEdge(s,l),b.push(l)}}}for(;;){const s=m.roots();if(s.length===0){if(!m.isEmpty())throw new k(m);break}for(const{data:u}of s){if(this._getServiceInstanceOrDescriptor(u.id)instanceof P.SyncDescriptor){const l=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,l)}m.removeNode(u)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,h,v=[],m,r){if(this._services.get(g)instanceof P.SyncDescriptor)return this._createServiceInstance(g,h,v,m,r);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,h,v,m,r);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(g,h,v=[],m,r){if(m){const b=new E(void 0,this._strict,this,this._enableTracing);b._globalGraphImplicitDependency=String(g);const s=new Map,u=new c.IdleValue(()=>{const o=b._createInstance(h,v,r);for(const[l,a]of s){const d=o[l];if(typeof d=="function")for(const n of a)d.apply(o,n)}return s.clear(),o});return new Proxy(Object.create(null),{get(o,l){if(!u.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let n=s.get(l);return n||(n=new D.LinkedList,s.set(l,n)),(p,C,R)=>{const U=n.push([p,C,R]);return(0,I.toDisposable)(U)}}if(l in o)return o[l];const a=u.value;let d=a[l];return typeof d!="function"||(d=d.bind(a),o[l]=d),d},set(o,l,a){return u.value[l]=a,!0}})}else return this._createInstance(h,v,r)}_throwIfStrict(g,h){if(h&&console.warn(g),this._strict)throw new Error(g)}}e.InstantiationService=E;var _;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(_||(_={}));class w{static traceInvocation(g,h){return g?new w(1,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w._None}static traceCreation(g,h){return g?new w(0,h.name):w._None}constructor(g,h){this.type=g,this.name=h,this._start=Date.now(),this._dep=[]}branch(g,h){const v=new w(2,g.toString());return this._dep.push([g,h,v]),v}stop(){const g=Date.now()-this._start;w._totals+=g;let h=!1;function v(r,b){const s=[],u=new Array(r+1).join("	");for(const[o,l,a]of b._dep)if(l&&a){h=!0,s.push(`${u}CREATES -> ${o}`);const d=v(r+1,a);d&&s.push(d)}else s.push(`${u}uses -> ${o}`);return s.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(g>2||h)&&w.all.add(m.join(`
`))}}e.Trace=w,w.all=new Set,w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(_e[13],ye([1,0,50,4,6,28,12,2,3]),function(Z,e,c,t,I,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function D(){return new Date().toISOString()}var A;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(A=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=A.Info;function k(d,n,i){switch(n){case A.Trace:d.trace(i);break;case A.Debug:d.debug(i);break;case A.Info:d.info(i);break;case A.Warning:d.warn(i);break;case A.Error:d.error(i);break;default:throw new Error("Invalid log level")}}e.log=k;function E(d){let n="";for(let i=0;i<d.length;i++){let p=d[i];if(typeof p=="object")try{p=JSON.stringify(p)}catch{}n+=(i>0?" ":"")+p}return n}e.format=E;class _ extends I.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class w extends _{constructor(n){super(),this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(A.Trace)&&this.log(A.Trace,E([n,...i]))}debug(n,...i){this.checkLogLevel(A.Debug)&&this.log(A.Debug,E([n,...i]))}info(n,...i){this.checkLogLevel(A.Info)&&this.log(A.Info,E([n,...i]))}warn(n,...i){this.checkLogLevel(A.Warning)&&this.log(A.Warning,E([n,...i]))}error(n,...i){if(this.checkLogLevel(A.Error))if(n instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=n.stack,this.log(A.Error,E(p))}else this.log(A.Error,E([n,...i]))}flush(){}}e.AbstractMessageLogger=w;class f extends _{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.useColors=!y.isWindows}trace(n,...i){this.getLevel()<=A.Trace&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...i):console.log(`[main ${D()}]`,n,...i))}debug(n,...i){this.getLevel()<=A.Debug&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...i):console.log(`[main ${D()}]`,n,...i))}info(n,...i){this.getLevel()<=A.Info&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...i):console.log(`[main ${D()}]`,n,...i))}warn(n,...i){this.getLevel()<=A.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,n,...i):console.warn(`[main ${D()}]`,n,...i))}error(n,...i){this.getLevel()<=A.Error&&(this.useColors?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,n,...i):console.error(`[main ${D()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class g extends _{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...i){this.getLevel()<=A.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=A.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=A.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=A.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=A.Error&&console.log("%c  ERR","color: #f33",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=g;class h extends _{constructor(n,i=e.DEFAULT_LOG_LEVEL){super(),this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=A.Trace&&this.adapter.log(A.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=A.Debug&&this.adapter.log(A.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=A.Info&&this.adapter.log(A.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=A.Warning&&this.adapter.log(A.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=A.Error&&this.adapter.log(A.Error,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,c.toErrorMessage)(n,this.getLevel()<=A.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class v extends _{constructor(n){super(),this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const p of this.logServices)p.trace(n,...i)}debug(n,...i){for(const p of this.logServices)p.debug(n,...i)}info(n,...i){for(const p of this.logServices)p.info(n,...i)}warn(n,...i){for(const p of this.logServices)p.warn(n,...i)}error(n,...i){for(const p of this.logServices)p.error(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=v;class m extends I.Disposable{constructor(n){super(),this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}flush(){this.logger.flush()}}e.LogService=m;class r extends I.Disposable{constructor(n,i){super(),this.logLevel=n,this.loggerItems=new P.ResourceMap,this._register(i(p=>this.setLevel(p)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:n})=>n)}getLogger(n){return this.loggerItems.get(n)?.logger}createLogger(n,i,p){let C=this.loggerItems.get(n)?.logger;return C||(p=i?.always?A.Trace:p,C=this.doCreateLogger(n,p??this.logLevel,i),this.loggerItems.set(n,{logger:C,logLevel:p})),C}setLevel(n,i){const p=T.URI.isUri(n)?n:void 0,C=p?i:n;if(p){const R=this.loggerItems.get(p);R&&R.logLevel!==C&&(R.logLevel=C,R.logger.setLevel(C))}else this.logLevel=C,this.loggerItems.forEach(({logLevel:R,logger:U})=>{R===void 0&&U.setLevel(this.logLevel)})}getLogLevel(n){return this.loggerItems.get(n)?.logLevel}dispose(){this.loggerItems.forEach(({logger:n})=>n.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=r;class b{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return A.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogger=b;class s extends b{}e.NullLogService=s;class u extends r{constructor(){super(A.Info,t.Event.None)}doCreateLogger(n,i,p){return new b}}e.NullLoggerService=u;function o(d){if(d.verbose)return A.Trace;if(typeof d.logLevel=="string"){const n=a(d.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function l(d){switch(d){case A.Trace:return"trace";case A.Debug:return"debug";case A.Info:return"info";case A.Warning:return"warn";case A.Error:return"error";case A.Off:return"off"}}e.LogLevelToString=l;function a(d){switch(d){case"trace":return A.Trace;case"debug":return A.Debug;case"info":return A.Info;case"warn":return A.Warning;case"error":return A.Error;case"critical":return A.Error;case"off":return A.Off}}e.parseLogLevel=a}),define(_e[195],ye([1,0,38,13]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var I;(function(D){D[D.Trace=0]="Trace",D[D.Debug=1]="Debug",D[D.Info=2]="Info",D[D.Warning=3]="Warning",D[D.Error=4]="Error",D[D.Critical=5]="Critical",D[D.Off=6]="Off"})(I||(I={}));async function P(D,A,k,E,_){try{const w=await new Promise((g,h)=>{Z(["spdlog"],g,h)});w.setFlushOn(t.LogLevel.Trace);const f=await w.createAsyncRotatingLogger(D,A,k,E);return _?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(w){console.error(w)}return null}function y(D,A,k){switch(A){case t.LogLevel.Trace:D.trace(k);break;case t.LogLevel.Debug:D.debug(k);break;case t.LogLevel.Info:D.info(k);break;case t.LogLevel.Warning:D.warn(k);break;case t.LogLevel.Error:D.error(k);break;default:throw new Error("Invalid log level")}}function T(D,A){switch(A){case t.LogLevel.Trace:D.setLevel(I.Trace);break;case t.LogLevel.Debug:D.setLevel(I.Debug);break;case t.LogLevel.Info:D.setLevel(I.Info);break;case t.LogLevel.Warning:D.setLevel(I.Warning);break;case t.LogLevel.Error:D.setLevel(I.Error);break;case t.LogLevel.Off:D.setLevel(I.Off);break;default:throw new Error("Invalid log level")}}class S extends t.AbstractMessageLogger{constructor(A,k,E,_,w){super(),this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(A,k,E,_),this._register(this.onDidChangeLogLevel(f=>{this._logger&&T(this._logger,f)}))}async _createSpdLogLogger(A,k,E,_){const w=E?6:1,f=30/w*c.ByteSize.MB,g=await P(A,k,f,w,_);if(g){this._logger=g,T(this._logger,this.getLevel());for(const{level:h,message:v}of this.buffer)y(this._logger,h,v);this.buffer=[]}}log(A,k){this._logger?y(this._logger,A,k):this.getLevel()<=A&&this.buffer.push({level:A,message:k})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=S}),define(_e[122],ye([1,0,42,169,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var y;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function D(w,f){return f-w}S.compare=D;const A=Object.create(null);A[S.Error]=(0,t.localize)(0,null),A[S.Warning]=(0,t.localize)(1,null),A[S.Info]=(0,t.localize)(2,null);function k(w){return A[w]||""}S.toString=k;function E(w){switch(w){case c.default.Error:return S.Error;case c.default.Warning:return S.Warning;case c.default.Info:return S.Info;case c.default.Ignore:return S.Hint}}S.fromSeverity=E;function _(w){switch(w){case S.Error:return c.default.Error;case S.Warning:return c.default.Warning;case S.Info:return c.default.Info;case S.Hint:return c.default.Ignore}}S.toSeverity=_}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(S){const D="";function A(E){return k(E,!0)}S.makeKey=A;function k(E,_){const w=[D];return E.source?w.push(E.source.replace("\xA6","\\\xA6")):w.push(D),E.code?typeof E.code=="string"?w.push(E.code.replace("\xA6","\\\xA6")):w.push(E.code.value.replace("\xA6","\\\xA6")):w.push(D),E.severity!==void 0&&E.severity!==null?w.push(y.toString(E.severity)):w.push(D),E.message&&_?w.push(E.message.replace("\xA6","\\\xA6")):w.push(D),E.startLineNumber!==void 0&&E.startLineNumber!==null?w.push(E.startLineNumber.toString()):w.push(D),E.startColumn!==void 0&&E.startColumn!==null?w.push(E.startColumn.toString()):w.push(D),E.endLineNumber!==void 0&&E.endLineNumber!==null?w.push(E.endLineNumber.toString()):w.push(D),E.endColumn!==void 0&&E.endColumn!==null?w.push(E.endColumn.toString()):w.push(D),w.push(D),w.join("\xA6")}S.makeKeyOptionalMessage=k})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(_e[196],ye([1,0,4,42,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var P;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new S,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(A){}updateMessage(A){}updateActions(A){}close(){}}e.NoOpNotification=T;class S{infinite(){}done(){}total(A){}worked(A){}}e.NoOpProgress=S}),define(_e[123],ye([1,0,8,2,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,I.createDecorator)("openerService");function P(D,A){return t.URI.isUri(D)?(0,c.equalsIgnoreCase)(D.scheme,A):(0,c.startsWithIgnoreCase)(D,A+":")}e.matchesScheme=P;function y(D,...A){return A.some(k=>P(D,k))}e.matchesSomeScheme=y;function T(D,A){return D.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.withSelection=T;function S(D){let A;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(D.fragment);return k&&(A={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},D=D.with({fragment:""})),{selection:A,uri:D}}e.extractSelection=S}),define(_e[197],ye([1,0,14,12,36,22]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const T=t.globals.vscode.context.configuration();if(T)y=T.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Z?.__$__nodeRequire=="function"){const T=(0,P.dirname)(c.FileAccess.asFileUri("",Z));if(y=Z.__$__nodeRequire((0,P.joinPath)(T,"product.json").fsPath),I.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`,serverDataFolderName:y.serverDataFolderName?`${y.serverDataFolderName}-dev`:void 0}),!y.version){const S=Z.__$__nodeRequire((0,P.joinPath)(T,"package.json").fsPath);Object.assign(y,{version:S.version})}}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=y}),define(_e[198],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__param||function(Z,e){return function(c,t){e(c,t,Z)}};define(_e[124],ye([1,0,18,21,6,3]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var y;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{get value(){return this._value}constructor(k){this.callback=k}report(k){this._value=k,this.callback(this._value)}}e.Progress=T,T.None=Object.freeze({report(){}});let S=class extends I.Disposable{constructor(k,E){super(),this.deferred=new c.DeferredPromise,E.withProgress(k,_=>(this.reporter=_,this.lastStep&&_.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};S=Ve([ze(1,e.IProgressService)],S),e.UnmanagedProgress=S;class D extends I.Disposable{constructor(k){super(),this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(k){this.stop();const E=++this.currentOperationId,_=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{E===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>_.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:E,token:_.token,stop:()=>this.doStop(E),isCurrent:()=>this.currentOperationId===E}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(_e[43],ye([1,0,48,11]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(y,T){c.ok(t.isString(y)),c.ok(t.isObject(T)),c.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,T)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new I}),define(_e[125],ye([1,0,4,43]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class P{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,D){this.schemasById[I(S)]=D,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new P;t.Registry.add(e.Extensions.JSONContribution,y)}),define(_e[126],ye([1,0,17,4,11,164,52,125,43]),function(Z,e,c,t,I,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=S.Registry.as(T.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,u=!0){this.registerConfigurations([s],u)}registerConfigurations(s,u=!0){const o=this.doRegisterConfigurations(s,u);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}deregisterConfigurations(s){const u=this.doDeregisterConfigurations(s);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:s,remove:u}){const o=[];o.push(...this.doDeregisterConfigurations(u)),o.push(...this.doRegisterConfigurations(s,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,c.distinct)(o)})}registerDefaultConfigurations(s){const u=[],o=[];for(const{overrides:l,source:a}of s)for(const d in l)if(u.push(d),e.OVERRIDE_PROPERTY_REGEX.test(d)){const n=this.configurationDefaultsOverrides.get(d),i=n?.valuesSources??new Map;if(a)for(const U of Object.keys(l[d]))i.set(U,a);const p={...n?.value||{},...l[d]};this.configurationDefaultsOverrides.set(d,{source:a,value:p,valuesSources:i});const C=(0,y.getLanguageTagSettingPlainKey)(d),R={type:"object",default:p,description:P.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:I.isString(a)?void 0:a,defaultValueSource:a};o.push(...f(d)),this.configurationProperties[d]=R,this.defaultLanguageConfigurationOverridesNode.properties[d]=R}else{this.configurationDefaultsOverrides.set(d,{value:l[d],source:a});const n=this.configurationProperties[d];n&&(this.updatePropertyDefaultValue(d,n),this.updateSchema(d,n))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const u=[];for(const{overrides:o,source:l}of s)for(const a in o){const d=this.configurationDefaultsOverrides.get(a),n=I.isString(l)?l:l?.id,i=I.isString(d?.source)?d?.source:d?.source?.id;if(n===i)if(u.push(a),this.configurationDefaultsOverrides.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const p=this.configurationProperties[a];p&&(this.updatePropertyDefaultValue(a,p),this.updateSchema(a,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const u of s)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,u){const o=[];return s.forEach(l=>{o.push(...this.validateAndRegisterProperties(l,u,l.extensionInfo,l.restrictedProperties)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),o}doDeregisterConfigurations(s){const u=[],o=l=>{if(l.properties)for(const a in l.properties){u.push(a);const d=this.configurationProperties[a];d?.policy?.name&&this.policyConfigurations.delete(d.policy.name),delete this.configurationProperties[a],this.removeFromSchema(a,l.properties[a])}l.allOf?.forEach(a=>o(a))};for(const l of s){o(l);const a=this.configurationContributors.indexOf(l);a!==-1&&this.configurationContributors.splice(a,1)}return u}validateAndRegisterProperties(s,u=!0,o,l,a=3){a=I.isUndefinedOrNull(s.scope)?a:s.scope;const d=[],n=s.properties;if(n)for(const p in n){const C=n[p];if(u&&m(p,C)){delete n[p];continue}if(C.source=o,C.defaultDefaultValue=n[p].default,this.updatePropertyDefaultValue(p,C),e.OVERRIDE_PROPERTY_REGEX.test(p)?C.scope=void 0:(C.scope=I.isUndefinedOrNull(C.scope)?a:C.scope,C.restricted=I.isUndefinedOrNull(C.restricted)?!!l?.includes(p):C.restricted),n[p].hasOwnProperty("included")&&!n[p].included){this.excludedConfigurationProperties[p]=n[p],delete n[p];continue}else this.configurationProperties[p]=n[p],n[p].policy?.name&&this.policyConfigurations.set(n[p].policy.name,p);!n[p].deprecationMessage&&n[p].markdownDeprecationMessage&&(n[p].deprecationMessage=n[p].markdownDeprecationMessage),d.push(p)}const i=s.allOf;if(i)for(const p of i)d.push(...this.validateAndRegisterProperties(p,u,o,l,a));return d}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const u=o=>{const l=o.properties;if(l)for(const d in l)this.updateSchema(d,l[d]);o.allOf?.forEach(u)};u(s)}updateSchema(s,u){switch(e.allSettings.properties[s]=u,u.scope){case 1:e.applicationSettings.properties[s]=u;break;case 2:e.machineSettings.properties[s]=u;break;case 6:e.machineOverridableSettings.properties[s]=u;break;case 3:e.windowSettings.properties[s]=u;break;case 4:e.resourceSettings.properties[s]=u;break;case 5:e.resourceSettings.properties[s]=u,this.resourceLanguageSettingsSchema.properties[s]=u;break}}removeFromSchema(s,u){switch(delete e.allSettings.properties[s],u.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const u=`[${s}]`,o={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,o),e.allSettings.properties[u]=o,e.applicationSettings.properties[u]=o,e.machineSettings.properties[u]=o,e.machineOverridableSettings.properties[u]=o,e.windowSettings.properties[u]=o,e.resourceSettings.properties[u]=o}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,u){const o=this.configurationDefaultsOverrides.get(s);let l=o?.value,a=o?.source;I.isUndefined(l)&&(l=u.defaultDefaultValue,a=void 0),I.isUndefined(l)&&(l=h(u.type)),u.default=l,u.defaultValueSource=a}}const _="\\[([^\\]]+)\\]",w=new RegExp(_,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${_})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(b){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let u=w.exec(b);for(;u?.length;){const o=u[1].trim();o&&s.push(o),u=w.exec(b)}}return(0,c.distinct)(s)}e.overrideIdentifiersFromKey=f;function g(b){return b.reduce((s,u)=>`${s}[${u}]`,"")}e.keyFromOverrideIdentifiers=g;function h(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const v=new E;S.Registry.add(e.Extensions.Configuration,v);function m(b,s){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?P.localize(7,null,b):v.getConfigurationProperties()[b]!==void 0?P.localize(8,null,b):s.policy?.name&&v.getPolicyConfigurations().get(s.policy?.name)!==void 0?P.localize(9,null,b,s.policy?.name,v.getPolicyConfigurations().get(s.policy?.name)):null:P.localize(6,null)}e.validateProperty=m;function r(){const b=[],s=v.getConfigurationProperties();for(const u of Object.keys(s))b.push([u,s[u].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=r}),define(_e[199],ye([1,0,17,4,144,6,28,24,11,2,52,126,43]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class _{constructor(u={},o=[],l=[],a){this._contents=u,this._keys=o,this._overrides=l,this.raw=a,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const u=this.raw.map(o=>{if(o instanceof _)return o;const l=new w("");return l.parseRaw(o),l.configurationModel});this._rawConfiguration=u.reduce((o,l)=>l===o?l:o.merge(l),u[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(u){return u?(0,A.getConfigurationValue)(this.contents,u):this.contents}inspect(u,o){const l=this.rawConfiguration.getValue(u),a=o?this.rawConfiguration.getOverrideValue(u,o):void 0,d=o?this.rawConfiguration.override(o).getValue(u):l;return{value:l,override:a,merged:d}}getOverrideValue(u,o){const l=this.getContentsForOverrideIdentifer(o);return l?u?(0,A.getConfigurationValue)(l,u):l:void 0}getKeysForOverrideIdentifier(u){const o=[];for(const l of this.overrides)l.identifiers.includes(u)&&o.push(...l.keys);return c.distinct(o)}getAllOverrideIdentifiers(){const u=[];for(const o of this.overrides)u.push(...o.identifiers);return c.distinct(u)}override(u){let o=this.overrideConfigurations.get(u);return o||(o=this.createOverrideConfigurationModel(u),this.overrideConfigurations.set(u,o)),o}merge(...u){const o=T.deepClone(this.contents),l=T.deepClone(this.overrides),a=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const n of u)if(d.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.mergeContents(o,n.contents);for(const i of n.overrides){const[p]=l.filter(C=>c.equals(C.identifiers,i.identifiers));p?(this.mergeContents(p.contents,i.contents),p.keys.push(...i.keys),p.keys=c.distinct(p.keys)):l.push(T.deepClone(i))}for(const i of n.keys)a.indexOf(i)===-1&&a.push(i)}return new _(o,a,l,d.every(n=>n instanceof _)?void 0:d)}freeze(){return this.frozen=!0,this}clone(){return new _(T.deepClone(this.contents),[...this.keys],T.deepClone(this.overrides))}createOverrideConfigurationModel(u){const o=this.getContentsForOverrideIdentifer(u);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const l={};for(const a of c.distinct([...Object.keys(this.contents),...Object.keys(o)])){let d=this.contents[a];const n=o[a];n&&(typeof d=="object"&&typeof n=="object"?(d=T.deepClone(d),this.mergeContents(d,n)):d=n),l[a]=d}return new _(l,this.keys,this.overrides)}mergeContents(u,o){for(const l of Object.keys(o)){if(l in u&&S.isObject(u[l])&&S.isObject(o[l])){this.mergeContents(u[l],o[l]);continue}u[l]=T.deepClone(o[l])}}checkAndFreeze(u){return this.frozen&&!Object.isFrozen(u)?T.deepFreeze(u):u}getContentsForOverrideIdentifer(u){let o=null,l=null;const a=d=>{d&&(l?this.mergeContents(l,d):l=T.deepClone(d))};for(const d of this.overrides)c.equals(d.identifiers,[u])?o=d.contents:d.identifiers.includes(u)&&a(d.contents);return a(o),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(u,o){this.addKey(u),(0,A.addToValueTree)(this.contents,u,o,l=>{throw new Error(l)})}removeValue(u){this.removeKey(u)&&(0,A.removeFromValueTree)(this.contents,u)}addKey(u){let o=this.keys.length;for(let l=0;l<o;l++)u.indexOf(this.keys[l])===0&&(o=l);this.keys.splice(o,1,u)}removeKey(u){const o=this.keys.indexOf(u);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=_;class w{constructor(u){this._name=u,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new _}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(u,o){if(!S.isUndefinedOrNull(u)){const l=this.doParseContent(u);this.parseRaw(l,o)}}reparse(u){this._raw&&this.parseRaw(this._raw,u)}parseRaw(u,o){this._raw=u;const{contents:l,keys:a,overrides:d,restricted:n,hasExcludedProperties:i}=this.doParseRaw(u,o);this._configurationModel=new _(l,a,d,i?[u]:void 0),this._restrictedConfigurations=n||[]}doParseContent(u){let o={},l=null,a=[];const d=[],n=[];function i(C){Array.isArray(a)?a.push(C):l!==null&&(a[l]=C)}const p={onObjectBegin:()=>{const C={};i(C),d.push(a),a=C,l=null},onObjectProperty:C=>{l=C},onObjectEnd:()=>{a=d.pop()},onArrayBegin:()=>{const C=[];i(C),d.push(a),a=C,l=null},onArrayEnd:()=>{a=d.pop()},onLiteralValue:i,onError:(C,R,U)=>{n.push({error:C,offset:R,length:U})}};if(u)try{I.visit(u,p),o=a[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return o}doParseRaw(u,o){const l=E.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),a=this.filter(u,l,!0,o);u=a.raw;const d=(0,A.toValuesTree)(u,p=>console.error(`Conflict in settings file ${this._name}: ${p}`)),n=Object.keys(u),i=this.toOverrides(u,p=>console.error(`Conflict in settings file ${this._name}: ${p}`));return{contents:d,keys:n,overrides:i,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}filter(u,o,l,a){let d=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:u,restricted:[],hasExcludedProperties:d};const n={},i=[];for(const p in u)if(k.OVERRIDE_PROPERTY_REGEX.test(p)&&l){const C=this.filter(u[p],o,!1,a);n[p]=C.raw,d=d||C.hasExcludedProperties,i.push(...C.restricted)}else{const C=o[p],R=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&i.push(p),(R===void 0||a.scopes===void 0||a.scopes.includes(R))&&!(a.skipRestricted&&C?.restricted)?n[p]=u[p]:d=!0}return{raw:n,restricted:i,hasExcludedProperties:d}}toOverrides(u,o){const l=[];for(const a of Object.keys(u))if(k.OVERRIDE_PROPERTY_REGEX.test(a)){const d={};for(const n in u[a])d[n]=u[a][n];l.push({identifiers:(0,k.overrideIdentifiersFromKey)(a),keys:Object.keys(d),contents:(0,A.toValuesTree)(d,o)})}return l}}e.ConfigurationModelParser=w;class f extends P.Disposable{constructor(u,o,l,a){super(),this.userSettingsResource=u,this.scopes=o,this.fileService=a,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,d=>(d.isOperation(0)||d.isOperation(3)||d.isOperation(1)||d.isOperation(4))&&l.isEqual(d.resource,u)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const u=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(u.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new _}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class g{constructor(u,o,l,a,d,n,i,p,C,R,U,H,V){this.key=u,this.overrides=o,this.value=l,this.overrideIdentifiers=a,this.defaultConfiguration=d,this.policyConfiguration=n,this.applicationConfiguration=i,this.userConfiguration=p,this.localUserConfiguration=C,this.remoteUserConfiguration=R,this.workspaceConfiguration=U,this.folderConfigurationModel=H,this.memoryInspectValue=V}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class h{constructor(u,o,l,a,d=new _,n=new _,i=new y.ResourceMap,p=new _,C=new y.ResourceMap,R=!0){this._defaultConfiguration=u,this._policyConfiguration=o,this._applicationConfiguration=l,this._localUserConfiguration=a,this._remoteUserConfiguration=d,this._workspaceConfiguration=n,this._folderConfigurations=i,this._memoryConfiguration=p,this._memoryConfigurationByResource=C,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(u,o,l){return this.getConsolidatedConfigurationModel(u,o,l).getValue(u)}updateValue(u,o,l={}){let a;l.resource?(a=this._memoryConfigurationByResource.get(l.resource),a||(a=new _,this._memoryConfigurationByResource.set(l.resource,a))):a=this._memoryConfiguration,o===void 0?a.removeValue(u):a.setValue(u,o),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(u,o,l){const a=this.getConsolidatedConfigurationModel(u,o,l),d=c.distinct(a.overrides.map(p=>p.identifiers).flat()).filter(p=>a.getOverrideValue(u,p)!==void 0),n=this.getFolderConfigurationModelForResource(o.resource,l),i=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration;return new g(u,o,a.getValue(u),d.length?d:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),l?this._workspaceConfiguration.freeze():void 0,n?n.freeze():void 0,i.inspect(u,o.overrideIdentifier))}keys(u){const o=this.getFolderConfigurationModelForResource(void 0,u);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(u){this._defaultConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(u){this._policyConfiguration=u}updateApplicationConfiguration(u){this._applicationConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(u){this._localUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(u){this._remoteUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(u){this._workspaceConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(u,o){this._folderConfigurations.set(u,o),this._foldersConsolidatedConfigurations.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this._foldersConsolidatedConfigurations.delete(u)}compareAndUpdateDefaultConfiguration(u,o){const l=[];if(!o){const{added:a,updated:d,removed:n}=r(this._defaultConfiguration,u);o=[...a,...d,...n]}for(const a of o)for(const d of(0,k.overrideIdentifiersFromKey)(a)){const n=this._defaultConfiguration.getKeysForOverrideIdentifier(d),i=u.getKeysForOverrideIdentifier(d),p=[...i.filter(C=>n.indexOf(C)===-1),...n.filter(C=>i.indexOf(C)===-1),...n.filter(C=>!T.equals(this._defaultConfiguration.override(d).getValue(C),u.override(d).getValue(C)))];l.push([d,p])}return this.updateDefaultConfiguration(u),{keys:o,overrides:l}}compareAndUpdatePolicyConfiguration(u){const{added:o,updated:l,removed:a}=r(this._policyConfiguration,u),d=[...o,...l,...a];return d.length&&this.updatePolicyConfiguration(u),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:o,updated:l,removed:a,overrides:d}=r(this.applicationConfiguration,u),n=[...o,...l,...a];return n.length&&this.updateApplicationConfiguration(u),{keys:n,overrides:d}}compareAndUpdateLocalUserConfiguration(u){const{added:o,updated:l,removed:a,overrides:d}=r(this.localUserConfiguration,u),n=[...o,...l,...a];return n.length&&this.updateLocalUserConfiguration(u),{keys:n,overrides:d}}compareAndUpdateRemoteUserConfiguration(u){const{added:o,updated:l,removed:a,overrides:d}=r(this.remoteUserConfiguration,u),n=[...o,...l,...a];return n.length&&this.updateRemoteUserConfiguration(u),{keys:n,overrides:d}}compareAndUpdateWorkspaceConfiguration(u){const{added:o,updated:l,removed:a,overrides:d}=r(this.workspaceConfiguration,u),n=[...o,...l,...a];return n.length&&this.updateWorkspaceConfiguration(u),{keys:n,overrides:d}}compareAndUpdateFolderConfiguration(u,o){const l=this.folderConfigurations.get(u),{added:a,updated:d,removed:n,overrides:i}=r(l,o),p=[...a,...d,...n];return(p.length||!l)&&this.updateFolderConfiguration(u,o),{keys:p,overrides:i}}compareAndDeleteFolderConfiguration(u){const o=this.folderConfigurations.get(u);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:l,updated:a,removed:d,overrides:n}=r(o,void 0);return{keys:[...l,...a,...d],overrides:n}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(u,o,l){let a=this.getConsolidatedConfigurationModelForResource(o,l);return o.overrideIdentifier&&(a=a.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(u)!==void 0&&(a=a.merge(this._policyConfiguration)),a}getConsolidatedConfigurationModelForResource({resource:u},o){let l=this.getWorkspaceConsolidatedConfiguration();if(o&&u){const a=o.getFolder(u);a&&(l=this.getFolderConsolidatedConfiguration(a.uri)||l);const d=this._memoryConfigurationByResource.get(u);d&&(l=l.merge(d))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(u){let o=this._foldersConsolidatedConfigurations.get(u);if(!o){const l=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(u);a?(o=l.merge(a),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(u,o)):o=l}return o}getFolderConfigurationModelForResource(u,o){if(o&&u){const l=o.getFolder(u);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((u,o)=>{const{contents:l,overrides:a,keys:d}=this._folderConfigurations.get(o);return u.push([o,{contents:l,overrides:a,keys:d}]),u},[])}}allKeys(){const u=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>u.add(o)),this.userConfiguration.freeze().keys.forEach(o=>u.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>u.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(l=>u.add(l))),[...u.values()]}allOverrideIdentifiers(){const u=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>u.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>u.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>u.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(l=>u.add(l))),[...u.values()]}getAllKeysForOverrideIdentifier(u){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(u).forEach(l=>o.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(l=>o.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(u).forEach(l=>o.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(u).forEach(a=>o.add(a))),[...o.values()]}static parse(u){const o=this.parseConfigurationModel(u.defaults),l=this.parseConfigurationModel(u.policy),a=this.parseConfigurationModel(u.application),d=this.parseConfigurationModel(u.user),n=this.parseConfigurationModel(u.workspace),i=u.folders.reduce((p,C)=>(p.set(D.URI.revive(C[0]),this.parseConfigurationModel(C[1])),p),new y.ResourceMap);return new h(o,l,a,d,new _,n,i,new _,new y.ResourceMap,!1)}static parseConfigurationModel(u){return new _(u.contents,u.keys,u.overrides).freeze()}}e.Configuration=h;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const u=new Set,o=new Map;for(const a of s)a.keys.forEach(d=>u.add(d)),a.overrides.forEach(([d,n])=>{const i=(0,y.getOrSet)(o,d,new Set);n.forEach(p=>i.add(p))});const l=[];return o.forEach((a,d)=>l.push([d,[...a.values()]])),{keys:[...u.values()],overrides:l}}e.mergeChanges=v;class m{constructor(u,o,l,a){this.change=u,this.previous=o,this.currentConfiguraiton=l,this.currentWorkspace=a,this._previousConfiguration=void 0;const d=new Set;u.keys.forEach(i=>d.add(i)),u.overrides.forEach(([,i])=>i.forEach(p=>d.add(p))),this.affectedKeys=[...d.values()];const n=new _;this.affectedKeys.forEach(i=>n.setValue(i,{})),this.affectedKeysTree=n.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(u,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,u)){if(o){const l=this.previousConfiguration?this.previousConfiguration.getValue(u,o,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(u,o,this.currentWorkspace);return!T.equals(l,a)}return!0}return!1}doesAffectedKeysTreeContains(u,o){let l=(0,A.toValuesTree)({[o]:!0},()=>{}),a;for(;typeof l=="object"&&(a=Object.keys(l)[0]);){if(u=u[a],!u)return!1;l=l[a]}return!0}}e.ConfigurationChangeEvent=m;function r(s,u){const{added:o,removed:l,updated:a}=b(u?.rawConfiguration,s?.rawConfiguration),d=[],n=s?.getAllOverrideIdentifiers()||[],i=u?.getAllOverrideIdentifiers()||[];if(u){const p=i.filter(C=>!n.includes(C));for(const C of p)d.push([C,u.getKeysForOverrideIdentifier(C)])}if(s){const p=n.filter(C=>!i.includes(C));for(const C of p)d.push([C,s.getKeysForOverrideIdentifier(C)])}if(u&&s){for(const p of n)if(i.includes(p)){const C=b({contents:s.getOverrideValue(void 0,p)||{},keys:s.getKeysForOverrideIdentifier(p)},{contents:u.getOverrideValue(void 0,p)||{},keys:u.getKeysForOverrideIdentifier(p)});d.push([p,[...C.added,...C.removed,...C.updated]])}}return{added:o,removed:l,updated:a,overrides:d}}function b(s,u){const o=s?u?s.keys.filter(d=>u.keys.indexOf(d)===-1):[...s.keys]:[],l=u?s?u.keys.filter(d=>s.keys.indexOf(d)===-1):[...u.keys]:[],a=[];if(s&&u){for(const d of u.keys)if(s.keys.indexOf(d)!==-1){const n=(0,A.getConfigurationValue)(u.contents,d),i=(0,A.getConfigurationValue)(s.contents,d);T.equals(n,i)||a.push(d)}}return{added:o,removed:l,updated:a}}}),define(_e[127],ye([1,0,10,3]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var I;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends c.ErrorNoTelemetry{static isNotAvailable(T){return T instanceof P&&T._code===I.NotAvailable}static isTemporarilyNotAvailable(T){return T instanceof P&&T._code===I.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof P&&T._code===I.NoResolverFound}static isHandled(T){return T instanceof P&&T.isHandled}constructor(T,S=I.Unknown,D){super(T),this._message=T,this._code=S,this._detail=D,this.isHandled=S===I.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}}e.RemoteAuthorityResolverError=P}),define(_e[86],ye([1,0,14]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(D){return D.scheme===c.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=t;function I(D){if(!D)return;const A=D.indexOf("+");return A<0?D:D.substr(0,A)}e.getRemoteName=I;function P(D){return`/${D.quality??"oss"}-${D.commit??"dev"}`}e.getRemoteServerRootPath=P;function y(D){const{host:A,port:k}=S(D);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:k}}e.parseAuthorityWithPort=y;function T(D,A){let{host:k,port:E}=S(D);return typeof E>"u"&&(E=A),{host:k,port:E}}e.parseAuthorityWithOptionalPort=T;function S(D){const A=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=D.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const E=D.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:D,port:void 0}}}),define(_e[26],ye([1,0,8,3,86]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=P;function y(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));var S;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class D{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,g){if(typeof f>"u"||f===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof f=="string"||typeof g=="string"){const h=typeof f=="string"?f:f.value,v=typeof g=="string"?g:g.value;return c.equalsIgnoreCase(h,v)}return f._lower===g._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=D;function A(w){return k(w)}e.isApplicationScopedExtension=A;function k(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function E(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function _(w,f){if(f){const g=`onResolveRemoteAuthority:${(0,I.getRemoteName)(f)}`;return w.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(_e[200],ye([1,0,8,121,26,12,2,10,36]),function(Z,e,c,t,I,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function D(u,o){return u.uuid&&o.uuid?u.uuid===o.uuid:u.id===o.id?!0:(0,c.compareIgnoreCase)(u.id,o.id)===0}e.areSameExtensions=D;const A=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(o){const l=o.manifest?o.manifest.version:o.version,a=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new k(o.identifier,l,a)}static parse(o){const l=A.exec(o);return l&&l[1]&&l[2]?new k({id:l[1]},l[2],l[4]||void 0):null}constructor(o,l,a="undefined"){this.version=l,this.targetPlatform=a,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof k?D(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=k;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function _(u){const o=E.exec(u);return o&&o[1]?[f(o[1]),o[2]]:[f(u),void 0]}e.getIdAndVersion=_;function w(u,o){return`${u}.${o}`}e.getExtensionId=w;function f(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=f;function g(u,o){return f(w(u,o))}e.getGalleryExtensionId=g;function h(u,o){const l=[],a=d=>{for(const n of l)if(n.some(i=>D(o(i),o(d))))return n;return null};for(const d of u){const n=a(d);n?n.push(d):l.push([d])}return l}e.groupByExtension=h;function v(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function m(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function r(u,o){const l=[],a=o.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const d=a.shift();if(d&&l.every(n=>!D(n.identifier,{id:d}))){const n=u.filter(i=>D(i.identifier,{id:d}));n.length===1&&(l.push(n[0]),a.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=r;async function b(u,o){if(!P.isLinux)return!1;let l;try{l=(await u.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await u.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){o.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(d))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=b;async function s(u,o){const l=await b(u,o),a=(0,t.getTargetPlatform)(l?"alpine":P.platform,S.arch);return o.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=s}),define(_e[201],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class c{constructor(){this.validators=new Map}vsda(){return new Promise((I,P)=>Z(["vsda"],I,P))}async createNewMessage(I){try{const P=await this.vsda(),y=new P.validator;if(y){const T=String(c._nextId++);return this.validators.set(T,y),{id:T,data:y.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,P){if(!I.id)return!0;const y=this.validators.get(I.id);if(!y)return!1;this.validators.delete(I.id);try{return y.validate(P)==="ok"}catch{return!1}}async sign(I){try{const P=await this.vsda(),y=new P.signer;if(y)return y.sign(I)}catch{}return I}}e.SignService=c,c._nextId=1}),define(_e[202],ye([1,0,12,36,2,31]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function y(D){if(c.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}async function T(D,A,k,E,_,w,f,g,h,v){const m=Object.create(null);m["common.machineId"]=f,m.sessionID=(0,P.generateUuid)()+Date.now(),m.commitHash=_,m.version=w,m["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,c.PlatformToString)(c.platform),m["common.nodePlatform"]=t.platform,m["common.nodeArch"]=E,m["common.product"]=v||"desktop",g&&(m["common.msftInternal"]=g);let r=0;const b=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),c.isLinuxSnap&&(m["common.snap"]="true");const s=y(k);s&&(m["common.platformDetail"]=s);try{const u=await D.readFile(I.URI.file(h));m["common.source"]=u.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=T;function S(D){const A=t.env.USERDNSDOMAIN;if(!A)return!1;const k=A.toLowerCase();return D.some(E=>k===E)}e.verifyMicrosoftInternalDomain=S}),define(_e[203],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var I;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(I=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(_e[204],ye([1,0,24,157,11,52,202,203]),function(Z,e,c,t,I,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(l,a){return Promise.resolve(void 0)}publicLog2(l,a){return this.publicLog(l,a)}publicLogError(l,a){return Promise.resolve(void 0)}publicLogError2(l,a){return this.publicLogError(l,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class D{async publicLog(l,a,d){}async publicLogError(l,a,d){}}e.NullEndpointTelemetryService=D,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function A(o,l){return l.onDidChangeConfiguration(a=>{a.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(a.source),configurationKeys:h(a.sourceConfig)})})}e.configurationTelemetry=A;function k(o,l){return!(l.disableTelemetry||!o.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=k;function E(o){const l=o.getValue(T.TELEMETRY_SETTING_ID),a=o.getValue("telemetry.enableCrashReporter");if(o.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function _(o){const l={},a={},d={};g(o,d);for(let n in d){n=n.length>150?n.substr(n.length-149):n;const i=d[n];typeof i=="number"?a[n]=i:typeof i=="boolean"?a[n]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${i.length}`),l[n]=i.substring(0,8191)):typeof i<"u"&&i!==null&&(l[n]=i)}return{properties:l,measurements:a}}e.validateTelemetryData=_;const w=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function f(o){if(!o)return"none";for(const l of w)if(o.startsWith(`${l}+`))return l;return"other"}e.cleanRemoteAuthority=f;function g(o,l,a=0,d){if(!!o)for(const n of Object.getOwnPropertyNames(o)){const i=o[n],p=d?d+n:n;Array.isArray(i)?l[p]=(0,c.safeStringify)(i):i instanceof Date?l[p]=i.toISOString():(0,I.isObject)(i)?a<2?g(i,l,a+1,p+"."):l[p]=(0,c.safeStringify)(i):l[p]=i}}function h(o){if(!o)return[];const l=[];return v(l,"",o),l}function v(o,l,a){a&&typeof a=="object"&&!Array.isArray(a)?Object.keys(a).forEach(d=>v(o,l?`${l}.${d}`:d,a[d])):o.push(l)}function m(o,l){const a=o.msftInternalDomains||[],d=l.getValue("telemetry.internalTesting");return(0,y.verifyMicrosoftInternalDomain)(a)||d}e.isInternalTelemetry=m;function r(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=r;function b(o,l){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let a=o;const d=[];for(const C of l)for(;;){const R=C.exec(o);if(!R)break;d.push([R.index,C.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(a="";;){const C=i.exec(o);if(!C)break;const R=d.some(([U,H])=>C.index<H&&U<i.lastIndex);!n.test(C[0])&&!R&&(a+=o.substring(p,C.index)+"<REDACTED: user-file-path>",p=i.lastIndex)}return p<o.length&&(a+=o.substr(p)),a}function s(o){if(!o)return o;const l=o.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of a)if(d.regex.test(l))return`<REDACTED: ${d.label}>`;return o}function u(o,l){return(0,c.cloneAndChange)(o,a=>{if(typeof a=="string"){let d=a;d=b(d,l);for(const n of l)d=d.replace(n,"");return d=s(d),d}})}e.cleanData=u}),define(_e[205],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,P,y=5){const T=P(S=>{const D=typeof S=="string"?S:S.data;let A=this._terminalBufferMap.get(I);if(A){A.data.push(D);return}const k=setTimeout(()=>this.flushBuffer(I),y);A={data:[D],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(I),T.dispose()}},this._terminalBufferMap.set(I,A)});return T}stopBuffering(I){this._terminalBufferMap.get(I)?.dispose()}flushBuffer(I){const P=this._terminalBufferMap.get(I);P&&(this._terminalBufferMap.delete(I),this._callback(I,P.data.join("")))}}e.TerminalDataBufferer=c}),define(_e[206],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var c;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(c=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===c.HIGH_CONTRAST_DARK||P===c.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function I(P){return P===c.DARK||P===c.HIGH_CONTRAST_DARK}e.isDark=I}),define(_e[87],ye([1,0,77,4,6,3,43,206]),function(Z,e,c,t,I,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var S;(function(g){function h(v){return v&&typeof v=="object"&&typeof v.id=="string"}g.isThemeColor=h})(S=e.ThemeColor||(e.ThemeColor={}));function D(g){return{id:g}}e.themeColorFromId=D;var A;(function(g){function h(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||S.isThemeColor(l.color))}g.isThemeIcon=h;const v=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function m(l){const a=v.exec(l);if(!a)return;const[,d]=a;return{id:d}}g.fromString=m;function r(l){return{id:l}}g.fromId=r;function b(l,a){let d=l.id;const n=d.lastIndexOf("~");return n!==-1&&(d=d.substring(0,n)),a&&(d=`${d}~${a}`),{id:d}}g.modify=b;function s(l){const a=l.id.lastIndexOf("~");if(a!==-1)return l.id.substring(a+1)}g.getModifier=s;function u(l,a){return l.id===a.id&&l.color?.id===a.color?.id}g.isEqual=u;function o(l,a){return{id:l.id,color:a?D(a):void 0}}g.asThemeIcon=o,g.asClassNameArray=c.CSSIcon.asClassNameArray,g.asClassName=c.CSSIcon.asClassName,g.asCSSSelector=c.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function k(g){switch(g){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case T.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(h){return this.themingParticipants.push(h),this.onThemingParticipantAddedEmitter.fire(h),(0,I.toDisposable)(()=>{const v=this.themingParticipants.indexOf(h);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const _=new E;y.Registry.add(e.Extensions.ThemingContribution,_);function w(g){return _.onColorThemeChange(g)}e.registerThemingParticipant=w;class f extends I.Disposable{constructor(h){super(),this.themeService=h,this.theme=h.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(h){this.theme=h,this.updateStyles()}updateStyles(){}getColor(h,v){let m=this.theme.getColor(h);return m&&v&&(m=v(m,this.theme)),m?m.toString():null}}e.Themable=f}),define(_e[128],ye([1,0,4,52,3,13]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var y;(function(f){f.Http="http",f.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=k;function E(f,g,h,v){if(h===1)return!1;if(h===2&&k(g)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(m?.length===4&&parseInt(m[1])>=18)return!1}return f<1024}e.isPortPrivileged=E;class _{constructor(g,h,v){this.remoteAddress=g,this.localAddress=h,this._dispose=v,this._onDispose=new c.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=_;let w=class{constructor(g,h){this.logService=g,this.configurationService=h,this._onTunnelOpened=new c.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new c.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new c.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this._tunnelProvider=g,g?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],h=Array.from(this._tunnels.values());for(const v of h){const m=Array.from(v.values());for(const r of m){const b=await r.value;b&&g.push(b)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:h}of g.values())await h.then(v=>v?.dispose());g.clear()}this._tunnels.clear()}setEnvironmentTunnel(g,h,v,m,r){this.addTunnelToMap(g,h,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:h,localAddress:v,privacy:m,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,h){(k(g)||A(g))&&(g=e.LOCALHOST_ADDRESSES[0]);const v=this.getTunnelFromMap(g,h);if(v)return++v.refcount,v.value}openTunnel(g,h,v,m,r=!1,b,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${v} on local port ${m}.`),!g)return;if(h||(h="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(g,h,v,m,r,b,s);return u?u.then(o=>{if(!o){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.makeTunnel(o);return(o.tunnelRemoteHost!==h||o.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(l),l}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const h=this._tunnels.get(g.tunnelRemoteHost);if(h){const v=h.get(g.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,v))}}}}async tryDisposeTunnel(g,h,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${h}.`);const m=v.value.then(async r=>{r&&(await r.dispose(!0),this._onTunnelClosed.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(h),m}}async closeTunnel(g,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${h} `);const v=this._tunnels.get(g);if(v&&v.has(h)){const m=v.get(h);m.refcount=0,await this.tryDisposeTunnel(g,h,m)}}addTunnelToMap(g,h,v){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(h,{refcount:1,value:v})}async removeEmptyTunnelFromMap(g,h){const v=this._tunnels.get(g);v&&(await v.get(h)||v.delete(h),v.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,h){const v=[g];A(g)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):k(g)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const m=v.map(r=>this._tunnels.get(r));for(const r of m){const b=r?.get(h);if(b)return b}}canTunnel(g){return!!D(g)}createWithProvider(g,h,v,m,r,b,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${v} on local port ${m}.`);const u=v;this._factoryInProgress.add(u);const o=m===void 0?v:m,l={elevationRequired:r?this.isPortPrivileged(o):!1},a={remoteAddress:{host:h,port:v},localAddressPort:m,privacy:b,public:b?b!==T.Private:void 0,protocol:s},d=g.forwardPort(a,l);return d?(this.addTunnelToMap(h,v,d),d.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),d}};w=Ve([ze(0,P.ILogService),ze(1,t.IConfigurationService)],w),e.AbstractTunnelService=w}),define(_e[207],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var t;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(_e[208],ye([1,0,14]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(S){return S.scheme!==c.Schemas.file&&S.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=t;function I(S){if(S.folders.length)return S.folders.every(D=>t(D.uri))?S.folders[0].uri:void 0;if(S.configuration&&t(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=I;function P(S){return I(S)?.scheme}e.getVirtualWorkspaceScheme=P;function y(S){return I(S)?.authority}e.getVirtualWorkspaceAuthority=y;function T(S){return I(S)!==void 0}e.isVirtualWorkspace=T}),define(_e[45],ye([1,0,170,9,64,22,2,3,14]),function(Z,e,c,t,I,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function D(u){const o=u;return typeof o?.id=="string"&&y.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=D,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function A(u,o){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,t.basename)(u)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const l=u;if(l.configuration)return{id:l.id,configPath:l.configuration};if(l.folders.length===1)return{id:l.id,uri:l.folders[0].uri}}e.toWorkspaceIdentifier=A;function k(u){const o=u;return typeof o?.id=="string"&&y.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=k;function E(u){const o=u;if(o?.uri)return{id:o.id,uri:y.URI.revive(o.uri)};const l=u;if(l?.configPath)return{id:l.id,configPath:y.URI.revive(l.configPath)};if(u?.id)return{id:u.id}}e.reviveIdentifier=E;var _;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(_=e.WorkbenchState||(e.WorkbenchState={}));function w(u){const o=u;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=w;function f(u){const o=u;return!!(o&&typeof o=="object"&&y.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=f;class g{constructor(o,l,a,d,n){this._id=o,this._transient=a,this._configuration=d,this._ignorePathCasing=n,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=l}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o)||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class h{constructor(o,l){this.raw=l,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,P.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function v(u){return new h({uri:u,index:0,name:(0,P.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(u,o){return P.extUriBiasedIgnorePathCase.isEqualOrParent(u,o.untitledWorkspacesHome)}e.isUntitledWorkspace=m;function r(u){let o;return y.URI.isUri(u)?o=u:o=u.configuration,o?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=r;function b(u,o){return!m(u,o)&&!r(u)}e.isSavedWorkspace=b;function s(u){return(typeof u=="string"?(0,t.extname)(u):(0,P.extname)(u))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(_e[88],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const P=this._idPool++;return this._data.set(P,I),this.logDebugInfo(),P}get(I,P){return this._data.has(I)?this._data.get(I)[P]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!c.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(_e[46],ye([1,0,14,22,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(T=>{const S=this._providerInfo.get(T.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(T,S){S===null?this._providerInfo.delete(T.scheme):this._providerInfo.set(T.scheme,S)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(_e[25],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(_e[209],ye([1,0,18]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(y,T,S){this._deferredPromises=new Map,this._id=y,this._shared=T,this._storage=S,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(D=>(this._value=D,this)),this._storageListener=this._storage.onDidChangeStorage(D=>{D.shared===this._shared&&D.key===this._id&&(this._value=D.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const D=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const A of D.values())A.complete()}catch(A){for(const k of D.values())k.error(A)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(y,T){let S=this._value[y];return typeof S>"u"&&(S=T),S}update(y,T){this._value[y]=T;const S=this._deferredPromises.get(y);if(S!==void 0)return S.p;const D=new c.DeferredPromise;return this._deferredPromises.set(y,D),this._scheduler.isScheduled()||this._scheduler.schedule(),D.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class I extends t{setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}constructor(y,T){super(y.identifier.value,!0,T),this._extension=y}}e.ExtensionGlobalMemento=I}),define(_e[210],ye([1,0,4,2]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class I{constructor(y){this._notebooksAndEditors=y,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new c.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(y,T,S,D){const k=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptModelChanged(T.value,S,D);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(y,T){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptDirty(T)}$acceptModelSaved(y){const T=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y));this._onDidSaveNotebookDocument.fire(T.apiNotebook)}}e.ExtHostNotebookDocuments=I}),define(_e[16],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Me=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[211],ye([1,0,26,4]),function(Z,e,c,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(T,S){I.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(T.identifier),Ze(this,I,S,"f"),Me(this,I,"f").onDidChangePassword(D=>{D.extensionId===this._id&&this._onDidChange.fire({key:D.key})})}get(T){return Me(this,I,"f").get(this._id,T)}store(T,S){return Me(this,I,"f").store(this._id,T,S)}delete(T){return Me(this,I,"f").delete(this._id,T)}}e.ExtensionSecrets=P,I=new WeakMap}),define(_e[54],ye([1,0,3,128,4,16]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(S){function D(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:k.protocol}}S.fromApiTunnel=D;function A(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==t.TunnelPrivacyId.ConstantPrivate&&k.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}S.fromServiceTunnel=A})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let T=class{constructor(D){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,A){}async getTunnels(){return[]}async setTunnelFactory(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,A){return{dispose:()=>{}}}async $providePortAttributes(D,A,k,E,_){return[]}async $forwardPort(D,A){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ve([ze(0,P.IExtHostRpcService)],T),e.ExtHostTunnelService=T}),define(_e[55],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=t}),define(_e[212],ye([1,0,23]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let D=this.buffers.indexOf(S);return D<0&&(D=this.buffers.length,this.buffers.push(S)),D}}function I(T,S){if(S.serializeBuffersForPostMessage){const D=new t,A=(_,w)=>{if(w instanceof ArrayBuffer){const f=D.add(w);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(w)){const f=P(w);if(f){const g=D.add(w.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:f,byteLength:w.byteLength,byteOffset:w.byteOffset}}}}return w},k=JSON.stringify(T,A),E=D.buffers.map(_=>{const w=new Uint8Array(_);return c.VSBuffer.wrap(w)});return{message:k,buffers:E}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=I;function P(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(T,S){const D=S.map(E=>{const _=new ArrayBuffer(E.byteLength);return new Uint8Array(_).set(E.buffer),_}),A=S.length?(E,_)=>{if(_&&typeof _=="object"&&_.$$vscode_array_buffer_reference$$){const w=_,{index:f}=w,g=D[f];if(w.view)switch(w.view.type){case 1:return new Int8Array(g,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return _}:void 0;return{message:JSON.parse(T,A),arrayBuffers:D}}e.deserializeWebviewMessage=y}),define(_e[213],ye([1,0,112]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:y=>y.scheme==="vscode-remote"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="file"?{scheme:"vscode-local",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoing:y=>y.scheme==="file"?{scheme:"vscode-remote",authority:P,path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="vscode-local"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoingScheme:y=>y==="file"?"vscode-remote":y==="vscode-local"?"file":y}}function I(P){return new c.URITransformer(t(P))}e.createURITransformer=I}),define(_e[129],ye([1,0,180,11,2,6,3,43,38,14]),function(Z,e,c,t,I,P,y,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var A;(function(j){j[j.PROGRAMMATIC=1]="PROGRAMMATIC",j[j.USER=2]="USER",j[j.EDIT=3]="EDIT",j[j.NAVIGATION=4]="NAVIGATION",j[j.JUMP=5]="JUMP"})(A=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var k;(function(j){j[j.IDENTICAL=1]="IDENTICAL",j[j.SIMILAR=2]="SIMILAR",j[j.DIFFERENT=3]="DIFFERENT"})(k=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(j){const x=j;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.isEditorPaneWithSelection=E;function _(j,x,Q){for(const K of Q.visibleEditorPanes)if(K.group.id===x&&j.matches(K.input))return K.getViewState()}e.findViewStateForEditor=_;function w(j){if(a(j))return!1;const x=j;return I.URI.isUri(x?.resource)}e.isResourceEditorInput=w;function f(j){if(a(j))return!1;const x=j;return x?.original!==void 0&&x.modified!==void 0}e.isResourceDiffEditorInput=f;function g(j){if(a(j)||f(j))return!1;const x=j;return x?.primary!==void 0&&x.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function h(j){if(a(j))return!1;const x=j;return x?x.resource===void 0||x.resource.scheme===D.Schemas.untitled||x.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=h;const v=/Untitled-\d+/;function m(j){return j.scheme===D.Schemas.untitled&&j.path.length>1&&!v.test(j.path)}e.isUntitledWithAssociatedResource=m;function r(j){if(a(j))return!1;const x=j;return I.URI.isUri(x?.base?.resource)&&I.URI.isUri(x?.input1?.resource)&&I.URI.isUri(x?.input2?.resource)&&I.URI.isUri(x?.result?.resource)}e.isResourceMergeEditorInput=r;var b;(function(j){j[j.SHORT=0]="SHORT",j[j.MEDIUM=1]="MEDIUM",j[j.LONG=2]="LONG"})(b=e.Verbosity||(e.Verbosity={}));var s;(function(j){j[j.EXPLICIT=1]="EXPLICIT",j[j.AUTO=2]="AUTO",j[j.FOCUS_CHANGE=3]="FOCUS_CHANGE",j[j.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s=e.SaveReason||(e.SaveReason={}));class u{constructor(){this.mapIdToSaveSource=new Map}registerSource(x,Q){let K=this.mapIdToSaveSource.get(x);return K||(K={source:x,label:Q},this.mapIdToSaveSource.set(x,K)),K.source}getSourceLabel(x){return this.mapIdToSaveSource.get(x)?.label??x}}e.SaveSourceRegistry=new u;var o;(function(j){j[j.None=0]="None",j[j.Readonly=2]="Readonly",j[j.Untitled=4]="Untitled",j[j.Singleton=8]="Singleton",j[j.RequiresTrust=16]="RequiresTrust",j[j.CanSplitInGroup=32]="CanSplitInGroup",j[j.ForceDescription=64]="ForceDescription",j[j.CanDropIntoEditor=128]="CanDropIntoEditor",j[j.MultipleEditors=256]="MultipleEditors"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class l extends P.Disposable{}e.AbstractEditorInput=l;function a(j){return j instanceof l}e.isEditorInput=a;function d(j){const x=j;return I.URI.isUri(x?.preferredResource)}function n(j){const x=j;return a(x?.primary)&&a(x?.secondary)}e.isSideBySideEditorInput=n;function i(j){const x=j;return a(x?.modified)&&a(x?.original)}e.isDiffEditorInput=i;function p(j){return a(j?.editor)}e.isEditorInputWithOptions=p;function C(j){const x=j;return p(j)&&x?.group!==void 0}e.isEditorInputWithOptionsAndGroup=C;function R(j){const x=j;return typeof x?.groupId=="number"&&a(x.editor)}e.isEditorIdentifier=R;var U;(function(j){j[j.UNKNOWN=0]="UNKNOWN",j[j.REPLACE=1]="REPLACE",j[j.MOVE=2]="MOVE",j[j.UNPIN=3]="UNPIN"})(U=e.EditorCloseContext||(e.EditorCloseContext={}));var H;(function(j){j[j.GROUP_ACTIVE=0]="GROUP_ACTIVE",j[j.GROUP_INDEX=1]="GROUP_INDEX",j[j.GROUP_LOCKED=2]="GROUP_LOCKED",j[j.EDITOR_OPEN=3]="EDITOR_OPEN",j[j.EDITOR_CLOSE=4]="EDITOR_CLOSE",j[j.EDITOR_MOVE=5]="EDITOR_MOVE",j[j.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",j[j.EDITOR_LABEL=7]="EDITOR_LABEL",j[j.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",j[j.EDITOR_PIN=9]="EDITOR_PIN",j[j.EDITOR_STICKY=10]="EDITOR_STICKY",j[j.EDITOR_DIRTY=11]="EDITOR_DIRTY",j[j.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(H=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var V;(function(j){j[j.PRIMARY=1]="PRIMARY",j[j.SECONDARY=2]="SECONDARY",j[j.BOTH=3]="BOTH",j[j.ANY=4]="ANY"})(V=e.SideBySideEditor||(e.SideBySideEditor={}));class L{getOriginalUri(x,Q){if(!x)return;if(r(x))return e.EditorResourceAccessor.getOriginalUri(x.result,Q);if(Q?.supportSideBySide){const{primary:le,secondary:ie}=this.getSideEditors(x);if(le&&ie){if(Q?.supportSideBySide===V.BOTH)return{primary:this.getOriginalUri(le,{filterByScheme:Q.filterByScheme}),secondary:this.getOriginalUri(ie,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===V.ANY)return this.getOriginalUri(le,{filterByScheme:Q.filterByScheme})??this.getOriginalUri(ie,{filterByScheme:Q.filterByScheme});x=Q.supportSideBySide===V.PRIMARY?le:ie}}if(f(x)||g(x)||r(x))return;const K=d(x)?x.preferredResource:x.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}getSideEditors(x){return n(x)||g(x)?{primary:x.primary,secondary:x.secondary}:i(x)||f(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,Q){if(!x)return;if(r(x))return e.EditorResourceAccessor.getCanonicalUri(x.result,Q);if(Q?.supportSideBySide){const{primary:le,secondary:ie}=this.getSideEditors(x);if(le&&ie){if(Q?.supportSideBySide===V.BOTH)return{primary:this.getCanonicalUri(le,{filterByScheme:Q.filterByScheme}),secondary:this.getCanonicalUri(ie,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===V.ANY)return this.getCanonicalUri(le,{filterByScheme:Q.filterByScheme})??this.getCanonicalUri(ie,{filterByScheme:Q.filterByScheme});x=Q.supportSideBySide===V.PRIMARY?le:ie}}if(f(x)||g(x)||r(x))return;const K=x.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}filterUri(x,Q){if(Array.isArray(Q)){if(Q.some(K=>x.scheme===K))return x}else if(Q===x.scheme)return x}}e.EditorResourceAccessor=new L;var M;(function(j){j[j.LEFT=0]="LEFT",j[j.RIGHT=1]="RIGHT"})(M=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(x){const Q=this.instantiationService=x.get(y.IInstantiationService);for(const[K,le]of this.editorSerializerConstructors)this.createEditorSerializer(K,le,Q);this.editorSerializerConstructors.clear()}createEditorSerializer(x,Q,K){const le=K.createInstance(Q);this.editorSerializerInstances.set(x,le)}registerFileEditorFactory(x){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=x}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(x,Q){if(this.editorSerializerConstructors.has(x)||this.editorSerializerInstances.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.instantiationService?this.createEditorSerializer(x,Q,this.instantiationService):this.editorSerializerConstructors.set(x,Q),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(x),this.editorSerializerInstances.delete(x)})}getEditorSerializer(x){return this.editorSerializerInstances.get(typeof x=="string"?x:x.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new F);async function B(j,x,Q){return!j||!j.length?[]:await Promise.all(j.map(async K=>{const le=I.URI.revive(K.fileUri);if(!le){Q.info("Cannot resolve the path because it is not valid.",K);return}if(!await x.canHandleResource(le)){Q.info("Cannot resolve the path because it cannot be handled",K);return}let de=K.exists,Y=K.type;if(typeof de!="boolean"||typeof Y!="number")try{Y=(await x.stat(le)).isDirectory?S.FileType.Directory:S.FileType.Unknown,de=!0}catch(be){Q.error(be),de=!1}if(!de&&K.openOnlyIfExists){Q.info("Cannot resolve the path because it does not exist",K);return}if(Y===S.FileType.Directory){Q.info("Cannot resolve the path because it is a directory",K);return}const pe={...K.options,pinned:!0};return de?{resource:le,options:pe}:{resource:le,options:pe,forceUntitled:!0}}))}e.pathsToEditors=B;var N;(function(j){j[j.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",j[j.SEQUENTIAL=1]="SEQUENTIAL"})(N=e.EditorsOrder||(e.EditorsOrder={}));function z(j){const x=j;if(!x)return!1;const Q=x;if(Q.modified)return z(Q.modified);const K=x;return!!(K.contributionsState&&K.viewState&&Array.isArray(K.cursorState))}e.isTextEditorViewState=z}),define(_e[89],ye([1,0,14,2]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function I(T,S){return T.scheme===c.Schemas.http||T.scheme===c.Schemas.https?T:(S&&S.authority&&S.isRemote&&T.scheme===c.Schemas.file&&(T=t.URI.from({scheme:c.Schemas.vscodeRemote,authority:S.authority,path:T.path})),t.URI.from({scheme:c.Schemas.https,authority:`${T.scheme}+${P(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=I;function P(T){return T.replace(/./g,S=>{const D=S.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?S:"-"+D.toString(16).padStart(4,"0")})}function y(T){return T.replace(/-([0-9a-f]{4})/g,(S,D)=>String.fromCharCode(parseInt(D,16)))}e.decodeAuthority=y}),define(_e[214],ye([1,0,4,6,89]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(T,S,D){this._proxy=T,this._editors=S,this._remoteInfo=D,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const A=S.getVisibleTextEditors();for(const k of this._insets.values())A.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(T=>T.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(T,S,D,A,k){let E;for(const m of this._editors.getVisibleTextEditors(!0))if(m.value===T){E=m;break}if(!E)throw new Error("not a visible editor");const _=this,w=this._handlePool++,f=new c.Emitter,g=new c.Emitter,h=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(m){return(0,I.asWebviewUri)(m,_._remoteInfo)}get cspSource(){return I.webviewGenericCspSource}set options(m){this._options=m,_._proxy.$setOptions(w,m)}get options(){return this._options}set html(m){this._html=m,_._proxy.$setHtml(w,m)}get html(){return this._html}get onDidReceiveMessage(){return f.event}postMessage(m){return _._proxy.$postMessage(w,m)}},v=new class{constructor(){this.editor=T,this.line=S,this.height=D,this.webview=h,this.onDidDispose=g.event}dispose(){_._insets.has(w)&&(_._insets.delete(w),_._proxy.$disposeEditorInset(w),g.fire(),g.dispose(),f.dispose())}};return this._proxy.$createEditorInset(w,E.id,E.value.document.uri,S+1,D,A||{},k.identifier,k.extensionLocation),this._insets.set(w,{editor:T,inset:v,onDidReceiveMessage:f}),v}$onDidDispose(T){const S=this._insets.get(T);S&&S.inset.dispose()}$onDidReceiveMessage(T,S){this._insets.get(T)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=P}),define(_e[130],ye([1,0,4,18,181]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(T){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=T}onEvent(T){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=T}onRequest(T){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=T}sendResponse(T){T.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.internalSend("response",T)}sendRequest(T,S,D,A){const k={command:T};if(S&&Object.keys(S).length>0&&(k.arguments=S),this.internalSend("request",k),typeof A=="number"){const E=setTimeout(()=>{clearTimeout(E);const _=this.pendingRequests.get(k.seq);if(_){this.pendingRequests.delete(k.seq);const w={type:"response",seq:0,request_seq:k.seq,success:!1,command:T,message:(0,I.localize)(0,null,A,T)};_(w)}},A)}return D&&this.pendingRequests.set(k.seq,D),k.seq}acceptMessage(T){this.messageCallback?this.messageCallback(T):(this.queue.push(T),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(T,S){return T.type!=="event"||S.type!=="event"}async processQueue(){let T;for(;this.queue.length;){if((!T||this.needsTaskBoundaryBetween(this.queue[0],T))&&await(0,t.timeout)(0),T=this.queue.shift(),!T)return;switch(T.type){case"event":this.eventCallback?.(T);break;case"request":this.requestCallback?.(T);break;case"response":{const S=T,D=this.pendingRequests.get(S.request_seq);D&&(this.pendingRequests.delete(S.request_seq),D(S));break}}}}internalSend(T,S){S.type=T,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const T=new Map;this.pendingRequests.forEach((S,D)=>T.set(D,S)),await(0,t.timeout)(500),T.forEach((S,D)=>{S({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(D)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(_e[215],ye([1,0,182,53,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:c.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:c.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:c.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:c.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:c.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:c.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:c.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:c.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:c.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:c.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:c.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:c.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:c.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:c.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:c.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:c.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:c.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:c.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:c.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:c.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:c.localize(20,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:c.localize(21,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:c.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:c.localize(23,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:c.localize(24,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:c.localize(25,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:c.localize(26,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:c.localize(27,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:c.localize(28,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:c.localize(29,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:c.localize(30,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:c.localize(31,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:c.localize(32,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:c.localize(33,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:c.localize(34,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:c.localize(35,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:c.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:c.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:c.localize(38,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:c.localize(39,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:c.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:c.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:c.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:c.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:c.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:c.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:c.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:c.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:c.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:c.localize(49,null)});const P=E=>c.localize(50,null,E);e.debuggerDisabledMessage=P,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:c.localize(51,null)};var y;(function(E){E[E.Inactive=0]="Inactive",E[E.Initializing=1]="Initializing",E[E.Stopped=2]="Stopped",E[E.Running=3]="Running"})(y=e.State||(e.State={}));function T(E){switch(E){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var S;(function(E){E[E.Valid=0]="Valid",E[E.Unreadable=1]="Unreadable",E[E.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var D;(function(E){E[E.Initial=1]="Initial",E[E.Dynamic=2]="Dynamic"})(D=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var A;(function(E){E.UnverifiedBreakpoints="unverifiedBreakpoints"})(A=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,I.createDecorator)("debugService");var k;(function(E){E[E.CONDITION=0]="CONDITION",E[E.HIT_COUNT=1]="HIT_COUNT",E[E.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(_e[216],ye([1,0,8,2,9,24,14]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function S(o,l,a){return o.replace(T,function(d,n){return l&&n.length>0&&n[0]!=="_"?d:a&&a.hasOwnProperty(n)?a[n]:d})}e.formatPII=S;function D(o){const l={};for(const a of Object.keys(o))a.startsWith("!")||(l[a]=o[a]);return l}e.filterExceptionsFromTelemetry=D;function A(o){return o.configuration.request==="attach"&&!k(o)&&(!o.parentSession||A(o.parentSession))}e.isSessionAttach=A;function k(o){let l=o.configuration.type;if(!!l)return l==="vslsShare"&&(l=o.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(l,"extensionhost")||(0,c.equalsIgnoreCase)(l,"pwa-extensionhost")?o:o.parentSession?k(o.parentSession):void 0}e.getExtensionHostDebugSession=k;function E(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=E;function _(o,l,a){let d,n=0;const i=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=i.exec(o);){const C=p.index+1,R=C+p[0].length;if(C<=l&&R>=a){d=p[0],n=C;break}}if(d){const C=/\w+/g;let R=null;for(;(R=C.exec(d))&&!(R.index+1+n+R[0].length>=a););R&&(d=d.substring(0,C.lastIndex))}return d?{start:n,end:n+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=_;const w=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function f(o){return!!(o&&o.match(w))}e.isUri=f;function g(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(f(o.path))return t.URI.parse(o.path);if((0,I.isAbsolute)(o.path))return t.URI.file(o.path)}return o.path}function h(o){if(typeof o.path=="object"){const l=t.URI.revive(o.path);if(l)return l.scheme===y.Schemas.file?l.fsPath:l.toString()}return o.path}function v(o,l){const a=l?g:h,d=(0,P.deepClone)(o);return r(d,(n,i)=>{n&&i&&(i.path=a(i))}),d}e.convertToDAPaths=v;function m(o,l){const a=l?g:h,d=(0,P.deepClone)(o);return r(d,(n,i)=>{!n&&i&&(i.path=a(i))}),d}e.convertToVSCPaths=m;function r(o,l){switch(o.type){case"event":{const a=o;switch(a.event){case"output":l(!1,a.body.source);break;case"loadedSource":l(!1,a.body.source);break;case"breakpoint":l(!1,a.body.breakpoint.source);break;default:break}break}case"request":{const a=o;switch(a.command){case"setBreakpoints":l(!0,a.arguments.source);break;case"breakpointLocations":l(!0,a.arguments.source);break;case"source":l(!0,a.arguments.source);break;case"gotoTargets":l(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(d=>l(!1,d));break;default:break}break}case"response":{const a=o;if(a.success&&a.body)switch(a.command){case"stackTrace":a.body.stackFrames.forEach(d=>l(!1,d.source));break;case"loadedSources":a.body.sources.forEach(d=>l(!1,d));break;case"scopes":a.body.scopes.forEach(d=>l(!1,d.source));break;case"setFunctionBreakpoints":a.body.breakpoints.forEach(d=>l(!1,d.source));break;case"setBreakpoints":a.body.breakpoints.forEach(d=>l(!1,d.source));break;case"disassemble":a.body?.instructions.forEach(n=>l(!1,n.location));break;default:break}break}}}function b(o){return o.filter(l=>!l.presentation?.hidden).sort((l,a)=>l.presentation?a.presentation?l.presentation.group?a.presentation.group?l.presentation.group!==a.presentation.group?l.presentation.group.localeCompare(a.presentation.group):s(l.presentation.order,a.presentation.order):-1:a.presentation.group?1:s(l.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=b;function s(o,l){return typeof o!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:o-l}async function u(o,l){const a=o.getValue("debug.saveBeforeStart",{overrideIdentifier:l.activeTextEditorLanguageId});if(a!=="none"&&(await l.saveAll(),a==="allEditorsInActiveGroup")){const d=l.activeEditorPane;d&&d.input.resource?.scheme===y.Schemas.untitled&&await l.save({editor:d.input,groupId:d.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(_e[217],ye([1,0,44,218,24,9,12,8,29,183,130]),function(Z,e,c,t,I,P,y,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends A.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(h,v){this.outputStream=v,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,h.on("data",m=>this.handleData(m))}sendMessage(h){if(this.outputStream){const v=JSON.stringify(h);this.outputStream.write(`Content-Length: ${Buffer.byteLength(v,"utf8")}${k.TWO_CRLF}${v}`,"utf8")}}handleData(h){for(this.rawData=Buffer.concat([this.rawData,h]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const v=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,v.length>0)try{this.acceptMessage(JSON.parse(v))}catch(m){this._onError.fire(new Error((m.message||m)+`
`+v))}continue}}else{const v=this.rawData.indexOf(k.TWO_CRLF);if(v!==-1){const r=this.rawData.toString("utf8",0,v).split(k.HEADER_LINESEPARATOR);for(const b of r){const s=b.split(k.HEADER_FIELDSEPARATOR);s[0]==="Content-Length"&&(this.contentLength=Number(s[1]))}this.rawData=this.rawData.slice(v+k.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=k,k.TWO_CRLF=`\r
\r
`,k.HEADER_LINESEPARATOR=/\r?\n/,k.HEADER_FIELDSEPARATOR=/: */;class E extends k{startSession(){return new Promise((h,v)=>{let m=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),h(),m=!0}),this.socket.on("close",()=>{m?this._onError.fire(new Error("connection closed")):v(new Error("connection closed"))}),this.socket.on("error",r=>{m?this._onError.fire(r):v(r)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class _ extends E{constructor(h){super(),this.adapterServer=h}createConnection(h){return t.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",h)}}e.SocketDebugAdapter=_;class w extends E{constructor(h){super(),this.adapterServer=h}createConnection(h){return t.createConnection(this.adapterServer.path,h)}}e.NamedPipeDebugAdapter=w;class f extends k{constructor(h,v){super(),this.adapterExecutable=h,this.debugType=v}async startSession(){const h=this.adapterExecutable.command,v=this.adapterExecutable.args,m=this.adapterExecutable.options||{};try{if(h)if(P.isAbsolute(h)){if(!await S.Promises.exists(h))throw new Error(D.localize(0,null,h))}else h.indexOf("/")<0&&h.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let r=process.env;if(m.env&&Object.keys(m.env).length>0&&(r=I.mixin(I.deepClone(process.env),m.env)),h==="node")if(Array.isArray(v)&&v.length>0){const b=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:r,execArgv:b?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};m.cwd&&(s.cwd=m.cwd);const u=c.fork(v[0],v.slice(1),s);if(!u.pid)throw new Error(D.localize(2,null,v[0]));this.serverProcess=u}else throw new Error(D.localize(3,null));else{const b={env:r};m.cwd&&(b.cwd=m.cwd),this.serverProcess=c.spawn(h,v,b)}this.serverProcess.on("error",b=>{this._onError.fire(b)}),this.serverProcess.on("exit",(b,s)=>{this._onExit.fire(b)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",b=>{this._onError.fire(b)}),this.serverProcess.stdin.on("error",b=>{this._onError.fire(b)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(r){this._onError.fire(r)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),y.isWindows?new Promise((h,v)=>{const m=c.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(r,b,s){if(r)return v(r)});m.on("exit",h),m.on("error",v)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(h,v){if(!h)return;const m=Object.create(null);h.runtime&&(h.runtime.indexOf("./")===0?m.runtime=P.join(v,h.runtime):m.runtime=h.runtime),h.runtimeArgs&&(m.runtimeArgs=h.runtimeArgs),h.program&&(P.isAbsolute(h.program)?m.program=h.program:m.program=P.join(v,h.program)),h.args&&(m.args=h.args);const r=h;return r.win&&(m.win=f.extract(r.win,v)),r.winx86&&(m.winx86=f.extract(r.winx86,v)),r.windows&&(m.windows=f.extract(r.windows,v)),r.osx&&(m.osx=f.extract(r.osx,v)),r.linux&&(m.linux=f.extract(r.linux,v)),m}static platformAdapterExecutable(h,v){let m=Object.create(null);v=v.toLowerCase();for(const l of h)if(l.contributes){const a=l.contributes.debuggers;a&&a.length>0&&a.filter(d=>typeof d.type=="string"&&T.equalsIgnoreCase(d.type,v)).forEach(d=>{const n=f.extract(d,l.extensionLocation.fsPath);m=I.mixin(m,n,l.isBuiltin)})}let r;y.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=m.winx86||m.win||m.windows:y.isWindows?r=m.win||m.windows:y.isMacintosh?r=m.osx:y.isLinux&&(r=m.linux),r=r||m;const b=r.program||m.program,s=r.args||m.args,u=r.runtime||m.runtime,o=r.runtimeArgs||m.runtimeArgs;if(u)return{type:"executable",command:u,args:(o||[]).concat(typeof b=="string"?[b]:[]).concat(s||[])};if(b)return{type:"executable",command:b,args:s||[]}}}e.ExecutableDebugAdapter=f}),define(_e[219],ye([1,0,44,32,12]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(D,A){return new Promise((k,E)=>{let _="";const w=c.spawn(D,A);w.pid&&w.stdout.on("data",f=>{_+=f.toString()}),w.on("error",f=>{E(f)}),w.on("close",f=>{k(_)})})}async function y(D){if(D)if(I.isWindows){const A=await new Promise((k,E)=>{Z(["windows-process-tree"],k,E)});return new Promise(k=>{A.getProcessTree(D,E=>{k(!!E&&E.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(D)]).then(A=>{const k=A.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.hasChildProcesses=y;var T;(function(D){D[D.cmd=0]="cmd",D[D.powershell=1]="powershell",D[D.bash=2]="bash"})(T||(T={}));function S(D,A,k,E,_){D=D.trim().toLowerCase();let w;D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0?w=1:D.indexOf("cmd.exe")>=0?w=0:D.indexOf("bash")>=0?w=2:I.isWindows?w=0:w=2;let f,g=" ";switch(w){case 1:if(f=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),E){const h=(0,t.getDriveLetter)(E);h&&(g+=`${h}:; `),g+=`cd ${f(E)}; `}if(_)for(const h in _){const v=_[h];v===null?g+=`Remove-Item env:${h}; `:g+=`\${env:${h}}='${v}'; `}if(A.length>0){const h=A.shift(),v=k?h:f(h);g+=v[0]==="'"?`& ${v} `:`${v} `;for(const m of A)g+=m==="<"||m===">"||k?m:f(m),g+=" "}break;case 0:if(f=h=>(h=h.replace(/\"/g,'""'),h=h.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(v=>h.includes(v))||h.length===0?`"${h}"`:h),E){const h=(0,t.getDriveLetter)(E);h&&(g+=`${h}: && `),g+=`cd ${f(E)} && `}if(_){g+='cmd /C "';for(const h in _){let v=_[h];v===null?g+=`set "${h}=" && `:(v=v.replace(/[&^|<>]/g,m=>`^${m}`),g+=`set "${h}=${v}" && `)}}for(const h of A)g+=h==="<"||h===">"||k?h:f(h),g+=" ";_&&(g+='"');break;case 2:{f=v=>(v=v.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),v.length===0?'""':v);const h=v=>/[^\w@%\/+=,.:^-]/.test(v)?`'${v.replace(/'/g,"'\\''")}'`:v;if(E&&(g+=`cd ${f(E)} ; `),_){g+="/usr/bin/env";for(const v in _){const m=_[v];m===null?g+=` -u ${h(v)}`:g+=` ${h(`${v}=${m}`)}`}g+=" "}for(const v of A)g+=v==="<"||v===">"||k?v:f(v),g+=" ";break}}return g}e.prepareCommand=S}),define(_e[90],ye([1,0,23,37,62,105,14,9,12,53]),function(Z,e,c,t,I,P,y,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var A;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.latex,P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.latex,P.Mimes.markdown,"application/json",P.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var E;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(E=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(_=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var w;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(w=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var v;(function(B){B.scheme=y.Schemas.vscodeNotebookCell;const N=["W","X","Y","Z","a","b","c","d","e","f"],z=new RegExp(`^[${N.join("")}]+`),j=7;function x(Y,pe){const be=pe.toString(j),Re=`${be.length<N.length?N[be.length-1]:"z"}${be}s${(0,c.encodeBase64)(c.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:B.scheme,fragment:Re})}B.generate=x;function Q(Y){if(Y.scheme!==B.scheme)return;const pe=Y.fragment.indexOf("s");if(pe<0)return;const be=parseInt(Y.fragment.substring(0,pe).replace(z,""),j),Ce=(0,c.decodeBase64)(Y.fragment.substring(pe+1)).toString();if(!isNaN(be))return{handle:be,notebook:Y.with({scheme:Ce,fragment:null})}}B.parse=Q;function K(Y,pe){return Y.with({scheme:y.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${Y.scheme!==y.Schemas.file?Y.scheme:""}`})}B.generateCellOutputUri=K;function le(Y){if(Y.scheme!==y.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!pe)return;const be=pe[1]&&pe[1]!==""?pe[1]:void 0,Ce=pe[2];return{outputId:be,notebook:Y.with({scheme:Ce||y.Schemas.file,fragment:null})}}B.parseCellOutputUri=le;function ie(Y,pe,be){return B.generate(Y,pe).with({scheme:be})}B.generateCellPropertyUri=ie;function de(Y,pe){if(Y.scheme===pe)return B.parse(Y.with({scheme:B.scheme}))}B.parseCellPropertyUri=de})(v=e.CellUri||(e.CellUri={}));const m=B=>S.isWindows?B.replace(/\//g,"\\"):B;class r{constructor(N=[],z=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=z,this.order=[...new Set(N)].map(j=>({pattern:j,matches:t.parse(m(j))}))}sort(N){const z=new Map(I.Iterable.map(N,x=>[x,m(x)]));let j=[];for(const{matches:x}of this.order)for(const[Q,K]of z)if(x(K)){j.push(Q),z.delete(Q);break}return z.size&&(j=j.concat([...z.keys()].sort((x,Q)=>this.defaultOrder.indexOf(x)-this.defaultOrder.indexOf(Q)))),j}prioritize(N,z){const j=this.findIndex(N);if(j===-1){this.order.unshift({pattern:N,matches:t.parse(m(N))});return}const x=new Set(z.map(K=>this.findIndex(K,j)));x.delete(-1);const Q=Array.from(x).sort();this.order.splice(j+1,0,...Q.map(K=>this.order[K]));for(let K=Q.length-1;K>=0;K--)this.order.splice(Q[K],1)}toArray(){return this.order.map(N=>N.pattern)}findIndex(N,z=this.order.length){const j=m(N);for(let x=0;x<z;x++)if(this.order[x].matches(j))return x;return-1}}e.MimeTypeDisplayOrder=r;function b(B,N,z,j=(x,Q)=>x===Q){const x=[];function Q(ie,de,Y){if(de===0&&Y.length===0)return;const pe=x[x.length-1];pe&&pe.start+pe.deleteCount===ie?(pe.deleteCount+=de,pe.toInsert.push(...Y)):x.push({start:ie,deleteCount:de,toInsert:Y})}let K=0,le=0;for(;;){if(K===B.length){Q(K,0,N.slice(le));break}if(le===N.length){Q(K,B.length-K,[]);break}const ie=B[K],de=N[le];if(j(ie,de)){K+=1,le+=1;continue}z(de)?(Q(K,1,[]),K+=1):(Q(K,0,[de]),le+=1)}return x}e.diff=b,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(B){B.default="default",B.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(B){const N=B;return!!((typeof N.include=="string"||t.isRelativePattern(N.include))&&(typeof N.exclude=="string"||t.isRelativePattern(N.exclude)))}e.isDocumentExcludePattern=u;function o(B,N,z){if(Array.isArray(B.viewType)&&B.viewType.indexOf(N)>=0||B.viewType===N)return!0;if(B.filenamePattern){const j=u(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,x=u(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(t.match(j,(0,T.basename)(z.fsPath).toLowerCase()))return!(x&&t.match(x,(0,T.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var l;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class a{static create(N){return`${a._prefix}${N}`}static parse(N){if(N.startsWith(a._prefix))return N.substring(a._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=a,a._prefix="notebook/";function d(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=d;const n=new TextDecoder;function i(B){const N=[];let z=!1;for(const j of B)(N.length===0||z)&&(N.push(j),z=!0);return U(N),F(c.VSBuffer.concat(N.map(j=>c.VSBuffer.wrap(j))))}e.compressOutputItemStreams=i;const p=`${String.fromCharCode(27)}[A`,C=p.split("").map(B=>B.charCodeAt(0)),R=10;function U(B){B.forEach((N,z)=>{if(z===0||N.length<p.length)return;const j=B[z-1],x=N.subarray(0,p.length);if(x[0]===C[0]&&x[1]===C[1]&&x[2]===C[2]){const Q=j.lastIndexOf(R);if(Q===-1)return;B[z-1]=j.subarray(0,Q),B[z]=N.subarray(p.length)}})}function H(B){let N=B;do B=N,N=B.replace(/[^\n]\x08/gm,"");while(N.length<B.length);return B}function V(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const N=B.match(/^(.*)\r+/m)[1];let z=B.match(/\r+(.*)$/m)[1];z=z+N.slice(z.length,N.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,z)}return B}const L="\b".charCodeAt(0),M="\r".charCodeAt(0);function F(B){return!B.buffer.includes(L)&&!B.buffer.includes(M)?B:c.VSBuffer.fromString(V(H(n.decode(B.buffer))))}}),define(_e[220],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(_e[221],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=c;function t(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=t;function I(y){return Array.from(y.entries()).map(T=>[T[0],c(T[1].map)])}e.serializeEnvironmentVariableCollections=I;function P(y){return new Map(y.map(T=>[T[0],{map:t(T[1])}]))}e.deserializeEnvironmentVariableCollections=P}),define(_e[56],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(P){P.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{static fromExtHostTestItem(y,T,S=y.parent){if(y._isRoot)return new I([T]);const D=[y.id];for(let A=S;A&&A.id!==T;A=A.parent)D.push(A.id);return D.push(T),new I(D.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const T=y.indexOf("\0");return T===-1?y:y.slice(0,T)}static fromString(y){return new I(y.split("\0"))}static join(y,T){return new I([...y.path,T])}static joinToString(y,T){return y.toString()+"\0"+T}static parentId(y){const T=y.lastIndexOf("\0");return T===-1?void 0:y.slice(0,T)}static compare(y,T){return y===T?0:T.startsWith(y+"\0")?2:y.startsWith(T+"\0")?3:1}constructor(y,T=y.length){if(this.path=y,this.viewEnd=T,y.length===0||T<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let y=1;y<=this.viewEnd;y++)yield new I(this.path,y)}*idsToRoot(){for(let y=this.viewEnd;y>0;y--)yield new I(this.path,y)}compare(y){if(typeof y=="string")return I.compare(this.toString(),y);for(let T=0;T<y.viewEnd&&T<this.viewEnd;T++)if(y.path[T]!==this.path[T])return 1;return y.viewEnd>this.viewEnd?2:y.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let y=1;y<this.viewEnd;y++)this.stringifed+="\0",this.stringifed+=this.path[y]}return this.stringifed}}e.TestId=I}),define(_e[67],ye([1,0,2,35,56]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var P;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(P=e.TestResultState||(e.TestResultState={}));var y;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(y=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var T;(function(n){n.serialize=i=>({range:i.range.toJSON(),uri:i.uri.toJSON()}),n.deserialize=i=>({range:t.Range.lift(i.range),uri:c.URI.revive(i.uri)})})(T=e.IRichLocation||(e.IRichLocation={}));var S;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var D;(function(n){n.serialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&T.serialize(i.location)}),n.deserialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&T.deserialize(i.location)})})(D=e.ITestErrorMessage||(e.ITestErrorMessage={}));const A=(n,i)=>`${i?"s":"e"}${n}`;e.getMarkId=A;var k;(function(n){n.serialize=i=>({message:i.message,type:1,offset:i.offset,length:i.length,location:i.location&&T.serialize(i.location)}),n.deserialize=i=>({message:i.message,type:1,offset:i.offset,length:i.length,location:i.location&&T.deserialize(i.location)})})(k=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(n){n.serialize=i=>i.type===0?D.serialize(i):k.serialize(i),n.deserialize=i=>i.type===0?D.deserialize(i):k.deserialize(i)})(E=e.ITestMessage||(e.ITestMessage={}));var _;(function(n){n.serializeWithoutMessages=i=>({state:i.state,duration:i.duration,messages:[]}),n.serialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(E.serialize)}),n.deserialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(E.deserialize)})})(_=e.ITestTaskState||(e.ITestTaskState={}));const w="\0",f=(n,i)=>n+w+i;e.namespaceTestTag=f;const g=n=>{const i=n.indexOf(w);return{ctrlId:n.slice(0,i),tagId:n.slice(i+1)}};e.denamespaceTestTag=g;var h;(function(n){n.serialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?.toJSON(),range:i.range?.toJSON()||null,description:i.description,error:i.error,sortText:i.sortText}),n.deserialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?c.URI.revive(i.uri):void 0,range:i.range?t.Range.lift(i.range):null,description:i.description,error:i.error,sortText:i.sortText})})(h=e.ITestItem||(e.ITestItem={}));var v;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var m;(function(n){n.serialize=i=>({expand:i.expand,item:h.serialize(i.item)}),n.deserialize=i=>({controllerId:I.TestId.root(i.item.extId),expand:i.expand,item:h.deserialize(i.item)})})(m=e.InternalTestItem||(e.InternalTestItem={}));var r;(function(n){n.serialize=i=>{let p;return i.item&&(p={},i.item.label!==void 0&&(p.label=i.item.label),i.item.tags!==void 0&&(p.tags=i.item.tags),i.item.busy!==void 0&&(p.busy=i.item.busy),i.item.uri!==void 0&&(p.uri=i.item.uri?.toJSON()),i.item.range!==void 0&&(p.range=i.item.range?.toJSON()),i.item.description!==void 0&&(p.description=i.item.description),i.item.error!==void 0&&(p.error=i.item.error),i.item.sortText!==void 0&&(p.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:p}},n.deserialize=i=>{let p;return i.item&&(p={},i.item.label!==void 0&&(p.label=i.item.label),i.item.tags!==void 0&&(p.tags=i.item.tags),i.item.busy!==void 0&&(p.busy=i.item.busy),i.item.range!==void 0&&(p.range=i.item.range?t.Range.lift(i.item.range):null),i.item.description!==void 0&&(p.description=i.item.description),i.item.error!==void 0&&(p.error=i.item.error),i.item.sortText!==void 0&&(p.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:p}}})(r=e.ITestItemUpdate||(e.ITestItemUpdate={}));const b=(n,i)=>{i.expand!==void 0&&(n.expand=i.expand),i.item!==void 0&&(n.item=n.item?Object.assign(n.item,i.item):i.item)};e.applyTestItemUpdate=b;var s;(function(n){n.serializeWithoutMessages=i=>({...m.serialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(_.serializeWithoutMessages),retired:i.retired}),n.serialize=i=>({...m.serialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(_.serialize),retired:i.retired}),n.deserialize=i=>({...m.deserialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(_.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var u;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(u=e.DetailType||(e.DetailType={}));var o;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(n){n.deserialize=i=>i.op===0?{op:i.op,item:m.deserialize(i.item)}:i.op===1?{op:i.op,item:r.deserialize(i.item)}:i.op===2?{op:i.op,uri:c.URI.revive(i.uri),docv:i.docv}:i,n.serialize=i=>i.op===0?{op:i.op,item:m.serialize(i.item)}:i.op===1?{op:i.op,item:r.serialize(i.item)}:i})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class a{add(i){}update(i){}remove(i,p){}complete(){}}e.IncrementalChangeCollector=a;class d{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const p=this.createChangeCollector();for(const C of i)switch(C.op){case 0:{const R=m.deserialize(C.item),U=I.TestId.parentId(R.item.extId)?.toString();if(U){if(this.items.has(U)){const H=this.items.get(U);H.children.add(R.item.extId);const V=this.createItem(R,H);this.items.set(R.item.extId,V),p.add(V)}}else{const H=this.createItem(R);this.roots.add(H),this.items.set(R.item.extId,H),p.add(H)}R.expand===2&&this.busyControllerCount++;break}case 1:{const R=r.deserialize(C.item),U=this.items.get(R.extId);if(!U)break;R.expand!==void 0&&(U.expand===2&&this.busyControllerCount--,R.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(U,R),p.update(U);break}case 3:{const R=this.items.get(C.itemId);if(!R)break;const U=I.TestId.parentId(R.item.extId)?.toString();U?this.items.get(U).children.delete(R.item.extId):this.roots.delete(R);const H=[[C.itemId]];for(;H.length;)for(const V of H.pop()){const L=this.items.get(V);L&&(H.push(L.children),this.items.delete(V),p.remove(L,L!==R),L.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(C.itemId);break;case 4:this.updatePendingRoots(C.amount);break;case 6:this._tags.set(C.tag.id,C.tag);break;case 7:this._tags.delete(C.id);break}p.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new a}}e.AbstractIncrementalTestCollection=d}),define(_e[91],ye([1,0,18,4,6,48,67,56]),function(Z,e,c,t,I,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const D=(h,v)=>h===v,A={range:(h,v)=>h===v?!0:!h||!v?!1:h.equalsRange(v),busy:D,label:D,description:D,error:D,tags:(h,v)=>!(h.length!==v.length||h.some(m=>!v.includes(m)))},k=(h,v)=>{let m;for(const[r,b]of Object.entries(A))b(h[r],v[r])||(m?m[r]=v[r]:m={[r]:v[r]});return m};class E extends I.Disposable{get root(){return this.options.root}constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(v){this._resolveHandler=v;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){switch(v.op){case 2:{for(const m of this.diff)if(m.op===2&&m.uri===v.uri){m.docv=v.docv;return}break}case 1:{const m=this.diff[this.diff.length-1];if(m){if(m.op===1&&m.item.extId===v.item.extId){(0,y.applyTestItemUpdate)(m.item,v.item);return}if(m.op===0&&m.item.item.extId===v.item.extId){(0,y.applyTestItemUpdate)(m.item,v.item);return}}break}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,m){const r=this.tree.get(v);if(!!r){if((r.expandLevels===void 0||m>r.expandLevels)&&(r.expandLevels=m),r.expand===1){const b=this.resolveChildren(r);return b.isOpen()?this.expandChildren(r,m-1):b.wait().then(()=>this.expandChildren(r,m-1))}else if(r.expand===3)return r.resolveBarrier?.isOpen()===!1?r.resolveBarrier.wait().then(()=>this.expandChildren(r,m-1)):this.expandChildren(r,m-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,m){switch(m.op){case 3:this.removeItem(T.TestId.joinToString(v.fullId,m.id));break;case 0:this.upsertItem(m.item,v);break;case 5:for(const r of m.ops)this.onTestItemEvent(v,r);break;case 1:this.diffTagRefs(m.new,m.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:m.update}});break;case 6:this.documentSynced(v.actual.uri);break;default:(0,P.assertNever)(m)}}documentSynced(v){v&&this.pushDiff({op:2,uri:v,docv:this.options.getDocumentVersion(v)})}upsertItem(v,m){const r=T.TestId.fromExtHostTestItem(v,this.root.id,m?.actual),b=this.options.getApiFor(v);b.parent&&b.parent!==m?.actual&&this.options.getChildren(b.parent).delete(v.id);let s=this.tree.get(r.toString());if(!s){s={fullId:r,actual:v,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(s.fullId.toString(),s),this.setItemParent(v,m),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:s.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,s,m);return}if(s.actual===v){this.connectItem(v,s,m);return}const u=this.options.getChildren(s.actual),o=s.actual,l=k(this.options.toITestItem(o),this.options.toITestItem(v));this.options.getApiFor(o).listener=void 0,s.actual=v,s.expand=0,l&&(l.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,o.tags,r.toString()),delete l.tags),this.onTestItemEvent(s,{op:4,update:l})),this.connectItemAndChildren(v,s,m);for(const[a,d]of u)this.options.getChildren(v).get(d.id)||this.removeItem(T.TestId.joinToString(r,d.id));this.documentSynced(s.actual.uri)}diffTagRefs(v,m,r){const b=new Set(m.map(s=>s.id));for(const s of v)b.delete(s.id)||this.incrementTagRefs(s);this.pushDiff({op:1,item:{extId:r,item:{tags:v.map(s=>(0,y.namespaceTestTag)(this.options.controllerId,s.id))}}}),b.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const m=this.tags.get(v.id);m?m.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,y.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const m=this.tags.get(v);m&&!--m.refCount&&(this.tags.delete(v),this.pushDiff({op:7,id:(0,y.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,m){this.options.getApiFor(v).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(v,m,r){this.setItemParent(v,r);const b=this.options.getApiFor(v);b.parent=r?.actual,b.listener=s=>this.onTestItemEvent(m,s),this.updateExpandability(m)}connectItemAndChildren(v,m,r){this.connectItem(v,m,r);for(const[b,s]of this.options.getChildren(v))this.upsertItem(s,m)}updateExpandability(v){let m;this._resolveHandler?v.resolveBarrier?m=v.resolveBarrier.isOpen()?3:2:m=v.actual.canResolveChildren?1:0:m=0,m!==v.expand&&(v.expand=m,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:m}}),m===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,m){if(m<0)return;const r=[];for(const[b,s]of this.options.getChildren(v.actual)){const u=this.expand(T.TestId.joinToString(v.fullId,s.id),m);(0,c.isThenable)(u)&&r.push(u)}if(r.length)return Promise.all(r).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const s=new c.Barrier;return s.open(),s}v.expand=2,this.pushExpandStateUpdate(v);const m=v.resolveBarrier=new c.Barrier,r=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,s)};let b;try{b=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(s){r(s)}return(0,c.isThenable)(b)?b.catch(r).then(()=>{m.open(),this.updateExpandability(v)}):(m.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const m=this.tree.get(v);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const r=[m];for(;r.length;){const b=r.pop();if(!!b){this.options.getApiFor(b.actual).listener=void 0;for(const s of b.actual.tags)this.decrementTagRefs(s.id);this.tree.delete(b.fullId.toString());for(const[s,u]of this.options.getChildren(b.actual))r.push(this.tree.get(T.TestId.joinToString(b.fullId,u.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=E;class _ extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=_;class w extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=w;class f extends Error{constructor(v,m,r){super(`TestItem with ID "${v}" is from controller "${m}" and cannot be added as a child of an item from controller "${r}".`)}}e.MixedTestItemController=f;const g=(h,v,m)=>{let r=new Map;return{get size(){return r.size},forEach(b,s){for(const u of r.values())b.call(s,u,this)},[Symbol.iterator](){return r.entries()},replace(b){const s=new Map,u=new Set(r.keys()),o={op:5,ops:[]};for(const l of b){if(!(l instanceof m))throw new w(l.id);const a=v(l).controllerId;if(a!==h.controllerId)throw new f(l.id,a,h.controllerId);if(s.has(l.id))throw new _(l.id);s.set(l.id,l),u.delete(l.id),o.ops.push({op:0,item:l})}for(const l of u.keys())o.ops.push({op:3,id:l});h.listener?.(o),r=s},add(b){if(!(b instanceof m))throw new w(b.id);r.set(b.id,b),h.listener?.({op:0,item:b})},delete(b){r.delete(b)&&h.listener?.({op:3,id:b})},get(b){return r.get(b)},toJSON(){return Array.from(r.values())}}};e.createTestItemChildren=g}),define(_e[131],ye([1,0,91]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,I=(y,T)=>{const S={controllerId:T};return t.set(y,S),S};e.createPrivateApiFor=I;const P=y=>{const T=t.get(y);if(!T)throw new c.InvalidTestItemError(y?.id||"<unknown>");return T};e.getPrivateApiFor=P}),define(_e[222],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var t;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class I extends Error{constructor(y,T){super(T),this.variable=y}}e.VariableError=I}),define(_e[223],ye([1,0,9,36,11,24,12,111,186,222,8]),function(Z,e,c,t,I,P,y,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(_,w,f,g){this._contributedVariables=new Map,this._context=_,this._labelService=w,this._userHomePromise=f,g&&(this._envVariablesPromise=g.then(h=>this.prepareEnv(h)))}prepareEnv(_){if(y.isWindows){const w=Object.create(null);return Object.keys(_).forEach(f=>{w[f.toLowerCase()]=_[f]}),w}return _}resolveWithEnvironment(_,w,f){return this.recursiveResolve({env:this.prepareEnv(_),userHome:void 0},w?w.uri:void 0,f)}async resolveAsync(_,w){const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,_?_.uri:void 0,w)}async resolveAnyBase(_,w,f,g){const h=P.deepClone(w);y.isWindows&&h.windows?Object.keys(h.windows).forEach(m=>h[m]=h.windows[m]):y.isMacintosh&&h.osx?Object.keys(h.osx).forEach(m=>h[m]=h.osx[m]):y.isLinux&&h.linux&&Object.keys(h.linux).forEach(m=>h[m]=h.linux[m]),delete h.windows,delete h.osx,delete h.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,_?_.uri:void 0,h,f,g)}async resolveAnyAsync(_,w,f){return this.resolveAnyBase(_,w,f)}async resolveAnyMap(_,w,f){const g=new Map;return{newConfig:await this.resolveAnyBase(_,w,f,g),resolvedVariables:g}}resolveWithInteractionReplace(_,w,f,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,w,f,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,w){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,w)}async recursiveResolve(_,w,f,g,h){if(I.isString(f))return this.resolveString(_,w,f,g,h);if(Array.isArray(f))return Promise.all(f.map(v=>this.recursiveResolve(_,w,v,g,h)));if(I.isObject(f)){const v=Object.create(null),m=await Promise.all(Object.keys(f).map(async r=>[await this.resolveString(_,w,r,g,h),await this.recursiveResolve(_,w,f[r],g,h)]));for(const[r,b]of m)v[r]=b;return v}return f}resolveString(_,w,f,g,h){return(0,A.replaceAsync)(f,k.VARIABLE_REGEXP,async(v,m)=>{if(m.includes(k.VARIABLE_LHS))return v;let r=await this.evaluateSingleVariable(_,v,m,w,g);return h?.set(m,r),r!==v&&I.isString(r)&&r.match(k.VARIABLE_REGEXP)&&(r=await this.resolveString(_,w,r,g,h)),r})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}async evaluateSingleVariable(_,w,f,g,h){let v;const m=f.split(":");m.length>1&&(f=m[0],v=m[1]);const r=u=>{const o=this._context.getFilePath();if(o)return o;throw new D.VariableError(u,(0,S.localize)(0,null,w))},b=u=>{const o=r(u);if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new D.VariableError(u,(0,S.localize)(1,null,w,c.basename(o)))},s=u=>{if(v){const o=this._context.getFolderUri(v);if(o)return o;throw new D.VariableError(u,(0,S.localize)(2,null,w,v))}if(g)return g;throw this._context.getWorkspaceFolderCount()>1?new D.VariableError(u,(0,S.localize)(3,null,w)):new D.VariableError(u,(0,S.localize)(4,null,w))};switch(f){case"env":if(v){if(_.env){const u=_.env[y.isWindows?v.toLowerCase():v];if(I.isString(u))return u}return""}throw new D.VariableError(D.VariableKind.Env,(0,S.localize)(5,null,w));case"config":if(v){const u=this._context.getConfigurationValue(g,v);if(I.isUndefinedOrNull(u))throw new D.VariableError(D.VariableKind.Config,(0,S.localize)(6,null,w,v));if(I.isObject(u))throw new D.VariableError(D.VariableKind.Config,(0,S.localize)(7,null,w,v));return u}throw new D.VariableError(D.VariableKind.Config,(0,S.localize)(8,null,w));case"command":return this.resolveFromMap(D.VariableKind.Command,w,v,h,"command");case"input":return this.resolveFromMap(D.VariableKind.Input,w,v,h,"input");case"extensionInstallFolder":if(v){const u=await this._context.getExtension(v);if(!u)throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,w,v));return this.fsPath(u.extensionLocation)}throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,w));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.fsPath(s(D.VariableKind.WorkspaceFolder)));case"cwd":return g||v?(0,T.normalizeDriveLetter)(this.fsPath(s(D.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return c.basename(this.fsPath(s(D.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(_.userHome)return _.userHome;throw new D.VariableError(D.VariableKind.UserHome,(0,S.localize)(11,null,w))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new D.VariableError(D.VariableKind.LineNumber,(0,S.localize)(12,null,w))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new D.VariableError(D.VariableKind.SelectedText,(0,S.localize)(13,null,w))}case"file":return r(D.VariableKind.File);case"fileWorkspaceFolder":return b(D.VariableKind.FileWorkspaceFolder);case"relativeFile":return g||v?c.relative(this.fsPath(s(D.VariableKind.RelativeFile)),r(D.VariableKind.RelativeFile)):r(D.VariableKind.RelativeFile);case"relativeFileDirname":{const u=c.dirname(r(D.VariableKind.RelativeFileDirname));if(g||v){const o=c.relative(this.fsPath(s(D.VariableKind.RelativeFileDirname)),u);return o.length===0?".":o}return u}case"fileDirname":return c.dirname(r(D.VariableKind.FileDirname));case"fileExtname":return c.extname(r(D.VariableKind.FileExtname));case"fileBasename":return c.basename(r(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=c.basename(r(D.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-c.extname(u).length)}case"fileDirnameBasename":return c.basename(c.dirname(r(D.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||w}case"execInstallFolder":{const u=this._context.getAppRoot();return u||w}case"pathSeparator":return c.sep;default:try{const u=v?`${f}:${v}`:f;return this.resolveFromMap(D.VariableKind.Unknown,w,u,h,void 0)}catch{return w}}}}resolveFromMap(_,w,f,g,h){if(f&&g){const v=h===void 0?g[f]:g[h+":"+f];if(typeof v=="string")return v;throw new D.VariableError(_,(0,S.localize)(14,null,w))}return w}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(_e[132],ye([1,0,3,129]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var I;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var P;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var T;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function D(w){const f=w;return(0,t.isEditorInput)(f?.editor)&&(0,t.isEditorInput)(f?.replacement)}e.isEditorReplacement=D;var A;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function E(w){const f=w;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.isEditorGroup=E;function _(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=_}),define(_e[224],ye([1,0,3,132]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(P){const y=P;return typeof P=="number"||(0,t.isEditorGroup)(y)}e.isPreferredGroup=I}),define(_e[225],ye([1,0,3,191]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(t.IEnvironmentService)}),define(_e[226],ye([1,0,26,4,9]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(k){this.removedDueToLooping=k}}e.DeltaExtensionsResult=P;class y{constructor(k){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=k,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const k of this._extensionDescriptions){if(this._extensionsMap.has(c.ExtensionIdentifier.toKey(k.identifier))){console.error("Extension `"+k.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(c.ExtensionIdentifier.toKey(k.identifier),k),this._extensionsArr.push(k),Array.isArray(k.activationEvents))for(let E of k.activationEvents)E==="onUri"&&(E=`onUri:${c.ExtensionIdentifier.toKey(k.identifier)}`),this._activationMap.has(E)||this._activationMap.set(E,[]),this._activationMap.get(E).push(k)}}set(k){this._extensionDescriptions=k,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(k,E){this._extensionDescriptions=D(this._extensionDescriptions,E),this._extensionDescriptions=this._extensionDescriptions.concat(k);const _=y._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=D(this._extensionDescriptions,_.map(w=>w.identifier)),this._initialize(),this._onDidChange.fire(void 0),new P(_)}static _findLoopingExtensions(k){const E=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(h){this._nodesSet.has(h)||(this._nodesSet.add(h),this._nodesArr.push(h))}addArc(h,v){this.addNode(h),this.addNode(v),this._arcs.has(h)?this._arcs.get(h).push(v):this._arcs.set(h,[v])}getArcs(h){return this._arcs.has(h)?this._arcs.get(h):[]}hasOnlyGoodArcs(h,v){const m=E.getArcs(h);for(let r=0;r<m.length;r++)if(!v.has(m[r]))return!1;return!0}getNodes(){return this._nodesArr}},_=new Map;for(const h of k){const v=c.ExtensionIdentifier.toKey(h.identifier);if(_.set(v,h),h.extensionDependencies)for(const m of h.extensionDependencies){const r=c.ExtensionIdentifier.toKey(m);E.addArc(v,r)}}const w=new Set;E.getNodes().filter(h=>E.getArcs(h).length===0).forEach(h=>w.add(h));const f=E.getNodes().filter(h=>!w.has(h));let g;do{g=!1;for(let h=0;h<f.length;h++){const v=f[h];E.hasOnlyGoodArcs(v,w)&&(f.splice(h,1),h--,w.add(v),g=!0)}}while(g);return f.map(h=>_.get(h))}containsActivationEvent(k){return this._activationMap.has(k)}containsExtension(k){return this._extensionsMap.has(c.ExtensionIdentifier.toKey(k))}getExtensionDescriptionsForActivationEvent(k){const E=this._activationMap.get(k);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(k){const E=this._extensionsMap.get(c.ExtensionIdentifier.toKey(k));return E||void 0}getExtensionDescriptionByUUID(k){for(const E of this._extensionsArr)if(E.uuid===k)return E}getExtensionDescriptionByIdOrUUID(k,E){return this.getExtensionDescription(k)??(E?this.getExtensionDescriptionByUUID(E):void 0)}}e.ExtensionDescriptionRegistry=y;var T;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(T||(T={}));function S(A,k){const E=A.isBuiltin?0:A.isUnderDevelopment?2:1,_=k.isBuiltin?0:k.isUnderDevelopment?2:1;if(E!==_)return E-_;const w=I.posix.basename(A.extensionLocation.path),f=I.posix.basename(k.extensionLocation.path);return w<f?-1:w>f?1:0}function D(A,k){const E=new Set;return k.forEach(_=>E.add(c.ExtensionIdentifier.toKey(_))),A.filter(_=>!E.has(c.ExtensionIdentifier.toKey(_.identifier)))}}),define(_e[227],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var c;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(c=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class I{constructor(){this.type=2}serialize(k){k[I.ENV_KEY]="1"}}e.SocketExtHostConnection=I,I.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(k){k[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function y(A){delete A[t.ENV_KEY],delete A[I.ENV_KEY],delete A[P.ENV_KEY]}function T(A,k){y(k),A.serialize(k)}e.writeExtHostConnection=T;function S(A){if(A[t.ENV_KEY])return D(A,new t(A[t.ENV_KEY]));if(A[I.ENV_KEY])return D(A,new I);if(A[P.ENV_KEY])return D(A,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function D(A,k){return y(A),k}}),define(_e[92],ye([1,0,23]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var I;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function y(D){const A=c.VSBuffer.alloc(1);switch(D){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.createMessageOfType=y;function T(D,A){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.isMessageOfType=T;var S;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(_e[93],ye([1,0,3,4,13,25,92,86,204,24,2]),function(Z,e,c,t,I,P,y,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let k=class{constructor(f,g){this.initData=f,this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryLoggers=new Map,this._outputLogger=g.createLogger(A.URI.revive(this.initData.environment.extensionTelemetryLogResource)),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(f,g){const h=this.getTelemetryDetails(),v=new E(g,f,this._outputLogger,this.getBuiltInCommonProperties(f),{isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled});return this._telemetryLoggers.set(f.identifier.value,v),v.apiTelemetryLogger}$initializeTelemetryLevel(f,g){this._level=f,this._productConfig=g||{usage:!0,error:!0}}getBuiltInCommonProperties(f){const g={};switch(g["common.extname"]=f.name,g["common.extversion"]=f.version,g["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,g["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,g["common.vscodeversion"]=this.initData.version,g["common.isnewappinstall"]=_(this.initData.telemetryInfo.firstSessionDate),g["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case y.UIKind.Web:g["common.uikind"]="web";break;case y.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,T.getRemoteName)((0,S.cleanRemoteAuthority)(this.initData.remote.authority)),g}$onDidChangeTelemetryLevel(f){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=f;const g=this.getTelemetryDetails();this._telemetryLoggers.forEach(h=>{h.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}onExtensionError(f,g){const h=this._telemetryLoggers.get(f.value);return h?(h.logError(g),!0):!1}};k=Ve([ze(0,P.IExtHostInitDataService),ze(1,I.ILoggerService)],k),e.ExtHostTelemetry=k;class E{constructor(f,g,h,v,m){this._extension=g,this._logger=h,this._commonProperties=v,this._onDidChangeEnableStates=new t.Emitter,this._appender=f,this._telemetryEnablements={isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}}updateTelemetryEnablements(f,g){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:f,isErrorsEnabled:g},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(f){let g=f.properties??f;return this._appender.additionalCommonProperties&&(g=(0,D.mixin)(g,this._appender.additionalCommonProperties)),g=(0,S.cleanData)(g,[]),this._appender.ignoreBuiltInCommonProperties||(g=(0,D.mixin)(g,this._commonProperties)),f.properties?f.properties=g:f=g,f}logEvent(f,g){f=this._extension.identifier.value+"/"+f,g=this.mixInCommonPropsAndCleanData(g||{}),this._appender.logEvent(f,g),this._logger.trace(f,g)}logUsage(f,g){!this._telemetryEnablements.isUsageEnabled||this.logEvent(f,g)}logError(f,g){!this._telemetryEnablements.isErrorsEnabled||(typeof f=="string"?this.logEvent(f,g):this._appender.logException(f,g))}get apiTelemetryLogger(){if(!this._apiObject){const f=this,g={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return f._telemetryEnablements.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f._onDidChangeEnableStates.event.bind(f)};this._apiObject=Object.freeze(g)}return this._apiObject}dispose(){this._appender?.flush&&this._appender.flush()}}e.ExtHostTelemetryLogger=E;function _(w){const f=Date.now()-new Date(w).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.isNewAppInstall=_,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(_e[27],ye([1,0,4,2,3,26,200]),function(Z,e,c,t,I,P,y){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");class S{constructor(d){this.affinity=d,this.kind=1}equals(d){return this.kind===d.kind&&this.affinity===d.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class D{constructor(d){this.affinity=d,this.kind=2}equals(d){return this.kind===d.kind&&this.affinity===d.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=D;class A{constructor(){this.kind=3,this.affinity=0}equals(d){return this.kind===d.kind}asString(){return"Remote"}}e.RemoteRunningLocation=A;class k{constructor(d){this.dependency=d}}e.MissingExtensionDependency=k;var E;(function(a){a[a.LocalProcess=1]="LocalProcess",a[a.LocalWebWorker=2]="LocalWebWorker",a[a.Remote=3]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(a){if(a===null)return"None";switch(a){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=_;class w{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(d,n){const i=[],p=[],C=[],R=[],U=h(this._allExtensions),H=h(d),V=(B,N)=>B.extensionLocation.toString()===N.extensionLocation.toString()||B.isBuiltin===N.isBuiltin||B.isUserBuiltin===N.isUserBuiltin||B.isUnderDevelopment===N.isUnderDevelopment;for(const B of this._allExtensions){const N=H.get(P.ExtensionIdentifier.toKey(B.identifier));if(!N){i.push(B.identifier),U.delete(P.ExtensionIdentifier.toKey(B.identifier));continue}if(!V(B,N)){i.push(B.identifier),U.delete(P.ExtensionIdentifier.toKey(B.identifier));continue}}for(const B of d){const N=U.get(P.ExtensionIdentifier.toKey(B.identifier));if(!N){p.push(B);continue}if(!V(N,B)){i.push(N.identifier),U.delete(P.ExtensionIdentifier.toKey(N.identifier));continue}}const L=g(this._myExtensions),M=g(n);for(const B of this._myExtensions)M.has(P.ExtensionIdentifier.toKey(B))||C.push(B);for(const B of n)L.has(P.ExtensionIdentifier.toKey(B))||R.push(B);const F={toRemove:i,toAdd:p,myToRemove:C,myToAdd:R};return this.delta(F),F}delta(d){const{toRemove:n,toAdd:i,myToRemove:p,myToAdd:C}=d,R=g(n),U=g(p);for(let H=0;H<this._allExtensions.length;H++)R.has(P.ExtensionIdentifier.toKey(this._allExtensions[H].identifier))&&(this._allExtensions.splice(H,1),H--);for(let H=0;H<this._myExtensions.length;H++)U.has(P.ExtensionIdentifier.toKey(this._myExtensions[H]))&&(this._myExtensions.splice(H,1),H--);for(const H of i)this._allExtensions.push(H);for(const H of C)this._myExtensions.push(H)}containsExtension(d){for(const n of this._myExtensions)if(P.ExtensionIdentifier.equals(n,d))return!0;return!1}}e.ExtensionHostExtensions=w;class f{constructor(d){if(this[T]="ExtensionIdentifierSet",this._map=new Map,this._toKey=P.ExtensionIdentifier.toKey,d)for(const n of d)this.add(n)}get size(){return this._map.size}add(d){return this._map.set(this._toKey(d),d),this}clear(){this._map.clear()}delete(d){return this._map.delete(this._toKey(d))}has(d){return this._map.has(this._toKey(d))}forEach(d,n){this._map.forEach(i=>d.call(n,i,i,this))}*entries(){for(const[d,n]of this._map)yield[n,n]}keys(){return this._map.values()}values(){return this._map.values()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=f;function g(a){const d=new Set;for(const n of a)d.add(P.ExtensionIdentifier.toKey(n));return d}e.extensionIdentifiersArrayToSet=g;function h(a){const d=new Map;for(const n of a)d.set(P.ExtensionIdentifier.toKey(n.identifier),n);return d}function v(a,d){return a.enabledApiProposals?a.enabledApiProposals.includes(d):!1}e.isProposedApiEnabled=v;function m(a,d){if(!v(a,d))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.checkProposedApiEnabled=m;class r{constructor(d,n,i,p){this.codeLoadingTime=d,this.activateCallTime=n,this.activateResolvedTime=i,this.activationReason=p}}e.ActivationTimes=r;class b{constructor(d,n){this.description=d,this.value=n}}e.ExtensionPointContribution=b,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var s;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function u(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function o(a,d){return{identifier:new P.ExtensionIdentifier((0,y.getExtensionId)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!d,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,browserNlsBundleUris:a.browserNlsBundleUris}}e.toExtensionDescription=o;class l{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(d,n){return Promise.resolve(0)}getInspectPorts(d,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(d,n){return Promise.resolve()}}e.NullExtensionService=l}),define(_e[228],ye([1,0,10,26,27,13,18]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class T{constructor(g,h,v,m){this.startup=g,this.codeLoadingTime=h,this.activateCallTime=v,this.activateResolvedTime=m}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class S{constructor(g){this._startup=g,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(g,h){return g===-1||h===-1?-1:h-g}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class D{constructor(g,h,v,m,r,b){this.activationFailed=g,this.activationFailedError=h,this.activationTimes=v,this.module=m,this.exports=r,this.subscriptions=b}}e.ActivatedExtension=D;class A extends D{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class k extends D{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class E extends D{constructor(g){super(!0,g,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let _=class{constructor(g,h,v,m,r){this._logService=r,this._registry=g,this._resolvedExtensionsSet=new Set,h.forEach(b=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(b))),this._externalExtensionsMap=new Map,v.forEach(b=>this._externalExtensionsMap.set(t.ExtensionIdentifier.toKey(b),b)),this._host=m,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[g,h]of this._operations)h.dispose()}isActivated(g){const h=this._operations.get(t.ExtensionIdentifier.toKey(g));return Boolean(h&&h.value)}getActivatedExtension(g){const h=this._operations.get(t.ExtensionIdentifier.toKey(g));if(!h||!h.value)throw new Error(`Extension '${g.value}' is not known or not activated`);return h.value}async activateByEvent(g,h){if(this._alreadyActivatedEvents[g])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(g);await this._activateExtensions(v.map(m=>({id:m.identifier,reason:{startup:h,extensionId:m.identifier,activationEvent:g}}))),this._alreadyActivatedEvents[g]=!0}activateById(g,h){const v=this._registry.getExtensionDescription(g);if(!v)throw new Error(`Extension '${g}' is not known`);return this._activateExtensions([{id:v.identifier,reason:h}])}async _activateExtensions(g){const h=g.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(h.map(v=>v.wait()))}_handleActivationRequest(g){if(this._operations.has(t.ExtensionIdentifier.toKey(g.id)))return this._operations.get(t.ExtensionIdentifier.toKey(g.id));if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(g.id)))return this._createAndSaveOperation(g,null,[],null);const h=this._registry.getExtensionDescription(g.id);if(!h){const r=new Error(`Cannot activate unknown extension '${g.id.value}'`),b=this._createAndSaveOperation(g,null,[],new E(r));return this._host.onExtensionActivationError(g.id,r,new I.MissingExtensionDependency(g.id.value)),b}const v=[],m=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const r of m){if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(r)))continue;const b=this._operations.get(t.ExtensionIdentifier.toKey(r));if(b){v.push(b);continue}if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(r))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(t.ExtensionIdentifier.toKey(r)),reason:g.reason}));continue}const s=this._registry.getExtensionDescription(r);if(s){if(!s.main&&!s.browser)continue;v.push(this._handleActivationRequest({id:s.identifier,reason:g.reason}));continue}const u=h.displayName||h.identifier.value,o=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${r}'`),l=this._createAndSaveOperation(g,h.displayName,[],new E(o));return this._host.onExtensionActivationError(h.identifier,o,new I.MissingExtensionDependency(r)),l}return this._createAndSaveOperation(g,h.displayName,v,null)}_createAndSaveOperation(g,h,v,m){const r=new w(g.id,h,g.reason,v,m,this._host,this._logService);return this._operations.set(t.ExtensionIdentifier.toKey(g.id),r),r}};_=Ve([ze(4,P.ILogService)],_),e.ExtensionsActivator=_;let w=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(g,h,v,m,r,b,s){this._id=g,this._displayName=h,this._reason=v,this._deps=m,this._value=r,this._host=b,this._logService=s,this._barrier=new y.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let g=0;g<this._deps.length;g++){const h=this._deps[g];if(h.value&&!h.value.activationFailed){this._deps.splice(g,1),g--;continue}if(h.value&&h.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);v.detail=h.value.activationFailedError,this._value=new E(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(g=>g.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(g){const h=new Error;if(g&&g.name&&(h.name=g.name),g&&g.message?h.message=`Activating extension '${this._id.value}' failed: ${g.message}.`:h.message=`Activating extension '${this._id.value}' failed: ${g}.`,g&&g.stack&&(h.stack=g.stack),this._value=new E(h),this._isDisposed&&c.isCancellationError(g))return;this._host.onExtensionActivationError(this._id,h,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(g)}}};w=Ve([ze(6,P.ILogService)],w)}),define(_e[229],ye([1,0,13,25,27]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends c.LogService{constructor(T,S){super(T.createLogger(S.logFile,{name:I.ExtensionHostLogFileName}))}};P=Ve([ze(0,c.ILoggerService),ze(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Me=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[7],ye([1,0,17,10,110,28,105,8,11,2,31,38,127,90,27]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w){"use strict";var f,g,h,v,m,r,b,s,u,o,l,a,d,n,i,p,C,R,U,H,V,L,M;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function F(G){return Object.assign(G,{apply:function(){const he=arguments.length===1?[]:arguments[1];return Reflect.construct(G,he,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(G,[]);{const[he,...ke]=arguments;return Reflect.construct(G,ke,he.constructor)}}})}let B=r=class{static from(...$){let he=$;return new r(function(){if(he){for(const ke of he)ke&&typeof ke.dispose=="function"&&ke.dispose();he=void 0}})}constructor($){f.set(this,void 0),Ze(this,f,$,"f")}dispose(){typeof Me(this,f,"f")=="function"&&(Me(this,f,"f").call(this),Ze(this,f,void 0,"f"))}};f=new WeakMap,B=r=Ve([F],B),e.Disposable=B;let N=b=class{static Min(...$){if($.length===0)throw new TypeError;let he=$[0];for(let ke=1;ke<$.length;ke++){const Ke=$[ke];Ke.isBefore(he)&&(he=Ke)}return he}static Max(...$){if($.length===0)throw new TypeError;let he=$[0];for(let ke=1;ke<$.length;ke++){const Ke=$[ke];Ke.isAfter(he)&&(he=Ke)}return he}static isPosition($){if(!$)return!1;if($ instanceof b)return!0;const{line:he,character:ke}=$;return typeof he=="number"&&typeof ke=="number"}static of($){if($ instanceof b)return $;if(this.isPosition($))return new b($.line,$.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor($,he){if($<0)throw(0,t.illegalArgument)("line must be non-negative");if(he<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=$,this._character=he}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,he=0){if($===null||he===null)throw(0,t.illegalArgument)();let ke;return typeof $>"u"?ke=0:typeof $=="number"?ke=$:(ke=typeof $.lineDelta=="number"?$.lineDelta:0,he=typeof $.characterDelta=="number"?$.characterDelta:0),ke===0&&he===0?this:new b(this.line+ke,this.character+he)}with($,he=this.character){if($===null||he===null)throw(0,t.illegalArgument)();let ke;return typeof $>"u"?ke=this.line:typeof $=="number"?ke=$:(ke=typeof $.line=="number"?$.line:this.line,he=typeof $.character=="number"?$.character:this.character),ke===this.line&&he===this.character?this:new b(ke,he)}toJSON(){return{line:this.line,character:this.character}}};N=b=Ve([F],N),e.Position=N;let z=s=class{static isRange($){return $ instanceof s?!0:$?N.isPosition($.start)&&N.isPosition($.end):!1}static of($){if($ instanceof s)return $;if(this.isRange($))return new s($.start,$.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor($,he,ke,Ke){let Je,lt;if(typeof $=="number"&&typeof he=="number"&&typeof ke=="number"&&typeof Ke=="number"?(Je=new N($,he),lt=new N(ke,Ke)):N.isPosition($)&&N.isPosition(he)&&(Je=N.of($),lt=N.of(he)),!Je||!lt)throw new Error("Invalid arguments");Je.isBefore(lt)?(this._start=Je,this._end=lt):(this._start=lt,this._end=Je)}contains($){return s.isRange($)?this.contains($.start)&&this.contains($.end):N.isPosition($)?!(N.of($).isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const he=N.Max($.start,this._start),ke=N.Min($.end,this._end);if(!he.isAfter(ke))return new s(he,ke)}union($){if(this.contains($))return this;if($.contains(this))return $;const he=N.Min($.start,this._start),ke=N.Max($.end,this.end);return new s(he,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,he=this.end){if($===null||he===null)throw(0,t.illegalArgument)();let ke;return $?N.isPosition($)?ke=$:(ke=$.start||this.start,he=$.end||this.end):ke=this.start,ke.isEqual(this._start)&&he.isEqual(this.end)?this:new s(ke,he)}toJSON(){return[this.start,this.end]}};z=s=Ve([F],z),e.Range=z;let j=u=class extends z{static isSelection($){return $ instanceof u?!0:$?z.isRange($)&&N.isPosition($.anchor)&&N.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor($,he,ke,Ke){let Je,lt;if(typeof $=="number"&&typeof he=="number"&&typeof ke=="number"&&typeof Ke=="number"?(Je=new N($,he),lt=new N(ke,Ke)):N.isPosition($)&&N.isPosition(he)&&(Je=N.of($),lt=N.of(he)),!Je||!lt)throw new Error("Invalid arguments");super(Je,lt),this._anchor=Je,this._active=lt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};j=u=Ve([F],j),e.Selection=j;class x{constructor($,he,ke){if(typeof $!="string"||$.length===0)throw(0,t.illegalArgument)("host");if(typeof he!="number"||he===0||Math.round(he)!==he)throw(0,t.illegalArgument)("port");if(typeof ke<"u"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,t.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(he),this.connectionToken=ke}}e.ResolvedAuthority=x;class Q extends Error{static NotAvailable($,he){return new Q($,E.RemoteAuthorityResolverErrorCode.NotAvailable,he)}static TemporarilyNotAvailable($){return new Q($,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor($,he=E.RemoteAuthorityResolverErrorCode.Unknown,ke){super($),this._message=$,this._code=he,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Q.prototype)}}e.RemoteAuthorityResolverError=Q;var K;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var le;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(le=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ie=o=class{static isTextEdit($){return $ instanceof o?!0:$?z.isRange($)&&typeof $.newText=="string":!1}static replace($,he){return new o($,he)}static insert($,he){return o.replace(new z($,$),he)}static delete($){return o.replace($,"")}static setEndOfLine($){const he=new o(new z(new N(0,0),new N(0,0)),"");return he.newEol=$,he}get range(){return this._range}set range($){if($&&!z.isRange($))throw(0,t.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,t.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,t.illegalArgument)("newEol");this._newEol=$}constructor($,he){this._range=$,this._newText=he}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ie=o=Ve([F],ie),e.TextEdit=ie;let de=l=class{static isNotebookCellEdit($){return $ instanceof l?!0:$?jt.isNotebookRange($)&&Array.isArray($.newCells):!1}static replaceCells($,he){return new l($,he)}static insertCells($,he){return new l(new jt($,$),he)}static deleteCells($){return new l($,[])}static updateCellMetadata($,he){const ke=new l(new jt($,$),[]);return ke.newCellMetadata=he,ke}static updateNotebookMetadata($){const he=new l(new jt(0,0),[]);return he.newNotebookMetadata=$,he}constructor($,he){this.range=$,this.newCells=he}};de=l=Ve([F],de),e.NotebookEdit=de;class Y{static isSnippetTextEdit($){return $ instanceof Y?!0:$?z.isRange($.range)&&Ce.isSnippetString($.snippet):!1}static replace($,he){return new Y($,he)}static insert($,he){return Y.replace(new z($,$),he)}constructor($,he){this.range=$,this.snippet=he}}e.SnippetTextEdit=Y;var pe;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(pe=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,he,ke,Ke){this._edits.push({_type:1,from:$,to:he,options:ke,metadata:Ke})}createFile($,he,ke){this._edits.push({_type:1,from:void 0,to:$,options:he,metadata:ke})}deleteFile($,he,ke){this._edits.push({_type:1,from:$,to:void 0,options:he,metadata:ke})}replaceNotebookMetadata($,he,ke){this._edits.push({_type:3,metadata:ke,uri:$,edit:{editType:5,metadata:he},notebookMetadata:he})}replaceNotebookCells($,he,ke,Ke){const Je=he.start,lt=he.end;(Je!==lt||ke.length>0)&&this._edits.push({_type:5,uri:$,index:Je,count:lt-Je,cells:ke,metadata:Ke})}replaceNotebookCellMetadata($,he,ke,Ke){this._edits.push({_type:3,metadata:Ke,uri:$,edit:{editType:8,index:he,metadata:ke}})}replace($,he,ke,Ke){this._edits.push({_type:2,uri:$,edit:new ie(he,ke),metadata:Ke})}insert($,he,ke,Ke){this.replace($,new z(he,he),ke,Ke)}delete($,he,ke){this.replace($,he,"",ke)}has($){return this._edits.some(he=>he._type===2&&he.uri.toString()===$.toString())}set($,he){if(he)for(const ke of he){if(!ke)continue;let Ke,Je;Array.isArray(ke)?(Ke=ke[0],Je=ke[1]):Ke=ke,de.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.replaceNotebookCellMetadata($,Ke.range.start,Ke.newCellMetadata,Je):Ke.newNotebookMetadata?this.replaceNotebookMetadata($,Ke.newNotebookMetadata,Je):this.replaceNotebookCells($,Ke.range,Ke.newCells,Je):Y.isSnippetTextEdit(Ke)?this._edits.push({_type:6,uri:$,range:Ke.range,edit:Ke.snippet,metadata:Je}):this._edits.push({_type:2,uri:$,edit:Ke,metadata:Je})}else{for(let ke=0;ke<this._edits.length;ke++){const Ke=this._edits[ke];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===$.toString()&&(this._edits[ke]=void 0);break}}(0,c.coalesceInPlace)(this._edits)}}get($){const he=[];for(const ke of this._edits)ke._type===2&&ke.uri.toString()===$.toString()&&he.push(ke.edit);return he}entries(){const $=new P.ResourceMap;for(const he of this._edits)if(he._type===2){let ke=$.get(he.uri);ke||(ke=[he.uri,[]],$.set(he.uri,ke)),ke[1].push(he.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=Ve([F],be),e.WorkspaceEdit=be;let Ce=a=class{static isSnippetString($){return $ instanceof a?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}constructor($){this._tabstop=1,this.value=$||""}appendText($){return this.value+=a._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,he=this._tabstop++){if(typeof $=="function"){const ke=new a;ke._tabstop=this._tabstop,$(ke),this._tabstop=ke._tabstop,$=ke.value}else $=a._escape($);return this.value+="${",this.value+=he,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,he=this._tabstop++){const ke=$.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=he,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable($,he){if(typeof he=="function"){const ke=new a;ke._tabstop=this._tabstop,he(ke),this._tabstop=ke._tabstop,he=ke.value}else typeof he=="string"&&(he=he.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,he&&(this.value+=":",this.value+=he),this.value+="}",this}};Ce=a=Ve([F],Ce),e.SnippetString=Ce;var Re;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(Re=e.DiagnosticTag||(e.DiagnosticTag={}));var We;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(We=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ne=d=class{static isLocation($){return $ instanceof d?!0:$?z.isRange($.range)&&D.URI.isUri($.uri):!1}constructor($,he){if(this.uri=$,he)if(z.isRange(he))this.range=z.of(he);else if(N.isPosition(he))this.range=new z(he,he);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ne=d=Ve([F],ne),e.Location=ne;let ce=class{static is($){return $?typeof $.message=="string"&&$.location&&z.isRange($.location.range)&&D.URI.isUri($.location.uri):!1}constructor($,he){this.location=$,this.message=he}static isEqual($,he){return $===he?!0:!$||!he?!1:$.message===he.message&&$.location.range.isEqual(he.location.range)&&$.location.uri.toString()===he.location.uri.toString()}};ce=Ve([F],ce),e.DiagnosticRelatedInformation=ce;let fe=class{constructor($,he,ke=We.Error){if(!z.isRange($))throw new TypeError("range must be set");if(!he)throw new TypeError("message must be set");this.range=$,this.message=he,this.severity=ke}toJSON(){return{severity:We[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,he){return $===he?!0:!$||!he?!1:$.message===he.message&&$.severity===he.severity&&$.code===he.code&&$.severity===he.severity&&$.source===he.source&&$.range.isEqual(he.range)&&(0,c.equals)($.tags,he.tags)&&(0,c.equals)($.relatedInformation,he.relatedInformation,ce.isEqual)}};fe=Ve([F],fe),e.Diagnostic=fe;let J=class{constructor($,he){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=he}};J=Ve([F],J),e.Hover=J;var re;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(re=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ee=class{constructor($,he=re.Text){this.range=$,this.kind=he}toJSON(){return{range:this.range,kind:re[this.kind]}}};ee=Ve([F],ee),e.DocumentHighlight=ee;var O;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(O=e.SymbolKind||(e.SymbolKind={}));var W;(function(G){G[G.Deprecated=1]="Deprecated"})(W=e.SymbolTag||(e.SymbolTag={}));let q=n=class{static validate($){if(!$.name)throw new Error("name must not be falsy")}constructor($,he,ke,Ke,Je){this.name=$,this.kind=he,this.containerName=Je,typeof ke=="string"&&(this.containerName=ke),Ke instanceof ne?this.location=Ke:ke instanceof z&&(this.location=new ne(Ke,ke)),n.validate(this)}toJSON(){return{name:this.name,kind:O[this.kind],location:this.location,containerName:this.containerName}}};q=n=Ve([F],q),e.SymbolInformation=q;let X=i=class{static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children?.forEach(i.validate)}constructor($,he,ke,Ke,Je){this.name=$,this.detail=he,this.kind=ke,this.range=Ke,this.selectionRange=Je,this.children=[],i.validate(this)}};X=i=Ve([F],X),e.DocumentSymbol=X;var ae;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ve=class{constructor($,he){this.title=$,this.kind=he}};ve=Ve([F],ve),e.CodeAction=ve;let Te=p=class{constructor($){this.value=$}append($){return new p(this.value?this.value+p.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+p.sep)}};Te.sep=".",Te=p=Ve([F],Te),e.CodeActionKind=Te,Te.Empty=new Te(""),Te.QuickFix=Te.Empty.append("quickfix"),Te.Refactor=Te.Empty.append("refactor"),Te.RefactorExtract=Te.Refactor.append("extract"),Te.RefactorInline=Te.Refactor.append("inline"),Te.RefactorMove=Te.Refactor.append("move"),Te.RefactorRewrite=Te.Refactor.append("rewrite"),Te.Source=Te.Empty.append("source"),Te.SourceOrganizeImports=Te.Source.append("organizeImports"),Te.SourceFixAll=Te.Source.append("fixAll");let ge=class{constructor($,he){if(this.range=$,this.parent=he,he&&!he.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ge=Ve([F],ge),e.SelectionRange=ge;class Pe{constructor($,he,ke,Ke,Je,lt){this.kind=$,this.name=he,this.detail=ke,this.uri=Ke,this.range=Je,this.selectionRange=lt}}e.CallHierarchyItem=Pe;class De{constructor($,he){this.fromRanges=he,this.from=$}}e.CallHierarchyIncomingCall=De;class xe{constructor($,he){this.fromRanges=he,this.to=$}}e.CallHierarchyOutgoingCall=xe;var je;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor($,he){this.range=$,this.command=he}get isResolved(){return!!this.command}};nt=Ve([F],nt),e.CodeLens=nt;let Xe=C=class{static isMarkdownString($){return $ instanceof C?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}constructor($,he=!1){g.set(this,void 0),Ze(this,g,new I.MarkdownString($,{supportThemeIcons:he}),"f")}get value(){return Me(this,g,"f").value}set value($){Me(this,g,"f").value=$}get isTrusted(){return Me(this,g,"f").isTrusted}set isTrusted($){Me(this,g,"f").isTrusted=$}get supportThemeIcons(){return Me(this,g,"f").supportThemeIcons}set supportThemeIcons($){Me(this,g,"f").supportThemeIcons=$}get supportHtml(){return Me(this,g,"f").supportHtml}set supportHtml($){Me(this,g,"f").supportHtml=$}get baseUri(){return Me(this,g,"f").baseUri}set baseUri($){Me(this,g,"f").baseUri=$}appendText($){return Me(this,g,"f").appendText($),this}appendMarkdown($){return Me(this,g,"f").appendMarkdown($),this}appendCodeblock($,he){return Me(this,g,"f").appendCodeblock(he??"",$),this}};g=new WeakMap,Xe=C=Ve([F],Xe),e.MarkdownString=Xe;let rt=class{constructor($,he){this.label=$,this.documentation=he}};rt=Ve([F],rt),e.ParameterInformation=rt;let Be=class{constructor($,he){this.label=$,this.documentation=he,this.parameters=[]}};Be=Ve([F],Be),e.SignatureInformation=Be;let dt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};dt=Ve([F],dt),e.SignatureHelp=dt;var se;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(se=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var oe;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(oe=e.InlayHintKind||(e.InlayHintKind={}));let Se=class{constructor($){this.value=$}};Se=Ve([F],Se),e.InlayHintLabelPart=Se;let ue=class{constructor($,he,ke){this.position=$,this.label=he,this.kind=ke}};ue=Ve([F],ue),e.InlayHint=ue;var Ie;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Le=e.CompletionItemKind||(e.CompletionItemKind={}));var Fe;(function(G){G[G.Deprecated=1]="Deprecated"})(Fe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ge=class{constructor($,he){this.label=$,this.kind=he}toJSON(){return{label:this.label,kind:this.kind&&Le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ge=Ve([F],Ge),e.CompletionItem=Ge;let Ye=class{constructor($=[],he=!1){this.items=$,this.isIncomplete=he}};Ye=Ve([F],Ye),e.CompletionList=Ye;let it=class{constructor($,he,ke){this.insertText=$,this.range=he,this.command=ke}};it=Ve([F],it),e.InlineSuggestion=it;let bt=class{constructor($){this.commands=void 0,this.items=$}};bt=Ve([F],bt),e.InlineSuggestionList=bt;var st;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(st=e.ViewColumn||(e.ViewColumn={}));var et;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(et=e.StatusBarAlignment||(e.StatusBarAlignment={}));var wt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(wt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var St;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(St=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Dt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Dt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var kt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(kt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ut;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Ut=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function $(he){switch(he){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=$}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Lt=class{constructor($,he){if(he&&!D.URI.isUri(he))throw(0,t.illegalArgument)("target");if(!z.isRange($)||$.isEmpty)throw(0,t.illegalArgument)("range");this.range=$,this.target=he}};Lt=Ve([F],Lt),e.DocumentLink=Lt;let Qe=class{constructor($,he,ke,Ke){this.red=$,this.green=he,this.blue=ke,this.alpha=Ke}};Qe=Ve([F],Qe),e.Color=Qe;let Pt=class{constructor($,he){if(he&&!(he instanceof Qe))throw(0,t.illegalArgument)("color");if(!z.isRange($)||$.isEmpty)throw(0,t.illegalArgument)("range");this.range=$,this.color=he}};Pt=Ve([F],Pt),e.ColorInformation=Pt;let Ot=class{constructor($){if(!$||typeof $!="string")throw(0,t.illegalArgument)("label");this.label=$}};Ot=Ve([F],Ot),e.ColorPresentation=Ot;var Bt;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Bt=e.ColorFormat||(e.ColorFormat={}));var pt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(pt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ae;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(Ae=e.TerminalExitReason||(e.TerminalExitReason={}));class Oe{constructor($,he,ke){if(this.startIndex=$,this.length=he,this.tooltip=ke,typeof $!="number"||$<0)throw(0,t.illegalArgument)("startIndex");if(typeof he!="number"||he<1)throw(0,t.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Oe;var Ee;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(Ee=e.TerminalLocation||(e.TerminalLocation={}));class te{constructor($){if(this.options=$,typeof $!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=te;var Ne;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Ne=e.TaskRevealKind||(e.TaskRevealKind={}));var $e;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})($e=e.TaskPanelKind||(e.TaskPanelKind={}));let tt=R=class{static from($){switch($){case"clean":return R.Clean;case"build":return R.Build;case"rebuild":return R.Rebuild;case"test":return R.Test;default:return}}constructor($,he){if(this.label=he,typeof $!="string"||typeof he!="string")throw(0,t.illegalArgument)("name");this._id=$}get id(){return this._id}};tt.Clean=new R("clean","Clean"),tt.Build=new R("build","Build"),tt.Rebuild=new R("rebuild","Rebuild"),tt.Test=new R("test","Test"),tt=R=Ve([F],tt),e.TaskGroup=tt;function qe(G){let $="";for(let he=0;he<G.length;he++)$+=G[he].replace(/,/g,",,")+",";return $}let ot=class{constructor($,he,ke){if(typeof $!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=$,he!==void 0&&(Array.isArray(he)?(this._args=he,this._options=ke):this._options=he)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,t.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(const he of this._args)$.push(he);return qe($)}};ot=Ve([F],ot),e.ProcessExecution=ot;let ct=class{constructor($,he,ke){if(this._args=[],Array.isArray(he)){if(!$)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,t.illegalArgument)("command");this._command=$,this._args=he,this._options=ke}else{if(typeof $!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=$,this._options=he}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,t.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const he of this._args)$.push(typeof he=="string"?he:he.value);return qe($)}};ct=Ve([F],ct),e.ShellExecution=ct;var At;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(At=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class It{constructor($){this._callback=$}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=It;let vt=U=class{constructor($,he,ke,Ke,Je,lt){this.__deprecated=!1,this._definition=this.definition=$;let ht;typeof he=="string"?(this._name=this.name=he,this._source=this.source=ke,this.execution=Ke,ht=Je,this.__deprecated=!0):he===Et.Global||he===Et.Workspace?(this.target=he,this._name=this.name=ke,this._source=this.source=Ke,this.execution=Je,ht=lt):(this.target=he,this._name=this.name=ke,this._source=this.source=Ke,this.execution=Je,ht=lt),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ot?this._definition={type:U.ProcessType,id:this._execution.computeId()}:this._execution instanceof ct?this._definition={type:U.ShellType,id:this._execution.computeId()}:this._execution instanceof It?this._definition={type:U.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:U.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const he=this._definition.type;(U.EmptyType===he||U.ProcessType===he||U.ShellType===he||U.ExtensionCallbackType===he)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=U=Ve([F],vt),e.Task=vt;var Ft;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Ft=e.ProgressLocation||(e.ProgressLocation={}));var mt;(function(G){function $(he){const ke=he;return(0,S.isNumber)(ke.value)?ke.tooltip&&!(0,S.isString)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}G.isViewBadge=$})(mt=e.ViewBadge||(e.ViewBadge={}));let Nt=H=class{static isTreeItem($,he){if($ instanceof H)return!0;const ke=$;if(ke.label!==void 0&&!(0,S.isString)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,S.isString)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,S.isString)(ke.iconPath)&&!D.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,S.isString)(ke.iconPath.id))){const Ke=ke.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!D.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!D.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}if(ke.description!==void 0&&!(0,S.isString)(ke.description)&&typeof ke.description!="boolean")return console.log("INVALID tree item, invalid description",ke.description),!1;if(ke.resourceUri!==void 0&&!D.URI.isUri(ke.resourceUri))return console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1;if(ke.tooltip!==void 0&&!(0,S.isString)(ke.tooltip)&&!(ke.tooltip instanceof Xe))return console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1;if(ke.command!==void 0&&!ke.command.command)return console.log("INVALID tree item, invalid command",ke.command),!1;if(ke.collapsibleState!==void 0&&ke.collapsibleState<Gt.None&&ke.collapsibleState>Gt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1;if(ke.contextValue!==void 0&&!(0,S.isString)(ke.contextValue))return console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1;if(ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1;if(ke.checkboxState!==void 0){(0,w.checkProposedApiEnabled)(he,"treeItemCheckbox");const Ke=(0,S.isNumber)(ke.checkboxState)?ke.checkboxState:(0,S.isObject)(ke.checkboxState)&&(0,S.isNumber)(ke.checkboxState.state)?ke.checkboxState.state:void 0,Je=!(0,S.isNumber)(ke.checkboxState)&&(0,S.isObject)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==_t.Checked&&Ke!==_t.Unchecked||Je!==void 0&&!(0,S.isString)(Je))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}return!0}constructor($,he=Gt.None){this.collapsibleState=he,D.URI.isUri($)?this.resourceUri=$:this.label=$}};Nt=H=Ve([F],Nt),e.TreeItem=Nt;var Gt;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(Gt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var _t;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(_t=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let xt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor($,he){this.value=$,this.id=he??(0,A.generateUuid)()}};xt=Ve([F],xt),e.DataTransferItem=xt;let rn=class{constructor($){h.set(this,new Map);for(const[he,ke]of $??[]){const Ke=Me(this,h,"f").get(he);Ke?Ke.push(ke):Me(this,h,"f").set(he,[ke])}}get($){return Me(this,h,"f").get($)?.[0]}set($,he){Me(this,h,"f").set($,[he])}forEach($,he){for(const[ke,Ke]of Me(this,h,"f"))for(const Je of Ke)$.call(he,Je,ke,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[$,he]of Me(this,h,"f"))for(const ke of he)yield[$,ke]}};rn=Ve([F],rn),e.DataTransfer=rn;let sn=class{constructor($){this.insertText=$}};sn=Ve([F],sn),e.DocumentDropEdit=sn;let gn=class{constructor($){this.insertText=$}};gn=Ve([F],gn),e.DocumentPasteEdit=gn;let Ct=class{constructor($,he){this.id=$,this.color=he}};Ct=Ve([F],Ct),e.ThemeIcon=Ct,Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let on=class{constructor($){this.id=$}};on=Ve([F],on),e.ThemeColor=on;var Rn;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Rn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Jt=class{get base(){return this._base}set base($){this._base=$,this._baseUri=D.URI.file($)}get baseUri(){return this._baseUri}set baseUri($){this._baseUri=$,this._base=$.fsPath}constructor($,he){if(typeof $!="string"&&(!$||!D.URI.isUri($)&&!D.URI.isUri($.uri)))throw(0,t.illegalArgument)("base");if(typeof he!="string")throw(0,t.illegalArgument)("pattern");typeof $=="string"?this.baseUri=D.URI.file($):D.URI.isUri($)?this.baseUri=$:this.baseUri=$.uri,this.pattern=he}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Jt=Ve([F],Jt),e.RelativePattern=Jt;let zt=class{constructor($,he,ke,Ke){this.enabled=typeof $=="boolean"?$:!0,typeof he=="string"&&(this.condition=he),typeof ke=="string"&&(this.hitCondition=ke),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};zt=Ve([F],zt),e.Breakpoint=zt;let ut=class extends zt{constructor($,he,ke,Ke,Je){if(super(he,ke,Ke,Je),$===null)throw(0,t.illegalArgument)("location");this.location=$}};ut=Ve([F],ut),e.SourceBreakpoint=ut;let pn=class extends zt{constructor($,he,ke,Ke,Je){super(he,ke,Ke,Je),this.functionName=$}};pn=Ve([F],pn),e.FunctionBreakpoint=pn;let Ht=class extends zt{constructor($,he,ke,Ke,Je,lt,ht){if(super(Ke,Je,lt,ht),!he)throw(0,t.illegalArgument)("dataId");this.label=$,this.dataId=he,this.canPersist=ke}};Ht=Ve([F],Ht),e.DataBreakpoint=Ht;let Kt=class{constructor($,he,ke){this.command=$,this.args=he||[],this.options=ke}};Kt=Ve([F],Kt),e.DebugAdapterExecutable=Kt;let an=class{constructor($,he){this.port=$,this.host=he}};an=Ve([F],an),e.DebugAdapterServer=an;let vn=class{constructor($){this.path=$}};vn=Ve([F],vn),e.DebugAdapterNamedPipeServer=vn;let cn=class{constructor($){this.implementation=$}};cn=Ve([F],cn),e.DebugAdapterInlineImplementation=cn;let bn=class{constructor($,he){this.range=$,this.expression=he}};bn=Ve([F],bn),e.EvaluatableExpression=bn;var Dn;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Dn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Zt=class{constructor($,he){this.range=$,this.text=he}};Zt=Ve([F],Zt),e.InlineValueText=Zt;let wn=class{constructor($,he,ke=!0){this.range=$,this.variableName=he,this.caseSensitiveLookup=ke}};wn=Ve([F],wn),e.InlineValueVariableLookup=wn;let en=class{constructor($,he){this.range=$,this.expression=he}};en=Ve([F],en),e.InlineValueEvaluatableExpression=en;let tn=class{constructor($,he){this.frameId=$,this.stoppedLocation=he}};tn=Ve([F],tn),e.InlineValueContext=tn;var Ln;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Ln=e.FileChangeType||(e.FileChangeType={}));let En=V=class extends Error{static FileExists($){return new V($,k.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound($){return new V($,k.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory($){return new V($,k.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory($){return new V($,k.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions($){return new V($,k.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable($){return new V($,k.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor($,he=k.FileSystemProviderErrorCode.Unknown,ke){super(D.URI.isUri($)?$.toString(!0):$),this.code=ke?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,he),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};En=V=Ve([F],En),e.FileSystemError=En;let Xt=class{constructor($,he,ke){this.start=$,this.end=he,this.kind=ke}};Xt=Ve([F],Xt),e.FoldingRange=Xt;var On;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(On=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Fn;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Nn;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Nn=e.CommentMode||(e.CommentMode={}));var Mn;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(Mn=e.CommentThreadState||(e.CommentThreadState={}));class Sn{constructor($,he=[]){this.tokenTypes=$,this.tokenModifiers=he}}e.SemanticTokensLegend=Sn;function In(G){return typeof G>"u"||(0,S.isStringArray)(G)}class ln{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let he=0,ke=$.tokenTypes.length;he<ke;he++)this._tokenTypeStrToInt.set($.tokenTypes[he],he);for(let he=0,ke=$.tokenModifiers.length;he<ke;he++)this._tokenModifierStrToInt.set($.tokenModifiers[he],he)}}push($,he,ke,Ke,Je){if(typeof $=="number"&&typeof he=="number"&&typeof ke=="number"&&typeof Ke=="number"&&(typeof Je=="number"||typeof Je>"u"))return typeof Je>"u"&&(Je=0),this._pushEncoded($,he,ke,Ke,Je);if(z.isRange($)&&typeof he=="string"&&In(ke))return this._push($,he,ke);throw(0,t.illegalArgument)()}_push($,he,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(he))throw new Error("`tokenType` is not in the provided legend");const Ke=$.start.line,Je=$.start.character,lt=$.end.character-$.start.character,ht=this._tokenTypeStrToInt.get(he);let Rt=0;if(ke)for(const Wt of ke){if(!this._tokenModifierStrToInt.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const $t=this._tokenModifierStrToInt.get(Wt);Rt|=1<<$t>>>0}this._pushEncoded(Ke,Je,lt,ht,Rt)}_pushEncoded($,he,ke,Ke,Je){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&he<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Rt=this._data.length/5|0;let Wt=0,$t=0;for(let qt=0;qt<Rt;qt++){let Qt=this._data[5*qt],yn=this._data[5*qt+1];Qt===0?(Qt=Wt,yn+=$t):Qt+=Wt,this._data[5*qt]=Qt,this._data[5*qt+1]=yn,Wt=Qt,$t=yn}}let lt=$,ht=he;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=Je,this._prevLine=$,this._prevChar=he}static _sortAndDeltaEncode($){const he=[],ke=$.length/5|0;for(let ht=0;ht<ke;ht++)he[ht]=ht;he.sort((ht,Rt)=>{const Wt=$[5*ht],$t=$[5*Rt];if(Wt===$t){const qt=$[5*ht+1],Qt=$[5*Rt+1];return qt-Qt}return Wt-$t});const Ke=new Uint32Array($.length);let Je=0,lt=0;for(let ht=0;ht<ke;ht++){const Rt=5*he[ht],Wt=$[Rt+0],$t=$[Rt+1],qt=$[Rt+2],Qt=$[Rt+3],yn=$[Rt+4],Jn=Wt-Je,_i=Jn===0?$t-lt:$t,Cn=5*ht;Ke[Cn+0]=Jn,Ke[Cn+1]=_i,Ke[Cn+2]=qt,Ke[Cn+3]=Qt,Ke[Cn+4]=yn,Je=Wt,lt=$t}return Ke}build($){return this._dataIsSortedAndDeltaEncoded?new He(new Uint32Array(this._data),$):new He(ln._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=ln;class He{constructor($,he){this.resultId=he,this.data=$}}e.SemanticTokens=He;class Vt{constructor($,he,ke){this.start=$,this.deleteCount=he,this.data=ke}}e.SemanticTokensEdit=Vt;class kn{constructor($,he){this.resultId=he,this.edits=$}}e.SemanticTokensEdits=kn;var gt;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let un=class{constructor(){}};un.Back={iconPath:new Ct("arrow-left")},un=Ve([F],un),e.QuickInputButtons=un;var Un;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Un=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Tn;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Tn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Bn;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Bn=e.ExtensionKind||(e.ExtensionKind={}));class dn{static validate($){if($.badge){let he=(0,T.nextCharLength)($.badge,0);if(he<$.badge.length&&(he+=(0,T.nextCharLength)($.badge,he)),$.badge.length>he)throw new Error("The 'badge'-property must be undefined or a short character")}if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty");return!0}constructor($,he,ke){this.badge=$,this.tooltip=he,this.color=ke}}e.FileDecoration=dn;let _n=class{constructor($){this.kind=$}};_n=Ve([F],_n),e.ColorTheme=_n;var Wn;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Wn=e.ColorThemeKind||(e.ColorThemeKind={}));class jt{static isNotebookRange($){return $ instanceof jt?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor($,he){if($<0)throw(0,t.illegalArgument)("start must be positive");if(he<0)throw(0,t.illegalArgument)("end must be positive");$<=he?(this._start=$,this._end=he):(this._start=he,this._end=$)}with($){let he=this._start,ke=this._end;return $.start!==void 0&&(he=$.start),$.end!==void 0&&(ke=$.end),he===this._start&&ke===this._end?this:new jt(he,ke)}}e.NotebookRange=jt;class nn{static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(he=>nn.isNotebookCellData(he))}static isNotebookCellData($){return!0}constructor($,he,ke,Ke,Je,lt,ht){this.kind=$,this.value=he,this.languageId=ke,this.mime=Ke,this.outputs=Je??[],this.metadata=lt,this.executionSummary=ht,nn.validate(this)}}e.NotebookCellData=nn;class zn{constructor($){this.cells=$}}e.NotebookData=zn;class Mt{static isNotebookCellOutputItem($){return $ instanceof Mt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const he={name:$.name,message:$.message,stack:$.stack};return Mt.json(he,"application/vnd.code.notebook.error")}static stdout($){return Mt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return Mt.text($,"application/vnd.code.notebook.stderr")}static bytes($,he="application/octet-stream"){return new Mt($,he)}static text($,he=y.Mimes.text){const ke=Me(Mt,v,"f",m).encode(String($));return new Mt(ke,he)}static json($,he="text/x-json"){const ke=JSON.stringify($,void 0,"	");return Mt.text(ke,he)}constructor($,he){this.data=$,this.mime=he;const ke=(0,y.normalizeMimeType)(he,!0);if(!ke)throw new Error(`INVALID mime type: ${he}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.NotebookCellOutputItem=Mt,v=Mt,m={value:new TextEncoder};class hn{static isNotebookCellOutput($){return $ instanceof hn?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&Array.isArray($.items)}static ensureUniqueMimeTypes($,he=!1){const ke=new Set,Ke=new Set;for(let Je=0;Je<$.length;Je++){const lt=$[Je],ht=(0,y.normalizeMimeType)(lt.mime);if(!ke.has(ht)||(0,_.isTextStreamMime)(ht)){ke.add(ht);continue}Ke.add(Je),he&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ke.size===0?$:$.filter((Je,lt)=>!Ke.has(lt))}constructor($,he,ke){this.items=hn.ensureUniqueMimeTypes($,!0),typeof he=="string"?(this.id=he,this.metadata=ke):(this.id=(0,A.generateUuid)(),this.metadata=he??ke)}}e.NotebookCellOutput=hn;var Hn;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Hn=e.NotebookCellKind||(e.NotebookCellKind={}));var $n;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})($n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var xn;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(xn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var me;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(me=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class we{constructor($,he){this.text=$,this.alignment=he}}e.NotebookCellStatusBarItem=we;var Ue;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(Ue=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var at;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(at=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class yt{constructor($,he=[]){this.uri=$,this.provides=(0,c.asArray)(he)}}e.NotebookRendererScript=yt;let Tt=class{constructor($,he){this.label=$,this.timestamp=he}};Tt=Ve([F],Tt),e.TimelineItem=Tt;var ni;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(ni=e.ExtensionMode||(e.ExtensionMode={}));var ii;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(ii=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ri;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(ri=e.StandardTokenType||(e.StandardTokenType={}));class si{constructor($,he){this.ranges=$,this.wordPattern=he}}e.LinkedEditingRanges=si;class oi{constructor($,he){this._port=$,this._autoForwardAction=he}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=oi;var ai;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(ai=e.TestResultState||(e.TestResultState={}));var ci;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(ci=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Vn=class{constructor($=void 0,he=void 0,ke=void 0){this.include=$,this.exclude=he,this.profile=ke}};Vn=Ve([F],Vn),e.TestRunRequest=Vn;let jn=L=class{static diff($,he,ke){const Ke=new L($);return Ke.expectedOutput=he,Ke.actualOutput=ke,Ke}constructor($){this.message=$}};jn=L=Ve([F],jn),e.TestMessage=jn;let qn=class{constructor($){this.id=$}};qn=Ve([F],qn),e.TestTag=qn;let fn=class{constructor($,he){this.covered=$,this.total=he}};fn=Ve([F],fn),e.CoveredCount=fn;let Gn=M=class{static fromDetails($,he){const ke=new fn(0,0),Ke=new fn(0,0),Je=new fn(0,0);for(const ht of he)if("branches"in ht){ke.total+=1,ke.covered+=ht.executionCount>0?1:0;for(const Rt of ht.branches)Ke.total+=1,Ke.covered+=Rt.executionCount>0?1:0}else Je.total+=1,Je.covered+=ht.executionCount>0?1:0;const lt=new M($,ke,Ke.total>0?Ke:void 0,Je.total>0?Je:void 0);return lt.detailedCoverage=he,lt}constructor($,he,ke,Ke){this.uri=$,this.statementCoverage=he,this.branchCoverage=ke,this.functionCoverage=Ke}};Gn=M=Ve([F],Gn),e.FileCoverage=Gn;let Kn=class{constructor($,he,ke=[]){this.executionCount=$,this.location=he,this.branches=ke}};Kn=Ve([F],Kn),e.StatementCoverage=Kn;let Xn=class{constructor($,he){this.executionCount=$,this.location=he}};Xn=Ve([F],Xn),e.BranchCoverage=Xn;let Qn=class{constructor($,he){this.executionCount=$,this.location=he}};Qn=Ve([F],Qn),e.FunctionCoverage=Qn;var li;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(li=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ui;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(ui=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var di;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(di=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class hi{constructor($,he,ke,Ke,Je,lt){this.kind=$,this.name=he,this.detail=ke,this.uri=Ke,this.range=Je,this.selectionRange=lt}}e.TypeHierarchyItem=hi;class fi{constructor($){this.uri=$}}e.TextTabInput=fi;class mi{constructor($,he){this.original=$,this.modified=he}}e.TextDiffTabInput=mi;class gi{constructor($,he,ke,Ke){this.base=$,this.input1=he,this.input2=ke,this.result=Ke}}e.TextMergeTabInput=gi;class pi{constructor($,he){this.uri=$,this.viewType=he}}e.CustomEditorTabInput=pi;class vi{constructor($){this.viewType=$}}e.WebviewEditorTabInput=vi;class bi{constructor($,he){this.uri=$,this.notebookType=he}}e.NotebookEditorTabInput=bi;class wi{constructor($,he,ke){this.original=$,this.modified=he,this.notebookType=ke}}e.NotebookDiffEditorTabInput=wi;class Ei{constructor(){}}e.TerminalEditorTabInput=Ei;class Si{constructor($,he){this.uri=$,this.inputBoxUri=he}}e.InteractiveWindowInput=Si}),define(_e[133],ye([1,0,48,14,8,160,103,7,17]),function(Z,e,c,t,I,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const D=new Map;function A(w,f){f?D.set(w,f):D.delete(w)}e.setWordDefinitionFor=A;function k(w){return D.get(w)}class E extends P.MirrorTextModel{constructor(f,g,h,v,m,r,b,s){super(g,h,v,m),this._proxy=f,this._languageId=r,this._isDirty=b,this.notebook=s,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(f){return(0,S.equals)(this._lines,f)}get document(){if(!this._document){const f=this;this._document={get uri(){return f._uri},get fileName(){return f._uri.fsPath},get isUntitled(){return f._uri.scheme===t.Schemas.untitled},get languageId(){return f._languageId},get version(){return f._versionId},get isClosed(){return f._isDisposed},get isDirty(){return f._isDirty},save(){return f._save()},getText(g){return g?f._getTextInRange(g):f.getText()},get eol(){return f._eol===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return f._lines.length},lineAt(g){return f._lineAt(g)},offsetAt(g){return f._offsetAt(g)},positionAt(g){return f._positionAt(g)},validateRange(g){return f._validateRange(g)},validatePosition(g){return f._validatePosition(g)},getWordRangeAtPosition(g,h){return f._getWordRangeAtPosition(g,h)}}}return Object.freeze(this._document)}_acceptLanguageId(f){(0,c.ok)(!this._isDisposed),this._languageId=f}_acceptIsDirty(f){(0,c.ok)(!this._isDisposed),this._isDirty=f}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(f){const g=this._validateRange(f);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const h=this._eol,v=g.start.line,m=g.end.line,r=[];r.push(this._lines[v].substring(g.start.character));for(let b=v+1;b<m;b++)r.push(this._lines[b]);return r.push(this._lines[m].substring(0,g.end.character)),r.join(h)}_lineAt(f){let g;if(f instanceof T.Position?g=f.line:typeof f=="number"&&(g=f),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new _(g,this._lines[g],g===this._lines.length-1)}_offsetAt(f){return f=this._validatePosition(f),this._ensureLineStarts(),this._lineStarts.getPrefixSum(f.line-1)+f.character}_positionAt(f){f=Math.floor(f),f=Math.max(0,f),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(f),h=this._lines[g.index].length;return new T.Position(g.index,Math.min(g.remainder,h))}_validateRange(f){if(!(f instanceof T.Range))throw new Error("Invalid argument");const g=this._validatePosition(f.start),h=this._validatePosition(f.end);return g===f.start&&h===f.end?f:new T.Range(g.line,g.character,h.line,h.character)}_validatePosition(f){if(!(f instanceof T.Position))throw new Error("Invalid argument");if(this._lines.length===0)return f.with(0,0);let{line:g,character:h}=f,v=!1;if(g<0)g=0,h=0,v=!0;else if(g>=this._lines.length)g=this._lines.length-1,h=this._lines[g].length,v=!0;else{const m=this._lines[g].length;h<0?(h=0,v=!0):h>m&&(h=m,v=!0)}return v?new T.Position(g,h):f}_getWordRangeAtPosition(f,g){const h=this._validatePosition(f);if(!g)g=k(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const v=(0,y.getWordAtText)(h.character+1,(0,y.ensureValidWordDefinition)(g),this._lines[h.line],0);if(v)return new T.Range(h.line,v.startColumn-1,h.line,v.endColumn-1)}}e.ExtHostDocumentData=E;class _{constructor(f,g,h){this._line=f,this._text=g,this._isLastLine=h}get lineNumber(){return this._line}get text(){return this._text}get range(){return new T.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new T.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=_}),define(_e[230],ye([1,0,7,16,4]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(T){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(T){let S;switch(T){case"light":S=c.ColorThemeKind.Light;break;case"hcDark":S=c.ColorThemeKind.HighContrast;break;case"hcLight":S=c.ColorThemeKind.HighContrastLight;break;default:S=c.ColorThemeKind.Dark}this._actual=new c.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=Ve([ze(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(_e[15],ye([1,0,17,23,110,28,145,82,24,11,2,35,66,122,131,129,90,56,67,224,7,61]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h,v,m,r,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Ae){function Oe(te){const{selectionStartLineNumber:Ne,selectionStartColumn:$e,positionLineNumber:tt,positionColumn:qe}=te,ot=new r.Position(Ne-1,$e-1),ct=new r.Position(tt-1,qe-1);return new r.Selection(ot,ct)}Ae.to=Oe;function Ee(te){const{anchor:Ne,active:$e}=te;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}Ae.from=Ee})(s=e.Selection||(e.Selection={}));var u;(function(Ae){function Oe(te){if(!te)return;const{start:Ne,end:$e}=te;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}Ae.from=Oe;function Ee(te){if(!te)return;const{startLineNumber:Ne,startColumn:$e,endLineNumber:tt,endColumn:qe}=te;return new r.Range(Ne-1,$e-1,tt-1,qe-1)}Ae.to=Ee})(u=e.Range||(e.Range={}));var o;(function(Ae){function Oe(Ee){switch(Ee){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Ae.to=Oe})(o=e.TokenType||(e.TokenType={}));var l;(function(Ae){function Oe(te){return new r.Position(te.lineNumber-1,te.column-1)}Ae.to=Oe;function Ee(te){return{lineNumber:te.line+1,column:te.character+1}}Ae.from=Ee})(l=e.Position||(e.Position={}));var a;(function(Ae){function Oe(Ne,$e){return(0,c.coalesce)((0,c.asArray)(Ne).map(tt=>Ee(tt,$e)))}Ae.from=Oe;function Ee(Ne,$e){if(typeof Ne=="string")return{$serialized:!0,language:Ne};if(Ne)return{$serialized:!0,language:Ne.language,scheme:te(Ne.scheme,$e),pattern:oe.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType}}function te(Ne,$e){return $e&&typeof Ne=="string"?$e.transformOutgoingScheme(Ne):Ne}})(a=e.DocumentSelector||(e.DocumentSelector={}));var d;(function(Ae){function Oe(te){switch(te){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function Ee(te){switch(te){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Ae.to=Ee})(d=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(Ae){function Oe(te){let Ne;return te.code&&((0,D.isString)(te.code)||(0,D.isNumber)(te.code)?Ne=String(te.code):Ne={value:String(te.code.value),target:te.code.target}),{...u.from(te.range),message:te.message,source:te.source,code:Ne,severity:p.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(i.from),tags:Array.isArray(te.tags)?(0,c.coalesce)(te.tags.map(d.from)):void 0}}Ae.from=Oe;function Ee(te){const Ne=new r.Diagnostic(u.to(te),te.message,p.to(te.severity));return Ne.source=te.source,Ne.code=(0,D.isString)(te.code)?te.code:te.code?.value,Ne.relatedInformation=te.relatedInformation&&te.relatedInformation.map(i.to),Ne.tags=te.tags&&(0,c.coalesce)(te.tags.map(d.to)),Ne}Ae.to=Ee})(n=e.Diagnostic||(e.Diagnostic={}));var i;(function(Ae){function Oe(te){return{...u.from(te.location.range),message:te.message,resource:te.location.uri}}Ae.from=Oe;function Ee(te){return new r.DiagnosticRelatedInformation(new r.Location(te.resource,u.to(te)),te.message)}Ae.to=Ee})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var p;(function(Ae){function Oe(te){switch(te){case r.DiagnosticSeverity.Error:return _.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return _.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return _.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return _.MarkerSeverity.Hint}return _.MarkerSeverity.Error}Ae.from=Oe;function Ee(te){switch(te){case _.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case _.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case _.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case _.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Ae.to=Ee})(p=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var C;(function(Ae){function Oe(te){return typeof te=="number"&&te>=r.ViewColumn.One?te-1:te===r.ViewColumn.Beside?m.SIDE_GROUP:m.ACTIVE_GROUP}Ae.from=Oe;function Ee(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=Ee})(C=e.ViewColumn||(e.ViewColumn={}));function R(Ae){return typeof Ae.range<"u"}function U(Ae){return Ae.length===0?!0:!!R(Ae[0])}e.isDecorationOptionsArr=U;var H;(function(Ae){function Oe(qe){return qe.map(Ae.from)}Ae.fromMany=Oe;function Ee(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function te(qe){let ot;if(Ee(qe)){const{language:It,value:vt}=qe;ot={value:"```"+It+`
`+vt+"\n```\n"}}else r.MarkdownString.isMarkdownString(qe)?ot={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ot={value:qe}:ot={value:""};const ct=Object.create(null);ot.uris=ct;const At=It=>{try{let vt=A.URI.parse(It,!0);vt=vt.with({query:Ne(vt.query,ct)}),ct[It]=vt}catch{}return""},Et=new y.marked.Renderer;return Et.link=At,Et.image=It=>typeof It=="string"?At(I.parseHrefAndDimensions(It).href):"",(0,y.marked)(ot.value,{renderer:Et}),ot}Ae.from=te;function Ne(qe,ot){if(!qe)return qe;let ct;try{ct=(0,T.parse)(qe)}catch{}if(!ct)return qe;let At=!1;return ct=(0,S.cloneAndChange)(ct,Et=>{if(A.URI.isUri(Et)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[It]=Et,At=!0,It}else return}),At?JSON.stringify(ct):qe}function $e(qe){const ot=new r.MarkdownString(qe.value,qe.supportThemeIcons);return ot.isTrusted=qe.isTrusted,ot.supportHtml=qe.supportHtml,ot.baseUri=qe.baseUri?A.URI.from(qe.baseUri):void 0,ot}Ae.to=$e;function tt(qe){if(!!qe)return typeof qe=="string"?qe:Ae.from(qe)}Ae.fromStrict=tt})(H=e.MarkdownString||(e.MarkdownString={}));function V(Ae){return U(Ae)?Ae.map(Oe=>({range:u.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?H.fromMany(Oe.hoverMessage):Oe.hoverMessage?H.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:u.from(Oe)}))}e.fromRangeOrRangeWithMessage=V;function L(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?A.URI.file(Ae):Ae}e.pathOrURIToURI=L;var M;(function(Ae){function Oe(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?L(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Ae.from=Oe})(M=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(Ae){function Oe(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?L(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?M.from(Ee.before):void 0,after:Ee.after?M.from(Ee.after):void 0}}Ae.from=Oe})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var B;(function(Ae){function Oe(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(B=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var N;(function(Ae){function Oe(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?B.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?F.from(Ee.light):void 0,dark:Ee.dark?F.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?L(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?M.from(Ee.before):void 0,after:Ee.after?M.from(Ee.after):void 0}}Ae.from=Oe})(N=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(Ae){function Oe(te){return{text:te.newText,eol:te.newEol&&Xe.from(te.newEol),range:u.from(te.range)}}Ae.from=Oe;function Ee(te){const Ne=new r.TextEdit(u.to(te.range),te.text);return Ne.newEol=typeof te.eol>"u"?void 0:Xe.to(te.eol),Ne}Ae.to=Ee})(z=e.TextEdit||(e.TextEdit={}));var j;(function(Ae){function Oe(te,Ne){const $e={edits:[]};if(te instanceof r.WorkspaceEdit){const tt=new P.ResourceSet;for(const qe of te._allEntries())qe._type===1&&A.URI.isUri(qe.to)&&qe.from===void 0&&tt.add(qe.to);for(const qe of te._allEntries())qe._type===1?$e.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contentsBase64:qe.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(qe.options.contents))},metadata:qe.metadata}):qe._type===2?$e.edits.push({resource:qe.uri,textEdit:z.from(qe.edit),versionId:tt.has(qe.uri)?void 0:Ne?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?$e.edits.push({resource:qe.uri,textEdit:{range:u.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:tt.has(qe.uri)?void 0:Ne?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?$e.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&$e.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Ye.from)}})}return $e}Ae.from=Oe;function Ee(te){const Ne=new r.WorkspaceEdit;for(const $e of te.edits)$e.textEdit?Ne.replace(A.URI.revive($e.resource),u.to($e.textEdit.range),$e.textEdit.text):Ne.renameFile(A.URI.revive($e.oldResource),A.URI.revive($e.newResource),$e.options);return Ne}Ae.to=Ee})(j=e.WorkspaceEdit||(e.WorkspaceEdit={}));var x;(function(Ae){const Oe=Object.create(null);Oe[r.SymbolKind.File]=0,Oe[r.SymbolKind.Module]=1,Oe[r.SymbolKind.Namespace]=2,Oe[r.SymbolKind.Package]=3,Oe[r.SymbolKind.Class]=4,Oe[r.SymbolKind.Method]=5,Oe[r.SymbolKind.Property]=6,Oe[r.SymbolKind.Field]=7,Oe[r.SymbolKind.Constructor]=8,Oe[r.SymbolKind.Enum]=9,Oe[r.SymbolKind.Interface]=10,Oe[r.SymbolKind.Function]=11,Oe[r.SymbolKind.Variable]=12,Oe[r.SymbolKind.Constant]=13,Oe[r.SymbolKind.String]=14,Oe[r.SymbolKind.Number]=15,Oe[r.SymbolKind.Boolean]=16,Oe[r.SymbolKind.Array]=17,Oe[r.SymbolKind.Object]=18,Oe[r.SymbolKind.Key]=19,Oe[r.SymbolKind.Null]=20,Oe[r.SymbolKind.EnumMember]=21,Oe[r.SymbolKind.Struct]=22,Oe[r.SymbolKind.Event]=23,Oe[r.SymbolKind.Operator]=24,Oe[r.SymbolKind.TypeParameter]=25;function Ee(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Ae.from=Ee;function te(Ne){for(const $e in Oe)if(Oe[$e]===Ne)return Number($e);return r.SymbolKind.Property}Ae.to=te})(x=e.SymbolKind||(e.SymbolKind={}));var Q;(function(Ae){function Oe(te){switch(te){case r.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function Ee(te){switch(te){case 1:return r.SymbolTag.Deprecated}}Ae.to=Ee})(Q=e.SymbolTag||(e.SymbolTag={}));var K;(function(Ae){function Oe(te){return{name:te.name,kind:x.from(te.kind),tags:te.tags&&te.tags.map(Q.from),containerName:te.containerName,location:pe.from(te.location)}}Ae.from=Oe;function Ee(te){const Ne=new r.SymbolInformation(te.name,x.to(te.kind),te.containerName,pe.to(te.location));return Ne.tags=te.tags&&te.tags.map(Q.to),Ne}Ae.to=Ee})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var le;(function(Ae){function Oe(te){const Ne={name:te.name||"!!MISSING: name!!",detail:te.detail,range:u.from(te.range),selectionRange:u.from(te.selectionRange),kind:x.from(te.kind),tags:te.tags?.map(Q.from)??[]};return te.children&&(Ne.children=te.children.map(Oe)),Ne}Ae.from=Oe;function Ee(te){const Ne=new r.DocumentSymbol(te.name,te.detail,x.to(te.kind),u.to(te.range),u.to(te.selectionRange));return(0,c.isNonEmptyArray)(te.tags)&&(Ne.tags=te.tags.map(Q.to)),te.children&&(Ne.children=te.children.map(Ee)),Ne}Ae.to=Ee})(le=e.DocumentSymbol||(e.DocumentSymbol={}));var ie;(function(Ae){function Oe(te){const Ne=new r.CallHierarchyItem(x.to(te.kind),te.name,te.detail||"",A.URI.revive(te.uri),u.to(te.range),u.to(te.selectionRange));return Ne._sessionId=te._sessionId,Ne._itemId=te._itemId,Ne}Ae.to=Oe;function Ee(te,Ne,$e){if(Ne=Ne??te._sessionId,$e=$e??te._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,name:te.name,detail:te.detail,kind:x.from(te.kind),uri:te.uri,range:u.from(te.range),selectionRange:u.from(te.selectionRange),tags:te.tags?.map(Q.from)}}Ae.from=Ee})(ie=e.CallHierarchyItem||(e.CallHierarchyItem={}));var de;(function(Ae){function Oe(Ee){return new r.CallHierarchyIncomingCall(ie.to(Ee.from),Ee.fromRanges.map(te=>u.to(te)))}Ae.to=Oe})(de=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Y;(function(Ae){function Oe(Ee){return new r.CallHierarchyOutgoingCall(ie.to(Ee.to),Ee.fromRanges.map(te=>u.to(te)))}Ae.to=Oe})(Y=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var pe;(function(Ae){function Oe(te){return{range:te.range&&u.from(te.range),uri:te.uri}}Ae.from=Oe;function Ee(te){return new r.Location(A.URI.revive(te.uri),u.to(te.range))}Ae.to=Ee})(pe=e.location||(e.location={}));var be;(function(Ae){function Oe(te){const Ne=te,$e=te;return{originSelectionRange:Ne.originSelectionRange?u.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:$e.uri,range:u.from(Ne.targetRange?Ne.targetRange:$e.range),targetSelectionRange:Ne.targetSelectionRange?u.from(Ne.targetSelectionRange):void 0}}Ae.from=Oe;function Ee(te){return{targetUri:A.URI.revive(te.uri),targetRange:u.to(te.range),targetSelectionRange:te.targetSelectionRange?u.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?u.to(te.originSelectionRange):void 0}}Ae.to=Ee})(be=e.DefinitionLink||(e.DefinitionLink={}));var Ce;(function(Ae){function Oe(te){return{range:u.from(te.range),contents:H.fromMany(te.contents)}}Ae.from=Oe;function Ee(te){return new r.Hover(te.contents.map(H.to),u.to(te.range))}Ae.to=Ee})(Ce=e.Hover||(e.Hover={}));var Re;(function(Ae){function Oe(te){return{range:u.from(te.range),expression:te.expression}}Ae.from=Oe;function Ee(te){return new r.EvaluatableExpression(u.to(te.range),te.expression)}Ae.to=Ee})(Re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var We;(function(Ae){function Oe(te){if(te instanceof r.InlineValueText)return{type:"text",range:u.from(te.range),text:te.text};if(te instanceof r.InlineValueVariableLookup)return{type:"variable",range:u.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function Ee(te){switch(te.type){case"text":return{range:u.to(te.range),text:te.text};case"variable":return{range:u.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:u.to(te.range),expression:te.expression}}}Ae.to=Ee})(We=e.InlineValue||(e.InlineValue={}));var ne;(function(Ae){function Oe(te){return{frameId:te.frameId,stoppedLocation:u.from(te.stoppedLocation)}}Ae.from=Oe;function Ee(te){return new r.InlineValueContext(te.frameId,u.to(te.stoppedLocation))}Ae.to=Ee})(ne=e.InlineValueContext||(e.InlineValueContext={}));var ce;(function(Ae){function Oe(te){return{range:u.from(te.range),kind:te.kind}}Ae.from=Oe;function Ee(te){return new r.DocumentHighlight(u.to(te.range),te.kind)}Ae.to=Ee})(ce=e.DocumentHighlight||(e.DocumentHighlight={}));var fe;(function(Ae){function Oe(Ee){switch(Ee){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Ae.to=Oe})(fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(Ae){function Oe(Ee){return{triggerKind:fe.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Ae.to=Oe})(J=e.CompletionContext||(e.CompletionContext={}));var re;(function(Ae){function Oe(te){switch(te){case r.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function Ee(te){switch(te){case 1:return r.CompletionItemTag.Deprecated}}Ae.to=Ee})(re=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(Ae){const Oe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ee($e){return Oe.get($e)??9}Ae.from=Ee;const te=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Ne($e){return te.get($e)??r.CompletionItemKind.Property}Ae.to=Ne})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var O;(function(Ae){function Oe(Ee,te){const Ne=new r.CompletionItem(Ee.label);return Ne.insertText=Ee.insertText,Ne.kind=ee.to(Ee.kind),Ne.tags=Ee.tags?.map(re.to),Ne.detail=Ee.detail,Ne.documentation=I.isMarkdownString(Ee.documentation)?H.to(Ee.documentation):Ee.documentation,Ne.sortText=Ee.sortText,Ne.filterText=Ee.filterText,Ne.preselect=Ee.preselect,Ne.commitCharacters=Ee.commitCharacters,k.Range.isIRange(Ee.range)?Ne.range=u.to(Ee.range):typeof Ee.range=="object"&&(Ne.range={inserting:u.to(Ee.range.insert),replacing:u.to(Ee.range.replace)}),Ne.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:Boolean(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Ne.insertText=new r.SnippetString(Ee.insertText):(Ne.insertText=Ee.insertText,Ne.textEdit=Ne.range instanceof r.Range?new r.TextEdit(Ne.range,Ne.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Ee.additionalTextEdits.map($e=>z.to($e))),Ne.command=te&&Ee.command?te.fromInternal(Ee.command):void 0,Ne}Ae.to=Oe})(O=e.CompletionItem||(e.CompletionItem={}));var W;(function(Ae){function Oe(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:H.fromStrict(te.documentation)}}Ae.from=Oe;function Ee(te){return{label:te.label,documentation:I.isMarkdownString(te.documentation)?H.to(te.documentation):te.documentation}}Ae.to=Ee})(W=e.ParameterInformation||(e.ParameterInformation={}));var q;(function(Ae){function Oe(te){return{label:te.label,documentation:H.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(W.from):[],activeParameter:te.activeParameter}}Ae.from=Oe;function Ee(te){return{label:te.label,documentation:I.isMarkdownString(te.documentation)?H.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(W.to):[],activeParameter:te.activeParameter}}Ae.to=Ee})(q=e.SignatureInformation||(e.SignatureInformation={}));var X;(function(Ae){function Oe(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(q.from):[]}}Ae.from=Oe;function Ee(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(q.to):[]}}Ae.to=Ee})(X=e.SignatureHelp||(e.SignatureHelp={}));var ae;(function(Ae){function Oe(Ee,te){const Ne=new r.InlayHint(l.to(te.position),typeof te.label=="string"?te.label:te.label.map(ve.to.bind(void 0,Ee)),te.kind&&Te.to(te.kind));return Ne.textEdits=te.textEdits&&te.textEdits.map(z.to),Ne.tooltip=I.isMarkdownString(te.tooltip)?H.to(te.tooltip):te.tooltip,Ne.paddingLeft=te.paddingLeft,Ne.paddingRight=te.paddingRight,Ne}Ae.to=Oe})(ae=e.InlayHint||(e.InlayHint={}));var ve;(function(Ae){function Oe(Ee,te){const Ne=new r.InlayHintLabelPart(te.label);return Ne.tooltip=I.isMarkdownString(te.tooltip)?H.to(te.tooltip):te.tooltip,E.Command.is(te.command)&&(Ne.command=Ee.fromInternal(te.command)),te.location&&(Ne.location=pe.to(te.location)),Ne}Ae.to=Oe})(ve=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Te;(function(Ae){function Oe(te){return te}Ae.from=Oe;function Ee(te){return te}Ae.to=Ee})(Te=e.InlayHintKind||(e.InlayHintKind={}));var ge;(function(Ae){function Oe(te){return{range:u.from(te.range),url:te.target,tooltip:te.tooltip}}Ae.from=Oe;function Ee(te){let Ne;if(te.url)try{Ne=typeof te.url=="string"?A.URI.parse(te.url,!0):A.URI.revive(te.url)}catch{}return new r.DocumentLink(u.to(te.range),Ne)}Ae.to=Ee})(ge=e.DocumentLink||(e.DocumentLink={}));var Pe;(function(Ae){function Oe(te){const Ne=new r.ColorPresentation(te.label);return te.textEdit&&(Ne.textEdit=z.to(te.textEdit)),te.additionalTextEdits&&(Ne.additionalTextEdits=te.additionalTextEdits.map($e=>z.to($e))),Ne}Ae.to=Oe;function Ee(te){return{label:te.label,textEdit:te.textEdit?z.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Ne=>z.from(Ne)):void 0}}Ae.from=Ee})(Pe=e.ColorPresentation||(e.ColorPresentation={}));var De;(function(Ae){function Oe(te){return new r.Color(te[0],te[1],te[2],te[3])}Ae.to=Oe;function Ee(te){return[te.red,te.green,te.blue,te.alpha]}Ae.from=Ee})(De=e.Color||(e.Color={}));var xe;(function(Ae){function Oe(te){return{range:u.from(te.range)}}Ae.from=Oe;function Ee(te){return new r.SelectionRange(u.to(te.range))}Ae.to=Ee})(xe=e.SelectionRange||(e.SelectionRange={}));var je;(function(Ae){function Oe(Ee){switch(Ee){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Ae){function Oe(te){switch(te){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function Ee(te){switch(te){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Ae.to=Ee})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Xe;(function(Ae){function Oe(te){if(te===r.EndOfLine.CRLF)return 1;if(te===r.EndOfLine.LF)return 0}Ae.from=Oe;function Ee(te){if(te===1)return r.EndOfLine.CRLF;if(te===0)return r.EndOfLine.LF}Ae.to=Ee})(Xe=e.EndOfLine||(e.EndOfLine={}));var rt;(function(Ae){function Oe(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(rt=e.ProgressLocation||(e.ProgressLocation={}));var Be;(function(Ae){function Oe(Ee){const te={start:Ee.start+1,end:Ee.end+1};return Ee.kind&&(te.kind=dt.from(Ee.kind)),te}Ae.from=Oe})(Be=e.FoldingRange||(e.FoldingRange={}));var dt;(function(Ae){function Oe(Ee){if(Ee)switch(Ee){case r.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}Ae.from=Oe})(dt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var se;(function(Ae){function Oe(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?u.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?f.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Oe})(se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var oe;(function(Ae){function Oe($e){return $e instanceof r.RelativePattern?$e.toJSON():typeof $e=="string"?$e:Ee($e)||te($e)?new r.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}Ae.from=Oe;function Ee($e){const tt=$e;return tt?A.URI.isUri(tt.baseUri)&&typeof tt.pattern=="string":!1}function te($e){const tt=$e;return tt?typeof tt.base=="string"&&typeof tt.pattern=="string":!1}function Ne($e){return typeof $e=="string"?$e:new r.RelativePattern(A.URI.revive($e.baseUri),$e.pattern)}Ae.to=Ne})(oe=e.GlobPattern||(e.GlobPattern={}));var Se;(function(Ae){function Oe(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(Oe);if(typeof Ee=="string")return Ee;{const te=Ee;return{language:te.language,scheme:te.scheme,pattern:oe.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Ae.from=Oe})(Se=e.LanguageSelector||(e.LanguageSelector={}));var ue;(function(Ae){function Oe(te){return{start:te.start,end:te.end}}Ae.from=Oe;function Ee(te){return new r.NotebookRange(te.start,te.end)}Ae.to=Ee})(ue=e.NotebookRange||(e.NotebookRange={}));var Ie;(function(Ae){function Oe(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Ae.to=Oe;function Ee(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Ae.from=Ee})(Ie=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Le;(function(Ae){function Oe(Ee){if(Ee===g.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ee===g.NotebookCellExecutionState.Pending)return;if(Ee===g.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Ae.to=Oe})(Le=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Fe;(function(Ae){function Oe(te){switch(te){case r.NotebookCellKind.Markup:return g.CellKind.Markup;case r.NotebookCellKind.Code:default:return g.CellKind.Code}}Ae.from=Oe;function Ee(te){switch(te){case g.CellKind.Markup:return r.NotebookCellKind.Markup;case g.CellKind.Code:default:return r.NotebookCellKind.Code}}Ae.to=Ee})(Fe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ge;(function(Ae){function Oe(te){const Ne={metadata:te.metadata??Object.create(null),cells:[]};for(const $e of te.cells)r.NotebookCellData.validate($e),Ne.cells.push(Ye.from($e));return Ne}Ae.from=Oe;function Ee(te){const Ne=new r.NotebookData(te.cells.map(Ye.to));return(0,D.isEmptyObject)(te.metadata)||(Ne.metadata=te.metadata),Ne}Ae.to=Ee})(Ge=e.NotebookData||(e.NotebookData={}));var Ye;(function(Ae){function Oe(te){return{cellKind:Fe.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Ie.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(bt.from):[]}}Ae.from=Oe;function Ee(te){return new r.NotebookCellData(Fe.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(bt.to):void 0,te.metadata,te.internalMetadata?Ie.to(te.internalMetadata):void 0)}Ae.to=Ee})(Ye=e.NotebookCellData||(e.NotebookCellData={}));var it;(function(Ae){function Oe(te){return{mime:te.mime,valueBytes:t.VSBuffer.wrap(te.data)}}Ae.from=Oe;function Ee(te){return new r.NotebookCellOutputItem(te.valueBytes.buffer,te.mime)}Ae.to=Ee})(it=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var bt;(function(Ae){function Oe(te){return{outputId:te.id,items:te.items.map(it.from),metadata:te.metadata}}Ae.from=Oe;function Ee(te){const Ne=te.items.map(it.to);return new r.NotebookCellOutput(Ne,te.outputId,te.metadata)}Ae.to=Ee})(bt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var st;(function(Ae){function Oe(Ne){return te(Ne)?{include:(0,D.withNullAsUndefined)(oe.from(Ne.include)),exclude:(0,D.withNullAsUndefined)(oe.from(Ne.exclude))}:(0,D.withNullAsUndefined)(oe.from(Ne))}Ae.from=Oe;function Ee(Ne){return te(Ne)?{include:oe.to(Ne.include),exclude:oe.to(Ne.exclude)}:oe.to(Ne)}Ae.to=Ee;function te(Ne){const $e=Ne;return $e?!(0,D.isUndefinedOrNull)($e.include)&&!(0,D.isUndefinedOrNull)($e.exclude):!1}})(st=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var et;(function(Ae){function Oe(Ee,te,Ne){const $e=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal($e,Ne),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Ae.from=Oe})(et=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var wt;(function(Ae){function Oe(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Ae.from=Oe})(wt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var St;(function(Ae){function Oe(te){return{uri:te.uri,provides:te.provides}}Ae.from=Oe;function Ee(te){return new r.NotebookRendererScript(A.URI.revive(te.uri),te.provides)}Ae.to=Ee})(St=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Dt;(function(Ae){function Oe(te){return{message:H.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,location:te.location&&{range:u.from(te.location.range),uri:te.location.uri}}}Ae.from=Oe;function Ee(te){const Ne=new r.TestMessage(typeof te.message=="string"?te.message:H.to(te.message));return Ne.actualOutput=te.actual,Ne.expectedOutput=te.expected,Ne.location=te.location?pe.to(te.location):void 0,Ne}Ae.to=Ee})(Dt=e.TestMessage||(e.TestMessage={}));var ft;(function(Ae){Ae.namespace=v.namespaceTestTag,Ae.denamespace=v.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var kt;(function(Ae){function Oe(te){const Ne=(0,w.getPrivateApiFor)(te).controllerId;return{extId:h.TestId.fromExtHostTestItem(te,Ne).toString(),label:te.label,uri:A.URI.revive(te.uri),busy:te.busy,tags:te.tags.map($e=>ft.namespace(Ne,$e.id)),range:k.Range.lift(u.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&H.fromStrict(te.error)||null}}Ae.from=Oe;function Ee(te){return{parent:void 0,error:void 0,id:h.TestId.fromString(te.extId).localId,label:te.label,uri:A.URI.revive(te.uri),tags:(te.tags||[]).map(Ne=>{const{tagId:$e}=ft.denamespace(Ne);return new r.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Ae.toPlain=Ee})(kt=e.TestItem||(e.TestItem={})),function(Ae){function Oe(te){return{id:te.id}}Ae.from=Oe;function Ee(te){return new r.TestTag(te.id)}Ae.to=Ee}(ft=e.TestTag||(e.TestTag={}));var Ut;(function(Ae){const Oe=(te,Ne)=>{const $e=[];for(const[qe,ot]of Ne)h.TestId.compare(ot.item.extId,qe)===2&&(Ne.delete(qe),$e.push(ot));const tt={...kt.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ot=>ot.type===0).map(Dt.to)})),children:$e.map(qe=>Oe(qe,Ne))};for(const qe of tt.children)qe.parent=tt;return tt};function Ee(te){const Ne=[],$e=new Map;for(const tt of te.items){$e.set(tt.item.extId,tt);const qe=h.TestId.root(tt.item.extId);te.request.targets.some(ot=>ot.controllerId===qe&&ot.testIds.includes(tt.item.extId))&&Ne.push(tt)}return{completedAt:te.completedAt,results:Ne.map(tt=>Oe(tt,$e))}}Ae.to=Ee})(Ut=e.TestResults||(e.TestResults={}));var Lt;(function(Ae){function Oe($e){return{covered:$e.covered,total:$e.covered}}function Ee($e){return"line"in $e?l.from($e):u.from($e)}function te($e){return"branches"in $e?{count:$e.executionCount,location:Ee($e.location),type:1,branches:$e.branches.length?$e.branches.map(tt=>({count:tt.executionCount,location:tt.location&&Ee(tt.location)})):void 0}:{type:0,count:$e.executionCount,location:Ee($e.location)}}Ae.fromDetailed=te;function Ne($e){return{uri:$e.uri,statement:Oe($e.statementCoverage),branch:$e.branchCoverage&&Oe($e.branchCoverage),function:$e.functionCoverage&&Oe($e.functionCoverage),details:$e.detailedCoverage?.map(te)}}Ae.fromFile=Ne})(Lt=e.TestCoverage||(e.TestCoverage={}));var Qe;(function(Ae){function Oe(Ee){switch(Ee){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(Qe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Pt;(function(Ae){function Oe(te){const Ne=new r.TypeHierarchyItem(x.to(te.kind),te.name,te.detail||"",A.URI.revive(te.uri),u.to(te.range),u.to(te.selectionRange));return Ne._sessionId=te._sessionId,Ne._itemId=te._itemId,Ne}Ae.to=Oe;function Ee(te,Ne,$e){if(Ne=Ne??te._sessionId,$e=$e??te._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,kind:x.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:u.from(te.range),selectionRange:u.from(te.selectionRange),tags:te.tags?.map(Q.from)}}Ae.from=Ee})(Pt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ot;(function(Ae){function Oe(Ee){if(!!Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Ae.from=Oe})(Ot=e.ViewBadge||(e.ViewBadge={}));var Bt;(function(Ae){function Oe(Ee,te){const Ne=Ee.fileData;return Ne?new class extends r.DataTransferItem{asFile(){return{name:Ne.name,uri:A.URI.revive(Ne.uri),data:(0,b.once)(()=>te())}}}("",Ee.id):new r.DataTransferItem(Ee.asString)}Ae.toDataTransferItem=Oe})(Bt=e.DataTransferItem||(e.DataTransferItem={}));var pt;(function(Ae){function Oe(te,Ne){const $e=te.items.map(([tt,qe])=>[tt,Bt.toDataTransferItem(qe,()=>Ne(qe.id))]);return new r.DataTransfer($e)}Ae.toDataTransfer=Oe;async function Ee(te){const Ne={items:[]},$e=[];return te.forEach((tt,qe)=>{$e.push((async()=>{const ot=await tt.asString(),ct=tt.asFile();Ne.items.push([qe,{id:tt.id,asString:ot,fileData:ct?{name:ct.name,uri:ct.uri}:void 0}])})())}),await Promise.all($e),Ne}Ae.toDataTransferDTO=Ee})(pt=e.DataTransfer||(e.DataTransfer={}))}),define(_e[231],ye([1,0,2,10,7,15,63]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(D,A,k,E={timeout:1500,errors:3}){this._logService=D,this._documents=A,this._mainThreadBulkEdits=k,this._thresholds=E,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(D){return(A,k,E)=>{const w={dispose:this._callbacks.push([A,k,D])};return Array.isArray(E)&&E.push(w),w}}async $participateInSave(D,A){const k=c.URI.revive(D);let E=!1;const _=setTimeout(()=>E=!0,this._thresholds.timeout),w=[];try{for(const f of[...this._callbacks]){if(E)break;const g=this._documents.getDocument(k),h=await this._deliverEventAsyncAndBlameBadListeners(f,{document:g,reason:P.TextDocumentSaveReason.to(A)});w.push(h)}}finally{clearTimeout(_)}return w}_deliverEventAsyncAndBlameBadListeners([D,A,k],E){const _=this._badListeners.get(D);return typeof _=="number"&&_>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,D,A,E).then(()=>!0,w=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(w),!(w instanceof Error)||w.message!=="concurrent_edits"){const f=this._badListeners.get(D);this._badListeners.set(D,f?f+1:1),typeof f=="number"&&f>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(D,A,k,E){const _=[],w=Date.now(),{document:f,reason:g}=E,{version:h}=f,v=Object.freeze({document:f,reason:g,waitUntil(m){if(Object.isFrozen(_))throw(0,t.illegalState)("waitUntil can not be called async");_.push(Promise.resolve(m))}});try{A.apply(k,[v])}catch(m){return Promise.reject(m)}return Object.freeze(_),new Promise((m,r)=>{const b=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(_).then(s=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-w}ms`),clearTimeout(b),m(s)}).catch(s=>{clearTimeout(b),r(s)})}).then(m=>{const r={edits:[]};for(const b of m)if(Array.isArray(b)&&b.every(s=>s instanceof I.TextEdit))for(const{newText:s,newEol:u,range:o}of b)r.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:o&&P.Range.from(o),text:s,eol:u&&P.EndOfLine.from(u)}});if(r.edits.length!==0)return h===f.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(_e[232],ye([1,0,14,2,15,7,90]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(k,E,_,w){this.start=k,this.deletedCount=E,this.deletedItems=_,this.items=w}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(k,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,E,_){this.notebook=k,this._extHostDocument=E,this._cellData=_,this.handle=_.handle,this.uri=t.URI.revive(_.uri),this.cellKind=_.cellKind,this._outputs=_.outputs.map(I.NotebookCellOutput.to),this._internalMetadata=_.internalMetadata??{},this._metadata=Object.freeze(_.metadata??{}),this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(_.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,E=this._extHostDocument.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const _={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:I.NotebookCellKind.to(this._cellData.cellKind),document:E.document,get mime(){return k._mime},set mime(w){k._mime=w},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(_)}return this._apiCell}setOutputs(k){this._outputs=k.map(I.NotebookCellOutput.to)}setOutputItems(k,E,_){const w=_.map(I.NotebookCellOutputItem.to),f=this._outputs.find(g=>g.id===k);if(f&&(E||(f.items.length=0),f.items.push(...w),f.items.length>1&&f.items.every(g=>y.isTextStreamMime(g.mime)))){const g=new Map,h=[];f.items.forEach(v=>{let m;g.has(v.mime)?m=g.get(v.mime):(m=[],g.set(v.mime,m),h.push(v.mime)),m.push(v.data)}),f.items.length=0,h.forEach(v=>{const m=y.compressOutputItemStreams(g.get(v));f.items.push({mime:v,data:m.buffer})})}}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=S;class D{constructor(k,E,_,w,f){this._proxy=k,this._textDocumentsAndEditors=E,this._textDocuments=_,this.uri=w,this.handle=D._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=f.viewType,this._metadata=Object.freeze(f.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,f.cells]],!0,void 0),this._versionId=f.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const k=this,E={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===c.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(_){return _=k._validateIndex(_),k._cells[_].apiCell},getCells(_){return(_?k._getCells(_):k._cells).map(f=>f.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(E)}return this._notebook}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,E,_){this._versionId=k.versionId,this._isDirty=E,this.acceptDocumentPropertiesChanged({metadata:_});const w={notebook:this.apiNotebook,metadata:_,cellChanges:[],contentChanges:[]},f=[];for(const h of k.rawEvents)h.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1,w.contentChanges):h.kind===y.NotebookCellsChangeType.Move?this._moveCells(h.index,h.length,h.newIdx,w.contentChanges):h.kind===y.NotebookCellsChangeType.Output?(this._setCellOutputs(h.index,h.outputs),f.push({cell:this._cells[h.index].apiCell,outputs:this._cells[h.index].apiCell.outputs})):h.kind===y.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems),f.push({cell:this._cells[h.index].apiCell,outputs:this._cells[h.index].apiCell.outputs})):h.kind===y.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(h.index,h.language),f.push({cell:this._cells[h.index].apiCell,document:this._cells[h.index].apiCell.document})):h.kind===y.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this._cells[h.index].apiCell,document:this._cells[h.index].apiCell.document}):h.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===y.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(h.index,h.metadata),f.push({cell:this._cells[h.index].apiCell,metadata:this._cells[h.index].apiCell.metadata})):h.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(h.index,h.internalMetadata),f.push({cell:this._cells[h.index].apiCell,executionSummary:this._cells[h.index].apiCell.executionSummary}));const g=new Map;for(let h=0;h<f.length;h++){const v=f[h],m=g.get(v.cell);if(m===void 0){const r=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});g.set(v.cell,r-1)}else w.cellChanges[m]={...w.cellChanges[m],...v}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let E=k.start|0,_=k.end|0;return E<0&&(E=0),_>this._cells.length&&(_=this._cells.length),k.with({start:E,end:_})}_getCells(k){k=this._validateRange(k);const E=[];for(let _=k.start;_<k.end;_++)E.push(this._cells[_]);return E}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,E,_){if(this._disposed)return;const w=[],f=[],g=[];if(k.reverse().forEach(h=>{const m=h[2].map(s=>{const u=new S(this,this._textDocumentsAndEditors,s);return E||f.push(S.asModelAddData(this.apiNotebook,s)),u}),r=new T(h[0],h[1],[],m),b=this._cells.splice(h[0],h[1],...m);for(const s of b)g.push(s.uri),r.deletedItems.push(s.apiCell);w.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:g}),_)for(const h of w)_.push(h.asApiEvent())}_moveCells(k,E,_,w){const f=this._cells.splice(k,E);this._cells.splice(_,0,...f);const g=[new T(k,E,f.map(h=>h.apiCell),[]),new T(_,0,[],f)];for(const h of g)w.push(h.asApiEvent())}_setCellOutputs(k,E){this._cells[k].setOutputs(E)}_setCellOutputItems(k,E,_,w){this._cells[k].setOutputItems(E,_,w)}_changeCellLanguage(k,E){const _=this._cells[k];_.apiCell.document.languageId!==E&&this._textDocuments.$acceptModelLanguageChanged(_.uri,E)}_changeCellMime(k,E){const _=this._cells[k];_.apiCell.mime=E}_changeCellMetadata(k,E){this._cells[k].setMetadata(E)}_changeCellInternalMetadata(k,E){this._cells[k].setInternalMetadata(E)}getCellFromApiCell(k){return this._cells.find(E=>E.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(E=>E.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=D,D._handlePool=0}),define(_e[134],ye([1,0,10,15,7]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(T,S,D,A,k,E){this.id=T,this._proxy=S,this.notebookData=D,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=k,this._visibleRanges=A,this._viewColumn=E}get apiEditor(){if(!this._editor){const T=this;this._editor={get notebook(){return T.notebookData.apiNotebook},get selection(){return T._selections[0]},set selection(S){this.selections=[S]},get selections(){return T._selections},set selections(S){if(!Array.isArray(S)||!S.every(I.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");T._selections=S,T._trySetSelections(S)},get visibleRanges(){return T._visibleRanges},revealRange(S,D){T._proxy.$tryRevealRange(T.id,t.NotebookRange.from(S),D??I.NotebookEditorRevealType.Default)},get viewColumn(){return T._viewColumn}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(T){this._visible=T}_acceptVisibleRanges(T){this._visibleRanges=T}_acceptSelections(T){this._selections=T}_trySetSelections(T){this._proxy.$trySetSelections(this.id,T.map(t.NotebookRange.from))}_acceptViewColumn(T){this._viewColumn=T}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(_e[233],ye([1,0,4,13,15]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(T,S){this._logService=T,this._notebooksAndEditors=S,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(T,S){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,S);const D=this._notebooksAndEditors.getEditorById(T);S.visibleRanges&&D._acceptVisibleRanges(S.visibleRanges.ranges.map(I.NotebookRange.to)),S.selections&&D._acceptSelections(S.selections.selections.map(I.NotebookRange.to)),S.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),S.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const S in T)this._notebooksAndEditors.getEditorById(S)._acceptViewColumn(I.ViewColumn.to(T[S]))}};P=Ve([ze(0,t.ILogService)],P),e.ExtHostNotebookEditors=P}),define(_e[234],ye([1,0,15,124,173,21,60,10]),function(Z,e,c,t,I,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(E){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=E}async withProgress(E,_,w){const f=this._handles++,{title:g,location:h,cancellable:v}=_,m={label:(0,I.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this._proxy.$startProgress(f,{location:c.ProgressLocation.from(h),title:g,source:m,cancellable:v},E.isUnderDevelopment?void 0:E.identifier.value).catch(T.onUnexpectedExternalError),this._withProgress(f,w,!!v)}_withProgress(E,_,w){let f;w&&(f=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(E,f));const g=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),f?.dispose()};let h;try{h=_(new A(this._proxy,E),w&&f?f.token:P.CancellationToken.None)}catch(v){throw g(E),v}return h.then(v=>g(E),v=>g(E)),h}$acceptProgressCanceled(E){const _=this._mapHandleToCancellationSource.get(E);_&&(_.cancel(),this._mapHandleToCancellationSource.delete(E))}}e.ExtHostProgress=S;function D(k,E){return k.message=E.message,typeof E.increment=="number"&&(typeof k.increment=="number"?k.increment+=E.increment:k.increment=E.increment),k}class A extends t.Progress{constructor(E,_){super(w=>this.throttledReport(w)),this._proxy=E,this._handle=_}throttledReport(E){this._proxy.$progressReport(this._handle,E)}}Ve([(0,y.throttle)(100,(k,E)=>D(k,E),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(_e[135],ye([1,0,35,131,56,91,67,15,2]),function(Z,e,c,t,I,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const D=(m,r,b,s)=>{let u=r;return{enumerable:!0,configurable:!1,get(){return u},set(o){if(!b(u,o)){const l=u;u=o,m.listener?.(s(o,l))}}}},A=(m,r)=>m===r,k={range:(m,r)=>m===r?!0:!m||!r?!1:m.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(m,r)=>!(m.length!==r.length||m.some(b=>!r.find(s=>b.id===s.id)))},E=m=>r=>({op:4,update:m(r)}),_=(m,r)=>({range:(()=>{let b;const s=E(u=>({range:c.Range.lift(T.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return b},set(u){m.listener?.({op:6}),k.range(b,u)||(b=u,m.listener?.(s(u)))}}})(),label:D(m,r,k.label,E(b=>({label:b}))),description:D(m,void 0,k.description,E(b=>({description:b}))),sortText:D(m,void 0,k.sortText,E(b=>({sortText:b}))),canResolveChildren:D(m,!1,k.canResolveChildren,b=>({op:2,state:b})),busy:D(m,!1,k.busy,E(b=>({busy:b}))),error:D(m,void 0,k.error,E(b=>({error:T.MarkdownString.fromStrict(b)||null}))),tags:D(m,[],k.tags,(b,s)=>({op:1,new:b.map(T.TestTag.from),old:s.map(T.TestTag.from)}))}),w=m=>{const r=I.TestId.fromString(m.extId),b=new g(r.controllerId,r.localId,m.label,S.URI.revive(m.uri)||void 0);return b.range=T.Range.to(m.range||void 0),b.description=m.description||void 0,b.sortText=m.sortText||void 0,b.tags=m.tags.map(s=>T.TestTag.to({id:(0,y.denamespaceTestTag)(s).tagId})),b},f=m=>{let r;for(const b of m.tests){const s=w(b.item);(0,t.getPrivateApiFor)(s).parent=r,r=s}return r};e.toItemFromContext=f;class g{constructor(r,b,s,u){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const o=(0,t.createPrivateApiFor)(this,r);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof h?void 0:o.parent}},children:{value:(0,P.createTestItemChildren)(o,t.getPrivateApiFor,g),enumerable:!0,writable:!1},..._(o,s)})}}e.TestItemImpl=g;class h extends g{constructor(r,b){super(r,r,b,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class v extends P.TestItemCollection{constructor(r,b,s){super({controllerId:r,getDocumentVersion:u=>u&&s.getDocument(u)?.version,getApiFor:t.getPrivateApiFor,getChildren:u=>u.children,root:new h(r,b),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(_e[136],ye([1,0,48,10,98,15,7]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class T{constructor(E,_,w){const f=T._Keys.nextId();E.$registerTextEditorDecorationType(_.identifier,f,P.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:f,dispose(){E.$removeTextEditorDecorationType(f)}})}}e.TextEditorDecorationType=T,T._Keys=new I.IdGenerator("TextEditorDecorationType");class S{constructor(E,_){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=E,this._documentVersionId=E.version,this._undoStopBefore=_.undoStopBefore,this._undoStopAfter=_.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(E,_){this._throwIfFinalized();let w=null;if(E instanceof y.Position)w=new y.Range(E,E);else if(E instanceof y.Range)w=E;else throw new Error("Unrecognized location");this._pushEdit(w,_,!1)}insert(E,_){this._throwIfFinalized(),this._pushEdit(new y.Range(E,E),_,!0)}delete(E){this._throwIfFinalized();let _=null;if(E instanceof y.Range)_=E;else throw new Error("Unrecognized location");this._pushEdit(_,null,!0)}_pushEdit(E,_,w){const f=this._document.validateRange(E);this._collectedEdits.push({range:f,text:_,forceMoveMarkers:w})}setEndOfLine(E){if(this._throwIfFinalized(),E!==y.EndOfLine.LF&&E!==y.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=E}}e.TextEditorEdit=S;class D{constructor(E,_,w,f){this._proxy=E,this._id=_,this._accept(w),this._logService=f;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(h){g._setTabSize(h)},get insertSpaces(){return g._insertSpaces},set insertSpaces(h){g._setInsertSpaces(h)},get cursorStyle(){return g._cursorStyle},set cursorStyle(h){g._setCursorStyle(h)},get lineNumbers(){return g._lineNumbers},set lineNumbers(h){g._setLineNumbers(h)}}}_accept(E){this._tabSize=E.tabSize,this._insertSpaces=E.insertSpaces,this._cursorStyle=E.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(E.lineNumbers)}_validateTabSize(E){if(E==="auto")return"auto";if(typeof E=="number"){const _=Math.floor(E);return _>0?_:null}if(typeof E=="string"){const _=parseInt(E,10);return isNaN(_)?null:_>0?_:null}return null}_setTabSize(E){const _=this._validateTabSize(E);if(_!==null){if(typeof _=="number"){if(this._tabSize===_)return;this._tabSize=_}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:_}))}}_validateInsertSpaces(E){return E==="auto"?"auto":E==="false"?!1:Boolean(E)}_setInsertSpaces(E){const _=this._validateInsertSpaces(E);if(typeof _=="boolean"){if(this._insertSpaces===_)return;this._insertSpaces=_}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:_}))}_setCursorStyle(E){this._cursorStyle!==E&&(this._cursorStyle=E,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:E})))}_setLineNumbers(E){this._lineNumbers!==E&&(this._lineNumbers=E,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(E)})))}assign(E){const _={};let w=!1;if(typeof E.tabSize<"u"){const f=this._validateTabSize(E.tabSize);f==="auto"?(w=!0,_.tabSize=f):typeof f=="number"&&this._tabSize!==f&&(this._tabSize=f,w=!0,_.tabSize=f)}if(typeof E.insertSpaces<"u"){const f=this._validateInsertSpaces(E.insertSpaces);f==="auto"?(w=!0,_.insertSpaces=f):this._insertSpaces!==f&&(this._insertSpaces=f,w=!0,_.insertSpaces=f)}typeof E.cursorStyle<"u"&&this._cursorStyle!==E.cursorStyle&&(this._cursorStyle=E.cursorStyle,w=!0,_.cursorStyle=E.cursorStyle),typeof E.lineNumbers<"u"&&this._lineNumbers!==E.lineNumbers&&(this._lineNumbers=E.lineNumbers,w=!0,_.lineNumbers=P.TextEditorLineNumbersStyle.from(E.lineNumbers)),w&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,_))}_warnOnError(E,_){_.catch(w=>{this._logService.warn(`ExtHostTextEditorOptions '${E}' failed:'`),this._logService.warn(w)})}}e.ExtHostTextEditorOptions=D;class A{constructor(E,_,w,f,g,h,v,m){this.id=E,this._proxy=_,this._logService=w,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new D(this._proxy,this.id,h,w),this._visibleRanges=v,this._viewColumn=m;const r=this;this.value=Object.freeze({get document(){return f.getValue()},set document(b){throw(0,t.readonly)("document")},get selection(){return r._selections&&r._selections[0]},set selection(b){if(!(b instanceof y.Selection))throw(0,t.illegalArgument)("selection");r._selections=[b],r._trySetSelection()},get selections(){return r._selections},set selections(b){if(!Array.isArray(b)||b.some(s=>!(s instanceof y.Selection)))throw(0,t.illegalArgument)("selections");r._selections=b,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(b){throw(0,t.readonly)("visibleRanges")},get options(){return r._options.value},set options(b){r._disposed||r._options.assign(b)},get viewColumn(){return r._viewColumn},set viewColumn(b){throw(0,t.readonly)("viewColumn")},edit(b,s={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new S(f.getValue(),s);return b(u),r._applyEdit(u)},insertSnippet(b,s,u={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!s||Array.isArray(s)&&s.length===0)o=r._selections.map(l=>P.Range.from(l));else if(s instanceof y.Position){const{lineNumber:l,column:a}=P.Position.from(s);o=[{startLineNumber:l,startColumn:a,endLineNumber:l,endColumn:a}]}else if(s instanceof y.Range)o=[P.Range.from(s)];else{o=[];for(const l of s)if(l instanceof y.Range)o.push(P.Range.from(l));else{const{lineNumber:a,column:d}=P.Position.from(l);o.push({startLineNumber:a,startColumn:d,endLineNumber:a,endColumn:d})}}return _.$tryInsertSnippet(E,f.getValue().version,b.value,o,u)},setDecorations(b,s){const u=s.length===0;u&&!r._hasDecorationsForKey.has(b.key)||(u?r._hasDecorationsForKey.delete(b.key):r._hasDecorationsForKey.add(b.key),r._runOnProxy(()=>{if(P.isDecorationOptionsArr(s))return _.$trySetDecorations(E,b.key,P.fromRangeOrRangeWithMessage(s));{const o=new Array(4*s.length);for(let l=0,a=s.length;l<a;l++){const d=s[l];o[4*l]=d.start.line+1,o[4*l+1]=d.start.character+1,o[4*l+2]=d.end.line+1,o[4*l+3]=d.end.character+1}return _.$trySetDecorationsFast(E,b.key,o)}}))},revealRange(b,s){r._runOnProxy(()=>_.$tryRevealRange(E,P.Range.from(b),s||y.TextEditorRevealType.Default))},show(b){_.$tryShowEditor(E,P.ViewColumn.from(b))},hide(){_.$tryHideEditor(E)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(E){(0,c.ok)(!this._disposed),this._options._accept(E)}_acceptVisibleRanges(E){(0,c.ok)(!this._disposed),this._visibleRanges=E}_acceptViewColumn(E){(0,c.ok)(!this._disposed),this._viewColumn=E}_acceptSelections(E){(0,c.ok)(!this._disposed),this._selections=E}async _trySetSelection(){const E=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,E)),this.value}_applyEdit(E){const _=E.finalize();if(_.edits.length===0&&!_.setEndOfLine)return Promise.resolve(!0);const w=_.edits.map(g=>g.range);w.sort((g,h)=>g.end.line===h.end.line?g.end.character===h.end.character?g.start.line===h.start.line?g.start.character-h.start.character:g.start.line-h.start.line:g.end.character-h.end.character:g.end.line-h.end.line);for(let g=0,h=w.length-1;g<h;g++){const v=w[g].end;if(w[g+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=_.edits.map(g=>({range:P.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,f,{setEndOfLine:typeof _.setEndOfLine=="number"?P.EndOfLine.from(_.setEndOfLine):void 0,undoStopBefore:_.undoStopBefore,undoStopAfter:_.undoStopAfter})}_runOnProxy(E){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):E().then(()=>this,_=>(_ instanceof Error&&_.name==="DISPOSED"||this._logService.warn(_),null))}}e.ExtHostTextEditor=A}),define(_e[235],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribTerminalQuickFixes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribTerminalQuickFixes.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(_e[236],ye([1,0,187,10,42,121,125,43,26,235,198]),function(Z,e,c,t,I,P,y,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const k=T.Registry.as(y.Extensions.JSONContribution);class E{constructor(r,b,s){this._messageHandler=r,this._extension=b,this._extensionPointId=s}_msg(r,b){this._messageHandler({type:r,message:b,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(r){this._msg(I.default.Error,r)}warn(r){this._msg(I.default.Warning,r)}info(r){this._msg(I.default.Info,r)}}e.ExtensionMessageCollector=E;class _{static _toSet(r){const b=new Set;for(let s=0,u=r.length;s<u;s++)b.add(S.ExtensionIdentifier.toKey(r[s].description.identifier));return b}static compute(r,b){if(!r||!r.length)return new _(b,[]);if(!b||!b.length)return new _([],r);const s=this._toSet(r),u=this._toSet(b),o=b.filter(a=>!s.has(S.ExtensionIdentifier.toKey(a.description.identifier))),l=r.filter(a=>!u.has(S.ExtensionIdentifier.toKey(a.description.identifier)));return new _(o,l)}constructor(r,b){this.added=r,this.removed=b}}e.ExtensionPointUserDelta=_;class w{constructor(r,b){this.name=r,this.defaultExtensionKind=b,this._handler=null,this._users=null,this._delta=null}setHandler(r){if(this._handler!==null)throw new Error("Handler already set!");this._handler=r,this._handle()}acceptUsers(r){this._delta=_.compute(this._users,r),this._users=r,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(r){(0,t.onUnexpectedError)(r)}}}e.ExtensionPoint=w;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},g="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},activationEvents:{description:c.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(30,null)},{label:"onUri",body:"onUri",description:c.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(35,null)},{label:"onRenderer",description:c.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(38,null)},{label:"*",description:c.localize(39,null),body:"*"}]}},badges:{type:"array",description:c.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(41,null)},href:{type:"string",description:c.localize(42,null)},description:{type:"string",description:c.localize(43,null)}}}},markdown:{type:"string",description:c.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(48,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(49,null)},{body:["workspace"],description:c.localize(50,null)},{body:["ui","workspace"],description:c.localize(51,null)},{body:["workspace","ui"],description:c.localize(52,null)},{body:[],description:c.localize(53,null)}]},capabilities:{description:c.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(57,null),c.localize(58,null),c.localize(59,null)]},description:{type:"string",markdownDescription:c.localize(60,null)}}},untrustedWorkspaces:{description:c.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(63,null),c.localize(64,null),c.localize(65,null)]},restrictedConfigurations:{description:c.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(67,null)}}}}},sponsor:{description:c.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(70,null),type:"string"},"vscode:uninstall":{description:c.localize(71,null),type:"string"}}},icon:{type:"string",description:c.localize(72,null)},l10n:{type:"string",description:c.localize(73,null)}}};class h{constructor(){this._extensionPoints=new Map}registerExtensionPoint(r){if(this._extensionPoints.has(r.extensionPoint))throw new Error("Duplicate extension point: "+r.extensionPoint);const b=new w(r.extensionPoint,r.defaultExtensionKind);return this._extensionPoints.set(r.extensionPoint,b),e.schema.properties.contributes.properties[r.extensionPoint]=r.jsonSchema,k.registerSchema(g,e.schema),b}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=h;const v={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(v.ExtensionsRegistry,new h),e.ExtensionsRegistry=T.Registry.as(v.ExtensionsRegistry),k.registerSchema(g,e.schema),k.registerSchema(A.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(74,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(_e[237],ye([1,0,184,11,24,236,53,4]),function(Z,e,c,t,I,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var D;(function(E){function _(w,f,g){if(!w)return;const h=t.isString(w.type)?w.type:void 0;if(!h||h.length===0){g.error(c.localize(3,null));return}const v=[];if(Array.isArray(w.required))for(const m of w.required)t.isString(m)&&v.push(m);return{extensionId:f.value,taskType:h,required:v,properties:w.properties?I.deepClone(w.properties):{},when:w.when?y.ContextKeyExpr.deserialize(w.when):void 0}}E.from=_})(D||(D={}));const A=P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:c.localize(4,null),type:"array",items:S}});class k{constructor(){this._onDefinitionsChanged=new T.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((_,w)=>{A.setHandler((f,g)=>{this._schema=void 0;try{for(const h of g.removed){const v=h.value;for(const m of v)this.taskTypes&&m.type&&this.taskTypes[m.type]&&delete this.taskTypes[m.type]}for(const h of g.added){const v=h.value;for(const m of v){const r=D.from(m,h.description.identifier,h.collector);r&&(this.taskTypes[r.taskType]=r)}}(g.removed.length>0||g.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}_(void 0)})})}onReady(){return this.readyPromise}get(_){return this.taskTypes[_]}all(){return Object.keys(this.taskTypes).map(_=>this.taskTypes[_])}getJsonSchema(){if(this._schema===void 0){const _=[];for(const w of this.all()){const f={type:"object",additionalProperties:!1};w.required.length>0&&(f.required=w.required.slice(0)),w.properties!==void 0?f.properties=I.deepClone(w.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[w.taskType]},_.push(f)}this._schema={oneOf:_}}return this._schema}}e.TaskDefinitionRegistry=new k}),define(_e[238],ye([1,0,185,11,22,24,53,237]),function(Z,e,c,t,I,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new y.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY={value:c.localize(1,null),original:"Tasks"};var S;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function B(N){if(!N)return F.Strong;switch(N.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=B}(S=e.ShellQuoting||(e.ShellQuoting={}));var D;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(D=e.CommandOptions||(e.CommandOptions={}));var A;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(A=e.RevealKind||(e.RevealKind={})),function(F){function B(N){switch(N.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=B}(A=e.RevealKind||(e.RevealKind={}));var k;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function B(N){switch(N.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=B}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var E;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(E=e.PanelKind||(e.PanelKind={})),function(F){function B(N){switch(N.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=B}(E=e.PanelKind||(e.PanelKind={}));var _;(function(F){F.defaults={echo:!0,reveal:A.Always,revealProblems:k.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(_=e.PresentationOptions||(e.PresentationOptions={}));var w;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(w=e.RuntimeType||(e.RuntimeType={})),function(F){function B(z){switch(z.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=B;function N(z){switch(z){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=N}(w=e.RuntimeType||(e.RuntimeType={}));var f;(function(F){function B(N){return t.isString(N)?N:N.value}F.value=B})(f=e.CommandString||(e.CommandString={}));var g;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function B(z){return z===F.Clean._id||z===F.Build._id||z===F.Rebuild._id||z===F.Test._id}F.is=B;function N(z){if(z!==void 0)return t.isString(z)?B(z)?{_id:z,isDefault:!1}:void 0:z}F.from=N})(g=e.TaskGroup||(e.TaskGroup={}));var h;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(h=e.TaskScope||(e.TaskScope={}));var v;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function B(N){switch(N){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=B})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var m;(function(F){F.parallel="parallel",F.sequence="sequence"})(m=e.DependsOrder||(e.DependsOrder={}));var r;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(r=e.RunOnOptions||(e.RunOnOptions={}));var b;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(b=e.RunOptions||(e.RunOptions={}));class s{constructor(B,N,z,j,x,Q){this._label="",this._id=B,N&&(this._label=N),z&&(this.type=z),this.runOptions=j,this.configurationProperties=x,this._source=Q}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.getFolderId(),id:this._id};return JSON.stringify(B)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,N=!1){if(B===void 0)return!1;if(t.isString(B))return B===this._label||B===this.configurationProperties.identifier||N&&B===this._id;const z=this.getDefinition(!0);return z!==void 0&&z._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),B&&(this._taskLoadMessages=this._taskLoadMessages.concat(B))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=s;class u extends s{constructor(B,N,z,j,x,Q,K,le){super(B,z,void 0,K,le,N),this.command={},this._source=N,this.hasDefinedMatchers=Q,x&&(this.command=x)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let N;switch(this.command?this.command.runtime:void 0){case w.Shell:N="shell";break;case w.Process:N="process";break;case w.CustomExecution:N="customExecution";break;case void 0:N="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:N,_key:this._id,id:this._id}}}static is(B){return B instanceof u}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const B=this.getFolderId();if(!B)return;let N=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(N+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:N};return JSON.stringify(z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(B){return new u(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=u;class o extends s{constructor(B,N,z,j,x,Q,K){super(B,z,j,Q,K,N),this._source=N,this.configures=x}static is(B){return B instanceof o}fromObject(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const B=this.getFolderId();if(!B)return;let N=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(N+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:N};return JSON.stringify(z)}}e.ConfiguringTask=o;class l extends s{constructor(B,N,z,j,x,Q,K,le,ie){super(B,z,j,le,ie,N),this.defines=x,this.hasDefinedMatchers=K,this.command=Q,this.icon=ie.icon,this.hide=ie.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof l}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.getFolderId(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(B){return new l(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=l;class a extends s{constructor(B,N,z,j,x,Q){super(B,z,j,x,Q,N),this._source=N}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(B){return new a(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=a;var d;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(d=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(d=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class i{constructor(B){this._order=new Map;for(let N=0;N<B.length;N++)this._order.set(B[N].uri.toString(),N)}compare(B,N){const z=B.getWorkspaceFolder(),j=N.getWorkspaceFolder();if(z&&j){let x=this._order.get(z.uri.toString());x=x===void 0?0:x+1;let Q=this._order.get(j.uri.toString());return Q=Q===void 0?0:Q+1,x===Q?B._label.localeCompare(N._label):x-Q}else return!z&&j?-1:z&&!j?1:0}}e.TaskSorter=i;var p;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var C;(function(F){F.SingleRun="singleRun",F.Background="background"})(C=e.TaskRunType||(e.TaskRunType={}));var R;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(R=e.TaskRunSource||(e.TaskRunSource={}));var U;(function(F){function B(N,z,j,x){if(z){const Q={kind:N,taskId:z._id,taskName:z.configurationProperties.name,runType:z.configurationProperties.isBackground?"background":"singleRun",group:z.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:j,__task:z};return N==="start"?Q.resolvedVariables=x:N==="processStarted"?Q.processId=x:N==="processEnded"&&(Q.exitCode=x),Object.freeze(Q)}else return Object.freeze({kind:"changed"})}F.create=B})(U=e.TaskEvent||(e.TaskEvent={}));var H;(function(F){function B(z){const j=Object.keys(z).sort();let x="";for(const Q of j){let K=z[Q];K instanceof Object?K=B(K):typeof K=="string"&&(K=K.replace(/,/g,",,")),x+=Q+","+K+","}return x}function N(z){const x={_key:B(z),type:z.taskType};return Object.assign(x,z),x}F.create=N})(H=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var V;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(V=e.TaskSettingId||(e.TaskSettingId={}));var L;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(L=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var M;(function(F){function B(N,z){const j=T.TaskDefinitionRegistry.get(N.type);if(j===void 0){const le=P.deepClone(N);return delete le._key,H.create(le)}const x=Object.create(null);x.type=j.taskType;const Q=new Set;j.required.forEach(le=>Q.add(le));const K=j.properties;for(const le of Object.keys(K)){const ie=N[le];if(ie!=null)x[le]=ie;else if(Q.has(le)){const de=K[le];if(de.default!==void 0)x[le]=P.deepClone(de.default);else switch(de.type){case"boolean":x[le]=!1;break;case"number":case"integer":x[le]=0;break;case"string":x[le]="";break;default:z.error(c.localize(2,null,JSON.stringify(N,void 0,0),le));return}}}return H.create(x)}F.createTaskIdentifier=B})(M=e.TaskDefinition||(e.TaskDefinition={}))}),define(_e[239],ye([1,0,10]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,T)=>{this._actualOk=y,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,c.onUnexpectedError)(y))}then(y,T){return this._ensureActual().then(y,T)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=t;class I extends t{constructor(){super(),this._hasErr=!0,this._err=new c.CancellationError}}e.CanceledLazyPromise=I}),define(_e[57],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const t=[];function I(T){const S=new c(T);return t[S.nid]=S,S}e.createProxyIdentifier=I;function P(T){return t[T].sid}e.getStringIdentifierForProxy=P;class y{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=y}),define(_e[5],ye([1,0,57]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(I=e.TabInputKind||(e.TabInputKind={}));var P;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(P=e.TabModelOperationKind||(e.TabModelOperationKind={}));var y;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var T;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(T=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var D;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(D=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));class k{static mixin(g){return g._id=k._n++,g}}e.IdObject=k,k._n=0;var E;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(E=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var _;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(_=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,c.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization")}}),define(_e[68],ye([1,0,3,13,5,16]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(S,D){this._extHostLogService=D,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(I.MainContext.MainThreadTelemetry)}report(S,D,A){const k=this.getUsageKey(S,D);this._reportedUsages.has(k)||(this._reportedUsages.add(k),D.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:S}))}getUsageKey(S,D){return`${S}-${D.identifier.value}`}};y=Ve([ze(0,P.IExtHostRpcService),ze(1,t.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(T,S,D){}})}),define(_e[240],ye([1,0,4,5,7,26]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,D,A,k={}){const E=P.ExtensionIdentifier.toKey(S.identifier),_=this._inFlightRequests.get(E)||[],w=[...A].sort().join(" ");let f=_.find(g=>g.providerId===D&&g.scopes===w);if(f)return f.result;{const g=this._getSession(S,E,D,A,k);f={providerId:D,scopes:w,result:g},_.push(f),this._inFlightRequests.set(E,_);try{await g}finally{const h=_.findIndex(v=>v.providerId===D&&v.scopes===w);h>-1&&(_.splice(h),this._inFlightRequests.set(E,_))}return g}}async _getSession(S,D,A,k,E={}){await this._proxy.$ensureProvider(A);const _=S.displayName||S.name;return this._proxy.$getSession(A,k,D,_,E)}async removeSession(S,D){const A=this._authenticationProviders.get(S);return A?A.provider.removeSession(D):this._proxy.$removeSession(S,D)}registerAuthenticationProvider(S,D,A,k){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:D,provider:A,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(_=>_.id===S)||this._providers.push({id:S,label:D});const E=A.onDidChangeSessions(_=>{this._proxy.$sendDidChangeSessions(S,{added:_.added??[],changed:_.changed??[],removed:_.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,D,k?.supportsMultipleAccounts??!1),new I.Disposable(()=>{E.dispose(),this._authenticationProviders.delete(S);const _=this._providers.findIndex(w=>w.id===S);_>-1&&this._providers.splice(_),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,D){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,D){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,D){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,D){return this._onDidChangeSessions.fire({provider:{id:S,label:D}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(_e[241],ye([1,0,5,16,15]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(T,S){this._proxy=T.getProxy(c.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:D=>S.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(T,S,D){const A=I.WorkspaceEdit.from(T,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(A,void 0,D?.isRefactoring??!1)}};P=Ve([ze(0,t.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(_e[242],ye([1,0,5]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const y=P.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(T){return y.$writeText(T)}})}}e.ExtHostClipboard=t});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Me=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[39],ye([1,0,11,7,15,24,5,17,13,82,35,49,2,6,3,16,135,23,57,50]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h,v,m){"use strict";var r,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(n,i){r.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,b.set(this,void 0),Ze(this,r,n.getProxy(y.MainContext.MainThreadCommands),"f"),this._logService=i,Ze(this,b,n.getProxy(y.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,p=>{const C=this._apiCommands.get(p);return C?.result===l.Void?C:void 0},i),this._argumentProcessors=[{processArgument(p){return(0,D.revive)(p)}},{processArgument(p){return(0,P.cloneAndChange)(p,function(C){if(A.Range.isIRange(C))return I.Range.to(C);if(k.Position.isIPosition(C))return I.Position.to(C);if(A.Range.isIRange(C.range)&&E.URI.isUri(C.uri))return I.location.to(C);if(C instanceof h.VSBuffer)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(n){this._argumentProcessors.push(n)}registerApiCommand(n){const i=this.registerCommand(!1,n.id,async(...p)=>{const C=n.args.map((U,H)=>{if(!U.validate(p[H]))throw new Error(`Invalid argument '${U.name}' when running '${n.id}', received: ${p[H]}`);return U.convert(p[H])}),R=await this.executeCommand(n.internalId,...C);return n.result.convert(R,p,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this._apiCommands.set(n.id,n),new t.Disposable(()=>{i.dispose(),this._apiCommands.delete(n.id)})}registerCommand(n,i,p,C,R,U){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:p,thisArg:C,description:R,extension:U}),n&&Me(this,r,"f").$registerCommand(i),new t.Disposable(()=>{this._commands.delete(i)&&n&&Me(this,r,"f").$unregisterCommand(i)})}executeCommand(n,...i){return this._logService.trace("ExtHostCommands#executeCommand",n),this._doExecuteCommand(n,i,!0)}async _doExecuteCommand(n,i,p){if(this._commands.has(n))return Me(this,r,"f").$fireCommandActivationEvent(n),this._executeContributedCommand(n,i,!1);{let C=!1;const R=(0,P.cloneAndChange)(i,function(U){if(U instanceof t.Position)return I.Position.from(U);if(U instanceof t.Range)return I.Range.from(U);if(U instanceof t.Location)return I.location.from(U);if(t.NotebookRange.isNotebookRange(U))return I.NotebookRange.from(U);if(U instanceof ArrayBuffer)return C=!0,h.VSBuffer.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return C=!0,h.VSBuffer.wrap(U);if(U instanceof h.VSBuffer)return C=!0,U;if(!Array.isArray(U))return U});try{const U=await Me(this,r,"f").$executeCommand(n,C?new v.SerializableObjectWithBuffers(R):R,p);return(0,D.revive)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this._doExecuteCommand(n,i,!1);throw U}}}async _executeContributedCommand(n,i,p){const C=this._commands.get(n);if(!C)throw new Error("Unknown command");const{callback:R,thisArg:U,description:H}=C;if(H)for(let L=0;L<H.args.length;L++)try{(0,c.validateConstraint)(i[L],H.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${H.args[L].name}' - ${H.args[L].description}`)}const V=Date.now();try{return await R.apply(U,i)}catch(L){if(n===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...i);M&&(n=M.command)}throw this._logService.error(L,n,C.extension?.identifier),p?new class extends Error{constructor(){super((0,m.toErrorMessage)(L)),this.id=n,this.source=C.extension?.displayName??C.extension?.name}}:L}finally{this._reportTelemetry(C,n,Date.now()-V)}}_reportTelemetry(n,i,p){!n.extension||n.extension.isBuiltin||Me(this,b,"f").$publicLog2("Extension:ActionExecuted",{extensionId:n.extension.identifier.value,id:i,duration:p})}$executeContributedCommand(n,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",n),this._commands.has(n)?(i=i.map(p=>this._argumentProcessors.reduce((C,R)=>R.processArgument(C),p)),this._executeContributedCommand(n,i,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this._logService.trace("ExtHostCommands#getCommands",n),Me(this,r,"f").$getCommands().then(i=>(n&&(i=i.filter(p=>p[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(const[i,p]of this._commands){const{description:C}=p;C&&(n[i]=C)}return Promise.resolve(n)}};r=new WeakMap,b=new WeakMap,s=Ve([ze(0,f.IExtHostRpcService),ze(1,S.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,w.createDecorator)("IExtHostCommands");class u{constructor(n,i,p){this._commands=n,this._lookupApiCommand=i,this._logService=p,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(n,i){if(!n)return;const p={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return p;const C=this._lookupApiCommand(n.command);if(C)p.id=C.internalId,p.arguments=C.args.map((R,U)=>R.convert(n.arguments&&n.arguments[U]));else if((0,T.isNonEmptyArray)(n.arguments)){const R=`${n.command}/${++this._cachIdPool}`;this._cache.set(R,n),i.add((0,_.toDisposable)(()=>{this._cache.delete(R),this._logService.trace("CommandsConverter#DISPOSE",R)})),p.$ident=R,p.id=this.delegatingCommandId,p.arguments=[R],this._logService.trace("CommandsConverter#CREATE",n.command,R)}return p}fromInternal(n){return typeof n.$ident=="string"?this._cache.get(n.$ident):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this._cache.get(n[0])}_executeConvertedCommand(...n){const i=this.getActualCommand(...n);return this._logService.trace("CommandsConverter#EXECUTE",n[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${n[0]}`)}}e.CommandsConverter=u;class o{constructor(n,i,p,C){this.name=n,this.description=i,this.validate=p,this.convert=C}optional(){return new o(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,i){return new o(n??this.name,i??this.description,this.validate,this.convert)}}e.ApiCommandArgument=o,o.Uri=new o("uri","Uri of a text document",d=>E.URI.isUri(d),d=>d),o.Position=new o("position","A position in a text document",d=>t.Position.isPosition(d),I.Position.from),o.Range=new o("range","A range in a text document",d=>t.Range.isRange(d),I.Range.from),o.Selection=new o("selection","A selection in a text document",d=>t.Selection.isSelection(d),I.Selection.from),o.Number=new o("number","",d=>typeof d=="number",d=>d),o.String=new o("string","",d=>typeof d=="string",d=>d),o.CallHierarchyItem=new o("item","A call hierarchy item",d=>d instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),o.TypeHierarchyItem=new o("item","A type hierarchy item",d=>d instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),o.TestItem=new o("testItem","A VS Code TestItem",d=>d instanceof g.TestItemImpl,I.TestItem.from);class l{constructor(n,i){this.description=n,this.convert=i}}e.ApiCommandResult=l,l.Void=new l("no result",d=>d);class a{constructor(n,i,p,C,R){this.id=n,this.internalId=i,this.description=p,this.args=C,this.result=R}}e.ApiCommand=a}),define(_e[243],ye([1,0,2,15,7,66,39,17,118,123,14]),function(Z,e,c,t,I,P,y,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const k=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",_(t.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(f,g)=>{if((0,T.isFalsyOrEmpty)(f))return;class h extends I.SymbolInformation{static to(m){const r=new h(m.name,t.SymbolKind.to(m.kind),m.containerName||"",new I.Location(g[0],t.Range.to(m.range)));return r.detail=m.detail,r.range=r.location.range,r.selectionRange=t.Range.to(m.selectionRange),r.children=m.children?m.children.map(h.to):[],r}}return f.map(h.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",f=>typeof f=="string",f=>f),new y.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(t.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",_(t.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",_(t.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",f=>Array.isArray(f)&&f.every(g=>I.Position.isPosition(g)),f=>f.map(t.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",f=>f.map(g=>{let h;for(const v of g.reverse())h=new I.SelectionRange(t.Range.to(v),h);return h}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",f=>f.map(t.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",f=>f.map(t.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",f=>f.map(t.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",f=>f.map(t.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",f=>{if(!!f)return{range:t.Range.to(f.range),placeholder:f.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",f=>{if(!!f){if(f.rejectReason)throw new Error(f.rejectReason);return t.WorkspaceEdit.to(f)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",f=>f.map(t.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new I.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const g=(0,S.decodeSemanticTokensDto)(f);if(g.type==="full")return new I.SemanticTokens(g.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new I.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const g=(0,S.decodeSemanticTokensDto)(f);if(g.type==="full")return new I.SemanticTokens(g.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(f,g,h)=>{if(!f)return new I.CompletionList([]);const v=f.suggestions.map(m=>t.CompletionItem.to(m,h));return new I.CompletionList(v,f.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",f=>{if(f)return t.SignatureHelp.to(f)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(f,g,h)=>_(v=>new I.CodeLens(t.Range.to(v.range),v.command&&h.fromInternal(v.command)))(f))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",f=>I.Range.isRange(f),f=>I.Selection.isSelection(f)?t.Selection.from(f):t.Range.from(f)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(f,g,h)=>_(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(v.command)}else{const m=new I.CodeAction(v.title,v.kind?new I.CodeActionKind(v.kind):void 0);return v.edit&&(m.edit=t.WorkspaceEdit.to(v.edit)),v.command&&(m.command=h.fromInternal(v.command)),m.isPreferred=v.isPreferred,m}})(f))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",f=>f?f.map(g=>new I.ColorInformation(t.Range.to(g.range),t.Color.to(g.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",f=>f instanceof I.Color,t.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",f=>!0,f=>({uri:f.uri,range:t.Range.from(f.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",f=>f?f.map(t.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(f,g,h)=>f.map(t.InlayHint.to.bind(void 0,h)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",_(f=>({viewType:f.viewType,displayName:f.displayName,options:{transientOutputs:f.options.transientOutputs,transientCellMetadata:f.options.transientCellMetadata,transientDocumentMetadata:f.options.transientDocumentMetadata},filenamePattern:f.filenamePattern.map(g=>t.NotebookExclusiveDocumentPattern.to(g))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",f=>f.map(t.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",f=>c.URI.isUri(f)||typeof f=="string"&&(0,D.matchesSomeScheme)(f,A.Schemas.http,A.Schemas.https),f=>f),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[t.ViewColumn.from(f),void 0]:[t.ViewColumn.from(f.viewColumn),t.TextEditorOpenOptions.from(f)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[t.ViewColumn.from(f),void 0]:[t.ViewColumn.from(f.viewColumn),t.TextEditorOpenOptions.from(f)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="object",f=>f&&[t.ViewColumn.from(f.viewColumn),t.TextEditorOpenOptions.from(f)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",f=>f.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",f=>f.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",f=>f.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void),new y.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[y.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],y.ApiCommandResult.Void)];class E{static register(g){k.forEach(g.registerApiCommand,g)}}e.ExtHostApiCommands=E;function _(f){return g=>{if(Array.isArray(g))return g.map(f)}}function w(f){if(!Array.isArray(f))return;const g=[];for(const h of f)P.isLocationLink(h)?g.push(t.DefinitionLink.to(h)):g.push(t.location.to(h));return g}}),define(_e[244],ye([1,0,18,60,4,6,2,66,26,15,7,27,5]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function _(w,f,g){const h=w.getProxy(E.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,f.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const n=this._commentControllers.get(d.handle);return n?n.value:d}else if(d&&d.$mid===7){const n=this._commentControllers.get(d.commentControlHandle);if(!n)return d;const i=n.getCommentThread(d.commentThreadHandle);return i?i.value:d}else if(d&&d.$mid===8){const n=this._commentControllers.get(d.thread.commentControlHandle);if(!n)return d;const i=n.getCommentThread(d.thread.commentThreadHandle);return i?{thread:i.value,text:d.text}:d}else if(d&&d.$mid===9){const n=this._commentControllers.get(d.thread.commentControlHandle);if(!n)return d;const i=n.getCommentThread(d.thread.commentThreadHandle);if(!i)return d;const p=d.commentUniqueId,C=i.getCommentByUniqueId(p);return C||d}else if(d&&d.$mid===10){const n=this._commentControllers.get(d.thread.commentControlHandle);if(!n)return d;const i=n.getCommentThread(d.thread.commentThreadHandle);if(!i)return d;const p=d.text,C=d.commentUniqueId,R=i.getCommentByUniqueId(C);return R?(typeof R.body=="string"?R.body=p:R.body.value=p,R):d}return d}})}createCommentController(d,n,i){const p=v.handlePool++,C=new r(d,p,n,i);this._commentControllers.set(C.handle,C);const R=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(d.identifier))||[];return R.push(C),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(d.identifier),R),C.value}$createCommentThreadTemplate(d,n,i){const p=this._commentControllers.get(d);!p||p.$createCommentThreadTemplate(n,i)}async $updateCommentThreadTemplate(d,n,i){const p=this._commentControllers.get(d);!p||p.$updateCommentThreadTemplate(n,i)}$deleteCommentThread(d,n){this._commentControllers.get(d)?.$deleteCommentThread(n)}$provideCommentingRanges(d,n,i){const p=this._commentControllers.get(d);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const C=g.getDocument(y.URI.revive(n));return(0,c.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(C,i)).then(R=>R?R.map(U=>D.Range.from(U)):void 0)}$toggleReaction(d,n,i,p,C){const R=this._commentControllers.get(d);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const U=R.getCommentThread(n);if(U){const H=U.getCommentByUniqueId(p.uniqueIdInThread);if(R!==void 0&&H&&R.reactionHandler)return R.reactionHandler(H,u(C))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class m{set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){d.isEqual(this._range)||(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get state(){return(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(d){(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=d,this.modifications.state=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(d,n,i,p,C,R,U,H){this._commentControllerHandle=n,this._id=i,this._uri=p,this._range=C,this._comments=R,this.extensionDescription=U,this._isTemplate=H,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${d}.${this.handle}`),h.$createCommentThread(n,this.handle,this._id,this._uri,D.Range.from(this._range),U.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{h.$deleteCommentThread(n,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(L){V.range=L},get comments(){return V.comments},set comments(L){V.comments=L},get collapsibleState(){return V.collapsibleState},set collapsibleState(L){V.collapsibleState=L},get canReply(){return V.canReply},set canReply(L){V.canReply=L},get contextValue(){return V.contextValue},set contextValue(L){V.contextValue=L},get label(){return V.label},set label(L){V.label=L},get state(){return V.state},set state(L){V.state=L},dispose:()=>{V.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const d=i=>Object.prototype.hasOwnProperty.call(this.modifications,i),n={};d("range")&&(n.range=D.Range.from(this._range)),d("label")&&(n.label=this.label),d("contextValue")&&(n.contextValue=this.contextValue??null),d("comments")&&(n.comments=this._comments.map(i=>b(this,i,this._commentsMap))),d("collapsibleState")&&(n.collapseState=o(this._collapseState)),d("canReply")&&(n.canReply=this.canReply),d("state")&&(n.state=l(this._state)),d("isTemplate")&&(n.isTemplate=this._isTemplate),this.modifications={},h.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,n)}getCommentByUniqueId(d){for(const n of this._commentsMap){const i=n[0],p=n[1];if(d===p)return i}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose())}}m._handlePool=0,Ve([(0,t.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(d){this._commentingRangeProvider=d,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,h.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(d,n,i,p){this._extension=d,this._handle=n,this._id=i,this._label=p,this._threads=new Map,h.$registerCommentController(this.handle,i,p);const C=this;this.value=Object.freeze({id:C.id,label:C.label,get options(){return C.options},set options(R){C.options=R},get commentingRangeProvider(){return C.commentingRangeProvider},set commentingRangeProvider(R){C.commentingRangeProvider=R},get reactionHandler(){return C.reactionHandler},set reactionHandler(R){C.reactionHandler=R},createCommentThread(R,U,H){return C.createCommentThread(R,U,H).value},dispose:()=>{C.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(d,n,i,p){if(typeof d=="string"){const C=new m(this.id,this.handle,d,n,i,p,this._extension,!1);return this._threads.set(C.handle,C),C}else{const C=new m(this.id,this.handle,void 0,d,n,i,this._extension,!1);return this._threads.set(C.handle,C),C}}$createCommentThreadTemplate(d,n){const i=new m(this.id,this.handle,void 0,y.URI.revive(d),D.Range.to(n),[],this._extension,!0);return i.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this._threads.set(i.handle,i),i}$updateCommentThreadTemplate(d,n){const i=this._threads.get(d);i&&(i.range=D.Range.to(n))}$deleteCommentThread(d){this._threads.get(d)?.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._localDisposables.forEach(d=>d.dispose())}}function b(a,d,n){let i=n.get(d);i||(i=++a.commentHandle,n.set(d,i));const p=d.author&&d.author.iconPath?d.author.iconPath.toString():void 0;return{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:i,body:typeof d.body=="string"?d.body:D.MarkdownString.from(d.body),userName:d.author.name,userIconPath:p,label:d.label,commentReactions:d.reactions?d.reactions.map(C=>s(C)):void 0,timestamp:d.timestamp?.toJSON()}}function s(a){return{label:a.label,iconPath:a.iconPath?D.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function u(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?y.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function o(a){if(a!==void 0)switch(a){case A.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}function l(a){if(a!==void 0)switch(a){case A.CommentThreadState.Unresolved:return T.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return T.CommentThreadState.Resolved}return T.CommentThreadState.Unresolved}return new v}e.createExtHostComments=_}),define(_e[245],ye([1,0,24,5,25,16]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let y=class{constructor(A,k){this._mainThreadConsole=A.getProxy(t.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(A,k){const E=this,_=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){E._handleConsoleCall(A,k,_,arguments)}})}_handleConsoleCall(A,k,E,_){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:S(_,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(A,E,_)}};y=Ve([ze(0,P.IExtHostRpcService),ze(1,I.IExtHostInitDataService)],y),e.AbstractExtHostConsoleForwarder=y;const T=1e5;function S(D,A){const k=[];if(D.length)for(let E=0;E<D.length;E++){let _=D[E];if(typeof _>"u")_="undefined";else if(_ instanceof Error){const w=_;w.stack?_=w.stack:_=w.toString()}k.push(_)}if(A){const E=new Error().stack;E&&k.push({__$stack:E.split(`
`).slice(3).join(`
`)})}try{const E=(0,c.safeStringify)(k);return E.length>T?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}),define(_e[137],ye([1,0,2,5,7,3,16,13,17,8,9]),function(Z,e,c,t,I,P,y,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class Pn{constructor(_,w){this._logService=w,this._provider=new Map,this._proxy=_.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(_,w){const f=Pn._handlePool++;this._provider.set(f,{provider:_,extensionId:w}),this._proxy.$registerDecorationProvider(f,w.value);const g=_.onDidChangeFileDecorations&&_.onDidChangeFileDecorations(h=>{if(!h){this._proxy.$onDidChange(f,null);return}const v=(0,S.asArray)(h);if(v.length<=Pn._maxEventSize){this._proxy.$onDidChange(f,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",w.value,v.length);const m=v.map(s=>({uri:s,rank:(0,D.count)(s.path,"/")})),r=(0,S.groupBy)(m,(s,u)=>s.rank-u.rank||(0,D.compare)(s.uri.path,u.uri.path)),b=[];e:for(const s of r){let u;for(const o of s){const l=(0,A.dirname)(o.uri.path);if(u!==l&&(u=l,b.push(o.uri)>=Pn._maxEventSize))break e}}this._proxy.$onDidChange(f,b)});return new I.Disposable(()=>{g?.dispose(),this._proxy.$unregisterDecorationProvider(f),this._provider.delete(f)})}async $provideDecorations(_,w,f){if(!this._provider.has(_))return Object.create(null);const g=Object.create(null),{provider:h,extensionId:v}=this._provider.get(_);return await Promise.all(w.map(async m=>{try{const{uri:r,id:b}=m,s=await Promise.resolve(h.provideFileDecoration(c.URI.revive(r),f));if(!s)return;try{I.FileDecoration.validate(s),g[b]=[s.propagate,s.tooltip,s.badge,s.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${v.value}': ${u}`)}}catch(r){this._logService.error(r)}})),g}};k._handlePool=0,k._maxEventSize=250,k=Ve([ze(0,y.IExtHostRpcService),ze(1,T.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Me=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[246],ye([1,0,171,122,2,5,7,15,4,13,28,46]),function(Z,e,c,t,I,P,y,T,S,D,A,k){"use strict";var E,_,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class f{constructor(v,m,r,b,s,u,o){this._name=v,this._owner=m,this._maxDiagnosticsPerFile=r,this._modelVersionIdProvider=b,E.set(this,void 0),_.set(this,void 0),w.set(this,void 0),this._isDisposed=!1,Ze(this,w,new A.ResourceMap(l=>s.getComparisonKey(l)),"f"),Ze(this,E,u,"f"),Ze(this,_,o,"f")}dispose(){this._isDisposed||(Me(this,_,"f").fire([...Me(this,w,"f").keys()]),Me(this,E,"f")?.$clear(this._owner),Me(this,w,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,m){if(!v){this.clear();return}this._checkDisposed();let r=[];if(I.URI.isUri(v)){if(!m){this.delete(v);return}Me(this,w,"f").set(v,m.slice()),r=[v]}else if(Array.isArray(v)){r=[];let s;v=[...v].sort(f._compareIndexedTuplesByUri);for(const u of v){const[o,l]=u;if((!s||o.toString()!==s.toString())&&(s&&Me(this,w,"f").get(s).length===0&&Me(this,w,"f").delete(s),s=o,r.push(o),Me(this,w,"f").set(o,[])),l)Me(this,w,"f").get(o)?.push(...l);else{const a=Me(this,w,"f").get(o);a&&(a.length=0)}}}if(Me(this,_,"f").fire(r),!Me(this,E,"f"))return;const b=[];for(const s of r){let u=[];const o=Me(this,w,"f").get(s);if(o)if(o.length>this._maxDiagnosticsPerFile){u=[];const l=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let a=0;a<4;a++)for(const d of o)if(d.severity===l[a]&&u.push({...T.Diagnostic.from(d),modelVersionId:this._modelVersionIdProvider(s)})===this._maxDiagnosticsPerFile)break e;u.push({severity:t.MarkerSeverity.Info,message:(0,c.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=o.map(l=>({...T.Diagnostic.from(l),modelVersionId:this._modelVersionIdProvider(s)}));b.push([s,u])}Me(this,E,"f").$changeMany(this._owner,b)}delete(v){this._checkDisposed(),Me(this,_,"f").fire([v]),Me(this,w,"f").delete(v),Me(this,E,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Me(this,_,"f").fire([...Me(this,w,"f").keys()]),Me(this,w,"f").clear(),Me(this,E,"f")?.$clear(this._owner)}forEach(v,m){this._checkDisposed();for(const[r,b]of this)v.call(m,r,b,this)}*[(E=new WeakMap,_=new WeakMap,w=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Me(this,w,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const m=Me(this,w,"f").get(v);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Me(this,w,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,m){return v[0].toString()<m[0].toString()?-1:v[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=f;let g=class mn{static _mapper(v){const m=new A.ResourceMap;for(const r of v)m.set(r,r);return{uris:Object.freeze(Array.from(m.values()))}}constructor(v,m,r,b){this._logService=m,this._fileSystemInfoService=r,this._extHostDocumentsAndEditors=b,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,mn._mapper),this._proxy=v.getProxy(P.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(v,m){const{_collections:r,_proxy:b,_onDidChangeDiagnostics:s,_logService:u,_fileSystemInfoService:o,_extHostDocumentsAndEditors:l}=this,a=new class{$changeMany(i,p){b.$changeMany(i,p),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,i,p.length===0?"CLEARING":p)}$clear(i){b.$clear(i),u.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,i)}dispose(){b.dispose()}};let d;if(!m)m="_generated_diagnostic_collection_name_#"+mn._idPool++,d=m;else if(!r.has(m))d=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do d=m+mn._idPool++;while(r.has(d))}return new class extends f{constructor(){super(m,d,mn._maxDiagnosticsPerFile,i=>l.getDocument(i)?.version,o.extUri,a,s),r.set(d,this)}dispose(){super.dispose(),r.delete(d)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const m=new Map,r=[];for(const b of this._collections.values())b.forEach((s,u)=>{let o=m.get(s.toString());typeof o>"u"&&(o=r.length,m.set(s.toString(),o),r.push([s,[]])),r[o][1]=r[o][1].concat(...u)});return r}}_getDiagnostics(v){let m=[];for(const r of this._collections.values())r.has(v)&&(m=m.concat(r.get(v)));return m}$acceptMarkersChange(v){if(!this._mirrorCollection){const m="_generated_mirror",r=new f(m,m,mn._maxDiagnosticsPerFile,b=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(m,r),this._mirrorCollection=r}for(const[m,r]of v)this._mirrorCollection.set(I.URI.revive(m),r.map(T.Diagnostic.to))}};g._idPool=0,g._maxDiagnosticsPerFile=1e3,g=Ve([ze(1,D.ILogService),ze(2,k.IExtHostFileSystemInfo)],g),e.ExtHostDiagnostics=g}),define(_e[247],ye([1,0,2,5]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(y){this._proxy=y.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(T=>T?T.map(S=>c.URI.revive(S)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(T=>T?c.URI.revive(T):void 0)}}e.ExtHostDialogs=I}),define(_e[248],ye([1,0,10,2,7,5,14,21,8]),function(Z,e,c,t,I,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(k,E,_){this._documentsAndEditors=E,this._logService=_,this._documentContentProviders=new Map,this._proxy=k.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,E){if(Object.keys(y.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const _=D._handlePool++;this._documentContentProviders.set(_,E),this._proxy.$registerTextContentProvider(_,k);let w;return typeof E.onDidChange=="function"&&(w=E.onDidChange(f=>{if(f.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(f)&&this.$provideTextDocumentContent(_,f).then(g=>{if(!g&&typeof g!="string")return;const h=this._documentsAndEditors.getDocument(f);if(!h)return;const v=(0,S.splitLines)(g);if(!h.equalLines(v))return this._proxy.$onVirtualDocumentChange(f,g)},c.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(_)&&this._proxy.$unregisterTextContentProvider(_),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(k,E){const _=this._documentContentProviders.get(k);return _?Promise.resolve(_.provideTextDocumentContent(t.URI.revive(E),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${E.scheme}`))}}e.ExtHostDocumentContentProvider=D,D._handlePool=0}),define(_e[249],ye([1,0,4,6,2,5,133,15,11,24,7]),function(Z,e,c,t,I,P,y,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(_,w){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=_.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=w,this._documentsAndEditors.onDidRemoveDocuments(f=>{for(const g of f)this._onDidRemoveDocument.fire(g.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(f=>{for(const g of f)this._onDidAddDocument.fire(g.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(_){if(!_)return;const w=this._documentsAndEditors.getDocument(_);if(w)return w}getDocument(_){const w=this.getDocumentData(_);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${_}'`);return w.document}ensureDocumentData(_){const w=this._documentsAndEditors.getDocument(_);if(w)return Promise.resolve(w);let f=this._documentLoader.get(_.toString());return f||(f=this._proxy.$tryOpenDocument(_).then(g=>{this._documentLoader.delete(_.toString());const h=I.URI.revive(g);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(h))},g=>(this._documentLoader.delete(_.toString()),Promise.reject(g))),this._documentLoader.set(_.toString(),f)),f}createDocumentData(_){return this._proxy.$tryCreateDocument(_).then(w=>I.URI.revive(w))}$acceptModelLanguageChanged(_,w){const f=I.URI.revive(_),g=this._documentsAndEditors.getDocument(f);if(!g)throw new Error("unknown document");this._onDidRemoveDocument.fire(g.document),g._acceptLanguageId(w),this._onDidAddDocument.fire(g.document)}$acceptModelSaved(_){const w=I.URI.revive(_),f=this._documentsAndEditors.getDocument(w);if(!f)throw new Error("unknown document");this.$acceptDirtyStateChanged(_,!1),this._onDidSaveDocument.fire(f.document)}$acceptDirtyStateChanged(_,w){const f=I.URI.revive(_),g=this._documentsAndEditors.getDocument(f);if(!g)throw new Error("unknown document");g._acceptIsDirty(w),this._onDidChangeDocument.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(_,w,f){const g=I.URI.revive(_),h=this._documentsAndEditors.getDocument(g);if(!h)throw new Error("unknown document");h._acceptIsDirty(f),h.onEvents(w);let v;w.isUndoing?v=A.TextDocumentChangeReason.Undo:w.isRedoing&&(v=A.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,D.deepFreeze)({document:h.document,contentChanges:w.changes.map(m=>({range:T.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:v}))}setWordDefinitionFor(_,w){(0,y.setWordDefinitionFor)(_,w)}}e.ExtHostDocuments=k}),define(_e[58],ye([1,0,48,4,6,2,3,5,133,16,136,15,13,28,14,62,79]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let v=class{constructor(r,b){this._extHostRpc=r,this._logService=b,this._activeEditorId=null,this._editors=new Map,this._documents=new _.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const b=[],s=[],u=[];if(r.removedDocuments)for(const o of r.removedDocuments){const l=P.URI.revive(o),a=this._documents.get(l);a?.unref()&&(this._documents.delete(l),b.push(a.value))}if(r.addedDocuments)for(const o of r.addedDocuments){const l=P.URI.revive(o.uri);let a=this._documents.get(l);if(a&&l.scheme!==w.Schemas.vscodeNotebookCell&&l.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);a||(a=new h(new S.ExtHostDocumentData(this._extHostRpc.getProxy(T.MainContext.MainThreadDocuments),l,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this._documents.set(l,a),s.push(a.value)),a.ref()}if(r.removedEditors)for(const o of r.removedEditors){const l=this._editors.get(o);this._editors.delete(o),l&&u.push(l)}if(r.addedEditors)for(const o of r.addedEditors){const l=P.URI.revive(o.documentUri);c.ok(this._documents.has(l),`document '${l}' does not exist`),c.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const a=this._documents.get(l).value,d=new A.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(T.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>a.document),o.selections.map(k.Selection.to),o.options,o.visibleRanges.map(n=>k.Range.to(n)),typeof o.editorPosition=="number"?k.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,d)}r.newActiveEditor!==void 0&&(c.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,I.dispose)(b),(0,I.dispose)(u),r.removedDocuments&&this._onDidRemoveDocuments.fire(b),r.addedDocuments&&this._onDidAddDocuments.fire(s),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return f.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const b=this._editors.get(this._activeEditorId);return r?b:b?.value}allEditors(){return[...this._editors.values()]}};v=Ve([ze(0,D.IExtHostRpcService),ze(1,E.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(_e[59],ye([1,0,15,5,2,4,3,7,16,11,78]),function(Z,e,c,t,I,P,y,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");class k{constructor(g,h,v){this._activeTabIdGetter=v,this._parentGroup=h,this.acceptDtoUpdate(g)}get apiObject(){if(!this._apiObject){const g=this,h={get isActive(){return g._dto.id===g._activeTabIdGetter()},get label(){return g._dto.label},get input(){return g._input},get isDirty(){return g._dto.isDirty},get isPinned(){return g._dto.isPinned},get isPreview(){return g._dto.isPreview},get group(){return g._parentGroup.apiObject}};this._apiObject=Object.freeze(h)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(g){this._dto=g,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new T.TextTabInput(I.URI.revive(this._dto.input.uri));case 2:return new T.TextDiffTabInput(I.URI.revive(this._dto.input.original),I.URI.revive(this._dto.input.modified));case 3:return new T.TextMergeTabInput(I.URI.revive(this._dto.input.base),I.URI.revive(this._dto.input.input1),I.URI.revive(this._dto.input.input2),I.URI.revive(this._dto.input.result));case 6:return new T.CustomEditorTabInput(I.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new T.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new T.NotebookEditorTabInput(I.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(I.URI.revive(this._dto.input.original),I.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(I.URI.revive(this._dto.input.uri),I.URI.revive(this._dto.input.inputBoxUri));default:return}}}class E{constructor(g,h){this._tabs=[],this._activeTabId="",this._dto=g,this._activeGroupIdGetter=h;for(const v of g.tabs)v.isActive&&(this._activeTabId=v.id),this._tabs.push(new k(v,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const g=this,h={get isActive(){return g._dto.groupId===g._activeGroupIdGetter()},get viewColumn(){return c.ViewColumn.to(g._dto.viewColumn)},get activeTab(){return g._tabs.find(v=>v.tabId===g._activeTabId)?.apiObject},get tabs(){return Object.freeze(g._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(h)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(g){this._dto=g}acceptTabOperation(g){if(g.kind===0){const v=new k(g.tabDto,this,()=>this.activeTabId());return this._tabs.splice(g.index,0,v),g.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(g.kind===1){const v=this._tabs.splice(g.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(g.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this._tabs.splice(g.index,0,v),v}const h=this._tabs.find(v=>v.tabId===g.tabDto.id);if(!h)throw new Error("INVALID tab");return g.tabDto.isActive?this._activeTabId=g.tabDto.id:this._activeTabId===g.tabDto.id&&!g.tabDto.isActive&&(this._activeTabId=""),h.acceptDtoUpdate(g.tabDto),h}activeTabId(){return this._activeTabId}}let _=class{constructor(g){this._onDidChangeTabs=new P.Emitter,this._onDidChangeTabGroups=new P.Emitter,this._extHostTabGroups=[],this._proxy=g.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const g=this,h={onDidChangeTabGroups:g._onDidChangeTabGroups.event,onDidChangeTabs:g._onDidChangeTabs.event,get all(){return Object.freeze(g._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=g._activeGroupId;return(0,D.assertIsDefined)(g._extHostTabGroups.find(r=>r.groupId===v)?.apiObject)},close:async(v,m)=>{const r=Array.isArray(v)?v:[v];return r.length?w(r[0])?this._closeGroups(r,m):this._closeTabs(r,m):!0}};this._apiObject=Object.freeze(h)}return this._apiObject}$acceptEditorTabModel(g){const h=new Set(this._extHostTabGroups.map(o=>o.groupId)),v=new Set(g.map(o=>o.groupId)),m=(0,A.diffSets)(h,v),r=this._extHostTabGroups.filter(o=>m.removed.includes(o.groupId)).map(o=>o.apiObject),b=[],s=[];this._extHostTabGroups=g.map(o=>{const l=new E(o,()=>this._activeGroupId);return m.added.includes(l.groupId)?b.push(l.apiObject):s.push(l.apiObject),l});const u=(0,D.assertIsDefined)(g.find(o=>o.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:b,closed:r,changed:s}))}$acceptTabGroupUpdate(g){const h=this._extHostTabGroups.find(v=>v.groupId===g.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(g),g.isActive&&(this._activeGroupId=g.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const h=this._extHostTabGroups.find(m=>m.groupId===g.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const v=h.acceptTabOperation(g);switch(g.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(g){for(const h of this._extHostTabGroups)for(const v of h.tabs)if(v.apiObject===g)return v}_findExtHostTabGroupFromApi(g){return this._extHostTabGroups.find(h=>h.apiObject===g)}async _closeTabs(g,h){const v=[];for(const m of g){const r=this._findExtHostTabFromApi(m);if(!r)throw new Error("Tab close: Invalid tab not found!");v.push(r.tabId)}return this._proxy.$closeTab(v,h)}async _closeGroups(g,h){const v=[];for(const m of g){const r=this._findExtHostTabGroupFromApi(m);if(!r)throw new Error("Group close: Invalid group not found!");v.push(r.groupId)}return this._proxy.$closeGroup(v,h)}};_=Ve([ze(0,S.IExtHostRpcService)],_),e.ExtHostEditorTabs=_;function w(f){return f.tabs!==void 0}}),define(_e[250],ye([1,0,2,5,6,7,15,150,8,23,27]),function(Z,e,c,t,I,P,y,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this._schemes=[]}add(w){this._stateMachine=void 0,this._schemes.push(w)}delete(w){const f=this._schemes.indexOf(w);f>=0&&(this._schemes.splice(f,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const w=this._schemes.sort(),f=[];let g,h,v=14,m=14;for(const r of w){let b=g?(0,S.commonPrefixLength)(g,r):0;for(b===0?h=1:h=m;b<r.length;b++)b+1===r.length?(v=m,m=9):m+=1,f.push([h,r.toUpperCase().charCodeAt(b),m]),f.push([h,r.toLowerCase().charCodeAt(b),m]),h=m;g=r,m=v}f.push([9,58,10]),f.push([10,47,12]),this._stateMachine=new T.StateMachine(f)}}provideDocumentLinks(w){this._initStateMachine();const f=[],g=T.LinkComputer.computeLinks({getLineContent(h){return w.lineAt(h-1).text},getLineCount(){return w.lineCount}},this._stateMachine);for(const h of g){const v=y.DocumentLink.to(h);v.target&&f.push(v)}return f}}class E{constructor(w,f){this._extHostLanguageFeatures=f,this._linkProvider=new k,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=w.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(w,f,g,h={}){if(this._registeredSchemes.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(w,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(f),this._registeredSchemes.add(f),this._fsProvider.set(v,g);let m=2;h.isCaseSensitive&&(m+=1024),h.isReadonly&&(m+=2048),typeof g.copy=="function"&&(m+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&((0,A.checkProposedApiEnabled)(w,"fsChunks"),m+=4),this._proxy.$registerFileSystemProvider(v,f,m).catch(b=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${f}`),console.error(b)});const r=g.onDidChangeFile(b=>{const s=[];for(const u of b){const{uri:o,type:l}=u;if(o.scheme!==f)continue;let a;switch(l){case P.FileChangeType.Changed:a=0;break;case P.FileChangeType.Created:a=1;break;case P.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:o,type:a})}this._proxy.$onFileSystemChange(v,s)});return(0,I.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(f),this._registeredSchemes.delete(f),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(w){const{type:f,ctime:g,mtime:h,size:v,permissions:m}=w;return{type:f,ctime:g,mtime:h,size:v,permissions:m}}$stat(w,f){return Promise.resolve(this._getFsProvider(w).stat(c.URI.revive(f))).then(g=>E._asIStat(g))}$readdir(w,f){return Promise.resolve(this._getFsProvider(w).readDirectory(c.URI.revive(f)))}$readFile(w,f){return Promise.resolve(this._getFsProvider(w).readFile(c.URI.revive(f))).then(g=>D.VSBuffer.wrap(g))}$writeFile(w,f,g,h){return Promise.resolve(this._getFsProvider(w).writeFile(c.URI.revive(f),g.buffer,h))}$delete(w,f,g){return Promise.resolve(this._getFsProvider(w).delete(c.URI.revive(f),g))}$rename(w,f,g,h){return Promise.resolve(this._getFsProvider(w).rename(c.URI.revive(f),c.URI.revive(g),h))}$copy(w,f,g,h){const v=this._getFsProvider(w);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(c.URI.revive(f),c.URI.revive(g),h))}$mkdir(w,f){return Promise.resolve(this._getFsProvider(w).createDirectory(c.URI.revive(f)))}$watch(w,f,g,h){const v=this._getFsProvider(w).watch(c.URI.revive(g),h);this._watches.set(f,v)}$unwatch(w,f){const g=this._watches.get(f);g&&(g.dispose(),this._watches.delete(f))}$open(w,f,g){const h=this._getFsProvider(w);if(!h.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(h.open(c.URI.revive(f),g))}$close(w,f){const g=this._getFsProvider(w);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(f))}$read(w,f,g,h){const v=this._getFsProvider(w);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const m=D.VSBuffer.alloc(h);return Promise.resolve(v.read(f,g,m.buffer,0,h)).then(r=>m.slice(0,r))}$write(w,f,g,h){const v=this._getFsProvider(w);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(f,g,h.buffer,0,h.byteLength))}_getFsProvider(w){const f=this._fsProvider.get(w);if(!f){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return f}}e.ExtHostFileSystem=E}),define(_e[69],ye([1,0,5,38,7,23,3,16,46,6]),function(Z,e,c,t,I,P,y,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Yt{constructor(E,_){this._fileSystemProvider=new Map,this._proxy=E.getProxy(c.MainContext.MainThreadFileSystem);const w=this;this.value=Object.freeze({async stat(f){try{const g=w._fileSystemProvider.get(f.scheme);if(!g)return await w._proxy.$stat(f);await w._proxy.$ensureActivation(f.scheme);const h=await g.stat(f);return{type:h.type,ctime:h.ctime,mtime:h.mtime,size:h.size,permissions:h.permissions}}catch(g){Yt._handleError(g)}},async readDirectory(f){try{const g=w._fileSystemProvider.get(f.scheme);return g?(await w._proxy.$ensureActivation(f.scheme),(await g.readDirectory(f)).slice()):await w._proxy.$readdir(f)}catch(g){return Yt._handleError(g)}},async createDirectory(f){try{return await w._proxy.$mkdir(f)}catch(g){return Yt._handleError(g)}},async readFile(f){try{const g=w._fileSystemProvider.get(f.scheme);return g?(await w._proxy.$ensureActivation(f.scheme),(await g.readFile(f)).slice()):(await w._proxy.$readFile(f)).buffer}catch(g){return Yt._handleError(g)}},async writeFile(f,g){try{return await w._proxy.$writeFile(f,P.VSBuffer.wrap(g))}catch(h){return Yt._handleError(h)}},async delete(f,g){try{const h=w._fileSystemProvider.get(f.scheme);return h?(await w._proxy.$ensureActivation(f.scheme),await h.delete(f,{recursive:!1,...g})):await w._proxy.$delete(f,{recursive:!1,useTrash:!1,...g})}catch(h){return Yt._handleError(h)}},async rename(f,g,h){try{return await w._proxy.$rename(f,g,{overwrite:!1,...h})}catch(v){return Yt._handleError(v)}},async copy(f,g,h){try{return await w._proxy.$copy(f,g,{overwrite:!1,...h})}catch(v){return Yt._handleError(v)}},isWritableFileSystem(f){const g=_.getCapabilities(f);if(typeof g=="number")return!(g&2048)}})}static _handleError(E){if(E instanceof I.FileSystemError)throw E;if(!(E instanceof Error))throw new I.FileSystemError(String(E));if(E.name==="ENOPRO")throw I.FileSystemError.Unavailable(E.message);switch(E.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(E.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(E.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(E.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(E.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(E.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(E.message);default:throw new I.FileSystemError(E.message,E.name)}}addFileSystemProvider(E,_){return this._fileSystemProvider.set(E,_),(0,D.toDisposable)(()=>this._fileSystemProvider.delete(E))}};A=Ve([ze(0,T.IExtHostRpcService),ze(1,S.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(_e[251],ye([1,0,4,37,2,5,15,7]),function(Z,e,c,t,I,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(k,E,_,w,f,g,h,v){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter;const m=this.ensureWatching(k,_,f);this._config=0,g&&(this._config+=1),h&&(this._config+=2),v&&(this._config+=4);const r=(0,t.parse)(f),b=typeof f=="string",s=w(u=>{if(!g)for(const o of u.created){const l=I.URI.revive(o);r(l.fsPath)&&(!b||E.getWorkspaceFolder(l))&&this._onDidCreate.fire(l)}if(!h)for(const o of u.changed){const l=I.URI.revive(o);r(l.fsPath)&&(!b||E.getWorkspaceFolder(l))&&this._onDidChange.fire(l)}if(!v)for(const o of u.deleted){const l=I.URI.revive(o);r(l.fsPath)&&(!b||E.getWorkspaceFolder(l))&&this._onDidDelete.fire(l)}});this._disposable=T.Disposable.from(m,this._onDidCreate,this._onDidChange,this._onDidDelete,s)}ensureWatching(k,E,_){const w=T.Disposable.from();if(typeof _=="string")return w;const f=k.getProxy(P.MainContext.MainThreadFileSystem);let g=!1;(_.pattern.includes(t.GLOBSTAR)||_.pattern.includes(t.GLOB_SPLIT))&&(g=!0);const h=Math.random();return f.$watch(E.identifier.value,h,_.baseUri,{recursive:g,excludes:[]}),T.Disposable.from({dispose:()=>f.$unwatch(h)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(k,E,_){this._mainContext=k,this._logService=E,this._extHostDocumentsAndEditors=_,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,E,_,w,f,g){return new S(this._mainContext,k,E,this._onFileSystemEvent.event,y.GlobPattern.from(_),w,f,g)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,E){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:E.map(_=>({oldUri:I.URI.revive(_.source),newUri:I.URI.revive(_.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:E.map(_=>I.URI.revive(_.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:E.map(_=>I.URI.revive(_.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,E){return(_,w,f)=>{const g=function(v){_.call(w,v)};return g.extension=k,E.event(g,void 0,f)}}async $onWillRunFileOperation(k,E,_,w){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:E.map(f=>({oldUri:I.URI.revive(f.source),newUri:I.URI.revive(f.target)}))},_,w);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:E.map(f=>I.URI.revive(f.target))},_,w);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:E.map(f=>I.URI.revive(f.target))},_,w)}}async _fireWillEvent(k,E,_,w){const f=new Set,g=[];if(await k.fireAsync(E,w,async(v,m)=>{const r=Date.now(),b=await Promise.resolve(v);b instanceof T.WorkspaceEdit&&(g.push([m.extension,b]),f.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-r>_&&this._logService.warn("SLOW file-participant",m.extension.identifier)}),w.isCancellationRequested||g.length===0)return;const h={edits:[]};for(const[,v]of g){const{edits:m}=y.WorkspaceEdit.from(v,{getTextDocumentVersion:r=>this._extHostDocumentsAndEditors.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});h.edits=h.edits.concat(m)}return{edit:h,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=D}),define(_e[252],ye([1,0,2,39]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(y,T,S,D,A){this._extHostNotebooks=T,this._textDocumentsAndEditors=S,this._commands=D;const k=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new t.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new t.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new t.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new t.ApiCommandResult("Notebook and input URI",E=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",E.notebookEditorId),E.notebookEditorId!==void 0){const _=this._extHostNotebooks.getEditorById(E.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",_.id),{notebookUri:c.URI.revive(E.notebookUri),inputUri:c.URI.revive(E.inputUri),notebookEditor:_.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",E.notebookUri,E.inputUri),{notebookUri:c.URI.revive(E.notebookUri),inputUri:c.URI.revive(E.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(y,T,S,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:S,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=I}),define(_e[253],ye([1,0,6,5]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(y){this._handlePool=0,this._proxy=y.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const T=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(T,y),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=I}),define(_e[254],ye([1,0,2,24,15,7,66,5,8,35,17,11,146,21,6,118,98,88,51,10,18,27]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h,v,m,r,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentSymbols(O,W){const q=this._documents.getDocument(O),X=await this._provider.provideDocumentSymbols(q,W);if(!(0,A.isFalsyOrEmpty)(X))return X[0]instanceof P.DocumentSymbol?X.map(I.DocumentSymbol.from):s._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((X,ae)=>{let ve=X.location.range.start.compareTo(ae.location.range.start);return ve===0&&(ve=ae.location.range.end.compareTo(X.location.range.end)),ve});const W=[],q=[];for(const X of O){const ae={name:X.name||"!!MISSING: name!!",kind:I.SymbolKind.from(X.kind),tags:X.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:I.Range.from(X.location.range),selectionRange:I.Range.from(X.location.range),children:[]};for(;;){if(q.length===0){q.push(ae),W.push(ae);break}const ve=q[q.length-1];if(D.Range.containsRange(ve.range,ae.range)&&!D.Range.equalsRange(ve.range,ae.range)){ve.children?.push(ae),q.push(ae);break}q.pop()}}return W}}class u{constructor(O,W,q){this._documents=O,this._commands=W,this._provider=q,this._cache=new h.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,W){const q=this._documents.getDocument(O),X=await this._provider.provideCodeLenses(q,W);if(!X||W.isCancellationRequested)return;const ae=this._cache.add(X),ve=new w.DisposableStore;this._disposables.set(ae,ve);const Te={cacheId:ae,lenses:[]};for(let ge=0;ge<X.length;ge++)Te.lenses.push({cacheId:[ae,ge],range:I.Range.from(X[ge].range),command:this._commands.toInternal(X[ge].command,ve)});return Te}async resolveCodeLens(O,W){const q=O.cacheId&&this._cache.get(...O.cacheId);if(!q)return;let X;if(typeof this._provider.resolveCodeLens!="function"||q.isResolved?X=q:X=await this._provider.resolveCodeLens(q,W),X||(X=q),W.isCancellationRequested)return;const ae=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!ae)return O.command=this._commands.toInternal(X.command??u._badCmd,ae),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function o(ee){return Array.isArray(ee)?ee.map(I.DefinitionLink.from):ee?[I.DefinitionLink.from(ee)]:[]}class l{constructor(O,W){this._documents=O,this._provider=W}async provideDefinition(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideDefinition(X,ae,q);return o(ve)}}class a{constructor(O,W){this._documents=O,this._provider=W}async provideDeclaration(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideDeclaration(X,ae,q);return o(ve)}}class d{constructor(O,W){this._documents=O,this._provider=W}async provideImplementation(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideImplementation(X,ae,q);return o(ve)}}class n{constructor(O,W){this._documents=O,this._provider=W}async provideTypeDefinition(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideTypeDefinition(X,ae,q);return o(ve)}}class i{constructor(O,W){this._documents=O,this._provider=W}async provideHover(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideHover(X,ae,q);if(!(!ve||(0,A.isFalsyOrEmpty)(ve.contents)))return ve.range||(ve.range=X.getWordRangeAtPosition(ae)),ve.range||(ve.range=new P.Range(ae,ae)),I.Hover.from(ve)}}class p{constructor(O,W){this._documents=O,this._provider=W}async provideEvaluatableExpression(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideEvaluatableExpression(X,ae,q);if(ve)return I.EvaluatableExpression.from(ve)}}class C{constructor(O,W){this._documents=O,this._provider=W}async provideInlineValues(O,W,q,X){const ae=this._documents.getDocument(O),ve=await this._provider.provideInlineValues(ae,I.Range.to(W),I.InlineValueContext.to(q),X);if(Array.isArray(ve))return ve.map(Te=>I.InlineValue.from(Te))}}class R{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentHighlights(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideDocumentHighlights(X,ae,q);if(Array.isArray(ve))return ve.map(I.DocumentHighlight.from)}}class U{constructor(O,W){this._documents=O,this._provider=W}async provideLinkedEditingRanges(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideLinkedEditingRanges(X,ae,q);if(ve&&Array.isArray(ve.ranges))return{ranges:(0,A.coalesce)(ve.ranges.map(I.Range.from)),wordPattern:ve.wordPattern}}}class H{constructor(O,W){this._documents=O,this._provider=W}async provideReferences(O,W,q,X){const ae=this._documents.getDocument(O),ve=I.Position.to(W),Te=await this._provider.provideReferences(ae,ve,q,X);if(Array.isArray(Te))return Te.map(I.location.from)}}class V{constructor(O,W,q,X,ae,ve,Te){this._documents=O,this._commands=W,this._diagnostics=q,this._provider=X,this._logService=ae,this._extension=ve,this._apiDeprecation=Te,this._cache=new h.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,W,q,X){const ae=this._documents.getDocument(O),ve=E.Selection.isISelection(W)?I.Selection.to(W):I.Range.to(W),Te=[];for(const nt of this._diagnostics.getDiagnostics(O))if(ve.intersection(nt.range)&&Te.push(nt)>V._maxCodeActionsPerFile)break;const ge={diagnostics:Te,only:q.only?new P.CodeActionKind(q.only):void 0,triggerKind:I.CodeActionTriggerKind.to(q.trigger)},Pe=await this._provider.provideCodeActions(ae,ve,ge,X);if(!(0,A.isNonEmptyArray)(Pe)||X.isCancellationRequested)return;const De=this._cache.add(Pe),xe=new w.DisposableStore;this._disposables.set(De,xe);const je=[];for(let nt=0;nt<Pe.length;nt++){const Xe=Pe[nt];!Xe||(V._isCommand(Xe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),je.push({_isSynthetic:!0,title:Xe.title,command:this._commands.toInternal(Xe,xe)})):(ge.only&&(Xe.kind?ge.only.contains(Xe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),je.push({cacheId:[De,nt],title:Xe.title,command:Xe.command&&this._commands.toInternal(Xe.command,xe),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(I.Diagnostic.from),edit:Xe.edit&&I.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:De,actions:je}}async resolveCodeAction(O,W){const[q,X]=O,ae=this._cache.get(q,X);if(!ae||V._isCommand(ae)||!this._provider.resolveCodeAction)return;const ve=await this._provider.resolveCodeAction(ae,W)??ae;return ve?.edit?I.WorkspaceEdit.from(ve.edit,void 0):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}V._maxCodeActionsPerFile=1e3;class L{constructor(O,W,q,X){this._proxy=O,this._documents=W,this._provider=q,this._handle=X}async prepareDocumentPaste(O,W,q,X){if(!this._provider.prepareDocumentPaste)return;const ae=this._documents.getDocument(O),ve=W.map(ge=>I.Range.to(ge)),Te=I.DataTransfer.toDataTransfer(q,()=>{throw new m.NotImplementedError});return await this._provider.prepareDocumentPaste(ae,ve,Te,X),I.DataTransfer.toDataTransferDTO(Te)}async providePasteEdits(O,W,q,X,ae){const ve=this._documents.getDocument(W),Te=q.map(De=>I.Range.to(De)),ge=I.DataTransfer.toDataTransfer(X,async De=>(await this._proxy.$resolvePasteFileData(this._handle,O,De)).buffer),Pe=await this._provider.provideDocumentPasteEdits(ve,Te,ge,ae);if(!!Pe)return{insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?I.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class M{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentFormattingEdits(O,W,q){const X=this._documents.getDocument(O),ae=await this._provider.provideDocumentFormattingEdits(X,W,q);if(Array.isArray(ae))return ae.map(I.TextEdit.from)}}class F{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentRangeFormattingEdits(O,W,q,X){const ae=this._documents.getDocument(O),ve=I.Range.to(W),Te=await this._provider.provideDocumentRangeFormattingEdits(ae,ve,q,X);if(Array.isArray(Te))return Te.map(I.TextEdit.from)}}class B{constructor(O,W){this._documents=O,this._provider=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,W,q,X,ae){const ve=this._documents.getDocument(O),Te=I.Position.to(W),ge=await this._provider.provideOnTypeFormattingEdits(ve,Te,q,X,ae);if(Array.isArray(ge))return ge.map(I.TextEdit.from)}}class N{constructor(O,W){this._provider=O,this._logService=W,this._cache=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,W){const q=await this._provider.provideWorkspaceSymbols(O,W);if(!(0,A.isNonEmptyArray)(q))return{symbols:[]};const X=this._cache.add(q),ae={cacheId:X,symbols:[]};for(let ve=0;ve<q.length;ve++){const Te=q[ve];if(!Te||!Te.name){this._logService.warn("INVALID SymbolInformation",Te);continue}ae.symbols.push({...I.WorkspaceSymbol.from(Te),cacheId:[X,ve]})}return ae}async resolveWorkspaceSymbol(O,W){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const q=this._cache.get(...O.cacheId);if(q){const X=await this._provider.resolveWorkspaceSymbol(q,W);return X&&(0,t.mixin)(O,I.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class z{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,W,q){this._documents=O,this._provider=W,this._logService=q}async provideRenameEdits(O,W,q,X){const ae=this._documents.getDocument(O),ve=I.Position.to(W);try{const Te=await this._provider.provideRenameEdits(ae,ve,q,X);return Te?I.WorkspaceEdit.from(Te):void 0}catch(Te){const ge=z._asMessage(Te);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(O,W,q){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(O),ae=I.Position.to(W);try{const ve=await this._provider.prepareRename(X,ae,q);let Te,ge;if(P.Range.isRange(ve)?(Te=ve,ge=X.getText(ve)):(0,k.isObject)(ve)&&(Te=ve.range,ge=ve.placeholder),!Te||!ge)return;if(Te.start.line>ae.line||Te.end.line<ae.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Te),text:ge}}catch(ve){const Te=z._asMessage(ve);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(ve)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class j{constructor(O,W){this.resultId=O,this.tokens=W}}class x{constructor(O,W){this._documents=O,this._provider=W,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,W,q){const X=this._documents.getDocument(O),ae=W!==0?this._previousResults.get(W):null;let ve=typeof ae?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,ae.resultId,q):await this._provider.provideDocumentSemanticTokens(X,q);return ae&&this._previousResults.delete(W),ve?(ve=x._fixProvidedSemanticTokens(ve),this._send(x._convertToEdits(ae,ve),ve)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return x._isSemanticTokens(O)?x._isCorrectSemanticTokens(O)?O:new P.SemanticTokens(new Uint32Array(O.data),O.resultId):x._isSemanticTokensEdits(O)?x._isCorrectSemanticTokensEdits(O)?O:new P.SemanticTokensEdits(O.edits.map(W=>new P.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const W of O.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,W){if(!x._isSemanticTokens(W)||!O||!O.tokens)return W;const q=O.tokens,X=q.length,ae=W.data,ve=ae.length;let Te=0;const ge=Math.min(X,ve);for(;Te<ge&&q[Te]===ae[Te];)Te++;if(Te===X&&Te===ve)return new P.SemanticTokensEdits([],W.resultId);let Pe=0;const De=ge-Te;for(;Pe<De&&q[X-Pe-1]===ae[ve-Pe-1];)Pe++;return new P.SemanticTokensEdits([{start:Te,deleteCount:X-Te-Pe,data:ae.subarray(Te,ve-Pe)}],W.resultId)}_send(O,W){if(x._isSemanticTokens(O)){const q=this._nextResultId++;return this._previousResults.set(q,new j(O.resultId,O.data)),(0,f.encodeSemanticTokensDto)({id:q,type:"full",data:O.data})}if(x._isSemanticTokensEdits(O)){const q=this._nextResultId++;return x._isSemanticTokens(W)?this._previousResults.set(q,new j(W.resultId,W.data)):this._previousResults.set(q,new j(O.resultId)),(0,f.encodeSemanticTokensDto)({id:q,type:"delta",deltas:(O.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}class Q{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentRangeSemanticTokens(O,W,q){const X=this._documents.getDocument(O),ae=await this._provider.provideDocumentRangeSemanticTokens(X,I.Range.to(W),q);return ae?this._send(ae):null}_send(O){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class K{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,W,q,X,ae){this._documents=O,this._commands=W,this._provider=q,this._apiDeprecation=X,this._extension=ae,this._cache=new h.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(O,W,q,X){const ae=this._documents.getDocument(O),ve=I.Position.to(W),Te=ae.getWordRangeAtPosition(ve)||new P.Range(ve,ve),ge=Te.with({end:ve}),Pe=new v.StopWatch(!0),De=await this._provider.provideCompletionItems(ae,ve,X,I.CompletionContext.to(q));if(!De||X.isCancellationRequested)return;const xe=Array.isArray(De)?new P.CompletionList(De):De,je=K.supportsResolving(this._provider)?this._cache.add(xe.items):this._cache.add([]),nt=new w.DisposableStore;this._disposables.set(je,nt);const Xe=[],rt={x:je,b:Xe,a:{replace:I.Range.from(Te),insert:I.Range.from(ge)},c:xe.isIncomplete||void 0,d:Pe.elapsed()};for(let Be=0;Be<xe.items.length;Be++){const dt=xe.items[Be],se=this._convertCompletionItem(dt,[je,Be],ge,Te);Xe.push(se)}return rt}async resolveCompletionItem(O,W){if(typeof this._provider.resolveCompletionItem!="function")return;const q=this._cache.get(...O);if(!q)return;const X=await this._provider.resolveCompletionItem(q,W);if(!!X)return this._convertCompletionItem(X,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,W,q,X){const ae=this._disposables.get(W[0]);if(!ae)throw Error("DisposableStore is missing...");const ve=this._commands.toInternal(O.command,ae),Te={x:W,a:O.label,b:O.kind!==void 0?I.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(I.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:I.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(I.TextEdit.from),n:ve?.$ident,o:ve?.id,p:ve?.$ident?void 0:ve?.arguments};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=O.textEdit.newText):typeof O.insertText=="string"?Te.h=O.insertText:O.insertText instanceof P.SnippetString&&(Te.h=O.insertText.value,Te.i|=4);let ge;return O.textEdit?ge=O.textEdit.range:O.range&&(ge=O.range),P.Range.isRange(ge)?Te.j=I.Range.from(ge):ge&&(!q?.isEqual(ge.inserting)||!X?.isEqual(ge.replacing))&&(Te.j={insert:I.Range.from(ge.inserting),replace:I.Range.from(ge.replacing)}),Te}}class le{async provideInlineCompletions(O,W,q,X){}disposeCompletions(O){}handleDidShowCompletionItem(O,W){}}class ie extends le{constructor(O,W,q,X){super(),this._extension=O,this._documents=W,this._provider=q,this._commands=X,this._references=new de,this._isAdditionsProposedApiEnabled=(0,b.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[y.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,b.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,W,q,X){const ae=this._documents.getDocument(O),ve=I.Position.to(W),Te=await this._provider.provideInlineCompletionItems(ae,ve,{selectedCompletionInfo:q.selectedSuggestionInfo?{range:I.Range.to(q.selectedSuggestionInfo.range),text:q.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[q.triggerKind]},X);if(!Te||X.isCancellationRequested)return;const ge=Array.isArray(Te)?Te:Te.items,Pe=this._isAdditionsProposedApiEnabled?Array.isArray(Te)?[]:Te.commands||[]:[];let De;return{pid:this._references.createReferenceId({dispose(){De?.dispose()},items:ge}),items:ge.map((je,nt)=>{let Xe;je.command&&(De||(De=new w.DisposableStore),Xe=this._commands.toInternal(je.command,De));const rt=je.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:je.filterText,range:je.range?I.Range.from(je.range):void 0,command:Xe,idx:nt,completeBracketPairs:this._isAdditionsProposedApiEnabled?je.completeBracketPairs:!1}}),commands:Pe.map(je=>(De||(De=new w.DisposableStore),this._commands.toInternal(je,De)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,W){const q=this._references.get(O)?.items[W];q&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(q)}}class de{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const W=this._idPool++;return this._references.set(W,O),W}disposeReferenceId(O){const W=this._references.get(O);return this._references.delete(O),W}get(O){return this._references.get(O)}}class Y{constructor(O,W){this._documents=O,this._provider=W,this._cache=new h.Cache("SignatureHelp")}async provideSignatureHelp(O,W,q,X){const ae=this._documents.getDocument(O),ve=I.Position.to(W),Te=this.reviveContext(q),ge=await this._provider.provideSignatureHelp(ae,ve,X,Te);if(ge){const Pe=this._cache.add([ge]);return{...I.SignatureHelp.from(ge),id:Pe}}}reviveContext(O){let W;if(O.activeSignatureHelp){const q=I.SignatureHelp.to(O.activeSignatureHelp),X=this._cache.get(O.activeSignatureHelp.id,0);X?(W=X,W.activeSignature=q.activeSignature,W.activeParameter=q.activeParameter):W=q}return{...O,activeSignatureHelp:W}}releaseSignatureHelp(O){this._cache.delete(O)}}class pe{constructor(O,W,q,X,ae){this._documents=O,this._commands=W,this._provider=q,this._logService=X,this._extension=ae,this._cache=new h.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,W,q){const X=this._documents.getDocument(O),ae=I.Range.to(W),ve=await this._provider.provideInlayHints(X,ae,q);if(!Array.isArray(ve)||ve.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${W}`);return}if(q.isCancellationRequested)return;const Te=this._cache.add(ve);this._disposables.set(Te,new w.DisposableStore);const ge={hints:[],cacheId:Te};for(let Pe=0;Pe<ve.length;Pe++)this._isValidInlayHint(ve[Pe],ae)&&ge.hints.push(this._convertInlayHint(ve[Pe],[Te,Pe]));return this._logService.trace(`[InlayHints] ${ge.hints.length} inlay hints from '${this._extension.identifier.value}' for ${W}`),ge}async resolveInlayHint(O,W){if(typeof this._provider.resolveInlayHint!="function")return;const q=this._cache.get(...O);if(!q)return;const X=await this._provider.resolveInlayHint(q,W);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,W){return O.label.length===0||Array.isArray(O.label)&&O.label.every(q=>q.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(W&&!W.contains(O.position))}_convertInlayHint(O,W){const q=this._disposables.get(W[0]);if(!q)throw Error("DisposableStore is missing...");const X={label:"",cacheId:W,tooltip:I.MarkdownString.fromStrict(O.tooltip),position:I.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(I.TextEdit.from),kind:O.kind&&I.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?X.label=O.label:X.label=O.label.map(ae=>{const ve={label:ae.value};return ve.tooltip=I.MarkdownString.fromStrict(ae.tooltip),P.Location.isLocation(ae.location)&&(ve.location=I.location.from(ae.location)),ae.command&&(ve.command=this._commands.toInternal(ae.command,q)),ve}),X}}class be{constructor(O,W){this._documents=O,this._provider=W,this._cache=new h.Cache("DocumentLink")}async provideLinks(O,W){const q=this._documents.getDocument(O),X=await this._provider.provideDocumentLinks(q,W);if(!(!Array.isArray(X)||X.length===0)&&!W.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(be._validateLink).map(I.DocumentLink.from)};{const ae=this._cache.add(X),ve={links:[],cacheId:ae};for(let Te=0;Te<X.length;Te++){if(!be._validateLink(X[Te]))continue;const ge=I.DocumentLink.from(X[Te]);ge.cacheId=[ae,Te],ve.links.push(ge)}return ve}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,W){if(typeof this._provider.resolveDocumentLink!="function")return;const q=this._cache.get(...O);if(!q)return;const X=await this._provider.resolveDocumentLink(q,W);if(!(!X||!be._validateLink(X)))return I.DocumentLink.from(X)}releaseLinks(O){this._cache.delete(O)}}class Ce{constructor(O,W){this._documents=O,this._provider=W}async provideColors(O,W){const q=this._documents.getDocument(O),X=await this._provider.provideDocumentColors(q,W);return Array.isArray(X)?X.map(ve=>({color:I.Color.from(ve.color),range:I.Range.from(ve.range)})):[]}async provideColorPresentations(O,W,q){const X=this._documents.getDocument(O),ae=I.Range.to(W.range),ve=I.Color.to(W.color),Te=await this._provider.provideColorPresentations(ve,{document:X,range:ae},q);if(!!Array.isArray(Te))return Te.map(I.ColorPresentation.from)}}class Re{constructor(O,W){this._documents=O,this._provider=W}async provideFoldingRanges(O,W,q){const X=this._documents.getDocument(O),ae=await this._provider.provideFoldingRanges(X,W,q);if(!!Array.isArray(ae))return ae.map(I.FoldingRange.from)}}class We{constructor(O,W,q){this._documents=O,this._provider=W,this._logService=q}async provideSelectionRanges(O,W,q){const X=this._documents.getDocument(O),ae=W.map(I.Position.to),ve=await this._provider.provideSelectionRanges(X,ae,q);if(!(0,A.isNonEmptyArray)(ve))return[];if(ve.length!==ae.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let ge=0;ge<ae.length;ge++){const Pe=[];Te.push(Pe);let De=ae[ge],xe=ve[ge];for(;;){if(!xe.range.contains(De))throw new Error("INVALID selection range, must contain the previous range");if(Pe.push(I.SelectionRange.from(xe)),!xe.parent)break;De=xe.range,xe=xe.parent}}return Te}}class ne{constructor(O,W){this._documents=O,this._provider=W,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.prepareCallHierarchy(X,ae,q);if(!ve)return;const Te=this._idPool.nextId();return this._cache.set(Te,new Map),Array.isArray(ve)?ve.map(ge=>this._cacheAndConvertItem(Te,ge)):[this._cacheAndConvertItem(Te,ve)]}async provideCallsTo(O,W,q){const X=this._itemFromCache(O,W);if(!X)throw new Error("missing call hierarchy item");const ae=await this._provider.provideCallHierarchyIncomingCalls(X,q);if(!!ae)return ae.map(ve=>({from:this._cacheAndConvertItem(O,ve.from),fromRanges:ve.fromRanges.map(Te=>I.Range.from(Te))}))}async provideCallsFrom(O,W,q){const X=this._itemFromCache(O,W);if(!X)throw new Error("missing call hierarchy item");const ae=await this._provider.provideCallHierarchyOutgoingCalls(X,q);if(!!ae)return ae.map(ve=>({to:this._cacheAndConvertItem(O,ve.to),fromRanges:ve.fromRanges.map(Te=>I.Range.from(Te))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,W){const q=this._cache.get(O),X=I.CallHierarchyItem.from(W,O,q.size.toString(36));return q.set(X._itemId,W),X}_itemFromCache(O,W){return this._cache.get(O)?.get(W)}}class ce{constructor(O,W){this._documents=O,this._provider=W,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.prepareTypeHierarchy(X,ae,q);if(!ve)return;const Te=this._idPool.nextId();return this._cache.set(Te,new Map),Array.isArray(ve)?ve.map(ge=>this._cacheAndConvertItem(Te,ge)):[this._cacheAndConvertItem(Te,ve)]}async provideSupertypes(O,W,q){const X=this._itemFromCache(O,W);if(!X)throw new Error("missing type hierarchy item");const ae=await this._provider.provideTypeHierarchySupertypes(X,q);if(!!ae)return ae.map(ve=>this._cacheAndConvertItem(O,ve))}async provideSubtypes(O,W,q){const X=this._itemFromCache(O,W);if(!X)throw new Error("missing type hierarchy item");const ae=await this._provider.provideTypeHierarchySubtypes(X,q);if(!!ae)return ae.map(ve=>this._cacheAndConvertItem(O,ve))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,W){const q=this._cache.get(O),X=I.TypeHierarchyItem.from(W,O,q.size.toString(36));return q.set(X._itemId,W),X}_itemFromCache(O,W){return this._cache.get(O)?.get(W)}}class fe{constructor(O,W,q,X){this._proxy=O,this._documents=W,this._provider=q,this._handle=X}async provideDocumentOnDropEdits(O,W,q,X,ae){const ve=this._documents.getDocument(W),Te=I.Position.to(q),ge=I.DataTransfer.toDataTransfer(X,async De=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,De)).buffer),Pe=await this._provider.provideDocumentDropEdits(ve,Te,ge,ae);if(!!Pe)return{insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?I.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class J{constructor(O,W){this.adapter=O,this.extension=W}}class re{constructor(O,W,q,X,ae,ve,Te,ge){this._uriTransformer=W,this._documents=q,this._commands=X,this._diagnostics=ae,this._logService=ve,this._apiDeprecation=Te,this._extensionTelemetry=ge,this._adapter=new Map,this._proxy=O.getProxy(T.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(O){return I.DocumentSelector.from(O,this._uriTransformer)}_createDisposable(O){return new P.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return re._handlePool++}async _withAdapter(O,W,q,X,ae,ve=!1){const Te=this._adapter.get(O);if(!Te||!(Te.adapter instanceof W))return X;const ge=Date.now();ve||this._logService.trace(`[${Te.extension.identifier.value}] INVOKE provider '${q.toString().replace(/[\r\n]/g,"")}'`);const Pe=q(Te.adapter,Te.extension);return Promise.resolve(Pe).catch(De=>{(0,m.isCancellationError)(De)||(this._logService.error(`[${Te.extension.identifier.value}] provider FAILED`),this._logService.error(De),this._extensionTelemetry.onExtensionError(Te.extension.identifier,De))}).finally(()=>{ve||this._logService.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-ge}ms`)}),_.CancellationToken.isCancellationToken(ae)?(0,r.raceCancellationError)(Pe,ae):Pe}_addNewAdapter(O,W){const q=this._nextHandle();return this._adapter.set(q,new J(O,W)),q}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,W,q,X){const ae=this._addNewAdapter(new s(this._documents,q),O),ve=X&&X.label||re._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(ae,this._transformDocumentSelector(W),ve),this._createDisposable(ae)}$provideDocumentSymbols(O,W,q){return this._withAdapter(O,s,X=>X.provideDocumentSymbols(c.URI.revive(W),q),void 0,q)}registerCodeLensProvider(O,W,q){const X=this._nextHandle(),ae=typeof q.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new J(new u(this._documents,this._commands.converter,q),O)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(W),ae);let ve=this._createDisposable(X);if(ae!==void 0){const Te=q.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(ae));ve=P.Disposable.from(ve,Te)}return ve}$provideCodeLenses(O,W,q){return this._withAdapter(O,u,X=>X.provideCodeLenses(c.URI.revive(W),q),void 0,q)}$resolveCodeLens(O,W,q){return this._withAdapter(O,u,X=>X.resolveCodeLens(W,q),void 0,void 0)}$releaseCodeLenses(O,W){this._withAdapter(O,u,q=>Promise.resolve(q.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(O,W,q){const X=this._addNewAdapter(new l(this._documents,q),O);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideDefinition(O,W,q,X){return this._withAdapter(O,l,ae=>ae.provideDefinition(c.URI.revive(W),q,X),[],X)}registerDeclarationProvider(O,W,q){const X=this._addNewAdapter(new a(this._documents,q),O);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideDeclaration(O,W,q,X){return this._withAdapter(O,a,ae=>ae.provideDeclaration(c.URI.revive(W),q,X),[],X)}registerImplementationProvider(O,W,q){const X=this._addNewAdapter(new d(this._documents,q),O);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideImplementation(O,W,q,X){return this._withAdapter(O,d,ae=>ae.provideImplementation(c.URI.revive(W),q,X),[],X)}registerTypeDefinitionProvider(O,W,q){const X=this._addNewAdapter(new n(this._documents,q),O);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideTypeDefinition(O,W,q,X){return this._withAdapter(O,n,ae=>ae.provideTypeDefinition(c.URI.revive(W),q,X),[],X)}registerHoverProvider(O,W,q,X){const ae=this._addNewAdapter(new i(this._documents,q),O);return this._proxy.$registerHoverProvider(ae,this._transformDocumentSelector(W)),this._createDisposable(ae)}$provideHover(O,W,q,X){return this._withAdapter(O,i,ae=>ae.provideHover(c.URI.revive(W),q,X),void 0,X)}registerEvaluatableExpressionProvider(O,W,q,X){const ae=this._addNewAdapter(new p(this._documents,q),O);return this._proxy.$registerEvaluatableExpressionProvider(ae,this._transformDocumentSelector(W)),this._createDisposable(ae)}$provideEvaluatableExpression(O,W,q,X){return this._withAdapter(O,p,ae=>ae.provideEvaluatableExpression(c.URI.revive(W),q,X),void 0,X)}registerInlineValuesProvider(O,W,q,X){const ae=typeof q.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ve=this._addNewAdapter(new C(this._documents,q),O);this._proxy.$registerInlineValuesProvider(ve,this._transformDocumentSelector(W),ae);let Te=this._createDisposable(ve);if(ae!==void 0){const ge=q.onDidChangeInlineValues(Pe=>this._proxy.$emitInlineValuesEvent(ae));Te=P.Disposable.from(Te,ge)}return Te}$provideInlineValues(O,W,q,X,ae){return this._withAdapter(O,C,ve=>ve.provideInlineValues(c.URI.revive(W),q,X,ae),void 0,ae)}registerDocumentHighlightProvider(O,W,q){const X=this._addNewAdapter(new R(this._documents,q),O);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideDocumentHighlights(O,W,q,X){return this._withAdapter(O,R,ae=>ae.provideDocumentHighlights(c.URI.revive(W),q,X),void 0,X)}registerLinkedEditingRangeProvider(O,W,q){const X=this._addNewAdapter(new U(this._documents,q),O);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideLinkedEditingRanges(O,W,q,X){return this._withAdapter(O,U,async ae=>{const ve=await ae.provideLinkedEditingRanges(c.URI.revive(W),q,X);if(ve)return{ranges:ve.ranges,wordPattern:ve.wordPattern?re._serializeRegExp(ve.wordPattern):void 0}},void 0,X)}registerReferenceProvider(O,W,q){const X=this._addNewAdapter(new H(this._documents,q),O);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideReferences(O,W,q,X,ae){return this._withAdapter(O,H,ve=>ve.provideReferences(c.URI.revive(W),q,X,ae),void 0,ae)}registerCodeActionProvider(O,W,q,X){const ae=new w.DisposableStore,ve=this._addNewAdapter(new V(this._documents,this._commands.converter,this._diagnostics,q,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(ve,this._transformDocumentSelector(W),{providedKinds:X?.providedCodeActionKinds?.map(Te=>Te.value),documentation:X?.documentation?.map(Te=>({kind:Te.kind.value,command:this._commands.converter.toInternal(Te.command,ae)}))},re._extLabel(O),Boolean(q.resolveCodeAction)),ae.add(this._createDisposable(ve)),ae}$provideCodeActions(O,W,q,X,ae){return this._withAdapter(O,V,ve=>ve.provideCodeActions(c.URI.revive(W),q,X,ae),void 0,ae)}$resolveCodeAction(O,W,q){return this._withAdapter(O,V,X=>X.resolveCodeAction(W,q),void 0,void 0)}$releaseCodeActions(O,W){this._withAdapter(O,V,q=>Promise.resolve(q.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(O,W,q){const X=this._addNewAdapter(new M(this._documents,q),O);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(W),O.identifier,O.displayName||O.name),this._createDisposable(X)}$provideDocumentFormattingEdits(O,W,q,X){return this._withAdapter(O,M,ae=>ae.provideDocumentFormattingEdits(c.URI.revive(W),q,X),void 0,X)}registerDocumentRangeFormattingEditProvider(O,W,q){const X=this._addNewAdapter(new F(this._documents,q),O);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(W),O.identifier,O.displayName||O.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(O,W,q,X,ae){return this._withAdapter(O,F,ve=>ve.provideDocumentRangeFormattingEdits(c.URI.revive(W),q,X,ae),void 0,ae)}registerOnTypeFormattingEditProvider(O,W,q,X){const ae=this._addNewAdapter(new B(this._documents,q),O);return this._proxy.$registerOnTypeFormattingSupport(ae,this._transformDocumentSelector(W),X,O.identifier),this._createDisposable(ae)}$provideOnTypeFormattingEdits(O,W,q,X,ae,ve){return this._withAdapter(O,B,Te=>Te.provideOnTypeFormattingEdits(c.URI.revive(W),q,X,ae,ve),void 0,ve)}registerWorkspaceSymbolProvider(O,W){const q=this._addNewAdapter(new N(W,this._logService),O);return this._proxy.$registerNavigateTypeSupport(q,typeof W.resolveWorkspaceSymbol=="function"),this._createDisposable(q)}$provideWorkspaceSymbols(O,W,q){return this._withAdapter(O,N,X=>X.provideWorkspaceSymbols(W,q),{symbols:[]},q)}$resolveWorkspaceSymbol(O,W,q){return this._withAdapter(O,N,X=>X.resolveWorkspaceSymbol(W,q),void 0,void 0)}$releaseWorkspaceSymbols(O,W){this._withAdapter(O,N,q=>q.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(O,W,q){const X=this._addNewAdapter(new z(this._documents,q,this._logService),O);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(W),z.supportsResolving(q)),this._createDisposable(X)}$provideRenameEdits(O,W,q,X,ae){return this._withAdapter(O,z,ve=>ve.provideRenameEdits(c.URI.revive(W),q,X,ae),void 0,ae)}$resolveRenameLocation(O,W,q,X){return this._withAdapter(O,z,ae=>ae.resolveRenameLocation(c.URI.revive(W),q,X),void 0,X)}registerDocumentSemanticTokensProvider(O,W,q,X){const ae=this._addNewAdapter(new x(this._documents,q),O),ve=typeof q.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ae,this._transformDocumentSelector(W),X,ve);let Te=this._createDisposable(ae);if(ve){const ge=q.onDidChangeSemanticTokens(Pe=>this._proxy.$emitDocumentSemanticTokensEvent(ve));Te=P.Disposable.from(Te,ge)}return Te}$provideDocumentSemanticTokens(O,W,q,X){return this._withAdapter(O,x,ae=>ae.provideDocumentSemanticTokens(c.URI.revive(W),q,X),null,X)}$releaseDocumentSemanticTokens(O,W){this._withAdapter(O,x,q=>q.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,W,q,X){const ae=this._addNewAdapter(new Q(this._documents,q),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ae,this._transformDocumentSelector(W),X),this._createDisposable(ae)}$provideDocumentRangeSemanticTokens(O,W,q,X){return this._withAdapter(O,Q,ae=>ae.provideDocumentRangeSemanticTokens(c.URI.revive(W),q,X),null,X)}registerCompletionItemProvider(O,W,q,X){const ae=this._addNewAdapter(new K(this._documents,this._commands.converter,q,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(ae,this._transformDocumentSelector(W),X,K.supportsResolving(q),`${O.identifier.value}(${X.join("")})`),this._createDisposable(ae)}$provideCompletionItems(O,W,q,X,ae){return this._withAdapter(O,K,ve=>ve.provideCompletionItems(c.URI.revive(W),q,X,ae),void 0,ae)}$resolveCompletionItem(O,W,q){return this._withAdapter(O,K,X=>X.resolveCompletionItem(W,q),void 0,q)}$releaseCompletionItems(O,W){this._withAdapter(O,K,q=>q.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(O,W,q){const X=new ie(O,this._documents,q,this._commands.converter),ae=this._addNewAdapter(X,O);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(W),X.supportsHandleDidShowCompletionItem),this._createDisposable(ae)}$provideInlineCompletions(O,W,q,X,ae){return this._withAdapter(O,le,ve=>ve.provideInlineCompletions(c.URI.revive(W),q,X,ae),void 0,ae)}$handleInlineCompletionDidShow(O,W,q){this._withAdapter(O,le,async X=>{X.handleDidShowCompletionItem(W,q)},void 0,void 0)}$freeInlineCompletionsList(O,W){this._withAdapter(O,le,async q=>{q.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(O,W,q,X){const ae=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,ve=this._addNewAdapter(new Y(this._documents,q),O);return this._proxy.$registerSignatureHelpProvider(ve,this._transformDocumentSelector(W),ae),this._createDisposable(ve)}$provideSignatureHelp(O,W,q,X,ae){return this._withAdapter(O,Y,ve=>ve.provideSignatureHelp(c.URI.revive(W),q,X,ae),void 0,ae)}$releaseSignatureHelp(O,W){this._withAdapter(O,Y,q=>q.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(O,W,q){const X=typeof q.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new pe(this._documents,this._commands.converter,q,this._logService,O),O);this._proxy.$registerInlayHintsProvider(ae,this._transformDocumentSelector(W),typeof q.resolveInlayHint=="function",X,re._extLabel(O));let ve=this._createDisposable(ae);if(X!==void 0){const Te=q.onDidChangeInlayHints(ge=>this._proxy.$emitInlayHintsEvent(X));ve=P.Disposable.from(ve,Te)}return ve}$provideInlayHints(O,W,q,X){return this._withAdapter(O,pe,ae=>ae.provideInlayHints(c.URI.revive(W),q,X),void 0,X)}$resolveInlayHint(O,W,q){return this._withAdapter(O,pe,X=>X.resolveInlayHint(W,q),void 0,q)}$releaseInlayHints(O,W){this._withAdapter(O,pe,q=>q.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(O,W,q){const X=this._addNewAdapter(new be(this._documents,q),O);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(W),typeof q.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(O,W,q){return this._withAdapter(O,be,X=>X.provideLinks(c.URI.revive(W),q),void 0,q,W.scheme==="output")}$resolveDocumentLink(O,W,q){return this._withAdapter(O,be,X=>X.resolveLink(W,q),void 0,void 0,!0)}$releaseDocumentLinks(O,W){this._withAdapter(O,be,q=>q.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(O,W,q){const X=this._addNewAdapter(new Ce(this._documents,q),O);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideDocumentColors(O,W,q){return this._withAdapter(O,Ce,X=>X.provideColors(c.URI.revive(W),q),[],q)}$provideColorPresentations(O,W,q,X){return this._withAdapter(O,Ce,ae=>ae.provideColorPresentations(c.URI.revive(W),q,X),void 0,X)}registerFoldingRangeProvider(O,W,q){const X=this._nextHandle(),ae=typeof q.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new J(new Re(this._documents,q),O)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(W),O.identifier,ae);let ve=this._createDisposable(X);if(ae!==void 0){const Te=q.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ae));ve=P.Disposable.from(ve,Te)}return ve}$provideFoldingRanges(O,W,q,X){return this._withAdapter(O,Re,ae=>ae.provideFoldingRanges(c.URI.revive(W),q,X),void 0,X)}registerSelectionRangeProvider(O,W,q){const X=this._addNewAdapter(new We(this._documents,q,this._logService),O);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideSelectionRanges(O,W,q,X){return this._withAdapter(O,We,ae=>ae.provideSelectionRanges(c.URI.revive(W),q,X),[],X)}registerCallHierarchyProvider(O,W,q){const X=this._addNewAdapter(new ne(this._documents,q),O);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$prepareCallHierarchy(O,W,q,X){return this._withAdapter(O,ne,ae=>Promise.resolve(ae.prepareSession(c.URI.revive(W),q,X)),void 0,X)}$provideCallHierarchyIncomingCalls(O,W,q,X){return this._withAdapter(O,ne,ae=>ae.provideCallsTo(W,q,X),void 0,X)}$provideCallHierarchyOutgoingCalls(O,W,q,X){return this._withAdapter(O,ne,ae=>ae.provideCallsFrom(W,q,X),void 0,X)}$releaseCallHierarchy(O,W){this._withAdapter(O,ne,q=>Promise.resolve(q.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(O,W,q){const X=this._addNewAdapter(new ce(this._documents,q),O);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$prepareTypeHierarchy(O,W,q,X){return this._withAdapter(O,ce,ae=>Promise.resolve(ae.prepareSession(c.URI.revive(W),q,X)),void 0,X)}$provideTypeHierarchySupertypes(O,W,q,X){return this._withAdapter(O,ce,ae=>ae.provideSupertypes(W,q,X),void 0,X)}$provideTypeHierarchySubtypes(O,W,q,X){return this._withAdapter(O,ce,ae=>ae.provideSubtypes(W,q,X),void 0,X)}$releaseTypeHierarchy(O,W){this._withAdapter(O,ce,q=>Promise.resolve(q.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(O,W,q){const X=this._nextHandle();return this._adapter.set(X,new J(new fe(this._proxy,this._documents,q,X),O)),this._proxy.$registerDocumentOnDropEditProvider(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideDocumentOnDropEdits(O,W,q,X,ae,ve){return this._withAdapter(O,fe,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(W,c.URI.revive(q),X,ae,ve)),void 0,void 0)}registerDocumentPasteEditProvider(O,W,q,X){const ae=this._nextHandle();return this._adapter.set(ae,new J(new L(this._proxy,this._documents,q,ae),O)),this._proxy.$registerPasteEditProvider(ae,this._transformDocumentSelector(W),!!q.prepareDocumentPaste,X.pasteMimeTypes),this._createDisposable(ae)}$prepareDocumentPaste(O,W,q,X,ae){return this._withAdapter(O,L,ve=>ve.prepareDocumentPaste(c.URI.revive(W),q,X,ae),void 0,ae)}$providePasteEdits(O,W,q,X,ae,ve){return this._withAdapter(O,L,Te=>Te.providePasteEdits(W,c.URI.revive(q),X,ae,ve),void 0,ve)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,S.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:re._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:re._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?re._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?re._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:re._serializeRegExp(O.beforeText),afterText:O.afterText?re._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?re._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(re._serializeOnEnterRule)}setLanguageConfiguration(O,W,q){const{wordPattern:X}=q;if(X&&(0,S.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(W,X):this._documents.setWordDefinitionFor(W,void 0),q.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),q.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const ae=this._nextHandle(),ve={comments:q.comments,brackets:q.brackets,wordPattern:q.wordPattern?re._serializeRegExp(q.wordPattern):void 0,indentationRules:q.indentationRules?re._serializeIndentationRule(q.indentationRules):void 0,onEnterRules:q.onEnterRules?re._serializeOnEnterRules(q.onEnterRules):void 0,__electricCharacterSupport:q.__electricCharacterSupport,__characterPairSupport:q.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ae,W,ve),this._createDisposable(ae)}$setWordDefinitions(O){for(const W of O)this._documents.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.ExtHostLanguageFeatures=re,re._handlePool=0}),define(_e[255],ye([1,0,5,15,7,42,18,6]),function(Z,e,c,t,I,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(A,k,E,_){this._documents=k,this._commands=E,this._uriTransformer=_,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=A.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(A){this._languageIds=A}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(A,k){await this._proxy.$changeLanguage(A,k);const E=this._documents.getDocumentData(A);if(!E)throw new Error(`document '${A.toString()}' NOT found`);return E.document}async tokenAtPosition(A,k){const E=A.version,_=t.Position.from(k),w=await this._proxy.$tokensAtPosition(A.uri,_),f={type:I.StandardTokenType.Other,range:A.getWordRangeAtPosition(k)??new I.Range(k.line,k.character,k.line,k.character)};if(!w)return f;const g={range:t.Range.to(w.range),type:t.TokenType.to(w.type)};return!g.range.contains(k)||E!==A.version?f:g}createLanguageStatusItem(A,k,E){const _=this._handlePool++,w=this._proxy,f=this._ids,g=`${A.identifier.value}/${k}`;if(f.has(g))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);f.add(g);const h={selector:E,id:k,name:A.displayName??A.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const m=new T.DisposableStore,r=()=>{v?.dispose(),v=(0,y.disposableTimeout)(()=>{m.clear(),this._proxy.$setLanguageStatus(_,{id:g,name:h.name??A.displayName??A.name,source:A.displayName??A.name,selector:t.DocumentSelector.from(h.selector,this._uriTransformer),label:h.text,detail:h.detail??"",severity:h.severity===I.LanguageStatusSeverity.Error?P.default.Error:h.severity===I.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:h.command&&this._commands.toInternal(h.command,m),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},b={dispose(){m.dispose(),v?.dispose(),w.$removeLanguageStatus(_),f.delete(g)},get id(){return h.id},get name(){return h.name},set name(s){h.name=s,r()},get selector(){return h.selector},set selector(s){h.selector=s,r()},get text(){return h.text},set text(s){h.text=s,r()},get detail(){return h.detail},set detail(s){h.detail=s,r()},get severity(){return h.severity},set severity(s){h.severity=s,r()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(s){h.accessibilityInformation=s,r()},get command(){return h.command},set command(s){h.command=s,r()},get busy(){return h.busy},set busy(s){h.busy=s,r()}};return r(),b}}e.ExtHostLanguages=S}),define(_e[94],ye([1,0,12,8,2,3,13,5,25,16]),function(Z,e,c,t,I,P,y,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let A=class{constructor(E,_,w){this.logService=w,this.bundleCache=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadLocalization),this.currentLanguage=E.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===c.LANGUAGE_DEFAULT}getMessage(E,_){const{message:w,args:f,comment:g}=_;if(this.isDefaultLanguage)return(0,t.format2)(w,f??{});let h=w;g&&g.length>0&&(h+=`/${Array.isArray(g)?g.join():g}`);const v=this.bundleCache.get(E)?.contents[h];return v||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,t.format2)(v??h,f??{})}getBundle(E){return this.bundleCache.get(E)?.contents}getBundleUri(E){return this.bundleCache.get(E)?.uri}async initializeLocalizedMessages(E){if(this.isDefaultLanguage||!E.l10n&&!E.isBuiltin||this.bundleCache.has(E.identifier.value))return;let _;const w=await this.getBundleLocation(E);if(!w){this.logService.error(`No bundle location found for extension ${E.identifier.value}`);return}try{const f=await this._proxy.$fetchBundleContents(w),g=JSON.parse(f);_=E.isBuiltin?g.contents?.bundle:g}catch(f){this.logService.error(`Failed to load translations for ${E.identifier.value} from ${w}: ${f.message}`);return}_&&this.bundleCache.set(E.identifier.value,{contents:_,uri:w})}async getBundleLocation(E){if(E.isBuiltin){const _=await this._proxy.$fetchBuiltInBundleUri(E.identifier.value);return I.URI.revive(_)}return E.l10n?I.URI.joinPath(E.extensionLocation,E.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};A=Ve([ze(0,S.IExtHostInitDataService),ze(1,D.IExtHostRpcService),ze(2,y.ILogService)],A),e.ExtHostLocalizationService=A,e.IExtHostLocalizationService=(0,P.createDecorator)("IExtHostLocalizationService")}),define(_e[138],ye([1,0,13,5,25,16,2,4,11]),function(Z,e,c,t,I,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends c.AbstractLoggerService{constructor(E,_){super(_.logLevel,T.Event.None),this._proxy=E.getProxy(t.MainContext.MainThreadLogger)}$setLevel(E,_){_?this.setLevel(y.URI.revive(_),E):(0,S.isUndefined)(E)||this.setLevel(E)}doCreateLogger(E,_,w){return new A(this._proxy,E,_,w)}};D=Ve([ze(0,P.IExtHostRpcService),ze(1,I.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class A extends c.AbstractMessageLogger{constructor(E,_,w,f){super(f?.always),this.proxy=E,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(w),this.proxy.$createLogger(_,f).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,_){const w=[[E,_]];this.isLoggerCreated?this.doLog(w):this.buffer.push(...w)}doLog(E){this.proxy.$log(this.file,E)}}}),define(_e[256],ye([1,0,5,13,27]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(T){return T&&T.title}let y=class{constructor(S,D){this._logService=D,this._proxy=S.getProxy(c.MainContext.MainThreadMessageService)}showMessage(S,D,A,k,E){const _={source:{identifier:S.identifier,label:S.displayName||S.name}};let w;typeof k=="string"||P(k)?w=[k,...E]:(_.modal=k?.modal,_.useCustom=k?.useCustom,_.detail=k?.detail,w=E),_.useCustom&&(0,I.checkProposedApiEnabled)(S,"resolvers");const f=[];for(let g=0;g<w.length;g++){const h=w[g];if(typeof h=="string")f.push({title:h,handle:g,isCloseAffordance:!1});else if(typeof h=="object"){const{title:v,isCloseAffordance:m}=h;f.push({title:v,isCloseAffordance:!!m,handle:g})}else this._logService.warn("Invalid message item:",h)}return this._proxy.$showMessage(D,A,_,f).then(g=>{if(typeof g=="number")return w[g]})}};y=Ve([ze(1,t.ILogService)],y),e.ExtHostMessageService=y}),define(_e[257],ye([1,0,23,4,6,28,8,11,2,88,5,39,15,7,57,232,134]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(m=>m.apiEditor)}constructor(m,r,b,s){this._textDocumentsAndEditors=b,this._textDocuments=s,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new D.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=m.getProxy(A.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=m.getProxy(A.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=m.getProxy(A.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===12){const o=u.notebookEditor?.notebookUri,l=u.cell.handle,d=this._documents.get(o)?.getCell(l);if(d)return d.apiCell}if(u&&u.$mid===13){const o=u.uri,l=this._documents.get(o);if(l)return l.apiNotebook}return u}}),h._registerApiCommands(r)}getEditorById(m){const r=this._editors.get(m);if(!r)throw new Error(`unknown text editor: ${m}. known editors: ${[...this._editors.keys()]} `);return r}getIdByEditor(m){for(const[r,b]of this._editors)if(b.apiEditor===m)return r}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(m,r){const b=this._documents.get(m);if(!b&&!r)throw new Error(`NO notebook document for '${m}'`);return b}static _convertNotebookRegistrationData(m,r){if(!r)return;const b=r.filenamePattern.map(s=>E.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(r.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${r.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:r.displayName,filenamePattern:b,exclusive:r.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,r,b){const s=h._notebookStatusBarItemProviderHandlePool++,u=typeof b.onDidChangeCellStatusBarItems=="function"?h._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,b),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,u,r);let o;return u!==void 0&&(o=b.onDidChangeCellStatusBarItems(l=>this._notebookProxy.$emitCellStatusBarEvent(u))),new _.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,u),o?.dispose()})}async createNotebookDocument(m){const r=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:m.viewType,content:m.content&&E.NotebookData.from(m.content)});return S.URI.revive(r)}async openNotebookDocument(m){const r=this._documents.get(m);if(r)return r.apiNotebook;const b=await this._notebookDocumentsProxy.$tryOpenNotebook(m),s=this._documents.get(S.URI.revive(b));return(0,T.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(m,r){S.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let b;typeof r=="object"?b={position:E.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(E.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:b={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(m.uri,m.notebookType,b),u=s&&this._editors.get(s)?.apiEditor;if(u)return u;throw s?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,r,b,s){const u=this._notebookStatusBarItemProviders.get(m),o=S.URI.revive(r),l=this._documents.get(o);if(!l||!u)return;const a=l.getCellFromIndex(b);if(!a)return;const d=await u.provideCellStatusBarItems(a.apiCell,s);if(!d)return;const n=new I.DisposableStore,i=this._statusBarCache.add([n]),C=(Array.isArray(d)?d:[d]).map(R=>E.NotebookStatusBarItem.from(R,this._commandsConverter,n));return{cacheId:i,items:C}}$releaseNotebookCellStatusBarItems(m){this._statusBarCache.delete(m)}registerNotebookSerializer(m,r,b,s,u){if((0,y.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,b),this._notebookProxy.$registerNotebookSerializer(o,{id:m.identifier,location:m.extensionLocation},r,E.NotebookDocumentContentOptions.from(s),h._convertNotebookRegistrationData(m,u)),(0,I.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(m,r,b){const s=this._notebookSerializer.get(m);if(!s)throw new Error("NO serializer found");const u=await s.deserializeNotebook(r.buffer,b);return new w.SerializableObjectWithBuffers(E.NotebookData.from(u))}async $notebookToData(m,r,b){const s=this._notebookSerializer.get(m);if(!s)throw new Error("NO serializer found");const u=await s.serializeNotebook(E.NotebookData.to(r.value),b);return c.VSBuffer.wrap(u)}_createExtHostEditor(m,r,b){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const s=new g.ExtHostNotebookEditor(r,this._notebookEditorsProxy,m,b.visibleRanges.map(E.NotebookRange.to),b.selections.map(E.NotebookRange.to),typeof b.viewColumn=="number"?E.ViewColumn.to(b.viewColumn):void 0);this._editors.set(r,s)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const b of m.value.removedDocuments){const s=S.URI.revive(b),u=this._documents.get(s);u&&(u.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:u.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(u.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===s.toString()&&this._editors.delete(o.id)}if(m.value.addedDocuments){const b=[];for(const s of m.value.addedDocuments){const u=S.URI.revive(s.uri);if(this._documents.has(u))throw new Error(`adding EXISTING notebook ${u} `);const o=new f.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,u,s);b.push(...s.cells.map(l=>f.ExtHostCell.asModelAddData(o.apiNotebook,l))),this._documents.get(u)?.dispose(),this._documents.set(u,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(m.value.addedEditors)for(const b of m.value.addedEditors){if(this._editors.has(b.id))return;const s=S.URI.revive(b.documentUri),u=this._documents.get(s);u&&this._createExtHostEditor(u,b.id,b)}const r=[];if(m.value.removedEditors)for(const b of m.value.removedEditors){const s=this._editors.get(b);s&&(this._editors.delete(b),this._activeNotebookEditor?.id===s.id&&(this._activeNotebookEditor=void 0),r.push(s))}if(m.value.visibleEditors){this._visibleNotebookEditors=m.value.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const b=new Set;this._visibleNotebookEditors.forEach(s=>b.add(s.id));for(const s of this._editors.values()){const u=b.has(s.id);s._acceptVisibility(u)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this._activeNotebookEditor=void 0:m.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(m){const r=k.ApiCommandArgument.String.with("notebookType","A notebook type"),b=new k.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[r,new k.ApiCommandArgument("data","Bytes to convert to data",u=>u instanceof Uint8Array,u=>c.VSBuffer.wrap(u))],new k.ApiCommandResult("Notebook Data",u=>E.NotebookData.to(u.value))),s=new k.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[r,new k.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",u=>!0,u=>new w.SerializableObjectWithBuffers(E.NotebookData.from(u)))],new k.ApiCommandResult("Bytes",u=>u.buffer));m.registerApiCommand(b),m.registerApiCommand(s)}}e.ExtHostNotebookController=h,h._notebookStatusBarItemProviderHandlePool=0}),define(_e[258],ye([1,0,17,18,21,4,6,28,2,26,13,5,39,15,7,89,220,27,57]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let m=class{constructor(l,a,d,n,i){this._initData=a,this._extHostNotebook=d,this._commands=n,this._logService=i,this._activeExecutions=new T.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=l.getProxy(k.MainContext.MainThreadNotebookKernels);const p=new E.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new E.ApiCommandArgument("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const R=this._extHostNotebook.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:R}}else if(C&&"notebookEditor"in C){const R=this._extHostNotebook.getIdByEditor(C.notebookEditor);if(R===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:R}}return C})],E.ApiCommandResult.Void);this._commands.registerApiCommand(p)}createNotebookController(l,a,d,n,i,p){for(const K of this._kernelData.values())if(K.controller.id===a&&D.ExtensionIdentifier.equals(l.identifier,K.extensionId))throw new Error(`notebook controller with id '${a}' ALREADY exist`);const C=this._handlePool++,R=this;this._logService.trace(`NotebookController[${C}], CREATED by ${l.identifier.value}, ${a}`);const U=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${l.identifier}'`);let H=!1;const V=new y.DisposableStore,L=new P.Emitter,M=new P.Emitter,F={id:u(l.identifier,a),notebookType:d,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:n||l.identifier.value,preloads:p?p.map(_.NotebookRendererScript.from):[]};let B=i??U,N;this._proxy.$addKernel(C,F).catch(K=>{console.log(K),H=!0});let z=0;const j=()=>{if(H)return;const K=++z;Promise.resolve().then(()=>{K===z&&this._proxy.$updateKernel(C,F)})},x=new T.ResourceMap,Q={get id(){return a},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return F.label},set label(K){F.label=K??l.displayName??l.name,j()},get detail(){return F.detail??""},set detail(K){F.detail=K,j()},get description(){return F.description??""},set description(K){F.description=K,j()},get kind(){return(0,h.checkProposedApiEnabled)(l,"notebookControllerKind"),F.kind??""},set kind(K){(0,h.checkProposedApiEnabled)(l,"notebookControllerKind"),F.kind=K,j()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(K){F.supportedLanguages=K,j()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(K){F.supportsExecutionOrder=K,j()},get rendererScripts(){return F.preloads?F.preloads.map(_.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(K){B=K??U},get interruptHandler(){return N},set interruptHandler(K){N=K,F.supportsInterrupt=Boolean(K),j()},createNotebookCellExecution(K){if(H)throw new Error("notebook controller is DISPOSED");if(!x.has(K.notebook.uri))throw R._logService.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(le=>le.toString())),new Error(`notebook controller is NOT associated to notebook: ${K.notebook.uri.toString()}`);return R._createNotebookCellExecution(K,u(l.identifier,this.id))},dispose:()=>{H||(this._logService.trace(`NotebookController[${C}], DISPOSED`),H=!0,this._kernelData.delete(C),V.dispose(),L.dispose(),M.dispose(),this._proxy.$removeKernel(C))},updateNotebookAffinity(K,le){le===w.NotebookControllerAffinity2.Hidden&&(0,h.checkProposedApiEnabled)(l,"notebookControllerAffinityHidden"),R._proxy.$updateNotebookPriority(C,K.uri,le)},onDidReceiveMessage:M.event,postMessage(K,le){return(0,h.checkProposedApiEnabled)(l,"notebookMessaging"),R._proxy.$postMessage(C,le&&R._extHostNotebook.getIdByEditor(le),K)},asWebviewUri(K){return(0,h.checkProposedApiEnabled)(l,"notebookMessaging"),(0,f.asWebviewUri)(K,R._initData.remote)}};return this._kernelData.set(C,{extensionId:l.identifier,controller:Q,onDidReceiveMessage:M,onDidChangeSelection:L,associatedNotebooks:x}),Q}getIdByController(l){for(const[a,d]of this._kernelData)if(d.controller===l)return u(d.extensionId,l.id);return null}$acceptNotebookAssociation(l,a,d){const n=this._kernelData.get(l);if(n){const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(a));d?n.associatedNotebooks.set(i.uri,!0):n.associatedNotebooks.delete(i.uri),this._logService.trace(`NotebookController[${l}] ASSOCIATE notebook`,i.uri.toString(),d),n.onDidChangeSelection.fire({selected:d,notebook:i.apiNotebook})}}async $executeCells(l,a,d){const n=this._kernelData.get(l);if(!n)return;const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(a)),p=[];for(const C of d){const R=i.getCell(C);R&&p.push(R.apiCell)}try{this._logService.trace(`NotebookController[${l}] EXECUTE cells`,i.uri.toString(),p.length),await n.controller.executeHandler.call(n.controller,p,i.apiNotebook,n.controller)}catch(C){this._logService.error(`NotebookController[${l}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(l,a,d){const n=this._kernelData.get(l);if(!n)return;const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(a));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,i.apiNotebook);else for(const p of d){const C=i.getCell(p);C&&this._activeExecutions.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(l,a,d){const n=this._kernelData.get(l);if(!n)return;const i=this._extHostNotebook.getEditorById(a);n.onDidReceiveMessage.fire(Object.freeze({editor:i.apiEditor,message:d}))}$cellExecutionChanged(l,a,d){const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(l)).getCell(a);if(i){const p=d?_.NotebookCellExecutionState.to(d):w.NotebookCellExecutionState.Idle;p!==void 0&&this._onDidChangeCellExecutionState.fire({cell:i.apiCell,state:p})}}_createNotebookCellExecution(l,a){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this._extHostNotebook.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!n)throw new Error("invalid cell");if(this._activeExecutions.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const i=new b(a,n,this._proxy);this._activeExecutions.set(n.uri,i);const p=i.onDidChangeState(()=>{i.state===r.Resolved&&(i.dispose(),p.dispose(),this._activeExecutions.delete(n.uri))});return i.asApiObject()}};m=Ve([ze(4,A.ILogService)],m),e.ExtHostNotebookKernels=m;var r;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(r||(r={}));class b extends y.Disposable{get state(){return this._state}constructor(l,a,d){super(),this._cell=a,this._proxy=d,this._handle=b.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new s(10,n=>this.update(n)),this._executionOrder=a.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,l,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(l){await this._collector.addItem(l)}async update(l){const a=Array.isArray(l)?l:[l];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(a))}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(l){let a=this._cell;if(l&&(a=this._cell.notebook.getCellFromApiCell(l)),!a)throw new Error("INVALID cell");return a.handle}validateAndConvertOutputs(l){return l.map(a=>{const d=w.NotebookCellOutput.ensureUniqueMimeTypes(a.items,!0);return d===a.items?_.NotebookCellOutput.from(a):_.NotebookCellOutput.from({items:d,id:a.id,metadata:a.metadata})})}async updateOutputs(l,a,d){const n=this.cellIndexToHandle(a),i=this.validateAndConvertOutputs((0,c.asArray)(l));return this.updateSoon({editType:g.CellExecutionUpdateType.Output,cellHandle:n,append:d,outputs:i})}async updateOutputItems(l,a,d){return l=w.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(l),!0),this.updateSoon({editType:g.CellExecutionUpdateType.OutputItems,items:l.map(_.NotebookCellOutputItem.from),outputId:a.id,append:d})}asApiObject(){const l=this;return Object.freeze({get token(){return l._tokenSource.token},get cell(){return l._cell.apiCell},get executionOrder(){return l._executionOrder},set executionOrder(d){l._executionOrder=d,l.update([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:l._executionOrder}])},start(d){if(l._state===r.Resolved||l._state===r.Started)throw new Error("Cannot call start again");l._state=r.Started,l._onDidChangeState.fire(),l.update({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:d})},end(d,n){if(l._state===r.Resolved)throw new Error("Cannot call resolve twice");l._state=r.Resolved,l._onDidChangeState.fire(),l._collector.flush(),l._proxy.$completeExecution(l._handle,new v.SerializableObjectWithBuffers({runEndTime:n,lastRunSuccess:d}))},clearOutput(d){return l.verifyStateForOutput(),l.updateOutputs([],d,!1)},appendOutput(d,n){return l.verifyStateForOutput(),l.updateOutputs(d,n,!0)},replaceOutput(d,n){return l.verifyStateForOutput(),l.updateOutputs(d,n,!1)},appendOutputItems(d,n){return l.verifyStateForOutput(),l.updateOutputItems(d,n,!0)},replaceOutputItems(d,n){return l.verifyStateForOutput(),l.updateOutputItems(d,n,!1)}})}}b.HANDLE=0;class s{constructor(l,a){this.delay=l,this.callback=a,this.batch=[],this.startedTimer=Date.now()}addItem(l){return this.batch.push(l),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const l=this.currentDeferred;this.currentDeferred=void 0;const a=this.batch;return this.batch=[],this.callback(a).finally(()=>l.complete())}}function u(o,l){return`${o.value}/${l}`}e.createKernelId=u}),define(_e[259],ye([1,0,4,5,134]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(T,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=T.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,S,D){const A=this._extHostNotebook.getEditorById(T);this._rendererMessageEmitters.get(S)?.fire({editor:A.apiEditor,message:D})}createRendererMessaging(T,S){if(!T.contributes?.notebookRenderer?.some(A=>A.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(A,k,E)=>this.getOrCreateEmitterFor(S).event(A,k,E),postMessage:(A,k)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(A)&&([A,k]=[k,A]);const E=k&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(E?.id,S,A)}}}getOrCreateEmitterFor(T){let S=this._rendererMessageEmitters.get(T);return S||(S=new c.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this._rendererMessageEmitters.delete(T)}}),this._rendererMessageEmitters.set(T,S),S)}}e.ExtHostNotebookRenderers=P}),define(_e[260],ye([1,0,21,4,6,5,2,7,10,17,42,87]),function(Z,e,c,t,I,P,y,T,S,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(_,w,f){const g=_.getProxy(P.MainContext.MainThreadQuickOpen);class h{constructor(a,d){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=d}showQuickPick(a,d,n=c.CancellationToken.None){this._onDidSelectItem=void 0;const i=Promise.resolve(a),p=++this._instances,C=g.$show(p,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},n),R={},U=C.then(()=>R);return Promise.race([U,i]).then(H=>{if(H!==R)return i.then(V=>{const L=[];for(let M=0;M<V.length;M++){const F=V[M];typeof F=="string"?L.push({label:F,handle:M}):F.kind===T.QuickPickItemKind.Separator?L.push({type:"separator",label:F.label}):L.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:M})}return d&&typeof d.onDidSelectItem=="function"&&(this._onDidSelectItem=M=>{d.onDidSelectItem(V[M])}),g.$setItems(p,L),C.then(M=>{if(typeof M=="number")return V[M];if(Array.isArray(M))return M.map(F=>V[F])})})}).then(void 0,H=>{if(!(0,S.isCancellationError)(H))return g.$setError(p,H),Promise.reject(H)})}$onItemSelected(a){this._onDidSelectItem?.(a)}showInput(a,d=c.CancellationToken.None){return this._validateInput=a?.validateInput,g.$input(a,typeof this._validateInput=="function",d).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(a){if(!this._validateInput)return;const d=await this._validateInput(a);if(!d||typeof d=="string")return d;let n;switch(d.severity){case T.InputBoxValidationSeverity.Info:n=A.default.Info;break;case T.InputBoxValidationSeverity.Warning:n=A.default.Warning;break;case T.InputBoxValidationSeverity.Error:n=A.default.Error;break;default:n=d.message?A.default.Error:A.default.Ignore;break}return{content:d.message,severity:n}}async showWorkspaceFolderPick(a,d=c.CancellationToken.None){const n=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!n)return;const i=await this._workspace.getWorkspaceFolders2();if(!!i)return i.find(p=>p.uri.toString()===n.uri.toString())}createQuickPick(a){const d=new u(a,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}createInputBox(a){const d=new o(a,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(a,d){this._sessions.get(a)?._fireDidChangeValue(d)}$onDidAccept(a){this._sessions.get(a)?._fireDidAccept()}$onDidChangeActive(a,d){const n=this._sessions.get(a);n instanceof u&&n._fireDidChangeActive(d)}$onDidChangeSelection(a,d){const n=this._sessions.get(a);n instanceof u&&n._fireDidChangeSelection(d)}$onDidTriggerButton(a,d){this._sessions.get(a)?._fireDidTriggerButton(d)}$onDidTriggerItemButton(a,d,n){const i=this._sessions.get(a);i instanceof u&&i._fireDidTriggerItemButton(d,n)}$onDidHide(a){this._sessions.get(a)?._fireDidHide()}}class v{constructor(a,d){this._extensionId=a,this._onDidDispose=d,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new t.Emitter,this._onDidChangeValueEmitter=new t.Emitter,this._onDidTriggerButtonEmitter=new t.Emitter,this._onDidHideEmitter=new t.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((d,n)=>{const i=d===T.QuickInputButtons.Back?-1:n;this._handlesToButtons.set(i,d)}),this.update({buttons:a.map((d,n)=>({...s(d),tooltip:d.tooltip,handle:d===T.QuickInputButtons.Back?-1:n}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const d=this._handlesToButtons.get(a);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),g.$dispose(this._id))}update(a){if(!this._disposed){for(const d of Object.keys(a)){const n=a[d];this._pendingUpdate[d]=n===void 0?null:n}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){g.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function m(l){if(l instanceof T.ThemeIcon)return{id:l.id};const a=b(l),d=r(l);return{dark:typeof a=="string"?y.URI.file(a):a,light:typeof d=="string"?y.URI.file(d):d}}function r(l){return typeof l=="object"&&"light"in l?l.light:l}function b(l){return typeof l=="object"&&"dark"in l?l.dark:l}function s(l){const a=m(l.iconPath);let d,n;return"id"in a?n=k.ThemeIcon.asClassName(a):d=a,{iconPath:d,iconClass:n}}class u extends v{constructor(a,d){super(a.identifier,d),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new t.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new t.Emitter,this._onDidTriggerItemButtonEmitter=new t.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((n,i)=>{this._handlesToItems.set(i,n),this._itemsToHandles.set(n,i)});const d=[];for(let n=0;n<a.length;n++){const i=a[n];i.kind===T.QuickPickItemKind.Separator?d.push({type:"separator",label:i.label}):d.push({handle:n,label:i.label,description:i.description,detail:i.detail,picked:i.picked,alwaysShow:i.alwaysShow,buttons:i.buttons?.map((p,C)=>({...s(p),tooltip:p.tooltip,handle:C}))})}this.update({items:d})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(a){this._keepScrollPosition=a,this.update({keepScrollPosition:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(a){const d=(0,D.coalesce)(a.map(n=>this._handlesToItems.get(n)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(a){const d=(0,D.coalesce)(a.map(n=>this._handlesToItems.get(n)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(a,d){const n=this._handlesToItems.get(a);if(!n||!n.buttons||!n.buttons.length)return;const i=n.buttons[d];i&&this._onDidTriggerItemButtonEmitter.fire({button:i,item:n})}}class o extends v{constructor(a,d){super(a.identifier,d),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get valueSelection(){return this._valueSelection}set valueSelection(a){this._valueSelection=a,this.update({valueSelection:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,a?typeof a=="string"?this.update({validationMessage:a,severity:A.default.Error}):this.update({validationMessage:a.message,severity:a.severity??A.default.Error}):this.update({validationMessage:void 0,severity:A.default.Ignore})}}return new h(w,f)}e.createExtHostQuickOpen=E});var Me=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)},Ze=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c};define(_e[261],ye([1,0,2,4,60,6,18,5,17,108,13,26,87,15,27]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w){"use strict";var f,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(i){if(i)return typeof i.iconPath=="string"?c.URI.file(i.iconPath):c.URI.isUri(i.iconPath)||E.ThemeIcon.isThemeIcon(i.iconPath)?i.iconPath:void 0}function v(i,p){if(!i.iconPath&&!p.iconPath)return 0;if(i.iconPath){if(!p.iconPath)return 1}else return-1;const C=typeof i.iconPath=="string"?i.iconPath:c.URI.isUri(i.iconPath)?i.iconPath.fsPath:i.iconPath.id,R=typeof p.iconPath=="string"?p.iconPath:c.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,D.comparePaths)(C,R)}function m(i,p){let C=0;if(i.strikeThrough!==p.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==p.faded)return i.faded?1:-1;if(i.tooltip!==p.tooltip)return(i.tooltip||"").localeCompare(p.tooltip||"");if(C=v(i,p),C!==0)return C;if(i.light&&p.light)C=v(i.light,p.light);else{if(i.light)return 1;if(p.light)return-1}if(C!==0)return C;if(i.dark&&p.dark)C=v(i.dark,p.dark);else{if(i.dark)return 1;if(p.dark)return-1}return C}function r(i,p){if(i.command!==p.command)return i.command<p.command?-1:1;if(i.title!==p.title)return i.title<p.title?-1:1;if(i.tooltip!==p.tooltip){if(i.tooltip!==void 0&&p.tooltip!==void 0)return i.tooltip<p.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(i.arguments===p.arguments)return 0;if(i.arguments)if(p.arguments){if(i.arguments.length!==p.arguments.length)return i.arguments.length-p.arguments.length}else return 1;else return-1;for(let C=0;C<i.arguments.length;C++){const R=i.arguments[C],U=p.arguments[C];if(R!==U)return R<U?-1:1}return 0}function b(i,p){let C=(0,D.comparePaths)(i.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(C!==0)return C;if(i.command&&p.command)C=r(i.command,p.command);else{if(i.command)return 1;if(p.command)return-1}if(C!==0)return C;if(i.decorations&&p.decorations)C=m(i.decorations,p.decorations);else{if(i.decorations)return 1;if(p.decorations)return-1}return C}function s(i,p){for(let C=0;C<i.length;C++)if(i[C]!==p[C])return!1;return!0}function u(i,p){return i.command===p.command&&i.title===p.title&&i.tooltip===p.tooltip&&(i.arguments&&p.arguments?s(i.arguments,p.arguments):i.arguments===p.arguments)}function o(i,p){return(0,S.equals)(i,p,u)}class l{get value(){return this._value}set value(p){p=p??"",Me(this,f,"f").$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){Me(this,f,"f").$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(p){if((0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,Me(this,f,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get enabled(){return this._enabled}set enabled(p){p=!!p,this._enabled!==p&&(this._enabled=p,Me(this,f,"f").$setInputBoxEnablement(this._sourceControlHandle,p))}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,Me(this,f,"f").$setInputBoxVisibility(this._sourceControlHandle,p))}constructor(p,C,R){this._extension=p,this._sourceControlHandle=R,f.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Ze(this,f,C,"f")}showValidationMessage(p,C){(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),Me(this,f,"f").$showValidationMessage(this._sourceControlHandle,p,C)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=l,f=new WeakMap;class a{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}constructor(p,C,R,U,H){this._proxy=p,this._commands=C,this._sourceControlHandle=R,this._id=U,this._label=H,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=a._handlePool++}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,C){const R=this._resourceStatesCommandsMap.get(p);return R?(0,y.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(b),R=(0,S.sortedDiff)(this._resourceSnapshot,p,b).map(V=>{const L=V.toInsert.map(M=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,M);const B=M.resourceUri;let N;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const pe=new P.DisposableStore;N=this._commands.converter.toInternal(M.command,pe),this._resourceStatesDisposablesMap.set(F,pe)}else this._resourceStatesCommandsMap.set(F,M.command);const z=h(M.decorations),j=M.decorations&&h(M.decorations.light)||z,x=M.decorations&&h(M.decorations.dark)||z,Q=[j,x],K=M.decorations&&M.decorations.tooltip||"",le=M.decorations&&!!M.decorations.strikeThrough,ie=M.decorations&&!!M.decorations.faded,de=M.contextValue||"";return{rawResource:[F,B,Q,K,le,ie,de,N],handle:F}});return{start:V.start,deleteCount:V.deleteCount,toInsert:L}}),U=R.map(({start:V,deleteCount:L,toInsert:M})=>[V,L,M.map(F=>F.rawResource)]),H=R.reverse();for(const{start:V,deleteCount:L,toInsert:M}of H){const F=M.map(N=>N.handle),B=this._handlesSnapshot.splice(V,L,...F);for(const N of B)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=p,U}dispose(){this._disposed=!0,this._onDidDispose.fire()}}a._handlePool=0;class d{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,Me(this,g,"f").$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,Me(this,g,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,Me(this,g,"f").$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=p;const C=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);Me(this,g,"f").$updateSourceControl(this.handle,{acceptInputCommand:C})}get actionButton(){return(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(p){(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=p;const C=p!==void 0?{command:this._commands.converter.toInternal(p.command,this._actionButtonDisposables.value),secondaryCommands:p.secondaryCommands?.map(R=>R.map(U=>this._commands.converter.toInternal(U,this._actionButtonDisposables.value))),description:p.description,enabled:p.enabled}:void 0;Me(this,g,"f").$updateSourceControl(this.handle,{actionButton:C??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&o(this._statusBarCommands,p))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=p;const C=(p||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));Me(this,g,"f").$updateSourceControl(this.handle,{statusBarCommands:C})}get selected(){return this._selected}constructor(p,C,R,U,H,V){this._extension=p,this._commands=R,this._id=U,this._label=H,this._rootUri=V,g.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=d._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ze(this,g,C,"f"),this._inputBox=new l(p,Me(this,g,"f"),this.handle),Me(this,g,"f").$registerSourceControl(this.handle,U,H,V)}createResourceGroup(p,C){const R=new a(Me(this,g,"f"),this._commands,this.handle,p,C),U=t.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,U),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const p=[],C=[];for(const[R,U]of this.createdResourceGroups){U.dispose();const H=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});t.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),H.dispose(),this._groups.delete(R.handle),Me(this,g,"f").$unregisterGroup(this.handle,R.handle)}),p.push([R.handle,R.id,R.label,R.features]);const V=R._takeResourceStateSnapshot();V.length>0&&C.push([R.handle,V]),this._groups.set(R.handle,R)}Me(this,g,"f").$registerGroups(this.handle,p,C),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(C=>{const R=C._takeResourceStateSnapshot();R.length!==0&&p.push([C.handle,R])}),p.length>0&&Me(this,g,"f").$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),Me(this,g,"f").$unregisterSourceControl(this.handle)}}g=new WeakMap,d._handlePool=0,Ve([(0,I.debounce)(100)],d.prototype,"eventuallyAddResourceGroups",null),Ve([(0,I.debounce)(100)],d.prototype,"eventuallyUpdateResourceStates",null);let n=class Zn{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(p,C,R){this._commands=C,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=p.getProxy(T.MainContext.MainThreadSCM),this._telemetry=p.getProxy(T.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const H=this._sourceControls.get(U.sourceControlHandle);if(!H)return U;const V=H.getResourceGroup(U.groupHandle);return V?V.getResourceState(U.handle):U}else if(U&&U.$mid===4){const H=this._sourceControls.get(U.sourceControlHandle);return H?H.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const H=this._sourceControls.get(U.handle);return H||U}return U}})}createSourceControl(p,C,R,U){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,C,R,U),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const H=Zn._handlePool++,V=new d(p,this._proxy,this._commands,C,R,U);this._sourceControls.set(H,V);const L=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(p.identifier))||[];return L.push(V),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(p.identifier),L),V}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const C=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(p.identifier)),R=C&&C[C.length-1];return R&&R.inputBox}$provideOriginalResource(p,C,R){const U=c.URI.revive(C);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,U.toString());const H=this._sourceControls.get(p);return!H||!H.quickDiffProvider||!H.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>H.quickDiffProvider.provideOriginalResource(U,R)).then(V=>V||null)}$onInputBoxValueChange(p,C){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const R=this._sourceControls.get(p);return R&&R.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(p,C,R,U){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,C,R);const H=this._sourceControls.get(p);if(!H)return Promise.resolve(void 0);const V=H.getResourceGroup(C);return V?V.$executeResourceCommand(R,U):Promise.resolve(void 0)}$validateInput(p,C,R){this.logService.trace("ExtHostSCM#$validateInput",p);const U=this._sourceControls.get(p);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>U.inputBox.validateInput(C,R)).then(H=>{if(!H)return Promise.resolve(void 0);const V=_.MarkdownString.fromStrict(H.message);return V?Promise.resolve([V,H.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};n._handlePool=0,n=Ve([ze(2,A.ILogService)],n),e.ExtHostSCM=n}),define(_e[95],ye([1,0,5,4,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(T){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=T.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this._onDidChangePassword.fire(T)}get(T,S){return this._proxy.$getPassword(T,S)}store(T,S,D){return this._proxy.$setPassword(T,S,D)}delete(T,S){return this._proxy.$deletePassword(T,S)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Me=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[262],ye([1,0,7,5,174,6,15,11]),function(Z,e,c,t,I,P,y,T){"use strict";var S,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(w,f,g,h,v=c.StatusBarAlignment.Left,m){S.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,Ze(this,S,w,"f"),Ze(this,D,f,"f"),this._entryId=A.ID_GEN++,this._extension=g,this._id=h,this._alignment=v,this._priority=this.validatePriority(m)}validatePriority(w){if(!!(0,T.isNumber)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(w){this._text=w,this.update()}set name(w){this._name=w,this.update()}set tooltip(w){this._tooltip=w,this.update()}set color(w){this._color=w,this.update()}set backgroundColor(w){w&&!A.ALLOWED_BACKGROUND_COLORS.has(w.id)&&(w=void 0),this._backgroundColor=w,this.update()}set command(w){this._command?.fromApi!==w&&(this._internalCommandRegistration.clear(),typeof w=="string"?this._command={fromApi:w,internal:Me(this,D,"f").toInternal({title:"",command:w},this._internalCommandRegistration)}:w?this._command={fromApi:w,internal:Me(this,D,"f").toInternal(w,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(w){this._accessibilityInformation=w,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let w;this._extension?this._id?w=`${this._extension.identifier.value}.${this._id}`:w=this._extension.identifier.value:w=this._id;let f;this._name?f=this._name:f=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const h=y.MarkdownString.fromStrict(this._tooltip);Me(this,S,"f").$setEntry(this._entryId,w,f,this._text,h,this._command?.internal,g,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,S=new WeakMap,D=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(w){this._messages=[],this._item=w.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(w){const f={message:w};return this._messages.unshift(f),this._update(),new c.Disposable(()=>{const g=this._messages.indexOf(f);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class E{constructor(w,f){this._proxy=w.getProxy(t.MainContext.MainThreadStatusBar),this._commands=f,this._statusMessage=new k(this)}createStatusBarEntry(w,f,g,h){return new A(this._proxy,this._commands,w,f,g,h)}setStatusBarMessage(w,f){const g=this._statusMessage.setMessage(w);let h;return typeof f=="number"?h=setTimeout(()=>g.dispose(),f):typeof f<"u"&&f.then(()=>g.dispose(),()=>g.dispose()),new c.Disposable(()=>{g.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=E}),define(_e[96],ye([1,0,5,4,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(T){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=T.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,S){this._proxy.$registerExtensionStorageKeysToSync(T,S)}initializeExtensionStorage(T,S,D){return this._proxy.$initializeExtensionStorage(T,S).then(A=>A||D)}setValue(T,S,D){return this._proxy.$setValue(T,S,D)}$acceptValue(T,S,D){this._onDidChangeStorage.fire({shared:T,key:S,value:D})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(_e[70],ye([1,0,3,25,13,69,2]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let T=class{constructor(D,A,k){this._logService=A,this._extHostFileSystem=k,this._workspace=D.workspace??void 0,this._environment=D.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(E=>this._value=E)}async _getWorkspaceStorageURI(D){return y.URI.joinPath(this._environment.workspaceStorageHome,D)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const D=this._workspace.id,A=await this._getWorkspaceStorageURI(D);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:y.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),A}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(D){if(this._value)return y.URI.joinPath(this._value,D.identifier.value)}globalValue(D){return y.URI.joinPath(this._environment.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=Ve([ze(0,t.IExtHostInitDataService),ze(1,I.ILogService),ze(2,P.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(_e[40],ye([1,0,4,5,3,2,16,6,7,175,10,221,21,31,205,87,11,18,15]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class m{constructor(n,i,p,C){this._proxy=n,this._id=i,this._creationOptions=p,this._name=C,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(U=>this._pidPromiseComplete=U);const R=this;this.value={get name(){return R._name||""},get processId(){return R._pidPromise},get creationOptions(){return R._creationOptions},get exitStatus(){return R._exitStatus},get state(){return R._state},sendText(U,H=!0){R._checkDisposed(),R._proxy.$sendText(R._id,U,H)},show(U){R._checkDisposed(),R._proxy.$show(R._id,U)},hide(){R._checkDisposed(),R._proxy.$hide(R._id)},dispose(){R._disposed||(R._disposed=!0,R._proxy.$dispose(R._id))},get dimensions(){if(!(R._cols===void 0||R._rows===void 0))return{columns:R._cols,rows:R._rows}}}}async create(n,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,g.withNullAsUndefined)(n.shellPath),shellArgs:(0,g.withNullAsUndefined)(n.shellArgs),cwd:(0,g.withNullAsUndefined)(n.cwd),env:(0,g.withNullAsUndefined)(n.env),icon:(0,g.withNullAsUndefined)(l(n.iconPath)),color:f.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,g.withNullAsUndefined)(n.message),strictEnv:(0,g.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(i?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(i?.useShellEnvironment),location:i?.location||this._serializeParentTerminal(n.location,i?.resolvedExtHostIdentifier),isTransient:(0,g.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,i,p,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:f.ThemeColor.isThemeColor(C)?C.id:void 0,location:this._serializeParentTerminal(n,i),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(n,i){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&i?{parentTerminal:i}:"viewColumn"in n?{viewColumn:v.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitStatus(n,i){this._exitStatus=Object.freeze({code:n,reason:i})}setDimensions(n,i){return n===this._cols&&i===this._rows||n===0||i===0?!1:(this._cols=n,this._rows=i,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=m;class r{get onProcessReady(){return this._onProcessReady.event}constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new c.Emitter,this._onDidChangeProperty=new c.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,i){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${i}`)}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput?.(n)}resize(n,i){this._pty.setDimensions?.({columns:n,rows:i})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose?.((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions?.(i=>{i&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:i.columns,rows:i.rows}})}),this._pty.onDidChangeName?.(i=>{this._onDidChangeProperty.fire({type:"title",value:i})}),this._pty.open(n||void 0),n&&this._pty.setDimensions?.(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=r;let b=1,s=class extends T.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(n,i){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new c.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=i.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new w.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[p,C]of this._terminalProcesses)C.shutdown(!0)}})}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,i){const p=new m(this._proxy,(0,_.generateUuid)(),n,n.name),C=new r(n.pty);return p.createExtensionTerminal(n.location,this._serializeParentTerminal(n,i).resolvedExtHostIdentifier,l(n.iconPath),a(n.color)).then(R=>{const U=this._setupExtHostProcessListeners(R,C);this._terminalProcessDisposables[R]=U}),this._terminals.push(p),p.value}_serializeParentTerminal(n,i){if(i=i||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const p=n.location.parentTerminal;if(p){const C=this._terminals.find(R=>R.value===p);C&&(i.resolvedExtHostIdentifier=C._id)}}else n.location&&typeof n.location!="object"?i.location=n.location:i.location&&typeof i.location=="object"&&"splitActiveTerminal"in i.location&&(i.location={splitActiveTerminal:!0});return i}attachPtyToTerminal(n,i){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const C=new r(i),R=this._setupExtHostProcessListeners(n,C);this._terminalProcessDisposables[n]=R}async $acceptActiveTerminalChanged(n){const i=this._activeTerminal;if(n===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(n);p&&(this._activeTerminal=p,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,i){const p=this._getTerminalById(n);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:i})}async $acceptTerminalDimensions(n,i,p){const C=this._getTerminalById(n);C&&C.setDimensions(i,p)&&this._onDidChangeTerminalDimensions.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptTerminalMaximumDimensions(n,i,p){this._terminalProcesses.get(n)?.resize(i,p)}async $acceptTerminalTitleChange(n,i){const p=this._getTerminalById(n);p&&(p.name=i)}async $acceptTerminalClosed(n,i,p){const C=this._getTerminalObjectIndexById(this._terminals,n);if(C!==null){const R=this._terminals.splice(C,1)[0];R.setExitStatus(i,p),this._onDidCloseTerminal.fire(R.value)}}$acceptTerminalOpened(n,i,p,C){if(i){const H=this._getTerminalObjectIndexById(this._terminals,i);if(H!==null){this._terminals[H]._id=n,this._onDidOpenTerminal.fire(this.terminals[H]),this._terminals[H].isOpen=!0;return}}const R={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:P.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},U=new m(this._proxy,n,R,p);this._terminals.push(U),this._onDidOpenTerminal.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(n,i){this._getTerminalById(n)?._setProcessId(i)}async $startExtensionTerminal(n,i){const p=this._getTerminalById(n);if(!p)return{message:(0,D.localize)(0,null,n)};p.isOpen||await new Promise(R=>{const U=this.onDidOpenTerminal(async H=>{H===p.value&&(U.dispose(),R())})});const C=this._terminalProcesses.get(n);C?C.startSendingEvents(i):this._extensionTerminalAwaitingStart[n]={initialDimensions:i}}_setupExtHostProcessListeners(n,i){const p=new T.DisposableStore;p.add(i.onProcessReady(R=>this._proxy.$sendProcessReady(n,R.pid,R.cwd))),p.add(i.onDidChangeProperty(R=>this._proxy.$sendProcessProperty(n,R))),this._bufferer.startBuffering(n,i.onProcessData),p.add(i.onProcessExit(R=>this._onProcessExit(n,R))),this._terminalProcesses.set(n,i);const C=this._extensionTerminalAwaitingStart[n];return C&&i instanceof r&&(i.startSendingEvents(C.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),p}$acceptProcessAckDataEvent(n,i){this._terminalProcesses.get(n)?.acknowledgeDataEvent(i)}$acceptProcessInput(n,i){this._terminalProcesses.get(n)?.input(i)}$acceptTerminalInteraction(n){const i=this._getTerminalById(n);i?.setInteractedWith()&&this._onDidChangeTerminalState.fire(i.value)}$acceptProcessResize(n,i,p){try{this._terminalProcesses.get(n)?.resize(i,p)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(n,i){this._terminalProcesses.get(n)?.shutdown(i)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(i=>this._proxy.$sendProcessProperty(n,{type:"initialCwd",value:i}))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(i=>this._proxy.$sendProcessProperty(n,{type:"cwd",value:i}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,i,p){if(this._profileProviders.has(i))throw new Error(`Terminal profile provider "${i}" already registered`);return this._profileProviders.set(i,p),this._proxy.$registerProfileProvider(i,n.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(i),this._proxy.$unregisterProfileProvider(i)})}async $createContributedProfileTerminal(n,i){const p=new E.CancellationTokenSource().token;let C=await this._profileProviders.get(n)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,i);return}this.createTerminalFromOptions(C.options,i)}}async $provideLinks(n,i){const p=this._getTerminalById(n);if(!p)return[];this._terminalLinkCache.delete(n),this._terminalLinkCancellationSource.get(n)?.dispose(!0);const R=new E.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,R);const U=[],H={terminal:p.value,line:i},V=[];for(const F of this._linkProviders)V.push(h.Promises.withAsyncBody(async B=>{R.token.onCancellationRequested(()=>B({provider:F,links:[]}));const N=await F.provideTerminalLinks(H,R.token)||[];R.token.isCancellationRequested||B({provider:F,links:N})}));const L=await Promise.all(V);if(R.token.isCancellationRequested)return[];const M=new Map;for(const F of L)F&&F.links.length>0&&U.push(...F.links.map(B=>{const N={id:b++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return M.set(N.id,{provider:F.provider,link:B}),N}));return this._terminalLinkCache.set(n,M),U}$activateLink(n,i){const p=this._terminalLinkCache.get(n)?.get(i);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(n,i){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const p=this._terminalProcessDisposables[n];p&&(p.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,i)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,i){const p=this._getTerminalObjectIndexById(n,i);return p!==null?n[p]:null}_getTerminalObjectIndexById(n,i){let p=null;return n.some((C,R)=>C._id===i?(p=R,!0):!1),p}getEnvironmentVariableCollection(n){let i=this._environmentVariableCollections.get(n.identifier.value);return i||(i=new u,this._setEnvironmentVariableCollection(n.identifier.value,i)),i}_syncEnvironmentVariableCollection(n,i){const p=(0,k.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(n,i.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(n){n.forEach(i=>{const p=i[0],C=new u(i[1]);this._setEnvironmentVariableCollection(p,C)})}$acceptDefaultProfile(n,i){const p=this._defaultProfile;this._defaultProfile=n,this._defaultAutomationProfile=i,p?.path!==n.path&&this._onDidChangeShell.fire(n.path)}_setEnvironmentVariableCollection(n,i){this._environmentVariableCollections.set(n,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,i)})}};s=Ve([ze(1,y.IExtHostRpcService)],s),e.BaseExtHostTerminalService=s;class u{get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,i){this._setIfDiffers(n,{value:i,type:S.EnvironmentVariableMutatorType.Replace})}append(n,i){this._setIfDiffers(n,{value:i,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,i){this._setIfDiffers(n,{value:i,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,i){const p=this.map.get(n);(!p||p.value!==i.value||p.type!==i.type)&&(this.map.set(n,i),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,i){this.map.forEach((p,C)=>n.call(i,C,p,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let o=class extends s{constructor(n){super(!1,n)}createTerminal(n,i,p){throw new A.NotSupportedError}createTerminalFromOptions(n,i){throw new A.NotSupportedError}};o=Ve([ze(0,y.IExtHostRpcService)],o),e.WorkerExtHostTerminalService=o;function l(d){if(!(!d||typeof d=="string"))return"id"in d?{id:d.id,color:d.color}:d}function a(d){return f.ThemeColor.isThemeColor(d)?d:void 0}});var Me=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)},Ze=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c};define(_e[263],ye([1,0,17,23,21,4,61,81,6,24,11,31,5,16,135,15,7,56,91,67]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h,v,m){"use strict";var r,b;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(H,V,L){this.editors=L,this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=H.getProxy(E.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new o(this.proxy),V.registerArgumentProcessor({processArgument:M=>{if(M?.$mid!==14)return M;const F=M,B=F.tests[F.tests.length-1].item.extId;return this.controllers.get(h.TestId.root(B))?.collection.tree.get(B)?.actual??(0,w.toItemFromContext)(M)}})}createTestController(H,V,L){if(this.controllers.has(H))throw new Error(`Attempt to insert a duplicate controller with ID "${H}"`);const M=new S.DisposableStore,F=M.add(new w.ExtHostTestItemCollection(H,V,this.editors));F.root.label=V;const B=new Map,N=this.proxy,z={items:F.root.children,get label(){return V},set label(x){V=x,F.root.label=x,N.$updateController(H,{label:V})},get refreshHandler(){return L},set refreshHandler(x){L=x,N.$updateController(H,{canRefresh:!!x})},get id(){return H},createRunProfile:(x,Q,K,le,ie)=>{let de=(0,T.hash)(x);for(;B.has(de);)de++;return new C(this.proxy,B,H,de,x,Q,K,le,ie)},createTestItem(x,Q,K){return new w.TestItemImpl(H,x,Q,K)},createTestRun:(x,Q,K=!0)=>this.runTracker.createTestRun(H,F,x,Q,K),set resolveHandler(x){F.resolveHandler=x},get resolveHandler(){return F.resolveHandler},dispose:()=>{M.dispose()}};N.$registerTestController(H,V,!!L),M.add((0,S.toDisposable)(()=>N.$unregisterTestController(H)));const j={controller:z,collection:F,profiles:B};return this.controllers.set(H,j),M.add((0,S.toDisposable)(()=>this.controllers.delete(H))),M.add(F.onDidGenerateDiff(x=>N.$publishDiff(H,x.map(m.TestsDiffOp.serialize)))),z}createTestObserver(){return this.observer.checkout()}async runTests(H,V=I.CancellationToken.None){const L=l(H);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.controllers.get(L.controllerId);if(!M)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:H.include?.map(F=>h.TestId.fromExtHostTestItem(F,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:R[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:H.exclude?.map(F=>F.id)},V)}$syncTests(){for(const{collection:H}of this.controllers.values())H.flushDiff();return Promise.resolve()}$provideFileCoverage(H,V,L){return(0,c.mapFind)(this.runTracker.trackers,F=>F.id===H?F.getCoverage(V):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(H,V,L,M){return(0,c.mapFind)(this.runTracker.trackers,B=>B.id===H?B.getCoverage(V):void 0)?.resolveFileCoverage(L,M)??Promise.resolve([])}$configureRunProfile(H,V){this.controllers.get(H)?.profiles.get(V)?.configureHandler?.()}async $refreshTests(H,V){await this.controllers.get(H)?.controller.refreshHandler?.(V)}$publishTestResults(H){this.results=Object.freeze(H.map(V=>(0,D.deepFreeze)(f.TestResults.to(V))).concat(this.results).sort((V,L)=>L.completedAt-V.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(H,V){const L=this.controllers.get(h.TestId.fromString(H).controllerId)?.collection;L&&(await L.expand(H,V<0?1/0:V),L.flushDiff())}$acceptDiff(H){this.observer.applyDiff(H.map(m.TestsDiffOp.deserialize))}async $runControllerTests(H,V){return Promise.all(H.map(L=>this.runControllerTestRequest(L,V)))}async runControllerTestRequest(H,V){const L=this.controllers.get(H.controllerId);if(!L)return{};const{collection:M,profiles:F}=L,B=F.get(H.profileId);if(!B)return{};const N=H.testIds.map(Q=>M.tree.get(Q)).filter(A.isDefined),z=H.excludeExtIds.map(Q=>L.collection.tree.get(Q)).filter(A.isDefined).filter(Q=>N.some(K=>K.fullId.compare(Q.fullId)===2));if(!N.length)return{};const j=new g.TestRunRequest(N.some(Q=>Q.actual instanceof w.TestItemRootImpl)?void 0:N.map(Q=>Q.actual),z.map(Q=>Q.actual),B),x=this.runTracker.prepareForMainThreadTestRun(j,a.fromInternal(H,L.collection),V);try{return await B.runHandler(j,V),{}}catch(Q){return{error:String(Q)}}finally{x.isRunning&&!V.isCancellationRequested&&await P.Event.toPromise(x.onEnd),x.dispose()}}$cancelExtensionTestRun(H){H===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(H)}};s=Ve([ze(0,_.IExtHostRpcService)],s),e.ExtHostTesting=s;class u extends S.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(H,V,L){super(),this.dto=H,this.proxy=V,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:M}of this.tasks.values())M.end()}))}getCoverage(H){return this.tasks.get(H)?.coverage}createRun(H){const V=this.dto.id,L=this.dto.controllerId,M=(0,k.generateUuid)(),F=new d(this.proxy,V,M),B=x=>(Q,...K)=>{if(z){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Q)||(this.ensureTestIsKnown(Q),x(Q,...K))},N=(x,Q)=>{const K=Q instanceof Array?Q.map(f.TestMessage.from):[f.TestMessage.from(Q)];if(x.uri&&x.range){const le={range:f.Range.from(x.range),uri:x.uri};for(const ie of K)ie.location=ie.location||le}this.proxy.$appendTestMessagesInRun(V,M,h.TestId.fromExtHostTestItem(x,L).toString(),K)};let z=!1;const j={isPersisted:this.dto.isPersisted,token:this.cts.token,name:H,get coverageProvider(){return F.coverageProvider},set coverageProvider(x){F.coverageProvider=x},enqueued:B(x=>{this.proxy.$updateTestStateInRun(V,M,h.TestId.fromExtHostTestItem(x,L).toString(),1)}),skipped:B(x=>{this.proxy.$updateTestStateInRun(V,M,h.TestId.fromExtHostTestItem(x,L).toString(),5)}),started:B(x=>{this.proxy.$updateTestStateInRun(V,M,h.TestId.fromExtHostTestItem(x,L).toString(),2)}),errored:B((x,Q,K)=>{N(x,Q),this.proxy.$updateTestStateInRun(V,M,h.TestId.fromExtHostTestItem(x,L).toString(),6,K)}),failed:B((x,Q,K)=>{N(x,Q),this.proxy.$updateTestStateInRun(V,M,h.TestId.fromExtHostTestItem(x,L).toString(),4,K)}),passed:B((x,Q)=>{this.proxy.$updateTestStateInRun(V,M,h.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString(),3,Q)}),appendOutput:(x,Q,K)=>{z||(K&&(this.dto.isIncluded(K)?this.ensureTestIsKnown(K):K=void 0),this.proxy.$appendOutputToRun(V,M,t.VSBuffer.fromString(x),Q&&f.location.from(Q),K&&h.TestId.fromExtHostTestItem(K,L).toString()))},end:()=>{z||(z=!0,this.proxy.$finishedTestRunTask(V,M),this.tasks.delete(M),this.isRunning||this.dispose())}};return this.tasks.set(M,{run:j,coverage:F}),this.proxy.$startedTestRunTask(V,{id:M,name:H,running:!0}),j}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(H){if(!(H instanceof w.TestItemImpl))throw new v.InvalidTestItemError(H.id);if(this.sharedTestIds.has(h.TestId.fromExtHostTestItem(H,this.dto.controllerId).toString()))return;const V=[],L=this.dto.colllection.root;for(;;){const M=f.TestItem.from(H);if(V.unshift(M),this.sharedTestIds.has(M.extId)||(this.sharedTestIds.add(M.extId),H===L))break;H=H.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,V)}}class o{get trackers(){return this.tracked.values()}constructor(H){this.proxy=H,this.tracked=new Map}prepareForMainThreadTestRun(H,V,L){return this.getTracker(H,V,L)}cancelRunById(H){for(const V of this.tracked.values())if(V.id===H){V.dispose();return}}cancelAllRuns(){for(const H of this.tracked.values())H.dispose()}createTestRun(H,V,L,M,F){const B=this.tracked.get(L);if(B)return B.createRun(M);const N=a.fromPublic(H,V,L,F),z=l(L);this.proxy.$startedExtensionTestRun({controllerId:H,profile:z&&{group:R[z.kind],id:z.profileId},exclude:L.exclude?.map(x=>h.TestId.fromExtHostTestItem(x,V.root.id).toString())??[],id:N.id,include:L.include?.map(x=>h.TestId.fromExtHostTestItem(x,V.root.id).toString())??[V.root.id],persist:F});const j=this.getTracker(L,N);return j.onEnd(()=>this.proxy.$finishedExtensionTestRun(N.id)),j.createRun(M)}getTracker(H,V,L){const M=new u(V,this.proxy,L);return this.tracked.set(H,M),M.onEnd(()=>this.tracked.delete(H)),M}}e.TestRunCoordinator=o;const l=U=>{if(!!U.profile){if(!(U.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return U.profile}};class a{static fromPublic(H,V,L,M){return new a(H,(0,k.generateUuid)(),L.include?.map(F=>h.TestId.fromExtHostTestItem(F,H).toString())??[H],L.exclude?.map(F=>h.TestId.fromExtHostTestItem(F,H).toString())??[],M,V)}static fromInternal(H,V){return new a(H.controllerId,H.runId,H.testIds,H.excludeExtIds,!0,V)}constructor(H,V,L,M,F,B){this.controllerId=H,this.id=V,this.isPersisted=F,this.colllection=B,this.includePrefix=L.map(N=>N+"\0"),this.excludePrefix=M.map(N=>N+"\0")}isIncluded(H){const V=h.TestId.fromExtHostTestItem(H,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(V===L||V.startsWith(L))return!1;for(const L of this.includePrefix)if(V===L||V.startsWith(L))return!0;return!1}}e.TestRunDto=a;class d{set coverageProvider(H){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!H||(this._coverageProvider=H,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(H,V,L){this.proxy=H,this.runId=V,this.taskId=L}async provideFileCoverage(H){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(H))());try{return(await this.fileCoverage)?.map(f.TestCoverage.fromFile)??[]}catch(V){throw this.fileCoverage=void 0,V}}async resolveFileCoverage(H,V){const L=await this.fileCoverage;let M=L?.[H];return!this._coverageProvider||!L||!M?[]:(M.detailedCoverage||(M=L[H]=await this._coverageProvider.resolveFileCoverage?.(M,V)??M),M.detailedCoverage?.map(f.TestCoverage.fromDetailed)??[])}}class n extends m.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(H){super(),this.emitter=H,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(H){this.added.add(H)}update(H){Object.assign(H.revived,f.TestItem.toPlain(H.item)),this.added.has(H)||this.updated.add(H)}remove(H){if(this.added.has(H)){this.added.delete(H);return}this.updated.delete(H);const V=h.TestId.parentId(H.item.extId);if(V&&this.alreadyRemoved.has(V.toString())){this.alreadyRemoved.add(H.item.extId);return}this.removed.add(H)}getChangeEvent(){const{added:H,updated:V,removed:L}=this;return{get added(){return[...H].map(M=>M.revived)},get updated(){return[...V].map(M=>M.revived)},get removed(){return[...L].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class i extends m.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(H){return this.items.get(H)}getMirroredTestDataByReference(H){return this.items.get(H.id)}createItem(H,V){return{...H,revived:f.TestItem.toPlain(H.item),depth:V?V.depth+1:0,children:new Set}}createChangeCollector(){return new n(this.changeEmitter)}}e.MirroredTestCollection=i;class p{constructor(H){this.proxy=H}checkout(){this.current||(this.current=this.createObserverData());const H=this.current;return H.observers++,{onDidChangeTest:H.tests.onDidChangeTests,get tests(){return[...H.tests.rootTests].map(V=>V.revived)},dispose:(0,y.once)(()=>{--H.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(H){return this.current?.tests.getMirroredTestDataByReference(H)}applyDiff(H){this.current?.tests.apply(H)}createObserverData(){const H=new i;return this.proxy.$subscribeToDiffs(),{observers:0,tests:H}}}class C{get label(){return this._label}set label(H){H!==this._label&&(this._label=H,Me(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:H}))}get isDefault(){return this._isDefault}set isDefault(H){H!==this._isDefault&&(this._isDefault=H,Me(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:H}))}get tag(){return this._tag}set tag(H){H?.id!==this._tag?.id&&(this._tag=H,Me(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:H?f.TestTag.namespace(this.controllerId,H.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(H){H!==this._configureHandler&&(this._configureHandler=H,Me(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!H}))}constructor(H,V,L,M,F,B,N,z=!1,j=void 0){this.controllerId=L,this.profileId=M,this._label=F,this.kind=B,this.runHandler=N,this._isDefault=z,this._tag=j,r.set(this,void 0),b.set(this,void 0),Ze(this,r,H,"f"),Ze(this,b,V,"f"),V.set(M,this);const x=R[B];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${B}`);Me(this,r,"f").$publishTestRunProfile({profileId:M,controllerId:L,tag:j?f.TestTag.namespace(this.controllerId,j.id):null,label:F,group:x,isDefault:z,hasConfigurationHandler:!1})}dispose(){Me(this,b,"f")?.delete(this.profileId)&&(Ze(this,b,void 0,"f"),Me(this,r,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=C,r=new WeakMap,b=new WeakMap;const R={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(_e[264],ye([1,0,17,4,5,136,15,7]),function(Z,e,c,t,I,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(A,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new t.Emitter,this._onDidChangeTextEditorOptions=new t.Emitter,this._onDidChangeTextEditorVisibleRanges=new t.Emitter,this._onDidChangeTextEditorViewColumn=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=A.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(E=>this._onDidChangeVisibleTextEditors.fire(E)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(E=>this._onDidChangeActiveTextEditor.fire(E))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(A){const k=this._extHostDocumentsAndEditors.allEditors();return A?k:k.map(E=>E.value)}async showTextDocument(A,k,E){let _;typeof k=="number"?_={position:y.ViewColumn.from(k),preserveFocus:E}:typeof k=="object"?_={position:y.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?y.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:_={preserveFocus:!1};const w=await this._proxy.$tryShowTextDocument(A.uri,_),f=w&&this._extHostDocumentsAndEditors.getEditor(w);if(f)return f.value;throw w?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,k){return new P.TextEditorDecorationType(this._proxy,A,k).value}$acceptEditorPropertiesChanged(A,k){const E=this._extHostDocumentsAndEditors.getEditor(A);if(!E)throw new Error("unknown text editor");if(k.options&&E._acceptOptions(k.options),k.selections){const _=k.selections.selections.map(y.Selection.to);E._acceptSelections(_)}if(k.visibleRanges){const _=c.coalesce(k.visibleRanges.map(y.Range.to));E._acceptVisibleRanges(_)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:E.value,options:{...k.options,lineNumbers:y.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const _=T.TextEditorSelectionChangeKind.fromValue(k.selections.source),w=k.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:E.value,selections:w,kind:_})}if(k.visibleRanges){const _=c.coalesce(k.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:E.value,visibleRanges:_})}}$acceptEditorPositionData(A){for(const k in A){const E=this._extHostDocumentsAndEditors.getEditor(k);if(!E)throw new Error("Unknown text editor");const _=y.ViewColumn.to(A[k]);E.value.viewColumn!==_&&(E._acceptViewColumn(_),this._onDidChangeTextEditorViewColumn.fire({textEditor:E.value,viewColumn:_}))}}getDiffInformation(A){return Promise.resolve(this._proxy.$getDiffInformation(A))}}e.ExtHostEditors=S}),define(_e[265],ye([1,0,2,3,5,6,7,15,11]),function(Z,e,c,t,I,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class D{constructor(E,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=E.getProxy(I.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===11){const f=w.uri===void 0?void 0:c.URI.revive(w.uri);return this._itemsBySourceAndUriMap.get(w.source)?.get(A(f))?.get(w.handle)}return w}})}async $getTimeline(E,_,w,f){return this._providers.get(E)?.provideTimeline(c.URI.revive(_),w,f)}registerTimelineProvider(E,_,w,f){const g=new P.DisposableStore,h=this.convertTimelineItem(_.id,f,g).bind(this);let v;_.onDidChange&&(v=_.onDidChange(r=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...r,id:_.id}),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:E,onDidChange:void 0,async provideTimeline(r,b,s){b?.resetCache&&(g.clear(),m.get(_.id)?.clear());const u=await _.provideTimeline(r,b,s);if(u==null)return;const o=h(r,b);return{...u,source:_.id,items:u.items.map(o)}},dispose(){for(const r of m.values())r.get(_.id)?.clear();v?.dispose(),g.dispose()}})}convertTimelineItem(E,_,w){return(f,g)=>{let h;if(g?.cacheResults){let v=this._itemsBySourceAndUriMap.get(E);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(E,v));const m=A(f);h=v.get(m),h===void 0&&(h=new Map,v.set(m,h))}return v=>{const{iconPath:m,...r}=v,b=`${E}|${v.id??v.timestamp}`;h?.set(b,v);let s,u,o;v.iconPath&&(m instanceof y.ThemeIcon?o={id:m.id,color:m.color}:c.URI.isUri(m)?(s=m,u=m):{light:s,dark:u}=m);let l;return y.MarkdownString.isMarkdownString(r.tooltip)?l=T.MarkdownString.from(r.tooltip):(0,S.isString)(r.tooltip)?l=r.tooltip:y.MarkdownString.isMarkdownString(r.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=T.MarkdownString.from(r.detail)):(0,S.isString)(r.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=r.detail),{...r,id:r.id??void 0,handle:b,source:E,command:v.command?_.toInternal(v.command,w):void 0,icon:s,iconDark:u,themeIcon:o,tooltip:l,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(E){if(this._providers.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this._proxy.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this._providers.set(E.id,E),(0,P.toDisposable)(()=>{for(const w of this._itemsBySourceAndUriMap.values())w.get(E.id)?.clear();this._providers.delete(E.id),this._proxy.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=D;function A(k){return k?.toString()}}),define(_e[266],ye([1,0,6,14,2,5]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(S){this._openers=new Map,this._proxy=S.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,D,A,k){if(this._openers.has(D))throw new Error(`Opener with id '${D}' already registered`);const E=k.schemes.find(_=>!y.supportedSchemes.has(_));if(E)throw new Error(`Scheme '${E}' is not supported. Only http and https are currently supported.`);return this._openers.set(D,A),this._proxy.$registerUriOpener(D,k.schemes,S,k.label),(0,c.toDisposable)(()=>{this._openers.delete(D),this._proxy.$unregisterUriOpener(D)})}async $canOpenUri(S,D,A){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener with id: ${S}`);const E=I.URI.revive(D);return k.canOpenExternalUri(E,A)}async $openUri(S,D,A){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener id: '${S}'`);return k.openExternalUri(I.URI.revive(D.resolvedUri),{sourceUri:I.URI.revive(D.sourceUri)},A)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(_e[267],ye([1,0,5,2,6,10,26]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(D){this.handles=new Set,this.handlers=new Map,this._proxy=D.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(D,A){if(this.handles.has(y.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const k=T.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(D)),this.handlers.set(k,A),this._proxy.$registerUriHandler(k,D),(0,I.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(D)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(D,A){const k=this.handlers.get(D);if(!k)return Promise.resolve(void 0);try{k.handleUri(t.URI.revive(A))}catch(E){(0,P.onUnexpectedError)(E)}return Promise.resolve(void 0)}async createAppUri(D){return t.URI.revive(await this._proxy.$createAppUri(D))}}e.ExtHostUrls=T,T.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Me=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[71],ye([1,0,4,14,24,2,189,212,89,5]),function(Z,e,c,t,I,P,y,T,S,D){"use strict";var A,k,E,_,w,f,g,h,v,m,r,b,s;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(R,U,H,V,L,M,F){A.set(this,void 0),k.set(this,void 0),E.set(this,void 0),_.set(this,void 0),w.set(this,void 0),f.set(this,void 0),g.set(this,""),h.set(this,void 0),v.set(this,!1),m.set(this,!1),r.set(this,void 0),b.set(this,void 0),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new c.Emitter),this._onDidDispose=Me(this,s,"f").event,Ze(this,A,R,"f"),Ze(this,k,U,"f"),Ze(this,h,H,"f"),Ze(this,_,V,"f"),Ze(this,w,L,"f"),Ze(this,f,M,"f"),Ze(this,r,o(M),"f"),Ze(this,b,l(M),"f"),Ze(this,E,F,"f")}dispose(){Ze(this,v,!0,"f"),Me(this,s,"f").fire(),Me(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(R){return Ze(this,m,!0,"f"),(0,S.asWebviewUri)(R,Me(this,_,"f"))}get cspSource(){const R=Me(this,f,"f").extensionLocation;if(R.scheme===t.Schemas.https||R.scheme===t.Schemas.http){let U=R.toString();return U.endsWith("/")||(U+="/"),U+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Me(this,g,"f")}set html(R){this.assertNotDisposed(),Me(this,g,"f")!==R&&(Ze(this,g,R,"f"),Me(this,b,"f")&&!Me(this,m,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(R)&&(Ze(this,m,!0,"f"),Me(this,E,"f").report("Webview vscode-resource: uris",Me(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,k,"f").$setHtml(Me(this,A,"f"),this.rewriteOldResourceUrlsIfNeeded(R)))}get options(){return this.assertNotDisposed(),Me(this,h,"f")}set options(R){this.assertNotDisposed(),I.equals(Me(this,h,"f"),R)||Me(this,k,"f").$setOptions(Me(this,A,"f"),n(Me(this,f,"f"),Me(this,w,"f"),R)),Ze(this,h,R,"f")}async postMessage(R){if(Me(this,v,"f"))return!1;const U=(0,T.serializeWebviewMessage)(R,{serializeBuffersForPostMessage:Me(this,r,"f")});return Me(this,k,"f").$postMessage(Me(this,A,"f"),U.message,...U.buffers)}assertNotDisposed(){if(Me(this,v,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(R){if(!Me(this,b,"f"))return R;const U=Me(this,f,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,H=Me(this,f,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Me(this,f,"f").extensionLocation.authority:void 0;return R.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,L,M,F,B,N)=>{const z=P.URI.from({scheme:F||"file",path:decodeURIComponent(B)}),j=(0,S.asWebviewUri)(z,{isRemote:U,authority:H}).toString();return`${L}${j}${N}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,L,M,F,B,N)=>{const z=P.URI.from({scheme:F||"file",path:decodeURIComponent(B)}),j=(0,S.asWebviewUri)(z,{isRemote:U,authority:H}).toString();return`${L}${j}${N}`})}}e.ExtHostWebview=u,A=new WeakMap,k=new WeakMap,E=new WeakMap,_=new WeakMap,w=new WeakMap,f=new WeakMap,g=new WeakMap,h=new WeakMap,v=new WeakMap,m=new WeakMap,r=new WeakMap,b=new WeakMap,s=new WeakMap;function o(C){try{const R=(0,y.normalizeVersion)((0,y.parseVersion)(C.engines.vscode));return!!R&&R.majorBase>=1&&R.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;function l(C){try{const R=(0,y.normalizeVersion)((0,y.parseVersion)(C.engines.vscode));return R?R.majorBase<1||R.majorBase===1&&R.minorBase<60:!1}catch{return!1}}class a{constructor(R,U,H,V,L){this.remoteInfo=U,this.workspace=H,this._logService=V,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=R.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(R,U,H){const V=this.getWebview(R);if(V){const{message:L}=(0,T.deserializeWebviewMessage)(U,H.value);V._onMessageEmitter.fire(L)}}$onMissingCsp(R,U){this._logService.warn(`${U} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(R,U,H){const V=new u(R,this._webviewProxy,i(U),this.remoteInfo,this.workspace,H,this._deprecationService);return this._webviews.set(R,V),V._onDidDispose(()=>{this._webviews.delete(R)}),V}deleteWebview(R){this._webviews.delete(R)}getWebview(R){return this._webviews.get(R)}}e.ExtHostWebviews=a;function d(C){return{id:C.identifier,location:C.extensionLocation}}e.toExtensionData=d;function n(C,R,U){return{enableCommandUris:U.enableCommandUris,enableScripts:U.enableScripts,enableForms:U.enableForms,portMapping:U.portMapping,localResourceRoots:U.localResourceRoots||p(C,R)}}e.serializeWebviewOptions=n;function i(C){return{enableCommandUris:C.enableCommandUris,enableScripts:C.enableScripts,enableForms:C.enableForms,portMapping:C.portMapping,localResourceRoots:C.localResourceRoots?.map(R=>P.URI.from(R))}}function p(C,R){return[...(R?.getWorkspaceFolders()||[]).map(U=>U.uri),C.extensionLocation]}}),define(_e[268],ye([1,0,21,81,6,14,22,2,15,71,88,5,7]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class _{constructor(u,o){this.document=u,this._storagePath=o,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(u){return this._edits.add([u])}async undo(u,o){await this.getEdit(u).undo(),o||this.disposeBackup()}async redo(u,o){await this.getEdit(u).redo(),o||this.disposeBackup()}disposeEdits(u){for(const o of u)this._edits.delete(o)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const u=b(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,u)}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(u){const o=this._edits.get(u,0);if(!o)throw new Error("No edit found");return o}}class w{constructor(){this._documents=new Map}get(u,o){return this._documents.get(this.key(u,o))}add(u,o,l){const a=this.key(u,o.uri);if(this._documents.has(a))throw new Error(`Document already exists for viewType:${u} resource:${o.uri}`);const d=new _(o,l);return this._documents.set(a,d),d}delete(u,o){const l=this.key(u,o.uri);this._documents.delete(l)}key(u,o){return`${u}@@@${o}`}}var f;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(f||(f={}));class g{constructor(){this._providers=new Map}addTextProvider(u,o,l){return this.add(0,u,o,l)}addCustomProvider(u,o,l){return this.add(1,u,o,l)}get(u){return this._providers.get(u)}add(u,o,l,a){if(this._providers.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this._providers.set(o,{type:u,extension:l,provider:a}),new E.Disposable(()=>this._providers.delete(o))}}class h{constructor(u,o,l,a,d){this._extHostDocuments=o,this._extensionStoragePaths=l,this._extHostWebview=a,this._extHostWebviewPanels=d,this._editorProviders=new g,this._documents=new w,this._proxy=u.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(u,o,l,a){const d=new I.DisposableStore;return m(l)?(d.add(this._editorProviders.addTextProvider(o,u,l)),this._proxy.$registerTextEditorProvider((0,D.toExtensionData)(u),o,a.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,D.shouldSerializeBuffersForPostMessage)(u))):(d.add(this._editorProviders.addCustomProvider(o,u,l)),v(l)&&d.add(l.onDidChangeCustomDocument(n=>{const i=this.getCustomDocumentEntry(o,n.document.uri);if(r(n)){const p=i.addEdit(n);this._proxy.$onDidEdit(n.document.uri,o,p,n.label)}else this._proxy.$onContentChange(n.document.uri,o)})),this._proxy.$registerCustomEditorProvider((0,D.toExtensionData)(u),o,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,D.shouldSerializeBuffersForPostMessage)(u))),E.Disposable.from(d,new E.Disposable(()=>{this._proxy.$unregisterEditorProvider(o)}))}async $createCustomDocument(u,o,l,a,d){const n=this._editorProviders.get(o);if(!n)throw new Error(`No provider found for '${o}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${o}'`);const i=T.URI.revive(u),p=await n.provider.openCustomDocument(i,{backupId:l,untitledDocumentData:a?.buffer},d);let C;return v(n.provider)&&this._extensionStoragePaths&&(C=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension)),this._documents.add(o,p,C),{editable:v(n.provider)}}async $disposeCustomDocument(u,o){const l=this._editorProviders.get(o);if(!l)throw new Error(`No provider found for '${o}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${o}'`);const a=T.URI.revive(u),{document:d}=this.getCustomDocumentEntry(o,a);this._documents.delete(o,d),d.dispose()}async $resolveWebviewEditor(u,o,l,a,d,n){const i=this._editorProviders.get(l);if(!i)throw new Error(`No provider found for '${l}'`);const p=S.ViewColumn.to(d),C=this._extHostWebview.createNewWebview(o,a.contentOptions,i.extension),R=this._extHostWebviewPanels.createNewWebviewPanel(o,l,a.title,p,a.options,C,!0),U=T.URI.revive(u);switch(i.type){case 1:{const{document:H}=this.getCustomDocumentEntry(l,U);return i.provider.resolveCustomEditor(H,R,n)}case 0:{const H=this._extHostDocuments.getDocument(U);return i.provider.resolveCustomTextEditor(H,R,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,o,l){this.getCustomDocumentEntry(o,u).disposeEdits(l)}async $onMoveCustomEditor(u,o,l){const a=this._editorProviders.get(l);if(!a)throw new Error(`No provider found for '${l}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const d=this._extHostWebviewPanels.getWebviewPanel(u);if(!d)throw new Error("No webview found");const n=T.URI.revive(o),i=this._extHostDocuments.getDocument(n);await a.provider.moveCustomTextEditor(i,d,c.CancellationToken.None)}async $undo(u,o,l,a){return this.getCustomDocumentEntry(o,u).undo(l,a)}async $redo(u,o,l,a){return this.getCustomDocumentEntry(o,u).redo(l,a)}async $revert(u,o,l){const a=this.getCustomDocumentEntry(o,u);await this.getCustomEditorProvider(o).revertCustomDocument(a.document,l),a.disposeBackup()}async $onSave(u,o,l){const a=this.getCustomDocumentEntry(o,u);await this.getCustomEditorProvider(o).saveCustomDocument(a.document,l),a.disposeBackup()}async $onSaveAs(u,o,l,a){const d=this.getCustomDocumentEntry(o,u);return this.getCustomEditorProvider(o).saveCustomDocumentAs(d.document,T.URI.revive(l),a)}async $backup(u,o,l){const a=this.getCustomDocumentEntry(o,u),n=await this.getCustomEditorProvider(o).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},l);return a.updateBackup(n),n.id}getCustomDocumentEntry(u,o){const l=this._documents.get(u,T.URI.revive(o));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(u){const l=this._editorProviders.get(u)?.provider;if(!l||!v(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=h;function v(s){return!!s.onDidChangeCustomDocument}function m(s){return typeof s.resolveCustomTextEditor=="function"}function r(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function b(s){const u=s.scheme===P.Schemas.file||s.scheme===P.Schemas.untitled?s.fsPath:s.toString();return(0,t.hash)(u)+""}});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Me=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[269],ye([1,0,4,6,2,31,15,71,5,7]),function(Z,e,c,t,I,P,y,T,S,D){"use strict";var A,k,E,_,w,f,g,h,v,m,r,b,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends t.Disposable{constructor(d,n,i,p){super(),A.set(this,void 0),k.set(this,void 0),E.set(this,void 0),_.set(this,void 0),w.set(this,void 0),f.set(this,void 0),g.set(this,void 0),h.set(this,void 0),v.set(this,!0),m.set(this,void 0),r.set(this,!1),b.set(this,this._register(new c.Emitter)),this.onDidDispose=Me(this,b,"f").event,s.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Me(this,s,"f").event,Ze(this,A,d,"f"),Ze(this,k,n,"f"),Ze(this,_,i,"f"),Ze(this,E,p.viewType,"f"),Ze(this,w,p.panelOptions,"f"),Ze(this,h,p.viewColumn,"f"),Ze(this,f,p.title,"f"),Ze(this,m,p.active,"f")}dispose(){Me(this,r,"f")||(Ze(this,r,!0,"f"),Me(this,b,"f").fire(),Me(this,k,"f").$disposeWebview(Me(this,A,"f")),Me(this,_,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,_,"f")}get viewType(){return this.assertNotDisposed(),Me(this,E,"f")}get title(){return this.assertNotDisposed(),Me(this,f,"f")}set title(d){this.assertNotDisposed(),Me(this,f,"f")!==d&&(Ze(this,f,d,"f"),Me(this,k,"f").$setTitle(Me(this,A,"f"),d))}get iconPath(){return this.assertNotDisposed(),Me(this,g,"f")}set iconPath(d){this.assertNotDisposed(),Me(this,g,"f")!==d&&(Ze(this,g,d,"f"),Me(this,k,"f").$setIconPath(Me(this,A,"f"),I.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Me(this,w,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,h,"f")=="number"&&Me(this,h,"f")<0))return Me(this,h,"f")}get active(){return this.assertNotDisposed(),Me(this,m,"f")}get visible(){return this.assertNotDisposed(),Me(this,v,"f")}_updateViewState(d){Me(this,r,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(Ze(this,m,d.active,"f"),Ze(this,v,d.visible,"f"),Ze(this,h,d.viewColumn,"f"),Me(this,s,"f").fire({webviewPanel:this}))}reveal(d,n){this.assertNotDisposed(),Me(this,k,"f").$reveal(Me(this,A,"f"),{viewColumn:typeof d>"u"?void 0:y.ViewColumn.from(d),preserveFocus:!!n})}assertNotDisposed(){if(Me(this,r,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,k=new WeakMap,E=new WeakMap,_=new WeakMap,w=new WeakMap,f=new WeakMap,g=new WeakMap,h=new WeakMap,v=new WeakMap,m=new WeakMap,r=new WeakMap,b=new WeakMap,s=new WeakMap;class o{static newHandle(){return(0,P.generateUuid)()}constructor(d,n,i){this.webviews=n,this.workspace=i,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(d,n,i,p,C={}){const R=typeof p=="object"?p.viewColumn:p,U={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof p=="object"&&!!p.preserveFocus},H=(0,T.shouldSerializeBuffersForPostMessage)(d),V=o.newHandle();this._proxy.$createWebviewPanel((0,T.toExtensionData)(d),V,n,{title:i,panelOptions:l(C),webviewOptions:(0,T.serializeWebviewOptions)(d,this.workspace,C),serializeBuffersForPostMessage:H},U);const L=this.webviews.createNewWebview(V,C,d);return this.createNewWebviewPanel(V,n,i,R,C,L,!0)}$onDidChangeWebviewPanelViewStates(d){const n=Object.keys(d);n.sort((i,p)=>{const C=d[i],R=d[p];return C.active?1:R.active?-1:+C.visible-+R.visible});for(const i of n){const p=this.getWebviewPanel(i);if(!p)continue;const C=d[i];p._updateViewState({active:C.active,visible:C.visible,viewColumn:y.ViewColumn.to(C.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,n,i){if(this._serializers.has(n))throw new Error(`Serializer for '${n}' already registered`);return this._serializers.set(n,{serializer:i,extension:d}),this._proxy.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(d)}),new D.Disposable(()=>{this._serializers.delete(n),this._proxy.$unregisterSerializer(n)})}async $deserializeWebviewPanel(d,n,i,p){const C=this._serializers.get(n);if(!C)throw new Error(`No serializer found for '${n}'`);const{serializer:R,extension:U}=C,H=this.webviews.createNewWebview(d,i.webviewOptions,U),V=this.createNewWebviewPanel(d,n,i.title,p,i.panelOptions,H,i.active);await R.deserializeWebviewPanel(V,i.state)}createNewWebviewPanel(d,n,i,p,C,R,U){const H=new u(d,this._proxy,R,{viewType:n,title:i,viewColumn:p,panelOptions:C,active:U});return this._webviewPanels.set(d,H),H}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=o;function l(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Me=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[270],ye([1,0,4,6,71,15,5,7]),function(Z,e,c,t,I,P,y,T){"use strict";var S,D,A,k,E,_,w,f,g,h,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends t.Disposable{constructor(s,u,o,l,a,d){super(),S.set(this,void 0),D.set(this,void 0),A.set(this,void 0),k.set(this,void 0),E.set(this,!1),_.set(this,void 0),w.set(this,void 0),f.set(this,void 0),g.set(this,void 0),h.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Me(this,h,"f").event,v.set(this,this._register(new c.Emitter)),this.onDidDispose=Me(this,v,"f").event,Ze(this,A,o,"f"),Ze(this,w,l,"f"),Ze(this,S,s,"f"),Ze(this,D,u,"f"),Ze(this,k,a,"f"),Ze(this,_,d,"f")}dispose(){Me(this,E,"f")||(Ze(this,E,!0,"f"),Me(this,v,"f").fire(),Me(this,k,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,w,"f")}set title(s){this.assertNotDisposed(),Me(this,w,"f")!==s&&(Ze(this,w,s,"f"),Me(this,D,"f").$setWebviewViewTitle(Me(this,S,"f"),s))}get description(){return this.assertNotDisposed(),Me(this,f,"f")}set description(s){this.assertNotDisposed(),Me(this,f,"f")!==s&&(Ze(this,f,s,"f"),Me(this,D,"f").$setWebviewViewDescription(Me(this,S,"f"),s))}get visible(){return Me(this,_,"f")}get webview(){return Me(this,k,"f")}get viewType(){return Me(this,A,"f")}_setVisible(s){s===Me(this,_,"f")||Me(this,E,"f")||(Ze(this,_,s,"f"),Me(this,h,"f").fire())}get badge(){return this.assertNotDisposed(),Me(this,g,"f")}set badge(s){this.assertNotDisposed(),!(s?.value===Me(this,g,"f")?.value&&s?.tooltip===Me(this,g,"f")?.tooltip)&&(Ze(this,g,P.ViewBadge.from(s),"f"),Me(this,D,"f").$setWebviewViewBadge(Me(this,S,"f"),s))}show(s){this.assertNotDisposed(),Me(this,D,"f").$show(Me(this,S,"f"),!!s)}assertNotDisposed(){if(Me(this,E,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,D=new WeakMap,A=new WeakMap,k=new WeakMap,E=new WeakMap,_=new WeakMap,w=new WeakMap,f=new WeakMap,g=new WeakMap,h=new WeakMap,v=new WeakMap;class r{constructor(s,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,u,o,l){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:o,extension:s}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(s),u,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(s)}),new T.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(s,u,o,l,a){const d=this._viewProviders.get(u);if(!d)throw new Error(`No view provider found for '${u}'`);const{provider:n,extension:i}=d,p=this._extHostWebview.createNewWebview(s,{},i),C=new m(s,this._proxy,u,o,p,!0);this._webviewViews.set(s,C),await n.resolveWebviewView(C,{state:l},a)}async $onDidChangeWebviewViewVisibility(s,u){this.getWebviewView(s)._setVisible(u)}async $disposeWebviewView(s){const u=this.getWebviewView(s);this._webviewViews.delete(s),u.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const u=this._webviewViews.get(s);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=r}),define(_e[139],ye([1,0,4,5,2,14,8,3,16]),function(Z,e,c,t,I,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class ei{get state(){return this._state}constructor(k){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ei.InitialState,this._proxy=k.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(E=>this.$onDidChangeWindowFocus(E))}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,E){let _;if(typeof k=="string"){_=k;try{k=I.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,y.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,_,E)}async asExternalUri(k,E){if((0,y.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const _=await this._proxy.$asExternalUri(k,E);return I.URI.from(_)}};D.InitialState={focused:!0},D=Ve([ze(0,S.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(_e[271],ye([1,0,117,272,65,39,2,13,45]),function(Z,e,c,t,I,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(E,_,w){this._commands=E,this.logService=_,this._ipcHandlePath=w,this._server=t.createServer((f,g)=>this.onRequest(f,g)),this.setup().catch(f=>(_.error(f),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",E=>this.logService.error(E))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(E,_){const w=(g,h)=>{_.writeHead(g,{"content-type":"application/json"}),_.end(JSON.stringify(h||null),v=>v&&this.logService.error(v))},f=[];E.setEncoding("utf8"),E.on("data",g=>f.push(g)),E.on("end",async()=>{try{const g=JSON.parse(f.join(""));let h;switch(g.type){case"open":h=await this.open(g);break;case"openExternal":h=await this.openExternal(g);break;case"status":h=await this.getStatus(g);break;case"extensionManagement":h=await this.manageExtensions(g);break;default:w(404,`Unknown message type: ${g.type}`);break}w(200,h)}catch(g){const h=g instanceof Error?g.message:JSON.stringify(g);w(500,h),this.logService.error("Error while processing pipe request",g)}})}async open(E){const{fileURIs:_,folderURIs:w,forceNewWindow:f,diffMode:g,mergeMode:h,addMode:v,forceReuseWindow:m,gotoLineMode:r,waitMarkerFilePath:b,remoteAuthority:s}=E,u=[];if(Array.isArray(w))for(const d of w)try{u.push({folderUri:y.URI.parse(d)})}catch{}if(Array.isArray(_))for(const d of _)try{(0,S.hasWorkspaceFileExtension)(d)?u.push({workspaceUri:y.URI.parse(d)}):u.push({fileUri:y.URI.parse(d)})}catch{}const o=b?y.URI.file(b):void 0,a={forceNewWindow:f,diffMode:g,mergeMode:h,addMode:v,gotoLineMode:r,forceReuseWindow:m,preferNewWindow:!m&&!o&&!v,waitMarkerFileURI:o,remoteAuthority:s};return this._commands.executeCommand("_remoteCLI.windowOpen",u,a),""}async openExternal(E){for(const _ of E.uris){const w=y.URI.parse(_),f=w.scheme==="file"?w:_;await this._commands.executeCommand("_remoteCLI.openExternal",f)}}async manageExtensions(E){const _=f=>f?.map(g=>/\.vsix$/i.test(g)?y.URI.parse(g):g),w={list:E.list,install:_(E.install),uninstall:_(E.uninstall),force:E.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",w)}async getStatus(E){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=D;let A=class extends D{constructor(E,_){super(E,_,(0,c.createRandomIPCHandle)())}};A=Ve([ze(0,P.IExtHostCommands),ze(1,T.ILogService)],A),e.CLIServer=A}),define(_e[273],ye([1,0,245,25,16]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const P=1024*1024;let y=class extends c.AbstractExtHostConsoleForwarder{constructor(S,D){super(S,D),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(S,D,A){const k=S==="error"||S==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),D.apply(console,A),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(S,D){const A=process[S],k=A.write;let E="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(_,w,f)=>{if(!this._isMakingConsoleCall){E+=_.toString(w);const g=E.length>P?E.length:E.lastIndexOf(`
`);g!==-1&&(console[D](E.slice(0,g)),E=E.slice(g+1))}k.call(A,_,w,f)}})}};y=Ve([ze(0,I.IExtHostRpcService),ze(1,t.IExtHostInitDataService)],y),e.ExtHostConsoleForwarder=y}),define(_e[274],ye([1,0,9,83,31,39,6,5,2,16]),function(Z,e,c,t,I,P,y,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let A=class extends y.Disposable{constructor(E,_){super();const w=E.getProxy(T.MainContext.MainThreadDownloadService);_.registerCommand(!1,"_workbench.downloadResource",async f=>{const g=S.URI.file((0,c.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await w.$download(f,g),g})}};A=Ve([ze(0,D.IExtHostRpcService),ze(1,P.IExtHostCommands)],A),e.ExtHostDownloadService=A}),define(_e[275],ye([1,0,138,14,195,31]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class y extends c.ExtHostLoggerService{doCreateLogger(S,D,A){return S.scheme===t.Schemas.file?new I.SpdLogLogger(A?.name||(0,P.generateUuid)(),S.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,D):super.doCreateLogger(S,D,A)}}e.ExtHostLoggerService=y}),define(_e[276],ye([1,0,65,9,2,70,6,14,18,29]),function(Z,e,c,t,I,P,y,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends P.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(s){const u=await super._getWorkspaceStorageURI(s);if(u.scheme!==T.Schemas.file)return u;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${u.fsPath}.`),u;const o=u.fsPath;let l=0;do{let a;l===0?a=o:a=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${l}`:`${o}-${l}`,await k(a);const d=t.join(a,"vscode.lock"),n=await f(this._logService,d,!1);if(n)return this._workspaceStorageLock=n,process.on("exit",()=>{n.dispose()}),I.URI.file(a);l++}while(l<10);return u}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function k(b){try{await D.Promises.stat(b);return}catch{}try{await D.Promises.mkdir(b,{recursive:!0})}catch{}}const E=1e3,_=10*60*1e3;class w extends y.Disposable{constructor(s,u){super(),this.logService=s,this.filename=u,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const o=await g(s,u);(!o||o.pid!==process.pid)&&(s.info(`Lock '${u}': The lock was lost unexpectedly.`),this._timer.cancel());try{await D.Promises.utimes(u,new Date,new Date)}catch(l){s.error(l),s.info(`Lock '${u}': Could not update mtime.`)}},E)}dispose(){super.dispose();try{c.unlinkSync(this.filename)}catch{}}async setWillRelease(s){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${s} ms.`);try{const u={pid:process.pid,willReleaseAt:Date.now()+s};await D.Promises.writeFile(this.filename,JSON.stringify(u),{flag:"w"})}catch(u){this.logService.error(u)}}}async function f(b,s,u){try{const l={pid:process.pid,willReleaseAt:0};await D.Promises.writeFile(s,JSON.stringify(l),{flag:"wx"})}catch(l){b.error(l)}const o=await g(b,s);return!o||o.pid!==process.pid?u?(b.info(`Lock '${s}': Could not acquire lock, giving up.`),null):(b.info(`Lock '${s}': Could not acquire lock, checking if the file is stale.`),m(b,s)):(b.info(`Lock '${s}': Lock acquired.`),new w(b,s))}async function g(b,s){let u;try{u=await D.Promises.readFile(s)}catch(o){return b.error(o),null}try{return JSON.parse(String(u))}catch(o){return b.error(o),null}}async function h(b,s){let u;try{u=await D.Promises.stat(s)}catch(o){return b.error(o),0}return u.mtime.getTime()}function v(b){try{return process.kill(b,0),!0}catch{return!1}}async function m(b,s){const u=await g(b,s);if(!u)return b.info(`Lock '${s}': Could not read pid of lock holder.`),r(b,s);if(u.willReleaseAt){let n=u.willReleaseAt-Date.now();if(n<5e3){for(n>0?b.info(`Lock '${s}': The lockfile is scheduled to be released in ${n} ms.`):b.info(`Lock '${s}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await h(b,s)===0)return r(b,s);n=u.willReleaseAt-Date.now()}return r(b,s)}}if(!v(u.pid))return b.info(`Lock '${s}': The pid ${u.pid} appears to be gone.`),r(b,s);const o=await h(b,s),l=Date.now()-o;if(l<=_)return b.info(`Lock '${s}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;b.info(`Lock '${s}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const a=await h(b,s),d=Date.now()-a;return d<=_?(b.info(`Lock '${s}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(b.info(`Lock '${s}': The lock looks stale even after waiting for 2s.`),r(b,s))}async function r(b,s){b.info(`Lock '${s}': Deleting a stale lock.`);try{await D.Promises.unlink(s)}catch{}return f(b,s,!0)}}),define(_e[277],ye([1,0,31,16,40]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let P=class extends I.BaseExtHostTerminalService{constructor(T){super(!0,T)}createTerminal(T,S,D){return this.createTerminalFromOptions({name:T,shellPath:S,shellArgs:D})}createTerminalFromOptions(T,S){const D=new I.ExtHostTerminal(this._proxy,(0,c.generateUuid)(),T,T.name);return this._terminals.push(D),D.create(T,this._serializeParentTerminal(T,S)),D.value}};P=Ve([ze(0,t.IExtHostRpcService)],P),e.ExtHostTerminalService=P}),define(_e[278],ye([1,0,5,16,179,6,25,2,44,22,29,7,12,54,4,128,99,13]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class v extends f.DisposableTunnel{}function m(n){const i=n.trim().split(`
`),p=[];return i.forEach(R=>{const U=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);U&&U.length>=3&&p.push({pid:parseInt(U[1],10),socket:parseInt(U[2],10)})}),p.reduce((R,U)=>(R[U.socket]=U,R),{})}e.getSockets=m;function r(...n){const i=[].concat(...n.map(s));return[...new Map(i.filter(p=>p.st==="0A").map(p=>{const C=p.local_address.split(":");return{socket:parseInt(p.inode,10),ip:b(C[0]),port:parseInt(C[1],16)}}).map(p=>[p.ip+":"+p.port,p])).values()]}e.loadListeningPorts=r;function b(n){let i="";if(n.length===8)for(let p=n.length-2;p>=0;p-=2)i+=parseInt(n.substr(p,2),16),p!==0&&(i+=".");else for(let p=n.length-4;p>=0;p-=4)i+=parseInt(n.substr(p,4),16).toString(16),p!==0&&(i+=":");return i}function s(n){const i=n.trim().split(`
`),p=i.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return i.map(R=>R.trim().split(/\s+/).reduce((U,H,V)=>(U[p[V]||V]=H,U),{}))}e.loadConnectionTable=s;function u(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function o(n){const i=n.trim().split(`
`),p=[];return i.forEach(C=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(C);R&&R.length>=4&&p.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),p}e.getRootProcesses=o;async function l(n,i,p){const C=p.reduce((U,H)=>(U[H.pid]=H,U),{}),R=[];return n.forEach(({socket:U,ip:H,port:V})=>{const L=i[U]?i[U].pid:void 0,M=L?C[L]?.cmd:void 0;L&&M&&!u(M)&&R.push({host:H,port:V,detail:M,pid:L})}),R}e.findPorts=l;function a(n,i,p){const C=new Map,R=o(i);for(const U of n){const H=p.get(U.port);if(H){C.set(U.port,H);continue}const V=R.find(L=>L.cmd.includes(`${U.port}`));if(V){let L=V,M;do M=R.find(F=>F.ppid===L.pid),M&&(L=M);while(M);C.set(U.port,{host:U.ip,port:U.port,pid:L.pid,detail:L.cmd,ppid:L.ppid})}else C.set(U.port,{host:U.ip,port:U.port,ppid:Number.MAX_VALUE})}return C}e.tryFindRootPorts=a;let d=class extends P.Disposable{constructor(i,p,C){super(),this.logService=C,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new w.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=i.getProxy(c.MainContext.MainThreadTunnelService),E.isLinux&&p.remote.isRemote&&p.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(i,p){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${p.remoteAddress.host}:${p.remoteAddress.port}.`);const C=await this._proxy.$openTunnel(p,i.displayName);if(C){const R=new v(C.remoteAddress,C.localAddress,()=>this._proxy.$closeTunnel(C.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(i){return Math.max(i*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(i,p){const C=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(C,{selector:i,provider:p}),this._proxy.$registerPortsAttributesProvider(i,C),new k.Disposable(()=>{this._portAttributesProviders.delete(C),this._proxy.$unregisterPortsAttributesProvider(C)})}async $providePortAttributes(i,p,C,R,U){const H=[];for(const L of i){const M=this._portAttributesProviders.get(L);if(!M)return[];H.push(...await Promise.all(p.map(async F=>M.provider.providePortAttributes(F,C,R,U))))}const V=H.filter(L=>!!L);return V.length>0?V.map(L=>({autoForwardAction:L.autoForwardAction,port:L.port})):[]}async $registerCandidateFinder(i){if(i&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=i;const p=new g.MovingAverage;let C;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),U=(await this.findCandidatePorts()).filter(V=>(0,f.isLocalhost)(V.host)||(0,f.isAllInterfaces)(V.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${U.map(V=>V.port).join(", ")}`);const H=new Date().getTime()-R;p.update(H),(!C||JSON.stringify(C)!==JSON.stringify(U))&&(C=U,await this._proxy.$onFoundNewCandidates(C)),await new Promise(V=>setTimeout(()=>V(),this.calculateDelay(p.value)))}}async setTunnelFactory(i){if(i){if(i.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this._showCandidatePort=i.showCandidatePort,this._proxy.$setCandidateFilter()),i.tunnelFactory){this._forwardPortProvider=i.tunnelFactory;let p=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&p.length===0&&(p=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const C=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:p}:void 0;this._proxy.$setTunnelProvider(C)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(i,p){if(this._extensionTunnels.has(i.host)){const C=this._extensionTunnels.get(i.host);C.has(i.port)&&(p&&C.get(i.port).disposeListener.dispose(),await C.get(i.port).tunnel.dispose(),C.delete(i.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(i,p){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const C=this._forwardPortProvider(i,p);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),C!==void 0){const R=await C;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(i.remoteAddress.host)||this._extensionTunnels.set(i.remoteAddress.host,new Map);const U=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:R,disposeListener:U}),_.TunnelDtoConverter.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(i){const p=await Promise.all(i.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),C=i.filter((R,U)=>p[U]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(R=>R.port).join(", ")} to ${C.map(R=>R.port).join(", ")}`),C}async findCandidatePorts(){let i="",p="";try{i=await A.Promises.readFile("/proc/net/tcp","utf8"),p=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const C=r(i,p),R=await new Promise(N=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(z,j,x)=>{N(j)})}),U=m(R),H=await A.Promises.readdir("/proc"),V=[];for(const N of H)try{const z=Number(N),j=D.joinPath(T.URI.file("/proc"),N);if((await A.Promises.stat(j.fsPath)).isDirectory()&&!isNaN(z)){const Q=await A.Promises.readlink(D.joinPath(j,"cwd").fsPath),K=await A.Promises.readFile(D.joinPath(j,"cmdline").fsPath,"utf8");V.push({pid:z,cwd:Q,cmd:K})}}catch{}const L=[],M=C.filter(N=>{const z=U[N.socket];return z||L.push(N),z}),F=l(M,U,V);let B;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${L.length}`),L.length>0){const N=await new Promise(z=>{(0,S.exec)("ps -F -A -l | grep root",(j,x,Q)=>{z(x)})});this._foundRootPorts=a(L,N,this._foundRootPorts),B=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.join(", ")}`)}return F.then(N=>B?N.concat(B):N)}};d=Ve([ze(0,t.IExtHostRpcService),ze(1,y.IExtHostInitDataService),ze(2,h.ILogService)],d),e.ExtHostTunnelService=d}),define(_e[279],ye([1,0,18,23,21,10,4,6,112,239,57]),function(Z,e,c,t,I,P,y,T,S,D,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function E(C,R){try{return JSON.stringify(C,R)}catch{return"null"}}const _="$$ref$$",w={[_]:-1};class f{constructor(R,U){this.jsonString=R,this.referencedBuffers=U}}function g(C,R=null,U=!1){const H=[];return{jsonString:(U?E:JSON.stringify)(C,(L,M)=>{if(typeof M>"u")return w;if(typeof M=="object"){if(M instanceof t.VSBuffer){const F=H.push(M)-1;return{[_]:F}}if(R)return R(L,M)}return M}),referencedBuffers:H}}e.stringifyJsonWithBufferRefs=g;function h(C,R,U){return JSON.parse(C,(H,V)=>{if(V){const L=V[_];if(typeof L=="number")return R[L];if(U&&V.$mid===1)return U.transformIncoming(V)}return V})}e.parseJsonAndRestoreBufferRefs=h;function v(C,R){return JSON.stringify(C,R)}function m(C){return C?(R,U)=>U&&U.$mid===1?C.transformOutgoing(U):U:null}var r;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(r=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(C){C[C.Responsive=0]="Responsive",C[C.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},u=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class l extends T.Disposable{constructor(R,U=null,H=null){super(),this[k]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=U,this._uriTransformer=H,this._uriReplacer=m(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let V=0,L=A.ProxyIdentifier.count;V<L;V++)this._locals[V]=null,this._proxies[V]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(V=>this._receiveOneMessage(V))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,S.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:U,sid:H}=R;return this._proxies[U]||(this._proxies[U]=this._createProxy(U,H)),this._proxies[U]}_createProxy(R,U){const H={get:(V,L)=>(typeof L=="string"&&!V[L]&&L.charCodeAt(0)===36&&(V[L]=(...M)=>this._remoteCall(R,L,M)),L===o?U:V[L])};return new Proxy(Object.create(null),H)}set(R,U){return this._locals[R.nid]=U,U}assertRegistered(R){for(let U=0,H=R.length;U<H;U++){const V=R[U];if(!this._locals[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}_receiveOneMessage(R){if(this._isDisposed)return;const U=R.byteLength,H=a.read(R,0),V=H.readUInt8(),L=H.readUInt32();switch(V){case 1:case 2:{let{rpcId:M,method:F,args:B}=n.deserializeRequestJSONArgs(H);this._uriTransformer&&(B=(0,S.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(U,L,M,F,B,V===2);break}case 3:case 4:{let{rpcId:M,method:F,args:B}=n.deserializeRequestMixedArgs(H);this._uriTransformer&&(B=(0,S.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(U,L,M,F,B,V===4);break}case 5:{this._logger?.logIncoming(U,L,0,"ack"),this._onDidReceiveAcknowledge(L);break}case 6:{this._receiveCancel(U,L);break}case 7:{this._receiveReply(U,L,void 0);break}case 9:{let M=n.deserializeReplyOKJSON(H);this._uriTransformer&&(M=(0,S.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(U,L,M);break}case 10:{const M=n.deserializeReplyOKJSONWithBuffers(H,this._uriTransformer);this._receiveReply(U,L,M);break}case 8:{const M=n.deserializeReplyOKVSBuffer(H);this._receiveReply(U,L,M);break}case 11:{let M=n.deserializeReplyErrError(H);this._uriTransformer&&(M=(0,S.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(U,L,M);break}case 12:{this._receiveReplyErr(U,L,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,U,H,V,L,M){this._logger?.logIncoming(R,U,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(H)}.${V}(`,L);const F=String(U);let B,N;if(M){const j=new I.CancellationTokenSource;L.push(j.token),B=this._invokeHandler(H,V,L),N=()=>j.cancel()}else B=this._invokeHandler(H,V,L),N=s;this._cancelInvokedHandlers[F]=N;const z=n.serializeAcknowledged(U);this._logger?.logOutgoing(z.byteLength,U,1,"ack"),this._protocol.send(z),B.then(j=>{delete this._cancelInvokedHandlers[F];const x=n.serializeReplyOK(U,j,this._uriReplacer);this._logger?.logOutgoing(x.byteLength,U,1,"reply:",j),this._protocol.send(x)},j=>{delete this._cancelInvokedHandlers[F];const x=n.serializeReplyErr(U,j);this._logger?.logOutgoing(x.byteLength,U,1,"replyErr:",j),this._protocol.send(x)})}_receiveCancel(R,U){this._logger?.logIncoming(R,U,1,"receiveCancel");const H=String(U);this._cancelInvokedHandlers[H]?.()}_receiveReply(R,U,H){this._logger?.logIncoming(R,U,0,"receiveReply:",H);const V=String(U);if(!this._pendingRPCReplies.hasOwnProperty(V))return;const L=this._pendingRPCReplies[V];delete this._pendingRPCReplies[V],L.resolveOk(H)}_receiveReplyErr(R,U,H){this._logger?.logIncoming(R,U,0,"receiveReplyErr:",H);const V=String(U);if(!this._pendingRPCReplies.hasOwnProperty(V))return;const L=this._pendingRPCReplies[V];delete this._pendingRPCReplies[V];let M;H&&(H.$isError?(M=new Error,M.name=H.name,M.message=H.message,M.stack=H.stack):M=H),L.resolveErr(M)}_invokeHandler(R,U,H){try{return Promise.resolve(this._doInvokeHandler(R,U,H))}catch(V){return Promise.reject(V)}}_doInvokeHandler(R,U,H){const V=this._locals[R];if(!V)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(R));const L=V[U];if(typeof L!="function")throw new Error("Unknown method "+U+" on actor "+(0,A.getStringIdentifierForProxy)(R));return L.apply(V,H)}_remoteCall(R,U,H){if(this._isDisposed)return new D.CanceledLazyPromise;let V=null;if(H.length>0&&I.CancellationToken.isCancellationToken(H[H.length-1])&&(V=H.pop()),V&&V.isCancellationRequested)return Promise.reject(P.canceled());const L=n.serializeRequestArguments(H,this._uriReplacer),M=++this._lastMessageId,F=String(M),B=new D.LazyPromise;V&&V.onCancellationRequested(()=>{const z=n.serializeCancel(M);this._logger?.logOutgoing(z.byteLength,M,0,"cancel"),this._protocol.send(n.serializeCancel(M))}),this._pendingRPCReplies[F]=B,this._onWillSendRequest(M);const N=n.serializeRequest(M,R,U,L,!!V);return this._logger?.logOutgoing(N.byteLength,M,0,`request: ${(0,A.getStringIdentifierForProxy)(R)}.${U}(`,H),this._protocol.send(N),B}}e.RPCProtocol=l,k=u,l.UNRESPONSIVE_TIME=3*1e3;class a{static alloc(R,U,H){const V=new a(t.VSBuffer.alloc(H+1+4),0);return V.writeUInt8(R),V.writeUInt32(U),V}static read(R,U){return new a(R,U)}get buffer(){return this._buff}constructor(R,U){this._buff=R,this._offset=U}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const H=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,H}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const H=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,H}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,U}static sizeMixedArray(R){let U=0;U+=1;for(let H=0,V=R.length;H<V;H++){const L=R[H];switch(U+=1,L.type){case 1:U+=this.sizeLongString(L.value);break;case 2:U+=this.sizeVSBuffer(L.value);break;case 3:U+=this.sizeUInt32,U+=this.sizeLongString(L.value);for(let M=0;M<L.buffers.length;++M)U+=this.sizeVSBuffer(L.buffers[M]);break;case 4:break}}return U}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let U=0,H=R.length;U<H;U++){const V=R[U];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let L=0;L<V.buffers.length;++L)this.writeBuffer(V.buffers[L]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const U=new Array(R);for(let H=0;H<R;H++)switch(this.readUInt8()){case 1:U[H]=this.readLongString();break;case 2:U[H]=this.readVSBuffer();break;case 3:{const L=this.readUInt32(),M=this.readLongString(),F=[];for(let B=0;B<L;++B)F.push(this.readVSBuffer());U[H]=new A.SerializableObjectWithBuffers(h(M,F,null));break}case 4:U[H]=void 0;break}return U}}a.sizeUInt32=4;var d;(function(C){C[C.Simple=0]="Simple",C[C.Mixed=1]="Mixed"})(d||(d={}));class n{static _useMixedArgSerialization(R){for(let U=0,H=R.length;U<H;U++)if(R[U]instanceof t.VSBuffer||R[U]instanceof A.SerializableObjectWithBuffers||typeof R[U]>"u")return!0;return!1}static serializeRequestArguments(R,U){if(this._useMixedArgSerialization(R)){const H=[];for(let V=0,L=R.length;V<L;V++){const M=R[V];if(M instanceof t.VSBuffer)H[V]={type:2,value:M};else if(typeof M>"u")H[V]={type:4};else if(M instanceof A.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:B}=g(M.value,U);H[V]={type:3,value:t.VSBuffer.fromString(F),buffers:B}}else H[V]={type:1,value:t.VSBuffer.fromString(v(M,U))}}return{type:1,args:H}}return{type:0,args:v(R,U)}}static serializeRequest(R,U,H,V,L){switch(V.type){case 0:return this._requestJSONArgs(R,U,H,V.args,L);case 1:return this._requestMixedArgs(R,U,H,V.args,L)}}static _requestJSONArgs(R,U,H,V,L){const M=t.VSBuffer.fromString(H),F=t.VSBuffer.fromString(V);let B=0;B+=a.sizeUInt8(),B+=a.sizeShortString(M),B+=a.sizeLongString(F);const N=a.alloc(L?2:1,R,B);return N.writeUInt8(U),N.writeShortString(M),N.writeLongString(F),N.buffer}static deserializeRequestJSONArgs(R){const U=R.readUInt8(),H=R.readShortString(),V=R.readLongString();return{rpcId:U,method:H,args:JSON.parse(V)}}static _requestMixedArgs(R,U,H,V,L){const M=t.VSBuffer.fromString(H);let F=0;F+=a.sizeUInt8(),F+=a.sizeShortString(M),F+=a.sizeMixedArray(V);const B=a.alloc(L?4:3,R,F);return B.writeUInt8(U),B.writeShortString(M),B.writeMixedArray(V),B.buffer}static deserializeRequestMixedArgs(R){const U=R.readUInt8(),H=R.readShortString(),V=R.readMixedArray(),L=new Array(V.length);for(let M=0,F=V.length;M<F;M++){const B=V[M];typeof B=="string"?L[M]=JSON.parse(B):L[M]=B}return{rpcId:U,method:H,args:L}}static serializeAcknowledged(R){return a.alloc(5,R,0).buffer}static serializeCancel(R){return a.alloc(6,R,0).buffer}static serializeReplyOK(R,U,H){if(typeof U>"u")return this._serializeReplyOKEmpty(R);if(U instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(R,U);if(U instanceof A.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:L}=g(U.value,H,!0);return this._serializeReplyOKJSONWithBuffers(R,V,L)}else return this._serializeReplyOKJSON(R,E(U,H))}static _serializeReplyOKEmpty(R){return a.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,U){let H=0;H+=a.sizeVSBuffer(U);const V=a.alloc(8,R,H);return V.writeVSBuffer(U),V.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,U){const H=t.VSBuffer.fromString(U);let V=0;V+=a.sizeLongString(H);const L=a.alloc(9,R,V);return L.writeLongString(H),L.buffer}static _serializeReplyOKJSONWithBuffers(R,U,H){const V=t.VSBuffer.fromString(U);let L=0;L+=a.sizeUInt32,L+=a.sizeLongString(V);for(const F of H)L+=a.sizeVSBuffer(F);const M=a.alloc(10,R,L);M.writeUInt32(H.length),M.writeLongString(V);for(const F of H)M.writeBuffer(F);return M.buffer}static deserializeReplyOKJSON(R){const U=R.readLongString();return JSON.parse(U)}static deserializeReplyOKJSONWithBuffers(R,U){const H=R.readUInt32(),V=R.readLongString(),L=[];for(let M=0;M<H;++M)L.push(R.readVSBuffer());return new A.SerializableObjectWithBuffers(h(V,L,U))}static serializeReplyErr(R,U){const H=U?E(P.transformErrorForSerialization(U),null):void 0;if(typeof H!="string")return this._serializeReplyErrEmpty(R);const V=t.VSBuffer.fromString(H);let L=0;L+=a.sizeLongString(V);const M=a.alloc(11,R,L);return M.writeLongString(V),M.buffer}static deserializeReplyErrError(R){const U=R.readLongString();return JSON.parse(U)}static _serializeReplyErrEmpty(R){return a.alloc(12,R,0).buffer}}var i;(function(C){C[C.RequestJSONArgs=1]="RequestJSONArgs",C[C.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",C[C.RequestMixedArgs=3]="RequestMixedArgs",C[C.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",C[C.Acknowledged=5]="Acknowledged",C[C.Cancel=6]="Cancel",C[C.ReplyOKEmpty=7]="ReplyOKEmpty",C[C.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",C[C.ReplyOKJSON=9]="ReplyOKJSON",C[C.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",C[C.ReplyErrError=11]="ReplyErrError",C[C.ReplyErrEmpty=12]="ReplyErrEmpty"})(i||(i={}));var p;(function(C){C[C.String=1]="String",C[C.VSBuffer=2]="VSBuffer",C[C.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",C[C.Undefined=4]="Undefined"})(p||(p={}))}),define(_e[280],ye([1,0,4,43,53,3,38,10,18]),function(Z,e,c,t,I,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)(e.OUTPUT_SERVICE_ID);var D;(function(_){_[_.Append=1]="Append",_[_.Replace=2]="Replace",_[_.Clear=3]="Clear"})(D=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.channels=new Map,this._onDidRegisterChannel=new c.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new c.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(w){this.channels.has(w.id)||(this.channels.set(w.id,w),this._onDidRegisterChannel.fire(w.id))}getChannels(){const w=[];return this.channels.forEach(f=>w.push(f)),w}getChannel(w){return this.channels.get(w)}removeChannel(w){this.channels.delete(w),this._onDidRemoveChannel.fire(w)}}t.Registry.add(e.Extensions.OutputChannels,new A);function k(_,w,f,g,h){return(0,S.createCancelablePromise)(async v=>{await(0,y.whenProviderRegistered)(f,g);const m=t.Registry.as(e.Extensions.OutputChannels);try{await E(f,1,g,h,v),m.registerChannel({id:_,label:w,file:f,log:!0})}catch(r){(0,T.isCancellationError)(r)||h.error("Error while registering log channel",f.toString(),(0,T.getErrorMessage)(r))}})}e.registerLogChannel=k;async function E(_,w,f,g,h){if(!await f.exists(_)){if(h.isCancellationRequested)throw new T.CancellationError;if(w>10)throw new Error("Timed out while waiting for file to be created");g.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",_.toString()),await(0,S.timeout)(1e3,h),await E(_,w+1,f,g,h)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new I.RawContextKey("activeOutputChannel","")}),define(_e[140],ye([1,0,5,3,16,26,13,280,69,25,46,153,23,11,38,4,6,27]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class v extends y.AbstractMessageLogger{get disposed(){return this._disposed}constructor(s,u,o,l,a){super(),this.id=s,this.name=u,this.logger=o,this.proxy=l,this.extension=a,this.offset=0,this._disposed=!1,this.visible=!1,this._register(o.onDidChangeLogLevel(d=>this.setLevel(d)))}get logLevel(){return this.logger.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s)}clear(){const s=this.offset;this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Clear,s)}replace(s){const u=this.offset;this.info(s),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Replace,u),this.visible&&this.logger.flush()}show(s,u){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof s=="boolean"?s:u))}hide(){this.proxy.$close(this.id)}log(s,u){this.offset+=E.VSBuffer.fromString(u).byteLength,(0,y.log)(this.logger,s,u),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class m extends v{appendLine(s){this.append(s)}}let r=class{constructor(s,u,o,l,a,d){this.initData=u,this.extHostFileSystem=o,this.extHostFileSystemInfo=l,this.loggerService=a,this.logService=d,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=s.getProxy(c.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(u.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.visibleChannelId=s;for(const[u,o]of this.channels)o.visible=u===this.visibleChannelId}createOutputChannel(s,u,o){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const l=typeof u=="object"&&u.log;l&&(0,h.checkProposedApiEnabled)(o,"extensionLog");const a=(0,_.isString)(u)?u:void 0;if((0,_.isString)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let d;const n=this.initData.environment.extensionLogLevel?.find(([p])=>P.ExtensionIdentifier.equals(o.identifier,p))?.[1];n&&(d=(0,y.parseLogLevel)(n));const i=l?this.doCreateLogOutputChannel(s,d,o):this.doCreateOutputChannel(s,a,o);return i.then(p=>{this.channels.set(p.id,p),p.visible=p.id===this.visibleChannelId}),l?this.createExtHostLogOutputChannel(s,d??this.logService.getLevel(),i):this.createExtHostOutputChannel(s,i)}async doCreateOutputChannel(s,u,o){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const l=await this.outputDirectoryPromise,a=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.loggerService.createLogger(a,{always:!0,donotRotate:!0,donotUseFormatters:!0}),n=await this.proxy.$register(s,a,!1,u,o.identifier.value);return new v(n,s,d,this.proxy,o)}async doCreateLogOutputChannel(s,u,o){const l=await this.createExtensionLogDirectory(o),a=this.extHostFileSystemInfo.extUri.joinPath(l,`${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.loggerService.createLogger(a,{name:s},u),n=await this.proxy.$register(s,a,!0,void 0,o.identifier.value);return new m(n,s,d,this.proxy,o)}createExtensionLogDirectory(s){let u=this.extensionLogDirectoryPromise.get(s.identifier.value);if(!u){const o=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,s.identifier.value);this.extensionLogDirectoryPromise.set(s.identifier.value,u=(async()=>{try{await this.extHostFileSystem.value.createDirectory(o)}catch(l){if((0,w.toFileSystemProviderErrorCode)(l)!==w.FileSystemProviderErrorCode.FileExists)throw l}return o})())}return u}createExtHostOutputChannel(s,u){let o=!1;const l=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return s},append(a){l(),u.then(d=>d.append(a))},appendLine(a){l(),u.then(d=>d.appendLine(a))},clear(){l(),u.then(a=>a.clear())},replace(a){l(),u.then(d=>d.replace(a))},show(a,d){l(),u.then(n=>n.show(a,d))},hide(){l(),u.then(a=>a.hide())},dispose(){o=!0,u.then(a=>a.dispose())}}}createExtHostLogOutputChannel(s,u,o){const l=new g.DisposableStore,a=()=>{if(l.isDisposed)throw new Error("Channel has been closed")},d=l.add(new f.Emitter);return o.then(n=>{l.add(n),l.add(n.onDidChangeLogLevel(i=>{u=i,d.fire(i)}))}),{...this.createExtHostOutputChannel(s,o),get logLevel(){return u},onDidChangeLogLevel:d.event,trace(n,...i){a(),o.then(p=>p.trace(n,...i))},debug(n,...i){a(),o.then(p=>p.debug(n,...i))},info(n,...i){a(),o.then(p=>p.info(n,...i))},warn(n,...i){a(),o.then(p=>p.warn(n,...i))},error(n,...i){a(),o.then(p=>p.error(n,...i))},dispose(){l.dispose()}}}};r=Ve([ze(0,I.IExtHostRpcService),ze(1,D.IExtHostInitDataService),ze(2,S.IExtHostConsumerFileSystem),ze(3,A.IExtHostFileSystemInfo),ze(4,y.ILoggerService),ze(5,y.ILogService)],r),e.ExtHostOutputService=r,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(_e[281],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(_e[282],ye([1,0,32,14,9,12,22,2,3,208,45,225,281]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let _=class ti{constructor(f,g,h,v){this.localUserHome=f,this.remoteAgentService=g,this.environmentService=h,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const m=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=m?.userHome??f})()}hasValidBasename(f,g,h){return typeof g=="string"||typeof g>"u"?this.resolveOS.then(v=>this.doHasValidBasename(f,v,g)):this.doHasValidBasename(f,g,h)}doHasValidBasename(f,g,h){return f.scheme===t.Schemas.file||f.scheme===t.Schemas.vscodeRemote?(0,c.isValidBasename)(h??(0,y.basename)(f),g===1):!0}get defaultUriScheme(){return ti.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,g){if(f.remoteAuthority)return t.Schemas.vscodeRemote;const h=(0,D.getVirtualWorkspaceScheme)(g.getWorkspace());if(h)return h;const v=g.getWorkspace().folders[0];if(v)return v.uri.scheme;const m=g.getWorkspace().configuration;return m?m.scheme:t.Schemas.file}userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?I.win32:I.posix)}async fileURI(f){let g="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const v=f.indexOf("/",2);v===-1?(g=f.substring(2),f="/"):(g=f.substring(2,v),f=f.substring(v)||"/")}return T.URI.from({scheme:t.Schemas.file,authority:g,path:f,query:"",fragment:""})}};_=Ve([ze(1,E.IRemoteAgentService),ze(2,k.IWorkbenchEnvironmentService),ze(3,A.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(_e[72],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(y,T){this.line=y,this.character=T}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,T){return new c(0,0)}with(y){return new c(0,0)}}e.Position=c;class t{constructor(y,T,S,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(y,T),this.end=new c(S,D)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new t(0,0,0,0)}with(y){return new t(0,0,0,0)}}e.Range=t;var I;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(_e[30],ye([1,0,17,37,24,32,8,3,9,10,72,18]),function(Z,e,c,t,I,P,y,T,S,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const E="\u27EA ",_=" characters skipped \u27EB",w=(E.length+_.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var f;(function(K){K[K.file=0]="file",K[K.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(K){K[K.File=1]="File",K[K.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function h(K){return!!K.preview}e.resultIsMatch=h;function v(K){return!!K.resource}e.isFileMatch=v;function m(K){return!!K.message}e.isProgressMessage=m;var r;(function(K){K[K.Normal=0]="Normal",K[K.NewSearchStarted=1]="NewSearchStarted"})(r=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class b{constructor(le){this.resource=le,this.results=[]}}e.FileMatch=b;class s{constructor(le,ie,de){this.ranges=ie;const Y=Array.isArray(ie)?ie:[ie];if(de&&de.matchLines===1&&u(Y)){le=(0,y.getNLines)(le,de.matchLines);let pe="",be=0,Ce=0;const Re=Math.floor(de.charsPerLine/5),We=[];for(const ne of Y){const ce=Math.max(ne.startColumn-Re,0),fe=ne.startColumn+de.charsPerLine;if(ce>Ce+Re+w){const J=E+(ce-Ce)+_;pe+=J+le.slice(ce,fe),be+=ce-(Ce+J.length)}else pe+=le.slice(Ce,fe);We.push(new l(0,ne.startColumn-be,ne.endColumn-be)),Ce=fe}this.preview={text:pe,matches:Array.isArray(this.ranges)?We:We[0]}}else{const pe=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:le,matches:(0,c.mapArrayOrNot)(ie,be=>new o(be.startLineNumber-pe,be.startColumn,be.endLineNumber-pe,be.endColumn))}}}}e.TextSearchMatch=s;function u(K){const le=K[0].startLineNumber;for(const ie of K)if(ie.startLineNumber!==le||ie.endLineNumber!==le)return!1;return!0}class o{constructor(le,ie,de,Y){this.startLineNumber=le,this.startColumn=ie,this.endLineNumber=de,this.endColumn=Y}}e.SearchRange=o;class l extends o{constructor(le,ie,de){super(le,ie,le,de)}}e.OneLineRange=l;var a;(function(K){K.List="list",K.Tree="tree"})(a=e.ViewMode||(e.ViewMode={}));var d;(function(K){K.Default="default",K.FileNames="fileNames",K.Type="type",K.Modified="modified",K.CountDescending="countDescending",K.CountAscending="countAscending"})(d=e.SearchSortOrder||(e.SearchSortOrder={}));function n(K,le=!0){const ie=K&&K.files&&K.files.exclude,de=le&&K&&K.search&&K.search.exclude;if(!ie&&!de)return;if(!ie||!de)return ie||de;let Y=Object.create(null);return Y=I.mixin(Y,I.deepClone(ie)),Y=I.mixin(Y,I.deepClone(de),!0),Y}e.getExcludes=n;function i(K,le){return K.excludePattern&&t.match(K.excludePattern,le)?!1:K.includePattern||K.usingSearchPaths?K.includePattern&&t.match(K.includePattern,le)?!0:K.usingSearchPaths?!!K.folderQueries&&K.folderQueries.some(ie=>{const de=ie.folder.fsPath;if(P.isEqualOrParent(le,de)){const Y=S.relative(de,le);return!ie.includePattern||!!t.match(ie.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=i;var p;(function(K){K[K.unknownEncoding=1]="unknownEncoding",K[K.regexParseError=2]="regexParseError",K[K.globParseError=3]="globParseError",K[K.invalidLiteral=4]="invalidLiteral",K[K.rgProcessError=5]="rgProcessError",K[K.other=6]="other",K[K.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class C extends Error{constructor(le,ie){super(le),this.code=ie}}e.SearchError=C;function R(K){const le=K.message;if((0,D.isCancellationError)(K))return new C(le,p.canceled);try{const ie=JSON.parse(le);return new C(ie.message,ie.code)}catch{return new C(le,p.other)}}e.deserializeSearchError=R;function U(K){const le={message:K.message,code:K.code};return new Error(JSON.stringify(le))}e.serializeSearchError=U;function H(K){return K.type==="error"?!0:K.type==="success"}e.isSerializedSearchComplete=H;function V(K){return K.type==="success"}e.isSerializedSearchSuccess=V;function L(K){return!!K.path}e.isSerializedFileMatch=L;function M(K,le){const ie=K.searchPath?K.searchPath:K.relativePath;return(0,y.fuzzyContains)(ie,le)}e.isFilePatternMatch=M;class F{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function B(K,le){const ie={...K||{},...le||{}};return Object.keys(ie).filter(de=>{const Y=ie[de];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=B;class N{constructor(le,ie){this._parsedIncludeExpression=null,this._excludeExpression={...le.excludePattern||{},...ie.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let de=le.includePattern;ie.includePattern&&(de?de={...de,...ie.includePattern}:de=ie.includePattern),de&&(this._parsedIncludeExpression=t.parse(de))}matchesExcludesSync(le,ie,de){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(le,ie,de))}includedInQuerySync(le,ie,de){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(le,ie,de)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(le,ie,de))}includedInQuery(le,ie,de){const Y=this._parsedExcludeExpression(le,ie,de),pe=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(le,ie,de):!0;return(0,k.isThenable)(Y)?Y.then(be=>be?!1:pe()):pe()}hasSiblingExcludeClauses(){return z(this._excludeExpression)}}e.QueryGlobTester=N;function z(K){for(const le in K)if(typeof K[le]!="boolean")return!0;return!1}function j(K){if(!K)return;let le;return ie=>(le||(le=(K()||Promise.resolve([])).then(de=>de?Q(de):{})),le.then(de=>!!de[ie]))}e.hasSiblingPromiseFn=j;function x(K){if(!K)return;let le;return ie=>{if(!le){const de=K();le=de?Q(de):{}}return!!le[ie]}}e.hasSiblingFn=x;function Q(K){const le={};for(const ie of K)le[ie]=!0;return le}}),define(_e[33],ye([1,0,17,18,21,4,6,64,14,99,22,8,11,2,177,3,13,196,45,46,25,16,15,7,55,30,5]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h,v,m,r,b,s,u,o,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function d(V,L,M){return new A.ExtUri(F=>C(F,M)).isEqual(V,L)}function n(V,L,M){return d(V.uri,L.uri,M)?0:(0,k.compare)(V.uri.toString(),L.uri.toString())}function i(V,L,M){return V.index!==L.index?V.index<L.index?-1:1:d(V.uri,L.uri,M)?(0,k.compare)(V.name,L.name):(0,k.compare)(V.uri.toString(),L.uri.toString())}function p(V,L,M,F){const B=V.slice(0).sort((z,j)=>M(z,j,F)),N=L.slice(0).sort((z,j)=>M(z,j,F));return(0,c.delta)(B,N,(z,j)=>M(z,j,F))}function C(V,L){const M=L.getCapabilities(V.scheme);return!(M&&M&1024)}class R extends v.Workspace{static toExtHostWorkspace(L,M,F,B){if(!L)return{workspace:null,added:[],removed:[]};const{id:N,name:z,folders:j,configuration:x,transient:Q,isUntitled:K}=L,le=[],ie=M;M?j.forEach((be,Ce)=>{const Re=_.URI.revive(be.uri),We=R._findFolder(F||M,Re,B);We?(We.name=be.name,We.index=be.index,le.push(We)):le.push({uri:Re,name:be.name,index:Ce})}):le.push(...j.map(({uri:be,name:Ce,index:Re})=>({uri:_.URI.revive(be),name:Ce,index:Re}))),le.sort((be,Ce)=>be.index<Ce.index?-1:1);const de=new R(N,z,le,!!Q,x?_.URI.revive(x):null,!!K,be=>C(be,B)),{added:Y,removed:pe}=p(ie?ie.workspaceFolders:[],de.workspaceFolders,n,B);return{workspace:de,added:Y,removed:pe}}static _findFolder(L,M,F){for(let B=0;B<L.folders.length;B++){const N=L.workspaceFolders[B];if(d(N.uri,M,F))return N}}constructor(L,M,F,B,N,z,j){super(L,F.map(x=>new v.WorkspaceFolder(x)),B,N,j),this._name=M,this._isUntitled=z,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(j),F.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,M){return M&&this._structure.get(L)&&(L=(0,A.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let U=class{constructor(L,M,F,B,N){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=B,this._extHostFileSystemInfo=F,this._uriTransformerService=N,this._requestIdProvider=new D.Counter,this._barrier=new t.Barrier,this._proxy=L.getProxy(a.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(a.MainContext.MainThreadMessageService);const z=M.workspace;this._confirmedWorkspace=z?new R(z.id,z.name,[],!!z.transient,z.configuration?_.URI.revive(z.configuration):null,!!z.isUntitled,j=>C(j,F)):void 0}$initializeWorkspace(L,M){this._trusted=M,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?_.URI.from({scheme:S.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,M,F,...B){const N=[];if(Array.isArray(B)&&B.forEach(K=>{_.URI.isUri(K.uri)&&!N.some(le=>d(le.uri,K.uri,this._extHostFileSystemInfo))&&N.push({uri:K.uri,name:K.name||(0,A.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[M,F].some(K=>typeof K!="number"||K<0)||F===0&&N.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(M+F>z.length)return!1;const j=z.slice(0);j.splice(M,F,...N.map(K=>({uri:K.uri,name:K.name||(0,A.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<j.length;K++){const le=j[K];if(j.some((ie,de)=>de!==K&&d(le.uri,ie.uri,this._extHostFileSystemInfo)))return!1}j.forEach((K,le)=>K.index=le);const{added:x,removed:Q}=p(z,j,i,this._extHostFileSystemInfo);if(x.length===0&&Q.length===0)return!1;if(this._proxy){const K=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(K,M,F,N).then(void 0,le=>{this._unconfirmedWorkspace=void 0;const ie={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(h.Severity.Error,(0,w.localize)(0,null,K,le.toString()),ie,[])})}return this.trySetWorkspaceFolders(j),!0}getWorkspaceFolder(L,M){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,M)}async getWorkspaceFolder2(L,M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,M)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,M){let F,B="";if(typeof L=="string"?(F=_.URI.file(L),B=L):typeof L<"u"&&(F=L,B=L.fsPath),!F)return B;const N=this.getWorkspaceFolder(F,!0);if(!N)return B;typeof M>"u"&&this._actualWorkspace&&(M=this._actualWorkspace.folders.length>1);let z=(0,A.relativePath)(N.uri,F);return M&&N.name&&(z=`${N.name}/${z}`),z}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=R.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:M,added:F,removed:B}=R.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=M||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:F,removed:B}))}findFiles(L,M,F,B,N=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let z;if(M===null?z=!1:M&&(typeof M=="string"?z=M:z=M.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:j,folder:x}=H(s.GlobPattern.from(L));return this._proxy.$startFileSearch((0,E.withUndefinedAsNull)(j),(0,E.withUndefinedAsNull)(x),(0,E.withUndefinedAsNull)(z),(0,E.withUndefinedAsNull)(F),N).then(Q=>Array.isArray(Q)?Q.map(K=>_.URI.revive(K)):[])}async findTextInFiles(L,M,F,B,N=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),j=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:x,folder:Q}=H(s.GlobPattern.from(M.include)),K=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,le={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:j,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:x,excludePattern:K},ie=!1;if(this._activeSearchCallbacks[z]=de=>{if(ie)return;const Y=_.URI.revive(de.resource);de.results.forEach(pe=>{(0,l.resultIsMatch)(pe)?F({uri:Y,preview:{text:pe.preview.text,matches:(0,c.mapArrayOrNot)(pe.preview.matches,be=>new u.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,c.mapArrayOrNot)(pe.ranges,be=>new u.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):F({uri:Y,text:pe.text,lineNumber:pe.lineNumber})})},N.isCancellationRequested)return{};try{const de=await this._proxy.$startTextSearch(L,(0,E.withUndefinedAsNull)(Q),le,z,N);return delete this._activeSearchCallbacks[z],de||{}}catch(de){throw delete this._activeSearchCallbacks[z],de}}$handleTextSearchResult(L,M){this._activeSearchCallbacks[M]?.(L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(L,M){if(this._editSessionIdentityProviders.has(L))throw new Error(`A provider has already been registered for scheme ${L}`);this._editSessionIdentityProviders.set(L,M);const F=this._uriTransformerService.transformOutgoingScheme(L),B=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(B,F),(0,y.toDisposable)(()=>{this._editSessionIdentityProviders.delete(L),this._proxy.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(L,M){this._logService.info("Getting edit session identifier for workspaceFolder",L);const F=await this.resolveWorkspaceFolder(_.URI.revive(L));if(!F){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const B=this._editSessionIdentityProviders.get(F.uri.scheme);if(this._logService.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!B),!B)return;const N=await B.provideEditSessionIdentity(F,M);if(this._logService.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(L,M,F,B){this._logService.info("Getting edit session identifier for workspaceFolder",L);const N=await this.resolveWorkspaceFolder(_.URI.revive(L));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const z=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!z),!z)return;const j=await z.provideEditSessionIdentityMatch?.(M,F,B);if(this._logService.info("Provider returned edit session identifier match result: ",j),!!j)return j}};U=Ve([ze(0,b.IExtHostRpcService),ze(1,r.IExtHostInitDataService),ze(2,m.IExtHostFileSystemInfo),ze(3,g.ILogService),ze(4,o.IURITransformerService)],U),e.ExtHostWorkspace=U,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function H(V){let L,M;return V&&(typeof V=="string"?L=V:(L=V.pattern,M=_.URI.revive(V.baseUri))),{includePattern:L,folder:M}}}),define(_e[34],ye([1,0,24,4,33,5,7,199,126,11,18,3,16,13,2]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(u,o){if(o){const l=o.split(".");let a=u;for(let d=0;a&&d<l.length;d++)a=a[l[d]];return a}}function g(u){return u instanceof w.URI}function h(u){return u&&u.uri instanceof w.URI&&u.languageId&&typeof u.languageId=="string"}function v(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function m(u){return u&&u.uri instanceof w.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function r(u){if(g(u))return{resource:u};if(h(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(v(u))return{overrideIdentifier:u.languageId};if(m(u))return{resource:u.uri};if(u===null)return{resource:null}}let b=class{constructor(o,l,a){this._proxy=o.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=l,this._logService=a,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new s(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,l){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(o,l))}};b=Ve([ze(0,E.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,_.ILogService)],b),e.ExtHostConfiguration=b;class s{constructor(o,l,a,d){this._onDidChangeConfiguration=new t.Emitter,this._proxy=o,this._logService=d,this._extHostWorkspace=l,this._configuration=T.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,l){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=T.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(l,a))}getConfiguration(o,l,a){const d=r(l)||{},n=this._toReadonlyValue(o?f(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,d,a?.identifier);function i(C){if(C==null)return null;if(typeof C=="boolean")return C?2:5;switch(C){case y.ConfigurationTarget.Global:return 2;case y.ConfigurationTarget.Workspace:return 5;case y.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(C){return typeof f(n,C)<"u"},get:(C,R)=>{this._validateConfigurationAccess(o?`${o}.${C}`:C,d,a?.identifier);let U=f(n,C);if(typeof U>"u")U=R;else{let H;const V=(L,M)=>{let F;const B=()=>{H=H||(0,c.deepClone)(n),F=F||f(H,M)};return(0,D.isObject)(L)?new Proxy(L,{get:(N,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return B(),()=>F;if(H)return F=F||f(H,M),F[z];const j=N[z];return typeof z=="string"?V(j,`${M}.${z}`):j},set:(N,z,j)=>(B(),F&&(F[z]=j),!0),deleteProperty:(N,z)=>(B(),F&&delete F[z],!0),defineProperty:(N,z,j)=>(B(),F&&Object.defineProperty(F,z,j),!0)}):L};U=V(U,C)}return U},update:(C,R,U,H)=>{C=o?`${o}.${C}`:C;const V=i(U);return R!==void 0?this._proxy.$updateConfigurationOption(V,C,R,d,H):this._proxy.$removeConfigurationOption(V,C,d,H)},inspect:C=>{C=o?`${o}.${C}`:C;const R=this._configuration.inspect(C,d,this._extHostWorkspace.workspace);if(R)return{key:C,defaultValue:(0,c.deepClone)(R.policy?.value??R.default?.value),globalValue:(0,c.deepClone)(R.user?.value??R.application?.value),workspaceValue:(0,c.deepClone)(R.workspace?.value),workspaceFolderValue:(0,c.deepClone)(R.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(R.default?.override),globalLanguageValue:(0,c.deepClone)(R.user?.override??R.application?.override),workspaceLanguageValue:(0,c.deepClone)(R.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(R.workspaceFolder?.override),languageIds:(0,c.deepClone)(R.overrideIdentifiers)}}};return typeof n=="object"&&(0,c.mixin)(p,n,!1),Object.freeze(p)}_toReadonlyValue(o){const l=a=>(0,D.isObject)(a)?new Proxy(a,{get:(d,n)=>l(d[n]),set:(d,n,i)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(d,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(d,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return l(o)}_validateConfigurationAccess(o,l,a){const d=S.OVERRIDE_PROPERTY_REGEX.test(o)?4:this._configurationScopes.get(o),n=a?`[${a.value}] `:"";if(d===4){typeof l?.resource>"u"&&this._logService.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){l?.resource&&this._logService.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,l){const a=new T.ConfigurationChangeEvent(o,l,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,n)=>a.affectsConfiguration(d,r(n))})}_toMap(o){return o.reduce((l,a)=>(l.set(a[0],a[1]),l),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Me=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[73],ye([1,0,2,18,4,5,7,33,58,34,21,40,16,25,3,14,12,13,68,238,10]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h,v,m,r){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(L){function M(B){if(B!=null)return B}L.from=M;function F(B){if(B!=null)return B}L.to=F})(s||(s={}));var u;(function(L){function M(B){if(B!=null)return B}L.from=M;function F(B){if(B!=null)return B}L.to=F})(u||(u={}));var o;(function(L){function M(B){if(B!=null)return B}L.from=M;function F(B){if(B!=null)return B}L.to=F})(o||(o={}));var l;(function(L){function M(N){if(N){const z=N;return z&&!!z.process}else return!1}L.is=M;function F(N){if(N==null)return;const z={process:N.process,args:N.args};return N.options&&(z.options=o.from(N.options)),z}L.from=F;function B(N){if(N!=null)return new y.ProcessExecution(N.process,N.args,N.options)}L.to=B})(l||(l={}));var a;(function(L){function M(B){if(B!=null)return B}L.from=M;function F(B){if(B!=null)return B}L.to=F})(a||(a={}));var d;(function(L){function M(N){if(N){const z=N;return z&&(!!z.commandLine||!!z.command)}else return!1}L.is=M;function F(N){if(N==null)return;const z={};return N.commandLine!==void 0?z.commandLine=N.commandLine:(z.command=N.command,z.args=N.args),N.options&&(z.options=a.from(N.options)),z}L.from=F;function B(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new y.ShellExecution(N.commandLine,N.options):new y.ShellExecution(N.command,N.args?N.args:[],N.options)}L.to=B})(d||(d={}));var n;(function(L){function M(N){if(N){const z=N;return z&&z.customExecution==="customExecution"}else return!1}L.is=M;function F(N){return{customExecution:"customExecution"}}L.from=F;function B(N,z){return z.get(N)}L.to=B})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var i;(function(L){function M(F,B){let N;return F.scope!==void 0&&typeof F.scope!="number"?N=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===y.TaskScope.Workspace&&B&&B.workspaceFile?N=B.workspaceFile:N=m.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:N}}L.from=M})(i=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(L){function M(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}L.from=M})(p||(p={}));var C;(function(L){function M(N,z){if(N==null)return[];const j=[];for(const x of N){const Q=F(x,z);Q&&j.push(Q)}return j}L.fromMany=M;function F(N,z){if(N==null)return;let j;N.execution instanceof y.ProcessExecution?j=l.from(N.execution):N.execution instanceof y.ShellExecution?j=d.from(N.execution):N.execution&&N.execution instanceof y.CustomExecution&&(j=n.from(N.execution));const x=s.from(N.definition);let Q;return N.scope?typeof N.scope=="number"?Q=N.scope:Q=N.scope.uri:Q=y.TaskScope.Workspace,!x||!Q?void 0:{_id:N._id,definition:x,name:N.name,source:{extensionId:z.identifier.value,label:N.source,scope:Q},execution:j,isBackground:N.isBackground,group:p.from(N.group),presentationOptions:u.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}L.from=F;async function B(N,z,j){if(N==null)return;let x;l.is(N.execution)?x=l.to(N.execution):d.is(N.execution)?x=d.to(N.execution):n.is(N.execution)&&(x=n.to(N._id,j));const Q=s.to(N.definition);let K;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?K=N.source.scope:K=await z.resolveWorkspaceFolder(c.URI.revive(N.source.scope)):K=y.TaskScope.Workspace),!Q||!K)return;const le=new y.Task(Q,K,N.name,N.source.label,x,N.problemMatchers);return N.isBackground!==void 0&&(le.isBackground=N.isBackground),N.group!==void 0&&(le.group=y.TaskGroup.from(N.group._id),le.group&&N.group.isDefault&&(le.group=new y.TaskGroup(le.group.id,le.group.label),N.group.isDefault===!0&&(le.group.isDefault=N.group.isDefault))),N.presentationOptions&&(le.presentationOptions=u.to(N.presentationOptions)),N._id&&(le._id=N._id),N.detail&&(le.detail=N.detail),le}L.to=B})(C=e.TaskDTO||(e.TaskDTO={}));var R;(function(L){function M(B){return B}L.from=M;function F(B){if(!!B)return Object.assign(Object.create(null),B)}L.to=F})(R||(R={}));class U{constructor(M,F,B){this._id=F,this._task=B,b.set(this,void 0),Ze(this,b,M,"f")}get task(){return this._task}terminate(){Me(this,b,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}b=new WeakMap;let H=class{constructor(M,F,B,N,z,j,x,Q){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=M.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=N,this._configurationService=z,this._terminalService=j,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=x,this._deprecationService=Q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,F,B){if(!B)return new y.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:F,provider:B,extension:M}),this._proxy.$registerTaskProvider(N,F),new y.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(M,F){this._proxy.$registerTaskSystem(M,F)}fetchTasks(M){return this._proxy.$fetchTasks(R.from(M)).then(async F=>{const B=[];for(const N of F){const z=await C.to(N,this._workspaceProvider,this._providedCustomExecutions2);z&&B.push(z)}return B})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(F=>M.push(F)),M}terminateTask(M){if(!(M instanceof U))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,F,B){const N=this._providedCustomExecutions2.get(M.id);N&&(this._activeCustomExecutions2.set(M.id,N),this._terminalService.attachPtyToTerminal(F,await N.callback(B))),this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){const F=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:F})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const F=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:F,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const F=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:F,exitCode:M.exitCode})}$provideTasks(M,F){const B=this._handlers.get(M);if(!B)return Promise.reject(new Error("no handler found"));const N=[],z=(0,t.asPromise)(()=>B.provider.provideTasks(A.CancellationToken.None)).then(j=>this.provideTasksInternal(F,N,B,j));return new Promise(j=>{z.then(x=>{Promise.all(N).then(()=>{j(x)})})})}async $resolveTask(M,F){const B=this._handlers.get(M);if(!B)return Promise.reject(new Error("no handler found"));if(F.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${B.type}].`);const N=await C.to(F,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const z=await B.provider.resolveTask(N,A.CancellationToken.None);if(!z)return;this.checkDeprecation(z,B);const j=C.from(z,B.extension);if(!j)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(j.execution)&&await this.addCustomExecution(j,z,!0),await this.resolveTaskInternal(j)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,F,B){const N=await this._proxy.$createTaskId(M);!B&&!this._providedCustomExecutions2.has(N)&&(this._notProvidedCustomExecutions.add(N),this._activeCustomExecutions2.set(N,F.execution)),this._providedCustomExecutions2.set(N,F.execution)}async getTaskExecution(M,F){if(typeof M=="string"){const z=this._taskExecutionPromises.get(M);if(!z)throw new r.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return z}const B=this._taskExecutionPromises.get(M.id);if(B)return B;const N=new Promise((z,j)=>{function x(Q,K,le){le?z(new U(Q,K.id,le)):j("Unexpected: Task does not exist.")}F?x(this,M,F):C.to(M.task,this._workspaceProvider,this._providedCustomExecutions2).then(Q=>x(this,M,Q))});return this._taskExecutionPromises.set(M.id,N),N.then(z=>(this._taskExecutions.set(M.id,z),z),z=>Promise.reject(z))}checkDeprecation(M,F){M._deprecated&&this._deprecationService.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));const B=this._notProvidedCustomExecutions.values();let N=B.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=B.next()}};H=Ve([ze(0,E.IExtHostRpcService),ze(1,_.IExtHostInitDataService),ze(2,T.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,D.IExtHostConfiguration),ze(5,k.IExtHostTerminalService),ze(6,h.ILogService),ze(7,v.IExtHostApiDeprecationService)],H),e.ExtHostTaskBase=H;let V=class extends H{constructor(M,F,B,N,z,j,x,Q){super(M,F,B,N,z,j,x,Q),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(M,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const B=C.from(F,M);if(B===void 0)throw new Error("Task is not valid");if(n.is(B.execution))await this.addCustomExecution(B,F,!1);else throw new r.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),F);return this._proxy.$executeTask(B).catch(z=>{throw new Error(z)}),N}provideTasksInternal(M,F,B,N){const z=[];if(N)for(const j of N){this.checkDeprecation(j,B),(!j.definition||!M[j.definition.type])&&this._logService.warn(`The task [${j.source}, ${j.name}] uses an undefined task type. The task will be ignored in the future.`);const x=C.from(j,B.extension);x&&n.is(x.execution)?(z.push(x),F.push(this.addCustomExecution(x,j,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:B.extension}}async resolveTaskInternal(M){if(n.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,F,B){}};V=Ve([ze(0,E.IExtHostRpcService),ze(1,_.IExtHostInitDataService),ze(2,T.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,D.IExtHostConfiguration),ze(5,k.IExtHostTerminalService),ze(6,h.ILogService),ze(7,v.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,w.createDecorator)("IExtHostTask")}),define(_e[283],ye([1,0,9,21,50,37,22,51,30]),function(Z,e,c,t,I,P,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(E,_,w){this.config=E,this.provider=_,this.sessionToken=w,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=E.filePattern,this.includePattern=E.includePattern&&P.parse(E.includePattern),this.maxResults=E.maxResults||void 0,this.exists=E.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=E.excludePattern&&P.parse(E.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(E=>E.cancel()),this.activeCancellationTokens=new Set}search(E){const _=this.config.folderQueries||[];return new Promise((w,f)=>{const g=h=>{this.resultCount++,E(h)};if(this.isCanceled)return w({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(h=>{const v=h.toString(),m=c.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,m)||this.matchFile(g,{base:h,basename:m})}),Promise.all(_.map(h=>this.searchInFolder(h,g))).then(h=>{w({limitHit:this.isLimitHit,stats:h[0]||void 0})},h=>{f(new Error((0,I.toErrorMessage)(h)))})})}async searchInFolder(E,_){const w=new t.CancellationTokenSource,f=this.getSearchOptionsForFolder(E),g=this.initDirectoryTree(),h=new S.QueryGlobTester(this.config,E),v=!h.hasSiblingExcludeClauses();let m;try{this.activeCancellationTokens.add(w),m=T.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},f,w.token),b=m.elapsed(),s=T.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(u=>{const o=c.posix.relative(E.folder.path,u.path);if(v){const l=c.basename(u.path);this.matchFile(_,{base:E.folder,relativePath:o,basename:l});return}this.addDirectoryEntries(g,E.folder,o,_)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,h,_),{providerTime:b,postProcessTime:s.elapsed()})}finally{w.dispose(),this.activeCancellationTokens.delete(w)}}getSearchOptionsForFolder(E){const _=(0,S.resolvePatternsForProvider)(this.config.includePattern,E.includePattern),w=(0,S.resolvePatternsForProvider)(this.config.excludePattern,E.excludePattern);return{folder:E.folder,excludes:w,includes:_,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}addDirectoryEntries({pathToEntries:E},_,w,f){if(w===this.filePattern){const h=c.basename(this.filePattern);this.matchFile(f,{base:_,relativePath:this.filePattern,basename:h})}function g(h){const v=c.basename(h),m=c.dirname(h);let r=E[m];r||(r=E[m]=[],g(m)),r.push({base:_,relativePath:h,basename:v})}g(w)}matchDirectoryTree({rootEntries:E,pathToEntries:_},w,f){const g=this,h=this.filePattern;function v(m){const r=(0,S.hasSiblingFn)(()=>m.map(b=>b.basename));for(let b=0,s=m.length;b<s;b++){const u=m[b],{relativePath:o,basename:l}=u;if(w.matchesExcludesSync(o,l,h!==l?r:void 0))continue;const a=_[o];if(a)v(a);else{if(o===h)continue;g.matchFile(f,u)}if(g.isLimitHit)break}}v(E)}matchFile(E,_){(!this.includePattern||_.relativePath&&this.includePattern(_.relativePath,_.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||E(_))}}class A{constructor(){this.sessions=new Map}fileSearch(E,_,w,f){const g=this.getSessionTokenSource(E.cacheKey),h=new D(E,_,g&&g.token);let v=0;const m=r=>{v+=r.length,w(r.map(b=>this.rawMatchToSearchItem(b)))};return this.doSearch(h,A.BATCH_SIZE,m,f).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:r.stats}}))}clearCache(E){this.getSessionTokenSource(E)?.cancel()}getSessionTokenSource(E){if(!!E)return this.sessions.has(E)||this.sessions.set(E,new t.CancellationTokenSource),this.sessions.get(E)}rawMatchToSearchItem(E){return E.relativePath?{resource:y.joinPath(E.base,E.relativePath)}:{resource:E.base}}doSearch(E,_,w,f){f.onCancellationRequested(()=>{E.cancel()});const g=v=>{v&&(h.push(v),_>0&&h.length>=_&&(w(h),h=[]))};let h=[];return E.search(g).then(v=>(h.length&&w(h),v),v=>(h.length&&w(h),Promise.reject(v)))}}e.FileSearchManager=A,A.BATCH_SIZE=512}),define(_e[284],ye([1,0,17,78,37,111,28,14,9,22,8,11,2,161,188,52,13,45,132,282,30]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h,v,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let b=class{constructor(p,C,R,U,H){this.configurationService=p,this.workspaceContextService=C,this.editorGroupsService=R,this.logService=U,this.pathService=H}text(p,C,R={}){p=this.getContentPattern(p,R);const U=this.configurationService.getValue(),H=C&&C.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(C?.map(h.toWorkspaceFolder),R),type:2,contentPattern:p,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:U.search.usePCRE2||H||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}getContentPattern(p,C){const R=this.configurationService.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const U={...p,wordSeparators:R.editor.wordSeparators};return this.isCaseSensitive(p,C)&&(U.isCaseSensitive=!0),this.isMultiline(p)&&(U.isMultiline=!0),U}file(p,C={}){return{...this.commonQuery(p,C),type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey}}handleIncludeExclude(p,C){return p?(p=Array.isArray(p)?p.map(a):a(p),C?this.parseSearchPaths(p):{pattern:u(...Array.isArray(p)?p:[p])}):{}}commonQuery(p=[],C={}){const R=this.handleIncludeExclude(C.includePattern,C.expandPatterns),U=this.handleIncludeExclude(C.excludePattern,C.expandPatterns),H=p.length>1,V=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(F=>this.getFolderQueryForSearchPath(F,C,U)):p.map(F=>this.getFolderQueryForRoot(F,C,U,H))).filter(F=>!!F),L={_reason:C._reason,folderQueries:V,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:U.pattern,includePattern:R.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const F=c.coalesce(c.flatten(this.editorGroupsService.groups.map(z=>z.editors.map(j=>j.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const B=F.filter(z=>(0,r.pathIncludedInQuery)(L,z.fsPath)),N=this.commonQueryFromFileList(B);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(N)),{...L,...N}}const M=C.extraFileResources&&C.extraFileResources.filter(F=>(0,r.pathIncludedInQuery)(L,F.fsPath));return L.extraFileResources=M&&M.length?M:void 0,L}commonQueryFromFileList(p){const C=[],R=new y.ResourceMap,U={};let H=!1;return p.forEach(V=>{if(V.scheme===T.Schemas.walkThrough)return;if((0,D.isAbsolutePath)(V)){const M=this.workspaceContextService.getWorkspaceFolder(V)?.uri??V.with({path:S.dirname(V.fsPath)});let F=R.get(M);F||(H=!0,F={folder:M,includePattern:{}},C.push(F),R.set(M,F));const B=S.relative(M.fsPath,V.fsPath);(0,k.assertIsDefined)(F.includePattern)[B.replace(/\\/g,"/")]=!0}else V.fsPath&&(H=!0,U[V.fsPath]=!0)}),{folderQueries:C,includePattern:U,usingSearchPaths:!0,excludePattern:H?void 0:{"**/*":!0}}}isCaseSensitive(p,C){if(C.isSmartCase){if(p.isRegExp){if(A.containsUppercaseCharacter(p.pattern,!0))return!0}else if(A.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}isMultiline(p){return p.isMultiline||p.isRegExp&&(0,_.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const C=N=>S.isAbsolute(N)||/^\.\.?([\/\\]|$)/.test(N),U=(Array.isArray(p)?p:o(p)).map(N=>{const z=this.pathService.resolvedUserHome;return z?(0,P.untildify)(N,z.scheme===T.Schemas.file?z.fsPath:z.path):N}),H=t.groupBy(U,N=>C(N)?"searchPaths":"exprSegments"),V=(H.exprSegments||[]).map(N=>A.rtrim(N,"/")).map(N=>A.rtrim(N,"\\")).map(N=>(N[0]==="."&&(N="*"+N),l(N))),L={},M=this.expandSearchPathPatterns(H.searchPaths||[]);M&&M.length&&(L.searchPaths=M);const F=c.flatten(V),B=u(...F);return B&&(L.pattern=B),L}getExcludesForFolder(p,C){return C.disregardExcludeSettings?void 0:(0,r.getExcludes)(p,!C.disregardSearchExcludeSettings)}expandSearchPathPatterns(p){if(!p||!p.length)return[];const C=c.flatten(p.map(U=>{let{pathPortion:H,globPortion:V}=s(U);V&&(V=d(V));const L=this.expandOneSearchPath(H);return c.flatten(L.map(M=>this.resolveOneSearchPathPattern(M,V)))})),R=new Map;return C.forEach(U=>{const H=U.searchPath.toString(),V=R.get(H);V?U.pattern&&(V.pattern=V.pattern||{},V.pattern[U.pattern]=!0):R.set(H,{searchPath:U.searchPath,pattern:U.pattern?u(U.pattern):void 0})}),Array.from(R.values())}expandOneSearchPath(p){if(S.isAbsolute(p)){const C=this.workspaceContextService.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==T.Schemas.file?[{searchPath:C[0].uri.with({path:p})}]:[{searchPath:E.URI.file(S.normalize(p))}]}if(this.workspaceContextService.getWorkbenchState()===2){const C=this.workspaceContextService.getWorkspace().folders[0].uri;if(p=a(p),p.startsWith("../")||p===".."){const U=S.posix.resolve(C.path,p);return[{searchPath:C.with({path:U})}]}const R=d(p);return[{searchPath:C,pattern:R}]}else{if(p==="./"||p===".\\")return[];{const C=p.replace(/^\.[\/\\]/,""),U=this.workspaceContextService.getWorkspace().folders.map(H=>{const V=C.match(new RegExp(`^${A.escapeRegExpCharacters(H.name)}(?:/(.*)|$)`));return V?{match:V,folder:H}:null}).filter(k.isDefined);if(U.length)return U.map(H=>{const V=H.match[1];return{searchPath:H.folder.uri,pattern:V&&d(V)}});{const H=p.match(/\.[\/\\](.+)[\/\\]?/),V=H?H[1]:p,L=w.localize(0,null,V);throw new Error(L)}}}}resolveOneSearchPathPattern(p,C){const R=p.pattern&&C?`${p.pattern}/${C}`:p.pattern||C,U=[{searchPath:p.searchPath,pattern:R}];return R&&!R.endsWith("**")&&U.push({searchPath:p.searchPath,pattern:R+"/**"}),U}getFolderQueryForSearchPath(p,C,R){const U=this.getFolderQueryForRoot((0,h.toWorkspaceFolder)(p.searchPath),C,R,!1);return U?{...U,includePattern:p.pattern}:null}getFolderQueryForRoot(p,C,R,U){let H;const V=E.URI.isUri(p)?p:p.uri;if(R.searchPaths){const N=R.searchPaths.filter(z=>(0,D.isEqual)(z.searchPath,V))[0];if(N&&!N.pattern)return null;N&&(H=N.pattern)}const L=this.configurationService.getValue({resource:V}),F={...this.getExcludesForFolder(L,C)||{},...H||{}},B=E.URI.isUri(p)?(0,D.basename)(p):p.name;return{folder:V,folderName:U?B:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof C.disregardParentIgnoreFiles=="boolean"?C.disregardParentIgnoreFiles:!L.search.useParentIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!L.search.followSymlinks}}};b=Ve([ze(0,f.IConfigurationService),ze(1,h.IWorkspaceContextService),ze(2,v.IEditorGroupsService),ze(3,g.ILogService),ze(4,m.IPathService)],b),e.QueryBuilder=b;function s(i){const p=i.match(/[\*\{\}\(\)\[\]\?]/);if(p){const C=p.index,R=i.substr(0,C).match(/[/|\\][^/\\]*$/);if(R){let U=i.substr(0,R.index);return U.match(/[/\\]/)||(U+="/"),{pathPortion:U,globPortion:i.substr((R.index||0)+1)}}}return{pathPortion:i}}function u(...i){return i.length?i.reduce((p,C)=>(p[C]=!0,p),Object.create(null)):void 0}function o(i){return I.splitGlobAware(i,",").map(p=>p.trim()).filter(p=>!!p.length)}function l(i){return[`**/${i}/**`,`**/${i}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function a(i){return i.replace(/\\/g,"/")}function d(i){return a(i).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(i,p){i=c.distinct(i,U=>U.toString());const C=[],R=p.getWorkspace();return i&&i.forEach(U=>{let H;if(p.getWorkbenchState()===2)H=(0,D.relativePath)(R.folders[0].uri,U),H&&H!=="."&&(H="./"+H);else{const V=p.getWorkspaceFolder(U);if(V){const L=V.name;if(R.folders.filter(F=>F.name===L).length===1){const F=(0,D.relativePath)(V.uri,U);F===""?H=`./${V.name}`:H=`./${V.name}/${F}`}else H=U.fsPath}}H&&C.push(H)}),C}e.resolveResourcesForSearchIncludes=n}),define(_e[285],ye([1,0,22,2,21,10,3,284,30,45]),function(Z,e,c,t,I,P,y,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function k(f,g){const h=g.activationEvents;if(!h)return Promise.resolve(void 0);const v=[],m=[];for(const l of h)if(/^workspaceContains:/.test(l)){const a=l.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||f.forceUsingSearch?m.push(a):v.push(a)}if(v.length===0&&m.length===0)return Promise.resolve(void 0);let r;const b=new Promise((l,a)=>{r=l}),s=l=>r({activationEvent:l}),u=Promise.all(v.map(l=>E(f,l,s))).then(()=>{}),o=_(f,g.identifier,m,s);return Promise.all([u,o]).then(()=>{r(void 0)}),b}e.checkActivateWorkspaceContainsExtension=k;async function E(f,g,h){for(const v of f.folders)if(await f.exists(c.joinPath(t.URI.revive(v),g))){h(`workspaceContains:${g}`);return}}async function _(f,g,h,v){if(h.length===0)return Promise.resolve(void 0);const m=new I.CancellationTokenSource,r=f.checkExists(f.folders,h,m.token),b=setTimeout(async()=>{m.cancel(),f.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},A);let s=!1;try{s=await r}catch(u){P.isCancellationError(u)||P.onUnexpectedError(u)}m.dispose(),clearTimeout(b),s&&v(`workspaceContains:${h.join(",")}`)}function w(f,g,h,v){const m=f.get(y.IInstantiationService),r=f.get(S.ISearchService),s=m.createInstance(T.QueryBuilder).file(g.map(u=>(0,D.toWorkspaceFolder)(t.URI.revive(u))),{_reason:"checkExists",includePattern:h,exists:!0});return r.fileSearch(s,v).then(u=>!!u.limitHit,u=>P.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=w});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Me=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[41],ye([1,0,172,9,74,22,18,6,64,2,13,5,34,228,96,33,27,226,10,26,23,209,7,127,3,25,70,16,85,54,40,4,285,95,211,14,94]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h,v,m,r,b,s,u,o,l,a,d,n,i,p,C,R,U,H,V,L){"use strict";var M,F,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let N=class An extends T.Disposable{constructor(ie,de,Y,pe,be,Ce,Re,We,ne,ce,fe){super(),this._onDidChangeRemoteConnectionData=this._register(new C.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=de,this._extHostContext=Y,this._initData=Re,this._extHostWorkspace=pe,this._extHostConfiguration=be,this._logService=Ce,this._extHostTunnelService=ne,this._extHostTerminalService=ce,this._extHostLocalizationService=fe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._globalRegistry=new h.ExtensionDescriptionRegistry(this._initData.allExtensions);const J=(0,g.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new h.ExtensionDescriptionRegistry(x(this._globalRegistry,J)),this._storage=new w.ExtHostStorage(this._extHostContext),this._secretState=new U.ExtHostSecretState(this._extHostContext),this._storagePath=We,this._instaService=ie.createChild(new n.ServiceCollection([w.IExtHostStorage,this._storage],[U.IExtHostSecretState,this._secretState]));let re=[],ee=[];this._initData.remote.isRemote&&(re=this._initData.allExtensions.filter(W=>!W.main&&!W.browser).map(W=>W.identifier),ee=this._initData.allExtensions.filter(W=>!J.has(m.ExtensionIdentifier.toKey(W.identifier.value))).filter(W=>(W.main||W.browser)&&W.api==="none").map(W=>W.identifier));const O=(0,g.extensionIdentifiersArrayToSet)(ee);this._activator=this._register(new _.ExtensionsActivator(this._myRegistry,re,ee,{onExtensionActivationError:(W,q,X)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(W,v.transformErrorForSerialization(q),X)},actualActivateExtension:async(W,q)=>{if(O.has(m.ExtensionIdentifier.toKey(W)))return await this._mainThreadExtensionsProxy.$activateExtension(W,q),new _.HostExtension;const X=this._myRegistry.getExtensionDescription(W);return this._activateExtension(X,q)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ie){v.onUnexpectedError(ie)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ie=[];try{ie=this._myRegistry.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this._deactivate(be))}catch{}await Promise.all(ie)}terminate(ie,de=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ie}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(pe=>{this._logService.error(pe)}),this._extHostContext.dispose();const Y=this._deactivateAll();Promise.race([(0,y.timeout)(5e3),Y]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${de}`):this._logService.info(`Extension host exiting with code ${de}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(de)})}isActivated(ie){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ie):!1}async getExtension(ie){const de=await this._mainThreadExtensionsProxy.$getExtension(ie);let Y;if(de?.browserNlsBundleUris){Y={};for(const pe of Object.keys(de.browserNlsBundleUris))Y[pe]=D.URI.revive(de.browserNlsBundleUris[pe])}return de&&{...de,identifier:new m.ExtensionIdentifier(de.identifier.value),extensionLocation:D.URI.revive(de.extensionLocation),browserNlsBundleUris:Y}}_activateByEvent(ie,de){return this._activator.activateByEvent(ie,de)}_activateById(ie,de){return this._activator.activateById(ie,de)}activateByIdWithErrors(ie,de){return this._activateById(ie,de).then(()=>{const Y=this._activator.getActivatedExtension(ie);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ie=>this._myRegistry)}getExtensionExports(ie){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ie).exports:null}async _realPathExtensionUri(ie){if(ie.scheme!==V.Schemas.file)return ie;const de=await this._hostUtils.realpath(ie.fsPath);return D.URI.file(de)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ie=>new K(ie))),this._extensionPathIndex}async _createExtensionPathIndex(ie){const de=S.TernarySearchTree.forUris(Y=>P.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(ie.map(async Y=>{if(this._getEntryPoint(Y)){const pe=await this._realPathExtensionUri(Y.extensionLocation);de.set(pe,Y)}})),de}_deactivate(ie){let de=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ie))return de;const Y=this._activator.getActivatedExtension(ie);if(!Y)return de;try{typeof Y.module.deactivate=="function"&&(de=Promise.resolve(Y.module.deactivate()).then(void 0,pe=>(this._logService.error(pe),Promise.resolve(void 0))))}catch(pe){this._logService.error(`An error occurred when deactivating the extension '${ie.value}':`),this._logService.error(pe)}try{(0,T.dispose)(Y.subscriptions)}catch(pe){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this._logService.error(pe)}return de}async _activateExtension(ie,de){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ie.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ie.identifier),this._doActivateExtension(ie,de).then(Y=>{const pe=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ie.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,de),this._logExtensionActivationTimes(ie,de,"success",pe),Y},Y=>{throw this._logExtensionActivationTimes(ie,de,"failure"),Y})}_logExtensionActivationTimes(ie,de,Y,pe){const be=z(ie,de);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...be,...pe||{},outcome:Y})}_doActivateExtension(ie,de){const Y=z(ie,de);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const pe=this._getEntryPoint(ie);if(!pe)return Promise.resolve(new _.EmptyExtension(_.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${de.startup}, activationEvent: '${de.activationEvent}'${ie.identifier.value!==de.extensionId.value?`, root cause: ${de.extensionId.value}`:""}`),this._logService.flush();const be=new _.ExtensionActivationTimesBuilder(de.startup);return Promise.all([this._loadCommonJSModule(ie,(0,P.joinPath)(ie.extensionLocation,pe),be),this._loadExtensionContext(ie)]).then(Ce=>(I.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),An._callActivate(this._logService,ie.identifier,Ce[0],Ce[1],be))).then(Ce=>(I.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),Ce))}_loadExtensionContext(ie){const de=new b.ExtensionGlobalMemento(ie,this._storage),Y=new b.ExtensionMemento(ie.identifier.value,!1,this._storage),pe=new H.ExtensionSecrets(ie,this._secretState),be=ie.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Ce=this._initData.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([de.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let We,ne;const ce=(0,g.isProposedApiEnabled)(ie,"ipc")?this._initData.messagePorts?.get(m.ExtensionIdentifier.toKey(ie.identifier)):void 0;return Object.freeze({globalState:de,workspaceState:Y,secrets:pe,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(fe){return t.join(ie.extensionLocation.fsPath,fe)},get storagePath(){return Re._storagePath.workspaceValue(ie)?.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(ie).fsPath},get logPath(){return t.join(Re._initData.logsLocation.fsPath,ie.identifier.value)},get logUri(){return D.URI.joinPath(Re._initData.logsLocation,ie.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(ie)},get globalStorageUri(){return Re._storagePath.globalValue(ie)},get extensionMode(){return be},get extension(){return We===void 0&&(We=new j(Re,ie.identifier,ie,Ce,!1)),We},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(ie,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!ne){if(!ce)return;const fe=C.Event.buffer(C.Event.fromDOMEventEmitter(ce,"message",J=>J.data));ce.start(),ne={onDidReceiveMessage:fe,postMessage:ce.postMessage.bind(ce)}}return ne}})})}static _callActivate(ie,de,Y,pe,be){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(ie,de,Y,pe,be).then(Ce=>new _.ActivatedExtension(!1,null,be.build(),Y,Ce,pe.subscriptions))}static _callActivateOptional(ie,de,Y,pe,be){if(typeof Y.activate=="function")try{be.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${de.value}`);const Ce=typeof global=="object"?global:self,Re=Y.activate.apply(Ce,[pe]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(Re).then(We=>(be.activateResolveStop(),We))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(Y)}_activateOneStartupFinished(ie,de){this._activateById(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:de}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const ie of this._myRegistry.getAllExtensionDescriptions())if(ie.activationEvents)for(const de of ie.activationEvents)de==="onStartupFinished"&&this._activateOneStartupFinished(ie,de)}_handleEagerExtensions(){const ie=this._activateByEvent("*",!0).then(void 0,be=>{this._logService.error(be)});this._register(this._extHostWorkspace.onDidChangeWorkspace(be=>this._handleWorkspaceContainsEagerExtensions(be.added)));const de=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(de),pe=Promise.all([ie,Y]).then(()=>{});return Promise.race([pe,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),pe}_handleWorkspaceContainsEagerExtensions(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(de=>this._handleWorkspaceContainsEagerExtension(ie,de))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ie,de){if(this.isActivated(de.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,pe={logService:this._logService,folders:ie.map(Ce=>Ce.uri),forceUsingSearch:Y,exists:Ce=>this._hostUtils.exists(Ce.fsPath),checkExists:(Ce,Re,We)=>this._mainThreadWorkspaceProxy.$checkExists(Ce,Re,We)},be=await(0,R.checkActivateWorkspaceContainsExtension)(pe,de);if(!!be)return this._activateById(de.identifier,{startup:!0,extensionId:de.identifier,activationEvent:be.activationEvent}).then(void 0,Ce=>this._logService.error(Ce))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ie){throw console.error(ie),ie}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:de}=this._initData.environment;if(!ie||!de)throw new Error(c.localize(0,null));const Y=await this._loadCommonJSModule(null,de,new _.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(c.localize(1,null,de.toString()));return new Promise((pe,be)=>{const Ce=(ne,ce)=>{ne?be(ne):pe(typeof ce=="number"&&ce>0?1:0)},Re=(0,P.originalFSPath)(de),We=Y.run(Re,Ce);We&&We.then&&We.then(()=>{pe(0)}).catch(ne=>{be(ne instanceof Error&&ne.stack?ne.stack:String(ne))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,de){return this._resolvers[ie]=de,(0,T.toDisposable)(()=>{delete this._resolvers[ie]})}async _activateAndGetResolver(ie){const de=ie.indexOf("+");if(de===-1)throw new Error("Not an authority that can be resolved!");const Y=ie.substr(0,de);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(ie,de){this._logService.info(`$resolveAuthority invoked for authority (${Q(ie)})`);const{authorityPrefix:Y,resolver:pe}=await this._activateAndGetResolver(ie);if(!pe)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(pe)),I.mark(`code/extHost/willResolveAuthority/${Y}`);const be=await pe.resolve(ie,{resolveAttempt:de});I.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const Ce={authority:ie,host:be.host,port:be.port,connectionToken:be.connectionToken},Re={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Ce,options:Re,tunnelInformation:{environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures}}}}catch(be){if(I.mark(`code/extHost/didResolveAuthorityError/${Y}`),be instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:be._code,message:be._message,detail:be._detail}};throw be}}async $getCanonicalURI(ie,de){this._logService.info(`$getCanonicalURI invoked for authority (${Q(ie)})`);const{resolver:Y}=await this._activateAndGetResolver(ie);if(!Y)return null;const pe=D.URI.revive(de);if(typeof Y.getCanonicalURI>"u")return pe;const be=await(0,y.asPromise)(()=>Y.getCanonicalURI(pe));return be||pe}static _applyExtensionsDelta(ie,de,Y){const pe=new h.ExtensionDescriptionRegistry(ie.getAllExtensionDescriptions());pe.deltaExtensions(Y.toAdd,Y.toRemove);const be=(0,g.extensionIdentifiersArrayToSet)(de.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of Y.myToRemove)be.delete(m.ExtensionIdentifier.toKey(Re));for(const Re of Y.myToAdd)be.add(m.ExtensionIdentifier.toKey(Re));const Ce=x(pe,be);return{globalRegistry:pe,myExtensions:Ce}}$startExtensionHost(ie){ie.toAdd.forEach(pe=>pe.extensionLocation=D.URI.revive(pe.extensionLocation));const{globalRegistry:de,myExtensions:Y}=An._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ie);return this._globalRegistry.set(de.getAllExtensionDescriptions()),this._myRegistry.set(Y),this._startExtensionHost()}$activateByEvent(ie,de){return de===1?this._activateByEvent(ie,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(ie,!1))}async $activate(ie,de){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ie)?(await this._activateById(ie,de),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(Ce=>Ce.extensionLocation=D.URI.revive(Ce.extensionLocation));const{globalRegistry:de,myExtensions:Y}=An._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ie),pe=await this._createExtensionPathIndex(Y);return(await this.getExtensionPathIndex()).setSearchTree(pe),this._globalRegistry.set(de.getAllExtensionDescriptions()),this._myRegistry.set(Y),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const de=r.VSBuffer.alloc(ie),Y=Math.random()%256;for(let pe=0;pe<ie;pe++)de.writeUInt8(Y,pe);return de}async $updateRemoteConnectionData(ie){this._remoteConnectionData=ie,this._onDidChangeRemoteConnectionData.fire()}};N=Ve([ze(0,o.IInstantiationService),ze(1,e.IHostUtils),ze(2,d.IExtHostRpcService),ze(3,f.IExtHostWorkspace),ze(4,E.IExtHostConfiguration),ze(5,A.ILogService),ze(6,l.IExtHostInitDataService),ze(7,a.IExtensionStoragePaths),ze(8,i.IExtHostTunnelService),ze(9,p.IExtHostTerminalService),ze(10,L.IExtHostLocalizationService)],N),e.AbstractExtHostExtensionService=N;function z(le,ie){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class j{constructor(ie,de,Y,pe,be){M.set(this,void 0),F.set(this,void 0),B.set(this,void 0),Ze(this,M,ie,"f"),Ze(this,F,de,"f"),Ze(this,B,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=pe,this.isFromDifferentExtensionHost=be}get isActive(){return Me(this,M,"f").isActivated(Me(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Me(this,M,"f").getExtensionExports(Me(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Me(this,M,"f").activateByIdWithErrors(Me(this,B,"f"),{startup:!1,extensionId:Me(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=j,M=new WeakMap,F=new WeakMap,B=new WeakMap;function x(le,ie){return le.getAllExtensionDescriptions().filter(de=>ie.has(m.ExtensionIdentifier.toKey(de.identifier)))}function Q(le){const ie=le.indexOf("+");return ie===-1?le:le.substring(0,ie)}class K{constructor(ie){this._searchTree=ie}setSearchTree(ie){this._searchTree=ie}findSubstr(ie){return this._searchTree.findSubstr(ie)}forEach(ie){return this._searchTree.forEach(ie)}}e.ExtensionPaths=K}),define(_e[286],ye([1,0,74,2,5,34,27,26,16,25,3,41,36,13,8]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(b,s,u,o,l,a,d){this._apiFactory=b,this._extensionRegistry=s,this._instaService=u,this._extHostConfiguration=o,this._extHostExtensionService=l,this._initData=a,this._logService=d,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const b=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,s,this._extensionRegistry,b,this._logService)),this.register(this._instaService.createInstance(v,s)),this.register(this._instaService.createInstance(g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,s,this._initData.environment.appUriScheme))}register(b){if("nodeModuleName"in b)if(Array.isArray(b.nodeModuleName))for(const s of b.nodeModuleName)this._factories.set(s,b);else this._factories.set(b.nodeModuleName,b);typeof b.alternativeModuleName=="function"&&this._alternatives.push(s=>b.alternativeModuleName(s))}};f=Ve([ze(2,A.IInstantiationService),ze(3,P.IExtHostConfiguration),ze(4,k.IExtHostExtensionService),ze(5,D.IExtHostInitDataService),ze(6,_.ILogService)],f),e.RequireInterceptor=f;let g=class Yn{constructor(b){if(b.environment.appRoot&&Yn.aliased.size){const s=(0,w.escapeRegExpCharacters)(this.forceForwardSlashes(b.environment.appRoot.fsPath)),u="[a-z0-9_.-]",o=`@${u}+\\/${u}+|${u}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${s}/${l}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(b){if(!this.re)return;const s=this.re.exec(this.forceForwardSlashes(b));if(!s)return;const[,u,o,l]=s,a=Yn.aliased.get(o);if(a!==void 0)return console.warn(`${o} as been renamed to ${a}, please update your imports`),u+a+l}forceForwardSlashes(b){return b.replace(/\\/g,"/")}};g.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),g=Ve([ze(0,D.IExtHostInitDataService)],g);class h{constructor(b,s,u,o,l){this._apiFactory=b,this._extensionPaths=s,this._extensionRegistry=u,this._configProvider=o,this._logService=l,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(b,s){const u=this._extensionPaths.findSubstr(s);if(u){let o=this._extApiImpl.get(T.ExtensionIdentifier.toKey(u.identifier));return o||(o=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(T.ExtensionIdentifier.toKey(u.identifier),o)),o}if(!this._defaultApiImpl){let o="";this._extensionPaths.forEach((l,a)=>o+=`	${a} -> ${l.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${o}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(b,s,u){this._extensionPaths=b,this.nodeModuleName="keytar",this._mainThreadTelemetry=s.getProxy(I.MainContext.MainThreadTelemetry);const{environment:o}=u,l=s.getProxy(I.MainContext.MainThreadKeytar);if(o.appRoot){let a=o.appRoot.fsPath;E.platform==="win32"&&(a=a.replace(/\\/g,"/")),a[a.length-1]==="/"&&(a=a.substr(0,a.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${a}/node_modules.asar/keytar`),this.alternativeNames.add(`${a}/node_modules/keytar`)}this._impl={getPassword:(a,d)=>l.$getPassword(a,d),setPassword:(a,d,n)=>l.$setPassword(a,d,n),deletePassword:(a,d)=>l.$deletePassword(a,d),findPassword:a=>l.$findPassword(a),findCredentials(a){return l.$findCredentials(a)}}}load(b,s){const u=this._extensionPaths.findSubstr(s);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(b){const s=b.length;if(s<=7||!this.alternativeNames)return;const u=s-7;if((b.charAt(u)==="/"||b.charAt(u)==="\\")&&b.endsWith("keytar")&&(b=b.replace(/\\/g,"/"),this.alternativeNames.has(b)))return"keytar"}};v=Ve([ze(1,S.IExtHostRpcService),ze(2,D.IExtHostInitDataService)],v);let m=class{constructor(b,s,u){this._extensionPaths=b,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(I.MainContext.MainThreadTelemetry);const o=u.getProxy(I.MainContext.MainThreadWindow);this._impl=(l,a)=>{const d=t.URI.parse(l);return a?this.callOriginal(l,a):d.scheme==="http"||d.scheme==="https"?o.$openUri(d,l,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this._appUriScheme?o.$openUri(d,l,{}):this.callOriginal(l,a)}}load(b,s,u){const o=this._extensionPaths.findSubstr(s);return o&&(this._extensionId=o.identifier.value,this.sendShimmingTelemetry()),this._original=u(b),this._impl}callOriginal(b,s){return this.sendNoForwardTelemetry(),this._original(b,s)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=Ve([ze(2,S.IExtHostRpcService)],m)}),define(_e[47],ye([1,0,79,6,9,36,3,58,59,41,7,33,223,34]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,y.createDecorator)("IExtHostVariableResolverProvider");class w extends E.AbstractVariableResolverService{constructor(h,v,m,r,b,s,u){function o(){if(m){const l=m.activeEditor();if(l)return l.document.uri;const a=r.tabGroups.all.find(d=>d.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof A.TextDiffTabInput||a.input instanceof A.NotebookDiffEditorTabInput)return a.input.modified;if(a.input instanceof A.TextTabInput||a.input instanceof A.NotebookEditorTabInput||a.input instanceof A.CustomEditorTabInput)return a.input.uri}}}super({getFolderUri:l=>{const a=s.folders.filter(d=>d.name===l);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(l,a)=>b.getConfiguration(void 0,l).get(a),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=o();if(l)return I.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const l=o();if(l){const a=v.getWorkspaceFolder(l);if(a)return I.normalize(a.uri.fsPath)}}},getSelectedText:()=>{if(m){const l=m.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(m){const l=m.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>h.getExtension(l)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(P.env))}}let f=class extends t.Disposable{constructor(h,v,m,r,b){super(),this.extensionService=h,this.workspaceService=v,this.editorService=m,this.configurationService=r,this.editorTabs=b,this._resolver=new c.Lazy(async()=>{const s=await this.configurationService.getConfigProvider(),o={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async l=>{o.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new w(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,s,o,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};f=Ve([ze(0,D.IExtHostExtensionService),ze(1,k.IExtHostWorkspace),ze(2,T.IExtHostDocumentsAndEditors),ze(3,_.IExtHostConfiguration),ze(4,S.IExtHostEditorTabs)],f),e.ExtHostVariableResolverProviderService=f}),define(_e[75],ye([1,0,18,4,11,2,3,5,59,41,16,7,33,130,216,34,47]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(o,l,a,d,n,i){this._workspaceService=l,this._extensionService=a,this._configurationService=d,this._editorTabs=n,this._variableResolver=i,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new t.Emitter,this._onDidTerminateDebugSession=new t.Emitter,this._onDidChangeActiveDebugSession=new t.Emitter,this._onDidReceiveDebugSessionCustomEvent=new t.Emitter,this._debugServiceProxy=o.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new t.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new m(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(p=>{p.onDidChange(C=>{this.registerAllDebugTypes(p)}),this.registerAllDebugTypes(p)})}asDebugSourceUri(o,l){const a=o;if(typeof a.sourceReference=="number"&&a.sourceReference>0){let d=`debug:${encodeURIComponent(a.path||"")}`,n="?";return l&&(d+=`${n}session=${encodeURIComponent(l.id)}`,n="&"),d+=`${n}ref=${a.sourceReference}`,P.URI.parse(d)}else{if(a.path)return P.URI.file(a.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const l=[];for(const a of o.getAllExtensionDescriptions())if(a.contributes){const d=a.contributes.debuggers;if(d&&d.length>0)for(const n of d)(0,w.isDebuggerMainContribution)(n)&&l.push(n.type)}this._debugServiceProxy.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(l=>o.push(l)),o}addBreakpoints(o){this.startBreakpoints();const l=o.filter(n=>{const i=n.id;return this._breakpoints.has(i)?!1:(this._breakpoints.set(i,n),!0)});this.fireBreakpointChanges(l,[],[]);const a=[],d=new Map;for(const n of l)if(n instanceof k.SourceBreakpoint){let i=d.get(n.location.uri.toString());i||(i={type:"sourceMulti",uri:n.location.uri,lines:[]},d.set(n.location.uri.toString(),i),a.push(i)),i.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof k.FunctionBreakpoint&&a.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this._debugServiceProxy.$registerBreakpoints(a)}removeBreakpoints(o){this.startBreakpoints();const l=o.filter(i=>this._breakpoints.delete(i.id));this.fireBreakpointChanges([],l,[]);const a=l.filter(i=>i instanceof k.SourceBreakpoint).map(i=>i.id),d=l.filter(i=>i instanceof k.FunctionBreakpoint).map(i=>i.id),n=l.filter(i=>i instanceof k.DataBreakpoint).map(i=>i.id);return this._debugServiceProxy.$unregisterBreakpoints(a,d,n)}startDebugging(o,l,a){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,l,{parentSessionID:a.parentSession?a.parentSession.id:void 0,lifecycleManagedByParent:a.lifecycleManagedByParent,repl:a.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:a.noDebug,compact:a.compact,suppressSaveBeforeStart:a.suppressSaveBeforeStart,suppressDebugStatusbar:a.suppressDebugStatusbar??a.debugUI?.simple,suppressDebugToolbar:a.suppressDebugToolbar??a.debugUI?.simple,suppressDebugView:a.suppressDebugView??a.debugUI?.simple})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,l,a){if(!l)return new k.Disposable(()=>{});const d=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:d,provider:l}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,a,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,d),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(n=>n.provider!==l),this._debugServiceProxy.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(o,l,a){if(!a)return new k.Disposable(()=>{});if(!this.definesDebugType(o,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.getAdapterDescriptorFactoryByType(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:l,handle:d,factory:a}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(l,d),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(n=>n.factory!==a),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(o,l){if(!l)return new k.Disposable(()=>{});const a=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:a,factory:l}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(d=>d.factory!==l)})}async $runInTerminal(o,l){return Promise.resolve(void 0)}async $substituteVariables(o,l){let a;const d=await this.getFolder(o);return d&&(a={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(a,l)}createDebugAdapter(o,l){if(o.type==="implementation")return new b(o.implementation)}createSignService(){}async $startDASession(o,l){const a=this,d=await this.getSession(l);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(d.type),d).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const i=this.convertToDto(n),p=this.createDebugAdapter(i,d);if(!p)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const C=p;return this._debugAdapters.set(o,C),this.getDebugAdapterTrackers(d).then(R=>(R&&this._debugAdaptersTrackers.set(o,R),C.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const H=U,V={type:"response",seq:0,command:H.command,request_seq:H.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(H.arguments.value);V.body={signature:L},C.sendResponse(V)}else throw new Error("no signer")}catch(L){V.success=!1,V.message=L.message,C.sendResponse(V)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(U),U=(0,w.convertToVSCPaths)(U,!0),a._debugServiceProxy.$acceptDAMessage(o,U)}),C.onError(U=>{R&&R.onError&&R.onError(U),this._debugServiceProxy.$acceptDAError(o,U.name,U.message,U.stack)}),C.onExit(U=>{R&&R.onExit&&R.onExit((0,I.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,I.withNullAsUndefined)(U),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),C.startSession()))})}$sendDAMessage(o,l){l=(0,w.convertToDAPaths)(l,!1);const a=this._debugAdaptersTrackers.get(o);a&&a.onWillReceiveMessage&&a.onWillReceiveMessage(l),this._debugAdapters.get(o)?.sendMessage(l)}$stopDASession(o){const l=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),l&&l.onWillStopSession&&l.onWillStopSession();const a=this._debugAdapters.get(o);return this._debugAdapters.delete(o),a?a.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const l=[],a=[],d=[];if(o.added)for(const n of o.added){const i=n.id;if(i&&!this._breakpoints.has(i)){let p;if(n.type==="function")p=new k.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")p=new k.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const C=P.URI.revive(n.uri);p=new k.SourceBreakpoint(new k.Location(C,new k.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}p._id=i,this._breakpoints.set(i,p),l.push(p)}}if(o.removed)for(const n of o.removed){const i=this._breakpoints.get(n);i&&(this._breakpoints.delete(n),a.push(i))}if(o.changed){for(const n of o.changed)if(n.id){const i=this._breakpoints.get(n.id);if(i){if(i instanceof k.FunctionBreakpoint&&n.type==="function"){const p=i;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.functionName=n.functionName}else if(i instanceof k.SourceBreakpoint&&n.type==="source"){const p=i;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.location=new k.Location(P.URI.revive(n.uri),new k.Position(n.line,n.character))}d.push(i)}}}this.fireBreakpointChanges(l,a,d)}$provideDebugConfigurations(o,l,a){return(0,c.asPromise)(async()=>{const d=this.getConfigProviderByHandle(o);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.getFolder(l);return d.provideDebugConfigurations(n,a)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(o,l,a,d){return(0,c.asPromise)(async()=>{const n=this.getConfigProviderByHandle(o);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const i=await this.getFolder(l);return n.resolveDebugConfiguration(i,a,d)})}$resolveDebugConfigurationWithSubstitutedVariables(o,l,a,d){return(0,c.asPromise)(async()=>{const n=this.getConfigProviderByHandle(o);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const i=await this.getFolder(l);return n.resolveDebugConfigurationWithSubstitutedVariables(i,a,d)})}async $provideDebugAdapter(o,l){const a=this.getAdapterDescriptorFactoryByHandle(o);if(!a)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.getSession(l);return this.getAdapterDescriptor(a,d).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.convertToDto(n)})}async $acceptDebugSessionStarted(o){const l=await this.getSession(o);this._onDidStartDebugSession.fire(l)}async $acceptDebugSessionTerminated(o){const l=await this.getSession(o);l&&(this._onDidTerminateDebugSession.fire(l),this._debugSessions.delete(l.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,l){(await this.getSession(o))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(o,l){const d={session:await this.getSession(o),event:l.event,body:l.body};this._onDidReceiveDebugSessionCustomEvent.fire(d)}convertToDto(o){if(o instanceof k.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof k.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const l=this._adapterFactories.filter(a=>a.type===o);if(l.length>0)return l[0].factory}getAdapterDescriptorFactoryByHandle(o){const l=this._adapterFactories.filter(a=>a.handle===o);if(l.length>0)return l[0].factory}getConfigProviderByHandle(o){const l=this._configProviders.filter(a=>a.handle===o);if(l.length>0)return l[0].provider}definesDebugType(o,l){if(o.contributes){const a=o.contributes.debuggers;if(a&&a.length>0){for(const d of a)if(d.label&&d.type&&d.type===l)return!0}}return!1}getDebugAdapterTrackers(o){const a=o.configuration.type,d=this._trackerFactories.filter(n=>n.type===a||n.type==="*").map(n=>(0,c.asPromise)(()=>n.factory.createDebugAdapterTracker(o)).then(i=>i,i=>null));return Promise.race([Promise.all(d).then(n=>{const i=n.filter(p=>!!p);if(i.length>0)return new r(i)}),new Promise((n,i)=>{const p=setTimeout(()=>{clearTimeout(p),i(new Error("timeout"))},1e3)})]).catch(n=>{})}async getAdapterDescriptor(o,l){const a=l.configuration.debugServer;if(typeof a=="number")return Promise.resolve(new k.DebugAdapterServer(a));if(o){const n=await this._extensionService.getExtensionRegistry();return(0,c.asPromise)(()=>o.createDebugAdapterDescriptor(l,this.daExecutableFromPackage(l,n))).then(i=>{if(i)return i})}const d=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(l,d))}daExecutableFromPackage(o,l){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,l,a){(o.length>0||l.length>0||a.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:l,changed:a}))}async getSession(o){if(o)if(typeof o=="string"){const l=this._debugSessions.get(o);if(l)return l}else{let l=this._debugSessions.get(o.id);if(!l){const a=await this.getFolder(o.folderUri),d=o.parent?this._debugSessions.get(o.parent):void 0;l=new v(this._debugServiceProxy,o.id,o.type,o.name,a,o.configuration,d),this._debugSessions.set(l.id,l),this._debugServiceProxy.$sessionCached(l.id)}return l}throw new Error("cannot find session")}getFolder(o){if(o){const l=P.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};h=Ve([ze(0,A.IExtHostRpcService),ze(1,E.IExtHostWorkspace),ze(2,D.IExtHostExtensionService),ze(3,f.IExtHostConfiguration),ze(4,S.IExtHostEditorTabs),ze(5,g.IExtHostVariableResolverProvider)],h),e.ExtHostDebugServiceBase=h;class v{constructor(o,l,a,d,n,i,p){this._debugServiceProxy=o,this._id=l,this._type=a,this._name=d,this._workspaceFolder=n,this._configuration=i,this._parentSession=p}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}get parentSession(){return this._parentSession}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,l){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,l)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=v;class m{constructor(o){this.value=Object.freeze({append(l){o.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=m;class r{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(l=>l.onError?l.onError(o):void 0)}onExit(o,l){this.trackers.forEach(a=>a.onExit?a.onExit(o,l):void 0)}}class b extends _.AbstractDebugAdapter{constructor(o){super(),this.implementation=o,o.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends h{constructor(o,l,a,d,n,i){super(o,l,a,d,n,i)}};s=Ve([ze(0,A.IExtHostRpcService),ze(1,E.IExtHostWorkspace),ze(2,D.IExtHostExtensionService),ze(3,f.IExtHostConfiguration),ze(4,S.IExtHostEditorTabs),ze(5,g.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(_e[287],ye([1,0,10,74,2,5,279,13,84,85,25,194,16,55,41,93]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class g{static async installEarlyHandler(m){const r=m.get(T.ILogService),s=m.get(E.IExtHostRpcService).getProxy(P.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(u=>{r.error(u);const o=c.transformErrorForSerialization(u);s.$onUnexpectedError(o)})}static async installFullHandler(m){const r=m.get(T.ILogService),b=m.get(E.IExtHostRpcService),s=m.get(w.IExtHostExtensionService),u=m.get(f.IExtHostTelemetry),o=b.getProxy(P.MainContext.MainThreadExtensionService),l=b.getProxy(P.MainContext.MainThreadErrors),a=await s.getExtensionPathIndex(),d=new WeakMap;Error.prepareStackTrace=(n,i)=>{let p="",C,R;for(const U of i)p+=`
	at ${U.toString()}`,R=U.getFileName(),!C&&R&&(C=a.findSubstr(I.URI.file(R)));return d.set(n,C?.identifier),`${n.name||"Error"}: ${n.message||""}${p}`},c.setUnexpectedErrorHandler(n=>{r.error(n);const i=c.transformErrorForSerialization(n),p=d.get(n);if(!p){l.$onUnexpectedError(i);return}o.$onExtensionRuntimeError(p,i);const C=u.onExtensionError(p,n);r.trace("forwarded error to extension?",C,p)})}}Error.stackTraceLimit=100;class h{constructor(m,r,b,s,u){this._hostUtils=b,this._rpcProtocol=new y.RPCProtocol(m,null,s),r=h._transform(r,this._rpcProtocol);const o=new D.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());o.set(A.IExtHostInitDataService,{_serviceBrand:void 0,...r,messagePorts:u}),o.set(E.IExtHostRpcService,new E.ExtHostRpcService(this._rpcProtocol)),o.set(_.IURITransformerService,new _.URITransformerService(s)),o.set(w.IHostUtils,b);const l=new k.InstantiationService(o,!0);l.invokeFunction(g.installEarlyHandler),this._logService=l.invokeFunction(a=>a.get(T.ILogService)),t.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",r),this._extensionService=l.invokeFunction(a=>a.get(w.IExtHostExtensionService)),this._extensionService.initialize(),l.invokeFunction(g.installFullHandler)}async asBrowserUri(m){const r=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return I.URI.revive(await r.$asBrowserUri(m))}terminate(m){this._extensionService.terminate(m)}static _transform(m,r){m.allExtensions.forEach(s=>{s.extensionLocation=I.URI.revive(r.transformIncomingURIs(s.extensionLocation));const u={};s.browserNlsBundleUris&&(Object.keys(s.browserNlsBundleUris).forEach(o=>u[o]=I.URI.revive(r.transformIncomingURIs(s.browserNlsBundleUris[o]))),s.browserNlsBundleUris=u)}),m.environment.appRoot=I.URI.revive(r.transformIncomingURIs(m.environment.appRoot));const b=m.environment.extensionDevelopmentLocationURI;return b&&(m.environment.extensionDevelopmentLocationURI=b.map(s=>I.URI.revive(r.transformIncomingURIs(s)))),m.environment.extensionTestsLocationURI=I.URI.revive(r.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=I.URI.revive(r.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=I.URI.revive(r.transformIncomingURIs(m.environment.workspaceStorageHome)),m.environment.extensionTelemetryLogResource=I.URI.revive(r.transformIncomingURIs(m.environment.extensionTelemetryLogResource)),m.nlsBaseUrl=I.URI.revive(r.transformIncomingURIs(m.nlsBaseUrl)),m.logsLocation=I.URI.revive(r.transformIncomingURIs(m.logsLocation)),m.logFile=I.URI.revive(r.transformIncomingURIs(m.logFile)),m.workspace=r.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=h}),define(_e[288],ye([1,0,18,12,178,193,201,75,59,41,16,40,7,47,33,217,219,34]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let v=class extends T.ExtHostDebugServiceBase{constructor(u,o,l,a,d,n,i){super(u,o,l,a,n,i),this._terminalService=d,this._integratedTerminalInstances=new b}createDebugAdapter(u,o){switch(u.type){case"server":return new f.SocketDebugAdapter(u);case"pipeServer":return new f.NamedPipeDebugAdapter(u);case"executable":return new f.ExecutableDebugAdapter(u,o.type)}return super.createDebugAdapter(u,o)}daExecutableFromPackage(u,o){const l=f.ExecutableDebugAdapter.platformAdapterExecutable(o.getAllExtensionDescriptions(),u.type);if(l)return new E.DebugAdapterExecutable(l.command,l.args,l.options)}createSignService(){return new y.SignService}async $runInTerminal(u,o){if(u.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const l=await this._configurationService.getConfigProvider(),a=this._terminalService.getDefaultShell(!0),d=this._terminalService.getDefaultShellArgs(!0),n=u.title||I.localize(0,null),i=JSON.stringify({shell:a,shellArgs:d});let p=await this._integratedTerminalInstances.checkout(i,n),C,R=!1;if(p)C=u.cwd;else{const L={shellPath:a,shellArgs:d,cwd:u.cwd,name:n,iconPath:new E.ThemeIcon("debug")};R=!0,p=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(p,i)}p.show(!0);const U=await p.processId;R?await new Promise(L=>setTimeout(L,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?p.sendText("cls"):a.indexOf("bash")>=0?p.sendText("clear"):t.isWindows?p.sendText("cls"):p.sendText("clear"));const H=(0,g.prepareCommand)(a,u.args,!!u.argsCanBeInterpretedByShell,C,u.env);p.sendText(H);const V=this.onDidTerminateDebugSession(L=>{L.id===o&&(this._integratedTerminalInstances.free(p),V.dispose())});return U}else if(u.kind==="external")return r(u,await this._configurationService.getConfigProvider());return super.$runInTerminal(u,o)}};v=Ve([ze(0,A.IExtHostRpcService),ze(1,w.IExtHostWorkspace),ze(2,D.IExtHostExtensionService),ze(3,h.IExtHostConfiguration),ze(4,k.IExtHostTerminalService),ze(5,S.IExtHostEditorTabs),ze(6,_.IExtHostVariableResolverProvider)],v),e.ExtHostDebugService=v;let m;function r(s,u){if(!m)if(t.isWindows)m=new P.WindowsExternalTerminalService;else if(t.isMacintosh)m=new P.MacExternalTerminalService;else if(t.isLinux)m=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const o=u.getConfiguration("terminal");return m.runInTerminal(s.title,s.cwd,s.args,s.env||{},o.external||{})}class b{constructor(){this._terminalInstances=new Map}async checkout(u,o){const a=[...this._terminalInstances.entries()].map(([d,n])=>(0,c.createCancelablePromise)(async i=>{if(d.name!==o||n.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await d.processId))return null;const p=Date.now();return n.lastUsedAt+b.minUseDelay>p||i.isCancellationRequested||n.config!==u?null:(n.lastUsedAt=p,d)}));return await(0,c.firstParallel)(a,d=>!!d)}insert(u,o){this._terminalInstances.set(u,{lastUsedAt:Date.now(),config:o})}free(u){const o=this._terminalInstances.get(u);o&&(o.lastUsedAt=-1)}onTerminalClosed(u){this._terminalInstances.delete(u)}}b.minUseDelay=1e3}),define(_e[289],ye([1,0,9,2,114,33,58,34,45,40,16,25,73,14,13,68,22,83,47]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let m=class extends E.ExtHostTaskBase{constructor(b,s,u,o,l,a,d,n,i){super(b,s,u,o,l,a,d,n),this.workspaceService=u,this.variableResolver=i,s.remote.isRemote&&s.remote.authority?this.registerTaskSystem(_.Schemas.vscodeRemote,{scheme:_.Schemas.vscodeRemote,authority:s.remote.authority,platform:process.platform}):this.registerTaskSystem(_.Schemas.file,{scheme:_.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(b,s){const u=s;if(!s.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const o=E.TaskHandleDTO.from(u,this.workspaceService),l=await this._proxy.$getTaskExecution(o);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.getTaskExecution(l,s);return this._proxy.$executeTask(o).catch(()=>{}),a}else{const o=E.TaskDTO.from(s,b);if(o===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(o.execution)&&await this.addCustomExecution(o,s,!1);const l=await this.getTaskExecution(await this._proxy.$getTaskExecution(o),s);return this._proxy.$executeTask(o).catch(()=>{}),l}}provideTasksInternal(b,s,u,o){const l=[];if(o)for(const a of o){this.checkDeprecation(a,u),(!a.definition||!b[a.definition.type])&&this._logService.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const d=E.TaskDTO.from(a,u.extension);d&&(l.push(d),E.CustomExecutionDTO.is(d.execution)&&s.push(this.addCustomExecution(d,a,!0)))}return{tasks:l,extension:u.extension}}async resolveTaskInternal(b){return b}async getAFolder(b){let s=b&&b.length>0?b[0]:void 0;if(!s){const u=t.URI.file((0,h.homedir)());s=new S.WorkspaceFolder({uri:u,name:g.basename(u),index:0})}return{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(b,s){const u=t.URI.revive(b),o={process:void 0,variables:Object.create(null)},l=await this._workspaceProvider.resolveWorkspaceFolder(u),a=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.variableResolver.getResolver(),n=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(a);for(const i of s.variables)o.variables[i]=await d.resolveAsync(n,i);if(s.process!==void 0){let i;if(s.process.path!==void 0){i=s.process.path.split(c.delimiter);for(let p=0;p<i.length;p++)i[p]=await d.resolveAsync(n,i[p])}o.process=await I.win32.findExecutable(await d.resolveAsync(n,s.process.name),s.process.cwd!==void 0?await d.resolveAsync(n,s.process.cwd):void 0,i)}return o}async $jsonTasksSupported(){return!0}async $findExecutable(b,s,u){return I.win32.findExecutable(b,s,u)}};m=Ve([ze(0,A.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,P.IExtHostWorkspace),ze(3,y.IExtHostDocumentsAndEditors),ze(4,T.IExtHostConfiguration),ze(5,D.IExtHostTerminalService),ze(6,w.ILogService),ze(7,f.IExtHostApiDeprecationService),ze(8,v.IExtHostVariableResolverProvider)],m),e.ExtHostTask=m}),define(_e[290],ye([1,0,83,47]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class I extends t.ExtHostVariableResolverProviderService{homeDir(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=I}),define(_e[141],ye([1,0,17,18,21,50,14,9,22,2,30]),function(Z,e,c,t,I,P,y,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(v,m,r,b){this.query=v,this.provider=m,this.fileUtils=r,this.processType=b,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,m){const r=this.query.folderQueries||[],b=new I.CancellationTokenSource;return m.onCancellationRequested(()=>b.cancel()),new Promise((s,u)=>{this.collector=new _(v);let o=!1;const l=(a,d)=>{if(!o&&!this.isLimitHit){const n=this.resultSize(a);f(a)&&typeof this.query.maxResults=="number"&&this.resultCount+n>this.query.maxResults&&(this.isLimitHit=!0,o=!0,b.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const i=this.resultSize(a);this.resultCount+=i,(i>0||!f(a))&&this.collector.add(a,d)}};Promise.all(r.map((a,d)=>this.searchInFolder(a,n=>l(n,d),b.token))).then(a=>{b.dispose(),this.collector.flush();const d=a.some(n=>!!n&&!!n.limitHit);s({limitHit:this.isLimitHit||d,messages:(0,c.flatten)(a.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.processType}})},a=>{b.dispose();const d=(0,P.toErrorMessage)(a);u(new Error(d))})})}resultSize(v){return f(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,m){const r=Array.isArray(v.ranges)?v.ranges:[v.ranges],b=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:r.slice(0,m),preview:{matches:b.slice(0,m),text:v.preview.text},uri:v.uri}}async searchInFolder(v,m,r){const b=new A.QueryGlobTester(this.query,v),s=[],u={report:a=>{if(!this.validateProviderResult(a))return;const d=v.folder.scheme===y.Schemas.file?(0,A.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(S.dirname(a.uri))):void 0,n=S.relativePath(v.folder,a.uri);if(n){const i=b.includedInQuery(n,T.basename(n),d);(0,t.isThenable)(i)?s.push(i.then(p=>{p&&m(a)})):i&&m(a)}}},o=this.getSearchOptionsForFolder(v),l=await this.provider.provideTextSearchResults(E(this.query.contentPattern),o,u,r);return s.length&&await Promise.all(s),l}validateProviderResult(v){if(f(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const m=(0,A.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),r=(0,A.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),b={folder:D.URI.from(v.folder),excludes:r,includes:m,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return b.usePCRE2=this.query.usePCRE2,b}}e.TextSearchManager=k;function E(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class _{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,m=>this.sendItems(m))}add(v,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!S.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(w(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=_;function w(h){return f(h)?{preview:{matches:(0,c.mapArrayOrNot)(h.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:h.preview.text},ranges:(0,c.mapArrayOrNot)(h.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function f(h){return!!h.preview}e.extensionResultIsMatch=f;class g{constructor(v,m){this.maxBatchSize=v,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,m){!v||this.addItemToBatch(v,m)}addItems(v,m){!v||this.addItemsToBatch(v,m)}addItemToBatch(v,m){this.batch.push(v),this.batchSize+=m,this.onUpdate()}addItemsToBatch(v,m){this.batch=this.batch.concat(v),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(_e[76],ye([1,0,6,5,3,283,16,55,13,2,141]),function(Z,e,c,t,I,P,y,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let k=class{constructor(f,g,h){this.extHostRpc=f,this._uriTransformer=g,this._logService=h,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}registerTextSearchProvider(f,g){if(this._textSearchUsedSchemes.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this._textSearchUsedSchemes.add(f);const h=this._handlePool++;return this._textSearchProvider.set(h,g),this._proxy.$registerTextSearchProvider(h,this._transformScheme(f)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(f),this._textSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}registerFileSearchProvider(f,g){if(this._fileSearchUsedSchemes.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this._fileSearchUsedSchemes.add(f);const h=this._handlePool++;return this._fileSearchProvider.set(h,g),this._proxy.$registerFileSearchProvider(h,this._transformScheme(f)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(f),this._fileSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(f,g,h,v){const m=E(h),r=this._fileSearchProvider.get(f);if(r)return this._fileSearchManager.fileSearch(m,r,b=>{this._proxy.$handleFileMatch(f,g,b.map(s=>s.resource))},v);throw new Error("unknown provider: "+f)}$clearCache(f){return this._fileSearchManager.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,g,h,v){const m=this._textSearchProvider.get(f);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const r=E(h);return this.createTextSearchManager(r,m).search(s=>this._proxy.$handleTextMatch(f,g,s),v)}$enableExtensionHostSearch(){}createTextSearchManager(f,g){return new A.TextSearchManager(f,g,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}};k=Ve([ze(0,y.IExtHostRpcService),ze(1,T.IURITransformerService),ze(2,S.ILogService)],k),e.ExtHostSearch=k;function E(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(_),extraFileResources:w.extraFileResources&&w.extraFileResources.map(f=>D.URI.revive(f))}}e.reviveQuery=E;function _(w){return{...w,folder:D.URI.revive(w.folder)}}}),define(_e[291],ye([1,0,84,140,33,137,34,39,58,40,73,75,76,96,54,68,139,69,46,95,93,59,138,13,229,47,94]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h,v,m,r,b,s,u,o,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(a.IExtHostLocalizationService,a.ExtHostLocalizationService,1),(0,c.registerSingleton)(u.ILoggerService,s.ExtHostLoggerService,1),(0,c.registerSingleton)(u.ILogService,o.ExtHostLogService,1),(0,c.registerSingleton)(f.IExtHostApiDeprecationService,f.ExtHostApiDeprecationService,1),(0,c.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands,0),(0,c.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration,0),(0,c.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem,0),(0,c.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,0),(0,c.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations,0),(0,c.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,c.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,0),(0,c.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,c.registerSingleton)(E.IExtHostSearch,E.ExtHostSearch,0),(0,c.registerSingleton)(_.IExtHostStorage,_.ExtHostStorage,0),(0,c.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask,0),(0,c.registerSingleton)(D.IExtHostTerminalService,D.WorkerExtHostTerminalService,0),(0,c.registerSingleton)(w.IExtHostTunnelService,w.ExtHostTunnelService,0),(0,c.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow,0),(0,c.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace,0),(0,c.registerSingleton)(m.IExtHostSecretState,m.ExtHostSecretState,0),(0,c.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry,0),(0,c.registerSingleton)(b.IExtHostEditorTabs,b.ExtHostEditorTabs,0),(0,c.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(_e[97],ye([1,0,17,13,30,72]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=y;function T(k,E,_,w){const f=(0,c.mapArrayOrNot)(_,S),g=new I.TextSearchMatch(E,f,w),h=g.preview.matches;return{ranges:(0,c.mapArrayOrNot)(f,D),uri:k,preview:{text:g.preview.text,matches:(0,c.mapArrayOrNot)(h,D)}}}e.createTextSearchResult=T;function S(k){return new I.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function D(k){return new P.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let A=class{constructor(E,_){this.prefix=E,this.logService=_}appendLine(E){this.logService.debug(`${this.prefix}#search`,E)}};A=Ve([ze(1,t.ILogService)],A),e.OutputChannel=A}),define(_e[292],ye([1,0,44,9,80,32,12,8,97,293]),function(Z,e,c,t,I,P,y,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const A=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(m,r,b,s){const u=E(m,r,b,s),o=r.folder.fsPath;return{cmd:c.spawn(A,u.args,{cwd:o}),rgDiskPath:A,siblingClauses:u.siblingClauses,rgArgs:u,cwd:o}}e.spawnRipgrepCmd=k;function E(m,r,b,s){const u=["--files","--hidden","--case-sensitive"];w([r],b,!1).forEach(l=>{const a=(0,S.anchorGlob)(l);if(u.push("-g",a),y.isMacintosh){const d=(0,I.normalizeNFD)(a);d!==a&&u.push("-g",d)}});const o=_([r],s,void 0,!1);return o.globArgs.forEach(l=>{const a=`!${(0,S.anchorGlob)(l)}`;if(u.push("-g",a),y.isMacintosh){const d=(0,I.normalizeNFD)(a);d!==a&&u.push("-g",d)}}),r.disregardIgnoreFiles!==!1?u.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&u.push("--no-ignore-parent"),r.ignoreSymlinks||u.push("--follow"),m.exists&&u.push("--quiet"),u.push("--no-config"),r.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:o.siblingClauses}}function _(m,r,b,s=!0){const u=[];let o={};return m.forEach(l=>{const a=Object.assign({},l.excludePattern||{},r||{}),d=f(a,s?l.folder.fsPath:void 0,b);u.push(...d.globArgs),d.siblingClauses&&(o=Object.assign(o,d.siblingClauses))}),{globArgs:u,siblingClauses:o}}e.foldersToRgExcludeGlobs=_;function w(m,r,b=!0){const s=[];return m.forEach(u=>{const o=Object.assign({},r||{},u.includePattern||{}),l=f(o,b?u.folder.fsPath:void 0);s.push(...l.globArgs)}),s}e.foldersToIncludeGlobs=w;function f(m,r,b){const s=[],u={};return Object.keys(m).forEach(o=>{if(b&&b.has(o)||!o)return;const l=m[o];o=h(r?g(r,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof l=="boolean"&&l?(o.startsWith("\\\\")&&(o+="**"),s.push(v(o))):l&&l.when&&(u[o]=l)}),{globArgs:s,siblingClauses:u}}function g(m,r){return t.isAbsolute(r)?r:t.join(m,r)}e.getAbsoluteGlob=g;function h(m){return m=T.rtrim(m,"\\"),T.rtrim(m,"/")}function v(m){return P.getRoot(m).toLowerCase()==="c:/"?m.replace(/^c:[/\\]/i,"/"):m}e.fixDriveC=v}),define(_e[294],ye([1,0,44,65,9,295,17,50,37,80,32,12,51,8,11,29,30,292,109]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const m=new Set;process.on("exit",()=>{m.forEach(o=>o())});class r{constructor(l){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=l,this.filePattern=l.filePattern||"",this.includePattern=l.includePattern&&S.parse(l.includePattern),this.maxResults=l.maxResults||null,this.exists=!!l.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,v.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=l.excludePattern&&S.parse(l.excludePattern),this.folderExcludePatterns=new Map,l.folderQueries.forEach(a=>{const d=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),n=a.folder.fsPath;l.folderQueries.map(i=>i.folder.fsPath).filter(i=>i!==n).forEach(i=>{(0,A.isEqualOrParent)(i,n)&&(d[I.relative(n,i)]=!0)}),this.folderExcludePatterns.set(n,new s(d,n))})}cancel(){this.isCanceled=!0,m.forEach(l=>l())}walk(l,a,d,n,i){if(this.fileWalkSW=E.StopWatch.create(!1),this.isCanceled)return i(null,this.isLimitHit);a.forEach(p=>{const C=I.basename(p.fsPath);this.globalExcludePattern&&this.globalExcludePattern(p.fsPath,C)||this.matchFile(d,{relativePath:p.fsPath,searchPath:void 0})}),this.cmdSW=E.StopWatch.create(!1),this.parallel(l,(p,C)=>{this.call(this.cmdTraversal,this,p,d,n,R=>{if(R){const U=(0,T.toErrorMessage)(R);console.error(U),this.errors.push(U),C(R,void 0)}else C(null,void 0)})},(p,C)=>{this.fileWalkSW.stop();const R=p?y.coalesce(p)[0]:null;i(R,this.isLimitHit)})}parallel(l,a,d){const n=new Array(l.length),i=new Array(l.length);let p=!1,C=0;if(l.length===0)return d(null,[]);l.forEach((R,U)=>{a(R,(H,V)=>{if(H?(p=!0,n[U]=null,i[U]=H):(n[U]=V,i[U]=null),++C===l.length)return d(p?i:null,n)})})}call(l,a,...d){try{l.apply(a,d)}catch(n){d[d.length-1](n)}}cmdTraversal(l,a,d,n){const i=l.folder.fsPath,p=k.isMacintosh,C=()=>L&&L.kill();m.add(C);let R=N=>{m.delete(C),R=()=>{},n(N)},U="";const H=this.initDirectoryTree(),V=(0,h.spawnRipgrepCmd)(this.config,l,this.config.includePattern,this.folderExcludePatterns.get(l.folder.fsPath).expression),L=V.cmd,M=!Object.keys(V.siblingClauses).length,F=V.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let B=`${V.rgDiskPath} ${F}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),d({message:B}),this.cmdResultCount=0,this.collectStdout(L,"utf8",d,(N,z,j)=>{if(N){R(N);return}if(this.isLimitHit){R();return}const Q=(U+(p?D.normalizeNFC(z||""):z)).split(`
`);if(j){const K=Q.length;Q[K-1]=Q[K-1].trim(),Q[K-1]||Q.pop()}else U=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=Q.length,M){for(const K of Q)if(this.matchFile(a,{base:i,relativePath:K,searchPath:this.getSearchPath(l,K)}),this.isLimitHit){C();break}(j||this.isLimitHit)&&R();return}this.addDirectoryEntries(l,H,i,Q,a),j&&(this.matchDirectoryTree(H,i,a),R())})}spawnFindCmd(l){const a=this.folderExcludePatterns.get(l.folder.fsPath),d=a.getBasenameTerms(),n=a.getPathTerms(),i=["-L","."];if(d.length||n.length){i.push("-not","(","(");for(const p of d)i.push("-name",p),i.push("-o");for(const p of n)i.push("-path",p),i.push("-o");i.pop(),i.push(")","-prune",")")}return i.push("-type","f"),c.spawn("find",i,{cwd:l.folder.fsPath})}readStdout(l,a,d){let n="";this.collectStdout(l,a,()=>{},(i,p,C)=>{if(i){d(i);return}n+=p,C&&d(null,n)})}collectStdout(l,a,d,n){let i=(R,U,H)=>{(R||H)&&(i=()=>{},this.cmdSW?.stop()),n(R,U,H)},p=!1;l.stdout?(this.forwardData(l.stdout,a,i),l.stdout.once("data",()=>p=!0)):d({message:"stdout is null"});let C;l.stderr?C=this.collectData(l.stderr):d({message:"stderr is null"}),l.on("error",R=>{i(R)}),l.on("close",R=>{let U;!p&&(U=this.decodeData(C,a))&&u(U)?i(new Error(`command failed with error code ${R}: ${this.decodeData(C,a)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),i(null,"",!0))})}forwardData(l,a,d){const n=new P.StringDecoder(a);return l.on("data",i=>{d(null,n.write(i))}),n}collectData(l){const a=[];return l.on("data",d=>{a.push(d)}),a}decodeData(l,a){const d=new P.StringDecoder(a);return l.map(n=>d.write(n)).join("")}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries(l,{pathToEntries:a},d,n,i){n.indexOf(this.filePattern)!==-1&&this.matchFile(i,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(l,this.filePattern)});const p=C=>{const R=I.basename(C),U=I.dirname(C);let H=a[U];H||(H=a[U]=[],p(U)),H.push({base:d,relativePath:C,basename:R,searchPath:this.getSearchPath(l,C)})};n.forEach(p)}matchDirectoryTree({rootEntries:l,pathToEntries:a},d,n){const i=this,p=this.folderExcludePatterns.get(d),C=this.filePattern;function R(U){i.directoriesWalked++;const H=(0,g.hasSiblingFn)(()=>U.map(V=>V.basename));for(let V=0,L=U.length;V<L;V++){const M=U[V],{relativePath:F,basename:B}=M;if(p.test(F,B,C!==B?H:void 0))continue;const N=a[F];if(N)R(N);else{if(i.filesWalked++,F===C)continue;i.matchFile(n,M)}if(i.isLimitHit)break}}R(l)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(l,a,d,n,i){const p=l.folder,C=(0,g.hasSiblingFn)(()=>d);this.parallel(d,(R,U)=>{if(this.isCanceled||this.isLimitHit)return U(null);const H=a?[a,R].join(I.sep):R;if(this.folderExcludePatterns.get(l.folder.fsPath).test(H,R,this.config.filePattern!==R?C:void 0))return U(null);const V=[p.fsPath,H].join(I.sep);t.lstat(V,(L,M)=>{if(L||this.isCanceled||this.isLimitHit)return U(null);this.statLinkIfNeeded(V,M,(F,B)=>F||this.isCanceled||this.isLimitHit?U(null):B.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(V,M,(N,z)=>N||this.isCanceled||this.isLimitHit||(z=z||"",this.walkedPaths[z])?U(null):(this.walkedPaths[z]=!0,f.Promises.readdir(V).then(j=>{if(this.isCanceled||this.isLimitHit)return U(null);this.doWalk(l,H,j,n,x=>U(x||null))},j=>{U(null)})))):(this.filesWalked++,H===this.filePattern||this.maxFilesize&&w.isNumber(B.size)&&B.size>this.maxFilesize||this.matchFile(n,{base:p.fsPath,relativePath:H,searchPath:this.getSearchPath(l,H)}),U(null,void 0)))})},R=>{const U=R&&y.coalesce(R);return i(U&&U.length>0?U[0]:void 0)})}matchFile(l,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,I.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||l(a))}isFileMatch(l){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,g.isFilePatternMatch)(l,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(l,a,d){return a.isSymbolicLink()?t.stat(l,d):d(null,a)}realPathIfNeeded(l,a,d){return a.isSymbolicLink()?t.realpath(l,(n,i)=>n?d(n):d(null,i)):d(null,l)}getSearchPath(l,a){return l.folderName?I.join(l.folderName,a):a}}e.FileWalker=r;class b{constructor(l){this.folderQueries=l.folderQueries,this.extraFiles=l.extraFileResources||[],this.walker=new r(l)}search(l,a,d){this.walker.walk(this.folderQueries,this.extraFiles,l,a,(n,i)=>{d(n,{limitHit:i,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=b;class s{constructor(l,a){this.expression=l,this.root=a,this.init(l)}init(l){let a,d;Object.keys(l).filter(n=>l[n]).forEach(n=>{I.isAbsolute(n)?(a=a||S.getEmptyExpression(),a[n]=l[n]):(d=d||S.getEmptyExpression(),d[n]=l[n])}),this.absoluteParsedExpr=a&&S.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=d&&S.parse(d,{trimForExclusions:!0})}test(l,a,d){return this.relativeParsedExpr&&this.relativeParsedExpr(l,a,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,l),a,d)}getBasenameTerms(){const l=[];return this.absoluteParsedExpr&&l.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&l.push(...S.getBasenameTerms(this.relativeParsedExpr)),l}getPathTerms(){const l=[];return this.absoluteParsedExpr&&l.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&l.push(...S.getPathTerms(this.relativeParsedExpr)),l}}function u(o){const l=o.trim().split(`
`),a=l[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return _.uppercaseFirstLetter(l[l.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=u}),define(_e[296],ye([1,0,100,23]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(o){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(l=>l===o)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,y=512,T=512*8,S=512*128;var D;(function(o){o[o.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(D=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class A extends Error{constructor(l,a){super(l),this.decodeStreamErrorKind=a}}e.DecodeStreamError=A;class k{static async create(l){let a;if(l!==e.UTF8)a=(await new Promise((n,i)=>{Z(["@vscode/iconv-lite-umd"],n,i)})).getDecoder(f(l));else{const d=new TextDecoder;a={write(n){return d.decode(n,{stream:!0})},end(){return d.decode()}}}return new k(a)}constructor(l){this.iconvLiteDecoder=l}write(l){return this.iconvLiteDecoder.write(l)}end(){return this.iconvLiteDecoder.end()}}function E(o,l){const a=l.minBytesRequiredForDetection??l.guessEncoding?T:y;return new Promise((d,n)=>{const i=(0,c.newWriteableStream)(V=>V.join("")),p=[];let C=0,R,U;const H=async()=>{try{const V=await u({buffer:t.VSBuffer.concat(p),bytesRead:C},l.guessEncoding);if(V.seemsBinary&&l.acceptTextOnly)throw new A("Stream is binary but only text is accepted for decoding",1);V.encoding=await l.overwriteEncoding(V.encoding),R=await k.create(V.encoding);const L=R.write(t.VSBuffer.concat(p).buffer);i.write(L),p.length=0,C=0,d({stream:i,detected:V})}catch(V){U?.dispose(),i.destroy(),n(V)}};U=(0,c.listenStream)(o,{onData:async V=>{R?i.write(R.write(V.buffer)):(p.push(V),C+=V.byteLength,C>=a&&(o.pause(),await H(),setTimeout(()=>o.resume())))},onError:V=>i.error(V),onEnd:async()=>{R||await H(),i.end(R?.end())}})})}e.toDecodeStream=E;async function _(o,l,a){const n=(await new Promise((C,R)=>{Z(["@vscode/iconv-lite-umd"],C,R)})).getEncoder(f(l),a);let i=!1,p=!1;return{read(){if(p)return null;const C=o.read();if(typeof C!="string"){if(p=!0,!i&&a?.addBOM)switch(l){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=n.end();return R&&R.length>0?(i=!0,t.VSBuffer.wrap(R)):null}return i=!0,t.VSBuffer.wrap(n.write(C))}}}e.toEncodeReadable=_;async function w(o){return(await new Promise((a,d)=>{Z(["@vscode/iconv-lite-umd"],a,d)})).encodingExists(f(o))}e.encodingExists=w;function f(o){return o===e.UTF8_with_bom||o===null?e.UTF8:o}e.toNodeEncoding=f;function g(o,l){if(!o||l<e.UTF16be_BOM.length)return null;const a=o.readUInt8(0),d=o.readUInt8(1);if(a===e.UTF16be_BOM[0]&&d===e.UTF16be_BOM[1])return e.UTF16be;if(a===e.UTF16le_BOM[0]&&d===e.UTF16le_BOM[1])return e.UTF16le;if(l<e.UTF8_BOM.length)return null;const n=o.readUInt8(2);return a===e.UTF8_BOM[0]&&d===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=g;const h=["ascii","utf-16","utf-32"];async function v(o){const l=await new Promise((p,C)=>{Z(["jschardet"],p,C)}),a=o.slice(0,S),d=b(a.buffer),n=l.detect(d);if(!n||!n.encoding)return null;const i=n.encoding.toLowerCase();return 0<=h.indexOf(i)?null:r(n.encoding)}const m={ibm866:"cp866",big5:"cp950"};function r(o){const l=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return m[l]||l}function b(o){let l="";for(let a=0;a<o.length;a++)l+=String.fromCharCode(o[a]);return l}function s(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=o.match(/windows(\d+)/);return l?"windows-"+l[1]:o}}}e.toCanonicalName=s;function u({buffer:o,bytesRead:l},a){let d=g(o,l),n=!1;if(d!==e.UTF16be&&d!==e.UTF16le&&o){let i=!0,p=!0,C=!1;for(let R=0;R<l&&R<P;R++){const U=R%2===1,H=o.readUInt8(R)===0;if(H&&(C=!0),i&&(U&&!H||!U&&H)&&(i=!1),p&&(U&&H||!U&&!H)&&(p=!1),H&&!i&&!p)break}C&&(i?d=e.UTF16le:p?d=e.UTF16be:n=!0)}return a&&!n&&!d&&o?v(o.slice(0,l)).then(i=>({seemsBinary:!1,encoding:i})):{seemsBinary:n,encoding:d}}e.detectEncodingFromBuffer=u,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(_e[142],ye([1,0,296,29,141]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends I.TextSearchManager{constructor(T,S,D=t,A="searchProcess"){super(T,S,{readdir:k=>D.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,c.toCanonicalName)(k)},A)}}e.NativeTextSearchManager=P}),define(_e[297],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class c{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(I){if(I&&this._dragOperations.has(I)){const P=this._dragOperations.get(I);return this._dragOperations.delete(I),P}}addDragOperationTransfer(I,P){this._dragOperations.set(I,P)}getRenderedTreeElement(I){if(this._renderedElements.has(I))return this._renderedElements.get(I)}addRenderedTreeItemElement(I,P){this._renderedElements.set(I,P)}removeRenderedTreeItemElement(I){this._renderedElements.has(I)&&this._renderedElements.delete(I)}}e.TreeviewsService=c}),define(_e[298],ye([1,0,176,7,22,2,4,6,18,7,11,17,15,21,297,27]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(m,r){if((0,A.isString)(m))return{label:m};if(m&&typeof m=="object"&&typeof m.label=="string"){let b;return Array.isArray(m.highlights)&&(b=m.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),b=b.length?b:void 0),{label:m.label,highlights:b}}}class h{constructor(r,b,s){this._proxy=r,this.commands=b,this.logService=s,this.treeViews=new Map,this.treeDragAndDropService=new w.TreeviewsService;function u(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}b.registerArgumentProcessor({processArgument:o=>u(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(l=>u(l)?this.convertArgument(l):l):o})}registerTreeDataProvider(r,b,s){const u=this.createTreeView(r,{treeDataProvider:b},s);return{dispose:()=>u.dispose()}}createTreeView(r,b,s){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=b.dragAndDropController?.dropMimeTypes??[],o=b.dragAndDropController?.dragMimeTypes??[],l=!!b.dragAndDropController?.handleDrag,a=!!b.dragAndDropController?.handleDrop,d=this.createExtHostTreeView(r,b,s),n=this._proxy.$registerTreeViewDataProvider(r,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,dropMimeTypes:u,dragMimeTypes:o,hasHandleDrag:l,hasHandleDrop:a});return{get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,f.checkProposedApiEnabled)(s,"treeItemCheckbox"),d.onDidChangeCheckboxState},get message(){return d.message},set message(i){d.message=i},get title(){return d.title},set title(i){d.title=i},get description(){return d.description},set description(i){d.description=i},get badge(){return d.badge},set badge(i){i!==void 0&&D.ViewBadge.isViewBadge(i)?d.badge={value:Math.floor(Math.abs(i.value)),tooltip:i.tooltip}:i===void 0&&(d.badge=void 0)},reveal:(i,p)=>d.reveal(i,p),dispose:async()=>{await n,this.treeViews.delete(r),d.dispose()}}}$getChildren(r,b){const s=this.treeViews.get(r);return s?s.getChildren(b):Promise.reject(new Error((0,c.localize)(0,null,r)))}async $handleDrop(r,b,s,u,o,l,a,d){const n=this.treeViews.get(r);if(!n)return Promise.reject(new Error((0,c.localize)(1,null,r)));const i=E.DataTransfer.toDataTransfer(s,async p=>(await this._proxy.$resolveDropFileData(r,b,p)).buffer);return a===r&&d&&await this.addAdditionalTransferItems(i,n,d,o,l),n.onDrop(i,u,o)}async addAdditionalTransferItems(r,b,s,u,o){const l=this.treeDragAndDropService.removeDragOperationTransfer(o);if(l)(await l)?.forEach((a,d)=>{a&&r.set(d,a)});else if(o&&b.handleDrag){const a=b.handleDrag(s,r,u);this.treeDragAndDropService.addDragOperationTransfer(o,a),await a}return r}async $handleDrag(r,b,s,u){const o=this.treeViews.get(r);if(!o)return Promise.reject(new Error((0,c.localize)(2,null,r)));const l=await this.addAdditionalTransferItems(new t.DataTransfer,o,b,u,s);if(!!l)return E.DataTransfer.toDataTransferDTO(l)}async $hasResolve(r){const b=this.treeViews.get(r);if(!b)throw new Error((0,c.localize)(3,null,r));return b.hasResolve}$resolve(r,b,s){const u=this.treeViews.get(r);if(!u)throw new Error((0,c.localize)(4,null,r));return u.resolveTreeItem(b,s)}$setExpanded(r,b,s){const u=this.treeViews.get(r);if(!u)throw new Error((0,c.localize)(5,null,r));u.setExpanded(b,s)}$setSelection(r,b){const s=this.treeViews.get(r);if(!s)throw new Error((0,c.localize)(6,null,r));s.setSelection(b)}$setFocus(r,b){const s=this.treeViews.get(r);if(!s)throw new Error((0,c.localize)(7,null,r));s.setFocus(b)}$setVisible(r,b){const s=this.treeViews.get(r);if(!s)throw new Error((0,c.localize)(8,null,r));s.setVisible(b)}$changeCheckboxState(r,b){const s=this.treeViews.get(r);if(!s)throw new Error((0,c.localize)(9,null,r));s.setCheckboxState(b)}createExtHostTreeView(r,b,s){const u=new v(r,b,this._proxy,this.commands.converter,this.logService,s);return this.treeViews.set(r,u),u}convertArgument(r){const b=this.treeViews.get(r.$treeViewId);return b&&"$treeItemHandle"in r?b.getExtensionElement(r.$treeItemHandle):b&&"$focusedTreeItem"in r&&r.$focusedTreeItem?b.focusedElement:null}}e.ExtHostTreeViews=h;class v extends T.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(r=>this.getExtensionElement(r)).filter(r=>!(0,A.isUndefinedOrNull)(r))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(r,b,s,u,o,l){if(super(),this.viewId=r,this.proxy=s,this.commands=u,this.logService=o,this.extension=l,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new y.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new _.CancellationTokenSource,l.contributes&&l.contributes.views)for(const n in l.contributes.views)for(const i of l.contributes.views[n])i.id===r&&(this._title=i.name);this.dataProvider=b.treeDataProvider,this.dndController=b.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let a,d;this._register(y.Event.debounce(this._onDidChangeData.event,(n,i)=>(n||(n={message:!1,elements:[]}),i.element!==!1&&(a||(a=new Promise(p=>d=p),this.refreshPromise=this.refreshPromise.then(()=>a)),Array.isArray(i.element)?n.elements.push(...i.element):n.elements.push(i.element)),i.message&&(n.message=!0),n),200,!0)(({message:n,elements:i})=>{i.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=d;return a=null,this.refresh(i).then(()=>p())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(r){const b=r?this.getExtensionElement(r):void 0;if(r&&!b)return this.logService.error(`No tree item with id '${r}' found.`),Promise.resolve([]);let s=this.getChildrenNodes(r);return s||(s=await this.fetchChildrenNodes(b)),s?s.map(u=>u.item):void 0}getExtensionElement(r){return this.elements.get(r)}reveal(r,b){b=b||{select:!0,focus:!1};const s=(0,A.isUndefinedOrNull)(b.select)?!0:b.select,u=(0,A.isUndefinedOrNull)(b.focus)?!1:b.focus,o=(0,A.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):r?this.refreshPromise.then(()=>this.resolveUnknownParentChain(r)).then(l=>this.resolveTreeNode(r,l[l.length-1]).then(a=>this.proxy.$reveal(this.viewId,{item:a.item,parentChain:l.map(d=>d.item)},{select:s,focus:u,expand:o})),l=>this.logService.error(l)):this.proxy.$reveal(this.viewId,void 0,{select:s,focus:u,expand:o})}get message(){return this._message}set message(r){this._message=r,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(r){this._title=r,this.proxy.$setTitle(this.viewId,r,this._description)}get description(){return this._description}set description(r){this._description=r,this.proxy.$setTitle(this.viewId,this._title,r)}get badge(){return this._badge}set badge(r){this._badge?.value===r?.value&&this._badge?.tooltip===r?.tooltip||(this._badge=E.ViewBadge.from(r),this.proxy.$setBadge(this.viewId,r))}setExpanded(r,b){const s=this.getExtensionElement(r);s&&(b?this._onDidExpandElement.fire(Object.freeze({element:s})):this._onDidCollapseElement.fire(Object.freeze({element:s})))}setSelection(r){(0,k.equals)(this._selectedHandles,r)||(this._selectedHandles=r,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(r){this._focusedHandle=r}setVisible(r){r!==this._visible&&(this._visible=r,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(r){const b=(await Promise.all(r.map(async s=>{const u=this.getExtensionElement(s.treeItemHandle);return u?{extensionItem:u,treeItem:await this.dataProvider.getTreeItem(u),newState:s.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);b.forEach(s=>{s.treeItem.checkboxState=s.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:b.map(s=>[s.extensionItem,s.newState])})}async handleDrag(r,b,s){const u=[];for(const o of r){const l=this.getExtensionElement(o);l&&u.push(l)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,b,s),b}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(r,b,s){const u=b?this.getExtensionElement(b):void 0;if(!(!u&&b||!this.dndController?.handleDrop))return(0,S.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(u,r,s):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(r,b){if(!this.dataProvider.resolveTreeItem)return;const s=this.elements.get(r);if(s){const u=this.nodes.get(s);if(u){const o=await this.dataProvider.resolveTreeItem(u.extensionItem,s,b)??u.extensionItem;return this.validateTreeItem(o),u.item.tooltip=this.getTooltip(o.tooltip),u.item.command=this.getCommand(u.disposableStore,o.command),u.item}}}resolveUnknownParentChain(r){return this.resolveParent(r).then(b=>b?this.resolveUnknownParentChain(b).then(s=>this.resolveTreeNode(b,s[s.length-1]).then(u=>(s.push(u),s))):Promise.resolve([]))}resolveParent(r){const b=this.nodes.get(r);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(r))}resolveTreeNode(r,b){const s=this.nodes.get(r);return s?Promise.resolve(s):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(r)).then(u=>this.createHandle(r,u,b,!0)).then(u=>this.getChildren(b?b.item.handle:void 0).then(()=>{const o=this.getExtensionElement(u);if(o){const l=this.nodes.get(o);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(r){if(r){let b;if(typeof r=="string"){const s=this.getExtensionElement(r);b=s?this.nodes.get(s):void 0}else b=r;return b&&b.children||void 0}return this.roots}async fetchChildrenNodes(r){this.clearChildren(r);const b=new _.CancellationTokenSource(this._refreshCancellationSource.token);try{const s=r?this.nodes.get(r):void 0,u=await this.dataProvider.getChildren(r);if(b.token.isCancellationRequested)return;const o=await Promise.all((0,k.coalesce)(u||[]).map(async l=>{const a=await this.dataProvider.getTreeItem(l);return a&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(l,a,s):null}));return b.token.isCancellationRequested?void 0:(0,k.coalesce)(o)}finally{b.dispose()}}refresh(r){if(r.some(s=>!s))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new _.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const s=this.getHandlesToRefresh(r);if(s.length)return this.refreshHandles(s)}return Promise.resolve(void 0)}getHandlesToRefresh(r){const b=new Set,s=r.map(o=>this.nodes.get(o));for(const o of s)if(o&&!b.has(o.item.handle)){let l=o;for(;l&&l.parent&&s.findIndex(a=>l&&l.parent&&a&&a.item.handle===l.parent.item.handle)===-1;){const a=this.elements.get(l.parent.item.handle);l=a?this.nodes.get(a):void 0}l&&!l.parent&&b.add(o.item.handle)}const u=[];return b.forEach(o=>{const l=this.elements.get(o);if(l){const a=this.nodes.get(l);a&&(!a.parent||!b.has(a.parent.item.handle))&&u.push(o)}}),u}refreshHandles(r){const b={};return Promise.all(r.map(s=>this.refreshNode(s).then(u=>{u&&(b[s]=u.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(r){const b=this.getExtensionElement(r);if(b){const s=this.nodes.get(b);if(s)return this.clearChildren(b),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(u=>{if(u){const o=this.createTreeNode(b,u,s.parent);return this.updateNodeCache(b,o,s,s.parent),s.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(r,b,s){const u=this.createTreeNode(r,b,s);if(b.id&&this.elements.has(u.item.handle))throw new Error((0,c.localize)(10,null,b.id));return this.addNodeToCache(r,u),this.addNodeToParentCache(u,s),u}getTooltip(r){return D.MarkdownString.isMarkdownString(r)?E.MarkdownString.from(r):r}getCommand(r,b){return b?{...this.commands.toInternal(b,r),originalId:b.command}:void 0}getCheckbox(r){if(!r.checkboxState)return;let b,s;return typeof r.checkboxState=="number"?b=r.checkboxState:(b=r.checkboxState.state,s=r.checkboxState.tooltip),{isChecked:b===D.TreeItemCheckboxState.Checked,tooltip:s}}validateTreeItem(r){if(!D.TreeItem.isTreeItem(r,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(r,b,s){this.validateTreeItem(b);const u=new T.DisposableStore,o=this.createHandle(r,b,s),l=this.getLightIconPath(b);return{item:{handle:o,parentHandle:s?s.item.handle:void 0,label:g(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(u,b.command),contextValue:b.contextValue,icon:l,iconDark:this.getDarkIconPath(b)||l,themeIcon:this.getThemeIcon(b),collapsibleState:(0,A.isUndefinedOrNull)(b.collapsibleState)?D.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation,checkbox:this.getCheckbox(b)},extensionItem:b,parent:s,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(r){return r.iconPath instanceof D.ThemeIcon?r.iconPath:void 0}createHandle(r,{id:b,label:s,resourceUri:u},o,l){if(b)return`${v.ID_HANDLE_PREFIX}/${b}`;const a=g(s,this.extension),d=o?o.item.handle:v.LABEL_HANDLE_PREFIX;let n=a?a.label:u?(0,I.basename)(u):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const i=this.nodes.has(r)?this.nodes.get(r).item.handle:void 0,p=this.getChildrenNodes(o)||[];let C,R=0;do{if(C=`${d}/${R}:${n}`,l||!this.elements.has(C)||i===C)break;R++}while(R<=p.length);return C}getLightIconPath(r){if(r.iconPath&&!(r.iconPath instanceof D.ThemeIcon))return typeof r.iconPath=="string"||P.URI.isUri(r.iconPath)?this.getIconPath(r.iconPath):this.getIconPath(r.iconPath.light)}getDarkIconPath(r){if(r.iconPath&&!(r.iconPath instanceof D.ThemeIcon)&&r.iconPath.dark)return this.getIconPath(r.iconPath.dark)}getIconPath(r){return P.URI.isUri(r)?r:P.URI.file(r)}addNodeToCache(r,b){this.elements.set(b.item.handle,r),this.nodes.set(r,b)}updateNodeCache(r,b,s,u){this.elements.delete(b.item.handle),this.nodes.delete(r),b.item.handle!==s.item.handle&&this.elements.delete(s.item.handle),this.addNodeToCache(r,b);const o=this.getChildrenNodes(u)||[],l=o.filter(a=>a.item.handle===s.item.handle)[0];l&&o.splice(o.indexOf(l),1,b)}addNodeToParentCache(r,b){b?(b.children||(b.children=[]),b.children.push(r)):(this.roots||(this.roots=[]),this.roots.push(r))}clearChildren(r){if(r){const b=this.nodes.get(r);if(b){if(b.children)for(const s of b.children){const u=this.elements.get(s.item.handle);u&&this.clear(u)}b.children=void 0}}else this.clearAll()}clear(r){const b=this.nodes.get(r);if(b){if(b.children)for(const s of b.children){const u=this.elements.get(s.item.handle);u&&this.clear(u)}this.nodes.delete(r),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(r=>r.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(_e[299],ye([1,0,21,10,4,42,2,119,104,149,159,38,5,92,243,242,39,244,34,246,247,248,231,249,58,41,250,251,254,255,256,140,234,260,261,262,96,40,264,298,15,7,267,71,139,33,214,253,86,137,73,75,76,13,55,16,25,257,230,54,68,240,265,70,69,270,268,269,241,46,263,266,95,59,93,258,72,259,14,123,233,210,252,6,27,215,94,207]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h,v,m,r,b,s,u,o,l,a,d,n,i,p,C,R,U,H,V,L,M,F,B,N,z,j,x,Q,K,le,ie,de,Y,pe,be,Ce,Re,We,ne,ce,fe,J,re,ee,O,W,q,X,ae,ve,Te,ge,Pe,De,xe,je,nt,Xe,rt,Be,dt,se,oe,Se,ue,Ie,Le,Fe,Ge,Ye,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function bt(st){const et=st.get(ce.IExtHostInitDataService),wt=st.get(Pe.IExtHostFileSystemInfo),St=st.get(X.IExtHostConsumerFileSystem),Dt=st.get(l.IExtHostExtensionService),ft=st.get(K.IExtHostWorkspace),kt=st.get(Xe.IExtHostTelemetry),Ut=st.get(v.IExtHostConfiguration),Lt=st.get(We.IURITransformerService),Qe=st.get(ne.IExtHostRpcService),Pt=st.get(L.IExtHostStorage),Ot=st.get(q.IExtensionStoragePaths),Bt=st.get(Re.ILoggerService),pt=st.get(Re.ILogService),Ae=st.get(re.IExtHostTunnelService),Oe=st.get(ee.IExtHostApiDeprecationService),Ee=st.get(Q.IExtHostWindow),te=st.get(je.IExtHostSecretState),Ne=st.get(nt.IExtHostEditorTabs);Qe.set(E.ExtHostContext.ExtHostFileSystemInfo,wt),Qe.set(E.ExtHostContext.ExtHostLogLevelServiceShape,Bt),Qe.set(E.ExtHostContext.ExtHostWorkspace,ft),Qe.set(E.ExtHostContext.ExtHostConfiguration,Ut),Qe.set(E.ExtHostContext.ExtHostExtensionService,Dt),Qe.set(E.ExtHostContext.ExtHostStorage,Pt),Qe.set(E.ExtHostContext.ExtHostTunnelService,Ae),Qe.set(E.ExtHostContext.ExtHostWindow,Ee),Qe.set(E.ExtHostContext.ExtHostSecretState,te),Qe.set(E.ExtHostContext.ExtHostTelemetry,kt),Qe.set(E.ExtHostContext.ExtHostEditorTabs,Ne);const $e=Qe.set(E.ExtHostContext.ExtHostDecorations,st.get(Y.IExtHostDecorations)),tt=Qe.set(E.ExtHostContext.ExtHostDocumentsAndEditors,st.get(o.IExtHostDocumentsAndEditors)),qe=Qe.set(E.ExtHostContext.ExtHostCommands,st.get(g.IExtHostCommands)),ot=Qe.set(E.ExtHostContext.ExtHostTerminalService,st.get(M.IExtHostTerminalService)),ct=Qe.set(E.ExtHostContext.ExtHostDebugService,st.get(be.IExtHostDebugService)),At=Qe.set(E.ExtHostContext.ExtHostSearch,st.get(Ce.IExtHostSearch)),Et=Qe.set(E.ExtHostContext.ExtHostTask,st.get(pe.IExtHostTask)),It=Qe.set(E.ExtHostContext.ExtHostOutputService,st.get(C.IExtHostOutputService)),vt=Qe.set(E.ExtHostContext.ExtHostLocalization,st.get(Ye.IExtHostLocalizationService)),Ft=Qe.set(E.ExtHostContext.ExtHostUrls,new j.ExtHostUrls(Qe)),mt=Qe.set(E.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(Qe,tt)),Nt=Qe.set(E.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(Qe,tt,pt)),Gt=Qe.set(E.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(pt,mt,Qe.getProxy(E.MainContext.MainThreadBulkEdits))),_t=Qe.set(E.ExtHostContext.ExtHostNotebook,new fe.ExtHostNotebookController(Qe,qe,tt,mt)),xt=Qe.set(E.ExtHostContext.ExtHostNotebookDocuments,new ue.ExtHostNotebookDocuments(_t)),rn=Qe.set(E.ExtHostContext.ExtHostNotebookEditors,new Se.ExtHostNotebookEditors(pt,_t)),sn=Qe.set(E.ExtHostContext.ExtHostNotebookKernels,new rt.ExtHostNotebookKernels(Qe,et,_t,qe,pt)),gn=Qe.set(E.ExtHostContext.ExtHostNotebookRenderers,new dt.ExtHostNotebookRenderers(Qe,_t)),Ct=Qe.set(E.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Qe,tt)),on=Qe.set(E.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Qe.getProxy(E.MainContext.MainThreadTreeViews),qe,pt)),Rn=Qe.set(E.ExtHostContext.ExtHostEditorInsets,new le.ExtHostEditorInsets(Qe.getProxy(E.MainContext.MainThreadEditorInsets),Ct,et.remote)),Jt=Qe.set(E.ExtHostContext.ExtHostDiagnostics,new m.ExtHostDiagnostics(Qe,pt,wt,tt)),zt=Qe.set(E.ExtHostContext.ExtHostLanguages,new i.ExtHostLanguages(Qe,mt,qe.converter,Lt)),ut=Qe.set(E.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Qe,Lt,mt,qe,Jt,pt,Oe,kt)),pn=Qe.set(E.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(Qe,ut)),Ht=Qe.set(E.ExtHostContext.ExtHostFileSystemEventService,new d.ExtHostFileSystemEventService(Qe,pt,tt)),Kt=Qe.set(E.ExtHostContext.ExtHostQuickOpen,(0,U.createExtHostQuickOpen)(Qe,ft,qe)),an=Qe.set(E.ExtHostContext.ExtHostSCM,new H.ExtHostSCM(Qe,qe,pt)),vn=Qe.set(E.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(Qe,qe,mt)),cn=Qe.set(E.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Qe.getProxy(E.MainContext.MainThreadProgress))),bn=Qe.set(E.ExtHostContext.ExtHosLabelService,new ie.ExtHostLabelService(Qe)),Dn=Qe.set(E.ExtHostContext.ExtHostTheming,new J.ExtHostTheming(Qe)),Zt=Qe.set(E.ExtHostContext.ExtHostAuthentication,new O.ExtHostAuthentication(Qe)),wn=Qe.set(E.ExtHostContext.ExtHostTimeline,new W.ExtHostTimeline(Qe,qe)),en=Qe.set(E.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(Qe,et.remote,ft,pt,Oe)),tn=Qe.set(E.ExtHostContext.ExtHostWebviewPanels,new Te.ExtHostWebviewPanels(Qe,en,ft)),Ln=Qe.set(E.ExtHostContext.ExtHostCustomEditors,new ve.ExtHostCustomEditors(Qe,mt,Ot,en,tn)),En=Qe.set(E.ExtHostContext.ExtHostWebviewViews,new ae.ExtHostWebviewViews(Qe,en)),Xt=Qe.set(E.ExtHostContext.ExtHostTesting,new De.ExtHostTesting(Qe,qe,tt)),On=Qe.set(E.ExtHostContext.ExtHostUriOpeners,new xe.ExtHostUriOpeners(Qe));Qe.set(E.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Qe,_t,tt,qe,pt));const Fn=Object.values(E.ExtHostContext);Qe.assertRegistered(Fn);const Nn=new ge.ExtHostBulkEdits(Qe,tt),Mn=new f.ExtHostClipboard(Qe),Sn=new p.ExtHostMessageService(Qe,pt),In=new r.ExtHostDialogs(Qe),ln=new V.ExtHostStatusBar(Qe,qe.converter);return w.ExtHostApiCommands.register(qe),function(He,Vt,kn){const gt=function(){let me=!He.isUnderDevelopment;function we(){me||(pt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function Ue(at){if(Array.isArray(at))at.forEach(Ue);else if(typeof at=="string")we();else{const yt=at;typeof yt.scheme>"u"&&we(),typeof yt.exclusive=="boolean"&&(0,Fe.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return at}}(),un={getSession(me,we,Ue){return Zt.getSession(He,me,we,Ue)},async hasSession(me,we){return(0,Fe.checkProposedApiEnabled)(He,"authSession"),!!await Zt.getSession(He,me,we,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(me,we,Ue,at){return Zt.registerAuthenticationProvider(me,we,Ue,at)}},Un={registerCommand(me,we,Ue){return qe.registerCommand(!0,me,we,Ue,void 0,He)},registerTextEditorCommand(me,we,Ue){return qe.registerCommand(!0,me,(...at)=>{const yt=Ct.getActiveTextEditor();if(!yt){pt.warn("Cannot execute "+me+" because there is no active text editor.");return}return yt.edit(Tt=>{we.apply(Ue,[yt,Tt,...at])}).then(Tt=>{Tt||pt.warn("Edits from command "+me+" were not applied.")},Tt=>{pt.warn("An error occurred while running command "+me,Tt)})},void 0,void 0,He)},registerDiffInformationCommand:(me,we,Ue)=>((0,Fe.checkProposedApiEnabled)(He,"diffCommand"),qe.registerCommand(!0,me,async(...at)=>{const yt=tt.activeEditor(!0);if(!yt){pt.warn("Cannot execute "+me+" because there is no active text editor.");return}const Tt=await Ct.getDiffInformation(yt.id);we.apply(Ue,[Tt,...at])},void 0,void 0,He)),executeCommand(me,...we){return qe.executeCommand(me,...we)},getCommands(me=!1){return qe.getCommands(me)}},Tn={get machineId(){return et.telemetryInfo.machineId},get sessionId(){return et.telemetryInfo.sessionId},get language(){return et.environment.appLanguage},get appName(){return et.environment.appName},get appRoot(){return et.environment.appRoot?.fsPath??""},get appHost(){return et.environment.appHost},get uriScheme(){return et.environment.appUriScheme},get clipboard(){return Mn.value},get shell(){return ot.getDefaultShell(!1)},get onDidChangeShell(){return(0,Fe.checkProposedApiEnabled)(He,"envShellEvent"),ot.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Fe.checkProposedApiEnabled)(He,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Fe.checkProposedApiEnabled)(He,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Xe.isNewAppInstall)(et.telemetryInfo.firstSessionDate)},createTelemetryLogger(me){return(0,Fe.checkProposedApiEnabled)(He,"telemetryLogger"),kt.instantiateLogger(He,me)},openExternal(me,we){return Ee.openUri(me,{allowTunneling:!!et.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===et.environment.appUriScheme)return Ft.createAppUri(me);try{return await Ee.asExternalUri(me,{allowTunneling:!!et.remote.authority})}catch(we){if((0,oe.matchesScheme)(me,se.Schemas.http)||(0,oe.matchesScheme)(me,se.Schemas.https))return me;throw we}},get remoteName(){return(0,de.getRemoteName)(et.remote.authority)},get remoteAuthority(){return(0,Fe.checkProposedApiEnabled)(He,"resolvers"),et.remote.authority},get uiKind(){return et.uiKind},get logLevel(){return(0,Fe.checkProposedApiEnabled)(He,"extensionLog"),pt.getLevel()},get onDidChangeLogLevel(){return(0,Fe.checkProposedApiEnabled)(He,"extensionLog"),pt.onDidChangeLogLevel}};et.environment.extensionTestsLocationURI||Object.freeze(Tn);const Bn={createTestController(me,we,Ue){return Xt.createTestController(me,we,Ue)},createTestObserver(){return(0,Fe.checkProposedApiEnabled)(He,"testObserver"),Xt.createTestObserver()},runTests(me){return(0,Fe.checkProposedApiEnabled)(He,"testObserver"),Xt.runTests(me)},get onDidChangeTestResults(){return(0,Fe.checkProposedApiEnabled)(He,"testObserver"),Xt.onResultsChanged},get testResults(){return(0,Fe.checkProposedApiEnabled)(He,"testObserver"),Xt.results}},dn=et.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,_n={getExtension(me,we){(0,Fe.isProposedApiEnabled)(He,"extensionsAny")||(we=!1);const Ue=Vt.mine.getExtensionDescription(me);if(Ue)return new l.Extension(Dt,He.identifier,Ue,dn,!1);if(we){const at=Vt.all.getExtensionDescription(me);if(at)return new l.Extension(Dt,He.identifier,at,dn,!0)}},get all(){const me=[];for(const we of Vt.mine.getAllExtensionDescriptions())me.push(new l.Extension(Dt,He.identifier,we,dn,!1));return me},get allAcrossExtensionHosts(){(0,Fe.checkProposedApiEnabled)(He,"extensionsAny");const me=new Fe.ExtensionIdentifierSet(Vt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),we=[];for(const Ue of Vt.all.getAllExtensionDescriptions()){const at=!me.has(Ue.identifier);we.push(new l.Extension(Dt,He.identifier,Ue,dn,at))}return we},get onDidChange(){return(0,Fe.isProposedApiEnabled)(He,"extensionsAny")?I.Event.any(Vt.mine.onDidChange,Vt.all.onDidChange):Vt.mine.onDidChange}},Wn={createDiagnosticCollection(me){return Jt.createDiagnosticCollection(He.identifier,me)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:me=>Jt.getDiagnostics(me),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(me,we){return zt.changeLanguage(me.uri,we)},match(me,we){const Ue=mt.getDocumentData(we.uri)?.notebook;return(0,A.score)(N.LanguageSelector.from(me),we.uri,we.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(me,we,Ue){return ut.registerCodeActionProvider(He,gt(me),we,Ue)},registerDocumentPasteEditProvider(me,we,Ue){return(0,Fe.checkProposedApiEnabled)(He,"documentPaste"),ut.registerDocumentPasteEditProvider(He,gt(me),we,Ue)},registerCodeLensProvider(me,we){return ut.registerCodeLensProvider(He,gt(me),we)},registerDefinitionProvider(me,we){return ut.registerDefinitionProvider(He,gt(me),we)},registerDeclarationProvider(me,we){return ut.registerDeclarationProvider(He,gt(me),we)},registerImplementationProvider(me,we){return ut.registerImplementationProvider(He,gt(me),we)},registerTypeDefinitionProvider(me,we){return ut.registerTypeDefinitionProvider(He,gt(me),we)},registerHoverProvider(me,we){return ut.registerHoverProvider(He,gt(me),we,He.identifier)},registerEvaluatableExpressionProvider(me,we){return ut.registerEvaluatableExpressionProvider(He,gt(me),we,He.identifier)},registerInlineValuesProvider(me,we){return ut.registerInlineValuesProvider(He,gt(me),we,He.identifier)},registerDocumentHighlightProvider(me,we){return ut.registerDocumentHighlightProvider(He,gt(me),we)},registerLinkedEditingRangeProvider(me,we){return ut.registerLinkedEditingRangeProvider(He,gt(me),we)},registerReferenceProvider(me,we){return ut.registerReferenceProvider(He,gt(me),we)},registerRenameProvider(me,we){return ut.registerRenameProvider(He,gt(me),we)},registerDocumentSymbolProvider(me,we,Ue){return ut.registerDocumentSymbolProvider(He,gt(me),we,Ue)},registerWorkspaceSymbolProvider(me){return ut.registerWorkspaceSymbolProvider(He,me)},registerDocumentFormattingEditProvider(me,we){return ut.registerDocumentFormattingEditProvider(He,gt(me),we)},registerDocumentRangeFormattingEditProvider(me,we){return ut.registerDocumentRangeFormattingEditProvider(He,gt(me),we)},registerOnTypeFormattingEditProvider(me,we,Ue,...at){return ut.registerOnTypeFormattingEditProvider(He,gt(me),we,[Ue].concat(at))},registerDocumentSemanticTokensProvider(me,we,Ue){return ut.registerDocumentSemanticTokensProvider(He,gt(me),we,Ue)},registerDocumentRangeSemanticTokensProvider(me,we,Ue){return ut.registerDocumentRangeSemanticTokensProvider(He,gt(me),we,Ue)},registerSignatureHelpProvider(me,we,Ue,...at){return typeof Ue=="object"?ut.registerSignatureHelpProvider(He,gt(me),we,Ue):ut.registerSignatureHelpProvider(He,gt(me),we,typeof Ue>"u"?[]:[Ue,...at])},registerCompletionItemProvider(me,we,...Ue){return ut.registerCompletionItemProvider(He,gt(me),we,Ue)},registerInlineCompletionItemProvider(me,we){return we.handleDidShowCompletionItem&&(0,Fe.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(He,gt(me),we)},registerDocumentLinkProvider(me,we){return ut.registerDocumentLinkProvider(He,gt(me),we)},registerColorProvider(me,we){return ut.registerColorProvider(He,gt(me),we)},registerFoldingRangeProvider(me,we){return ut.registerFoldingRangeProvider(He,gt(me),we)},registerSelectionRangeProvider(me,we){return ut.registerSelectionRangeProvider(He,me,we)},registerCallHierarchyProvider(me,we){return ut.registerCallHierarchyProvider(He,me,we)},registerTypeHierarchyProvider(me,we){return ut.registerTypeHierarchyProvider(He,me,we)},setLanguageConfiguration:(me,we)=>ut.setLanguageConfiguration(He,me,we),getTokenInformationAtPosition(me,we){return(0,Fe.checkProposedApiEnabled)(He,"tokenInformation"),zt.tokenAtPosition(me,we)},registerInlayHintsProvider(me,we){return ut.registerInlayHintsProvider(He,me,we)},createLanguageStatusItem(me,we){return zt.createLanguageStatusItem(He,me,we)},registerDocumentDropEditProvider(me,we){return ut.registerDocumentOnDropEditProvider(He,me,we)}},jt={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return ot.activeTerminal},get terminals(){return ot.terminals},async showTextDocument(me,we,Ue){const at=await(y.URI.isUri(me)?Promise.resolve(nn.openTextDocument(me)):Promise.resolve(me));return Ct.showTextDocument(at,we,Ue)},createTextEditorDecorationType(me){return Ct.createTextEditorDecorationType(He,me)},onDidChangeActiveTextEditor(me,we,Ue){return Ct.onDidChangeActiveTextEditor(me,we,Ue)},onDidChangeVisibleTextEditors(me,we,Ue){return Ct.onDidChangeVisibleTextEditors(me,we,Ue)},onDidChangeTextEditorSelection(me,we,Ue){return Ct.onDidChangeTextEditorSelection(me,we,Ue)},onDidChangeTextEditorOptions(me,we,Ue){return Ct.onDidChangeTextEditorOptions(me,we,Ue)},onDidChangeTextEditorVisibleRanges(me,we,Ue){return Ct.onDidChangeTextEditorVisibleRanges(me,we,Ue)},onDidChangeTextEditorViewColumn(me,we,Ue){return Ct.onDidChangeTextEditorViewColumn(me,we,Ue)},onDidCloseTerminal(me,we,Ue){return ot.onDidCloseTerminal(me,we,Ue)},onDidOpenTerminal(me,we,Ue){return ot.onDidOpenTerminal(me,we,Ue)},onDidChangeActiveTerminal(me,we,Ue){return ot.onDidChangeActiveTerminal(me,we,Ue)},onDidChangeTerminalDimensions(me,we,Ue){return(0,Fe.checkProposedApiEnabled)(He,"terminalDimensions"),ot.onDidChangeTerminalDimensions(me,we,Ue)},onDidChangeTerminalState(me,we,Ue){return ot.onDidChangeTerminalState(me,we,Ue)},onDidWriteTerminalData(me,we,Ue){return(0,Fe.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),ot.onDidWriteTerminalData(me,we,Ue)},get state(){return Ee.state},onDidChangeWindowState(me,we,Ue){return Ee.onDidChangeWindowState(me,we,Ue)},showInformationMessage(me,...we){return Sn.showMessage(He,P.default.Info,me,we[0],we.slice(1))},showWarningMessage(me,...we){return Sn.showMessage(He,P.default.Warning,me,we[0],we.slice(1))},showErrorMessage(me,...we){return Sn.showMessage(He,P.default.Error,me,we[0],we.slice(1))},showQuickPick(me,we,Ue){return Kt.showQuickPick(me,we,Ue)},showWorkspaceFolderPick(me){return Kt.showWorkspaceFolderPick(me)},showInputBox(me,we){return Kt.showInput(me,we)},showOpenDialog(me){return In.showOpenDialog(me)},showSaveDialog(me){return In.showSaveDialog(me)},createStatusBarItem(me,we,Ue){let at,yt,Tt;return typeof me=="string"?(at=me,yt=we,Tt=Ue):(yt=me,Tt=we),ln.createStatusBarEntry(He,at,yt,Tt)},setStatusBarMessage(me,we){return ln.setStatusBarMessage(me,we)},withScmProgress(me){return Oe.report("window.withScmProgress",He,"Use 'withProgress' instead."),cn.withProgress(He,{location:z.ProgressLocation.SourceControl},(we,Ue)=>me({report(at){}}))},withProgress(me,we){return cn.withProgress(He,me,we)},createOutputChannel(me,we){return It.createOutputChannel(me,we,He)},createWebviewPanel(me,we,Ue,at){return tn.createWebviewPanel(He,me,we,Ue,at)},createWebviewTextEditorInset(me,we,Ue,at){return(0,Fe.checkProposedApiEnabled)(He,"editorInsets"),Rn.createWebviewEditorInset(me,we,Ue,at,He)},createTerminal(me,we,Ue){return typeof me=="object"?"pty"in me?ot.createExtensionTerminal(me):ot.createTerminalFromOptions(me):ot.createTerminal(me,we,Ue)},registerTerminalLinkProvider(me){return ot.registerLinkProvider(me)},registerTerminalProfileProvider(me,we){return ot.registerProfileProvider(He,me,we)},registerTreeDataProvider(me,we){return on.registerTreeDataProvider(me,we,He)},createTreeView(me,we){return on.createTreeView(me,we,He)},registerWebviewPanelSerializer:(me,we)=>tn.registerWebviewPanelSerializer(He,me,we),registerCustomEditorProvider:(me,we,Ue={})=>Ln.registerCustomEditorProvider(He,me,we,Ue),registerFileDecorationProvider(me){return $e.registerFileDecorationProvider(me,He.identifier)},registerUriHandler(me){return Ft.registerUriHandler(He.identifier,me)},createQuickPick(){return Kt.createQuickPick(He)},createInputBox(){return Kt.createInputBox(He)},get activeColorTheme(){return Dn.activeColorTheme},onDidChangeActiveColorTheme(me,we,Ue){return Dn.onDidChangeActiveColorTheme(me,we,Ue)},registerWebviewViewProvider(me,we,Ue){return En.registerWebviewViewProvider(He,me,we,Ue?.webviewOptions)},get activeNotebookEditor(){return _t.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,we,Ue){return _t.onDidChangeActiveNotebookEditor(me,we,Ue)},get visibleNotebookEditors(){return _t.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return _t.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(me,we,Ue){return rn.onDidChangeNotebookEditorSelection(me,we,Ue)},onDidChangeNotebookEditorVisibleRanges(me,we,Ue){return rn.onDidChangeNotebookEditorVisibleRanges(me,we,Ue)},showNotebookDocument(me,we){return _t.showNotebookDocument(me,we)},registerExternalUriOpener(me,we,Ue){return(0,Fe.checkProposedApiEnabled)(He,"externalUriOpener"),On.registerExternalUriOpener(He.identifier,me,we,Ue)},get tabGroups(){return Ne.tabGroups}},nn={get rootPath(){return Oe.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(me){throw t.readonly()},getWorkspaceFolder(me){return ft.getWorkspaceFolder(me)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(me){throw t.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(me){throw t.readonly()},updateWorkspaceFolders:(me,we,...Ue)=>ft.updateWorkspaceFolders(He,me,we||0,...Ue),onDidChangeWorkspaceFolders:function(me,we,Ue){return ft.onDidChangeWorkspace(me,we,Ue)},asRelativePath:(me,we)=>ft.getRelativePath(me,we),findFiles:(me,we,Ue,at)=>ft.findFiles(me,we,Ue,He.identifier,at),findTextInFiles:(me,we,Ue,at)=>{(0,Fe.checkProposedApiEnabled)(He,"findTextInFiles");let yt,Tt;return typeof we=="object"?(yt=we,Tt=Ue):(yt={},Tt=we,at=Ue),ft.findTextInFiles(me,yt||{},Tt,He.identifier,at)},saveAll:me=>ft.saveAll(me),applyEdit(me,we){return Nn.applyWorkspaceEdit(me,He,we)},createFileSystemWatcher:(me,we,Ue,at)=>Ht.createFileSystemWatcher(ft,He,me,we,Ue,at),get textDocuments(){return mt.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw t.readonly()},openTextDocument(me){let we;const Ue=me;if(typeof me=="string")we=Promise.resolve(y.URI.file(me));else if(y.URI.isUri(me))we=Promise.resolve(me);else if(!Ue||typeof Ue=="object")we=mt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(at=>mt.ensureDocumentData(at).then(yt=>yt.document))},onDidOpenTextDocument:(me,we,Ue)=>mt.onDidAddDocument(me,we,Ue),onDidCloseTextDocument:(me,we,Ue)=>mt.onDidRemoveDocument(me,we,Ue),onDidChangeTextDocument:(me,we,Ue)=>mt.onDidChangeDocument(me,we,Ue),onDidSaveTextDocument:(me,we,Ue)=>mt.onDidSaveDocument(me,we,Ue),onWillSaveTextDocument:(me,we,Ue)=>Gt.getOnWillSaveTextDocumentEvent(He)(me,we,Ue),get notebookDocuments(){return _t.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,we){let Ue;if(y.URI.isUri(me))Ue=me,await _t.openNotebookDocument(me);else if(typeof me=="string")Ue=y.URI.revive(await _t.createNotebookDocument({viewType:me,content:we}));else throw new Error("Invalid arguments");return _t.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(me,we,Ue){return xt.onDidSaveNotebookDocument(me,we,Ue)},onDidChangeNotebookDocument(me,we,Ue){return xt.onDidChangeNotebookDocument(me,we,Ue)},get onDidOpenNotebookDocument(){return _t.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return _t.onDidCloseNotebookDocument},registerNotebookSerializer(me,we,Ue,at){return _t.registerNotebookSerializer(He,me,we,Ue,(0,Fe.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(me,we,Ue)=>kn.onDidChangeConfiguration(me,we,Ue),getConfiguration(me,we){return we=arguments.length===1?void 0:we,kn.getConfiguration(me,we,He)},registerTextDocumentContentProvider(me,we){return Nt.registerTextDocumentContentProvider(me,we)},registerTaskProvider:(me,we)=>(Oe.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(He,me,we)),registerFileSystemProvider(me,we,Ue){return(0,Le.combinedDisposable)(pn.registerFileSystemProvider(He,me,we,Ue),St.addFileSystemProvider(me,we))},get fs(){return St.value},registerFileSearchProvider:(me,we)=>((0,Fe.checkProposedApiEnabled)(He,"fileSearchProvider"),At.registerFileSearchProvider(me,we)),registerTextSearchProvider:(me,we)=>((0,Fe.checkProposedApiEnabled)(He,"textSearchProvider"),At.registerTextSearchProvider(me,we)),registerRemoteAuthorityResolver:(me,we)=>((0,Fe.checkProposedApiEnabled)(He,"resolvers"),Dt.registerRemoteAuthorityResolver(me,we)),registerResourceLabelFormatter:me=>((0,Fe.checkProposedApiEnabled)(He,"resolvers"),bn.$registerResourceLabelFormatter(me)),onDidCreateFiles:(me,we,Ue)=>Ht.onDidCreateFile(me,we,Ue),onDidDeleteFiles:(me,we,Ue)=>Ht.onDidDeleteFile(me,we,Ue),onDidRenameFiles:(me,we,Ue)=>Ht.onDidRenameFile(me,we,Ue),onWillCreateFiles:(me,we,Ue)=>Ht.getOnWillCreateFileEvent(He)(me,we,Ue),onWillDeleteFiles:(me,we,Ue)=>Ht.getOnWillDeleteFileEvent(He)(me,we,Ue),onWillRenameFiles:(me,we,Ue)=>Ht.getOnWillRenameFileEvent(He)(me,we,Ue),openTunnel:me=>((0,Fe.checkProposedApiEnabled)(He,"tunnels"),Ae.openTunnel(He,me).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,Fe.checkProposedApiEnabled)(He,"tunnels"),Ae.getTunnels()},onDidChangeTunnels:(me,we,Ue)=>((0,Fe.checkProposedApiEnabled)(He,"tunnels"),Ae.onDidChangeTunnels(me,we,Ue)),registerPortAttributesProvider:(me,we)=>((0,Fe.checkProposedApiEnabled)(He,"portsAttributes"),Ae.registerPortsAttributesProvider(me,we)),registerTimelineProvider:(me,we)=>((0,Fe.checkProposedApiEnabled)(He,"timeline"),wn.registerTimelineProvider(me,we,He.identifier,qe.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:me=>((0,Fe.checkProposedApiEnabled)(He,"workspaceTrust"),ft.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,we,Ue)=>ft.onDidGrantWorkspaceTrust(me,we,Ue),registerEditSessionIdentityProvider:(me,we)=>((0,Fe.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(me,we))},zn={get inputBox(){return Oe.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),an.getLastInputBox(He)},createSourceControl(me,we,Ue){return an.createSourceControl(He,me,we,Ue)}},Mt={createCommentController(me,we){return vn.createCommentController(He,me,we)}},hn={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(me,we,Ue){return ct.onDidStartDebugSession(me,we,Ue)},onDidTerminateDebugSession(me,we,Ue){return ct.onDidTerminateDebugSession(me,we,Ue)},onDidChangeActiveDebugSession(me,we,Ue){return ct.onDidChangeActiveDebugSession(me,we,Ue)},onDidReceiveDebugSessionCustomEvent(me,we,Ue){return ct.onDidReceiveDebugSessionCustomEvent(me,we,Ue)},onDidChangeBreakpoints(me,we,Ue){return ct.onDidChangeBreakpoints(me,we,Ue)},registerDebugConfigurationProvider(me,we,Ue){return ct.registerDebugConfigurationProvider(me,we,Ue||Ge.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,we){return ct.registerDebugAdapterDescriptorFactory(He,me,we)},registerDebugAdapterTrackerFactory(me,we){return ct.registerDebugAdapterTrackerFactory(me,we)},startDebugging(me,we,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?ct.startDebugging(me,we,{parentSession:Ue}):ct.startDebugging(me,we,Ue||{})},stopDebugging(me){return ct.stopDebugging(me)},addBreakpoints(me){return ct.addBreakpoints(me)},removeBreakpoints(me){return ct.removeBreakpoints(me)},asDebugSourceUri(me,we){return ct.asDebugSourceUri(me,we)}},Hn={registerTaskProvider:(me,we)=>Et.registerTaskProvider(He,me,we),fetchTasks:me=>Et.fetchTasks(me),executeTask:me=>Et.executeTask(He,me),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(me,we,Ue)=>Et.onDidStartTask(me,we,Ue),onDidEndTask:(me,we,Ue)=>Et.onDidEndTask(me,we,Ue),onDidStartTaskProcess:(me,we,Ue)=>Et.onDidStartTaskProcess(me,we,Ue),onDidEndTaskProcess:(me,we,Ue)=>Et.onDidEndTaskProcess(me,we,Ue)},$n={createNotebookController(me,we,Ue,at,yt){return sn.createNotebookController(He,me,we,Ue,at,(0,Fe.isProposedApiEnabled)(He,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(me,we)=>_t.registerNotebookCellStatusBarItemProvider(He,me,we),createRendererMessaging(me){return gn.createRendererMessaging(He,me)},onDidChangeNotebookCellExecutionState(me,we,Ue){return(0,Fe.checkProposedApiEnabled)(He,"notebookCellExecutionState"),sn.onDidChangeNotebookCellExecutionState(me,we,Ue)}},xn={t(...me){if(typeof me[0]=="string"){const we=me.shift(),Ue=!me||typeof me[0]!="object"?me:me[0];return vt.getMessage(He.identifier.value,{message:we,args:Ue})}return vt.getMessage(He.identifier.value,me[0])},get bundle(){return vt.getBundle(He.identifier.value)},get uri(){return vt.getBundleUri(He.identifier.value)}};return{version:et.version,authentication:un,commands:Un,comments:Mt,debug:hn,env:Tn,extensions:_n,l10n:xn,languages:Wn,notebooks:$n,scm:zn,tasks:Hn,tests:Bn,window:jt,workspace:nn,Breakpoint:z.Breakpoint,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:E.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ge.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionList:z.InlineSuggestionList,Hover:z.Hover,IndentAction:D.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,SnippetTextEdit:z.SnippetTextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItem2:z.TreeItem,TreeItemCheckboxState:z.TreeItemCheckboxState,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:_.UIKind,Uri:y.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,DocumentDropEdit:z.DocumentDropEdit,DocumentPasteEdit:z.DocumentPasteEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,NotebookControllerAffinity2:z.NotebookControllerAffinity2,NotebookEdit:z.NotebookEdit,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:Be.TextSearchCompleteMessageType,DataTransfer:z.DataTransfer,DataTransferItem:z.DataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind,InputBoxValidationSeverity:z.InputBoxValidationSeverity,TabInputText:z.TextTabInput,TabInputTextDiff:z.TextDiffTabInput,TabInputTextMerge:z.TextMergeTabInput,TabInputCustom:z.CustomEditorTabInput,TabInputNotebook:z.NotebookEditorTabInput,TabInputNotebookDiff:z.NotebookDiffEditorTabInput,TabInputWebview:z.WebviewEditorTabInput,TabInputTerminal:z.TerminalEditorTabInput,TabInputInteractiveWindow:z.InteractiveWindowInput,TerminalExitReason:z.TerminalExitReason,LogLevel:Re.LogLevel,EditSessionIdentityMatch:it.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=bt}),define(_e[300],ye([1,0,272,309,310,2,311]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function T(k,E,_,w,f,g){const h=g.environment.useHostProxy,v=typeof h=="boolean"?h:!g.remote.isRemote,m=(0,y.createProxyResolver)({resolveProxy:b=>k.resolveProxy(b),getHttpProxySetting:()=>E.getConfiguration("http").get("proxy"),log:(b,s,...u)=>{switch(b){case y.LogLevel.Trace:w.trace(s,...u);break;case y.LogLevel.Debug:w.debug(s,...u);break;case y.LogLevel.Info:w.info(s,...u);break;case y.LogLevel.Warning:w.warn(s,...u);break;case y.LogLevel.Error:w.error(s,...u);break;case y.LogLevel.Critical:w.error(s,...u);break;case y.LogLevel.Off:break;default:o(b,s,u);break}function o(l,a,...d){w.error("Unknown log level",l),w.error(a,...d)}},getLogLevel:()=>w.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:v,env:process.env}),r=S(E,m);return A(_,r)}e.connectProxyResolver=T;function S(k,E){const _={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(f=>{_.config=k.getConfiguration("http").get("proxySupport")||"off"});const w={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(f=>{w.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},c,(0,y.createHttpPatch)(c,E,{config:"off"},w,!0)),on:Object.assign({},c,(0,y.createHttpPatch)(c,E,{config:"on"},w,!0)),override:Object.assign({},c,(0,y.createHttpPatch)(c,E,{config:"override"},w,!0)),onRequest:Object.assign({},c,(0,y.createHttpPatch)(c,E,_,w,!0)),default:Object.assign(c,(0,y.createHttpPatch)(c,E,_,w,!1))},https:{off:Object.assign({},t,(0,y.createHttpPatch)(t,E,{config:"off"},w,!0)),on:Object.assign({},t,(0,y.createHttpPatch)(t,E,{config:"on"},w,!0)),override:Object.assign({},t,(0,y.createHttpPatch)(t,E,{config:"override"},w,!0)),onRequest:Object.assign({},t,(0,y.createHttpPatch)(t,E,_,w,!0)),default:Object.assign(t,(0,y.createHttpPatch)(t,E,_,w,!1))},tls:Object.assign(I,(0,y.createTlsPatch)(I))}}const D=new Map;function A(k,E){return k.getExtensionPathIndex().then(_=>{const w=Z.__$__nodeRequire("module"),f=w._load;w._load=function(h,v,m){if(h==="tls")return E.tls;if(h!=="http"&&h!=="https")return f.apply(this,arguments);const r=E[h],b=_.findSubstr(P.URI.file(v.filename));let s=D.get(b);if(s||D.set(b,s={}),!s[h]){const u=r.default;s[h]={...u}}return s[h]}})}}),define(_e[301],ye([1,0,74,299,286,300,41,274,2,14,7,271,113,273]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class w extends I.RequireInterceptor{_installInterceptor(){const h=this,v=Z.__$__nodeRequire("module"),m=v._load;v._load=function(u,o,l){return u=b(u),h._factories.has(u)?h._factories.get(u).load(u,S.URI.file((0,E.realpathSync)(o.filename)),a=>m.apply(this,[a,o,l])):m.apply(this,arguments)};const r=v._resolveLookupPaths;v._resolveLookupPaths=(s,u)=>r.call(this,b(s),u);const b=s=>{for(const u of h._alternatives){const o=u(s);if(o){s=o;break}}return s}}}class f extends y.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(_.ExtHostConsoleForwarder);const h=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(T.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const r=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=r.ipcHandlePath}await this._instaService.createInstance(w,h,{mine:this._myRegistry,all:this._globalRegistry}).install(),c.mark("code/extHost/didInitAPI");const m=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,m,this,this._logService,this._mainThreadTelemetryProxy,this._initData),c.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(h){return h.main}async _loadCommonJSModule(h,v,m){if(v.scheme!==D.Schemas.file)throw new Error(`Cannot load URI: '${v}', must be of file-scheme`);let r=null;m.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${v.toString(!0)}`),this._logService.flush();const b=h?.identifier.value;h&&await this._extHostLocalizationService.initializeLocalizedMessages(h);try{b&&c.mark(`code/extHost/willLoadExtensionCode/${b}`),r=Z.__$__nodeRequire(v.fsPath)}finally{b&&c.mark(`code/extHost/didLoadExtensionCode/${b}`),m.codeLoadingStop()}return r}async $setRemoteEnvironment(h){if(!!this._initData.remote.isRemote)for(const v in h){const m=h[v];m===null?delete process.env[v]:process.env[v]=m}}}e.ExtHostExtensionService=f}),define(_e[143],ye([1,0,44,312,295,17,78,37,9,8,2,30,72,313,293,97]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const g=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class h{constructor(p){this.outputChannel=p}provideTextSearchResults(p,C,R,U){return this.outputChannel.appendLine(`provideTextSearchResults ${p.pattern}, ${JSON.stringify({...C,folder:C.folder.toString()})}`),new Promise((H,V)=>{U.onCancellationRequested(()=>x());const L=u(p,C),M=C.folder.fsPath,F=L.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.outputChannel.appendLine(`${g} ${F}
 - cwd: ${M}`);let B=c.spawn(g,L,{cwd:M});B.on("error",de=>{console.error(de),this.outputChannel.appendLine("Error: "+(de&&de.message)),V((0,k.serializeSearchError)(new k.SearchError(de&&de.message,k.SearchErrorCode.rgProcessError)))});let N=!1;const z=new r(C.maxResults,M,C.previewOptions);z.on("result",de=>{N=!0,K="",R.report(de)});let j=!1;const x=()=>{j=!0,B?.kill(),z?.cancel()};let Q=!1;z.on("hitLimit",()=>{Q=!0,x()});let K="";B.stdout.on("data",de=>{z.handleData(de),N||(K+=de)});let le=!1;B.stdout.once("data",()=>le=!0);let ie="";B.stderr.on("data",de=>{const Y=de.toString();this.outputChannel.appendLine(Y),ie.length+Y.length<1e6&&(ie+=Y)}),B.on("close",()=>{if(this.outputChannel.appendLine(le?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),K&&this.outputChannel.appendLine(`Got data without result: ${K}`),this.outputChannel.appendLine(""),j)H({limitHit:Q});else{z.flush(),B=null;let de;ie&&!le&&(de=v(ie))?V((0,k.serializeSearchError)(new k.SearchError(de.message,de.code))):H({limitHit:Q})}})})}}e.RipgrepTextSearchEngine=h;function v(i){const p=i.split(`
`),C=p[0].trim();if(p.some(U=>U.startsWith("regex parse error")))return new k.SearchError(m(p),k.SearchErrorCode.regexParseError);const R=C.match(/grep config error: unknown encoding: (.*)/);if(R)return new k.SearchError(`Unknown encoding: ${R[1]}`,k.SearchErrorCode.unknownEncoding);if(C.startsWith("error parsing glob"))return new k.SearchError(C.charAt(0).toUpperCase()+C.substr(1),k.SearchErrorCode.globParseError);if(C.startsWith("the literal"))return new k.SearchError(C.charAt(0).toUpperCase()+C.substr(1),k.SearchErrorCode.invalidLiteral);if(C.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(C,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=v;function m(i){const p=["Regex parse error"],C=i.filter(R=>R.startsWith("PCRE2:"));if(C.length>=1){const R=C[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const U=R.split(":")[1];p.push(":"+U)}}return p.join("")}e.buildRegexParseError=m;class r extends t.EventEmitter{constructor(p,C,R){super(),this.maxResults=p,this.rootFolder=C,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(p,C){return super.on(p,C),this}handleData(p){if(this.isDone)return;const C=typeof p=="string"?p:this.stringDecoder.write(p);this.handleDecodedData(C)}handleDecodedData(p){let C=p.indexOf(`
`);const R=this.remainder+p;if(C>=0)C+=this.remainder.length;else{this.remainder=R;return}let U=0;for(;C>=0;)this.handleLine(R.substring(U,C).trim()),U=C+1,C=R.indexOf(`
`,U);this.remainder=R.substring(U)}handleLine(p){if(this.isDone||!p)return;let C;try{C=JSON.parse(p)}catch{throw new Error(`malformed line from rg: ${p}`)}if(C.type==="match"){const R=b(C.data.path),U=A.URI.file(S.join(this.rootFolder,R)),H=this.createTextSearchMatch(C.data,U);this.onResult(H),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(C.type==="context"){const R=b(C.data.path),U=A.URI.file(S.join(this.rootFolder,R));this.createTextSearchContext(C.data,U).forEach(V=>this.onResult(V))}}createTextSearchMatch(p,C){const R=p.line_number-1,U=b(p.lines),H=Buffer.from(U);let V=0,L=0,M=R;p.submatches.length===0&&p.submatches.push(U.length?{start:0,end:1,match:{text:U[0]}}:{start:0,end:0,match:{text:""}});const F=(0,P.coalesce)(p.submatches.map((B,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const z=b(B.match),j=H.slice(V,B.start).toString(),x=s(j),Q=x.numLines>0?x.lastLineLength:x.lastLineLength+L,K=s(z),le=x.numLines+M,ie=K.numLines+le,de=K.numLines>0?K.lastLineLength:K.lastLineLength+Q;return V=B.end,L=de,M=ie,new E.Range(le,Q,ie,de)}));return(0,f.createTextSearchResult)(C,U,F,this.previewOptions)}createTextSearchContext(p,C){const R=b(p.lines),U=p.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((H,V)=>({text:H,uri:C,lineNumber:U+V}))}onResult(p){this.emit("result",p)}}e.RipgrepParser=r;function b(i){return i.bytes?Buffer.from(i.bytes,"base64").toString():i.text}function s(i){const p=/\n/g;let C=0,R=-1,U;for(;U=p.exec(i);)C++,R=U.index;const H=R>=0?i.length-R-1:i.length;return{numLines:C,lastLineLength:H}}function u(i,p){const C=["--hidden"];C.push(i.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:U}=(0,y.groupBy)(p.includes,V=>V.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(U&&U.length){const V=new Set;U.forEach(L=>{V.add(L)}),C.push("-g","!*"),V.forEach(L=>{o(L).map(f.anchorGlob).forEach(M=>{C.push("-g",M)})})}R&&R.length&&R.forEach(V=>{C.push("-g",V)}),p.excludes.map(f.anchorGlob).forEach(V=>C.push("-g",`!${V}`)),p.maxFileSize&&C.push("--max-filesize",p.maxFileSize+""),p.useIgnoreFiles?p.useParentIgnoreFiles||C.push("--no-ignore-parent"):C.push("--no-ignore"),p.followSymlinks&&C.push("--follow"),p.encoding&&p.encoding!=="utf8"&&C.push("--encoding",p.encoding),i.pattern==="--"&&(i.isRegExp=!0,i.pattern="\\-\\-"),i.isMultiline&&!i.isRegExp&&(i.pattern=(0,D.escapeRegExpCharacters)(i.pattern),i.isRegExp=!0),p.usePCRE2&&C.push("--pcre2"),C.push("--crlf"),i.isRegExp&&(i.pattern=l(i.pattern),C.push("--engine","auto"));let H;if(i.isWordMatch){const L=(0,D.createRegExp)(i.pattern,!!i.isRegExp,{wholeWord:i.isWordMatch}).source.replace(/\\\//g,"/");C.push("--regexp",L)}else if(i.isRegExp){let V=d(i.pattern);V=n(V),C.push("--regexp",V)}else H=i.pattern,C.push("--fixed-strings");return C.push("--no-config"),p.useGlobalIgnoreFiles||C.push("--no-ignore-global"),C.push("--json"),i.isMultiline&&C.push("--multiline"),p.beforeContext&&C.push("--before-context",p.beforeContext+""),p.afterContext&&C.push("--after-context",p.afterContext+""),C.push("--"),H&&C.push(H),C.push("."),C}function o(i){const p=(0,T.splitGlobAware)(i,"/");return p.map((C,R)=>p.slice(0,R+1).join("/"))}e.spreadGlobComponents=o;function l(i){const p=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;i.match(p);)i=i.replace(p,"$1\\x{$2}");const C=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;i.match(C);)i=i.replace(C,"$1\\x{$2}");return i}e.unicodeEscapesToPCRE2=l;const a=i=>i.type==="Assertion"&&i.kind==="lookbehind";function d(i){let p;try{p=new _.RegExpParser().parsePattern(i)}catch{return i}let C="",R=0;const U=(L,M,F)=>{C+=i.slice(R,L)+F,R=M},H=[];return new _.RegExpVisitor({onCharacterEnter(L){if(L.raw!=="\\n")return;const M=H[0];if(!M)U(L.start,L.end,"\\r?\\n");else if(!H.some(a))if(M.type==="CharacterClass")if(M.negate){const F=i.slice(M.start+2,L.start)+i.slice(L.end,M.end-1);M.parent?.type==="Quantifier"?U(M.start,M.end,F?`[^${F}]`:"."):U(M.start,M.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=i.slice(M.start+1,L.start)+i.slice(L.end,M.end-1);U(M.start,M.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else M.type==="Quantifier"&&U(L.start,L.end,"(?:\\r?\\n)")},onQuantifierEnter(L){H.unshift(L)},onQuantifierLeave(){H.shift()},onCharacterClassRangeEnter(L){H.unshift(L)},onCharacterClassRangeLeave(){H.shift()},onCharacterClassEnter(L){H.unshift(L)},onCharacterClassLeave(){H.shift()},onAssertionEnter(L){a(L)&&H.push(L)},onAssertionLeave(L){H[0]===L&&H.shift()}}).visit(p),C+=i.slice(R),C}e.fixRegexNewline=d;function n(i){return i.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(_e[302],ye([1,0,21,143,124,14]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(D){this.outputChannel=D,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(D,A,k,E){const _=new t.RipgrepTextSearchEngine(this.outputChannel);if(A.folder.scheme===P.Schemas.vscodeUserData){const w={...A,folder:A.folder.with({scheme:P.Schemas.file})},f=new I.Progress(g=>k.report({...g,uri:g.uri.with({scheme:A.folder.scheme})}));return this.withToken(E,g=>_.provideTextSearchResults(D,w,f,g))}else return this.withToken(E,w=>_.provideTextSearchResults(D,A,k,w))}async withToken(D,A){const k=T(D);this.inProgress.add(k);const E=await A(k.token);return this.inProgress.delete(k),E}dispose(){this.inProgress.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=y;function T(S){const D=new c.CancellationTokenSource;return S.onCancellationRequested(()=>D.cancel()),D}}),define(_e[303],ye([1,0,29,143,142]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(S){this.query=S}search(S,D,A){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(_){A({message:_})}},E=new I.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(k),c);return new Promise((_,w)=>E.search(f=>{D(f.map(y))},S).then(f=>_({limitHit:f.limitHit,type:"success",stats:f.stats}),w))}}e.TextSearchEngineAdapter=P;function y(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((S,D)=>{if(D.ranges){const A=D;return S+(Array.isArray(A.ranges)?A.ranges.length:1)}else return S+1},0)}}}),define(_e[304],ye([1,0,17,18,10,4,109,9,51,2,38,30,294,303]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class w{constructor(r="searchProcess"){this.processType=r,this.caches=Object.create(null)}fileSearch(r){let b;const s=h(r),u=new P.Emitter({onDidAddFirstListener:()=>{b=(0,t.createCancelablePromise)(o=>this.doFileSearchWithEngine(E.Engine,s,l=>u.fire(l),o)),b.then(o=>u.fire(o),o=>u.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return u.event}textSearch(r){let b;const s=h(r),u=new P.Emitter({onDidAddFirstListener:()=>{b=(0,t.createCancelablePromise)(o=>this.ripgrepTextSearch(s,l=>u.fire(l),o)),b.then(o=>u.fire(o),o=>u.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return u.event}ripgrepTextSearch(r,b,s){return r.maxFileSize=(0,A.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new _.TextSearchEngineAdapter(r).search(s,b,b)}doFileSearch(r,b,s){return this.doFileSearchWithEngine(E.Engine,r,b,s)}doFileSearchWithEngine(r,b,s,u,o=w.BATCH_SIZE){let l=0;const a=n=>{Array.isArray(n)?(l+=n.length,s(n.map(i=>this.rawMatchToSearchItem(i)))):n.relativePath?(l++,s(this.rawMatchToSearchItem(n))):s(n)};if(b.sortByScore){let n=this.trySortedSearchFromCache(b,a,u);if(!n){const i=b.maxResults?Object.assign({},b,{maxResults:null}):b,p=new r(i);n=this.doSortedSearch(p,b,s,a,u)}return new Promise((i,p)=>{n.then(([C,R])=>{const U=R.map(H=>this.rawMatchToSearchItem(H));this.sendProgress(U,s,o),i(C)},p)})}const d=new r(b);return this.doSearch(d,a,o,u).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.processType,fromCache:!1,resultCount:l,sortingTime:void 0}}))}rawMatchToSearchItem(r){return{path:r.base?(0,T.join)(r.base,r.relativePath):r.relativePath}}doSortedSearch(r,b,s,u,o){const l=new P.Emitter;let a=(0,t.createCancelablePromise)(n=>{let i=[];const p=C=>{Array.isArray(C)?i=C:(u(C),l.fire(C))};return this.doSearch(r,p,-1,n).then(C=>[C,i])}),d;if(b.cacheKey){d=this.getOrCreateCache(b.cacheKey);const n={promise:a,event:l.event,resolved:!1};d.resultsToSearchCache[b.filePattern||""]=n,a.then(()=>{n.resolved=!0},i=>{delete d.resultsToSearchCache[b.filePattern||""]}),a=this.preventCancellation(a)}return a.then(([n,i])=>{const p=d?d.scorerCache:Object.create(null),C=(typeof b.maxResults!="number"||b.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(b,i,p,o).then(R=>{const U=C?C.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:U,fromCache:!1,type:this.processType,workspaceFolderCount:b.folderQueries.length,resultCount:R.length},messages:n.messages,limitHit:n.limitHit||typeof b.maxResults=="number"&&i.length>b.maxResults},R]})})}getOrCreateCache(r){const b=this.caches[r];return b||(this.caches[r]=new f)}trySortedSearchFromCache(r,b,s){const u=r.cacheKey&&this.caches[r.cacheKey];if(!u)return;const o=this.getResultsFromCache(u,r.filePattern||"",b,s);if(o)return o.then(([l,a,d])=>{const n=S.StopWatch.create(!1);return this.sortResults(r,a,u.scorerCache,s).then(i=>{const p=n.elapsed(),C={fromCache:!0,detailStats:d,type:this.processType,resultCount:a.length,sortingTime:p};return[{type:"success",limitHit:l.limitHit||typeof r.maxResults=="number"&&a.length>r.maxResults,stats:C},i]})})}sortResults(r,b,s,u){const o=(0,y.prepareQuery)(r.filePattern||""),l=(d,n)=>(0,y.compareItemsByFuzzyScore)(d,n,o,!0,g,s),a=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return c.topAsync(b,l,a,1e4,u)}sendProgress(r,b,s){if(s&&s>0)for(let u=0;u<r.length;u+=s)b(r.slice(u,u+s));else b(r)}getResultsFromCache(r,b,s,u){const o=S.StopWatch.create(!1),l=b.indexOf(T.sep)>=0;let a;for(const p in r.resultsToSearchCache)if(b.startsWith(p)){if(l&&p.indexOf(T.sep)<0&&p!=="")continue;const C=r.resultsToSearchCache[p];a={promise:this.preventCancellation(C.promise),event:C.event,resolved:C.resolved};break}if(!a)return null;const d=o.elapsed(),n=S.StopWatch.create(!1),i=a.event(s);return u&&u.onCancellationRequested(()=>{i.dispose()}),a.promise.then(([p,C])=>{if(u&&u.isCancellationRequested)throw(0,I.canceled)();const R=[],U=(0,y.prepareQuery)(b).normalizedLowercase;for(const H of C)!(0,k.isFilePatternMatch)(H,U)||R.push(H);return[p,R,{cacheWasResolved:a.resolved,cacheLookupTime:d,cacheFilterTime:n.elapsed(),cacheEntryCount:C.length}]})}doSearch(r,b,s,u){return new Promise((o,l)=>{let a=[];u?.onCancellationRequested(()=>r.cancel()),r.search(d=>{d&&(s?(a.push(d),s>0&&a.length>=s&&(b(a),a=[])):b(d))},d=>{b(d)},(d,n)=>{a.length&&b(a),d?l(d):o(n)})})}clearCache(r){return delete this.caches[r],Promise.resolve(void 0)}preventCancellation(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(b,s){return r.then(b,s)}catch(b){return this.then(void 0,b)}finally(b){return r.finally(b)}}}}e.SearchService=w,w.BATCH_SIZE=512;class f{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(m){return(0,T.basename)(m.relativePath)}getItemDescription(m){return(0,T.dirname)(m.relativePath)}getItemPath(m){return m.relativePath}};function h(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(v),extraFileResources:m.extraFileResources&&m.extraFileResources.map(r=>D.URI.revive(r))}}function v(m){return{...m,folder:D.URI.revive(m.folder)}}}),define(_e[305],ye([1,0,6,14,2,29,13,25,16,76,55,30,304,302,97,142]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let g=class extends D.ExtHostSearch{constructor(v,m,r,b){super(v,r,b),this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const s=new w.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new _.RipgrepSearchProvider(s)),m.remote.isRemote&&m.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const v=new w.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new _.RipgrepSearchProvider(v)),this.registerInternalFileSearchProvider(t.Schemas.file,new E.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(v,m){const r=this._handlePool++;return this._internalFileSearchProvider=m,this._internalFileSearchHandle=r,this._proxy.$registerFileSearchProvider(r,this._transformScheme(v)),(0,c.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(v,m,r,b){const s=(0,D.reviveQuery)(r);return v===this._internalFileSearchHandle?this.doInternalFileSearch(v,m,s,b):super.$provideFileSearchResults(v,m,r,b)}doInternalFileSearch(v,m,r,b){const s=u=>{if((0,k.isSerializedFileMatch)(u)&&(u=[u]),Array.isArray(u)){this._proxy.$handleFileMatch(v,m,u.map(o=>I.URI.file(o.path)));return}u.message&&this._logService.debug("ExtHostSearch",u.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(r,s,b)}$clearCache(v){return this._internalFileSearchProvider?.clearCache(v),super.$clearCache(v)}createTextSearchManager(v,m){return new f.NativeTextSearchManager(v,m,void 0,"textSearchProvider")}};g=Ve([ze(0,S.IExtHostRpcService),ze(1,T.IExtHostInitDataService),ze(2,A.IURITransformerService),ze(3,y.ILogService)],g),e.NativeExtHostSearch=g}),define(_e[306],ye([1,0,84,277,289,288,305,301,278,75,41,76,73,40,54,70,276,275,13,290,47]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h,v,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(A.IExtHostExtensionService,T.ExtHostExtensionService,0),(0,c.registerSingleton)(v.ILoggerService,h.ExtHostLoggerService,1),(0,c.registerSingleton)(f.IExtensionStoragePaths,g.ExtensionStoragePaths,0),(0,c.registerSingleton)(D.IExtHostDebugService,P.ExtHostDebugService,0),(0,c.registerSingleton)(k.IExtHostSearch,y.NativeExtHostSearch,0),(0,c.registerSingleton)(E.IExtHostTask,I.ExtHostTask,0),(0,c.registerSingleton)(_.IExtHostTerminalService,t.ExtHostTerminalService,0),(0,c.registerSingleton)(w.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,c.registerSingleton)(r.IExtHostVariableResolverProvider,m.NodeExtHostVariableResolverProviderService,0)}),define(_e[314],ye([1,0,218,315,74,10,116,117,197,92,287,23,29,113,18,119,213,227,291,306]),function(Z,e,c,t,I,P,y,T,S,D,A,k,E,_,w,f,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let d=0;d<process.execArgv.length;d++)process.execArgv[d]==="--inspect-port=0"&&(process.execArgv.splice(d,1),d--)}();const v=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const a=Z.__$__nodeRequire("module"),d=a._load;a._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return d.apply(this,arguments)}})();const m=process.exit.bind(process);function r(a){process.exit=function(d){if(a)m(d);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const d=new Error("An extension called process.crash() and this was prevented.");console.warn(d.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let b=function(a){m()};function s(){const a=(0,h.readExtHostConnection)(process.env);if(a.type===3)return new Promise((d,n)=>{const i=p=>{const C=p[0],R=new y.BufferedEmitter;C.on("message",U=>R.fire(k.VSBuffer.wrap(U.data))),C.on("close",()=>{b("renderer closed the MessagePort")}),C.start(),d({onMessage:R.event,send:U=>C.postMessage(U.buffer)})};process?.parentPort.on("message",p=>i(p.ports))});if(a.type===2)return new Promise((d,n)=>{let i=null;const p=setTimeout(()=>{b("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),C=108e5,R=3e5,U=new w.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (1)"),C),H=new w.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (2)"),R);process.on("message",(L,M)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){M.setNoDelay(!0);const F=k.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let B;if(L.skipWebSocketFrames)B=new T.NodeSocket(M,"extHost-socket");else{const N=k.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));B=new T.WebSocketNodeSocket(new T.NodeSocket(M,"extHost-socket"),L.permessageDeflate,N,!1)}i?(U.cancel(),H.cancel(),i.beginAcceptReconnection(B,F),i.endAcceptReconnection(),i.sendResume()):(clearTimeout(p),i=new y.PersistentProtocol(B,F),i.sendResume(),i.onDidDispose(()=>b("renderer disconnected")),d(i),i.onSocketClose(()=>{U.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(H.isScheduled())return;U.isScheduled()&&H.schedule()}});const V={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(V)});{const d=a.pipeName;return new Promise((n,i)=>{const p=c.createConnection(d,()=>{p.removeListener("error",i);const C=new y.PersistentProtocol(new T.NodeSocket(p,"extHost-renderer"));C.sendResume(),n(C)});p.once("error",i),p.on("close",()=>{b("renderer closed the socket")})})}}async function u(){const a=await s();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,a.onMessage(d=>{(0,D.isMessageOfType)(d,2)?(this._terminating=!0,b("received terminate message from renderer")):this._onMessage.fire(d)})}send(d){this._terminating||a.send(d)}async drain(){if(a.drain)return a.drain()}}}function o(a){return new Promise(d=>{const n=a.onMessage(i=>{n.dispose();const p=JSON.parse(i.toString()),C=p.commit,R=S.default.commit;if(C&&R&&C!==R&&m(55),p.parentPid){let U=0;setInterval(function(){try{process.kill(p.parentPid,0),U=0}catch(V){V&&V.code==="EPERM"?(U++,U>=3&&b(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):b(`parent process ${p.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let H;try{H=Z.__$__nodeRequire("native-watchdog"),H.start(p.parentPid)}catch(V){(0,P.onUnexpectedError)(V)}}a.send((0,D.createMessageOfType)(0)),d({protocol:a,initData:p})});a.send((0,D.createMessageOfType)(1))})}async function l(){const a=[];process.on("unhandledRejection",(U,H)=>{a.push(H),setTimeout(()=>{const V=a.indexOf(H);V>=0&&H.catch(L=>{a.splice(V,1),(0,P.isCancellationError)(L)||(console.warn(`rejected promise not handled within 1 second: ${L}`),L&&L.stack&&console.warn(`stack trace: ${L.stack}`),U&&(0,P.onUnexpectedError)(U))})},1e3)}),process.on("rejectionHandled",U=>{const H=a.indexOf(U);H>=0&&a.splice(H,1)}),process.on("uncaughtException",function(U){(0,P.onUnexpectedError)(U)}),I.mark("code/extHost/willConnectToRenderer");const d=await u();I.mark("code/extHost/didConnectToRenderer");const n=await o(d);I.mark("code/extHost/didWaitForInitData");const{initData:i}=n;r(!!i.environment.extensionTestsLocationURI),i.environment.useHostProxy=v.useHostProxy!==void 0?v.useHostProxy!=="false":void 0,i.environment.skipWorkspaceStorageLock=(0,f.boolean)(v.skipWorkspaceStorageLock,!1);const p=new class{constructor(){this.pid=process.pid}exit(H){m(H)}exists(H){return E.Promises.exists(H)}realpath(H){return(0,_.realpath)(H)}};let C=null;i.remote.authority&&v.transformURIs&&(C=(0,g.createURITransformer)(i.remote.authority));const R=new A.ExtensionHostMain(n.protocol,i,p,C);b=U=>R.terminate(U)}l().catch(a=>console.log(a))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/96db0b339360bc72d27d869d81a557540ad5f800/core/vs/workbench/api/node/extensionHostProcess.js.map
