/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/errorMessage","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/base/common/process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/observableValue","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ie=function(ie){for(var e=[],i=0,I=ie.length;i<I;i++)e[i]=De[ie[i]];return e};define(De[77],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(D,A){const y=Object.create(null);for(const k of D){const R=A(k);let b=y[R];b||(b=y[R]=[]),b.push(k)}return y}e.groupBy=i;function I(D,A){const y=[],k=[];for(const R of D)A.has(R)||y.push(R);for(const R of A)D.has(R)||k.push(R);return{removed:y,added:k}}e.diffSets=I;function S(D,A){const y=[],k=[];for(const[R,b]of D)A.has(R)||y.push(b);for(const[R,b]of A)D.has(R)||k.push(b);return{removed:y,added:k}}e.diffMaps=S;class M{constructor(){this.map=new Map}add(A,y){let k=this.map.get(A);k||(k=new Set,this.map.set(A,k)),k.add(y)}delete(A,y){const k=this.map.get(A);!k||(k.delete(y),k.size===0&&this.map.delete(A))}forEach(A,y){const k=this.map.get(A);!k||k.forEach(y)}}e.SetMap=M}),define(De[58],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(D){return(A,y,k)=>{let R=null,b=null;if(typeof k.value=="function"?(R="value",b=k.value):typeof k.get=="function"&&(R="get",b=k.get),!b)throw new Error("not supported");k[R]=D(b,y)}}function I(D,A,y){let k=null,R=null;if(typeof y.value=="function"?(k="value",R=y.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(k="get",R=y.get),!R)throw new Error("not supported");const b=`$memoize$${A}`;y[k]=function(...p){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,p)}),this[b]}}e.memoize=I;function S(D,A,y){return i((k,R)=>{const b=`$debounce$${R}`,p=`$debounce$result$${R}`;return function(...E){this[p]||(this[p]=y?y():void 0),clearTimeout(this[b]),A&&(this[p]=A(this[p],...E),E=[this[p]]),this[b]=setTimeout(()=>{k.apply(this,E),this[p]=y?y():void 0},D)}})}e.debounce=S;function M(D,A,y){return i((k,R)=>{const b=`$throttle$timer$${R}`,p=`$throttle$result$${R}`,E=`$throttle$lastRun$${R}`,m=`$throttle$pending$${R}`;return function(...t){if(this[p]||(this[p]=y?y():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),A&&(this[p]=A(this[p],...t)),this[m])return;const o=this[E]+D;o<=Date.now()?(this[E]=Date.now(),k.apply(this,[this[p]]),this[p]=y?y():void 0):(this[m]=!0,this[b]=setTimeout(()=>{this[m]=!1,this[E]=Date.now(),k.apply(this,[this[p]]),this[p]=y?y():void 0},o-Date.now()))}})}e.throttle=M}),define(De[78],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(De[106],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var I;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(r){r.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function D(r,c=!1){let n=0;const u=r.length;let l="",f=0,s=16,h=0;function v(F){let O=0,x=0;for(;O<F;){const B=r.charCodeAt(n);if(B>=48&&B<=57)x=x*16+B-48;else if(B>=65&&B<=70)x=x*16+B-65+10;else if(B>=97&&B<=102)x=x*16+B-97+10;else break;n++,O++}return O<F&&(x=-1),x}function P(F){n=F,l="",f=0,s=16,h=0}function L(){const F=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&k(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&k(r.charCodeAt(n)))for(n++;n<r.length&&k(r.charCodeAt(n));)n++;else return h=3,r.substring(F,n);let O=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&k(r.charCodeAt(n))){for(n++;n<r.length&&k(r.charCodeAt(n));)n++;O=n}else h=3;return r.substring(F,O)}function j(){let F="",O=n;for(;;){if(n>=u){F+=r.substring(O,n),h=2;break}const x=r.charCodeAt(n);if(x===34){F+=r.substring(O,n),n++;break}if(x===92){if(F+=r.substring(O,n),n++,n>=u){h=2;break}switch(r.charCodeAt(n++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const H=v(4);H>=0?F+=String.fromCharCode(H):h=4;break}default:h=5}O=n;continue}if(x>=0&&x<=31)if(y(x)){F+=r.substring(O,n),h=2;break}else h=6;n++}return F}function W(){if(l="",h=0,f=n,n>=u)return f=u,s=17;let F=r.charCodeAt(n);if(A(F)){do n++,l+=String.fromCharCode(F),F=r.charCodeAt(n);while(A(F));return s=15}if(y(F))return n++,l+=String.fromCharCode(F),F===13&&r.charCodeAt(n)===10&&(n++,l+=`
`),s=14;switch(F){case 123:return n++,s=1;case 125:return n++,s=2;case 91:return n++,s=3;case 93:return n++,s=4;case 58:return n++,s=6;case 44:return n++,s=5;case 34:return n++,l=j(),s=10;case 47:{const O=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<u&&!y(r.charCodeAt(n));)n++;return l=r.substring(O,n),s=12}if(r.charCodeAt(n+1)===42){n+=2;const x=u-1;let B=!1;for(;n<x;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,B=!0;break}n++}return B||(n++,h=1),l=r.substring(O,n),s=13}return l+=String.fromCharCode(F),n++,s=16}case 45:if(l+=String.fromCharCode(F),n++,n===u||!k(r.charCodeAt(n)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=L(),s=11;default:for(;n<u&&V(F);)n++,F=r.charCodeAt(n);if(f!==n){switch(l=r.substring(f,n),l){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return l+=String.fromCharCode(F),n++,s=16}}function V(F){if(A(F)||y(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function C(){let F;do F=W();while(F>=12&&F<=15);return F}return{setPosition:P,getPosition:()=>n,scan:c?C:W,getToken:()=>s,getTokenValue:()=>l,getTokenOffset:()=>f,getTokenLength:()=>n-f,getTokenError:()=>h}}e.createScanner=D;function A(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function y(r){return r===10||r===13||r===8232||r===8233}function k(r){return r>=48&&r<=57}var R;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(R||(R={}));function b(r,c){const n=[],u=new Object;let l;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function h(v,P,L,j){f.value=v,f.offset=P,f.length=L,f.type=j,f.colonOffset=void 0,l=f}try{w(r,{onObjectBegin:(v,P)=>{if(c<=v)throw u;l=void 0,s=c>v,n.push("")},onObjectProperty:(v,P,L)=>{if(c<P||(h(v,P,L,"property"),n[n.length-1]=v,c<=P+L))throw u},onObjectEnd:(v,P)=>{if(c<=v)throw u;l=void 0,n.pop()},onArrayBegin:(v,P)=>{if(c<=v)throw u;l=void 0,n.push(0)},onArrayEnd:(v,P)=>{if(c<=v)throw u;l=void 0,n.pop()},onLiteralValue:(v,P,L)=>{if(c<P||(h(v,P,L,T(v)),c<=P+L))throw u},onSeparator:(v,P,L)=>{if(c<=P)throw u;if(v===":"&&l&&l.type==="property")l.colonOffset=P,s=!1,l=void 0;else if(v===","){const j=n[n.length-1];typeof j=="number"?n[n.length-1]=j+1:(s=!0,n[n.length-1]=""),l=void 0}}})}catch(v){if(v!==u)throw v}return{path:n,previousNode:l,isAtPropertyKey:s,matches:v=>{let P=0;for(let L=0;P<v.length&&L<n.length;L++)if(v[P]===n[L]||v[P]==="*")P++;else if(v[P]!=="**")return!1;return P===v.length}}}e.getLocation=b;function p(r,c=[],n=M.DEFAULT){let u=null,l=[];const f=[];function s(v){Array.isArray(l)?l.push(v):u!==null&&(l[u]=v)}return w(r,{onObjectBegin:()=>{const v={};s(v),f.push(l),l=v,u=null},onObjectProperty:v=>{u=v},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const v=[];s(v),f.push(l),l=v,u=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:s,onError:(v,P,L)=>{c.push({error:v,offset:P,length:L})}},n),l[0]}e.parse=p;function E(r,c=[],n=M.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(v){u.type==="property"&&(u.length=v-u.offset,u=u.parent)}function f(v){return u.children.push(v),v}w(r,{onObjectBegin:v=>{u=f({type:"object",offset:v,length:-1,parent:u,children:[]})},onObjectProperty:(v,P,L)=>{u=f({type:"property",offset:P,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:v,offset:P,length:L,parent:u})},onObjectEnd:(v,P)=>{u.length=v+P-u.offset,u=u.parent,l(v+P)},onArrayBegin:(v,P)=>{u=f({type:"array",offset:v,length:-1,parent:u,children:[]})},onArrayEnd:(v,P)=>{u.length=v+P-u.offset,u=u.parent,l(v+P)},onLiteralValue:(v,P,L)=>{f({type:T(v),offset:P,length:L,parent:u,value:v}),l(P+L)},onSeparator:(v,P,L)=>{u.type==="property"&&(v===":"?u.colonOffset=P:v===","&&l(P))},onError:(v,P,L)=>{c.push({error:v,offset:P,length:L})}},n);const h=u.children[0];return h&&delete h.parent,h}e.parseTree=E;function m(r,c){if(!r)return;let n=r;for(const u of c)if(typeof u=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const f of n.children)if(Array.isArray(f.children)&&f.children[0].value===u){n=f.children[1],l=!0;break}if(!l)return}else{const l=u;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}e.findNodeAtLocation=m;function t(r){if(!r.parent||!r.parent.children)return[];const c=t(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;c.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&c.push(n)}return c}e.getNodePath=t;function o(r){switch(r.type){case"array":return r.children.map(o);case"object":{const c=Object.create(null);for(const n of r.children){const u=n.children[1];u&&(c[n.children[0].value]=o(u))}return c}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=o;function a(r,c,n=!1){return c>=r.offset&&c<r.offset+r.length||n&&c===r.offset+r.length}e.contains=a;function g(r,c,n=!1){if(a(r,c,n)){const u=r.children;if(Array.isArray(u))for(let l=0;l<u.length&&u[l].offset<=c;l++){const f=g(u[l],c,n);if(f)return f}return r}}e.findNodeAtOffset=g;function w(r,c,n=M.DEFAULT){const u=D(r,!1);function l(le){return le?()=>le(u.getTokenOffset(),u.getTokenLength()):()=>!0}function f(le){return le?de=>le(de,u.getTokenOffset(),u.getTokenLength()):()=>!0}const s=l(c.onObjectBegin),h=f(c.onObjectProperty),v=l(c.onObjectEnd),P=l(c.onArrayBegin),L=l(c.onArrayEnd),j=f(c.onLiteralValue),W=f(c.onSeparator),V=l(c.onComment),C=f(c.onError),F=n&&n.disallowComments,O=n&&n.allowTrailingComma;function x(){for(;;){const le=u.scan();switch(u.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:F||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(le){case 12:case 13:F?B(10):V();break;case 16:B(1);break;case 15:case 14:break;default:return le}}}function B(le,de=[],Y=[]){if(C(le),de.length+Y.length>0){let me=u.getToken();for(;me!==17;){if(de.indexOf(me)!==-1){x();break}else if(Y.indexOf(me)!==-1)break;me=x()}}}function H(le){const de=u.getTokenValue();return le?j(de):h(de),x(),!0}function G(){switch(u.getToken()){case 11:{let le=0;try{le=JSON.parse(u.getTokenValue()),typeof le!="number"&&(B(2),le=0)}catch{B(2)}j(le);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return x(),!0}function ee(){return u.getToken()!==10?(B(3,[],[2,5]),!1):(H(!1),u.getToken()===6?(W(":"),x(),pe()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function ue(){s(),x();let le=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(le||B(4,[],[]),W(","),x(),u.getToken()===2&&O)break}else le&&B(6,[],[]);ee()||B(4,[],[2,5]),le=!0}return v(),u.getToken()!==2?B(7,[2],[]):x(),!0}function re(){P(),x();let le=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(le||B(4,[],[]),W(","),x(),u.getToken()===4&&O)break}else le&&B(6,[],[]);pe()||B(4,[],[4,5]),le=!0}return L(),u.getToken()!==4?B(8,[4],[]):x(),!0}function pe(){switch(u.getToken()){case 3:return re();case 1:return ue();case 10:return H(!0);default:return G()}}return x(),u.getToken()===17?n.allowEmptyContent?!0:(B(4,[],[]),!1):pe()?(u.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=w;function d(r,c){const n=D(r),u=[];let l,f=0,s;do switch(s=n.getPosition(),l=n.scan(),l){case 12:case 13:case 17:f!==s&&u.push(r.substring(f,s)),c!==void 0&&u.push(n.getTokenValue().replace(/[^\r\n]/g,c)),f=n.getPosition();break}while(l!==17);return u.join("")}e.stripComments=d;function T(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=T}),define(De[28],Ie([1,0]),function(ie,e){"use strict";var i,I,S;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(m,t,o){let a=m.get(t);return a===void 0&&(a=o,m.set(t,a)),a}e.getOrSet=M;function D(m){const t=[];return m.forEach((o,a)=>{t.push(`${a} => ${o}`)}),`Map(${m.size}) {${t.join(", ")}}`}e.mapToString=D;function A(m){const t=[];return m.forEach(o=>{t.push(o)}),`Set(${m.size}) {${t.join(", ")}}`}e.setToString=A;class y{constructor(t,o){this.uri=t,this.value=o}}class k{constructor(t,o){this[i]="ResourceMap",t instanceof k?(this.map=new Map(t.map),this.toKey=o??k.defaultToKey):(this.map=new Map,this.toKey=t??k.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new y(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o<"u"&&(t=t.bind(o));for(const[a,g]of this.map)t(g.value,g.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=k,k.defaultToKey=m=>m.toString();class R{constructor(t,o){this[I]="ResourceSet",!t||typeof t=="function"?this._map=new k(t):(this._map=new k(o),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,o){this._map.forEach((a,g)=>t.call(o,g,g,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var b;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class p{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const a=this._map.get(t);if(!!a)return o!==0&&this.touch(a,o),a.value}set(t,o,a=0){let g=this._map.get(t);if(g)g.value=o,a!==0&&this.touch(g,a);else{switch(g={key:t,value:o,next:void 0,previous:void 0},a){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(t,g),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(!!o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const a=this._state;let g=this._head;for(;g;){if(o?t.bind(o)(g.value,g.key,this):t(g.value,g.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const t=this,o=this._state;let a=this._head;const g={[Symbol.iterator](){return g},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const w={value:a.key,done:!1};return a=a.next,w}else return{value:void 0,done:!0}}};return g}values(){const t=this,o=this._state;let a=this._head;const g={[Symbol.iterator](){return g},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const w={value:a.value,done:!1};return a=a.next,w}else return{value:void 0,done:!0}}};return g}entries(){const t=this,o=this._state;let a=this._head;const g={[Symbol.iterator](){return g},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const w={value:[a.key,a.value],done:!1};return a=a.next,w}else return{value:void 0,done:!0}}};return g}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,a=this.size;for(;o&&a>t;)this._map.delete(o.key),o=o.next,a--;this._head=o,this._size=a,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,a=t.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const a=t.next,g=t.previous;t===this._tail?(g.next=void 0,this._tail=g):(a.previous=g,g.next=a),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const a=t.next,g=t.previous;t===this._head?(a.previous=void 0,this._head=a):(a.previous=g,g.next=a),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,a)=>{t.push([a,o])}),t}fromJSON(t){this.clear();for(const[o,a]of t)this.set(o,a)}}e.LinkedMap=p;class E extends p{constructor(t,o=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=E}),function(ie,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[107],Ie([0]),e):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(ke,ye){for(var Ce=0;Ce<ye.length;Ce++){var se=ye[Ce];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(ke,se.key,se)}}function i(ke,ye,Ce){return ye&&e(ke.prototype,ye),Ce&&e(ke,Ce),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function I(ke,ye){if(!!ke){if(typeof ke=="string")return S(ke,ye);var Ce=Object.prototype.toString.call(ke).slice(8,-1);if(Ce==="Object"&&ke.constructor&&(Ce=ke.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(ke);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return S(ke,ye)}}function S(ke,ye){(ye==null||ye>ke.length)&&(ye=ke.length);for(var Ce=0,se=new Array(ye);Ce<ye;Ce++)se[Ce]=ke[Ce];return se}function M(ke,ye){var Ce=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(Ce)return(Ce=Ce.call(ke)).next.bind(Ce);if(Array.isArray(ke)||(Ce=I(ke))||ye&&ke&&typeof ke.length=="number"){Ce&&(ke=Ce);var se=0;return function(){return se>=ke.length?{done:!0}:{done:!1,value:ke[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=D();function A(ke){ie.defaults=ke}var y=/[&<>"']/,k=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ye){return p[ye]};function m(ke,ye){if(ye){if(y.test(ke))return ke.replace(k,E)}else if(R.test(ke))return ke.replace(b,E);return ke}var t=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ke){return ke.replace(t,function(ye,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var a=/(^|[^\[])\^/g;function g(ke,ye){ke=typeof ke=="string"?ke:ke.source,ye=ye||"";var Ce={replace:function(ae,J){return J=J.source||J,J=J.replace(a,"$1"),ke=ke.replace(ae,J),Ce},getRegex:function(){return new RegExp(ke,ye)}};return Ce}var w=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function T(ke,ye,Ce){if(ke){var se;try{se=decodeURIComponent(o(Ce)).replace(w,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}ye&&!d.test(Ce)&&(Ce=l(ye,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch{return null}return Ce}var r={},c=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(ke,ye){r[" "+ke]||(c.test(ke)?r[" "+ke]=ke+"/":r[" "+ke]=v(ke,"/",!0)),ke=r[" "+ke];var Ce=ke.indexOf(":")===-1;return ye.substring(0,2)==="//"?Ce?ye:ke.replace(n,"$1")+ye:ye.charAt(0)==="/"?Ce?ye:ke.replace(u,"$1")+ye:ke+ye}var f={exec:function(){}};function s(ke){for(var ye=1,Ce,se;ye<arguments.length;ye++){Ce=arguments[ye];for(se in Ce)Object.prototype.hasOwnProperty.call(Ce,se)&&(ke[se]=Ce[se])}return ke}function h(ke,ye){var Ce=ke.replace(/\|/g,function(J,_,N){for(var $=!1,q=_;--q>=0&&N[q]==="\\";)$=!$;return $?"|":" |"}),se=Ce.split(/ \|/),ae=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>ye)se.splice(ye);else for(;se.length<ye;)se.push("");for(;ae<se.length;ae++)se[ae]=se[ae].trim().replace(/\\\|/g,"|");return se}function v(ke,ye,Ce){var se=ke.length;if(se===0)return"";for(var ae=0;ae<se;){var J=ke.charAt(se-ae-1);if(J===ye&&!Ce)ae++;else if(J!==ye&&Ce)ae++;else break}return ke.slice(0,se-ae)}function P(ke,ye){if(ke.indexOf(ye[1])===-1)return-1;for(var Ce=ke.length,se=0,ae=0;ae<Ce;ae++)if(ke[ae]==="\\")ae++;else if(ke[ae]===ye[0])se++;else if(ke[ae]===ye[1]&&(se--,se<0))return ae;return-1}function L(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(ke,ye){if(ye<1)return"";for(var Ce="";ye>1;)ye&1&&(Ce+=ke),ye>>=1,ke+=ke;return Ce+ke}function W(ke,ye,Ce,se){var ae=ye.href,J=ye.title?m(ye.title):null,_=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){se.state.inLink=!0;var N={type:"link",raw:Ce,href:ae,title:J,text:_,tokens:se.inlineTokens(_)};return se.state.inLink=!1,N}return{type:"image",raw:Ce,href:ae,title:J,text:m(_)}}function V(ke,ye){var Ce=ke.match(/^(\s+)(?:```)/);if(Ce===null)return ye;var se=Ce[1];return ye.split(`
`).map(function(ae){var J=ae.match(/^\s+/);if(J===null)return ae;var _=J[0];return _.length>=se.length?ae.slice(se.length):ae}).join(`
`)}var C=function(){function ke(Ce){this.options=Ce||ie.defaults}var ye=ke.prototype;return ye.space=function(se){var ae=this.rules.block.newline.exec(se);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},ye.code=function(se){var ae=this.rules.block.code.exec(se);if(ae){var J=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?J:v(J,`
`)}}},ye.fences=function(se){var ae=this.rules.block.fences.exec(se);if(ae){var J=ae[0],_=V(J,ae[3]||"");return{type:"code",raw:J,lang:ae[2]?ae[2].trim():ae[2],text:_}}},ye.heading=function(se){var ae=this.rules.block.heading.exec(se);if(ae){var J=ae[2].trim();if(/#$/.test(J)){var _=v(J,"#");(this.options.pedantic||!_||/ $/.test(_))&&(J=_.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:J,tokens:this.lexer.inline(J)}}},ye.hr=function(se){var ae=this.rules.block.hr.exec(se);if(ae)return{type:"hr",raw:ae[0]}},ye.blockquote=function(se){var ae=this.rules.block.blockquote.exec(se);if(ae){var J=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},ye.list=function(se){var ae=this.rules.block.list.exec(se);if(ae){var J,_,N,$,q,Z,ce,be,oe,we,ve,Ue,ze=ae[1].trim(),et=ze.length>1,Ke={type:"list",raw:"",ordered:et,start:et?+ze.slice(0,-1):"",loose:!1,items:[]};ze=et?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=et?ze:"[*+-]");for(var tt=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(Ue=!1,!(!(ae=tt.exec(se))||this.rules.block.hr.test(se)));){if(J=ae[0],se=se.substring(J.length),be=ae[2].split(`
`,1)[0],oe=se.split(`
`,1)[0],this.options.pedantic?($=2,ve=be.trimLeft()):($=ae[2].search(/[^ ]/),$=$>4?1:$,ve=be.slice($),$+=ae[1].length),Z=!1,!be&&/^ *$/.test(oe)&&(J+=oe+`
`,se=se.substring(oe.length+1),Ue=!0),!Ue)for(var Fe=new RegExp("^ {0,"+Math.min(3,$-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,$-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),X=new RegExp("^ {0,"+Math.min(3,$-1)+"}(?:```|~~~)"),Q=new RegExp("^ {0,"+Math.min(3,$-1)+"}#");se&&(we=se.split(`
`,1)[0],be=we,this.options.pedantic&&(be=be.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(X.test(be)||Q.test(be)||Fe.test(be)||ht.test(se)));){if(be.search(/[^ ]/)>=$||!be.trim())ve+=`
`+be.slice($);else if(!Z)ve+=`
`+be;else break;!Z&&!be.trim()&&(Z=!0),J+=we+`
`,se=se.substring(we.length+1)}Ke.loose||(ce?Ke.loose=!0:/\n *\n *$/.test(J)&&(ce=!0)),this.options.gfm&&(_=/^\[[ xX]\] /.exec(ve),_&&(N=_[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Ke.items.push({type:"list_item",raw:J,task:!!_,checked:N,loose:!1,text:ve}),Ke.raw+=J}Ke.items[Ke.items.length-1].raw=J.trimRight(),Ke.items[Ke.items.length-1].text=ve.trimRight(),Ke.raw=Ke.raw.trimRight();var ge=Ke.items.length;for(q=0;q<ge;q++){this.lexer.state.top=!1,Ke.items[q].tokens=this.lexer.blockTokens(Ke.items[q].text,[]);var Ne=Ke.items[q].tokens.filter(function(qe){return qe.type==="space"}),je=Ne.every(function(qe){for(var We=qe.raw.split(""),Ze=0,nt=M(We),ct;!(ct=nt()).done;){var It=ct.value;if(It===`
`&&(Ze+=1),Ze>1)return!0}return!1});!Ke.loose&&Ne.length&&je&&(Ke.loose=!0,Ke.items[q].loose=!0)}return Ke}},ye.html=function(se){var ae=this.rules.block.html.exec(se);if(ae){var J={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var _=this.options.sanitizer?this.options.sanitizer(ae[0]):m(ae[0]);J.type="paragraph",J.text=_,J.tokens=this.lexer.inline(_)}return J}},ye.def=function(se){var ae=this.rules.block.def.exec(se);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var J=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:ae[0],href:ae[2],title:ae[3]}}},ye.table=function(se){var ae=this.rules.block.table.exec(se);if(ae){var J={type:"table",header:h(ae[1]).map(function(ce){return{text:ce}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=ae[0];var _=J.align.length,N,$,q,Z;for(N=0;N<_;N++)/^ *-+: *$/.test(J.align[N])?J.align[N]="right":/^ *:-+: *$/.test(J.align[N])?J.align[N]="center":/^ *:-+ *$/.test(J.align[N])?J.align[N]="left":J.align[N]=null;for(_=J.rows.length,N=0;N<_;N++)J.rows[N]=h(J.rows[N],J.header.length).map(function(ce){return{text:ce}});for(_=J.header.length,$=0;$<_;$++)J.header[$].tokens=this.lexer.inline(J.header[$].text);for(_=J.rows.length,$=0;$<_;$++)for(Z=J.rows[$],q=0;q<Z.length;q++)Z[q].tokens=this.lexer.inline(Z[q].text);return J}}},ye.lheading=function(se){var ae=this.rules.block.lheading.exec(se);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},ye.paragraph=function(se){var ae=this.rules.block.paragraph.exec(se);if(ae){var J=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:J,tokens:this.lexer.inline(J)}}},ye.text=function(se){var ae=this.rules.block.text.exec(se);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},ye.escape=function(se){var ae=this.rules.inline.escape.exec(se);if(ae)return{type:"escape",raw:ae[0],text:m(ae[1])}},ye.tag=function(se){var ae=this.rules.inline.tag.exec(se);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):m(ae[0]):ae[0]}},ye.link=function(se){var ae=this.rules.inline.link.exec(se);if(ae){var J=ae[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var _=v(J.slice(0,-1),"\\");if((J.length-_.length)%2===0)return}else{var N=P(ae[2],"()");if(N>-1){var $=ae[0].indexOf("!")===0?5:4,q=$+ae[1].length+N;ae[2]=ae[2].substring(0,N),ae[0]=ae[0].substring(0,q).trim(),ae[3]=""}}var Z=ae[2],ce="";if(this.options.pedantic){var be=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Z);be&&(Z=be[1],ce=be[3])}else ce=ae[3]?ae[3].slice(1,-1):"";return Z=Z.trim(),/^</.test(Z)&&(this.options.pedantic&&!/>$/.test(J)?Z=Z.slice(1):Z=Z.slice(1,-1)),W(ae,{href:Z&&Z.replace(this.rules.inline._escapes,"$1"),title:ce&&ce.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},ye.reflink=function(se,ae){var J;if((J=this.rules.inline.reflink.exec(se))||(J=this.rules.inline.nolink.exec(se))){var _=(J[2]||J[1]).replace(/\s+/g," ");if(_=ae[_.toLowerCase()],!_||!_.href){var N=J[0].charAt(0);return{type:"text",raw:N,text:N}}return W(J,_,J[0],this.lexer)}},ye.emStrong=function(se,ae,J){J===void 0&&(J="");var _=this.rules.inline.emStrong.lDelim.exec(se);if(!!_&&!(_[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var N=_[1]||_[2]||"";if(!N||N&&(J===""||this.rules.inline.punctuation.exec(J))){var $=_[0].length-1,q,Z,ce=$,be=0,oe=_[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,ae=ae.slice(-1*se.length+$);(_=oe.exec(ae))!=null;)if(q=_[1]||_[2]||_[3]||_[4]||_[5]||_[6],!!q){if(Z=q.length,_[3]||_[4]){ce+=Z;continue}else if((_[5]||_[6])&&$%3&&!(($+Z)%3)){be+=Z;continue}if(ce-=Z,!(ce>0)){if(Z=Math.min(Z,Z+ce+be),Math.min($,Z)%2){var we=se.slice(1,$+_.index+Z);return{type:"em",raw:se.slice(0,$+_.index+Z+1),text:we,tokens:this.lexer.inlineTokens(we)}}var ve=se.slice(2,$+_.index+Z-1);return{type:"strong",raw:se.slice(0,$+_.index+Z+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},ye.codespan=function(se){var ae=this.rules.inline.code.exec(se);if(ae){var J=ae[2].replace(/\n/g," "),_=/[^ ]/.test(J),N=/^ /.test(J)&&/ $/.test(J);return _&&N&&(J=J.substring(1,J.length-1)),J=m(J,!0),{type:"codespan",raw:ae[0],text:J}}},ye.br=function(se){var ae=this.rules.inline.br.exec(se);if(ae)return{type:"br",raw:ae[0]}},ye.del=function(se){var ae=this.rules.inline.del.exec(se);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},ye.autolink=function(se,ae){var J=this.rules.inline.autolink.exec(se);if(J){var _,N;return J[2]==="@"?(_=m(this.options.mangle?ae(J[1]):J[1]),N="mailto:"+_):(_=m(J[1]),N=_),{type:"link",raw:J[0],text:_,href:N,tokens:[{type:"text",raw:_,text:_}]}}},ye.url=function(se,ae){var J;if(J=this.rules.inline.url.exec(se)){var _,N;if(J[2]==="@")_=m(this.options.mangle?ae(J[0]):J[0]),N="mailto:"+_;else{var $;do $=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while($!==J[0]);_=m(J[0]),J[1]==="www."?N="http://"+_:N=_}return{type:"link",raw:J[0],text:_,href:N,tokens:[{type:"text",raw:_,text:_}]}}},ye.inlineText=function(se,ae){var J=this.rules.inline.text.exec(se);if(J){var _;return this.lexer.state.inRawBlock?_=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):m(J[0]):J[0]:_=m(this.options.smartypants?ae(J[0]):J[0]),{type:"text",raw:J[0],text:_}}},ke}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=g(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=g(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=g(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=g(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=g(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=g(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=s({},F),F.gfm=s({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=g(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=g(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=s({},F.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:g(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=g(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=g(F._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=g(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=g(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=g(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=g(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=g(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=g(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=g(O.reflink).replace("label",O._label).replace("ref",F._label).getRegex(),O.nolink=g(O.nolink).replace("ref",F._label).getRegex(),O.reflinkSearch=g(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=s({},O),O.pedantic=s({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=s({},O.normal,{escape:g(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=g(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=s({},O.gfm,{br:g(O.br).replace("{2,}","*").getRegex(),text:g(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function x(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(ke){var ye="",Ce,se,ae=ke.length;for(Ce=0;Ce<ae;Ce++)se=ke.charCodeAt(Ce),Math.random()>.5&&(se="x"+se.toString(16)),ye+="&#"+se+";";return ye}var H=function(){function ke(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||ie.defaults,this.options.tokenizer=this.options.tokenizer||new C,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:F.normal,inline:O.normal};this.options.pedantic?(se.block=F.pedantic,se.inline=O.pedantic):this.options.gfm&&(se.block=F.gfm,this.options.breaks?se.inline=O.breaks:se.inline=O.gfm),this.tokenizer.rules=se}ke.lex=function(se,ae){var J=new ke(ae);return J.lex(se)},ke.lexInline=function(se,ae){var J=new ke(ae);return J.inlineTokens(se)};var ye=ke.prototype;return ye.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},ye.blockTokens=function(se,ae){var J=this;ae===void 0&&(ae=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(ce,be,oe){return be+"    ".repeat(oe.length)});for(var _,N,$,q;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ce){return(_=ce.call({lexer:J},se,ae))?(se=se.substring(_.raw.length),ae.push(_),!0):!1}))){if(_=this.tokenizer.space(se)){se=se.substring(_.raw.length),_.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(_);continue}if(_=this.tokenizer.code(se)){se=se.substring(_.raw.length),N=ae[ae.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+_.raw,N.text+=`
`+_.text,this.inlineQueue[this.inlineQueue.length-1].src=N.text):ae.push(_);continue}if(_=this.tokenizer.fences(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.heading(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.hr(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.blockquote(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.list(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.html(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.def(se)){se=se.substring(_.raw.length),N=ae[ae.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+_.raw,N.text+=`
`+_.raw,this.inlineQueue[this.inlineQueue.length-1].src=N.text):this.tokens.links[_.tag]||(this.tokens.links[_.tag]={href:_.href,title:_.title});continue}if(_=this.tokenizer.table(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.lheading(se)){se=se.substring(_.raw.length),ae.push(_);continue}if($=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var ce=1/0,be=se.slice(1),oe=void 0;J.options.extensions.startBlock.forEach(function(we){oe=we.call({lexer:this},be),typeof oe=="number"&&oe>=0&&(ce=Math.min(ce,oe))}),ce<1/0&&ce>=0&&($=se.substring(0,ce+1))}(),this.state.top&&(_=this.tokenizer.paragraph($))){N=ae[ae.length-1],q&&N.type==="paragraph"?(N.raw+=`
`+_.raw,N.text+=`
`+_.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):ae.push(_),q=$.length!==se.length,se=se.substring(_.raw.length);continue}if(_=this.tokenizer.text(se)){se=se.substring(_.raw.length),N=ae[ae.length-1],N&&N.type==="text"?(N.raw+=`
`+_.raw,N.text+=`
`+_.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):ae.push(_);continue}if(se){var Z="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return this.state.top=!0,ae},ye.inline=function(se,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:se,tokens:ae}),ae},ye.inlineTokens=function(se,ae){var J=this;ae===void 0&&(ae=[]);var _,N,$,q=se,Z,ce,be;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(Z=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)oe.includes(Z[0].slice(Z[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,Z.index)+"["+j("a",Z[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Z=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,Z.index)+"["+j("a",Z[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Z=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,Z.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(ce||(be=""),ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(_=ve.call({lexer:J},se,ae))?(se=se.substring(_.raw.length),ae.push(_),!0):!1}))){if(_=this.tokenizer.escape(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.tag(se)){se=se.substring(_.raw.length),N=ae[ae.length-1],N&&_.type==="text"&&N.type==="text"?(N.raw+=_.raw,N.text+=_.text):ae.push(_);continue}if(_=this.tokenizer.link(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(_.raw.length),N=ae[ae.length-1],N&&_.type==="text"&&N.type==="text"?(N.raw+=_.raw,N.text+=_.text):ae.push(_);continue}if(_=this.tokenizer.emStrong(se,q,be)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.codespan(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.br(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.del(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.autolink(se,B)){se=se.substring(_.raw.length),ae.push(_);continue}if(!this.state.inLink&&(_=this.tokenizer.url(se,B))){se=se.substring(_.raw.length),ae.push(_);continue}if($=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Ue=se.slice(1),ze=void 0;J.options.extensions.startInline.forEach(function(et){ze=et.call({lexer:this},Ue),typeof ze=="number"&&ze>=0&&(ve=Math.min(ve,ze))}),ve<1/0&&ve>=0&&($=se.substring(0,ve+1))}(),_=this.tokenizer.inlineText($,x)){se=se.substring(_.raw.length),_.raw.slice(-1)!=="_"&&(be=_.raw.slice(-1)),ce=!0,N=ae[ae.length-1],N&&N.type==="text"?(N.raw+=_.raw,N.text+=_.text):ae.push(_);continue}if(se){var we="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return ae},i(ke,null,[{key:"rules",get:function(){return{block:F,inline:O}}}]),ke}(),G=function(){function ke(Ce){this.options=Ce||ie.defaults}var ye=ke.prototype;return ye.code=function(se,ae,J){var _=(ae||"").match(/\S*/)[0];if(this.options.highlight){var N=this.options.highlight(se,_);N!=null&&N!==se&&(J=!0,se=N)}return se=se.replace(/\n$/,"")+`
`,_?'<pre><code class="'+this.options.langPrefix+m(_,!0)+'">'+(J?se:m(se,!0))+`</code></pre>
`:"<pre><code>"+(J?se:m(se,!0))+`</code></pre>
`},ye.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},ye.html=function(se){return se},ye.heading=function(se,ae,J,_){if(this.options.headerIds){var N=this.options.headerPrefix+_.slug(J);return"<h"+ae+' id="'+N+'">'+se+"</h"+ae+`>
`}return"<h"+ae+">"+se+"</h"+ae+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(se,ae,J){var _=ae?"ol":"ul",N=ae&&J!==1?' start="'+J+'"':"";return"<"+_+N+`>
`+se+"</"+_+`>
`},ye.listitem=function(se){return"<li>"+se+`</li>
`},ye.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(se){return"<p>"+se+`</p>
`},ye.table=function(se,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ae+`</table>
`},ye.tablerow=function(se){return`<tr>
`+se+`</tr>
`},ye.tablecell=function(se,ae){var J=ae.header?"th":"td",_=ae.align?"<"+J+' align="'+ae.align+'">':"<"+J+">";return _+se+("</"+J+`>
`)},ye.strong=function(se){return"<strong>"+se+"</strong>"},ye.em=function(se){return"<em>"+se+"</em>"},ye.codespan=function(se){return"<code>"+se+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(se){return"<del>"+se+"</del>"},ye.link=function(se,ae,J){if(se=T(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var _='<a href="'+m(se)+'"';return ae&&(_+=' title="'+ae+'"'),_+=">"+J+"</a>",_},ye.image=function(se,ae,J){if(se=T(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var _='<img src="'+se+'" alt="'+J+'"';return ae&&(_+=' title="'+ae+'"'),_+=this.options.xhtml?"/>":">",_},ye.text=function(se){return se},ke}(),ee=function(){function ke(){}var ye=ke.prototype;return ye.strong=function(se){return se},ye.em=function(se){return se},ye.codespan=function(se){return se},ye.del=function(se){return se},ye.html=function(se){return se},ye.text=function(se){return se},ye.link=function(se,ae,J){return""+J},ye.image=function(se,ae,J){return""+J},ye.br=function(){return""},ke}(),ue=function(){function ke(){this.seen={}}var ye=ke.prototype;return ye.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(se,ae){var J=se,_=0;if(this.seen.hasOwnProperty(J)){_=this.seen[se];do _++,J=se+"-"+_;while(this.seen.hasOwnProperty(J))}return ae||(this.seen[se]=_,this.seen[J]=0),J},ye.slug=function(se,ae){ae===void 0&&(ae={});var J=this.serialize(se);return this.getNextSafeSlug(J,ae.dryrun)},ke}(),re=function(){function ke(Ce){this.options=Ce||ie.defaults,this.options.renderer=this.options.renderer||new G,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ee,this.slugger=new ue}ke.parse=function(se,ae){var J=new ke(ae);return J.parse(se)},ke.parseInline=function(se,ae){var J=new ke(ae);return J.parseInline(se)};var ye=ke.prototype;return ye.parse=function(se,ae){ae===void 0&&(ae=!0);var J="",_,N,$,q,Z,ce,be,oe,we,ve,Ue,ze,et,Ke,tt,Fe,ht,X,Q,ge=se.length;for(_=0;_<ge;_++){if(ve=se[_],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(Q=this.options.extensions.renderers[ve.type].call({parser:this},ve),Q!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){J+=Q||"";continue}switch(ve.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,o(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(oe="",be="",q=ve.header.length,N=0;N<q;N++)be+=this.renderer.tablecell(this.parseInline(ve.header[N].tokens),{header:!0,align:ve.align[N]});for(oe+=this.renderer.tablerow(be),we="",q=ve.rows.length,N=0;N<q;N++){for(ce=ve.rows[N],be="",Z=ce.length,$=0;$<Z;$++)be+=this.renderer.tablecell(this.parseInline(ce[$].tokens),{header:!1,align:ve.align[$]});we+=this.renderer.tablerow(be)}J+=this.renderer.table(oe,we);continue}case"blockquote":{we=this.parse(ve.tokens),J+=this.renderer.blockquote(we);continue}case"list":{for(Ue=ve.ordered,ze=ve.start,et=ve.loose,q=ve.items.length,we="",N=0;N<q;N++)tt=ve.items[N],Fe=tt.checked,ht=tt.task,Ke="",tt.task&&(X=this.renderer.checkbox(Fe),et?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=X+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=X+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:X}):Ke+=X),Ke+=this.parse(tt.tokens,et),we+=this.renderer.listitem(Ke,ht,Fe);J+=this.renderer.list(we,Ue,ze);continue}case"html":{J+=this.renderer.html(ve.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(we=ve.tokens?this.parseInline(ve.tokens):ve.text;_+1<ge&&se[_+1].type==="text";)ve=se[++_],we+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);J+=ae?this.renderer.paragraph(we):we;continue}default:{var Ne='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}}return J},ye.parseInline=function(se,ae){ae=ae||this.renderer;var J="",_,N,$,q=se.length;for(_=0;_<q;_++){if(N=se[_],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[N.type]&&($=this.options.extensions.renderers[N.type].call({parser:this},N),$!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(N.type))){J+=$||"";continue}switch(N.type){case"escape":{J+=ae.text(N.text);break}case"html":{J+=ae.html(N.text);break}case"link":{J+=ae.link(N.href,N.title,this.parseInline(N.tokens,ae));break}case"image":{J+=ae.image(N.href,N.title,N.text);break}case"strong":{J+=ae.strong(this.parseInline(N.tokens,ae));break}case"em":{J+=ae.em(this.parseInline(N.tokens,ae));break}case"codespan":{J+=ae.codespan(N.text);break}case"br":{J+=ae.br();break}case"del":{J+=ae.del(this.parseInline(N.tokens,ae));break}case"text":{J+=ae.text(N.text);break}default:{var Z='Token with "'+N.type+'" type was not found.';if(this.options.silent){console.error(Z);return}else throw new Error(Z)}}}return J},ke}();function pe(ke,ye,Ce){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof ye=="function"&&(Ce=ye,ye=null),ye=s({},pe.defaults,ye||{}),L(ye),Ce){var se=ye.highlight,ae;try{ae=H.lex(ke,ye)}catch(q){return Ce(q)}var J=function(Z){var ce;if(!Z)try{ye.walkTokens&&pe.walkTokens(ae,ye.walkTokens),ce=re.parse(ae,ye)}catch(be){Z=be}return ye.highlight=se,Z?Ce(Z):Ce(null,ce)};if(!se||se.length<3||(delete ye.highlight,!ae.length))return J();var _=0;pe.walkTokens(ae,function(q){q.type==="code"&&(_++,setTimeout(function(){se(q.text,q.lang,function(Z,ce){if(Z)return J(Z);ce!=null&&ce!==q.text&&(q.text=ce,q.escaped=!0),_--,_===0&&J()})},0))}),_===0&&J();return}function N(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+m(q.message+"",!0)+"</pre>";throw q}try{var $=H.lex(ke,ye);if(ye.walkTokens){if(ye.async)return Promise.all(pe.walkTokens($,ye.walkTokens)).then(function(){return re.parse($,ye)}).catch(N);pe.walkTokens($,ye.walkTokens)}return re.parse($,ye)}catch(q){N(q)}}pe.options=pe.setOptions=function(ke){return s(pe.defaults,ke),A(pe.defaults),pe},pe.getDefaults=D,pe.defaults=ie.defaults,pe.use=function(){for(var ke=arguments.length,ye=new Array(ke),Ce=0;Ce<ke;Ce++)ye[Ce]=arguments[Ce];var se=s.apply(void 0,[{}].concat(ye)),ae=pe.defaults.extensions||{renderers:{},childTokens:{}},J;ye.forEach(function(_){if(_.extensions&&(J=!0,_.extensions.forEach(function($){if(!$.name)throw new Error("extension name required");if($.renderer){var q=ae.renderers?ae.renderers[$.name]:null;q?ae.renderers[$.name]=function(){for(var Z=arguments.length,ce=new Array(Z),be=0;be<Z;be++)ce[be]=arguments[be];var oe=$.renderer.apply(this,ce);return oe===!1&&(oe=q.apply(this,ce)),oe}:ae.renderers[$.name]=$.renderer}if($.tokenizer){if(!$.level||$.level!=="block"&&$.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[$.level]?ae[$.level].unshift($.tokenizer):ae[$.level]=[$.tokenizer],$.start&&($.level==="block"?ae.startBlock?ae.startBlock.push($.start):ae.startBlock=[$.start]:$.level==="inline"&&(ae.startInline?ae.startInline.push($.start):ae.startInline=[$.start]))}$.childTokens&&(ae.childTokens[$.name]=$.childTokens)})),_.renderer&&function(){var $=pe.defaults.renderer||new G,q=function(be){var oe=$[be];$[be]=function(){for(var we=arguments.length,ve=new Array(we),Ue=0;Ue<we;Ue++)ve[Ue]=arguments[Ue];var ze=_.renderer[be].apply($,ve);return ze===!1&&(ze=oe.apply($,ve)),ze}};for(var Z in _.renderer)q(Z);se.renderer=$}(),_.tokenizer&&function(){var $=pe.defaults.tokenizer||new C,q=function(be){var oe=$[be];$[be]=function(){for(var we=arguments.length,ve=new Array(we),Ue=0;Ue<we;Ue++)ve[Ue]=arguments[Ue];var ze=_.tokenizer[be].apply($,ve);return ze===!1&&(ze=oe.apply($,ve)),ze}};for(var Z in _.tokenizer)q(Z);se.tokenizer=$}(),_.walkTokens){var N=pe.defaults.walkTokens;se.walkTokens=function($){var q=[];return q.push(_.walkTokens.call(this,$)),N&&(q=q.concat(N.call(this,$))),q}}J&&(se.extensions=ae),pe.setOptions(se)})},pe.walkTokens=function(ke,ye){for(var Ce=[],se=function(){var N=J.value;switch(Ce=Ce.concat(ye.call(pe,N)),N.type){case"table":{for(var $=M(N.header),q;!(q=$()).done;){var Z=q.value;Ce=Ce.concat(pe.walkTokens(Z.tokens,ye))}for(var ce=M(N.rows),be;!(be=ce()).done;)for(var oe=be.value,we=M(oe),ve;!(ve=we()).done;){var Ue=ve.value;Ce=Ce.concat(pe.walkTokens(Ue.tokens,ye))}break}case"list":{Ce=Ce.concat(pe.walkTokens(N.items,ye));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[N.type]?pe.defaults.extensions.childTokens[N.type].forEach(function(ze){Ce=Ce.concat(pe.walkTokens(N[ze],ye))}):N.tokens&&(Ce=Ce.concat(pe.walkTokens(N.tokens,ye)))}},ae=M(ke),J;!(J=ae()).done;)se();return Ce},pe.parseInline=function(ke,ye){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");ye=s({},pe.defaults,ye||{}),L(ye);try{var Ce=H.lexInline(ke,ye);return ye.walkTokens&&pe.walkTokens(Ce,ye.walkTokens),re.parseInline(Ce,ye)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+m(se.message+"",!0)+"</pre>";throw se}},pe.Parser=re,pe.parser=re.parse,pe.Renderer=G,pe.TextRenderer=ee,pe.Lexer=H,pe.lexer=H.lex,pe.Tokenizer=C,pe.Slugger=ue,pe.parse=pe;var le=pe.options,de=pe.setOptions,Y=pe.use,me=pe.walkTokens,Se=pe.parseInline,Oe=pe,Be=re.parse,Xe=H.lex;ie.Lexer=H,ie.Parser=re,ie.Renderer=G,ie.Slugger=ue,ie.TextRenderer=ee,ie.Tokenizer=C,ie.getDefaults=D,ie.lexer=Xe,ie.marked=pe,ie.options=le,ie.parse=Oe,ie.parseInline=Se,ie.parser=Be,ie.setOptions=de,ie.use=Y,ie.walkTokens=me,Object.defineProperty(ie,"__esModule",{value:!0})}),define(De[108],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(A,y,k){return Math.min(Math.max(A,y),k)}e.clamp=i;function I(A,y){return(y+A%y)%y}e.rot=I;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class M{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class D{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const k=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=k,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=D}),function(){function ie(S){const M=[];typeof S=="number"&&M.push("code/timeOrigin",S);function D(y){M.push(y,Date.now())}function A(){const y=[];for(let k=0;k<M.length;k+=2)y.push({name:M[k],startTime:M[k+1]});return y}return{mark:D,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const D of performance.getEntriesByType("mark"))M.push({name:D.name,startTime:Math.round(S+D.startTime)});return M}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function i(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=i(I))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var I in i)(typeof exports=="object"?exports:ie)[I]=i[I]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function i(I){if(e[I])return e[I].exports;var S=e[I]={i:I,l:!1,exports:{}};return ie[I].call(S.exports,S,S.exports,i),S.l=!0,S.exports}return i.m=ie,i.c=e,i.d=function(I,S,M){i.o(I,S)||Object.defineProperty(I,S,{enumerable:!0,get:M})},i.r=function(I){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},i.t=function(I,S){if(1&S&&(I=i(I)),8&S||4&S&&typeof I=="object"&&I&&I.__esModule)return I;var M=Object.create(null);if(i.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:I}),2&S&&typeof I!="string")for(var D in I)i.d(M,D,function(A){return I[A]}.bind(null,D));return M},i.n=function(I){var S=I&&I.__esModule?function(){return I.default}:function(){return I};return i.d(S,"a",S),S},i.o=function(I,S){return Object.prototype.hasOwnProperty.call(I,S)},i.p="",i(i.s=0)}([function(ie,e,i){(function(I){var S;e=ie.exports=Y,S=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],k=0,R=k++;y[R]="0|[1-9]\\d*";var b=k++;y[b]="[0-9]+";var p=k++;y[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=k++;y[E]="("+y[R]+")\\.("+y[R]+")\\.("+y[R]+")";var m=k++;y[m]="("+y[b]+")\\.("+y[b]+")\\.("+y[b]+")";var t=k++;y[t]="(?:"+y[R]+"|"+y[p]+")";var o=k++;y[o]="(?:"+y[b]+"|"+y[p]+")";var a=k++;y[a]="(?:-("+y[t]+"(?:\\."+y[t]+")*))";var g=k++;y[g]="(?:-?("+y[o]+"(?:\\."+y[o]+")*))";var w=k++;y[w]="[0-9A-Za-z-]+";var d=k++;y[d]="(?:\\+("+y[w]+"(?:\\."+y[w]+")*))";var T=k++,r="v?"+y[E]+y[a]+"?"+y[d]+"?";y[T]="^"+r+"$";var c="[v=\\s]*"+y[m]+y[g]+"?"+y[d]+"?",n=k++;y[n]="^"+c+"$";var u=k++;y[u]="((?:<|>)?=?)";var l=k++;y[l]=y[b]+"|x|X|\\*";var f=k++;y[f]=y[R]+"|x|X|\\*";var s=k++;y[s]="[v=\\s]*("+y[f]+")(?:\\.("+y[f]+")(?:\\.("+y[f]+")(?:"+y[a]+")?"+y[d]+"?)?)?";var h=k++;y[h]="[v=\\s]*("+y[l]+")(?:\\.("+y[l]+")(?:\\.("+y[l]+")(?:"+y[g]+")?"+y[d]+"?)?)?";var v=k++;y[v]="^"+y[u]+"\\s*"+y[s]+"$";var P=k++;y[P]="^"+y[u]+"\\s*"+y[h]+"$";var L=k++;y[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=k++;y[j]="(?:~>?)";var W=k++;y[W]="(\\s*)"+y[j]+"\\s+",A[W]=new RegExp(y[W],"g");var V=k++;y[V]="^"+y[j]+y[s]+"$";var C=k++;y[C]="^"+y[j]+y[h]+"$";var F=k++;y[F]="(?:\\^)";var O=k++;y[O]="(\\s*)"+y[F]+"\\s+",A[O]=new RegExp(y[O],"g");var x=k++;y[x]="^"+y[F]+y[s]+"$";var B=k++;y[B]="^"+y[F]+y[h]+"$";var H=k++;y[H]="^"+y[u]+"\\s*("+c+")$|^$";var G=k++;y[G]="^"+y[u]+"\\s*("+r+")$|^$";var ee=k++;y[ee]="(\\s*)"+y[u]+"\\s*("+c+"|"+y[s]+")",A[ee]=new RegExp(y[ee],"g");var ue=k++;y[ue]="^\\s*("+y[s]+")\\s+-\\s+("+y[s]+")\\s*$";var re=k++;y[re]="^\\s*("+y[h]+")\\s+-\\s+("+y[h]+")\\s*$";var pe=k++;y[pe]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)S(le,y[le]),A[le]||(A[le]=new RegExp(y[le]));function de(oe,we){if(oe instanceof Y)return oe;if(typeof oe!="string"||oe.length>M||!(we?A[n]:A[T]).test(oe))return null;try{return new Y(oe,we)}catch{return null}}function Y(oe,we){if(oe instanceof Y){if(oe.loose===we)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof Y))return new Y(oe,we);S("SemVer",oe,we),this.loose=we;var ve=oe.trim().match(we?A[n]:A[T]);if(!ve)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Ue){if(/^[0-9]+$/.test(Ue)){var ze=+Ue;if(ze>=0&&ze<D)return ze}return Ue}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=de,e.valid=function(oe,we){var ve=de(oe,we);return ve?ve.version:null},e.clean=function(oe,we){var ve=de(oe.trim().replace(/^[=v]+/,""),we);return ve?ve.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(oe){return S("SemVer.compare",this.version,this.loose,oe),oe instanceof Y||(oe=new Y(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},Y.prototype.compareMain=function(oe){return oe instanceof Y||(oe=new Y(oe,this.loose)),Se(this.major,oe.major)||Se(this.minor,oe.minor)||Se(this.patch,oe.patch)},Y.prototype.comparePre=function(oe){if(oe instanceof Y||(oe=new Y(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var we=0;do{var ve=this.prerelease[we],Ue=oe.prerelease[we];if(S("prerelease compare",we,ve,Ue),ve===void 0&&Ue===void 0)return 0;if(Ue===void 0)return 1;if(ve===void 0)return-1;if(ve!==Ue)return Se(ve,Ue)}while(++we)},Y.prototype.inc=function(oe,we){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",we);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",we);break;case"prepatch":this.prerelease.length=0,this.inc("patch",we),this.inc("pre",we);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",we),this.inc("pre",we);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}we&&(this.prerelease[0]===we?isNaN(this.prerelease[1])&&(this.prerelease=[we,0]):this.prerelease=[we,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,we,ve,Ue){typeof ve=="string"&&(Ue=ve,ve=void 0);try{return new Y(oe,ve).inc(we,Ue).version}catch{return null}},e.diff=function(oe,we){if(ke(oe,we))return null;var ve=de(oe),Ue=de(we);if(ve.prerelease.length||Ue.prerelease.length){for(var ze in ve)if((ze==="major"||ze==="minor"||ze==="patch")&&ve[ze]!==Ue[ze])return"pre"+ze;return"prerelease"}for(var ze in ve)if((ze==="major"||ze==="minor"||ze==="patch")&&ve[ze]!==Ue[ze])return ze},e.compareIdentifiers=Se;var me=/^[0-9]+$/;function Se(oe,we){var ve=me.test(oe),Ue=me.test(we);return ve&&Ue&&(oe=+oe,we=+we),ve&&!Ue?-1:Ue&&!ve?1:oe<we?-1:oe>we?1:0}function Oe(oe,we,ve){return new Y(oe,ve).compare(new Y(we,ve))}function Be(oe,we,ve){return Oe(oe,we,ve)>0}function Xe(oe,we,ve){return Oe(oe,we,ve)<0}function ke(oe,we,ve){return Oe(oe,we,ve)===0}function ye(oe,we,ve){return Oe(oe,we,ve)!==0}function Ce(oe,we,ve){return Oe(oe,we,ve)>=0}function se(oe,we,ve){return Oe(oe,we,ve)<=0}function ae(oe,we,ve,Ue){var ze;switch(we){case"===":typeof oe=="object"&&(oe=oe.version),typeof ve=="object"&&(ve=ve.version),ze=oe===ve;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof ve=="object"&&(ve=ve.version),ze=oe!==ve;break;case"":case"=":case"==":ze=ke(oe,ve,Ue);break;case"!=":ze=ye(oe,ve,Ue);break;case">":ze=Be(oe,ve,Ue);break;case">=":ze=Ce(oe,ve,Ue);break;case"<":ze=Xe(oe,ve,Ue);break;case"<=":ze=se(oe,ve,Ue);break;default:throw new TypeError("Invalid operator: "+we)}return ze}function J(oe,we){if(oe instanceof J){if(oe.loose===we)return oe;oe=oe.value}if(!(this instanceof J))return new J(oe,we);S("comparator",oe,we),this.loose=we,this.parse(oe),this.semver===_?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(oe,we){return Se(we,oe)},e.major=function(oe,we){return new Y(oe,we).major},e.minor=function(oe,we){return new Y(oe,we).minor},e.patch=function(oe,we){return new Y(oe,we).patch},e.compare=Oe,e.compareLoose=function(oe,we){return Oe(oe,we,!0)},e.rcompare=function(oe,we,ve){return Oe(we,oe,ve)},e.sort=function(oe,we){return oe.sort(function(ve,Ue){return e.compare(ve,Ue,we)})},e.rsort=function(oe,we){return oe.sort(function(ve,Ue){return e.rcompare(ve,Ue,we)})},e.gt=Be,e.lt=Xe,e.eq=ke,e.neq=ye,e.gte=Ce,e.lte=se,e.cmp=ae,e.Comparator=J;var _={};function N(oe,we){if(oe instanceof N)return oe.loose===we?oe:new N(oe.raw,we);if(oe instanceof J)return new N(oe.value,we);if(!(this instanceof N))return new N(oe,we);if(this.loose=we,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function $(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function q(oe,we,ve,Ue,ze,et,Ke,tt,Fe,ht,X,Q,ge){return((we=$(ve)?"":$(Ue)?">="+ve+".0.0":$(ze)?">="+ve+"."+Ue+".0":">="+we)+" "+(tt=$(Fe)?"":$(ht)?"<"+(+Fe+1)+".0.0":$(X)?"<"+Fe+"."+(+ht+1)+".0":Q?"<="+Fe+"."+ht+"."+X+"-"+Q:"<="+tt)).trim()}function Z(oe,we){for(var ve=0;ve<oe.length;ve++)if(!oe[ve].test(we))return!1;if(we.prerelease.length){for(ve=0;ve<oe.length;ve++)if(S(oe[ve].semver),oe[ve].semver!==_&&oe[ve].semver.prerelease.length>0){var Ue=oe[ve].semver;if(Ue.major===we.major&&Ue.minor===we.minor&&Ue.patch===we.patch)return!0}return!1}return!0}function ce(oe,we,ve){try{we=new N(we,ve)}catch{return!1}return we.test(oe)}function be(oe,we,ve,Ue){var ze,et,Ke,tt,Fe;switch(oe=new Y(oe,Ue),we=new N(we,Ue),ve){case">":ze=Be,et=se,Ke=Xe,tt=">",Fe=">=";break;case"<":ze=Xe,et=Ce,Ke=Be,tt="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ce(oe,we,Ue))return!1;for(var ht=0;ht<we.set.length;++ht){var X=we.set[ht],Q=null,ge=null;if(X.forEach(function(Ne){Ne.semver===_&&(Ne=new J(">=0.0.0")),Q=Q||Ne,ge=ge||Ne,ze(Ne.semver,Q.semver,Ue)?Q=Ne:Ke(Ne.semver,ge.semver,Ue)&&(ge=Ne)}),Q.operator===tt||Q.operator===Fe||(!ge.operator||ge.operator===tt)&&et(oe,ge.semver)||ge.operator===Fe&&Ke(oe,ge.semver))return!1}return!0}J.prototype.parse=function(oe){var we=this.loose?A[H]:A[G],ve=oe.match(we);if(!ve)throw new TypeError("Invalid comparator: "+oe);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new Y(ve[2],this.loose):this.semver=_},J.prototype.toString=function(){return this.value},J.prototype.test=function(oe){return S("Comparator.test",oe,this.loose),this.semver===_||(typeof oe=="string"&&(oe=new Y(oe,this.loose)),ae(oe,this.operator,this.semver,this.loose))},J.prototype.intersects=function(oe,we){if(!(oe instanceof J))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new N(oe.value,we),ce(this.value,ve,we);if(oe.operator==="")return ve=new N(this.value,we),ce(oe.semver,ve,we);var Ue=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),et=this.semver.version===oe.semver.version,Ke=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),tt=ae(this.semver,"<",oe.semver,we)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),Fe=ae(this.semver,">",oe.semver,we)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return Ue||ze||et&&Ke||tt||Fe},e.Range=N,N.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},N.prototype.toString=function(){return this.range},N.prototype.parseRange=function(oe){var we=this.loose;oe=oe.trim(),S("range",oe,we);var ve=we?A[re]:A[ue];oe=oe.replace(ve,q),S("hyphen replace",oe),oe=oe.replace(A[ee],"$1$2$3"),S("comparator trim",oe,A[ee]),oe=(oe=(oe=oe.replace(A[W],"$1~")).replace(A[O],"$1^")).split(/\s+/).join(" ");var Ue=we?A[H]:A[G],ze=oe.split(" ").map(function(et){return function(Ke,tt){return S("comp",Ke),Ke=function(Fe,ht){return Fe.trim().split(/\s+/).map(function(X){return function(Q,ge){S("caret",Q,ge);var Ne=ge?A[B]:A[x];return Q.replace(Ne,function(je,qe,We,Ze,nt){var ct;return S("caret",Q,je,qe,We,Ze,nt),$(qe)?ct="":$(We)?ct=">="+qe+".0.0 <"+(+qe+1)+".0.0":$(Ze)?ct=qe==="0"?">="+qe+"."+We+".0 <"+qe+"."+(+We+1)+".0":">="+qe+"."+We+".0 <"+(+qe+1)+".0.0":nt?(S("replaceCaret pr",nt),nt.charAt(0)!=="-"&&(nt="-"+nt),ct=qe==="0"?We==="0"?">="+qe+"."+We+"."+Ze+nt+" <"+qe+"."+We+"."+(+Ze+1):">="+qe+"."+We+"."+Ze+nt+" <"+qe+"."+(+We+1)+".0":">="+qe+"."+We+"."+Ze+nt+" <"+(+qe+1)+".0.0"):(S("no pr"),ct=qe==="0"?We==="0"?">="+qe+"."+We+"."+Ze+" <"+qe+"."+We+"."+(+Ze+1):">="+qe+"."+We+"."+Ze+" <"+qe+"."+(+We+1)+".0":">="+qe+"."+We+"."+Ze+" <"+(+qe+1)+".0.0"),S("caret return",ct),ct})}(X,ht)}).join(" ")}(Ke,tt),S("caret",Ke),Ke=function(Fe,ht){return Fe.trim().split(/\s+/).map(function(X){return function(Q,ge){var Ne=ge?A[C]:A[V];return Q.replace(Ne,function(je,qe,We,Ze,nt){var ct;return S("tilde",Q,je,qe,We,Ze,nt),$(qe)?ct="":$(We)?ct=">="+qe+".0.0 <"+(+qe+1)+".0.0":$(Ze)?ct=">="+qe+"."+We+".0 <"+qe+"."+(+We+1)+".0":nt?(S("replaceTilde pr",nt),nt.charAt(0)!=="-"&&(nt="-"+nt),ct=">="+qe+"."+We+"."+Ze+nt+" <"+qe+"."+(+We+1)+".0"):ct=">="+qe+"."+We+"."+Ze+" <"+qe+"."+(+We+1)+".0",S("tilde return",ct),ct})}(X,ht)}).join(" ")}(Ke,tt),S("tildes",Ke),Ke=function(Fe,ht){return S("replaceXRanges",Fe,ht),Fe.split(/\s+/).map(function(X){return function(Q,ge){Q=Q.trim();var Ne=ge?A[P]:A[v];return Q.replace(Ne,function(je,qe,We,Ze,nt,ct){S("xRange",Q,je,qe,We,Ze,nt,ct);var It=$(We),at=It||$(Ze),rt=at||$(nt);return qe==="="&&rt&&(qe=""),It?je=qe===">"||qe==="<"?"<0.0.0":"*":qe&&rt?(at&&(Ze=0),rt&&(nt=0),qe===">"?(qe=">=",at?(We=+We+1,Ze=0,nt=0):rt&&(Ze=+Ze+1,nt=0)):qe==="<="&&(qe="<",at?We=+We+1:Ze=+Ze+1),je=qe+We+"."+Ze+"."+nt):at?je=">="+We+".0.0 <"+(+We+1)+".0.0":rt&&(je=">="+We+"."+Ze+".0 <"+We+"."+(+Ze+1)+".0"),S("xRange return",je),je})}(X,ht)}).join(" ")}(Ke,tt),S("xrange",Ke),Ke=function(Fe,ht){return S("replaceStars",Fe,ht),Fe.trim().replace(A[pe],"")}(Ke,tt),S("stars",Ke),Ke}(et,we)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(et){return!!et.match(Ue)})),ze=ze.map(function(et){return new J(et,we)})},N.prototype.intersects=function(oe,we){if(!(oe instanceof N))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Ue){return oe.set.some(function(ze){return ze.every(function(et){return Ue.intersects(et,we)})})})})},e.toComparators=function(oe,we){return new N(oe,we).set.map(function(ve){return ve.map(function(Ue){return Ue.value}).join(" ").trim().split(" ")})},N.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new Y(oe,this.loose));for(var we=0;we<this.set.length;we++)if(Z(this.set[we],oe))return!0;return!1},e.satisfies=ce,e.maxSatisfying=function(oe,we,ve){var Ue=null,ze=null;try{var et=new N(we,ve)}catch{return null}return oe.forEach(function(Ke){et.test(Ke)&&(Ue&&ze.compare(Ke)!==-1||(ze=new Y(Ue=Ke,ve)))}),Ue},e.minSatisfying=function(oe,we,ve){var Ue=null,ze=null;try{var et=new N(we,ve)}catch{return null}return oe.forEach(function(Ke){et.test(Ke)&&(Ue&&ze.compare(Ke)!==1||(ze=new Y(Ue=Ke,ve)))}),Ue},e.validRange=function(oe,we){try{return new N(oe,we).range||"*"}catch{return null}},e.ltr=function(oe,we,ve){return be(oe,we,"<",ve)},e.gtr=function(oe,we,ve){return be(oe,we,">",ve)},e.outside=be,e.prerelease=function(oe,we){var ve=de(oe,we);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(oe,we,ve){return oe=new N(oe,ve),we=new N(we,ve),oe.intersects(we)},e.coerce=function(oe){if(oe instanceof Y)return oe;if(typeof oe!="string")return null;var we=oe.match(A[L]);return we==null?null:de((we[1]||"0")+"."+(we[2]||"0")+"."+(we[3]||"0"))}}).call(this,i(1))},function(ie,e){var i,I,S=ie.exports={};function M(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function A(o){if(i===setTimeout)return setTimeout(o,0);if((i===M||!i)&&setTimeout)return i=setTimeout,setTimeout(o,0);try{return i(o,0)}catch{try{return i.call(null,o,0)}catch{return i.call(this,o,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:M}catch{i=M}try{I=typeof clearTimeout=="function"?clearTimeout:D}catch{I=D}})();var y,k=[],R=!1,b=-1;function p(){R&&y&&(R=!1,y.length?k=y.concat(k):b=-1,k.length&&E())}function E(){if(!R){var o=A(p);R=!0;for(var a=k.length;a;){for(y=k,k=[];++b<a;)y&&y[b].run();b=-1,a=k.length}y=null,R=!1,function(g){if(I===clearTimeout)return clearTimeout(g);if((I===D||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(g);try{I(g)}catch{try{return I.call(null,g)}catch{return I.call(this,g)}}}(o)}}function m(o,a){this.fun=o,this.array=a}function t(){}S.nextTick=function(o){var a=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)a[g-1]=arguments[g];k.push(new m(o,a)),k.length!==1||R||A(E)},m.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=t,S.addListener=t,S.once=t,S.off=t,S.removeListener=t,S.removeAllListeners=t,S.emit=t,S.prependListener=t,S.prependOnceListener=t,S.listeners=function(o){return[]},S.binding=function(o){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(o){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(De[109],Ie([1,0,12,7]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function S(d){const T=d;return T?typeof T.read=="function":!1}e.isReadable=S;function M(d){const T=d;return T?[T.on,T.pause,T.resume,T.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=M;function D(d){const T=d;return T?M(T.stream)&&Array.isArray(T.buffer)&&typeof T.ended=="boolean":!1}e.isReadableBufferedStream=D;function A(d,T){return new y(d,T)}e.newWriteableStream=A;class y{constructor(T,r){this.reducer=T,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(T){if(!this.state.destroyed){if(this.state.flowing)this.emitData(T);else if(this.buffer.data.push(T),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(T){this.state.destroyed||(this.state.flowing?this.emitError(T):this.buffer.error.push(T))}end(T){this.state.destroyed||(typeof T<"u"&&this.write(T),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(T){this.listeners.data.slice(0).forEach(r=>r(T))}emitError(T){this.listeners.error.length===0?(0,i.onUnexpectedError)(T):this.listeners.error.slice(0).forEach(r=>r(T))}emitEnd(){this.listeners.end.slice(0).forEach(T=>T())}on(T,r){if(!this.state.destroyed)switch(T){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(T,r){if(this.state.destroyed)return;let c;switch(T){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const n=c.indexOf(r);n>=0&&c.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const T=this.reducer(this.buffer.data);this.emitData(T),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const T of this.buffer.error)this.emitError(T);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function k(d,T){const r=[];let c;for(;(c=d.read())!==null;)r.push(c);return T(r)}e.consumeReadable=k;function R(d,T,r){const c=[];let n;for(;(n=d.read())!==null&&c.length<r;)c.push(n);return n===null&&c.length>0?T(c):{read:()=>{if(c.length>0)return c.shift();if(typeof n<"u"){const u=n;return n=void 0,u}return d.read()}}}e.peekReadable=R;function b(d,T){return new Promise((r,c)=>{const n=[];p(d,{onData:u=>{T&&n.push(u)},onError:u=>{T?c(u):r(void 0)},onEnd:()=>{r(T?T(n):void 0)}})})}e.consumeStream=b;function p(d,T){let r=!1;return d.on("error",c=>{r||T.onError(c)}),d.on("end",()=>{r||T.onEnd()}),d.on("data",c=>{r||T.onData(c)}),(0,I.toDisposable)(()=>r=!0)}e.listenStream=p;function E(d,T){return new Promise((r,c)=>{const n=new I.DisposableStore,u=[],l=h=>{if(u.push(h),u.length>T)return n.dispose(),d.pause(),r({stream:d,buffer:u,ended:!1})},f=h=>c(h),s=()=>r({stream:d,buffer:u,ended:!0});n.add((0,I.toDisposable)(()=>d.removeListener("error",f))),d.on("error",f),n.add((0,I.toDisposable)(()=>d.removeListener("end",s))),d.on("end",s),n.add((0,I.toDisposable)(()=>d.removeListener("data",l))),d.on("data",l)})}e.peekStream=E;function m(d,T){const r=A(T);return r.end(d),r}e.toStream=m;function t(){const d=A(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=t;function o(d){let T=!1;return{read:()=>T?null:(T=!0,d)}}e.toReadable=o;function a(d,T,r){const c=A(r);return p(d,{onData:n=>c.write(T.data(n)),onError:n=>c.error(T.error?T.error(n):n),onEnd:()=>c.end()}),c}e.transform=a;function g(d,T,r){let c=!1;return{read:()=>{const n=T.read();return c?n:(c=!0,n!==null?r([d,n]):d)}}}e.prefixedReadable=g;function w(d,T,r){let c=!1;const n=A(r);return p(T,{onData:u=>c?n.write(u):(c=!0,n.write(r([d,u]))),onError:u=>n.error(u),onEnd:()=>{c||(c=!0,n.write(d)),n.end()}}),n}e.prefixedStream=w}),define(De[24],Ie([1,0,109]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const I=typeof Buffer<"u";let S,M;class D{static alloc(h){return I?new D(Buffer.allocUnsafe(h)):new D(new Uint8Array(h))}static wrap(h){return I&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new D(h)}static fromString(h,v){return!(v?.dontUseNodeBuffer||!1)&&I?new D(Buffer.from(h)):(S||(S=new TextEncoder),new D(S.encode(h)))}static fromByteArray(h){const v=D.alloc(h.length);for(let P=0,L=h.length;P<L;P++)v.buffer[P]=h[P];return v}static concat(h,v){if(typeof v>"u"){v=0;for(let j=0,W=h.length;j<W;j++)v+=h[j].byteLength}const P=D.alloc(v);let L=0;for(let j=0,W=h.length;j<W;j++){const V=h[j];P.set(V,L),L+=V.byteLength}return P}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=D.alloc(this.byteLength);return h.set(this),h}toString(){return I?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(h,v){return new D(this.buffer.subarray(h,v))}set(h,v){if(h instanceof D)this.buffer.set(h.buffer,v);else if(h instanceof Uint8Array)this.buffer.set(h,v);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),v);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return k(this.buffer,h)}writeUInt32BE(h,v){R(this.buffer,h,v)}readUInt32LE(h){return b(this.buffer,h)}writeUInt32LE(h,v){p(this.buffer,h,v)}readUInt8(h){return E(this.buffer,h)}writeUInt8(h,v){m(this.buffer,h,v)}}e.VSBuffer=D;function A(s,h){return s[h+0]<<0>>>0|s[h+1]<<8>>>0}e.readUInt16LE=A;function y(s,h,v){s[v+0]=h&255,h=h>>>8,s[v+1]=h&255}e.writeUInt16LE=y;function k(s,h){return s[h]*2**24+s[h+1]*2**16+s[h+2]*2**8+s[h+3]}e.readUInt32BE=k;function R(s,h,v){s[v+3]=h,h=h>>>8,s[v+2]=h,h=h>>>8,s[v+1]=h,h=h>>>8,s[v]=h}e.writeUInt32BE=R;function b(s,h){return s[h+0]<<0>>>0|s[h+1]<<8>>>0|s[h+2]<<16>>>0|s[h+3]<<24>>>0}e.readUInt32LE=b;function p(s,h,v){s[v+0]=h&255,h=h>>>8,s[v+1]=h&255,h=h>>>8,s[v+2]=h&255,h=h>>>8,s[v+3]=h&255}e.writeUInt32LE=p;function E(s,h){return s[h]}e.readUInt8=E;function m(s,h,v){s[v]=h}e.writeUInt8=m;function t(s){return i.consumeReadable(s,h=>D.concat(h))}e.readableToBuffer=t;function o(s){return i.toReadable(s)}e.bufferToReadable=o;function a(s){return i.consumeStream(s,h=>D.concat(h))}e.streamToBuffer=a;async function g(s){return s.ended?D.concat(s.buffer):D.concat([...s.buffer,await a(s.stream)])}e.bufferedStreamToBuffer=g;function w(s){return i.toStream(s,h=>D.concat(h))}e.bufferToStream=w;function d(s){return i.transform(s,{data:h=>typeof h=="string"?D.fromString(h):D.wrap(h)},h=>D.concat(h))}e.streamToBufferReadableStream=d;function T(s){return i.newWriteableStream(h=>D.concat(h),s)}e.newWriteableBufferStream=T;function r(s,h){return i.prefixedReadable(s,h,v=>D.concat(v))}e.prefixedBufferReadable=r;function c(s,h){return i.prefixedStream(s,h,v=>D.concat(v))}e.prefixedBufferStream=c;function n(s){let h=0,v=0,P=0;const L=new Uint8Array(Math.floor(s.length/4*3)),j=V=>{switch(v){case 3:L[P++]=h|V,v=0;break;case 2:L[P++]=h|V>>>2,h=V<<6,v=3;break;case 1:L[P++]=h|V>>>4,h=V<<4,v=2;break;default:h=V<<2,v=1}};for(let V=0;V<s.length;V++){const C=s.charCodeAt(V);if(C>=65&&C<=90)j(C-65);else if(C>=97&&C<=122)j(C-97+26);else if(C>=48&&C<=57)j(C-48+52);else if(C===43||C===45)j(62);else if(C===47||C===95)j(63);else{if(C===61)break;throw new SyntaxError(`Unexpected base64 character ${s[V]}`)}}const W=P;for(;v>0;)j(0);return D.wrap(L).slice(0,W)}e.decodeBase64=n;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:s},h=!0,v=!1){const P=v?l:u;let L="";const j=s.byteLength%3;let W=0;for(;W<s.byteLength-j;W+=3){const V=s[W+0],C=s[W+1],F=s[W+2];L+=P[V>>>2],L+=P[(V<<4|C>>>4)&63],L+=P[(C<<2|F>>>6)&63],L+=P[F&63]}if(j===1){const V=s[W+0];L+=P[V>>>2],L+=P[V<<4&63],h&&(L+="==")}else if(j===2){const V=s[W+0],C=s[W+1];L+=P[V>>>2],L+=P[(V<<4|C>>>4)&63],L+=P[C<<2&63],h&&(L+="=")}return L}e.encodeBase64=f}),define(De[38],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(S){return i.test(S)}e.isUUID=I,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const M=new Uint8Array(16),D=[];for(let A=0;A<256;A++)D.push(A.toString(16).padStart(2,"0"));return function(){S(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let y=0,k="";return k+=D[M[y++]],k+=D[M[y++]],k+=D[M[y++]],k+=D[M[y++]],k+="-",k+=D[M[y++]],k+=D[M[y++]],k+="-",k+=D[M[y++]],k+=D[M[y++]],k+="-",k+=D[M[y++]],k+=D[M[y++]],k+="-",k+=D[M[y++]],k+=D[M[y++]],k+=D[M[y++]],k+=D[M[y++]],k+=D[M[y++]],k+=D[M[y++]],k}}()}),define(De[110],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[111],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class I{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let y=0,k=A.notIn.length;y<k;y++)switch(A.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const k=A.findTokenIndexAtOffset(y-2),R=A.getStandardTokenType(k);return this.isOK(R)}_findNeutralCharacterInRange(A,y){for(let k=A;k<=y;k++){const R=String.fromCharCode(k);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=I;class S{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)M(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),M(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),M(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),M(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&M(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=S;function M(D,A,y){D.has(A)?D.get(A).push(y):D.set(A,[y])}}),define(De[112],Ie([16,17]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(De[113],Ie([1,0,112]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,S=I*60,M=S*24,D=M*7,A=M*30,y=M*365;function k(b,p,E){typeof b!="number"&&(b=b.getTime());const m=Math.round((new Date().getTime()-b)/1e3);if(m<-30)return(0,i.localize)(0,null,k(new Date().getTime()+m*1e3,!1));if(m<30)return(0,i.localize)(1,null);let t;return m<I?(t=m,p?t===1?E?(0,i.localize)(2,null,t):(0,i.localize)(3,null,t):E?(0,i.localize)(4,null,t):(0,i.localize)(5,null,t):t===1?E?(0,i.localize)(6,null,t):(0,i.localize)(7,null,t):E?(0,i.localize)(8,null,t):(0,i.localize)(9,null,t)):m<S?(t=Math.floor(m/I),p?t===1?E?(0,i.localize)(10,null,t):(0,i.localize)(11,null,t):E?(0,i.localize)(12,null,t):(0,i.localize)(13,null,t):t===1?E?(0,i.localize)(14,null,t):(0,i.localize)(15,null,t):E?(0,i.localize)(16,null,t):(0,i.localize)(17,null,t)):m<M?(t=Math.floor(m/S),p?t===1?E?(0,i.localize)(18,null,t):(0,i.localize)(19,null,t):E?(0,i.localize)(20,null,t):(0,i.localize)(21,null,t):t===1?E?(0,i.localize)(22,null,t):(0,i.localize)(23,null,t):E?(0,i.localize)(24,null,t):(0,i.localize)(25,null,t)):m<D?(t=Math.floor(m/M),p?t===1?(0,i.localize)(26,null,t):(0,i.localize)(27,null,t):t===1?(0,i.localize)(28,null,t):(0,i.localize)(29,null,t)):m<A?(t=Math.floor(m/D),p?t===1?E?(0,i.localize)(30,null,t):(0,i.localize)(31,null,t):E?(0,i.localize)(32,null,t):(0,i.localize)(33,null,t):t===1?E?(0,i.localize)(34,null,t):(0,i.localize)(35,null,t):E?(0,i.localize)(36,null,t):(0,i.localize)(37,null,t)):m<y?(t=Math.floor(m/A),p?t===1?E?(0,i.localize)(38,null,t):(0,i.localize)(39,null,t):E?(0,i.localize)(40,null,t):(0,i.localize)(41,null,t):t===1?E?(0,i.localize)(42,null,t):(0,i.localize)(43,null,t):E?(0,i.localize)(44,null,t):(0,i.localize)(45,null,t)):(t=Math.floor(m/y),p?t===1?E?(0,i.localize)(46,null,t):(0,i.localize)(47,null,t):E?(0,i.localize)(48,null,t):(0,i.localize)(49,null,t):t===1?E?(0,i.localize)(50,null,t):(0,i.localize)(51,null,t):E?(0,i.localize)(52,null,t):(0,i.localize)(53,null,t))}e.fromNow=k;function R(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(De[114],Ie([16,17]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(De[45],Ie([1,0,18,9,114]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(b,p){return p&&(b.stack||b.stacktrace)?S.localize(0,null,A(b),D(b.stack)||D(b.stacktrace)):A(b)}function D(b){return Array.isArray(b)?b.join(`
`):b}function A(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?S.localize(1,null,b.message):b.message||S.localize(2,null)}function y(b=null,p=!1){if(!b)return S.localize(3,null);if(Array.isArray(b)){const E=i.coalesce(b),m=y(E[0],p);return E.length>1?S.localize(4,null,m,E.length):m}if(I.isString(b))return b;if(b.detail){const E=b.detail;if(E.error)return M(E.error,p);if(E.exception)return M(E.exception,p)}return b.stack?M(b,p):b.message?b.message:S.localize(5,null)}e.toErrorMessage=y;function k(b){const p=b;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=k;function R(b,p){let E;return typeof b=="string"?E=new Error(b):E=b,E.actions=p,E}e.createErrorWithActions=R}),define(De[79],Ie([1,0,19]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(R){const b=(0,i.extname)(R),p=I[b.toLowerCase()];return p!==void 0?p:D(R)}e.getMediaOrTextMime=M;function D(R){const b=(0,i.extname)(R);return S[b.toLowerCase()]}e.getMediaMime=D;function A(R){for(const b in S)if(S[b]===R)return b}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function k(R,b){const p=y.exec(R);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:b?void 0:R}e.normalizeMimeType=k}),define(De[115],Ie([1,0,4,7]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const S=D=>({onDidChange:i.Event.None,value:D});e.staticObservableValue=S;class M extends I.Disposable{get value(){return this._value}set value(A){A!==this._value&&(this._value=A,this.changeEmitter.fire(A))}constructor(A){super(),this._value=A,this.changeEmitter=this._register(new i.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=M}),define(De[39],Ie([1,0,19,21,10,9]),function(ie,e,i,I,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(l){return l===47||l===92}e.isPathSeparator=D;function A(l){return l.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=A;function y(l){return l.indexOf("/")===-1&&(l=A(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=y;function k(l,f=i.posix.sep){if(!l)return"";const s=l.length,h=l.charCodeAt(0);if(D(h)){if(D(l.charCodeAt(1))&&!D(l.charCodeAt(2))){let P=3;const L=P;for(;P<s&&!D(l.charCodeAt(P));P++);if(L!==P&&!D(l.charCodeAt(P+1))){for(P+=1;P<s;P++)if(D(l.charCodeAt(P)))return l.slice(0,P+1).replace(/[\\/]/g,f)}}return f}else if(a(h)&&l.charCodeAt(1)===58)return D(l.charCodeAt(2))?l.slice(0,2)+f:l.slice(0,2);let v=l.indexOf("://");if(v!==-1){for(v+=3;v<s;v++)if(D(l.charCodeAt(v)))return l.slice(0,v+1)}return""}e.getRoot=k;function R(l){if(!I.isWindows||!l||l.length<5)return!1;let f=l.charCodeAt(0);if(f!==92||(f=l.charCodeAt(1),f!==92))return!1;let s=2;const h=s;for(;s<l.length&&(f=l.charCodeAt(s),f!==92);s++);return!(h===s||(f=l.charCodeAt(s+1),isNaN(f)||f===92))}e.isUNC=R;const b=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(l,f=I.isWindows){const s=f?b:p;return!(!l||l.length===0||/^\s+$/.test(l)||(s.lastIndex=0,s.test(l))||f&&E.test(l)||l==="."||l===".."||f&&l[l.length-1]==="."||f&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=m;function t(l,f,s){const h=l===f;return!s||h?h:!l||!f?!1:(0,S.equalsIgnoreCase)(l,f)}e.isEqual=t;function o(l,f,s,h=i.sep){if(l===f)return!0;if(!l||!f||f.length>l.length)return!1;if(s){if(!(0,S.startsWithIgnoreCase)(l,f))return!1;if(f.length===l.length)return!0;let P=f.length;return f.charAt(f.length-1)===h&&P--,l.charAt(P)===h}return f.charAt(f.length-1)!==h&&(f+=h),l.indexOf(f)===0}e.isEqualOrParent=o;function a(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=a;function g(l,f){return I.isWindows&&l.endsWith(":")&&(l+=i.sep),(0,i.isAbsolute)(l)||(l=(0,i.join)(f,l)),l=(0,i.normalize)(l),I.isWindows?(l=(0,S.rtrim)(l,i.sep),l.endsWith(":")&&(l+=i.sep)):(l=(0,S.rtrim)(l,i.sep),l||(l=i.sep)),l}e.sanitizeFilePath=g;function w(l){const f=(0,i.normalize)(l);return I.isWindows?l.length>3?!1:d(f)&&(l.length===2||f.charCodeAt(2)===92):f===i.posix.sep}e.isRootOrDriveLetter=w;function d(l,f=I.isWindows){return f?a(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function T(l){return d(l)?l[0]:void 0}e.getDriveLetter=T;function r(l,f,s){return f.length>l.length?-1:l===f?0:(s&&(l=l.toLowerCase(),f=f.toLowerCase()),l.indexOf(f))}e.indexOfPath=r;function c(l){const f=l.split(":");let s,h,v;for(const P of f){const L=Number(P);(0,M.isNumber)(L)?h===void 0?h=L:v===void 0&&(v=L):s=s?[s,P].join(":"):P}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:h!==void 0?h:void 0,column:v!==void 0?v:h!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function u(l,f,s=8){let h="";for(let P=0;P<s;P++)h+=n.charAt(Math.floor(Math.random()*n.length));let v;return f?v=`${f}-${h}`:v=h,l?(0,i.join)(l,v):v}e.randomPath=u}),define(De[116],Ie([1,0,28,10]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...J){return function(_,N){for(let $=0,q=J.length;$<q;$++){const Z=J[$](_,N);if(Z)return Z}return null}}e.or=S,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(J,_,N){if(!N||N.length<_.length)return null;let $;return J?$=I.startsWithIgnoreCase(N,_):$=N.indexOf(_)===0,$?_.length>0?[{start:0,end:_.length}]:[]:null}function D(J,_){const N=_.toLowerCase().indexOf(J.toLowerCase());return N===-1?null:[{start:N,end:N+J.length}]}e.matchesContiguousSubString=D;function A(J,_){return y(J.toLowerCase(),_.toLowerCase(),0,0)}e.matchesSubString=A;function y(J,_,N,$){if(N===J.length)return[];if($===_.length)return null;if(J[N]===_[$]){let q=null;return(q=y(J,_,N+1,$+1))?a({start:$,end:$+1},q):null}return y(J,_,N,$+1)}function k(J){return 97<=J&&J<=122}function R(J){return 65<=J&&J<=90}e.isUpper=R;function b(J){return 48<=J&&J<=57}function p(J){return J===32||J===9||J===10||J===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>E.add(J.charCodeAt(0)));function m(J){return p(J)||E.has(J)}function t(J,_){return J===_||m(J)&&m(_)}function o(J){return k(J)||R(J)||b(J)}function a(J,_){return _.length===0?_=[J]:J.end===_[0].start?_[0].start=J.start:_.unshift(J),_}function g(J,_){for(let N=_;N<J.length;N++){const $=J.charCodeAt(N);if(R($)||b($)||N>0&&!o(J.charCodeAt(N-1)))return N}return J.length}function w(J,_,N,$){if(N===J.length)return[];if($===_.length)return null;if(J[N]!==_[$].toLowerCase())return null;{let q=null,Z=$+1;for(q=w(J,_,N+1,$+1);!q&&(Z=g(_,Z))<_.length;)q=w(J,_,N+1,Z),Z++;return q===null?null:a({start:$,end:$+1},q)}}function d(J){let _=0,N=0,$=0,q=0,Z=0;for(let ve=0;ve<J.length;ve++)Z=J.charCodeAt(ve),R(Z)&&_++,k(Z)&&N++,o(Z)&&$++,b(Z)&&q++;const ce=_/J.length,be=N/J.length,oe=$/J.length,we=q/J.length;return{upperPercent:ce,lowerPercent:be,alphaPercent:oe,numericPercent:we}}function T(J){const{upperPercent:_,lowerPercent:N}=J;return N===0&&_>.6}function r(J){const{upperPercent:_,lowerPercent:N,alphaPercent:$,numericPercent:q}=J;return N>.2&&_<.8&&$>.6&&q<.2}function c(J){let _=0,N=0,$=0,q=0;for(let Z=0;Z<J.length;Z++)$=J.charCodeAt(Z),R($)&&_++,k($)&&N++,p($)&&q++;return(_===0||N===0)&&q===0?J.length<=30:_<=5}function n(J,_){if(!_||(_=_.trim(),_.length===0)||!c(J)||_.length>60)return null;const N=d(_);if(!r(N)){if(!T(N))return null;_=_.toLowerCase()}let $=null,q=0;for(J=J.toLowerCase();q<_.length&&($=w(J,_,0,q))===null;)q=g(_,q+1);return $}e.matchesCamelCase=n;function u(J,_,N=!1){if(!_||_.length===0)return null;let $=null,q=0;for(J=J.toLowerCase(),_=_.toLowerCase();q<_.length&&($=l(J,_,0,q,N))===null;)q=f(_,q+1);return $}e.matchesWords=u;function l(J,_,N,$,q){if(N===J.length)return[];if($===_.length)return null;if(t(J.charCodeAt(N),_.charCodeAt($))){let Z=null,ce=$+1;if(Z=l(J,_,N+1,$+1,q),!q)for(;!Z&&(ce=f(_,ce))<_.length;)Z=l(J,_,N+1,ce,q),ce++;return Z?J.charCodeAt(N)!==_.charCodeAt($)?Z:a({start:$,end:$+1},Z):null}else return null}function f(J,_){for(let N=_;N<J.length;N++)if(m(J.charCodeAt(N))||N>0&&m(J.charCodeAt(N-1)))return N;return J.length}const s=S(e.matchesPrefix,n,D),h=S(e.matchesPrefix,n,A),v=new i.LRUCache(1e4);function P(J,_,N=!1){if(typeof J!="string"||typeof _!="string")return null;let $=v.get(J);$||($=new RegExp(I.convertSimple2RegExpPattern(J),"i"),v.set(J,$));const q=$.exec(_);return q?[{start:q.index,end:q.index+q[0].length}]:N?h(J,_):s(J,_)}e.matchesFuzzy=P;function L(J,_){const N=Be(J,J.toLowerCase(),0,_,_.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return N?W(N):null}e.matchesFuzzy2=L;function j(J,_,N,$,q,Z){const ce=Math.min(13,J.length);for(;N<ce;N++){const be=Be(J,_,N,$,q,Z,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(be)return be}return[0,Z]}e.anyScore=j;function W(J){if(typeof J>"u")return[];const _=[],N=J[1];for(let $=J.length-1;$>1;$--){const q=J[$]+N,Z=_[_.length-1];Z&&Z.end===q?Z.end=q+1:_.push({start:q,end:q+1})}return _}e.createMatches=W;const V=128;function C(){const J=[],_=[];for(let N=0;N<=V;N++)_[N]=0;for(let N=0;N<=V;N++)J.push(_.slice(0));return J}function F(J){const _=[];for(let N=0;N<=J;N++)_[N]=0;return _}const O=F(2*V),x=F(2*V),B=C(),H=C(),G=C(),ee=!1;function ue(J,_,N,$,q){function Z(be,oe,we=" "){for(;be.length<oe;)be=we+be;return be}let ce=` |   |${$.split("").map(be=>Z(be,3)).join("|")}
`;for(let be=0;be<=N;be++)be===0?ce+=" |":ce+=`${_[be-1]}|`,ce+=J[be].slice(0,q+1).map(oe=>Z(oe.toString(),3)).join("|")+`
`;return ce}function re(J,_,N,$){J=J.substr(_),N=N.substr($),console.log(ue(H,J,J.length,N,N.length)),console.log(ue(G,J,J.length,N,N.length)),console.log(ue(B,J,J.length,N,N.length))}function pe(J,_){if(_<0||_>=J.length)return!1;const N=J.codePointAt(_);switch(N){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(N)}}function le(J,_){if(_<0||_>=J.length)return!1;switch(J.charCodeAt(_)){case 32:case 9:return!0;default:return!1}}function de(J,_,N){return _[J]!==N[J]}function Y(J,_,N,$,q,Z,ce=!1){for(;_<N&&q<Z;)J[_]===$[q]&&(ce&&(O[_]=q),_+=1),q+=1;return _===N}e.isPatternInWord=Y;var me;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(me||(me={}));var Se;(function(J){J.Default=[-100,0];function _(N){return!N||N.length===2&&N[0]===-100&&N[1]===0}J.isDefault=_})(Se=e.FuzzyScore||(e.FuzzyScore={}));class Oe{constructor(_,N){this.firstMatchCanBeWeak=_,this.boostFullMatch=N}}e.FuzzyScoreOptions=Oe,Oe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Be(J,_,N,$,q,Z,ce=Oe.default){const be=J.length>V?V:J.length,oe=$.length>V?V:$.length;if(N>=be||Z>=oe||be-N>oe-Z||!Y(_,N,be,q,Z,oe,!0))return;Xe(be,oe,N,Z,_,q);let we=1,ve=1,Ue=N,ze=Z;const et=[!1];for(we=1,Ue=N;Ue<be;we++,Ue++){const X=O[Ue],Q=x[Ue],ge=Ue+1<be?x[Ue+1]:oe;for(ve=X-Z+1,ze=X;ze<ge;ve++,ze++){let Ne=Number.MIN_SAFE_INTEGER,je=!1;ze<=Q&&(Ne=ke(J,_,Ue,N,$,q,ze,oe,Z,B[we-1][ve-1]===0,et));let qe=0;Ne!==Number.MAX_SAFE_INTEGER&&(je=!0,qe=Ne+H[we-1][ve-1]);const We=ze>X,Ze=We?H[we][ve-1]+(B[we][ve-1]>0?-5:0):0,nt=ze>X+1&&B[we][ve-1]>0,ct=nt?H[we][ve-2]+(B[we][ve-2]>0?-5:0):0;if(nt&&(!We||ct>=Ze)&&(!je||ct>=qe))H[we][ve]=ct,G[we][ve]=3,B[we][ve]=0;else if(We&&(!je||Ze>=qe))H[we][ve]=Ze,G[we][ve]=2,B[we][ve]=0;else if(je)H[we][ve]=qe,G[we][ve]=1,B[we][ve]=B[we-1][ve-1]+1;else throw new Error("not possible")}}if(ee&&re(J,N,$,Z),!et[0]&&!ce.firstMatchCanBeWeak)return;we--,ve--;const Ke=[H[we][ve],Z];let tt=0,Fe=0;for(;we>=1;){let X=ve;do{const Q=G[we][X];if(Q===3)X=X-2;else if(Q===2)X=X-1;else break}while(X>=1);tt>1&&_[N+we-1]===q[Z+ve-1]&&!de(X+Z-1,$,q)&&tt+1>B[we][X]&&(X=ve),X===ve?tt++:tt=1,Fe||(Fe=X),we--,ve=X-1,Ke.push(ve)}oe===be&&ce.boostFullMatch&&(Ke[0]+=2);const ht=Fe-be;return Ke[0]-=ht,Ke}e.fuzzyScore=Be;function Xe(J,_,N,$,q,Z){let ce=J-1,be=_-1;for(;ce>=N&&be>=$;)q[ce]===Z[be]&&(x[ce]=be,ce--),be--}function ke(J,_,N,$,q,Z,ce,be,oe,we,ve){if(_[N]!==Z[ce])return Number.MIN_SAFE_INTEGER;let Ue=1,ze=!1;return ce===N-$?Ue=J[N]===q[ce]?7:5:de(ce,q,Z)&&(ce===0||!de(ce-1,q,Z))?(Ue=J[N]===q[ce]?7:5,ze=!0):pe(Z,ce)&&(ce===0||!pe(Z,ce-1))?Ue=5:(pe(Z,ce-1)||le(Z,ce-1))&&(Ue=5,ze=!0),Ue>1&&N===$&&(ve[0]=!0),ze||(ze=de(ce,q,Z)||pe(Z,ce-1)||le(Z,ce-1)),N===$?ce>oe&&(Ue-=ze?3:5):we?Ue+=ze?2:0:Ue+=ze?0:1,ce+1===be&&(Ue-=ze?3:5),Ue}function ye(J,_,N,$,q,Z,ce){return se(J,_,N,$,q,Z,!0,ce)}e.fuzzyScoreGracefulAggressive=ye;function Ce(J,_,N,$,q,Z,ce){return se(J,_,N,$,q,Z,!1,ce)}e.fuzzyScoreGraceful=Ce;function se(J,_,N,$,q,Z,ce,be){let oe=Be(J,_,N,$,q,Z,be);if(oe&&!ce)return oe;if(J.length>=3){const we=Math.min(7,J.length-1);for(let ve=N+1;ve<we;ve++){const Ue=ae(J,ve);if(Ue){const ze=Be(Ue,Ue.toLowerCase(),N,$,q,Z,be);ze&&(ze[0]-=3,(!oe||ze[0]>oe[0])&&(oe=ze))}}}return oe}function ae(J,_){if(_+1>=J.length)return;const N=J[_],$=J[_+1];if(N!==$)return J.slice(0,_)+$+N+J.slice(_+2)}}),define(De[117],Ie([1,0,118,116,10]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",D=new RegExp(`\\$\\(${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(i.CSSIcon.iconNameCharacter),y=new RegExp(`(\\\\)?${D.source}`,"g");function k(a){return a.replace(y,(g,w)=>w?g:`\\${g}`)}e.escapeIcons=k;const R=new RegExp(`\\\\${D.source}`,"g");function b(a){return a.replace(R,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=b;const p=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function E(a){return a.indexOf(M)===-1?a:a.replace(p,(g,w,d,T)=>d?g:w||T||"")}e.stripIcons=E;function m(a){const g=a.indexOf(M);return g===-1?{text:a}:t(a,g)}e.parseLabelWithIcons=m;function t(a,g){const w=[];let d="";function T(h){if(h){d+=h;for(const v of h)w.push(n)}}let r=-1,c="",n=0,u,l,f=g;const s=a.length;for(T(a.substr(0,g));f<s;)u=a[f],l=a[f+1],u===M[0]&&l===M[1]?(r=f,T(c),c=M,f++):u===")"&&r!==-1?(n+=f-r+1,r=-1,c=""):r!==-1?A.test(u)?c+=u:(T(c),r=-1,c=""):T(u),f++;return T(c),{text:d,iconOffsets:w}}function o(a,g,w=!1){const{text:d,iconOffsets:T}=g;if(!T||T.length===0)return(0,I.matchesFuzzy)(a,d,w);const r=(0,S.ltrim)(d," "),c=d.length-r.length,n=(0,I.matchesFuzzy)(a,r,w);if(n)for(const u of n){const l=T[u.start+c]+c;u.start+=l,u.end+=l}return n}e.matchesFuzzyIconAware=o}),define(De[29],Ie([1,0,10]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(I||(I={})),function(S){const M="error",D="warning",A="warn",y="info",k="ignore";function R(p){return p?i.equalsIgnoreCase(M,p)?S.Error:i.equalsIgnoreCase(D,p)||i.equalsIgnoreCase(A,p)?S.Warning:i.equalsIgnoreCase(y,p)?S.Info:S.Ignore:S.Ignore}S.fromValue=R;function b(p){switch(p){case S.Error:return M;case S.Warning:return D;case S.Info:return y;default:return k}}S.toString=b}(I||(I={})),e.default=I}),define(De[46],Ie([1,0,18,10]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class S{constructor(){this._value="",this._pos=0}reset(E){return this._value=E,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(E){const m=E.charCodeAt(0),t=this._value.charCodeAt(this._pos);return m-t}value(){return this._value[this._pos]}}e.StringIterator=S;class M{constructor(E=!0){this._caseSensitive=E}reset(E){return this._value=E,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let E=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(E)this._from++;else break;else E=!1;return this}cmp(E){return this._caseSensitive?(0,I.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=M;class D{constructor(E=!0,m=!0){this._splitOnBackslash=E,this._caseSensitive=m}reset(E){this._from=0,this._to=0,this._value=E,this._valueLen=E.length;for(let m=E.length-1;m>=0;m--,this._valueLen--){const t=this._value.charCodeAt(m);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let E=!0;for(;this._to<this._valueLen;this._to++){const m=this._value.charCodeAt(this._to);if(m===47||this._splitOnBackslash&&m===92)if(E)this._from++;else break;else E=!1}return this}cmp(E){return this._caseSensitive?(0,I.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=D;var A;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(E,m){this._ignorePathCasing=E,this._ignoreQueryAndFragment=m,this._states=[],this._stateIdx=0}reset(E){return this._value=E,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new D(!1,!this._ignorePathCasing(E)),this._pathIterator.reset(E.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(E)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(E){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(E,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(E,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(E);if(this._states[this._stateIdx]===4)return(0,I.compare)(E,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(E,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(R||(R={}));class b{static forUris(E=()=>!1,m=()=>!1){return new b(new y(E,m))}static forPaths(E=!1){return new b(new D(void 0,!E))}static forStrings(){return new b(new S)}static forConfigKeys(){return new b(new M)}constructor(E){this._iter=E}clear(){this._root=void 0}fill(E,m){if(m){const t=m.slice(0);(0,i.shuffle)(t);for(const o of t)this.set(o,E)}else{const t=E.slice(0);(0,i.shuffle)(t);for(const o of t)this.set(o[0],o[1])}}set(E,m){const t=this._iter.reset(E);let o;this._root||(this._root=new k,this._root.segment=t.value());const a=[];for(o=this._root;;){const w=t.cmp(o.segment);if(w>0)o.left||(o.left=new k,o.left.segment=t.value()),a.push([-1,o]),o=o.left;else if(w<0)o.right||(o.right=new k,o.right.segment=t.value()),a.push([1,o]),o=o.right;else if(t.hasNext())t.next(),o.mid||(o.mid=new k,o.mid.segment=t.value()),a.push([0,o]),o=o.mid;else break}const g=o.value;o.value=m,o.key=E;for(let w=a.length-1;w>=0;w--){const d=a[w][1];d.updateHeight();const T=d.balanceFactor();if(T<-1||T>1){const r=a[w][0],c=a[w+1][0];if(r===1&&c===1)a[w][1]=d.rotateLeft();else if(r===-1&&c===-1)a[w][1]=d.rotateRight();else if(r===1&&c===-1)d.right=a[w+1][1]=a[w+1][1].rotateRight(),a[w][1]=d.rotateLeft();else if(r===-1&&c===1)d.left=a[w+1][1]=a[w+1][1].rotateLeft(),a[w][1]=d.rotateRight();else throw new Error;if(w>0)switch(a[w-1][0]){case-1:a[w-1][1].left=a[w][1];break;case 1:a[w-1][1].right=a[w][1];break;case 0:a[w-1][1].mid=a[w][1];break}else this._root=a[0][1]}}return g}get(E){return this._getNode(E)?.value}_getNode(E){const m=this._iter.reset(E);let t=this._root;for(;t;){const o=m.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(m.hasNext())m.next(),t=t.mid;else break}return t}has(E){const m=this._getNode(E);return!(m?.value===void 0&&m?.mid===void 0)}delete(E){return this._delete(E,!1)}deleteSuperstr(E){return this._delete(E,!0)}_delete(E,m){const t=this._iter.reset(E),o=[];let a=this._root;for(;a;){const g=t.cmp(a.segment);if(g>0)o.push([-1,a]),a=a.left;else if(g<0)o.push([1,a]),a=a.right;else if(t.hasNext())t.next(),o.push([0,a]),a=a.mid;else break}if(!!a){if(m?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const g=this._min(a.right);if(g.key){const{key:w,value:d,segment:T}=g;this._delete(g.key,!1),a.key=w,a.value=d,a.segment=T}}else{const g=a.left??a.right;if(o.length>0){const[w,d]=o[o.length-1];switch(w){case-1:d.left=g;break;case 0:d.mid=g;break;case 1:d.right=g;break}}else this._root=g}for(let g=o.length-1;g>=0;g--){const w=o[g][1];w.updateHeight();const d=w.balanceFactor();if(d>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),o[g][1]=w.rotateLeft()):d<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),o[g][1]=w.rotateRight()),g>0)switch(o[g-1][0]){case-1:o[g-1][1].left=o[g][1];break;case 1:o[g-1][1].right=o[g][1];break;case 0:o[g-1][1].mid=o[g][1];break}else this._root=o[0][1]}}}_min(E){for(;E.left;)E=E.left;return E}findSubstr(E){const m=this._iter.reset(E);let t=this._root,o;for(;t;){const a=m.cmp(t.segment);if(a>0)t=t.left;else if(a<0)t=t.right;else if(m.hasNext())m.next(),o=t.value||o,t=t.mid;else break}return t&&t.value||o}findSuperstr(E){const m=this._iter.reset(E);let t=this._root;for(;t;){const o=m.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(m.hasNext())m.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(E){for(const[m,t]of this)E(t,m)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(E){const m=[];return this._dfsEntries(E,m),m[Symbol.iterator]()}_dfsEntries(E,m){!E||(E.left&&this._dfsEntries(E.left,m),E.value&&m.push([E.key,E.value]),E.mid&&this._dfsEntries(E.mid,m),E.right&&this._dfsEntries(E.right,m))}_isBalanced(){const E=m=>{if(!m)return!0;const t=m.balanceFactor();return t<-1||t>1?!1:E(m.left)&&E(m.right)};return E(this._root)}}e.TernarySearchTree=b}),define(De[80],Ie([1,0,24,10,2]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(k){return JSON.stringify(k,A)}e.stringify=M;function D(k){let R=JSON.parse(k);return R=y(R),R}e.parse=D;function A(k,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,I.regExpFlags)(R)}:R}function y(k,R=0){if(!k||R>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return S.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 15:return new Date(k.source)}if(k instanceof i.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let b=0;b<k.length;++b)k[b]=y(k[b],R+1);else for(const b in k)Object.hasOwnProperty.call(k,b)&&(k[b]=y(k[b],R+1))}return k}e.revive=y}),define(De[13],Ie([1,0,21,2]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var S;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(S=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${S.vscodeRemoteResource}`}setPreferredWebSchema(k){this._preferredWebSchema=k}setDelegate(k){this._delegate=k}setServerRootPath(k){this._remoteResourcesPath=`${k}/${S.vscodeRemoteResource}`}set(k,R,b){this._hosts[k]=R,this._ports[k]=b}setConnectionToken(k,R){this._connectionTokens[k]=R}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(k){if(this._delegate)return this._delegate(k);const R=k.authority;let b=this._hosts[R];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const p=this._ports[R],E=this._connectionTokens[R];let m=`path=${encodeURIComponent(k.path)}`;return typeof E=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),I.URI.from({scheme:i.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${b}:${p}`,path:this._remoteResourcesPath,query:m})}}e.RemoteAuthorities=new M;class D{asBrowserUri(k,R){const b=this.toUri(k,R);return b.scheme===S.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===S.file&&(i.isNative||i.isWebWorker&&i.globals.origin===`${S.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?b.with({scheme:S.vscodeFileResource,authority:b.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(k,R){const b=this.toUri(k,R);return b.scheme===S.vscodeFileResource?b.with({scheme:S.file,authority:b.authority!==D.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(k,R){return I.URI.isUri(k)?k:I.URI.parse(R.toUrl(k))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D;var A;(function(y){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(k.get("3"));const R="vscode-coi";function b(E){let m;typeof E=="string"?m=new URL(E).searchParams:E instanceof URL?m=E.searchParams:I.URI.isUri(E)&&(m=new URL(E.toString(!0)).searchParams);const t=m?.get(R);if(!!t)return k.get(t)}y.getHeadersFromQuery=b;function p(E,m,t){if(!globalThis.crossOriginIsolated)return;const o=m&&t?"3":t?"2":"1";E instanceof URLSearchParams?E.set(R,o):E[R]=o}y.addSearchParam=p})(A=e.COI||(e.COI={}))}),define(De[22],Ie([1,0,39,13,19,21,10,2]),function(ie,e,i,I,S,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(E){return(0,A.uriToFsPath)(E,!0)}e.originalFSPath=y;class k{constructor(m){this._ignorePathCasing=m}compare(m,t,o=!1){return m===t?0:(0,D.compare)(this.getComparisonKey(m,o),this.getComparisonKey(t,o))}isEqual(m,t,o=!1){return m===t?!0:!m||!t?!1:this.getComparisonKey(m,o)===this.getComparisonKey(t,o)}getComparisonKey(m,t=!1){return m.with({path:this._ignorePathCasing(m)?m.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(m){return this._ignorePathCasing(m)}isEqualOrParent(m,t,o=!1){if(m.scheme===t.scheme){if(m.scheme===I.Schemas.file)return i.isEqualOrParent(y(m),y(t),this._ignorePathCasing(m))&&m.query===t.query&&(o||m.fragment===t.fragment);if((0,e.isEqualAuthority)(m.authority,t.authority))return i.isEqualOrParent(m.path,t.path,this._ignorePathCasing(m),"/")&&m.query===t.query&&(o||m.fragment===t.fragment)}return!1}joinPath(m,...t){return A.URI.joinPath(m,...t)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return S.posix.basename(m.path)}extname(m){return S.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let t;return m.scheme===I.Schemas.file?t=A.URI.file(S.dirname(y(m))).path:(t=S.posix.dirname(m.path),m.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),t="/")),m.with({path:t})}normalizePath(m){if(!m.path.length)return m;let t;return m.scheme===I.Schemas.file?t=A.URI.file(S.normalize(y(m))).path:t=S.posix.normalize(m.path),m.with({path:t})}relativePath(m,t){if(m.scheme!==t.scheme||!(0,e.isEqualAuthority)(m.authority,t.authority))return;if(m.scheme===I.Schemas.file){const g=S.relative(y(m),y(t));return M.isWindows?i.toSlashes(g):g}let o=m.path||"/";const a=t.path||"/";if(this._ignorePathCasing(m)){let g=0;for(const w=Math.min(o.length,a.length);g<w&&!(o.charCodeAt(g)!==a.charCodeAt(g)&&o.charAt(g).toLowerCase()!==a.charAt(g).toLowerCase());g++);o=a.substr(0,g)+o.substr(g)}return S.posix.relative(o,a)}resolvePath(m,t){if(m.scheme===I.Schemas.file){const o=A.URI.file(S.resolve(y(m),t));return m.with({authority:o.authority,path:o.path})}return t=i.toPosixPath(t),m.with({path:S.posix.resolve(m.path,t)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,t){return m===t||m!==void 0&&t!==void 0&&(0,D.equalsIgnoreCase)(m,t)}hasTrailingPathSeparator(m,t=S.sep){if(m.scheme===I.Schemas.file){const o=y(m);return o.length>i.getRoot(o).length&&o[o.length-1]===t}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,t=S.sep){return(0,e.hasTrailingPathSeparator)(m,t)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,t=S.sep){let o=!1;if(m.scheme===I.Schemas.file){const a=y(m);o=a!==void 0&&a.length===i.getRoot(a).length&&a[a.length-1]===t}else{t="/";const a=m.path;o=a.length===1&&a.charCodeAt(a.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(m,t)?m.with({path:m.path+"/"}):m}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(E=>E.scheme===I.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new k(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(E,m){const t=[];for(let o=0;o<E.length;o++){const a=m(E[o]);E.some((g,w)=>w===o?!1:(0,e.isEqualOrParent)(a,m(g)))||t.push(E[o])}return t}e.distinctParents=R;var b;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function m(t){const o=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(w=>{const[d,T]=w.split(":");d&&T&&o.set(d,T)});const g=t.path.substring(0,t.path.indexOf(";"));return g&&o.set(E.META_DATA_MIME,g),o}E.parseMetaData=m})(b=e.DataUri||(e.DataUri={}));function p(E,m,t){if(m){let o=E.path;return o&&o[0]!==S.posix.sep&&(o=S.posix.sep+o),E.with({scheme:t,authority:m,path:o})}return E.with({scheme:t})}e.toLocalResource=p}),define(De[15],Ie([1,0,20,12,4,7,22,21]),function(ie,e,i,I,S,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(de){return!!de&&typeof de.then=="function"}e.isThenable=y;function k(de){const Y=new i.CancellationTokenSource,me=de(Y.token),Se=new Promise((Oe,Be)=>{const Xe=Y.token.onCancellationRequested(()=>{Xe.dispose(),Y.dispose(),Be(new I.CancellationError)});Promise.resolve(me).then(ke=>{Xe.dispose(),Y.dispose(),Oe(ke)},ke=>{Xe.dispose(),Y.dispose(),Be(ke)})});return new class{cancel(){Y.cancel()}then(Oe,Be){return Se.then(Oe,Be)}catch(Oe){return this.then(void 0,Oe)}finally(Oe){return Se.finally(Oe)}}}e.createCancelablePromise=k;function R(de,Y,me){return new Promise((Se,Oe)=>{const Be=Y.onCancellationRequested(()=>{Be.dispose(),Se(me)});de.then(Se,Oe).finally(()=>Be.dispose())})}e.raceCancellation=R;function b(de,Y){return new Promise((me,Se)=>{const Oe=Y.onCancellationRequested(()=>{Oe.dispose(),Se(new I.CancellationError)});de.then(me,Se).finally(()=>Oe.dispose())})}e.raceCancellationError=b;async function p(de){let Y=-1;const me=de.map((Oe,Be)=>Oe.then(Xe=>(Y=Be,Xe))),Se=await Promise.race(me);return de.forEach((Oe,Be)=>{Be!==Y&&Oe.cancel()}),Se}e.raceCancellablePromises=p;function E(de,Y,me){let Se;const Oe=setTimeout(()=>{Se?.(void 0),me?.()},Y);return Promise.race([de.finally(()=>clearTimeout(Oe)),new Promise(Be=>Se=Be)])}e.raceTimeout=E;function m(de){return new Promise((Y,me)=>{const Se=de();y(Se)?Se.then(Y,me):Y(Se)})}e.asPromise=m;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const me=()=>{this.queuedPromise=null;const Se=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Se};this.queuedPromise=new Promise(Se=>{this.activePromise.then(me,me).then(Se)})}return new Promise((me,Se)=>{this.queuedPromise.then(me,Se)})}return this.activePromise=Y(),new Promise((me,Se)=>{this.activePromise.then(Oe=>{this.activePromise=null,me(Oe)},Oe=>{this.activePromise=null,Se(Oe)})})}}e.Throttler=t;class o{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=o;class a{constructor(){this.promiseMap=new Map}queue(Y,me){const Oe=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.promiseMap.get(Y)===Oe&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,Oe),Oe}}e.SequencerByKey=a;const g=(de,Y)=>{let me=!0;const Se=setTimeout(()=>{me=!1,Y()},de);return{isTriggered:()=>me,dispose:()=>{clearTimeout(Se),me=!1}}},w=de=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,de())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,me=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Oe,Be)=>{this.doResolve=Oe,this.doReject=Be}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Oe=this.task;return this.task=null,Oe()}}));const Se=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=me===e.MicrotaskDelay?w(Se):g(me,Se),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new I.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=d;class T{constructor(Y){this.delayer=new d(Y),this.throttler=new t}trigger(Y,me){return this.delayer.trigger(()=>this.throttler.queue(Y),me)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=T;class r{constructor(){this._isOpen=!1,this._promise=new Promise((Y,me)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class c extends r{constructor(Y){super(),this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function n(de,Y){return Y?new Promise((me,Se)=>{const Oe=setTimeout(()=>{Be.dispose(),me()},de),Be=Y.onCancellationRequested(()=>{clearTimeout(Oe),Be.dispose(),Se(new I.CancellationError)})}):k(me=>n(de,me))}e.timeout=n;function u(de,Y=0){const me=setTimeout(de,Y);return(0,M.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=u;function l(de){const Y=[];let me=0;const Se=de.length;function Oe(){return me<Se?de[me++]():null}function Be(Xe){Xe!=null&&Y.push(Xe);const ke=Oe();return ke?ke.then(Be):Promise.resolve(Y)}return Promise.resolve(null).then(Be)}e.sequence=l;function f(de,Y=Se=>!!Se,me=null){let Se=0;const Oe=de.length,Be=()=>{if(Se>=Oe)return Promise.resolve(me);const Xe=de[Se++];return Promise.resolve(Xe()).then(ye=>Y(ye)?Promise.resolve(ye):Be())};return Be()}e.first=f;function s(de,Y=Se=>!!Se,me=null){if(de.length===0)return Promise.resolve(me);let Se=de.length;const Oe=()=>{Se=-1;for(const Be of de)Be.cancel?.()};return new Promise((Be,Xe)=>{for(const ke of de)ke.then(ye=>{--Se>=0&&Y(ye)?(Oe(),Be(ye)):Se===0&&Be(me)}).catch(ye=>{--Se>=0&&(Oe(),Xe(ye))})})}e.firstParallel=s;class h{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new S.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Y){return this._size++,new Promise((me,Se)=>{this.outstandingPromises.push({factory:Y,c:me,e:Se}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const me=Y.factory();me.then(Y.c,Y.e),me.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=h;class v extends h{constructor(){super(1)}}e.Queue=v;class P{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new G;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,me=D.extUri){const Se=me.getComparisonKey(Y);let Oe=this.queues.get(Se);return Oe||(Oe=new v,S.Event.once(Oe.onDrained)(()=>{Oe?.dispose(),this.queues.delete(Se),this.onDidQueueDrain()}),this.queues.set(Se,Oe)),Oe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=P;class L{constructor(Y,me){this._token=-1,typeof Y=="function"&&typeof me=="number"&&this.setIfNotSet(Y,me)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,me){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},me)}setIfNotSet(Y,me){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},me))}}e.TimeoutTimer=L;class j{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,me){this.cancel(),this._token=setInterval(()=>{Y()},me)}}e.IntervalTimer=j;class W{constructor(Y,me){this.timeoutToken=-1,this.runner=Y,this.timeout=me,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=W;class V{constructor(Y,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=me,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=V;class C extends W{constructor(Y,me){super(Y,me),this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner?.(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=C;class F extends M.Disposable{constructor(Y,me){super(),this.options=Y,this.handler=me,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new W(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=de=>{(0,A.setTimeout0)(()=>{if(Y)return;const me=Date.now()+15;de(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(de,Y)=>{const me=requestIdleCallback(de,typeof Y=="number"?{timeout:Y}:void 0);let Se=!1;return{dispose(){Se||(Se=!0,cancelIdleCallback(me))}}}}();class O{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(me){this._error=me}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function x(de,Y,me){let Se;for(let Oe=0;Oe<me;Oe++)try{return await de()}catch(Be){Se=Be,await n(Y)}throw Se}e.retry=x;class B{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Y,me,Se){return this._pending={taskId:Y,cancel:()=>Se?.(),promise:me},me.then(()=>this.donePending(Y),()=>this.donePending(Y)),me}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let me,Se;const Oe=new Promise((Be,Xe)=>{me=Be,Se=Xe});this._next={run:Y,promise:Oe,promiseResolve:me,promiseReject:Se}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=B;class H{constructor(Y,me=()=>Date.now()){this.interval=Y,this.nowFn=me,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class G{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,me)=>{this.completeCallback=Y,this.errorCallback=me})}complete(Y){return new Promise(me=>{this.completeCallback(Y),this.resolved=!0,me()})}error(Y){return new Promise(me=>{this.errorCallback(Y),this.rejected=!0,me()})}cancel(){new Promise(Y=>{this.errorCallback(new I.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=G;var ee;(function(de){async function Y(Se){let Oe;const Be=await Promise.all(Se.map(Xe=>Xe.then(ke=>ke,ke=>{Oe||(Oe=ke)})));if(typeof Oe<"u")throw Oe;return Be}de.settled=Y;function me(Se){return new Promise(async(Oe,Be)=>{try{await Se(Oe,Be)}catch(Xe){Be(Xe)}})}de.withAsyncBody=me})(ee=e.Promises||(e.Promises={}));var ue;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(ue||(ue={}));class re{static fromArray(Y){return new re(me=>{me.emitMany(Y)})}static fromPromise(Y){return new re(async me=>{me.emitMany(await Y)})}static fromPromises(Y){return new re(async me=>{await Promise.all(Y.map(async Se=>me.emitOne(await Se)))})}static merge(Y){return new re(async me=>{await Promise.all(Y.map(async Se=>{for await(const Oe of Se)me.emitOne(Oe)}))})}constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new S.Emitter,queueMicrotask(async()=>{const me={emitOne:Se=>this.emitOne(Se),emitMany:Se=>this.emitMany(Se),reject:Se=>this.reject(Se)};try{await Promise.resolve(Y(me)),this.resolve()}catch(Se){this.reject(Se)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await S.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,me){return new re(async Se=>{for await(const Oe of Y)Se.emitOne(me(Oe))})}map(Y){return re.map(this,Y)}static filter(Y,me){return new re(async Se=>{for await(const Oe of Y)me(Oe)&&Se.emitOne(Oe)})}filter(Y){return re.filter(this,Y)}static coalesce(Y){return re.filter(Y,me=>!!me)}coalesce(){return re.coalesce(this)}static async toPromise(Y){const me=[];for await(const Se of Y)me.push(Se);return me}toPromise(){return re.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=re,re.EMPTY=re.fromArray([]);class pe extends re{constructor(Y,me){super(me),this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=pe;function le(de){const Y=new i.CancellationTokenSource,me=de(Y.token);return new pe(Y,async Se=>{const Oe=Y.token.onCancellationRequested(()=>{Oe.dispose(),Y.dispose(),Se.reject(new I.CancellationError)});try{for await(const Be of me){if(Y.token.isCancellationRequested)return;Se.emitOne(Be)}Oe.dispose(),Y.dispose()}catch(Be){Oe.dispose(),Y.dispose(),Se.reject(Be)}})}e.createCancelableAsyncIterable=le}),define(De[119],Ie([1,0,15,19]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new i.IdleValue(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),M=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(v,P,L=!1){const j=v||"",W=P||"",V=S.value.collator.compare(j,W);return S.value.collatorIsNumeric&&V===0&&j!==W?j<W?-1:1:V}e.compareFileNames=A;function y(v,P){const L=M.value.collator;return v=v||"",P=P||"",T(L,v,P)}e.compareFileNamesDefault=y;function k(v,P){const L=M.value.collator;return v=v||"",P=P||"",u(v,P)||T(L,v,P)}e.compareFileNamesUpper=k;function R(v,P){const L=M.value.collator;return v=v||"",P=P||"",n(v,P)||T(L,v,P)}e.compareFileNamesLower=R;function b(v,P){return v=v||"",P=P||"",v===P?0:v<P?-1:1}e.compareFileNamesUnicode=b;function p(v,P,L=!1){L||(v=v&&v.toLowerCase(),P=P&&P.toLowerCase());const[j,W]=w(v),[V,C]=w(P);return j!==V?j<V?-1:1:W===C?0:W<C?-1:1}e.noIntlCompareFileNames=p;function E(v,P){const[L,j]=w(v),[W,V]=w(P);let C=S.value.collator.compare(j,V);if(C===0){if(S.value.collatorIsNumeric&&j!==V)return j<V?-1:1;if(C=S.value.collator.compare(L,W),S.value.collatorIsNumeric&&C===0&&L!==W)return L<W?-1:1}return C}e.compareFileExtensions=E;function m(v,P){v=v||"",P=P||"";const L=d(v),j=d(P),W=M.value.collator,V=D.value.collator;return T(V,L,j)||T(W,v,P)}e.compareFileExtensionsDefault=m;function t(v,P){v=v||"",P=P||"";const L=d(v),j=d(P),W=M.value.collator,V=D.value.collator;return T(V,L,j)||u(v,P)||T(W,v,P)}e.compareFileExtensionsUpper=t;function o(v,P){v=v||"",P=P||"";const L=d(v),j=d(P),W=M.value.collator,V=D.value.collator;return T(V,L,j)||n(v,P)||T(W,v,P)}e.compareFileExtensionsLower=o;function a(v,P){v=v||"",P=P||"";const L=d(v).toLowerCase(),j=d(P).toLowerCase();return L!==j?L<j?-1:1:v!==P?v<P?-1:1:0}e.compareFileExtensionsUnicode=a;const g=/^(.*?)(\.([^.]*))?$/;function w(v,P=!1){const L=v?g.exec(v):[];let j=[L&&L[1]||"",L&&L[3]||""];return P&&(!j[0]&&j[1]||j[0]&&j[0].charAt(0)===".")&&(j=[j[0]+"."+j[1],""]),j}function d(v){const P=v?g.exec(v):[];return P&&P[1]&&P[1].charAt(0)!=="."&&P[3]||""}function T(v,P,L){const j=v.compare(P,L);return j!==0?j:P.length!==L.length?P.length<L.length?-1:1:0}function r(v){const P=v.charAt(0);return P.toLocaleUpperCase()!==P}function c(v){const P=v.charAt(0);return P.toLocaleLowerCase()!==P}function n(v,P){return r(v)&&c(P)?-1:c(v)&&r(P)?1:0}function u(v,P){return c(v)&&r(P)?-1:r(v)&&c(P)?1:0}function l(v,P,L=!1){return L||(v=v&&v.toLowerCase(),P=P&&P.toLowerCase()),v===P?0:v<P?-1:1}function f(v,P,L=!1){const j=v.split(I.sep),W=P.split(I.sep),V=j.length-1,C=W.length-1;let F,O;for(let x=0;;x++){if(F=V===x,O=C===x,F&&O)return A(j[x],W[x],L);if(F)return-1;if(O)return 1;const B=l(j[x],W[x],L);if(B!==0)return B}}e.comparePaths=f;function s(v,P,L){const j=v.toLowerCase(),W=P.toLowerCase(),V=h(v,P,L);if(V)return V;const C=j.endsWith(L),F=W.endsWith(L);if(C!==F)return C?-1:1;const O=A(j,W);return O!==0?O:j.localeCompare(W)}e.compareAnything=s;function h(v,P,L){const j=v.toLowerCase(),W=P.toLowerCase(),V=j.startsWith(L),C=W.startsWith(L);if(V!==C)return V?-1:1;if(V&&C){if(j.length<W.length)return-1;if(j.length>W.length)return 1}return 0}e.compareByPrefix=h}),define(De[34],Ie([1,0,18,15,39,28,19,21,10]),function(ie,e,i,I,S,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",b="[^/\\\\]",p=/\//g;function E(G,ee){switch(G){case 0:return"";case 1:return`${b}*?`;default:return`(?:${R}|${b}+${R}${ee?`|${R}${b}+`:""})*?`}}function m(G,ee){if(!G)return[];const ue=[];let re=!1,pe=!1,le="";for(const de of G){switch(de){case ee:if(!re&&!pe){ue.push(le),le="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}le+=de}return le&&ue.push(le),ue}e.splitGlobAware=m;function t(G){if(!G)return"";let ee="";const ue=m(G,e.GLOB_SPLIT);if(ue.every(re=>re===e.GLOBSTAR))ee=".*";else{let re=!1;ue.forEach((pe,le)=>{if(pe===e.GLOBSTAR){if(re)return;ee+=E(2,le===ue.length-1)}else{let de=!1,Y="",me=!1,Se="";for(const Oe of pe){if(Oe!=="}"&&de){Y+=Oe;continue}if(me&&(Oe!=="]"||!Se)){let Be;Oe==="-"?Be=Oe:(Oe==="^"||Oe==="!")&&!Se?Be="^":Oe===e.GLOB_SPLIT?Be="":Be=(0,y.escapeRegExpCharacters)(Oe),Se+=Be;continue}switch(Oe){case"{":de=!0;continue;case"[":me=!0;continue;case"}":{ee+=`(?:${m(Y,",").map(ke=>t(ke)).join("|")})`,de=!1,Y="";break}case"]":{ee+="["+Se+"]",me=!1,Se="";break}case"?":ee+=b;continue;case"*":ee+=E(1);continue;default:ee+=(0,y.escapeRegExpCharacters)(Oe)}}le<ue.length-1&&(ue[le+1]!==e.GLOBSTAR||le+2<ue.length)&&(ee+=R)}re=pe===e.GLOBSTAR})}return ee}const o=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,T=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new M.LRUCache(1e4),c=function(){return!1},n=function(){return null};function u(G,ee){if(!G)return n;let ue;typeof G!="string"?ue=G.pattern:ue=G,ue=ue.trim();const re=`${ue}_${!!ee.trimForExclusions}`;let pe=r.get(re);if(pe)return l(pe,G);let le;return o.test(ue)?pe=s(ue.substr(4),ue):(le=a.exec(f(ue,ee)))?pe=h(le[1],ue):(ee.trimForExclusions?w:g).test(ue)?pe=v(ue,ee):(le=d.exec(f(ue,ee)))?pe=P(le[1].substr(1),ue,!0):(le=T.exec(f(ue,ee)))?pe=P(le[1],ue,!1):pe=L(ue),r.set(re,pe),l(pe,G)}function l(G,ee){if(typeof ee=="string")return G;const ue=function(re,pe){return(0,S.isEqualOrParent)(re,ee.base,!A.isLinux)?G(re.substr(ee.base.length+1),pe):null};return ue.allBasenames=G.allBasenames,ue.allPaths=G.allPaths,ue.basenames=G.basenames,ue.patterns=G.patterns,ue}function f(G,ee){return ee.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function s(G,ee){return function(ue,re){return typeof ue=="string"&&ue.endsWith(G)?ee:null}}function h(G,ee){const ue=`/${G}`,re=`\\${G}`,pe=function(de,Y){return typeof de!="string"?null:Y?Y===G?ee:null:de===G||de.endsWith(ue)||de.endsWith(re)?ee:null},le=[G];return pe.basenames=le,pe.patterns=[ee],pe.allBasenames=le,pe}function v(G,ee){const ue=B(G.slice(1,-1).split(",").map(Y=>u(Y,ee)).filter(Y=>Y!==n),G),re=ue.length;if(!re)return n;if(re===1)return ue[0];const pe=function(Y,me){for(let Se=0,Oe=ue.length;Se<Oe;Se++)if(ue[Se](Y,me))return G;return null},le=ue.find(Y=>!!Y.allBasenames);le&&(pe.allBasenames=le.allBasenames);const de=ue.reduce((Y,me)=>me.allPaths?Y.concat(me.allPaths):Y,[]);return de.length&&(pe.allPaths=de),pe}function P(G,ee,ue){const re=D.sep===D.posix.sep,pe=re?G:G.replace(p,D.sep),le=D.sep+pe,de=D.posix.sep+G;let Y;return ue?Y=function(me,Se){return typeof me=="string"&&(me===pe||me.endsWith(le)||!re&&(me===G||me.endsWith(de)))?ee:null}:Y=function(me,Se){return typeof me=="string"&&(me===pe||!re&&me===G)?ee:null},Y.allPaths=[(ue?"*/":"./")+G],Y}function L(G){try{const ee=new RegExp(`^${t(G)}$`);return function(ue){return ee.lastIndex=0,typeof ue=="string"&&ee.test(ue)?G:null}}catch{return n}}function j(G,ee,ue){return!G||typeof ee!="string"?!1:W(G)(ee,void 0,ue)}e.match=j;function W(G,ee={}){if(!G)return c;if(typeof G=="string"||V(G)){const ue=u(G,ee);if(ue===n)return c;const re=function(pe,le){return!!ue(pe,le)};return ue.allBasenames&&(re.allBasenames=ue.allBasenames),ue.allPaths&&(re.allPaths=ue.allPaths),re}return O(G,ee)}e.parse=W;function V(G){const ee=G;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}e.isRelativePattern=V;function C(G){return G.allBasenames||[]}e.getBasenameTerms=C;function F(G){return G.allPaths||[]}e.getPathTerms=F;function O(G,ee){const ue=B(Object.getOwnPropertyNames(G).map(Y=>x(Y,G[Y],ee)).filter(Y=>Y!==n)),re=ue.length;if(!re)return n;if(!ue.some(Y=>!!Y.requiresSiblings)){if(re===1)return ue[0];const Y=function(Oe,Be){let Xe;for(let ke=0,ye=ue.length;ke<ye;ke++){const Ce=ue[ke](Oe,Be);if(typeof Ce=="string")return Ce;(0,I.isThenable)(Ce)&&(Xe||(Xe=[]),Xe.push(Ce))}return Xe?(async()=>{for(const ke of Xe){const ye=await ke;if(typeof ye=="string")return ye}return null})():null},me=ue.find(Oe=>!!Oe.allBasenames);me&&(Y.allBasenames=me.allBasenames);const Se=ue.reduce((Oe,Be)=>Be.allPaths?Oe.concat(Be.allPaths):Oe,[]);return Se.length&&(Y.allPaths=Se),Y}const pe=function(Y,me,Se){let Oe,Be;for(let Xe=0,ke=ue.length;Xe<ke;Xe++){const ye=ue[Xe];ye.requiresSiblings&&Se&&(me||(me=(0,D.basename)(Y)),Oe||(Oe=me.substr(0,me.length-(0,D.extname)(Y).length)));const Ce=ye(Y,me,Oe,Se);if(typeof Ce=="string")return Ce;(0,I.isThenable)(Ce)&&(Be||(Be=[]),Be.push(Ce))}return Be?(async()=>{for(const Xe of Be){const ke=await Xe;if(typeof ke=="string")return ke}return null})():null},le=ue.find(Y=>!!Y.allBasenames);le&&(pe.allBasenames=le.allBasenames);const de=ue.reduce((Y,me)=>me.allPaths?Y.concat(me.allPaths):Y,[]);return de.length&&(pe.allPaths=de),pe}function x(G,ee,ue){if(ee===!1)return n;const re=u(G,ue);if(re===n)return n;if(typeof ee=="boolean")return re;if(ee){const pe=ee.when;if(typeof pe=="string"){const le=(de,Y,me,Se)=>{if(!Se||!re(de,Y))return null;const Oe=pe.replace("$(basename)",me),Be=Se(Oe);return(0,I.isThenable)(Be)?Be.then(Xe=>Xe?G:null):Be?G:null};return le.requiresSiblings=!0,le}}return re}function B(G,ee){const ue=G.filter(Y=>!!Y.basenames);if(ue.length<2)return G;const re=ue.reduce((Y,me)=>{const Se=me.basenames;return Se?Y.concat(Se):Y},[]);let pe;if(ee){pe=[];for(let Y=0,me=re.length;Y<me;Y++)pe.push(ee)}else pe=ue.reduce((Y,me)=>{const Se=me.patterns;return Se?Y.concat(Se):Y},[]);const le=function(Y,me){if(typeof Y!="string")return null;if(!me){let Oe;for(Oe=Y.length;Oe>0;Oe--){const Be=Y.charCodeAt(Oe-1);if(Be===47||Be===92)break}me=Y.substr(Oe)}const Se=re.indexOf(me);return Se!==-1?pe[Se]:null};le.basenames=re,le.patterns=pe,le.allBasenames=re;const de=G.filter(Y=>!Y.basenames);return de.push(le),de}function H(G,ee){return(0,i.equals)(G,ee,(ue,re)=>typeof ue=="string"&&typeof re=="string"?ue===re:typeof ue!="string"&&typeof re!="string"?ue.base===re.base&&ue.pattern===re.pattern:!1)}e.patternsEquals=H}),define(De[81],Ie([1,0,12,117,22,10,2]),function(ie,e,i,I,S,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(a="",g=!1){if(this.value=a,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(a,g=0){return this.value+=p(this.supportThemeIcons?(0,I.escapeIcons)(a):a).replace(/([ \t]+)/g,(w,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,g){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(a,g,w){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(a),")"),w&&(this.value+=` "${this._escape(this._escape(w,'"'),")")}"`),this.value+=")",this}_escape(a,g){const w=new RegExp((0,M.escapeRegExpCharacters)(g),"g");return a.replace(w,(d,T)=>a.charAt(T-1)!=="\\"?`\\${d}`:d)}}e.MarkdownString=y;function k(o){return R(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.isEmptyMarkdownString=k;function R(o){return o instanceof y?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function b(o,a){return o===a?!0:!o||!a?!1:o.value===a.value&&o.isTrusted===a.isTrusted&&o.supportThemeIcons===a.supportThemeIcons&&o.supportHtml===a.supportHtml&&(o.baseUri===a.baseUri||!!o.baseUri&&!!a.baseUri&&(0,S.isEqual)(D.URI.from(o.baseUri),D.URI.from(a.baseUri)))}e.markdownStringEqual=b;function p(o){return o.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=p;function E(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=E;function m(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=m;function t(o){const a=[],g=o.split("|").map(d=>d.trim());o=g[0];const w=g[1];if(w){const d=/height=(\d+)/.exec(w),T=/width=(\d+)/.exec(w),r=d?d[1]:"",c=T?T[1]:"",n=isFinite(parseInt(c)),u=isFinite(parseInt(r));n&&a.push(`width="${c}"`),u&&a.push(`height="${r}"`)}return{href:o,dimensions:a}}e.parseHrefAndDimensions=t}),define(De[82],Ie([1,0,18,39,19,21,22,10]),function(ie,e,i,I,S,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(n,u){const{os:l,tildify:f,relative:s}=u;if(s){const P=k(n,s,l);if(typeof P=="string")return P}let h=n.fsPath;if(l===1&&!M.isWindows?h=h.replace(/\//g,"\\"):l!==1&&M.isWindows&&(h=h.replace(/\\/g,"/")),l!==1&&f?.userHome){const P=f.userHome.fsPath;let L;n.scheme!==f.userHome.scheme&&n.path.startsWith(S.posix.sep)?L=f.userHome.with({path:n.path}).fsPath:L=n.fsPath,h=p(L,P,l)}return(l===1?S.win32:S.posix).normalize(R(h,l===1))}e.getPathLabel=y;function k(n,u,l){const f=l===1?S.win32:S.posix,s=l===3?D.extUri:D.extUriIgnorePathCase,h=u.getWorkspace(),v=(0,i.firstOrDefault)(h.folders);if(!v)return;n.scheme!==v.uri.scheme&&n.path.startsWith(S.posix.sep)&&(n=v.uri.with({path:n.path}));const P=u.getWorkspaceFolder(n);if(!P)return;let L;if(s.isEqual(P.uri,n)?L="":L=s.relativePath(P.uri,n)??"",L&&(L=f.normalize(L)),h.folders.length>1&&!u.noPrefix){const j=P.name?P.name:s.basenameOrAuthority(P.uri);L=L?`${j} \u2022 ${L}`:j}return L}function R(n,u=M.isWindows){return(0,I.hasDriveLetter)(n,u)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=R;let b=Object.create(null);function p(n,u,l=M.OS){if(l===1||!n||!u)return n;let f=b.original===u?b.normalized:void 0;f||(f=u,M.isWindows&&(f=(0,I.toSlashes)(f)),f=`${(0,A.rtrim)(f,S.posix.sep)}${S.posix.sep}`,b={original:u,normalized:f});let s=n;return M.isWindows&&(s=(0,I.toSlashes)(s)),(l===3?s.startsWith(f):(0,A.startsWithIgnoreCase)(s,f))?`~/${s.substr(f.length)}`:n}e.tildify=p;function E(n,u){return n.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=E;const m="\u2026",t="\\\\",o="~";function a(n,u=S.sep){const l=new Array(n.length);let f=!1;for(let s=0;s<n.length;s++){const h=n[s];if(h===""){l[s]=`.${u}`;continue}if(!h){l[s]=h;continue}f=!0;let v="",P=h;P.indexOf(t)===0?(v=P.substr(0,P.indexOf(t)+t.length),P=P.substr(P.indexOf(t)+t.length)):P.indexOf(u)===0?(v=P.substr(0,P.indexOf(u)+u.length),P=P.substr(P.indexOf(u)+u.length)):P.indexOf(o)===0&&(v=P.substr(0,P.indexOf(o)+o.length),P=P.substr(P.indexOf(o)+o.length));const L=P.split(u);for(let j=1;f&&j<=L.length;j++)for(let W=L.length-j;f&&W>=0;W--){f=!1;let V=L.slice(W,W+j).join(u);for(let C=0;!f&&C<n.length;C++)if(C!==s&&n[C]&&n[C].indexOf(V)>-1){const F=W+j===L.length,O=W>0&&n[C].indexOf(u)>-1?u+V:V,x=n[C].endsWith(O);f=!F||x}if(!f){let C="";(L[0].endsWith(":")||v!=="")&&(W===1&&(W=0,j++,V=L[0]+u+V),W>0&&(C=L[0]+u),C=v+C),W>0&&(C=C+m+u),C=C+V,W+j<L.length&&(C=C+u+m),l[s]=C}}f&&(l[s]=h)}return l}e.shorten=a;var g;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function w(n,u=Object.create(null)){const l=[];let f=!1,s="";for(const h of n)if(h==="$"||f&&h==="{")s&&l.push({value:s,type:g.TEXT}),s="",f=!0;else if(h==="}"&&f){const v=u[s];if(typeof v=="string")v.length&&l.push({value:v,type:g.VARIABLE});else if(v){const P=l[l.length-1];(!P||P.type!==g.SEPARATOR)&&l.push({value:v.label,type:g.SEPARATOR})}s="",f=!1}else s+=h;return s&&!f&&l.push({value:s,type:g.TEXT}),l.filter((h,v)=>{if(h.type===g.SEPARATOR){const P=l[v-1],L=l[v+1];return[P,L].every(j=>j&&(j.type===g.VARIABLE||j.type===g.TEXT)&&j.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=w;function d(n,u){return M.isMacintosh||u?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):n.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=d;function T(n,u){return M.isMacintosh||u?n.replace(/\(&&\w\)|&&/g,""):M.isWindows?n.replace(/&&|&/g,l=>l==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=T;function r(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=r;function c(n){const u=n.indexOf("/")!==-1?S.posix:S.win32,l=u.basename(n),f=u.dirname(n);return l.length?{name:l,parentPath:f}:{name:f,parentPath:""}}e.splitName=c}),define(De[120],Ie([1,0,2]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(R){return R.toJSON()}class S{constructor(b){this._uriTransformer=b}transformIncoming(b){const p=this._uriTransformer.transformIncoming(b);return p===b?b:I(i.URI.from(p))}transformOutgoing(b){const p=this._uriTransformer.transformOutgoing(b);return p===b?b:I(i.URI.from(p))}transformOutgoingURI(b){const p=this._uriTransformer.transformOutgoing(b);return p===b?b:i.URI.from(p)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function M(R,b,p){if(!R||p>200)return null;if(typeof R=="object"){if(R instanceof i.URI)return b.transformOutgoing(R);for(const E in R)if(Object.hasOwnProperty.call(R,E)){const m=M(R[E],b,p+1);m!==null&&(R[E]=m)}}return null}function D(R,b){const p=M(R,b,0);return p===null?R:p}e.transformOutgoingURIs=D;function A(R,b,p,E){if(!R||E>200)return null;if(typeof R=="object"){if(R.$mid===1)return p?i.URI.revive(b.transformIncoming(R)):b.transformIncoming(R);for(const m in R)if(Object.hasOwnProperty.call(R,m)){const t=A(R[m],b,p,E+1);t!==null&&(R[m]=t)}}return null}function y(R,b){const p=A(R,b,!1,0);return p===null?R:p}e.transformIncomingURIs=y;function k(R,b){const p=A(R,b,!0,0);return p===null?R:p}e.transformAndReviveIncomingURIs=k}),define(De[121],Ie([1,0,34,19]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(M,D,A,y,k,R){if(Array.isArray(M)){let b=0;for(const p of M){const E=S(p,D,A,y,k,R);if(E===10)return E;E>b&&(b=E)}return b}else{if(typeof M=="string")return y?M==="*"?5:M===A?10:0:0;if(M){const{language:b,pattern:p,scheme:E,hasAccessToAllModels:m,notebookType:t}=M;if(!y&&!m)return 0;t&&k&&(D=k);let o=0;if(E)if(E===D.scheme)o=10;else if(E==="*")o=5;else return 0;if(b)if(b===A)o=10;else if(b==="*")o=Math.max(o,5);else return 0;if(t)if(t===R)o=10;else if(t==="*"&&R!==void 0)o=Math.max(o,5);else return 0;if(p){let a;if(typeof p=="string"?a=p:a={...p,base:(0,I.normalize)(p.base)},a===D.fsPath||(0,i.match)(a,D.fsPath))o=10;else return 0}return o}else return 0}}e.score=S}),define(De[83],Ie([1,0,24,21]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(S||(S={}));function M(b){for(let p=0,E=b.length;p<E;p+=4){const m=b[p+0],t=b[p+1],o=b[p+2],a=b[p+3];b[p+0]=a,b[p+1]=o,b[p+2]=t,b[p+3]=m}}function D(b){const p=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return I.isLittleEndian()||M(p),i.VSBuffer.wrap(p)}function A(b){const p=b.buffer;if(I.isLittleEndian()||M(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const E=new Uint8Array(p.byteLength);return E.set(p),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function y(b){const p=new Uint32Array(k(b));let E=0;if(p[E++]=b.id,b.type==="full")p[E++]=1,p[E++]=b.data.length,p.set(b.data,E),E+=b.data.length;else{p[E++]=2,p[E++]=b.deltas.length;for(const m of b.deltas)p[E++]=m.start,p[E++]=m.deleteCount,m.data?(p[E++]=m.data.length,p.set(m.data,E),E+=m.data.length):p[E++]=0}return D(p)}e.encodeSemanticTokensDto=y;function k(b){let p=0;if(p+=1+1,b.type==="full")p+=1+b.data.length;else{p+=1,p+=(1+1+1)*b.deltas.length;for(const E of b.deltas)E.data&&(p+=E.data.length)}return p}function R(b){const p=A(b);let E=0;const m=p[E++];if(p[E++]===1){const g=p[E++],w=p.subarray(E,E+g);return E+=g,{id:m,type:"full",data:w}}const o=p[E++],a=[];for(let g=0;g<o;g++){const w=p[E++],d=p[E++],T=p[E++];let r;T>0&&(r=p.subarray(E,E+T),E+=T),a[g]={start:w,deleteCount:d,data:r}}return{id:m,type:"delta",deltas:a}}e.decodeSemanticTokensDto=R}),define(De[122],Ie([16,17]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(De[123],Ie([1,0,122,21,124,18,23,110]),function(ie,e,i,I,S,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=k;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class b{constructor(Q,ge,Ne,je){this.id=Q,this.name=ge,this.defaultValue=Ne,this.schema=je}applyUpdate(Q,ge){return E(Q,ge)}compute(Q,ge,Ne){return Ne}}class p{constructor(Q,ge){this.newValue=Q,this.didChange=ge}}e.ApplyUpdateResult=p;function E(X,Q){if(typeof X!="object"||typeof Q!="object"||!X||!Q)return new p(Q,X!==Q);if(Array.isArray(X)||Array.isArray(Q)){const Ne=Array.isArray(X)&&Array.isArray(Q)&&M.equals(X,Q);return new p(Q,!Ne)}let ge=!1;for(const Ne in Q)if(Q.hasOwnProperty(Ne)){const je=E(X[Ne],Q[Ne]);je.didChange&&(X[Ne]=je.newValue,ge=!0)}return new p(X,ge)}class m{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ge){return E(Q,ge)}validate(Q){return this.defaultValue}}class t{constructor(Q,ge,Ne,je){this.id=Q,this.name=ge,this.defaultValue=Ne,this.schema=je}applyUpdate(Q,ge){return E(Q,ge)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,ge,Ne){return Ne}}function o(X,Q){return typeof X>"u"?Q:X==="false"?!1:Boolean(X)}e.boolean=o;class a extends t{constructor(Q,ge,Ne,je=void 0){typeof je<"u"&&(je.type="boolean",je.default=Ne),super(Q,ge,Ne,je)}validate(Q){return o(Q,this.defaultValue)}}function g(X,Q,ge,Ne){if(typeof X>"u")return Q;let je=parseInt(X,10);return isNaN(je)?Q:(je=Math.max(ge,je),je=Math.min(Ne,je),je|0)}e.clampedInt=g;class w extends t{static clampedInt(Q,ge,Ne,je){return g(Q,ge,Ne,je)}constructor(Q,ge,Ne,je,qe,We=void 0){typeof We<"u"&&(We.type="integer",We.default=Ne,We.minimum=je,We.maximum=qe),super(Q,ge,Ne,We),this.minimum=je,this.maximum=qe}validate(Q){return w.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class d extends t{static clamp(Q,ge,Ne){return Q<ge?ge:Q>Ne?Ne:Q}static float(Q,ge){if(typeof Q=="number")return Q;if(typeof Q>"u")return ge;const Ne=parseFloat(Q);return isNaN(Ne)?ge:Ne}constructor(Q,ge,Ne,je,qe){typeof qe<"u"&&(qe.type="number",qe.default=Ne),super(Q,ge,Ne,qe),this.validationFn=je}validate(Q){return this.validationFn(d.float(Q,this.defaultValue))}}class T extends t{static string(Q,ge){return typeof Q!="string"?ge:Q}constructor(Q,ge,Ne,je=void 0){typeof je<"u"&&(je.type="string",je.default=Ne),super(Q,ge,Ne,je)}validate(Q){return T.string(Q,this.defaultValue)}}function r(X,Q,ge){return typeof X!="string"||ge.indexOf(X)===-1?Q:X}e.stringSet=r;class c extends t{constructor(Q,ge,Ne,je,qe=void 0){typeof qe<"u"&&(qe.type="string",qe.enum=je,qe.default=Ne),super(Q,ge,Ne,qe),this._allowedValues=je}validate(Q){return r(Q,this.defaultValue,this._allowedValues)}}class n extends b{constructor(Q,ge,Ne,je,qe,We,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=qe,Ze.default=je),super(Q,ge,Ne,Ze),this._allowedValues=qe,this._convert=We}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function u(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends b{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ge,Ne){return Ne===0?Q.accessibilitySupport:Ne}}class f extends b{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:i.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertSpace:o(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function h(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function P(X){switch(X){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=P;function L(X){switch(X){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class j extends m{constructor(){super(130)}compute(Q,ge,Ne){const je=["monaco-editor"];return ge.get(34)&&je.push(ge.get(34)),Q.extraEditorClassName&&je.push(Q.extraEditorClassName),ge.get(67)==="default"?je.push("mouse-default"):ge.get(67)==="copy"&&je.push("mouse-copy"),ge.get(101)&&je.push("showUnused"),ge.get(128)&&je.push("showDeprecated"),je.join(" ")}}class W extends a{constructor(){super(33,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(Q,ge,Ne){return Ne&&Q.emptySelectionClipboard}}class V extends b{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:i.localize(16,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:i.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{cursorMoveOnType:o(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":r(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":r(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(ge.loop,this.defaultValue.loop)}}}class C extends b{constructor(){super(46,"fontLigatures",C.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?C.OFF:Q==="true"?C.ON:Q:Boolean(Q)?C.ON:C.OFF}}e.EditorFontLigatures=C,C.OFF='"liga" off, "calt" off',C.ON='"liga" on, "calt" on';class F extends m{constructor(){super(45)}compute(Q,ge,Ne){return Q.fontInfo}}class O extends t{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(22,null)})}validate(Q){const ge=d.float(Q,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(ge,6,100)}compute(Q,ge,Ne){return Q.fontInfo.fontSize}}class x extends b{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:i.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(w.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class B extends b{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[i.localize(25,null),i.localize(26,null),i.localize(27,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(29,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(30,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:i.localize(31,null),...ge},"editor.gotoLocation.multipleImplementations":{description:i.localize(32,null),...ge},"editor.gotoLocation.multipleReferences":{description:i.localize(33,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ne,description:i.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ne,description:i.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ne,description:i.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ne,description:i.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ne,description:i.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{multiple:r(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??r(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??r(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??r(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??r(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??r(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:T.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:T.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:T.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:T.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:T.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class H extends b{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:i.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:i.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:i.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:i.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),delay:w.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:o(ge.sticky,this.defaultValue.sticky),above:o(ge.above,this.defaultValue.above)}}}var G;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(G=e.RenderMinimap||(e.RenderMinimap={}));class ee extends m{constructor(){super(133)}compute(Q,ge,Ne){return ee.computeLayout(ge,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const ge=Q.height/Q.lineHeight,Ne=Q.scrollBeyondLastLine?ge-1:0,je=(Q.viewLineCount+Ne)/(Q.pixelRatio*Q.height),qe=Math.floor(Q.viewLineCount/je);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:Ne,desiredRatio:je,minimapLineCount:qe}}static _computeMinimapLayout(Q,ge){const Ne=Q.outerWidth,je=Q.outerHeight,qe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(qe*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const We=ge.stableMinimapLayoutInput,Ze=We&&Q.outerHeight===We.outerHeight&&Q.lineHeight===We.lineHeight&&Q.typicalHalfwidthCharacterWidth===We.typicalHalfwidthCharacterWidth&&Q.pixelRatio===We.pixelRatio&&Q.scrollBeyondLastLine===We.scrollBeyondLastLine&&Q.minimap.enabled===We.minimap.enabled&&Q.minimap.side===We.minimap.side&&Q.minimap.size===We.minimap.size&&Q.minimap.showSlider===We.minimap.showSlider&&Q.minimap.renderCharacters===We.minimap.renderCharacters&&Q.minimap.maxColumn===We.minimap.maxColumn&&Q.minimap.scale===We.minimap.scale&&Q.verticalScrollbarWidth===We.verticalScrollbarWidth&&Q.isViewportWrapping===We.isViewportWrapping,nt=Q.lineHeight,ct=Q.typicalHalfwidthCharacterWidth,It=Q.scrollBeyondLastLine,at=Q.minimap.renderCharacters;let rt=qe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Lt=Q.minimap.maxColumn,At=Q.minimap.size,kt=Q.minimap.side,ft=Q.verticalScrollbarWidth,yt=Q.viewLineCount,Ut=Q.remainingWidth,Rt=Q.isViewportWrapping,Ge=at?2:3;let Ct=Math.floor(qe*je);const Ot=Ct/qe;let Bt=!1,pt=!1,_e=Ge*rt,Te=rt/qe,fe=1;if(At==="fill"||At==="fit"){const{typicalViewportLineCount:ot,extraLinesBeyondLastLine:Tt,desiredRatio:Et,minimapLineCount:_t}=ee.computeContainedMinimapLineCount({viewLineCount:yt,scrollBeyondLastLine:It,height:je,lineHeight:nt,pixelRatio:qe});if(yt/_t>1)Bt=!0,pt=!0,rt=1,_e=1,Te=rt/qe;else{let Ft=!1,mt=rt+1;if(At==="fit"){const Mt=Math.ceil((yt+Tt)*_e);Rt&&Ze&&Ut<=ge.stableFitRemainingWidth?(Ft=!0,mt=ge.stableFitMaxMinimapScale):Ft=Mt>Ct}if(At==="fill"||Ft){Bt=!0;const Mt=rt;_e=Math.min(nt*qe,Math.max(1,Math.floor(1/Et))),Rt&&Ze&&Ut<=ge.stableFitRemainingWidth&&(mt=ge.stableFitMaxMinimapScale),rt=Math.min(mt,Math.max(1,Math.floor(_e/Ge))),rt>Mt&&(fe=Math.min(2,rt/Mt)),Te=rt/qe/fe,Ct=Math.ceil(Math.max(ot,yt+Tt)*_e),Rt?(ge.stableMinimapLayoutInput=Q,ge.stableFitRemainingWidth=Ut,ge.stableFitMaxMinimapScale=rt):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const K=Math.floor(Lt*Te),Pe=Math.min(K,Math.max(0,Math.floor((Ut-ft-2)*Te/(ct+Te)))+e.MINIMAP_GUTTER_WIDTH);let Me=Math.floor(qe*Pe);const Je=Me/qe;Me=Math.floor(Me*fe);const xe=at?1:2,it=kt==="left"?0:Ne-Pe-ft;return{renderMinimap:xe,minimapLeft:it,minimapWidth:Pe,minimapHeightIsEditorHeight:Bt,minimapIsSampling:pt,minimapScale:rt,minimapLineHeight:_e,minimapCanvasInnerWidth:Me,minimapCanvasInnerHeight:Ct,minimapCanvasOuterWidth:Je,minimapCanvasOuterHeight:Ot}}static computeLayout(Q,ge){const Ne=ge.outerWidth|0,je=ge.outerHeight|0,qe=ge.lineHeight|0,We=ge.lineNumbersDigitCount|0,Ze=ge.typicalHalfwidthCharacterWidth,nt=ge.maxDigitWidth,ct=ge.pixelRatio,It=ge.viewLineCount,at=Q.get(125),rt=at==="inherit"?Q.get(124):at,Lt=rt==="inherit"?Q.get(120):rt,At=Q.get(123),kt=ge.isDominatedByLongLines,ft=Q.get(51),yt=Q.get(61).renderType!==0,Ut=Q.get(62),Rt=Q.get(95),Ge=Q.get(66),Ct=Q.get(93),Ot=Ct.verticalScrollbarSize,Bt=Ct.verticalHasArrows,pt=Ct.arrowSize,_e=Ct.horizontalScrollbarSize,Te=Q.get(59),fe=Q.get(38),K=Q.get(100)!=="never";let Pe;if(typeof Te=="string"&&/^\d+(\.\d+)?ch$/.test(Te)){const Ht=parseFloat(Te.substr(0,Te.length-2));Pe=w.clampedInt(Ht*Ze,0,0,1e3)}else Pe=w.clampedInt(Te,0,0,1e3);fe&&K&&(Pe+=16);let Me=0;if(yt){const Ht=Math.max(We,Ut);Me=Math.round(Ht*nt)}let Je=0;ft&&(Je=qe);let xe=0,it=xe+Je,ot=it+Me,Tt=ot+Pe;const Et=Ne-Je-Me-Pe;let _t=!1,vt=!1,Ft=-1;rt==="inherit"&&kt?(_t=!0,vt=!0):Lt==="on"||Lt==="bounded"?vt=!0:Lt==="wordWrapColumn"&&(Ft=At);const mt=ee._computeMinimapLayout({outerWidth:Ne,outerHeight:je,lineHeight:qe,typicalHalfwidthCharacterWidth:Ze,pixelRatio:ct,scrollBeyondLastLine:Rt,minimap:Ge,verticalScrollbarWidth:Ot,viewLineCount:It,remainingWidth:Et,isViewportWrapping:vt},ge.memory||new R);mt.renderMinimap!==0&&mt.minimapLeft===0&&(xe+=mt.minimapWidth,it+=mt.minimapWidth,ot+=mt.minimapWidth,Tt+=mt.minimapWidth);const Mt=Et-mt.minimapWidth,Kt=Math.max(1,Math.floor((Mt-Ot-2)/Ze)),bt=Bt?pt:0;return vt&&(Ft=Math.max(1,Kt),Lt==="bounded"&&(Ft=Math.min(Ft,At))),{width:Ne,height:je,glyphMarginLeft:xe,glyphMarginWidth:Je,lineNumbersLeft:it,lineNumbersWidth:Me,decorationsLeft:ot,decorationsWidth:Pe,contentLeft:Tt,contentWidth:Mt,minimap:mt,viewportColumn:Kt,isWordWrapMinified:_t,isViewportWrapping:vt,wrappingColumn:Ft,verticalScrollbarWidth:Ot,horizontalScrollbarHeight:_e,overviewRuler:{top:bt,width:Ot,height:je-2*bt,right:0}}}}e.EditorLayoutInfoComputer=ee;class ue extends b{constructor(){super(127,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(43,null),i.localize(44,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(45,null)}})}validate(Q){return r(Q,"simple",["simple","advanced"])}compute(Q,ge,Ne){return ge.get(2)===2?"advanced":Ne}}class re extends b{constructor(){const Q={enabled:!0};super(58,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:i.localize(46,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}class pe extends b{constructor(){const Q={enabled:!1,maxLineCount:5};super(105,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:i.localize(47,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:i.localize(48,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),maxLineCount:w.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class le extends b{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:i.localize(49,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(50,null),i.localize(51,null,I.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(52,null,I.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(53,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:i.localize(54,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:i.localize(55,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:i.localize(56,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:r(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:w.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:T.string(ge.fontFamily,this.defaultValue.fontFamily),padding:o(ge.padding,this.defaultValue.padding)}}}class de extends d{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>d.clamp(Q,0,150),{markdownDescription:i.localize(57,null)})}compute(Q,ge,Ne){return Q.fontInfo.lineHeight}}class Y extends b{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:i.localize(58,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:i.localize(59,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(60,null),i.localize(61,null),i.localize(62,null)],default:Q.size,description:i.localize(63,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:i.localize(64,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:i.localize(65,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(66,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:i.localize(67,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:i.localize(68,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),autohide:o(ge.autohide,this.defaultValue.autohide),size:r(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(ge.side,this.defaultValue.side,["right","left"]),showSlider:r(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(ge.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(ge.scale,1,1,3),maxColumn:w.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function me(X){return X==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Se extends b{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(69,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(70,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{top:w.clampedInt(ge.top,0,0,1e3),bottom:w.clampedInt(ge.bottom,0,0,1e3)}}}class Oe extends b{constructor(){const Q={enabled:!0,cycle:!1};super(77,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:i.localize(71,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:i.localize(72,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),cycle:o(ge.cycle,this.defaultValue.cycle)}}}class Be extends m{constructor(){super(131)}compute(Q,ge,Ne){return Q.pixelRatio}}class Xe extends b{constructor(){const Q={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(73,null),i.localize(74,null),i.localize(75,null)]}];super(80,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:Q.strings,description:i.localize(76,null)},comments:{anyOf:ge,default:Q.comments,description:i.localize(77,null)},other:{anyOf:ge,default:Q.other,description:i.localize(78,null)}},default:Q,markdownDescription:i.localize(79,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const ct=Q?"on":"off";return{comments:ct,strings:ct,other:ct}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:ge,comments:Ne,strings:je}=Q,qe=["on","inline","off"];let We,Ze,nt;return typeof ge=="boolean"?We=ge?"on":"off":We=r(ge,this.defaultValue.other,qe),typeof Ne=="boolean"?Ze=Ne?"on":"off":Ze=r(Ne,this.defaultValue.comments,qe),typeof je=="boolean"?nt=je?"on":"off":nt=r(je,this.defaultValue.strings,qe),{other:We,comments:Ze,strings:nt}}}var ke;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ye extends b{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(80,null),i.localize(81,null),i.localize(82,null),i.localize(83,null)],default:"on",description:i.localize(84,null)})}validate(Q){let ge=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(ge=4,Ne=Q):Q==="interval"?ge=3:Q==="relative"?ge=2:Q==="on"?ge=1:ge=0),{renderType:ge,renderFn:Ne}}}function Ce(X){const Q=X.get(88);return Q==="editable"?X.get(82):Q!=="on"}e.filterValidationDecorations=Ce;class se extends b{constructor(){const Q=[],ge={type:"number",description:i.localize(85,null)};super(92,"rulers",Q,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:i.localize(86,null),format:"color-hex"}}}]},default:Q,description:i.localize(87,null)})}validate(Q){if(Array.isArray(Q)){const ge=[];for(const Ne of Q)if(typeof Ne=="number")ge.push({column:w.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const je=Ne;ge.push({column:w.clampedInt(je.column,0,0,1e4),color:je.color})}return ge.sort((Ne,je)=>Ne.column-je.column),ge}return this.defaultValue}}function ae(X,Q){if(typeof X!="string")return Q;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class J extends b{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(88,null),i.localize(89,null),i.localize(90,null)],default:"auto",description:i.localize(91,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(92,null),i.localize(93,null),i.localize(94,null)],default:"auto",description:i.localize(95,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:i.localize(96,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:i.localize(97,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:i.localize(98,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q,Ne=w.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=w.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(ge.vertical,this.defaultValue.vertical),horizontal:ae(ge.horizontal,this.defaultValue.horizontal),useShadows:o(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:w.clampedInt(ge.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:je,verticalSliderSize:w.clampedInt(ge.verticalSliderSize,je,0,1e3),scrollByPage:o(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class _ extends b{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:i.localize(99,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:i.localize(100,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:i.localize(101,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:i.localize(102,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:i.localize(104,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:i.localize(105,null)}})}applyUpdate(Q,ge){let Ne=!1;ge.allowedCharacters&&Q&&(D.equals(Q.allowedCharacters,ge.allowedCharacters)||(Q={...Q,allowedCharacters:ge.allowedCharacters},Ne=!0)),ge.allowedLocales&&Q&&(D.equals(Q.allowedLocales,ge.allowedLocales)||(Q={...Q,allowedLocales:ge.allowedLocales},Ne=!0));const je=super.applyUpdate(Q,ge);return Ne?new p(je.newValue,!0):je}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{nonBasicASCII:Z(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Z(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Z(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,ge){if(typeof Q!="object"||!Q)return ge;const Ne={};for(const[je,qe]of Object.entries(Q))qe===!0&&(Ne[je]=!0);return Ne}}class N extends b{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:i.localize(106,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),mode:r(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class $ extends b{constructor(){const Q={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:i.localize(107,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:i.localize(108,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends b{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(109,null),i.localize(110,null),i.localize(111,null)],default:Q.bracketPairs,description:i.localize(112,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(113,null),i.localize(114,null),i.localize(115,null)],default:Q.bracketPairsHorizontal,description:i.localize(116,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:i.localize(117,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:i.localize(118,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(119,null),i.localize(120,null),i.localize(121,null)],default:Q.highlightActiveIndentation,description:i.localize(122,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{bracketPairs:Z(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Z(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:Z(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Z(X,Q,ge){const Ne=ge.indexOf(X);return Ne===-1?Q:ge[Ne]}class ce extends b{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(123,null),i.localize(124,null)],default:Q.insertMode,description:i.localize(125,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:i.localize(126,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:i.localize(127,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:i.localize(128,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:i.localize(129,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:i.localize(130,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:i.localize(131,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:i.localize(132,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:i.localize(133,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(134,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(135,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(136,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(137,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(138,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(139,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(140,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(141,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(142,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(143,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(144,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(145,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(146,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(147,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(148,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertMode:r(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:o(ge.showIcons,this.defaultValue.showIcons),showStatusBar:o(ge.showStatusBar,this.defaultValue.showStatusBar),preview:o(ge.preview,this.defaultValue.preview),previewMode:r(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(ge.showMethods,this.defaultValue.showMethods),showFunctions:o(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:o(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(ge.showFields,this.defaultValue.showFields),showVariables:o(ge.showVariables,this.defaultValue.showVariables),showClasses:o(ge.showClasses,this.defaultValue.showClasses),showStructs:o(ge.showStructs,this.defaultValue.showStructs),showInterfaces:o(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:o(ge.showModules,this.defaultValue.showModules),showProperties:o(ge.showProperties,this.defaultValue.showProperties),showEvents:o(ge.showEvents,this.defaultValue.showEvents),showOperators:o(ge.showOperators,this.defaultValue.showOperators),showUnits:o(ge.showUnits,this.defaultValue.showUnits),showValues:o(ge.showValues,this.defaultValue.showValues),showConstants:o(ge.showConstants,this.defaultValue.showConstants),showEnums:o(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:o(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(ge.showKeywords,this.defaultValue.showKeywords),showWords:o(ge.showWords,this.defaultValue.showWords),showColors:o(ge.showColors,this.defaultValue.showColors),showFiles:o(ge.showFiles,this.defaultValue.showFiles),showReferences:o(ge.showReferences,this.defaultValue.showReferences),showFolders:o(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:o(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(ge.showSnippets,this.defaultValue.showSnippets),showUsers:o(ge.showUsers,this.defaultValue.showUsers),showIssues:o(ge.showIssues,this.defaultValue.showIssues)}}}class be extends b{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(166,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class oe extends m{constructor(){super(132)}compute(Q,ge,Ne){return ge.get(82)?!0:Q.tabFocusMode}}var we;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(we=e.WrappingIndent||(e.WrappingIndent={}));class ve extends b{constructor(){super(126,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(167,null),i.localize(168,null),i.localize(169,null),i.localize(170,null)],description:i.localize(171,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,ge,Ne){return ge.get(2)===2?0:Ne}}class Ue extends m{constructor(){super(134)}compute(Q,ge,Ne){const je=ge.get(133);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}class ze extends b{constructor(){const Q={enabled:!0};super(32,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:i.localize(172,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",Ke="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Ke:I.isLinux?tt:et,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(X){return e.editorOptionsRegistry[X.id]=X,X}var ht;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.guides=13]="guides",X[X.codeLens=14]="codeLens",X[X.codeLensFontFamily=15]="codeLensFontFamily",X[X.codeLensFontSize=16]="codeLensFontSize",X[X.colorDecorators=17]="colorDecorators",X[X.columnSelection=18]="columnSelection",X[X.comments=19]="comments",X[X.contextmenu=20]="contextmenu",X[X.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",X[X.cursorBlinking=22]="cursorBlinking",X[X.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",X[X.cursorStyle=24]="cursorStyle",X[X.cursorSurroundingLines=25]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",X[X.cursorWidth=27]="cursorWidth",X[X.disableLayerHinting=28]="disableLayerHinting",X[X.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",X[X.domReadOnly=30]="domReadOnly",X[X.dragAndDrop=31]="dragAndDrop",X[X.dropIntoEditor=32]="dropIntoEditor",X[X.emptySelectionClipboard=33]="emptySelectionClipboard",X[X.extraEditorClassName=34]="extraEditorClassName",X[X.fastScrollSensitivity=35]="fastScrollSensitivity",X[X.find=36]="find",X[X.fixedOverflowWidgets=37]="fixedOverflowWidgets",X[X.folding=38]="folding",X[X.foldingStrategy=39]="foldingStrategy",X[X.foldingHighlight=40]="foldingHighlight",X[X.foldingImportsByDefault=41]="foldingImportsByDefault",X[X.foldingMaximumRegions=42]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=44]="fontFamily",X[X.fontInfo=45]="fontInfo",X[X.fontLigatures=46]="fontLigatures",X[X.fontSize=47]="fontSize",X[X.fontWeight=48]="fontWeight",X[X.formatOnPaste=49]="formatOnPaste",X[X.formatOnType=50]="formatOnType",X[X.glyphMargin=51]="glyphMargin",X[X.gotoLocation=52]="gotoLocation",X[X.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",X[X.hover=54]="hover",X[X.inDiffEditor=55]="inDiffEditor",X[X.inlineSuggest=56]="inlineSuggest",X[X.letterSpacing=57]="letterSpacing",X[X.lightbulb=58]="lightbulb",X[X.lineDecorationsWidth=59]="lineDecorationsWidth",X[X.lineHeight=60]="lineHeight",X[X.lineNumbers=61]="lineNumbers",X[X.lineNumbersMinChars=62]="lineNumbersMinChars",X[X.linkedEditing=63]="linkedEditing",X[X.links=64]="links",X[X.matchBrackets=65]="matchBrackets",X[X.minimap=66]="minimap",X[X.mouseStyle=67]="mouseStyle",X[X.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=69]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",X[X.multiCursorModifier=71]="multiCursorModifier",X[X.multiCursorPaste=72]="multiCursorPaste",X[X.occurrencesHighlight=73]="occurrencesHighlight",X[X.overviewRulerBorder=74]="overviewRulerBorder",X[X.overviewRulerLanes=75]="overviewRulerLanes",X[X.padding=76]="padding",X[X.parameterHints=77]="parameterHints",X[X.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",X[X.quickSuggestions=80]="quickSuggestions",X[X.quickSuggestionsDelay=81]="quickSuggestionsDelay",X[X.readOnly=82]="readOnly",X[X.renameOnType=83]="renameOnType",X[X.renderControlCharacters=84]="renderControlCharacters",X[X.renderFinalNewline=85]="renderFinalNewline",X[X.renderLineHighlight=86]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=88]="renderValidationDecorations",X[X.renderWhitespace=89]="renderWhitespace",X[X.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",X[X.roundedSelection=91]="roundedSelection",X[X.rulers=92]="rulers",X[X.scrollbar=93]="scrollbar",X[X.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=95]="scrollBeyondLastLine",X[X.scrollPredominantAxis=96]="scrollPredominantAxis",X[X.selectionClipboard=97]="selectionClipboard",X[X.selectionHighlight=98]="selectionHighlight",X[X.selectOnLineNumbers=99]="selectOnLineNumbers",X[X.showFoldingControls=100]="showFoldingControls",X[X.showUnused=101]="showUnused",X[X.snippetSuggestions=102]="snippetSuggestions",X[X.smartSelect=103]="smartSelect",X[X.smoothScrolling=104]="smoothScrolling",X[X.stickyScroll=105]="stickyScroll",X[X.stickyTabStops=106]="stickyTabStops",X[X.stopRenderingLineAfter=107]="stopRenderingLineAfter",X[X.suggest=108]="suggest",X[X.suggestFontSize=109]="suggestFontSize",X[X.suggestLineHeight=110]="suggestLineHeight",X[X.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",X[X.suggestSelection=112]="suggestSelection",X[X.tabCompletion=113]="tabCompletion",X[X.tabIndex=114]="tabIndex",X[X.unicodeHighlighting=115]="unicodeHighlighting",X[X.unusualLineTerminators=116]="unusualLineTerminators",X[X.useShadowDOM=117]="useShadowDOM",X[X.useTabStops=118]="useTabStops",X[X.wordSeparators=119]="wordSeparators",X[X.wordWrap=120]="wordWrap",X[X.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=123]="wordWrapColumn",X[X.wordWrapOverride1=124]="wordWrapOverride1",X[X.wordWrapOverride2=125]="wordWrapOverride2",X[X.wrappingIndent=126]="wrappingIndent",X[X.wrappingStrategy=127]="wrappingStrategy",X[X.showDeprecated=128]="showDeprecated",X[X.inlayHints=129]="inlayHints",X[X.editorClassName=130]="editorClassName",X[X.pixelRatio=131]="pixelRatio",X[X.tabFocusMode=132]="tabFocusMode",X[X.layoutInfo=133]="layoutInfo",X[X.wrappingInfo=134]="wrappingInfo"})(ht=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(173,null)})),acceptSuggestionOnEnter:Fe(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(174,null),""],markdownDescription:i.localize(175,null)})),accessibilitySupport:Fe(new l),accessibilityPageSize:Fe(new w(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(176,null),tags:["accessibility"]})),ariaLabel:Fe(new T(4,"ariaLabel",i.localize(177,null))),autoClosingBrackets:Fe(new c(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(178,null),i.localize(179,null),""],description:i.localize(180,null)})),autoClosingDelete:Fe(new c(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(181,null),""],description:i.localize(182,null)})),autoClosingOvertype:Fe(new c(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(183,null),""],description:i.localize(184,null)})),autoClosingQuotes:Fe(new c(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(185,null),i.localize(186,null),""],description:i.localize(187,null)})),autoIndent:Fe(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[i.localize(188,null),i.localize(189,null),i.localize(190,null),i.localize(191,null),i.localize(192,null)],description:i.localize(193,null)})),automaticLayout:Fe(new a(10,"automaticLayout",!1)),autoSurround:Fe(new c(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(194,null),i.localize(195,null),i.localize(196,null),""],description:i.localize(197,null)})),bracketPairColorization:Fe(new $),bracketPairGuides:Fe(new q),stickyTabStops:Fe(new a(106,"stickyTabStops",!1,{description:i.localize(198,null)})),codeLens:Fe(new a(14,"codeLens",!0,{description:i.localize(199,null)})),codeLensFontFamily:Fe(new T(15,"codeLensFontFamily","",{description:i.localize(200,null)})),codeLensFontSize:Fe(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(201,null)})),colorDecorators:Fe(new a(17,"colorDecorators",!0,{description:i.localize(202,null)})),columnSelection:Fe(new a(18,"columnSelection",!1,{description:i.localize(203,null)})),comments:Fe(new f),contextmenu:Fe(new a(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new a(21,"copyWithSyntaxHighlighting",!0,{description:i.localize(204,null)})),cursorBlinking:Fe(new n(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:i.localize(205,null)})),cursorSmoothCaretAnimation:Fe(new a(23,"cursorSmoothCaretAnimation",!1,{description:i.localize(206,null)})),cursorStyle:Fe(new n(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:i.localize(207,null)})),cursorSurroundingLines:Fe(new w(25,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(208,null)})),cursorSurroundingLinesStyle:Fe(new c(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(209,null),i.localize(210,null)],description:i.localize(211,null)})),cursorWidth:Fe(new w(27,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(212,null)})),disableLayerHinting:Fe(new a(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new a(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new a(30,"domReadOnly",!1)),dragAndDrop:Fe(new a(31,"dragAndDrop",!0,{description:i.localize(213,null)})),emptySelectionClipboard:Fe(new W),dropIntoEditor:Fe(new ze),stickyScroll:Fe(new pe),extraEditorClassName:Fe(new T(34,"extraEditorClassName","")),fastScrollSensitivity:Fe(new d(35,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:i.localize(214,null)})),find:Fe(new V),fixedOverflowWidgets:Fe(new a(37,"fixedOverflowWidgets",!1)),folding:Fe(new a(38,"folding",!0,{description:i.localize(215,null)})),foldingStrategy:Fe(new c(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(216,null),i.localize(217,null)],description:i.localize(218,null)})),foldingHighlight:Fe(new a(40,"foldingHighlight",!0,{description:i.localize(219,null)})),foldingImportsByDefault:Fe(new a(41,"foldingImportsByDefault",!1,{description:i.localize(220,null)})),foldingMaximumRegions:Fe(new w(42,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(221,null)})),unfoldOnClickAfterEndOfLine:Fe(new a(43,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(222,null)})),fontFamily:Fe(new T(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(223,null)})),fontInfo:Fe(new F),fontLigatures2:Fe(new C),fontSize:Fe(new O),fontWeight:Fe(new x),formatOnPaste:Fe(new a(49,"formatOnPaste",!1,{description:i.localize(224,null)})),formatOnType:Fe(new a(50,"formatOnType",!1,{description:i.localize(225,null)})),glyphMargin:Fe(new a(51,"glyphMargin",!0,{description:i.localize(226,null)})),gotoLocation:Fe(new B),hideCursorInOverviewRuler:Fe(new a(53,"hideCursorInOverviewRuler",!1,{description:i.localize(227,null)})),hover:Fe(new H),inDiffEditor:Fe(new a(55,"inDiffEditor",!1)),letterSpacing:Fe(new d(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>d.clamp(X,-5,20),{description:i.localize(228,null)})),lightbulb:Fe(new re),lineDecorationsWidth:Fe(new t(59,"lineDecorationsWidth",10)),lineHeight:Fe(new de),lineNumbers:Fe(new ye),lineNumbersMinChars:Fe(new w(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new a(63,"linkedEditing",!1,{description:i.localize(229,null)})),links:Fe(new a(64,"links",!0,{description:i.localize(230,null)})),matchBrackets:Fe(new c(65,"matchBrackets","always",["always","near","never"],{description:i.localize(231,null)})),minimap:Fe(new Y),mouseStyle:Fe(new c(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new d(68,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:i.localize(232,null)})),mouseWheelZoom:Fe(new a(69,"mouseWheelZoom",!1,{markdownDescription:i.localize(233,null)})),multiCursorMergeOverlapping:Fe(new a(70,"multiCursorMergeOverlapping",!0,{description:i.localize(234,null)})),multiCursorModifier:Fe(new n(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],me,{markdownEnumDescriptions:[i.localize(235,null),i.localize(236,null)],markdownDescription:i.localize(237,null)})),multiCursorPaste:Fe(new c(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(238,null),i.localize(239,null)],markdownDescription:i.localize(240,null)})),occurrencesHighlight:Fe(new a(73,"occurrencesHighlight",!0,{description:i.localize(241,null)})),overviewRulerBorder:Fe(new a(74,"overviewRulerBorder",!0,{description:i.localize(242,null)})),overviewRulerLanes:Fe(new w(75,"overviewRulerLanes",3,0,3)),padding:Fe(new Se),parameterHints:Fe(new Oe),peekWidgetDefaultFocus:Fe(new c(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(243,null),i.localize(244,null)],description:i.localize(245,null)})),definitionLinkOpensInPeek:Fe(new a(79,"definitionLinkOpensInPeek",!1,{description:i.localize(246,null)})),quickSuggestions:Fe(new Xe),quickSuggestionsDelay:Fe(new w(81,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(247,null)})),readOnly:Fe(new a(82,"readOnly",!1)),renameOnType:Fe(new a(83,"renameOnType",!1,{description:i.localize(248,null),markdownDeprecationMessage:i.localize(249,null)})),renderControlCharacters:Fe(new a(84,"renderControlCharacters",!0,{description:i.localize(250,null),restricted:!0})),renderFinalNewline:Fe(new a(85,"renderFinalNewline",!0,{description:i.localize(251,null)})),renderLineHighlight:Fe(new c(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(252,null)],description:i.localize(253,null)})),renderLineHighlightOnlyWhenFocus:Fe(new a(87,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(254,null)})),renderValidationDecorations:Fe(new c(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new c(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(255,null),i.localize(256,null),i.localize(257,null),""],description:i.localize(258,null)})),revealHorizontalRightPadding:Fe(new w(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new a(91,"roundedSelection",!0,{description:i.localize(259,null)})),rulers:Fe(new se),scrollbar:Fe(new J),scrollBeyondLastColumn:Fe(new w(94,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(260,null)})),scrollBeyondLastLine:Fe(new a(95,"scrollBeyondLastLine",!0,{description:i.localize(261,null)})),scrollPredominantAxis:Fe(new a(96,"scrollPredominantAxis",!0,{description:i.localize(262,null)})),selectionClipboard:Fe(new a(97,"selectionClipboard",!0,{description:i.localize(263,null),included:I.isLinux})),selectionHighlight:Fe(new a(98,"selectionHighlight",!0,{description:i.localize(264,null)})),selectOnLineNumbers:Fe(new a(99,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new c(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(265,null),i.localize(266,null),i.localize(267,null)],description:i.localize(268,null)})),showUnused:Fe(new a(101,"showUnused",!0,{description:i.localize(269,null)})),showDeprecated:Fe(new a(128,"showDeprecated",!0,{description:i.localize(270,null)})),inlayHints:Fe(new le),snippetSuggestions:Fe(new c(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(271,null),i.localize(272,null),i.localize(273,null),i.localize(274,null)],description:i.localize(275,null)})),smartSelect:Fe(new be),smoothScrolling:Fe(new a(104,"smoothScrolling",!1,{description:i.localize(276,null)})),stopRenderingLineAfter:Fe(new w(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ce),inlineSuggest:Fe(new N),suggestFontSize:Fe(new w(109,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(277,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new w(110,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(278,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new a(111,"suggestOnTriggerCharacters",!0,{description:i.localize(279,null)})),suggestSelection:Fe(new c(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(280,null),i.localize(281,null),i.localize(282,null)],description:i.localize(283,null)})),tabCompletion:Fe(new c(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(284,null),i.localize(285,null),i.localize(286,null)],description:i.localize(287,null)})),tabIndex:Fe(new w(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new _),unusualLineTerminators:Fe(new c(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(288,null),i.localize(289,null),i.localize(290,null)],description:i.localize(291,null)})),useShadowDOM:Fe(new a(117,"useShadowDOM",!0)),useTabStops:Fe(new a(118,"useTabStops",!0,{description:i.localize(292,null)})),wordSeparators:Fe(new T(119,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:i.localize(293,null)})),wordWrap:Fe(new c(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(294,null),i.localize(295,null),i.localize(296,null),i.localize(297,null)],description:i.localize(298,null)})),wordWrapBreakAfterCharacters:Fe(new T(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new T(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new w(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(299,null)})),wordWrapOverride1:Fe(new c(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new c(125,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new j),pixelRatio:Fe(new Be),tabFocusMode:Fe(new oe),layoutInfo:Fe(new ee),wrappingInfo:Fe(new Ue),wrappingIndent:Fe(new ve),wrappingStrategy:Fe(new ue)}}),define(De[125],Ie([16,17]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[126],Ie([16,17]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[127],Ie([16,17]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[128],Ie([16,17]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(De[129],Ie([16,17]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(De[130],Ie([16,17]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(De[131],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[132],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[133],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(De[134],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[135],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[136],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[137],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[138],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(De[139],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[140],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[141],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[142],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[143],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[144],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[145],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[146],Ie([1,0,22,29,127,246]),function(ie,e,i,I,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(a){return a=a.trim(),a==="*"||D.test(a)}e.isValidVersionStr=y;function k(a){if(!y(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=a.match(D);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=k;function R(a){if(!a)return null;const g=a.majorBase,w=a.majorMustEqual,d=a.minorBase;let T=a.minorMustEqual;const r=a.patchBase;let c=a.patchMustEqual;a.hasCaret&&(g===0||(T=!1),c=!1);let n=0;if(a.preRelease){const u=A.exec(a.preRelease);if(u){const[,l,f,s]=u;n=Date.UTC(Number(l),Number(f)-1,Number(s))}}return{majorBase:g,majorMustEqual:w,minorBase:d,minorMustEqual:T,patchBase:r,patchMustEqual:c,isMinimum:a.hasGreaterEquals,notBefore:n}}e.normalizeVersion=R;function b(a,g,w){let d;typeof a=="string"?d=R(k(a)):d=a;let T;g instanceof Date?T=g.getTime():typeof g=="string"&&(T=new Date(g).getTime());let r;if(typeof w=="string"?r=R(k(w)):r=w,!d||!r)return!1;const c=d.majorBase,n=d.minorBase,u=d.patchBase;let l=r.majorBase,f=r.minorBase,s=r.patchBase;const h=r.notBefore;let v=r.majorMustEqual,P=r.minorMustEqual,L=r.patchMustEqual;return r.isMinimum?c>l?!0:c<l?!1:n>f?!0:n<f||T&&T<h?!1:u>=s:(c===1&&l===0&&(!v||!P||!L)&&(l=1,f=0,s=0,v=!0,P=!1,L=!1),c<l?!1:c>l?!v:n<f?!1:n>f?!P:u<s?!1:u>s?!L:!(T&&T<h))}e.isValidVersion=b;function p(a,g,w,d,T){const r=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return r.push([I.default.Error,S.localize(0,null)]),r;if(typeof d.name!="string")return r.push([I.default.Error,S.localize(1,null,"name")]),r;if(typeof d.version!="string")return r.push([I.default.Error,S.localize(2,null,"version")]),r;if(!d.engines)return r.push([I.default.Error,S.localize(3,null,"engines")]),r;if(typeof d.engines.vscode!="string")return r.push([I.default.Error,S.localize(4,null,"engines.vscode")]),r;if(typeof d.extensionDependencies<"u"&&!o(d.extensionDependencies))return r.push([I.default.Error,S.localize(5,null,"extensionDependencies")]),r;if(typeof d.activationEvents<"u"){if(!o(d.activationEvents))return r.push([I.default.Error,S.localize(6,null,"activationEvents")]),r;if(typeof d.main>"u"&&typeof d.browser>"u")return r.push([I.default.Error,S.localize(7,null,"activationEvents","main")]),r}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&r.push([I.default.Warning,S.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return r.push([I.default.Error,S.localize(9,null,"main")]),r;{const u=(0,i.joinPath)(w,d.main);(0,i.isEqualOrParent)(u,w)||r.push([I.default.Warning,S.localize(10,null,u.path,w.path)])}if(typeof d.activationEvents>"u")return r.push([I.default.Error,S.localize(11,null,"activationEvents","main")]),r}if(typeof d.browser<"u"){if(typeof d.browser!="string")return r.push([I.default.Error,S.localize(12,null,"browser")]),r;{const u=(0,i.joinPath)(w,d.browser);(0,i.isEqualOrParent)(u,w)||r.push([I.default.Warning,S.localize(13,null,u.path,w.path)])}if(typeof d.activationEvents>"u")return r.push([I.default.Error,S.localize(14,null,"activationEvents","browser")]),r}if(!M.valid(d.version))return r.push([I.default.Error,S.localize(15,null)]),r;const c=[];if(!E(a,g,d,T,c))for(const u of c)r.push([I.default.Error,u]);return r}e.validateExtensionManifest=p;function E(a,g,w,d,T){return d||typeof w.main>"u"&&typeof w.browser>"u"?!0:t(a,g,w.engines.vscode,T)}e.isValidExtensionVersion=E;function m(a,g,w){return a==="*"||t(g,w,a)}e.isEngineValid=m;function t(a,g,w,d=[]){const T=R(k(w));if(!T)return d.push(S.localize(16,null,w)),!1;if(T.majorBase===0){if(!T.majorMustEqual||!T.minorMustEqual)return d.push(S.localize(17,null,w)),!1}else if(!T.majorMustEqual)return d.push(S.localize(18,null,w)),!1;return b(a,g,T)?!0:(d.push(S.localize(19,null,a,w)),!1)}function o(a){if(!Array.isArray(a))return!1;for(let g=0,w=a.length;g<w;g++)if(typeof a[g]!="string")return!1;return!0}}),define(De[84],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(S,M=[],D=!1){this.ctor=S,this.staticArguments=M,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=i}),define(De[59],Ie([1,0,84]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const I=[];var S;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(S=e.InstantiationType||(e.InstantiationType={}));function M(A,y,k){y instanceof i.SyncDescriptor||(y=new i.SyncDescriptor(y,[],Boolean(k))),I.push([A,y])}e.registerSingleton=M;function D(){return I}e.getSingletonServiceDescriptors=D}),define(De[147],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(M,D){this.key=M,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class I{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const D of this._nodes.values())D.outgoing.size===0&&M.push(D);return M}insertEdge(M,D){const A=this.lookupOrInsertNode(M),y=this.lookupOrInsertNode(D);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(M){const D=this._hashFn(M);this._nodes.delete(D);for(const A of this._nodes.values())A.outgoing.delete(D),A.incoming.delete(D)}lookupOrInsertNode(M){const D=this._hashFn(M);let A=this._nodes.get(D);return A||(A=new i(D,M),this._nodes.set(D,A)),A}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[D,A]of this._nodes)M.push(`${D}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,D]of this._nodes){const A=new Set([M]),y=this._findCycle(D,A);if(y)return y}}_findCycle(M,D){for(const[A,y]of M.outgoing){if(D.has(A))return[...D,A].join(" -> ");D.add(A);const k=this._findCycle(y,D);if(k)return k;D.delete(A)}}}e.Graph=I}),define(De[3],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=A})(i=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function I(D,A,y){A[i.DI_TARGET]===A?A[i.DI_DEPENDENCIES].push({id:D,index:y}):(A[i.DI_DEPENDENCIES]=[{id:D,index:y}],A[i.DI_TARGET]=A)}function S(D){if(i.serviceIds.has(D))return i.serviceIds.get(D);const A=function(y,k,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(A,y,R)};return A.toString=()=>D,i.serviceIds.set(D,A),A}e.createDecorator=S;function M(D){return D}e.refineServiceDecorator=M}),define(De[40],Ie([1,0,9,2,3]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function M(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof I.URI)}e.isConfigurationOverrides=M;function D(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof I.URI)}e.isConfigurationUpdateOverrides=D;var A;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function k(a,g){const w=Object.create(null);for(const d in a)R(w,d,a[d],g);return w}e.toValuesTree=k;function R(a,g,w,d){const T=g.split("."),r=T.pop();let c=a;for(let n=0;n<T.length;n++){const u=T[n];let l=c[u];switch(typeof l){case"undefined":l=c[u]=Object.create(null);break;case"object":break;default:d(`Ignoring ${g} as ${T.slice(0,n+1).join(".")} is ${JSON.stringify(l)}`);return}c=l}if(typeof c=="object"&&c!==null)try{c[r]=w}catch{d(`Ignoring ${g} as ${T.join(".")} is ${JSON.stringify(c)}`)}else d(`Ignoring ${g} as ${T.join(".")} is ${JSON.stringify(c)}`)}e.addToValueTree=R;function b(a,g){const w=g.split(".");p(a,w)}e.removeFromValueTree=b;function p(a,g){const w=g.shift();if(g.length===0){delete a[w];return}if(Object.keys(a).indexOf(w)!==-1){const d=a[w];typeof d=="object"&&!Array.isArray(d)&&(p(d,g),Object.keys(d).length===0&&delete a[w])}}function E(a,g,w){function d(c,n){let u=c;for(const l of n){if(typeof u!="object"||u===null)return;u=u[l]}return u}const T=g.split("."),r=d(a,T);return typeof r>"u"?w:r}e.getConfigurationValue=E;function m(a,g,w){Object.keys(g).forEach(d=>{d!=="__proto__"&&(d in a?i.isObject(a[d])&&i.isObject(g[d])?m(a[d],g[d],w):w&&(a[d]=g[d]):a[d]=g[d])})}e.merge=m;function t(a,g,w){const d=a.inspect(g),T=a.inspect(w);return typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:typeof T.userValue<"u"||typeof T.workspaceValue<"u"||typeof T.workspaceFolderValue<"u"?T.value:d.defaultValue}e.getMigratedSettingValue=t;function o(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(De[41],Ie([1,0,21,10,3]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",i.isMacintosh),M.set("isLinux",i.isLinux),M.set("isWindows",i.isWindows),M.set("isWeb",i.isWeb),M.set("isMacNative",i.isMacintosh&&!i.isWeb),M.set("isEdge",i.isEdge),M.set("isFirefox",i.isFirefox),M.set("isChrome",i.isChrome),M.set("isSafari",i.isSafari);const D=Object.prototype.hasOwnProperty;var A;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return b.INSTANCE}static true(){return p.INSTANCE}static has(C){return E.create(C)}static equals(C,F){return m.create(C,F)}static notEquals(C,F){return a.create(C,F)}static regex(C,F){return n.create(C,F)}static in(C,F){return t.create(C,F)}static notIn(C,F){return o.create(C,F)}static not(C){return g.create(C)}static and(...C){return f.create(C,null,!0)}static or(...C){return s.create(C,null,!0)}static greater(C,F){return d.create(C,F)}static greaterEquals(C,F){return T.create(C,F)}static smaller(C,F){return r.create(C,F)}static smallerEquals(C,F){return c.create(C,F)}static deserialize(C,F=!1){if(!!C)return this._deserializeOrExpression(C,F)}static _deserializeOrExpression(C,F){const O=C.split("||");return s.create(O.map(x=>this._deserializeAndExpression(x,F)),null,!0)}static _deserializeAndExpression(C,F){const O=C.split("&&");return f.create(O.map(x=>this._deserializeOne(x,F)),null,!0)}static _deserializeOne(C,F){if(C=C.trim(),C.indexOf("!=")>=0){const O=C.split("!=");return a.create(O[0].trim(),this._deserializeValue(O[1],F))}if(C.indexOf("==")>=0){const O=C.split("==");return m.create(O[0].trim(),this._deserializeValue(O[1],F))}if(C.indexOf("=~")>=0){const O=C.split("=~");return n.create(O[0].trim(),this._deserializeRegexValue(O[1],F))}if(C.indexOf(" not in ")>=0){const O=C.split(" not in ");return o.create(O[0].trim(),this._deserializeValue(O[1],F))}if(C.indexOf(" in ")>=0){const O=C.split(" in ");return t.create(O[0].trim(),this._deserializeValue(O[1],F))}if(/^[^<=>]+>=[^<=>]+$/.test(C)){const O=C.split(">=");return T.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(C)){const O=C.split(">");return d.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(C)){const O=C.split("<=");return c.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(C)){const O=C.split("<");return r.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(C)?g.create(C.substr(1).trim()):E.create(C)}static _deserializeValue(C,F){if(C=C.trim(),C==="true")return!0;if(C==="false")return!1;const O=/^'([^']*)'$/.exec(C);return O?O[1].trim():C}static _deserializeRegexValue(C,F){if((0,I.isFalsyOrWhitespace)(C)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const O=C.indexOf("/"),x=C.lastIndexOf("/");if(O===x||O<0){if(F)throw new Error(`bad regexp-value '${C}', missing /-enclosure`);return console.warn(`bad regexp-value '${C}', missing /-enclosure`),null}const B=C.slice(O+1,x),H=C[x+1]==="i"?"i":"";try{return new RegExp(B,H)}catch(G){if(F)throw new Error(`bad regexp-value '${C}', parse error: ${G}`);return console.warn(`bad regexp-value '${C}', parse error: ${G}`),null}}}e.ContextKeyExpr=y;function k(V,C){const F=V?V.substituteConstants():void 0,O=C?C.substituteConstants():void 0;return!F&&!O?!0:!F||!O?!1:F.equals(O)}e.expressionsAreEqualWithConstantSubstitution=k;function R(V,C){return V.cmp(C)}class b{constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class p{constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class E{static create(C,F=null){const O=M.get(C);return typeof O=="boolean"?O?p.INSTANCE:b.INSTANCE:new E(C,F)}constructor(C,F){this.key=C,this.negated=F,this.type=2}cmp(C){return C.type!==this.type?this.type-C.type:v(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=M.get(this.key);return typeof C=="boolean"?C?p.INSTANCE:b.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=E;class m{static create(C,F,O=null){if(typeof F=="boolean")return F?E.create(C,O):g.create(C,O);const x=M.get(C);return typeof x=="boolean"?F===(x?"true":"false")?p.INSTANCE:b.INSTANCE:new m(C,F,O)}constructor(C,F,O){this.key=C,this.value=F,this.negated=O,this.type=4}cmp(C){return C.type!==this.type?this.type-C.type:P(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=M.get(this.key);if(typeof C=="boolean"){const F=C?"true":"false";return this.value===F?p.INSTANCE:b.INSTANCE}return this}evaluate(C){return C.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(C){return C.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=m;class t{static create(C,F){return new t(C,F)}constructor(C,F){this.key=C,this.valueKey=F,this.type=10,this.negated=null}cmp(C){return C.type!==this.type?this.type-C.type:P(this.key,this.valueKey,C.key,C.valueKey)}equals(C){return C.type===this.type?this.key===C.key&&this.valueKey===C.valueKey:!1}substituteConstants(){return this}evaluate(C){const F=C.getValue(this.valueKey),O=C.getValue(this.key);return Array.isArray(F)?F.includes(O):typeof O=="string"&&typeof F=="object"&&F!==null?D.call(F,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(C){return C.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=o.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=t;class o{static create(C,F){return new o(C,F)}constructor(C,F){this.key=C,this.valueKey=F,this.type=11,this._negated=t.create(C,F)}cmp(C){return C.type!==this.type?this.type-C.type:this._negated.cmp(C._negated)}equals(C){return C.type===this.type?this._negated.equals(C._negated):!1}substituteConstants(){return this}evaluate(C){return!this._negated.evaluate(C)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(C){return C.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=o;class a{static create(C,F,O=null){if(typeof F=="boolean")return F?g.create(C,O):E.create(C,O);const x=M.get(C);return typeof x=="boolean"?F===(x?"true":"false")?b.INSTANCE:p.INSTANCE:new a(C,F,O)}constructor(C,F,O){this.key=C,this.value=F,this.negated=O,this.type=5}cmp(C){return C.type!==this.type?this.type-C.type:P(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=M.get(this.key);if(typeof C=="boolean"){const F=C?"true":"false";return this.value===F?b.INSTANCE:p.INSTANCE}return this}evaluate(C){return C.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(C){return C.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=a;class g{static create(C,F=null){const O=M.get(C);return typeof O=="boolean"?O?b.INSTANCE:p.INSTANCE:new g(C,F)}constructor(C,F){this.key=C,this.negated=F,this.type=3}cmp(C){return C.type!==this.type?this.type-C.type:v(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=M.get(this.key);return typeof C=="boolean"?C?b.INSTANCE:p.INSTANCE:this}evaluate(C){return!C.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(C){return C.mapNot(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function w(V,C){if(typeof V=="string"){const F=parseFloat(V);isNaN(F)||(V=F)}return typeof V=="string"||typeof V=="number"?C(V):b.INSTANCE}class d{static create(C,F,O=null){return w(F,x=>new d(C,x,O))}constructor(C,F,O){this.key=C,this.value=F,this.negated=O,this.type=12}cmp(C){return C.type!==this.type?this.type-C.type:P(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=d;class T{static create(C,F,O=null){return w(F,x=>new T(C,x,O))}constructor(C,F,O){this.key=C,this.value=F,this.negated=O,this.type=13}cmp(C){return C.type!==this.type?this.type-C.type:P(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=T;class r{static create(C,F,O=null){return w(F,x=>new r(C,x,O))}constructor(C,F,O){this.key=C,this.value=F,this.negated=O,this.type=14}cmp(C){return C.type!==this.type?this.type-C.type:P(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class c{static create(C,F,O=null){return w(F,x=>new c(C,x,O))}constructor(C,F,O){this.key=C,this.value=F,this.negated=O,this.type=15}cmp(C){return C.type!==this.type?this.type-C.type:P(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=c;class n{static create(C,F){return new n(C,F)}constructor(C,F){this.key=C,this.regexp=F,this.type=7,this.negated=null}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.key<C.key)return-1;if(this.key>C.key)return 1;const F=this.regexp?this.regexp.source:"",O=C.regexp?C.regexp.source:"";return F<O?-1:F>O?1:0}equals(C){if(C.type===this.type){const F=this.regexp?this.regexp.source:"",O=C.regexp?C.regexp.source:"";return this.key===C.key&&F===O}return!1}substituteConstants(){return this}evaluate(C){const F=C.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const C=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${C}`}keys(){return[this.key]}map(C){return C.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=u.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class u{static create(C){return new u(C)}constructor(C){this._actual=C,this.type=8}cmp(C){return C.type!==this.type?this.type-C.type:this._actual.cmp(C._actual)}equals(C){return C.type===this.type?this._actual.equals(C._actual):!1}substituteConstants(){return this}evaluate(C){return!this._actual.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(C){return new u(this._actual.map(C))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=u;function l(V){let C=null;for(let F=0,O=V.length;F<O;F++){const x=V[F].substituteConstants();if(V[F]!==x&&C===null){C=[];for(let B=0;B<F;B++)C[B]=V[B]}C!==null&&(C[F]=x)}return C===null?V:C}class f{static create(C,F,O){return f._normalizeArr(C,F,O)}constructor(C,F){this.expr=C,this.negated=F,this.type=6}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const x=R(this.expr[F],C.expr[F]);if(x!==0)return x}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(C.expr[F]))return!1;return!0}return!1}substituteConstants(){const C=l(this.expr);return C===this.expr?this:f.create(C,this.negated,!1)}evaluate(C){for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].evaluate(C))return!1;return!0}static _normalizeArr(C,F,O){const x=[];let B=!1;for(const H of C)if(!!H){if(H.type===1){B=!0;continue}if(H.type===0)return b.INSTANCE;if(H.type===6){x.push(...H.expr);continue}x.push(H)}if(x.length===0&&B)return p.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(R);for(let H=1;H<x.length;H++)x[H-1].equals(x[H])&&(x.splice(H,1),H--);if(x.length===1)return x[0];for(;x.length>1;){const H=x[x.length-1];if(H.type!==9)break;x.pop();const G=x.pop(),ee=x.length===0,ue=s.create(H.expr.map(re=>f.create([re,G],null,O)),null,ee);ue&&(x.push(ue),x.sort(R))}if(x.length===1)return x[0];if(O){for(let H=0;H<x.length;H++)for(let G=H+1;G<x.length;G++)if(x[H].negate().equals(x[G]))return b.INSTANCE;if(x.length===1)return x[0]}return new f(x,F)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const F of this.expr)C.push(...F.keys());return C}map(C){return new f(this.expr.map(F=>F.map(C)),null)}negate(){if(!this.negated){const C=[];for(const F of this.expr)C.push(F.negate());this.negated=s.create(C,this,!0)}return this.negated}}class s{static create(C,F,O){return s._normalizeArr(C,F,O)}constructor(C,F){this.expr=C,this.negated=F,this.type=9}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const x=R(this.expr[F],C.expr[F]);if(x!==0)return x}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(C.expr[F]))return!1;return!0}return!1}substituteConstants(){const C=l(this.expr);return C===this.expr?this:s.create(C,this.negated,!1)}evaluate(C){for(let F=0,O=this.expr.length;F<O;F++)if(this.expr[F].evaluate(C))return!0;return!1}static _normalizeArr(C,F,O){let x=[],B=!1;if(C){for(let H=0,G=C.length;H<G;H++){const ee=C[H];if(!!ee){if(ee.type===0){B=!0;continue}if(ee.type===1)return p.INSTANCE;if(ee.type===9){x=x.concat(ee.expr);continue}x.push(ee)}}if(x.length===0&&B)return b.INSTANCE;x.sort(R)}if(x.length!==0){if(x.length===1)return x[0];for(let H=1;H<x.length;H++)x[H-1].equals(x[H])&&(x.splice(H,1),H--);if(x.length===1)return x[0];if(O){for(let H=0;H<x.length;H++)for(let G=H+1;G<x.length;G++)if(x[H].negate().equals(x[G]))return p.INSTANCE;if(x.length===1)return x[0]}return new s(x,F)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const F of this.expr)C.push(...F.keys());return C}map(C){return new s(this.expr.map(F=>F.map(C)),null)}negate(){if(!this.negated){const C=[];for(const F of this.expr)C.push(F.negate());for(;C.length>1;){const F=C.shift(),O=C.shift(),x=[];for(const B of W(F))for(const H of W(O))x.push(f.create([B,H],null,!1));C.unshift(s.create(x,null,!1))}this.negated=s.create(C,this,!0)}return this.negated}}class h extends E{static all(){return h._info.values()}constructor(C,F,O){super(C,null),this._defaultValue=F,typeof O=="object"?h._info.push({...O,key:C}):O!==!0&&h._info.push({key:C,description:O,type:F!=null?typeof F:void 0})}bindTo(C){return C.createKey(this.key,this._defaultValue)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return m.create(this.key,C)}notEqualsTo(C){return a.create(this.key,C)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(V,C){return V<C?-1:V>C?1:0}function P(V,C,F,O){return V<F?-1:V>F?1:C<O?-1:C>O?1:0}function L(V,C){if(V.type===0||C.type===1)return!0;if(V.type===9)return C.type===9?j(V.expr,C.expr):!1;if(C.type===9){for(const F of C.expr)if(L(V,F))return!0;return!1}if(V.type===6){if(C.type===6)return j(C.expr,V.expr);for(const F of V.expr)if(L(F,C))return!0;return!1}return V.equals(C)}e.implies=L;function j(V,C){let F=0,O=0;for(;F<V.length&&O<C.length;){const x=V[F].cmp(C[O]);if(x<0)return!1;x===0&&F++,O++}return F===V.length}function W(V){return V.type===9?V.expr:[V]}}),define(De[148],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(De[85],Ie([1,0,126,3]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY="DEFAULT_PROFILE_EXTENSIONS_MIGRATION";function S(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=S;function M(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function D(a,g){switch(a){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function A(a,g){return g==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(a,g,w){return A(g,w)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===w?!0:k(w).includes(a)}e.isTargetPlatformCompatible=y;function k(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function R(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=R;var b;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var p;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var E;(function(a){a.Install="install",a.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var m;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var t;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal",a.Signature="Signature"})(t=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(g,w){super(g),this.code=w,this.name=w}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(De[35],Ie([1,0,46,19,10,9,2,128,3]),function(ie,e,i,I,S,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function k(B){return B.create===!0}e.isFileOpenForWriteOptions=k;var R;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var b;(function(B){B[B.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var p;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=E;function m(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=m;function t(B){return!!(B.capabilities&32768)}e.hasFileCloneCapability=t;function o(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function a(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=a;function g(B){return E(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var w;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(H,G){super(H),this.code=G}}e.FileSystemProviderError=d;function T(B,H){const G=new d(B.toString(),H);return c(G,H),G}e.createFileSystemProviderError=T;function r(B){return B||T((0,A.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=r;function c(B,H){return B.name=H?`${H} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=c;function n(B){if(!B)return w.Unknown;if(B instanceof d)return B.code;const H=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!H)return w.Unknown;switch(H[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=n;function u(B){if(B instanceof P)return B.fileOperationResult;switch(n(B)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var l;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(l=e.FileOperation||(e.FileOperation={}));class f{constructor(H,G,ee){this.resource=H,this.operation=G,this.target=ee}isOperation(H){return this.operation===H}}e.FileOperationEvent=f;var s;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class h{constructor(H,G){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=H;const ee=new Map;for(const ue of H){const re=ee.get(ue.type);switch(re?re.push([ue.resource,ue]):ee.set(ue.type,[[ue.resource,ue]]),ue.type){case 1:this.rawAdded.push(ue.resource);break;case 0:this.rawUpdated.push(ue.resource);break;case 2:this.rawDeleted.push(ue.resource);break}}for(const[ue,re]of ee)switch(ue){case 1:this.added=i.TernarySearchTree.forUris(()=>G),this.added.fill(re);break;case 0:this.updated=i.TernarySearchTree.forUris(()=>G),this.updated.fill(re);break;case 2:this.deleted=i.TernarySearchTree.forUris(()=>G),this.deleted.fill(re);break}}contains(H,...G){return this.doContains(H,{includeChildren:!1},...G)}affects(H,...G){return this.doContains(H,{includeChildren:!0},...G)}doContains(H,G,...ee){if(!H)return!1;const ue=ee.length>0;return!!((!ue||ee.includes(1))&&(this.added?.get(H)||G.includeChildren&&this.added?.findSuperstr(H))||(!ue||ee.includes(0))&&(this.updated?.get(H)||G.includeChildren&&this.updated?.findSuperstr(H))||(!ue||ee.includes(2))&&(this.deleted?.findSubstr(H)||G.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function v(B,H,G){return!B||!H||B===H||H.length>B.length?!1:(H.charAt(H.length-1)!==I.sep&&(H+=I.sep),G?(0,S.startsWithIgnoreCase)(B,H):B.indexOf(H)===0)}e.isParent=v;class P extends Error{constructor(H,G,ee){super(H),this.fileOperationResult=G,this.options=ee}}e.FileOperationError=P;class L extends P{constructor(H,G,ee){super(H,2,ee),this.stat=G}}e.NotModifiedSinceFileOperationError=L;var j;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(j=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var W;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(W=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=V;async function C(B,H){if(!H.hasProvider(D.URI.from({scheme:B.scheme})))return new Promise(G=>{const ee=H.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===B.scheme&&ue.added&&(ee.dispose(),G())})})}e.whenProviderRegistered=C,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(H){return(0,M.isNumber)(H)||(H=0),H<F.KB?(0,A.localize)(1,null,H.toFixed(0)):H<F.MB?(0,A.localize)(2,null,(H/F.KB).toFixed(2)):H<F.GB?(0,A.localize)(3,null,(H/F.MB).toFixed(2)):H<F.TB?(0,A.localize)(4,null,(H/F.GB).toFixed(2)):(0,A.localize)(5,null,(H/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var O;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(O=e.Arch||(e.Arch={}));function x(B){return{maxFileSize:B===0?300*F.MB:16*F.GB,maxHeapSize:B===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=x}),define(De[60],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...S){this._entries=new Map;for(const[M,D]of S)this.set(M,D)}set(S,M){const D=this._entries.get(S);return this._entries.set(S,M),D}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=i}),define(De[149],Ie([1,0,15,12,7,84,147,3,60,150]),function(ie,e,i,I,S,M,D,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class b extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class p{constructor(o=new y.ServiceCollection,a=!1,g,w=R){this._services=o,this._strict=a,this._parent=g,this._enableTracing=w,this._activeInstantiations=new Set,this._services.set(A.IInstantiationService,this),this._globalGraph=w?g?._globalGraph??new D.Graph(d=>d):void 0}createChild(o){return new p(o,this._strict,this,this._enableTracing)}invokeFunction(o,...a){const g=m.traceInvocation(this._enableTracing,o);let w=!1;try{return o({get:T=>{if(w)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(T,g);if(!r)throw new Error(`[invokeFunction] unknown service '${T}'`);return r}},...a)}finally{w=!0,g.stop()}}createInstance(o,...a){let g,w;return o instanceof M.SyncDescriptor?(g=m.traceCreation(this._enableTracing,o.ctor),w=this._createInstance(o.ctor,o.staticArguments.concat(a),g)):(g=m.traceCreation(this._enableTracing,o),w=this._createInstance(o,a,g)),g.stop(),w}_createInstance(o,a=[],g){const w=A._util.getServiceDependencies(o).sort((r,c)=>r.index-c.index),d=[];for(const r of w){const c=this._getOrCreateServiceInstance(r.id,g);c||this._throwIfStrict(`[createInstance] ${o.name} depends on UNKNOWN service ${r.id}.`,!1),d.push(c)}const T=w.length>0?w[0].index:a.length;if(a.length!==T){console.trace(`[createInstance] First service dependency of ${o.name} at position ${T+1} conflicts with ${a.length} static arguments`);const r=T-a.length;r>0?a=a.concat(new Array(r)):a=a.slice(0,T)}return Reflect.construct(o,a.concat(d))}_setServiceInstance(o,a){if(this._services.get(o)instanceof M.SyncDescriptor)this._services.set(o,a);else if(this._parent)this._parent._setServiceInstance(o,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){const a=this._services.get(o);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):a}_getOrCreateServiceInstance(o,a){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(o));const g=this._getServiceInstanceOrDescriptor(o);return g instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,g,a.branch(o,!0)):(a.branch(o,!1),g)}_safeCreateAndCacheServiceInstance(o,a,g){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,a,g)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,a,g){const w=new D.Graph(r=>r.id.toString());let d=0;const T=[{id:o,desc:a,_trace:g}];for(;T.length;){const r=T.pop();if(w.lookupOrInsertNode(r),d++>1e3)throw new b(w);for(const c of A._util.getServiceDependencies(r.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(c.id);if(n||this._throwIfStrict(`[createInstance] ${o} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(c.id)),n instanceof M.SyncDescriptor){const u={id:c.id,desc:n,_trace:r._trace.branch(c.id,!0)};w.insertEdge(r,u),T.push(u)}}}for(;;){const r=w.roots();if(r.length===0){if(!w.isEmpty())throw new b(w);break}for(const{data:c}of r){if(this._getServiceInstanceOrDescriptor(c.id)instanceof M.SyncDescriptor){const u=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,u)}w.removeNode(c)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,a,g=[],w,d){if(this._services.get(o)instanceof M.SyncDescriptor)return this._createServiceInstance(o,a,g,w,d);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,a,g,w,d);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(o,a,g=[],w,d){if(w){const T=new p(void 0,this._strict,this,this._enableTracing);T._globalGraphImplicitDependency=String(o);const r=new Map,c=new i.IdleValue(()=>{const n=T._createInstance(a,g,d);for(const[u,l]of r){const f=n[u];if(typeof f=="function")for(const s of l)f.apply(n,s)}return r.clear(),n});return new Proxy(Object.create(null),{get(n,u){if(!c.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let s=r.get(u);return s||(s=new k.LinkedList,r.set(u,s)),(v,P,L)=>{const j=s.push([v,P,L]);return(0,S.toDisposable)(j)}}if(u in n)return n[u];const l=c.value;let f=l[u];return typeof f!="function"||(f=f.bind(l),n[u]=f),f},set(n,u,l){return c.value[u]=l,!0}})}else return this._createInstance(a,g,d)}_throwIfStrict(o,a){if(a&&console.warn(o),this._strict)throw new Error(o)}}e.InstantiationService=p;var E;(function(t){t[t.Creation=0]="Creation",t[t.Invocation=1]="Invocation",t[t.Branch=2]="Branch"})(E||(E={}));class m{static traceInvocation(o,a){return o?new m(1,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m._None}static traceCreation(o,a){return o?new m(0,a.name):m._None}constructor(o,a){this.type=o,this.name=a,this._start=Date.now(),this._dep=[]}branch(o,a){const g=new m(2,o.toString());return this._dep.push([o,a,g]),g}stop(){const o=Date.now()-this._start;m._totals+=o;let a=!1;function g(d,T){const r=[],c=new Array(d+1).join("	");for(const[n,u,l]of T._dep)if(u&&l){a=!0,r.push(`${c}CREATES -> ${n}`);const f=g(d+1,l);f&&r.push(f)}else r.push(`${c}uses -> ${n}`);return r.join(`
`)}const w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(o>2||a)&&m.all.add(w.join(`
`))}}e.Trace=m,m.all=new Set,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(De[11],Ie([1,0,45,4,7,28,21,2,3]),function(ie,e,i,I,S,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function k(){return new Date().toISOString()}var R;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(R=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=R.Info;function b(f,s,h){switch(s){case R.Trace:f.trace(h);break;case R.Debug:f.debug(h);break;case R.Info:f.info(h);break;case R.Warning:f.warn(h);break;case R.Error:f.error(h);break;default:throw new Error("Invalid log level")}}e.log=b;function p(f){let s="";for(let h=0;h<f.length;h++){let v=f[h];if(typeof v=="object")try{v=JSON.stringify(v)}catch{}s+=(h>0?" ":"")+v}return s}e.format=p;class E extends S.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class m extends E{constructor(s){super(),this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...h){this.checkLogLevel(R.Trace)&&this.log(R.Trace,p([s,...h]))}debug(s,...h){this.checkLogLevel(R.Debug)&&this.log(R.Debug,p([s,...h]))}info(s,...h){this.checkLogLevel(R.Info)&&this.log(R.Info,p([s,...h]))}warn(s,...h){this.checkLogLevel(R.Warning)&&this.log(R.Warning,p([s,...h]))}error(s,...h){if(this.checkLogLevel(R.Error))if(s instanceof Error){const v=Array.prototype.slice.call(arguments);v[0]=s.stack,this.log(R.Error,p(v))}else this.log(R.Error,p([s,...h]))}flush(){}}e.AbstractMessageLogger=m;class t extends E{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.useColors=!D.isWindows}trace(s,...h){this.getLevel()<=R.Trace&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,s,...h):console.log(`[main ${k()}]`,s,...h))}debug(s,...h){this.getLevel()<=R.Debug&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,s,...h):console.log(`[main ${k()}]`,s,...h))}info(s,...h){this.getLevel()<=R.Info&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,s,...h):console.log(`[main ${k()}]`,s,...h))}warn(s,...h){this.getLevel()<=R.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,s,...h):console.warn(`[main ${k()}]`,s,...h))}error(s,...h){this.getLevel()<=R.Error&&(this.useColors?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,s,...h):console.error(`[main ${k()}]`,s,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=t;class o extends E{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...h){this.getLevel()<=R.Trace&&console.log("%cTRACE","color: #888",s,...h)}debug(s,...h){this.getLevel()<=R.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...h)}info(s,...h){this.getLevel()<=R.Info&&console.log("%c INFO","color: #33f",s,...h)}warn(s,...h){this.getLevel()<=R.Warning&&console.log("%c WARN","color: #993",s,...h)}error(s,...h){this.getLevel()<=R.Error&&console.log("%c  ERR","color: #f33",s,...h)}dispose(){}flush(){}}e.ConsoleLogger=o;class a extends E{constructor(s,h=e.DEFAULT_LOG_LEVEL){super(),this.adapter=s,this.setLevel(h)}trace(s,...h){this.getLevel()<=R.Trace&&this.adapter.log(R.Trace,[this.extractMessage(s),...h])}debug(s,...h){this.getLevel()<=R.Debug&&this.adapter.log(R.Debug,[this.extractMessage(s),...h])}info(s,...h){this.getLevel()<=R.Info&&this.adapter.log(R.Info,[this.extractMessage(s),...h])}warn(s,...h){this.getLevel()<=R.Warning&&this.adapter.log(R.Warning,[this.extractMessage(s),...h])}error(s,...h){this.getLevel()<=R.Error&&this.adapter.log(R.Error,[this.extractMessage(s),...h])}extractMessage(s){return typeof s=="string"?s:(0,i.toErrorMessage)(s,this.getLevel()<=R.Trace)}dispose(){}flush(){}}e.AdapterLogger=a;class g extends E{constructor(s){super(),this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const h of this.logServices)h.setLevel(s);super.setLevel(s)}trace(s,...h){for(const v of this.logServices)v.trace(s,...h)}debug(s,...h){for(const v of this.logServices)v.debug(s,...h)}info(s,...h){for(const v of this.logServices)v.info(s,...h)}warn(s,...h){for(const v of this.logServices)v.warn(s,...h)}error(s,...h){for(const v of this.logServices)v.error(s,...h)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=g;class w extends S.Disposable{constructor(s){super(),this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...h){this.logger.trace(s,...h)}debug(s,...h){this.logger.debug(s,...h)}info(s,...h){this.logger.info(s,...h)}warn(s,...h){this.logger.warn(s,...h)}error(s,...h){this.logger.error(s,...h)}flush(){this.logger.flush()}}e.LogService=w;class d extends S.Disposable{constructor(s,h){super(),this.logLevel=s,this.loggerItems=new M.ResourceMap,this._register(h(v=>this.setLevel(v)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:s})=>s)}getLogger(s){return this.loggerItems.get(s)?.logger}createLogger(s,h,v){let P=this.loggerItems.get(s)?.logger;return P||(v=h?.always?R.Trace:v,P=this.doCreateLogger(s,v??this.logLevel,h),this.loggerItems.set(s,{logger:P,logLevel:v})),P}setLevel(s,h){const v=A.URI.isUri(s)?s:void 0,P=v?h:s;if(v){const L=this.loggerItems.get(v);L&&L.logLevel!==P&&(L.logLevel=P,L.logger.setLevel(P))}else this.logLevel=P,this.loggerItems.forEach(({logLevel:L,logger:j})=>{L===void 0&&j.setLevel(this.logLevel)})}getLogLevel(s){return this.loggerItems.get(s)?.logLevel}dispose(){this.loggerItems.forEach(({logger:s})=>s.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=d;class T{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(s){}getLevel(){return R.Info}trace(s,...h){}debug(s,...h){}info(s,...h){}warn(s,...h){}error(s,...h){}critical(s,...h){}dispose(){}flush(){}}e.NullLogger=T;class r extends T{}e.NullLogService=r;class c extends d{constructor(){super(R.Info,I.Event.None)}doCreateLogger(s,h,v){return new T}}e.NullLoggerService=c;function n(f){if(f.verbose)return R.Trace;if(typeof f.logLevel=="string"){const s=l(f.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function u(f){switch(f){case R.Trace:return"trace";case R.Debug:return"debug";case R.Info:return"info";case R.Warning:return"warn";case R.Error:return"error";case R.Off:return"off"}}e.LogLevelToString=u;function l(f){switch(f){case"trace":return R.Trace;case"debug":return R.Debug;case"info":return R.Info;case"warn":return R.Warning;case"error":return R.Error;case"critical":return R.Error;case"off":return R.Off}}e.parseLogLevel=l}),define(De[86],Ie([1,0,29,129,3]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function k(m,t){return t-m}y.compare=k;const R=Object.create(null);R[y.Error]=(0,I.localize)(0,null),R[y.Warning]=(0,I.localize)(1,null),R[y.Info]=(0,I.localize)(2,null);function b(m){return R[m]||""}y.toString=b;function p(m){switch(m){case i.default.Error:return y.Error;case i.default.Warning:return y.Warning;case i.default.Info:return y.Info;case i.default.Ignore:return y.Hint}}y.fromSeverity=p;function E(m){switch(m){case y.Error:return i.default.Error;case y.Warning:return i.default.Warning;case y.Info:return i.default.Info;case y.Hint:return i.default.Ignore}}y.toSeverity=E}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const k="";function R(p){return b(p,!0)}y.makeKey=R;function b(p,E){const m=[k];return p.source?m.push(p.source.replace("\xA6","\\\xA6")):m.push(k),p.code?typeof p.code=="string"?m.push(p.code.replace("\xA6","\\\xA6")):m.push(p.code.value.replace("\xA6","\\\xA6")):m.push(k),p.severity!==void 0&&p.severity!==null?m.push(D.toString(p.severity)):m.push(k),p.message&&E?m.push(p.message.replace("\xA6","\\\xA6")):m.push(k),p.startLineNumber!==void 0&&p.startLineNumber!==null?m.push(p.startLineNumber.toString()):m.push(k),p.startColumn!==void 0&&p.startColumn!==null?m.push(p.startColumn.toString()):m.push(k),p.endLineNumber!==void 0&&p.endLineNumber!==null?m.push(p.endLineNumber.toString()):m.push(k),p.endColumn!==void 0&&p.endColumn!==null?m.push(p.endColumn.toString()):m.push(k),m.push(k),m.join("\xA6")}y.makeKeyOptionalMessage=b})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,S.createDecorator)("markerService")}),define(De[151],Ie([1,0,4,29,3]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=I.default,e.INotificationService=(0,S.createDecorator)("notificationService");var M;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=y}),define(De[87],Ie([1,0,10,2,3]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,S.createDecorator)("openerService");function M(k,R){return I.URI.isUri(k)?(0,i.equalsIgnoreCase)(k.scheme,R):(0,i.startsWithIgnoreCase)(k,R+":")}e.matchesScheme=M;function D(k,...R){return R.some(b=>M(k,b))}e.matchesSomeScheme=D;function A(k,R){return k.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.withSelection=A;function y(k){let R;const b=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return b&&(R={startLineNumber:parseInt(b[1]),startColumn:b[2]?parseInt(b[2]):1,endLineNumber:b[4]?parseInt(b[4]):void 0,endColumn:b[4]?b[5]?parseInt(b[5]):1:void 0},k=k.with({fragment:""})),{selection:R,uri:k}}e.extractSelection=y}),define(De[152],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var He=this&&this.__decorate||function(ie,e,i,I){var S=arguments.length,M=S<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,i):I,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ie,e,i,I);else for(var A=ie.length-1;A>=0;A--)(D=ie[A])&&(M=(S<3?D(M):S>3?D(e,i,M):D(e,i))||M);return S>3&&M&&Object.defineProperty(e,i,M),M},$e=this&&this.__param||function(ie,e){return function(i,I){e(i,I,ie)}};define(De[153],Ie([1,0,15,20,7,3]),function(ie,e,i,I,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var D;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this._value}constructor(b){this.callback=b}report(b){this._value=b,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends S.Disposable{constructor(b,p){super(),this.deferred=new i.DeferredPromise,p.withProgress(b,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};y=He([$e(1,e.IProgressService)],y),e.UnmanagedProgress=y;class k extends S.Disposable{constructor(b){super(),this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(b){this.stop();const p=++this.currentOperationId,E=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{p===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:p,token:E.token,stop:()=>this.doStop(p),isCurrent:()=>this.currentOperationId===p}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(De[30],Ie([1,0,47,9]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(D,A){i.ok(I.isString(D)),i.ok(I.isObject(A)),i.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,A)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new S}),define(De[88],Ie([1,0,4,30]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class M{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,k){this.schemasById[S(y)]=k,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new M;I.Registry.add(e.Extensions.JSONContribution,D)}),define(De[89],Ie([1,0,18,4,9,125,40,88,30]),function(ie,e,i,I,S,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(T){T.Multiline="multilineText",T.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(T){T[T.APPLICATION=1]="APPLICATION",T[T.MACHINE=2]="MACHINE",T[T.WINDOW=3]="WINDOW",T[T.RESOURCE=4]="RESOURCE",T[T.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",T[T.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=y.Registry.as(A.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,c=!0){this.registerConfigurations([r],c)}registerConfigurations(r,c=!0){const n=this.doRegisterConfigurations(r,c);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(r){const c=this.doDeregisterConfigurations(r);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}updateConfigurations({add:r,remove:c}){const n=[];n.push(...this.doDeregisterConfigurations(c)),n.push(...this.doRegisterConfigurations(r,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,i.distinct)(n)})}registerDefaultConfigurations(r){const c=[],n=[];for(const{overrides:u,source:l}of r)for(const f in u)if(c.push(f),e.OVERRIDE_PROPERTY_REGEX.test(f)){const s=this.configurationDefaultsOverrides.get(f),h=s?.valuesSources??new Map;if(l)for(const j of Object.keys(u[f]))h.set(j,l);const v={...s?.value||{},...u[f]};this.configurationDefaultsOverrides.set(f,{source:l,value:v,valuesSources:h});const P=(0,D.getLanguageTagSettingPlainKey)(f),L={type:"object",default:v,description:M.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:S.isString(l)?void 0:l,defaultValueSource:l};n.push(...t(f)),this.configurationProperties[f]=L,this.defaultLanguageConfigurationOverridesNode.properties[f]=L}else{this.configurationDefaultsOverrides.set(f,{value:u[f],source:l});const s=this.configurationProperties[f];s&&(this.updatePropertyDefaultValue(f,s),this.updateSchema(f,s))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const c=[];for(const{overrides:n,source:u}of r)for(const l in n){const f=this.configurationDefaultsOverrides.get(l),s=S.isString(u)?u:u?.id,h=S.isString(f?.source)?f?.source:f?.source?.id;if(s===h)if(c.push(l),this.configurationDefaultsOverrides.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const v=this.configurationProperties[l];v&&(this.updatePropertyDefaultValue(l,v),this.updateSchema(l,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const c of r)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,c){const n=[];return r.forEach(u=>{n.push(...this.validateAndRegisterProperties(u,c,u.extensionInfo,u.restrictedProperties)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),n}doDeregisterConfigurations(r){const c=[],n=u=>{if(u.properties)for(const l in u.properties){c.push(l);const f=this.configurationProperties[l];f?.policy?.name&&this.policyConfigurations.delete(f.policy.name),delete this.configurationProperties[l],this.removeFromSchema(l,u.properties[l])}u.allOf?.forEach(l=>n(l))};for(const u of r){n(u);const l=this.configurationContributors.indexOf(u);l!==-1&&this.configurationContributors.splice(l,1)}return c}validateAndRegisterProperties(r,c=!0,n,u,l=3){l=S.isUndefinedOrNull(r.scope)?l:r.scope;const f=[],s=r.properties;if(s)for(const v in s){const P=s[v];if(c&&w(v,P)){delete s[v];continue}if(P.source=n,P.defaultDefaultValue=s[v].default,this.updatePropertyDefaultValue(v,P),e.OVERRIDE_PROPERTY_REGEX.test(v)?P.scope=void 0:(P.scope=S.isUndefinedOrNull(P.scope)?l:P.scope,P.restricted=S.isUndefinedOrNull(P.restricted)?!!u?.includes(v):P.restricted),s[v].hasOwnProperty("included")&&!s[v].included){this.excludedConfigurationProperties[v]=s[v],delete s[v];continue}else this.configurationProperties[v]=s[v],s[v].policy?.name&&this.policyConfigurations.set(s[v].policy.name,v);!s[v].deprecationMessage&&s[v].markdownDeprecationMessage&&(s[v].deprecationMessage=s[v].markdownDeprecationMessage),f.push(v)}const h=r.allOf;if(h)for(const v of h)f.push(...this.validateAndRegisterProperties(v,c,n,u,l));return f}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const c=n=>{const u=n.properties;if(u)for(const f in u)this.updateSchema(f,u[f]);n.allOf?.forEach(c)};c(r)}updateSchema(r,c){switch(e.allSettings.properties[r]=c,c.scope){case 1:e.applicationSettings.properties[r]=c;break;case 2:e.machineSettings.properties[r]=c;break;case 6:e.machineOverridableSettings.properties[r]=c;break;case 3:e.windowSettings.properties[r]=c;break;case 4:e.resourceSettings.properties[r]=c;break;case 5:e.resourceSettings.properties[r]=c,this.resourceLanguageSettingsSchema.properties[r]=c;break}}removeFromSchema(r,c){switch(delete e.allSettings.properties[r],c.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const c=`[${r}]`,n={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,n),e.allSettings.properties[c]=n,e.applicationSettings.properties[c]=n,e.machineSettings.properties[c]=n,e.machineOverridableSettings.properties[c]=n,e.windowSettings.properties[c]=n,e.resourceSettings.properties[c]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,c){const n=this.configurationDefaultsOverrides.get(r);let u=n?.value,l=n?.source;S.isUndefined(u)&&(u=c.defaultDefaultValue,l=void 0),S.isUndefined(u)&&(u=a(c.type)),c.default=u,c.defaultValueSource=l}}const E="\\[([^\\]]+)\\]",m=new RegExp(E,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(T){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(T)){let c=m.exec(T);for(;c?.length;){const n=c[1].trim();n&&r.push(n),c=m.exec(T)}}return(0,i.distinct)(r)}e.overrideIdentifiersFromKey=t;function o(T){return T.reduce((r,c)=>`${r}[${c}]`,"")}e.keyFromOverrideIdentifiers=o;function a(T){switch(Array.isArray(T)?T[0]:T){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const g=new p;y.Registry.add(e.Extensions.Configuration,g);function w(T,r){return T.trim()?e.OVERRIDE_PROPERTY_REGEX.test(T)?M.localize(7,null,T):g.getConfigurationProperties()[T]!==void 0?M.localize(8,null,T):r.policy?.name&&g.getPolicyConfigurations().get(r.policy?.name)!==void 0?M.localize(9,null,T,r.policy?.name,g.getPolicyConfigurations().get(r.policy?.name)):null:M.localize(6,null)}e.validateProperty=w;function d(){const T=[],r=g.getConfigurationProperties();for(const c of Object.keys(r))T.push([c,r[c].scope]);return T.push(["launch",4]),T.push(["task",4]),T}e.getScopes=d}),define(De[154],Ie([1,0,18,4,106,7,28,23,9,2,40,89,30]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class E{constructor(c={},n=[],u=[],l){this._contents=c,this._keys=n,this._overrides=u,this.raw=l,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const c=this.raw.map(n=>{if(n instanceof E)return n;const u=new m("");return u.parseRaw(n),u.configurationModel});this._rawConfiguration=c.reduce((n,u)=>u===n?u:n.merge(u),c[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(c){return c?(0,R.getConfigurationValue)(this.contents,c):this.contents}inspect(c,n){const u=this.rawConfiguration.getValue(c),l=n?this.rawConfiguration.getOverrideValue(c,n):void 0,f=n?this.rawConfiguration.override(n).getValue(c):u;return{value:u,override:l,merged:f}}getOverrideValue(c,n){const u=this.getContentsForOverrideIdentifer(n);return u?c?(0,R.getConfigurationValue)(u,c):u:void 0}getKeysForOverrideIdentifier(c){const n=[];for(const u of this.overrides)u.identifiers.includes(c)&&n.push(...u.keys);return i.distinct(n)}getAllOverrideIdentifiers(){const c=[];for(const n of this.overrides)c.push(...n.identifiers);return i.distinct(c)}override(c){let n=this.overrideConfigurations.get(c);return n||(n=this.createOverrideConfigurationModel(c),this.overrideConfigurations.set(c,n)),n}merge(...c){const n=A.deepClone(this.contents),u=A.deepClone(this.overrides),l=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const s of c)if(f.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.mergeContents(n,s.contents);for(const h of s.overrides){const[v]=u.filter(P=>i.equals(P.identifiers,h.identifiers));v?(this.mergeContents(v.contents,h.contents),v.keys.push(...h.keys),v.keys=i.distinct(v.keys)):u.push(A.deepClone(h))}for(const h of s.keys)l.indexOf(h)===-1&&l.push(h)}return new E(n,l,u,f.every(s=>s instanceof E)?void 0:f)}freeze(){return this.frozen=!0,this}clone(){return new E(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}createOverrideConfigurationModel(c){const n=this.getContentsForOverrideIdentifer(c);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const u={};for(const l of i.distinct([...Object.keys(this.contents),...Object.keys(n)])){let f=this.contents[l];const s=n[l];s&&(typeof f=="object"&&typeof s=="object"?(f=A.deepClone(f),this.mergeContents(f,s)):f=s),u[l]=f}return new E(u,this.keys,this.overrides)}mergeContents(c,n){for(const u of Object.keys(n)){if(u in c&&y.isObject(c[u])&&y.isObject(n[u])){this.mergeContents(c[u],n[u]);continue}c[u]=A.deepClone(n[u])}}checkAndFreeze(c){return this.frozen&&!Object.isFrozen(c)?A.deepFreeze(c):c}getContentsForOverrideIdentifer(c){let n=null,u=null;const l=f=>{f&&(u?this.mergeContents(u,f):u=A.deepClone(f))};for(const f of this.overrides)i.equals(f.identifiers,[c])?n=f.contents:f.identifiers.includes(c)&&l(f.contents);return l(n),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(c,n){this.addKey(c),(0,R.addToValueTree)(this.contents,c,n,u=>{throw new Error(u)})}removeValue(c){this.removeKey(c)&&(0,R.removeFromValueTree)(this.contents,c)}addKey(c){let n=this.keys.length;for(let u=0;u<n;u++)c.indexOf(this.keys[u])===0&&(n=u);this.keys.splice(n,1,c)}removeKey(c){const n=this.keys.indexOf(c);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=E;class m{constructor(c){this._name=c,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(c,n){if(!y.isUndefinedOrNull(c)){const u=this.doParseContent(c);this.parseRaw(u,n)}}reparse(c){this._raw&&this.parseRaw(this._raw,c)}parseRaw(c,n){this._raw=c;const{contents:u,keys:l,overrides:f,restricted:s,hasExcludedProperties:h}=this.doParseRaw(c,n);this._configurationModel=new E(u,l,f,h?[c]:void 0),this._restrictedConfigurations=s||[]}doParseContent(c){let n={},u=null,l=[];const f=[],s=[];function h(P){Array.isArray(l)?l.push(P):u!==null&&(l[u]=P)}const v={onObjectBegin:()=>{const P={};h(P),f.push(l),l=P,u=null},onObjectProperty:P=>{u=P},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const P=[];h(P),f.push(l),l=P,u=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:h,onError:(P,L,j)=>{s.push({error:P,offset:L,length:j})}};if(c)try{S.visit(c,v),n=l[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return n}doParseRaw(c,n){const u=p.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),l=this.filter(c,u,!0,n);c=l.raw;const f=(0,R.toValuesTree)(c,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),s=Object.keys(c),h=this.toOverrides(c,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:f,keys:s,overrides:h,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}filter(c,n,u,l){let f=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:c,restricted:[],hasExcludedProperties:f};const s={},h=[];for(const v in c)if(b.OVERRIDE_PROPERTY_REGEX.test(v)&&u){const P=this.filter(c[v],n,!1,l);s[v]=P.raw,f=f||P.hasExcludedProperties,h.push(...P.restricted)}else{const P=n[v],L=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&h.push(v),(L===void 0||l.scopes===void 0||l.scopes.includes(L))&&!(l.skipRestricted&&P?.restricted)?s[v]=c[v]:f=!0}return{raw:s,restricted:h,hasExcludedProperties:f}}toOverrides(c,n){const u=[];for(const l of Object.keys(c))if(b.OVERRIDE_PROPERTY_REGEX.test(l)){const f={};for(const s in c[l])f[s]=c[l][s];u.push({identifiers:(0,b.overrideIdentifiersFromKey)(l),keys:Object.keys(f),contents:(0,R.toValuesTree)(f,n)})}return u}}e.ConfigurationModelParser=m;class t extends M.Disposable{constructor(c,n,u,l){super(),this.userSettingsResource=c,this.scopes=n,this.fileService=l,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.any(I.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource)),I.Event.filter(this.fileService.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&u.isEqual(f.resource,c)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const c=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(c.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=t;class o{constructor(c,n,u,l,f,s,h,v,P,L,j,W,V){this.key=c,this.overrides=n,this.value=u,this.overrideIdentifiers=l,this.defaultConfiguration=f,this.policyConfiguration=s,this.applicationConfiguration=h,this.userConfiguration=v,this.localUserConfiguration=P,this.remoteUserConfiguration=L,this.workspaceConfiguration=j,this.folderConfigurationModel=W,this.memoryInspectValue=V}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class a{constructor(c,n,u,l,f=new E,s=new E,h=new D.ResourceMap,v=new E,P=new D.ResourceMap,L=!0){this._defaultConfiguration=c,this._policyConfiguration=n,this._applicationConfiguration=u,this._localUserConfiguration=l,this._remoteUserConfiguration=f,this._workspaceConfiguration=s,this._folderConfigurations=h,this._memoryConfiguration=v,this._memoryConfigurationByResource=P,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(c,n,u){return this.getConsolidatedConfigurationModel(c,n,u).getValue(c)}updateValue(c,n,u={}){let l;u.resource?(l=this._memoryConfigurationByResource.get(u.resource),l||(l=new E,this._memoryConfigurationByResource.set(u.resource,l))):l=this._memoryConfiguration,n===void 0?l.removeValue(c):l.setValue(c,n),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(c,n,u){const l=this.getConsolidatedConfigurationModel(c,n,u),f=i.distinct(l.overrides.map(v=>v.identifiers).flat()).filter(v=>l.getOverrideValue(c,v)!==void 0),s=this.getFolderConfigurationModelForResource(n.resource,u),h=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration;return new o(c,n,l.getValue(c),f.length?f:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),u?this._workspaceConfiguration.freeze():void 0,s?s.freeze():void 0,h.inspect(c,n.overrideIdentifier))}keys(c){const n=this.getFolderConfigurationModelForResource(void 0,c);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(c){this._defaultConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(c){this._policyConfiguration=c}updateApplicationConfiguration(c){this._applicationConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(c){this._localUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(c){this._remoteUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(c){this._workspaceConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(c,n){this._folderConfigurations.set(c,n),this._foldersConsolidatedConfigurations.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this._foldersConsolidatedConfigurations.delete(c)}compareAndUpdateDefaultConfiguration(c,n){const u=[];if(!n){const{added:l,updated:f,removed:s}=d(this._defaultConfiguration,c);n=[...l,...f,...s]}for(const l of n)for(const f of(0,b.overrideIdentifiersFromKey)(l)){const s=this._defaultConfiguration.getKeysForOverrideIdentifier(f),h=c.getKeysForOverrideIdentifier(f),v=[...h.filter(P=>s.indexOf(P)===-1),...s.filter(P=>h.indexOf(P)===-1),...s.filter(P=>!A.equals(this._defaultConfiguration.override(f).getValue(P),c.override(f).getValue(P)))];u.push([f,v])}return this.updateDefaultConfiguration(c),{keys:n,overrides:u}}compareAndUpdatePolicyConfiguration(c){const{added:n,updated:u,removed:l}=d(this._policyConfiguration,c),f=[...n,...u,...l];return f.length&&this.updatePolicyConfiguration(c),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:n,updated:u,removed:l,overrides:f}=d(this.applicationConfiguration,c),s=[...n,...u,...l];return s.length&&this.updateApplicationConfiguration(c),{keys:s,overrides:f}}compareAndUpdateLocalUserConfiguration(c){const{added:n,updated:u,removed:l,overrides:f}=d(this.localUserConfiguration,c),s=[...n,...u,...l];return s.length&&this.updateLocalUserConfiguration(c),{keys:s,overrides:f}}compareAndUpdateRemoteUserConfiguration(c){const{added:n,updated:u,removed:l,overrides:f}=d(this.remoteUserConfiguration,c),s=[...n,...u,...l];return s.length&&this.updateRemoteUserConfiguration(c),{keys:s,overrides:f}}compareAndUpdateWorkspaceConfiguration(c){const{added:n,updated:u,removed:l,overrides:f}=d(this.workspaceConfiguration,c),s=[...n,...u,...l];return s.length&&this.updateWorkspaceConfiguration(c),{keys:s,overrides:f}}compareAndUpdateFolderConfiguration(c,n){const u=this.folderConfigurations.get(c),{added:l,updated:f,removed:s,overrides:h}=d(u,n),v=[...l,...f,...s];return(v.length||!u)&&this.updateFolderConfiguration(c,n),{keys:v,overrides:h}}compareAndDeleteFolderConfiguration(c){const n=this.folderConfigurations.get(c);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:u,updated:l,removed:f,overrides:s}=d(n,void 0);return{keys:[...u,...l,...f],overrides:s}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(c,n,u){let l=this.getConsolidatedConfigurationModelForResource(n,u);return n.overrideIdentifier&&(l=l.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(c)!==void 0&&(l=l.merge(this._policyConfiguration)),l}getConsolidatedConfigurationModelForResource({resource:c},n){let u=this.getWorkspaceConsolidatedConfiguration();if(n&&c){const l=n.getFolder(c);l&&(u=this.getFolderConsolidatedConfiguration(l.uri)||u);const f=this._memoryConfigurationByResource.get(c);f&&(u=u.merge(f))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(c){let n=this._foldersConsolidatedConfigurations.get(c);if(!n){const u=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(c);l?(n=u.merge(l),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(c,n)):n=u}return n}getFolderConfigurationModelForResource(c,n){if(n&&c){const u=n.getFolder(c);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((c,n)=>{const{contents:u,overrides:l,keys:f}=this._folderConfigurations.get(n);return c.push([n,{contents:u,overrides:l,keys:f}]),c},[])}}allKeys(){const c=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>c.add(n)),this.userConfiguration.freeze().keys.forEach(n=>c.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>c.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(u=>c.add(u))),[...c.values()]}allOverrideIdentifiers(){const c=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>c.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>c.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>c.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(u=>c.add(u))),[...c.values()]}getAllKeysForOverrideIdentifier(c){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(c).forEach(u=>n.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(u=>n.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(c).forEach(u=>n.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(c).forEach(l=>n.add(l))),[...n.values()]}static parse(c){const n=this.parseConfigurationModel(c.defaults),u=this.parseConfigurationModel(c.policy),l=this.parseConfigurationModel(c.application),f=this.parseConfigurationModel(c.user),s=this.parseConfigurationModel(c.workspace),h=c.folders.reduce((v,P)=>(v.set(k.URI.revive(P[0]),this.parseConfigurationModel(P[1])),v),new D.ResourceMap);return new a(n,u,l,f,new E,s,h,new E,new D.ResourceMap,!1)}static parseConfigurationModel(c){return new E(c.contents,c.keys,c.overrides).freeze()}}e.Configuration=a;function g(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const c=new Set,n=new Map;for(const l of r)l.keys.forEach(f=>c.add(f)),l.overrides.forEach(([f,s])=>{const h=(0,D.getOrSet)(n,f,new Set);s.forEach(v=>h.add(v))});const u=[];return n.forEach((l,f)=>u.push([f,[...l.values()]])),{keys:[...c.values()],overrides:u}}e.mergeChanges=g;class w{constructor(c,n,u,l){this.change=c,this.previous=n,this.currentConfiguraiton=u,this.currentWorkspace=l,this._previousConfiguration=void 0;const f=new Set;c.keys.forEach(h=>f.add(h)),c.overrides.forEach(([,h])=>h.forEach(v=>f.add(v))),this.affectedKeys=[...f.values()];const s=new E;this.affectedKeys.forEach(h=>s.setValue(h,{})),this.affectedKeysTree=s.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=a.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(c,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,c)){if(n){const u=this.previousConfiguration?this.previousConfiguration.getValue(c,n,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(c,n,this.currentWorkspace);return!A.equals(u,l)}return!0}return!1}doesAffectedKeysTreeContains(c,n){let u=(0,R.toValuesTree)({[n]:!0},()=>{}),l;for(;typeof u=="object"&&(l=Object.keys(u)[0]);){if(c=c[l],!c)return!1;u=u[l]}return!0}}e.ConfigurationChangeEvent=w;function d(r,c){const{added:n,removed:u,updated:l}=T(c?.rawConfiguration,r?.rawConfiguration),f=[],s=r?.getAllOverrideIdentifiers()||[],h=c?.getAllOverrideIdentifiers()||[];if(c){const v=h.filter(P=>!s.includes(P));for(const P of v)f.push([P,c.getKeysForOverrideIdentifier(P)])}if(r){const v=s.filter(P=>!h.includes(P));for(const P of v)f.push([P,r.getKeysForOverrideIdentifier(P)])}if(c&&r){for(const v of s)if(h.includes(v)){const P=T({contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)},{contents:c.getOverrideValue(void 0,v)||{},keys:c.getKeysForOverrideIdentifier(v)});f.push([v,[...P.added,...P.removed,...P.updated]])}}return{added:n,removed:u,updated:l,overrides:f}}function T(r,c){const n=r?c?r.keys.filter(f=>c.keys.indexOf(f)===-1):[...r.keys]:[],u=c?r?c.keys.filter(f=>r.keys.indexOf(f)===-1):[...c.keys]:[],l=[];if(r&&c){for(const f of c.keys)if(r.keys.indexOf(f)!==-1){const s=(0,R.getConfigurationValue)(c.contents,f),h=(0,R.getConfigurationValue)(r.contents,f);A.equals(s,h)||l.push(f)}}return{added:n,removed:u,updated:l}}}),define(De[90],Ie([1,0,12,3]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,I.createDecorator)("remoteAuthorityResolverService");var S;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(S=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends i.ErrorNoTelemetry{static isNotAvailable(A){return A instanceof M&&A._code===S.NotAvailable}static isTemporarilyNotAvailable(A){return A instanceof M&&A._code===S.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof M&&A._code===S.NoResolverFound}static isHandled(A){return A instanceof M&&A.isHandled}constructor(A,y=S.Unknown,k){super(A),this._message=A,this._code=y,this._detail=k,this.isHandled=y===S.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M}),define(De[61],Ie([1,0,13]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function I(k){return k.scheme===i.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=I;function S(k){if(!k)return;const R=k.indexOf("+");return R<0?k:k.substr(0,R)}e.getRemoteName=S;function M(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=M;function D(k){const{host:R,port:b}=y(k);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:b}}e.parseAuthorityWithPort=D;function A(k,R){let{host:b,port:p}=y(k);return typeof p>"u"&&(p=R),{host:b,port:p}}e.parseAuthorityWithOptionalPort=A;function y(k){const R=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const b=k.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const p=k.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:k,port:void 0}}}),define(De[25],Ie([1,0,10,3,61]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=M;function D(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var y;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,o){if(typeof t>"u"||t===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof t=="string"||typeof o=="string"){const a=typeof t=="string"?t:t.value,g=typeof o=="string"?o:o.value;return i.equalsIgnoreCase(a,g)}return t._lower===o._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.ExtensionIdentifier=k;function R(m){return b(m)}e.isApplicationScopedExtension=R;function b(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function p(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function E(m,t){if(t){const o=`onResolveRemoteAuthority:${(0,S.getRemoteName)(t)}`;return m.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[155],Ie([1,0,10,85,25,21,2,12,48]),function(ie,e,i,I,S,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(c,n){return c.uuid&&n.uuid?c.uuid===n.uuid:c.id===n.id?!0:(0,i.compareIgnoreCase)(c.id,n.id)===0}e.areSameExtensions=k;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(n){const u=n.manifest?n.manifest.version:n.version,l=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new b(n.identifier,u,l)}static parse(n){const u=R.exec(n);return u&&u[1]&&u[2]?new b({id:u[1]},u[2],u[4]||void 0):null}constructor(n,u,l="undefined"){this.version=u,this.targetPlatform=l,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof b?k(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=b;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(c){const n=p.exec(c);return n&&n[1]?[t(n[1]),n[2]]:[t(c),void 0]}e.getIdAndVersion=E;function m(c,n){return`${c}.${n}`}e.getExtensionId=m;function t(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=t;function o(c,n){return t(m(c,n))}e.getGalleryExtensionId=o;function a(c,n){const u=[],l=f=>{for(const s of u)if(s.some(h=>k(n(h),n(f))))return s;return null};for(const f of c){const s=l(f);s?s.push(f):u.push([f])}return u}e.groupByExtension=a;function g(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function w(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function d(c,n){const u=[],l=n.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const f=l.shift();if(f&&u.every(s=>!k(s.identifier,{id:f}))){const s=c.filter(h=>k(h.identifier,{id:f}));s.length===1&&(u.push(s[0]),l.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.getExtensionDependencies=d;async function T(c,n){if(!M.isLinux)return!1;let u;try{u=(await c.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await c.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){n.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(f))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=T;async function r(c,n){const u=await T(c,n),l=(0,I.getTargetPlatform)(u?"alpine":M.platform,y.arch);return n.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=r}),define(De[156],Ie([1,0,21,48,2,38]),function(ie,e,i,I,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(k){if(i.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function A(k,R,b,p,E,m,t,o,a,g){const w=Object.create(null);w["common.machineId"]=t,w.sessionID=(0,M.generateUuid)()+Date.now(),w.commitHash=E,w.version=m,w["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,i.PlatformToString)(i.platform),w["common.nodePlatform"]=I.platform,w["common.nodeArch"]=p,w["common.product"]=g||"desktop",o&&(w["common.msftInternal"]=o);let d=0;const T=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-T,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),i.isLinuxSnap&&(w["common.snap"]="true");const r=D(b);r&&(w["common.platformDetail"]=r);try{const c=await k.readFile(S.URI.file(a));w["common.source"]=c.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=A;function y(k){const R=I.env.USERDNSDOMAIN;if(!R)return!1;const b=R.toLowerCase();return k.some(p=>b===p)}e.verifyMicrosoftInternalDomain=y}),define(De[157],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(I=e.TelemetryLevel||(e.TelemetryLevel={}));var S;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(S=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(De[158],Ie([1,0,23,115,9,40,156,157]),function(ie,e,i,I,S,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,I.staticObservableValue)(0)}publicLog(u,l){return Promise.resolve(void 0)}publicLog2(u,l){return this.publicLog(u,l)}publicLogError(u,l){return Promise.resolve(void 0)}publicLogError2(u,l){return this.publicLogError(u,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class k{async publicLog(u,l,f){}async publicLogError(u,l,f){}}e.NullEndpointTelemetryService=k,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function R(n,u){return u.onDidChangeConfiguration(l=>{l.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(l.source),configurationKeys:a(l.sourceConfig)})})}e.configurationTelemetry=R;function b(n,u){return!(u.disableTelemetry||!n.enableTelemetry||u.extensionTestsLocationURI)}e.supportsTelemetry=b;function p(n){const u=n.getValue(A.TELEMETRY_SETTING_ID),l=n.getValue("telemetry.enableCrashReporter");if(n.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function E(n){const u={},l={},f={};o(n,f);for(let s in f){s=s.length>150?s.substr(s.length-149):s;const h=f[s];typeof h=="number"?l[s]=h:typeof h=="boolean"?l[s]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${h.length}`),u[s]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(u[s]=h)}return{properties:u,measurements:l}}e.validateTelemetryData=E;const m=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function t(n){if(!n)return"none";for(const u of m)if(n.startsWith(`${u}+`))return u;return"other"}e.cleanRemoteAuthority=t;function o(n,u,l=0,f){if(!!n)for(const s of Object.getOwnPropertyNames(n)){const h=n[s],v=f?f+s:s;Array.isArray(h)?u[v]=(0,i.safeStringify)(h):h instanceof Date?u[v]=h.toISOString():(0,S.isObject)(h)?l<2?o(h,u,l+1,v+"."):u[v]=(0,i.safeStringify)(h):u[v]=h}}function a(n){if(!n)return[];const u=[];return g(u,"",n),u}function g(n,u,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(f=>g(n,u?`${u}.${f}`:f,l[f])):n.push(u)}function w(n,u){const l=n.msftInternalDomains||[],f=u.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(l)||f}e.isInternalTelemetry=w;function d(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=d;function T(n,u){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let l=n;const f=[];for(const P of u)for(;;){const L=P.exec(n);if(!L)break;f.push([L.index,P.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(l="";;){const P=h.exec(n);if(!P)break;const L=f.some(([j,W])=>P.index<W&&j<h.lastIndex);!s.test(P[0])&&!L&&(l+=n.substring(v,P.index)+"<REDACTED: user-file-path>",v=h.lastIndex)}return v<n.length&&(l+=n.substr(v)),l}function r(n){if(!n)return n;const u=n.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of l)if(f.regex.test(u))return`<REDACTED: ${f.label}>`;return n}function c(n,u){return(0,i.cloneAndChange)(n,l=>{if(typeof l=="string"){let f=l;f=T(f,u);for(const s of u)f=f.replace(s,"");return f=r(f),f}})}e.cleanData=c}),define(De[159],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,M,D=5){const A=M(y=>{const k=typeof y=="string"?y:y.data;let R=this._terminalBufferMap.get(S);if(R){R.data.push(k);return}const b=setTimeout(()=>this.flushBuffer(S),D);R={data:[k],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(S),A.dispose()}},this._terminalBufferMap.set(S,R)});return A}stopBuffering(S){this._terminalBufferMap.get(S)?.dispose()}flushBuffer(S){const M=this._terminalBufferMap.get(S);M&&(this._terminalBufferMap.delete(S),this._callback(S,M.data.join("")))}}e.TerminalDataBufferer=i}),define(De[160],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var i;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(i=e.ColorScheme||(e.ColorScheme={}));function I(M){return M===i.HIGH_CONTRAST_DARK||M===i.HIGH_CONTRAST_LIGHT}e.isHighContrast=I;function S(M){return M===i.DARK||M===i.HIGH_CONTRAST_DARK}e.isDark=S}),define(De[62],Ie([1,0,118,4,7,3,30,160]),function(ie,e,i,I,S,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var y;(function(o){function a(g){return g&&typeof g=="object"&&typeof g.id=="string"}o.isThemeColor=a})(y=e.ThemeColor||(e.ThemeColor={}));function k(o){return{id:o}}e.themeColorFromId=k;var R;(function(o){function a(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||y.isThemeColor(u.color))}o.isThemeIcon=a;const g=new RegExp(`^\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)$`);function w(u){const l=g.exec(u);if(!l)return;const[,f]=l;return{id:f}}o.fromString=w;function d(u){return{id:u}}o.fromId=d;function T(u,l){let f=u.id;const s=f.lastIndexOf("~");return s!==-1&&(f=f.substring(0,s)),l&&(f=`${f}~${l}`),{id:f}}o.modify=T;function r(u){const l=u.id.lastIndexOf("~");if(l!==-1)return u.id.substring(l+1)}o.getModifier=r;function c(u,l){return u.id===l.id&&u.color?.id===l.color?.id}o.isEqual=c;function n(u,l){return{id:u.id,color:l?k(l):void 0}}o.asThemeIcon=n,o.asClassNameArray=i.CSSIcon.asClassNameArray,o.asClassName=i.CSSIcon.asClassName,o.asCSSSelector=i.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=i.Codicon.file,e.FolderThemeIcon=i.Codicon.folder;function b(o){switch(o){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new I.Emitter}onColorThemeChange(a){return this.themingParticipants.push(a),this.onThemingParticipantAddedEmitter.fire(a),(0,S.toDisposable)(()=>{const g=this.themingParticipants.indexOf(a);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const E=new p;D.Registry.add(e.Extensions.ThemingContribution,E);function m(o){return E.onColorThemeChange(o)}e.registerThemingParticipant=m;class t extends S.Disposable{constructor(a){super(),this.themeService=a,this.theme=a.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(a){this.theme=a,this.updateStyles()}updateStyles(){}getColor(a,g){let w=this.theme.getColor(a);return w&&g&&(w=g(w,this.theme)),w?w.toString():null}}e.Themable=t}),define(De[161],Ie([1,0,4,40,3,11]),function(ie,e,i,I,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,S.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,S.createDecorator)("sharedTunnelsService");var D;(function(t){t.Http="http",t.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=b;function p(t,o,a,g){if(a===1)return!1;if(a===2&&b(o)){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(w?.length===4&&parseInt(w[1])>=18)return!1}return t<1024}e.isPortPrivileged=p;class E{constructor(o,a,g){this.remoteAddress=o,this.localAddress=a,this._dispose=g,this._onDispose=new i.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=E;let m=class{constructor(o,a){this.logService=o,this.configurationService=a,this._onTunnelOpened=new i.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new i.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new i.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const o=this.configurationService.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this._tunnelProvider=o,o?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this._canElevate=o.elevation,this._privacyOptions=o.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const o=[],a=Array.from(this._tunnels.values());for(const g of a){const w=Array.from(g.values());for(const d of w){const T=await d.value;T&&o.push(T)}}return o}async dispose(){for(const o of this._tunnels.values()){for(const{value:a}of o.values())await a.then(g=>g?.dispose());o.clear()}this._tunnels.clear()}setEnvironmentTunnel(o,a,g,w,d){this.addTunnelToMap(o,a,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:a,localAddress:g,privacy:w,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,a){(b(o)||R(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const g=this.getTunnelFromMap(o,a);if(g)return++g.refcount,g.value}openTunnel(o,a,g,w,d=!1,T,r){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${g} on local port ${w}.`),!o)return;if(a||(a="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.retainOrCreateTunnel(o,a,g,w,d,T,r);return c?c.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(a,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.makeTunnel(n);return(n.tunnelRemoteHost!==a||n.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(u),u}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const a=this._tunnels.get(o.tunnelRemoteHost);if(a){const g=a.get(o.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,g))}}}}async tryDisposeTunnel(o,a,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${a}.`);const w=g.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(a),w}}async closeTunnel(o,a){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${a} `);const g=this._tunnels.get(o);if(g&&g.has(a)){const w=g.get(a);w.refcount=0,await this.tryDisposeTunnel(o,a,w)}}addTunnelToMap(o,a,g){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(a,{refcount:1,value:g})}async removeEmptyTunnelFromMap(o,a){const g=this._tunnels.get(o);g&&(await g.get(a)||g.delete(a),g.size===0&&this._tunnels.delete(o))}getTunnelFromMap(o,a){const g=[o];R(o)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):b(o)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const w=g.map(d=>this._tunnels.get(d));for(const d of w){const T=d?.get(a);if(T)return T}}canTunnel(o){return!!k(o)}createWithProvider(o,a,g,w,d,T,r){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${g} on local port ${w}.`);const c=g;this._factoryInProgress.add(c);const n=w===void 0?g:w,u={elevationRequired:d?this.isPortPrivileged(n):!1},l={remoteAddress:{host:a,port:g},localAddressPort:w,privacy:T,public:T?T!==A.Private:void 0,protocol:r},f=o.forwardPort(l,u);return f?(this.addTunnelToMap(a,g,f),f.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(c)})):this._factoryInProgress.delete(c),f}};m=He([$e(0,M.ILogService),$e(1,I.IConfigurationService)],m),e.AbstractTunnelService=m}),define(De[162],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var I;(function(S){S[S.Complete=100]="Complete",S[S.Partial=50]="Partial",S[S.None=0]="None"})(I=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(De[163],Ie([1,0,13]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function I(y){return y.scheme!==i.Schemas.file&&y.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=I;function S(y){if(y.folders.length)return y.folders.every(k=>I(k.uri))?y.folders[0].uri:void 0;if(y.configuration&&I(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=S;function M(y){return S(y)?.scheme}e.getVirtualWorkspaceScheme=M;function D(y){return S(y)?.authority}e.getVirtualWorkspaceAuthority=D;function A(y){return S(y)!==void 0}e.isVirtualWorkspace=A}),define(De[49],Ie([1,0,130,19,46,22,2,3,13]),function(ie,e,i,I,S,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function k(c){const n=c;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function R(c,n){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,I.basename)(c)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const u=c;if(u.configuration)return{id:u.id,configPath:u.configuration};if(u.folders.length===1)return{id:u.id,uri:u.folders[0].uri}}e.toWorkspaceIdentifier=R;function b(c){const n=c;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=b;function p(c){const n=c;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const u=c;if(u?.configPath)return{id:u.id,configPath:D.URI.revive(u.configPath)};if(c?.id)return{id:c.id}}e.reviveIdentifier=p;var E;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function m(c){const n=c;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=m;function t(c){const n=c;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=t;class o{constructor(n,u,l,f,s){this._id=n,this._transient=l,this._configuration=f,this._ignorePathCasing=s,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=u}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class a{constructor(n,u){this.raw=u,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=a;function g(c){return new a({uri:c,index:0,name:(0,M.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(c,n){return M.extUriBiasedIgnorePathCase.isEqualOrParent(c,n.untitledWorkspacesHome)}e.isUntitledWorkspace=w;function d(c){let n;return D.URI.isUri(c)?n=c:n=c.configuration,n?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=d;function T(c,n){return!w(c,n)&&!d(c)}e.isSavedWorkspace=T;function r(c){return(typeof c=="string"?(0,I.extname)(c):(0,M.extname)(c))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(De[63],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const M=this._idPool++;return this._data.set(M,S),this.logDebugInfo(),M}get(S,M){return this._data.has(S)?this._data.get(S)[M]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!i.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=i,i.enableDebugLogging=!1}),define(De[36],Ie([1,0,13,22,3]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this._systemSchemes=new Set(Object.keys(i.Schemas)),this._providerInfo=new Map,this.extUri=new I.ExtUri(A=>{const y=this._providerInfo.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,y)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(De[164],Ie([1,0,15]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(D,A,y){this._deferredPromises=new Map,this._id=D,this._shared=A,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new i.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of k.values())R.complete()}catch(R){for(const b of k.values())b.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(D,A){let y=this._value[D];return typeof y>"u"&&(y=A),y}update(D,A){this._value[D]=A;const y=this._deferredPromises.get(D);if(y!==void 0)return y.p;const k=new i.DeferredPromise;return this._deferredPromises.set(D,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class S extends I{setKeysForSync(D){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},D)}constructor(D,A){super(D.identifier.value,!0,A),this._extension=D}}e.ExtensionGlobalMemento=S}),define(De[165],Ie([1,0,4,2]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class S{constructor(D){this._notebooksAndEditors=D,this._onDidSaveNotebookDocument=new i.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new i.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(D,A,y,k){const b=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(D)).acceptModelChanged(A.value,y,k);this._onDidChangeNotebookDocument.fire(b)}$acceptDirtyStateChanged(D,A){this._notebooksAndEditors.getNotebookDocument(I.URI.revive(D)).acceptDirty(A)}$acceptModelSaved(D){const A=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(D));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=S}),define(De[14],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class I{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=I});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,S){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?S.call(ie,i):S?S.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[166],Ie([1,0,25,4]),function(ie,e,i,I){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(A,y){S.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=i.ExtensionIdentifier.toKey(A.identifier),Ye(this,S,y,"f"),Ae(this,S,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(A){return Ae(this,S,"f").get(this._id,A)}store(A,y){return Ae(this,S,"f").store(this._id,A,y)}delete(A){return Ae(this,S,"f").delete(this._id,A)}}e.ExtensionSecrets=M,S=new WeakMap}),define(De[64],Ie([1,0,3,161,4,14]),function(ie,e,i,I,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var D;(function(y){function k(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?I.TunnelPrivacyId.Public:I.TunnelPrivacyId.Private),protocol:b.protocol}}y.fromApiTunnel=k;function R(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==I.TunnelPrivacyId.ConstantPrivate&&b.privacy!==I.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}y.fromServiceTunnel=R})(D=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let A=class{constructor(k){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,R){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,R){return{dispose:()=>{}}}async $providePortAttributes(k,R,b,p,E){return[]}async $forwardPort(k,R){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=He([$e(0,M.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(De[50],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class I{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=I}),define(De[167],Ie([1,0,24]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(y){let k=this.buffers.indexOf(y);return k<0&&(k=this.buffers.length,this.buffers.push(y)),k}}function S(A,y){if(y.serializeBuffersForPostMessage){const k=new I,R=(E,m)=>{if(m instanceof ArrayBuffer){const t=k.add(m);return{$$vscode_array_buffer_reference$$:!0,index:t}}else if(ArrayBuffer.isView(m)){const t=M(m);if(t){const o=k.add(m.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:t,byteLength:m.byteLength,byteOffset:m.byteOffset}}}}return m},b=JSON.stringify(A,R),p=k.buffers.map(E=>{const m=new Uint8Array(E);return i.VSBuffer.wrap(m)});return{message:b,buffers:p}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=S;function M(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(A,y){const k=y.map(p=>{const E=new ArrayBuffer(p.byteLength);return new Uint8Array(E).set(p.buffer),E}),R=y.length?(p,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const m=E,{index:t}=m,o=k[t];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return E}:void 0;return{message:JSON.parse(A,R),arrayBuffers:k}}e.deserializeWebviewMessage=D}),define(De[91],Ie([1,0,138,9,2,7,3,30,35,13]),function(ie,e,i,I,S,M,D,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var b;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(b=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function p(G){const ee=G;return!!ee&&typeof ee.getSelection=="function"&&!!ee.onDidChangeSelection}e.isEditorPaneWithSelection=p;function E(G,ee,ue){for(const re of ue.visibleEditorPanes)if(re.group.id===ee&&G.matches(re.input))return re.getViewState()}e.findViewStateForEditor=E;function m(G){if(l(G))return!1;const ee=G;return S.URI.isUri(ee?.resource)}e.isResourceEditorInput=m;function t(G){if(l(G))return!1;const ee=G;return ee?.original!==void 0&&ee.modified!==void 0}e.isResourceDiffEditorInput=t;function o(G){if(l(G)||t(G))return!1;const ee=G;return ee?.primary!==void 0&&ee.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function a(G){if(l(G))return!1;const ee=G;return ee?ee.resource===void 0||ee.resource.scheme===k.Schemas.untitled||ee.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;const g=/Untitled-\d+/;function w(G){return G.scheme===k.Schemas.untitled&&G.path.length>1&&!g.test(G.path)}e.isUntitledWithAssociatedResource=w;function d(G){if(l(G))return!1;const ee=G;return S.URI.isUri(ee?.base?.resource)&&S.URI.isUri(ee?.input1?.resource)&&S.URI.isUri(ee?.input2?.resource)&&S.URI.isUri(ee?.result?.resource)}e.isResourceMergeEditorInput=d;var T;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(T=e.Verbosity||(e.Verbosity={}));var r;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.mapIdToSaveSource=new Map}registerSource(ee,ue){let re=this.mapIdToSaveSource.get(ee);return re||(re={source:ee,label:ue},this.mapIdToSaveSource.set(ee,re)),re.source}getSourceLabel(ee){return this.mapIdToSaveSource.get(ee)?.label??ee}}e.SaveSourceRegistry=new c;var n;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors"})(n=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class u extends M.Disposable{}e.AbstractEditorInput=u;function l(G){return G instanceof u}e.isEditorInput=l;function f(G){const ee=G;return S.URI.isUri(ee?.preferredResource)}function s(G){const ee=G;return l(ee?.primary)&&l(ee?.secondary)}e.isSideBySideEditorInput=s;function h(G){const ee=G;return l(ee?.modified)&&l(ee?.original)}e.isDiffEditorInput=h;function v(G){return l(G?.editor)}e.isEditorInputWithOptions=v;function P(G){const ee=G;return v(G)&&ee?.group!==void 0}e.isEditorInputWithOptionsAndGroup=P;function L(G){const ee=G;return typeof ee?.groupId=="number"&&l(ee.editor)}e.isEditorIdentifier=L;var j;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})(j=e.EditorCloseContext||(e.EditorCloseContext={}));var W;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(W=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var V;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(V=e.SideBySideEditor||(e.SideBySideEditor={}));class C{getOriginalUri(ee,ue){if(!ee)return;if(d(ee))return e.EditorResourceAccessor.getOriginalUri(ee.result,ue);if(ue?.supportSideBySide){const{primary:pe,secondary:le}=this.getSideEditors(ee);if(pe&&le){if(ue?.supportSideBySide===V.BOTH)return{primary:this.getOriginalUri(pe,{filterByScheme:ue.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===V.ANY)return this.getOriginalUri(pe,{filterByScheme:ue.filterByScheme})??this.getOriginalUri(le,{filterByScheme:ue.filterByScheme});ee=ue.supportSideBySide===V.PRIMARY?pe:le}}if(t(ee)||o(ee)||d(ee))return;const re=f(ee)?ee.preferredResource:ee.resource;return!re||!ue||!ue.filterByScheme?re:this.filterUri(re,ue.filterByScheme)}getSideEditors(ee){return s(ee)||o(ee)?{primary:ee.primary,secondary:ee.secondary}:h(ee)||t(ee)?{primary:ee.modified,secondary:ee.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ee,ue){if(!ee)return;if(d(ee))return e.EditorResourceAccessor.getCanonicalUri(ee.result,ue);if(ue?.supportSideBySide){const{primary:pe,secondary:le}=this.getSideEditors(ee);if(pe&&le){if(ue?.supportSideBySide===V.BOTH)return{primary:this.getCanonicalUri(pe,{filterByScheme:ue.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===V.ANY)return this.getCanonicalUri(pe,{filterByScheme:ue.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:ue.filterByScheme});ee=ue.supportSideBySide===V.PRIMARY?pe:le}}if(t(ee)||o(ee)||d(ee))return;const re=ee.resource;return!re||!ue||!ue.filterByScheme?re:this.filterUri(re,ue.filterByScheme)}filterUri(ee,ue){if(Array.isArray(ue)){if(ue.some(re=>ee.scheme===re))return ee}else if(ue===ee.scheme)return ee}}e.EditorResourceAccessor=new C;var F;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(F=e.CloseDirection||(e.CloseDirection={}));class O{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(ee){const ue=this.instantiationService=ee.get(D.IInstantiationService);for(const[re,pe]of this.editorSerializerConstructors)this.createEditorSerializer(re,pe,ue);this.editorSerializerConstructors.clear()}createEditorSerializer(ee,ue,re){const pe=re.createInstance(ue);this.editorSerializerInstances.set(ee,pe)}registerFileEditorFactory(ee){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=ee}getFileEditorFactory(){return(0,I.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(ee,ue){if(this.editorSerializerConstructors.has(ee)||this.editorSerializerInstances.has(ee))throw new Error(`A editor serializer with type ID '${ee}' was already registered.`);return this.instantiationService?this.createEditorSerializer(ee,ue,this.instantiationService):this.editorSerializerConstructors.set(ee,ue),(0,M.toDisposable)(()=>{this.editorSerializerConstructors.delete(ee),this.editorSerializerInstances.delete(ee)})}getEditorSerializer(ee){return this.editorSerializerInstances.get(typeof ee=="string"?ee:ee.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new O);async function x(G,ee,ue){return!G||!G.length?[]:await Promise.all(G.map(async re=>{const pe=S.URI.revive(re.fileUri);if(!pe){ue.info("Cannot resolve the path because it is not valid.",re);return}if(!await ee.canHandleResource(pe)){ue.info("Cannot resolve the path because it cannot be handled",re);return}let de=re.exists,Y=re.type;if(typeof de!="boolean"||typeof Y!="number")try{Y=(await ee.stat(pe)).isDirectory?y.FileType.Directory:y.FileType.Unknown,de=!0}catch(Se){ue.error(Se),de=!1}if(!de&&re.openOnlyIfExists){ue.info("Cannot resolve the path because it does not exist",re);return}if(Y===y.FileType.Directory){ue.info("Cannot resolve the path because it is a directory",re);return}const me={...re.options,pinned:!0};return de?{resource:pe,options:me}:{resource:pe,options:me,forceUntitled:!0}}))}e.pathsToEditors=x;var B;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}));function H(G){const ee=G;if(!ee)return!1;const ue=ee;if(ue.modified)return H(ue.modified);const re=ee;return!!(re.contributionsState&&re.viewState&&Array.isArray(re.cursorState))}e.isTextEditorViewState=H}),define(De[65],Ie([1,0,13,2]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function S(A,y){return A.scheme===i.Schemas.http||A.scheme===i.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===i.Schemas.file&&(A=I.URI.from({scheme:i.Schemas.vscodeRemote,authority:y.authority,path:A.path})),I.URI.from({scheme:i.Schemas.https,authority:`${A.scheme}+${M(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=S;function M(A){return A.replace(/./g,y=>{const k=y.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?y:"-"+k.toString(16).padStart(4,"0")})}function D(A){return A.replace(/-([0-9a-f]{4})/g,(y,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=D}),define(De[168],Ie([1,0,4,7,65]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(A,y,k){this._proxy=A,this._editors=y,this._remoteInfo=k,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const R=y.getVisibleTextEditors();for(const b of this._insets.values())R.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,y,k,R,b){let p;for(const w of this._editors.getVisibleTextEditors(!0))if(w.value===A){p=w;break}if(!p)throw new Error("not a visible editor");const E=this,m=this._handlePool++,t=new i.Emitter,o=new i.Emitter,a=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(w){return(0,S.asWebviewUri)(w,E._remoteInfo)}get cspSource(){return S.webviewGenericCspSource}set options(w){this._options=w,E._proxy.$setOptions(m,w)}get options(){return this._options}set html(w){this._html=w,E._proxy.$setHtml(m,w)}get html(){return this._html}get onDidReceiveMessage(){return t.event}postMessage(w){return E._proxy.$postMessage(m,w)}},g=new class{constructor(){this.editor=A,this.line=y,this.height=k,this.webview=a,this.onDidDispose=o.event}dispose(){E._insets.has(m)&&(E._insets.delete(m),E._proxy.$disposeEditorInset(m),o.fire(),o.dispose(),t.dispose())}};return this._proxy.$createEditorInset(m,p.id,p.value.document.uri,y+1,k,R||{},b.identifier,b.extensionLocation),this._insets.set(m,{editor:A,inset:g,onDidReceiveMessage:t}),g}$onDidDispose(A){const y=this._insets.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this._insets.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=M}),define(De[169],Ie([1,0,4,15,139]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new i.Emitter,this._onExit=new i.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,y,k,R){const b={command:A};if(y&&Object.keys(y).length>0&&(b.arguments=y),this.internalSend("request",b),typeof R=="number"){const p=setTimeout(()=>{clearTimeout(p);const E=this.pendingRequests.get(b.seq);if(E){this.pendingRequests.delete(b.seq);const m={type:"response",seq:0,request_seq:b.seq,success:!1,command:A,message:(0,S.localize)(0,null,R,A)};E(m)}},R)}return k&&this.pendingRequests.set(b.seq,k),b.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,y){return A.type!=="event"||y.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,I.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const y=A,k=this.pendingRequests.get(y.request_seq);k&&(this.pendingRequests.delete(y.request_seq),k(y));break}}}}internalSend(A,y){y.type=A,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((y,k)=>A.set(k,y)),await(0,I.timeout)(500),A.forEach((y,k)=>{y({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=M}),define(De[170],Ie([1,0,140,41,3]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new I.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new I.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new I.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new I.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new I.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new I.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new I.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new I.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new I.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new I.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new I.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new I.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new I.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new I.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new I.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new I.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new I.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new I.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new I.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new I.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new I.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new I.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(21,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new I.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new I.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(23,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new I.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(24,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new I.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new I.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new I.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new I.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new I.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new I.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new I.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new I.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new I.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(33,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new I.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(34,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new I.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new I.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new I.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new I.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new I.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new I.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new I.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new I.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new I.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new I.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new I.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new I.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new I.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new I.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new I.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(49,null)});const M=p=>i.localize(50,null,p);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(51,null)};var D;(function(p){p[p.Inactive=0]="Inactive",p[p.Initializing=1]="Initializing",p[p.Stopped=2]="Stopped",p[p.Running=3]="Running"})(D=e.State||(e.State={}));function A(p){switch(p){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(p){p[p.Valid=0]="Valid",p[p.Unreadable=1]="Unreadable",p[p.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(p){p[p.Initial=1]="Initial",p[p.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(p){p.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,S.createDecorator)("debugService");var b;(function(p){p[p.CONDITION=0]="CONDITION",p[p.HIT_COUNT=1]="HIT_COUNT",p[p.LOG_MESSAGE=2]="LOG_MESSAGE"})(b=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[171],Ie([1,0,10,2,19,23,13]),function(ie,e,i,I,S,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(n,u,l){return n.replace(A,function(f,s){return u&&s.length>0&&s[0]!=="_"?f:l&&l.hasOwnProperty(s)?l[s]:f})}e.formatPII=y;function k(n){const u={};for(const l of Object.keys(n))l.startsWith("!")||(u[l]=n[l]);return u}e.filterExceptionsFromTelemetry=k;function R(n){return n.configuration.request==="attach"&&!b(n)&&(!n.parentSession||R(n.parentSession))}e.isSessionAttach=R;function b(n){let u=n.configuration.type;if(!!u)return u==="vslsShare"&&(u=n.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(u,"extensionhost")||(0,i.equalsIgnoreCase)(u,"pwa-extensionhost")?n:n.parentSession?b(n.parentSession):void 0}e.getExtensionHostDebugSession=b;function p(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=p;function E(n,u,l){let f,s=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let v=null;for(;v=h.exec(n);){const P=v.index+1,L=P+v[0].length;if(P<=u&&L>=l){f=v[0],s=P;break}}if(f){const P=/\w+/g;let L=null;for(;(L=P.exec(f))&&!(L.index+1+s+L[0].length>=l););L&&(f=f.substring(0,P.lastIndex))}return f?{start:s,end:s+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=E;const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(n){return!!(n&&n.match(m))}e.isUri=t;function o(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(t(n.path))return I.URI.parse(n.path);if((0,S.isAbsolute)(n.path))return I.URI.file(n.path)}return n.path}function a(n){if(typeof n.path=="object"){const u=I.URI.revive(n.path);if(u)return u.scheme===D.Schemas.file?u.fsPath:u.toString()}return n.path}function g(n,u){const l=u?o:a,f=(0,M.deepClone)(n);return d(f,(s,h)=>{s&&h&&(h.path=l(h))}),f}e.convertToDAPaths=g;function w(n,u){const l=u?o:a,f=(0,M.deepClone)(n);return d(f,(s,h)=>{!s&&h&&(h.path=l(h))}),f}e.convertToVSCPaths=w;function d(n,u){switch(n.type){case"event":{const l=n;switch(l.event){case"output":u(!1,l.body.source);break;case"loadedSource":u(!1,l.body.source);break;case"breakpoint":u(!1,l.body.breakpoint.source);break;default:break}break}case"request":{const l=n;switch(l.command){case"setBreakpoints":u(!0,l.arguments.source);break;case"breakpointLocations":u(!0,l.arguments.source);break;case"source":u(!0,l.arguments.source);break;case"gotoTargets":u(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(f=>u(!1,f));break;default:break}break}case"response":{const l=n;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(f=>u(!1,f.source));break;case"loadedSources":l.body.sources.forEach(f=>u(!1,f));break;case"scopes":l.body.scopes.forEach(f=>u(!1,f.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(f=>u(!1,f.source));break;case"setBreakpoints":l.body.breakpoints.forEach(f=>u(!1,f.source));break;case"disassemble":l.body?.instructions.forEach(s=>u(!1,s.location));break;default:break}break}}}function T(n){return n.filter(u=>!u.presentation?.hidden).sort((u,l)=>u.presentation?l.presentation?u.presentation.group?l.presentation.group?u.presentation.group!==l.presentation.group?u.presentation.group.localeCompare(l.presentation.group):r(u.presentation.order,l.presentation.order):-1:l.presentation.group?1:r(u.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=T;function r(n,u){return typeof n!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:n-u}async function c(n,u){const l=n.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(l!=="none"&&(await u.saveAll(),l==="allEditorsInActiveGroup")){const f=u.activeEditorPane;f&&f.input.resource?.scheme===D.Schemas.untitled&&await u.save({editor:f.input,groupId:f.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=c}),define(De[66],Ie([1,0,24,34,172,79,13,19,21,41]),function(ie,e,i,I,S,M,D,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var b;(function(x){x[x.Running=1]="Running",x[x.Idle=2]="Idle"})(b=e.NotebookRunState||(e.NotebookRunState={}));var p;(function(x){x[x.Unconfirmed=1]="Unconfirmed",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(p=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function(x){x[x.WithHardKernelDependency=0]="WithHardKernelDependency",x[x.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",x[x.Pure=2]="Pure",x[x.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(x){x.Always="always",x.Never="never",x.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var t;(function(x){x[x.ModelChange=1]="ModelChange",x[x.Move=2]="Move",x[x.ChangeCellLanguage=5]="ChangeCellLanguage",x[x.Initialize=6]="Initialize",x[x.ChangeCellMetadata=7]="ChangeCellMetadata",x[x.Output=8]="Output",x[x.OutputItem=9]="OutputItem",x[x.ChangeCellContent=10]="ChangeCellContent",x[x.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",x[x.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",x[x.ChangeCellMime=13]="ChangeCellMime",x[x.Unknown=100]="Unknown"})(t=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(x){x[x.Handle=0]="Handle",x[x.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var a;(function(x){x[x.Replace=1]="Replace",x[x.Output=2]="Output",x[x.Metadata=3]="Metadata",x[x.CellLanguage=4]="CellLanguage",x[x.DocumentMetadata=5]="DocumentMetadata",x[x.Move=6]="Move",x[x.OutputItems=7]="OutputItems",x[x.PartialMetadata=8]="PartialMetadata",x[x.PartialInternalMetadata=9]="PartialInternalMetadata"})(a=e.CellEditType||(e.CellEditType={}));var g;(function(x){x.scheme=D.Schemas.vscodeNotebookCell;const B=["W","X","Y","Z","a","b","c","d","e","f"],H=new RegExp(`^[${B.join("")}]+`),G=7;function ee(Y,me){const Se=me.toString(G),Be=`${Se.length<B.length?B[Se.length-1]:"z"}${Se}s${(0,i.encodeBase64)(i.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:x.scheme,fragment:Be})}x.generate=ee;function ue(Y){if(Y.scheme!==x.scheme)return;const me=Y.fragment.indexOf("s");if(me<0)return;const Se=parseInt(Y.fragment.substring(0,me).replace(H,""),G),Oe=(0,i.decodeBase64)(Y.fragment.substring(me+1)).toString();if(!isNaN(Se))return{handle:Se,notebook:Y.with({scheme:Oe,fragment:null})}}x.parse=ue;function re(Y,me){return Y.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${me??""},${Y.scheme!==D.Schemas.file?Y.scheme:""}`})}x.generateCellOutputUri=re;function pe(Y){if(Y.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const me=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!me)return;const Se=me[1]&&me[1]!==""?me[1]:void 0,Oe=me[2];return{outputId:Se,notebook:Y.with({scheme:Oe||D.Schemas.file,fragment:null})}}x.parseCellOutputUri=pe;function le(Y,me,Se){return x.generate(Y,me).with({scheme:Se})}x.generateCellPropertyUri=le;function de(Y,me){if(Y.scheme===me)return x.parse(Y.with({scheme:x.scheme}))}x.parseCellPropertyUri=de})(g=e.CellUri||(e.CellUri={}));const w=x=>y.isWindows?x.replace(/\//g,"\\"):x;class d{constructor(B=[],H=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=H,this.order=[...new Set(B)].map(G=>({pattern:G,matches:I.parse(w(G))}))}sort(B){const H=new Map(S.Iterable.map(B,ee=>[ee,w(ee)]));let G=[];for(const{matches:ee}of this.order)for(const[ue,re]of H)if(ee(re)){G.push(ue),H.delete(ue);break}return H.size&&(G=G.concat([...H.keys()].sort((ee,ue)=>this.defaultOrder.indexOf(ee)-this.defaultOrder.indexOf(ue)))),G}prioritize(B,H){const G=this.findIndex(B);if(G===-1){this.order.unshift({pattern:B,matches:I.parse(w(B))});return}const ee=new Set(H.map(re=>this.findIndex(re,G)));ee.delete(-1);const ue=Array.from(ee).sort();this.order.splice(G+1,0,...ue.map(re=>this.order[re]));for(let re=ue.length-1;re>=0;re--)this.order.splice(ue[re],1)}toArray(){return this.order.map(B=>B.pattern)}findIndex(B,H=this.order.length){const G=w(B);for(let ee=0;ee<H;ee++)if(this.order[ee].matches(G))return ee;return-1}}e.MimeTypeDisplayOrder=d;function T(x,B,H,G=(ee,ue)=>ee===ue){const ee=[];function ue(le,de,Y){if(de===0&&Y.length===0)return;const me=ee[ee.length-1];me&&me.start+me.deleteCount===le?(me.deleteCount+=de,me.toInsert.push(...Y)):ee.push({start:le,deleteCount:de,toInsert:Y})}let re=0,pe=0;for(;;){if(re===x.length){ue(re,0,B.slice(pe));break}if(pe===B.length){ue(re,x.length-re,[]);break}const le=x[re],de=B[pe];if(G(le,de)){re+=1,pe+=1;continue}H(de)?(ue(re,1,[]),re+=1):(ue(re,0,[de]),pe+=1)}return ee}e.diff=T,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(x){x.default="default",x.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(x){const B=x;return!!((typeof B.include=="string"||I.isRelativePattern(B.include))&&(typeof B.exclude=="string"||I.isRelativePattern(B.exclude)))}e.isDocumentExcludePattern=c;function n(x,B,H){if(Array.isArray(x.viewType)&&x.viewType.indexOf(B)>=0||x.viewType===B)return!0;if(x.filenamePattern){const G=c(x.filenamePattern)?x.filenamePattern.include:x.filenamePattern,ee=c(x.filenamePattern)?x.filenamePattern.exclude:void 0;if(I.match(G,(0,A.basename)(H.fsPath).toLowerCase()))return!(ee&&I.match(ee,(0,A.basename)(H.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var u;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class l{static create(B){return`${l._prefix}${B}`}static parse(B){if(B.startsWith(l._prefix))return B.substring(l._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=l,l._prefix="notebook/";function f(x){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(x)}e.isTextStreamMime=f;const s=new TextDecoder;function h(x){const B=[];let H=!1;for(const G of x)(B.length===0||H)&&(B.push(G),H=!0);return j(B),O(i.VSBuffer.concat(B.map(G=>i.VSBuffer.wrap(G))))}e.compressOutputItemStreams=h;const v=`${String.fromCharCode(27)}[A`,P=v.split("").map(x=>x.charCodeAt(0)),L=10;function j(x){x.forEach((B,H)=>{if(H===0||B.length<v.length)return;const G=x[H-1],ee=B.subarray(0,v.length);if(ee[0]===P[0]&&ee[1]===P[1]&&ee[2]===P[2]){const ue=G.lastIndexOf(L);if(ue===-1)return;x[H-1]=G.subarray(0,ue),x[H]=B.subarray(v.length)}})}function W(x){let B=x;do x=B,B=x.replace(/[^\n]\x08/gm,"");while(B.length<x.length);return x}function V(x){for(x=x.replace(/\r+\n/gm,`
`);x.search(/\r[^$]/g)>-1;){const B=x.match(/^(.*)\r+/m)[1];let H=x.match(/\r+(.*)$/m)[1];H=H+B.slice(H.length,B.length),x=x.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,H)}return x}const C="\b".charCodeAt(0),F="\r".charCodeAt(0);function O(x){return!x.buffer.includes(C)&&!x.buffer.includes(F)?x:i.VSBuffer.fromString(V(W(s.decode(x.buffer))))}}),define(De[173],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var I;(function(S){S[S.Output=1]="Output",S[S.OutputItems=2]="OutputItems",S[S.ExecutionState=3]="ExecutionState"})(I=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(De[174],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=i;function I(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=I;function S(D){return Array.from(D.entries()).map(A=>[A[0],i(A[1].map)])}e.serializeEnvironmentVariableCollections=S;function M(D){return new Map(D.map(A=>[A[0],{map:I(A[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(De[42],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(M){M.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var I;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(I=e.TestPosition||(e.TestPosition={}));class S{static fromExtHostTestItem(D,A,y=D.parent){if(D._isRoot)return new S([A]);const k=[D.id];for(let R=y;R&&R.id!==A;R=R.parent)k.push(R.id);return k.push(A),new S(k.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const A=D.indexOf("\0");return A===-1?D:D.slice(0,A)}static fromString(D){return new S(D.split("\0"))}static join(D,A){return new S([...D.path,A])}static joinToString(D,A){return D.toString()+"\0"+A}static parentId(D){const A=D.lastIndexOf("\0");return A===-1?void 0:D.slice(0,A)}static compare(D,A){return D===A?0:A.startsWith(D+"\0")?2:D.startsWith(A+"\0")?3:1}constructor(D,A=D.length){if(this.path=D,this.viewEnd=A,D.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new S(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let D=1;D<=this.viewEnd;D++)yield new S(this.path,D)}*idsToRoot(){for(let D=this.viewEnd;D>0;D--)yield new S(this.path,D)}compare(D){if(typeof D=="string")return S.compare(this.toString(),D);for(let A=0;A<D.viewEnd&&A<this.viewEnd;A++)if(D.path[A]!==this.path[A])return 1;return D.viewEnd>this.viewEnd?2:D.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let D=1;D<this.viewEnd;D++)this.stringifed+="\0",this.stringifed+=this.path[D]}return this.stringifed}}e.TestId=S}),define(De[51],Ie([1,0,2,52,42]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var D;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(D=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var A;(function(s){s.serialize=h=>({range:h.range.toJSON(),uri:h.uri.toJSON()}),s.deserialize=h=>({range:I.Range.lift(h.range),uri:i.URI.revive(h.uri)})})(A=e.IRichLocation||(e.IRichLocation={}));var y;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(y=e.TestMessageType||(e.TestMessageType={}));var k;(function(s){s.serialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,location:h.location&&A.serialize(h.location)}),s.deserialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,location:h.location&&A.deserialize(h.location)})})(k=e.ITestErrorMessage||(e.ITestErrorMessage={}));const R=(s,h)=>`${h?"s":"e"}${s}`;e.getMarkId=R;var b;(function(s){s.serialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&A.serialize(h.location)}),s.deserialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&A.deserialize(h.location)})})(b=e.ITestOutputMessage||(e.ITestOutputMessage={}));var p;(function(s){s.serialize=h=>h.type===0?k.serialize(h):b.serialize(h),s.deserialize=h=>h.type===0?k.deserialize(h):b.deserialize(h)})(p=e.ITestMessage||(e.ITestMessage={}));var E;(function(s){s.serializeWithoutMessages=h=>({state:h.state,duration:h.duration,messages:[]}),s.serialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(p.serialize)}),s.deserialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(p.deserialize)})})(E=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",t=(s,h)=>s+m+h;e.namespaceTestTag=t;const o=s=>{const h=s.indexOf(m);return{ctrlId:s.slice(0,h),tagId:s.slice(h+1)}};e.denamespaceTestTag=o;var a;(function(s){s.serialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?.toJSON(),range:h.range?.toJSON()||null,description:h.description,error:h.error,sortText:h.sortText}),s.deserialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?i.URI.revive(h.uri):void 0,range:h.range?I.Range.lift(h.range):null,description:h.description,error:h.error,sortText:h.sortText})})(a=e.ITestItem||(e.ITestItem={}));var g;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(g=e.TestItemExpandState||(e.TestItemExpandState={}));var w;(function(s){s.serialize=h=>({expand:h.expand,item:a.serialize(h.item)}),s.deserialize=h=>({controllerId:S.TestId.root(h.item.extId),expand:h.expand,item:a.deserialize(h.item)})})(w=e.InternalTestItem||(e.InternalTestItem={}));var d;(function(s){s.serialize=h=>{let v;return h.item&&(v={},h.item.label!==void 0&&(v.label=h.item.label),h.item.tags!==void 0&&(v.tags=h.item.tags),h.item.busy!==void 0&&(v.busy=h.item.busy),h.item.uri!==void 0&&(v.uri=h.item.uri?.toJSON()),h.item.range!==void 0&&(v.range=h.item.range?.toJSON()),h.item.description!==void 0&&(v.description=h.item.description),h.item.error!==void 0&&(v.error=h.item.error),h.item.sortText!==void 0&&(v.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:v}},s.deserialize=h=>{let v;return h.item&&(v={},h.item.label!==void 0&&(v.label=h.item.label),h.item.tags!==void 0&&(v.tags=h.item.tags),h.item.busy!==void 0&&(v.busy=h.item.busy),h.item.range!==void 0&&(v.range=h.item.range?I.Range.lift(h.item.range):null),h.item.description!==void 0&&(v.description=h.item.description),h.item.error!==void 0&&(v.error=h.item.error),h.item.sortText!==void 0&&(v.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:v}}})(d=e.ITestItemUpdate||(e.ITestItemUpdate={}));const T=(s,h)=>{h.expand!==void 0&&(s.expand=h.expand),h.item!==void 0&&(s.item=s.item?Object.assign(s.item,h.item):h.item)};e.applyTestItemUpdate=T;var r;(function(s){s.serializeWithoutMessages=h=>({...w.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(E.serializeWithoutMessages),retired:h.retired}),s.serialize=h=>({...w.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(E.serialize),retired:h.retired}),s.deserialize=h=>({...w.deserialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(E.deserialize),retired:!0})})(r=e.TestResultItem||(e.TestResultItem={}));var c;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(c=e.DetailType||(e.DetailType={}));var n;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.DocumentSynced=2]="DocumentSynced",s[s.Remove=3]="Remove",s[s.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",s[s.Retire=5]="Retire",s[s.AddTag=6]="AddTag",s[s.RemoveTag=7]="RemoveTag"})(n=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(s){s.deserialize=h=>h.op===0?{op:h.op,item:w.deserialize(h.item)}:h.op===1?{op:h.op,item:d.deserialize(h.item)}:h.op===2?{op:h.op,uri:i.URI.revive(h.uri),docv:h.docv}:h,s.serialize=h=>h.op===0?{op:h.op,item:w.serialize(h.item)}:h.op===1?{op:h.op,item:d.serialize(h.item)}:h})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class l{add(h){}update(h){}remove(h,v){}complete(){}}e.IncrementalChangeCollector=l;class f{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(h){const v=this.createChangeCollector();for(const P of h)switch(P.op){case 0:{const L=w.deserialize(P.item),j=S.TestId.parentId(L.item.extId)?.toString();if(j){if(this.items.has(j)){const W=this.items.get(j);W.children.add(L.item.extId);const V=this.createItem(L,W);this.items.set(L.item.extId,V),v.add(V)}}else{const W=this.createItem(L);this.roots.add(W),this.items.set(L.item.extId,W),v.add(W)}L.expand===2&&this.busyControllerCount++;break}case 1:{const L=d.deserialize(P.item),j=this.items.get(L.extId);if(!j)break;L.expand!==void 0&&(j.expand===2&&this.busyControllerCount--,L.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(j,L),v.update(j);break}case 3:{const L=this.items.get(P.itemId);if(!L)break;const j=S.TestId.parentId(L.item.extId)?.toString();j?this.items.get(j).children.delete(L.item.extId):this.roots.delete(L);const W=[[P.itemId]];for(;W.length;)for(const V of W.pop()){const C=this.items.get(V);C&&(W.push(C.children),this.items.delete(V),v.remove(C,C!==L),C.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(P.itemId);break;case 4:this.updatePendingRoots(P.amount);break;case 6:this._tags.set(P.tag.id,P.tag);break;case 7:this._tags.delete(P.id);break}v.complete()}retireTest(h){}updatePendingRoots(h){this.pendingRootCount+=h}createChangeCollector(){return new l}}e.AbstractIncrementalTestCollection=f}),define(De[67],Ie([1,0,15,4,7,47,51,42]),function(ie,e,i,I,S,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(a,g)=>a===g,R={range:(a,g)=>a===g?!0:!a||!g?!1:a.equalsRange(g),busy:k,label:k,description:k,error:k,tags:(a,g)=>!(a.length!==g.length||a.some(w=>!g.includes(w)))},b=(a,g)=>{let w;for(const[d,T]of Object.entries(R))T(a[d],g[d])||(w?w[d]=g[d]:w={[d]:g[d]});return w};class p extends S.Disposable{get root(){return this.options.root}constructor(g){super(),this.options=g,this.debounceSendDiff=this._register(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new I.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(g){this._resolveHandler=g;for(const w of this.tree.values())this.updateExpandability(w)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){switch(g.op){case 2:{for(const w of this.diff)if(w.op===2&&w.uri===g.uri){w.docv=g.docv;return}break}case 1:{const w=this.diff[this.diff.length-1];if(w){if(w.op===1&&w.item.extId===g.item.extId){(0,D.applyTestItemUpdate)(w.item,g.item);return}if(w.op===0&&w.item.item.extId===g.item.extId){(0,D.applyTestItemUpdate)(w.item,g.item);return}}break}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,w){const d=this.tree.get(g);if(!!d){if((d.expandLevels===void 0||w>d.expandLevels)&&(d.expandLevels=w),d.expand===1){const T=this.resolveChildren(d);return T.isOpen()?this.expandChildren(d,w-1):T.wait().then(()=>this.expandChildren(d,w-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,w-1)):this.expandChildren(d,w-1)}}dispose(){for(const g of this.tree.values())this.options.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,w){switch(w.op){case 3:this.removeItem(A.TestId.joinToString(g.fullId,w.id));break;case 0:this.upsertItem(w.item,g);break;case 5:for(const d of w.ops)this.onTestItemEvent(g,d);break;case 1:this.diffTagRefs(w.new,w.old,g.fullId.toString());break;case 2:this.updateExpandability(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:w.update}});break;case 6:this.documentSynced(g.actual.uri);break;default:(0,M.assertNever)(w)}}documentSynced(g){g&&this.pushDiff({op:2,uri:g,docv:this.options.getDocumentVersion(g)})}upsertItem(g,w){const d=A.TestId.fromExtHostTestItem(g,this.root.id,w?.actual),T=this.options.getApiFor(g);T.parent&&T.parent!==w?.actual&&this.options.getChildren(T.parent).delete(g.id);let r=this.tree.get(d.toString());if(!r){r={fullId:d,actual:g,expandLevels:w?.expandLevels?w.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(g,w),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(g)}}),this.connectItemAndChildren(g,r,w);return}if(r.actual===g){this.connectItem(g,r,w);return}const c=this.options.getChildren(r.actual),n=r.actual,u=b(this.options.toITestItem(n),this.options.toITestItem(g));this.options.getApiFor(n).listener=void 0,r.actual=g,r.expand=0,u&&(u.hasOwnProperty("tags")&&(this.diffTagRefs(g.tags,n.tags,d.toString()),delete u.tags),this.onTestItemEvent(r,{op:4,update:u})),this.connectItemAndChildren(g,r,w);for(const[l,f]of c)this.options.getChildren(g).get(f.id)||this.removeItem(A.TestId.joinToString(d,f.id));this.documentSynced(r.actual.uri)}diffTagRefs(g,w,d){const T=new Set(w.map(r=>r.id));for(const r of g)T.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:1,item:{extId:d,item:{tags:g.map(r=>(0,D.namespaceTestTag)(this.options.controllerId,r.id))}}}),T.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const w=this.tags.get(g.id);w?w.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,D.namespaceTestTag)(this.options.controllerId,g.id)}}))}decrementTagRefs(g){const w=this.tags.get(g);w&&!--w.refCount&&(this.tags.delete(g),this.pushDiff({op:7,id:(0,D.namespaceTestTag)(this.options.controllerId,g)}))}setItemParent(g,w){this.options.getApiFor(g).parent=w&&w.actual!==this.root?w.actual:void 0}connectItem(g,w,d){this.setItemParent(g,d);const T=this.options.getApiFor(g);T.parent=d?.actual,T.listener=r=>this.onTestItemEvent(w,r),this.updateExpandability(w)}connectItemAndChildren(g,w,d){this.connectItem(g,w,d);for(const[T,r]of this.options.getChildren(g))this.upsertItem(r,w)}updateExpandability(g){let w;this._resolveHandler?g.resolveBarrier?w=g.resolveBarrier.isOpen()?3:2:w=g.actual.canResolveChildren?1:0:w=0,w!==g.expand&&(g.expand=w,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:w}}),w===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,w){if(w<0)return;const d=[];for(const[T,r]of this.options.getChildren(g.actual)){const c=this.expand(A.TestId.joinToString(g.fullId,r.id),w);(0,i.isThenable)(c)&&d.push(c)}if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const r=new i.Barrier;return r.open(),r}g.expand=2,this.pushExpandStateUpdate(g);const w=g.resolveBarrier=new i.Barrier,d=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let T;try{T=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(r){d(r)}return(0,i.isThenable)(T)?T.catch(d).then(()=>{w.open(),this.updateExpandability(g)}):(w.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const w=this.tree.get(g);if(!w)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const d=[w];for(;d.length;){const T=d.pop();if(!!T){this.options.getApiFor(T.actual).listener=void 0;for(const r of T.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(T.fullId.toString());for(const[r,c]of this.options.getChildren(T.actual))d.push(this.tree.get(A.TestId.joinToString(T.fullId,c.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.TestItemCollection=p;class E extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=E;class m extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class t extends Error{constructor(g,w,d){super(`TestItem with ID "${g}" is from controller "${w}" and cannot be added as a child of an item from controller "${d}".`)}}e.MixedTestItemController=t;const o=(a,g,w)=>{let d=new Map;return{get size(){return d.size},forEach(T,r){for(const c of d.values())T.call(r,c,this)},[Symbol.iterator](){return d.entries()},replace(T){const r=new Map,c=new Set(d.keys()),n={op:5,ops:[]};for(const u of T){if(!(u instanceof w))throw new m(u.id);const l=g(u).controllerId;if(l!==a.controllerId)throw new t(u.id,l,a.controllerId);if(r.has(u.id))throw new E(u.id);r.set(u.id,u),c.delete(u.id),n.ops.push({op:0,item:u})}for(const u of c.keys())n.ops.push({op:3,id:u});a.listener?.(n),d=r},add(T){if(!(T instanceof w))throw new m(T.id);d.set(T.id,T),a.listener?.({op:0,item:T})},delete(T){d.delete(T)&&a.listener?.({op:3,id:T})},get(T){return d.get(T)},toJSON(){return Array.from(d.values())}}};e.createTestItemChildren=o}),define(De[92],Ie([1,0,67]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const I=new WeakMap,S=(D,A)=>{const y={controllerId:A};return I.set(D,y),y};e.createPrivateApiFor=S;const M=D=>{const A=I.get(D);if(!A)throw new i.InvalidTestItemError(D?.id||"<unknown>");return A};e.getPrivateApiFor=M}),define(De[175],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var I;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(I=e.VariableKind||(e.VariableKind={}));class S extends Error{constructor(D,A){super(A),this.variable=D}}e.VariableError=S}),define(De[176],Ie([1,0,19,48,9,23,21,82,143,175,10]),function(ie,e,i,I,S,M,D,A,y,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class b{constructor(E,m,t,o){this._contributedVariables=new Map,this._context=E,this._labelService=m,this._userHomePromise=t,o&&(this._envVariablesPromise=o.then(a=>this.prepareEnv(a)))}prepareEnv(E){if(D.isWindows){const m=Object.create(null);return Object.keys(E).forEach(t=>{m[t.toLowerCase()]=E[t]}),m}return E}resolveWithEnvironment(E,m,t){return this.recursiveResolve({env:this.prepareEnv(E),userHome:void 0},m?m.uri:void 0,t)}async resolveAsync(E,m){const t={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(t,E?E.uri:void 0,m)}async resolveAnyBase(E,m,t,o){const a=M.deepClone(m);D.isWindows&&a.windows?Object.keys(a.windows).forEach(w=>a[w]=a.windows[w]):D.isMacintosh&&a.osx?Object.keys(a.osx).forEach(w=>a[w]=a.osx[w]):D.isLinux&&a.linux&&Object.keys(a.linux).forEach(w=>a[w]=a.linux[w]),delete a.windows,delete a.osx,delete a.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,E?E.uri:void 0,a,t,o)}async resolveAnyAsync(E,m,t){return this.resolveAnyBase(E,m,t)}async resolveAnyMap(E,m,t){const o=new Map;return{newConfig:await this.resolveAnyBase(E,m,t,o),resolvedVariables:o}}resolveWithInteractionReplace(E,m,t,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,m,t,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,m){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,m)}async recursiveResolve(E,m,t,o,a){if(S.isString(t))return this.resolveString(E,m,t,o,a);if(Array.isArray(t))return Promise.all(t.map(g=>this.recursiveResolve(E,m,g,o,a)));if(S.isObject(t)){const g=Object.create(null),w=await Promise.all(Object.keys(t).map(async d=>[await this.resolveString(E,m,d,o,a),await this.recursiveResolve(E,m,t[d],o,a)]));for(const[d,T]of w)g[d]=T;return g}return t}resolveString(E,m,t,o,a){return(0,R.replaceAsync)(t,b.VARIABLE_REGEXP,async(g,w)=>{if(w.includes(b.VARIABLE_LHS))return g;let d=await this.evaluateSingleVariable(E,g,w,m,o);return a?.set(w,d),d!==g&&S.isString(d)&&d.match(b.VARIABLE_REGEXP)&&(d=await this.resolveString(E,m,d,o,a)),d})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}async evaluateSingleVariable(E,m,t,o,a){let g;const w=t.split(":");w.length>1&&(t=w[0],g=w[1]);const d=c=>{const n=this._context.getFilePath();if(n)return n;throw new k.VariableError(c,(0,y.localize)(0,null,m))},T=c=>{const n=d(c);if(this._context.getWorkspaceFolderPathForFile){const u=this._context.getWorkspaceFolderPathForFile();if(u)return u}throw new k.VariableError(c,(0,y.localize)(1,null,m,i.basename(n)))},r=c=>{if(g){const n=this._context.getFolderUri(g);if(n)return n;throw new k.VariableError(c,(0,y.localize)(2,null,m,g))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new k.VariableError(c,(0,y.localize)(3,null,m)):new k.VariableError(c,(0,y.localize)(4,null,m))};switch(t){case"env":if(g){if(E.env){const c=E.env[D.isWindows?g.toLowerCase():g];if(S.isString(c))return c}return""}throw new k.VariableError(k.VariableKind.Env,(0,y.localize)(5,null,m));case"config":if(g){const c=this._context.getConfigurationValue(o,g);if(S.isUndefinedOrNull(c))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(6,null,m,g));if(S.isObject(c))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(7,null,m,g));return c}throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(8,null,m));case"command":return this.resolveFromMap(k.VariableKind.Command,m,g,a,"command");case"input":return this.resolveFromMap(k.VariableKind.Input,m,g,a,"input");case"extensionInstallFolder":if(g){const c=await this._context.getExtension(g);if(!c)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,m,g));return this.fsPath(c.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,m));default:switch(t){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(r(k.VariableKind.WorkspaceFolder)));case"cwd":return o||g?(0,A.normalizeDriveLetter)(this.fsPath(r(k.VariableKind.Cwd))):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return i.basename(this.fsPath(r(k.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(E.userHome)return E.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,y.localize)(11,null,m))}case"lineNumber":{const c=this._context.getLineNumber();if(c)return c;throw new k.VariableError(k.VariableKind.LineNumber,(0,y.localize)(12,null,m))}case"selectedText":{const c=this._context.getSelectedText();if(c)return c;throw new k.VariableError(k.VariableKind.SelectedText,(0,y.localize)(13,null,m))}case"file":return d(k.VariableKind.File);case"fileWorkspaceFolder":return T(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||g?i.relative(this.fsPath(r(k.VariableKind.RelativeFile)),d(k.VariableKind.RelativeFile)):d(k.VariableKind.RelativeFile);case"relativeFileDirname":{const c=i.dirname(d(k.VariableKind.RelativeFileDirname));if(o||g){const n=i.relative(this.fsPath(r(k.VariableKind.RelativeFileDirname)),c);return n.length===0?".":n}return c}case"fileDirname":return i.dirname(d(k.VariableKind.FileDirname));case"fileExtname":return i.extname(d(k.VariableKind.FileExtname));case"fileBasename":return i.basename(d(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const c=i.basename(d(k.VariableKind.FileBasenameNoExtension));return c.slice(0,c.length-i.extname(c).length)}case"fileDirnameBasename":return i.basename(i.dirname(d(k.VariableKind.FileDirnameBasename)));case"execPath":{const c=this._context.getExecPath();return c||m}case"execInstallFolder":{const c=this._context.getAppRoot();return c||m}case"pathSeparator":return i.sep;default:try{const c=g?`${t}:${g}`:t;return this.resolveFromMap(k.VariableKind.Unknown,m,c,a,void 0)}catch{return m}}}}resolveFromMap(E,m,t,o,a){if(t&&o){const g=a===void 0?o[t]:o[a+":"+t];if(typeof g=="string")return g;throw new k.VariableError(E,(0,y.localize)(14,null,m))}return m}}e.AbstractVariableResolverService=b,b.VARIABLE_LHS="${",b.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[93],Ie([1,0,3,91]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var S;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var M;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var A;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function k(m){const t=m;return(0,I.isEditorInput)(t?.editor)&&(0,I.isEditorInput)(t?.replacement)}e.isEditorReplacement=k;var R;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var b;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(b=e.OpenEditorContext||(e.OpenEditorContext={}));function p(m){const t=m;return!!t&&typeof t.id=="number"&&Array.isArray(t.editors)}e.isEditorGroup=p;function E(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(De[177],Ie([1,0,3,93]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(M){const D=M;return typeof M=="number"||(0,I.isEditorGroup)(D)}e.isPreferredGroup=S}),define(De[178],Ie([1,0,3,148]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(I.IEnvironmentService)}),define(De[179],Ie([1,0,25,4,19]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(b){this.removedDueToLooping=b}}e.DeltaExtensionsResult=M;class D{constructor(b){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=b,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const b of this._extensionDescriptions){if(this._extensionsMap.has(i.ExtensionIdentifier.toKey(b.identifier))){console.error("Extension `"+b.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(i.ExtensionIdentifier.toKey(b.identifier),b),this._extensionsArr.push(b),Array.isArray(b.activationEvents))for(let p of b.activationEvents)p==="onUri"&&(p=`onUri:${i.ExtensionIdentifier.toKey(b.identifier)}`),this._activationMap.has(p)||this._activationMap.set(p,[]),this._activationMap.get(p).push(b)}}set(b){this._extensionDescriptions=b,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(b,p){this._extensionDescriptions=k(this._extensionDescriptions,p),this._extensionDescriptions=this._extensionDescriptions.concat(b);const E=D._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=k(this._extensionDescriptions,E.map(m=>m.identifier)),this._initialize(),this._onDidChange.fire(void 0),new M(E)}static _findLoopingExtensions(b){const p=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(a){this._nodesSet.has(a)||(this._nodesSet.add(a),this._nodesArr.push(a))}addArc(a,g){this.addNode(a),this.addNode(g),this._arcs.has(a)?this._arcs.get(a).push(g):this._arcs.set(a,[g])}getArcs(a){return this._arcs.has(a)?this._arcs.get(a):[]}hasOnlyGoodArcs(a,g){const w=p.getArcs(a);for(let d=0;d<w.length;d++)if(!g.has(w[d]))return!1;return!0}getNodes(){return this._nodesArr}},E=new Map;for(const a of b){const g=i.ExtensionIdentifier.toKey(a.identifier);if(E.set(g,a),a.extensionDependencies)for(const w of a.extensionDependencies){const d=i.ExtensionIdentifier.toKey(w);p.addArc(g,d)}}const m=new Set;p.getNodes().filter(a=>p.getArcs(a).length===0).forEach(a=>m.add(a));const t=p.getNodes().filter(a=>!m.has(a));let o;do{o=!1;for(let a=0;a<t.length;a++){const g=t[a];p.hasOnlyGoodArcs(g,m)&&(t.splice(a,1),a--,m.add(g),o=!0)}}while(o);return t.map(a=>E.get(a))}containsActivationEvent(b){return this._activationMap.has(b)}containsExtension(b){return this._extensionsMap.has(i.ExtensionIdentifier.toKey(b))}getExtensionDescriptionsForActivationEvent(b){const p=this._activationMap.get(b);return p?p.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(b){const p=this._extensionsMap.get(i.ExtensionIdentifier.toKey(b));return p||void 0}getExtensionDescriptionByUUID(b){for(const p of this._extensionsArr)if(p.uuid===b)return p}getExtensionDescriptionByIdOrUUID(b,p){return this.getExtensionDescription(b)??(p?this.getExtensionDescriptionByUUID(p):void 0)}}e.ExtensionDescriptionRegistry=D;var A;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(A||(A={}));function y(R,b){const p=R.isBuiltin?0:R.isUnderDevelopment?2:1,E=b.isBuiltin?0:b.isUnderDevelopment?2:1;if(p!==E)return p-E;const m=S.posix.basename(R.extensionLocation.path),t=S.posix.basename(b.extensionLocation.path);return m<t?-1:m>t?1:0}function k(R,b){const p=new Set;return b.forEach(E=>p.add(i.ExtensionIdentifier.toKey(E))),R.filter(E=>!p.has(i.ExtensionIdentifier.toKey(E.identifier)))}}),define(De[68],Ie([1,0,24]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var I;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var S;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(S=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function D(k){const R=i.VSBuffer.alloc(1);switch(k){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=D;function A(k,R){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=A;var y;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[69],Ie([1,0,3,4,11,26,68,61,158,23,2]),function(ie,e,i,I,S,M,D,A,y,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let b=class{constructor(t,o){this.initData=t,this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new I.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryLoggers=new Map,this._outputLogger=o.createLogger(R.URI.revive(this.initData.environment.extensionTelemetryLogResource)),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(t,o){const a=this.getTelemetryDetails(),g=new p(o,t,this._outputLogger,this.getBuiltInCommonProperties(t),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled});return this._telemetryLoggers.set(t.identifier.value,g),g.apiTelemetryLogger}$initializeTelemetryLevel(t,o){this._level=t,this._productConfig=o||{usage:!0,error:!0}}getBuiltInCommonProperties(t){const o={};switch(o["common.extname"]=t.name,o["common.extversion"]=t.version,o["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,o["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,o["common.vscodeversion"]=this.initData.version,o["common.isnewappinstall"]=E(this.initData.telemetryInfo.firstSessionDate),o["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case D.UIKind.Web:o["common.uikind"]="web";break;case D.UIKind.Desktop:o["common.uikind"]="desktop";break;default:o["common.uikind"]="unknown"}return o["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),o}$onDidChangeTelemetryLevel(t){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=t;const o=this.getTelemetryDetails();this._telemetryLoggers.forEach(a=>{a.updateTelemetryEnablements(o.isUsageEnabled,o.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}onExtensionError(t,o){const a=this._telemetryLoggers.get(t.value);return a?(a.logError(o),!0):!1}};b=He([$e(0,M.IExtHostInitDataService),$e(1,S.ILoggerService)],b),e.ExtHostTelemetry=b;class p{constructor(t,o,a,g,w){this._extension=o,this._logger=a,this._commonProperties=g,this._onDidChangeEnableStates=new I.Emitter,this._appender=t,this._telemetryEnablements={isUsageEnabled:w.isUsageEnabled,isErrorsEnabled:w.isErrorsEnabled}}updateTelemetryEnablements(t,o){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:t,isErrorsEnabled:o},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(t){let o=t.properties??t;return this._appender.additionalCommonProperties&&(o=(0,k.mixin)(o,this._appender.additionalCommonProperties)),o=(0,y.cleanData)(o,[]),this._appender.ignoreBuiltInCommonProperties||(o=(0,k.mixin)(o,this._commonProperties)),t.properties?t.properties=o:t=o,t}logEvent(t,o){t=this._extension.identifier.value+"/"+t,o=this.mixInCommonPropsAndCleanData(o||{}),this._appender.logEvent(t,o),this._logger.trace(t,o)}logUsage(t,o){!this._telemetryEnablements.isUsageEnabled||this.logEvent(t,o)}logError(t,o){!this._telemetryEnablements.isErrorsEnabled||(typeof t=="string"?this.logEvent(t,o):this._appender.logException(t,o))}get apiTelemetryLogger(){if(!this._apiObject){const t=this,o={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return t._telemetryEnablements.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t._onDidChangeEnableStates.event.bind(t)};this._apiObject=Object.freeze(o)}return this._apiObject}dispose(){this._appender?.flush&&this._appender.flush()}}e.ExtHostTelemetryLogger=p;function E(m){const t=Date.now()-new Date(m).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.isNewAppInstall=E,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(De[27],Ie([1,0,4,2,3,25,155]),function(ie,e,i,I,S,M,D){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class y{constructor(f){this.affinity=f,this.kind=1}equals(f){return this.kind===f.kind&&this.affinity===f.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class k{constructor(f){this.affinity=f,this.kind=2}equals(f){return this.kind===f.kind&&this.affinity===f.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class R{constructor(){this.kind=3,this.affinity=0}equals(f){return this.kind===f.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class b{constructor(f){this.dependency=f}}e.MissingExtensionDependency=b;var p;(function(l){l[l.LocalProcess=1]="LocalProcess",l[l.LocalWebWorker=2]="LocalWebWorker",l[l.Remote=3]="Remote"})(p=e.ExtensionHostKind||(e.ExtensionHostKind={}));function E(l){if(l===null)return"None";switch(l){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=E;class m{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(f,s){const h=[],v=[],P=[],L=[],j=a(this._allExtensions),W=a(f),V=(x,B)=>x.extensionLocation.toString()===B.extensionLocation.toString()||x.isBuiltin===B.isBuiltin||x.isUserBuiltin===B.isUserBuiltin||x.isUnderDevelopment===B.isUnderDevelopment;for(const x of this._allExtensions){const B=W.get(M.ExtensionIdentifier.toKey(x.identifier));if(!B){h.push(x.identifier),j.delete(M.ExtensionIdentifier.toKey(x.identifier));continue}if(!V(x,B)){h.push(x.identifier),j.delete(M.ExtensionIdentifier.toKey(x.identifier));continue}}for(const x of f){const B=j.get(M.ExtensionIdentifier.toKey(x.identifier));if(!B){v.push(x);continue}if(!V(B,x)){h.push(B.identifier),j.delete(M.ExtensionIdentifier.toKey(B.identifier));continue}}const C=o(this._myExtensions),F=o(s);for(const x of this._myExtensions)F.has(M.ExtensionIdentifier.toKey(x))||P.push(x);for(const x of s)C.has(M.ExtensionIdentifier.toKey(x))||L.push(x);const O={toRemove:h,toAdd:v,myToRemove:P,myToAdd:L};return this.delta(O),O}delta(f){const{toRemove:s,toAdd:h,myToRemove:v,myToAdd:P}=f,L=o(s),j=o(v);for(let W=0;W<this._allExtensions.length;W++)L.has(M.ExtensionIdentifier.toKey(this._allExtensions[W].identifier))&&(this._allExtensions.splice(W,1),W--);for(let W=0;W<this._myExtensions.length;W++)j.has(M.ExtensionIdentifier.toKey(this._myExtensions[W]))&&(this._myExtensions.splice(W,1),W--);for(const W of h)this._allExtensions.push(W);for(const W of P)this._myExtensions.push(W)}containsExtension(f){for(const s of this._myExtensions)if(M.ExtensionIdentifier.equals(s,f))return!0;return!1}}e.ExtensionHostExtensions=m;class t{constructor(f){if(this[A]="ExtensionIdentifierSet",this._map=new Map,this._toKey=M.ExtensionIdentifier.toKey,f)for(const s of f)this.add(s)}get size(){return this._map.size}add(f){return this._map.set(this._toKey(f),f),this}clear(){this._map.clear()}delete(f){return this._map.delete(this._toKey(f))}has(f){return this._map.has(this._toKey(f))}forEach(f,s){this._map.forEach(h=>f.call(s,h,h,this))}*entries(){for(const[f,s]of this._map)yield[s,s]}keys(){return this._map.values()}values(){return this._map.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=t;function o(l){const f=new Set;for(const s of l)f.add(M.ExtensionIdentifier.toKey(s));return f}e.extensionIdentifiersArrayToSet=o;function a(l){const f=new Map;for(const s of l)f.set(M.ExtensionIdentifier.toKey(s.identifier),s);return f}function g(l,f){return l.enabledApiProposals?l.enabledApiProposals.includes(f):!1}e.isProposedApiEnabled=g;function w(l,f){if(!g(l,f))throw new Error(`Extension '${l.identifier.value}' CANNOT use API proposal: ${f}.
Its package.json#enabledApiProposals-property declares: ${l.enabledApiProposals?.join(", ")??"[]"} but NOT ${f}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${l.identifier.value}`)}e.checkProposedApiEnabled=w;class d{constructor(f,s,h,v){this.codeLoadingTime=f,this.activateCallTime=s,this.activateResolvedTime=h,this.activationReason=v}}e.ActivationTimes=d;class T{constructor(f,s){this.description=f,this.value=s}}e.ExtensionPointContribution=T,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var r;(function(l){l[l.Normal=0]="Normal",l[l.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function c(l){return{type:l.isBuiltin?0:1,isBuiltin:l.isBuiltin||l.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(l.publisher,l.name),uuid:l.uuid},manifest:l,location:l.extensionLocation,targetPlatform:l.targetPlatform,validations:[],isValid:!0}}e.toExtension=c;function n(l,f){return{identifier:new M.ExtensionIdentifier((0,D.getExtensionId)(l.manifest.publisher,l.manifest.name)),isBuiltin:l.type===0,isUserBuiltin:l.type===1&&l.isBuiltin,isUnderDevelopment:!!f,extensionLocation:l.location,...l.manifest,uuid:l.identifier.uuid,targetPlatform:l.targetPlatform,browserNlsBundleUris:l.browserNlsBundleUris}}e.toExtensionDescription=n;class u{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.extensions=[]}activateByEvent(f){return Promise.resolve(void 0)}activationEventIsDone(f){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(f){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(f,s){return Promise.resolve(0)}getInspectPorts(f,s){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(f){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(f,s){return Promise.resolve()}}e.NullExtensionService=u}),define(De[180],Ie([1,0,12,25,27,11,15]),function(ie,e,i,I,S,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class A{constructor(o,a,g,w){this.startup=o,this.codeLoadingTime=a,this.activateCallTime=g,this.activateResolvedTime=w}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class y{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,a){return o===-1||a===-1?-1:a-o}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class k{constructor(o,a,g,w,d,T){this.activationFailed=o,this.activationFailedError=a,this.activationTimes=g,this.module=w,this.exports=d,this.subscriptions=T}}e.ActivatedExtension=k;class R extends k{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class b extends k{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=b;class p extends k{constructor(o){super(!0,o,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let E=class{constructor(o,a,g,w,d){this._logService=d,this._registry=o,this._resolvedExtensionsSet=new Set,a.forEach(T=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(T))),this._externalExtensionsMap=new Map,g.forEach(T=>this._externalExtensionsMap.set(I.ExtensionIdentifier.toKey(T),T)),this._host=w,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[o,a]of this._operations)a.dispose()}isActivated(o){const a=this._operations.get(I.ExtensionIdentifier.toKey(o));return Boolean(a&&a.value)}getActivatedExtension(o){const a=this._operations.get(I.ExtensionIdentifier.toKey(o));if(!a||!a.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return a.value}async activateByEvent(o,a){if(this._alreadyActivatedEvents[o])return;const g=this._registry.getExtensionDescriptionsForActivationEvent(o);await this._activateExtensions(g.map(w=>({id:w.identifier,reason:{startup:a,extensionId:w.identifier,activationEvent:o}}))),this._alreadyActivatedEvents[o]=!0}activateById(o,a){const g=this._registry.getExtensionDescription(o);if(!g)throw new Error(`Extension '${o}' is not known`);return this._activateExtensions([{id:g.identifier,reason:a}])}async _activateExtensions(o){const a=o.filter(g=>!this.isActivated(g.id)).map(g=>this._handleActivationRequest(g));await Promise.all(a.map(g=>g.wait()))}_handleActivationRequest(o){if(this._operations.has(I.ExtensionIdentifier.toKey(o.id)))return this._operations.get(I.ExtensionIdentifier.toKey(o.id));if(this._externalExtensionsMap.has(I.ExtensionIdentifier.toKey(o.id)))return this._createAndSaveOperation(o,null,[],null);const a=this._registry.getExtensionDescription(o.id);if(!a){const d=new Error(`Cannot activate unknown extension '${o.id.value}'`),T=this._createAndSaveOperation(o,null,[],new p(d));return this._host.onExtensionActivationError(o.id,d,new S.MissingExtensionDependency(o.id.value)),T}const g=[],w=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const d of w){if(this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(d)))continue;const T=this._operations.get(I.ExtensionIdentifier.toKey(d));if(T){g.push(T);continue}if(this._externalExtensionsMap.has(I.ExtensionIdentifier.toKey(d))){g.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(I.ExtensionIdentifier.toKey(d)),reason:o.reason}));continue}const r=this._registry.getExtensionDescription(d);if(r){if(!r.main&&!r.browser)continue;g.push(this._handleActivationRequest({id:r.identifier,reason:o.reason}));continue}const c=a.displayName||a.identifier.value,n=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${d}'`),u=this._createAndSaveOperation(o,a.displayName,[],new p(n));return this._host.onExtensionActivationError(a.identifier,n,new S.MissingExtensionDependency(d)),u}return this._createAndSaveOperation(o,a.displayName,g,null)}_createAndSaveOperation(o,a,g,w){const d=new m(o.id,a,o.reason,g,w,this._host,this._logService);return this._operations.set(I.ExtensionIdentifier.toKey(o.id),d),d}};E=He([$e(4,M.ILogService)],E),e.ExtensionsActivator=E;let m=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(o,a,g,w,d,T,r){this._id=o,this._displayName=a,this._reason=g,this._deps=w,this._value=d,this._host=T,this._logService=r,this._barrier=new D.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let o=0;o<this._deps.length;o++){const a=this._deps[o];if(a.value&&!a.value.activationFailed){this._deps.splice(o,1),o--;continue}if(a.value&&a.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);g.detail=a.value.activationFailedError,this._value=new p(g),this._host.onExtensionActivationError(this._id,g,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(o=>o.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(o){const a=new Error;if(o&&o.name&&(a.name=o.name),o&&o.message?a.message=`Activating extension '${this._id.value}' failed: ${o.message}.`:a.message=`Activating extension '${this._id.value}' failed: ${o}.`,o&&o.stack&&(a.stack=o.stack),this._value=new p(a),this._isDisposed&&i.isCancellationError(o))return;this._host.onExtensionActivationError(this._id,a,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(o)}}};m=He([$e(6,M.ILogService)],m)}),define(De[181],Ie([1,0,11,26,27]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends i.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:S.ExtensionHostLogFileName}))}};M=He([$e(0,i.ILoggerService),$e(1,I.IExtHostInitDataService)],M),e.ExtHostLogService=M});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,S){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?S.call(ie,i):S?S.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[6],Ie([1,0,18,12,81,28,79,10,9,2,38,35,90,66,27]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m){"use strict";var t,o,a,g,w,d,T,r,c,n,u,l,f,s,h,v,P,L,j,W,V,C,F;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function O(z){return Object.assign(z,{apply:function(){const te=arguments.length===1?[]:arguments[1];return Reflect.construct(z,te,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[te,...Ee]=arguments;return Reflect.construct(z,Ee,te.constructor)}}})}let x=d=class{static from(...U){let te=U;return new d(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}constructor(U){t.set(this,void 0),Ye(this,t,U,"f")}dispose(){typeof Ae(this,t,"f")=="function"&&(Ae(this,t,"f").call(this),Ye(this,t,void 0,"f"))}};t=new WeakMap,x=d=He([O],x),e.Disposable=x;let B=T=class{static Min(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let Ee=1;Ee<U.length;Ee++){const Ve=U[Ee];Ve.isBefore(te)&&(te=Ve)}return te}static Max(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let Ee=1;Ee<U.length;Ee++){const Ve=U[Ee];Ve.isAfter(te)&&(te=Ve)}return te}static isPosition(U){if(!U)return!1;if(U instanceof T)return!0;const{line:te,character:Ee}=U;return typeof te=="number"&&typeof Ee=="number"}static of(U){if(U instanceof T)return U;if(this.isPosition(U))return new T(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(U,te){if(U<0)throw(0,I.illegalArgument)("line must be non-negative");if(te<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=U,this._character=te}isBefore(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<U._character}isBeforeOrEqual(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<=U._character}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this._line===U._line&&this._character===U._character}compareTo(U){return this._line<U._line?-1:this._line>U.line?1:this._character<U._character?-1:this._character>U._character?1:0}translate(U,te=0){if(U===null||te===null)throw(0,I.illegalArgument)();let Ee;return typeof U>"u"?Ee=0:typeof U=="number"?Ee=U:(Ee=typeof U.lineDelta=="number"?U.lineDelta:0,te=typeof U.characterDelta=="number"?U.characterDelta:0),Ee===0&&te===0?this:new T(this.line+Ee,this.character+te)}with(U,te=this.character){if(U===null||te===null)throw(0,I.illegalArgument)();let Ee;return typeof U>"u"?Ee=this.line:typeof U=="number"?Ee=U:(Ee=typeof U.line=="number"?U.line:this.line,te=typeof U.character=="number"?U.character:this.character),Ee===this.line&&te===this.character?this:new T(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};B=T=He([O],B),e.Position=B;let H=r=class{static isRange(U){return U instanceof r?!0:U?B.isPosition(U.start)&&B.isPosition(U.end):!1}static of(U){if(U instanceof r)return U;if(this.isRange(U))return new r(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(U,te,Ee,Ve){let Qe,lt;if(typeof U=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ve=="number"?(Qe=new B(U,te),lt=new B(Ee,Ve)):B.isPosition(U)&&B.isPosition(te)&&(Qe=B.of(U),lt=B.of(te)),!Qe||!lt)throw new Error("Invalid arguments");Qe.isBefore(lt)?(this._start=Qe,this._end=lt):(this._start=lt,this._end=Qe)}contains(U){return r.isRange(U)?this.contains(U.start)&&this.contains(U.end):B.isPosition(U)?!(B.of(U).isBefore(this._start)||this._end.isBefore(U)):!1}isEqual(U){return this._start.isEqual(U._start)&&this._end.isEqual(U._end)}intersection(U){const te=B.Max(U.start,this._start),Ee=B.Min(U.end,this._end);if(!te.isAfter(Ee))return new r(te,Ee)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const te=B.Min(U.start,this._start),Ee=B.Max(U.end,this.end);return new r(te,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(U,te=this.end){if(U===null||te===null)throw(0,I.illegalArgument)();let Ee;return U?B.isPosition(U)?Ee=U:(Ee=U.start||this.start,te=U.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&te.isEqual(this.end)?this:new r(Ee,te)}toJSON(){return[this.start,this.end]}};H=r=He([O],H),e.Range=H;let G=c=class extends H{static isSelection(U){return U instanceof c?!0:U?H.isRange(U)&&B.isPosition(U.anchor)&&B.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(U,te,Ee,Ve){let Qe,lt;if(typeof U=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ve=="number"?(Qe=new B(U,te),lt=new B(Ee,Ve)):B.isPosition(U)&&B.isPosition(te)&&(Qe=B.of(U),lt=B.of(te)),!Qe||!lt)throw new Error("Invalid arguments");super(Qe,lt),this._anchor=Qe,this._active=lt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=c=He([O],G),e.Selection=G;class ee{constructor(U,te,Ee){if(typeof U!="string"||U.length===0)throw(0,I.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,I.illegalArgument)("port");if(typeof Ee<"u"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,I.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(te),this.connectionToken=Ee}}e.ResolvedAuthority=ee;class ue extends Error{static NotAvailable(U,te){return new ue(U,p.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(U){return new ue(U,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,te=p.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(U),this._message=U,this._code=te,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ue.prototype)}}e.RemoteAuthorityResolverError=ue;var re;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(re=e.EndOfLine||(e.EndOfLine={}));var pe;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(pe=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let le=n=class{static isTextEdit(U){return U instanceof n?!0:U?H.isRange(U)&&typeof U.newText=="string":!1}static replace(U,te){return new n(U,te)}static insert(U,te){return n.replace(new H(U,U),te)}static delete(U){return n.replace(U,"")}static setEndOfLine(U){const te=new n(new H(new B(0,0),new B(0,0)),"");return te.newEol=U,te}get range(){return this._range}set range(U){if(U&&!H.isRange(U))throw(0,I.illegalArgument)("range");this._range=U}get newText(){return this._newText||""}set newText(U){if(U&&typeof U!="string")throw(0,I.illegalArgument)("newText");this._newText=U}get newEol(){return this._newEol}set newEol(U){if(U&&typeof U!="number")throw(0,I.illegalArgument)("newEol");this._newEol=U}constructor(U,te){this._range=U,this._newText=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};le=n=He([O],le),e.TextEdit=le;let de=u=class{static isNotebookCellEdit(U){return U instanceof u?!0:U?jt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,te){return new u(U,te)}static insertCells(U,te){return new u(new jt(U,U),te)}static deleteCells(U){return new u(U,[])}static updateCellMetadata(U,te){const Ee=new u(new jt(U,U),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(U){const te=new u(new jt(0,0),[]);return te.newNotebookMetadata=U,te}constructor(U,te){this.range=U,this.newCells=te}};de=u=He([O],de),e.NotebookEdit=de;class Y{static isSnippetTextEdit(U){return U instanceof Y?!0:U?H.isRange(U.range)&&Oe.isSnippetString(U.snippet):!1}static replace(U,te){return new Y(U,te)}static insert(U,te){return Y.replace(new H(U,U),te)}constructor(U,te){this.range=U,this.snippet=te}}e.SnippetTextEdit=Y;var me;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(me=e.FileEditType||(e.FileEditType={}));let Se=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(U,te,Ee,Ve){this._edits.push({_type:1,from:U,to:te,options:Ee,metadata:Ve})}createFile(U,te,Ee){this._edits.push({_type:1,from:void 0,to:U,options:te,metadata:Ee})}deleteFile(U,te,Ee){this._edits.push({_type:1,from:U,to:void 0,options:te,metadata:Ee})}replaceNotebookMetadata(U,te,Ee){this._edits.push({_type:3,metadata:Ee,uri:U,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(U,te,Ee,Ve){const Qe=te.start,lt=te.end;(Qe!==lt||Ee.length>0)&&this._edits.push({_type:5,uri:U,index:Qe,count:lt-Qe,cells:Ee,metadata:Ve})}replaceNotebookCellMetadata(U,te,Ee,Ve){this._edits.push({_type:3,metadata:Ve,uri:U,edit:{editType:8,index:te,metadata:Ee}})}replace(U,te,Ee,Ve){this._edits.push({_type:2,uri:U,edit:new le(te,Ee),metadata:Ve})}insert(U,te,Ee,Ve){this.replace(U,new H(te,te),Ee,Ve)}delete(U,te,Ee){this.replace(U,te,"",Ee)}has(U){return this._edits.some(te=>te._type===2&&te.uri.toString()===U.toString())}set(U,te){if(te)for(const Ee of te){if(!Ee)continue;let Ve,Qe;Array.isArray(Ee)?(Ve=Ee[0],Qe=Ee[1]):Ve=Ee,de.isNotebookCellEdit(Ve)?Ve.newCellMetadata?this.replaceNotebookCellMetadata(U,Ve.range.start,Ve.newCellMetadata,Qe):Ve.newNotebookMetadata?this.replaceNotebookMetadata(U,Ve.newNotebookMetadata,Qe):this.replaceNotebookCells(U,Ve.range,Ve.newCells,Qe):Y.isSnippetTextEdit(Ve)?this._edits.push({_type:6,uri:U,range:Ve.range,edit:Ve.snippet,metadata:Qe}):this._edits.push({_type:2,uri:U,edit:Ve,metadata:Qe})}else{for(let Ee=0;Ee<this._edits.length;Ee++){const Ve=this._edits[Ee];switch(Ve._type){case 2:case 6:case 3:case 5:Ve.uri.toString()===U.toString()&&(this._edits[Ee]=void 0);break}}(0,i.coalesceInPlace)(this._edits)}}get(U){const te=[];for(const Ee of this._edits)Ee._type===2&&Ee.uri.toString()===U.toString()&&te.push(Ee.edit);return te}entries(){const U=new M.ResourceMap;for(const te of this._edits)if(te._type===2){let Ee=U.get(te.uri);Ee||(Ee=[te.uri,[]],U.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Se=He([O],Se),e.WorkspaceEdit=Se;let Oe=l=class{static isSnippetString(U){return U instanceof l?!0:U?typeof U.value=="string":!1}static _escape(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this._tabstop=1,this.value=U||""}appendText(U){return this.value+=l._escape(U),this}appendTabstop(U=this._tabstop++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,te=this._tabstop++){if(typeof U=="function"){const Ee=new l;Ee._tabstop=this._tabstop,U(Ee),this._tabstop=Ee._tabstop,U=Ee.value}else U=l._escape(U);return this.value+="${",this.value+=te,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,te=this._tabstop++){const Ee=U.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(U,te){if(typeof te=="function"){const Ee=new l;Ee._tabstop=this._tabstop,te(Ee),this._tabstop=Ee._tabstop,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,te&&(this.value+=":",this.value+=te),this.value+="}",this}};Oe=l=He([O],Oe),e.SnippetString=Oe;var Be;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Be=e.DiagnosticTag||(e.DiagnosticTag={}));var Xe;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Xe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=f=class{static isLocation(U){return U instanceof f?!0:U?H.isRange(U.range)&&k.URI.isUri(U.uri):!1}constructor(U,te){if(this.uri=U,te)if(H.isRange(te))this.range=H.of(te);else if(B.isPosition(te))this.range=new H(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=f=He([O],ke),e.Location=ke;let ye=class{static is(U){return U?typeof U.message=="string"&&U.location&&H.isRange(U.location.range)&&k.URI.isUri(U.location.uri):!1}constructor(U,te){this.location=U,this.message=te}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.location.range.isEqual(te.location.range)&&U.location.uri.toString()===te.location.uri.toString()}};ye=He([O],ye),e.DiagnosticRelatedInformation=ye;let Ce=class{constructor(U,te,Ee=Xe.Error){if(!H.isRange(U))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=U,this.message=te,this.severity=Ee}toJSON(){return{severity:Xe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.severity===te.severity&&U.code===te.code&&U.severity===te.severity&&U.source===te.source&&U.range.isEqual(te.range)&&(0,i.equals)(U.tags,te.tags)&&(0,i.equals)(U.relatedInformation,te.relatedInformation,ye.isEqual)}};Ce=He([O],Ce),e.Diagnostic=Ce;let se=class{constructor(U,te){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=te}};se=He([O],se),e.Hover=se;var ae;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let J=class{constructor(U,te=ae.Text){this.range=U,this.kind=te}toJSON(){return{range:this.range,kind:ae[this.kind]}}};J=He([O],J),e.DocumentHighlight=J;var _;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(_=e.SymbolKind||(e.SymbolKind={}));var N;(function(z){z[z.Deprecated=1]="Deprecated"})(N=e.SymbolTag||(e.SymbolTag={}));let $=s=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,te,Ee,Ve,Qe){this.name=U,this.kind=te,this.containerName=Qe,typeof Ee=="string"&&(this.containerName=Ee),Ve instanceof ke?this.location=Ve:Ee instanceof H&&(this.location=new ke(Ve,Ee)),s.validate(this)}toJSON(){return{name:this.name,kind:_[this.kind],location:this.location,containerName:this.containerName}}};$=s=He([O],$),e.SymbolInformation=$;let q=h=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(h.validate)}constructor(U,te,Ee,Ve,Qe){this.name=U,this.detail=te,this.kind=Ee,this.range=Ve,this.selectionRange=Qe,this.children=[],h.validate(this)}};q=h=He([O],q),e.DocumentSymbol=q;var Z;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(Z=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ce=class{constructor(U,te){this.title=U,this.kind=te}};ce=He([O],ce),e.CodeAction=ce;let be=v=class{constructor(U){this.value=U}append(U){return new v(this.value?this.value+v.sep+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+v.sep)}};be.sep=".",be=v=He([O],be),e.CodeActionKind=be,be.Empty=new be(""),be.QuickFix=be.Empty.append("quickfix"),be.Refactor=be.Empty.append("refactor"),be.RefactorExtract=be.Refactor.append("extract"),be.RefactorInline=be.Refactor.append("inline"),be.RefactorMove=be.Refactor.append("move"),be.RefactorRewrite=be.Refactor.append("rewrite"),be.Source=be.Empty.append("source"),be.SourceOrganizeImports=be.Source.append("organizeImports"),be.SourceFixAll=be.Source.append("fixAll");let oe=class{constructor(U,te){if(this.range=U,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=He([O],oe),e.SelectionRange=oe;class we{constructor(U,te,Ee,Ve,Qe,lt){this.kind=U,this.name=te,this.detail=Ee,this.uri=Ve,this.range=Qe,this.selectionRange=lt}}e.CallHierarchyItem=we;class ve{constructor(U,te){this.fromRanges=te,this.from=U}}e.CallHierarchyIncomingCall=ve;class Ue{constructor(U,te){this.fromRanges=te,this.to=U}}e.CallHierarchyOutgoingCall=Ue;var ze;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,te){this.range=U,this.command=te}get isResolved(){return!!this.command}};et=He([O],et),e.CodeLens=et;let Ke=P=class{static isMarkdownString(U){return U instanceof P?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,te=!1){o.set(this,void 0),Ye(this,o,new S.MarkdownString(U,{supportThemeIcons:te}),"f")}get value(){return Ae(this,o,"f").value}set value(U){Ae(this,o,"f").value=U}get isTrusted(){return Ae(this,o,"f").isTrusted}set isTrusted(U){Ae(this,o,"f").isTrusted=U}get supportThemeIcons(){return Ae(this,o,"f").supportThemeIcons}set supportThemeIcons(U){Ae(this,o,"f").supportThemeIcons=U}get supportHtml(){return Ae(this,o,"f").supportHtml}set supportHtml(U){Ae(this,o,"f").supportHtml=U}get baseUri(){return Ae(this,o,"f").baseUri}set baseUri(U){Ae(this,o,"f").baseUri=U}appendText(U){return Ae(this,o,"f").appendText(U),this}appendMarkdown(U){return Ae(this,o,"f").appendMarkdown(U),this}appendCodeblock(U,te){return Ae(this,o,"f").appendCodeblock(te??"",U),this}};o=new WeakMap,Ke=P=He([O],Ke),e.MarkdownString=Ke;let tt=class{constructor(U,te){this.label=U,this.documentation=te}};tt=He([O],tt),e.ParameterInformation=tt;let Fe=class{constructor(U,te){this.label=U,this.documentation=te,this.parameters=[]}};Fe=He([O],Fe),e.SignatureInformation=Fe;let ht=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ht=He([O],ht),e.SignatureHelp=ht;var X;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Q;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Q=e.InlayHintKind||(e.InlayHintKind={}));let ge=class{constructor(U){this.value=U}};ge=He([O],ge),e.InlayHintLabelPart=ge;let Ne=class{constructor(U,te,Ee){this.position=U,this.label=te,this.kind=Ee}};Ne=He([O],Ne),e.InlayHint=Ne;var je;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(qe=e.CompletionItemKind||(e.CompletionItemKind={}));var We;(function(z){z[z.Deprecated=1]="Deprecated"})(We=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(U,te){this.label=U,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&qe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=He([O],Ze),e.CompletionItem=Ze;let nt=class{constructor(U=[],te=!1){this.items=U,this.isIncomplete=te}};nt=He([O],nt),e.CompletionList=nt;let ct=class{constructor(U,te,Ee){this.insertText=U,this.range=te,this.command=Ee}};ct=He([O],ct),e.InlineSuggestion=ct;let It=class{constructor(U){this.commands=void 0,this.items=U}};It=He([O],It),e.InlineSuggestionList=It;var at;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(at=e.ViewColumn||(e.ViewColumn={}));var rt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Lt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Lt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var At;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(At=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var kt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(kt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var yt;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(yt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ut;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Ut=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function U(te){switch(te){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Rt=class{constructor(U,te){if(te&&!k.URI.isUri(te))throw(0,I.illegalArgument)("target");if(!H.isRange(U)||U.isEmpty)throw(0,I.illegalArgument)("range");this.range=U,this.target=te}};Rt=He([O],Rt),e.DocumentLink=Rt;let Ge=class{constructor(U,te,Ee,Ve){this.red=U,this.green=te,this.blue=Ee,this.alpha=Ve}};Ge=He([O],Ge),e.Color=Ge;let Ct=class{constructor(U,te){if(te&&!(te instanceof Ge))throw(0,I.illegalArgument)("color");if(!H.isRange(U)||U.isEmpty)throw(0,I.illegalArgument)("range");this.range=U,this.color=te}};Ct=He([O],Ct),e.ColorInformation=Ct;let Ot=class{constructor(U){if(!U||typeof U!="string")throw(0,I.illegalArgument)("label");this.label=U}};Ot=He([O],Ot),e.ColorPresentation=Ot;var Bt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Bt=e.ColorFormat||(e.ColorFormat={}));var pt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(pt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var _e;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(_e=e.TerminalExitReason||(e.TerminalExitReason={}));class Te{constructor(U,te,Ee){if(this.startIndex=U,this.length=te,this.tooltip=Ee,typeof U!="number"||U<0)throw(0,I.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,I.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,I.illegalArgument)("tooltip")}}e.TerminalLink=Te;var fe;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(fe=e.TerminalLocation||(e.TerminalLocation={}));class K{constructor(U){if(this.options=U,typeof U!="object")throw(0,I.illegalArgument)("options")}}e.TerminalProfile=K;var Pe;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Pe=e.TaskRevealKind||(e.TaskRevealKind={}));var Me;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Me=e.TaskPanelKind||(e.TaskPanelKind={}));let Je=L=class{static from(U){switch(U){case"clean":return L.Clean;case"build":return L.Build;case"rebuild":return L.Rebuild;case"test":return L.Test;default:return}}constructor(U,te){if(this.label=te,typeof U!="string"||typeof te!="string")throw(0,I.illegalArgument)("name");this._id=U}get id(){return this._id}};Je.Clean=new L("clean","Clean"),Je.Build=new L("build","Build"),Je.Rebuild=new L("rebuild","Rebuild"),Je.Test=new L("test","Test"),Je=L=He([O],Je),e.TaskGroup=Je;function xe(z){let U="";for(let te=0;te<z.length;te++)U+=z[te].replace(/,/g,",,")+",";return U}let it=class{constructor(U,te,Ee){if(typeof U!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=U,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Ee):this._options=te)}get process(){return this._process}set process(U){if(typeof U!="string")throw(0,I.illegalArgument)("process");this._process=U}get args(){return this._args}set args(U){Array.isArray(U)||(U=[]),this._args=U}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("process"),this._process!==void 0&&U.push(this._process),this._args&&this._args.length>0)for(const te of this._args)U.push(te);return xe(U)}};it=He([O],it),e.ProcessExecution=it;let ot=class{constructor(U,te,Ee){if(this._args=[],Array.isArray(te)){if(!U)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,I.illegalArgument)("command");this._command=U,this._args=te,this._options=Ee}else{if(typeof U!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=U,this._options=te}}get commandLine(){return this._commandLine}set commandLine(U){if(typeof U!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=U}get command(){return this._command?this._command:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,I.illegalArgument)("command");this._command=U}get args(){return this._args}set args(U){this._args=U||[]}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("shell"),this._commandLine!==void 0&&U.push(this._commandLine),this._command!==void 0&&U.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const te of this._args)U.push(typeof te=="string"?te:te.value);return xe(U)}};ot=He([O],ot),e.ShellExecution=ot;var Tt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Tt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class _t{constructor(U){this._callback=U}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(U){this._callback=U}get callback(){return this._callback}}e.CustomExecution=_t;let vt=j=class{constructor(U,te,Ee,Ve,Qe,lt){this.__deprecated=!1,this._definition=this.definition=U;let dt;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Ee,this.execution=Ve,dt=Qe,this.__deprecated=!0):te===Et.Global||te===Et.Workspace?(this.target=te,this._name=this.name=Ee,this._source=this.source=Ve,this.execution=Qe,dt=lt):(this.target=te,this._name=this.name=Ee,this._source=this.source=Ve,this.execution=Qe,dt=lt),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(U){this.__id=U}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof it?this._definition={type:j.ProcessType,id:this._execution.computeId()}:this._execution instanceof ot?this._definition={type:j.ShellType,id:this._execution.computeId()}:this._execution instanceof _t?this._definition={type:j.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:j.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(U){if(U==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=U}get scope(){return this._scope}set target(U){this.clear(),this._scope=U}get name(){return this._name}set name(U){if(typeof U!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=U}get execution(){return this._execution}set execution(U){U===null&&(U=void 0),this.clear(),this._execution=U;const te=this._definition.type;(j.EmptyType===te||j.ProcessType===te||j.ShellType===te||j.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(U){if(Array.isArray(U))this.clear(),this._problemMatchers=U,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.clear(),this._isBackground=U}get source(){return this._source}set source(U){if(typeof U!="string"||U.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=U}get group(){return this._group}set group(U){U===null&&(U=void 0),this.clear(),this._group=U}get detail(){return this._detail}set detail(U){U===null&&(U=void 0),this._detail=U}get presentationOptions(){return this._presentationOptions}set presentationOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._presentationOptions=U}get runOptions(){return this._runOptions}set runOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._runOptions=U}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=j=He([O],vt),e.Task=vt;var Ft;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Ft=e.ProgressLocation||(e.ProgressLocation={}));var mt;(function(z){function U(te){const Ee=te;return(0,y.isNumber)(Ee.value)?Ee.tooltip&&!(0,y.isString)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}z.isViewBadge=U})(mt=e.ViewBadge||(e.ViewBadge={}));let Mt=W=class{static isTreeItem(U,te){if(U instanceof W)return!0;const Ee=U;if(Ee.label!==void 0&&!(0,y.isString)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,y.isString)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,y.isString)(Ee.iconPath)&&!k.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,y.isString)(Ee.iconPath.id))){const Ve=Ee.iconPath;if(!Ve||!(0,y.isString)(Ve.light)&&!k.URI.isUri(Ve.light)&&!(0,y.isString)(Ve.dark)&&!k.URI.isUri(Ve.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}if(Ee.description!==void 0&&!(0,y.isString)(Ee.description)&&typeof Ee.description!="boolean")return console.log("INVALID tree item, invalid description",Ee.description),!1;if(Ee.resourceUri!==void 0&&!k.URI.isUri(Ee.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1;if(Ee.tooltip!==void 0&&!(0,y.isString)(Ee.tooltip)&&!(Ee.tooltip instanceof Ke))return console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1;if(Ee.command!==void 0&&!Ee.command.command)return console.log("INVALID tree item, invalid command",Ee.command),!1;if(Ee.collapsibleState!==void 0&&Ee.collapsibleState<Kt.None&&Ee.collapsibleState>Kt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1;if(Ee.contextValue!==void 0&&!(0,y.isString)(Ee.contextValue))return console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1;if(Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1;if(Ee.checkboxState!==void 0){(0,m.checkProposedApiEnabled)(te,"treeItemCheckbox");const Ve=(0,y.isNumber)(Ee.checkboxState)?Ee.checkboxState:(0,y.isObject)(Ee.checkboxState)&&(0,y.isNumber)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Qe=!(0,y.isNumber)(Ee.checkboxState)&&(0,y.isObject)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ve===void 0||Ve!==bt.Checked&&Ve!==bt.Unchecked||Qe!==void 0&&!(0,y.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}return!0}constructor(U,te=Kt.None){this.collapsibleState=te,k.URI.isUri(U)?this.resourceUri=U:this.label=U}};Mt=W=He([O],Mt),e.TreeItem=Mt;var Kt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(Kt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var bt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(bt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Ht=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,te){this.value=U,this.id=te??(0,R.generateUuid)()}};Ht=He([O],Ht),e.DataTransferItem=Ht;let ni=class{constructor(U){a.set(this,new Map);for(const[te,Ee]of U??[]){const Ve=Ae(this,a,"f").get(te);Ve?Ve.push(Ee):Ae(this,a,"f").set(te,[Ee])}}get(U){return Ae(this,a,"f").get(U)?.[0]}set(U,te){Ae(this,a,"f").set(U,[te])}forEach(U,te){for(const[Ee,Ve]of Ae(this,a,"f"))for(const Qe of Ve)U.call(te,Qe,Ee,this)}*[(a=new WeakMap,Symbol.iterator)](){for(const[U,te]of Ae(this,a,"f"))for(const Ee of te)yield[U,Ee]}};ni=He([O],ni),e.DataTransfer=ni;let ri=class{constructor(U){this.insertText=U}};ri=He([O],ri),e.DocumentDropEdit=ri;let mi=class{constructor(U){this.insertText=U}};mi=He([O],mi),e.DocumentPasteEdit=mi;let St=class{constructor(U,te){this.id=U,this.color=te}};St=He([O],St),e.ThemeIcon=St,St.File=new St("file"),St.Folder=new St("folder");let si=class{constructor(U){this.id=U}};si=He([O],si),e.ThemeColor=si;var Ai;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Jt=class{get base(){return this._base}set base(U){this._base=U,this._baseUri=k.URI.file(U)}get baseUri(){return this._baseUri}set baseUri(U){this._baseUri=U,this._base=U.fsPath}constructor(U,te){if(typeof U!="string"&&(!U||!k.URI.isUri(U)&&!k.URI.isUri(U.uri)))throw(0,I.illegalArgument)("base");if(typeof te!="string")throw(0,I.illegalArgument)("pattern");typeof U=="string"?this.baseUri=k.URI.file(U):k.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Jt=He([O],Jt),e.RelativePattern=Jt;let zt=class{constructor(U,te,Ee,Ve){this.enabled=typeof U=="boolean"?U:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};zt=He([O],zt),e.Breakpoint=zt;let ut=class extends zt{constructor(U,te,Ee,Ve,Qe){if(super(te,Ee,Ve,Qe),U===null)throw(0,I.illegalArgument)("location");this.location=U}};ut=He([O],ut),e.SourceBreakpoint=ut;let gi=class extends zt{constructor(U,te,Ee,Ve,Qe){super(te,Ee,Ve,Qe),this.functionName=U}};gi=He([O],gi),e.FunctionBreakpoint=gi;let $t=class extends zt{constructor(U,te,Ee,Ve,Qe,lt,dt){if(super(Ve,Qe,lt,dt),!te)throw(0,I.illegalArgument)("dataId");this.label=U,this.dataId=te,this.canPersist=Ee}};$t=He([O],$t),e.DataBreakpoint=$t;let Gt=class{constructor(U,te,Ee){this.command=U,this.args=te||[],this.options=Ee}};Gt=He([O],Gt),e.DebugAdapterExecutable=Gt;let oi=class{constructor(U,te){this.port=U,this.host=te}};oi=He([O],oi),e.DebugAdapterServer=oi;let pi=class{constructor(U){this.path=U}};pi=He([O],pi),e.DebugAdapterNamedPipeServer=pi;let ai=class{constructor(U){this.implementation=U}};ai=He([O],ai),e.DebugAdapterInlineImplementation=ai;let vi=class{constructor(U,te){this.range=U,this.expression=te}};vi=He([O],vi),e.EvaluatableExpression=vi;var Di;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Di=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Zt=class{constructor(U,te){this.range=U,this.text=te}};Zt=He([O],Zt),e.InlineValueText=Zt;let Ei=class{constructor(U,te,Ee=!0){this.range=U,this.variableName=te,this.caseSensitiveLookup=Ee}};Ei=He([O],Ei),e.InlineValueVariableLookup=Ei;let ei=class{constructor(U,te){this.range=U,this.expression=te}};ei=He([O],ei),e.InlineValueEvaluatableExpression=ei;let ti=class{constructor(U,te){this.frameId=U,this.stoppedLocation=te}};ti=He([O],ti),e.InlineValueContext=ti;var Ri;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Ri=e.FileChangeType||(e.FileChangeType={}));let bi=V=class extends Error{static FileExists(U){return new V(U,b.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(U){return new V(U,b.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(U){return new V(U,b.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(U){return new V(U,b.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(U){return new V(U,b.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(U){return new V(U,b.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor(U,te=b.FileSystemProviderErrorCode.Unknown,Ee){super(k.URI.isUri(U)?U.toString(!0):U),this.code=Ee?.name??"Unknown",(0,b.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};bi=V=He([O],bi),e.FileSystemError=bi;let Xt=class{constructor(U,te,Ee){this.start=U,this.end=te,this.kind=Ee}};Xt=He([O],Xt),e.FoldingRange=Xt;var Oi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Oi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Fi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Li;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Li=e.CommentMode||(e.CommentMode={}));var Mi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Mi=e.CommentThreadState||(e.CommentThreadState={}));class wi{constructor(U,te=[]){this.tokenTypes=U,this.tokenModifiers=te}}e.SemanticTokensLegend=wi;function Ii(z){return typeof z>"u"||(0,y.isStringArray)(z)}class li{constructor(U){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,U){this._hasLegend=!0;for(let te=0,Ee=U.tokenTypes.length;te<Ee;te++)this._tokenTypeStrToInt.set(U.tokenTypes[te],te);for(let te=0,Ee=U.tokenModifiers.length;te<Ee;te++)this._tokenModifierStrToInt.set(U.tokenModifiers[te],te)}}push(U,te,Ee,Ve,Qe){if(typeof U=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ve=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this._pushEncoded(U,te,Ee,Ve,Qe);if(H.isRange(U)&&typeof te=="string"&&Ii(Ee))return this._push(U,te,Ee);throw(0,I.illegalArgument)()}_push(U,te,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ve=U.start.line,Qe=U.start.character,lt=U.end.character-U.start.character,dt=this._tokenTypeStrToInt.get(te);let Pt=0;if(Ee)for(const xt of Ee){if(!this._tokenModifierStrToInt.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(xt);Pt|=1<<Wt>>>0}this._pushEncoded(Ve,Qe,lt,dt,Pt)}_pushEncoded(U,te,Ee,Ve,Qe){if(this._dataIsSortedAndDeltaEncoded&&(U<this._prevLine||U===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Pt=this._data.length/5|0;let xt=0,Wt=0;for(let qt=0;qt<Pt;qt++){let Qt=this._data[5*qt],_i=this._data[5*qt+1];Qt===0?(Qt=xt,_i+=Wt):Qt+=xt,this._data[5*qt]=Qt,this._data[5*qt+1]=_i,xt=Qt,Wt=_i}}let lt=U,dt=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=Qe,this._prevLine=U,this._prevChar=te}static _sortAndDeltaEncode(U){const te=[],Ee=U.length/5|0;for(let dt=0;dt<Ee;dt++)te[dt]=dt;te.sort((dt,Pt)=>{const xt=U[5*dt],Wt=U[5*Pt];if(xt===Wt){const qt=U[5*dt+1],Qt=U[5*Pt+1];return qt-Qt}return xt-Wt});const Ve=new Uint32Array(U.length);let Qe=0,lt=0;for(let dt=0;dt<Ee;dt++){const Pt=5*te[dt],xt=U[Pt+0],Wt=U[Pt+1],qt=U[Pt+2],Qt=U[Pt+3],_i=U[Pt+4],Yi=xt-Qe,_n=Yi===0?Wt-lt:Wt,yi=5*dt;Ve[yi+0]=Yi,Ve[yi+1]=_n,Ve[yi+2]=qt,Ve[yi+3]=Qt,Ve[yi+4]=_i,Qe=xt,lt=Wt}return Ve}build(U){return this._dataIsSortedAndDeltaEncoded?new Le(new Uint32Array(this._data),U):new Le(li._sortAndDeltaEncode(this._data),U)}}e.SemanticTokensBuilder=li;class Le{constructor(U,te){this.resultId=te,this.data=U}}e.SemanticTokens=Le;class Vt{constructor(U,te,Ee){this.start=U,this.deleteCount=te,this.data=Ee}}e.SemanticTokensEdit=Vt;class Ci{constructor(U,te){this.resultId=te,this.edits=U}}e.SemanticTokensEdits=Ci;var gt;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ci=class{constructor(){}};ci.Back={iconPath:new St("arrow-left")},ci=He([O],ci),e.QuickInputButtons=ci;var Ni;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Ti;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(Ti=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ui;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Ui=e.ExtensionKind||(e.ExtensionKind={}));class ui{static validate(U){if(U.badge){let te=(0,A.nextCharLength)(U.badge,0);if(te<U.badge.length&&(te+=(0,A.nextCharLength)(U.badge,te)),U.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,te,Ee){this.badge=U,this.tooltip=te,this.color=Ee}}e.FileDecoration=ui;let Si=class{constructor(U){this.kind=U}};Si=He([O],Si),e.ColorTheme=Si;var Bi;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Bi=e.ColorThemeKind||(e.ColorThemeKind={}));class jt{static isNotebookRange(U){return U instanceof jt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(U,te){if(U<0)throw(0,I.illegalArgument)("start must be positive");if(te<0)throw(0,I.illegalArgument)("end must be positive");U<=te?(this._start=U,this._end=te):(this._start=te,this._end=U)}with(U){let te=this._start,Ee=this._end;return U.start!==void 0&&(te=U.start),U.end!==void 0&&(Ee=U.end),te===this._start&&Ee===this._end?this:new jt(te,Ee)}}e.NotebookRange=jt;class ii{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(te=>ii.isNotebookCellData(te))}static isNotebookCellData(U){return!0}constructor(U,te,Ee,Ve,Qe,lt,dt){this.kind=U,this.value=te,this.languageId=Ee,this.mime=Ve,this.outputs=Qe??[],this.metadata=lt,this.executionSummary=dt,ii.validate(this)}}e.NotebookCellData=ii;class xi{constructor(U){this.cells=U}}e.NotebookData=xi;class Nt{static isNotebookCellOutputItem(U){return U instanceof Nt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const te={name:U.name,message:U.message,stack:U.stack};return Nt.json(te,"application/vnd.code.notebook.error")}static stdout(U){return Nt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Nt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,te="application/octet-stream"){return new Nt(U,te)}static text(U,te=D.Mimes.text){const Ee=Ae(Nt,g,"f",w).encode(String(U));return new Nt(Ee,te)}static json(U,te="text/x-json"){const Ee=JSON.stringify(U,void 0,"	");return Nt.text(Ee,te)}constructor(U,te){this.data=U,this.mime=te;const Ee=(0,D.normalizeMimeType)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.NotebookCellOutputItem=Nt,g=Nt,w={value:new TextEncoder};class di{static isNotebookCellOutput(U){return U instanceof di?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,te=!1){const Ee=new Set,Ve=new Set;for(let Qe=0;Qe<U.length;Qe++){const lt=U[Qe],dt=(0,D.normalizeMimeType)(lt.mime);if(!Ee.has(dt)||(0,E.isTextStreamMime)(dt)){Ee.add(dt);continue}Ve.add(Qe),te&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ve.size===0?U:U.filter((Qe,lt)=>!Ve.has(lt))}constructor(U,te,Ee){this.items=di.ensureUniqueMimeTypes(U,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,R.generateUuid)(),this.metadata=te??Ee)}}e.NotebookCellOutput=di;var zi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(zi=e.NotebookCellKind||(e.NotebookCellKind={}));var $i;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})($i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Wi;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var ne;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(ne=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class he{constructor(U,te){this.text=U,this.alignment=te}}e.NotebookCellStatusBarItem=he;var Re;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(Re=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var st;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(st=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class wt{constructor(U,te=[]){this.uri=U,this.provides=(0,i.asArray)(te)}}e.NotebookRendererScript=wt;let Dt=class{constructor(U,te){this.label=U,this.timestamp=te}};Dt=He([O],Dt),e.TimelineItem=Dt;var tn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(tn=e.ExtensionMode||(e.ExtensionMode={}));var nn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(nn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var rn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(rn=e.StandardTokenType||(e.StandardTokenType={}));class sn{constructor(U,te){this.ranges=U,this.wordPattern=te}}e.LinkedEditingRanges=sn;class on{constructor(U,te){this._port=U,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=on;var an;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(an=e.TestResultState||(e.TestResultState={}));var ln;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(ln=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Hi=class{constructor(U=void 0,te=void 0,Ee=void 0){this.include=U,this.exclude=te,this.profile=Ee}};Hi=He([O],Hi),e.TestRunRequest=Hi;let Vi=C=class{static diff(U,te,Ee){const Ve=new C(U);return Ve.expectedOutput=te,Ve.actualOutput=Ee,Ve}constructor(U){this.message=U}};Vi=C=He([O],Vi),e.TestMessage=Vi;let ji=class{constructor(U){this.id=U}};ji=He([O],ji),e.TestTag=ji;let hi=class{constructor(U,te){this.covered=U,this.total=te}};hi=He([O],hi),e.CoveredCount=hi;let qi=F=class{static fromDetails(U,te){const Ee=new hi(0,0),Ve=new hi(0,0),Qe=new hi(0,0);for(const dt of te)if("branches"in dt){Ee.total+=1,Ee.covered+=dt.executionCount>0?1:0;for(const Pt of dt.branches)Ve.total+=1,Ve.covered+=Pt.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=dt.executionCount>0?1:0;const lt=new F(U,Ee,Ve.total>0?Ve:void 0,Qe.total>0?Qe:void 0);return lt.detailedCoverage=te,lt}constructor(U,te,Ee,Ve){this.uri=U,this.statementCoverage=te,this.branchCoverage=Ee,this.functionCoverage=Ve}};qi=F=He([O],qi),e.FileCoverage=qi;let Ki=class{constructor(U,te,Ee=[]){this.executionCount=U,this.location=te,this.branches=Ee}};Ki=He([O],Ki),e.StatementCoverage=Ki;let Gi=class{constructor(U,te){this.executionCount=U,this.location=te}};Gi=He([O],Gi),e.BranchCoverage=Gi;let Xi=class{constructor(U,te){this.executionCount=U,this.location=te}};Xi=He([O],Xi),e.FunctionCoverage=Xi;var cn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(cn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var un;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(un=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var dn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(dn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class hn{constructor(U,te,Ee,Ve,Qe,lt){this.kind=U,this.name=te,this.detail=Ee,this.uri=Ve,this.range=Qe,this.selectionRange=lt}}e.TypeHierarchyItem=hn;class fn{constructor(U){this.uri=U}}e.TextTabInput=fn;class mn{constructor(U,te){this.original=U,this.modified=te}}e.TextDiffTabInput=mn;class gn{constructor(U,te,Ee,Ve){this.base=U,this.input1=te,this.input2=Ee,this.result=Ve}}e.TextMergeTabInput=gn;class pn{constructor(U,te){this.uri=U,this.viewType=te}}e.CustomEditorTabInput=pn;class vn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=vn;class En{constructor(U,te){this.uri=U,this.notebookType=te}}e.NotebookEditorTabInput=En;class bn{constructor(U,te,Ee){this.original=U,this.modified=te,this.notebookType=Ee}}e.NotebookDiffEditorTabInput=bn;class wn{constructor(){}}e.TerminalEditorTabInput=wn;class Sn{constructor(U,te){this.uri=U,this.inputBoxUri=te}}e.InteractiveWindowInput=Sn}),define(De[94],Ie([1,0,47,13,10,247,124,6,18]),function(ie,e,i,I,S,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function R(m,t){t?k.set(m,t):k.delete(m)}e.setWordDefinitionFor=R;function b(m){return k.get(m)}class p extends M.MirrorTextModel{constructor(t,o,a,g,w,d,T,r){super(o,a,g,w),this._proxy=t,this._languageId=d,this._isDirty=T,this.notebook=r,this._isDisposed=!1}dispose(){(0,i.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(t){return(0,y.equals)(this._lines,t)}get document(){if(!this._document){const t=this;this._document={get uri(){return t._uri},get fileName(){return t._uri.fsPath},get isUntitled(){return t._uri.scheme===I.Schemas.untitled},get languageId(){return t._languageId},get version(){return t._versionId},get isClosed(){return t._isDisposed},get isDirty(){return t._isDirty},save(){return t._save()},getText(o){return o?t._getTextInRange(o):t.getText()},get eol(){return t._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return t._lines.length},lineAt(o){return t._lineAt(o)},offsetAt(o){return t._offsetAt(o)},positionAt(o){return t._positionAt(o)},validateRange(o){return t._validateRange(o)},validatePosition(o){return t._validatePosition(o)},getWordRangeAtPosition(o,a){return t._getWordRangeAtPosition(o,a)}}}return Object.freeze(this._document)}_acceptLanguageId(t){(0,i.ok)(!this._isDisposed),this._languageId=t}_acceptIsDirty(t){(0,i.ok)(!this._isDisposed),this._isDirty=t}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(t){const o=this._validateRange(t);if(o.isEmpty)return"";if(o.isSingleLine)return this._lines[o.start.line].substring(o.start.character,o.end.character);const a=this._eol,g=o.start.line,w=o.end.line,d=[];d.push(this._lines[g].substring(o.start.character));for(let T=g+1;T<w;T++)d.push(this._lines[T]);return d.push(this._lines[w].substring(0,o.end.character)),d.join(a)}_lineAt(t){let o;if(t instanceof A.Position?o=t.line:typeof t=="number"&&(o=t),typeof o!="number"||o<0||o>=this._lines.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new E(o,this._lines[o],o===this._lines.length-1)}_offsetAt(t){return t=this._validatePosition(t),this._ensureLineStarts(),this._lineStarts.getPrefixSum(t.line-1)+t.character}_positionAt(t){t=Math.floor(t),t=Math.max(0,t),this._ensureLineStarts();const o=this._lineStarts.getIndexOf(t),a=this._lines[o.index].length;return new A.Position(o.index,Math.min(o.remainder,a))}_validateRange(t){if(!(t instanceof A.Range))throw new Error("Invalid argument");const o=this._validatePosition(t.start),a=this._validatePosition(t.end);return o===t.start&&a===t.end?t:new A.Range(o.line,o.character,a.line,a.character)}_validatePosition(t){if(!(t instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return t.with(0,0);let{line:o,character:a}=t,g=!1;if(o<0)o=0,a=0,g=!0;else if(o>=this._lines.length)o=this._lines.length-1,a=this._lines[o].length,g=!0;else{const w=this._lines[o].length;a<0?(a=0,g=!0):a>w&&(a=w,g=!0)}return g?new A.Position(o,a):t}_getWordRangeAtPosition(t,o){const a=this._validatePosition(t);if(!o)o=b(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const g=(0,D.getWordAtText)(a.character+1,(0,D.ensureValidWordDefinition)(o),this._lines[a.line],0);if(g)return new A.Range(a.line,g.startColumn-1,a.line,g.endColumn-1)}}e.ExtHostDocumentData=p;class E{constructor(t,o,a){this._line=t,this._text=o,this._isLastLine=a}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(De[182],Ie([1,0,6,14,4]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(A){this._actual=new i.ColorTheme(i.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let y;switch(A){case"light":y=i.ColorThemeKind.Light;break;case"hcDark":y=i.ColorThemeKind.HighContrast;break;case"hcLight":y=i.ColorThemeKind.HighContrastLight;break;default:y=i.ColorThemeKind.Dark}this._actual=new i.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};M=He([$e(0,I.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(De[8],Ie([1,0,18,24,81,28,107,80,23,9,2,52,70,86,92,91,66,42,51,177,6,183]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o,a,g,w,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(_e){function Te(K){const{selectionStartLineNumber:Pe,selectionStartColumn:Me,positionLineNumber:Je,positionColumn:xe}=K,it=new d.Position(Pe-1,Me-1),ot=new d.Position(Je-1,xe-1);return new d.Selection(it,ot)}_e.to=Te;function fe(K){const{anchor:Pe,active:Me}=K;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}_e.from=fe})(r=e.Selection||(e.Selection={}));var c;(function(_e){function Te(K){if(!K)return;const{start:Pe,end:Me}=K;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}_e.from=Te;function fe(K){if(!K)return;const{startLineNumber:Pe,startColumn:Me,endLineNumber:Je,endColumn:xe}=K;return new d.Range(Pe-1,Me-1,Je-1,xe-1)}_e.to=fe})(c=e.Range||(e.Range={}));var n;(function(_e){function Te(fe){switch(fe){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}_e.to=Te})(n=e.TokenType||(e.TokenType={}));var u;(function(_e){function Te(K){return new d.Position(K.lineNumber-1,K.column-1)}_e.to=Te;function fe(K){return{lineNumber:K.line+1,column:K.character+1}}_e.from=fe})(u=e.Position||(e.Position={}));var l;(function(_e){function Te(Pe,Me){return(0,i.coalesce)((0,i.asArray)(Pe).map(Je=>fe(Je,Me)))}_e.from=Te;function fe(Pe,Me){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:K(Pe.scheme,Me),pattern:Q.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function K(Pe,Me){return Me&&typeof Pe=="string"?Me.transformOutgoingScheme(Pe):Pe}})(l=e.DocumentSelector||(e.DocumentSelector={}));var f;(function(_e){function Te(K){switch(K){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}_e.from=Te;function fe(K){switch(K){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}_e.to=fe})(f=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(_e){function Te(K){let Pe;return K.code&&((0,k.isString)(K.code)||(0,k.isNumber)(K.code)?Pe=String(K.code):Pe={value:String(K.code.value),target:K.code.target}),{...c.from(K.range),message:K.message,source:K.source,code:Pe,severity:v.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(h.from),tags:Array.isArray(K.tags)?(0,i.coalesce)(K.tags.map(f.from)):void 0}}_e.from=Te;function fe(K){const Pe=new d.Diagnostic(c.to(K),K.message,v.to(K.severity));return Pe.source=K.source,Pe.code=(0,k.isString)(K.code)?K.code:K.code?.value,Pe.relatedInformation=K.relatedInformation&&K.relatedInformation.map(h.to),Pe.tags=K.tags&&(0,i.coalesce)(K.tags.map(f.to)),Pe}_e.to=fe})(s=e.Diagnostic||(e.Diagnostic={}));var h;(function(_e){function Te(K){return{...c.from(K.location.range),message:K.message,resource:K.location.uri}}_e.from=Te;function fe(K){return new d.DiagnosticRelatedInformation(new d.Location(K.resource,c.to(K)),K.message)}_e.to=fe})(h=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var v;(function(_e){function Te(K){switch(K){case d.DiagnosticSeverity.Error:return E.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return E.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return E.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return E.MarkerSeverity.Hint}return E.MarkerSeverity.Error}_e.from=Te;function fe(K){switch(K){case E.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case E.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case E.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case E.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}_e.to=fe})(v=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var P;(function(_e){function Te(K){return typeof K=="number"&&K>=d.ViewColumn.One?K-1:K===d.ViewColumn.Beside?w.SIDE_GROUP:w.ACTIVE_GROUP}_e.from=Te;function fe(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=fe})(P=e.ViewColumn||(e.ViewColumn={}));function L(_e){return typeof _e.range<"u"}function j(_e){return _e.length===0?!0:!!L(_e[0])}e.isDecorationOptionsArr=j;var W;(function(_e){function Te(xe){return xe.map(_e.from)}_e.fromMany=Te;function fe(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function K(xe){let it;if(fe(xe)){const{language:_t,value:vt}=xe;it={value:"```"+_t+`
`+vt+"\n```\n"}}else d.MarkdownString.isMarkdownString(xe)?it={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml,baseUri:xe.baseUri}:typeof xe=="string"?it={value:xe}:it={value:""};const ot=Object.create(null);it.uris=ot;const Tt=_t=>{try{let vt=R.URI.parse(_t,!0);vt=vt.with({query:Pe(vt.query,ot)}),ot[_t]=vt}catch{}return""},Et=new D.marked.Renderer;return Et.link=Tt,Et.image=_t=>typeof _t=="string"?Tt(S.parseHrefAndDimensions(_t).href):"",(0,D.marked)(it.value,{renderer:Et}),it}_e.from=K;function Pe(xe,it){if(!xe)return xe;let ot;try{ot=(0,A.parse)(xe)}catch{}if(!ot)return xe;let Tt=!1;return ot=(0,y.cloneAndChange)(ot,Et=>{if(R.URI.isUri(Et)){const _t=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[_t]=Et,Tt=!0,_t}else return}),Tt?JSON.stringify(ot):xe}function Me(xe){const it=new d.MarkdownString(xe.value,xe.supportThemeIcons);return it.isTrusted=xe.isTrusted,it.supportHtml=xe.supportHtml,it.baseUri=xe.baseUri?R.URI.from(xe.baseUri):void 0,it}_e.to=Me;function Je(xe){if(!!xe)return typeof xe=="string"?xe:_e.from(xe)}_e.fromStrict=Je})(W=e.MarkdownString||(e.MarkdownString={}));function V(_e){return j(_e)?_e.map(Te=>({range:c.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?W.fromMany(Te.hoverMessage):Te.hoverMessage?W.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):_e.map(Te=>({range:c.from(Te)}))}e.fromRangeOrRangeWithMessage=V;function C(_e){return typeof _e>"u"?_e:typeof _e=="string"?R.URI.file(_e):_e}e.pathOrURIToURI=C;var F;(function(_e){function Te(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?C(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}_e.from=Te})(F=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(_e){function Te(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?C(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?F.from(fe.before):void 0,after:fe.after?F.from(fe.after):void 0}}_e.from=Te})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var x;(function(_e){function Te(fe){if(typeof fe>"u")return fe;switch(fe){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=Te})(x=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(_e){function Te(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?x.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?O.from(fe.light):void 0,dark:fe.dark?O.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?C(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?F.from(fe.before):void 0,after:fe.after?F.from(fe.after):void 0}}_e.from=Te})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(_e){function Te(K){return{text:K.newText,eol:K.newEol&&Ke.from(K.newEol),range:c.from(K.range)}}_e.from=Te;function fe(K){const Pe=new d.TextEdit(c.to(K.range),K.text);return Pe.newEol=typeof K.eol>"u"?void 0:Ke.to(K.eol),Pe}_e.to=fe})(H=e.TextEdit||(e.TextEdit={}));var G;(function(_e){function Te(K,Pe){const Me={edits:[]};if(K instanceof d.WorkspaceEdit){const Je=new M.ResourceSet;for(const xe of K._allEntries())xe._type===1&&R.URI.isUri(xe.to)&&xe.from===void 0&&Je.add(xe.to);for(const xe of K._allEntries())xe._type===1?Me.edits.push({oldResource:xe.from,newResource:xe.to,options:{...xe.options,contentsBase64:xe.options?.contents&&(0,I.encodeBase64)(I.VSBuffer.wrap(xe.options.contents))},metadata:xe.metadata}):xe._type===2?Me.edits.push({resource:xe.uri,textEdit:H.from(xe.edit),versionId:Je.has(xe.uri)?void 0:Pe?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===6?Me.edits.push({resource:xe.uri,textEdit:{range:c.from(xe.range),text:xe.edit.value,insertAsSnippet:!0},versionId:Je.has(xe.uri)?void 0:Pe?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===3?Me.edits.push({metadata:xe.metadata,resource:xe.uri,cellEdit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(xe.uri)}):xe._type===5&&Me.edits.push({metadata:xe.metadata,resource:xe.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(xe.uri),cellEdit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(nt.from)}})}return Me}_e.from=Te;function fe(K){const Pe=new d.WorkspaceEdit;for(const Me of K.edits)Me.textEdit?Pe.replace(R.URI.revive(Me.resource),c.to(Me.textEdit.range),Me.textEdit.text):Pe.renameFile(R.URI.revive(Me.oldResource),R.URI.revive(Me.newResource),Me.options);return Pe}_e.to=fe})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ee;(function(_e){const Te=Object.create(null);Te[d.SymbolKind.File]=0,Te[d.SymbolKind.Module]=1,Te[d.SymbolKind.Namespace]=2,Te[d.SymbolKind.Package]=3,Te[d.SymbolKind.Class]=4,Te[d.SymbolKind.Method]=5,Te[d.SymbolKind.Property]=6,Te[d.SymbolKind.Field]=7,Te[d.SymbolKind.Constructor]=8,Te[d.SymbolKind.Enum]=9,Te[d.SymbolKind.Interface]=10,Te[d.SymbolKind.Function]=11,Te[d.SymbolKind.Variable]=12,Te[d.SymbolKind.Constant]=13,Te[d.SymbolKind.String]=14,Te[d.SymbolKind.Number]=15,Te[d.SymbolKind.Boolean]=16,Te[d.SymbolKind.Array]=17,Te[d.SymbolKind.Object]=18,Te[d.SymbolKind.Key]=19,Te[d.SymbolKind.Null]=20,Te[d.SymbolKind.EnumMember]=21,Te[d.SymbolKind.Struct]=22,Te[d.SymbolKind.Event]=23,Te[d.SymbolKind.Operator]=24,Te[d.SymbolKind.TypeParameter]=25;function fe(Pe){return typeof Te[Pe]=="number"?Te[Pe]:6}_e.from=fe;function K(Pe){for(const Me in Te)if(Te[Me]===Pe)return Number(Me);return d.SymbolKind.Property}_e.to=K})(ee=e.SymbolKind||(e.SymbolKind={}));var ue;(function(_e){function Te(K){switch(K){case d.SymbolTag.Deprecated:return 1}}_e.from=Te;function fe(K){switch(K){case 1:return d.SymbolTag.Deprecated}}_e.to=fe})(ue=e.SymbolTag||(e.SymbolTag={}));var re;(function(_e){function Te(K){return{name:K.name,kind:ee.from(K.kind),tags:K.tags&&K.tags.map(ue.from),containerName:K.containerName,location:me.from(K.location)}}_e.from=Te;function fe(K){const Pe=new d.SymbolInformation(K.name,ee.to(K.kind),K.containerName,me.to(K.location));return Pe.tags=K.tags&&K.tags.map(ue.to),Pe}_e.to=fe})(re=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var pe;(function(_e){function Te(K){const Pe={name:K.name||"!!MISSING: name!!",detail:K.detail,range:c.from(K.range),selectionRange:c.from(K.selectionRange),kind:ee.from(K.kind),tags:K.tags?.map(ue.from)??[]};return K.children&&(Pe.children=K.children.map(Te)),Pe}_e.from=Te;function fe(K){const Pe=new d.DocumentSymbol(K.name,K.detail,ee.to(K.kind),c.to(K.range),c.to(K.selectionRange));return(0,i.isNonEmptyArray)(K.tags)&&(Pe.tags=K.tags.map(ue.to)),K.children&&(Pe.children=K.children.map(fe)),Pe}_e.to=fe})(pe=e.DocumentSymbol||(e.DocumentSymbol={}));var le;(function(_e){function Te(K){const Pe=new d.CallHierarchyItem(ee.to(K.kind),K.name,K.detail||"",R.URI.revive(K.uri),c.to(K.range),c.to(K.selectionRange));return Pe._sessionId=K._sessionId,Pe._itemId=K._itemId,Pe}_e.to=Te;function fe(K,Pe,Me){if(Pe=Pe??K._sessionId,Me=Me??K._itemId,Pe===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Me,name:K.name,detail:K.detail,kind:ee.from(K.kind),uri:K.uri,range:c.from(K.range),selectionRange:c.from(K.selectionRange),tags:K.tags?.map(ue.from)}}_e.from=fe})(le=e.CallHierarchyItem||(e.CallHierarchyItem={}));var de;(function(_e){function Te(fe){return new d.CallHierarchyIncomingCall(le.to(fe.from),fe.fromRanges.map(K=>c.to(K)))}_e.to=Te})(de=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Y;(function(_e){function Te(fe){return new d.CallHierarchyOutgoingCall(le.to(fe.to),fe.fromRanges.map(K=>c.to(K)))}_e.to=Te})(Y=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var me;(function(_e){function Te(K){return{range:K.range&&c.from(K.range),uri:K.uri}}_e.from=Te;function fe(K){return new d.Location(R.URI.revive(K.uri),c.to(K.range))}_e.to=fe})(me=e.location||(e.location={}));var Se;(function(_e){function Te(K){const Pe=K,Me=K;return{originSelectionRange:Pe.originSelectionRange?c.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Me.uri,range:c.from(Pe.targetRange?Pe.targetRange:Me.range),targetSelectionRange:Pe.targetSelectionRange?c.from(Pe.targetSelectionRange):void 0}}_e.from=Te;function fe(K){return{targetUri:R.URI.revive(K.uri),targetRange:c.to(K.range),targetSelectionRange:K.targetSelectionRange?c.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?c.to(K.originSelectionRange):void 0}}_e.to=fe})(Se=e.DefinitionLink||(e.DefinitionLink={}));var Oe;(function(_e){function Te(K){return{range:c.from(K.range),contents:W.fromMany(K.contents)}}_e.from=Te;function fe(K){return new d.Hover(K.contents.map(W.to),c.to(K.range))}_e.to=fe})(Oe=e.Hover||(e.Hover={}));var Be;(function(_e){function Te(K){return{range:c.from(K.range),expression:K.expression}}_e.from=Te;function fe(K){return new d.EvaluatableExpression(c.to(K.range),K.expression)}_e.to=fe})(Be=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Xe;(function(_e){function Te(K){if(K instanceof d.InlineValueText)return{type:"text",range:c.from(K.range),text:K.text};if(K instanceof d.InlineValueVariableLookup)return{type:"variable",range:c.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=Te;function fe(K){switch(K.type){case"text":return{range:c.to(K.range),text:K.text};case"variable":return{range:c.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:c.to(K.range),expression:K.expression}}}_e.to=fe})(Xe=e.InlineValue||(e.InlineValue={}));var ke;(function(_e){function Te(K){return{frameId:K.frameId,stoppedLocation:c.from(K.stoppedLocation)}}_e.from=Te;function fe(K){return new d.InlineValueContext(K.frameId,c.to(K.stoppedLocation))}_e.to=fe})(ke=e.InlineValueContext||(e.InlineValueContext={}));var ye;(function(_e){function Te(K){return{range:c.from(K.range),kind:K.kind}}_e.from=Te;function fe(K){return new d.DocumentHighlight(c.to(K.range),K.kind)}_e.to=fe})(ye=e.DocumentHighlight||(e.DocumentHighlight={}));var Ce;(function(_e){function Te(fe){switch(fe){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}_e.to=Te})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var se;(function(_e){function Te(fe){return{triggerKind:Ce.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}_e.to=Te})(se=e.CompletionContext||(e.CompletionContext={}));var ae;(function(_e){function Te(K){switch(K){case d.CompletionItemTag.Deprecated:return 1}}_e.from=Te;function fe(K){switch(K){case 1:return d.CompletionItemTag.Deprecated}}_e.to=fe})(ae=e.CompletionItemTag||(e.CompletionItemTag={}));var J;(function(_e){const Te=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function fe(Me){return Te.get(Me)??9}_e.from=fe;const K=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Pe(Me){return K.get(Me)??d.CompletionItemKind.Property}_e.to=Pe})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var _;(function(_e){function Te(fe,K){const Pe=new d.CompletionItem(fe.label);return Pe.insertText=fe.insertText,Pe.kind=J.to(fe.kind),Pe.tags=fe.tags?.map(ae.to),Pe.detail=fe.detail,Pe.documentation=S.isMarkdownString(fe.documentation)?W.to(fe.documentation):fe.documentation,Pe.sortText=fe.sortText,Pe.filterText=fe.filterText,Pe.preselect=fe.preselect,Pe.commitCharacters=fe.commitCharacters,b.Range.isIRange(fe.range)?Pe.range=c.to(fe.range):typeof fe.range=="object"&&(Pe.range={inserting:c.to(fe.range.insert),replacing:c.to(fe.range.replace)}),Pe.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Pe.insertText=new d.SnippetString(fe.insertText):(Pe.insertText=fe.insertText,Pe.textEdit=Pe.range instanceof d.Range?new d.TextEdit(Pe.range,Pe.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Pe.additionalTextEdits=fe.additionalTextEdits.map(Me=>H.to(Me))),Pe.command=K&&fe.command?K.fromInternal(fe.command):void 0,Pe}_e.to=Te})(_=e.CompletionItem||(e.CompletionItem={}));var N;(function(_e){function Te(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:W.fromStrict(K.documentation)}}_e.from=Te;function fe(K){return{label:K.label,documentation:S.isMarkdownString(K.documentation)?W.to(K.documentation):K.documentation}}_e.to=fe})(N=e.ParameterInformation||(e.ParameterInformation={}));var $;(function(_e){function Te(K){return{label:K.label,documentation:W.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(N.from):[],activeParameter:K.activeParameter}}_e.from=Te;function fe(K){return{label:K.label,documentation:S.isMarkdownString(K.documentation)?W.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(N.to):[],activeParameter:K.activeParameter}}_e.to=fe})($=e.SignatureInformation||(e.SignatureInformation={}));var q;(function(_e){function Te(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map($.from):[]}}_e.from=Te;function fe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map($.to):[]}}_e.to=fe})(q=e.SignatureHelp||(e.SignatureHelp={}));var Z;(function(_e){function Te(fe,K){const Pe=new d.InlayHint(u.to(K.position),typeof K.label=="string"?K.label:K.label.map(ce.to.bind(void 0,fe)),K.kind&&be.to(K.kind));return Pe.textEdits=K.textEdits&&K.textEdits.map(H.to),Pe.tooltip=S.isMarkdownString(K.tooltip)?W.to(K.tooltip):K.tooltip,Pe.paddingLeft=K.paddingLeft,Pe.paddingRight=K.paddingRight,Pe}_e.to=Te})(Z=e.InlayHint||(e.InlayHint={}));var ce;(function(_e){function Te(fe,K){const Pe=new d.InlayHintLabelPart(K.label);return Pe.tooltip=S.isMarkdownString(K.tooltip)?W.to(K.tooltip):K.tooltip,p.Command.is(K.command)&&(Pe.command=fe.fromInternal(K.command)),K.location&&(Pe.location=me.to(K.location)),Pe}_e.to=Te})(ce=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var be;(function(_e){function Te(K){return K}_e.from=Te;function fe(K){return K}_e.to=fe})(be=e.InlayHintKind||(e.InlayHintKind={}));var oe;(function(_e){function Te(K){return{range:c.from(K.range),url:K.target,tooltip:K.tooltip}}_e.from=Te;function fe(K){let Pe;if(K.url)try{Pe=typeof K.url=="string"?R.URI.parse(K.url,!0):R.URI.revive(K.url)}catch{}return new d.DocumentLink(c.to(K.range),Pe)}_e.to=fe})(oe=e.DocumentLink||(e.DocumentLink={}));var we;(function(_e){function Te(K){const Pe=new d.ColorPresentation(K.label);return K.textEdit&&(Pe.textEdit=H.to(K.textEdit)),K.additionalTextEdits&&(Pe.additionalTextEdits=K.additionalTextEdits.map(Me=>H.to(Me))),Pe}_e.to=Te;function fe(K){return{label:K.label,textEdit:K.textEdit?H.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Pe=>H.from(Pe)):void 0}}_e.from=fe})(we=e.ColorPresentation||(e.ColorPresentation={}));var ve;(function(_e){function Te(K){return new d.Color(K[0],K[1],K[2],K[3])}_e.to=Te;function fe(K){return[K.red,K.green,K.blue,K.alpha]}_e.from=fe})(ve=e.Color||(e.Color={}));var Ue;(function(_e){function Te(K){return{range:c.from(K.range)}}_e.from=Te;function fe(K){return new d.SelectionRange(c.to(K.range))}_e.to=fe})(Ue=e.SelectionRange||(e.SelectionRange={}));var ze;(function(_e){function Te(fe){switch(fe){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}_e.to=Te})(ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(_e){function Te(K){switch(K){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=Te;function fe(K){switch(K){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}_e.to=fe})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ke;(function(_e){function Te(K){if(K===d.EndOfLine.CRLF)return 1;if(K===d.EndOfLine.LF)return 0}_e.from=Te;function fe(K){if(K===1)return d.EndOfLine.CRLF;if(K===0)return d.EndOfLine.LF}_e.to=fe})(Ke=e.EndOfLine||(e.EndOfLine={}));var tt;(function(_e){function Te(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=Te})(tt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(_e){function Te(fe){const K={start:fe.start+1,end:fe.end+1};return fe.kind&&(K.kind=ht.from(fe.kind)),K}_e.from=Te})(Fe=e.FoldingRange||(e.FoldingRange={}));var ht;(function(_e){function Te(fe){if(fe)switch(fe){case d.FoldingRangeKind.Comment:return p.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return p.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return p.FoldingRangeKind.Region}}_e.from=Te})(ht=e.FoldingRangeKind||(e.FoldingRangeKind={}));var X;(function(_e){function Te(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?c.from(fe.selection):void 0,override:typeof fe.override=="boolean"?t.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}_e.from=Te})(X=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(_e){function Te(Me){return Me instanceof d.RelativePattern?Me.toJSON():typeof Me=="string"?Me:fe(Me)||K(Me)?new d.RelativePattern(Me.baseUri??Me.base,Me.pattern).toJSON():Me}_e.from=Te;function fe(Me){const Je=Me;return Je?R.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function K(Me){const Je=Me;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Pe(Me){return typeof Me=="string"?Me:new d.RelativePattern(R.URI.revive(Me.baseUri),Me.pattern)}_e.to=Pe})(Q=e.GlobPattern||(e.GlobPattern={}));var ge;(function(_e){function Te(fe){if(fe){if(Array.isArray(fe))return fe.map(Te);if(typeof fe=="string")return fe;{const K=fe;return{language:K.language,scheme:K.scheme,pattern:Q.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}_e.from=Te})(ge=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(_e){function Te(K){return{start:K.start,end:K.end}}_e.from=Te;function fe(K){return new d.NotebookRange(K.start,K.end)}_e.to=fe})(Ne=e.NotebookRange||(e.NotebookRange={}));var je;(function(_e){function Te(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}_e.to=Te;function fe(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}_e.from=fe})(je=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var qe;(function(_e){function Te(fe){if(fe===o.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;if(fe===o.NotebookCellExecutionState.Pending)return;if(fe===o.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}_e.to=Te})(qe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var We;(function(_e){function Te(K){switch(K){case d.NotebookCellKind.Markup:return o.CellKind.Markup;case d.NotebookCellKind.Code:default:return o.CellKind.Code}}_e.from=Te;function fe(K){switch(K){case o.CellKind.Markup:return d.NotebookCellKind.Markup;case o.CellKind.Code:default:return d.NotebookCellKind.Code}}_e.to=fe})(We=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(_e){function Te(K){const Pe={metadata:K.metadata??Object.create(null),cells:[]};for(const Me of K.cells)d.NotebookCellData.validate(Me),Pe.cells.push(nt.from(Me));return Pe}_e.from=Te;function fe(K){const Pe=new d.NotebookData(K.cells.map(nt.to));return(0,k.isEmptyObject)(K.metadata)||(Pe.metadata=K.metadata),Pe}_e.to=fe})(Ze=e.NotebookData||(e.NotebookData={}));var nt;(function(_e){function Te(K){return{cellKind:We.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:je.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(It.from):[]}}_e.from=Te;function fe(K){return new d.NotebookCellData(We.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(It.to):void 0,K.metadata,K.internalMetadata?je.to(K.internalMetadata):void 0)}_e.to=fe})(nt=e.NotebookCellData||(e.NotebookCellData={}));var ct;(function(_e){function Te(K){return{mime:K.mime,valueBytes:I.VSBuffer.wrap(K.data)}}_e.from=Te;function fe(K){return new d.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}_e.to=fe})(ct=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var It;(function(_e){function Te(K){return{outputId:K.id,items:K.items.map(ct.from),metadata:K.metadata}}_e.from=Te;function fe(K){const Pe=K.items.map(ct.to);return new d.NotebookCellOutput(Pe,K.outputId,K.metadata)}_e.to=fe})(It=e.NotebookCellOutput||(e.NotebookCellOutput={}));var at;(function(_e){function Te(Pe){return K(Pe)?{include:(0,k.withNullAsUndefined)(Q.from(Pe.include)),exclude:(0,k.withNullAsUndefined)(Q.from(Pe.exclude))}:(0,k.withNullAsUndefined)(Q.from(Pe))}_e.from=Te;function fe(Pe){return K(Pe)?{include:Q.to(Pe.include),exclude:Q.to(Pe.exclude)}:Q.to(Pe)}_e.to=fe;function K(Pe){const Me=Pe;return Me?!(0,k.isUndefinedOrNull)(Me.include)&&!(0,k.isUndefinedOrNull)(Me.exclude):!1}})(at=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(_e){function Te(fe,K,Pe){const Me=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Me,Pe),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}_e.from=Te})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Lt;(function(_e){function Te(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}_e.from=Te})(Lt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var At;(function(_e){function Te(K){return{uri:K.uri,provides:K.provides}}_e.from=Te;function fe(K){return new d.NotebookRendererScript(R.URI.revive(K.uri),K.provides)}_e.to=fe})(At=e.NotebookRendererScript||(e.NotebookRendererScript={}));var kt;(function(_e){function Te(K){return{message:W.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:c.from(K.location.range),uri:K.location.uri}}}_e.from=Te;function fe(K){const Pe=new d.TestMessage(typeof K.message=="string"?K.message:W.to(K.message));return Pe.actualOutput=K.actual,Pe.expectedOutput=K.expected,Pe.location=K.location?me.to(K.location):void 0,Pe}_e.to=fe})(kt=e.TestMessage||(e.TestMessage={}));var ft;(function(_e){_e.namespace=g.namespaceTestTag,_e.denamespace=g.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var yt;(function(_e){function Te(K){const Pe=(0,m.getPrivateApiFor)(K).controllerId;return{extId:a.TestId.fromExtHostTestItem(K,Pe).toString(),label:K.label,uri:R.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Me=>ft.namespace(Pe,Me.id)),range:b.Range.lift(c.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&W.fromStrict(K.error)||null}}_e.from=Te;function fe(K){return{parent:void 0,error:void 0,id:a.TestId.fromString(K.extId).localId,label:K.label,uri:R.URI.revive(K.uri),tags:(K.tags||[]).map(Pe=>{const{tagId:Me}=ft.denamespace(Pe);return new d.TestTag(Me)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}_e.toPlain=fe})(yt=e.TestItem||(e.TestItem={})),function(_e){function Te(K){return{id:K.id}}_e.from=Te;function fe(K){return new d.TestTag(K.id)}_e.to=fe}(ft=e.TestTag||(e.TestTag={}));var Ut;(function(_e){const Te=(K,Pe)=>{const Me=[];for(const[xe,it]of Pe)a.TestId.compare(it.item.extId,xe)===2&&(Pe.delete(xe),Me.push(it));const Je={...yt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(xe=>({state:xe.state,duration:xe.duration,messages:xe.messages.filter(it=>it.type===0).map(kt.to)})),children:Me.map(xe=>Te(xe,Pe))};for(const xe of Je.children)xe.parent=Je;return Je};function fe(K){const Pe=[],Me=new Map;for(const Je of K.items){Me.set(Je.item.extId,Je);const xe=a.TestId.root(Je.item.extId);K.request.targets.some(it=>it.controllerId===xe&&it.testIds.includes(Je.item.extId))&&Pe.push(Je)}return{completedAt:K.completedAt,results:Pe.map(Je=>Te(Je,Me))}}_e.to=fe})(Ut=e.TestResults||(e.TestResults={}));var Rt;(function(_e){function Te(Me){return{covered:Me.covered,total:Me.covered}}function fe(Me){return"line"in Me?u.from(Me):c.from(Me)}function K(Me){return"branches"in Me?{count:Me.executionCount,location:fe(Me.location),type:1,branches:Me.branches.length?Me.branches.map(Je=>({count:Je.executionCount,location:Je.location&&fe(Je.location)})):void 0}:{type:0,count:Me.executionCount,location:fe(Me.location)}}_e.fromDetailed=K;function Pe(Me){return{uri:Me.uri,statement:Te(Me.statementCoverage),branch:Me.branchCoverage&&Te(Me.branchCoverage),function:Me.functionCoverage&&Te(Me.functionCoverage),details:Me.detailedCoverage?.map(K)}}_e.fromFile=Pe})(Rt=e.TestCoverage||(e.TestCoverage={}));var Ge;(function(_e){function Te(fe){switch(fe){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}_e.to=Te})(Ge=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ct;(function(_e){function Te(K){const Pe=new d.TypeHierarchyItem(ee.to(K.kind),K.name,K.detail||"",R.URI.revive(K.uri),c.to(K.range),c.to(K.selectionRange));return Pe._sessionId=K._sessionId,Pe._itemId=K._itemId,Pe}_e.to=Te;function fe(K,Pe,Me){if(Pe=Pe??K._sessionId,Me=Me??K._itemId,Pe===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Me,kind:ee.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:c.from(K.range),selectionRange:c.from(K.selectionRange),tags:K.tags?.map(ue.from)}}_e.from=fe})(Ct=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ot;(function(_e){function Te(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}_e.from=Te})(Ot=e.ViewBadge||(e.ViewBadge={}));var Bt;(function(_e){function Te(fe,K){const Pe=fe.fileData;return Pe?new class extends d.DataTransferItem{asFile(){return{name:Pe.name,uri:R.URI.revive(Pe.uri),data:(0,T.once)(()=>K())}}}("",fe.id):new d.DataTransferItem(fe.asString)}_e.toDataTransferItem=Te})(Bt=e.DataTransferItem||(e.DataTransferItem={}));var pt;(function(_e){function Te(K,Pe){const Me=K.items.map(([Je,xe])=>[Je,Bt.toDataTransferItem(xe,()=>Pe(xe.id))]);return new d.DataTransfer(Me)}_e.toDataTransfer=Te;async function fe(K){const Pe={items:[]},Me=[];return K.forEach((Je,xe)=>{Me.push((async()=>{const it=await Je.asString(),ot=Je.asFile();Pe.items.push([xe,{id:Je.id,asString:it,fileData:ot?{name:ot.name,uri:ot.uri}:void 0}])})())}),await Promise.all(Me),Pe}_e.toDataTransferDTO=fe})(pt=e.DataTransfer||(e.DataTransfer={}))}),define(De[184],Ie([1,0,2,12,6,8,150]),function(ie,e,i,I,S,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(k,R,b,p={timeout:1500,errors:3}){this._logService=k,this._documents=R,this._mainThreadBulkEdits=b,this._thresholds=p,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(R,b,p)=>{const m={dispose:this._callbacks.push([R,b,k])};return Array.isArray(p)&&p.push(m),m}}async $participateInSave(k,R){const b=i.URI.revive(k);let p=!1;const E=setTimeout(()=>p=!0,this._thresholds.timeout),m=[];try{for(const t of[...this._callbacks]){if(p)break;const o=this._documents.getDocument(b),a=await this._deliverEventAsyncAndBlameBadListeners(t,{document:o,reason:M.TextDocumentSaveReason.to(R)});m.push(a)}}finally{clearTimeout(E)}return m}_deliverEventAsyncAndBlameBadListeners([k,R,b],p){const E=this._badListeners.get(k);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,k,R,p).then(()=>!0,m=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const t=this._badListeners.get(k);this._badListeners.set(k,t?t+1:1),typeof t=="number"&&t>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,R,b,p){const E=[],m=Date.now(),{document:t,reason:o}=p,{version:a}=t,g=Object.freeze({document:t,reason:o,waitUntil(w){if(Object.isFrozen(E))throw(0,I.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(w))}});try{R.apply(b,[g])}catch(w){return Promise.reject(w)}return Object.freeze(E),new Promise((w,d)=>{const T=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(T),w(r)}).catch(r=>{clearTimeout(T),d(r)})}).then(w=>{const d={edits:[]};for(const T of w)if(Array.isArray(T)&&T.every(r=>r instanceof S.TextEdit))for(const{newText:r,newEol:c,range:n}of T)d.edits.push({resource:t.uri,versionId:void 0,textEdit:{range:n&&M.Range.from(n),text:r,eol:c&&M.EndOfLine.from(c)}});if(d.edits.length!==0)return a===t.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(De[185],Ie([1,0,13,2,8,6,66]),function(ie,e,i,I,S,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(b,p,E,m){this.start=b,this.deletedCount=p,this.deletedItems=E,this.items=m}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(b=>b.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(b,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:b}}constructor(b,p,E){this.notebook=b,this._extHostDocument=p,this._cellData=E,this.handle=E.handle,this.uri=I.URI.revive(E.uri),this.cellKind=E.cellKind,this._outputs=E.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=E.internalMetadata??{},this._metadata=Object.freeze(E.metadata??{}),this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const b=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return b._mime},set mime(m){b._mime=m},get outputs(){return b._outputs.slice(0)},get metadata(){return b._metadata},get executionSummary(){return b._previousResult}};this._apiCell=Object.freeze(E)}return this._apiCell}setOutputs(b){this._outputs=b.map(S.NotebookCellOutput.to)}setOutputItems(b,p,E){const m=E.map(S.NotebookCellOutputItem.to),t=this._outputs.find(o=>o.id===b);if(t&&(p||(t.items.length=0),t.items.push(...m),t.items.length>1&&t.items.every(o=>D.isTextStreamMime(o.mime)))){const o=new Map,a=[];t.items.forEach(g=>{let w;o.has(g.mime)?w=o.get(g.mime):(w=[],o.set(g.mime,w),a.push(g.mime)),w.push(g.data)}),t.items.length=0,a.forEach(g=>{const w=D.compressOutputItemStreams(o.get(g));t.items.push({mime:g,data:w.buffer})})}}setMetadata(b){this._metadata=Object.freeze(b)}setInternalMetadata(b){this._internalMetadata=b,this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.ExtHostCell=y;class k{constructor(b,p,E,m,t){this._proxy=b,this._textDocumentsAndEditors=p,this._textDocuments=E,this.uri=m,this.handle=k._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=t.viewType,this._metadata=Object.freeze(t.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,t.cells]],!0,void 0),this._versionId=t.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const b=this,p={get uri(){return b.uri},get version(){return b._versionId},get notebookType(){return b._notebookType},get isDirty(){return b._isDirty},get isUntitled(){return b.uri.scheme===i.Schemas.untitled},get isClosed(){return b._disposed},get metadata(){return b._metadata},get cellCount(){return b._cells.length},cellAt(E){return E=b._validateIndex(E),b._cells[E].apiCell},getCells(E){return(E?b._getCells(E):b._cells).map(t=>t.apiCell)},save(){return b._save()}};this._notebook=Object.freeze(p)}return this._notebook}acceptDocumentPropertiesChanged(b){b.metadata&&(this._metadata=Object.freeze({...this._metadata,...b.metadata}))}acceptDirty(b){this._isDirty=b}acceptModelChanged(b,p,E){this._versionId=b.versionId,this._isDirty=p,this.acceptDocumentPropertiesChanged({metadata:E});const m={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},t=[];for(const a of b.rawEvents)a.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1,m.contentChanges):a.kind===D.NotebookCellsChangeType.Move?this._moveCells(a.index,a.length,a.newIdx,m.contentChanges):a.kind===D.NotebookCellsChangeType.Output?(this._setCellOutputs(a.index,a.outputs),t.push({cell:this._cells[a.index].apiCell,outputs:this._cells[a.index].apiCell.outputs})):a.kind===D.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems),t.push({cell:this._cells[a.index].apiCell,outputs:this._cells[a.index].apiCell.outputs})):a.kind===D.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(a.index,a.language),t.push({cell:this._cells[a.index].apiCell,document:this._cells[a.index].apiCell.document})):a.kind===D.NotebookCellsChangeType.ChangeCellContent?t.push({cell:this._cells[a.index].apiCell,document:this._cells[a.index].apiCell.document}):a.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===D.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(a.index,a.metadata),t.push({cell:this._cells[a.index].apiCell,metadata:this._cells[a.index].apiCell.metadata})):a.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(a.index,a.internalMetadata),t.push({cell:this._cells[a.index].apiCell,executionSummary:this._cells[a.index].apiCell.executionSummary}));const o=new Map;for(let a=0;a<t.length;a++){const g=t[a],w=o.get(g.cell);if(w===void 0){const d=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});o.set(g.cell,d-1)}else m.cellChanges[w]={...m.cellChanges[w],...g}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}_validateIndex(b){return b=b|0,b<0?0:b>=this._cells.length?this._cells.length-1:b}_validateRange(b){let p=b.start|0,E=b.end|0;return p<0&&(p=0),E>this._cells.length&&(E=this._cells.length),b.with({start:p,end:E})}_getCells(b){b=this._validateRange(b);const p=[];for(let E=b.start;E<b.end;E++)p.push(this._cells[E]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(b,p,E){if(this._disposed)return;const m=[],t=[],o=[];if(b.reverse().forEach(a=>{const w=a[2].map(r=>{const c=new y(this,this._textDocumentsAndEditors,r);return p||t.push(y.asModelAddData(this.apiNotebook,r)),c}),d=new A(a[0],a[1],[],w),T=this._cells.splice(a[0],a[1],...w);for(const r of T)o.push(r.uri),d.deletedItems.push(r.apiCell);m.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:t,removedDocuments:o}),E)for(const a of m)E.push(a.asApiEvent())}_moveCells(b,p,E,m){const t=this._cells.splice(b,p);this._cells.splice(E,0,...t);const o=[new A(b,p,t.map(a=>a.apiCell),[]),new A(E,0,[],t)];for(const a of o)m.push(a.asApiEvent())}_setCellOutputs(b,p){this._cells[b].setOutputs(p)}_setCellOutputItems(b,p,E,m){this._cells[b].setOutputItems(p,E,m)}_changeCellLanguage(b,p){const E=this._cells[b];E.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelLanguageChanged(E.uri,p)}_changeCellMime(b,p){const E=this._cells[b];E.apiCell.mime=p}_changeCellMetadata(b,p){this._cells[b].setMetadata(p)}_changeCellInternalMetadata(b,p){this._cells[b].setInternalMetadata(p)}getCellFromApiCell(b){return this._cells.find(p=>p.apiCell===b)}getCellFromIndex(b){return this._cells[b]}getCell(b){return this._cells.find(p=>p.handle===b)}getCellIndex(b){return this._cells.indexOf(b)}}e.ExtHostNotebookDocument=k,k._handlePool=0}),define(De[95],Ie([1,0,12,8,6]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(A,y,k,R,b,p){this.id=A,this._proxy=y,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=b,this._visibleRanges=R,this._viewColumn=p}get apiEditor(){if(!this._editor){const A=this;this._editor={get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(y){this.selections=[y]},get selections(){return A._selections},set selections(y){if(!Array.isArray(y)||!y.every(S.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");A._selections=y,A._trySetSelections(y)},get visibleRanges(){return A._visibleRanges},revealRange(y,k){A._proxy.$tryRevealRange(A.id,I.NotebookRange.from(y),k??S.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},M.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(I.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(De[186],Ie([1,0,4,11,8]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(A,y){this._logService=A,this._notebooksAndEditors=y,this._onDidChangeNotebookEditorSelection=new i.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new i.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,y){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,y);const k=this._notebooksAndEditors.getEditorById(A);y.visibleRanges&&k._acceptVisibleRanges(y.visibleRanges.ranges.map(S.NotebookRange.to)),y.selections&&k._acceptSelections(y.selections.selections.map(S.NotebookRange.to)),y.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),y.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const y in A)this._notebooksAndEditors.getEditorById(y)._acceptViewColumn(S.ViewColumn.to(A[y]))}};M=He([$e(0,I.ILogService)],M),e.ExtHostNotebookEditors=M}),define(De[187],Ie([1,0,8,153,133,20,58,12]),function(ie,e,i,I,S,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(p){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=p}async withProgress(p,E,m){const t=this._handles++,{title:o,location:a,cancellable:g}=E,w={label:(0,S.localize)(0,null,p.displayName||p.name),id:p.identifier.value};return this._proxy.$startProgress(t,{location:i.ProgressLocation.from(a),title:o,source:w,cancellable:g},p.isUnderDevelopment?void 0:p.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(t,m,!!g)}_withProgress(p,E,m){let t;m&&(t=new M.CancellationTokenSource,this._mapHandleToCancellationSource.set(p,t));const o=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),t?.dispose()};let a;try{a=E(new R(this._proxy,p),m&&t?t.token:M.CancellationToken.None)}catch(g){throw o(p),g}return a.then(g=>o(p),g=>o(p)),a}$acceptProgressCanceled(p){const E=this._mapHandleToCancellationSource.get(p);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(p))}}e.ExtHostProgress=y;function k(b,p){return b.message=p.message,typeof p.increment=="number"&&(typeof b.increment=="number"?b.increment+=p.increment:b.increment=p.increment),b}class R extends I.Progress{constructor(p,E){super(m=>this.throttledReport(m)),this._proxy=p,this._handle=E}throttledReport(p){this._proxy.$progressReport(this._handle,p)}}He([(0,D.throttle)(100,(b,p)=>k(b,p),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(De[96],Ie([1,0,52,92,42,67,51,8,2]),function(ie,e,i,I,S,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(w,d,T,r)=>{let c=d;return{enumerable:!0,configurable:!1,get(){return c},set(n){if(!T(c,n)){const u=c;c=n,w.listener?.(r(n,u))}}}},R=(w,d)=>w===d,b={range:(w,d)=>w===d?!0:!w||!d?!1:w.isEqual(d),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(w,d)=>!(w.length!==d.length||w.some(T=>!d.find(r=>T.id===r.id)))},p=w=>d=>({op:4,update:w(d)}),E=(w,d)=>({range:(()=>{let T;const r=p(c=>({range:i.Range.lift(A.Range.from(c))}));return{enumerable:!0,configurable:!1,get(){return T},set(c){w.listener?.({op:6}),b.range(T,c)||(T=c,w.listener?.(r(c)))}}})(),label:k(w,d,b.label,p(T=>({label:T}))),description:k(w,void 0,b.description,p(T=>({description:T}))),sortText:k(w,void 0,b.sortText,p(T=>({sortText:T}))),canResolveChildren:k(w,!1,b.canResolveChildren,T=>({op:2,state:T})),busy:k(w,!1,b.busy,p(T=>({busy:T}))),error:k(w,void 0,b.error,p(T=>({error:A.MarkdownString.fromStrict(T)||null}))),tags:k(w,[],b.tags,(T,r)=>({op:1,new:T.map(A.TestTag.from),old:r.map(A.TestTag.from)}))}),m=w=>{const d=S.TestId.fromString(w.extId),T=new o(d.controllerId,d.localId,w.label,y.URI.revive(w.uri)||void 0);return T.range=A.Range.to(w.range||void 0),T.description=w.description||void 0,T.sortText=w.sortText||void 0,T.tags=w.tags.map(r=>A.TestTag.to({id:(0,D.denamespaceTestTag)(r).tagId})),T},t=w=>{let d;for(const T of w.tests){const r=m(T.item);(0,I.getPrivateApiFor)(r).parent=d,d=r}return d};e.toItemFromContext=t;class o{constructor(d,T,r,c){if(T.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(T)} symbol`);const n=(0,I.createPrivateApiFor)(this,d);Object.defineProperties(this,{id:{value:T,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof a?void 0:n.parent}},children:{value:(0,M.createTestItemChildren)(n,I.getPrivateApiFor,o),enumerable:!0,writable:!1},...E(n,r)})}}e.TestItemImpl=o;class a extends o{constructor(d,T){super(d,d,T,void 0),this._isRoot=!0}}e.TestItemRootImpl=a;class g extends M.TestItemCollection{constructor(d,T,r){super({controllerId:d,getDocumentVersion:c=>c&&r.getDocument(c)?.version,getApiFor:I.getPrivateApiFor,getChildren:c=>c.children,root:new a(d,T),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(De[97],Ie([1,0,47,12,78,8,6]),function(ie,e,i,I,S,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(p,E,m){const t=A._Keys.nextId();p.$registerTextEditorDecorationType(E.identifier,t,M.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:t,dispose(){p.$removeTextEditorDecorationType(t)}})}}e.TextEditorDecorationType=A,A._Keys=new S.IdGenerator("TextEditorDecorationType");class y{constructor(p,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=p,this._documentVersionId=p.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(p,E){this._throwIfFinalized();let m=null;if(p instanceof D.Position)m=new D.Range(p,p);else if(p instanceof D.Range)m=p;else throw new Error("Unrecognized location");this._pushEdit(m,E,!1)}insert(p,E){this._throwIfFinalized(),this._pushEdit(new D.Range(p,p),E,!0)}delete(p){this._throwIfFinalized();let E=null;if(p instanceof D.Range)E=p;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(p,E,m){const t=this._document.validateRange(p);this._collectedEdits.push({range:t,text:E,forceMoveMarkers:m})}setEndOfLine(p){if(this._throwIfFinalized(),p!==D.EndOfLine.LF&&p!==D.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=p}}e.TextEditorEdit=y;class k{constructor(p,E,m,t){this._proxy=p,this._id=E,this._accept(m),this._logService=t;const o=this;this.value={get tabSize(){return o._tabSize},set tabSize(a){o._setTabSize(a)},get insertSpaces(){return o._insertSpaces},set insertSpaces(a){o._setInsertSpaces(a)},get cursorStyle(){return o._cursorStyle},set cursorStyle(a){o._setCursorStyle(a)},get lineNumbers(){return o._lineNumbers},set lineNumbers(a){o._setLineNumbers(a)}}}_accept(p){this._tabSize=p.tabSize,this._insertSpaces=p.insertSpaces,this._cursorStyle=p.cursorStyle,this._lineNumbers=M.TextEditorLineNumbersStyle.to(p.lineNumbers)}_validateTabSize(p){if(p==="auto")return"auto";if(typeof p=="number"){const E=Math.floor(p);return E>0?E:null}if(typeof p=="string"){const E=parseInt(p,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(p){const E=this._validateTabSize(p);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateInsertSpaces(p){return p==="auto"?"auto":p==="false"?!1:Boolean(p)}_setInsertSpaces(p){const E=this._validateInsertSpaces(p);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(p){this._cursorStyle!==p&&(this._cursorStyle=p,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:p})))}_setLineNumbers(p){this._lineNumbers!==p&&(this._lineNumbers=p,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:M.TextEditorLineNumbersStyle.from(p)})))}assign(p){const E={};let m=!1;if(typeof p.tabSize<"u"){const t=this._validateTabSize(p.tabSize);t==="auto"?(m=!0,E.tabSize=t):typeof t=="number"&&this._tabSize!==t&&(this._tabSize=t,m=!0,E.tabSize=t)}if(typeof p.insertSpaces<"u"){const t=this._validateInsertSpaces(p.insertSpaces);t==="auto"?(m=!0,E.insertSpaces=t):this._insertSpaces!==t&&(this._insertSpaces=t,m=!0,E.insertSpaces=t)}typeof p.cursorStyle<"u"&&this._cursorStyle!==p.cursorStyle&&(this._cursorStyle=p.cursorStyle,m=!0,E.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this._lineNumbers!==p.lineNumbers&&(this._lineNumbers=p.lineNumbers,m=!0,E.lineNumbers=M.TextEditorLineNumbersStyle.from(p.lineNumbers)),m&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(p,E){E.catch(m=>{this._logService.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this._logService.warn(m)})}}e.ExtHostTextEditorOptions=k;class R{constructor(p,E,m,t,o,a,g,w){this.id=p,this._proxy=E,this._logService=m,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=o,this._options=new k(this._proxy,this.id,a,m),this._visibleRanges=g,this._viewColumn=w;const d=this;this.value=Object.freeze({get document(){return t.getValue()},set document(T){throw(0,I.readonly)("document")},get selection(){return d._selections&&d._selections[0]},set selection(T){if(!(T instanceof D.Selection))throw(0,I.illegalArgument)("selection");d._selections=[T],d._trySetSelection()},get selections(){return d._selections},set selections(T){if(!Array.isArray(T)||T.some(r=>!(r instanceof D.Selection)))throw(0,I.illegalArgument)("selections");d._selections=T,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(T){throw(0,I.readonly)("visibleRanges")},get options(){return d._options.value},set options(T){d._disposed||d._options.assign(T)},get viewColumn(){return d._viewColumn},set viewColumn(T){throw(0,I.readonly)("viewColumn")},edit(T,r={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const c=new y(t.getValue(),r);return T(c),d._applyEdit(c)},insertSnippet(T,r,c={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!r||Array.isArray(r)&&r.length===0)n=d._selections.map(u=>M.Range.from(u));else if(r instanceof D.Position){const{lineNumber:u,column:l}=M.Position.from(r);n=[{startLineNumber:u,startColumn:l,endLineNumber:u,endColumn:l}]}else if(r instanceof D.Range)n=[M.Range.from(r)];else{n=[];for(const u of r)if(u instanceof D.Range)n.push(M.Range.from(u));else{const{lineNumber:l,column:f}=M.Position.from(u);n.push({startLineNumber:l,startColumn:f,endLineNumber:l,endColumn:f})}}return E.$tryInsertSnippet(p,t.getValue().version,T.value,n,c)},setDecorations(T,r){const c=r.length===0;c&&!d._hasDecorationsForKey.has(T.key)||(c?d._hasDecorationsForKey.delete(T.key):d._hasDecorationsForKey.add(T.key),d._runOnProxy(()=>{if(M.isDecorationOptionsArr(r))return E.$trySetDecorations(p,T.key,M.fromRangeOrRangeWithMessage(r));{const n=new Array(4*r.length);for(let u=0,l=r.length;u<l;u++){const f=r[u];n[4*u]=f.start.line+1,n[4*u+1]=f.start.character+1,n[4*u+2]=f.end.line+1,n[4*u+3]=f.end.character+1}return E.$trySetDecorationsFast(p,T.key,n)}}))},revealRange(T,r){d._runOnProxy(()=>E.$tryRevealRange(p,M.Range.from(T),r||D.TextEditorRevealType.Default))},show(T){E.$tryShowEditor(p,M.ViewColumn.from(T))},hide(){E.$tryHideEditor(p)}})}dispose(){(0,i.ok)(!this._disposed),this._disposed=!0}_acceptOptions(p){(0,i.ok)(!this._disposed),this._options._accept(p)}_acceptVisibleRanges(p){(0,i.ok)(!this._disposed),this._visibleRanges=p}_acceptViewColumn(p){(0,i.ok)(!this._disposed),this._viewColumn=p}_acceptSelections(p){(0,i.ok)(!this._disposed),this._selections=p}async _trySetSelection(){const p=this._selections.map(M.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,p)),this.value}_applyEdit(p){const E=p.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const m=E.edits.map(o=>o.range);m.sort((o,a)=>o.end.line===a.end.line?o.end.character===a.end.character?o.start.line===a.start.line?o.start.character-a.start.character:o.start.line-a.start.line:o.end.character-a.end.character:o.end.line-a.end.line);for(let o=0,a=m.length-1;o<a;o++){const g=m[o].end;if(m[o+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const t=E.edits.map(o=>({range:M.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,t,{setEndOfLine:typeof E.setEndOfLine=="number"?M.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(p){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=R}),define(De[188],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribTerminalQuickFixes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribTerminalQuickFixes.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[189],Ie([1,0,144,12,29,85,88,30,25,188,152]),function(ie,e,i,I,S,M,D,A,y,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const b=A.Registry.as(D.Extensions.JSONContribution);class p{constructor(d,T,r){this._messageHandler=d,this._extension=T,this._extensionPointId=r}_msg(d,T){this._messageHandler({type:d,message:T,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(d){this._msg(S.default.Error,d)}warn(d){this._msg(S.default.Warning,d)}info(d){this._msg(S.default.Info,d)}}e.ExtensionMessageCollector=p;class E{static _toSet(d){const T=new Set;for(let r=0,c=d.length;r<c;r++)T.add(y.ExtensionIdentifier.toKey(d[r].description.identifier));return T}static compute(d,T){if(!d||!d.length)return new E(T,[]);if(!T||!T.length)return new E([],d);const r=this._toSet(d),c=this._toSet(T),n=T.filter(l=>!r.has(y.ExtensionIdentifier.toKey(l.description.identifier))),u=d.filter(l=>!c.has(y.ExtensionIdentifier.toKey(l.description.identifier)));return new E(n,u)}constructor(d,T){this.added=d,this.removed=T}}e.ExtensionPointUserDelta=E;class m{constructor(d,T){this.name=d,this.defaultExtensionKind=T,this._handler=null,this._users=null,this._delta=null}setHandler(d){if(this._handler!==null)throw new Error("Handler already set!");this._handler=d,this._handle()}acceptUsers(d){this._delta=E.compute(this._users,d),this._users=d,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(d){(0,I.onUnexpectedError)(d)}}}e.ExtensionPoint=m;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},activationEvents:{description:i.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(30,null)},{label:"onUri",body:"onUri",description:i.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(35,null)},{label:"onRenderer",description:i.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(38,null)},{label:"*",description:i.localize(39,null),body:"*"}]}},badges:{type:"array",description:i.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(41,null)},href:{type:"string",description:i.localize(42,null)},description:{type:"string",description:i.localize(43,null)}}}},markdown:{type:"string",description:i.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(48,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(49,null)},{body:["workspace"],description:i.localize(50,null)},{body:["ui","workspace"],description:i.localize(51,null)},{body:["workspace","ui"],description:i.localize(52,null)},{body:[],description:i.localize(53,null)}]},capabilities:{description:i.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(57,null),i.localize(58,null),i.localize(59,null)]},description:{type:"string",markdownDescription:i.localize(60,null)}}},untrustedWorkspaces:{description:i.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(63,null),i.localize(64,null),i.localize(65,null)]},restrictedConfigurations:{description:i.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(67,null)}}}}},sponsor:{description:i.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(70,null),type:"string"},"vscode:uninstall":{description:i.localize(71,null),type:"string"}}},icon:{type:"string",description:i.localize(72,null)},l10n:{type:"string",description:i.localize(73,null)}}};class a{constructor(){this._extensionPoints=new Map}registerExtensionPoint(d){if(this._extensionPoints.has(d.extensionPoint))throw new Error("Duplicate extension point: "+d.extensionPoint);const T=new m(d.extensionPoint,d.defaultExtensionKind);return this._extensionPoints.set(d.extensionPoint,T),e.schema.properties.contributes.properties[d.extensionPoint]=d.jsonSchema,b.registerSchema(o,e.schema),T}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=a;const g={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(g.ExtensionsRegistry,new a),e.ExtensionsRegistry=A.Registry.as(g.ExtensionsRegistry),b.registerSchema(o,e.schema),b.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(74,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(De[190],Ie([1,0,141,9,23,189,41,4]),function(ie,e,i,I,S,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var k;(function(p){function E(m,t,o){if(!m)return;const a=I.isString(m.type)?m.type:void 0;if(!a||a.length===0){o.error(i.localize(3,null));return}const g=[];if(Array.isArray(m.required))for(const w of m.required)I.isString(w)&&g.push(w);return{extensionId:t.value,taskType:a,required:g,properties:m.properties?S.deepClone(m.properties):{},when:m.when?D.ContextKeyExpr.deserialize(m.when):void 0}}p.from=E})(k||(k={}));const R=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:i.localize(4,null),type:"array",items:y}});class b{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((E,m)=>{R.setHandler((t,o)=>{this._schema=void 0;try{for(const a of o.removed){const g=a.value;for(const w of g)this.taskTypes&&w.type&&this.taskTypes[w.type]&&delete this.taskTypes[w.type]}for(const a of o.added){const g=a.value;for(const w of g){const d=k.from(w,a.description.identifier,a.collector);d&&(this.taskTypes[d.taskType]=d)}}(o.removed.length>0||o.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}E(void 0)})})}onReady(){return this.readyPromise}get(E){return this.taskTypes[E]}all(){return Object.keys(this.taskTypes).map(E=>this.taskTypes[E])}getJsonSchema(){if(this._schema===void 0){const E=[];for(const m of this.all()){const t={type:"object",additionalProperties:!1};m.required.length>0&&(t.required=m.required.slice(0)),m.properties!==void 0?t.properties=S.deepClone(m.properties):t.properties=Object.create(null),t.properties.type={type:"string",enum:[m.taskType]},E.push(t)}this._schema={oneOf:E}}return this._schema}}e.TaskDefinitionRegistry=new b}),define(De[191],Ie([1,0,142,9,22,23,41,190]),function(ie,e,i,I,S,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new D.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var y;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function x(B){if(!B)return O.Strong;switch(B.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=x}(y=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var R;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(O){function x(B){switch(B.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=x}(R=e.RevealKind||(e.RevealKind={}));var b;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(b=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function x(B){switch(B.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=x}(b=e.RevealProblemKind||(e.RevealProblemKind={}));var p;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(p=e.PanelKind||(e.PanelKind={})),function(O){function x(B){switch(B.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=x}(p=e.PanelKind||(e.PanelKind={}));var E;(function(O){O.defaults={echo:!0,reveal:R.Always,revealProblems:b.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(E=e.PresentationOptions||(e.PresentationOptions={}));var m;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(m=e.RuntimeType||(e.RuntimeType={})),function(O){function x(H){switch(H.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=x;function B(H){switch(H){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=B}(m=e.RuntimeType||(e.RuntimeType={}));var t;(function(O){function x(B){return I.isString(B)?B:B.value}O.value=x})(t=e.CommandString||(e.CommandString={}));var o;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function x(H){return H===O.Clean._id||H===O.Build._id||H===O.Rebuild._id||H===O.Test._id}O.is=x;function B(H){if(H!==void 0)return I.isString(H)?x(H)?{_id:H,isDefault:!1}:void 0:H}O.from=B})(o=e.TaskGroup||(e.TaskGroup={}));var a;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(a=e.TaskScope||(e.TaskScope={}));var g;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function x(B){switch(B){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=x})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var w;(function(O){O.parallel="parallel",O.sequence="sequence"})(w=e.DependsOrder||(e.DependsOrder={}));var d;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(d=e.RunOnOptions||(e.RunOnOptions={}));var T;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:d.default,instanceLimit:1}})(T=e.RunOptions||(e.RunOptions={}));class r{constructor(x,B,H,G,ee,ue){this._label="",this._id=x,B&&(this._label=B),H&&(this.type=H),this.runOptions=G,this.configurationProperties=ee,this._source=ue}getDefinition(x){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const x={folder:this.getFolderId(),id:this._id};return JSON.stringify(x)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(x,B=!1){if(x===void 0)return!1;if(I.isString(x))return x===this._label||x===this.configurationProperties.identifier||B&&x===this._id;const H=this.getDefinition(!0);return H!==void 0&&H._key===x._key}getQualifiedLabel(){const x=this.getWorkspaceFolder();return x?`${this._label} (${x.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(x){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),x&&(this._taskLoadMessages=this._taskLoadMessages.concat(x))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=r;class c extends r{constructor(x,B,H,G,ee,ue,re,pe){super(x,H,void 0,re,pe,B),this.command={},this._source=B,this.hasDefinedMatchers=ue,ee&&(this.command=ee)}clone(){return new c(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(x=!1){if(x&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case m.Shell:B="shell";break;case m.Process:B="process";break;case m.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(x){return x instanceof c}getMapKey(){const x=this._source.config.workspaceFolder;return x?`${x.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const x=this.getFolderId();if(!x)return;let B=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(B+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:x,id:B};return JSON.stringify(H)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(x){return new c(x._id,x._source,x._label,x.type,x.command,x.hasDefinedMatchers,x.runOptions,x.configurationProperties)}}e.CustomTask=c;class n extends r{constructor(x,B,H,G,ee,ue,re){super(x,H,G,ue,re,B),this._source=B,this.configures=ee}static is(x){return x instanceof n}fromObject(x){return x}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const x=this.getFolderId();if(!x)return;let B=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(B+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:x,id:B};return JSON.stringify(H)}}e.ConfiguringTask=n;class u extends r{constructor(x,B,H,G,ee,ue,re,pe,le){super(x,H,G,pe,le,B),this.defines=ee,this.hasDefinedMatchers=re,this.command=ue,this.icon=le.icon,this.hide=le.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(x){return x instanceof u}getMapKey(){const x=this._source.workspaceFolder;return x?`${this._source.scope.toString()}|${x.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const x={type:"contributed",scope:this._source.scope,id:this._id};return x.folder=this.getFolderId(),JSON.stringify(x)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(x){return new u(x._id,x._source,x._label,x.type,x.defines,x.command,x.hasDefinedMatchers,x.runOptions,x.configurationProperties)}}e.ContributedTask=u;class l extends r{constructor(x,B,H,G,ee,ue){super(x,H,G,ee,ue,B),this._source=B}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(x){return x instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(x){return new l(x._id,x._source,x._label,x.type,x.runOptions,x.configurationProperties)}}e.InMemoryTask=l;var f;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(f=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(f=e.ExecutionEngine||(e.ExecutionEngine={}));var s;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(s=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class h{constructor(x){this._order=new Map;for(let B=0;B<x.length;B++)this._order.set(x[B].uri.toString(),B)}compare(x,B){const H=x.getWorkspaceFolder(),G=B.getWorkspaceFolder();if(H&&G){let ee=this._order.get(H.uri.toString());ee=ee===void 0?0:ee+1;let ue=this._order.get(G.uri.toString());return ue=ue===void 0?0:ue+1,ee===ue?x._label.localeCompare(B._label):ee-ue}else return!H&&G?-1:H&&!G?1:0}}e.TaskSorter=h;var v;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(v=e.TaskEventKind||(e.TaskEventKind={}));var P;(function(O){O.SingleRun="singleRun",O.Background="background"})(P=e.TaskRunType||(e.TaskRunType={}));var L;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var j;(function(O){function x(B,H,G,ee){if(H){const ue={kind:B,taskId:H._id,taskName:H.configurationProperties.name,runType:H.configurationProperties.isBackground?"background":"singleRun",group:H.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:G,__task:H};return B==="start"?ue.resolvedVariables=ee:B==="processStarted"?ue.processId=ee:B==="processEnded"&&(ue.exitCode=ee),Object.freeze(ue)}else return Object.freeze({kind:"changed"})}O.create=x})(j=e.TaskEvent||(e.TaskEvent={}));var W;(function(O){function x(H){const G=Object.keys(H).sort();let ee="";for(const ue of G){let re=H[ue];re instanceof Object?re=x(re):typeof re=="string"&&(re=re.replace(/,/g,",,")),ee+=ue+","+re+","}return ee}function B(H){const ee={_key:x(H),type:H.taskType};return Object.assign(ee,H),ee}O.create=B})(W=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var V;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(V=e.TaskSettingId||(e.TaskSettingId={}));var C;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(C=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var F;(function(O){function x(B,H){const G=A.TaskDefinitionRegistry.get(B.type);if(G===void 0){const pe=M.deepClone(B);return delete pe._key,W.create(pe)}const ee=Object.create(null);ee.type=G.taskType;const ue=new Set;G.required.forEach(pe=>ue.add(pe));const re=G.properties;for(const pe of Object.keys(re)){const le=B[pe];if(le!=null)ee[pe]=le;else if(ue.has(pe)){const de=re[pe];if(de.default!==void 0)ee[pe]=M.deepClone(de.default);else switch(de.type){case"boolean":ee[pe]=!1;break;case"number":case"integer":ee[pe]=0;break;case"string":ee[pe]="";break;default:H.error(i.localize(2,null,JSON.stringify(B,void 0,0),pe));return}}}return W.create(ee)}O.createTaskIdentifier=x})(F=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[192],Ie([1,0,12]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((D,A)=>{this._actualOk=D,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(D){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=D,this._actual&&this._actualOk(D))}resolveErr(D){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=D,this._actual?this._actualErr(D):(0,i.onUnexpectedError)(D))}then(D,A){return this._ensureActual().then(D,A)}catch(D){return this._ensureActual().then(void 0,D)}finally(D){return this._ensureActual().finally(D)}}e.LazyPromise=I;class S extends I{constructor(){super(),this._hasErr=!0,this._err=new i.CancellationError}}e.CanceledLazyPromise=S}),define(De[43],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++i.count}}e.ProxyIdentifier=i,i.count=0;const I=[];function S(A){const y=new i(A);return I[y.nid]=y,y}e.createProxyIdentifier=S;function M(A){return I[A].sid}e.getStringIdentifierForProxy=M;class D{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=D}),define(De[5],Ie([1,0,43]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var I;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(I=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(t){t[t.UnknownInput=0]="UnknownInput",t[t.TextInput=1]="TextInput",t[t.TextDiffInput=2]="TextDiffInput",t[t.TextMergeInput=3]="TextMergeInput",t[t.NotebookInput=4]="NotebookInput",t[t.NotebookDiffInput=5]="NotebookDiffInput",t[t.CustomEditorInput=6]="CustomEditorInput",t[t.WebviewEditorInput=7]="WebviewEditorInput",t[t.TerminalEditorInput=8]="TerminalEditorInput",t[t.InteractiveEditorInput=9]="InteractiveEditorInput"})(S=e.TabInputKind||(e.TabInputKind={}));var M;(function(t){t[t.TAB_OPEN=0]="TAB_OPEN",t[t.TAB_CLOSE=1]="TAB_CLOSE",t[t.TAB_UPDATE=2]="TAB_UPDATE",t[t.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var D;(function(t){t[t.Editable=0]="Editable",t[t.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(t){t[t.Int8Array=1]="Int8Array",t[t.Uint8Array=2]="Uint8Array",t[t.Uint8ClampedArray=3]="Uint8ClampedArray",t[t.Int16Array=4]="Int16Array",t[t.Uint16Array=5]="Uint16Array",t[t.Int32Array=6]="Int32Array",t[t.Uint32Array=7]="Uint32Array",t[t.Float32Array=8]="Float32Array",t[t.Float64Array=9]="Float64Array",t[t.BigInt64Array=10]="BigInt64Array",t[t.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(t){t[t.Text=1]="Text",t[t.Error=2]="Error",t[t.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(t){t[t.None=0]="None",t[t.Process=1]="Process",t[t.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class b{static mixin(o){return o._id=b._n++,o}}e.IdObject=b,b._n=0;var p;(function(t){t.label="a",t.kind="b",t.detail="c",t.documentation="d",t.sortText="e",t.filterText="f",t.preselect="g",t.insertText="h",t.insertTextRules="i",t.range="j",t.commitCharacters="k",t.additionalTextEdits="l",t.kindModifier="m",t.commandIdent="n",t.commandId="o",t.commandArguments="p"})(p=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(t){t.defaultRanges="a",t.completions="b",t.isIncomplete="c",t.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(t){t[t.Workspace=0]="Workspace",t[t.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(De[71],Ie([1,0,3,11,5,14]),function(ie,e,i,I,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(y,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(S.MainContext.MainThreadTelemetry)}report(y,k,R){const b=this.getUsageKey(y,k);this._reportedUsages.has(b)||(this._reportedUsages.add(b),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:y}))}getUsageKey(y,k){return`${y}-${k.identifier.value}`}};D=He([$e(0,M.IExtHostRpcService),$e(1,I.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,k){}})}),define(De[193],Ie([1,0,4,5,6,25]),function(ie,e,i,I,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new i.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,k,R,b={}){const p=M.ExtensionIdentifier.toKey(y.identifier),E=this._inFlightRequests.get(p)||[],m=[...R].sort().join(" ");let t=E.find(o=>o.providerId===k&&o.scopes===m);if(t)return t.result;{const o=this._getSession(y,p,k,R,b);t={providerId:k,scopes:m,result:o},E.push(t),this._inFlightRequests.set(p,E);try{await o}finally{const a=E.findIndex(g=>g.providerId===k&&g.scopes===m);a>-1&&(E.splice(a),this._inFlightRequests.set(p,E))}return o}}async _getSession(y,k,R,b,p={}){await this._proxy.$ensureProvider(R);const E=y.displayName||y.name;return this._proxy.$getSession(R,b,k,E,p)}async removeSession(y,k){const R=this._authenticationProviders.get(y);return R?R.provider.removeSession(k):this._proxy.$removeSession(y,k)}registerAuthenticationProvider(y,k,R,b){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:k,provider:R,options:b??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===y)||this._providers.push({id:y,label:k});const p=R.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(y,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,k,b?.supportsMultipleAccounts??!1),new S.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(y);const E=this._providers.findIndex(m=>m.id===y);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,k){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,k){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,k){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,k){return this._onDidChangeSessions.fire({provider:{id:y,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(De[194],Ie([1,0,5,14,8]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(A,y){this._proxy=A.getProxy(i.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:k=>y.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,k){const R=S.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(R,void 0,k?.isRefactoring??!1)}};M=He([$e(0,I.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(De[195],Ie([1,0,5]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(M){const D=M.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(A){return D.$writeText(A)}})}}e.ExtHostClipboard=I});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,S){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?S.call(ie,i):S?S.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[37],Ie([1,0,9,6,8,23,5,18,11,80,52,248,2,7,3,14,96,24,43,45]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o,a,g,w){"use strict";var d,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(s,h){d.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,T.set(this,void 0),Ye(this,d,s.getProxy(D.MainContext.MainThreadCommands),"f"),this._logService=h,Ye(this,T,s.getProxy(D.MainContext.MainThreadTelemetry),"f"),this.converter=new c(this,v=>{const P=this._apiCommands.get(v);return P?.result===u.Void?P:void 0},h),this._argumentProcessors=[{processArgument(v){return(0,k.revive)(v)}},{processArgument(v){return(0,M.cloneAndChange)(v,function(P){if(R.Range.isIRange(P))return S.Range.to(P);if(b.Position.isIPosition(P))return S.Position.to(P);if(R.Range.isIRange(P.range)&&p.URI.isUri(P.uri))return S.location.to(P);if(P instanceof a.VSBuffer)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const h=this.registerCommand(!1,s.id,async(...v)=>{const P=s.args.map((j,W)=>{if(!j.validate(v[W]))throw new Error(`Invalid argument '${j.name}' when running '${s.id}', received: ${v[W]}`);return j.convert(v[W])}),L=await this.executeCommand(s.internalId,...P);return s.result.convert(L,v,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new I.Disposable(()=>{h.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,h,v,P,L,j){if(this._logService.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this._commands.has(h))throw new Error(`command '${h}' already exists`);return this._commands.set(h,{callback:v,thisArg:P,description:L,extension:j}),s&&Ae(this,d,"f").$registerCommand(h),new I.Disposable(()=>{this._commands.delete(h)&&s&&Ae(this,d,"f").$unregisterCommand(h)})}executeCommand(s,...h){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,h,!0)}async _doExecuteCommand(s,h,v){if(this._commands.has(s))return Ae(this,d,"f").$fireCommandActivationEvent(s),this._executeContributedCommand(s,h,!1);{let P=!1;const L=(0,M.cloneAndChange)(h,function(j){if(j instanceof I.Position)return S.Position.from(j);if(j instanceof I.Range)return S.Range.from(j);if(j instanceof I.Location)return S.location.from(j);if(I.NotebookRange.isNotebookRange(j))return S.NotebookRange.from(j);if(j instanceof ArrayBuffer)return P=!0,a.VSBuffer.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return P=!0,a.VSBuffer.wrap(j);if(j instanceof a.VSBuffer)return P=!0,j;if(!Array.isArray(j))return j});try{const j=await Ae(this,d,"f").$executeCommand(s,P?new g.SerializableObjectWithBuffers(L):L,v);return(0,k.revive)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this._doExecuteCommand(s,h,!1);throw j}}}async _executeContributedCommand(s,h,v){const P=this._commands.get(s);if(!P)throw new Error("Unknown command");const{callback:L,thisArg:j,description:W}=P;if(W)for(let C=0;C<W.args.length;C++)try{(0,i.validateConstraint)(h[C],W.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${W.args[C].name}' - ${W.args[C].description}`)}const V=Date.now();try{return await L.apply(j,h)}catch(C){if(s===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...h);F&&(s=F.command)}throw this._logService.error(C,s,P.extension?.identifier),v?new class extends Error{constructor(){super((0,w.toErrorMessage)(C)),this.id=s,this.source=P.extension?.displayName??P.extension?.name}}:C}finally{this._reportTelemetry(P,s,Date.now()-V)}}_reportTelemetry(s,h,v){!s.extension||s.extension.isBuiltin||Ae(this,T,"f").$publicLog2("Extension:ActionExecuted",{extensionId:s.extension.identifier.value,id:h,duration:v})}$executeContributedCommand(s,...h){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(h=h.map(v=>this._argumentProcessors.reduce((P,L)=>L.processArgument(P),v)),this._executeContributedCommand(s,h,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),Ae(this,d,"f").$getCommands().then(h=>(s&&(h=h.filter(v=>v[0]!=="_")),h))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(const[h,v]of this._commands){const{description:P}=v;P&&(s[h]=P)}return Promise.resolve(s)}};d=new WeakMap,T=new WeakMap,r=He([$e(0,t.IExtHostRpcService),$e(1,y.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class c{constructor(s,h,v){this._commands=s,this._lookupApiCommand=h,this._logService=v,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,h){if(!s)return;const v={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return v;const P=this._lookupApiCommand(s.command);if(P)v.id=P.internalId,v.arguments=P.args.map((L,j)=>L.convert(s.arguments&&s.arguments[j]));else if((0,A.isNonEmptyArray)(s.arguments)){const L=`${s.command}/${++this._cachIdPool}`;this._cache.set(L,s),h.add((0,E.toDisposable)(()=>{this._cache.delete(L),this._logService.trace("CommandsConverter#DISPOSE",L)})),v.$ident=L,v.id=this.delegatingCommandId,v.arguments=[L],this._logService.trace("CommandsConverter#CREATE",s.command,L)}return v}fromInternal(s){return typeof s.$ident=="string"?this._cache.get(s.$ident):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const h=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],h?h.command:"MISSING"),h?this._commands.executeCommand(h.command,...h.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${s[0]}`)}}e.CommandsConverter=c;class n{constructor(s,h,v,P){this.name=s,this.description=h,this.validate=v,this.convert=P}optional(){return new n(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,h){return new n(s??this.name,h??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",f=>p.URI.isUri(f),f=>f),n.Position=new n("position","A position in a text document",f=>I.Position.isPosition(f),S.Position.from),n.Range=new n("range","A range in a text document",f=>I.Range.isRange(f),S.Range.from),n.Selection=new n("selection","A selection in a text document",f=>I.Selection.isSelection(f),S.Selection.from),n.Number=new n("number","",f=>typeof f=="number",f=>f),n.String=new n("string","",f=>typeof f=="string",f=>f),n.CallHierarchyItem=new n("item","A call hierarchy item",f=>f instanceof I.CallHierarchyItem,S.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",f=>f instanceof I.TypeHierarchyItem,S.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",f=>f instanceof o.TestItemImpl,S.TestItem.from);class u{constructor(s,h){this.description=s,this.convert=h}}e.ApiCommandResult=u,u.Void=new u("no result",f=>f);class l{constructor(s,h,v,P,L){this.id=s,this.internalId=h,this.description=v,this.args=P,this.result=L}}e.ApiCommand=l}),define(De[196],Ie([1,0,2,8,6,70,37,18,83,87,13]),function(ie,e,i,I,S,M,D,A,y,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const b=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",E(I.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,o)=>{if((0,A.isFalsyOrEmpty)(t))return;class a extends S.SymbolInformation{static to(w){const d=new a(w.name,I.SymbolKind.to(w.kind),w.containerName||"",new S.Location(o[0],I.Range.to(w.range)));return d.detail=w.detail,d.range=d.location.range,d.selectionRange=I.Range.to(w.selectionRange),d.children=w.children?w.children.map(a.to):[],d}}return t.map(a.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(I.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(I.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new D.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(I.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",E(I.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",E(I.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(o=>S.Position.isPosition(o)),t=>t.map(I.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(o=>{let a;for(const g of o.reverse())a=new S.SelectionRange(I.Range.to(g),a);return a}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(I.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(I.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(I.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(I.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:I.Range.to(t.range),placeholder:t.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return I.WorkspaceEdit.to(t)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(I.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new S.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const o=(0,y.decodeSemanticTokensDto)(t);if(o.type==="full")return new S.SemanticTokens(o.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new S.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const o=(0,y.decodeSemanticTokensDto)(t);if(o.type==="full")return new S.SemanticTokens(o.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,o,a)=>{if(!t)return new S.CompletionList([]);const g=t.suggestions.map(w=>I.CompletionItem.to(w,a));return new S.CompletionList(g,t.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return I.SignatureHelp.to(t)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,o,a)=>E(g=>new S.CodeLens(I.Range.to(g.range),g.command&&a.fromInternal(g.command)))(t))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>S.Range.isRange(t),t=>S.Selection.isSelection(t)?I.Selection.from(t):I.Range.from(t)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,o,a)=>E(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(g.command)}else{const w=new S.CodeAction(g.title,g.kind?new S.CodeActionKind(g.kind):void 0);return g.edit&&(w.edit=I.WorkspaceEdit.to(g.edit)),g.command&&(w.command=a.fromInternal(g.command)),w.isPreferred=g.isPreferred,w}})(t))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(o=>new S.ColorInformation(I.Range.to(o.range),I.Color.to(o.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",t=>t instanceof S.Color,I.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:I.Range.from(t.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(I.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,o,a)=>t.map(I.InlayHint.to.bind(void 0,a)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",E(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(o=>I.NotebookExclusiveDocumentPattern.to(o))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(I.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>i.URI.isUri(t)||typeof t=="string"&&(0,k.matchesSomeScheme)(t,R.Schemas.http,R.Schemas.https),t=>t),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[I.ViewColumn.from(t),void 0]:[I.ViewColumn.from(t.viewColumn),I.TextEditorOpenOptions.from(t)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[I.ViewColumn.from(t),void 0]:[I.ViewColumn.from(t.viewColumn),I.TextEditorOpenOptions.from(t)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[I.ViewColumn.from(t.viewColumn),I.TextEditorOpenOptions.from(t)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(I.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(I.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(I.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void),new D.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[D.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],D.ApiCommandResult.Void)];class p{static register(o){b.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=p;function E(t){return o=>{if(Array.isArray(o))return o.map(t)}}function m(t){if(!Array.isArray(t))return;const o=[];for(const a of t)M.isLocationLink(a)?o.push(I.DefinitionLink.to(a)):o.push(I.location.to(a));return o}}),define(De[197],Ie([1,0,15,58,4,7,2,70,25,8,6,27,5]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function E(m,t,o){const a=m.getProxy(p.MainContext.MainThreadComments);class g{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,t.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const s=this._commentControllers.get(f.handle);return s?s.value:f}else if(f&&f.$mid===7){const s=this._commentControllers.get(f.commentControlHandle);if(!s)return f;const h=s.getCommentThread(f.commentThreadHandle);return h?h.value:f}else if(f&&f.$mid===8){const s=this._commentControllers.get(f.thread.commentControlHandle);if(!s)return f;const h=s.getCommentThread(f.thread.commentThreadHandle);return h?{thread:h.value,text:f.text}:f}else if(f&&f.$mid===9){const s=this._commentControllers.get(f.thread.commentControlHandle);if(!s)return f;const h=s.getCommentThread(f.thread.commentThreadHandle);if(!h)return f;const v=f.commentUniqueId,P=h.getCommentByUniqueId(v);return P||f}else if(f&&f.$mid===10){const s=this._commentControllers.get(f.thread.commentControlHandle);if(!s)return f;const h=s.getCommentThread(f.thread.commentThreadHandle);if(!h)return f;const v=f.text,P=f.commentUniqueId,L=h.getCommentByUniqueId(P);return L?(typeof L.body=="string"?L.body=v:L.body.value=v,L):f}return f}})}createCommentController(f,s,h){const v=g.handlePool++,P=new d(f,v,s,h);this._commentControllers.set(P.handle,P);const L=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(f.identifier))||[];return L.push(P),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(f.identifier),L),P.value}$createCommentThreadTemplate(f,s,h){const v=this._commentControllers.get(f);!v||v.$createCommentThreadTemplate(s,h)}async $updateCommentThreadTemplate(f,s,h){const v=this._commentControllers.get(f);!v||v.$updateCommentThreadTemplate(s,h)}$deleteCommentThread(f,s){this._commentControllers.get(f)?.$deleteCommentThread(s)}$provideCommentingRanges(f,s,h){const v=this._commentControllers.get(f);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const P=o.getDocument(D.URI.revive(s));return(0,i.asPromise)(()=>v.commentingRangeProvider.provideCommentingRanges(P,h)).then(L=>L?L.map(j=>k.Range.from(j)):void 0)}$toggleReaction(f,s,h,v,P){const L=this._commentControllers.get(f);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const j=L.getCommentThread(s);if(j){const W=j.getCommentByUniqueId(v.uniqueIdInThread);if(L!==void 0&&W&&L.reactionHandler)return L.reactionHandler(W,c(P))}return Promise.resolve(void 0)})}dispose(){}}g.handlePool=0;class w{set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){f.isEqual(this._range)||(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get state(){return(0,b.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(f){(0,b.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=f,this.modifications.state=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(f,s,h,v,P,L,j,W){this._commentControllerHandle=s,this._id=h,this._uri=v,this._range=P,this._comments=L,this.extensionDescription=j,this._isTemplate=W,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputDisposables.value=new M.DisposableStore,this._id===void 0&&(this._id=`${f}.${this.handle}`),a.$createCommentThread(s,this.handle,this._id,this._uri,k.Range.from(this._range),j.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this._localDisposables.push({dispose:()=>{a.$deleteCommentThread(s,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(C){V.range=C},get comments(){return V.comments},set comments(C){V.comments=C},get collapsibleState(){return V.collapsibleState},set collapsibleState(C){V.collapsibleState=C},get canReply(){return V.canReply},set canReply(C){V.canReply=C},get contextValue(){return V.contextValue},set contextValue(C){V.contextValue=C},get label(){return V.label},set label(C){V.label=C},get state(){return V.state},set state(C){V.state=C},dispose:()=>{V.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new M.DisposableStore);const f=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),s={};f("range")&&(s.range=k.Range.from(this._range)),f("label")&&(s.label=this.label),f("contextValue")&&(s.contextValue=this.contextValue??null),f("comments")&&(s.comments=this._comments.map(h=>T(this,h,this._commentsMap))),f("collapsibleState")&&(s.collapseState=n(this._collapseState)),f("canReply")&&(s.canReply=this.canReply),f("state")&&(s.state=u(this._state)),f("isTemplate")&&(s.isTemplate=this._isTemplate),this.modifications={},a.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,s)}getCommentByUniqueId(f){for(const s of this._commentsMap){const h=s[0],v=s[1];if(f===v)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose())}}w._handlePool=0,He([(0,I.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class d{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(f){this._commentingRangeProvider=f,a.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,a.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(f,s,h,v){this._extension=f,this._handle=s,this._id=h,this._label=v,this._threads=new Map,a.$registerCommentController(this.handle,h,v);const P=this;this.value=Object.freeze({id:P.id,label:P.label,get options(){return P.options},set options(L){P.options=L},get commentingRangeProvider(){return P.commentingRangeProvider},set commentingRangeProvider(L){P.commentingRangeProvider=L},get reactionHandler(){return P.reactionHandler},set reactionHandler(L){P.reactionHandler=L},createCommentThread(L,j,W){return P.createCommentThread(L,j,W).value},dispose:()=>{P.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(f,s,h,v){if(typeof f=="string"){const P=new w(this.id,this.handle,f,s,h,v,this._extension,!1);return this._threads.set(P.handle,P),P}else{const P=new w(this.id,this.handle,void 0,f,s,h,this._extension,!1);return this._threads.set(P.handle,P),P}}$createCommentThreadTemplate(f,s){const h=new w(this.id,this.handle,void 0,D.URI.revive(f),k.Range.to(s),[],this._extension,!0);return h.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(f,s){const h=this._threads.get(f);h&&(h.range=k.Range.to(s))}$deleteCommentThread(f){this._threads.get(f)?.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._localDisposables.forEach(f=>f.dispose())}}function T(l,f,s){let h=s.get(f);h||(h=++l.commentHandle,s.set(f,h));const v=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:h,body:typeof f.body=="string"?f.body:k.MarkdownString.from(f.body),userName:f.author.name,userIconPath:v,label:f.label,commentReactions:f.reactions?f.reactions.map(P=>r(P)):void 0,timestamp:f.timestamp?.toJSON()}}function r(l){return{label:l.label,iconPath:l.iconPath?k.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function c(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?D.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function n(l){if(l!==void 0)switch(l){case R.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function u(l){if(l!==void 0)switch(l){case R.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new g}e.createExtHostComments=E}),define(De[198],Ie([1,0,23,5,26,14]),function(ie,e,i,I,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let D=class{constructor(R,b){this._mainThreadConsole=R.getProxy(I.MainContext.MainThreadConsole),this._includeStack=b.consoleForward.includeStack,this._logNative=b.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,b){const p=this,E=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){p._handleConsoleCall(R,b,E,arguments)}})}_handleConsoleCall(R,b,p,E){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:b,arguments:y(E,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,p,E)}};D=He([$e(0,M.IExtHostRpcService),$e(1,S.IExtHostInitDataService)],D),e.AbstractExtHostConsoleForwarder=D;const A=1e5;function y(k,R){const b=[];if(k.length)for(let p=0;p<k.length;p++){let E=k[p];if(typeof E>"u")E="undefined";else if(E instanceof Error){const m=E;m.stack?E=m.stack:E=m.toString()}b.push(E)}if(R){const p=new Error().stack;p&&b.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,i.safeStringify)(b);return p.length>A?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(De[98],Ie([1,0,2,5,6,3,14,11,18,10,19]),function(ie,e,i,I,S,M,D,A,y,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class ki{constructor(E,m){this._logService=m,this._provider=new Map,this._proxy=E.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,m){const t=ki._handlePool++;this._provider.set(t,{provider:E,extensionId:m}),this._proxy.$registerDecorationProvider(t,m.value);const o=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(a=>{if(!a){this._proxy.$onDidChange(t,null);return}const g=(0,y.asArray)(a);if(g.length<=ki._maxEventSize){this._proxy.$onDidChange(t,g);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",m.value,g.length);const w=g.map(r=>({uri:r,rank:(0,k.count)(r.path,"/")})),d=(0,y.groupBy)(w,(r,c)=>r.rank-c.rank||(0,k.compare)(r.uri.path,c.uri.path)),T=[];e:for(const r of d){let c;for(const n of r){const u=(0,R.dirname)(n.uri.path);if(c!==u&&(c=u,T.push(n.uri)>=ki._maxEventSize))break e}}this._proxy.$onDidChange(t,T)});return new S.Disposable(()=>{o?.dispose(),this._proxy.$unregisterDecorationProvider(t),this._provider.delete(t)})}async $provideDecorations(E,m,t){if(!this._provider.has(E))return Object.create(null);const o=Object.create(null),{provider:a,extensionId:g}=this._provider.get(E);return await Promise.all(m.map(async w=>{try{const{uri:d,id:T}=w,r=await Promise.resolve(a.provideFileDecoration(i.URI.revive(d),t));if(!r)return;try{S.FileDecoration.validate(r),o[T]=[r.propagate,r.tooltip,r.badge,r.color]}catch(c){this._logService.warn(`INVALID decoration from extension '${g.value}': ${c}`)}}catch(d){this._logService.error(d)}})),o}};b._handlePool=0,b._maxEventSize=250,b=He([$e(0,D.IExtHostRpcService),$e(1,A.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,S){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?S.call(ie,i):S?S.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[199],Ie([1,0,131,86,2,5,6,8,4,11,28,36]),function(ie,e,i,I,S,M,D,A,y,k,R,b){"use strict";var p,E,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class t{constructor(g,w,d,T,r,c,n){this._name=g,this._owner=w,this._maxDiagnosticsPerFile=d,this._modelVersionIdProvider=T,p.set(this,void 0),E.set(this,void 0),m.set(this,void 0),this._isDisposed=!1,Ye(this,m,new R.ResourceMap(u=>r.getComparisonKey(u)),"f"),Ye(this,p,c,"f"),Ye(this,E,n,"f")}dispose(){this._isDisposed||(Ae(this,E,"f").fire([...Ae(this,m,"f").keys()]),Ae(this,p,"f")?.$clear(this._owner),Ae(this,m,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(g,w){if(!g){this.clear();return}this._checkDisposed();let d=[];if(S.URI.isUri(g)){if(!w){this.delete(g);return}Ae(this,m,"f").set(g,w.slice()),d=[g]}else if(Array.isArray(g)){d=[];let r;g=[...g].sort(t._compareIndexedTuplesByUri);for(const c of g){const[n,u]=c;if((!r||n.toString()!==r.toString())&&(r&&Ae(this,m,"f").get(r).length===0&&Ae(this,m,"f").delete(r),r=n,d.push(n),Ae(this,m,"f").set(n,[])),u)Ae(this,m,"f").get(n)?.push(...u);else{const l=Ae(this,m,"f").get(n);l&&(l.length=0)}}}if(Ae(this,E,"f").fire(d),!Ae(this,p,"f"))return;const T=[];for(const r of d){let c=[];const n=Ae(this,m,"f").get(r);if(n)if(n.length>this._maxDiagnosticsPerFile){c=[];const u=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const f of n)if(f.severity===u[l]&&c.push({...A.Diagnostic.from(f),modelVersionId:this._modelVersionIdProvider(r)})===this._maxDiagnosticsPerFile)break e;c.push({severity:I.MarkerSeverity.Info,message:(0,i.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=n.map(u=>({...A.Diagnostic.from(u),modelVersionId:this._modelVersionIdProvider(r)}));T.push([r,c])}Ae(this,p,"f").$changeMany(this._owner,T)}delete(g){this._checkDisposed(),Ae(this,E,"f").fire([g]),Ae(this,m,"f").delete(g),Ae(this,p,"f")?.$changeMany(this._owner,[[g,void 0]])}clear(){this._checkDisposed(),Ae(this,E,"f").fire([...Ae(this,m,"f").keys()]),Ae(this,m,"f").clear(),Ae(this,p,"f")?.$clear(this._owner)}forEach(g,w){this._checkDisposed();for(const[d,T]of this)g.call(w,d,T,this)}*[(p=new WeakMap,E=new WeakMap,m=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const g of Ae(this,m,"f").keys())yield[g,this.get(g)]}get(g){this._checkDisposed();const w=Ae(this,m,"f").get(g);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(g){return this._checkDisposed(),Array.isArray(Ae(this,m,"f").get(g))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(g,w){return g[0].toString()<w[0].toString()?-1:g[0].toString()>w[0].toString()?1:0}}e.DiagnosticCollection=t;let o=class fi{static _mapper(g){const w=new R.ResourceMap;for(const d of g)w.set(d,d);return{uris:Object.freeze(Array.from(w.values()))}}constructor(g,w,d,T){this._logService=w,this._fileSystemInfoService=d,this._extHostDocumentsAndEditors=T,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,fi._mapper),this._proxy=g.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(g,w){const{_collections:d,_proxy:T,_onDidChangeDiagnostics:r,_logService:c,_fileSystemInfoService:n,_extHostDocumentsAndEditors:u}=this,l=new class{$changeMany(h,v){T.$changeMany(h,v),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,h,v.length===0?"CLEARING":v)}$clear(h){T.$clear(h),c.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,h)}dispose(){T.dispose()}};let f;if(!w)w="_generated_diagnostic_collection_name_#"+fi._idPool++,f=w;else if(!d.has(w))f=w;else{this._logService.warn(`DiagnosticCollection with name '${w}' does already exist.`);do f=w+fi._idPool++;while(d.has(f))}return new class extends t{constructor(){super(w,f,fi._maxDiagnosticsPerFile,h=>u.getDocument(h)?.version,n.extUri,l,r),d.set(f,this)}dispose(){super.dispose(),d.delete(f)}}}getDiagnostics(g){if(g)return this._getDiagnostics(g);{const w=new Map,d=[];for(const T of this._collections.values())T.forEach((r,c)=>{let n=w.get(r.toString());typeof n>"u"&&(n=d.length,w.set(r.toString(),n),d.push([r,[]])),d[n][1]=d[n][1].concat(...c)});return d}}_getDiagnostics(g){let w=[];for(const d of this._collections.values())d.has(g)&&(w=w.concat(d.get(g)));return w}$acceptMarkersChange(g){if(!this._mirrorCollection){const w="_generated_mirror",d=new t(w,w,fi._maxDiagnosticsPerFile,T=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(w,d),this._mirrorCollection=d}for(const[w,d]of g)this._mirrorCollection.set(S.URI.revive(w),d.map(A.Diagnostic.to))}};o._idPool=0,o._maxDiagnosticsPerFile=1e3,o=He([$e(1,k.ILogService),$e(2,b.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(De[200],Ie([1,0,2,5]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(D){this._proxy=D.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(A=>A?A.map(y=>i.URI.revive(y)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(A=>A?i.URI.revive(A):void 0)}}e.ExtHostDialogs=S}),define(De[201],Ie([1,0,12,2,6,5,13,20,10]),function(ie,e,i,I,S,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(b,p,E){this._documentsAndEditors=p,this._logService=E,this._documentContentProviders=new Map,this._proxy=b.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,p){if(Object.keys(D.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const E=k._handlePool++;this._documentContentProviders.set(E,p),this._proxy.$registerTextContentProvider(E,b);let m;return typeof p.onDidChange=="function"&&(m=p.onDidChange(t=>{if(t.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${t.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(t)&&this.$provideTextDocumentContent(E,t).then(o=>{if(!o&&typeof o!="string")return;const a=this._documentsAndEditors.getDocument(t);if(!a)return;const g=(0,y.splitLines)(o);if(!a.equalLines(g))return this._proxy.$onVirtualDocumentChange(t,o)},i.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(b,p){const E=this._documentContentProviders.get(b);return E?Promise.resolve(E.provideTextDocumentContent(I.URI.revive(p),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(De[202],Ie([1,0,4,7,2,5,94,8,9,23,6]),function(ie,e,i,I,S,M,D,A,y,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(E,m){this._onDidAddDocument=new i.Emitter,this._onDidRemoveDocument=new i.Emitter,this._onDidChangeDocument=new i.Emitter,this._onDidSaveDocument=new i.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(M.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(t=>{for(const o of t)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(t=>{for(const o of t)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const m=this._documentsAndEditors.getDocument(E);if(m)return m}getDocument(E){const m=this.getDocumentData(E);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return m.document}ensureDocumentData(E){const m=this._documentsAndEditors.getDocument(E);if(m)return Promise.resolve(m);let t=this._documentLoader.get(E.toString());return t||(t=this._proxy.$tryOpenDocument(E).then(o=>{this._documentLoader.delete(E.toString());const a=S.URI.revive(o);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(a))},o=>(this._documentLoader.delete(E.toString()),Promise.reject(o))),this._documentLoader.set(E.toString(),t)),t}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(m=>S.URI.revive(m))}$acceptModelLanguageChanged(E,m){const t=S.URI.revive(E),o=this._documentsAndEditors.getDocument(t);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(m),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(E){const m=S.URI.revive(E),t=this._documentsAndEditors.getDocument(m);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(t.document)}$acceptDirtyStateChanged(E,m){const t=S.URI.revive(E),o=this._documentsAndEditors.getDocument(t);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this._onDidChangeDocument.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,m,t){const o=S.URI.revive(E),a=this._documentsAndEditors.getDocument(o);if(!a)throw new Error("unknown document");a._acceptIsDirty(t),a.onEvents(m);let g;m.isUndoing?g=R.TextDocumentChangeReason.Undo:m.isRedoing&&(g=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:a.document,contentChanges:m.changes.map(w=>({range:A.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text})),reason:g}))}setWordDefinitionFor(E,m){(0,D.setWordDefinitionFor)(E,m)}}e.ExtHostDocuments=b}),define(De[53],Ie([1,0,47,4,7,2,3,5,94,14,97,8,11,28,13,172,203]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class a{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let g=class{constructor(d,T){this._extHostRpc=d,this._logService=T,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const T=[],r=[],c=[];if(d.removedDocuments)for(const n of d.removedDocuments){const u=M.URI.revive(n),l=this._documents.get(u);l?.unref()&&(this._documents.delete(u),T.push(l.value))}if(d.addedDocuments)for(const n of d.addedDocuments){const u=M.URI.revive(n.uri);let l=this._documents.get(u);if(l&&u.scheme!==m.Schemas.vscodeNotebookCell&&u.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);l||(l=new a(new y.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),u,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(u,l),r.push(l.value)),l.ref()}if(d.removedEditors)for(const n of d.removedEditors){const u=this._editors.get(n);this._editors.delete(n),u&&c.push(u)}if(d.addedEditors)for(const n of d.addedEditors){const u=M.URI.revive(n.documentUri);i.ok(this._documents.has(u),`document '${u}' does not exist`),i.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const l=this._documents.get(u).value,f=new R.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new o.Lazy(()=>l.document),n.selections.map(b.Selection.to),n.options,n.visibleRanges.map(s=>b.Range.to(s)),typeof n.editorPosition=="number"?b.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,f)}d.newActiveEditor!==void 0&&(i.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),(0,S.dispose)(T),(0,S.dispose)(c),d.removedDocuments&&this._onDidRemoveDocuments.fire(T),d.addedDocuments&&this._onDidAddDocuments.fire(r),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){return this._documents.get(d)?.value}allDocuments(){return t.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const T=this._editors.get(this._activeEditorId);return d?T:T?.value}allEditors(){return[...this._editors.values()]}};g=He([$e(0,k.IExtHostRpcService),$e(1,p.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[54],Ie([1,0,8,5,2,4,3,6,14,9,77]),function(ie,e,i,I,S,M,D,A,y,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class b{constructor(o,a,g){this._activeTabIdGetter=g,this._parentGroup=a,this.acceptDtoUpdate(o)}get apiObject(){if(!this._apiObject){const o=this,a={get isActive(){return o._dto.id===o._activeTabIdGetter()},get label(){return o._dto.label},get input(){return o._input},get isDirty(){return o._dto.isDirty},get isPinned(){return o._dto.isPinned},get isPreview(){return o._dto.isPreview},get group(){return o._parentGroup.apiObject}};this._apiObject=Object.freeze(a)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(o){this._dto=o,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(S.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(S.URI.revive(this._dto.input.original),S.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(S.URI.revive(this._dto.input.base),S.URI.revive(this._dto.input.input1),S.URI.revive(this._dto.input.input2),S.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(S.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(S.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(S.URI.revive(this._dto.input.original),S.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(S.URI.revive(this._dto.input.uri),S.URI.revive(this._dto.input.inputBoxUri));default:return}}}class p{constructor(o,a){this._tabs=[],this._activeTabId="",this._dto=o,this._activeGroupIdGetter=a;for(const g of o.tabs)g.isActive&&(this._activeTabId=g.id),this._tabs.push(new b(g,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const o=this,a={get isActive(){return o._dto.groupId===o._activeGroupIdGetter()},get viewColumn(){return i.ViewColumn.to(o._dto.viewColumn)},get activeTab(){return o._tabs.find(g=>g.tabId===o._activeTabId)?.apiObject},get tabs(){return Object.freeze(o._tabs.map(g=>g.apiObject))}};this._apiObject=Object.freeze(a)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(o){this._dto=o}acceptTabOperation(o){if(o.kind===0){const g=new b(o.tabDto,this,()=>this.activeTabId());return this._tabs.splice(o.index,0,g),o.tabDto.isActive&&(this._activeTabId=g.tabId),g}else if(o.kind===1){const g=this._tabs.splice(o.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return g.tabId===this._activeTabId&&(this._activeTabId=""),g}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this._tabs.splice(o.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this._tabs.splice(o.index,0,g),g}const a=this._tabs.find(g=>g.tabId===o.tabDto.id);if(!a)throw new Error("INVALID tab");return o.tabDto.isActive?this._activeTabId=o.tabDto.id:this._activeTabId===o.tabDto.id&&!o.tabDto.isActive&&(this._activeTabId=""),a.acceptDtoUpdate(o.tabDto),a}activeTabId(){return this._activeTabId}}let E=class{constructor(o){this._onDidChangeTabs=new M.Emitter,this._onDidChangeTabGroups=new M.Emitter,this._extHostTabGroups=[],this._proxy=o.getProxy(I.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const o=this,a={onDidChangeTabGroups:o._onDidChangeTabGroups.event,onDidChangeTabs:o._onDidChangeTabs.event,get all(){return Object.freeze(o._extHostTabGroups.map(g=>g.apiObject))},get activeTabGroup(){const g=o._activeGroupId;return(0,k.assertIsDefined)(o._extHostTabGroups.find(d=>d.groupId===g)?.apiObject)},close:async(g,w)=>{const d=Array.isArray(g)?g:[g];return d.length?m(d[0])?this._closeGroups(d,w):this._closeTabs(d,w):!0}};this._apiObject=Object.freeze(a)}return this._apiObject}$acceptEditorTabModel(o){const a=new Set(this._extHostTabGroups.map(n=>n.groupId)),g=new Set(o.map(n=>n.groupId)),w=(0,R.diffSets)(a,g),d=this._extHostTabGroups.filter(n=>w.removed.includes(n.groupId)).map(n=>n.apiObject),T=[],r=[];this._extHostTabGroups=o.map(n=>{const u=new p(n,()=>this._activeGroupId);return w.added.includes(u.groupId)?T.push(u.apiObject):r.push(u.apiObject),u});const c=(0,k.assertIsDefined)(o.find(n=>n.isActive===!0)?.groupId);c!==void 0&&this._activeGroupId!==c&&(this._activeGroupId=c),this._onDidChangeTabGroups.fire(Object.freeze({opened:T,closed:d,changed:r}))}$acceptTabGroupUpdate(o){const a=this._extHostTabGroups.find(g=>g.groupId===o.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(o),o.isActive&&(this._activeGroupId=o.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const a=this._extHostTabGroups.find(w=>w.groupId===o.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const g=a.acceptTabOperation(o);switch(o.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}_findExtHostTabFromApi(o){for(const a of this._extHostTabGroups)for(const g of a.tabs)if(g.apiObject===o)return g}_findExtHostTabGroupFromApi(o){return this._extHostTabGroups.find(a=>a.apiObject===o)}async _closeTabs(o,a){const g=[];for(const w of o){const d=this._findExtHostTabFromApi(w);if(!d)throw new Error("Tab close: Invalid tab not found!");g.push(d.tabId)}return this._proxy.$closeTab(g,a)}async _closeGroups(o,a){const g=[];for(const w of o){const d=this._findExtHostTabGroupFromApi(w);if(!d)throw new Error("Group close: Invalid group not found!");g.push(d.groupId)}return this._proxy.$closeGroup(g,a)}};E=He([$e(0,y.IExtHostRpcService)],E),e.ExtHostEditorTabs=E;function m(t){return t.tabs!==void 0}}),define(De[204],Ie([1,0,2,5,7,6,8,249,10,24,27]),function(ie,e,i,I,S,M,D,A,y,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class b{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const t=this._schemes.indexOf(m);t>=0&&(this._schemes.splice(t,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),t=[];let o,a,g=14,w=14;for(const d of m){let T=o?(0,y.commonPrefixLength)(o,d):0;for(T===0?a=1:a=w;T<d.length;T++)T+1===d.length?(g=w,w=9):w+=1,t.push([a,d.toUpperCase().charCodeAt(T),w]),t.push([a,d.toLowerCase().charCodeAt(T),w]),a=w;o=d,w=g}t.push([9,58,10]),t.push([10,47,12]),this._stateMachine=new A.StateMachine(t)}}provideDocumentLinks(m){this._initStateMachine();const t=[],o=A.LinkComputer.computeLinks({getLineContent(a){return m.lineAt(a-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const a of o){const g=D.DocumentLink.to(a);g.target&&t.push(g)}return t}}class p{constructor(m,t){this._extHostLanguageFeatures=t,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(m,t,o,a={}){if(this._registeredSchemes.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(m,"*",this._linkProvider));const g=this._handlePool++;this._linkProvider.add(t),this._registeredSchemes.add(t),this._fsProvider.set(g,o);let w=2;a.isCaseSensitive&&(w+=1024),a.isReadonly&&(w+=2048),typeof o.copy=="function"&&(w+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,R.checkProposedApiEnabled)(m,"fsChunks"),w+=4),this._proxy.$registerFileSystemProvider(g,t,w).catch(T=>{console.error(`FAILED to register filesystem provider of ${m.identifier.value}-extension for the scheme ${t}`),console.error(T)});const d=o.onDidChangeFile(T=>{const r=[];for(const c of T){const{uri:n,type:u}=c;if(n.scheme!==t)continue;let l;switch(u){case M.FileChangeType.Changed:l=0;break;case M.FileChangeType.Created:l=1;break;case M.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:n,type:l})}this._proxy.$onFileSystemChange(g,r)});return(0,S.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(t),this._registeredSchemes.delete(t),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(m){const{type:t,ctime:o,mtime:a,size:g,permissions:w}=m;return{type:t,ctime:o,mtime:a,size:g,permissions:w}}$stat(m,t){return Promise.resolve(this._getFsProvider(m).stat(i.URI.revive(t))).then(o=>p._asIStat(o))}$readdir(m,t){return Promise.resolve(this._getFsProvider(m).readDirectory(i.URI.revive(t)))}$readFile(m,t){return Promise.resolve(this._getFsProvider(m).readFile(i.URI.revive(t))).then(o=>k.VSBuffer.wrap(o))}$writeFile(m,t,o,a){return Promise.resolve(this._getFsProvider(m).writeFile(i.URI.revive(t),o.buffer,a))}$delete(m,t,o){return Promise.resolve(this._getFsProvider(m).delete(i.URI.revive(t),o))}$rename(m,t,o,a){return Promise.resolve(this._getFsProvider(m).rename(i.URI.revive(t),i.URI.revive(o),a))}$copy(m,t,o,a){const g=this._getFsProvider(m);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(i.URI.revive(t),i.URI.revive(o),a))}$mkdir(m,t){return Promise.resolve(this._getFsProvider(m).createDirectory(i.URI.revive(t)))}$watch(m,t,o,a){const g=this._getFsProvider(m).watch(i.URI.revive(o),a);this._watches.set(t,g)}$unwatch(m,t){const o=this._watches.get(t);o&&(o.dispose(),this._watches.delete(t))}$open(m,t,o){const a=this._getFsProvider(m);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(i.URI.revive(t),o))}$close(m,t){const o=this._getFsProvider(m);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(t))}$read(m,t,o,a){const g=this._getFsProvider(m);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const w=k.VSBuffer.alloc(a);return Promise.resolve(g.read(t,o,w.buffer,0,a)).then(d=>w.slice(0,d))}$write(m,t,o,a){const g=this._getFsProvider(m);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(t,o,a.buffer,0,a.byteLength))}_getFsProvider(m){const t=this._fsProvider.get(m);if(!t){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return t}}e.ExtHostFileSystem=p}),define(De[55],Ie([1,0,5,35,6,24,3,14,36,7]),function(ie,e,i,I,S,M,D,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Yt{constructor(p,E){this._fileSystemProvider=new Map,this._proxy=p.getProxy(i.MainContext.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(t){try{const o=m._fileSystemProvider.get(t.scheme);if(!o)return await m._proxy.$stat(t);await m._proxy.$ensureActivation(t.scheme);const a=await o.stat(t);return{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions}}catch(o){Yt._handleError(o)}},async readDirectory(t){try{const o=m._fileSystemProvider.get(t.scheme);return o?(await m._proxy.$ensureActivation(t.scheme),(await o.readDirectory(t)).slice()):await m._proxy.$readdir(t)}catch(o){return Yt._handleError(o)}},async createDirectory(t){try{return await m._proxy.$mkdir(t)}catch(o){return Yt._handleError(o)}},async readFile(t){try{const o=m._fileSystemProvider.get(t.scheme);return o?(await m._proxy.$ensureActivation(t.scheme),(await o.readFile(t)).slice()):(await m._proxy.$readFile(t)).buffer}catch(o){return Yt._handleError(o)}},async writeFile(t,o){try{return await m._proxy.$writeFile(t,M.VSBuffer.wrap(o))}catch(a){return Yt._handleError(a)}},async delete(t,o){try{const a=m._fileSystemProvider.get(t.scheme);return a?(await m._proxy.$ensureActivation(t.scheme),await a.delete(t,{recursive:!1,...o})):await m._proxy.$delete(t,{recursive:!1,useTrash:!1,...o})}catch(a){return Yt._handleError(a)}},async rename(t,o,a){try{return await m._proxy.$rename(t,o,{overwrite:!1,...a})}catch(g){return Yt._handleError(g)}},async copy(t,o,a){try{return await m._proxy.$copy(t,o,{overwrite:!1,...a})}catch(g){return Yt._handleError(g)}},isWritableFileSystem(t){const o=E.getCapabilities(t);if(typeof o=="number")return!(o&2048)}})}static _handleError(p){if(p instanceof S.FileSystemError)throw p;if(!(p instanceof Error))throw new S.FileSystemError(String(p));if(p.name==="ENOPRO")throw S.FileSystemError.Unavailable(p.message);switch(p.name){case I.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(p.message);case I.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(p.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(p.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(p.message);case I.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(p.message);case I.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(p.message);default:throw new S.FileSystemError(p.message,p.name)}}addFileSystemProvider(p,E){return this._fileSystemProvider.set(p,E),(0,k.toDisposable)(()=>this._fileSystemProvider.delete(p))}};R=He([$e(0,A.IExtHostRpcService),$e(1,y.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(De[205],Ie([1,0,4,34,2,5,8,6]),function(ie,e,i,I,S,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(b,p,E,m,t,o,a,g){this._onDidCreate=new i.Emitter,this._onDidChange=new i.Emitter,this._onDidDelete=new i.Emitter;const w=this.ensureWatching(b,E,t);this._config=0,o&&(this._config+=1),a&&(this._config+=2),g&&(this._config+=4);const d=(0,I.parse)(t),T=typeof t=="string",r=m(c=>{if(!o)for(const n of c.created){const u=S.URI.revive(n);d(u.fsPath)&&(!T||p.getWorkspaceFolder(u))&&this._onDidCreate.fire(u)}if(!a)for(const n of c.changed){const u=S.URI.revive(n);d(u.fsPath)&&(!T||p.getWorkspaceFolder(u))&&this._onDidChange.fire(u)}if(!g)for(const n of c.deleted){const u=S.URI.revive(n);d(u.fsPath)&&(!T||p.getWorkspaceFolder(u))&&this._onDidDelete.fire(u)}});this._disposable=A.Disposable.from(w,this._onDidCreate,this._onDidChange,this._onDidDelete,r)}ensureWatching(b,p,E){const m=A.Disposable.from();if(typeof E=="string")return m;const t=b.getProxy(M.MainContext.MainThreadFileSystem);let o=!1;(E.pattern.includes(I.GLOBSTAR)||E.pattern.includes(I.GLOB_SPLIT))&&(o=!0);const a=Math.random();return t.$watch(p.identifier.value,a,E.baseUri,{recursive:o,excludes:[]}),A.Disposable.from({dispose:()=>t.$unwatch(a)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(b,p,E){this._mainContext=b,this._logService=p,this._extHostDocumentsAndEditors=E,this._onFileSystemEvent=new i.Emitter,this._onDidRenameFile=new i.Emitter,this._onDidCreateFile=new i.Emitter,this._onDidDeleteFile=new i.Emitter,this._onWillRenameFile=new i.AsyncEmitter,this._onWillCreateFile=new i.AsyncEmitter,this._onWillDeleteFile=new i.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(b,p,E,m,t,o){return new y(this._mainContext,b,p,this._onFileSystemEvent.event,D.GlobPattern.from(E),m,t,o)}$onFileEvent(b){this._onFileSystemEvent.fire(b)}$onDidRunFileOperation(b,p){switch(b){case 2:this._onDidRenameFile.fire(Object.freeze({files:p.map(E=>({oldUri:S.URI.revive(E.source),newUri:S.URI.revive(E.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:p.map(E=>S.URI.revive(E.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:p.map(E=>S.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(b){return this._createWillExecuteEvent(b,this._onWillRenameFile)}getOnWillCreateFileEvent(b){return this._createWillExecuteEvent(b,this._onWillCreateFile)}getOnWillDeleteFileEvent(b){return this._createWillExecuteEvent(b,this._onWillDeleteFile)}_createWillExecuteEvent(b,p){return(E,m,t)=>{const o=function(g){E.call(m,g)};return o.extension=b,p.event(o,void 0,t)}}async $onWillRunFileOperation(b,p,E,m){switch(b){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:p.map(t=>({oldUri:S.URI.revive(t.source),newUri:S.URI.revive(t.target)}))},E,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:p.map(t=>S.URI.revive(t.target))},E,m);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:p.map(t=>S.URI.revive(t.target))},E,m)}}async _fireWillEvent(b,p,E,m){const t=new Set,o=[];if(await b.fireAsync(p,m,async(g,w)=>{const d=Date.now(),T=await Promise.resolve(g);T instanceof A.WorkspaceEdit&&(o.push([w.extension,T]),t.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-d>E&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),m.isCancellationRequested||o.length===0)return;const a={edits:[]};for(const[,g]of o){const{edits:w}=D.WorkspaceEdit.from(g,{getTextDocumentVersion:d=>this._extHostDocumentsAndEditors.getDocument(d)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(w)}return{edit:a,extensionNames:Array.from(t)}}}e.ExtHostFileSystemEventService=k}),define(De[206],Ie([1,0,2,37]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class S{constructor(D,A,y,k,R){this._extHostNotebooks=A,this._textDocumentsAndEditors=y,this._commands=k;const b=new I.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new I.ApiCommandArgument("showOptions","Show Options",p=>!0,p=>p),new I.ApiCommandArgument("resource","Interactive resource Uri",p=>!0,p=>p),new I.ApiCommandArgument("controllerId","Notebook controller Id",p=>!0,p=>p),new I.ApiCommandArgument("title","Interactive editor title",p=>!0,p=>p)],new I.ApiCommandResult("Notebook and input URI",p=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const E=this._extHostNotebooks.getEditorById(p.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:i.URI.revive(p.notebookUri),inputUri:i.URI.revive(p.inputUri),notebookEditor:E.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:i.URI.revive(p.notebookUri),inputUri:i.URI.revive(p.inputUri)}}));this._commands.registerApiCommand(b)}$willAddInteractiveDocument(D,A,y,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:D,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(i.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=S}),define(De[207],Ie([1,0,7,5]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(D){this._handlePool=0,this._proxy=D.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,D),(0,i.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=S}),define(De[208],Ie([1,0,2,23,8,6,70,5,10,52,18,9,250,20,7,83,78,63,209,12,15,27]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o,a,g,w,d,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class r{constructor(_,N){this._documents=_,this._provider=N}async provideDocumentSymbols(_,N){const $=this._documents.getDocument(_),q=await this._provider.provideDocumentSymbols($,N);if(!(0,R.isFalsyOrEmpty)(q))return q[0]instanceof M.DocumentSymbol?q.map(S.DocumentSymbol.from):r._asDocumentSymbolTree(q)}static _asDocumentSymbolTree(_){_=_.slice(0).sort((q,Z)=>{let ce=q.location.range.start.compareTo(Z.location.range.start);return ce===0&&(ce=Z.location.range.end.compareTo(q.location.range.end)),ce});const N=[],$=[];for(const q of _){const Z={name:q.name||"!!MISSING: name!!",kind:S.SymbolKind.from(q.kind),tags:q.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:S.Range.from(q.location.range),selectionRange:S.Range.from(q.location.range),children:[]};for(;;){if($.length===0){$.push(Z),N.push(Z);break}const ce=$[$.length-1];if(k.Range.containsRange(ce.range,Z.range)&&!k.Range.equalsRange(ce.range,Z.range)){ce.children?.push(Z),$.push(Z);break}$.pop()}}return N}}class c{constructor(_,N,$){this._documents=_,this._commands=N,this._provider=$,this._cache=new a.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(_,N){const $=this._documents.getDocument(_),q=await this._provider.provideCodeLenses($,N);if(!q||N.isCancellationRequested)return;const Z=this._cache.add(q),ce=new m.DisposableStore;this._disposables.set(Z,ce);const be={cacheId:Z,lenses:[]};for(let oe=0;oe<q.length;oe++)be.lenses.push({cacheId:[Z,oe],range:S.Range.from(q[oe].range),command:this._commands.toInternal(q[oe].command,ce)});return be}async resolveCodeLens(_,N){const $=_.cacheId&&this._cache.get(..._.cacheId);if(!$)return;let q;if(typeof this._provider.resolveCodeLens!="function"||$.isResolved?q=$:q=await this._provider.resolveCodeLens($,N),q||(q=$),N.isCancellationRequested)return;const Z=_.cacheId&&this._disposables.get(_.cacheId[0]);if(!!Z)return _.command=this._commands.toInternal(q.command??c._badCmd,Z),_}releaseCodeLenses(_){this._disposables.get(_)?.dispose(),this._disposables.delete(_),this._cache.delete(_)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function n(J){return Array.isArray(J)?J.map(S.DefinitionLink.from):J?[S.DefinitionLink.from(J)]:[]}class u{constructor(_,N){this._documents=_,this._provider=N}async provideDefinition(_,N,$){const q=this._documents.getDocument(_),Z=S.Position.to(N),ce=await this._provider.provideDefinition(q,Z,$);return n(ce)}}class l{constructor(_,N){this._documents=_,this._provider=N}async provideDeclaration(_,N,$){const q=this._documents.getDocument(_),Z=S.Position.to(N),ce=await this._provider.provideDeclaration(q,Z,$);return n(ce)}}class f{constructor(_,N){this._documents=_,this._provider=N}async provideImplementation(_,N,$){const q=this._documents.getDocument(_),Z=S.Position.to(N),ce=await this._provider.provideImplementation(q,Z,$);return n(ce)}}class s{constructor(_,N){this._documents=_,this._provider=N}async provideTypeDefinition(_,N,$){const q=this._documents.getDocument(_),Z=S.Position.to(N),ce=await this._provider.provideTypeDefinition(q,Z,$);return n(ce)}}class h{constructor(_,N){this._documents=_,this._provider=N}async provideHover(_,N,$){const q=this._documents.getDocument(_),Z=S.Position.to(N),ce=await this._provider.provideHover(q,Z,$);if(!(!ce||(0,R.isFalsyOrEmpty)(ce.contents)))return ce.range||(ce.range=q.getWordRangeAtPosition(Z)),ce.range||(ce.range=new M.Range(Z,Z)),S.Hover.from(ce)}}class v{constructor(_,N){this._documents=_,this._provider=N}async provideEvaluatableExpression(_,N,$){const q=this._documents.getDocument(_),Z=S.Position.to(N),ce=await this._provider.provideEvaluatableExpression(q,Z,$);if(ce)return S.EvaluatableExpression.from(ce)}}class P{constructor(_,N){this._documents=_,this._provider=N}async provideInlineValues(_,N,$,q){const Z=this._documents.getDocument(_),ce=await this._provider.provideInlineValues(Z,S.Range.to(N),S.InlineValueContext.to($),q);if(Array.isArray(ce))return ce.map(be=>S.InlineValue.from(be))}}class L{constructor(_,N){this._documents=_,this._provider=N}async provideDocumentHighlights(_,N,$){const q=this._documents.getDocument(_),Z=S.Position.to(N),ce=await this._provider.provideDocumentHighlights(q,Z,$);if(Array.isArray(ce))return ce.map(S.DocumentHighlight.from)}}class j{constructor(_,N){this._documents=_,this._provider=N}async provideLinkedEditingRanges(_,N,$){const q=this._documents.getDocument(_),Z=S.Position.to(N),ce=await this._provider.provideLinkedEditingRanges(q,Z,$);if(ce&&Array.isArray(ce.ranges))return{ranges:(0,R.coalesce)(ce.ranges.map(S.Range.from)),wordPattern:ce.wordPattern}}}class W{constructor(_,N){this._documents=_,this._provider=N}async provideReferences(_,N,$,q){const Z=this._documents.getDocument(_),ce=S.Position.to(N),be=await this._provider.provideReferences(Z,ce,$,q);if(Array.isArray(be))return be.map(S.location.from)}}class V{constructor(_,N,$,q,Z,ce,be){this._documents=_,this._commands=N,this._diagnostics=$,this._provider=q,this._logService=Z,this._extension=ce,this._apiDeprecation=be,this._cache=new a.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(_,N,$,q){const Z=this._documents.getDocument(_),ce=p.Selection.isISelection(N)?S.Selection.to(N):S.Range.to(N),be=[];for(const et of this._diagnostics.getDiagnostics(_))if(ce.intersection(et.range)&&be.push(et)>V._maxCodeActionsPerFile)break;const oe={diagnostics:be,only:$.only?new M.CodeActionKind($.only):void 0,triggerKind:S.CodeActionTriggerKind.to($.trigger)},we=await this._provider.provideCodeActions(Z,ce,oe,q);if(!(0,R.isNonEmptyArray)(we)||q.isCancellationRequested)return;const ve=this._cache.add(we),Ue=new m.DisposableStore;this._disposables.set(ve,Ue);const ze=[];for(let et=0;et<we.length;et++){const Ke=we[et];!Ke||(V._isCommand(Ke)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ze.push({_isSynthetic:!0,title:Ke.title,command:this._commands.toInternal(Ke,Ue)})):(oe.only&&(Ke.kind?oe.only.contains(Ke.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${oe.only.value} 'requested but returned code action is of kind '${Ke.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ze.push({cacheId:[ve,et],title:Ke.title,command:Ke.command&&this._commands.toInternal(Ke.command,Ue),diagnostics:Ke.diagnostics&&Ke.diagnostics.map(S.Diagnostic.from),edit:Ke.edit&&S.WorkspaceEdit.from(Ke.edit,void 0),kind:Ke.kind&&Ke.kind.value,isPreferred:Ke.isPreferred,disabled:Ke.disabled?.reason})))}return{cacheId:ve,actions:ze}}async resolveCodeAction(_,N){const[$,q]=_,Z=this._cache.get($,q);if(!Z||V._isCommand(Z)||!this._provider.resolveCodeAction)return;const ce=await this._provider.resolveCodeAction(Z,N)??Z;return ce?.edit?S.WorkspaceEdit.from(ce.edit,void 0):void 0}releaseCodeActions(_){this._disposables.get(_)?.dispose(),this._disposables.delete(_),this._cache.delete(_)}static _isCommand(_){return typeof _.command=="string"&&typeof _.title=="string"}}V._maxCodeActionsPerFile=1e3;class C{constructor(_,N,$,q){this._proxy=_,this._documents=N,this._provider=$,this._handle=q}async prepareDocumentPaste(_,N,$,q){if(!this._provider.prepareDocumentPaste)return;const Z=this._documents.getDocument(_),ce=N.map(oe=>S.Range.to(oe)),be=S.DataTransfer.toDataTransfer($,()=>{throw new w.NotImplementedError});return await this._provider.prepareDocumentPaste(Z,ce,be,q),S.DataTransfer.toDataTransferDTO(be)}async providePasteEdits(_,N,$,q,Z){const ce=this._documents.getDocument(N),be=$.map(ve=>S.Range.to(ve)),oe=S.DataTransfer.toDataTransfer(q,async ve=>(await this._proxy.$resolvePasteFileData(this._handle,_,ve)).buffer),we=await this._provider.provideDocumentPasteEdits(ce,be,oe,Z);if(!!we)return{insertText:typeof we.insertText=="string"?we.insertText:{snippet:we.insertText.value},additionalEdit:we.additionalEdit?S.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}}class F{constructor(_,N){this._documents=_,this._provider=N}async provideDocumentFormattingEdits(_,N,$){const q=this._documents.getDocument(_),Z=await this._provider.provideDocumentFormattingEdits(q,N,$);if(Array.isArray(Z))return Z.map(S.TextEdit.from)}}class O{constructor(_,N){this._documents=_,this._provider=N}async provideDocumentRangeFormattingEdits(_,N,$,q){const Z=this._documents.getDocument(_),ce=S.Range.to(N),be=await this._provider.provideDocumentRangeFormattingEdits(Z,ce,$,q);if(Array.isArray(be))return be.map(S.TextEdit.from)}}class x{constructor(_,N){this._documents=_,this._provider=N,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(_,N,$,q,Z){const ce=this._documents.getDocument(_),be=S.Position.to(N),oe=await this._provider.provideOnTypeFormattingEdits(ce,be,$,q,Z);if(Array.isArray(oe))return oe.map(S.TextEdit.from)}}class B{constructor(_,N){this._provider=_,this._logService=N,this._cache=new a.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(_,N){const $=await this._provider.provideWorkspaceSymbols(_,N);if(!(0,R.isNonEmptyArray)($))return{symbols:[]};const q=this._cache.add($),Z={cacheId:q,symbols:[]};for(let ce=0;ce<$.length;ce++){const be=$[ce];if(!be||!be.name){this._logService.warn("INVALID SymbolInformation",be);continue}Z.symbols.push({...S.WorkspaceSymbol.from(be),cacheId:[q,ce]})}return Z}async resolveWorkspaceSymbol(_,N){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!_.cacheId)return _;const $=this._cache.get(..._.cacheId);if($){const q=await this._provider.resolveWorkspaceSymbol($,N);return q&&(0,I.mixin)(_,S.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(_){this._cache.delete(_)}}class H{static supportsResolving(_){return typeof _.prepareRename=="function"}constructor(_,N,$){this._documents=_,this._provider=N,this._logService=$}async provideRenameEdits(_,N,$,q){const Z=this._documents.getDocument(_),ce=S.Position.to(N);try{const be=await this._provider.provideRenameEdits(Z,ce,$,q);return be?S.WorkspaceEdit.from(be):void 0}catch(be){const oe=H._asMessage(be);return oe?{rejectReason:oe,edits:void 0}:Promise.reject(be)}}async resolveRenameLocation(_,N,$){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const q=this._documents.getDocument(_),Z=S.Position.to(N);try{const ce=await this._provider.prepareRename(q,Z,$);let be,oe;if(M.Range.isRange(ce)?(be=ce,oe=q.getText(ce)):(0,b.isObject)(ce)&&(be=ce.range,oe=ce.placeholder),!be||!oe)return;if(be.start.line>Z.line||be.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(be),text:oe}}catch(ce){const be=H._asMessage(ce);return be?{rejectReason:be,range:void 0,text:void 0}:Promise.reject(ce)}}static _asMessage(_){return typeof _=="string"?_:_ instanceof Error&&typeof _.message=="string"?_.message:void 0}}class G{constructor(_,N){this.resultId=_,this.tokens=N}}class ee{constructor(_,N){this._documents=_,this._provider=N,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(_,N,$){const q=this._documents.getDocument(_),Z=N!==0?this._previousResults.get(N):null;let ce=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(q,Z.resultId,$):await this._provider.provideDocumentSemanticTokens(q,$);return Z&&this._previousResults.delete(N),ce?(ce=ee._fixProvidedSemanticTokens(ce),this._send(ee._convertToEdits(Z,ce),ce)):null}async releaseDocumentSemanticColoring(_){this._previousResults.delete(_)}static _fixProvidedSemanticTokens(_){return ee._isSemanticTokens(_)?ee._isCorrectSemanticTokens(_)?_:new M.SemanticTokens(new Uint32Array(_.data),_.resultId):ee._isSemanticTokensEdits(_)?ee._isCorrectSemanticTokensEdits(_)?_:new M.SemanticTokensEdits(_.edits.map(N=>new M.SemanticTokensEdit(N.start,N.deleteCount,N.data?new Uint32Array(N.data):N.data)),_.resultId):_}static _isSemanticTokens(_){return _&&!!_.data}static _isCorrectSemanticTokens(_){return _.data instanceof Uint32Array}static _isSemanticTokensEdits(_){return _&&Array.isArray(_.edits)}static _isCorrectSemanticTokensEdits(_){for(const N of _.edits)if(!(N.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(_,N){if(!ee._isSemanticTokens(N)||!_||!_.tokens)return N;const $=_.tokens,q=$.length,Z=N.data,ce=Z.length;let be=0;const oe=Math.min(q,ce);for(;be<oe&&$[be]===Z[be];)be++;if(be===q&&be===ce)return new M.SemanticTokensEdits([],N.resultId);let we=0;const ve=oe-be;for(;we<ve&&$[q-we-1]===Z[ce-we-1];)we++;return new M.SemanticTokensEdits([{start:be,deleteCount:q-be-we,data:Z.subarray(be,ce-we)}],N.resultId)}_send(_,N){if(ee._isSemanticTokens(_)){const $=this._nextResultId++;return this._previousResults.set($,new G(_.resultId,_.data)),(0,t.encodeSemanticTokensDto)({id:$,type:"full",data:_.data})}if(ee._isSemanticTokensEdits(_)){const $=this._nextResultId++;return ee._isSemanticTokens(N)?this._previousResults.set($,new G(N.resultId,N.data)):this._previousResults.set($,new G(_.resultId)),(0,t.encodeSemanticTokensDto)({id:$,type:"delta",deltas:(_.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class ue{constructor(_,N){this._documents=_,this._provider=N}async provideDocumentRangeSemanticTokens(_,N,$){const q=this._documents.getDocument(_),Z=await this._provider.provideDocumentRangeSemanticTokens(q,S.Range.to(N),$);return Z?this._send(Z):null}_send(_){return(0,t.encodeSemanticTokensDto)({id:0,type:"full",data:_.data})}}class re{static supportsResolving(_){return typeof _.resolveCompletionItem=="function"}constructor(_,N,$,q,Z){this._documents=_,this._commands=N,this._provider=$,this._apiDeprecation=q,this._extension=Z,this._cache=new a.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(_,N,$,q){const Z=this._documents.getDocument(_),ce=S.Position.to(N),be=Z.getWordRangeAtPosition(ce)||new M.Range(ce,ce),oe=be.with({end:ce}),we=new g.StopWatch(!0),ve=await this._provider.provideCompletionItems(Z,ce,q,S.CompletionContext.to($));if(!ve||q.isCancellationRequested)return;const Ue=Array.isArray(ve)?new M.CompletionList(ve):ve,ze=re.supportsResolving(this._provider)?this._cache.add(Ue.items):this._cache.add([]),et=new m.DisposableStore;this._disposables.set(ze,et);const Ke=[],tt={x:ze,b:Ke,a:{replace:S.Range.from(be),insert:S.Range.from(oe)},c:Ue.isIncomplete||void 0,d:we.elapsed()};for(let Fe=0;Fe<Ue.items.length;Fe++){const ht=Ue.items[Fe],X=this._convertCompletionItem(ht,[ze,Fe],oe,be);Ke.push(X)}return tt}async resolveCompletionItem(_,N){if(typeof this._provider.resolveCompletionItem!="function")return;const $=this._cache.get(..._);if(!$)return;const q=await this._provider.resolveCompletionItem($,N);if(!!q)return this._convertCompletionItem(q,_)}releaseCompletionItems(_){this._disposables.get(_)?.dispose(),this._disposables.delete(_),this._cache.delete(_)}_convertCompletionItem(_,N,$,q){const Z=this._disposables.get(N[0]);if(!Z)throw Error("DisposableStore is missing...");const ce=this._commands.toInternal(_.command,Z),be={x:N,a:_.label,b:_.kind!==void 0?S.CompletionItemKind.from(_.kind):void 0,m:_.tags&&_.tags.map(S.CompletionItemTag.from),c:_.detail,d:typeof _.documentation>"u"?void 0:S.MarkdownString.fromStrict(_.documentation),e:_.sortText!==_.label?_.sortText:void 0,f:_.filterText!==_.label?_.filterText:void 0,g:_.preselect||void 0,i:_.keepWhitespace?1:0,k:_.commitCharacters?.join(""),l:_.additionalTextEdits&&_.additionalTextEdits.map(S.TextEdit.from),n:ce?.$ident,o:ce?.id,p:ce?.$ident?void 0:ce?.arguments};_.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),be.h=_.textEdit.newText):typeof _.insertText=="string"?be.h=_.insertText:_.insertText instanceof M.SnippetString&&(be.h=_.insertText.value,be.i|=4);let oe;return _.textEdit?oe=_.textEdit.range:_.range&&(oe=_.range),M.Range.isRange(oe)?be.j=S.Range.from(oe):oe&&(!$?.isEqual(oe.inserting)||!q?.isEqual(oe.replacing))&&(be.j={insert:S.Range.from(oe.inserting),replace:S.Range.from(oe.replacing)}),be}}class pe{async provideInlineCompletions(_,N,$,q){}disposeCompletions(_){}handleDidShowCompletionItem(_,N){}}class le extends pe{constructor(_,N,$,q){super(),this._extension=_,this._documents=N,this._provider=$,this._commands=q,this._references=new de,this._isAdditionsProposedApiEnabled=(0,T.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[D.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[D.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,T.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(_,N,$,q){const Z=this._documents.getDocument(_),ce=S.Position.to(N),be=await this._provider.provideInlineCompletionItems(Z,ce,{selectedCompletionInfo:$.selectedSuggestionInfo?{range:S.Range.to($.selectedSuggestionInfo.range),text:$.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[$.triggerKind]},q);if(!be||q.isCancellationRequested)return;const oe=Array.isArray(be)?be:be.items,we=this._isAdditionsProposedApiEnabled?Array.isArray(be)?[]:be.commands||[]:[];let ve;return{pid:this._references.createReferenceId({dispose(){ve?.dispose()},items:oe}),items:oe.map((ze,et)=>{let Ke;ze.command&&(ve||(ve=new m.DisposableStore),Ke=this._commands.toInternal(ze.command,ve));const tt=ze.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:ze.filterText,range:ze.range?S.Range.from(ze.range):void 0,command:Ke,idx:et,completeBracketPairs:this._isAdditionsProposedApiEnabled?ze.completeBracketPairs:!1}}),commands:we.map(ze=>(ve||(ve=new m.DisposableStore),this._commands.toInternal(ze,ve)))}}disposeCompletions(_){this._references.disposeReferenceId(_)?.dispose()}handleDidShowCompletionItem(_,N){const $=this._references.get(_)?.items[N];$&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem($)}}class de{constructor(){this._references=new Map,this._idPool=1}createReferenceId(_){const N=this._idPool++;return this._references.set(N,_),N}disposeReferenceId(_){const N=this._references.get(_);return this._references.delete(_),N}get(_){return this._references.get(_)}}class Y{constructor(_,N){this._documents=_,this._provider=N,this._cache=new a.Cache("SignatureHelp")}async provideSignatureHelp(_,N,$,q){const Z=this._documents.getDocument(_),ce=S.Position.to(N),be=this.reviveContext($),oe=await this._provider.provideSignatureHelp(Z,ce,q,be);if(oe){const we=this._cache.add([oe]);return{...S.SignatureHelp.from(oe),id:we}}}reviveContext(_){let N;if(_.activeSignatureHelp){const $=S.SignatureHelp.to(_.activeSignatureHelp),q=this._cache.get(_.activeSignatureHelp.id,0);q?(N=q,N.activeSignature=$.activeSignature,N.activeParameter=$.activeParameter):N=$}return{..._,activeSignatureHelp:N}}releaseSignatureHelp(_){this._cache.delete(_)}}class me{constructor(_,N,$,q,Z){this._documents=_,this._commands=N,this._provider=$,this._logService=q,this._extension=Z,this._cache=new a.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(_,N,$){const q=this._documents.getDocument(_),Z=S.Range.to(N),ce=await this._provider.provideInlayHints(q,Z,$);if(!Array.isArray(ce)||ce.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${N}`);return}if($.isCancellationRequested)return;const be=this._cache.add(ce);this._disposables.set(be,new m.DisposableStore);const oe={hints:[],cacheId:be};for(let we=0;we<ce.length;we++)this._isValidInlayHint(ce[we],Z)&&oe.hints.push(this._convertInlayHint(ce[we],[be,we]));return this._logService.trace(`[InlayHints] ${oe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${N}`),oe}async resolveInlayHint(_,N){if(typeof this._provider.resolveInlayHint!="function")return;const $=this._cache.get(..._);if(!$)return;const q=await this._provider.resolveInlayHint($,N);if(!!q&&!!this._isValidInlayHint(q))return this._convertInlayHint(q,_)}releaseHints(_){this._disposables.get(_)?.dispose(),this._disposables.delete(_),this._cache.delete(_)}_isValidInlayHint(_,N){return _.label.length===0||Array.isArray(_.label)&&_.label.every($=>$.value.length===0)?(console.log("INVALID inlay hint, empty label",_),!1):!(N&&!N.contains(_.position))}_convertInlayHint(_,N){const $=this._disposables.get(N[0]);if(!$)throw Error("DisposableStore is missing...");const q={label:"",cacheId:N,tooltip:S.MarkdownString.fromStrict(_.tooltip),position:S.Position.from(_.position),textEdits:_.textEdits&&_.textEdits.map(S.TextEdit.from),kind:_.kind&&S.InlayHintKind.from(_.kind),paddingLeft:_.paddingLeft,paddingRight:_.paddingRight};return typeof _.label=="string"?q.label=_.label:q.label=_.label.map(Z=>{const ce={label:Z.value};return ce.tooltip=S.MarkdownString.fromStrict(Z.tooltip),M.Location.isLocation(Z.location)&&(ce.location=S.location.from(Z.location)),Z.command&&(ce.command=this._commands.toInternal(Z.command,$)),ce}),q}}class Se{constructor(_,N){this._documents=_,this._provider=N,this._cache=new a.Cache("DocumentLink")}async provideLinks(_,N){const $=this._documents.getDocument(_),q=await this._provider.provideDocumentLinks($,N);if(!(!Array.isArray(q)||q.length===0)&&!N.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:q.filter(Se._validateLink).map(S.DocumentLink.from)};{const Z=this._cache.add(q),ce={links:[],cacheId:Z};for(let be=0;be<q.length;be++){if(!Se._validateLink(q[be]))continue;const oe=S.DocumentLink.from(q[be]);oe.cacheId=[Z,be],ce.links.push(oe)}return ce}}}static _validateLink(_){return _.target&&_.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(_,N){if(typeof this._provider.resolveDocumentLink!="function")return;const $=this._cache.get(..._);if(!$)return;const q=await this._provider.resolveDocumentLink($,N);if(!(!q||!Se._validateLink(q)))return S.DocumentLink.from(q)}releaseLinks(_){this._cache.delete(_)}}class Oe{constructor(_,N){this._documents=_,this._provider=N}async provideColors(_,N){const $=this._documents.getDocument(_),q=await this._provider.provideDocumentColors($,N);return Array.isArray(q)?q.map(ce=>({color:S.Color.from(ce.color),range:S.Range.from(ce.range)})):[]}async provideColorPresentations(_,N,$){const q=this._documents.getDocument(_),Z=S.Range.to(N.range),ce=S.Color.to(N.color),be=await this._provider.provideColorPresentations(ce,{document:q,range:Z},$);if(!!Array.isArray(be))return be.map(S.ColorPresentation.from)}}class Be{constructor(_,N){this._documents=_,this._provider=N}async provideFoldingRanges(_,N,$){const q=this._documents.getDocument(_),Z=await this._provider.provideFoldingRanges(q,N,$);if(!!Array.isArray(Z))return Z.map(S.FoldingRange.from)}}class Xe{constructor(_,N,$){this._documents=_,this._provider=N,this._logService=$}async provideSelectionRanges(_,N,$){const q=this._documents.getDocument(_),Z=N.map(S.Position.to),ce=await this._provider.provideSelectionRanges(q,Z,$);if(!(0,R.isNonEmptyArray)(ce))return[];if(ce.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const be=[];for(let oe=0;oe<Z.length;oe++){const we=[];be.push(we);let ve=Z[oe],Ue=ce[oe];for(;;){if(!Ue.range.contains(ve))throw new Error("INVALID selection range, must contain the previous range");if(we.push(S.SelectionRange.from(Ue)),!Ue.parent)break;ve=Ue.range,Ue=Ue.parent}}return be}}class ke{constructor(_,N){this._documents=_,this._provider=N,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(_,N,$){const q=this._documents.getDocument(_),Z=S.Position.to(N),ce=await this._provider.prepareCallHierarchy(q,Z,$);if(!ce)return;const be=this._idPool.nextId();return this._cache.set(be,new Map),Array.isArray(ce)?ce.map(oe=>this._cacheAndConvertItem(be,oe)):[this._cacheAndConvertItem(be,ce)]}async provideCallsTo(_,N,$){const q=this._itemFromCache(_,N);if(!q)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(q,$);if(!!Z)return Z.map(ce=>({from:this._cacheAndConvertItem(_,ce.from),fromRanges:ce.fromRanges.map(be=>S.Range.from(be))}))}async provideCallsFrom(_,N,$){const q=this._itemFromCache(_,N);if(!q)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(q,$);if(!!Z)return Z.map(ce=>({to:this._cacheAndConvertItem(_,ce.to),fromRanges:ce.fromRanges.map(be=>S.Range.from(be))}))}releaseSession(_){this._cache.delete(_)}_cacheAndConvertItem(_,N){const $=this._cache.get(_),q=S.CallHierarchyItem.from(N,_,$.size.toString(36));return $.set(q._itemId,N),q}_itemFromCache(_,N){return this._cache.get(_)?.get(N)}}class ye{constructor(_,N){this._documents=_,this._provider=N,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(_,N,$){const q=this._documents.getDocument(_),Z=S.Position.to(N),ce=await this._provider.prepareTypeHierarchy(q,Z,$);if(!ce)return;const be=this._idPool.nextId();return this._cache.set(be,new Map),Array.isArray(ce)?ce.map(oe=>this._cacheAndConvertItem(be,oe)):[this._cacheAndConvertItem(be,ce)]}async provideSupertypes(_,N,$){const q=this._itemFromCache(_,N);if(!q)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(q,$);if(!!Z)return Z.map(ce=>this._cacheAndConvertItem(_,ce))}async provideSubtypes(_,N,$){const q=this._itemFromCache(_,N);if(!q)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(q,$);if(!!Z)return Z.map(ce=>this._cacheAndConvertItem(_,ce))}releaseSession(_){this._cache.delete(_)}_cacheAndConvertItem(_,N){const $=this._cache.get(_),q=S.TypeHierarchyItem.from(N,_,$.size.toString(36));return $.set(q._itemId,N),q}_itemFromCache(_,N){return this._cache.get(_)?.get(N)}}class Ce{constructor(_,N,$,q){this._proxy=_,this._documents=N,this._provider=$,this._handle=q}async provideDocumentOnDropEdits(_,N,$,q,Z){const ce=this._documents.getDocument(N),be=S.Position.to($),oe=S.DataTransfer.toDataTransfer(q,async ve=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,_,ve)).buffer),we=await this._provider.provideDocumentDropEdits(ce,be,oe,Z);if(!!we)return{insertText:typeof we.insertText=="string"?we.insertText:{snippet:we.insertText.value},additionalEdit:we.additionalEdit?S.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}}class se{constructor(_,N){this.adapter=_,this.extension=N}}class ae{constructor(_,N,$,q,Z,ce,be,oe){this._uriTransformer=N,this._documents=$,this._commands=q,this._diagnostics=Z,this._logService=ce,this._apiDeprecation=be,this._extensionTelemetry=oe,this._adapter=new Map,this._proxy=_.getProxy(A.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(_){return S.DocumentSelector.from(_,this._uriTransformer)}_createDisposable(_){return new M.Disposable(()=>{this._adapter.delete(_),this._proxy.$unregister(_)})}_nextHandle(){return ae._handlePool++}async _withAdapter(_,N,$,q,Z,ce=!1){const be=this._adapter.get(_);if(!be||!(be.adapter instanceof N))return q;const oe=Date.now();ce||this._logService.trace(`[${be.extension.identifier.value}] INVOKE provider '${$.toString().replace(/[\r\n]/g,"")}'`);const we=$(be.adapter,be.extension);return Promise.resolve(we).catch(ve=>{(0,w.isCancellationError)(ve)||(this._logService.error(`[${be.extension.identifier.value}] provider FAILED`),this._logService.error(ve),this._extensionTelemetry.onExtensionError(be.extension.identifier,ve))}).finally(()=>{ce||this._logService.trace(`[${be.extension.identifier.value}] provider DONE after ${Date.now()-oe}ms`)}),E.CancellationToken.isCancellationToken(Z)?(0,d.raceCancellationError)(we,Z):we}_addNewAdapter(_,N){const $=this._nextHandle();return this._adapter.set($,new se(_,N)),$}static _extLabel(_){return _.displayName||_.name}registerDocumentSymbolProvider(_,N,$,q){const Z=this._addNewAdapter(new r(this._documents,$),_),ce=q&&q.label||ae._extLabel(_);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(N),ce),this._createDisposable(Z)}$provideDocumentSymbols(_,N,$){return this._withAdapter(_,r,q=>q.provideDocumentSymbols(i.URI.revive(N),$),void 0,$)}registerCodeLensProvider(_,N,$){const q=this._nextHandle(),Z=typeof $.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(q,new se(new c(this._documents,this._commands.converter,$),_)),this._proxy.$registerCodeLensSupport(q,this._transformDocumentSelector(N),Z);let ce=this._createDisposable(q);if(Z!==void 0){const be=$.onDidChangeCodeLenses(oe=>this._proxy.$emitCodeLensEvent(Z));ce=M.Disposable.from(ce,be)}return ce}$provideCodeLenses(_,N,$){return this._withAdapter(_,c,q=>q.provideCodeLenses(i.URI.revive(N),$),void 0,$)}$resolveCodeLens(_,N,$){return this._withAdapter(_,c,q=>q.resolveCodeLens(N,$),void 0,void 0)}$releaseCodeLenses(_,N){this._withAdapter(_,c,$=>Promise.resolve($.releaseCodeLenses(N)),void 0,void 0)}registerDefinitionProvider(_,N,$){const q=this._addNewAdapter(new u(this._documents,$),_);return this._proxy.$registerDefinitionSupport(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideDefinition(_,N,$,q){return this._withAdapter(_,u,Z=>Z.provideDefinition(i.URI.revive(N),$,q),[],q)}registerDeclarationProvider(_,N,$){const q=this._addNewAdapter(new l(this._documents,$),_);return this._proxy.$registerDeclarationSupport(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideDeclaration(_,N,$,q){return this._withAdapter(_,l,Z=>Z.provideDeclaration(i.URI.revive(N),$,q),[],q)}registerImplementationProvider(_,N,$){const q=this._addNewAdapter(new f(this._documents,$),_);return this._proxy.$registerImplementationSupport(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideImplementation(_,N,$,q){return this._withAdapter(_,f,Z=>Z.provideImplementation(i.URI.revive(N),$,q),[],q)}registerTypeDefinitionProvider(_,N,$){const q=this._addNewAdapter(new s(this._documents,$),_);return this._proxy.$registerTypeDefinitionSupport(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideTypeDefinition(_,N,$,q){return this._withAdapter(_,s,Z=>Z.provideTypeDefinition(i.URI.revive(N),$,q),[],q)}registerHoverProvider(_,N,$,q){const Z=this._addNewAdapter(new h(this._documents,$),_);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(N)),this._createDisposable(Z)}$provideHover(_,N,$,q){return this._withAdapter(_,h,Z=>Z.provideHover(i.URI.revive(N),$,q),void 0,q)}registerEvaluatableExpressionProvider(_,N,$,q){const Z=this._addNewAdapter(new v(this._documents,$),_);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(N)),this._createDisposable(Z)}$provideEvaluatableExpression(_,N,$,q){return this._withAdapter(_,v,Z=>Z.provideEvaluatableExpression(i.URI.revive(N),$,q),void 0,q)}registerInlineValuesProvider(_,N,$,q){const Z=typeof $.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new P(this._documents,$),_);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(N),Z);let be=this._createDisposable(ce);if(Z!==void 0){const oe=$.onDidChangeInlineValues(we=>this._proxy.$emitInlineValuesEvent(Z));be=M.Disposable.from(be,oe)}return be}$provideInlineValues(_,N,$,q,Z){return this._withAdapter(_,P,ce=>ce.provideInlineValues(i.URI.revive(N),$,q,Z),void 0,Z)}registerDocumentHighlightProvider(_,N,$){const q=this._addNewAdapter(new L(this._documents,$),_);return this._proxy.$registerDocumentHighlightProvider(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideDocumentHighlights(_,N,$,q){return this._withAdapter(_,L,Z=>Z.provideDocumentHighlights(i.URI.revive(N),$,q),void 0,q)}registerLinkedEditingRangeProvider(_,N,$){const q=this._addNewAdapter(new j(this._documents,$),_);return this._proxy.$registerLinkedEditingRangeProvider(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideLinkedEditingRanges(_,N,$,q){return this._withAdapter(_,j,async Z=>{const ce=await Z.provideLinkedEditingRanges(i.URI.revive(N),$,q);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?ae._serializeRegExp(ce.wordPattern):void 0}},void 0,q)}registerReferenceProvider(_,N,$){const q=this._addNewAdapter(new W(this._documents,$),_);return this._proxy.$registerReferenceSupport(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideReferences(_,N,$,q,Z){return this._withAdapter(_,W,ce=>ce.provideReferences(i.URI.revive(N),$,q,Z),void 0,Z)}registerCodeActionProvider(_,N,$,q){const Z=new m.DisposableStore,ce=this._addNewAdapter(new V(this._documents,this._commands.converter,this._diagnostics,$,this._logService,_,this._apiDeprecation),_);return this._proxy.$registerQuickFixSupport(ce,this._transformDocumentSelector(N),{providedKinds:q?.providedCodeActionKinds?.map(be=>be.value),documentation:q?.documentation?.map(be=>({kind:be.kind.value,command:this._commands.converter.toInternal(be.command,Z)}))},ae._extLabel(_),Boolean($.resolveCodeAction)),Z.add(this._createDisposable(ce)),Z}$provideCodeActions(_,N,$,q,Z){return this._withAdapter(_,V,ce=>ce.provideCodeActions(i.URI.revive(N),$,q,Z),void 0,Z)}$resolveCodeAction(_,N,$){return this._withAdapter(_,V,q=>q.resolveCodeAction(N,$),void 0,void 0)}$releaseCodeActions(_,N){this._withAdapter(_,V,$=>Promise.resolve($.releaseCodeActions(N)),void 0,void 0)}registerDocumentFormattingEditProvider(_,N,$){const q=this._addNewAdapter(new F(this._documents,$),_);return this._proxy.$registerDocumentFormattingSupport(q,this._transformDocumentSelector(N),_.identifier,_.displayName||_.name),this._createDisposable(q)}$provideDocumentFormattingEdits(_,N,$,q){return this._withAdapter(_,F,Z=>Z.provideDocumentFormattingEdits(i.URI.revive(N),$,q),void 0,q)}registerDocumentRangeFormattingEditProvider(_,N,$){const q=this._addNewAdapter(new O(this._documents,$),_);return this._proxy.$registerRangeFormattingSupport(q,this._transformDocumentSelector(N),_.identifier,_.displayName||_.name),this._createDisposable(q)}$provideDocumentRangeFormattingEdits(_,N,$,q,Z){return this._withAdapter(_,O,ce=>ce.provideDocumentRangeFormattingEdits(i.URI.revive(N),$,q,Z),void 0,Z)}registerOnTypeFormattingEditProvider(_,N,$,q){const Z=this._addNewAdapter(new x(this._documents,$),_);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(N),q,_.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(_,N,$,q,Z,ce){return this._withAdapter(_,x,be=>be.provideOnTypeFormattingEdits(i.URI.revive(N),$,q,Z,ce),void 0,ce)}registerWorkspaceSymbolProvider(_,N){const $=this._addNewAdapter(new B(N,this._logService),_);return this._proxy.$registerNavigateTypeSupport($,typeof N.resolveWorkspaceSymbol=="function"),this._createDisposable($)}$provideWorkspaceSymbols(_,N,$){return this._withAdapter(_,B,q=>q.provideWorkspaceSymbols(N,$),{symbols:[]},$)}$resolveWorkspaceSymbol(_,N,$){return this._withAdapter(_,B,q=>q.resolveWorkspaceSymbol(N,$),void 0,void 0)}$releaseWorkspaceSymbols(_,N){this._withAdapter(_,B,$=>$.releaseWorkspaceSymbols(N),void 0,void 0)}registerRenameProvider(_,N,$){const q=this._addNewAdapter(new H(this._documents,$,this._logService),_);return this._proxy.$registerRenameSupport(q,this._transformDocumentSelector(N),H.supportsResolving($)),this._createDisposable(q)}$provideRenameEdits(_,N,$,q,Z){return this._withAdapter(_,H,ce=>ce.provideRenameEdits(i.URI.revive(N),$,q,Z),void 0,Z)}$resolveRenameLocation(_,N,$,q){return this._withAdapter(_,H,Z=>Z.resolveRenameLocation(i.URI.revive(N),$,q),void 0,q)}registerDocumentSemanticTokensProvider(_,N,$,q){const Z=this._addNewAdapter(new ee(this._documents,$),_),ce=typeof $.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(N),q,ce);let be=this._createDisposable(Z);if(ce){const oe=$.onDidChangeSemanticTokens(we=>this._proxy.$emitDocumentSemanticTokensEvent(ce));be=M.Disposable.from(be,oe)}return be}$provideDocumentSemanticTokens(_,N,$,q){return this._withAdapter(_,ee,Z=>Z.provideDocumentSemanticTokens(i.URI.revive(N),$,q),null,q)}$releaseDocumentSemanticTokens(_,N){this._withAdapter(_,ee,$=>$.releaseDocumentSemanticColoring(N),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(_,N,$,q){const Z=this._addNewAdapter(new ue(this._documents,$),_);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(N),q),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(_,N,$,q){return this._withAdapter(_,ue,Z=>Z.provideDocumentRangeSemanticTokens(i.URI.revive(N),$,q),null,q)}registerCompletionItemProvider(_,N,$,q){const Z=this._addNewAdapter(new re(this._documents,this._commands.converter,$,this._apiDeprecation,_),_);return this._proxy.$registerCompletionsProvider(Z,this._transformDocumentSelector(N),q,re.supportsResolving($),`${_.identifier.value}(${q.join("")})`),this._createDisposable(Z)}$provideCompletionItems(_,N,$,q,Z){return this._withAdapter(_,re,ce=>ce.provideCompletionItems(i.URI.revive(N),$,q,Z),void 0,Z)}$resolveCompletionItem(_,N,$){return this._withAdapter(_,re,q=>q.resolveCompletionItem(N,$),void 0,$)}$releaseCompletionItems(_,N){this._withAdapter(_,re,$=>$.releaseCompletionItems(N),void 0,void 0)}registerInlineCompletionsProvider(_,N,$){const q=new le(_,this._documents,$,this._commands.converter),Z=this._addNewAdapter(q,_);return this._proxy.$registerInlineCompletionsSupport(Z,this._transformDocumentSelector(N),q.supportsHandleDidShowCompletionItem),this._createDisposable(Z)}$provideInlineCompletions(_,N,$,q,Z){return this._withAdapter(_,pe,ce=>ce.provideInlineCompletions(i.URI.revive(N),$,q,Z),void 0,Z)}$handleInlineCompletionDidShow(_,N,$){this._withAdapter(_,pe,async q=>{q.handleDidShowCompletionItem(N,$)},void 0,void 0)}$freeInlineCompletionsList(_,N){this._withAdapter(_,pe,async $=>{$.disposeCompletions(N)},void 0,void 0)}registerSignatureHelpProvider(_,N,$,q){const Z=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,ce=this._addNewAdapter(new Y(this._documents,$),_);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(N),Z),this._createDisposable(ce)}$provideSignatureHelp(_,N,$,q,Z){return this._withAdapter(_,Y,ce=>ce.provideSignatureHelp(i.URI.revive(N),$,q,Z),void 0,Z)}$releaseSignatureHelp(_,N){this._withAdapter(_,Y,$=>$.releaseSignatureHelp(N),void 0,void 0)}registerInlayHintsProvider(_,N,$){const q=typeof $.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new me(this._documents,this._commands.converter,$,this._logService,_),_);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(N),typeof $.resolveInlayHint=="function",q,ae._extLabel(_));let ce=this._createDisposable(Z);if(q!==void 0){const be=$.onDidChangeInlayHints(oe=>this._proxy.$emitInlayHintsEvent(q));ce=M.Disposable.from(ce,be)}return ce}$provideInlayHints(_,N,$,q){return this._withAdapter(_,me,Z=>Z.provideInlayHints(i.URI.revive(N),$,q),void 0,q)}$resolveInlayHint(_,N,$){return this._withAdapter(_,me,q=>q.resolveInlayHint(N,$),void 0,$)}$releaseInlayHints(_,N){this._withAdapter(_,me,$=>$.releaseHints(N),void 0,void 0)}registerDocumentLinkProvider(_,N,$){const q=this._addNewAdapter(new Se(this._documents,$),_);return this._proxy.$registerDocumentLinkProvider(q,this._transformDocumentSelector(N),typeof $.resolveDocumentLink=="function"),this._createDisposable(q)}$provideDocumentLinks(_,N,$){return this._withAdapter(_,Se,q=>q.provideLinks(i.URI.revive(N),$),void 0,$,N.scheme==="output")}$resolveDocumentLink(_,N,$){return this._withAdapter(_,Se,q=>q.resolveLink(N,$),void 0,void 0,!0)}$releaseDocumentLinks(_,N){this._withAdapter(_,Se,$=>$.releaseLinks(N),void 0,void 0,!0)}registerColorProvider(_,N,$){const q=this._addNewAdapter(new Oe(this._documents,$),_);return this._proxy.$registerDocumentColorProvider(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideDocumentColors(_,N,$){return this._withAdapter(_,Oe,q=>q.provideColors(i.URI.revive(N),$),[],$)}$provideColorPresentations(_,N,$,q){return this._withAdapter(_,Oe,Z=>Z.provideColorPresentations(i.URI.revive(N),$,q),void 0,q)}registerFoldingRangeProvider(_,N,$){const q=this._nextHandle(),Z=typeof $.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(q,new se(new Be(this._documents,$),_)),this._proxy.$registerFoldingRangeProvider(q,this._transformDocumentSelector(N),_.identifier,Z);let ce=this._createDisposable(q);if(Z!==void 0){const be=$.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));ce=M.Disposable.from(ce,be)}return ce}$provideFoldingRanges(_,N,$,q){return this._withAdapter(_,Be,Z=>Z.provideFoldingRanges(i.URI.revive(N),$,q),void 0,q)}registerSelectionRangeProvider(_,N,$){const q=this._addNewAdapter(new Xe(this._documents,$,this._logService),_);return this._proxy.$registerSelectionRangeProvider(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideSelectionRanges(_,N,$,q){return this._withAdapter(_,Xe,Z=>Z.provideSelectionRanges(i.URI.revive(N),$,q),[],q)}registerCallHierarchyProvider(_,N,$){const q=this._addNewAdapter(new ke(this._documents,$),_);return this._proxy.$registerCallHierarchyProvider(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$prepareCallHierarchy(_,N,$,q){return this._withAdapter(_,ke,Z=>Promise.resolve(Z.prepareSession(i.URI.revive(N),$,q)),void 0,q)}$provideCallHierarchyIncomingCalls(_,N,$,q){return this._withAdapter(_,ke,Z=>Z.provideCallsTo(N,$,q),void 0,q)}$provideCallHierarchyOutgoingCalls(_,N,$,q){return this._withAdapter(_,ke,Z=>Z.provideCallsFrom(N,$,q),void 0,q)}$releaseCallHierarchy(_,N){this._withAdapter(_,ke,$=>Promise.resolve($.releaseSession(N)),void 0,void 0)}registerTypeHierarchyProvider(_,N,$){const q=this._addNewAdapter(new ye(this._documents,$),_);return this._proxy.$registerTypeHierarchyProvider(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$prepareTypeHierarchy(_,N,$,q){return this._withAdapter(_,ye,Z=>Promise.resolve(Z.prepareSession(i.URI.revive(N),$,q)),void 0,q)}$provideTypeHierarchySupertypes(_,N,$,q){return this._withAdapter(_,ye,Z=>Z.provideSupertypes(N,$,q),void 0,q)}$provideTypeHierarchySubtypes(_,N,$,q){return this._withAdapter(_,ye,Z=>Z.provideSubtypes(N,$,q),void 0,q)}$releaseTypeHierarchy(_,N){this._withAdapter(_,ye,$=>Promise.resolve($.releaseSession(N)),void 0,void 0)}registerDocumentOnDropEditProvider(_,N,$){const q=this._nextHandle();return this._adapter.set(q,new se(new Ce(this._proxy,this._documents,$,q),_)),this._proxy.$registerDocumentOnDropEditProvider(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideDocumentOnDropEdits(_,N,$,q,Z,ce){return this._withAdapter(_,Ce,be=>Promise.resolve(be.provideDocumentOnDropEdits(N,i.URI.revive($),q,Z,ce)),void 0,void 0)}registerDocumentPasteEditProvider(_,N,$,q){const Z=this._nextHandle();return this._adapter.set(Z,new se(new C(this._proxy,this._documents,$,Z),_)),this._proxy.$registerPasteEditProvider(Z,this._transformDocumentSelector(N),!!$.prepareDocumentPaste,q.pasteMimeTypes),this._createDisposable(Z)}$prepareDocumentPaste(_,N,$,q,Z){return this._withAdapter(_,C,ce=>ce.prepareDocumentPaste(i.URI.revive(N),$,q,Z),void 0,Z)}$providePasteEdits(_,N,$,q,Z,ce){return this._withAdapter(_,C,be=>be.providePasteEdits(N,i.URI.revive($),q,Z,ce),void 0,ce)}static _serializeRegExp(_){return{pattern:_.source,flags:(0,y.regExpFlags)(_)}}static _serializeIndentationRule(_){return{decreaseIndentPattern:ae._serializeRegExp(_.decreaseIndentPattern),increaseIndentPattern:ae._serializeRegExp(_.increaseIndentPattern),indentNextLinePattern:_.indentNextLinePattern?ae._serializeRegExp(_.indentNextLinePattern):void 0,unIndentedLinePattern:_.unIndentedLinePattern?ae._serializeRegExp(_.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(_){return{beforeText:ae._serializeRegExp(_.beforeText),afterText:_.afterText?ae._serializeRegExp(_.afterText):void 0,previousLineText:_.previousLineText?ae._serializeRegExp(_.previousLineText):void 0,action:_.action}}static _serializeOnEnterRules(_){return _.map(ae._serializeOnEnterRule)}setLanguageConfiguration(_,N,$){const{wordPattern:q}=$;if(q&&(0,y.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this._documents.setWordDefinitionFor(N,q):this._documents.setWordDefinitionFor(N,void 0),$.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",_,"Do not use."),$.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",_,"Do not use.");const Z=this._nextHandle(),ce={comments:$.comments,brackets:$.brackets,wordPattern:$.wordPattern?ae._serializeRegExp($.wordPattern):void 0,indentationRules:$.indentationRules?ae._serializeIndentationRule($.indentationRules):void 0,onEnterRules:$.onEnterRules?ae._serializeOnEnterRules($.onEnterRules):void 0,__electricCharacterSupport:$.__electricCharacterSupport,__characterPairSupport:$.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,N,ce),this._createDisposable(Z)}$setWordDefinitions(_){for(const N of _)this._documents.setWordDefinitionFor(N.languageId,new RegExp(N.regexSource,N.regexFlags))}}e.ExtHostLanguageFeatures=ae,ae._handlePool=0}),define(De[210],Ie([1,0,5,8,6,29,15,7]),function(ie,e,i,I,S,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(R,b,p,E){this._documents=b,this._commands=p,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,b){await this._proxy.$changeLanguage(R,b);const p=this._documents.getDocumentData(R);if(!p)throw new Error(`document '${R.toString()}' NOT found`);return p.document}async tokenAtPosition(R,b){const p=R.version,E=I.Position.from(b),m=await this._proxy.$tokensAtPosition(R.uri,E),t={type:S.StandardTokenType.Other,range:R.getWordRangeAtPosition(b)??new S.Range(b.line,b.character,b.line,b.character)};if(!m)return t;const o={range:I.Range.to(m.range),type:I.TokenType.to(m.type)};return!o.range.contains(b)||p!==R.version?t:o}createLanguageStatusItem(R,b,p){const E=this._handlePool++,m=this._proxy,t=this._ids,o=`${R.identifier.value}/${b}`;if(t.has(o))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);t.add(o);const a={selector:p,id:b,name:R.displayName??R.name,severity:S.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const w=new A.DisposableStore,d=()=>{g?.dispose(),g=(0,D.disposableTimeout)(()=>{w.clear(),this._proxy.$setLanguageStatus(E,{id:o,name:a.name??R.displayName??R.name,source:R.displayName??R.name,selector:I.DocumentSelector.from(a.selector,this._uriTransformer),label:a.text,detail:a.detail??"",severity:a.severity===S.LanguageStatusSeverity.Error?M.default.Error:a.severity===S.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:a.command&&this._commands.toInternal(a.command,w),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},T={dispose(){w.dispose(),g?.dispose(),m.$removeLanguageStatus(E),t.delete(o)},get id(){return a.id},get name(){return a.name},set name(r){a.name=r,d()},get selector(){return a.selector},set selector(r){a.selector=r,d()},get text(){return a.text},set text(r){a.text=r,d()},get detail(){return a.detail},set detail(r){a.detail=r,d()},get severity(){return a.severity},set severity(r){a.severity=r,d()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(r){a.accessibilityInformation=r,d()},get command(){return a.command},set command(r){a.command=r,d()},get busy(){return a.busy},set busy(r){a.busy=r,d()}};return d(),T}}e.ExtHostLanguages=y}),define(De[72],Ie([1,0,21,10,2,3,11,5,26,14]),function(ie,e,i,I,S,M,D,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(p,E,m){this.logService=m,this.bundleCache=new Map,this._proxy=E.getProxy(A.MainContext.MainThreadLocalization),this.currentLanguage=p.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===i.LANGUAGE_DEFAULT}getMessage(p,E){const{message:m,args:t,comment:o}=E;if(this.isDefaultLanguage)return(0,I.format2)(m,t??{});let a=m;o&&o.length>0&&(a+=`/${Array.isArray(o)?o.join():o}`);const g=this.bundleCache.get(p)?.contents[a];return g||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,I.format2)(g??a,t??{})}getBundle(p){return this.bundleCache.get(p)?.contents}getBundleUri(p){return this.bundleCache.get(p)?.uri}async initializeLocalizedMessages(p){if(this.isDefaultLanguage||!p.l10n&&!p.isBuiltin||this.bundleCache.has(p.identifier.value))return;let E;const m=await this.getBundleLocation(p);if(!m){this.logService.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const t=await this._proxy.$fetchBundleContents(m),o=JSON.parse(t);E=p.isBuiltin?o.contents?.bundle:o}catch(t){this.logService.error(`Failed to load translations for ${p.identifier.value} from ${m}: ${t.message}`);return}E&&this.bundleCache.set(p.identifier.value,{contents:E,uri:m})}async getBundleLocation(p){if(p.isBuiltin){const E=await this._proxy.$fetchBuiltInBundleUri(p.identifier.value);return S.URI.revive(E)}return p.l10n?S.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};R=He([$e(0,y.IExtHostInitDataService),$e(1,k.IExtHostRpcService),$e(2,D.ILogService)],R),e.ExtHostLocalizationService=R,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(De[211],Ie([1,0,11,5,26,14,2,4,9]),function(ie,e,i,I,S,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends i.AbstractLoggerService{constructor(p,E){super(E.logLevel,A.Event.None),this._proxy=p.getProxy(I.MainContext.MainThreadLogger)}$setLevel(p,E){E?this.setLevel(D.URI.revive(E),p):(0,y.isUndefined)(p)||this.setLevel(p)}doCreateLogger(p,E,m){return new R(this._proxy,p,E,m)}};k=He([$e(0,M.IExtHostRpcService),$e(1,S.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class R extends i.AbstractMessageLogger{constructor(p,E,m,t){super(t?.always),this.proxy=p,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.proxy.$createLogger(E,t).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,E){const m=[[p,E]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(p){this.proxy.$log(this.file,p)}}}),define(De[212],Ie([1,0,5,11,27]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(A){return A&&A.title}let D=class{constructor(y,k){this._logService=k,this._proxy=y.getProxy(i.MainContext.MainThreadMessageService)}showMessage(y,k,R,b,p){const E={source:{identifier:y.identifier,label:y.displayName||y.name}};let m;typeof b=="string"||M(b)?m=[b,...p]:(E.modal=b?.modal,E.useCustom=b?.useCustom,E.detail=b?.detail,m=p),E.useCustom&&(0,S.checkProposedApiEnabled)(y,"resolvers");const t=[];for(let o=0;o<m.length;o++){const a=m[o];if(typeof a=="string")t.push({title:a,handle:o,isCloseAffordance:!1});else if(typeof a=="object"){const{title:g,isCloseAffordance:w}=a;t.push({title:g,isCloseAffordance:!!w,handle:o})}else this._logService.warn("Invalid message item:",a)}return this._proxy.$showMessage(k,R,E,t).then(o=>{if(typeof o=="number")return m[o]})}};D=He([$e(1,I.ILogService)],D),e.ExtHostMessageService=D}),define(De[213],Ie([1,0,24,4,7,28,10,9,2,63,5,37,8,6,43,185,95]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class a{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(w=>w.apiEditor)}constructor(w,d,T,r){this._textDocumentsAndEditors=T,this._textDocuments=r,this._notebookStatusBarItemProviders=new Map,this._documents=new M.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new k.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=w.getProxy(R.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=w.getProxy(R.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=w.getProxy(R.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===12){const n=c.notebookEditor?.notebookUri,u=c.cell.handle,f=this._documents.get(n)?.getCell(u);if(f)return f.apiCell}if(c&&c.$mid===13){const n=c.uri,u=this._documents.get(n);if(u)return u.apiNotebook}return c}}),a._registerApiCommands(d)}getEditorById(w){const d=this._editors.get(w);if(!d)throw new Error(`unknown text editor: ${w}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(w){for(const[d,T]of this._editors)if(T.apiEditor===w)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(w,d){const T=this._documents.get(w);if(!T&&!d)throw new Error(`NO notebook document for '${w}'`);return T}static _convertNotebookRegistrationData(w,d){if(!d)return;const T=d.filenamePattern.map(r=>p.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(d.filenamePattern&&!T){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:d.displayName,filenamePattern:T,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,d,T){const r=a._notebookStatusBarItemProviderHandlePool++,c=typeof T.onDidChangeCellStatusBarItems=="function"?a._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(r,T),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(r,c,d);let n;return c!==void 0&&(n=T.onDidChangeCellStatusBarItems(u=>this._notebookProxy.$emitCellStatusBarEvent(c))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(r),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(r,c),n?.dispose()})}async createNotebookDocument(w){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:w.viewType,content:w.content&&p.NotebookData.from(w.content)});return y.URI.revive(d)}async openNotebookDocument(w){const d=this._documents.get(w);if(d)return d.apiNotebook;const T=await this._notebookDocumentsProxy.$tryOpenNotebook(w),r=this._documents.get(y.URI.revive(T));return(0,A.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(w,d){y.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let T;typeof d=="object"?T={position:p.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(p.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:T={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(w.uri,w.notebookType,T),c=r&&this._editors.get(r)?.apiEditor;if(c)return c;throw r?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,d,T,r){const c=this._notebookStatusBarItemProviders.get(w),n=y.URI.revive(d),u=this._documents.get(n);if(!u||!c)return;const l=u.getCellFromIndex(T);if(!l)return;const f=await c.provideCellStatusBarItems(l.apiCell,r);if(!f)return;const s=new S.DisposableStore,h=this._statusBarCache.add([s]),P=(Array.isArray(f)?f:[f]).map(L=>p.NotebookStatusBarItem.from(L,this._commandsConverter,s));return{cacheId:h,items:P}}$releaseNotebookCellStatusBarItems(w){this._statusBarCache.delete(w)}registerNotebookSerializer(w,d,T,r,c){if((0,D.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,T),this._notebookProxy.$registerNotebookSerializer(n,{id:w.identifier,location:w.extensionLocation},d,p.NotebookDocumentContentOptions.from(r),a._convertNotebookRegistrationData(w,c)),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(w,d,T){const r=this._notebookSerializer.get(w);if(!r)throw new Error("NO serializer found");const c=await r.deserializeNotebook(d.buffer,T);return new m.SerializableObjectWithBuffers(p.NotebookData.from(c))}async $notebookToData(w,d,T){const r=this._notebookSerializer.get(w);if(!r)throw new Error("NO serializer found");const c=await r.serializeNotebook(p.NotebookData.to(d.value),T);return i.VSBuffer.wrap(c)}_createExtHostEditor(w,d,T){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const r=new o.ExtHostNotebookEditor(d,this._notebookEditorsProxy,w,T.visibleRanges.map(p.NotebookRange.to),T.selections.map(p.NotebookRange.to),typeof T.viewColumn=="number"?p.ViewColumn.to(T.viewColumn):void 0);this._editors.set(d,r)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const T of w.value.removedDocuments){const r=y.URI.revive(T),c=this._documents.get(r);c&&(c.dispose(),this._documents.delete(r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:c.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(c.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===r.toString()&&this._editors.delete(n.id)}if(w.value.addedDocuments){const T=[];for(const r of w.value.addedDocuments){const c=y.URI.revive(r.uri);if(this._documents.has(c))throw new Error(`adding EXISTING notebook ${c} `);const n=new t.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,c,r);T.push(...r.cells.map(u=>t.ExtHostCell.asModelAddData(n.apiNotebook,u))),this._documents.get(c)?.dispose(),this._documents.set(c,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:T}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(w.value.addedEditors)for(const T of w.value.addedEditors){if(this._editors.has(T.id))return;const r=y.URI.revive(T.documentUri),c=this._documents.get(r);c&&this._createExtHostEditor(c,T.id,T)}const d=[];if(w.value.removedEditors)for(const T of w.value.removedEditors){const r=this._editors.get(T);r&&(this._editors.delete(T),this._activeNotebookEditor?.id===r.id&&(this._activeNotebookEditor=void 0),d.push(r))}if(w.value.visibleEditors){this._visibleNotebookEditors=w.value.visibleEditors.map(r=>this._editors.get(r)).filter(r=>!!r);const T=new Set;this._visibleNotebookEditors.forEach(r=>T.add(r.id));for(const r of this._editors.values()){const c=T.has(r.id);r._acceptVisibility(c)}this._visibleNotebookEditors=[...this._editors.values()].map(r=>r).filter(r=>r.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this._activeNotebookEditor=void 0:w.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(w){const d=b.ApiCommandArgument.String.with("notebookType","A notebook type"),T=new b.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new b.ApiCommandArgument("data","Bytes to convert to data",c=>c instanceof Uint8Array,c=>i.VSBuffer.wrap(c))],new b.ApiCommandResult("Notebook Data",c=>p.NotebookData.to(c.value))),r=new b.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new b.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",c=>!0,c=>new m.SerializableObjectWithBuffers(p.NotebookData.from(c)))],new b.ApiCommandResult("Bytes",c=>c.buffer));w.registerApiCommand(T),w.registerApiCommand(r)}}e.ExtHostNotebookController=a,a._notebookStatusBarItemProviderHandlePool=0}),define(De[214],Ie([1,0,18,15,20,4,7,28,2,25,11,5,37,8,6,65,173,27,43]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let w=class{constructor(u,l,f,s,h){this._initData=l,this._extHostNotebook=f,this._commands=s,this._logService=h,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=u.getProxy(b.MainContext.MainThreadNotebookKernels);const v=new p.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.ApiCommandArgument("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const L=this._extHostNotebook.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:L}}else if(P&&"notebookEditor"in P){const L=this._extHostNotebook.getIdByEditor(P.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return P})],p.ApiCommandResult.Void);this._commands.registerApiCommand(v)}createNotebookController(u,l,f,s,h,v){for(const re of this._kernelData.values())if(re.controller.id===l&&k.ExtensionIdentifier.equals(u.identifier,re.extensionId))throw new Error(`notebook controller with id '${l}' ALREADY exist`);const P=this._handlePool++,L=this;this._logService.trace(`NotebookController[${P}], CREATED by ${u.identifier.value}, ${l}`);const j=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${u.identifier}'`);let W=!1;const V=new D.DisposableStore,C=new M.Emitter,F=new M.Emitter,O={id:c(u.identifier,l),notebookType:f,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:s||u.identifier.value,preloads:v?v.map(E.NotebookRendererScript.from):[]};let x=h??j,B;this._proxy.$addKernel(P,O).catch(re=>{console.log(re),W=!0});let H=0;const G=()=>{if(W)return;const re=++H;Promise.resolve().then(()=>{re===H&&this._proxy.$updateKernel(P,O)})},ee=new A.ResourceMap,ue={get id(){return l},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:C.event,get label(){return O.label},set label(re){O.label=re??u.displayName??u.name,G()},get detail(){return O.detail??""},set detail(re){O.detail=re,G()},get description(){return O.description??""},set description(re){O.description=re,G()},get kind(){return(0,a.checkProposedApiEnabled)(u,"notebookControllerKind"),O.kind??""},set kind(re){(0,a.checkProposedApiEnabled)(u,"notebookControllerKind"),O.kind=re,G()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(re){O.supportedLanguages=re,G()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(re){O.supportsExecutionOrder=re,G()},get rendererScripts(){return O.preloads?O.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return x},set executeHandler(re){x=re??j},get interruptHandler(){return B},set interruptHandler(re){B=re,O.supportsInterrupt=Boolean(re),G()},createNotebookCellExecution(re){if(W)throw new Error("notebook controller is DISPOSED");if(!ee.has(re.notebook.uri))throw L._logService.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(pe=>pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return L._createNotebookCellExecution(re,c(u.identifier,this.id))},dispose:()=>{W||(this._logService.trace(`NotebookController[${P}], DISPOSED`),W=!0,this._kernelData.delete(P),V.dispose(),C.dispose(),F.dispose(),this._proxy.$removeKernel(P))},updateNotebookAffinity(re,pe){pe===m.NotebookControllerAffinity2.Hidden&&(0,a.checkProposedApiEnabled)(u,"notebookControllerAffinityHidden"),L._proxy.$updateNotebookPriority(P,re.uri,pe)},onDidReceiveMessage:F.event,postMessage(re,pe){return(0,a.checkProposedApiEnabled)(u,"notebookMessaging"),L._proxy.$postMessage(P,pe&&L._extHostNotebook.getIdByEditor(pe),re)},asWebviewUri(re){return(0,a.checkProposedApiEnabled)(u,"notebookMessaging"),(0,t.asWebviewUri)(re,L._initData.remote)}};return this._kernelData.set(P,{extensionId:u.identifier,controller:ue,onDidReceiveMessage:F,onDidChangeSelection:C,associatedNotebooks:ee}),ue}getIdByController(u){for(const[l,f]of this._kernelData)if(f.controller===u)return c(f.extensionId,u.id);return null}$acceptNotebookAssociation(u,l,f){const s=this._kernelData.get(u);if(s){const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(l));f?s.associatedNotebooks.set(h.uri,!0):s.associatedNotebooks.delete(h.uri),this._logService.trace(`NotebookController[${u}] ASSOCIATE notebook`,h.uri.toString(),f),s.onDidChangeSelection.fire({selected:f,notebook:h.apiNotebook})}}async $executeCells(u,l,f){const s=this._kernelData.get(u);if(!s)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(l)),v=[];for(const P of f){const L=h.getCell(P);L&&v.push(L.apiCell)}try{this._logService.trace(`NotebookController[${u}] EXECUTE cells`,h.uri.toString(),v.length),await s.controller.executeHandler.call(s.controller,v,h.apiNotebook,s.controller)}catch(P){this._logService.error(`NotebookController[${u}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(u,l,f){const s=this._kernelData.get(u);if(!s)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(l));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,h.apiNotebook);else for(const v of f){const P=h.getCell(v);P&&this._activeExecutions.get(P.uri)?.cancel()}}$acceptKernelMessageFromRenderer(u,l,f){const s=this._kernelData.get(u);if(!s)return;const h=this._extHostNotebook.getEditorById(l);s.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:f}))}$cellExecutionChanged(u,l,f){const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(u)).getCell(l);if(h){const v=f?E.NotebookCellExecutionState.to(f):m.NotebookCellExecutionState.Idle;v!==void 0&&this._onDidChangeCellExecutionState.fire({cell:h.apiCell,state:v})}}_createNotebookCellExecution(u,l){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const h=new T(l,s,this._proxy);this._activeExecutions.set(s.uri,h);const v=h.onDidChangeState(()=>{h.state===d.Resolved&&(h.dispose(),v.dispose(),this._activeExecutions.delete(s.uri))});return h.asApiObject()}};w=He([$e(4,R.ILogService)],w),e.ExtHostNotebookKernels=w;var d;(function(n){n[n.Init=0]="Init",n[n.Started=1]="Started",n[n.Resolved=2]="Resolved"})(d||(d={}));class T extends D.Disposable{get state(){return this._state}constructor(u,l,f){super(),this._cell=l,this._proxy=f,this._handle=T.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new S.CancellationTokenSource),this._collector=new r(10,s=>this.update(s)),this._executionOrder=l.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,u,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(u){await this._collector.addItem(u)}async update(u){const l=Array.isArray(u)?u:[u];return this._proxy.$updateExecution(this._handle,new g.SerializableObjectWithBuffers(l))}verifyStateForOutput(){if(this._state===d.Init)throw new Error("Must call start before modifying cell output");if(this._state===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(u){let l=this._cell;if(u&&(l=this._cell.notebook.getCellFromApiCell(u)),!l)throw new Error("INVALID cell");return l.handle}validateAndConvertOutputs(u){return u.map(l=>{const f=m.NotebookCellOutput.ensureUniqueMimeTypes(l.items,!0);return f===l.items?E.NotebookCellOutput.from(l):E.NotebookCellOutput.from({items:f,id:l.id,metadata:l.metadata})})}async updateOutputs(u,l,f){const s=this.cellIndexToHandle(l),h=this.validateAndConvertOutputs((0,i.asArray)(u));return this.updateSoon({editType:o.CellExecutionUpdateType.Output,cellHandle:s,append:f,outputs:h})}async updateOutputItems(u,l,f){return u=m.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(u),!0),this.updateSoon({editType:o.CellExecutionUpdateType.OutputItems,items:u.map(E.NotebookCellOutputItem.from),outputId:l.id,append:f})}asApiObject(){const u=this;return Object.freeze({get token(){return u._tokenSource.token},get cell(){return u._cell.apiCell},get executionOrder(){return u._executionOrder},set executionOrder(f){u._executionOrder=f,u.update([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:u._executionOrder}])},start(f){if(u._state===d.Resolved||u._state===d.Started)throw new Error("Cannot call start again");u._state=d.Started,u._onDidChangeState.fire(),u.update({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,s){if(u._state===d.Resolved)throw new Error("Cannot call resolve twice");u._state=d.Resolved,u._onDidChangeState.fire(),u._collector.flush(),u._proxy.$completeExecution(u._handle,new g.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:f}))},clearOutput(f){return u.verifyStateForOutput(),u.updateOutputs([],f,!1)},appendOutput(f,s){return u.verifyStateForOutput(),u.updateOutputs(f,s,!0)},replaceOutput(f,s){return u.verifyStateForOutput(),u.updateOutputs(f,s,!1)},appendOutputItems(f,s){return u.verifyStateForOutput(),u.updateOutputItems(f,s,!0)},replaceOutputItems(f,s){return u.verifyStateForOutput(),u.updateOutputItems(f,s,!1)}})}}T.HANDLE=0;class r{constructor(u,l){this.delay=u,this.callback=l,this.batch=[],this.startedTimer=Date.now()}addItem(u){return this.batch.push(u),this.currentDeferred||(this.currentDeferred=new I.DeferredPromise,this.startedTimer=Date.now(),(0,I.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const u=this.currentDeferred;this.currentDeferred=void 0;const l=this.batch;return this.batch=[],this.callback(l).finally(()=>u.complete())}}function c(n,u){return`${n.value}/${u}`}e.createKernelId=c}),define(De[215],Ie([1,0,4,5,95]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(A,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(I.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,k){const R=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(y)?.fire({editor:R.apiEditor,message:k})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(R=>R.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(R,b,p)=>this.getOrCreateEmitterFor(y).event(R,b,p),postMessage:(R,b)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,b]=[b,R]);const p=b&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(b);return this.proxy.$postMessage(p?.id,y,R)}}}getOrCreateEmitterFor(A){let y=this._rendererMessageEmitters.get(A);return y||(y=new i.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,y),y)}}e.ExtHostNotebookRenderers=M}),define(De[216],Ie([1,0,20,4,7,5,2,6,12,18,29,62]),function(ie,e,i,I,S,M,D,A,y,k,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(E,m,t){const o=E.getProxy(M.MainContext.MainThreadQuickOpen);class a{constructor(l,f){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=f}showQuickPick(l,f,s=i.CancellationToken.None){this._onDidSelectItem=void 0;const h=Promise.resolve(l),v=++this._instances,P=o.$show(v,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},s),L={},j=P.then(()=>L);return Promise.race([j,h]).then(W=>{if(W!==L)return h.then(V=>{const C=[];for(let F=0;F<V.length;F++){const O=V[F];typeof O=="string"?C.push({label:O,handle:F}):O.kind===A.QuickPickItemKind.Separator?C.push({type:"separator",label:O.label}):C.push({label:O.label,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,handle:F})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=F=>{f.onDidSelectItem(V[F])}),o.$setItems(v,C),P.then(F=>{if(typeof F=="number")return V[F];if(Array.isArray(F))return F.map(O=>V[O])})})}).then(void 0,W=>{if(!(0,y.isCancellationError)(W))return o.$setError(v,W),Promise.reject(W)})}$onItemSelected(l){this._onDidSelectItem?.(l)}showInput(l,f=i.CancellationToken.None){return this._validateInput=l?.validateInput,o.$input(l,typeof this._validateInput=="function",f).then(void 0,s=>{if(!(0,y.isCancellationError)(s))return Promise.reject(s)})}async $validateInput(l){if(!this._validateInput)return;const f=await this._validateInput(l);if(!f||typeof f=="string")return f;let s;switch(f.severity){case A.InputBoxValidationSeverity.Info:s=R.default.Info;break;case A.InputBoxValidationSeverity.Warning:s=R.default.Warning;break;case A.InputBoxValidationSeverity.Error:s=R.default.Error;break;default:s=f.message?R.default.Error:R.default.Ignore;break}return{content:f.message,severity:s}}async showWorkspaceFolderPick(l,f=i.CancellationToken.None){const s=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!s)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(v=>v.uri.toString()===s.uri.toString())}createQuickPick(l){const f=new c(l,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(l){const f=new n(l,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}$onDidChangeValue(l,f){this._sessions.get(l)?._fireDidChangeValue(f)}$onDidAccept(l){this._sessions.get(l)?._fireDidAccept()}$onDidChangeActive(l,f){const s=this._sessions.get(l);s instanceof c&&s._fireDidChangeActive(f)}$onDidChangeSelection(l,f){const s=this._sessions.get(l);s instanceof c&&s._fireDidChangeSelection(f)}$onDidTriggerButton(l,f){this._sessions.get(l)?._fireDidTriggerButton(f)}$onDidTriggerItemButton(l,f,s){const h=this._sessions.get(l);h instanceof c&&h._fireDidTriggerItemButton(f,s)}$onDidHide(l){this._sessions.get(l)?._fireDidHide()}}class g{constructor(l,f){this._extensionId=l,this._onDidDispose=f,this._id=c._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((f,s)=>{const h=f===A.QuickInputButtons.Back?-1:s;this._handlesToButtons.set(h,f)}),this.update({buttons:l.map((f,s)=>({...r(f),tooltip:f.tooltip,handle:f===A.QuickInputButtons.Back?-1:s}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const f=this._handlesToButtons.get(l);f&&this._onDidTriggerButtonEmitter.fire(f)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,S.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),o.$dispose(this._id))}update(l){if(!this._disposed){for(const f of Object.keys(l)){const s=l[f];this._pendingUpdate[f]=s===void 0?null:s}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){o.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function w(u){if(u instanceof A.ThemeIcon)return{id:u.id};const l=T(u),f=d(u);return{dark:typeof l=="string"?D.URI.file(l):l,light:typeof f=="string"?D.URI.file(f):f}}function d(u){return typeof u=="object"&&"light"in u?u.light:u}function T(u){return typeof u=="object"&&"dark"in u?u.dark:u}function r(u){const l=w(u.iconPath);let f,s;return"id"in l?s=b.ThemeIcon.asClassName(l):f=l,{iconPath:f,iconClass:s}}class c extends g{constructor(l,f){super(l.identifier,f),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((s,h)=>{this._handlesToItems.set(h,s),this._itemsToHandles.set(s,h)});const f=[];for(let s=0;s<l.length;s++){const h=l[s];h.kind===A.QuickPickItemKind.Separator?f.push({type:"separator",label:h.label}):f.push({handle:s,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((v,P)=>({...r(v),tooltip:v.tooltip,handle:P}))})}this.update({items:f})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(f=>this._itemsToHandles.has(f)),this.update({activeItems:this._activeItems.map(f=>this._itemsToHandles.get(f))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(f=>this._itemsToHandles.has(f)),this.update({selectedItems:this._selectedItems.map(f=>this._itemsToHandles.get(f))})}_fireDidChangeActive(l){const f=(0,k.coalesce)(l.map(s=>this._handlesToItems.get(s)));this._activeItems=f,this._onDidChangeActiveEmitter.fire(f)}_fireDidChangeSelection(l){const f=(0,k.coalesce)(l.map(s=>this._handlesToItems.get(s)));this._selectedItems=f,this._onDidChangeSelectionEmitter.fire(f)}_fireDidTriggerItemButton(l,f){const s=this._handlesToItems.get(l);if(!s||!s.buttons||!s.buttons.length)return;const h=s.buttons[f];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:s})}}class n extends g{constructor(l,f){super(l.identifier,f),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get valueSelection(){return this._valueSelection}set valueSelection(l){this._valueSelection=l,this.update({valueSelection:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,l?typeof l=="string"?this.update({validationMessage:l,severity:R.default.Error}):this.update({validationMessage:l.message,severity:l.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new a(m,t)}e.createExtHostQuickOpen=p});var Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)},Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,S){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?S.call(ie,i):S?S.value=i:e.set(ie,i),i};define(De[217],Ie([1,0,2,4,58,7,15,5,18,119,11,25,62,8,27]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m){"use strict";var t,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(h){if(h)return typeof h.iconPath=="string"?i.URI.file(h.iconPath):i.URI.isUri(h.iconPath)||p.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function g(h,v){if(!h.iconPath&&!v.iconPath)return 0;if(h.iconPath){if(!v.iconPath)return 1}else return-1;const P=typeof h.iconPath=="string"?h.iconPath:i.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,L=typeof v.iconPath=="string"?v.iconPath:i.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,k.comparePaths)(P,L)}function w(h,v){let P=0;if(h.strikeThrough!==v.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==v.faded)return h.faded?1:-1;if(h.tooltip!==v.tooltip)return(h.tooltip||"").localeCompare(v.tooltip||"");if(P=g(h,v),P!==0)return P;if(h.light&&v.light)P=g(h.light,v.light);else{if(h.light)return 1;if(v.light)return-1}if(P!==0)return P;if(h.dark&&v.dark)P=g(h.dark,v.dark);else{if(h.dark)return 1;if(v.dark)return-1}return P}function d(h,v){if(h.command!==v.command)return h.command<v.command?-1:1;if(h.title!==v.title)return h.title<v.title?-1:1;if(h.tooltip!==v.tooltip){if(h.tooltip!==void 0&&v.tooltip!==void 0)return h.tooltip<v.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(h.arguments===v.arguments)return 0;if(h.arguments)if(v.arguments){if(h.arguments.length!==v.arguments.length)return h.arguments.length-v.arguments.length}else return 1;else return-1;for(let P=0;P<h.arguments.length;P++){const L=h.arguments[P],j=v.arguments[P];if(L!==j)return L<j?-1:1}return 0}function T(h,v){let P=(0,k.comparePaths)(h.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(P!==0)return P;if(h.command&&v.command)P=d(h.command,v.command);else{if(h.command)return 1;if(v.command)return-1}if(P!==0)return P;if(h.decorations&&v.decorations)P=w(h.decorations,v.decorations);else{if(h.decorations)return 1;if(v.decorations)return-1}return P}function r(h,v){for(let P=0;P<h.length;P++)if(h[P]!==v[P])return!1;return!0}function c(h,v){return h.command===v.command&&h.title===v.title&&h.tooltip===v.tooltip&&(h.arguments&&v.arguments?r(h.arguments,v.arguments):h.arguments===v.arguments)}function n(h,v){return(0,y.equals)(h,v,c)}class u{get value(){return this._value}set value(v){v=v??"",Ae(this,t,"f").$setInputBoxValue(this._sourceControlHandle,v),this.updateValue(v)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(v){Ae(this,t,"f").$setInputBoxPlaceholder(this._sourceControlHandle,v),this._placeholder=v}get validateInput(){return(0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(v){if((0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=v,Ae(this,t,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!v)}get enabled(){return this._enabled}set enabled(v){v=!!v,this._enabled!==v&&(this._enabled=v,Ae(this,t,"f").$setInputBoxEnablement(this._sourceControlHandle,v))}get visible(){return this._visible}set visible(v){v=!!v,this._visible!==v&&(this._visible=v,Ae(this,t,"f").$setInputBoxVisibility(this._sourceControlHandle,v))}constructor(v,P,L){this._extension=v,this._sourceControlHandle=L,t.set(this,void 0),this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Ye(this,t,P,"f")}showValidationMessage(v,P){(0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),Ae(this,t,"f").$showValidationMessage(this._sourceControlHandle,v,P)}$onInputBoxValueChange(v){this.updateValue(v)}updateValue(v){this._value=v,this._onDidChange.fire(v)}}e.ExtHostSCMInputBox=u,t=new WeakMap;class l{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(v){this._label=v,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,v)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(v){this._hideWhenEmpty=v,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(v){this._resourceStates=[...v],this._onDidUpdateResourceStates.fire()}constructor(v,P,L,j,W){this._proxy=v,this._commands=P,this._sourceControlHandle=L,this._id=j,this._label=W,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=l._handlePool++}getResourceState(v){return this._resourceStatesMap.get(v)}$executeResourceCommand(v,P){const L=this._resourceStatesCommandsMap.get(v);return L?(0,D.asPromise)(()=>this._commands.executeCommand(L.command,...L.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this._resourceStates].sort(T),L=(0,y.sortedDiff)(this._resourceSnapshot,v,T).map(V=>{const C=V.toInsert.map(F=>{const O=this._resourceHandlePool++;this._resourceStatesMap.set(O,F);const x=F.resourceUri;let B;if(F.command)if(F.command.command==="vscode.open"||F.command.command==="vscode.diff"){const me=new M.DisposableStore;B=this._commands.converter.toInternal(F.command,me),this._resourceStatesDisposablesMap.set(O,me)}else this._resourceStatesCommandsMap.set(O,F.command);const H=a(F.decorations),G=F.decorations&&a(F.decorations.light)||H,ee=F.decorations&&a(F.decorations.dark)||H,ue=[G,ee],re=F.decorations&&F.decorations.tooltip||"",pe=F.decorations&&!!F.decorations.strikeThrough,le=F.decorations&&!!F.decorations.faded,de=F.contextValue||"";return{rawResource:[O,x,ue,re,pe,le,de,B],handle:O}});return{start:V.start,deleteCount:V.deleteCount,toInsert:C}}),j=L.map(({start:V,deleteCount:C,toInsert:F})=>[V,C,F.map(O=>O.rawResource)]),W=L.reverse();for(const{start:V,deleteCount:C,toInsert:F}of W){const O=F.map(B=>B.handle),x=this._handlesSnapshot.splice(V,C,...O);for(const B of x)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=v,j}dispose(){this._disposed=!0,this._onDidDispose.fire()}}l._handlePool=0;class f{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(v){this._count!==v&&(this._count=v,Ae(this,o,"f").$updateSourceControl(this.handle,{count:v}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(v){this._quickDiffProvider=v,Ae(this,o,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!v})}get commitTemplate(){return this._commitTemplate}set commitTemplate(v){v!==this._commitTemplate&&(this._commitTemplate=v,Ae(this,o,"f").$updateSourceControl(this.handle,{commitTemplate:v}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(v){this._acceptInputDisposables.value=new M.DisposableStore,this._acceptInputCommand=v;const P=this._commands.converter.toInternal(v,this._acceptInputDisposables.value);Ae(this,o,"f").$updateSourceControl(this.handle,{acceptInputCommand:P})}get actionButton(){return(0,m.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(v){(0,m.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new M.DisposableStore,this._actionButton=v;const P=v!==void 0?{command:this._commands.converter.toInternal(v.command,this._actionButtonDisposables.value),secondaryCommands:v.secondaryCommands?.map(L=>L.map(j=>this._commands.converter.toInternal(j,this._actionButtonDisposables.value))),description:v.description,enabled:v.enabled}:void 0;Ae(this,o,"f").$updateSourceControl(this.handle,{actionButton:P??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(v){if(this._statusBarCommands&&v&&n(this._statusBarCommands,v))return;this._statusBarDisposables.value=new M.DisposableStore,this._statusBarCommands=v;const P=(v||[]).map(L=>this._commands.converter.toInternal(L,this._statusBarDisposables.value));Ae(this,o,"f").$updateSourceControl(this.handle,{statusBarCommands:P})}get selected(){return this._selected}constructor(v,P,L,j,W,V){this._extension=v,this._commands=L,this._id=j,this._label=W,this._rootUri=V,o.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new M.MutableDisposable,this._statusBarDisposables=new M.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=f._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ye(this,o,P,"f"),this._inputBox=new u(v,Ae(this,o,"f"),this.handle),Ae(this,o,"f").$registerSourceControl(this.handle,j,W,V)}createResourceGroup(v,P){const L=new l(Ae(this,o,"f"),this._commands,this.handle,v,P),j=I.Event.once(L.onDidDispose)(()=>this.createdResourceGroups.delete(L));return this.createdResourceGroups.set(L,j),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const v=[],P=[];for(const[L,j]of this.createdResourceGroups){j.dispose();const W=L.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(L),this.eventuallyUpdateResourceStates()});I.Event.once(L.onDidDispose)(()=>{this.updatedResourceGroups.delete(L),W.dispose(),this._groups.delete(L.handle),Ae(this,o,"f").$unregisterGroup(this.handle,L.handle)}),v.push([L.handle,L.id,L.label,L.features]);const V=L._takeResourceStateSnapshot();V.length>0&&P.push([L.handle,V]),this._groups.set(L.handle,L)}Ae(this,o,"f").$registerGroups(this.handle,v,P),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const v=[];this.updatedResourceGroups.forEach(P=>{const L=P._takeResourceStateSnapshot();L.length!==0&&v.push([P.handle,L])}),v.length>0&&Ae(this,o,"f").$spliceResourceStates(this.handle,v),this.updatedResourceGroups.clear()}getResourceGroup(v){return this._groups.get(v)}setSelectionState(v){this._selected=v,this._onDidChangeSelection.fire(v)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(v=>v.dispose()),Ae(this,o,"f").$unregisterSourceControl(this.handle)}}o=new WeakMap,f._handlePool=0,He([(0,S.debounce)(100)],f.prototype,"eventuallyAddResourceGroups",null),He([(0,S.debounce)(100)],f.prototype,"eventuallyUpdateResourceStates",null);let s=class Ji{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(v,P,L){this._commands=P,this.logService=L,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=v.getProxy(A.MainContext.MainThreadSCM),this._telemetry=v.getProxy(A.MainContext.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const W=this._sourceControls.get(j.sourceControlHandle);if(!W)return j;const V=W.getResourceGroup(j.groupHandle);return V?V.getResourceState(j.handle):j}else if(j&&j.$mid===4){const W=this._sourceControls.get(j.sourceControlHandle);return W?W.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const W=this._sourceControls.get(j.handle);return W||j}return j}})}createSourceControl(v,P,L,j){this.logService.trace("ExtHostSCM#createSourceControl",v.identifier.value,P,L,j),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const W=Ji._handlePool++,V=new f(v,this._proxy,this._commands,P,L,j);this._sourceControls.set(W,V);const C=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(v.identifier))||[];return C.push(V),this._sourceControlsByExtension.set(b.ExtensionIdentifier.toKey(v.identifier),C),V}getLastInputBox(v){this.logService.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const P=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(v.identifier)),L=P&&P[P.length-1];return L&&L.inputBox}$provideOriginalResource(v,P,L){const j=i.URI.revive(P);this.logService.trace("ExtHostSCM#$provideOriginalResource",v,j.toString());const W=this._sourceControls.get(v);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>W.quickDiffProvider.provideOriginalResource(j,L)).then(V=>V||null)}$onInputBoxValueChange(v,P){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",v);const L=this._sourceControls.get(v);return L&&L.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(v,P,L,j){this.logService.trace("ExtHostSCM#$executeResourceCommand",v,P,L);const W=this._sourceControls.get(v);if(!W)return Promise.resolve(void 0);const V=W.getResourceGroup(P);return V?V.$executeResourceCommand(L,j):Promise.resolve(void 0)}$validateInput(v,P,L){this.logService.trace("ExtHostSCM#$validateInput",v);const j=this._sourceControls.get(v);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>j.inputBox.validateInput(P,L)).then(W=>{if(!W)return Promise.resolve(void 0);const V=E.MarkdownString.fromStrict(W.message);return V?Promise.resolve([V,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this._sourceControls.get(v)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=v,Promise.resolve(void 0)}};s._handlePool=0,s=He([$e(2,R.ILogService)],s),e.ExtHostSCM=s}),define(De[73],Ie([1,0,5,4,3]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(A){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,y){return this._proxy.$getPassword(A,y)}store(A,y,k){return this._proxy.$setPassword(A,y,k)}delete(A,y){return this._proxy.$deletePassword(A,y)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,S){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?S.call(ie,i):S?S.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[218],Ie([1,0,6,5,134,7,8,9]),function(ie,e,i,I,S,M,D,A){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(m,t,o,a,g=i.StatusBarAlignment.Left,w){y.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new M.DisposableStore,Ye(this,y,m,"f"),Ye(this,k,t,"f"),this._entryId=R.ID_GEN++,this._extension=o,this._id=a,this._alignment=g,this._priority=this.validatePriority(w)}validatePriority(m){if(!!(0,A.isNumber)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(m){this._text=m,this.update()}set name(m){this._name=m,this.update()}set tooltip(m){this._tooltip=m,this.update()}set color(m){this._color=m,this.update()}set backgroundColor(m){m&&!R.ALLOWED_BACKGROUND_COLORS.has(m.id)&&(m=void 0),this._backgroundColor=m,this.update()}set command(m){this._command?.fromApi!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:Ae(this,k,"f").toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:Ae(this,k,"f").toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let m;this._extension?this._id?m=`${this._extension.identifier.value}.${this._id}`:m=this._extension.identifier.value:m=this._id;let t;this._name?t=this._name:t=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let o=this._color;this._backgroundColor&&(o=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const a=D.MarkdownString.fromStrict(this._tooltip);Ae(this,y,"f").$setEntry(this._entryId,m,t,this._text,a,this._command?.internal,o,this._backgroundColor,this._alignment===i.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,y=new WeakMap,k=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(m){this._messages=[],this._item=m.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(m){const t={message:m};return this._messages.unshift(t),this._update(),new i.Disposable(()=>{const o=this._messages.indexOf(t);o>=0&&(this._messages.splice(o,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class p{constructor(m,t){this._proxy=m.getProxy(I.MainContext.MainThreadStatusBar),this._commands=t,this._statusMessage=new b(this)}createStatusBarEntry(m,t,o,a){return new R(this._proxy,this._commands,m,t,o,a)}setStatusBarMessage(m,t){const o=this._statusMessage.setMessage(m);let a;return typeof t=="number"?a=setTimeout(()=>o.dispose(),t):typeof t<"u"&&t.then(()=>o.dispose(),()=>o.dispose()),new i.Disposable(()=>{o.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=p}),define(De[74],Ie([1,0,5,4,3]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(A){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this._proxy.$registerExtensionStorageKeysToSync(A,y)}initializeExtensionStorage(A,y,k){return this._proxy.$initializeExtensionStorage(A,y).then(R=>R||k)}setValue(A,y,k){return this._proxy.$setValue(A,y,k)}$acceptValue(A,y,k){this._onDidChangeStorage.fire({shared:A,key:y,value:k})}}e.ExtHostStorage=M,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(De[75],Ie([1,0,3,26,11,55,2]),function(ie,e,i,I,S,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let A=class{constructor(k,R,b){this._logService=R,this._extHostFileSystem=b,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(p=>this._value=p)}async _getWorkspaceStorageURI(k){return D.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,R=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:D.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(k){if(this._value)return D.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return D.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=He([$e(0,I.IExtHostInitDataService),$e(1,S.ILogService),$e(2,M.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(De[56],Ie([1,0,4,5,3,2,14,7,6,135,12,174,20,38,159,62,9,15,8]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class w{constructor(s,h,v,P){this._proxy=s,this._id=h,this._creationOptions=v,this._name=P,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(j=>this._pidPromiseComplete=j);const L=this;this.value={get name(){return L._name||""},get processId(){return L._pidPromise},get creationOptions(){return L._creationOptions},get exitStatus(){return L._exitStatus},get state(){return L._state},sendText(j,W=!0){L._checkDisposed(),L._proxy.$sendText(L._id,j,W)},show(j){L._checkDisposed(),L._proxy.$show(L._id,j)},hide(){L._checkDisposed(),L._proxy.$hide(L._id)},dispose(){L._disposed||(L._disposed=!0,L._proxy.$dispose(L._id))},get dimensions(){if(!(L._cols===void 0||L._rows===void 0))return{columns:L._cols,rows:L._rows}}}}async create(s,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:(0,o.withNullAsUndefined)(s.shellPath),shellArgs:(0,o.withNullAsUndefined)(s.shellArgs),cwd:(0,o.withNullAsUndefined)(s.cwd),env:(0,o.withNullAsUndefined)(s.env),icon:(0,o.withNullAsUndefined)(u(s.iconPath)),color:t.ThemeColor.isThemeColor(s.color)?s.color.id:void 0,initialText:(0,o.withNullAsUndefined)(s.message),strictEnv:(0,o.withNullAsUndefined)(s.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(s.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this._serializeParentTerminal(s.location,h?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(s.isTransient)})}async createExtensionTerminal(s,h,v,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:v,color:t.ThemeColor.isThemeColor(P)?P.id:void 0,location:this._serializeParentTerminal(s,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(s,h){return typeof s=="object"?"parentTerminal"in s&&s.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in s?{viewColumn:g.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus}:void 0:s}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitStatus(s,h){this._exitStatus=Object.freeze({code:s,reason:h})}setDimensions(s,h){return s===this._cols&&h===this._rows||s===0||h===0?!1:(this._cols=s,this._rows=h,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=w;class d{get onProcessReady(){return this._onProcessReady.event}constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._onProcessData=new i.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new i.Emitter,this._onDidChangeProperty=new i.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new i.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(s){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${s}`)}updateProperty(s,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${s}, value: ${h}`)}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput?.(s)}resize(s,h){this._pty.setDimensions?.({columns:s,rows:h})}async processBinary(s){}acknowledgeDataEvent(s){}async setUnicodeVersion(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose?.((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions?.(h=>{h&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this._pty.onDidChangeName?.(h=>{this._onDidChangeProperty.fire({type:"title",value:h})}),this._pty.open(s||void 0),s&&this._pty.setDimensions?.(s),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=d;let T=1,r=class extends A.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(s,h){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new i.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new i.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new i.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new i.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new i.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new i.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=h.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new m.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new i.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[v,P]of this._terminalProcesses)P.shutdown(!0)}})}getDefaultShell(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(s,h){const v=new w(this._proxy,(0,E.generateUuid)(),s,s.name),P=new d(s.pty);return v.createExtensionTerminal(s.location,this._serializeParentTerminal(s,h).resolvedExtHostIdentifier,u(s.iconPath),l(s.color)).then(L=>{const j=this._setupExtHostProcessListeners(L,P);this._terminalProcessDisposables[L]=j}),this._terminals.push(v),v.value}_serializeParentTerminal(s,h){if(h=h||{},s.location&&typeof s.location=="object"&&"parentTerminal"in s.location){const v=s.location.parentTerminal;if(v){const P=this._terminals.find(L=>L.value===v);P&&(h.resolvedExtHostIdentifier=P._id)}}else s.location&&typeof s.location!="object"?h.location=s.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(s,h){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const P=new d(h),L=this._setupExtHostProcessListeners(s,P);this._terminalProcessDisposables[s]=L}async $acceptActiveTerminalChanged(s){const h=this._activeTerminal;if(s===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const v=this._getTerminalById(s);v&&(this._activeTerminal=v,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,h){const v=this._getTerminalById(s);v&&this._onDidWriteTerminalData.fire({terminal:v.value,data:h})}async $acceptTerminalDimensions(s,h,v){const P=this._getTerminalById(s);P&&P.setDimensions(h,v)&&this._onDidChangeTerminalDimensions.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptTerminalMaximumDimensions(s,h,v){this._terminalProcesses.get(s)?.resize(h,v)}async $acceptTerminalTitleChange(s,h){const v=this._getTerminalById(s);v&&(v.name=h)}async $acceptTerminalClosed(s,h,v){const P=this._getTerminalObjectIndexById(this._terminals,s);if(P!==null){const L=this._terminals.splice(P,1)[0];L.setExitStatus(h,v),this._onDidCloseTerminal.fire(L.value)}}$acceptTerminalOpened(s,h,v,P){if(h){const W=this._getTerminalObjectIndexById(this._terminals,h);if(W!==null){this._terminals[W]._id=s,this._onDidOpenTerminal.fire(this.terminals[W]),this._terminals[W].isOpen=!0;return}}const L={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:M.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},j=new w(this._proxy,s,L,v);this._terminals.push(j),this._onDidOpenTerminal.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(s,h){this._getTerminalById(s)?._setProcessId(h)}async $startExtensionTerminal(s,h){const v=this._getTerminalById(s);if(!v)return{message:(0,k.localize)(0,null,s)};v.isOpen||await new Promise(L=>{const j=this.onDidOpenTerminal(async W=>{W===v.value&&(j.dispose(),L())})});const P=this._terminalProcesses.get(s);P?P.startSendingEvents(h):this._extensionTerminalAwaitingStart[s]={initialDimensions:h}}_setupExtHostProcessListeners(s,h){const v=new A.DisposableStore;v.add(h.onProcessReady(L=>this._proxy.$sendProcessReady(s,L.pid,L.cwd))),v.add(h.onDidChangeProperty(L=>this._proxy.$sendProcessProperty(s,L))),this._bufferer.startBuffering(s,h.onProcessData),v.add(h.onProcessExit(L=>this._onProcessExit(s,L))),this._terminalProcesses.set(s,h);const P=this._extensionTerminalAwaitingStart[s];return P&&h instanceof d&&(h.startSendingEvents(P.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),v}$acceptProcessAckDataEvent(s,h){this._terminalProcesses.get(s)?.acknowledgeDataEvent(h)}$acceptProcessInput(s,h){this._terminalProcesses.get(s)?.input(h)}$acceptTerminalInteraction(s){const h=this._getTerminalById(s);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptProcessResize(s,h,v){try{this._terminalProcesses.get(s)?.resize(h,v)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(s,h){this._terminalProcesses.get(s)?.shutdown(h)}$acceptProcessRequestInitialCwd(s){this._terminalProcesses.get(s)?.getInitialCwd().then(h=>this._proxy.$sendProcessProperty(s,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(s){this._terminalProcesses.get(s)?.getCwd().then(h=>this._proxy.$sendProcessProperty(s,{type:"cwd",value:h}))}$acceptProcessRequestLatency(s){return Promise.resolve(s)}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,h,v){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,v),this._proxy.$registerProfileProvider(h,s.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(s,h){const v=new p.CancellationTokenSource().token;let P=await this._profileProviders.get(s)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,h);return}this.createTerminalFromOptions(P.options,h)}}async $provideLinks(s,h){const v=this._getTerminalById(s);if(!v)return[];this._terminalLinkCache.delete(s),this._terminalLinkCancellationSource.get(s)?.dispose(!0);const L=new p.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,L);const j=[],W={terminal:v.value,line:h},V=[];for(const O of this._linkProviders)V.push(a.Promises.withAsyncBody(async x=>{L.token.onCancellationRequested(()=>x({provider:O,links:[]}));const B=await O.provideTerminalLinks(W,L.token)||[];L.token.isCancellationRequested||x({provider:O,links:B})}));const C=await Promise.all(V);if(L.token.isCancellationRequested)return[];const F=new Map;for(const O of C)O&&O.links.length>0&&j.push(...O.links.map(x=>{const B={id:T++,startIndex:x.startIndex,length:x.length,label:x.tooltip};return F.set(B.id,{provider:O.provider,link:x}),B}));return this._terminalLinkCache.set(s,F),j}$activateLink(s,h){const v=this._terminalLinkCache.get(s)?.get(h);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(s,h){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const v=this._terminalProcessDisposables[s];v&&(v.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,h)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,h){const v=this._getTerminalObjectIndexById(s,h);return v!==null?s[v]:null}_getTerminalObjectIndexById(s,h){let v=null;return s.some((P,L)=>P._id===h?(v=L,!0):!1),v}getEnvironmentVariableCollection(s){let h=this._environmentVariableCollections.get(s.identifier.value);return h||(h=new c,this._setEnvironmentVariableCollection(s.identifier.value,h)),h}_syncEnvironmentVariableCollection(s,h){const v=(0,b.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(s,h.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(s){s.forEach(h=>{const v=h[0],P=new c(h[1]);this._setEnvironmentVariableCollection(v,P)})}$acceptDefaultProfile(s,h){const v=this._defaultProfile;this._defaultProfile=s,this._defaultAutomationProfile=h,v?.path!==s.path&&this._onDidChangeShell.fire(s.path)}_setEnvironmentVariableCollection(s,h){this._environmentVariableCollections.set(s,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,h)})}};r=He([$e(1,D.IExtHostRpcService)],r),e.BaseExtHostTerminalService=r;class c{get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new i.Emitter,this.map=new Map(s)}get size(){return this.map.size}replace(s,h){this._setIfDiffers(s,{value:h,type:y.EnvironmentVariableMutatorType.Replace})}append(s,h){this._setIfDiffers(s,{value:h,type:y.EnvironmentVariableMutatorType.Append})}prepend(s,h){this._setIfDiffers(s,{value:h,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,h){const v=this.map.get(s);(!v||v.value!==h.value||v.type!==h.type)&&(this.map.set(s,h),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,h){this.map.forEach((v,P)=>s.call(h,P,v,this))}[Symbol.iterator](){return this.map.entries()}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let n=class extends r{constructor(s){super(!1,s)}createTerminal(s,h,v){throw new R.NotSupportedError}createTerminalFromOptions(s,h){throw new R.NotSupportedError}};n=He([$e(0,D.IExtHostRpcService)],n),e.WorkerExtHostTerminalService=n;function u(f){if(!(!f||typeof f=="string"))return"id"in f?{id:f.id,color:f.color}:f}function l(f){return t.ThemeColor.isThemeColor(f)?f:void 0}});var Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)},Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,S){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?S.call(ie,i):S?S.value=i:e.set(ie,i),i};define(De[219],Ie([1,0,18,24,20,4,183,220,7,23,9,38,5,14,96,8,6,42,67,51]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o,a,g,w){"use strict";var d,T;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(W,V,C){this.editors=C,this.resultsChangedEmitter=new M.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=W.getProxy(p.MainContext.MainThreadTesting),this.observer=new v(this.proxy),this.runTracker=new n(this.proxy),V.registerArgumentProcessor({processArgument:F=>{if(F?.$mid!==14)return F;const O=F,x=O.tests[O.tests.length-1].item.extId;return this.controllers.get(a.TestId.root(x))?.collection.tree.get(x)?.actual??(0,m.toItemFromContext)(F)}})}createTestController(W,V,C){if(this.controllers.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const F=new y.DisposableStore,O=F.add(new m.ExtHostTestItemCollection(W,V,this.editors));O.root.label=V;const x=new Map,B=this.proxy,H={items:O.root.children,get label(){return V},set label(ee){V=ee,O.root.label=ee,B.$updateController(W,{label:V})},get refreshHandler(){return C},set refreshHandler(ee){C=ee,B.$updateController(W,{canRefresh:!!ee})},get id(){return W},createRunProfile:(ee,ue,re,pe,le)=>{let de=(0,A.hash)(ee);for(;x.has(de);)de++;return new P(this.proxy,x,W,de,ee,ue,re,pe,le)},createTestItem(ee,ue,re){return new m.TestItemImpl(W,ee,ue,re)},createTestRun:(ee,ue,re=!0)=>this.runTracker.createTestRun(W,O,ee,ue,re),set resolveHandler(ee){O.resolveHandler=ee},get resolveHandler(){return O.resolveHandler},dispose:()=>{F.dispose()}};B.$registerTestController(W,V,!!C),F.add((0,y.toDisposable)(()=>B.$unregisterTestController(W)));const G={controller:H,collection:O,profiles:x};return this.controllers.set(W,G),F.add((0,y.toDisposable)(()=>this.controllers.delete(W))),F.add(O.onDidGenerateDiff(ee=>B.$publishDiff(W,ee.map(w.TestsDiffOp.serialize)))),H}createTestObserver(){return this.observer.checkout()}async runTests(W,V=S.CancellationToken.None){const C=u(W);if(!C)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(C.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:W.include?.map(O=>a.TestId.fromExtHostTestItem(O,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:L[C.kind],profileId:C.profileId,controllerId:C.controllerId}],exclude:W.exclude?.map(O=>O.id)},V)}$syncTests(){for(const{collection:W}of this.controllers.values())W.flushDiff();return Promise.resolve()}$provideFileCoverage(W,V,C){return(0,i.mapFind)(this.runTracker.trackers,O=>O.id===W?O.getCoverage(V):void 0)?.provideFileCoverage(C)??Promise.resolve([])}$resolveFileCoverage(W,V,C,F){return(0,i.mapFind)(this.runTracker.trackers,x=>x.id===W?x.getCoverage(V):void 0)?.resolveFileCoverage(C,F)??Promise.resolve([])}$configureRunProfile(W,V){this.controllers.get(W)?.profiles.get(V)?.configureHandler?.()}async $refreshTests(W,V){await this.controllers.get(W)?.controller.refreshHandler?.(V)}$publishTestResults(W){this.results=Object.freeze(W.map(V=>(0,k.deepFreeze)(t.TestResults.to(V))).concat(this.results).sort((V,C)=>C.completedAt-V.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(W,V){const C=this.controllers.get(a.TestId.fromString(W).controllerId)?.collection;C&&(await C.expand(W,V<0?1/0:V),C.flushDiff())}$acceptDiff(W){this.observer.applyDiff(W.map(w.TestsDiffOp.deserialize))}async $runControllerTests(W,V){return Promise.all(W.map(C=>this.runControllerTestRequest(C,V)))}async runControllerTestRequest(W,V){const C=this.controllers.get(W.controllerId);if(!C)return{};const{collection:F,profiles:O}=C,x=O.get(W.profileId);if(!x)return{};const B=W.testIds.map(ue=>F.tree.get(ue)).filter(R.isDefined),H=W.excludeExtIds.map(ue=>C.collection.tree.get(ue)).filter(R.isDefined).filter(ue=>B.some(re=>re.fullId.compare(ue.fullId)===2));if(!B.length)return{};const G=new o.TestRunRequest(B.some(ue=>ue.actual instanceof m.TestItemRootImpl)?void 0:B.map(ue=>ue.actual),H.map(ue=>ue.actual),x),ee=this.runTracker.prepareForMainThreadTestRun(G,l.fromInternal(W,C.collection),V);try{return await x.runHandler(G,V),{}}catch(ue){return{error:String(ue)}}finally{ee.isRunning&&!V.isCancellationRequested&&await M.Event.toPromise(ee.onEnd),ee.dispose()}}$cancelExtensionTestRun(W){W===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(W)}};r=He([$e(0,E.IExtHostRpcService)],r),e.ExtHostTesting=r;class c extends y.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(W,V,C){super(),this.dto=W,this.proxy=V,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new M.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new S.CancellationTokenSource(C)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}getCoverage(W){return this.tasks.get(W)?.coverage}createRun(W){const V=this.dto.id,C=this.dto.controllerId,F=(0,b.generateUuid)(),O=new f(this.proxy,V,F),x=ee=>(ue,...re)=>{if(H){console.warn(`Setting the state of test "${ue.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(ue)||(this.ensureTestIsKnown(ue),ee(ue,...re))},B=(ee,ue)=>{const re=ue instanceof Array?ue.map(t.TestMessage.from):[t.TestMessage.from(ue)];if(ee.uri&&ee.range){const pe={range:t.Range.from(ee.range),uri:ee.uri};for(const le of re)le.location=le.location||pe}this.proxy.$appendTestMessagesInRun(V,F,a.TestId.fromExtHostTestItem(ee,C).toString(),re)};let H=!1;const G={isPersisted:this.dto.isPersisted,token:this.cts.token,name:W,get coverageProvider(){return O.coverageProvider},set coverageProvider(ee){O.coverageProvider=ee},enqueued:x(ee=>{this.proxy.$updateTestStateInRun(V,F,a.TestId.fromExtHostTestItem(ee,C).toString(),1)}),skipped:x(ee=>{this.proxy.$updateTestStateInRun(V,F,a.TestId.fromExtHostTestItem(ee,C).toString(),5)}),started:x(ee=>{this.proxy.$updateTestStateInRun(V,F,a.TestId.fromExtHostTestItem(ee,C).toString(),2)}),errored:x((ee,ue,re)=>{B(ee,ue),this.proxy.$updateTestStateInRun(V,F,a.TestId.fromExtHostTestItem(ee,C).toString(),6,re)}),failed:x((ee,ue,re)=>{B(ee,ue),this.proxy.$updateTestStateInRun(V,F,a.TestId.fromExtHostTestItem(ee,C).toString(),4,re)}),passed:x((ee,ue)=>{this.proxy.$updateTestStateInRun(V,F,a.TestId.fromExtHostTestItem(ee,this.dto.controllerId).toString(),3,ue)}),appendOutput:(ee,ue,re)=>{H||(re&&(this.dto.isIncluded(re)?this.ensureTestIsKnown(re):re=void 0),this.proxy.$appendOutputToRun(V,F,I.VSBuffer.fromString(ee),ue&&t.location.from(ue),re&&a.TestId.fromExtHostTestItem(re,C).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(V,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:G,coverage:O}),this.proxy.$startedTestRunTask(V,{id:F,name:W,running:!0}),G}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(W){if(!(W instanceof m.TestItemImpl))throw new g.InvalidTestItemError(W.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(W,this.dto.controllerId).toString()))return;const V=[],C=this.dto.colllection.root;for(;;){const F=t.TestItem.from(W);if(V.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),W===C))break;W=W.parent||C}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,V)}}class n{get trackers(){return this.tracked.values()}constructor(W){this.proxy=W,this.tracked=new Map}prepareForMainThreadTestRun(W,V,C){return this.getTracker(W,V,C)}cancelRunById(W){for(const V of this.tracked.values())if(V.id===W){V.dispose();return}}cancelAllRuns(){for(const W of this.tracked.values())W.dispose()}createTestRun(W,V,C,F,O){const x=this.tracked.get(C);if(x)return x.createRun(F);const B=l.fromPublic(W,V,C,O),H=u(C);this.proxy.$startedExtensionTestRun({controllerId:W,profile:H&&{group:L[H.kind],id:H.profileId},exclude:C.exclude?.map(ee=>a.TestId.fromExtHostTestItem(ee,V.root.id).toString())??[],id:B.id,include:C.include?.map(ee=>a.TestId.fromExtHostTestItem(ee,V.root.id).toString())??[V.root.id],persist:O});const G=this.getTracker(C,B);return G.onEnd(()=>this.proxy.$finishedExtensionTestRun(B.id)),G.createRun(F)}getTracker(W,V,C){const F=new c(V,this.proxy,C);return this.tracked.set(W,F),F.onEnd(()=>this.tracked.delete(W)),F}}e.TestRunCoordinator=n;const u=j=>{if(!!j.profile){if(!(j.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class l{static fromPublic(W,V,C,F){return new l(W,(0,b.generateUuid)(),C.include?.map(O=>a.TestId.fromExtHostTestItem(O,W).toString())??[W],C.exclude?.map(O=>a.TestId.fromExtHostTestItem(O,W).toString())??[],F,V)}static fromInternal(W,V){return new l(W.controllerId,W.runId,W.testIds,W.excludeExtIds,!0,V)}constructor(W,V,C,F,O,x){this.controllerId=W,this.id=V,this.isPersisted=O,this.colllection=x,this.includePrefix=C.map(B=>B+"\0"),this.excludePrefix=F.map(B=>B+"\0")}isIncluded(W){const V=a.TestId.fromExtHostTestItem(W,this.controllerId).toString()+"\0";for(const C of this.excludePrefix)if(V===C||V.startsWith(C))return!1;for(const C of this.includePrefix)if(V===C||V.startsWith(C))return!0;return!1}}e.TestRunDto=l;class f{set coverageProvider(W){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!W||(this._coverageProvider=W,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(W,V,C){this.proxy=W,this.runId=V,this.taskId=C}async provideFileCoverage(W){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(W))());try{return(await this.fileCoverage)?.map(t.TestCoverage.fromFile)??[]}catch(V){throw this.fileCoverage=void 0,V}}async resolveFileCoverage(W,V){const C=await this.fileCoverage;let F=C?.[W];return!this._coverageProvider||!C||!F?[]:(F.detailedCoverage||(F=C[W]=await this._coverageProvider.resolveFileCoverage?.(F,V)??F),F.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class s extends w.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(W){super(),this.emitter=W,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(W){this.added.add(W)}update(W){Object.assign(W.revived,t.TestItem.toPlain(W.item)),this.added.has(W)||this.updated.add(W)}remove(W){if(this.added.has(W)){this.added.delete(W);return}this.updated.delete(W);const V=a.TestId.parentId(W.item.extId);if(V&&this.alreadyRemoved.has(V.toString())){this.alreadyRemoved.add(W.item.extId);return}this.removed.add(W)}getChangeEvent(){const{added:W,updated:V,removed:C}=this;return{get added(){return[...W].map(F=>F.revived)},get updated(){return[...V].map(F=>F.revived)},get removed(){return[...C].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new M.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(W){return this.items.get(W)}getMirroredTestDataByReference(W){return this.items.get(W.id)}createItem(W,V){return{...W,revived:t.TestItem.toPlain(W.item),depth:V?V.depth+1:0,children:new Set}}createChangeCollector(){return new s(this.changeEmitter)}}e.MirroredTestCollection=h;class v{constructor(W){this.proxy=W}checkout(){this.current||(this.current=this.createObserverData());const W=this.current;return W.observers++,{onDidChangeTest:W.tests.onDidChangeTests,get tests(){return[...W.tests.rootTests].map(V=>V.revived)},dispose:(0,D.once)(()=>{--W.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(W){return this.current?.tests.getMirroredTestDataByReference(W)}applyDiff(W){this.current?.tests.apply(W)}createObserverData(){const W=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:W}}}class P{get label(){return this._label}set label(W){W!==this._label&&(this._label=W,Ae(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:W}))}get isDefault(){return this._isDefault}set isDefault(W){W!==this._isDefault&&(this._isDefault=W,Ae(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:W}))}get tag(){return this._tag}set tag(W){W?.id!==this._tag?.id&&(this._tag=W,Ae(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:W?t.TestTag.namespace(this.controllerId,W.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(W){W!==this._configureHandler&&(this._configureHandler=W,Ae(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!W}))}constructor(W,V,C,F,O,x,B,H=!1,G=void 0){this.controllerId=C,this.profileId=F,this._label=O,this.kind=x,this.runHandler=B,this._isDefault=H,this._tag=G,d.set(this,void 0),T.set(this,void 0),Ye(this,d,W,"f"),Ye(this,T,V,"f"),V.set(F,this);const ee=L[x];if(typeof ee!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Ae(this,d,"f").$publishTestRunProfile({profileId:F,controllerId:C,tag:G?t.TestTag.namespace(this.controllerId,G.id):null,label:O,group:ee,isDefault:H,hasConfigurationHandler:!1})}dispose(){Ae(this,T,"f")?.delete(this.profileId)&&(Ye(this,T,void 0,"f"),Ae(this,d,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=P,d=new WeakMap,T=new WeakMap;const L={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(De[221],Ie([1,0,18,4,5,97,8,6]),function(ie,e,i,I,S,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(R,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new I.Emitter,this._onDidChangeTextEditorOptions=new I.Emitter,this._onDidChangeTextEditorVisibleRanges=new I.Emitter,this._onDidChangeTextEditorViewColumn=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(p=>this._onDidChangeVisibleTextEditors.fire(p)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(p=>this._onDidChangeActiveTextEditor.fire(p))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const b=this._extHostDocumentsAndEditors.allEditors();return R?b:b.map(p=>p.value)}async showTextDocument(R,b,p){let E;typeof b=="number"?E={position:D.ViewColumn.from(b),preserveFocus:p}:typeof b=="object"?E={position:D.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?D.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:E={preserveFocus:!1};const m=await this._proxy.$tryShowTextDocument(R.uri,E),t=m&&this._extHostDocumentsAndEditors.getEditor(m);if(t)return t.value;throw m?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,b){return new M.TextEditorDecorationType(this._proxy,R,b).value}$acceptEditorPropertiesChanged(R,b){const p=this._extHostDocumentsAndEditors.getEditor(R);if(!p)throw new Error("unknown text editor");if(b.options&&p._acceptOptions(b.options),b.selections){const E=b.selections.selections.map(D.Selection.to);p._acceptSelections(E)}if(b.visibleRanges){const E=i.coalesce(b.visibleRanges.map(D.Range.to));p._acceptVisibleRanges(E)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:p.value,options:{...b.options,lineNumbers:D.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const E=A.TextEditorSelectionChangeKind.fromValue(b.selections.source),m=b.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:p.value,selections:m,kind:E})}if(b.visibleRanges){const E=i.coalesce(b.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:p.value,visibleRanges:E})}}$acceptEditorPositionData(R){for(const b in R){const p=this._extHostDocumentsAndEditors.getEditor(b);if(!p)throw new Error("Unknown text editor");const E=D.ViewColumn.to(R[b]);p.value.viewColumn!==E&&(p._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:p.value,viewColumn:E}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=y}),define(De[222],Ie([1,0,2,3,5,7,6,8,9]),function(ie,e,i,I,S,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class k{constructor(p,E){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=p.getProxy(S.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===11){const t=m.uri===void 0?void 0:i.URI.revive(m.uri);return this._itemsBySourceAndUriMap.get(m.source)?.get(R(t))?.get(m.handle)}return m}})}async $getTimeline(p,E,m,t){return this._providers.get(p)?.provideTimeline(i.URI.revive(E),m,t)}registerTimelineProvider(p,E,m,t){const o=new M.DisposableStore,a=this.convertTimelineItem(E.id,t,o).bind(this);let g;E.onDidChange&&(g=E.onDidChange(d=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...d,id:E.id}),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...E,scheme:p,onDidChange:void 0,async provideTimeline(d,T,r){T?.resetCache&&(o.clear(),w.get(E.id)?.clear());const c=await E.provideTimeline(d,T,r);if(c==null)return;const n=a(d,T);return{...c,source:E.id,items:c.items.map(n)}},dispose(){for(const d of w.values())d.get(E.id)?.clear();g?.dispose(),o.dispose()}})}convertTimelineItem(p,E,m){return(t,o)=>{let a;if(o?.cacheResults){let g=this._itemsBySourceAndUriMap.get(p);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(p,g));const w=R(t);a=g.get(w),a===void 0&&(a=new Map,g.set(w,a))}return g=>{const{iconPath:w,...d}=g,T=`${p}|${g.id??g.timestamp}`;a?.set(T,g);let r,c,n;g.iconPath&&(w instanceof D.ThemeIcon?n={id:w.id,color:w.color}:i.URI.isUri(w)?(r=w,c=w):{light:r,dark:c}=w);let u;return D.MarkdownString.isMarkdownString(d.tooltip)?u=A.MarkdownString.from(d.tooltip):(0,y.isString)(d.tooltip)?u=d.tooltip:D.MarkdownString.isMarkdownString(d.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=A.MarkdownString.from(d.detail)):(0,y.isString)(d.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=d.detail),{...d,id:d.id??void 0,handle:T,source:p,command:g.command?E.toInternal(g.command,m):void 0,icon:r,iconDark:c,themeIcon:n,tooltip:u,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(p){if(this._providers.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this._proxy.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this._providers.set(p.id,p),(0,M.toDisposable)(()=>{for(const m of this._itemsBySourceAndUriMap.values())m.get(p.id)?.clear();this._providers.delete(p.id),this._proxy.$unregisterTimelineProvider(p.id),p.dispose()})}}e.ExtHostTimeline=k;function R(b){return b?.toString()}}),define(De[223],Ie([1,0,7,13,2,5]),function(ie,e,i,I,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(y){this._openers=new Map,this._proxy=y.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,k,R,b){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const p=b.schemes.find(E=>!D.supportedSchemes.has(E));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,R),this._proxy.$registerUriOpener(k,b.schemes,y,b.label),(0,i.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(y,k,R){const b=this._openers.get(y);if(!b)throw new Error(`Unknown opener with id: ${y}`);const p=S.URI.revive(k);return b.canOpenExternalUri(p,R)}async $openUri(y,k,R){const b=this._openers.get(y);if(!b)throw new Error(`Unknown opener id: '${y}'`);return b.openExternalUri(S.URI.revive(k.resolvedUri),{sourceUri:S.URI.revive(k.sourceUri)},R)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(De[224],Ie([1,0,5,2,7,12,25]),function(ie,e,i,I,S,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(k,R){if(this.handles.has(D.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const b=A.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(k)),this.handlers.set(b,R),this._proxy.$registerUriHandler(b,k),(0,S.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(k)),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(k,R){const b=this.handlers.get(k);if(!b)return Promise.resolve(void 0);try{b.handleUri(I.URI.revive(R))}catch(p){(0,M.onUnexpectedError)(p)}return Promise.resolve(void 0)}async createAppUri(k){return I.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=A,A.HandlePool=0});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,S){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?S.call(ie,i):S?S.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[57],Ie([1,0,4,13,23,2,146,167,65,5]),function(ie,e,i,I,S,M,D,A,y,k){"use strict";var R,b,p,E,m,t,o,a,g,w,d,T,r;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class c{constructor(L,j,W,V,C,F,O){R.set(this,void 0),b.set(this,void 0),p.set(this,void 0),E.set(this,void 0),m.set(this,void 0),t.set(this,void 0),o.set(this,""),a.set(this,void 0),g.set(this,!1),w.set(this,!1),d.set(this,void 0),T.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new i.Emitter),this._onDidDispose=Ae(this,r,"f").event,Ye(this,R,L,"f"),Ye(this,b,j,"f"),Ye(this,a,W,"f"),Ye(this,E,V,"f"),Ye(this,m,C,"f"),Ye(this,t,F,"f"),Ye(this,d,n(F),"f"),Ye(this,T,u(F),"f"),Ye(this,p,O,"f")}dispose(){Ye(this,g,!0,"f"),Ae(this,r,"f").fire(),Ae(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(L){return Ye(this,w,!0,"f"),(0,y.asWebviewUri)(L,Ae(this,E,"f"))}get cspSource(){const L=Ae(this,t,"f").extensionLocation;if(L.scheme===I.Schemas.https||L.scheme===I.Schemas.http){let j=L.toString();return j.endsWith("/")||(j+="/"),j+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,o,"f")}set html(L){this.assertNotDisposed(),Ae(this,o,"f")!==L&&(Ye(this,o,L,"f"),Ae(this,T,"f")&&!Ae(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(L)&&(Ye(this,w,!0,"f"),Ae(this,p,"f").report("Webview vscode-resource: uris",Ae(this,t,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,b,"f").$setHtml(Ae(this,R,"f"),this.rewriteOldResourceUrlsIfNeeded(L)))}get options(){return this.assertNotDisposed(),Ae(this,a,"f")}set options(L){this.assertNotDisposed(),S.equals(Ae(this,a,"f"),L)||Ae(this,b,"f").$setOptions(Ae(this,R,"f"),s(Ae(this,t,"f"),Ae(this,m,"f"),L)),Ye(this,a,L,"f")}async postMessage(L){if(Ae(this,g,"f"))return!1;const j=(0,A.serializeWebviewMessage)(L,{serializeBuffersForPostMessage:Ae(this,d,"f")});return Ae(this,b,"f").$postMessage(Ae(this,R,"f"),j.message,...j.buffers)}assertNotDisposed(){if(Ae(this,g,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(L){if(!Ae(this,T,"f"))return L;const j=Ae(this,t,"f").extensionLocation?.scheme===I.Schemas.vscodeRemote,W=Ae(this,t,"f").extensionLocation.scheme===I.Schemas.vscodeRemote?Ae(this,t,"f").extensionLocation.authority:void 0;return L.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,C,F,O,x,B)=>{const H=M.URI.from({scheme:O||"file",path:decodeURIComponent(x)}),G=(0,y.asWebviewUri)(H,{isRemote:j,authority:W}).toString();return`${C}${G}${B}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,C,F,O,x,B)=>{const H=M.URI.from({scheme:O||"file",path:decodeURIComponent(x)}),G=(0,y.asWebviewUri)(H,{isRemote:j,authority:W}).toString();return`${C}${G}${B}`})}}e.ExtHostWebview=c,R=new WeakMap,b=new WeakMap,p=new WeakMap,E=new WeakMap,m=new WeakMap,t=new WeakMap,o=new WeakMap,a=new WeakMap,g=new WeakMap,w=new WeakMap,d=new WeakMap,T=new WeakMap,r=new WeakMap;function n(P){try{const L=(0,D.normalizeVersion)((0,D.parseVersion)(P.engines.vscode));return!!L&&L.majorBase>=1&&L.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;function u(P){try{const L=(0,D.normalizeVersion)((0,D.parseVersion)(P.engines.vscode));return L?L.majorBase<1||L.majorBase===1&&L.minorBase<60:!1}catch{return!1}}class l{constructor(L,j,W,V,C){this.remoteInfo=j,this.workspace=W,this._logService=V,this._deprecationService=C,this._webviews=new Map,this._webviewProxy=L.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(L,j,W){const V=this.getWebview(L);if(V){const{message:C}=(0,A.deserializeWebviewMessage)(j,W.value);V._onMessageEmitter.fire(C)}}$onMissingCsp(L,j){this._logService.warn(`${j} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(L,j,W){const V=new c(L,this._webviewProxy,h(j),this.remoteInfo,this.workspace,W,this._deprecationService);return this._webviews.set(L,V),V._onDidDispose(()=>{this._webviews.delete(L)}),V}deleteWebview(L){this._webviews.delete(L)}getWebview(L){return this._webviews.get(L)}}e.ExtHostWebviews=l;function f(P){return{id:P.identifier,location:P.extensionLocation}}e.toExtensionData=f;function s(P,L,j){return{enableCommandUris:j.enableCommandUris,enableScripts:j.enableScripts,enableForms:j.enableForms,portMapping:j.portMapping,localResourceRoots:j.localResourceRoots||v(P,L)}}e.serializeWebviewOptions=s;function h(P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,enableForms:P.enableForms,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots?.map(L=>M.URI.from(L))}}function v(P,L){return[...(L?.getWorkspaceFolders()||[]).map(j=>j.uri),P.extensionLocation]}}),define(De[225],Ie([1,0,20,220,7,13,22,2,8,57,63,5,6]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(c,n){this.document=c,this._storagePath=n,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(c){return this._edits.add([c])}async undo(c,n){await this.getEdit(c).undo(),n||this.disposeBackup()}async redo(c,n){await this.getEdit(c).redo(),n||this.disposeBackup()}disposeEdits(c){for(const n of c)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const c=T(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,c)}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(c){const n=this._edits.get(c,0);if(!n)throw new Error("No edit found");return n}}class m{constructor(){this._documents=new Map}get(c,n){return this._documents.get(this.key(c,n))}add(c,n,u){const l=this.key(c,n.uri);if(this._documents.has(l))throw new Error(`Document already exists for viewType:${c} resource:${n.uri}`);const f=new E(n,u);return this._documents.set(l,f),f}delete(c,n){const u=this.key(c,n.uri);this._documents.delete(u)}key(c,n){return`${c}@@@${n}`}}var t;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(t||(t={}));class o{constructor(){this._providers=new Map}addTextProvider(c,n,u){return this.add(0,c,n,u)}addCustomProvider(c,n,u){return this.add(1,c,n,u)}get(c){return this._providers.get(c)}add(c,n,u,l){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:c,extension:u,provider:l}),new p.Disposable(()=>this._providers.delete(n))}}class a{constructor(c,n,u,l,f){this._extHostDocuments=n,this._extensionStoragePaths=u,this._extHostWebview=l,this._extHostWebviewPanels=f,this._editorProviders=new o,this._documents=new m,this._proxy=c.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(c,n,u,l){const f=new S.DisposableStore;return w(u)?(f.add(this._editorProviders.addTextProvider(n,c,u)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(c),n,l.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(c))):(f.add(this._editorProviders.addCustomProvider(n,c,u)),g(u)&&f.add(u.onDidChangeCustomDocument(s=>{const h=this.getCustomDocumentEntry(n,s.document.uri);if(d(s)){const v=h.addEdit(s);this._proxy.$onDidEdit(s.document.uri,n,v,s.label)}else this._proxy.$onContentChange(s.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(c),n,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(c))),p.Disposable.from(f,new p.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(c,n,u,l,f){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provide type for '${n}'`);const h=A.URI.revive(c),v=await s.provider.openCustomDocument(h,{backupId:u,untitledDocumentData:l?.buffer},f);let P;return g(s.provider)&&this._extensionStoragePaths&&(P=this._extensionStoragePaths.workspaceValue(s.extension)??this._extensionStoragePaths.globalValue(s.extension)),this._documents.add(n,v,P),{editable:g(s.provider)}}async $disposeCustomDocument(c,n){const u=this._editorProviders.get(n);if(!u)throw new Error(`No provider found for '${n}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${n}'`);const l=A.URI.revive(c),{document:f}=this.getCustomDocumentEntry(n,l);this._documents.delete(n,f),f.dispose()}async $resolveWebviewEditor(c,n,u,l,f,s){const h=this._editorProviders.get(u);if(!h)throw new Error(`No provider found for '${u}'`);const v=y.ViewColumn.to(f),P=this._extHostWebview.createNewWebview(n,l.contentOptions,h.extension),L=this._extHostWebviewPanels.createNewWebviewPanel(n,u,l.title,v,l.options,P,!0),j=A.URI.revive(c);switch(h.type){case 1:{const{document:W}=this.getCustomDocumentEntry(u,j);return h.provider.resolveCustomEditor(W,L,s)}case 0:{const W=this._extHostDocuments.getDocument(j);return h.provider.resolveCustomTextEditor(W,L,s)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,n,u){this.getCustomDocumentEntry(n,c).disposeEdits(u)}async $onMoveCustomEditor(c,n,u){const l=this._editorProviders.get(u);if(!l)throw new Error(`No provider found for '${u}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const f=this._extHostWebviewPanels.getWebviewPanel(c);if(!f)throw new Error("No webview found");const s=A.URI.revive(n),h=this._extHostDocuments.getDocument(s);await l.provider.moveCustomTextEditor(h,f,i.CancellationToken.None)}async $undo(c,n,u,l){return this.getCustomDocumentEntry(n,c).undo(u,l)}async $redo(c,n,u,l){return this.getCustomDocumentEntry(n,c).redo(u,l)}async $revert(c,n,u){const l=this.getCustomDocumentEntry(n,c);await this.getCustomEditorProvider(n).revertCustomDocument(l.document,u),l.disposeBackup()}async $onSave(c,n,u){const l=this.getCustomDocumentEntry(n,c);await this.getCustomEditorProvider(n).saveCustomDocument(l.document,u),l.disposeBackup()}async $onSaveAs(c,n,u,l){const f=this.getCustomDocumentEntry(n,c);return this.getCustomEditorProvider(n).saveCustomDocumentAs(f.document,A.URI.revive(u),l)}async $backup(c,n,u){const l=this.getCustomDocumentEntry(n,c),s=await this.getCustomEditorProvider(n).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},u);return l.updateBackup(s),s.id}getCustomDocumentEntry(c,n){const u=this._documents.get(c,A.URI.revive(n));if(!u)throw new Error("No custom document found");return u}getCustomEditorProvider(c){const u=this._editorProviders.get(c)?.provider;if(!u||!g(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=a;function g(r){return!!r.onDidChangeCustomDocument}function w(r){return typeof r.resolveCustomTextEditor=="function"}function d(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function T(r){const c=r.scheme===M.Schemas.file||r.scheme===M.Schemas.untitled?r.fsPath:r.toString();return(0,I.hash)(c)+""}});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,S){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?S.call(ie,i):S?S.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[226],Ie([1,0,4,7,2,38,8,57,5,6]),function(ie,e,i,I,S,M,D,A,y,k){"use strict";var R,b,p,E,m,t,o,a,g,w,d,T,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class c extends I.Disposable{constructor(f,s,h,v){super(),R.set(this,void 0),b.set(this,void 0),p.set(this,void 0),E.set(this,void 0),m.set(this,void 0),t.set(this,void 0),o.set(this,void 0),a.set(this,void 0),g.set(this,!0),w.set(this,void 0),d.set(this,!1),T.set(this,this._register(new i.Emitter)),this.onDidDispose=Ae(this,T,"f").event,r.set(this,this._register(new i.Emitter)),this.onDidChangeViewState=Ae(this,r,"f").event,Ye(this,R,f,"f"),Ye(this,b,s,"f"),Ye(this,E,h,"f"),Ye(this,p,v.viewType,"f"),Ye(this,m,v.panelOptions,"f"),Ye(this,a,v.viewColumn,"f"),Ye(this,t,v.title,"f"),Ye(this,w,v.active,"f")}dispose(){Ae(this,d,"f")||(Ye(this,d,!0,"f"),Ae(this,T,"f").fire(),Ae(this,b,"f").$disposeWebview(Ae(this,R,"f")),Ae(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,E,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,p,"f")}get title(){return this.assertNotDisposed(),Ae(this,t,"f")}set title(f){this.assertNotDisposed(),Ae(this,t,"f")!==f&&(Ye(this,t,f,"f"),Ae(this,b,"f").$setTitle(Ae(this,R,"f"),f))}get iconPath(){return this.assertNotDisposed(),Ae(this,o,"f")}set iconPath(f){this.assertNotDisposed(),Ae(this,o,"f")!==f&&(Ye(this,o,f,"f"),Ae(this,b,"f").$setIconPath(Ae(this,R,"f"),S.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Ae(this,m,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,a,"f")=="number"&&Ae(this,a,"f")<0))return Ae(this,a,"f")}get active(){return this.assertNotDisposed(),Ae(this,w,"f")}get visible(){return this.assertNotDisposed(),Ae(this,g,"f")}_updateViewState(f){Ae(this,d,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(Ye(this,w,f.active,"f"),Ye(this,g,f.visible,"f"),Ye(this,a,f.viewColumn,"f"),Ae(this,r,"f").fire({webviewPanel:this}))}reveal(f,s){this.assertNotDisposed(),Ae(this,b,"f").$reveal(Ae(this,R,"f"),{viewColumn:typeof f>"u"?void 0:D.ViewColumn.from(f),preserveFocus:!!s})}assertNotDisposed(){if(Ae(this,d,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,b=new WeakMap,p=new WeakMap,E=new WeakMap,m=new WeakMap,t=new WeakMap,o=new WeakMap,a=new WeakMap,g=new WeakMap,w=new WeakMap,d=new WeakMap,T=new WeakMap,r=new WeakMap;class n{static newHandle(){return(0,M.generateUuid)()}constructor(f,s,h){this.webviews=s,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(f,s,h,v,P={}){const L=typeof v=="object"?v.viewColumn:v,j={viewColumn:D.ViewColumn.from(L),preserveFocus:typeof v=="object"&&!!v.preserveFocus},W=(0,A.shouldSerializeBuffersForPostMessage)(f),V=n.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(f),V,s,{title:h,panelOptions:u(P),webviewOptions:(0,A.serializeWebviewOptions)(f,this.workspace,P),serializeBuffersForPostMessage:W},j);const C=this.webviews.createNewWebview(V,P,f);return this.createNewWebviewPanel(V,s,h,L,P,C,!0)}$onDidChangeWebviewPanelViewStates(f){const s=Object.keys(f);s.sort((h,v)=>{const P=f[h],L=f[v];return P.active?1:L.active?-1:+P.visible-+L.visible});for(const h of s){const v=this.getWebviewPanel(h);if(!v)continue;const P=f[h];v._updateViewState({active:P.active,visible:P.visible,viewColumn:D.ViewColumn.to(P.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,s,h){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:h,extension:f}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(f)}),new k.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(f,s,h,v){const P=this._serializers.get(s);if(!P)throw new Error(`No serializer found for '${s}'`);const{serializer:L,extension:j}=P,W=this.webviews.createNewWebview(f,h.webviewOptions,j),V=this.createNewWebviewPanel(f,s,h.title,v,h.panelOptions,W,h.active);await L.deserializeWebviewPanel(V,h.state)}createNewWebviewPanel(f,s,h,v,P,L,j){const W=new c(f,this._proxy,L,{viewType:s,title:h,viewColumn:v,panelOptions:P,active:j});return this._webviewPanels.set(f,W),W}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=n;function u(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,S){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?S.call(ie,i):S?S.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[227],Ie([1,0,4,7,57,8,5,6]),function(ie,e,i,I,S,M,D,A){"use strict";var y,k,R,b,p,E,m,t,o,a,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends I.Disposable{constructor(r,c,n,u,l,f){super(),y.set(this,void 0),k.set(this,void 0),R.set(this,void 0),b.set(this,void 0),p.set(this,!1),E.set(this,void 0),m.set(this,void 0),t.set(this,void 0),o.set(this,void 0),a.set(this,this._register(new i.Emitter)),this.onDidChangeVisibility=Ae(this,a,"f").event,g.set(this,this._register(new i.Emitter)),this.onDidDispose=Ae(this,g,"f").event,Ye(this,R,n,"f"),Ye(this,m,u,"f"),Ye(this,y,r,"f"),Ye(this,k,c,"f"),Ye(this,b,l,"f"),Ye(this,E,f,"f")}dispose(){Ae(this,p,"f")||(Ye(this,p,!0,"f"),Ae(this,g,"f").fire(),Ae(this,b,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,m,"f")}set title(r){this.assertNotDisposed(),Ae(this,m,"f")!==r&&(Ye(this,m,r,"f"),Ae(this,k,"f").$setWebviewViewTitle(Ae(this,y,"f"),r))}get description(){return this.assertNotDisposed(),Ae(this,t,"f")}set description(r){this.assertNotDisposed(),Ae(this,t,"f")!==r&&(Ye(this,t,r,"f"),Ae(this,k,"f").$setWebviewViewDescription(Ae(this,y,"f"),r))}get visible(){return Ae(this,E,"f")}get webview(){return Ae(this,b,"f")}get viewType(){return Ae(this,R,"f")}_setVisible(r){r===Ae(this,E,"f")||Ae(this,p,"f")||(Ye(this,E,r,"f"),Ae(this,a,"f").fire())}get badge(){return this.assertNotDisposed(),Ae(this,o,"f")}set badge(r){this.assertNotDisposed(),!(r?.value===Ae(this,o,"f")?.value&&r?.tooltip===Ae(this,o,"f")?.tooltip)&&(Ye(this,o,M.ViewBadge.from(r),"f"),Ae(this,k,"f").$setWebviewViewBadge(Ae(this,y,"f"),r))}show(r){this.assertNotDisposed(),Ae(this,k,"f").$show(Ae(this,y,"f"),!!r)}assertNotDisposed(){if(Ae(this,p,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,k=new WeakMap,R=new WeakMap,b=new WeakMap,p=new WeakMap,E=new WeakMap,m=new WeakMap,t=new WeakMap,o=new WeakMap,a=new WeakMap,g=new WeakMap;class d{constructor(r,c){this._extHostWebview=c,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,c,n,u){if(this._viewProviders.has(c))throw new Error(`View provider for '${c}' already registered`);return this._viewProviders.set(c,{provider:n,extension:r}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(r),c,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(r)}),new A.Disposable(()=>{this._viewProviders.delete(c),this._proxy.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(r,c,n,u,l){const f=this._viewProviders.get(c);if(!f)throw new Error(`No view provider found for '${c}'`);const{provider:s,extension:h}=f,v=this._extHostWebview.createNewWebview(r,{},h),P=new w(r,this._proxy,c,n,v,!0);this._webviewViews.set(r,P),await s.resolveWebviewView(P,{state:u},l)}async $onDidChangeWebviewViewVisibility(r,c){this.getWebviewView(r)._setVisible(c)}async $disposeWebviewView(r){const c=this.getWebviewView(r);this._webviewViews.delete(r),c.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const c=this._webviewViews.get(r);if(!c)throw new Error("No webview found");return c}}e.ExtHostWebviewViews=d}),define(De[99],Ie([1,0,4,5,2,13,10,3,14]),function(ie,e,i,I,S,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Zi{get state(){return this._state}constructor(b){this._onDidChangeWindowState=new i.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Zi.InitialState,this._proxy=b.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(p=>this.$onDidChangeWindowFocus(p))}$onDidChangeWindowFocus(b){b!==this._state.focused&&(this._state={...this._state,focused:b},this._onDidChangeWindowState.fire(this._state))}openUri(b,p){let E;if(typeof b=="string"){E=b;try{b=S.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,D.isFalsyOrWhitespace)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this._proxy.$openUri(b,E,p)}async asExternalUri(b,p){if((0,D.isFalsyOrWhitespace)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(b,p);return S.URI.from(E)}};k.InitialState={focused:!0},k=He([$e(0,y.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(De[228],Ie([1,0,198,26,14]),function(ie,e,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends i.AbstractExtHostConsoleForwarder{constructor(A,y){super(A,y)}_nativeConsoleLogMessage(A,y,k){y.apply(console,k)}};M=He([$e(0,S.IExtHostRpcService),$e(1,I.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(De[229],Ie([1,0,15,24,20,12,4,7,120,192,43]),function(ie,e,i,I,S,M,D,A,y,k,R){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function p(P,L){try{return JSON.stringify(P,L)}catch{return"null"}}const E="$$ref$$",m={[E]:-1};class t{constructor(L,j){this.jsonString=L,this.referencedBuffers=j}}function o(P,L=null,j=!1){const W=[];return{jsonString:(j?p:JSON.stringify)(P,(C,F)=>{if(typeof F>"u")return m;if(typeof F=="object"){if(F instanceof I.VSBuffer){const O=W.push(F)-1;return{[E]:O}}if(L)return L(C,F)}return F}),referencedBuffers:W}}e.stringifyJsonWithBufferRefs=o;function a(P,L,j){return JSON.parse(P,(W,V)=>{if(V){const C=V[E];if(typeof C=="number")return L[C];if(j&&V.$mid===1)return j.transformIncoming(V)}return V})}e.parseJsonAndRestoreBufferRefs=a;function g(P,L){return JSON.stringify(P,L)}function w(P){return P?(L,j)=>j&&j.$mid===1?P.transformOutgoing(j):j:null}var d;(function(P){P[P.LocalSide=0]="LocalSide",P[P.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var T;(function(P){P[P.Responsive=0]="Responsive",P[P.Unresponsive=1]="Unresponsive"})(T=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},c=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class u extends A.Disposable{constructor(L,j=null,W=null){super(),this[b]=!0,this._onDidChangeResponsiveState=this._register(new D.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=L,this._logger=j,this._uriTransformer=W,this._uriReplacer=w(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let V=0,C=R.ProxyIdentifier.count;V<C;V++)this._locals[V]=null,this._proxies[V]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new i.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(V=>this._receiveOneMessage(V))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(L=>{this._pendingRPCReplies[L].resolveErr(M.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(L){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(L){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(L){this._responsiveState!==L&&(this._responsiveState=L,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(L){return this._uriTransformer?(0,y.transformIncomingURIs)(L,this._uriTransformer):L}getProxy(L){const{nid:j,sid:W}=L;return this._proxies[j]||(this._proxies[j]=this._createProxy(j,W)),this._proxies[j]}_createProxy(L,j){const W={get:(V,C)=>(typeof C=="string"&&!V[C]&&C.charCodeAt(0)===36&&(V[C]=(...F)=>this._remoteCall(L,C,F)),C===n?j:V[C])};return new Proxy(Object.create(null),W)}set(L,j){return this._locals[L.nid]=j,j}assertRegistered(L){for(let j=0,W=L.length;j<W;j++){const V=L[j];if(!this._locals[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}_receiveOneMessage(L){if(this._isDisposed)return;const j=L.byteLength,W=l.read(L,0),V=W.readUInt8(),C=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:F,method:O,args:x}=s.deserializeRequestJSONArgs(W);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(j,C,F,O,x,V===2);break}case 3:case 4:{let{rpcId:F,method:O,args:x}=s.deserializeRequestMixedArgs(W);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(j,C,F,O,x,V===4);break}case 5:{this._logger?.logIncoming(j,C,0,"ack"),this._onDidReceiveAcknowledge(C);break}case 6:{this._receiveCancel(j,C);break}case 7:{this._receiveReply(j,C,void 0);break}case 9:{let F=s.deserializeReplyOKJSON(W);this._uriTransformer&&(F=(0,y.transformIncomingURIs)(F,this._uriTransformer)),this._receiveReply(j,C,F);break}case 10:{const F=s.deserializeReplyOKJSONWithBuffers(W,this._uriTransformer);this._receiveReply(j,C,F);break}case 8:{const F=s.deserializeReplyOKVSBuffer(W);this._receiveReply(j,C,F);break}case 11:{let F=s.deserializeReplyErrError(W);this._uriTransformer&&(F=(0,y.transformIncomingURIs)(F,this._uriTransformer)),this._receiveReplyErr(j,C,F);break}case 12:{this._receiveReplyErr(j,C,void 0);break}default:console.error("received unexpected message"),console.error(L)}}_receiveRequest(L,j,W,V,C,F){this._logger?.logIncoming(L,j,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(W)}.${V}(`,C);const O=String(j);let x,B;if(F){const G=new S.CancellationTokenSource;C.push(G.token),x=this._invokeHandler(W,V,C),B=()=>G.cancel()}else x=this._invokeHandler(W,V,C),B=r;this._cancelInvokedHandlers[O]=B;const H=s.serializeAcknowledged(j);this._logger?.logOutgoing(H.byteLength,j,1,"ack"),this._protocol.send(H),x.then(G=>{delete this._cancelInvokedHandlers[O];const ee=s.serializeReplyOK(j,G,this._uriReplacer);this._logger?.logOutgoing(ee.byteLength,j,1,"reply:",G),this._protocol.send(ee)},G=>{delete this._cancelInvokedHandlers[O];const ee=s.serializeReplyErr(j,G);this._logger?.logOutgoing(ee.byteLength,j,1,"replyErr:",G),this._protocol.send(ee)})}_receiveCancel(L,j){this._logger?.logIncoming(L,j,1,"receiveCancel");const W=String(j);this._cancelInvokedHandlers[W]?.()}_receiveReply(L,j,W){this._logger?.logIncoming(L,j,0,"receiveReply:",W);const V=String(j);if(!this._pendingRPCReplies.hasOwnProperty(V))return;const C=this._pendingRPCReplies[V];delete this._pendingRPCReplies[V],C.resolveOk(W)}_receiveReplyErr(L,j,W){this._logger?.logIncoming(L,j,0,"receiveReplyErr:",W);const V=String(j);if(!this._pendingRPCReplies.hasOwnProperty(V))return;const C=this._pendingRPCReplies[V];delete this._pendingRPCReplies[V];let F;W&&(W.$isError?(F=new Error,F.name=W.name,F.message=W.message,F.stack=W.stack):F=W),C.resolveErr(F)}_invokeHandler(L,j,W){try{return Promise.resolve(this._doInvokeHandler(L,j,W))}catch(V){return Promise.reject(V)}}_doInvokeHandler(L,j,W){const V=this._locals[L];if(!V)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(L));const C=V[j];if(typeof C!="function")throw new Error("Unknown method "+j+" on actor "+(0,R.getStringIdentifierForProxy)(L));return C.apply(V,W)}_remoteCall(L,j,W){if(this._isDisposed)return new k.CanceledLazyPromise;let V=null;if(W.length>0&&S.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(M.canceled());const C=s.serializeRequestArguments(W,this._uriReplacer),F=++this._lastMessageId,O=String(F),x=new k.LazyPromise;V&&V.onCancellationRequested(()=>{const H=s.serializeCancel(F);this._logger?.logOutgoing(H.byteLength,F,0,"cancel"),this._protocol.send(s.serializeCancel(F))}),this._pendingRPCReplies[O]=x,this._onWillSendRequest(F);const B=s.serializeRequest(F,L,j,C,!!V);return this._logger?.logOutgoing(B.byteLength,F,0,`request: ${(0,R.getStringIdentifierForProxy)(L)}.${j}(`,W),this._protocol.send(B),x}}e.RPCProtocol=u,b=c,u.UNRESPONSIVE_TIME=3*1e3;class l{static alloc(L,j,W){const V=new l(I.VSBuffer.alloc(W+1+4),0);return V.writeUInt8(L),V.writeUInt32(j),V}static read(L,j){return new l(L,j)}get buffer(){return this._buff}constructor(L,j){this._buff=L,this._offset=j}static sizeUInt8(){return 1}writeUInt8(L){this._buff.writeUInt8(L,this._offset),this._offset+=1}readUInt8(){const L=this._buff.readUInt8(this._offset);return this._offset+=1,L}writeUInt32(L){this._buff.writeUInt32BE(L,this._offset),this._offset+=4}readUInt32(){const L=this._buff.readUInt32BE(this._offset);return this._offset+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this._buff.writeUInt8(L.byteLength,this._offset),this._offset+=1,this._buff.set(L,this._offset),this._offset+=L.byteLength}readShortString(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const W=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,W}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readLongString(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const W=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,W}writeBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readVSBuffer(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const j=this._buff.slice(this._offset,this._offset+L);return this._offset+=L,j}static sizeMixedArray(L){let j=0;j+=1;for(let W=0,V=L.length;W<V;W++){const C=L[W];switch(j+=1,C.type){case 1:j+=this.sizeLongString(C.value);break;case 2:j+=this.sizeVSBuffer(C.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(C.value);for(let F=0;F<C.buffers.length;++F)j+=this.sizeVSBuffer(C.buffers[F]);break;case 4:break}}return j}writeMixedArray(L){this._buff.writeUInt8(L.length,this._offset),this._offset+=1;for(let j=0,W=L.length;j<W;j++){const V=L[j];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let C=0;C<V.buffers.length;++C)this.writeBuffer(V.buffers[C]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const j=new Array(L);for(let W=0;W<L;W++)switch(this.readUInt8()){case 1:j[W]=this.readLongString();break;case 2:j[W]=this.readVSBuffer();break;case 3:{const C=this.readUInt32(),F=this.readLongString(),O=[];for(let x=0;x<C;++x)O.push(this.readVSBuffer());j[W]=new R.SerializableObjectWithBuffers(a(F,O,null));break}case 4:j[W]=void 0;break}return j}}l.sizeUInt32=4;var f;(function(P){P[P.Simple=0]="Simple",P[P.Mixed=1]="Mixed"})(f||(f={}));class s{static _useMixedArgSerialization(L){for(let j=0,W=L.length;j<W;j++)if(L[j]instanceof I.VSBuffer||L[j]instanceof R.SerializableObjectWithBuffers||typeof L[j]>"u")return!0;return!1}static serializeRequestArguments(L,j){if(this._useMixedArgSerialization(L)){const W=[];for(let V=0,C=L.length;V<C;V++){const F=L[V];if(F instanceof I.VSBuffer)W[V]={type:2,value:F};else if(typeof F>"u")W[V]={type:4};else if(F instanceof R.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:x}=o(F.value,j);W[V]={type:3,value:I.VSBuffer.fromString(O),buffers:x}}else W[V]={type:1,value:I.VSBuffer.fromString(g(F,j))}}return{type:1,args:W}}return{type:0,args:g(L,j)}}static serializeRequest(L,j,W,V,C){switch(V.type){case 0:return this._requestJSONArgs(L,j,W,V.args,C);case 1:return this._requestMixedArgs(L,j,W,V.args,C)}}static _requestJSONArgs(L,j,W,V,C){const F=I.VSBuffer.fromString(W),O=I.VSBuffer.fromString(V);let x=0;x+=l.sizeUInt8(),x+=l.sizeShortString(F),x+=l.sizeLongString(O);const B=l.alloc(C?2:1,L,x);return B.writeUInt8(j),B.writeShortString(F),B.writeLongString(O),B.buffer}static deserializeRequestJSONArgs(L){const j=L.readUInt8(),W=L.readShortString(),V=L.readLongString();return{rpcId:j,method:W,args:JSON.parse(V)}}static _requestMixedArgs(L,j,W,V,C){const F=I.VSBuffer.fromString(W);let O=0;O+=l.sizeUInt8(),O+=l.sizeShortString(F),O+=l.sizeMixedArray(V);const x=l.alloc(C?4:3,L,O);return x.writeUInt8(j),x.writeShortString(F),x.writeMixedArray(V),x.buffer}static deserializeRequestMixedArgs(L){const j=L.readUInt8(),W=L.readShortString(),V=L.readMixedArray(),C=new Array(V.length);for(let F=0,O=V.length;F<O;F++){const x=V[F];typeof x=="string"?C[F]=JSON.parse(x):C[F]=x}return{rpcId:j,method:W,args:C}}static serializeAcknowledged(L){return l.alloc(5,L,0).buffer}static serializeCancel(L){return l.alloc(6,L,0).buffer}static serializeReplyOK(L,j,W){if(typeof j>"u")return this._serializeReplyOKEmpty(L);if(j instanceof I.VSBuffer)return this._serializeReplyOKVSBuffer(L,j);if(j instanceof R.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:C}=o(j.value,W,!0);return this._serializeReplyOKJSONWithBuffers(L,V,C)}else return this._serializeReplyOKJSON(L,p(j,W))}static _serializeReplyOKEmpty(L){return l.alloc(7,L,0).buffer}static _serializeReplyOKVSBuffer(L,j){let W=0;W+=l.sizeVSBuffer(j);const V=l.alloc(8,L,W);return V.writeVSBuffer(j),V.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static _serializeReplyOKJSON(L,j){const W=I.VSBuffer.fromString(j);let V=0;V+=l.sizeLongString(W);const C=l.alloc(9,L,V);return C.writeLongString(W),C.buffer}static _serializeReplyOKJSONWithBuffers(L,j,W){const V=I.VSBuffer.fromString(j);let C=0;C+=l.sizeUInt32,C+=l.sizeLongString(V);for(const O of W)C+=l.sizeVSBuffer(O);const F=l.alloc(10,L,C);F.writeUInt32(W.length),F.writeLongString(V);for(const O of W)F.writeBuffer(O);return F.buffer}static deserializeReplyOKJSON(L){const j=L.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(L,j){const W=L.readUInt32(),V=L.readLongString(),C=[];for(let F=0;F<W;++F)C.push(L.readVSBuffer());return new R.SerializableObjectWithBuffers(a(V,C,j))}static serializeReplyErr(L,j){const W=j?p(M.transformErrorForSerialization(j),null):void 0;if(typeof W!="string")return this._serializeReplyErrEmpty(L);const V=I.VSBuffer.fromString(W);let C=0;C+=l.sizeLongString(V);const F=l.alloc(11,L,C);return F.writeLongString(V),F.buffer}static deserializeReplyErrError(L){const j=L.readLongString();return JSON.parse(j)}static _serializeReplyErrEmpty(L){return l.alloc(12,L,0).buffer}}var h;(function(P){P[P.RequestJSONArgs=1]="RequestJSONArgs",P[P.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",P[P.RequestMixedArgs=3]="RequestMixedArgs",P[P.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",P[P.Acknowledged=5]="Acknowledged",P[P.Cancel=6]="Cancel",P[P.ReplyOKEmpty=7]="ReplyOKEmpty",P[P.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",P[P.ReplyOKJSON=9]="ReplyOKJSON",P[P.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",P[P.ReplyErrError=11]="ReplyErrError",P[P.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var v;(function(P){P[P.String=1]="String",P[P.VSBuffer=2]="VSBuffer",P[P.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",P[P.Undefined=4]="Undefined"})(v||(v={}))}),define(De[230],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(M){const D=A=>{self.removeEventListener("message",D);const y=A.data;Object.defineProperties(self,{postMessage:{value(k,R){y.postMessage(k,R)}},onmessage:{get(){return y.onmessage},set(k){y.onmessage=k}}}),y.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",D)}.toString();class I extends EventTarget{constructor(M,D,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${i})('${D}'))`,k=new Blob([y],{type:"application/javascript"}),R=URL.createObjectURL(k),b=new MessageChannel,p=R,E={type:"_newWorker",id:p,port:b.port2,url:R,options:A};M(E,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{M({type:"_terminateWorker",id:p}),URL.revokeObjectURL(R),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(m){b.port1.onmessage=m}},onmessageerror:{get(){return b.port1.onmessageerror},set(m){b.port1.onmessageerror=m}}}),b.port1.addEventListener("messageerror",m=>{const t=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(t)}),b.port1.addEventListener("message",m=>{const t=new MessageEvent("message",{data:m.data});this.dispatchEvent(t)}),b.port1.start()}}e.NestedWorker=I}),define(De[231],Ie([1,0,4,30,41,3,35,12,15]),function(ie,e,i,I,S,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new S.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new S.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new S.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new i.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new i.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(m){this.channels.has(m.id)||(this.channels.set(m.id,m),this._onDidRegisterChannel.fire(m.id))}getChannels(){const m=[];return this.channels.forEach(t=>m.push(t)),m}getChannel(m){return this.channels.get(m)}removeChannel(m){this.channels.delete(m),this._onDidRemoveChannel.fire(m)}}I.Registry.add(e.Extensions.OutputChannels,new R);function b(E,m,t,o,a){return(0,y.createCancelablePromise)(async g=>{await(0,D.whenProviderRegistered)(t,o);const w=I.Registry.as(e.Extensions.OutputChannels);try{await p(t,1,o,a,g),w.registerChannel({id:E,label:m,file:t,log:!0})}catch(d){(0,A.isCancellationError)(d)||a.error("Error while registering log channel",t.toString(),(0,A.getErrorMessage)(d))}})}e.registerLogChannel=b;async function p(E,m,t,o,a){if(!await t.exists(E)){if(a.isCancellationRequested)throw new A.CancellationError;if(m>10)throw new Error("Timed out while waiting for file to be created");o.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",E.toString()),await(0,y.timeout)(1e3,a),await p(E,m+1,t,o,a)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new S.RawContextKey("activeOutputChannel","")}),define(De[100],Ie([1,0,5,3,14,25,11,231,55,26,36,113,24,9,35,4,7,27]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class g extends D.AbstractMessageLogger{get disposed(){return this._disposed}constructor(r,c,n,u,l){super(),this.id=r,this.name=c,this.logger=n,this.proxy=u,this.extension=l,this.offset=0,this._disposed=!1,this.visible=!1,this._register(n.onDidChangeLogLevel(f=>this.setLevel(f)))}get logLevel(){return this.logger.getLevel()}appendLine(r){this.append(r+`
`)}append(r){this.info(r)}clear(){const r=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,r)}replace(r){const c=this.offset;this.info(r),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,c),this.visible&&this.logger.flush()}show(r,c){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof r=="boolean"?r:c))}hide(){this.proxy.$close(this.id)}log(r,c){this.offset+=p.VSBuffer.fromString(c).byteLength,(0,D.log)(this.logger,r,c),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class w extends g{appendLine(r){this.append(r)}}let d=class{constructor(r,c,n,u,l,f){this.initData=c,this.extHostFileSystem=n,this.extHostFileSystemInfo=u,this.loggerService=l,this.logService=f,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=r.getProxy(i.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(c.logsLocation,`output_logging_${(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(r){this.visibleChannelId=r;for(const[c,n]of this.channels)n.visible=c===this.visibleChannelId}createOutputChannel(r,c,n){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");const u=typeof c=="object"&&c.log;u&&(0,a.checkProposedApiEnabled)(n,"extensionLog");const l=(0,E.isString)(c)?c:void 0;if((0,E.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let f;const s=this.initData.environment.extensionLogLevel?.find(([v])=>M.ExtensionIdentifier.equals(n.identifier,v))?.[1];s&&(f=(0,D.parseLogLevel)(s));const h=u?this.doCreateLogOutputChannel(r,f,n):this.doCreateOutputChannel(r,l,n);return h.then(v=>{this.channels.set(v.id,v),v.visible=v.id===this.visibleChannelId}),u?this.createExtHostLogOutputChannel(r,f??this.logService.getLevel(),h):this.createExtHostOutputChannel(r,h)}async doCreateOutputChannel(r,c,n){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const u=await this.outputDirectoryPromise,l=this.extHostFileSystemInfo.extUri.joinPath(u,`${this.namePool++}-${r.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.loggerService.createLogger(l,{always:!0,donotRotate:!0,donotUseFormatters:!0}),s=await this.proxy.$register(r,l,!1,c,n.identifier.value);return new g(s,r,f,this.proxy,n)}async doCreateLogOutputChannel(r,c,n){const u=await this.createExtensionLogDirectory(n),l=this.extHostFileSystemInfo.extUri.joinPath(u,`${r.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.loggerService.createLogger(l,{name:r},c),s=await this.proxy.$register(r,l,!0,void 0,n.identifier.value);return new w(s,r,f,this.proxy,n)}createExtensionLogDirectory(r){let c=this.extensionLogDirectoryPromise.get(r.identifier.value);if(!c){const n=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,r.identifier.value);this.extensionLogDirectoryPromise.set(r.identifier.value,c=(async()=>{try{await this.extHostFileSystem.value.createDirectory(n)}catch(u){if((0,m.toFileSystemProviderErrorCode)(u)!==m.FileSystemProviderErrorCode.FileExists)throw u}return n})())}return c}createExtHostOutputChannel(r,c){let n=!1;const u=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return r},append(l){u(),c.then(f=>f.append(l))},appendLine(l){u(),c.then(f=>f.appendLine(l))},clear(){u(),c.then(l=>l.clear())},replace(l){u(),c.then(f=>f.replace(l))},show(l,f){u(),c.then(s=>s.show(l,f))},hide(){u(),c.then(l=>l.hide())},dispose(){n=!0,c.then(l=>l.dispose())}}}createExtHostLogOutputChannel(r,c,n){const u=new o.DisposableStore,l=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},f=u.add(new t.Emitter);return n.then(s=>{u.add(s),u.add(s.onDidChangeLogLevel(h=>{c=h,f.fire(h)}))}),{...this.createExtHostOutputChannel(r,n),get logLevel(){return c},onDidChangeLogLevel:f.event,trace(s,...h){l(),n.then(v=>v.trace(s,...h))},debug(s,...h){l(),n.then(v=>v.debug(s,...h))},info(s,...h){l(),n.then(v=>v.info(s,...h))},warn(s,...h){l(),n.then(v=>v.warn(s,...h))},error(s,...h){l(),n.then(v=>v.error(s,...h))},dispose(){u.dispose()}}}};d=He([$e(0,S.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,y.IExtHostConsumerFileSystem),$e(3,R.IExtHostFileSystemInfo),$e(4,D.ILoggerService),$e(5,D.ILogService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(De[232],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(De[233],Ie([1,0,39,13,19,21,22,2,3,163,49,178,232]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let E=class en{constructor(t,o,a,g){this.localUserHome=t,this.remoteAgentService=o,this.environmentService=a,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||M.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome??t})()}hasValidBasename(t,o,a){return typeof o=="string"||typeof o>"u"?this.resolveOS.then(g=>this.doHasValidBasename(t,g,o)):this.doHasValidBasename(t,o,a)}doHasValidBasename(t,o,a){return t.scheme===I.Schemas.file||t.scheme===I.Schemas.vscodeRemote?(0,i.isValidBasename)(a??(0,D.basename)(t),o===1):!0}get defaultUriScheme(){return en.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(t,o){if(t.remoteAuthority)return I.Schemas.vscodeRemote;const a=(0,k.getVirtualWorkspaceScheme)(o.getWorkspace());if(a)return a;const g=o.getWorkspace().folders[0];if(g)return g.uri.scheme;const w=o.getWorkspace().configuration;return w?w.scheme:I.Schemas.file}userHome(t){return t?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(t=>t===1?S.win32:S.posix)}async fileURI(t){let o="";if(await this.resolveOS===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const g=t.indexOf("/",2);g===-1?(o=t.substring(2),t="/"):(o=t.substring(2,g),t=t.substring(g)||"/")}return A.URI.from({scheme:I.Schemas.file,authority:o,path:t,query:"",fragment:""})}};E=He([$e(1,p.IRemoteAgentService),$e(2,b.IWorkbenchEnvironmentService),$e(3,R.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(De[101],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(D,A){this.line=D,this.character=A}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,A){return new i(0,0)}with(D){return new i(0,0)}}e.Position=i;class I{constructor(D,A,y,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(D,A),this.end=new i(y,k)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new I(0,0,0,0)}with(D){return new I(0,0,0,0)}}e.Range=I;var S;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[44],Ie([1,0,18,34,23,39,10,3,19,12,101,15]),function(ie,e,i,I,S,M,D,A,y,k,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const p="\u27EA ",E=" characters skipped \u27EB",m=(p.length+E.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var t;(function(re){re[re.file=0]="file",re[re.text=1]="text"})(t=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(re){re[re.File=1]="File",re[re.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function a(re){return!!re.preview}e.resultIsMatch=a;function g(re){return!!re.resource}e.isFileMatch=g;function w(re){return!!re.message}e.isProgressMessage=w;var d;(function(re){re[re.Normal=0]="Normal",re[re.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class T{constructor(pe){this.resource=pe,this.results=[]}}e.FileMatch=T;class r{constructor(pe,le,de){this.ranges=le;const Y=Array.isArray(le)?le:[le];if(de&&de.matchLines===1&&c(Y)){pe=(0,D.getNLines)(pe,de.matchLines);let me="",Se=0,Oe=0;const Be=Math.floor(de.charsPerLine/5),Xe=[];for(const ke of Y){const ye=Math.max(ke.startColumn-Be,0),Ce=ke.startColumn+de.charsPerLine;if(ye>Oe+Be+m){const se=p+(ye-Oe)+E;me+=se+pe.slice(ye,Ce),Se+=ye-(Oe+se.length)}else me+=pe.slice(Oe,Ce);Xe.push(new u(0,ke.startColumn-Se,ke.endColumn-Se)),Oe=Ce}this.preview={text:me,matches:Array.isArray(this.ranges)?Xe:Xe[0]}}else{const me=Array.isArray(le)?le[0].startLineNumber:le.startLineNumber;this.preview={text:pe,matches:(0,i.mapArrayOrNot)(le,Se=>new n(Se.startLineNumber-me,Se.startColumn,Se.endLineNumber-me,Se.endColumn))}}}}e.TextSearchMatch=r;function c(re){const pe=re[0].startLineNumber;for(const le of re)if(le.startLineNumber!==pe||le.endLineNumber!==pe)return!1;return!0}class n{constructor(pe,le,de,Y){this.startLineNumber=pe,this.startColumn=le,this.endLineNumber=de,this.endColumn=Y}}e.SearchRange=n;class u extends n{constructor(pe,le,de){super(pe,le,pe,de)}}e.OneLineRange=u;var l;(function(re){re.List="list",re.Tree="tree"})(l=e.ViewMode||(e.ViewMode={}));var f;(function(re){re.Default="default",re.FileNames="fileNames",re.Type="type",re.Modified="modified",re.CountDescending="countDescending",re.CountAscending="countAscending"})(f=e.SearchSortOrder||(e.SearchSortOrder={}));function s(re,pe=!0){const le=re&&re.files&&re.files.exclude,de=pe&&re&&re.search&&re.search.exclude;if(!le&&!de)return;if(!le||!de)return le||de;let Y=Object.create(null);return Y=S.mixin(Y,S.deepClone(le)),Y=S.mixin(Y,S.deepClone(de),!0),Y}e.getExcludes=s;function h(re,pe){return re.excludePattern&&I.match(re.excludePattern,pe)?!1:re.includePattern||re.usingSearchPaths?re.includePattern&&I.match(re.includePattern,pe)?!0:re.usingSearchPaths?!!re.folderQueries&&re.folderQueries.some(le=>{const de=le.folder.fsPath;if(M.isEqualOrParent(pe,de)){const Y=y.relative(de,pe);return!le.includePattern||!!I.match(le.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var v;(function(re){re[re.unknownEncoding=1]="unknownEncoding",re[re.regexParseError=2]="regexParseError",re[re.globParseError=3]="globParseError",re[re.invalidLiteral=4]="invalidLiteral",re[re.rgProcessError=5]="rgProcessError",re[re.other=6]="other",re[re.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(pe,le){super(pe),this.code=le}}e.SearchError=P;function L(re){const pe=re.message;if((0,k.isCancellationError)(re))return new P(pe,v.canceled);try{const le=JSON.parse(pe);return new P(le.message,le.code)}catch{return new P(pe,v.other)}}e.deserializeSearchError=L;function j(re){const pe={message:re.message,code:re.code};return new Error(JSON.stringify(pe))}e.serializeSearchError=j;function W(re){return re.type==="error"?!0:re.type==="success"}e.isSerializedSearchComplete=W;function V(re){return re.type==="success"}e.isSerializedSearchSuccess=V;function C(re){return!!re.path}e.isSerializedFileMatch=C;function F(re,pe){const le=re.searchPath?re.searchPath:re.relativePath;return(0,D.fuzzyContains)(le,pe)}e.isFilePatternMatch=F;class O{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function x(re,pe){const le={...re||{},...pe||{}};return Object.keys(le).filter(de=>{const Y=le[de];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=x;class B{constructor(pe,le){this._parsedIncludeExpression=null,this._excludeExpression={...pe.excludePattern||{},...le.excludePattern||{}},this._parsedExcludeExpression=I.parse(this._excludeExpression);let de=pe.includePattern;le.includePattern&&(de?de={...de,...le.includePattern}:de=le.includePattern),de&&(this._parsedIncludeExpression=I.parse(de))}matchesExcludesSync(pe,le,de){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(pe,le,de))}includedInQuerySync(pe,le,de){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(pe,le,de)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(pe,le,de))}includedInQuery(pe,le,de){const Y=this._parsedExcludeExpression(pe,le,de),me=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(pe,le,de):!0;return(0,b.isThenable)(Y)?Y.then(Se=>Se?!1:me()):me()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=B;function H(re){for(const pe in re)if(typeof re[pe]!="boolean")return!0;return!1}function G(re){if(!re)return;let pe;return le=>(pe||(pe=(re()||Promise.resolve([])).then(de=>de?ue(de):{})),pe.then(de=>!!de[le]))}e.hasSiblingPromiseFn=G;function ee(re){if(!re)return;let pe;return le=>{if(!pe){const de=re();pe=de?ue(de):{}}return!!pe[le]}}e.hasSiblingFn=ee;function ue(re){const pe={};for(const le of re)pe[le]=!0;return pe}}),define(De[31],Ie([1,0,18,15,20,4,7,46,13,108,22,10,9,2,137,3,11,151,49,36,26,14,8,6,50,44,5]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o,a,g,w,d,T,r,c,n,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function f(V,C,F){return new R.ExtUri(O=>P(O,F)).isEqual(V,C)}function s(V,C,F){return f(V.uri,C.uri,F)?0:(0,b.compare)(V.uri.toString(),C.uri.toString())}function h(V,C,F){return V.index!==C.index?V.index<C.index?-1:1:f(V.uri,C.uri,F)?(0,b.compare)(V.name,C.name):(0,b.compare)(V.uri.toString(),C.uri.toString())}function v(V,C,F,O){const x=V.slice(0).sort((H,G)=>F(H,G,O)),B=C.slice(0).sort((H,G)=>F(H,G,O));return(0,i.delta)(x,B,(H,G)=>F(H,G,O))}function P(V,C){const F=C.getCapabilities(V.scheme);return!(F&&F&1024)}class L extends g.Workspace{static toExtHostWorkspace(C,F,O,x){if(!C)return{workspace:null,added:[],removed:[]};const{id:B,name:H,folders:G,configuration:ee,transient:ue,isUntitled:re}=C,pe=[],le=F;F?G.forEach((Se,Oe)=>{const Be=E.URI.revive(Se.uri),Xe=L._findFolder(O||F,Be,x);Xe?(Xe.name=Se.name,Xe.index=Se.index,pe.push(Xe)):pe.push({uri:Be,name:Se.name,index:Oe})}):pe.push(...G.map(({uri:Se,name:Oe,index:Be})=>({uri:E.URI.revive(Se),name:Oe,index:Be}))),pe.sort((Se,Oe)=>Se.index<Oe.index?-1:1);const de=new L(B,H,pe,!!ue,ee?E.URI.revive(ee):null,!!re,Se=>P(Se,x)),{added:Y,removed:me}=v(le?le.workspaceFolders:[],de.workspaceFolders,s,x);return{workspace:de,added:Y,removed:me}}static _findFolder(C,F,O){for(let x=0;x<C.folders.length;x++){const B=C.workspaceFolders[x];if(f(B.uri,F,O))return B}}constructor(C,F,O,x,B,H,G){super(C,O.map(ee=>new g.WorkspaceFolder(ee)),x,B,G),this._name=F,this._isUntitled=H,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(G),O.forEach(ee=>{this._workspaceFolders.push(ee),this._structure.set(ee.uri,ee)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(C,F){return F&&this._structure.get(C)&&(C=(0,R.dirname)(C)),this._structure.findSubstr(C)}resolveWorkspaceFolder(C){return this._structure.get(C)}}let j=class{constructor(C,F,O,x,B){this._onDidChangeWorkspace=new M.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new M.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=x,this._extHostFileSystemInfo=O,this._uriTransformerService=B,this._requestIdProvider=new k.Counter,this._barrier=new I.Barrier,this._proxy=C.getProxy(l.MainContext.MainThreadWorkspace),this._messageService=C.getProxy(l.MainContext.MainThreadMessageService);const H=F.workspace;this._confirmedWorkspace=H?new L(H.id,H.name,[],!!H.transient,H.configuration?E.URI.revive(H.configuration):null,!!H.isUntitled,G=>P(G,O)):void 0}$initializeWorkspace(C,F){this._trusted=F,this.$acceptWorkspaceData(C),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?E.URI.from({scheme:y.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(C,F,O,...x){const B=[];if(Array.isArray(x)&&x.forEach(re=>{E.URI.isUri(re.uri)&&!B.some(pe=>f(pe.uri,re.uri,this._extHostFileSystemInfo))&&B.push({uri:re.uri,name:re.name||(0,R.basenameOrAuthority)(re.uri)})}),this._unconfirmedWorkspace||[F,O].some(re=>typeof re!="number"||re<0)||O===0&&B.length===0)return!1;const H=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+O>H.length)return!1;const G=H.slice(0);G.splice(F,O,...B.map(re=>({uri:re.uri,name:re.name||(0,R.basenameOrAuthority)(re.uri),index:void 0})));for(let re=0;re<G.length;re++){const pe=G[re];if(G.some((le,de)=>de!==re&&f(pe.uri,le.uri,this._extHostFileSystemInfo)))return!1}G.forEach((re,pe)=>re.index=pe);const{added:ee,removed:ue}=v(H,G,h,this._extHostFileSystemInfo);if(ee.length===0&&ue.length===0)return!1;if(this._proxy){const re=C.displayName||C.name;this._proxy.$updateWorkspaceFolders(re,F,O,B).then(void 0,pe=>{this._unconfirmedWorkspace=void 0;const le={source:{identifier:C.identifier,label:C.displayName||C.name}};this._messageService.$showMessage(a.Severity.Error,(0,m.localize)(0,null,re,pe.toString()),le,[])})}return this.trySetWorkspaceFolders(G),!0}getWorkspaceFolder(C,F){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(C,F)}async getWorkspaceFolder2(C,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(C,F)}async resolveWorkspaceFolder(C){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(C)}getPath(){if(!this._actualWorkspace)return;const{folders:C}=this._actualWorkspace;if(C.length!==0)return C[0].uri.fsPath}getRelativePath(C,F){let O,x="";if(typeof C=="string"?(O=E.URI.file(C),x=C):typeof C<"u"&&(O=C,x=C.fsPath),!O)return x;const B=this.getWorkspaceFolder(O,!0);if(!B)return x;typeof F>"u"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let H=(0,R.relativePath)(B.uri,O);return F&&B.name&&(H=`${B.name}/${H}`),H}trySetWorkspaceFolders(C){this._actualWorkspace&&(this._unconfirmedWorkspace=L.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:C,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(C){const{workspace:F,added:O,removed:x}=L.toExtHostWorkspace(C,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:x}))}findFiles(C,F,O,x,B=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let H;if(F===null?H=!1:F&&(typeof F=="string"?H=F:H=F.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:G,folder:ee}=W(r.GlobPattern.from(C));return this._proxy.$startFileSearch((0,p.withUndefinedAsNull)(G),(0,p.withUndefinedAsNull)(ee),(0,p.withUndefinedAsNull)(H),(0,p.withUndefinedAsNull)(O),B).then(ue=>Array.isArray(ue)?ue.map(re=>E.URI.revive(re)):[])}async findTextInFiles(C,F,O,x,B=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const H=this._requestIdProvider.getNext(),G=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:ee,folder:ue}=W(r.GlobPattern.from(F.include)),re=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,pe={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:G,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:ee,excludePattern:re},le=!1;if(this._activeSearchCallbacks[H]=de=>{if(le)return;const Y=E.URI.revive(de.resource);de.results.forEach(me=>{(0,u.resultIsMatch)(me)?O({uri:Y,preview:{text:me.preview.text,matches:(0,i.mapArrayOrNot)(me.preview.matches,Se=>new c.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))},ranges:(0,i.mapArrayOrNot)(me.ranges,Se=>new c.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))}):O({uri:Y,text:me.text,lineNumber:me.lineNumber})})},B.isCancellationRequested)return{};try{const de=await this._proxy.$startTextSearch(C,(0,p.withUndefinedAsNull)(ue),pe,H,B);return delete this._activeSearchCallbacks[H],de||{}}catch(de){throw delete this._activeSearchCallbacks[H],de}}$handleTextSearchResult(C,F){this._activeSearchCallbacks[F]?.(C)}saveAll(C){return this._proxy.$saveAll(C)}resolveProxy(C){return this._proxy.$resolveProxy(C)}get trusted(){return this._trusted}requestWorkspaceTrust(C){return this._proxy.$requestWorkspaceTrust(C)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(C,F){if(this._editSessionIdentityProviders.has(C))throw new Error(`A provider has already been registered for scheme ${C}`);this._editSessionIdentityProviders.set(C,F);const O=this._uriTransformerService.transformOutgoingScheme(C),x=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(x,O),(0,D.toDisposable)(()=>{this._editSessionIdentityProviders.delete(C),this._proxy.$unregisterEditSessionIdentityProvider(x)})}async $getEditSessionIdentifier(C,F){this._logService.info("Getting edit session identifier for workspaceFolder",C);const O=await this.resolveWorkspaceFolder(E.URI.revive(C));if(!O){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const x=this._editSessionIdentityProviders.get(O.uri.scheme);if(this._logService.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!x),!x)return;const B=await x.provideEditSessionIdentity(O,F);if(this._logService.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(C,F,O,x){this._logService.info("Getting edit session identifier for workspaceFolder",C);const B=await this.resolveWorkspaceFolder(E.URI.revive(C));if(!B){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const H=this._editSessionIdentityProviders.get(B.uri.scheme);if(this._logService.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!H),!H)return;const G=await H.provideEditSessionIdentityMatch?.(F,O,x);if(this._logService.info("Provider returned edit session identifier match result: ",G),!!G)return G}};j=He([$e(0,T.IExtHostRpcService),$e(1,d.IExtHostInitDataService),$e(2,w.IExtHostFileSystemInfo),$e(3,o.ILogService),$e(4,n.IURITransformerService)],j),e.ExtHostWorkspace=j,e.IExtHostWorkspace=(0,t.createDecorator)("IExtHostWorkspace");function W(V){let C,F;return V&&(typeof V=="string"?C=V:(C=V.pattern,F=E.URI.revive(V.baseUri))),{includePattern:C,folder:F}}}),define(De[32],Ie([1,0,23,4,31,5,6,154,89,9,15,3,14,11,2]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function t(c,n){if(n){const u=n.split(".");let l=c;for(let f=0;l&&f<u.length;f++)l=l[u[f]];return l}}function o(c){return c instanceof m.URI}function a(c){return c&&c.uri instanceof m.URI&&c.languageId&&typeof c.languageId=="string"}function g(c){return c&&!c.uri&&c.languageId&&typeof c.languageId=="string"}function w(c){return c&&c.uri instanceof m.URI&&(!c.name||typeof c.name=="string")&&(!c.index||typeof c.index=="number")}function d(c){if(o(c))return{resource:c};if(a(c))return{resource:c.uri,overrideIdentifier:c.languageId};if(g(c))return{overrideIdentifier:c.languageId};if(w(c))return{resource:c.uri};if(c===null)return{resource:null}}let T=class{constructor(n,u,l){this._proxy=n.getProxy(M.MainContext.MainThreadConfiguration),this._extHostWorkspace=u,this._logService=l,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new r(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,u){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(n,u))}};T=He([$e(0,p.IExtHostRpcService),$e(1,S.IExtHostWorkspace),$e(2,E.ILogService)],T),e.ExtHostConfiguration=T;class r{constructor(n,u,l,f){this._onDidChangeConfiguration=new I.Emitter,this._proxy=n,this._logService=f,this._extHostWorkspace=u,this._configuration=A.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,u){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(u,l))}getConfiguration(n,u,l){const f=d(u)||{},s=this._toReadonlyValue(n?t(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,f,l?.identifier);function h(P){if(P==null)return null;if(typeof P=="boolean")return P?2:5;switch(P){case D.ConfigurationTarget.Global:return 2;case D.ConfigurationTarget.Workspace:return 5;case D.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(P){return typeof t(s,P)<"u"},get:(P,L)=>{this._validateConfigurationAccess(n?`${n}.${P}`:P,f,l?.identifier);let j=t(s,P);if(typeof j>"u")j=L;else{let W;const V=(C,F)=>{let O;const x=()=>{W=W||(0,i.deepClone)(s),O=O||t(W,F)};return(0,k.isObject)(C)?new Proxy(C,{get:(B,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return x(),()=>O;if(W)return O=O||t(W,F),O[H];const G=B[H];return typeof H=="string"?V(G,`${F}.${H}`):G},set:(B,H,G)=>(x(),O&&(O[H]=G),!0),deleteProperty:(B,H)=>(x(),O&&delete O[H],!0),defineProperty:(B,H,G)=>(x(),O&&Object.defineProperty(O,H,G),!0)}):C};j=V(j,P)}return j},update:(P,L,j,W)=>{P=n?`${n}.${P}`:P;const V=h(j);return L!==void 0?this._proxy.$updateConfigurationOption(V,P,L,f,W):this._proxy.$removeConfigurationOption(V,P,f,W)},inspect:P=>{P=n?`${n}.${P}`:P;const L=this._configuration.inspect(P,f,this._extHostWorkspace.workspace);if(L)return{key:P,defaultValue:(0,i.deepClone)(L.policy?.value??L.default?.value),globalValue:(0,i.deepClone)(L.user?.value??L.application?.value),workspaceValue:(0,i.deepClone)(L.workspace?.value),workspaceFolderValue:(0,i.deepClone)(L.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(L.default?.override),globalLanguageValue:(0,i.deepClone)(L.user?.override??L.application?.override),workspaceLanguageValue:(0,i.deepClone)(L.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(L.workspaceFolder?.override),languageIds:(0,i.deepClone)(L.overrideIdentifiers)}}};return typeof s=="object"&&(0,i.mixin)(v,s,!1),Object.freeze(v)}_toReadonlyValue(n){const u=l=>(0,k.isObject)(l)?new Proxy(l,{get:(f,s)=>u(f[s]),set:(f,s,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(f,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(f,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return u(n)}_validateConfigurationAccess(n,u,l){const f=y.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),s=l?`[${l.value}] `:"";if(f===4){typeof u?.resource>"u"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){u?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,u){const l=new A.ConfigurationChangeEvent(n,u,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,s)=>l.affectsConfiguration(f,d(s))})}_toMap(n){return n.reduce((u,l)=>(u.set(l[0],l[1]),u),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,S){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?S.call(ie,i):S?S.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[102],Ie([1,0,2,15,4,5,6,31,53,32,20,56,14,26,3,13,21,11,71,191,12]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o,a,g,w,d){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var r;(function(C){function F(x){if(x!=null)return x}C.from=F;function O(x){if(x!=null)return x}C.to=O})(r||(r={}));var c;(function(C){function F(x){if(x!=null)return x}C.from=F;function O(x){if(x!=null)return x}C.to=O})(c||(c={}));var n;(function(C){function F(x){if(x!=null)return x}C.from=F;function O(x){if(x!=null)return x}C.to=O})(n||(n={}));var u;(function(C){function F(B){if(B){const H=B;return H&&!!H.process}else return!1}C.is=F;function O(B){if(B==null)return;const H={process:B.process,args:B.args};return B.options&&(H.options=n.from(B.options)),H}C.from=O;function x(B){if(B!=null)return new D.ProcessExecution(B.process,B.args,B.options)}C.to=x})(u||(u={}));var l;(function(C){function F(x){if(x!=null)return x}C.from=F;function O(x){if(x!=null)return x}C.to=O})(l||(l={}));var f;(function(C){function F(B){if(B){const H=B;return H&&(!!H.commandLine||!!H.command)}else return!1}C.is=F;function O(B){if(B==null)return;const H={};return B.commandLine!==void 0?H.commandLine=B.commandLine:(H.command=B.command,H.args=B.args),B.options&&(H.options=l.from(B.options)),H}C.from=O;function x(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new D.ShellExecution(B.commandLine,B.options):new D.ShellExecution(B.command,B.args?B.args:[],B.options)}C.to=x})(f||(f={}));var s;(function(C){function F(B){if(B){const H=B;return H&&H.customExecution==="customExecution"}else return!1}C.is=F;function O(B){return{customExecution:"customExecution"}}C.from=O;function x(B,H){return H.get(B)}C.to=x})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(C){function F(O,x){let B;return O.scope!==void 0&&typeof O.scope!="number"?B=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===D.TaskScope.Workspace&&x&&x.workspaceFile?B=x.workspaceFile:B=w.USER_TASKS_GROUP_KEY),{id:O._id,workspaceFolder:B}}C.from=F})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(C){function F(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}C.from=F})(v||(v={}));var P;(function(C){function F(B,H){if(B==null)return[];const G=[];for(const ee of B){const ue=O(ee,H);ue&&G.push(ue)}return G}C.fromMany=F;function O(B,H){if(B==null)return;let G;B.execution instanceof D.ProcessExecution?G=u.from(B.execution):B.execution instanceof D.ShellExecution?G=f.from(B.execution):B.execution&&B.execution instanceof D.CustomExecution&&(G=s.from(B.execution));const ee=r.from(B.definition);let ue;return B.scope?typeof B.scope=="number"?ue=B.scope:ue=B.scope.uri:ue=D.TaskScope.Workspace,!ee||!ue?void 0:{_id:B._id,definition:ee,name:B.name,source:{extensionId:H.identifier.value,label:B.source,scope:ue},execution:G,isBackground:B.isBackground,group:v.from(B.group),presentationOptions:c.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}C.from=O;async function x(B,H,G){if(B==null)return;let ee;u.is(B.execution)?ee=u.to(B.execution):f.is(B.execution)?ee=f.to(B.execution):s.is(B.execution)&&(ee=s.to(B._id,G));const ue=r.to(B.definition);let re;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?re=B.source.scope:re=await H.resolveWorkspaceFolder(i.URI.revive(B.source.scope)):re=D.TaskScope.Workspace),!ue||!re)return;const pe=new D.Task(ue,re,B.name,B.source.label,ee,B.problemMatchers);return B.isBackground!==void 0&&(pe.isBackground=B.isBackground),B.group!==void 0&&(pe.group=D.TaskGroup.from(B.group._id),pe.group&&B.group.isDefault&&(pe.group=new D.TaskGroup(pe.group.id,pe.group.label),B.group.isDefault===!0&&(pe.group.isDefault=B.group.isDefault))),B.presentationOptions&&(pe.presentationOptions=c.to(B.presentationOptions)),B._id&&(pe._id=B._id),B.detail&&(pe.detail=B.detail),pe}C.to=x})(P=e.TaskDTO||(e.TaskDTO={}));var L;(function(C){function F(x){return x}C.from=F;function O(x){if(!!x)return Object.assign(Object.create(null),x)}C.to=O})(L||(L={}));class j{constructor(F,O,x){this._id=O,this._task=x,T.set(this,void 0),Ye(this,T,F,"f")}get task(){return this._task}terminate(){Ae(this,T,"f").terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}T=new WeakMap;let W=class{constructor(F,O,x,B,H,G,ee,ue){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=F.getProxy(M.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=B,this._configurationService=H,this._terminalService=G,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ee,this._deprecationService=ue,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(F,O,x){if(!x)return new D.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:O,provider:x,extension:F}),this._proxy.$registerTaskProvider(B,O),new D.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(F,O){this._proxy.$registerTaskSystem(F,O)}fetchTasks(F){return this._proxy.$fetchTasks(L.from(F)).then(async O=>{const x=[];for(const B of O){const H=await P.to(B,this._workspaceProvider,this._providedCustomExecutions2);H&&x.push(H)}return x})}get taskExecutions(){const F=[];return this._taskExecutions.forEach(O=>F.push(O)),F}terminateTask(F){if(!(F instanceof j))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(F._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(F,O,x){const B=this._providedCustomExecutions2.get(F.id);B&&(this._activeCustomExecutions2.set(F.id,B),this._terminalService.attachPtyToTerminal(O,await B.callback(x))),this._lastStartedTask=F.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(F)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(F){const O=await this.getTaskExecution(F);this._taskExecutionPromises.delete(F.id),this._taskExecutions.delete(F.id),this.customExecutionComplete(F),this._onDidTerminateTask.fire({execution:O})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(F){const O=await this.getTaskExecution(F.id);this._onDidTaskProcessStarted.fire({execution:O,processId:F.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(F){const O=await this.getTaskExecution(F.id);this._onDidTaskProcessEnded.fire({execution:O,exitCode:F.exitCode})}$provideTasks(F,O){const x=this._handlers.get(F);if(!x)return Promise.reject(new Error("no handler found"));const B=[],H=(0,I.asPromise)(()=>x.provider.provideTasks(R.CancellationToken.None)).then(G=>this.provideTasksInternal(O,B,x,G));return new Promise(G=>{H.then(ee=>{Promise.all(B).then(()=>{G(ee)})})})}async $resolveTask(F,O){const x=this._handlers.get(F);if(!x)return Promise.reject(new Error("no handler found"));if(O.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${x.type}].`);const B=await P.to(O,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const H=await x.provider.resolveTask(B,R.CancellationToken.None);if(!H)return;this.checkDeprecation(H,x);const G=P.from(H,x.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(G.execution)&&await this.addCustomExecution(G,H,!0),await this.resolveTaskInternal(G)}nextHandle(){return this._handleCounter++}async addCustomExecution(F,O,x){const B=await this._proxy.$createTaskId(F);!x&&!this._providedCustomExecutions2.has(B)&&(this._notProvidedCustomExecutions.add(B),this._activeCustomExecutions2.set(B,O.execution)),this._providedCustomExecutions2.set(B,O.execution)}async getTaskExecution(F,O){if(typeof F=="string"){const H=this._taskExecutionPromises.get(F);if(!H)throw new d.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return H}const x=this._taskExecutionPromises.get(F.id);if(x)return x;const B=new Promise((H,G)=>{function ee(ue,re,pe){pe?H(new j(ue,re.id,pe)):G("Unexpected: Task does not exist.")}O?ee(this,F,O):P.to(F.task,this._workspaceProvider,this._providedCustomExecutions2).then(ue=>ee(this,F,ue))});return this._taskExecutionPromises.set(F.id,B),B.then(H=>(this._taskExecutions.set(F.id,H),H),H=>Promise.reject(H))}checkDeprecation(F,O){F._deprecated&&this._deprecationService.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(F){this._activeCustomExecutions2.get(F.id)&&this._activeCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.has(F.id)&&this._lastStartedTask!==F.id&&(this._providedCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.delete(F.id));const x=this._notProvidedCustomExecutions.values();let B=x.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=x.next()}};W=He([$e(0,p.IExtHostRpcService),$e(1,E.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,b.IExtHostTerminalService),$e(6,a.ILogService),$e(7,g.IExtHostApiDeprecationService)],W),e.ExtHostTaskBase=W;let V=class extends W{constructor(F,O,x,B,H,G,ee,ue){super(F,O,x,B,H,G,ee,ue),this.registerTaskSystem(t.Schemas.vscodeRemote,{scheme:t.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask(F,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const x=P.from(O,F);if(x===void 0)throw new Error("Task is not valid");if(s.is(x.execution))await this.addCustomExecution(x,O,!1);else throw new d.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),O);return this._proxy.$executeTask(x).catch(H=>{throw new Error(H)}),B}provideTasksInternal(F,O,x,B){const H=[];if(B)for(const G of B){this.checkDeprecation(G,x),(!G.definition||!F[G.definition.type])&&this._logService.warn(`The task [${G.source}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`);const ee=P.from(G,x.extension);ee&&s.is(ee.execution)?(H.push(ee),O.push(this.addCustomExecution(ee,G,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:H,extension:x.extension}}async resolveTaskInternal(F){if(s.is(F.execution))return F;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(F,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,O,x){}};V=He([$e(0,p.IExtHostRpcService),$e(1,E.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,b.IExtHostTerminalService),$e(6,a.ILogService),$e(7,g.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,m.createDecorator)("IExtHostTask")}),define(De[234],Ie([1,0,19,20,45,34,22,209,44]),function(ie,e,i,I,S,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(p,E,m){this.config=p,this.provider=E,this.sessionToken=m,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=p.filePattern,this.includePattern=p.includePattern&&M.parse(p.includePattern),this.maxResults=p.maxResults||void 0,this.exists=p.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=p.excludePattern&&M.parse(p.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(p=>p.cancel()),this.activeCancellationTokens=new Set}search(p){const E=this.config.folderQueries||[];return new Promise((m,t)=>{const o=a=>{this.resultCount++,p(a)};if(this.isCanceled)return m({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(a=>{const g=a.toString(),w=i.basename(g);this.globalExcludePattern&&this.globalExcludePattern(g,w)||this.matchFile(o,{base:a,basename:w})}),Promise.all(E.map(a=>this.searchInFolder(a,o))).then(a=>{m({limitHit:this.isLimitHit,stats:a[0]||void 0})},a=>{t(new Error((0,S.toErrorMessage)(a)))})})}async searchInFolder(p,E){const m=new I.CancellationTokenSource,t=this.getSearchOptionsForFolder(p),o=this.initDirectoryTree(),a=new y.QueryGlobTester(this.config,p),g=!a.hasSiblingExcludeClauses();let w;try{this.activeCancellationTokens.add(m),w=A.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},t,m.token),T=w.elapsed(),r=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(c=>{const n=i.posix.relative(p.folder.path,c.path);if(g){const u=i.basename(c.path);this.matchFile(E,{base:p.folder,relativePath:n,basename:u});return}this.addDirectoryEntries(o,p.folder,n,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(o,a,E),{providerTime:T,postProcessTime:r.elapsed()})}finally{m.dispose(),this.activeCancellationTokens.delete(m)}}getSearchOptionsForFolder(p){const E=(0,y.resolvePatternsForProvider)(this.config.includePattern,p.includePattern),m=(0,y.resolvePatternsForProvider)(this.config.excludePattern,p.excludePattern);return{folder:p.folder,excludes:m,includes:E,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}addDirectoryEntries({pathToEntries:p},E,m,t){if(m===this.filePattern){const a=i.basename(this.filePattern);this.matchFile(t,{base:E,relativePath:this.filePattern,basename:a})}function o(a){const g=i.basename(a),w=i.dirname(a);let d=p[w];d||(d=p[w]=[],o(w)),d.push({base:E,relativePath:a,basename:g})}o(m)}matchDirectoryTree({rootEntries:p,pathToEntries:E},m,t){const o=this,a=this.filePattern;function g(w){const d=(0,y.hasSiblingFn)(()=>w.map(T=>T.basename));for(let T=0,r=w.length;T<r;T++){const c=w[T],{relativePath:n,basename:u}=c;if(m.matchesExcludesSync(n,u,a!==u?d:void 0))continue;const l=E[n];if(l)g(l);else{if(n===a)continue;o.matchFile(t,c)}if(o.isLimitHit)break}}g(p)}matchFile(p,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||p(E))}}class R{constructor(){this.sessions=new Map}fileSearch(p,E,m,t){const o=this.getSessionTokenSource(p.cacheKey),a=new k(p,E,o&&o.token);let g=0;const w=d=>{g+=d.length,m(d.map(T=>this.rawMatchToSearchItem(T)))};return this.doSearch(a,R.BATCH_SIZE,w,t).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:d.stats}}))}clearCache(p){this.getSessionTokenSource(p)?.cancel()}getSessionTokenSource(p){if(!!p)return this.sessions.has(p)||this.sessions.set(p,new I.CancellationTokenSource),this.sessions.get(p)}rawMatchToSearchItem(p){return p.relativePath?{resource:D.joinPath(p.base,p.relativePath)}:{resource:p.base}}doSearch(p,E,m,t){t.onCancellationRequested(()=>{p.cancel()});const o=g=>{g&&(a.push(g),E>0&&a.length>=E&&(m(a),a=[]))};let a=[];return p.search(o).then(g=>(a.length&&m(a),g),g=>(a.length&&m(a),Promise.reject(g)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(De[235],Ie([1,0,18,77,34,82,28,13,19,22,10,9,2,251,145,40,11,49,93,233,44]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o,a,g,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let T=class{constructor(v,P,L,j,W){this.configurationService=v,this.workspaceContextService=P,this.editorGroupsService=L,this.logService=j,this.pathService=W}text(v,P,L={}){v=this.getContentPattern(v,L);const j=this.configurationService.getValue(),W=P&&P.some(C=>!this.configurationService.getValue({resource:C}).search.useRipgrep);return{...this.commonQuery(P?.map(a.toWorkspaceFolder),L),type:2,contentPattern:v,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:j.search.usePCRE2||W||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}getContentPattern(v,P){const L=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const j={...v,wordSeparators:L.editor.wordSeparators};return this.isCaseSensitive(v,P)&&(j.isCaseSensitive=!0),this.isMultiline(v)&&(j.isMultiline=!0),j}file(v,P={}){return{...this.commonQuery(v,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey}}handleIncludeExclude(v,P){return v?(v=Array.isArray(v)?v.map(l):l(v),P?this.parseSearchPaths(v):{pattern:c(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],P={}){const L=this.handleIncludeExclude(P.includePattern,P.expandPatterns),j=this.handleIncludeExclude(P.excludePattern,P.expandPatterns),W=v.length>1,V=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,P,j)):v.map(O=>this.getFolderQueryForRoot(O,P,j,W))).filter(O=>!!O),C={_reason:P._reason,folderQueries:V,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:j.pattern,includePattern:L.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const O=i.coalesce(i.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(G=>G.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const x=O.filter(H=>(0,d.pathIncludedInQuery)(C,H.fsPath)),B=this.commonQueryFromFileList(x);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...C,...B}}const F=P.extraFileResources&&P.extraFileResources.filter(O=>(0,d.pathIncludedInQuery)(C,O.fsPath));return C.extraFileResources=F&&F.length?F:void 0,C}commonQueryFromFileList(v){const P=[],L=new D.ResourceMap,j={};let W=!1;return v.forEach(V=>{if(V.scheme===A.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(V)){const F=this.workspaceContextService.getWorkspaceFolder(V)?.uri??V.with({path:y.dirname(V.fsPath)});let O=L.get(F);O||(W=!0,O={folder:F,includePattern:{}},P.push(O),L.set(F,O));const x=y.relative(F.fsPath,V.fsPath);(0,b.assertIsDefined)(O.includePattern)[x.replace(/\\/g,"/")]=!0}else V.fsPath&&(W=!0,j[V.fsPath]=!0)}),{folderQueries:P,includePattern:j,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}isCaseSensitive(v,P){if(P.isSmartCase){if(v.isRegExp){if(R.containsUppercaseCharacter(v.pattern,!0))return!0}else if(R.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,E.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const P=B=>y.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),j=(Array.isArray(v)?v:n(v)).map(B=>{const H=this.pathService.resolvedUserHome;return H?(0,M.untildify)(B,H.scheme===A.Schemas.file?H.fsPath:H.path):B}),W=I.groupBy(j,B=>P(B)?"searchPaths":"exprSegments"),V=(W.exprSegments||[]).map(B=>R.rtrim(B,"/")).map(B=>R.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),u(B))),C={},F=this.expandSearchPathPatterns(W.searchPaths||[]);F&&F.length&&(C.searchPaths=F);const O=i.flatten(V),x=c(...O);return x&&(C.pattern=x),C}getExcludesForFolder(v,P){return P.disregardExcludeSettings?void 0:(0,d.getExcludes)(v,!P.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const P=i.flatten(v.map(j=>{let{pathPortion:W,globPortion:V}=r(j);V&&(V=f(V));const C=this.expandOneSearchPath(W);return i.flatten(C.map(F=>this.resolveOneSearchPathPattern(F,V)))})),L=new Map;return P.forEach(j=>{const W=j.searchPath.toString(),V=L.get(W);V?j.pattern&&(V.pattern=V.pattern||{},V.pattern[j.pattern]=!0):L.set(W,{searchPath:j.searchPath,pattern:j.pattern?c(j.pattern):void 0})}),Array.from(L.values())}expandOneSearchPath(v){if(y.isAbsolute(v)){const P=this.workspaceContextService.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==A.Schemas.file?[{searchPath:P[0].uri.with({path:v})}]:[{searchPath:p.URI.file(y.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const P=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=l(v),v.startsWith("../")||v===".."){const j=y.posix.resolve(P.path,v);return[{searchPath:P.with({path:j})}]}const L=f(v);return[{searchPath:P,pattern:L}]}else{if(v==="./"||v===".\\")return[];{const P=v.replace(/^\.[\/\\]/,""),j=this.workspaceContextService.getWorkspace().folders.map(W=>{const V=P.match(new RegExp(`^${R.escapeRegExpCharacters(W.name)}(?:/(.*)|$)`));return V?{match:V,folder:W}:null}).filter(b.isDefined);if(j.length)return j.map(W=>{const V=W.match[1];return{searchPath:W.folder.uri,pattern:V&&f(V)}});{const W=v.match(/\.[\/\\](.+)[\/\\]?/),V=W?W[1]:v,C=m.localize(0,null,V);throw new Error(C)}}}}resolveOneSearchPathPattern(v,P){const L=v.pattern&&P?`${v.pattern}/${P}`:v.pattern||P,j=[{searchPath:v.searchPath,pattern:L}];return L&&!L.endsWith("**")&&j.push({searchPath:v.searchPath,pattern:L+"/**"}),j}getFolderQueryForSearchPath(v,P,L){const j=this.getFolderQueryForRoot((0,a.toWorkspaceFolder)(v.searchPath),P,L,!1);return j?{...j,includePattern:v.pattern}:null}getFolderQueryForRoot(v,P,L,j){let W;const V=p.URI.isUri(v)?v:v.uri;if(L.searchPaths){const B=L.searchPaths.filter(H=>(0,k.isEqual)(H.searchPath,V))[0];if(B&&!B.pattern)return null;B&&(W=B.pattern)}const C=this.configurationService.getValue({resource:V}),O={...this.getExcludesForFolder(C,P)||{},...W||{}},x=p.URI.isUri(v)?(0,k.basename)(v):v.name;return{folder:V,folderName:j?x:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:C.files&&C.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!C.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!C.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof P.disregardParentIgnoreFiles=="boolean"?P.disregardParentIgnoreFiles:!C.search.useParentIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!C.search.followSymlinks}}};T=He([$e(0,t.IConfigurationService),$e(1,a.IWorkspaceContextService),$e(2,g.IEditorGroupsService),$e(3,o.ILogService),$e(4,w.IPathService)],T),e.QueryBuilder=T;function r(h){const v=h.match(/[\*\{\}\(\)\[\]\?]/);if(v){const P=v.index,L=h.substr(0,P).match(/[/|\\][^/\\]*$/);if(L){let j=h.substr(0,L.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:h.substr((L.index||0)+1)}}}return{pathPortion:h}}function c(...h){return h.length?h.reduce((v,P)=>(v[P]=!0,v),Object.create(null)):void 0}function n(h){return S.splitGlobAware(h,",").map(v=>v.trim()).filter(v=>!!v.length)}function u(h){return[`**/${h}/**`,`**/${h}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function l(h){return h.replace(/\\/g,"/")}function f(h){return l(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function s(h,v){h=i.distinct(h,j=>j.toString());const P=[],L=v.getWorkspace();return h&&h.forEach(j=>{let W;if(v.getWorkbenchState()===2)W=(0,k.relativePath)(L.folders[0].uri,j),W&&W!=="."&&(W="./"+W);else{const V=v.getWorkspaceFolder(j);if(V){const C=V.name;if(L.folders.filter(O=>O.name===C).length===1){const O=(0,k.relativePath)(V.uri,j);O===""?W=`./${V.name}`:W=`./${V.name}/${O}`}else W=j.fsPath}}W&&P.push(W)}),P}e.resolveResourcesForSearchIncludes=s}),define(De[236],Ie([1,0,22,2,20,12,3,235,44,49]),function(ie,e,i,I,S,M,D,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function b(t,o){const a=o.activationEvents;if(!a)return Promise.resolve(void 0);const g=[],w=[];for(const u of a)if(/^workspaceContains:/.test(u)){const l=u.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||t.forceUsingSearch?w.push(l):g.push(l)}if(g.length===0&&w.length===0)return Promise.resolve(void 0);let d;const T=new Promise((u,l)=>{d=u}),r=u=>d({activationEvent:u}),c=Promise.all(g.map(u=>p(t,u,r))).then(()=>{}),n=E(t,o.identifier,w,r);return Promise.all([c,n]).then(()=>{d(void 0)}),T}e.checkActivateWorkspaceContainsExtension=b;async function p(t,o,a){for(const g of t.folders)if(await t.exists(i.joinPath(I.URI.revive(g),o))){a(`workspaceContains:${o}`);return}}async function E(t,o,a,g){if(a.length===0)return Promise.resolve(void 0);const w=new S.CancellationTokenSource,d=t.checkExists(t.folders,a,w.token),T=setTimeout(async()=>{w.cancel(),t.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${a.join(",")}`)},R);let r=!1;try{r=await d}catch(c){M.isCancellationError(c)||M.onUnexpectedError(c)}w.dispose(),clearTimeout(T),r&&g(`workspaceContains:${a.join(",")}`)}function m(t,o,a,g){const w=t.get(D.IInstantiationService),d=t.get(y.ISearchService),r=w.createInstance(A.QueryBuilder).file(o.map(c=>(0,k.toWorkspaceFolder)(I.URI.revive(c))),{_reason:"checkExists",includePattern:a,exists:!0});return d.fileSearch(r,g).then(c=>!!c.limitHit,c=>M.isCancellationError(c)?!1:Promise.reject(c))}e.checkGlobFileExists=m});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,S){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?S.call(ie,i):S?S.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[33],Ie([1,0,132,19,76,22,15,7,46,2,11,5,32,180,74,31,27,179,12,25,24,164,6,90,3,26,75,14,60,64,56,4,236,73,166,13,72]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o,a,g,w,d,T,r,c,n,u,l,f,s,h,v,P,L,j,W,V,C){"use strict";var F,O,x;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let B=class Pi extends A.Disposable{constructor(le,de,Y,me,Se,Oe,Be,Xe,ke,ye,Ce){super(),this._onDidChangeRemoteConnectionData=this._register(new P.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=de,this._extHostContext=Y,this._initData=Be,this._extHostWorkspace=me,this._extHostConfiguration=Se,this._logService=Oe,this._extHostTunnelService=ke,this._extHostTerminalService=ye,this._extHostLocalizationService=Ce,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._globalRegistry=new a.ExtensionDescriptionRegistry(this._initData.allExtensions);const se=(0,o.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new a.ExtensionDescriptionRegistry(ee(this._globalRegistry,se)),this._storage=new m.ExtHostStorage(this._extHostContext),this._secretState=new j.ExtHostSecretState(this._extHostContext),this._storagePath=Xe,this._instaService=le.createChild(new s.ServiceCollection([m.IExtHostStorage,this._storage],[j.IExtHostSecretState,this._secretState]));let ae=[],J=[];this._initData.remote.isRemote&&(ae=this._initData.allExtensions.filter(N=>!N.main&&!N.browser).map(N=>N.identifier),J=this._initData.allExtensions.filter(N=>!se.has(w.ExtensionIdentifier.toKey(N.identifier.value))).filter(N=>(N.main||N.browser)&&N.api==="none").map(N=>N.identifier));const _=(0,o.extensionIdentifiersArrayToSet)(J);this._activator=this._register(new E.ExtensionsActivator(this._myRegistry,ae,J,{onExtensionActivationError:(N,$,q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(N,g.transformErrorForSerialization($),q)},actualActivateExtension:async(N,$)=>{if(_.has(w.ExtensionIdentifier.toKey(N)))return await this._mainThreadExtensionsProxy.$activateExtension(N,$),new E.HostExtension;const q=this._myRegistry.getExtensionDescription(N);return this._activateExtension(q,$)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(le){g.onUnexpectedError(le)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let le=[];try{le=this._myRegistry.getAllExtensionDescriptions().map(Se=>Se.identifier).filter(Se=>this.isActivated(Se)).map(Se=>this._deactivate(Se))}catch{}await Promise.all(le)}terminate(le,de=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${le}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),g.setUnexpectedErrorHandler(me=>{this._logService.error(me)}),this._extHostContext.dispose();const Y=this._deactivateAll();Promise.race([(0,D.timeout)(5e3),Y]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${de}`):this._logService.info(`Extension host exiting with code ${de}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(de)})}isActivated(le){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(le):!1}async getExtension(le){const de=await this._mainThreadExtensionsProxy.$getExtension(le);let Y;if(de?.browserNlsBundleUris){Y={};for(const me of Object.keys(de.browserNlsBundleUris))Y[me]=k.URI.revive(de.browserNlsBundleUris[me])}return de&&{...de,identifier:new w.ExtensionIdentifier(de.identifier.value),extensionLocation:k.URI.revive(de.extensionLocation),browserNlsBundleUris:Y}}_activateByEvent(le,de){return this._activator.activateByEvent(le,de)}_activateById(le,de){return this._activator.activateById(le,de)}activateByIdWithErrors(le,de){return this._activateById(le,de).then(()=>{const Y=this._activator.getActivatedExtension(le);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(le=>this._myRegistry)}getExtensionExports(le){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(le).exports:null}async _realPathExtensionUri(le){if(le.scheme!==V.Schemas.file)return le;const de=await this._hostUtils.realpath(le.fsPath);return k.URI.file(de)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(le=>new re(le))),this._extensionPathIndex}async _createExtensionPathIndex(le){const de=y.TernarySearchTree.forUris(Y=>M.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(le.map(async Y=>{if(this._getEntryPoint(Y)){const me=await this._realPathExtensionUri(Y.extensionLocation);de.set(me,Y)}})),de}_deactivate(le){let de=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(le))return de;const Y=this._activator.getActivatedExtension(le);if(!Y)return de;try{typeof Y.module.deactivate=="function"&&(de=Promise.resolve(Y.module.deactivate()).then(void 0,me=>(this._logService.error(me),Promise.resolve(void 0))))}catch(me){this._logService.error(`An error occurred when deactivating the extension '${le.value}':`),this._logService.error(me)}try{(0,A.dispose)(Y.subscriptions)}catch(me){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${le.value}':`),this._logService.error(me)}return de}async _activateExtension(le,de){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(le.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(le.identifier),this._doActivateExtension(le,de).then(Y=>{const me=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(le.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,de),this._logExtensionActivationTimes(le,de,"success",me),Y},Y=>{throw this._logExtensionActivationTimes(le,de,"failure"),Y})}_logExtensionActivationTimes(le,de,Y,me){const Se=H(le,de);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Se,...me||{},outcome:Y})}_doActivateExtension(le,de){const Y=H(le,de);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const me=this._getEntryPoint(le);if(!me)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${le.identifier.value}, startup: ${de.startup}, activationEvent: '${de.activationEvent}'${le.identifier.value!==de.extensionId.value?`, root cause: ${de.extensionId.value}`:""}`),this._logService.flush();const Se=new E.ExtensionActivationTimesBuilder(de.startup);return Promise.all([this._loadCommonJSModule(le,(0,M.joinPath)(le.extensionLocation,me),Se),this._loadExtensionContext(le)]).then(Oe=>(S.mark(`code/extHost/willActivateExtension/${le.identifier.value}`),Pi._callActivate(this._logService,le.identifier,Oe[0],Oe[1],Se))).then(Oe=>(S.mark(`code/extHost/didActivateExtension/${le.identifier.value}`),Oe))}_loadExtensionContext(le){const de=new T.ExtensionGlobalMemento(le,this._storage),Y=new T.ExtensionMemento(le.identifier.value,!1,this._storage),me=new W.ExtensionSecrets(le,this._secretState),Se=le.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Oe=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${le.identifier.value}`),Promise.all([de.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const Be=this;let Xe,ke;const ye=(0,o.isProposedApiEnabled)(le,"ipc")?this._initData.messagePorts?.get(w.ExtensionIdentifier.toKey(le.identifier)):void 0;return Object.freeze({globalState:de,workspaceState:Y,secrets:me,subscriptions:[],get extensionUri(){return le.extensionLocation},get extensionPath(){return le.extensionLocation.fsPath},asAbsolutePath(Ce){return I.join(le.extensionLocation.fsPath,Ce)},get storagePath(){return Be._storagePath.workspaceValue(le)?.fsPath},get globalStoragePath(){return Be._storagePath.globalValue(le).fsPath},get logPath(){return I.join(Be._initData.logsLocation.fsPath,le.identifier.value)},get logUri(){return k.URI.joinPath(Be._initData.logsLocation,le.identifier.value)},get storageUri(){return Be._storagePath.workspaceValue(le)},get globalStorageUri(){return Be._storagePath.globalValue(le)},get extensionMode(){return Se},get extension(){return Xe===void 0&&(Xe=new G(Be,le.identifier,le,Oe,!1)),Xe},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(le,"extensionRuntime"),Be.extensionRuntime},get environmentVariableCollection(){return Be._extHostTerminalService.getEnvironmentVariableCollection(le)},get messagePassingProtocol(){if(!ke){if(!ye)return;const Ce=P.Event.buffer(P.Event.fromDOMEventEmitter(ye,"message",se=>se.data));ye.start(),ke={onDidReceiveMessage:Ce,postMessage:ye.postMessage.bind(ye)}}return ke}})})}static _callActivate(le,de,Y,me,Se){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(le,de,Y,me,Se).then(Oe=>new E.ActivatedExtension(!1,null,Se.build(),Y,Oe,me.subscriptions))}static _callActivateOptional(le,de,Y,me,Se){if(typeof Y.activate=="function")try{Se.activateCallStart(),le.trace(`ExtensionService#_callActivateOptional ${de.value}`);const Oe=typeof global=="object"?global:self,Be=Y.activate.apply(Oe,[me]);return Se.activateCallStop(),Se.activateResolveStart(),Promise.resolve(Be).then(Xe=>(Se.activateResolveStop(),Xe))}catch(Oe){return Promise.reject(Oe)}else return Promise.resolve(Y)}_activateOneStartupFinished(le,de){this._activateById(le.identifier,{startup:!1,extensionId:le.identifier,activationEvent:de}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const le of this._myRegistry.getAllExtensionDescriptions())if(le.activationEvents)for(const de of le.activationEvents)de==="onStartupFinished"&&this._activateOneStartupFinished(le,de)}_handleEagerExtensions(){const le=this._activateByEvent("*",!0).then(void 0,Se=>{this._logService.error(Se)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Se=>this._handleWorkspaceContainsEagerExtensions(Se.added)));const de=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(de),me=Promise.all([le,Y]).then(()=>{});return Promise.race([me,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),me}_handleWorkspaceContainsEagerExtensions(le){return le.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(de=>this._handleWorkspaceContainsEagerExtension(le,de))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(le,de){if(this.isActivated(de.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,me={logService:this._logService,folders:le.map(Oe=>Oe.uri),forceUsingSearch:Y,exists:Oe=>this._hostUtils.exists(Oe.fsPath),checkExists:(Oe,Be,Xe)=>this._mainThreadWorkspaceProxy.$checkExists(Oe,Be,Xe)},Se=await(0,L.checkActivateWorkspaceContainsExtension)(me,de);if(!!Se)return this._activateById(de.identifier,{startup:!0,extensionId:de.identifier,activationEvent:Se.activationEvent}).then(void 0,Oe=>this._logService.error(Oe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(le){throw console.error(le),le}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:le,extensionTestsLocationURI:de}=this._initData.environment;if(!le||!de)throw new Error(i.localize(0,null));const Y=await this._loadCommonJSModule(null,de,new E.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(i.localize(1,null,de.toString()));return new Promise((me,Se)=>{const Oe=(ke,ye)=>{ke?Se(ke):me(typeof ye=="number"&&ye>0?1:0)},Be=(0,M.originalFSPath)(de),Xe=Y.run(Be,Oe);Xe&&Xe.then&&Xe.then(()=>{me(0)}).catch(ke=>{Se(ke instanceof Error&&ke.stack?ke.stack:String(ke))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(le,de){return this._resolvers[le]=de,(0,A.toDisposable)(()=>{delete this._resolvers[le]})}async _activateAndGetResolver(le){const de=le.indexOf("+");if(de===-1)throw new Error("Not an authority that can be resolved!");const Y=le.substr(0,de);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(le,de){this._logService.info(`$resolveAuthority invoked for authority (${ue(le)})`);const{authorityPrefix:Y,resolver:me}=await this._activateAndGetResolver(le);if(!me)return{type:"error",error:{code:c.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(me)),S.mark(`code/extHost/willResolveAuthority/${Y}`);const Se=await me.resolve(le,{resolveAttempt:de});S.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const Oe={authority:le,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},Be={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Oe,options:Be,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(S.mark(`code/extHost/didResolveAuthorityError/${Y}`),Se instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(le,de){this._logService.info(`$getCanonicalURI invoked for authority (${ue(le)})`);const{resolver:Y}=await this._activateAndGetResolver(le);if(!Y)return null;const me=k.URI.revive(de);if(typeof Y.getCanonicalURI>"u")return me;const Se=await(0,D.asPromise)(()=>Y.getCanonicalURI(me));return Se||me}static _applyExtensionsDelta(le,de,Y){const me=new a.ExtensionDescriptionRegistry(le.getAllExtensionDescriptions());me.deltaExtensions(Y.toAdd,Y.toRemove);const Se=(0,o.extensionIdentifiersArrayToSet)(de.getAllExtensionDescriptions().map(Be=>Be.identifier));for(const Be of Y.myToRemove)Se.delete(w.ExtensionIdentifier.toKey(Be));for(const Be of Y.myToAdd)Se.add(w.ExtensionIdentifier.toKey(Be));const Oe=ee(me,Se);return{globalRegistry:me,myExtensions:Oe}}$startExtensionHost(le){le.toAdd.forEach(me=>me.extensionLocation=k.URI.revive(me.extensionLocation));const{globalRegistry:de,myExtensions:Y}=Pi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,le);return this._globalRegistry.set(de.getAllExtensionDescriptions()),this._myRegistry.set(Y),this._startExtensionHost()}$activateByEvent(le,de){return de===1?this._activateByEvent(le,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(le,!1))}async $activate(le,de){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(le)?(await this._activateById(le,de),!0):!1}async $deltaExtensions(le){le.toAdd.forEach(Oe=>Oe.extensionLocation=k.URI.revive(Oe.extensionLocation));const{globalRegistry:de,myExtensions:Y}=Pi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,le),me=await this._createExtensionPathIndex(Y);return(await this.getExtensionPathIndex()).setSearchTree(me),this._globalRegistry.set(de.getAllExtensionDescriptions()),this._myRegistry.set(Y),Promise.resolve(void 0)}async $test_latency(le){return le}async $test_up(le){return le.byteLength}async $test_down(le){const de=d.VSBuffer.alloc(le),Y=Math.random()%256;for(let me=0;me<le;me++)de.writeUInt8(Y,me);return de}async $updateRemoteConnectionData(le){this._remoteConnectionData=le,this._onDidChangeRemoteConnectionData.fire()}};B=He([$e(0,n.IInstantiationService),$e(1,e.IHostUtils),$e(2,f.IExtHostRpcService),$e(3,t.IExtHostWorkspace),$e(4,p.IExtHostConfiguration),$e(5,R.ILogService),$e(6,u.IExtHostInitDataService),$e(7,l.IExtensionStoragePaths),$e(8,h.IExtHostTunnelService),$e(9,v.IExtHostTerminalService),$e(10,C.IExtHostLocalizationService)],B),e.AbstractExtHostExtensionService=B;function H(pe,le){return{id:pe.identifier.value,name:pe.name,extensionVersion:pe.version,publisherDisplayName:pe.publisher,activationEvents:pe.activationEvents?pe.activationEvents.join(","):null,isBuiltin:pe.isBuiltin,reason:le.activationEvent,reasonId:le.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class G{constructor(le,de,Y,me,Se){F.set(this,void 0),O.set(this,void 0),x.set(this,void 0),Ye(this,F,le,"f"),Ye(this,O,de,"f"),Ye(this,x,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=I.normalize((0,M.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=me,this.isFromDifferentExtensionHost=Se}get isActive(){return Ae(this,F,"f").isActivated(Ae(this,x,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ae(this,F,"f").getExtensionExports(Ae(this,x,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ae(this,F,"f").activateByIdWithErrors(Ae(this,x,"f"),{startup:!1,extensionId:Ae(this,O,"f"),activationEvent:"api"}),this.exports}}e.Extension=G,F=new WeakMap,O=new WeakMap,x=new WeakMap;function ee(pe,le){return pe.getAllExtensionDescriptions().filter(de=>le.has(w.ExtensionIdentifier.toKey(de.identifier)))}function ue(pe){const le=pe.indexOf("+");return le===-1?pe:pe.substring(0,le)}class re{constructor(le){this._searchTree=le}setSearchTree(le){this._searchTree=le}findSubstr(le){return this._searchTree.findSubstr(le)}forEach(le){return this._searchTree.forEach(le)}}e.ExtensionPaths=re}),define(De[237],Ie([1,0,76,2,5,32,27,25,14,26,3,33,48,11,10]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let t=class{constructor(T,r,c,n,u,l,f){this._apiFactory=T,this._extensionRegistry=r,this._instaService=c,this._extHostConfiguration=n,this._extHostExtensionService=u,this._initData=l,this._logService=f,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),i.mark("code/extHost/willWaitForConfig");const T=await this._extHostConfiguration.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,r,this._extensionRegistry,T,this._logService)),this.register(this._instaService.createInstance(g,r)),this.register(this._instaService.createInstance(o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,r,this._initData.environment.appUriScheme))}register(T){if("nodeModuleName"in T)if(Array.isArray(T.nodeModuleName))for(const r of T.nodeModuleName)this._factories.set(r,T);else this._factories.set(T.nodeModuleName,T);typeof T.alternativeModuleName=="function"&&this._alternatives.push(r=>T.alternativeModuleName(r))}};t=He([$e(2,R.IInstantiationService),$e(3,M.IExtHostConfiguration),$e(4,b.IExtHostExtensionService),$e(5,k.IExtHostInitDataService),$e(6,E.ILogService)],t),e.RequireInterceptor=t;let o=class Qi{constructor(T){if(T.environment.appRoot&&Qi.aliased.size){const r=(0,m.escapeRegExpCharacters)(this.forceForwardSlashes(T.environment.appRoot.fsPath)),c="[a-z0-9_.-]",n=`@${c}+\\/${c}+|${c}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${r}/${u}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(T){if(!this.re)return;const r=this.re.exec(this.forceForwardSlashes(T));if(!r)return;const[,c,n,u]=r,l=Qi.aliased.get(n);if(l!==void 0)return console.warn(`${n} as been renamed to ${l}, please update your imports`),c+l+u}forceForwardSlashes(T){return T.replace(/\\/g,"/")}};o.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=He([$e(0,k.IExtHostInitDataService)],o);class a{constructor(T,r,c,n,u){this._apiFactory=T,this._extensionPaths=r,this._extensionRegistry=c,this._configProvider=n,this._logService=u,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(T,r){const c=this._extensionPaths.findSubstr(r);if(c){let n=this._extApiImpl.get(A.ExtensionIdentifier.toKey(c.identifier));return n||(n=this._apiFactory(c,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(c.identifier),n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((u,l)=>n+=`	${l} -> ${u.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(T,r,c){this._extensionPaths=T,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(S.MainContext.MainThreadTelemetry);const{environment:n}=c,u=r.getProxy(S.MainContext.MainThreadKeytar);if(n.appRoot){let l=n.appRoot.fsPath;p.platform==="win32"&&(l=l.replace(/\\/g,"/")),l[l.length-1]==="/"&&(l=l.substr(0,l.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${l}/node_modules.asar/keytar`),this.alternativeNames.add(`${l}/node_modules/keytar`)}this._impl={getPassword:(l,f)=>u.$getPassword(l,f),setPassword:(l,f,s)=>u.$setPassword(l,f,s),deletePassword:(l,f)=>u.$deletePassword(l,f),findPassword:l=>u.$findPassword(l),findCredentials(l){return u.$findCredentials(l)}}}load(T,r){const c=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:c?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(T){const r=T.length;if(r<=7||!this.alternativeNames)return;const c=r-7;if((T.charAt(c)==="/"||T.charAt(c)==="\\")&&T.endsWith("keytar")&&(T=T.replace(/\\/g,"/"),this.alternativeNames.has(T)))return"keytar"}};g=He([$e(1,y.IExtHostRpcService),$e(2,k.IExtHostInitDataService)],g);let w=class{constructor(T,r,c){this._extensionPaths=T,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=c.getProxy(S.MainContext.MainThreadTelemetry);const n=c.getProxy(S.MainContext.MainThreadWindow);this._impl=(u,l)=>{const f=I.URI.parse(u);return l?this.callOriginal(u,l):f.scheme==="http"||f.scheme==="https"?n.$openUri(f,u,{allowTunneling:!0}):f.scheme==="mailto"||f.scheme===this._appUriScheme?n.$openUri(f,u,{}):this.callOriginal(u,l)}}load(T,r,c){const n=this._extensionPaths.findSubstr(r);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=c(T),this._impl}callOriginal(T,r){return this.sendNoForwardTelemetry(),this._original(T,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=He([$e(2,y.IExtHostRpcService)],w)}),define(De[103],Ie([1,0,203,7,19,48,3,53,54,33,6,31,176,32]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,D.createDecorator)("IExtHostVariableResolverProvider");class m extends p.AbstractVariableResolverService{constructor(a,g,w,d,T,r,c){function n(){if(w){const u=w.activeEditor();if(u)return u.document.uri;const l=d.tabGroups.all.find(f=>f.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof R.TextDiffTabInput||l.input instanceof R.NotebookDiffEditorTabInput)return l.input.modified;if(l.input instanceof R.TextTabInput||l.input instanceof R.NotebookEditorTabInput||l.input instanceof R.CustomEditorTabInput)return l.input.uri}}}super({getFolderUri:u=>{const l=r.folders.filter(f=>f.name===u);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(u,l)=>T.getConfiguration(void 0,u).get(l),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=n();if(u)return S.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const u=n();if(u){const l=g.getWorkspaceFolder(u);if(l)return S.normalize(l.uri.fsPath)}}},getSelectedText:()=>{if(w){const u=w.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(w){const u=w.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>a.getExtension(u)},void 0,c?Promise.resolve(c):void 0,Promise.resolve(M.env))}}let t=class extends I.Disposable{constructor(a,g,w,d,T){super(),this.extensionService=a,this.workspaceService=g,this.editorService=w,this.configurationService=d,this.editorTabs=T,this._resolver=new i.Lazy(async()=>{const r=await this.configurationService.getConfigProvider(),n={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async u=>{n.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new m(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,r,n,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};t=He([$e(0,k.IExtHostExtensionService),$e(1,b.IExtHostWorkspace),$e(2,A.IExtHostDocumentsAndEditors),$e(3,E.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs)],t),e.ExtHostVariableResolverProviderService=t}),define(De[104],Ie([1,0,15,4,9,2,3,5,54,33,14,6,31,169,171,32,103]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(n,u,l,f,s,h){this._workspaceService=u,this._extensionService=l,this._configurationService=f,this._editorTabs=s,this._variableResolver=h,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=n.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new w(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(v=>{v.onDidChange(P=>{this.registerAllDebugTypes(v)}),this.registerAllDebugTypes(v)})}asDebugSourceUri(n,u){const l=n;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let f=`debug:${encodeURIComponent(l.path||"")}`,s="?";return u&&(f+=`${s}session=${encodeURIComponent(u.id)}`,s="&"),f+=`${s}ref=${l.sourceReference}`,M.URI.parse(f)}else{if(l.path)return M.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const u=[];for(const l of n.getAllExtensionDescriptions())if(l.contributes){const f=l.contributes.debuggers;if(f&&f.length>0)for(const s of f)(0,m.isDebuggerMainContribution)(s)&&u.push(s.type)}this._debugServiceProxy.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const n=[];return this._breakpoints.forEach(u=>n.push(u)),n}addBreakpoints(n){this.startBreakpoints();const u=n.filter(s=>{const h=s.id;return this._breakpoints.has(h)?!1:(this._breakpoints.set(h,s),!0)});this.fireBreakpointChanges(u,[],[]);const l=[],f=new Map;for(const s of u)if(s instanceof b.SourceBreakpoint){let h=f.get(s.location.uri.toString());h||(h={type:"sourceMulti",uri:s.location.uri,lines:[]},f.set(s.location.uri.toString(),h),l.push(h)),h.lines.push({id:s.id,enabled:s.enabled,condition:s.condition,hitCondition:s.hitCondition,logMessage:s.logMessage,line:s.location.range.start.line,character:s.location.range.start.character})}else s instanceof b.FunctionBreakpoint&&l.push({type:"function",id:s.id,enabled:s.enabled,hitCondition:s.hitCondition,logMessage:s.logMessage,condition:s.condition,functionName:s.functionName});return this._debugServiceProxy.$registerBreakpoints(l)}removeBreakpoints(n){this.startBreakpoints();const u=n.filter(h=>this._breakpoints.delete(h.id));this.fireBreakpointChanges([],u,[]);const l=u.filter(h=>h instanceof b.SourceBreakpoint).map(h=>h.id),f=u.filter(h=>h instanceof b.FunctionBreakpoint).map(h=>h.id),s=u.filter(h=>h instanceof b.DataBreakpoint).map(h=>h.id);return this._debugServiceProxy.$unregisterBreakpoints(l,f,s)}startDebugging(n,u,l){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,u,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===b.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,suppressSaveBeforeStart:l.suppressSaveBeforeStart,suppressDebugStatusbar:l.suppressDebugStatusbar??l.debugUI?.simple,suppressDebugToolbar:l.suppressDebugToolbar??l.debugUI?.simple,suppressDebugView:l.suppressDebugView??l.debugUI?.simple})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,u,l){if(!u)return new b.Disposable(()=>{});const f=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:f,provider:u}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,l,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,f),new b.Disposable(()=>{this._configProviders=this._configProviders.filter(s=>s.provider!==u),this._debugServiceProxy.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(n,u,l){if(!l)return new b.Disposable(()=>{});if(!this.definesDebugType(n,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.getAdapterDescriptorFactoryByType(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:u,handle:f,factory:l}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(u,f),new b.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(s=>s.factory!==l),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(n,u){if(!u)return new b.Disposable(()=>{});const l=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:l,factory:u}),new b.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(f=>f.factory!==u)})}async $runInTerminal(n,u){return Promise.resolve(void 0)}async $substituteVariables(n,u){let l;const f=await this.getFolder(n);return f&&(l={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(l,u)}createDebugAdapter(n,u){if(n.type==="implementation")return new T(n.implementation)}createSignService(){}async $startDASession(n,u){const l=this,f=await this.getSession(u);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(f.type),f).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const h=this.convertToDto(s),v=this.createDebugAdapter(h,f);if(!v)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const P=v;return this._debugAdapters.set(n,P),this.getDebugAdapterTrackers(f).then(L=>(L&&this._debugAdaptersTrackers.set(n,L),P.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const W=j,V={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const C=await this._signService.sign(W.arguments.value);V.body={signature:C},P.sendResponse(V)}else throw new Error("no signer")}catch(C){V.success=!1,V.message=C.message,P.sendResponse(V)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(j),j=(0,m.convertToVSCPaths)(j,!0),l._debugServiceProxy.$acceptDAMessage(n,j)}),P.onError(j=>{L&&L.onError&&L.onError(j),this._debugServiceProxy.$acceptDAError(n,j.name,j.message,j.stack)}),P.onExit(j=>{L&&L.onExit&&L.onExit((0,S.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,S.withNullAsUndefined)(j),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),P.startSession()))})}$sendDAMessage(n,u){u=(0,m.convertToDAPaths)(u,!1);const l=this._debugAdaptersTrackers.get(n);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(u),this._debugAdapters.get(n)?.sendMessage(u)}$stopDASession(n){const u=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),u&&u.onWillStopSession&&u.onWillStopSession();const l=this._debugAdapters.get(n);return this._debugAdapters.delete(n),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const u=[],l=[],f=[];if(n.added)for(const s of n.added){const h=s.id;if(h&&!this._breakpoints.has(h)){let v;if(s.type==="function")v=new b.FunctionBreakpoint(s.functionName,s.enabled,s.condition,s.hitCondition,s.logMessage);else if(s.type==="data")v=new b.DataBreakpoint(s.label,s.dataId,s.canPersist,s.enabled,s.hitCondition,s.condition,s.logMessage);else{const P=M.URI.revive(s.uri);v=new b.SourceBreakpoint(new b.Location(P,new b.Position(s.line,s.character)),s.enabled,s.condition,s.hitCondition,s.logMessage)}v._id=h,this._breakpoints.set(h,v),u.push(v)}}if(n.removed)for(const s of n.removed){const h=this._breakpoints.get(s);h&&(this._breakpoints.delete(s),l.push(h))}if(n.changed){for(const s of n.changed)if(s.id){const h=this._breakpoints.get(s.id);if(h){if(h instanceof b.FunctionBreakpoint&&s.type==="function"){const v=h;v.enabled=s.enabled,v.condition=s.condition,v.hitCondition=s.hitCondition,v.logMessage=s.logMessage,v.functionName=s.functionName}else if(h instanceof b.SourceBreakpoint&&s.type==="source"){const v=h;v.enabled=s.enabled,v.condition=s.condition,v.hitCondition=s.hitCondition,v.logMessage=s.logMessage,v.location=new b.Location(M.URI.revive(s.uri),new b.Position(s.line,s.character))}f.push(h)}}}this.fireBreakpointChanges(u,l,f)}$provideDebugConfigurations(n,u,l){return(0,i.asPromise)(async()=>{const f=this.getConfigProviderByHandle(n);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const s=await this.getFolder(u);return f.provideDebugConfigurations(s,l)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(n,u,l,f){return(0,i.asPromise)(async()=>{const s=this.getConfigProviderByHandle(n);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const h=await this.getFolder(u);return s.resolveDebugConfiguration(h,l,f)})}$resolveDebugConfigurationWithSubstitutedVariables(n,u,l,f){return(0,i.asPromise)(async()=>{const s=this.getConfigProviderByHandle(n);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const h=await this.getFolder(u);return s.resolveDebugConfigurationWithSubstitutedVariables(h,l,f)})}async $provideDebugAdapter(n,u){const l=this.getAdapterDescriptorFactoryByHandle(n);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.getSession(u);return this.getAdapterDescriptor(l,f).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.convertToDto(s)})}async $acceptDebugSessionStarted(n){const u=await this.getSession(n);this._onDidStartDebugSession.fire(u)}async $acceptDebugSessionTerminated(n){const u=await this.getSession(n);u&&(this._onDidTerminateDebugSession.fire(u),this._debugSessions.delete(u.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,u){(await this.getSession(n))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(n,u){const f={session:await this.getSession(n),event:u.event,body:u.body};this._onDidReceiveDebugSessionCustomEvent.fire(f)}convertToDto(n){if(n instanceof b.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof b.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof b.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof b.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const u=this._adapterFactories.filter(l=>l.type===n);if(u.length>0)return u[0].factory}getAdapterDescriptorFactoryByHandle(n){const u=this._adapterFactories.filter(l=>l.handle===n);if(u.length>0)return u[0].factory}getConfigProviderByHandle(n){const u=this._configProviders.filter(l=>l.handle===n);if(u.length>0)return u[0].provider}definesDebugType(n,u){if(n.contributes){const l=n.contributes.debuggers;if(l&&l.length>0){for(const f of l)if(f.label&&f.type&&f.type===u)return!0}}return!1}getDebugAdapterTrackers(n){const l=n.configuration.type,f=this._trackerFactories.filter(s=>s.type===l||s.type==="*").map(s=>(0,i.asPromise)(()=>s.factory.createDebugAdapterTracker(n)).then(h=>h,h=>null));return Promise.race([Promise.all(f).then(s=>{const h=s.filter(v=>!!v);if(h.length>0)return new d(h)}),new Promise((s,h)=>{const v=setTimeout(()=>{clearTimeout(v),h(new Error("timeout"))},1e3)})]).catch(s=>{})}async getAdapterDescriptor(n,u){const l=u.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new b.DebugAdapterServer(l));if(n){const s=await this._extensionService.getExtensionRegistry();return(0,i.asPromise)(()=>n.createDebugAdapterDescriptor(u,this.daExecutableFromPackage(u,s))).then(h=>{if(h)return h})}const f=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(u,f))}daExecutableFromPackage(n,u){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(n,u,l){(n.length>0||u.length>0||l.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:u,changed:l}))}async getSession(n){if(n)if(typeof n=="string"){const u=this._debugSessions.get(n);if(u)return u}else{let u=this._debugSessions.get(n.id);if(!u){const l=await this.getFolder(n.folderUri),f=n.parent?this._debugSessions.get(n.parent):void 0;u=new g(this._debugServiceProxy,n.id,n.type,n.name,l,n.configuration,f),this._debugSessions.set(u.id,u),this._debugServiceProxy.$sessionCached(u.id)}return u}throw new Error("cannot find session")}getFolder(n){if(n){const u=M.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};a=He([$e(0,R.IExtHostRpcService),$e(1,p.IExtHostWorkspace),$e(2,k.IExtHostExtensionService),$e(3,t.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs),$e(5,o.IExtHostVariableResolverProvider)],a),e.ExtHostDebugServiceBase=a;class g{constructor(n,u,l,f,s,h,v){this._debugServiceProxy=n,this._id=u,this._type=l,this._name=f,this._workspaceFolder=s,this._configuration=h,this._parentSession=v}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,u){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,u)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=g;class w{constructor(n){this.value=Object.freeze({append(u){n.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=w;class d{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(u=>u.onError?u.onError(n):void 0)}onExit(n,u){this.trackers.forEach(l=>l.onExit?l.onExit(n,u):void 0)}}class T extends E.AbstractDebugAdapter{constructor(n){super(),this.implementation=n,n.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends a{constructor(n,u,l,f,s,h){super(n,u,l,f,s,h)}};r=He([$e(0,R.IExtHostRpcService),$e(1,p.IExtHostWorkspace),$e(2,k.IExtHostExtensionService),$e(3,t.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs),$e(5,o.IExtHostVariableResolverProvider)],r),e.WorkerExtHostDebugService=r}),define(De[238],Ie([1,0,12,76,2,5,229,11,59,60,26,149,14,50,33,69]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(w){const d=w.get(A.ILogService),r=w.get(p.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(c=>{d.error(c);const n=i.transformErrorForSerialization(c);r.$onUnexpectedError(n)})}static async installFullHandler(w){const d=w.get(A.ILogService),T=w.get(p.IExtHostRpcService),r=w.get(m.IExtHostExtensionService),c=w.get(t.IExtHostTelemetry),n=T.getProxy(M.MainContext.MainThreadExtensionService),u=T.getProxy(M.MainContext.MainThreadErrors),l=await r.getExtensionPathIndex(),f=new WeakMap;Error.prepareStackTrace=(s,h)=>{let v="",P,L;for(const j of h)v+=`
	at ${j.toString()}`,L=j.getFileName(),!P&&L&&(P=l.findSubstr(S.URI.file(L)));return f.set(s,P?.identifier),`${s.name||"Error"}: ${s.message||""}${v}`},i.setUnexpectedErrorHandler(s=>{d.error(s);const h=i.transformErrorForSerialization(s),v=f.get(s);if(!v){u.$onUnexpectedError(h);return}n.$onExtensionRuntimeError(v,h);const P=c.onExtensionError(v,s);d.trace("forwarded error to extension?",P,v)})}}Error.stackTraceLimit=100;class a{constructor(w,d,T,r,c){this._hostUtils=T,this._rpcProtocol=new D.RPCProtocol(w,null,r),d=a._transform(d,this._rpcProtocol);const n=new k.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());n.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...d,messagePorts:c}),n.set(p.IExtHostRpcService,new p.ExtHostRpcService(this._rpcProtocol)),n.set(E.IURITransformerService,new E.URITransformerService(r)),n.set(m.IHostUtils,T);const u=new b.InstantiationService(n,!0);u.invokeFunction(o.installEarlyHandler),this._logService=u.invokeFunction(l=>l.get(A.ILogService)),I.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",d),this._extensionService=u.invokeFunction(l=>l.get(m.IExtHostExtensionService)),this._extensionService.initialize(),u.invokeFunction(o.installFullHandler)}async asBrowserUri(w){const d=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService);return S.URI.revive(await d.$asBrowserUri(w))}terminate(w){this._extensionService.terminate(w)}static _transform(w,d){w.allExtensions.forEach(r=>{r.extensionLocation=S.URI.revive(d.transformIncomingURIs(r.extensionLocation));const c={};r.browserNlsBundleUris&&(Object.keys(r.browserNlsBundleUris).forEach(n=>c[n]=S.URI.revive(d.transformIncomingURIs(r.browserNlsBundleUris[n]))),r.browserNlsBundleUris=c)}),w.environment.appRoot=S.URI.revive(d.transformIncomingURIs(w.environment.appRoot));const T=w.environment.extensionDevelopmentLocationURI;return T&&(w.environment.extensionDevelopmentLocationURI=T.map(r=>S.URI.revive(d.transformIncomingURIs(r)))),w.environment.extensionTestsLocationURI=S.URI.revive(d.transformIncomingURIs(w.environment.extensionTestsLocationURI)),w.environment.globalStorageHome=S.URI.revive(d.transformIncomingURIs(w.environment.globalStorageHome)),w.environment.workspaceStorageHome=S.URI.revive(d.transformIncomingURIs(w.environment.workspaceStorageHome)),w.environment.extensionTelemetryLogResource=S.URI.revive(d.transformIncomingURIs(w.environment.extensionTelemetryLogResource)),w.nlsBaseUrl=S.URI.revive(d.transformIncomingURIs(w.nlsBaseUrl)),w.logsLocation=S.URI.revive(d.transformIncomingURIs(w.logsLocation)),w.logFile=S.URI.revive(d.transformIncomingURIs(w.logFile)),w.workspace=d.transformIncomingURIs(w.workspace),w}}e.ExtensionHostMain=a}),define(De[239],Ie([1,0,18,15,20,45,13,19,22,2,44]),function(ie,e,i,I,S,M,D,A,y,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(g,w,d,T){this.query=g,this.provider=w,this.fileUtils=d,this.processType=T,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(g,w){const d=this.query.folderQueries||[],T=new S.CancellationTokenSource;return w.onCancellationRequested(()=>T.cancel()),new Promise((r,c)=>{this.collector=new E(g);let n=!1;const u=(l,f)=>{if(!n&&!this.isLimitHit){const s=this.resultSize(l);t(l)&&typeof this.query.maxResults=="number"&&this.resultCount+s>this.query.maxResults&&(this.isLimitHit=!0,n=!0,T.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const h=this.resultSize(l);this.resultCount+=h,(h>0||!t(l))&&this.collector.add(l,f)}};Promise.all(d.map((l,f)=>this.searchInFolder(l,s=>u(s,f),T.token))).then(l=>{T.dispose(),this.collector.flush();const f=l.some(s=>!!s&&!!s.limitHit);r({limitHit:this.isLimitHit||f,messages:(0,i.flatten)(l.map(s=>s?.message?Array.isArray(s.message)?s.message:[s.message]:[])),stats:{type:this.processType}})},l=>{T.dispose();const f=(0,M.toErrorMessage)(l);c(new Error(f))})})}resultSize(g){return t(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}trimResultToSize(g,w){const d=Array.isArray(g.ranges)?g.ranges:[g.ranges],T=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:d.slice(0,w),preview:{matches:T.slice(0,w),text:g.preview.text},uri:g.uri}}async searchInFolder(g,w,d){const T=new R.QueryGlobTester(this.query,g),r=[],c={report:l=>{if(!this.validateProviderResult(l))return;const f=g.folder.scheme===D.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(l.uri))):void 0,s=y.relativePath(g.folder,l.uri);if(s){const h=T.includedInQuery(s,A.basename(s),f);(0,I.isThenable)(h)?r.push(h.then(v=>{v&&w(l)})):h&&w(l)}}},n=this.getSearchOptionsForFolder(g),u=await this.provider.provideTextSearchResults(p(this.query.contentPattern),n,c,d);return r.length&&await Promise.all(r),u}validateProviderResult(g){if(t(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(g){const w=(0,R.resolvePatternsForProvider)(this.query.includePattern,g.includePattern),d=(0,R.resolvePatternsForProvider)(this.query.excludePattern,g.excludePattern),T={folder:k.URI.from(g.folder),excludes:d,includes:w,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.fileUtils.toCanonicalName(g.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return T.usePCRE2=this.query.usePCRE2,T}}e.TextSearchManager=b;function p(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class E{constructor(g){this._onResult=g,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new o(512,w=>this.sendItems(w))}add(g,w){this._currentFileMatch&&(this._currentFolderIdx!==w||!y.isEqual(this._currentUri,g.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=w,this._currentFileMatch={resource:g.uri,results:[]}),this._currentFileMatch.results.push(m(g))}pushToCollector(){const g=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,g)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(g){this._onResult(g)}}e.TextSearchResultsCollector=E;function m(a){return t(a)?{preview:{matches:(0,i.mapArrayOrNot)(a.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:a.preview.text},ranges:(0,i.mapArrayOrNot)(a.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function t(a){return!!a.preview}e.extensionResultIsMatch=t;class o{constructor(g,w){this.maxBatchSize=g,this.cb=w,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(g,w){!g||this.addItemToBatch(g,w)}addItems(g,w){!g||this.addItemsToBatch(g,w)}addItemToBatch(g,w){this.batch.push(g),this.batchSize+=w,this.onUpdate()}addItemsToBatch(g,w){this.batch=this.batch.concat(g),this.batchSize+=w,this.onUpdate()}onUpdate(){this.totalNumberCompleted<o.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},o.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=o,o.TIMEOUT=4e3,o.START_BATCH_AFTER_COUNT=50}),define(De[105],Ie([1,0,7,5,3,234,14,50,11,2,239]),function(ie,e,i,I,S,M,D,A,y,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let b=class{constructor(t,o,a){this.extHostRpc=t,this._uriTransformer=o,this._logService=a,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new M.FileSearchManager}_transformScheme(t){return this._uriTransformer.transformOutgoingScheme(t)}registerTextSearchProvider(t,o){if(this._textSearchUsedSchemes.has(t))throw new Error(`a text search provider for the scheme '${t}' is already registered`);this._textSearchUsedSchemes.add(t);const a=this._handlePool++;return this._textSearchProvider.set(a,o),this._proxy.$registerTextSearchProvider(a,this._transformScheme(t)),(0,i.toDisposable)(()=>{this._textSearchUsedSchemes.delete(t),this._textSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}registerFileSearchProvider(t,o){if(this._fileSearchUsedSchemes.has(t))throw new Error(`a file search provider for the scheme '${t}' is already registered`);this._fileSearchUsedSchemes.add(t);const a=this._handlePool++;return this._fileSearchProvider.set(a,o),this._proxy.$registerFileSearchProvider(a,this._transformScheme(t)),(0,i.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(t),this._fileSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(t,o,a,g){const w=p(a),d=this._fileSearchProvider.get(t);if(d)return this._fileSearchManager.fileSearch(w,d,T=>{this._proxy.$handleFileMatch(t,o,T.map(r=>r.resource))},g);throw new Error("unknown provider: "+t)}$clearCache(t){return this._fileSearchManager.clearCache(t),Promise.resolve(void 0)}$provideTextSearchResults(t,o,a,g){const w=this._textSearchProvider.get(t);if(!w||!w.provideTextSearchResults)throw new Error(`Unknown provider ${t}`);const d=p(a);return this.createTextSearchManager(d,w).search(r=>this._proxy.$handleTextMatch(t,o,r),g)}$enableExtensionHostSearch(){}createTextSearchManager(t,o){return new R.TextSearchManager(t,o,{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}};b=He([$e(0,D.IExtHostRpcService),$e(1,A.IURITransformerService),$e(2,y.ILogService)],b),e.ExtHostSearch=b;function p(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(E),extraFileResources:m.extraFileResources&&m.extraFileResources.map(t=>k.URI.revive(t))}}e.reviveQuery=p;function E(m){return{...m,folder:k.URI.revive(m.folder)}}}),define(De[240],Ie([1,0,59,100,31,98,32,37,53,56,102,104,105,74,64,71,99,55,36,73,69,54,211,11,181,103,72]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o,a,g,w,d,T,r,c,n,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(l.IExtHostLocalizationService,l.ExtHostLocalizationService,1),(0,i.registerSingleton)(c.ILoggerService,r.ExtHostLoggerService,1),(0,i.registerSingleton)(c.ILogService,n.ExtHostLogService,1),(0,i.registerSingleton)(t.IExtHostApiDeprecationService,t.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,i.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration,0),(0,i.registerSingleton)(a.IExtHostConsumerFileSystem,a.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService,0),(0,i.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,i.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService,1),(0,i.registerSingleton)(p.IExtHostSearch,p.ExtHostSearch,0),(0,i.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage,0),(0,i.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,i.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService,0),(0,i.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,i.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace,0),(0,i.registerSingleton)(w.IExtHostSecretState,w.ExtHostSecretState,0),(0,i.registerSingleton)(d.IExtHostTelemetry,d.ExtHostTelemetry,0),(0,i.registerSingleton)(T.IExtHostEditorTabs,T.ExtHostEditorTabs,0),(0,i.registerSingleton)(u.IExtHostVariableResolverProvider,u.ExtHostVariableResolverProviderService,0)}),define(De[241],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class i{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(S){if(S&&this._dragOperations.has(S)){const M=this._dragOperations.get(S);return this._dragOperations.delete(S),M}}addDragOperationTransfer(S,M){this._dragOperations.set(S,M)}getRenderedTreeElement(S){if(this._renderedElements.has(S))return this._renderedElements.get(S)}addRenderedTreeItemElement(S,M){this._renderedElements.set(S,M)}removeRenderedTreeItemElement(S){this._renderedElements.has(S)&&this._renderedElements.delete(S)}}e.TreeviewsService=i}),define(De[242],Ie([1,0,136,6,22,2,4,7,15,6,9,18,8,20,241,27]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(w,d){if((0,R.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let T;return Array.isArray(w.highlights)&&(T=w.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),T=T.length?T:void 0),{label:w.label,highlights:T}}}class a{constructor(d,T,r){this._proxy=d,this.commands=T,this.logService=r,this.treeViews=new Map,this.treeDragAndDropService=new m.TreeviewsService;function c(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems||n.$focusedTreeItem)}T.registerArgumentProcessor({processArgument:n=>c(n)?this.convertArgument(n):Array.isArray(n)&&n.length>0?n.map(u=>c(u)?this.convertArgument(u):u):n})}registerTreeDataProvider(d,T,r){const c=this.createTreeView(d,{treeDataProvider:T},r);return{dispose:()=>c.dispose()}}createTreeView(d,T,r){if(!T||!T.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=T.dragAndDropController?.dropMimeTypes??[],n=T.dragAndDropController?.dragMimeTypes??[],u=!!T.dragAndDropController?.handleDrag,l=!!T.dragAndDropController?.handleDrop,f=this.createExtHostTreeView(d,T,r),s=this._proxy.$registerTreeViewDataProvider(d,{showCollapseAll:!!T.showCollapseAll,canSelectMany:!!T.canSelectMany,dropMimeTypes:c,dragMimeTypes:n,hasHandleDrag:u,hasHandleDrop:l});return{get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,t.checkProposedApiEnabled)(r,"treeItemCheckbox"),f.onDidChangeCheckboxState},get message(){return f.message},set message(h){f.message=h},get title(){return f.title},set title(h){f.title=h},get description(){return f.description},set description(h){f.description=h},get badge(){return f.badge},set badge(h){h!==void 0&&k.ViewBadge.isViewBadge(h)?f.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(f.badge=void 0)},reveal:(h,v)=>f.reveal(h,v),dispose:async()=>{await s,this.treeViews.delete(d),f.dispose()}}}$getChildren(d,T){const r=this.treeViews.get(d);return r?r.getChildren(T):Promise.reject(new Error((0,i.localize)(0,null,d)))}async $handleDrop(d,T,r,c,n,u,l,f){const s=this.treeViews.get(d);if(!s)return Promise.reject(new Error((0,i.localize)(1,null,d)));const h=p.DataTransfer.toDataTransfer(r,async v=>(await this._proxy.$resolveDropFileData(d,T,v)).buffer);return l===d&&f&&await this.addAdditionalTransferItems(h,s,f,n,u),s.onDrop(h,c,n)}async addAdditionalTransferItems(d,T,r,c,n){const u=this.treeDragAndDropService.removeDragOperationTransfer(n);if(u)(await u)?.forEach((l,f)=>{l&&d.set(f,l)});else if(n&&T.handleDrag){const l=T.handleDrag(r,d,c);this.treeDragAndDropService.addDragOperationTransfer(n,l),await l}return d}async $handleDrag(d,T,r,c){const n=this.treeViews.get(d);if(!n)return Promise.reject(new Error((0,i.localize)(2,null,d)));const u=await this.addAdditionalTransferItems(new I.DataTransfer,n,T,c,r);if(!!u)return p.DataTransfer.toDataTransferDTO(u)}async $hasResolve(d){const T=this.treeViews.get(d);if(!T)throw new Error((0,i.localize)(3,null,d));return T.hasResolve}$resolve(d,T,r){const c=this.treeViews.get(d);if(!c)throw new Error((0,i.localize)(4,null,d));return c.resolveTreeItem(T,r)}$setExpanded(d,T,r){const c=this.treeViews.get(d);if(!c)throw new Error((0,i.localize)(5,null,d));c.setExpanded(T,r)}$setSelection(d,T){const r=this.treeViews.get(d);if(!r)throw new Error((0,i.localize)(6,null,d));r.setSelection(T)}$setFocus(d,T){const r=this.treeViews.get(d);if(!r)throw new Error((0,i.localize)(7,null,d));r.setFocus(T)}$setVisible(d,T){const r=this.treeViews.get(d);if(!r)throw new Error((0,i.localize)(8,null,d));r.setVisible(T)}$changeCheckboxState(d,T){const r=this.treeViews.get(d);if(!r)throw new Error((0,i.localize)(9,null,d));r.setCheckboxState(T)}createExtHostTreeView(d,T,r){const c=new g(d,T,this._proxy,this.commands.converter,this.logService,r);return this.treeViews.set(d,c),c}convertArgument(d){const T=this.treeViews.get(d.$treeViewId);return T&&"$treeItemHandle"in d?T.getExtensionElement(d.$treeItemHandle):T&&"$focusedTreeItem"in d&&d.$focusedTreeItem?T.focusedElement:null}}e.ExtHostTreeViews=a;class g extends A.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(d=>this.getExtensionElement(d)).filter(d=>!(0,R.isUndefinedOrNull)(d))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(d,T,r,c,n,u){if(super(),this.viewId=d,this.proxy=r,this.commands=c,this.logService=n,this.extension=u,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new D.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new D.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new D.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new D.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new D.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new E.CancellationTokenSource,u.contributes&&u.contributes.views)for(const s in u.contributes.views)for(const h of u.contributes.views[s])h.id===d&&(this._title=h.name);this.dataProvider=T.treeDataProvider,this.dndController=T.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let l,f;this._register(D.Event.debounce(this._onDidChangeData.event,(s,h)=>(s||(s={message:!1,elements:[]}),h.element!==!1&&(l||(l=new Promise(v=>f=v),this.refreshPromise=this.refreshPromise.then(()=>l)),Array.isArray(h.element)?s.elements.push(...h.element):s.elements.push(h.element)),h.message&&(s.message=!0),s),200,!0)(({message:s,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=f;return l=null,this.refresh(h).then(()=>v())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(d){const T=d?this.getExtensionElement(d):void 0;if(d&&!T)return this.logService.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(d);return r||(r=await this.fetchChildrenNodes(T)),r?r.map(c=>c.item):void 0}getExtensionElement(d){return this.elements.get(d)}reveal(d,T){T=T||{select:!0,focus:!1};const r=(0,R.isUndefinedOrNull)(T.select)?!0:T.select,c=(0,R.isUndefinedOrNull)(T.focus)?!1:T.focus,n=(0,R.isUndefinedOrNull)(T.expand)?!1:T.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.refreshPromise.then(()=>this.resolveUnknownParentChain(d)).then(u=>this.resolveTreeNode(d,u[u.length-1]).then(l=>this.proxy.$reveal(this.viewId,{item:l.item,parentChain:u.map(f=>f.item)},{select:r,focus:c,expand:n})),u=>this.logService.error(u)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:c,expand:n})}get message(){return this._message}set message(d){this._message=d,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(d){this._title=d,this.proxy.$setTitle(this.viewId,d,this._description)}get description(){return this._description}set description(d){this._description=d,this.proxy.$setTitle(this.viewId,this._title,d)}get badge(){return this._badge}set badge(d){this._badge?.value===d?.value&&this._badge?.tooltip===d?.tooltip||(this._badge=p.ViewBadge.from(d),this.proxy.$setBadge(this.viewId,d))}setExpanded(d,T){const r=this.getExtensionElement(d);r&&(T?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelection(d){(0,b.equals)(this._selectedHandles,d)||(this._selectedHandles=d,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(d){this._focusedHandle=d}setVisible(d){d!==this._visible&&(this._visible=d,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(d){const T=(await Promise.all(d.map(async r=>{const c=this.getExtensionElement(r.treeItemHandle);return c?{extensionItem:c,treeItem:await this.dataProvider.getTreeItem(c),newState:r.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);T.forEach(r=>{r.treeItem.checkboxState=r.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:T.map(r=>[r.extensionItem,r.newState])})}async handleDrag(d,T,r){const c=[];for(const n of d){const u=this.getExtensionElement(n);u&&c.push(u)}if(!(!this.dndController?.handleDrag||c.length===0))return await this.dndController.handleDrag(c,T,r),T}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(d,T,r){const c=T?this.getExtensionElement(T):void 0;if(!(!c&&T||!this.dndController?.handleDrop))return(0,y.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(c,d,r):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(d,T){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(d);if(r){const c=this.nodes.get(r);if(c){const n=await this.dataProvider.resolveTreeItem(c.extensionItem,r,T)??c.extensionItem;return this.validateTreeItem(n),c.item.tooltip=this.getTooltip(n.tooltip),c.item.command=this.getCommand(c.disposableStore,n.command),c.item}}}resolveUnknownParentChain(d){return this.resolveParent(d).then(T=>T?this.resolveUnknownParentChain(T).then(r=>this.resolveTreeNode(T,r[r.length-1]).then(c=>(r.push(c),r))):Promise.resolve([]))}resolveParent(d){const T=this.nodes.get(d);return T?Promise.resolve(T.parent?this.elements.get(T.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(d))}resolveTreeNode(d,T){const r=this.nodes.get(d);return r?Promise.resolve(r):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(c=>this.createHandle(d,c,T,!0)).then(c=>this.getChildren(T?T.item.handle:void 0).then(()=>{const n=this.getExtensionElement(c);if(n){const u=this.nodes.get(n);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(d){if(d){let T;if(typeof d=="string"){const r=this.getExtensionElement(d);T=r?this.nodes.get(r):void 0}else T=d;return T&&T.children||void 0}return this.roots}async fetchChildrenNodes(d){this.clearChildren(d);const T=new E.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=d?this.nodes.get(d):void 0,c=await this.dataProvider.getChildren(d);if(T.token.isCancellationRequested)return;const n=await Promise.all((0,b.coalesce)(c||[]).map(async u=>{const l=await this.dataProvider.getTreeItem(u);return l&&!T.token.isCancellationRequested?this.createAndRegisterTreeNode(u,l,r):null}));return T.token.isCancellationRequested?void 0:(0,b.coalesce)(n)}finally{T.dispose()}}refresh(d){if(d.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new E.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(d);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(d){const T=new Set,r=d.map(n=>this.nodes.get(n));for(const n of r)if(n&&!T.has(n.item.handle)){let u=n;for(;u&&u.parent&&r.findIndex(l=>u&&u.parent&&l&&l.item.handle===u.parent.item.handle)===-1;){const l=this.elements.get(u.parent.item.handle);u=l?this.nodes.get(l):void 0}u&&!u.parent&&T.add(n.item.handle)}const c=[];return T.forEach(n=>{const u=this.elements.get(n);if(u){const l=this.nodes.get(u);l&&(!l.parent||!T.has(l.parent.item.handle))&&c.push(n)}}),c}refreshHandles(d){const T={};return Promise.all(d.map(r=>this.refreshNode(r).then(c=>{c&&(T[r]=c.item)}))).then(()=>Object.keys(T).length?this.proxy.$refresh(this.viewId,T):void 0)}refreshNode(d){const T=this.getExtensionElement(d);if(T){const r=this.nodes.get(T);if(r)return this.clearChildren(T),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(T)).then(c=>{if(c){const n=this.createTreeNode(T,c,r.parent);return this.updateNodeCache(T,n,r,r.parent),r.dispose(),n}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(d,T,r){const c=this.createTreeNode(d,T,r);if(T.id&&this.elements.has(c.item.handle))throw new Error((0,i.localize)(10,null,T.id));return this.addNodeToCache(d,c),this.addNodeToParentCache(c,r),c}getTooltip(d){return k.MarkdownString.isMarkdownString(d)?p.MarkdownString.from(d):d}getCommand(d,T){return T?{...this.commands.toInternal(T,d),originalId:T.command}:void 0}getCheckbox(d){if(!d.checkboxState)return;let T,r;return typeof d.checkboxState=="number"?T=d.checkboxState:(T=d.checkboxState.state,r=d.checkboxState.tooltip),{isChecked:T===k.TreeItemCheckboxState.Checked,tooltip:r}}validateTreeItem(d){if(!k.TreeItem.isTreeItem(d,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(d,T,r){this.validateTreeItem(T);const c=new A.DisposableStore,n=this.createHandle(d,T,r),u=this.getLightIconPath(T);return{item:{handle:n,parentHandle:r?r.item.handle:void 0,label:o(T.label,this.extension),description:T.description,resourceUri:T.resourceUri,tooltip:this.getTooltip(T.tooltip),command:this.getCommand(c,T.command),contextValue:T.contextValue,icon:u,iconDark:this.getDarkIconPath(T)||u,themeIcon:this.getThemeIcon(T),collapsibleState:(0,R.isUndefinedOrNull)(T.collapsibleState)?k.TreeItemCollapsibleState.None:T.collapsibleState,accessibilityInformation:T.accessibilityInformation,checkbox:this.getCheckbox(T)},extensionItem:T,parent:r,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(d){return d.iconPath instanceof k.ThemeIcon?d.iconPath:void 0}createHandle(d,{id:T,label:r,resourceUri:c},n,u){if(T)return`${g.ID_HANDLE_PREFIX}/${T}`;const l=o(r,this.extension),f=n?n.item.handle:g.LABEL_HANDLE_PREFIX;let s=l?l.label:c?(0,S.basename)(c):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const h=this.nodes.has(d)?this.nodes.get(d).item.handle:void 0,v=this.getChildrenNodes(n)||[];let P,L=0;do{if(P=`${f}/${L}:${s}`,u||!this.elements.has(P)||h===P)break;L++}while(L<=v.length);return P}getLightIconPath(d){if(d.iconPath&&!(d.iconPath instanceof k.ThemeIcon))return typeof d.iconPath=="string"||M.URI.isUri(d.iconPath)?this.getIconPath(d.iconPath):this.getIconPath(d.iconPath.light)}getDarkIconPath(d){if(d.iconPath&&!(d.iconPath instanceof k.ThemeIcon)&&d.iconPath.dark)return this.getIconPath(d.iconPath.dark)}getIconPath(d){return M.URI.isUri(d)?d:M.URI.file(d)}addNodeToCache(d,T){this.elements.set(T.item.handle,d),this.nodes.set(d,T)}updateNodeCache(d,T,r,c){this.elements.delete(T.item.handle),this.nodes.delete(d),T.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(d,T);const n=this.getChildrenNodes(c)||[],u=n.filter(l=>l.item.handle===r.item.handle)[0];u&&n.splice(n.indexOf(u),1,T)}addNodeToParentCache(d,T){T?(T.children||(T.children=[]),T.children.push(d)):(this.roots||(this.roots=[]),this.roots.push(d))}clearChildren(d){if(d){const T=this.nodes.get(d);if(T){if(T.children)for(const r of T.children){const c=this.elements.get(r.item.handle);c&&this.clear(c)}T.children=void 0}}else this.clearAll()}clear(d){const T=this.nodes.get(d);if(T){if(T.children)for(const r of T.children){const c=this.elements.get(r.item.handle);c&&this.clear(c)}this.nodes.delete(d),this.elements.delete(T.item.handle),T.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(d=>d.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}g.LABEL_HANDLE_PREFIX="0",g.ID_HANDLE_PREFIX="1"}),define(De[243],Ie([1,0,20,12,4,29,2,123,252,111,121,35,5,68,196,195,37,197,32,199,200,201,184,202,53,33,204,205,208,210,212,100,187,216,217,218,74,56,221,242,8,6,224,57,99,31,168,207,61,98,102,104,105,11,50,14,26,213,182,64,71,193,222,75,55,227,225,226,194,36,219,223,73,54,69,214,101,215,13,87,186,165,206,7,27,170,72,162]),function(ie,e,i,I,S,M,D,A,y,k,R,b,p,E,m,t,o,a,g,w,d,T,r,c,n,u,l,f,s,h,v,P,L,j,W,V,C,F,O,x,B,H,G,ee,ue,re,pe,le,de,Y,me,Se,Oe,Be,Xe,ke,ye,Ce,se,ae,J,_,N,$,q,Z,ce,be,oe,we,ve,Ue,ze,et,Ke,tt,Fe,ht,X,Q,ge,Ne,je,qe,We,Ze,nt,ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function It(at){const rt=at.get(ye.IExtHostInitDataService),Lt=at.get(we.IExtHostFileSystemInfo),At=at.get(q.IExtHostConsumerFileSystem),kt=at.get(u.IExtHostExtensionService),ft=at.get(re.IExtHostWorkspace),yt=at.get(Ke.IExtHostTelemetry),Ut=at.get(g.IExtHostConfiguration),Rt=at.get(Xe.IURITransformerService),Ge=at.get(ke.IExtHostRpcService),Ct=at.get(C.IExtHostStorage),Ot=at.get($.IExtensionStoragePaths),Bt=at.get(Be.ILoggerService),pt=at.get(Be.ILogService),_e=at.get(ae.IExtHostTunnelService),Te=at.get(J.IExtHostApiDeprecationService),fe=at.get(ue.IExtHostWindow),K=at.get(ze.IExtHostSecretState),Pe=at.get(et.IExtHostEditorTabs);Ge.set(p.ExtHostContext.ExtHostFileSystemInfo,Lt),Ge.set(p.ExtHostContext.ExtHostLogLevelServiceShape,Bt),Ge.set(p.ExtHostContext.ExtHostWorkspace,ft),Ge.set(p.ExtHostContext.ExtHostConfiguration,Ut),Ge.set(p.ExtHostContext.ExtHostExtensionService,kt),Ge.set(p.ExtHostContext.ExtHostStorage,Ct),Ge.set(p.ExtHostContext.ExtHostTunnelService,_e),Ge.set(p.ExtHostContext.ExtHostWindow,fe),Ge.set(p.ExtHostContext.ExtHostSecretState,K),Ge.set(p.ExtHostContext.ExtHostTelemetry,yt),Ge.set(p.ExtHostContext.ExtHostEditorTabs,Pe);const Me=Ge.set(p.ExtHostContext.ExtHostDecorations,at.get(Y.IExtHostDecorations)),Je=Ge.set(p.ExtHostContext.ExtHostDocumentsAndEditors,at.get(n.IExtHostDocumentsAndEditors)),xe=Ge.set(p.ExtHostContext.ExtHostCommands,at.get(o.IExtHostCommands)),it=Ge.set(p.ExtHostContext.ExtHostTerminalService,at.get(F.IExtHostTerminalService)),ot=Ge.set(p.ExtHostContext.ExtHostDebugService,at.get(Se.IExtHostDebugService)),Tt=Ge.set(p.ExtHostContext.ExtHostSearch,at.get(Oe.IExtHostSearch)),Et=Ge.set(p.ExtHostContext.ExtHostTask,at.get(me.IExtHostTask)),_t=Ge.set(p.ExtHostContext.ExtHostOutputService,at.get(P.IExtHostOutputService)),vt=Ge.set(p.ExtHostContext.ExtHostLocalization,at.get(nt.IExtHostLocalizationService)),Ft=Ge.set(p.ExtHostContext.ExtHostUrls,new G.ExtHostUrls(Ge)),mt=Ge.set(p.ExtHostContext.ExtHostDocuments,new c.ExtHostDocuments(Ge,Je)),Mt=Ge.set(p.ExtHostContext.ExtHostDocumentContentProviders,new T.ExtHostDocumentContentProvider(Ge,Je,pt)),Kt=Ge.set(p.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(pt,mt,Ge.getProxy(p.MainContext.MainThreadBulkEdits))),bt=Ge.set(p.ExtHostContext.ExtHostNotebook,new Ce.ExtHostNotebookController(Ge,xe,Je,mt)),Ht=Ge.set(p.ExtHostContext.ExtHostNotebookDocuments,new Ne.ExtHostNotebookDocuments(bt)),ni=Ge.set(p.ExtHostContext.ExtHostNotebookEditors,new ge.ExtHostNotebookEditors(pt,bt)),ri=Ge.set(p.ExtHostContext.ExtHostNotebookKernels,new tt.ExtHostNotebookKernels(Ge,rt,bt,xe,pt)),mi=Ge.set(p.ExtHostContext.ExtHostNotebookRenderers,new ht.ExtHostNotebookRenderers(Ge,bt)),St=Ge.set(p.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(Ge,Je)),si=Ge.set(p.ExtHostContext.ExtHostTreeViews,new x.ExtHostTreeViews(Ge.getProxy(p.MainContext.MainThreadTreeViews),xe,pt)),Ai=Ge.set(p.ExtHostContext.ExtHostEditorInsets,new pe.ExtHostEditorInsets(Ge.getProxy(p.MainContext.MainThreadEditorInsets),St,rt.remote)),Jt=Ge.set(p.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(Ge,pt,Lt,Je)),zt=Ge.set(p.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(Ge,mt,xe.converter,Rt)),ut=Ge.set(p.ExtHostContext.ExtHostLanguageFeatures,new s.ExtHostLanguageFeatures(Ge,Rt,mt,xe,Jt,pt,Te,yt)),gi=Ge.set(p.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(Ge,ut)),$t=Ge.set(p.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(Ge,pt,Je)),Gt=Ge.set(p.ExtHostContext.ExtHostQuickOpen,(0,j.createExtHostQuickOpen)(Ge,ft,xe)),oi=Ge.set(p.ExtHostContext.ExtHostSCM,new W.ExtHostSCM(Ge,xe,pt)),pi=Ge.set(p.ExtHostContext.ExtHostComments,(0,a.createExtHostComments)(Ge,xe,mt)),ai=Ge.set(p.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(Ge.getProxy(p.MainContext.MainThreadProgress))),vi=Ge.set(p.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(Ge)),Di=Ge.set(p.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(Ge)),Zt=Ge.set(p.ExtHostContext.ExtHostAuthentication,new _.ExtHostAuthentication(Ge)),Ei=Ge.set(p.ExtHostContext.ExtHostTimeline,new N.ExtHostTimeline(Ge,xe)),ei=Ge.set(p.ExtHostContext.ExtHostWebviews,new ee.ExtHostWebviews(Ge,rt.remote,ft,pt,Te)),ti=Ge.set(p.ExtHostContext.ExtHostWebviewPanels,new be.ExtHostWebviewPanels(Ge,ei,ft)),Ri=Ge.set(p.ExtHostContext.ExtHostCustomEditors,new ce.ExtHostCustomEditors(Ge,mt,Ot,ei,ti)),bi=Ge.set(p.ExtHostContext.ExtHostWebviewViews,new Z.ExtHostWebviewViews(Ge,ei)),Xt=Ge.set(p.ExtHostContext.ExtHostTesting,new ve.ExtHostTesting(Ge,xe,Je)),Oi=Ge.set(p.ExtHostContext.ExtHostUriOpeners,new Ue.ExtHostUriOpeners(Ge));Ge.set(p.ExtHostContext.ExtHostInteractive,new je.ExtHostInteractive(Ge,bt,Je,xe,pt));const Fi=Object.values(p.ExtHostContext);Ge.assertRegistered(Fi);const Li=new oe.ExtHostBulkEdits(Ge,Je),Mi=new t.ExtHostClipboard(Ge),wi=new v.ExtHostMessageService(Ge,pt),Ii=new d.ExtHostDialogs(Ge),li=new V.ExtHostStatusBar(Ge,xe.converter);return m.ExtHostApiCommands.register(xe),function(Le,Vt,Ci){const gt=function(){let ne=!Le.isUnderDevelopment;function he(){ne||(pt.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Re(st){if(Array.isArray(st))st.forEach(Re);else if(typeof st=="string")he();else{const wt=st;typeof wt.scheme>"u"&&he(),typeof wt.exclusive=="boolean"&&(0,We.checkProposedApiEnabled)(Le,"documentFiltersExclusive")}return st}}(),ci={getSession(ne,he,Re){return Zt.getSession(Le,ne,he,Re)},async hasSession(ne,he){return(0,We.checkProposedApiEnabled)(Le,"authSession"),!!await Zt.getSession(Le,ne,he,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(ne,he,Re,st){return Zt.registerAuthenticationProvider(ne,he,Re,st)}},Ni={registerCommand(ne,he,Re){return xe.registerCommand(!0,ne,he,Re,void 0,Le)},registerTextEditorCommand(ne,he,Re){return xe.registerCommand(!0,ne,(...st)=>{const wt=St.getActiveTextEditor();if(!wt){pt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return wt.edit(Dt=>{he.apply(Re,[wt,Dt,...st])}).then(Dt=>{Dt||pt.warn("Edits from command "+ne+" were not applied.")},Dt=>{pt.warn("An error occurred while running command "+ne,Dt)})},void 0,void 0,Le)},registerDiffInformationCommand:(ne,he,Re)=>((0,We.checkProposedApiEnabled)(Le,"diffCommand"),xe.registerCommand(!0,ne,async(...st)=>{const wt=Je.activeEditor(!0);if(!wt){pt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Dt=await St.getDiffInformation(wt.id);he.apply(Re,[Dt,...st])},void 0,void 0,Le)),executeCommand(ne,...he){return xe.executeCommand(ne,...he)},getCommands(ne=!1){return xe.getCommands(ne)}},Ti={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return Mi.value},get shell(){return it.getDefaultShell(!1)},get onDidChangeShell(){return(0,We.checkProposedApiEnabled)(Le,"envShellEvent"),it.onDidChangeShell},get isTelemetryEnabled(){return yt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return yt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Le,"telemetry"),yt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Le,"telemetry"),yt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ke.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return(0,We.checkProposedApiEnabled)(Le,"telemetryLogger"),yt.instantiateLogger(Le,ne)},openExternal(ne,he){return fe.openUri(ne,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===rt.environment.appUriScheme)return Ft.createAppUri(ne);try{return await fe.asExternalUri(ne,{allowTunneling:!!rt.remote.authority})}catch(he){if((0,Q.matchesScheme)(ne,X.Schemas.http)||(0,Q.matchesScheme)(ne,X.Schemas.https))return ne;throw he}},get remoteName(){return(0,de.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,We.checkProposedApiEnabled)(Le,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind},get logLevel(){return(0,We.checkProposedApiEnabled)(Le,"extensionLog"),pt.getLevel()},get onDidChangeLogLevel(){return(0,We.checkProposedApiEnabled)(Le,"extensionLog"),pt.onDidChangeLogLevel}};rt.environment.extensionTestsLocationURI||Object.freeze(Ti);const Ui={createTestController(ne,he,Re){return Xt.createTestController(ne,he,Re)},createTestObserver(){return(0,We.checkProposedApiEnabled)(Le,"testObserver"),Xt.createTestObserver()},runTests(ne){return(0,We.checkProposedApiEnabled)(Le,"testObserver"),Xt.runTests(ne)},get onDidChangeTestResults(){return(0,We.checkProposedApiEnabled)(Le,"testObserver"),Xt.onResultsChanged},get testResults(){return(0,We.checkProposedApiEnabled)(Le,"testObserver"),Xt.results}},ui=rt.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Si={getExtension(ne,he){(0,We.isProposedApiEnabled)(Le,"extensionsAny")||(he=!1);const Re=Vt.mine.getExtensionDescription(ne);if(Re)return new u.Extension(kt,Le.identifier,Re,ui,!1);if(he){const st=Vt.all.getExtensionDescription(ne);if(st)return new u.Extension(kt,Le.identifier,st,ui,!0)}},get all(){const ne=[];for(const he of Vt.mine.getAllExtensionDescriptions())ne.push(new u.Extension(kt,Le.identifier,he,ui,!1));return ne},get allAcrossExtensionHosts(){(0,We.checkProposedApiEnabled)(Le,"extensionsAny");const ne=new We.ExtensionIdentifierSet(Vt.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),he=[];for(const Re of Vt.all.getAllExtensionDescriptions()){const st=!ne.has(Re.identifier);he.push(new u.Extension(kt,Le.identifier,Re,ui,st))}return he},get onDidChange(){return(0,We.isProposedApiEnabled)(Le,"extensionsAny")?S.Event.any(Vt.mine.onDidChange,Vt.all.onDidChange):Vt.mine.onDidChange}},Bi={createDiagnosticCollection(ne){return Jt.createDiagnosticCollection(Le.identifier,ne)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:ne=>Jt.getDiagnostics(ne),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(ne,he){return zt.changeLanguage(ne.uri,he)},match(ne,he){const Re=mt.getDocumentData(he.uri)?.notebook;return(0,R.score)(B.LanguageSelector.from(ne),he.uri,he.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(ne,he,Re){return ut.registerCodeActionProvider(Le,gt(ne),he,Re)},registerDocumentPasteEditProvider(ne,he,Re){return(0,We.checkProposedApiEnabled)(Le,"documentPaste"),ut.registerDocumentPasteEditProvider(Le,gt(ne),he,Re)},registerCodeLensProvider(ne,he){return ut.registerCodeLensProvider(Le,gt(ne),he)},registerDefinitionProvider(ne,he){return ut.registerDefinitionProvider(Le,gt(ne),he)},registerDeclarationProvider(ne,he){return ut.registerDeclarationProvider(Le,gt(ne),he)},registerImplementationProvider(ne,he){return ut.registerImplementationProvider(Le,gt(ne),he)},registerTypeDefinitionProvider(ne,he){return ut.registerTypeDefinitionProvider(Le,gt(ne),he)},registerHoverProvider(ne,he){return ut.registerHoverProvider(Le,gt(ne),he,Le.identifier)},registerEvaluatableExpressionProvider(ne,he){return ut.registerEvaluatableExpressionProvider(Le,gt(ne),he,Le.identifier)},registerInlineValuesProvider(ne,he){return ut.registerInlineValuesProvider(Le,gt(ne),he,Le.identifier)},registerDocumentHighlightProvider(ne,he){return ut.registerDocumentHighlightProvider(Le,gt(ne),he)},registerLinkedEditingRangeProvider(ne,he){return ut.registerLinkedEditingRangeProvider(Le,gt(ne),he)},registerReferenceProvider(ne,he){return ut.registerReferenceProvider(Le,gt(ne),he)},registerRenameProvider(ne,he){return ut.registerRenameProvider(Le,gt(ne),he)},registerDocumentSymbolProvider(ne,he,Re){return ut.registerDocumentSymbolProvider(Le,gt(ne),he,Re)},registerWorkspaceSymbolProvider(ne){return ut.registerWorkspaceSymbolProvider(Le,ne)},registerDocumentFormattingEditProvider(ne,he){return ut.registerDocumentFormattingEditProvider(Le,gt(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return ut.registerDocumentRangeFormattingEditProvider(Le,gt(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Re,...st){return ut.registerOnTypeFormattingEditProvider(Le,gt(ne),he,[Re].concat(st))},registerDocumentSemanticTokensProvider(ne,he,Re){return ut.registerDocumentSemanticTokensProvider(Le,gt(ne),he,Re)},registerDocumentRangeSemanticTokensProvider(ne,he,Re){return ut.registerDocumentRangeSemanticTokensProvider(Le,gt(ne),he,Re)},registerSignatureHelpProvider(ne,he,Re,...st){return typeof Re=="object"?ut.registerSignatureHelpProvider(Le,gt(ne),he,Re):ut.registerSignatureHelpProvider(Le,gt(ne),he,typeof Re>"u"?[]:[Re,...st])},registerCompletionItemProvider(ne,he,...Re){return ut.registerCompletionItemProvider(Le,gt(ne),he,Re)},registerInlineCompletionItemProvider(ne,he){return he.handleDidShowCompletionItem&&(0,We.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Le,gt(ne),he)},registerDocumentLinkProvider(ne,he){return ut.registerDocumentLinkProvider(Le,gt(ne),he)},registerColorProvider(ne,he){return ut.registerColorProvider(Le,gt(ne),he)},registerFoldingRangeProvider(ne,he){return ut.registerFoldingRangeProvider(Le,gt(ne),he)},registerSelectionRangeProvider(ne,he){return ut.registerSelectionRangeProvider(Le,ne,he)},registerCallHierarchyProvider(ne,he){return ut.registerCallHierarchyProvider(Le,ne,he)},registerTypeHierarchyProvider(ne,he){return ut.registerTypeHierarchyProvider(Le,ne,he)},setLanguageConfiguration:(ne,he)=>ut.setLanguageConfiguration(Le,ne,he),getTokenInformationAtPosition(ne,he){return(0,We.checkProposedApiEnabled)(Le,"tokenInformation"),zt.tokenAtPosition(ne,he)},registerInlayHintsProvider(ne,he){return ut.registerInlayHintsProvider(Le,ne,he)},createLanguageStatusItem(ne,he){return zt.createLanguageStatusItem(Le,ne,he)},registerDocumentDropEditProvider(ne,he){return ut.registerDocumentOnDropEditProvider(Le,ne,he)}},jt={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return it.activeTerminal},get terminals(){return it.terminals},async showTextDocument(ne,he,Re){const st=await(D.URI.isUri(ne)?Promise.resolve(ii.openTextDocument(ne)):Promise.resolve(ne));return St.showTextDocument(st,he,Re)},createTextEditorDecorationType(ne){return St.createTextEditorDecorationType(Le,ne)},onDidChangeActiveTextEditor(ne,he,Re){return St.onDidChangeActiveTextEditor(ne,he,Re)},onDidChangeVisibleTextEditors(ne,he,Re){return St.onDidChangeVisibleTextEditors(ne,he,Re)},onDidChangeTextEditorSelection(ne,he,Re){return St.onDidChangeTextEditorSelection(ne,he,Re)},onDidChangeTextEditorOptions(ne,he,Re){return St.onDidChangeTextEditorOptions(ne,he,Re)},onDidChangeTextEditorVisibleRanges(ne,he,Re){return St.onDidChangeTextEditorVisibleRanges(ne,he,Re)},onDidChangeTextEditorViewColumn(ne,he,Re){return St.onDidChangeTextEditorViewColumn(ne,he,Re)},onDidCloseTerminal(ne,he,Re){return it.onDidCloseTerminal(ne,he,Re)},onDidOpenTerminal(ne,he,Re){return it.onDidOpenTerminal(ne,he,Re)},onDidChangeActiveTerminal(ne,he,Re){return it.onDidChangeActiveTerminal(ne,he,Re)},onDidChangeTerminalDimensions(ne,he,Re){return(0,We.checkProposedApiEnabled)(Le,"terminalDimensions"),it.onDidChangeTerminalDimensions(ne,he,Re)},onDidChangeTerminalState(ne,he,Re){return it.onDidChangeTerminalState(ne,he,Re)},onDidWriteTerminalData(ne,he,Re){return(0,We.checkProposedApiEnabled)(Le,"terminalDataWriteEvent"),it.onDidWriteTerminalData(ne,he,Re)},get state(){return fe.state},onDidChangeWindowState(ne,he,Re){return fe.onDidChangeWindowState(ne,he,Re)},showInformationMessage(ne,...he){return wi.showMessage(Le,M.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return wi.showMessage(Le,M.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return wi.showMessage(Le,M.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Re){return Gt.showQuickPick(ne,he,Re)},showWorkspaceFolderPick(ne){return Gt.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return Gt.showInput(ne,he)},showOpenDialog(ne){return Ii.showOpenDialog(ne)},showSaveDialog(ne){return Ii.showSaveDialog(ne)},createStatusBarItem(ne,he,Re){let st,wt,Dt;return typeof ne=="string"?(st=ne,wt=he,Dt=Re):(wt=ne,Dt=he),li.createStatusBarEntry(Le,st,wt,Dt)},setStatusBarMessage(ne,he){return li.setStatusBarMessage(ne,he)},withScmProgress(ne){return Te.report("window.withScmProgress",Le,"Use 'withProgress' instead."),ai.withProgress(Le,{location:H.ProgressLocation.SourceControl},(he,Re)=>ne({report(st){}}))},withProgress(ne,he){return ai.withProgress(Le,ne,he)},createOutputChannel(ne,he){return _t.createOutputChannel(ne,he,Le)},createWebviewPanel(ne,he,Re,st){return ti.createWebviewPanel(Le,ne,he,Re,st)},createWebviewTextEditorInset(ne,he,Re,st){return(0,We.checkProposedApiEnabled)(Le,"editorInsets"),Ai.createWebviewEditorInset(ne,he,Re,st,Le)},createTerminal(ne,he,Re){return typeof ne=="object"?"pty"in ne?it.createExtensionTerminal(ne):it.createTerminalFromOptions(ne):it.createTerminal(ne,he,Re)},registerTerminalLinkProvider(ne){return it.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,he){return it.registerProfileProvider(Le,ne,he)},registerTreeDataProvider(ne,he){return si.registerTreeDataProvider(ne,he,Le)},createTreeView(ne,he){return si.createTreeView(ne,he,Le)},registerWebviewPanelSerializer:(ne,he)=>ti.registerWebviewPanelSerializer(Le,ne,he),registerCustomEditorProvider:(ne,he,Re={})=>Ri.registerCustomEditorProvider(Le,ne,he,Re),registerFileDecorationProvider(ne){return Me.registerFileDecorationProvider(ne,Le.identifier)},registerUriHandler(ne){return Ft.registerUriHandler(Le.identifier,ne)},createQuickPick(){return Gt.createQuickPick(Le)},createInputBox(){return Gt.createInputBox(Le)},get activeColorTheme(){return Di.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Re){return Di.onDidChangeActiveColorTheme(ne,he,Re)},registerWebviewViewProvider(ne,he,Re){return bi.registerWebviewViewProvider(Le,ne,he,Re?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Re){return bt.onDidChangeActiveNotebookEditor(ne,he,Re)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,he,Re){return ni.onDidChangeNotebookEditorSelection(ne,he,Re)},onDidChangeNotebookEditorVisibleRanges(ne,he,Re){return ni.onDidChangeNotebookEditorVisibleRanges(ne,he,Re)},showNotebookDocument(ne,he){return bt.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Re){return(0,We.checkProposedApiEnabled)(Le,"externalUriOpener"),Oi.registerExternalUriOpener(Le.identifier,ne,he,Re)},get tabGroups(){return Pe.tabGroups}},ii={get rootPath(){return Te.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ne){throw I.readonly()},getWorkspaceFolder(ne){return ft.getWorkspaceFolder(ne)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ne){throw I.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ne){throw I.readonly()},updateWorkspaceFolders:(ne,he,...Re)=>ft.updateWorkspaceFolders(Le,ne,he||0,...Re),onDidChangeWorkspaceFolders:function(ne,he,Re){return ft.onDidChangeWorkspace(ne,he,Re)},asRelativePath:(ne,he)=>ft.getRelativePath(ne,he),findFiles:(ne,he,Re,st)=>ft.findFiles(ne,he,Re,Le.identifier,st),findTextInFiles:(ne,he,Re,st)=>{(0,We.checkProposedApiEnabled)(Le,"findTextInFiles");let wt,Dt;return typeof he=="object"?(wt=he,Dt=Re):(wt={},Dt=he,st=Re),ft.findTextInFiles(ne,wt||{},Dt,Le.identifier,st)},saveAll:ne=>ft.saveAll(ne),applyEdit(ne,he){return Li.applyWorkspaceEdit(ne,Le,he)},createFileSystemWatcher:(ne,he,Re,st)=>$t.createFileSystemWatcher(ft,Le,ne,he,Re,st),get textDocuments(){return mt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw I.readonly()},openTextDocument(ne){let he;const Re=ne;if(typeof ne=="string")he=Promise.resolve(D.URI.file(ne));else if(D.URI.isUri(ne))he=Promise.resolve(ne);else if(!Re||typeof Re=="object")he=mt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>mt.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(ne,he,Re)=>mt.onDidAddDocument(ne,he,Re),onDidCloseTextDocument:(ne,he,Re)=>mt.onDidRemoveDocument(ne,he,Re),onDidChangeTextDocument:(ne,he,Re)=>mt.onDidChangeDocument(ne,he,Re),onDidSaveTextDocument:(ne,he,Re)=>mt.onDidSaveDocument(ne,he,Re),onWillSaveTextDocument:(ne,he,Re)=>Kt.getOnWillSaveTextDocumentEvent(Le)(ne,he,Re),get notebookDocuments(){return bt.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,he){let Re;if(D.URI.isUri(ne))Re=ne,await bt.openNotebookDocument(ne);else if(typeof ne=="string")Re=D.URI.revive(await bt.createNotebookDocument({viewType:ne,content:he}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(ne,he,Re){return Ht.onDidSaveNotebookDocument(ne,he,Re)},onDidChangeNotebookDocument(ne,he,Re){return Ht.onDidChangeNotebookDocument(ne,he,Re)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(ne,he,Re,st){return bt.registerNotebookSerializer(Le,ne,he,Re,(0,We.isProposedApiEnabled)(Le,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(ne,he,Re)=>Ci.onDidChangeConfiguration(ne,he,Re),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,Ci.getConfiguration(ne,he,Le)},registerTextDocumentContentProvider(ne,he){return Mt.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(Te.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Le,ne,he)),registerFileSystemProvider(ne,he,Re){return(0,qe.combinedDisposable)(gi.registerFileSystemProvider(Le,ne,he,Re),At.addFileSystemProvider(ne,he))},get fs(){return At.value},registerFileSearchProvider:(ne,he)=>((0,We.checkProposedApiEnabled)(Le,"fileSearchProvider"),Tt.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>((0,We.checkProposedApiEnabled)(Le,"textSearchProvider"),Tt.registerTextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>((0,We.checkProposedApiEnabled)(Le,"resolvers"),kt.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>((0,We.checkProposedApiEnabled)(Le,"resolvers"),vi.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,he,Re)=>$t.onDidCreateFile(ne,he,Re),onDidDeleteFiles:(ne,he,Re)=>$t.onDidDeleteFile(ne,he,Re),onDidRenameFiles:(ne,he,Re)=>$t.onDidRenameFile(ne,he,Re),onWillCreateFiles:(ne,he,Re)=>$t.getOnWillCreateFileEvent(Le)(ne,he,Re),onWillDeleteFiles:(ne,he,Re)=>$t.getOnWillDeleteFileEvent(Le)(ne,he,Re),onWillRenameFiles:(ne,he,Re)=>$t.getOnWillRenameFileEvent(Le)(ne,he,Re),openTunnel:ne=>((0,We.checkProposedApiEnabled)(Le,"tunnels"),_e.openTunnel(Le,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,We.checkProposedApiEnabled)(Le,"tunnels"),_e.getTunnels()},onDidChangeTunnels:(ne,he,Re)=>((0,We.checkProposedApiEnabled)(Le,"tunnels"),_e.onDidChangeTunnels(ne,he,Re)),registerPortAttributesProvider:(ne,he)=>((0,We.checkProposedApiEnabled)(Le,"portsAttributes"),_e.registerPortsAttributesProvider(ne,he)),registerTimelineProvider:(ne,he)=>((0,We.checkProposedApiEnabled)(Le,"timeline"),Ei.registerTimelineProvider(ne,he,Le.identifier,xe.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ne=>((0,We.checkProposedApiEnabled)(Le,"workspaceTrust"),ft.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,he,Re)=>ft.onDidGrantWorkspaceTrust(ne,he,Re),registerEditSessionIdentityProvider:(ne,he)=>((0,We.checkProposedApiEnabled)(Le,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ne,he))},xi={get inputBox(){return Te.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),oi.getLastInputBox(Le)},createSourceControl(ne,he,Re){return oi.createSourceControl(Le,ne,he,Re)}},Nt={createCommentController(ne,he){return pi.createCommentController(Le,ne,he)}},di={get activeDebugSession(){return ot.activeDebugSession},get activeDebugConsole(){return ot.activeDebugConsole},get breakpoints(){return ot.breakpoints},onDidStartDebugSession(ne,he,Re){return ot.onDidStartDebugSession(ne,he,Re)},onDidTerminateDebugSession(ne,he,Re){return ot.onDidTerminateDebugSession(ne,he,Re)},onDidChangeActiveDebugSession(ne,he,Re){return ot.onDidChangeActiveDebugSession(ne,he,Re)},onDidReceiveDebugSessionCustomEvent(ne,he,Re){return ot.onDidReceiveDebugSessionCustomEvent(ne,he,Re)},onDidChangeBreakpoints(ne,he,Re){return ot.onDidChangeBreakpoints(ne,he,Re)},registerDebugConfigurationProvider(ne,he,Re){return ot.registerDebugConfigurationProvider(ne,he,Re||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return ot.registerDebugAdapterDescriptorFactory(Le,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return ot.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Re){return!Re||typeof Re=="object"&&"configuration"in Re?ot.startDebugging(ne,he,{parentSession:Re}):ot.startDebugging(ne,he,Re||{})},stopDebugging(ne){return ot.stopDebugging(ne)},addBreakpoints(ne){return ot.addBreakpoints(ne)},removeBreakpoints(ne){return ot.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return ot.asDebugSourceUri(ne,he)}},zi={registerTaskProvider:(ne,he)=>Et.registerTaskProvider(Le,ne,he),fetchTasks:ne=>Et.fetchTasks(ne),executeTask:ne=>Et.executeTask(Le,ne),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(ne,he,Re)=>Et.onDidStartTask(ne,he,Re),onDidEndTask:(ne,he,Re)=>Et.onDidEndTask(ne,he,Re),onDidStartTaskProcess:(ne,he,Re)=>Et.onDidStartTaskProcess(ne,he,Re),onDidEndTaskProcess:(ne,he,Re)=>Et.onDidEndTaskProcess(ne,he,Re)},$i={createNotebookController(ne,he,Re,st,wt){return ri.createNotebookController(Le,ne,he,Re,st,(0,We.isProposedApiEnabled)(Le,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,he)=>bt.registerNotebookCellStatusBarItemProvider(Le,ne,he),createRendererMessaging(ne){return mi.createRendererMessaging(Le,ne)},onDidChangeNotebookCellExecutionState(ne,he,Re){return(0,We.checkProposedApiEnabled)(Le,"notebookCellExecutionState"),ri.onDidChangeNotebookCellExecutionState(ne,he,Re)}},Wi={t(...ne){if(typeof ne[0]=="string"){const he=ne.shift(),Re=!ne||typeof ne[0]!="object"?ne:ne[0];return vt.getMessage(Le.identifier.value,{message:he,args:Re})}return vt.getMessage(Le.identifier.value,ne[0])},get bundle(){return vt.getBundle(Le.identifier.value)},get uri(){return vt.getBundleUri(Le.identifier.value)}};return{version:rt.version,authentication:ci,commands:Ni,comments:Nt,debug:di,env:Ti,extensions:Si,l10n:Wi,languages:Bi,notebooks:$i,scm:xi,tasks:zi,tests:Ui,window:jt,workspace:ii,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:I.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:p.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestionList,Hover:H.Hover,IndentAction:k.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,SnippetTextEdit:H.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItem2:H.TreeItem,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:E.UIKind,Uri:D.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,DocumentDropEdit:H.DocumentDropEdit,DocumentPasteEdit:H.DocumentPasteEdit,InlayHint:H.InlayHint,InlayHintLabelPart:H.InlayHintLabelPart,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.NotebookEdit,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:Fe.TextSearchCompleteMessageType,DataTransfer:H.DataTransfer,DataTransferItem:H.DataTransferItem,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.TextTabInput,TabInputTextDiff:H.TextDiffTabInput,TabInputTextMerge:H.TextMergeTabInput,TabInputCustom:H.CustomEditorTabInput,TabInputNotebook:H.NotebookEditorTabInput,TabInputNotebookDiff:H.NotebookDiffEditorTabInput,TabInputWebview:H.WebviewEditorTabInput,TabInputTerminal:H.TerminalEditorTabInput,TabInputInteractiveWindow:H.InteractiveWindowInput,TerminalExitReason:H.TerminalExitReason,LogLevel:Be.LogLevel,EditSessionIdentityMatch:ct.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=It}),define(De[244],Ie([1,0,243,33,2,237,6,15,228]),function(ie,e,i,I,S,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends M.RequireInterceptor{_installInterceptor(){}getModule(E,m){for(const t of this._alternatives){const o=t(E);if(o){E=o;break}}if(this._factories.has(E))return this._factories.get(E).load(E,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends I.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=D.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(y.ExtHostConsoleForwarder);const E=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(k,E,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(E){return E.browser}async _loadCommonJSModule(E,m,t){m=m.with({path:b(m.path,".js")});const o=E?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const a=S.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(m)),g=await fetch(a.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),g.status!==200)throw new Error(g.statusText);const w=await g.text(),d=`${m.toString(!0)}#vscode-extension`,T=`${w}
//# sourceURL=${d}`;let r;try{r=new Function("module","exports","require",T)}catch(l){throw console.error(o?`Loading code for extension ${o} failed: ${l.message}`:`Loading code failed: ${l.message}`),console.error(`${m.toString(!0)}${typeof l.line=="number"?` line ${l.line}`:""}${typeof l.column=="number"?` column ${l.column}`:""}`),console.error(l),l}E&&await this._extHostLocalizationService.initializeLocalizedMessages(E);const c={},n={exports:c},u=l=>{const f=this._fakeModules.getModule(l,m);if(f===void 0)throw new Error(`Cannot load module '${l}'`);return f};try{return t.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),r(n,c,u),n.exports!==c?n.exports:c}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),t.codeLoadingStop()}}async $setRemoteEnvironment(E){}async _waitForDebuggerAttachment(E=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+E;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=R;function b(p,E){return p.endsWith(E)?p:p+E}}),define(De[245],Ie([1,0,59,33,75,244]),function(ie,e,i,I,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(I.IExtHostExtensionService,M.ExtHostExtensionService,0),(0,i.registerSingleton)(S.IExtensionStoragePaths,S.ExtensionStoragePaths,0)}),define(De[253],Ie([1,0,24,4,68,238,230,19,76,13,2,240,245]),function(ie,e,i,I,S,M,D,A,y,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const p=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(r){return/^(file|vscode-remote):/i.test(r)}const m=fetch.bind(self);function t(r){self.fetch=async function(c,n){return c instanceof Request||E(String(c))&&(c=(await r(R.URI.parse(String(c)))).toString(!0)),m(c,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(c,n,u,l,f){(async()=>(E(n.toString())&&(n=(await r(R.URI.parse(n.toString()))).toString(!0)),super.open(c,n,u??!0,l,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(c,n){if(/^file:/i.test(c.toString()))c=k.FileAccess.asBrowserUri(R.URI.parse(c.toString())).toString(!0);else if(/^vscode-remote:/i.test(c.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const l=`(${function(v){function P(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const L=fetch.bind(self);self.fetch=function(W,V){return W instanceof Request?L(W,V):L(P(W),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,V,C,F,O){return super.open(W,P(V),C??!0,F,O)}};const j=importScripts.bind(self);self.importScripts=(...W)=>{j(...W.map(P))},j(v)}.toString()}('${c}'))`;n=n||{},n.name=n.name||A.basename(c.toString());const f=new Blob([l],{type:"application/javascript"}),s=URL.createObjectURL(f);return new r(s,n)}}else self.Worker=class extends D.NestedWorker{constructor(r,c){super(p,r,{name:A.basename(r.toString()),...c})}};const o=new class{constructor(){this.pid=void 0}exit(r){b()}async exists(r){return!0}async realpath(r){return r}};class a{constructor(){const c=new MessageChannel,n=new I.Emitter;let u=!1;p(c.port2,[c.port2]),c.port1.onmessage=l=>{const{data:f}=l;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const s=i.VSBuffer.wrap(new Uint8Array(f,0,f.byteLength));if((0,S.isMessageOfType)(s,2)){u=!0,w("received terminate message from renderer");return}n.fire(s)},this.protocol={onMessage:n.event,send:l=>{if(!u){const f=l.buffer.buffer.slice(l.buffer.byteOffset,l.buffer.byteOffset+l.buffer.byteLength);c.port1.postMessage(f,[f])}}}}}function g(r){return new Promise(c=>{const n=r.onMessage(u=>{n.dispose();const l=JSON.parse(u.toString());r.send((0,S.createMessageOfType)(0)),c({protocol:r,initData:l})});r.send((0,S.createMessageOfType)(1))})}let w=r=>b();function d(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function T(){y.mark("code/extHost/willConnectToRenderer");const r=new a;return{onmessage(c){!d(c)||g(r.protocol).then(n=>{y.mark("code/extHost/didWaitForInitData");const u=new M.ExtensionHostMain(n.protocol,n.initData,o,null,c.data);t(l=>u.asBrowserUri(l)),w=l=>u.terminate(l)})}}}e.create=T})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/96db0b339360bc72d27d869d81a557540ad5f800/core/vs/workbench/api/worker/extensionHostWorker.js.map
